require({cache:{
'epi-cms/layers/cms-widgets':function(){
﻿define([
    "dijit/form/NumberSpinner",
    "dijit/form/ValidationTextBox",
    "epi-cms/_ContentContextMixin",
    "epi-cms/ApplicationSettings",
    "epi-cms/CMSModule",
    "epi-cms/compare/views/AllPropertiesCompareView",
    "epi-cms/compare/views/CompareView",
    "epi-cms/compare/views/SideBySideCompareView",
    "epi-cms/component/ContextHistory",
    "epi-cms/component/GlobalToolbar",
    "epi-cms/component/MainNavigationComponent",
    "epi-cms/component/Media",
    "epi-cms/component/PageNavigationTree",
    "epi-cms/component/RecentlyChanged",
    "epi-cms/component/SharedBlocks",
    "epi-cms/component/SiteTree",
    "epi-cms/component/Tasks",
    "epi-cms/component/Trash",
    "epi-cms/component/VersionsComponent",
    "epi-cms/content-approval/ApprovalComponent",
    "epi-cms/contentediting/_Renderer",
    "epi-cms/contentediting/ContentDetails",
    "epi-cms/contentediting/ContentPreview",
    "epi-cms/contentediting/CreateContent",
    "epi-cms/contentediting/CreateLanguageBranch",
    "epi-cms/contentediting/DateTimeNowEditor",
    "epi-cms/contentediting/DialogEditorWrapper",
    "epi-cms/contentediting/EditActionPanel",
    "epi-cms/contentediting/EditingBase",
    "epi-cms/contentediting/editors/CheckBoxListEditor",
    "epi-cms/contentediting/editors/CollectionEditor",
    "epi-cms/contentediting/editors/ContentAreaEditor",
    "epi-cms/contentediting/editors/ContentReferenceEditor",
    "epi-cms/contentediting/editors/ItemCollectionEditor",
    "epi-cms/contentediting/editors/PreviewableDateTimeEditor",
    "epi-cms/contentediting/editors/PreviewableTextEditor",
    "epi-cms/contentediting/editors/RangeNumberEditor",
    "epi-cms/contentediting/editors/SelectionEditor",
    "epi-cms/contentediting/editors/ShortcutEditor",
    "epi-cms/contentediting/EditToolbar",
    "epi-cms/contentediting/FloatingEditorWrapper",
    "epi-cms/contentediting/FlyoutEditorWrapper",
    "epi-cms/contentediting/FormEditing",
    "epi-cms/contentediting/InlineEditorWrapper",
    "epi-cms/contentediting/NotificationBar",
    "epi-cms/contentediting/OnPageEditing",
    "epi-cms/contentediting/PageDataController",
    "epi-cms/contentediting/PropertyRenderer",
    "epi-cms/contentediting/PublishMenu",
    "epi-cms/contentediting/SettingsPanel",
    "epi-cms/contentediting/ValidationTextboxWithWarning",
    "epi-cms/contentediting/viewmodel/ContentDetailsViewModel",
    "epi-cms/conversion/PropertyContentAreaConverter",
    "epi-cms/conversion/PropertyDateConverter",
    "epi-cms/core/ContentReference",
    "epi-cms/layout/CreateContentGroupContainer",
    "epi-cms/layout/EditLayoutContainer",
    "epi-cms/project/Overview",
    "epi-cms/project/ProjectChangesComponent",
    "epi-cms/project/ProjectComponent",
    "epi-cms/project/ProjectModeToolbar",
    "epi-cms/version/LanguageSelector",
    "epi-cms/widget/_GridWidgetBase",
    "epi-cms/widget/CategorySelector",
    "epi-cms/widget/ContentSelector",
    "epi-cms/widget/HyperLinkSelector",
    "epi-cms/widget/LocalFolderUploader",
    "epi-cms/widget/MediaSelector",
    "epi-cms/widget/NotificationStatusBar",
    "epi-cms/widget/NotificationStatusZone",
    "epi-cms/widget/overlay/Block",
    "epi-cms/widget/overlay/ContentArea",
    "epi-cms/widget/overlay/ItemCollection",
    "epi-cms/widget/overlay/overlayFactory",
    "epi-cms/widget/ReadOnlyDateTimeEditor",
    "epi-cms/widget/SelectableMediaComponent",
    "epi-cms/widget/ThumbnailSelector",
    "epi-cms/widget/TooltipDialog",
    "epi-cms/widget/UrlContentSelector",
    "epi-cms/widget/UrlSelector",
    "epi-cms/widget/UrlThumbnailSelector"
], 1);

},
'dijit/form/NumberSpinner':function(){
define("dijit/form/NumberSpinner", [
	"dojo/_base/declare", // declare
	"dojo/_base/event", // event.stop
	"dojo/keys", // keys.END keys.HOME
	"./_Spinner",
	"./NumberTextBox"
], function(declare, event, keys, _Spinner, NumberTextBox){

// module:
//		dijit/form/NumberSpinner


return declare("dijit.form.NumberSpinner", [_Spinner, NumberTextBox.Mixin], {
	// summary:
	//		Extends NumberTextBox to add up/down arrows and pageup/pagedown for incremental change to the value
	//
	// description:
	//		A `dijit/form/NumberTextBox` extension to provide keyboard accessible value selection
	//		as well as icons for spinning direction. When using the keyboard, the typematic rules
	//		apply, meaning holding the key will gradually increase or decrease the value and
	//		accelerate.
	//
	// example:
	//	| new NumberSpinner({ constraints:{ max:300, min:100 }}, "someInput");

	baseClass: "dijitTextBox dijitSpinner dijitNumberTextBox",

	adjust: function(/*Object*/ val, /*Number*/ delta){
		// summary:
		//		Change Number val by the given amount
		// tags:
		//		protected

		var tc = this.constraints,
			v = isNaN(val),
			gotMax = !isNaN(tc.max),
			gotMin = !isNaN(tc.min)
		;
		if(v && delta != 0){ // blank or invalid value and they want to spin, so create defaults
			val = (delta > 0) ?
				gotMin ? tc.min : gotMax ? tc.max : 0 :
				gotMax ? this.constraints.max : gotMin ? tc.min : 0
			;
		}
		var newval = val + delta;
		if(v || isNaN(newval)){ return val; }
		if(gotMax && (newval > tc.max)){
			newval = tc.max;
		}
		if(gotMin && (newval < tc.min)){
			newval = tc.min;
		}
		return newval;
	},

	_onKeyPress: function(e){
		if(this.disabled || this.readOnly){ return; }
		if((e.charOrCode == keys.HOME || e.charOrCode == keys.END) && !(e.ctrlKey || e.altKey || e.metaKey)
		&& typeof this.get('value') != 'undefined' /* gibberish, so HOME and END are default editing keys*/){
			var value = this.constraints[(e.charOrCode == keys.HOME ? "min" : "max")];
			if(typeof value == "number"){
				this._setValueAttr(value, false);
			}
			// eat home or end key whether we change the value or not
			event.stop(e);
		}
	}
});

});

},
'dijit/form/NumberTextBox':function(){
define("dijit/form/NumberTextBox", [
	"dojo/_base/declare", // declare
	"dojo/_base/lang", // lang.hitch lang.mixin
	"dojo/number", // number._realNumberRegexp number.format number.parse number.regexp
	"./RangeBoundTextBox"
], function(declare, lang, number, RangeBoundTextBox){

	// module:
	//		dijit/form/NumberTextBox


	var NumberTextBoxMixin = declare("dijit.form.NumberTextBoxMixin", null, {
		// summary:
		//		A mixin for all number textboxes
		// tags:
		//		protected

		// Override ValidationTextBox.pattern.... we use a reg-ex generating function rather
		// than a straight regexp to deal with locale (plus formatting options too?)
		pattern: number.regexp,

		/*=====
		// constraints: NumberTextBox.__Constraints
		//		Despite the name, this parameter specifies both constraints on the input
		//		(including minimum/maximum allowed values) as well as
		//		formatting options like places (the number of digits to display after
		//		the decimal point).
		constraints: {},
		======*/

		// value: Number
		//		The value of this NumberTextBox as a Javascript Number (i.e., not a String).
		//		If the displayed value is blank, the value is NaN, and if the user types in
		//		an gibberish value (like "hello world"), the value is undefined
		//		(i.e. get('value') returns undefined).
		//
		//		Symmetrically, set('value', NaN) will clear the displayed value,
		//		whereas set('value', undefined) will have no effect.
		value: NaN,

		// editOptions: [protected] Object
		//		Properties to mix into constraints when the value is being edited.
		//		This is here because we edit the number in the format "12345", which is
		//		different than the display value (ex: "12,345")
		editOptions: { pattern: '#.######' },

		/*=====
		_formatter: function(value, options){
			// summary:
			//		_formatter() is called by format().  It's the base routine for formatting a number,
			//		as a string, for example converting 12345 into "12,345".
			// value: Number
			//		The number to be converted into a string.
			// options: number.__FormatOptions?
			//		Formatting options
			// tags:
			//		protected extension

			return "12345";		// String
		},
		 =====*/
		_formatter: number.format,

		postMixInProperties: function(){
			this.inherited(arguments);
			this._set("type", "text"); // in case type="number" was specified which messes up parse/format
		},

		_setConstraintsAttr: function(/*Object*/ constraints){
			var places = typeof constraints.places == "number"? constraints.places : 0;
			if(places){ places++; } // decimal rounding errors take away another digit of precision
			if(typeof constraints.max != "number"){
				constraints.max = 9 * Math.pow(10, 15-places);
			}
			if(typeof constraints.min != "number"){
				constraints.min = -9 * Math.pow(10, 15-places);
			}
			this.inherited(arguments, [ constraints ]);
			if(this.focusNode && this.focusNode.value && !isNaN(this.value)){
				this.set('value', this.value);
			}
		},

		_onFocus: function(){
			if(this.disabled || this.readOnly){ return; }
			var val = this.get('value');
			if(typeof val == "number" && !isNaN(val)){
				var formattedValue = this.format(val, this.constraints);
				if(formattedValue !== undefined){
					this.textbox.value = formattedValue;
				}
			}
			this.inherited(arguments);
		},

		format: function(/*Number*/ value, /*number.__FormatOptions*/ constraints){
			// summary:
			//		Formats the value as a Number, according to constraints.
			// tags:
			//		protected

			var formattedValue = String(value);
			if(typeof value != "number"){ return formattedValue; }
			if(isNaN(value)){ return ""; }
			// check for exponential notation that dojo/number.format() chokes on
			if(!("rangeCheck" in this && this.rangeCheck(value, constraints)) && constraints.exponent !== false && /\de[-+]?\d/i.test(formattedValue)){
				return formattedValue;
			}
			if(this.editOptions && this.focused){
				constraints = lang.mixin({}, constraints, this.editOptions);
			}
			return this._formatter(value, constraints);
		},

		/*=====
		_parser: function(value, constraints){
			// summary:
			//		Parses the string value as a Number, according to constraints.
			// value: String
			//		String representing a number
			// constraints: number.__ParseOptions
			//		Formatting options
			// tags:
			//		protected

			return 123.45;		// Number
		},
		=====*/
		_parser: number.parse,

		parse: function(/*String*/ value, /*number.__FormatOptions*/ constraints){
			// summary:
			//		Replaceable function to convert a formatted string to a number value
			// tags:
			//		protected extension

			var v = this._parser(value, lang.mixin({}, constraints, (this.editOptions && this.focused) ? this.editOptions : {}));
			if(this.editOptions && this.focused && isNaN(v)){
				v = this._parser(value, constraints); // parse w/o editOptions: not technically needed but is nice for the user
			}
			return v;
		},

		_getDisplayedValueAttr: function(){
			var v = this.inherited(arguments);
			return isNaN(v) ? this.textbox.value : v;
		},

		filter: function(/*Number*/ value){
			// summary:
			//		This is called with both the display value (string), and the actual value (a number).
			//		When called with the actual value it does corrections so that '' etc. are represented as NaN.
			//		Otherwise it dispatches to the superclass's filter() method.
			//
			//		See `dijit/form/TextBox.filter()` for more details.
			return (value == null /* or undefined */ || value === '') ? NaN : this.inherited(arguments); // set('value', null||''||undefined) should fire onChange(NaN)
		},

		serialize: function(/*Number*/ value, /*Object?*/ options){
			// summary:
			//		Convert value (a Number) into a canonical string (ie, how the number literal is written in javascript/java/C/etc.)
			// tags:
			//		protected
			return (typeof value != "number" || isNaN(value)) ? '' : this.inherited(arguments);
		},

		_setBlurValue: function(){
			var val = lang.hitch(lang.mixin({}, this, { focused: true }), "get")('value'); // parse with editOptions
			this._setValueAttr(val, true);
		},

		_setValueAttr: function(/*Number*/ value, /*Boolean?*/ priorityChange, /*String?*/ formattedValue){
			// summary:
			//		Hook so set('value', ...) works.
			if(value !== undefined && formattedValue === undefined){
				formattedValue = String(value);
				if(typeof value == "number"){
					if(isNaN(value)){ formattedValue = '' }
					// check for exponential notation that number.format chokes on
					else if(("rangeCheck" in this && this.rangeCheck(value, this.constraints)) || this.constraints.exponent === false || !/\de[-+]?\d/i.test(formattedValue)){
						formattedValue = undefined; // lets format compute a real string value
					}
				}else if(!value){ // 0 processed in if branch above, ''|null|undefined flows through here
					formattedValue = '';
					value = NaN;
				}else{ // non-numeric values
					value = undefined;
				}
			}
			this.inherited(arguments, [value, priorityChange, formattedValue]);
		},

		_getValueAttr: function(){
			// summary:
			//		Hook so get('value') works.
			//		Returns Number, NaN for '', or undefined for unparseable text
			var v = this.inherited(arguments); // returns Number for all values accepted by parse() or NaN for all other displayed values

			// If the displayed value of the textbox is gibberish (ex: "hello world"), this.inherited() above
			// returns NaN; this if() branch converts the return value to undefined.
			// Returning undefined prevents user text from being overwritten when doing _setValueAttr(_getValueAttr()).
			// A blank displayed value is still returned as NaN.
			if(isNaN(v) && this.textbox.value !== ''){
				if(this.constraints.exponent !== false && /\de[-+]?\d/i.test(this.textbox.value) && (new RegExp("^"+number._realNumberRegexp(lang.mixin({}, this.constraints))+"$").test(this.textbox.value))){	// check for exponential notation that parse() rejected (erroneously?)
					var n = Number(this.textbox.value);
					return isNaN(n) ? undefined : n; // return exponential Number or undefined for random text (may not be possible to do with the above RegExp check)
				}else{
					return undefined; // gibberish
				}
			}else{
				return v; // Number or NaN for ''
			}
		},

		isValid: function(/*Boolean*/ isFocused){
			// Overrides dijit/form/RangeBoundTextBox.isValid() to check that the editing-mode value is valid since
			// it may not be formatted according to the regExp validation rules
			if(!this.focused || this._isEmpty(this.textbox.value)){
				return this.inherited(arguments);
			}else{
				var v = this.get('value');
				if(!isNaN(v) && this.rangeCheck(v, this.constraints)){
					if(this.constraints.exponent !== false && /\de[-+]?\d/i.test(this.textbox.value)){ // exponential, parse doesn't like it
						return true; // valid exponential number in range
					}else{
						return this.inherited(arguments);
					}
				}else{
					return false;
				}
			}
		}
	});

	var NumberTextBox = declare("dijit.form.NumberTextBox", [RangeBoundTextBox, NumberTextBoxMixin], {
		// summary:
		//		A TextBox for entering numbers, with formatting and range checking
		// description:
		//		NumberTextBox is a textbox for entering and displaying numbers, supporting
		//		the following main features:
		//
		//		1. Enforce minimum/maximum allowed values (as well as enforcing that the user types
		//			a number rather than a random string)
		//		2. NLS support (altering roles of comma and dot as "thousands-separator" and "decimal-point"
		//			depending on locale).
		//		3. Separate modes for editing the value and displaying it, specifically that
		//			the thousands separator character (typically comma) disappears when editing
		//			but reappears after the field is blurred.
		//		4. Formatting and constraints regarding the number of places (digits after the decimal point)
		//			allowed on input, and number of places displayed when blurred (see `constraints` parameter).

		baseClass: "dijitTextBox dijitNumberTextBox"
	});

	NumberTextBox.Mixin = NumberTextBoxMixin;	// for monkey patching

	/*=====
	 NumberTextBox.__Constraints = declare([RangeBoundTextBox.__Constraints, number.__FormatOptions, number.__ParseOptions], {
		 // summary:
		 //		Specifies both the rules on valid/invalid values (minimum, maximum,
		 //		number of required decimal places), and also formatting options for
		 //		displaying the value when the field is not focused.
		 // example:
		 //		Minimum/maximum:
		 //		To specify a field between 0 and 120:
		 //	|		{min:0,max:120}
		 //		To specify a field that must be an integer:
		 //	|		{fractional:false}
		 //		To specify a field where 0 to 3 decimal places are allowed on input:
		 //	|		{places:'0,3'}
	 });
	 =====*/

	return NumberTextBox;
});

},
'epi-cms/_ContentContextMixin':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",

    "dojo/Deferred",
    "dojo/when",

    // epi
    "epi/dependency",
    "epi/UriParser",

    "epi/shell/_ContextMixin",

    "epi-cms/core/ContentReference"
],

function (
// dojo
    declare,
    lang,
    aspect,

    Deferred,
    when,

    // epi
    dependency,
    UriParser,

    _ContextMixin,

    ContentReference
) {

    return declare([_ContextMixin], {
        // summary:
        //      Helps keeping up to date with the current context. Mixing this into a class gives access to current context and other useful features.
        // tags:
        //      public abstract

        ignoreVersionWhenComparingLinks: false,

        contentDataStore: null,

        _currentContentContext: null,

        postscript: function () {
            this.inherited(arguments);

            this.own(aspect.after(this.getContentDataStore(), "notify", function (item, id) {
                this.itemChanged(id, item);
            }.bind(this), true));
        },

        getContentDataStore: function () {
            // summary:
            //      Gets the content data store from store registry if it's not already cached

            if (!this.contentDataStore) {
                var registry = dependency.resolve("epi.storeregistry");
                this.contentDataStore = registry.get("epi.cms.contentdata");
            }
            return this.contentDataStore;
        },

        getCurrentContent: function () {
            // summary:
            //      Returns either the current content or a deferred which will resolve a content data as soon as it becomes available.
            // example:
            //      dojo.when(this.getCurrentContent(), function(content) {
            //          console.log("now we know we've got ", content);
            //      });
            // tags:
            //      protected

            var deferred = new Deferred();

            when(this.getCurrentContext(), lang.hitch(this, function (ctx) {
                if (!this._isContentContext(ctx)) {
                    deferred.reject({ message: "Not a content data", context: ctx });
                    return;
                }

                when(this.getContentDataStore().get(ctx.id), function (contentData) {
                    deferred.resolve(contentData);
                });
            }));

            return deferred.promise;
        },

        contextChanged: function (ctx, callerData) {
            this.inherited(arguments);

            if (!this._isContentContext(ctx)) {
                this._currentContentContext = null;
                return;
            }

            var forceChange = (callerData && callerData.forceContextChange ? callerData.forceContextChange : false);

            if (!forceChange && this._isSameAsCurrentContentContext(ctx)) {
                // already loaded
                return;
            }

            this._currentContentContext = ctx;

            this.contentContextChanged(ctx, callerData);
        },

        contextUpdated: function (ctx, callerData) {

            if (!this._isContentContext(ctx)) {
                this._currentContentContext = null;
                return;
            }

            this._currentContentContext = ctx;

            this.contentContextUpdated(ctx, callerData);
        },

        contentContextChanged: function (ctx, callerData) {
            // summary:
            //      Called when the currently loaded content changes. I.e. a new content data object is loaded into the preview area.
            // tags:
            //      protected
        },

        contentContextUpdated: function (ctx, callerData) {
            // summary:
            //      Called when the currently loaded content updated.
            // tags:
            //      protected
        },

        itemChanged: function (id, item) {
            // summary:
            //      Notification event when an item has been patched or reloaded.
            // object: id
            //      The id of the updated item.
            // object: item
            //      The updated item.
            // tags:
            //      public deprecated
        },

        _isContentContext: function (ctx) {
            // summary:
            //      Verifies that the context has content data
            // ctx: context
            //      The context to check
            // tags:
            //      protected

            return ctx && ctx.type === "epi.cms.contentdata";
        },

        _isSameAsCurrentContentContext: function (ctx) {
            // summary:
            //      Checks if the content context has Id and PreferredLanguage the same as the already loaded current content context.
            // ctx: Object
            //      The content context to compare with current content context.
            // tags:
            //      protected

            if (this._currentContentContext && ctx) {
                return this._currentContentContext.id === ctx.id
                        && (this._currentContentContext.languageContext && ctx.languageContext
                            && this._currentContentContext.languageContext.preferredLanguage === ctx.languageContext.preferredLanguage);
            } else {
                return false;
            }
        },

        _isSameAsCurrentContext: function (uri) {
            // summary:
            //      Checks if the URI is the same as the already loaded context.
            // object: uri
            //      The uri of the context to compare with current.
            // tags:
            //      protected

            if (this._currentContext) {
                return this._compareUris(uri, this._currentContext.uri);
            } else {
                return false;
            }
        },

        _compareUris: function (obj1, obj2) {
            // summary:
            //      Checks if the URI:s are equal
            // object: obj1
            //      First object to compare.
            // object: obj2
            //      Second object to compare.
            // tags:
            //      protected

            var uri1 = new UriParser(obj1),
                uri2 = new UriParser(obj2);

            if (this.ignoreVersionWhenComparingLinks &&
                uri1.getType() === "epi.cms.contentdata" &&
                uri2.getType() === "epi.cms.contentdata" &&
                ContentReference.compareIgnoreVersion(uri1.getId(), uri2.getId())) {
                return true;
            } else if (obj1 === obj2) {
                return true;
            }

            return false;
        }

    });

});

},
'epi-cms/core/ContentReference':function(){
define(["dojo/_base/declare", "epi/epi"], function (declare, epi) {

    var ContentReference = declare(null, {
        // summary:
        //      An object uniquely identifying a CMS content item.
        //
        // example:
        //      Create a content reference from an object with properties
        //      |   var contentReference = new epi.cms.core.ContentReference({ id:3, workId:4, providerName: ""});
        //
        // example:
        //      Create a content reference from its serialized string representation
        //      |   var contentReference = new epi.cms.core.ContentReference("3__providerName");
        //
        // tags:
        //      public

        // id: [public] Integer
        //      The id number of an item
        id: 0,

        // workId: [public] Integer
        //      The version id of an item.
        workId: 0,

        // providerName: [public] String
        //      A string that identifies a if an external provider serves the item.
        providerName: null,

        // isSelfReference: [public] Boolean
        //      Denotes if the reference is a self reference
        isSelfReference: false,

        constructor: function (value) {
            // summary:
            //      Creates a new content reference instance from the provided value
            //
            // value: Object|String|Number|epi.cms.core.ContentReference
            //      Can be either an object in the format

            if (value) {
                this._parse(value);
            }
        },

        _parse: function (value) {
            // summary:
            //      Parses an object or a string describing a content reference int this object
            //
            // value: Object|String|Number
            //      The value to parse as a content reference
            //
            // tags:
            //      public

            if (typeof value === "object") {
                // Assume it's an object serialized by the server or an instance of this class
                this.id = parseInt(value.ID || value.id || value.iD || value.Id || 0, 10);
                this.workId = parseInt(value.WorkID || value.workId || 0, 10);
                this.providerName = value.ProviderName || value.providerName || null;
            } else if (typeof value === "string") {
                if (value === "-") {
                    this.isSelfReference = true;
                    this.id = 0;
                    this.workId = -1;
                } else {
                    this.isSelfReference = false;
                    var v = String();
                    v.split("_");
                    var segments = value.split("_");
                    this.id = parseInt(segments[0], 10);
                    this.workId = parseInt(segments[1], 10) || 0;
                    this.providerName = segments[2] || "";
                }
            } else if (typeof value === "number") {
                this.id = value;
                this.workId = 0;
                this.providerName = "";
            }

            // validate data
            if (isNaN(this.id)) {
                throw new Error("The id parameter of a content reference must be an integer");
            }

            if (isNaN(this.workId) && !this.isSelfReference) {
                throw new Error("The workId of a content reference must be an integer");
            }
        },

        toString: function () {
            // summary:
            //      Returns a serialized version of this content reference in the format id[_workId][_providerName]
            //
            // tags:
            //      public

            if (this.isSelfReference) {
                return "-";
            }

            var contentReference = String(this.id);
            if (this.workId !== 0) {
                contentReference += "_" + this.workId;
            }
            if (this.providerName) {
                contentReference += (this.workId === 0 ? "__" : "_") + this.providerName;
            }
            return contentReference;
        },

        createVersionUnspecificReference: function () {
            // summary:
            //      Creates a content link that ignores the work id
            //
            // tags:
            //      public

            return new ContentReference({ id: this.id, providerName: this.providerName });
        }
    });

    ContentReference.isContentReference = function (value) {
        // summary:
        //      Tests whether the given value can be parsed as a content reference.
        //
        // value: Object|String|Number|epi.cms.core.ContentReference
        //      The value to convert to a content reference
        //
        // tags:
        //      public

        try {
            return !!(new ContentReference(value));
        } catch (error) {
            return false;
        }
    };

    ContentReference.toContentReference = function (obj) {
        // summary:
        //      Returns the parameter obj if it's already a ContentReference, or
        //      creates a new ContentReference if it's a string or number.
        //      Otherwise returns an empty ContentReference.
        //
        // value: Object|String|Number|epi.cms.core.ContentReference
        //      The value to create a new content reference
        //
        // tags:
        //      public

        if (obj instanceof ContentReference) {
            return obj;
        } else if (typeof obj === "string" || typeof obj === "number") {
            return new ContentReference(obj);
        }

        return ContentReference.empty;
    };

    ContentReference.tryConvert = function (value, fallback) {
        // summary:
        //      Tries to create a new ContentReference, if it fails
        //      returns the fallback if given otherwise an empty ContentReference.
        //
        // value: Object|String|Number|epi.cms.core.ContentReference
        //      The value to convert to a content reference
        //
        // fallback: Object [optional]
        //      The value to return if the convertion fails, otherwise an empty ContentReference is returned.
        //
        // tags:
        //      public

        if (value instanceof ContentReference) {
            return value;
        }

        try {
            return new ContentReference(value);
        } catch (error) {
            // Allow falsy values as fallback, unless it's undefined.
            return fallback !== undefined ? fallback : ContentReference.empty;
        }
    };

    ContentReference.compareIgnoreVersion = function (object1, object2) {
        // summary:
        //      Compares two ContentReference's while ignoring their versions.
        //
        // object1: epi.cms.core.ContentReference
        //      Value to compare against object2
        //
        // object2: epi.cms.core.ContentReference
        //      Value to compare against object1
        //
        // tags:
        //      public

        var c1 = ContentReference.toContentReference(object1);
        var c2 = ContentReference.toContentReference(object2);

        var pub1 = c1.createVersionUnspecificReference();
        var pub2 = c2.createVersionUnspecificReference();

        return epi.areEqual(pub1, pub2);
    };

    // Deprecate emptyContentReference, and use empty instead.
    ContentReference.empty = new ContentReference({ id: -1, workId: -1 });
    ContentReference.emptyContentReference = ContentReference.empty;

    return ContentReference;
});

},
'epi-cms/CMSModule':function(){
define("epi-cms/CMSModule", [
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    // epi
    "epi",
    "epi/_Module",
    "epi/dependency",
    "epi/shell/request/mutators",
    "epi/routes",

    "epi/shell/conversion/ObjectConverterRegistry",
    "epi/shell/store/JsonRest",
    "epi/shell/store/Throttle",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/ViewSettings",
    "epi/shell/StickyViewSelector",

    "epi-cms/ApplicationSettings",
    "epi-cms/BackContextHistory",
    "epi-cms/ContextSynchronizer",
    "epi-cms/ContentRepositoryDescriptorService",

    "epi-cms/conversion/ContentFragmentConverter",
    "epi-cms/conversion/ContentLightUriConverter",
    "epi-cms/conversion/ContentReferenceConverter",
    "epi-cms/conversion/PropertyDateConverter",

    "epi-cms/core/ContentReference",

    "epi-cms/store/configurableQueryEngine",
    "epi-cms/store/PageVersionQueryEngine",
    "epi-cms/store/currentContentContext",
    "epi-cms/project/ProjectActivitiesQueryEngine",

    "epi-cms/component/command/GlobalToolbarCommandProvider",
    "epi-cms/compare/command/CompareCommandProvider",
    "epi-cms/command/ViewSettingsCommandProvider",
    "epi-cms/content-activity/command/ContentActivityCommandProvider",
    "epi-cms/contentediting/ContentHierarchyService",
    "epi-cms/contentediting/EditorFactory",
    "epi-cms/contentediting/InUseNotificationManager",
    "epi-cms/contentediting/ViewSettingsManager",

    "epi-cms/content-approval/ApprovalService",

    "epi-cms/project/ProjectService",
    "epi-cms/activity/ActivityService",
    "epi-cms/project/request/projectMode",
    "epi-cms/request/contentLanguage",
    "epi-cms/project/ProjectModeRequestInterceptor",
    "epi-cms/project/ProjectItemQueryEngine",

    "epi-cms/contentediting/command/Editing",

    "epi-cms/contentediting/commandproviders/ContentDetails",
    "epi-cms/contentediting/commandproviders/PublishMenu",
    "epi-cms/contentediting/commandproviders/PublishMenuGlobal",

    "epi-cms/contentediting/viewsettings/ChannelViewSetting",
    "epi-cms/contentediting/viewsettings/ResolutionViewSetting",
    "epi-cms/contentediting/viewsettings/ViewLanguageViewSetting",
    "epi-cms/contentediting/viewsettings/VisitorGroupViewSetting",
    "epi-cms/project/ProjectViewSetting",
    "epi-cms/widget/ContentTypeService",
    "epi-cms/telemetry/telemetryInitializer",

    "epi-cms/Profile"
], function (
    // dojo
    array,
    declare,
    lang,
    when,
    // epi
    epi,
    _Module,
    dependency,
    mutators,
    routes,

    ObjectConverterRegistry,
    JsonRest,
    Throttle,
    TypeDescriptorManager,
    ViewSettings,
    StickyViewSelector,

    ApplicationSettings,
    BackContextHistory,
    ContextSynchronizer,
    ContentRepositoryDescriptorService,

    ContentFragmentConverter,
    ContentLightConverter,
    ContentReferenceConverter,
    PropertyDateConverter,

    ContentReference,

    configurableQueryEngine,
    PageVersionQueryEngine,
    currentContentContext,
    ProjectActivitiesQueryEngine,

    GlobalToolbarCommandProvider,
    CompareCommandProvider,
    ViewSettingsCommandProvider,
    ContentActivityCommandProvider,

    ContentHierarchyService,
    EditorFactory,
    InUseNotificationManager,
    ViewSettingsManager,

    ApprovalService,

    ProjectService,
    ActivityService,
    projectMode,
    contentLanguage,
    ProjectModeRequestInterceptor,
    projectItemQueryEngine,

    Editing,

    ContentDetailsCommandProvider,
    PublishMenuCommandProvider,
    PublishMenuGlobalCommandProvider,

    ChannelViewSetting,
    ResolutionViewSetting,
    ViewLanguageViewSetting,
    VisitorGroupViewSetting,
    ProjectViewSetting,
    ContentTypeService,
    telemetryInitializer,

    Profile
) {

    return declare([_Module], {
        // tags:
        //      internal

        _settings: null,

        // _hashWrapper: Object
        //    HashWrapper instance, which will be used to manipulate hash.
        _hashWrapper: null,

        _firstTimeHashUpdated: false,

        constructor: function (settings) {
            this._settings = settings;
        },

        initialize: function () {
            // summary:
            //		Initialize module
            //
            // description:

            this.inherited(arguments);

            mutators.add(projectMode);
            mutators.add(currentContentContext);
            mutators.add(contentLanguage);

            declare.safeMixin(ApplicationSettings, this._settings);

            var profile = dependency.resolve("epi.shell.Profile");

            return when(profile.getContentLanguage()).then(lang.hitch(this, function (language) {

                //Set the current edit language on the profile object (this property has the same life-cycle as the application)
                //This property is used by the xhrwrapper
                ApplicationSettings.currentContentLanguage = profile.contentLanguage = language;
                if (ApplicationSettings.enableStickyView) {
                    StickyViewSelector.enable();
                } else {
                    StickyViewSelector.disable();
                }

                this.registerDependency("epi.cms.BackContextHistory", new BackContextHistory());
                this.registerDependency("epi.cms.ContextSynchronizer", new ContextSynchronizer(), undefined, function (value) {
                    value.destroy();
                });
                this.registerDependency("epi.cms.contentEditing.command.Editing", Editing);
                this._hashWrapper = dependency.resolve("epi.shell.HashWrapper");

                var contextService = this.resolveDependency("epi.shell.ContextService");

                this.registerDependency("epi.cms.contentRepositoryDescriptors",
                    new ContentRepositoryDescriptorService(this._settings.contentRepositoryDescriptors));

                // register route for redirecting page.
                // Consider: the second param (callback) might be replace to an object, which has "redirect" function, so we can extend it.
                contextService.registerRoute("epi.cms.contentdata", lang.hitch(this, this._redirectContentDataContext));
                contextService.registerRoute("epi.cms.project", lang.hitch(this, this._redirectContext));
                contextService.registerRoute("epi.cms.approval", lang.hitch(this, this._redirectContext));

                //initialize editor factory
                this._initializeEditorFactory();

                // Initialize stores
                this._initializeStores();

                // Setup the Content Approval service
                this.registerDependency("epi.cms.ApprovalService", new ApprovalService());

                // Setup the Project service after the stores has been initialized
                this.registerDependency("epi.cms.ProjectService", new ProjectService());
                this.registerDependency("epi.cms.ActivityService", new ActivityService());

                this.registerDependency("epi.cms.ContentHierarchyService", new ContentHierarchyService());

                this._projectModeRequestInterceptor = new ProjectModeRequestInterceptor();

                // Setup the ContentTypeService
                this.registerDependency("epi.cms.ContentTypeService", new ContentTypeService());

                this._setupConverters();
                this._setupViewSettings(contextService);

                var contentActivityCommandProvider = new ContentActivityCommandProvider();
                this.registerDependency("contentActivityCommandProvider", contentActivityCommandProvider);

                var commandregistry = dependency.resolve("epi.globalcommandregistry");

                // PublishMenuGlobal is dependent on ProjectService
                commandregistry.registerProvider("epi.cms.publishmenu", new PublishMenuGlobalCommandProvider());
                //We need to wait for the viewsettings to initialized before creating the global toolbar command provider
                commandregistry.registerProvider("epi.cms.globalToolbar", new GlobalToolbarCommandProvider());
                commandregistry.registerProvider("epi.cms.globalToolbar", new CompareCommandProvider());
                commandregistry.registerProvider("epi.cms.globalToolbar", new ViewSettingsCommandProvider());
                commandregistry.registerProvider("epi.cms.globalToolbar", contentActivityCommandProvider);

                telemetryInitializer.initialize();

                this._setupInUseNotificationManager(commandregistry);
            }));
        },

        _redirectContentDataContext: function (context, callerData, uri) {
            // summary:
            //      Process redirect action for content data context.
            //
            // context: Object
            //      Context from context service
            //
            // callerData: Object
            //      Sources that fire the event
            //
            // uri: Object
            //      Content Uri
            //
            // tags:
            //      Private

            if (ViewSettings.viewName === "/episerver/dashboard") { // we are in Dashboard mode
                // in Dashboard mode, we need to redirect to the cms editorial view.
                var homeUrl = routes.getActionPath({ moduleArea: "CMS", controller: "Home", action: "" });
                // remove last '/', which is unnecessary.
                homeUrl = homeUrl.substring(0, homeUrl.length - 1);
                var editPage = homeUrl + "#" + this._hashWrapper.extractHash(context, callerData);
                this._redirect(editPage);
            } else {
                if (context.hasSiteChanged) {
                    //we need to reload ui when a content from a different site has been requested.
                    var urlToPageOnOtherSite = context.fullHomeUrl + "#" + this._hashWrapper.extractHash(context, callerData);
                    this._redirect(urlToPageOnOtherSite);
                } else {
                    // currently in Home mode, need to update Hash only, instead of redirecting
                    // Not update hash in case of internal trigger and hash has been updated
                    if (callerData && callerData.trigger === "internal" && this._firstTimeHashUpdated) {
                        return;
                    }
                    this._firstTimeHashUpdated = true;
                    this._hashWrapper.onContextChange(context, callerData);
                }
            }
        },

        _redirectContext: function (/*Object*/context, /*Object*/callerData) {
            // summary:
            //      Redirect context
            // tags:
            //      private
            this._hashWrapper.onContextChange(context, callerData);
        },

        _redirect: function (url) {
            // summary:
            //      Redirect to another page (url).
            //
            // url: String
            //      Page url to navigate to.
            //
            // tags:
            //      Private

            window.location = url;
        },

        _setupConverters: function () {

            var contentLightConverter = new ContentLightConverter(),
                contentReferenceConverter = new ContentReferenceConverter(),
                contentFragmentConverter = new ContentFragmentConverter(),
                propertyDateConverter = new PropertyDateConverter(),
                repositoryDescriptors = this.resolveDependency("epi.cms.contentRepositoryDescriptors"),
                key;

            // Register converters for all linkable types known
            for (key in repositoryDescriptors) {
                var repo = repositoryDescriptors[key];
                if (repo.linkableTypes) {
                    repo.linkableTypes.forEach(function (type) {
                        ObjectConverterRegistry.registerConverter(type, type + ".link", contentLightConverter);
                        // Convert from content fragment to a link
                        ObjectConverterRegistry.registerConverter(type + ".fragment", type + ".link", contentLightConverter);
                        // Non specific type to link conversion
                        ObjectConverterRegistry.registerConverter(type, "link", contentLightConverter);
                    });
                }
            }

            for (key in TypeDescriptorManager._uiDescriptors) {
                //Currently we are registering converters for all types. Since uiDescriptors does not have to be content this might be a potential problem
                //but we ignore this until we need to fix this.
                var descriptor = TypeDescriptorManager._uiDescriptors[key].descriptor;
                ObjectConverterRegistry.registerConverter(descriptor.typeIdentifier, descriptor.typeIdentifier + ".reference", contentReferenceConverter);
                ObjectConverterRegistry.registerConverter(descriptor.typeIdentifier + ".fragment", descriptor.typeIdentifier + ".reference", contentReferenceConverter);
                ObjectConverterRegistry.registerConverter(descriptor.typeIdentifier, descriptor.typeIdentifier + ".light", contentLightConverter);
                ObjectConverterRegistry.registerConverter(descriptor.typeIdentifier, descriptor.typeIdentifier + ".fragment", contentFragmentConverter);
            }

            contentLightConverter.registerDefaultConverters(ObjectConverterRegistry);
            propertyDateConverter.registerDefaultConverters(ObjectConverterRegistry);
        },

        _setupViewSettings: function (contextService) {

            var viewSettingsManager = new ViewSettingsManager({
                viewSettings: [
                    new ResolutionViewSetting(),
                    new VisitorGroupViewSetting(),
                    new ChannelViewSetting(),
                    new ProjectViewSetting(contextService),
                    new ViewLanguageViewSetting(contextService)
                ]
            });

            this.registerDependency("epi.viewsettingsmanager", viewSettingsManager);
        },

        _initializeStores: function () {

            var registry = this.resolveDependency("epi.storeregistry"),
                authority,
                light,
                version;

            // Create complete page data store. This is the authority store.
            authority = registry.create("epi.cms.contentdata", this._getRestPath("contentdata"), { idProperty: "contentLink" });

            // Create content structure store
            light = registry.create("epi.cms.content.light", this._getRestPath("contentstructure"), { idProperty: "contentLink", queryEngine: configurableQueryEngine });

            // Create page version store
            version = registry.create("epi.cms.contentversion", this._getRestPath("contentversion"), { idProperty: "contentLink", queryEngine: PageVersionQueryEngine });

            // Create display options store
            registry.create("epi.cms.displayoptions", this._getRestPath("displayoptions"));

            // Create category store
            registry.create("epi.cms.category", this._getRestPath("categories"));

            // Create page editing session store
            registry.create("epi.cms.inusenotification", this._getRestPath("inusenotification"))
                .addDependentStore(authority);

            // Create visitor group store
            registry.create("epi.cms.visitorgroup", this._getRestPath("visitorgroup"));

            // Create language store
            registry.create("epi.cms.language", this._getRestPath("language"), { idProperty: "languageId" });

            // Create a site structure store
            registry.create("epi.cms.sitestructure", this._getRestPath("sitestructure"), { idProperty: "url" });

            // Create a display channel store.
            registry.create("epi.cms.displaychannels", this._getRestPath("channel"));

            // Create a content provider store.
            registry.create("epi.cms.wastebasket", this._getRestPath("wastebasket"));

            // Create the project stores
            registry.create("epi.cms.project", this._getRestPath("project"), { queryEngine: configurableQueryEngine, realtimeInfo: { subscriptionKey: "/episerver/cms/project" } });
            registry.create("epi.cms.project.item", this._getRestPath("project-item"), { queryEngine: projectItemQueryEngine, realtimeInfo: { subscriptionKey: "/episerver/cms/project-item" } });

            // Create the activities store.
            registry.create("epi.cms.activities", this._getRestPath("activities"), { queryEngine: ProjectActivitiesQueryEngine, realtimeInfo: { subscriptionKey: "/episerver/cms/activity" } });

            // Create the activities store.
            registry.create("epi.cms.activities.comments", this._getRestPath("activities-comments"), { realtimeInfo: { subscriptionKey: "/episerver/cms/activity-comment" } });

            // Create content type store, and fill it
            registry.create("epi.cms.contenttype", this._getRestPath("contenttype")).query();

            // Create the notification store
            registry.create("epi.cms.notification", this._getRestPath("notification"), { queryEngine: configurableQueryEngine, realtimeInfo: { subscriptionKey: "/episerver/cms/notification" } });

            // Create the notification users store.
            registry.create("epi.cms.notification.users", this._getRestPath("notification-users"), { idProperty: "userName" });

            // Create the approval users store.
            registry.create("epi.cms.approval.users", this._getRestPath("approval-users"));

            // Create personalized content store.
            registry.create("epi.cms.personalized.content", this._getRestPath("personalized-content"), { idProperty: "id" });

            // Create a content provider store.
            registry.create("epi.cms.multichannelcontent", this._getRestPath("multichannelcontent"));

            // Create the approval definition store.
            registry.add("epi.cms.approval.definition",
                new Throttle(
                    new JsonRest({
                        idProperty: "contentLink",
                        target: this._getRestPath("approval-definition"),
                        preventCache: false
                    })
                )
            );

            // Create the approval store.
            registry.add("epi.cms.approval",
                new Throttle(
                    new JsonRest({
                        target: this._getRestPath("approval"),
                        preventCache: false
                    })
                )
            );

            // Create language settings store
            registry.add("epi.cms.languagesettings", new Throttle(
                new JsonRest({
                    idProperty: "contentLink",
                    target: this._getRestPath("languagesettings"),
                    preventCache: false
                })
            ));

            // Create access rights store
            registry.add("epi.cms.accessrights", new Throttle(
                new JsonRest({
                    idProperty: "contentLink",
                    target: this._getRestPath("accessrights"),
                    preventCache: false
                })
            ));

            // Create access right users store.
            registry.add("epi.cms.accessright.users", new Throttle(
                new JsonRest({
                    target: this._getRestPath("accessright-users"),
                    preventCache: false
                })
            ));

            // Create content references store
            registry.add("epi.cms.contentreferences",
                new Throttle(
                    new JsonRest({
                        target: this._getRestPath("contentreferences"),
                        idProperty: "contentLink",
                        preventCache: false
                    })
                )
            );
            registry.add("epi.cms.referenced-content",
                new Throttle(
                    new JsonRest({
                        target: this._getRestPath("referenced-content"),
                        idProperty: "contentLink",
                        preventCache: false
                    })
                )
            );

            // Create non-cached content structure store
            registry.add("epi.cms.content.search",
                new Throttle(
                    new JsonRest({
                        target: this._getRestPath("contentstructure"),
                        idProperty: "contentLink"
                    })
                )
            );

            // Create non-cached latest content version store
            registry.add("epi.cms.latestcontentversion",
                new Throttle(
                    new JsonRest({
                        target: this._getRestPath("latestcontentversion"),
                        idProperty: "contentLink"
                    })
                )
            );

            authority.addDependentStore(light, {
                refreshOnPatch: true,
                refresh: function (patchObject) {
                    // Running the refresh in timeout to bypass the notification chain between
                    // Observable queries and dependant stores. Updating light store which is dependant
                    // on the master store is a postprocessing operation and can be deferred.
                    setTimeout(function () {
                        // The lightweight page store should only get updates for the published page
                        var id = authority.getIdentity(patchObject);
                        var versionAgnosticId = new ContentReference(id).createVersionUnspecificReference().toString();
                        light.refresh(versionAgnosticId);
                    });
                }
            });

            authority.addDependentStore(version, {
                transformDelegate: function (patchObject) {

                    //TODO: This is temporary until we have implemented dependant store capabilities checks
                    if (patchObject.capabilities && !patchObject.capabilities.versionable) {
                        return null;
                    }
                    // remap properties from the pagedata store to match the page version store
                    // source name : target name
                    if (!patchObject.properties) {
                        return null;
                    }

                    var propMap = {
                        pageChangedBy: "savedBy",
                        pageSaved: "savedDate",
                        pageLanguageBranch: "language",
                        pageName: "name",
                        name: "name",
                        icontent_name: "name"
                    };
                    var transformed = lang.mixin({}, patchObject);
                    for (var p in propMap) {
                        if (p in transformed.properties) {
                            transformed[propMap[p]] = transformed.properties[p];
                        }
                    }
                    return transformed;
                }
            });
        },

        _getRestPath: function (name) {
            return routes.getRestPath({ moduleArea: "cms", storeName: name });
        },

        _initializeEditorFactory: function () {
            // summary:
            //		Initialize editor bridge factory
            //

            this.registerDependency("epi.cms.contentediting.EditorFactory", function () {

                var editorFactory = new EditorFactory();

                // Inline
                editorFactory.registerEditorWrapper("inline", "epi-cms/contentediting/InlineEditorWrapper", function (wrapper, initParams) {
                });

                // Rich text inline editor wrapper
                editorFactory.registerEditorWrapper("richtextinline", "epi-cms/contentediting/RichTextInlineEditorWrapper", function (wrapper, initParams) {

                });

                // Flyout
                editorFactory.registerEditorWrapper("flyout", "epi-cms/contentediting/FlyoutEditorWrapper", function (wrapper, initParams) {
                });

                // Floating editor wrapper
                editorFactory.registerEditorWrapper("floating", "epi-cms/contentediting/FloatingEditorWrapper", function (wrapper, initParams) {
                });

                // Inline content editable
                editorFactory.registerEditorWrapper("contenteditable", "epi-cms/contentediting/ContentEditableWrapper", function (wrapper, initParams) {
                });

                return editorFactory;
            });
        },

        _setupInUseNotificationManager: function (commandregistry) {
            var notificationManager = new InUseNotificationManager();
            this.registerDependency("epi.cms.contentediting.inUseNotificationManager", notificationManager);
            commandregistry.registerProvider("epi.cms.publishmenu", new PublishMenuCommandProvider());
            commandregistry.registerProvider("epi.cms.contentdetailsmenu", new ContentDetailsCommandProvider());
        }
    });
});

},
'epi-cms/BackContextHistory':function(){
﻿define("epi-cms/BackContextHistory", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/store/Memory",

    "epi/shell/ContextHistory",
    "epi/shell/ViewSettings"
],
function (
    declare,
    lang,
    topic,

    Memory,

    ContextHistory,
    ViewSettings
) {

    return declare([ContextHistory], {
        // summary:
        //      Context history for back only action
        // tags:
        //      internal

        createStore: function () {
            // summary:
            //      Create new store
            // tags:
            //      override

            return new Memory({
                data: [],
                idProperty: "uri"
            });
        },

        onContextChanged: function (response, callerData, request) {
            // summary:
            // tags:
            //      override

            if (callerData && callerData.trigger === "back") {
                this._removeLastItem();
                return;
            }

            this.inherited(arguments);
        },

        closeAndNavigateBack: function (sender) {
            // summary:
            //      Removes the last context and all other same kind of context items from the history and issue change context request with the last item
            // tags:
            //      public

            var lastItem = this._getLastItem();

            // remove the item and same type of context from the history
            var historyToRemove = this.store.data.filter(function (item) {
                return lastItem.typeIdentifier && (lastItem.typeIdentifier === item.typeIdentifier);
            });

            historyToRemove.forEach(function (item) {
                var identity = this.store.getIdentity(item);
                this.store.remove(identity);
            }, this);

            var contextToNavigate = this._getLastItem();
            var uri = contextToNavigate && contextToNavigate.uri ? { uri: contextToNavigate.uri } : { uri: ViewSettings.settings.defaultContext };
            topic.publish("/epi/shell/context/request", uri, { sender: sender });
        },

        getPrevious: function () {
            // summary:
            //      Return previous content of currently loaded content.
            // tags:
            //      public

            var results = this.store.query({}, {
                count: 2, // Get current content and previous content
                sort: [{
                    attribute: "dateAdded",
                    descending: true
                }]
            });

            // Get previous content from sorted descending array.
            return (results && results.length > 1) ? results[1] : null;
        },

        _updateStore: function (response) {
            var lastItem = this._getLastItem();
            if (lastItem && lastItem.uri === response.versionAgnosticUri) {
                return;
            }

            this.inherited(arguments);
        },

        _getLastItem: function () {
            // summary:
            //     Returns the just previously added item from the store
            // tags:
            //      protected

            if (this.store && this.store.data && this.store.data.length > 0) {
                var sortedItemList = this.store.query({}, {sort: [{attribute: "dateAdded", descending: true}]});
                return sortedItemList[0];
            }

            return null;
        },

        _removeLastItem: function () {
            // summary:
            //     Removes the last added item from the store
            // tags:
            //      protected

            var lastItem = this._getLastItem();
            if (lastItem) {
                this.store.remove(this.store.getIdentity(lastItem));
            }
        }
    });
});

},
'epi-cms/ContextSynchronizer':function(){
﻿define("epi-cms/ContextSynchronizer", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/when",
    "epi/shell/_ContextMixin",
    "epi-cms/core/ContentReference"],
function (
    declare,
    lang,
    connect,
    when,
    _ContextMixin,
    ContentReference) {

    return declare([_ContextMixin], {
        // summary:
        //      A _ContextMixin that synchronizes content changes with the context
        //
        // tags:
        //      internal

        _subscribeHandle: null,

        constructor: function () {
            this._subscribeHandle = connect.subscribe("/epi/cms/contentdata/updated", this, this._updateCurrentContext);
        },

        _updateCurrentContext: function (updatedContent) {
            //When the content is updated, also update the context.

            var contentLink = updatedContent.contentLink;

            //if it's the current context that has been changed, tell the context service to update the context
            when(this.getCurrentContext(), function (currentContext) {
                if (currentContext && ContentReference.compareIgnoreVersion(currentContext.id, contentLink)) {
                    var data = {
                        uri: "epi.cms.contentdata:///" + contentLink
                    };

                    //only append the epslanguage if the content supports languages
                    if (currentContext.languageContext) {
                        data.epslanguage = currentContext.languageContext.preferredLanguage;
                    }
                    connect.publish("/epi/shell/context/updateRequest", data);
                }
            });
        },

        destroy: function () {
            connect.unsubscribe(this._subscribeHandle);
        }

    });
});

},
'epi-cms/ContentRepositoryDescriptorService':function(){
define("epi-cms/ContentRepositoryDescriptorService", [
    "epi/assign"
], function (
    assign
) {
    function ContentRepositoryDescriptorService(contentRepositoryDescriptors) {
        // summary:
        //      Service that contains all registered IContentRepositoryDescriptors from the server
        // tags:
        //      internal

        assign(this, contentRepositoryDescriptors);
    }

    ContentRepositoryDescriptorService.prototype.get = function (key) {
        // summary:
        //      Gets the repository descriptor with the matching key
        // tags:
        //      public

        return !key ? null : this[key.toLowerCase()];
    };

    ContentRepositoryDescriptorService.prototype.list = function () {
        // summary:
        //      Returns all the descriptor keys present in the repository
        // tags:
        //      public

        return Object.keys(this);
    };

    return ContentRepositoryDescriptorService;
});

},
'epi-cms/conversion/ContentFragmentConverter':function(){
define(["dojo/_base/declare"], function (declare) {

    return declare([], {
        // summary:
        //      Converts data from a content data object to an object that
        //      contains only those properties required by content fragments.
        // tags:
        //      internal

        convert: function (sourceType, targetType, data) {
            // summary:
            //      Converts data to a content fragment object.
            // data: Object
            //      The object to be converted to a content fragment.
            // tags:
            //      public

            if (!data) {
                return null;
            }

            return {
                contentLink: data.contentLink,
                name: data.name,
                typeIdentifier: data.typeIdentifier,
                id: data.id
            };
        }
    });
});

},
'epi-cms/conversion/ContentLightUriConverter':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi/dependency",
    "epi/UriParser",
    "epi-cms/core/ContentReference"
], function (declare, lang, when, dependency, UriParser, ContentReference) {

    return declare(null, {
        // summary:
        //    Converts data between light weight content types containing an URI as a specifier and other types.
        //
        // tags:
        //    internal

        _contentStore: null,

        constructor: function (params) {
            // summary:
            //    The constructor function
            //
            // params: Object
            //    The parameters that define the object.
            // tags:
            //    public

            lang.mixin(this, params);

            this._contentStore = this._contentStore || dependency.resolve("epi.storeregistry").get("epi.cms.contentdata");
        },

        registerDefaultConverters: function (/*Object*/registry) {
            // summary:
            //    Registers the type conversions that this class supports to the given registry.
            //
            // registry: Object
            //    The converter registry to add mappings to.
        },

        convert: function (/*String*/sourceDataType, /*String*/targetDataType, /*Object*/data) {
            // summary:
            //    Converts data between two types.
            //
            // sourceDataType: String
            //    The source data type.
            //
            // targetDataType: String
            //    The target data type.
            //
            // data: Object
            //    The data to convert.
            // tags:
            //    public

            if (!data || (!data.contentLink && !data.uri)) {
                return null;
            }

            var contentLink = data.contentLink || new UriParser(data.uri).getId();

            if (!contentLink) {
                return null;
            }

            contentLink = new ContentReference(contentLink).createVersionUnspecificReference().toString();

            return when(this._contentStore.get(contentLink), function (content) {
                return {
                    url: content.publicUrl,
                    previewUrl: content.previewUrl,
                    permanentUrl: content.permanentLink,
                    text: content.name,
                    typeIdentifier: content.typeIdentifier
                };
            });
        }
    });
});

},
'epi-cms/conversion/ContentReferenceConverter':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi/dependency",
    "epi/UriParser",
    "epi-cms/core/ContentReference"
], function (declare, lang, when, dependency, UriParser, ContentReference) {

    return declare(null, {
        // summary:
        //    Converts data between default content containing an URI as a specifyer and a version unspecific content reference.
        //
        // tags:
        //    internal

        convert: function (/*String*/sourceDataType, /*String*/targetDataType, /*Object*/data) {
            // summary:
            //    Converts data between two types.
            //
            // sourceDataType: String
            //    The source data type.
            //
            // targetDataType: String
            //    The target data type.
            //
            // converter: Object
            //    The class that performs the actual conversion.
            // tags:
            //    public

            if (!data || (!data.uri && !data.contentLink)) {
                return null;
            }

            var contentLink;
            if (data.uri) {
                var uri = new UriParser(data.uri);
                contentLink = uri.getId();
            } else {
                contentLink = data.contentLink;
            }

            return new ContentReference(contentLink).createVersionUnspecificReference().toString();
        }
    });
});

},
'epi-cms/conversion/PropertyDateConverter':function(){
﻿define([
    "dojo/_base/declare"
],
function (
    declare
) {

    return declare(null, {
        // summary:
        //    Converts PropertyDate value to runtime Date according to epi/datetime rules
        //
        // tags:
        //    internal

        sourceDataType: "epi.cms.propertydate",
        targetDataType: "runtimeType",

        registerDefaultConverters: function (/*Object*/registry) {
            // summary:
            //    Registers the type conversions that this class supports to the given registry.
            //
            // registry: Object
            //    The converter registry to add mappings to.
            registry.registerConverter(this.sourceDataType, this.targetDataType, this);
        },

        convert: function (/*String*/sourceDataType, /*String*/targetDataType, /*Object*/data) {
            // summary:
            //    Converts data between two types.
            //
            // sourceDataType: String
            //    The source data type.
            //
            // targetDataType: String
            //    The target data type.
            //
            // converter: Object
            //    The class that performs the actual conversion.
            // tags:
            //    public

            if (data && sourceDataType === this.sourceDataType && targetDataType === this.targetDataType) {
                return new Date(data);
            }

            return null;
        }
    });
}
);

},
'epi-cms/store/configurableQueryEngine':function(){
define([
    "epi/shell/store/queryUtils"
], function (queryUtils) {

    return function (query, options) {
        // summary:
        //      The module defines a filtering query engine that can be passed an array of ignore
        //      parameters enabling specific query parameters to be ignored when analyzing the query.
        // description:
        //		Simple query engine that matches using filter functions, named filter
        //		functions or objects by name-value on a query object hash.
        //
        // tags:
        //      internal xproduct

        options = options || {};

        return queryUtils.createEngine(query, options);
    };
});

},
'epi/shell/store/queryUtils':function(){
define("epi/shell/store/queryUtils", [], function () {

    function validSortOptions(sortOptions) {
        return sortOptions instanceof Array && sortOptions.length > 0;
    }

    var module =  {
        // summary:
        //      A QueryEngine configured to work with project items
        // tags:
        //      internal

        createFilter: function (query, options) {
            // summary:
            //      A factory usable for when creating filters for store queryEngines.
            //
            // query: Object
            //
            // options: dojo/store/api/Store.QueryOptions?
            //		An object that contains optional information such as sort, start, and count.
            //      It also supports having an array of ignore key values for query parts that
            //      should not be used in the filter and a compare dictionary for custom
            //      filtering logic.
            //
            //          {
            //              ignore: ["query", "prop2"],
            //              comparers: {
            //                  "prop3": function (queryPart, instance) { return true; }
            //              }
            //          }
            //
            // returns: Function
            //		A filter function

            var filter;

            options = options || {};

            // create our matching query function
            switch (typeof query) {

                case "object" :
                case "undefined" :
                    filter = function (item) {

                        return !query || Object.keys(query).every(function (key) {

                            var ignoreKeys = options.ignore,
                                comparer = options.comparers && options.comparers[key],
                                queryValue = query[key];

                            // Check if the query value should be ignored by the filter
                            if (ignoreKeys && ignoreKeys.indexOf(key) !== -1) {
                                return true;
                            }

                            // If there is a special comparer function registered for the query key then use that
                            if (comparer) {
                                return comparer(queryValue, item);
                            }

                            // Default to equality comparison of the query value and what's in in the items property
                            return queryValue === item[key];
                        });
                    };

                    break;
                default:
                    throw new Error("Can not query with a " + typeof query);
            }

            return filter;
        },

        createSorter: function (sortOptions) {
            // summary:
            //      A factory usable when creating sorters for store queryEngines.
            //
            // sortOptions: Object[]
            //          [
            //              { attribute: "name", descending: false },
            //              { attribute: "startDate", descending: true }
            //          ]
            //
            // returns: Function
            //		A sort function

            if (!validSortOptions(sortOptions)) {
                throw new Error("Argument must be an array containing sortOptions");
            }

            return function (a, b) {

                var aValue, bValue;

                for (var sort, i = 0; (sort = sortOptions[i]); i++) {
                    aValue = a[sort.attribute];
                    bValue = b[sort.attribute];

                    if (typeof aValue === "string" && typeof bValue === "string") {
                        aValue = aValue.toLowerCase();
                        bValue = bValue.toLowerCase();
                    }

                    if (aValue !== bValue) {
                        return sort.descending === (aValue > bValue) ? -1 : 1;
                    }
                }

                return 0;
            };
        },

        createExecuter: function (filter, sorter, start, count) {
            // summary:
            //      A factory usable for when creating the execute function of a queryEngines.
            //
            // filter: Function?
            //      A function capable of matching objects against a query
            //
            // sorter: Function?
            //      A function capable of sorting a collection
            //
            // start: Number?
            //      If used with pagination the starting point of the result collection
            //
            // count: Number?
            //      If used with pagination the number of items to return from the result collection
            //
            // returns: Function
            //		An execute function

            var begin = start || 0,
                end = count ? begin + count : Infinity;

            return function (results) {

                var total;

                // Make sure to create a new array
                results = filter ? results.filter(filter) : results.slice(0);

                sorter && results.sort(sorter);

                if (start || count) {
                    total = results.length;
                    results = results.slice(begin, end);
                    results.total = total;
                }

                return results;
            };
        },

        createEngine: function (query, options) {
            // summary:
            //      A factory for creating store queryEngines.
            //
            // query: Object
            //
            // options: dojo/store/api/Store.QueryOptions?
            //		An object that contains optional information such as sort, start, and count.
            //      It also supports having an array of ignore key values for query parts that
            //      should not be used in the filter and a compare dictionary for custom
            //      filtering logic.
            //
            //          {
            //              ignore: ["query", "prop2"],
            //              comparers: {
            //                  "prop3": function (queryPart, instance) { return true; }
            //              }
            //          }
            //
            // returns: Function
            //		A queryEngine function

            var filter,
                sorter,
                engine;

            options = options || {};

            filter = module.createFilter(query, options);
            sorter = validSortOptions(options.sort) ? module.createSorter(options.sort) : null;
            engine = module.createExecuter(filter, sorter, options.start, options.count);
            engine.matches = filter;

            return engine;
        }
    };

    return module;
});

},
'epi-cms/store/PageVersionQueryEngine':function(){
﻿define(["dojo/_base/array", "epi-cms/core/ContentReference"], function (arrayUtil, ContentReference) {

    return function (query, options) {
        // tags:
        //      internal

        // Create our matching query function
        switch (typeof query) {
            case "object": case "undefined":
                var queryObject = query;
                query = function (object) {
                    for (var key in queryObject) {
                        var required = queryObject[key],
                            original = required.toString();

                        // If the value is not a content reference and don't match return false, else if the value is a content reference
                        // then compare by ignoring versions.
                        if (original !== object[key] && (!ContentReference.isContentReference(original) || !ContentReference.compareIgnoreVersion(original, object[key]))) {
                            return false;
                        }
                    }
                    return true;
                };
                break;
            case "string":
                // named query
                if (!this[query]) {
                    throw new Error("No filter function " + query + " was found in store");
                }
                query = this[query];
                break;
            case "function":
                break;
            default:
                throw new Error("Can not query with a " + typeof query);
        }
        function execute(array) {
            // execute the whole query, first we filter
            var results = arrayUtil.filter(array, query);
            // next we sort
            if (options && options.sort) {
                results.sort(function (a, b) {
                    for (var sort, i = 0; (sort = options.sort[i]); i++) {
                        var aValue = a[sort.attribute];
                        var bValue = b[sort.attribute];
                        if (aValue !== bValue) {
                            return sort.descending === (aValue > bValue) ? -1 : 1;
                        }
                    }
                    return 0;
                });
            }
            // now we paginate
            if (options && (options.start || options.count)) {
                var total = results.length;
                results = results.slice(options.start || 0, (options.start || 0) + (options.count || Infinity));
                results.total = total;
            }
            return results;
        }
        execute.matches = query;
        return execute;
    };
});

},
'epi-cms/store/currentContentContext':function(){
define([
    "dojo/Deferred",
    "dojo/when",
    "epi/shell/_ContextMixin"
], function (Deferred, when, _ContextMixin) {

    return {
        // summary:
        //      Request mutator for adding the currently selected content id to the an xhr request
        // description:
        //      Sets the X-EPiCurrentContentContext header with the currently selected content id
        // tags:
        //      internal

        beforeSend: function (params) {
            // summary:
            //      Adds X-EPiCurrentContentContext to the options.headers of the request parameters.
            // params: Object
            //      The request parameters
            // tags: public

            var options = params.options;
            if (options.isProfileRequest) {
                return when(params);
            }

            var context = new _ContextMixin();
            var result = new Deferred();

            if (context._currentContext && context._currentContext.type === "epi.cms.contentdata" && context._currentContext.id) {
                options.headers["X-EPiCurrentContentContext"] = context._currentContext.id;
            }

            result.resolve(params);

            return result.promise;
        }
    };
});

},
'epi-cms/project/ProjectActivitiesQueryEngine':function(){
define([
    "dojo/_base/lang",
    "epi/shell/store/queryUtils"
], function (
    lang,
    queryUtils
) {

    return function (query, options) {
        // summary:
        //      Determines if the given activity instance matches the query object
        // query: Object
        //
        // options: dojo/store/api/Store.QueryOptions?
        //      An object that contains optional information such as sort, start, and count.
        //
        // tags:
        //      internal
        //
        // returns: Function
        //      A function that caches the passed query under the field "matches".  See any
        //      of the "query" methods on dojo/stores.

        options = lang.mixin({
            comparers: {
                projectId: function (projectId, instance) {
                    return !instance.projectId || projectId === instance.projectId;
                },
                contentReferences: function (references, instance) {
                    return references && references.some(function (reference) {
                        return reference === instance.contentLink;
                    });
                }
            }
        }, options);

        return queryUtils.createEngine(query, options);
    };
});

},
'epi-cms/component/command/GlobalToolbarCommandProvider':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",

    "dijit/Destroyable",
    "dijit/form/ToggleButton",

    "epi/dependency",
    "epi/shell/command/ToggleCommand",
    "epi/shell/ViewSettings",
    "epi-cms/ApplicationSettings",
    "epi-cms/widget/command/CreateContentFromSelector",
    "epi-cms/component/command/_GlobalToolbarCommandProvider",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting"
], function (
    array,
    declare,
    lang,
    topic,

    Destroyable,
    ToggleButton,

    dependency,
    ToggleCommand,
    ViewSettings,
    ApplicationSettings,
    CreateContentFromSelector,
    _GlobalToolbarCommandProvider,

    resources
) {

    var _ToggleNavigationPaneCommand = declare([ToggleCommand, Destroyable], {
        iconClass: "epi-iconListTree",
        tooltip: resources.toolbar.buttons.togglenavigationpane,
        label: resources.toolbar.buttons.togglenavigationpane,
        order: -10000, //Give it a low nr to make it more probable that it is always the first button
        canExecute: true,
        constructor: function () {
            this.own(
                topic.subscribe("/epi/layout/pinnable/navigation/visibilitychanged", lang.hitch(this, function (visible) {
                    this.set("active", visible);
                }))
            );
        },
        _execute: function () {
            topic.publish("/epi/layout/pinnable/navigation/toggle");
        }

    });

    var _ToggleAssetsPaneCommand = declare([ToggleCommand, Destroyable], {
        iconClass: "epi-iconFolders",
        tooltip: resources.toolbar.buttons.toggleassetspane,
        label: resources.toolbar.buttons.toggleassetspane,
        order: 10000, //Give it a high nr to make it more probable that it is always the last button
        canExecute: true,
        constructor: function () {
            this.own(
                topic.subscribe("/epi/layout/pinnable/tools/visibilitychanged", lang.hitch(this, function (visible) {
                    this.set("active", visible);
                }))
            );
        },
        _execute: function () {
            topic.publish("/epi/layout/pinnable/tools/toggle");
        }
    });

    return declare([_GlobalToolbarCommandProvider], {
        // summary:
        //      Default command provider for the epi-cms/component/GlobalToolbar
        // tags:
        //      internal

        contentRepositoryDescriptors: null,
        viewName: null,

        postscript: function () {
            // summary:
            //      Ensure that an array of commands has been initialized.
            // tags:
            //      public
            this.inherited(arguments);

            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
            this.viewName = this.viewName || ViewSettings.viewName;
            this._addLeadingCommands();

            if (!ApplicationSettings.isInHeadlessMode) {
                this._addCreateCommands();
            }

            this._addTrailingCommands();
        },

        _addLeadingCommands: function () {
            this.addToLeading(new _ToggleNavigationPaneCommand(), {
                widget: ToggleButton,
                "class": "epi-leadingToggleButton epi-mediumButton"
            });
        },

        _addCreateCommands: function () {

            var currentView = this.viewName;
            var descriptorsForCurrentView = [];
            var creatableTypesForCurrentView = [];
            var isCurrentView = function (view) {
                return view === currentView;
            };

            for (var index in this.contentRepositoryDescriptors) {
                var descriptor = this.contentRepositoryDescriptors[index];
                if (array.some(descriptor.mainViews, isCurrentView)) {
                    descriptorsForCurrentView.push(descriptor);
                }
            }

            array.forEach(descriptorsForCurrentView, function (descriptor) {
                var creatableTypes = descriptor.creatableTypes;
                array.forEach(creatableTypes, function (type) {
                    if (!creatableTypesForCurrentView.includes(type)) {
                        creatableTypesForCurrentView.push(type);
                    }
                });
            });

            array.forEach(creatableTypesForCurrentView, function (type) {
                this.addCommand(this._createCommand(type), { category: "create" });
            }, this);
        },

        _createCommand: function (type) {
            return new CreateContentFromSelector({
                creatingTypeIdentifier: type
            });
        },

        _addTrailingCommands: function () {
            this.addToTrailing(new _ToggleAssetsPaneCommand(), {
                widget: ToggleButton,
                "class": "epi-trailingToggleButton epi-mediumButton"
            });
        }
    });
});

},
'epi-cms/widget/command/CreateContentFromSelector':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/on",
    "dojo/topic",
    "dojo/when",

    // Shell
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/DialogService",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/widget/dialog/Dialog",

    // CMS
    "epi-cms/core/ContentReference",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/DialogPositionAdjust",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/widget/ContentSelectorDialog",
    "epi-cms/widget/ContentForestStoreModel",
    "epi-cms/widget/ContentTypeList",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/inline-editing/CreateNewBlockEditFormContainer",
    "epi-cms/contentediting/inline-editing/InlineEditBlockDialog",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.createcontentselector",

    "epi/i18n!epi/cms/nls/episerver.cms.components.createblock",
    "epi/i18n!epi/cms/nls/episerver.shared.action",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.inlineediting.inlinecommands.inlinepublish"
],

function (
    array,
    declare,
    lang,
    aspect,
    on,
    topic,
    when,

    // Shell
    dependency,
    _Command,
    TypeDescriptorManager,
    dialogService,
    Alert,
    Dialog,

    // CMS
    ContentReference,
    ApplicationSettings,
    DialogPositionAdjust,
    _ContextualContentContextMixin,
    ContentSelector,
    ContentForestStoreModel,
    ContentTypeList,
    ContentActionSupport,
    CreateNewBlockEditFormContainer,
    InlineEditBlockDialog,
    createcontentselectorresources,

    createBlockRes,
    sharedRes,
    inlinepublishRes
) {

    return declare([_Command, _ContextualContentContextMixin], {
        // tags:
        //      internal

        // canExecute: [Boolean]
        //      Default value indicate that command can execute
        canExecute: true,

        // canSelectOwnerContent:
        //      Indicate that command can select owner content
        canSelectOwnerContent: false,

        // showButtons:
        //      Indicate that command show buttons
        showButtons: false,

        // value: [String]
        //      Default select content
        value: null,

        // showRoot: [Boolean]
        //      True if show root on dialog, otherwise don't show root
        showRoot: false,

        // roots: [Array]
        //      The roots to show in the selector.
        roots: null,

        // creatingTypeIdentifier: [String]
        //      Type identifier of the content which is being created.
        creatingTypeIdentifier: null,

        // containerTypeIdentifiers: [Array]
        //      Type identifiers of content
        containerTypeIdentifiers: null,

        // modelContent: [Widget]
        //      That model selector dialog
        modelContent: null,

        // confirmActionText: [String]
        //      Confirm action text in dialog
        confirmActionText: createcontentselectorresources.buttons.confirmation,

        // description: [String]
        //      Description in dialog
        description: null,

        // title: [String]
        //      Title in dialog
        title: null,

        // createAsLocalAsset: [Boolean]
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        // autoPublish: Boolean
        //     Indicates if the content should be published automatically when created if the user has publish rights.
        autoPublish: false,

        // addToParentsAssetsFolder: [Boolean]
        //      Indicate if the command should attach content to the parent's assets folder.
        addToParentsAssetsFolder: false,

        typeDescriptorManager: null,

        contentRepositoryDescriptors: null,

        // allowedTypes: [public] Array
        //      The types which are allowed for the given property. i.e used for filtering based on AllowedTypesAttribute
        allowedTypes: null,

        // restrictedTypes: [public] Array
        //      The types which are restricted.
        restrictedTypes: null,

        // suppressOverlayAdjustments: [public] Boolean
        //      Flag which indicates that all overlay adjustments should not be performed. It might be useful when showing another overlay or dialog (e.g. TinyMCE full screen)
        suppressOverlayAdjustments: false,

        postscript: function () {
            // summary:
            //    Initial settings value.
            //
            // tags:
            //    public

            this.inherited(arguments);
            this._dialogPositionAdjust = new DialogPositionAdjust();
            this.own(this._dialogPositionAdjust);

            this._initialize();
        },

        _initialize: function () {
            // summary:
            //    Initial application setting
            //
            // tags:
            //    private
            if (!this.creatingTypeIdentifier) {
                throw "You need to specify a creatingTypeIdentifier";
            }

            if (this._initialized) {
                return;
            }
            var registry = dependency.resolve("epi.storeregistry");
            this.contentStore = this.contentStore || registry.get("epi.cms.content.light");
            this.contextService = this.contextService || dependency.resolve("epi.shell.ContextService");
            this.contentTypeStore = this.contentTypeStore || registry.get("epi.cms.contenttype");

            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");

            var repositoryDescriptor,
                matchType = function (type) {
                    return type === this.creatingTypeIdentifier;
                };
            for (var index in this.contentRepositoryDescriptors) {
                var descriptor = this.contentRepositoryDescriptors[index];
                //use the first descriptor that matches the creating type identifier.
                if (array.some(descriptor.containedTypes, matchType, this)) {
                    repositoryDescriptor = descriptor;
                    break;
                }
            }
            if (repositoryDescriptor) {
                var containerTypeIdentifiers = TypeDescriptorManager.getValue(this.creatingTypeIdentifier, "containerTypes");
                this.containerTypeIdentifiers = containerTypeIdentifiers ?
                    containerTypeIdentifiers :
                    [this.creatingTypeIdentifier];
                this.roots = this.roots || repositoryDescriptor.roots;
            }

            this.preventContextualContentFor = repositoryDescriptor.preventContextualContentFor;

            this.label = this.label || TypeDescriptorManager.getResourceValue(this.creatingTypeIdentifier, "create");
            this.title = this.title || TypeDescriptorManager.getResourceValue(this.creatingTypeIdentifier, "selectparent");
            this.description = this.description || TypeDescriptorManager.getResourceValue(this.creatingTypeIdentifier, "createdescription");
            this.iconClass = this.iconClass || TypeDescriptorManager.getValue(this.creatingTypeIdentifier, "commandIconClass");
            this._initialized = true;
        },

        _ensureModelContent: function () {
            // creating content from top bar is not a very common action, creating model can be postponed for performance reason

            if (this.modelContent) {
                return;
            }

            this.modelContent = new ContentForestStoreModel({
                roots: this.roots,
                additionalQueryOptions: {
                    sort: [{ attribute: "name", descending: false }]
                }
            });
        },

        contextChanged: function (ctx, callerData) {
            // summary:
            //      On context change
            // tags:
            //      protected
            this.set("isAvailable", this._isContentContext(ctx));
            this.inherited(arguments);
        },
        _execute: function () {
            // summary:
            //		Executes this command; ...
            // tags:
            //		protected

            when(this.getCurrentContent(), lang.hitch(this, function (currentContent) {
                if (!currentContent) {
                    return;
                }

                // when creating nest block in quick edit
                var contentLink = currentContent.contentLink || currentContent.id;

                // Get the context store for more information about the model
                // We need to append the ?uri= because the request chain can not handle URI's in URI's
                when(this.contextService.query({uri: "epi.cms.contentdata:///" + contentLink}), lang.hitch(this, function (context) {
                    if (!context) {
                        return;
                    }
                    var languageContext = context.languageContext;

                    // languageContext is null if the content or content provider does not have multi language support
                    // in this case allow creating a new page no matter which language is active
                    var hasAccessToLanguage = !languageContext || (languageContext.hasTranslationAccess && languageContext.isPreferredLanguageAvailable);

                    var isWastebasket = ContentReference.compareIgnoreVersion(contentLink, ApplicationSettings.wastebasketPage);

                    var isEnableMenu = !(isWastebasket || currentContent.isDeleted) && hasAccessToLanguage &&
                    ContentActionSupport.isActionAvailable(currentContent, ContentActionSupport.action.Create, ContentActionSupport.providerCapabilities.Create, true);

                    when(this._getAvailableContentTypes(contentLink), lang.hitch(this, function (availableContentTypes) {

                        var contentTypeCanBeChildToCurrentContext = this._isContentTypeAllowedAsChildToCurrentContext(availableContentTypes, currentContent);

                        // Show location selector dialog when current context is a valid location to store the one we are about to create.
                        if ((!contentTypeCanBeChildToCurrentContext && !this.createAsLocalAsset) ||
                            !isEnableMenu) {

                            this._createDialog();
                            this._setDialogButtonState(this.selector.get("value"));
                        } else {
                            this._switchView(currentContent);
                        }
                    }));
                }));
            }));
        },

        _getAvailableContentTypes: function (contentLink) {
            return this.contentTypeStore.query({
                query: "getavailablecontenttypes",
                localAsset: this.createAsLocalAsset,
                parentReference: contentLink
            });
        },

        _isContentTypeAllowedAsChildToCurrentContext: function (availableContentTypes, currentContent) {
            var anyAvailableContentTypeOfCorrectType = array.some(availableContentTypes, function (contentType) {
                return TypeDescriptorManager.isBaseTypeIdentifier(contentType.typeIdentifier, this.creatingTypeIdentifier);
            }, this);

            var currentContentIsAValidContainerType = array.some(this.containerTypeIdentifiers, function (type) {
                return TypeDescriptorManager.isBaseTypeIdentifier(currentContent.typeIdentifier, type);
            });

            return anyAvailableContentTypeOfCorrectType && currentContentIsAValidContainerType;
        },

        _createDialog: function () {
            // summary:
            //    Create selector dialog.
            //
            // tags:
            //    protected

            this._ensureModelContent();

            this.selector = new ContentSelector({
                canSelectOwnerContent: this.canSelectOwnerContent,
                showButtons: this.showButtons,
                value: this.value,
                showRoot: this.showRoot,
                multiRootsMode: true,
                allowedTypes: this.containerTypeIdentifiers,
                model: this.modelContent,
                showContextualContent: true,
                preventContextualContentFor: this.preventContextualContentFor
            });

            this.dialog = new Dialog({
                confirmActionText: this.confirmActionText,
                description: this.description,
                title: this.title,
                content: this.selector
            });

            this.selector.on("change", lang.hitch(this, this._setDialogButtonState));
            this.dialog.own(
                aspect.after(this.dialog, "hide", lang.hitch(this, function (result) {
                    this.hideDeferred = result;
                })));
            this.dialog.on("execute", lang.hitch(this, this._onContentSelected));

            this.dialog.show();
        },

        _onContentSelected: function () {
            // summary:
            //    When selected parent content, it should be hide dialog and change view.
            //
            // tags:
            //    protected

            var contentLink = this.selector.get("value");

            when(this.hideDeferred, lang.hitch(this, function () {
                when(this.contentStore.get(contentLink), lang.hitch(this, function (content) {
                    this._switchView(content);
                }));
            }));
        },

        _createInlineEditDialog: function (content, selectedType) {
            // summary:
            //      Create a dialog for inline-creating a block
            //
            // content:
            //      The content which will be the parent of the new creating block
            // selectedType:
            //      The block type to create the block
            //
            // tags:
            //      private


            var editDialog = new InlineEditBlockDialog({
                title: sharedRes["new"] + " " + selectedType.localizedName,
                saveLabel: sharedRes.create,
                suppressOverlayAdjustments: this.suppressOverlayAdjustments
            });

            var contextService = this.contextService;
            editDialog.on("cancel", function () {
                if (!contextService.currentContext) {
                    contextService.currentContext = {};
                }
                contextService.currentContext.currentMode = undefined;
            });

            var form = new CreateNewBlockEditFormContainer({
                autoPublish: this.autoPublish,
                addToDestination: this.model
            }, editDialog.content, "last");

            editDialog.own(on(form, "FormCreated", function () {
                editDialog.show();
                editDialog.toggleMainButton(false);
                editDialog.toggleDisabledSaveButton(false);
            }));

            form.reloadMetadata(content, selectedType.id);

            this.own(on(editDialog, "execute", function () {
                var deferred = form.saveForm();
                deferred.otherwise(function (errorMessages) {
                    dialogService.alertWithErrors({
                        title: inlinepublishRes.error
                    }, errorMessages);
                });
            }));
            this.own(on(editDialog, "hide", function () {
                this._dialogPositionAdjust.cleanup();
            }.bind(this)));
            editDialog.own(form);
            this.own(editDialog);

            this._dialogPositionAdjust.adjustDialogPosition(editDialog);
        },

        _switchView: function (content) {
            // summary:
            //    Change view to Create Content with parent content
            //
            // tags:
            //    protected

            if (!this.isInQuickEditMode && !this.keepCurrentView) {
                when(this.getCurrentContent(), lang.hitch(this, function (contextContent) {
                    var createAsLocalAsset = this.isPseudoContextualRoot(content) || this.createAsLocalAsset;

                    topic.publish("/epi/shell/action/changeview", "epi-cms/contentediting/CreateContent", null, {
                        requestedType: this.creatingTypeIdentifier,
                        parent: createAsLocalAsset ? contextContent : content,
                        editAllPropertiesOnCreate: this.editAllPropertiesOnCreate,
                        addToDestination: this.model,
                        createAsLocalAsset: createAsLocalAsset,
                        treatAsSecondaryView: this.createAsLocalAsset,
                        view: TypeDescriptorManager.getValue(this.creatingTypeIdentifier, "createView"),
                        autoPublish: this.autoPublish,
                        allowedTypes: this.allowedTypes,
                        restrictedTypes: this.restrictedTypes
                    });
                }));
            } else {
                var _this = this;
                var dialog;
                var contentTypeList = new ContentTypeList({
                    allowedTypes: this.allowedTypes,
                    restrictedTypes: this.restrictedTypes,
                    localAsset: true,
                    parentLink: content.contentLink,
                    onContentTypeSelected: function (selectedType) {
                        if (dialog) {
                            dialog.hide();
                        }
                        _this._createInlineEditDialog(content, selectedType);
                    }
                });

                _this.own(contentTypeList.watch("shouldSkipContentTypeSelection", function () {
                    if (contentTypeList.get("shouldSkipContentTypeSelection")) {
                        return;
                    }

                    dialog = new Alert({
                        // eslint-disable-next-line no-undef
                        acknowledgeActionText: epi.resources.action.close,
                        closeIconVisible: false,
                        content: contentTypeList,
                        dialogClass: "epi-dialog-portrait inline-edit-dialog",
                        title: createBlockRes.title
                    });

                    dialog.show();
                    dialog.containerNode.classList.add("create-content-dialog");
                    _this.own(dialog);
                    contentTypeList._suggestedContentTypes.setVisibility(false);
                }));
                contentTypeList.set("requestedType", "episerver.core.blockdata");
                contentTypeList.refresh();
                _this.own(contentTypeList);
            }
        },

        _setDialogButtonState: function (contentLink) {
            // summary:
            //    Set state of dialog button.
            //
            // tags:
            //    protected

            if (!contentLink) {
                this.dialog.definitionConsumer.setItemProperty(this.dialog._okButtonName, "disabled", true);
                return;
            }

            when(this.contentStore.get(contentLink), lang.hitch(this, function (content) {
                when(this.isPseudoContextualRoot(content) ? this.contextService.query({uri: "epi.cms.contentdata:///" + this._currentContext.id}) : content, lang.hitch(this, function (target) {
                    // language is null if the content or content provider does not have multi language support
                    // in this case allow creating a new block no matter which language is active
                    var hasAccessToLanguage = ContentActionSupport.hasLanguageAccess(target),
                        canCreate = hasAccessToLanguage && ContentActionSupport.hasAccess(content.accessMask, ContentActionSupport.accessLevel.Create);

                    this.dialog.definitionConsumer.setItemProperty(this.dialog._okButtonName, "disabled", !canCreate);
                }));
            }));
        }

    });

});

},
'epi-cms/contentediting/DialogPositionAdjust':function(){
﻿define([
    "dojo/_base/declare",
    "dijit/Destroyable"
], function (
    declare,
    Destroyable
) {

    return declare([Destroyable], {
        // summary:
        //      Adjust dialog position in case of small browser window
        // tags:
        //      internal

        _resizeObserver: null,

        destroy: function () {
            this.cleanup();

            this.inherited(arguments);
        },

        adjustDialogPosition: function (dialog, resizeHandle) {
            if (this._resizeObserver) {
                this._resizeObserver.disconnect();
            }

            resizeHandle = resizeHandle || this._resizeHandle;
            this._resizeObserver = new ResizeObserver(function () {
                resizeHandle(dialog);
            });
            this._resizeObserver.observe(dialog.domNode);
        },

        _resizeHandle: function (dialog) {
            if (!dialog.domNode) {
                return;
            }
            var dialogSize = dialog.domNode.getBoundingClientRect();
            dialog.domNode.style.top = Math.round(window.innerHeight - dialogSize.height - 10) / 2 + "px";
        },

        cleanup: function () {
            if (this._resizeObserver) {
                this._resizeObserver.disconnect();
                this._resizeObserver = null;
            }
        }
    });
});

},
'epi-cms/contentediting/_ContextualContentContextMixin':function(){
// We need to disable eqeqeq in this file because we need to do == comparisons because some components are sending the ids as int and some as strings
/*eslint eqeqeq:0*/

define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",

    "dojo/when",
    // epi
    "epi-cms/_ContentContextMixin",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/PseudoContextualCommandDecorator",
    "epi-cms/core/ContentReference"
],

function (
// dojo
    array,
    declare,
    Deferred,
    lang,

    when,
    // epi
    _ContentContextMixin,
    TypeDescriptorManager,

    // EPi CMS
    ApplicationSettings,
    PseudoContextualCommandDecorator,
    ContentReference) {

    return declare([_ContentContextMixin], {
        // summary:
        //      Provides stubs to interacts with contextual content of the current context.
        // tags:
        //      public

        // _commandDecorator: [private] "epi-cms/contentediting/PseudoContextualCommandDecorator"
        //      Decorates commands for a pseudo contextual content
        _commandDecorator: null,

        // =======================================================================
        // Public overrided functions

        postscript: function () {

            this.inherited(arguments);

            this._commandDecorator = this._commandDecorator || new PseudoContextualCommandDecorator();
        },

        destroy: function () {

            this._commandDecorator && this._commandDecorator.destroy();

            this.inherited(arguments);
        },

        // =======================================================================
        // Public functions

        isTypeOfRoot: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //      Checks to see if the item is type of root node such as: root, sub root, context root
            // contentItem: [dojo/data/Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public, extension

            var inherited = this.inherited(arguments),
                isContextualRoot = this.isContextualContent(contentItem);

            return inherited != null ? !!(inherited || isContextualRoot) : !!(contentItem && isContextualRoot);
        },

        isContextualContent: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //      Verifies the given content item data is contextual or not
            // contentItem: [dojo/data/Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            return this.isContextualRoot(contentItem) || this.isPseudoContextualRoot(contentItem);
        },

        isContextualRoot: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //      Checks to see the given data item object is contextual root or not
            // contentItem: [dojo/data/Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            return contentItem.parentLink == this._getPseudoContextualContent();
        },

        isPseudoContextualRoot: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //      Checks to see if the item is a pseudo contextual content
            // contentItem: [dojo/data/Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            var contentReference = ContentReference.toContentReference(contentItem.contentLink);
            return !contentReference.providerName && contentReference.id == this._getPseudoContextualContent();
        },

        hasContextual: function (/*Array*/contentAncestors) {
            // summary:
            //      Verifies the given tree node has a ancestor is contextual or not
            // contentAncestors: [Array]
            //      A collection of "dijit/_TreeNode" item object (dojo/data/Item) that are ancestors of the given selected content
            // returns: [Boolean]
            // tags:
            //      public

            if (!(contentAncestors instanceof Array) || contentAncestors.length <= 0) {
                return false;
            }

            return array.some(contentAncestors, this.isContextualContent, this);
        },

        canHaveContextualContent: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //      Verifies the given object allowed to show contextual content or not
            // contentItem: [dojo/data/Item]
            //      Content item data object
            // returns: [Boolean]
            // tags:
            //      public

            var contentReference = ContentReference.toContentReference(contentItem.contentLink);
            return !array.some(this.notSupportContextualContents, function (id) {
                return !contentReference.providerName && contentReference.id == id;
            });
        },

        getContextualRoot: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //      Get contextual content from the given content item data
            // contentItem: [dojo/data/Item]
            //      Content item data object
            // returns: [dojo/data/Item]
            //      A clone object that acts as a contextual content (local content assets folder for the current content context)
            // tags:
            //      public

            if (typeof contentItem !== "object") {
                return null;
            }

            var modifiedItem = lang.clone(contentItem);

            // Change the original name of the content (in this case is "Content Assets" root folder) based on the current content context's type identifier
            // Will be (core content data types):
            //      "For This Page" for the "episerver.core.pagedata" type identifier
            //      "For This Block" for the "episerver.core.blockdata" type identifier
            //      "For This {0}" if the given type identifier not found
            modifiedItem.name = this.getContextualRootName(modifiedItem);

            // Set "hasChildren" property to FALSE in order to hides collapsed icon for pseudo contextual content.
            if (this.isPseudoContextualRoot(modifiedItem)) {
                modifiedItem.hasChildren = false;
            }

            return modifiedItem;
        },

        getContextualRootName: function (/*dojo/data/Item?*/contentItem) {
            // summary:
            //      Get contextual root name based on the current content context data type.
            // contentItem: [dojo/data/Item?]
            //      Content item data object
            // returns: [String]
            //      "For This Page" for the "episerver.core.pagedata" type
            //      "For This Block" for the "episerver.core.blockdata" type
            //      "For This {0}" if the given type identifier not found
            // tags:
            //      public

            var ownerTypeIdentifier = contentItem && contentItem.ownerTypeIdentifier,
                typeIdentifier = ownerTypeIdentifier || (this._currentContext && this._currentContext.dataType) || "",
                typeName = TypeDescriptorManager.getResourceValue(typeIdentifier, "name", true);

            var label =  TypeDescriptorManager.getResourceValue(typeIdentifier, "forthis", false);

            return typeName ? lang.replace(label, [typeName]) : label;
        },

        decoratePseudoContextualCommands: function (/*Arrays*/commands) {
            // summary:
            //      Converts the given commands to work in case pseudo contextual content
            // commands: [Array]
            //      A collection of object that is instance of "epi/shell/command/_Command" class
            // tags:
            //      public

            when(this.getCurrentContent()).then(lang.hitch(this, function (contentItem) {
                this._commandDecorator.decorateCommands(commands, contentItem, /*pseudoContextualRootFilter*/lang.hitch(this, this.isPseudoContextualRoot));
            })).otherwise(function () {});
        },

        getCurrentContent: function () {
            // summary:
            //      Returns either the current content or a deferred which will resolve a content data as soon as it becomes available.
            // tags:
            //      protected

            if (this.isInQuickEditMode && this.contentDataStore) {
                if (this._currentContext && this._currentContext.id === this.quickEditBlockId) {
                    var deferred = new Deferred();
                    deferred.resolve(this._currentContext);
                    return deferred.promise;
                }
                return when(this.contentDataStore.get(parseInt(this.quickEditBlockId))).then(function (content) {
                    //this._currentContext = content;
                    return content;
                }.bind(this));
            }
            return this.inherited(arguments);
        },

        // =======================================================================
        // Protected functions

        _getPseudoContextualContent: function () {
            // summary:
            //      Get pseudo contextual content
            // returns: [Integer]
            //      The content link
            // tags:
            //      protected

            return ApplicationSettings.contentAssetsFolder;
        }

    });

});

},
'epi-cms/contentediting/PseudoContextualCommandDecorator':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    // epi
    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin"
],

function (
// dojo
    array,
    declare,
    lang,

    aspect,
    // epi
    _Command,
    _ClipboardCommandMixin,
    _SelectionCommandMixin
) {

    return declare(null, {
        // summary:
        //      Decorates commands for a pseudo contextual content
        // tags:
        //      internal

        // =======================================================================
        // Public functions

        destroy: function () {

            this._clearContextualCommandHandlers();
        },

        decorateCommands: function (/*Arrays*/commands, /*dojo/data/Item*/newModel, /*Function?*/pseudoContextualRootFilter) {
            // summary:
            //      Converts the given commands to work in case pseudo contextual content
            // commands: [Array]
            //      A collection of object that is instance of "epi/shell/command/_Command" class
            // newModel: [dojo/data/Item]
            // pseudoContextualRootFilter: [Function?]
            //      Command filter function
            // tags:
            //      public

            this._clearContextualCommandHandlers();

            if (!(commands instanceof Array) || commands.length <= 0 || typeof newModel !== "object") {
                return;
            }

            this._decorateCommands(commands, newModel, pseudoContextualRootFilter);
        },

        // =======================================================================
        // Private functions

        _decorateCommands: function (/*Arrays*/commands, /*dojo/data/Item*/newModel, /*Function?*/pseudoContextualRootFilter) {
            // summary:
            //      Converts the given commands to work in case pseudo contextual content
            // commands: [Array]
            //      A collection of object that is instance of "epi/shell/command/_Command" class
            // newModel: [dojo/data/Item]
            // pseudoContextualRootFilter: [Function?]
            //      Command filter function
            // tags:
            //      public

            array.forEach(commands, function (command) {
                if (!this._isValidCommand(command)) {
                    return;
                }

                // Do nothing if the current selected item is a real contextual content
                if (typeof pseudoContextualRootFilter === "function" && !pseudoContextualRootFilter(this._getCommandModel(command))) {
                    return;
                }

                this._onAroundCommandExecute(command, newModel);
            }, this);
        },

        _getCommandModel: function (command) {
            // summary:
            //      Returns the commands model.
            // returns:
            //      The first item if the model is an array; otherwise just the model.
            // tags:
            //      private

            if (command.model && command.model instanceof Array) {
                if (command.model.length === 1) {
                    return command.model[0];
                }
                return null;
            }
            return command.isInstanceOf(_SelectionCommandMixin) ? command.get("selectionData") : command.model;
        },

        _onAroundCommandExecute: function (/*Object*/command, /*Object*/newModel) {
            // summary:
            //      Stub to do something before and after the execution of the given command object
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // newModel: [Object]
            //      An instance of "dojo/data/Item"
            // tags:
            //      private

            var self = this;
            self._contextualCommandHandlers.push(aspect.around(command, "execute", function (originalFunction) {
                return function () {
                    var originalData = self._decorateCommandBeforeExecute(command, newModel);

                    originalFunction.apply(command, arguments);

                    self._restoreCommandAfterExecute(command, originalData);
                };
            }));
        },

        _decorateCommandBeforeExecute: function (/*Object*/command, /*Object*/newModel) {
            // summary:
            //      Decorates the given command: marks it always TRUE for "canExecute", "isAvailable" and "createAsLocalAsset" flags
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // newModel: [Object]
            //      An instance of "dojo/data/Item"
            // returns: [Object] original command data
            //      Default data:
            //          createAsLocalAsset: [Boolean]
            //      Optional data:
            //          model: [Object]
            //          data: [Object]
            // tags:
            //      private

            var originalData = this._decorateCommand(command);

            if (this._isNormalCommand(command)) {
                lang.mixin(originalData, this._decorateNormalCommand(command, newModel));
            } else if (command.isInstanceOf(_SelectionCommandMixin)) {
                lang.mixin(originalData, this._decorateSelectionCommand(command, newModel));
            }

            command.set({
                canExecute: true,
                isAvailable: true,
                createAsLocalAsset: true
            });

            return originalData;
        },

        _decorateCommand: function (/*Object*/command) {
            // summary:
            //      Returns the original value for the createAsLocalAsset flag and unwatches the commands model watches
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // tags:
            //      private

            var originalData = {
                createAsLocalAsset: command.get("createAsLocalAsset")
            };

            command.isInstanceOf(_Command) && command.unwatchModelChange();
            command.isInstanceOf(_ClipboardCommandMixin) && command.unwatchClipboardChange();
            command.isInstanceOf(_SelectionCommandMixin) && command.unwatchSelectionChange();

            return originalData;
        },

        _decorateNormalCommand: function (/*Object*/command, /*Object*/newModel) {
            // summary:
            //      Replaces the model in the command with the specified newModel and returns an object with the original model
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // newModel: [Object]
            //      An instance of "dojo/data/Item"
            // returns: [Object] original command data
            //      model: [Object]
            // tags:
            //      private

            var originalData = {
                model: command.get("model")
            };

            command.set("model", newModel);

            return originalData;
        },

        _decorateSelectionCommand: function (/*Object*/command, /*Object*/newModel) {
            // summary:
            //      Replaces the selection data in the command with the specified newModel and returns an object with the original selection data.
            // command: [Object]
            //      An instance of "epi/shell/command/_SelectionCommandMixin"
            // newModel: [Object]
            //      An instance of "dojo/data/Item"
            // returns: [Object] original command data
            //      data: [Object]
            // tags:
            //      private

            var originalData = {
                data: command.get("selectionData")
            };

            // Selection command case
            // If the given command object is instance of "epi/shell/command/_Command" and had mixed-in "epi/shell/command/_SelectionCommandMixin"
            var model = command.get("model");
            if (model && typeof model.refreshRoots == "function") {
                command.onRefreshSelection = function () {
                    return model.refreshRoots();
                };
            }

            command.selection.set("data", [{
                data: newModel,
                type: command.get("selectionType")
            }]);

            return originalData;
        },

        _restoreCommandAfterExecute: function (/*Object*/command, /*Object*/originalData) {
            // summary:
            //      Stub to do something after execution of the given command object
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // originalData: [Object]
            // tags:
            //      private

            this._restoreCommand(command, originalData);

            if (this._isNormalCommand(command)) {
                this._restoreNormalCommand(command, originalData);

                return;
            }

            // _SelectionCommandMixin
            if (command.isInstanceOf(_SelectionCommandMixin)) {
                this._restoreSelectionCommand(command, originalData);
            }
        },

        _restoreCommand: function (/*Object*/command, originalData) {
            // summary:
            //      Restores the given command to its original states
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // tags:
            //      private

            command.set("createAsLocalAsset", originalData.createAsLocalAsset);

            command.isInstanceOf(_Command) && command.watchModelChange();
            command.isInstanceOf(_ClipboardCommandMixin) && command.watchClipboardChange();
            command.isInstanceOf(_SelectionCommandMixin) && command.watchSelectionChange();
        },

        _restoreNormalCommand: function (/*Object*/command, /*Object*/originalData) {
            // summary:
            //      Restores the given normal command to its original states
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // originalData: [Object]
            // tags:
            //      private

            command.set("model", originalData.model);
        },

        _restoreSelectionCommand: function (/*Object*/command, /*Object*/originalData) {
            // summary:
            //      Restores the given selection command to its original states
            // command: [Object]
            //      An instance of "epi/shell/command/_SelectionCommandMixin"
            // originalData: [Object]
            // tags:
            //      private

            command.selection.set("data", [{
                data: originalData.data,
                type: command.get("selectionType")
            }]);
        },

        _clearContextualCommandHandlers: function () {
            // summary:
            //      Clear all handlers for pseudo contextual content commands
            // tags:
            //      private

            if (this._contextualCommandHandlers instanceof Array && this._contextualCommandHandlers.length > 0) {
                array.forEach(this._contextualCommandHandlers, function (handler) {
                    typeof handler.remove === "function" && handler.remove();
                });
            }

            this._contextualCommandHandlers = [];
        },

        _isNormalCommand: function (/*Object*/command) {
            // summary:
            //      Verifies the given command object is normal command or not
            //      The given command must be an instance of "epi/shell/command/_Command" only
            // command: [Object]
            //      The given object to verifies
            // returns: [Boolean]
            // tags:
            //      private

            return !(command.isInstanceOf(_SelectionCommandMixin) || command.isInstanceOf(_ClipboardCommandMixin));
        },

        _isValidCommand: function (/*Object*/command) {
            // summary:
            //      Verifies the given object is instance of "epi/shell/command/_Command" class or not.
            //      In additional, the given command must have its model.
            // command: [Object]
            //      The given object to verifies
            // returns: [Boolean]
            // tags:
            //      private

            return !!(command && command.isInstanceOf(_Command) && this._getCommandModel(command));
        }

    });

});

},
'epi/shell/command/_ClipboardCommandMixin':function(){
﻿define("epi/shell/command/_ClipboardCommandMixin", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang"
],

function (
// dojo
    declare,
    lang
) {

    return declare(null, {
        // summary:
        //      Stub to handles content copy/paste for an instance of "epi/shell/command/_Command" object
        // tags:
        //      internal mixin


        // clipboard: [public] Object
        //      Hold information about copy/paste content
        clipboard: null,

        // =======================================================================
        // Public overrided functions

        postscript: function () {
            // summary:
            //      Register a watch hanlder when the command change its model
            //      Watch model and initialize model dependent properties.
            // tags:
            //      public overrides

            this.inherited(arguments);

            this.watchClipboardChange();
        },

        // =======================================================================
        // Public functions

        onRefreshClipboard: function () {
            // summary:
            //      Stub to do somethings when clipboard refreshed
            // tags:
            //      public callback
        },

        watchClipboardChange: function () {
            // summary:
            //      Register a watch hanlder when the command change its model
            // tags:
            //      public

            this._clipboardChangeWatcher = this.clipboard.watch("data", lang.hitch(this, this._onModelChange));
        },

        unwatchClipboardChange: function () {
            // summary:
            //      Clear the registered watch handler for command model change
            // tags:
            //      public

            this._clipboardChangeWatcher && this._clipboardChangeWatcher.unwatch();
        },

        // =======================================================================
        // Protected functions

        _clipboardDataGetter: function () {
            // summary:
            //      Return clipboard content item data
            // tags:
            //      protected

            return this._getClipboardData();
        },

        _clipboardTypeGetter: function () {
            // summary:
            //      Return clipboard content type
            // tags:
            //      protected

            return this._getClipboardData().type;
        },

        // =======================================================================
        // Private functions

        _getClipboardData: function () {
            // summary:
            //      Return clipboard data
            // tags:
            //      private

            if (!this.clipboard || !(this.clipboard.data instanceof Array)) {
                return null;
            }

            return this.clipboard.data;
        }

    });

});

},
'epi/shell/command/_SelectionCommandMixin':function(){
﻿define("epi/shell/command/_SelectionCommandMixin", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang"
],

function (
// dojo
    declare,
    lang
) {

    return declare(null, {
        // summary:
        //      Stub to handle selection content for an instance of "epi/shell/command/_Command" object
        // tags:
        //      internal xproduct mixin

        // selection: [public] Object
        //      Hold information about selected content
        selection: null,

        // =======================================================================
        // Public overridden functions

        postscript: function () {
            // summary:
            //      Register a watch handler when the command change its model
            //      Watch model and initialize model dependent properties.
            // tags:
            //      public

            this.inherited(arguments);

            this.watchSelectionChange();
        },

        // =======================================================================
        // Public functions

        onRefreshSelection: function () {
            // summary:
            //      Stub to do somethings when selection refreshed
            // tags:
            //      public callback
        },

        watchSelectionChange: function () {
            // summary:
            //      Register a watch handler when the command change its model
            // tags:
            //      public

            this._selectionChangeWatcher = this.selection.watch("data", lang.hitch(this, this._onModelChange));
        },

        unwatchSelectionChange: function () {
            // summary:
            //      Clear the registered watch handler for command model change
            // tags:
            //      public

            this._selectionChangeWatcher && this._selectionChangeWatcher.unwatch();
        },

        // =======================================================================
        // Protected functions

        _getSingleSelectionData: function () {
            // summary:
            //      Returns the selected item if only one is selected otherwise null;
            // tags:
            //      protected

            var target = this._getSelectionData();

            return target && (this.selection.data.length === 1) ? target.data : null;
        },

        _selectionDataGetter: function () {
            // summary:
            //      Return selection content item data
            // tags:
            //      protected

            var selectionData = this._getSelectionData();
            return selectionData && selectionData.type === "epi.cms.contentdata" ? selectionData.data : null;
        },

        _selectionTypeGetter: function () {
            // summary:
            //      Return selection type
            // tags:
            //      protected

            return this._getSelectionData().type;
        },

        // =======================================================================
        // Private functions

        _getSelectionData: function () {
            // summary:
            //      Return the selection data for the first item selected
            // tags:
            //      private

            if (!this.selection || !(this.selection.data instanceof Array)) {
                return null;
            }

            return this.selection.data[0];
        }
    });

});

},
'epi-cms/widget/ContentSelectorDialog':function(){
define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-geometry",
    "dojo/when",

    // Dijit
    "dijit/layout/_LayoutWidget",

    // EPi
    "epi",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/ApplicationSettings",
    "epi-cms/widget/ContentTree",
    "epi-cms/widget/ContextualContentForestStoreModel",
    "epi-cms/widget/SearchBox",
    "epi-cms/component/_ContentNavigationTreeNode",

    // EPi Framework
    "epi/shell/widget/_ActionProviderWidget",
    "epi/dependency",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentselectordialog"
],

function (
// Dojo
    array,
    declare,
    lang,
    domGeometry,
    when,

    // Dijit
    _LayoutWidget,

    // EPi
    epi,
    TypeDescriptorManager,

    ApplicationSettings,
    ContentTree,
    ContextualContentForestStoreModel,
    SearchBox,
    _ContentNavigationTreeNode,

    // EPi Framework
    _ActionProviderWidget,
    dependency,

    // Resources
    localization
) {

    return declare([_LayoutWidget, _ActionProviderWidget], {
        // summary:
        //    Content selector widget.
        //
        // description:
        //    Used for editing PropertyPage properties in fly-out editor.
        //
        // tags:
        //    internal xproduct

        // _contentRef: [private] epi-cms/core/ContentReference
        //    Reference to the currently selected content.
        _contentRef: null,

        // res: [private] Object
        //    Resource bundle.
        res: localization,

        baseClass: "epi-content-selector-dialog",

        // roots: [public] Array
        //    A list of references to the root contents.
        roots: null,

        // typeIdentifiers: [public] Array | String
        //    Type identifiers to filter.
        typeIdentifiers: null,

        showButtons: true,

        // selectedContentReference: epi.cms.core.ContentReference
        //      Currently selected content reference
        selectedContentReference: null,

        model: null,

        // allowedTypes: String[]
        //      An array of types that should be selectable
        allowedTypes: null,

        // restrictedTypes: String[]
        //      An array of types that not should be selectable
        restrictedTypes: null,

        // canSelectOwnerContent: [private] Boolean
        //    Indicates whether select current owner content button should be available.
        canSelectOwnerContent: true,

        // multiRootsMode: [public] Boolean
        //      Indicate that multiple roots enabled in the tree or not
        multiRootsMode: false,

        _typesToDisplay: null,

        // showAllLanguages: Boolean
        //      Flags to indicate that the content tree should show all content in multiple languages or not.
        showAllLanguages: false,

        // selectedContentType: String
        //      The content type which is selected. (used when restore content for instance)
        selectedContentType: null,

        // showSearchBox: Boolean
        //      If true - a search field is displayed that allows user to find content
        showSearchBox: true,

        // searchArea: String
        //      Search area for the search box.
        searchArea: null,

        _searchBox: null,

        buildRendering: function () {
            this.inherited(arguments);

            var typeIdentifiers = this._getTypesToDisplay(),
                model = this.model,
                roots = this.roots || (model && model.roots);

            this.preventContextualContentFor = this.preventContextualContentFor || this._getSettingFromContentType();
            if (!model || this.showContextualContent) {
                model = new ContextualContentForestStoreModel({
                    roots: roots,
                    selectedContentReference: this.selectedContentReference,
                    typeIdentifiers: typeIdentifiers,
                    notSupportContextualContents: this.preventContextualContentFor,
                    showAllLanguages: this.showAllLanguages,
                    additionalQueryOptions: {
                        sort: {}
                    }
                });
            }

            model.set("view", "contentselector");

            if (this.showSearchBox && this.searchArea) {
                this._searchBox = new SearchBox({
                    innerSearchBoxClass: "epi-search--full-width",
                    triggerContextChange: false,
                    parameters: {
                        allowedTypes: this.allowedTypes,
                        restrictedTypes: this.restrictedTypes
                    },
                    onItemAction: lang.hitch(this, function (item) {
                        if (item && item.metadata && this._checkAcceptance(item.metadata.typeIdentifier, item.metadata.contentTypeId)) {
                            this.set("value", item.metadata.id);
                            this.onSearchResultSelected(item.metadata.id);
                        }
                    })
                });
                this._searchBox.set("area", this.searchArea);
                this._searchBox.set("searchRoots", this.roots);

                var searchBox = this._searchBox;
                model.getRoots(true).then(function (roots) {
                    searchBox.set("searchRoots", roots.join(","));
                });

                this.addChild(this._searchBox);
            }

            this.tree = new ContentTree({
                roots: roots,
                typeIdentifiers: typeIdentifiers,
                allowManipulation: false,
                model: model,
                allowedTypes: lang.clone(this.allowedTypes),
                restrictedTypes: lang.clone(this.restrictedTypes),
                disableRestrictedTypes: true,
                expandExtraNodeItems: ApplicationSettings.startPage, // Set extra node items to expand when the given tree loaded
                nodeConstructor: _ContentNavigationTreeNode,
                hasContextMenu: false,
                propertyName: this.propertyName
            });
            this.addChild(this.tree);

            this.connect(this.tree, "onClick", "_onTreeNodeClick");

            this.domNode.classList.add("epi-navigation");
        },

        layout: function () {
            this.inherited(arguments);

            var treeHeight = this._contentBox.h;

            //Subtract the height of the searchBox if it is created
            if (this._searchBox) {
                treeHeight -= domGeometry.getMarginBox(this._searchBox.domNode).h;
            }

            //Get the margin box for the tree and change the height
            var treeMarginBox = domGeometry.getMarginBox(this.tree.domNode);
            treeMarginBox.h = treeHeight;

            domGeometry.setMarginBox(this.tree.domNode, treeMarginBox);
        },

        _getSettingFromContentType: function () {
            // summary:
            //      Get preventContextualContentFor settings form selected content type
            // tags:
            //      private

            if (!this.selectedContentType) {
                return null;
            }
            var contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");

            var repositoryDescriptor,
                matchType = function (type) {
                    return TypeDescriptorManager.isBaseTypeIdentifier(this.selectedContentType, type);
                };
            for (var index in contentRepositoryDescriptors) {
                var descriptor = contentRepositoryDescriptors[index];
                if (array.some(descriptor.containedTypes, matchType, this)) {
                    repositoryDescriptor = descriptor;
                    break;
                }
            }

            return repositoryDescriptor.preventContextualContentFor;
        },

        _getTypesToDisplay: function () {
            if (!this._typesToDisplay) {

                var typesToDisplay = [];
                this._getContainerTypesRecursive(this.allowedTypes, typesToDisplay);
                this._typesToDisplay = typesToDisplay;
            }

            return this._typesToDisplay;
        },

        _getContainerTypesRecursive: function (types, results, checkedTypes) {
            if (!checkedTypes) {
                checkedTypes = [];
            }

            array.forEach(types, lang.hitch(this, function (type) {
                // To avoid infinite recursion, check if this type is already processed
                if (array.indexOf(checkedTypes, type) === -1) {
                    // Mark as checked
                    checkedTypes.push(type);

                    // Add the type itself if it isn't added already
                    if (array.indexOf(results, type) === -1) {
                        results.push(type);
                    }

                    // If there are any container types, process them as well
                    var containerTypesForType = TypeDescriptorManager.getValue(type, "containerTypes");

                    if (containerTypesForType) {
                        this._getContainerTypesRecursive(containerTypesForType, results, checkedTypes);
                    }
                }
            }));
        },

        _setValueAttr: function (value) {
            //summary:
            //    Value's setter.
            //
            // value: String
            //    Value to be set.
            //
            // tags:
            //    protected

            //construct ContentReference object
            if (value) {
                this._contentRef = value;
                var contentLinkToSelect = this._contentRef === "-" ? null : this._contentRef;

                if (this.multiRootsMode) {
                    // We need to wait until tree load top level children and then fire onLoad() event
                    when(this.tree.onLoadDeferred, lang.hitch(this, function () {
                        this.tree.selectContent(contentLinkToSelect, true);
                    }));
                } else {
                    if (!epi.isEmpty(contentLinkToSelect)) {
                        this.tree.selectContent(contentLinkToSelect, true);
                    }
                }
            } else {
                this._contentRef = null;
                this._clearSelectedContent();
            }
        },

        _getValueAttr: function () {
            //summary:
            //    Value's getter
            // tags:
            //    protected

            this.inherited(arguments);

            if (this._contentRef) {
                return this._contentRef.toString();
            } else {
                return "";
            }
        },

        _setAllowedTypesAttr: function (value) {
            this._typesToDisplay = null;
            this._set("allowedTypes", value);
        },

        _clearSelectedContent: function () {
            // summary:
            //      Clear selected node(s) in tree
            // tags:
            //      private

            this.tree.set("selectedNodes", []);
            this.tree.set("selectedItems", []);
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current owner content action added to the containing widget
            //
            // returns:
            //      An array containing a select page action definition, if it is not a shared block

            return this.canSelectOwnerContent ? [
                {
                    name: "selectpage",
                    label: localization.currentpage,
                    settings: { type: "submit", "class": "epi-outlined-button" },
                    action: lang.hitch(this, function () {
                        this._setValueOwnerContent();
                    })
                }
            ]
                : [];
        },

        _onTreeNodeClick: function (content) {
            // summary:
            //    Handle the inner tree's content change event.
            //
            // content: Object
            //    The content object.
            //
            // tags:
            //    private

            var value = content.contentLink;

            if (!this._checkAcceptance(content.typeIdentifier, content.contentTypeID)) {
                this.tree.lastFocused.setSelected(false);
                value = null;
            }

            this.set("value", value);
            this.onChange(this.get("value"));
        },

        _checkAcceptance: function (typeIdentifier, contentTypeId) {
            // summary:
            //    Compares a type against arrays of allowed and restricted types
            //
            // typeIdentifier: String
            //    The type to check if it's accepted to use
            //
            // tags:
            //    protected

            var acceptedTypes = TypeDescriptorManager.getValidAcceptedTypes([typeIdentifier, contentTypeId], this.allowedTypes, this.restrictedTypes);

            return !!acceptedTypes.length;

        },

        _setValueOwnerContent: function () {
            this.set("value", "-");
        },

        onChange: function (contentLink) {
            // summary:
            //    Fired when value is changed.
            //
            // contentLink:
            //    The content link
            // tags:
            //    public, callback
        },

        onSearchResultSelected: function (contentLink) {
            // summary:
            //    Fired when search result is clicked.
            //
            // contentLink:
            //    The content link
            // tags:
            //    public, callback
        },

        focus: function () {
            this.tree.focus();
        }

    });

});

},
'epi-cms/widget/ContentTree':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/connect", // To use isCopyKey()
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/Evented",

    "dojo/keys",
    "dojo/promise/all",
    "dojo/query",
    "dojo/sniff",
    "dojo/when",
    "dijit/registry",
    // epi
    "epi/dependency",
    "epi/shell/DestroyableByKey",
    "epi/shell/dnd/tree/dndSource",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/Tree",

    "epi-cms/core/ContentReference",
    "epi-cms/dgrid/formatters",
    "epi-cms/widget/_ContentTreeNode",
    "epi-cms/widget/ContentTreeModelConfirmation",
    "epi-cms/widget/ContentForestStoreModel"
],

function (
// dojo
    array,
    connect, // To use isCopyKey()
    declare,
    lang,

    domClass,
    domStyle,

    aspect,
    Deferred,
    Evented,

    keys,
    promiseAll,
    query,
    sniff,
    when,
    registry,
    // epi
    dependency,
    DestroyableByKey,
    dndSource,
    TypeDescriptorManager,
    Tree,

    ContentReference,
    formatters,

    _ContentTreeNode,
    ContentTreeModelConfirmation,
    ContentForestStoreModel
) {

    return declare([Tree, Evented, DestroyableByKey], {
        // summary:
        //      The EPiServer content tree.
        // description:
        //      The page tree shows the EPiServer CMS page tree using a REST store to fetch the data.
        // tags:
        //      internal

        // roots: Array
        //      A list of references to the root nodes.
        roots: null,

        // expandExtraNodeItems: [public] Array|Integer
        //      A collection of content item id or one content item id need to expand by default.
        expandExtraNodeItems: null,

        // nodeConstructor: Function
        //      Tree node constructor. It should be a sub class of dijit/Tree/_TreeNode
        nodeConstructor: null,

        // typeIdentifiers: String | Array
        //      Type identifier  filter.
        typeIdentifiers: null,

        // allowManipulation: Boolean
        //      Denotes if node manipulation is allowed.
        allowManipulation: true,

        // persist: Boolean
        //      Enables/disables use of cookies for state saving.
        persist: false,

        // expandOnDnd: [public] Boolean
        //      Enables/disables expand on a tree node when Dnd over it.
        expandOnDnd: true,

        // showRoot: [public] Boolean
        //      Flag that indicates whether the the root node should be displayed.
        showRoot: false,

        // handleSelection: [public] Boolean
        //      Flag that indicates this tree need to reset selection each time it had refresh
        handleSelection: false,

        // disableRestrictedTypes: [public] Boolean
        //      Flag that indicates this tree must apply disable style for the node which are not selectable based on provided allowedTypes.
        disableRestrictedTypes: false,

        // dndSource: [public] dndSource
        //      The dnd source to use for the tree, if no one is specified the epi/shell/dnd/tree/dndSource will be used
        dndSource: null,

        // hasContextMenu [internal] Boolean | null
        //      Determinate if context menu is available
        hasContextMenu: null,

        postMixInProperties: function () {
            // summary:
            //      Post mixin initializations.
            // tags:
            //      protected

            this.inherited(arguments);

            if (!this.model) {
                this.model = this._createTreeModel();
            }
            this.own(this.model);

            if (this.allowManipulation) {
                this.dndController = this.dndSource || dndSource;

                //We allow dropping all types contained in the content repository, even if it's not displayed in the tree.
                this.accept = this.model.containedTypes || this.containedTypes;
            }

            // make sure these get called with this class as context
            // otherwise context will be the dndController for the tree
            this.checkItemAcceptance = lang.hitch(this, this.checkItemAcceptance);

            this.nodeConstructor = this.nodeConstructor || _ContentTreeNode;

            this.own(aspect.around(this.model, "pasteItems", this._aroundPasteItem.bind(this)));

            // we don't want to disable folders
            if (this.allowedTypes) {
                var contentFolderAdded = array.some(this.allowedTypes, function (item) {
                    return item === "episerver.core.contentfolder";
                });

                if (!contentFolderAdded) {
                    this.allowedTypes.push("episerver.core.contentfolder");
                }
            }
        },

        getItemType: function (item) {
            // summary:
            //      Resolve the type for each item. Called by the dnd source.

            return TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");
        },

        buildRendering: function () {
            // Wrap the model before build rendering
            this.model = this._wrapModel(this.model);

            this.inherited(arguments);
        },

        _wrapModel: function (model) {
            // summary:
            //      Wraps the model with a confirmation
            // tags:
            //      protected
            return ContentTreeModelConfirmation(this.model);
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(
                this.connect(this.model, "onSelect", lang.hitch(this, this._onSelect)),
                aspect.before(this.model, "onToggleContentDisplay", lang.hitch(this, function (/*String*/target, /*Boolean*/display) {
                    var targetContent = this.getNodesByItem(target)[0];
                    if (targetContent) {
                        domStyle.set(targetContent.domNode, {
                            display: display === true ? "" : "none"
                        });
                    }
                }))
            );
        },

        onLoad: function () {
            // summary:
            //      Called when tree has finished loading and expanding.
            // tags:
            //      protected

            this.inherited(arguments);

            return when(this._expandRootNodes(), lang.hitch(this, this._expandExtraNodes));
        },

        _expandRootNodes: function () {
            // summary:
            //      Expand the root nodes by default
            // tags:
            //      private

            // Expand the root nodes by default.
            var nodes = this.showRoot ? [this.rootNode] : this.rootNode.getChildren();
            return promiseAll(array.map(nodes, this.tree._expandNode, this));
        },

        _expandExtraNodes: function () {
            // summary:
            //      Expand the given extra nodes by default
            // tags:
            //      private

            if (!this.expandExtraNodeItems) {
                return;
            }

            var expandExtraNodeItems = this.expandExtraNodeItems instanceof Array ? this.expandExtraNodeItems : [this.expandExtraNodeItems];

            var extraNodes = array.map(expandExtraNodeItems, function (item) {
                return this.tree.getNodesByItem(item)[0];
            }, this);

            // Filter out empty node from the given array.
            extraNodes = array.filter(extraNodes, Boolean);

            return promiseAll(array.map(extraNodes, this.tree._expandNode, this));
        },

        _aroundPasteItem: function (originalPasteItems) {
            // summary:
            //      Paste item wrapper that marks the target node as processing while the paste is
            //      being executed on the server
            // tags:
            //      private

            return function (sourceItems, targetItem) {
                if (targetItem.isWastebasket) {
                    // wast basket is not in tree and it's not expandable
                    return originalPasteItems.apply(this.model, arguments);
                }

                var targetNode = this.get("selectedNode");
                // If we for some reason don't have a selected treeNode (UI)
                // we still want to try to paste the item
                if (!targetNode) {
                    return originalPasteItems.apply(this.model, arguments);
                }

                targetNode.markProcessing();
                return originalPasteItems.apply(this.model, arguments)
                    .then(function () {
                        if (!targetNode.isExpanded) {
                            targetNode.expand();
                        }
                    }).always(function () {
                        targetNode.unmarkProcessing();
                    });
            }.bind(this);
        },

        // gets propagated to dndSource
        checkItemAcceptance: function (targetNode, source, position) {
            // summary:
            //      Called from DnD to check if a specific target can accept the items in source

            var targetTreeNode = registry.getEnclosingWidget(targetNode),
                target = targetTreeNode && targetTreeNode.item;

            if (!target) {
                return false;
            }

            return this.model.checkItemAcceptance(target, source);
        },

        _setAllowManipulationAttr: function (value) {
            // summary:
            //      setter of allowManipulation property.
            // tags:
            //      private

            this._set("allowManipulation", value);

            if (value) {
                this.dndController = this.dndSource || dndSource;
            }
        },

        _createTreeModel: function () {
            // summary:
            //      Create content tree model
            // tags:
            //      protected

            return new ContentForestStoreModel({
                roots: this.roots,
                typeIdentifiers: this.typeIdentifiers
            });
        },

        _onItemDelete: function (/*Item*/item, /*boolean*/deleteChildren) {
            // summary:
            //      Override of dijit/Tree._onItemDelete to enable cleaning
            //      of the itemsNodeMap from children of the item being deleted.
            // tags:
            //      protected, override

            function flattenChildHierarchy(node, children) {
                array.forEach(node.getChildren(), function (child) {
                    children.push(child.item);
                    flattenChildHierarchy(child, children);
                });

                return children;
            }

            if (deleteChildren) {
                var treeNodes = this._itemNodesMap[this.model.getIdentity(item)];
                if (treeNodes) {
                    array.forEach(treeNodes, function (treeNode) {
                        array.forEach(flattenChildHierarchy(treeNode, []).reverse(), function (childItem) {
                            this._onItemDelete(childItem);
                        }, this);
                    }, this);
                }
            }

            this.inherited(arguments);
        },

        _setTypeIdentifiersAttr: function (value) {
            this._set("typeIdentifiers", value);

            if (this.model) {
                this.model.typeIdentifiers = value;
            }
        },

        _setPropertyNameAttr: function (value) {
            this._set("propertyName", value);

            if (this.model) {
                this.model.propertyName = value;
            }
        },

        getTooltip: function (item) {

            // summary:
            //		Overridden to select data for the tooltip
            // tags:
            //		public, extension
            var getter = this.model.getTooltip || this.model.getLabel;
            var reference = new ContentReference(item.contentLink),
                baseTooltip = getter ? getter(item) : this.inherited(arguments);

            return baseTooltip ? formatters.title(baseTooltip, reference.id, item.contentTypeName) : baseTooltip;

        },

        buildNodeFromTemplate: function (args) {
            // summary:
            //      Build tree node from the given template.
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            return new this.nodeConstructor(args);
        },

        _createTreeNode: function (/*Object*/args) {
            // summary:
            //      Overridable function to make tree node draggable after creation
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            var params = lang.mixin({}, args, {
                dndData: args.item
            });

            if (this.hasContextMenu !== null) {
                params.hasContextMenu = this.hasContextMenu;
            }

            return this.buildNodeFromTemplate(params);
        },

        getIconClass: function (/*dojo/data/Item*/item, /*Boolean*/opened) {
            // summary:
            //      Overridable function to return CSS class name to display icon
            // tags:
            //      extension

            if (!item) {
                return this.inherited(arguments);
            }

            var iconNodeClass = TypeDescriptorManager.getValue(item.typeIdentifier, "iconClass");
            if (this.model.isTypeOfRoot(item)) {
                return this.model.getObjectIconClass(item, iconNodeClass);
            }

            var supportsOpenCssClass = TypeDescriptorManager.getValue(item.typeIdentifier, "supportsOpenCssClass");

            if (opened && !item.isSubRoot && supportsOpenCssClass) {
                iconNodeClass = iconNodeClass + "Open";
            }

            return iconNodeClass + this._getItemDisableStyle(item);
        },

        getLabelClass: function (item, expanded) {
            // summary:
            //      Overridable function to return CSS class name to display node label
            // tags:
            //      extension

            return this._getItemDisableStyle(item);
        },

        focus: function () {
            // summary:
            //      Set focus to the widget.
            // tags:
            //      public

            this.focusNode(this.get("selectedNode") || this.rootNode);
        },

        _getItemDisableStyle: function (/* dojo/data/Item */item) {
            // summary:
            //      Returns the disabled style/css class for the given item only if disableRestrictedTypes is enabled and item is not part of allowedTypes
            // item:
            //      dojo/data/Item
            // tags:
            //      private

            if (this.disableRestrictedTypes) {
                return this._isItemRestricted(item) ? " is-disabled " : "";
            }

            return "";
        },

        _isItemRestricted: function (/* dojo/data/Item */item) {
            // summary:
            //      Checks whether the given item is restricted based on the allowedTypes
            // item:
            //      dojo/data/Item
            // tags:
            //      private

            var acceptedTypes = TypeDescriptorManager.getValidAcceptedTypes([item.typeIdentifier, item.contentTypeID], this.allowedTypes, this.restrictedTypes);

            return !acceptedTypes.length;
        },

        _getTargetPath: function (/*String*/targetContent) {
            // summary:
            //      Get target content path
            // targetContent:
            //      Target content identity
            // tags:
            //      private

            var model = this.model,
                deferred = new Deferred();

            model.getAncestors(targetContent, function (ancestors) {
                // Path should include the target content, so push it onto the array for conversion.
                ancestors.push(targetContent);

                var targetPath = array.map(ancestors, function (item) {
                    return model.getIdentity(item).toString();
                });

                if (typeof model.filterAncestors === "function") {
                    targetPath = model.filterAncestors(targetPath);
                }

                deferred.resolve(targetPath);
            });

            return deferred.promise;
        },

        _isValidTargetContent: function (/*String*/content) {
            // summary:
            //      Validate target content before using
            // tags:
            //      private

            if (!content) {
                return false;
            }

            return !content.isDeleted && !content.isWastebasket;
        },

        _onSelect: function (id, setFocus, onComplete) {
            // summary:
            //      Raise event to set an item as selected
            // tags:
            //      private

            var selectedNode = this.get("selectedNode");
            this.tree.model.set("previousContextualSelection", {
                selectedContent: selectedNode
            });

            this.selectContent(id, setFocus, true, onComplete).then(lang.hitch(this, function () {
                selectedNode = this.get("selectedNode");
                if (selectedNode && selectedNode.item && selectedNode.item.contentLink) {
                    this.emit("select", selectedNode.item, selectedNode);
                }
            }));
        },

        selectContent: function (contentReferenceAsString, setFocus, needParentRefresh, onComplete) {
            // summary:
            //      Select a given page.
            // return: a <c href="dojo/Deferred" /> object which when it resolves will return pageName
            // tags:
            //      public

            var self = this,
                model = self.model,
                deferred = new Deferred(),
                setPaths = function (paths) {
                    self._preparePathNodes(paths);
                    self._setRecursivePaths(paths, deferred, setFocus, onComplete);
                };

            when(model.store.get(contentReferenceAsString), function (content) {
                if (!self._isValidTargetContent(content)) {
                    // Remark: Is this needed any more?
                    self.set("paths", []);
                    deferred.resolve(null);
                } else {
                    self._getTargetPath(content).then(function (targetPath) {
                        self._onSetTargetPath();
                        setPaths(targetPath);
                    });
                }
            });

            return deferred.promise;
        },

        _onSetTargetPath: function () {
            // summary:
            //      Handles selection when set target path for the tree.
            // tags:
            //      private

            if (!this.handleSelection) {
                return;
            }

            var selectedNode = this.get("selectedNode");
            if (selectedNode) {
                // Get selected node one more time by getNodesByItem() function
                // in order to ensures that the node is existing in the tree.
                selectedNode = this.getNodesByItem(selectedNode.item)[0];
                if (selectedNode) {
                    this.model.set("previousSelection", {
                        selectedContent: selectedNode,
                        selectedAncestors: selectedNode.getTreePath()
                    });
                }
            }
        },

        _preparePathNodes: function (paths) {
            // summary:
            //      Prepare steps before node selection in the tree
            // tags:
            //      protected, extension
        },

        _setRecursivePaths: function (paths, deferred, setFocus, onComplete) {
            if (!paths || paths.length === 0) {
                return;
            }

            this.set("paths", [paths]).then(lang.hitch(this, function () {
                var selectedNode = this.get("selectedNode");
                if (!selectedNode) {
                    // We didn't find a node to select. Remove the last node in the path and try again.
                    this._setRecursivePaths(paths.slice(0, -1), deferred, setFocus, onComplete);

                    return;
                }

                if (setFocus) {
                    this.focus();
                }

                if (onComplete) {
                    onComplete(selectedNode);
                }

                deferred.resolve(selectedNode);
            }, deferred.reject));
        },

        _onKeyDown: function (item, e) {
            // summary:
            //      Handles onKeyDown event to process cut, copy, paste, delete action (non-printable characters).
            // e:
            //      Event object
            // tags:
            //      private

            this.inherited(arguments);

            if (!this.allowManipulation) {
                return;
            }

            if (connect.isCopyKey(e)) {
                var character = e.keyCode ? String.fromCharCode(e.keyCode).toLowerCase() : "";
                switch (character) {
                    case "c":
                        this.emit("copyOrCut", true);
                        break;
                    case "x":
                        this.emit("copyOrCut", false);
                        break;
                    case "v":
                        this.emit("paste");
                        break;
                    default:
                        break;
                }
            }

            if (e.altKey || e.ctrlKey || e.metaKey) {
                return;
            }

            // catch F10 key
            if (e.shiftKey && e.keyCode === keys.F10) {
                this.emit("showContextMenu", e);
                e.preventDefault();
                return;
            }

            // Catch DELETE key
            if (e.shiftKey) {
                return;
            }
            if (e.keyCode === keys.DELETE) {
                this.emit("delete");
            }
        },

        _onNodeMouseLeave: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse leave event on a node
            // tags:
            //      private

            this.inherited(arguments);

            // Remove dijitTreeRowHover class for all tree nodes when mouse leave on a node (in IE browser, dijitTreeRowHover css class added by _CssStateMixin did not removed)
            if (sniff("ie")) {
                array.forEach(query(".dijitTreeRow.dijitTreeRowHover", this.tree.domNode), function (node) {
                    domClass.remove(node, "dijitTreeRowHover");
                });
            }
        }

    });

});

},
'epi/shell/dnd/tree/dndSource':function(){
﻿define("epi/shell/dnd/tree/dndSource", [
    "dojo/_base/declare", // declare

    "./multiDndSource"
], function (declare, multiDndSource) {

    return declare([multiDndSource], {
        // summary:
        //      dnd source that only supports single select
        // tags:
        //      internal

        //	singular: Boolean
        //      Allows selection of only one element, if true.
        //      Tree hasn't been tested in singular=true mode, unclear if it works.
        singular: true,

        userSelect: function (node) {
            // Override CTRL and SHIFT key press parameters since we don't support multiple selection.
            this.inherited(arguments, [node, false, false]);
        }
    });
});

},
'epi/shell/dnd/tree/multiDndSource':function(){
﻿define("epi/shell/dnd/tree/multiDndSource", [
    "dojo/_base/array", // array.forEach array.indexOf array.map
    "dojo/_base/connect", // isCopyKey
    "dojo/_base/declare", // declare
    "dojo/aspect",
    "dojo/dom-class", // domClass.add
    "dojo/dom-geometry", // domGeometry.position
    "dojo/_base/lang", // lang.mixin lang.hitch
    "dojo/on", // subscribe
    "dojo/touch",
    "dojo/topic",
    "dojo/dnd/Manager",
    "dojo/when",
    "dijit/tree/dndSource",
    "../_DndDataMixin",
    "epi/shell/TypeDescriptorManager"
], function (array, connect, declare, aspect, domClass, domGeometry, lang, on, touch, topic, dndManager, when, dndSource, _DndDataMixin, TypeDescriptorManager) {
    return declare([dndSource, _DndDataMixin], {
        // tags:
        //      internal xproduct

        generateText: false,

        //	singular: Boolean
        //      Allows selection of only one element, if true.
        //      Tree hasn't been tested in singular=true mode, unclear if it works.
        singular: false,

        constructor: function () {
            // If there are restricted types then add them to the accept array
            // with a value of zero to indicated that they are not accepted.
            var reject = this.reject;
            if (reject) {

                // we need to filter out restrictedDndTypes
                var allowedDnD = [];
                for (var key in this.accept) {
                    allowedDnD.push(key);
                }

                this.accept = {};
                allowedDnD = TypeDescriptorManager.removeIntersectingTypes(allowedDnD, this.reject);
                array.forEach(allowedDnD, function (allowed) {
                    this.accept[allowed] = 1;
                }, this);

                for (var i = 0; i < reject.length; ++i) {
                    this.accept[reject[i]] = 0;
                }
            }

            var manager = dndManager.manager();
            this._startDragHandle = aspect.before(manager, "startDrag", this._beforeStartDrag.bind(this));
        },

        destroy: function () {
            this.inherited(arguments);
            this._startDragHandle.remove();
            delete this._startDragHandle;
        },

        _beforeStartDrag: function (source, nodes, copy) {
            // summary:
            //      Replaces the nodes argument to include all selected nodes, not just parent nodes.
            //      dijit/tree/dndSource filters out nodes that are children to other nodes before calling startDrag.
            //      See: https://github.com/dojo/dijit/blob/1bd0548b63989418fc69a46976f5749651473ebb/tree/dndSource.js#L226
            // source: Object
            //      The dijit/tree/dndSource / dojo/dnd/Source which is providing the items
            // nodes: DomNode[]
            //      The list of transferred items, dndTreeNode nodes if dragging from a Tree
            // copy: Boolean
            //      Copy items, if true, move items otherwise
            // tags:
            //      private

            if (source !== this) {
                return arguments;
            }

            var allNodes = this.getSelectedTreeNodes();
            if (!allNodes.length) {
                return arguments;
            }

            allNodes = allNodes.map(function (treeNode) {
                return treeNode.domNode;
            });

            return [source, allNodes, copy];
        },

        deleteSelectedNodes: function () {
            // Method needed to interact with other sources but should not do anything
        },

        onDndDrop: function (source, nodes, copy, target) {
            // summary:
            //      Topic event processor for /dnd/drop, called to finish the DnD operation.
            // description:
            //      Updates data store items according to where node was dragged from and dropped
            //      to.   The tree will then respond to those data store updates and redraw itself.
            // source: Object
            //      The dijit.tree.dndSource / dojo.dnd.Source which is providing the items
            // nodes: DomNode[]
            //      The list of transferred items, dndTreeNode nodes if dragging from a Tree
            // copy: Boolean
            //      Copy items, if true, move items otherwise
            // tags:
            //      protected

            if (this.containerState === "Over") {
                var tree = this.tree,
                    model = tree.model,
                    targetAnchor = this.targetAnchor;

                this.isDragging = false;

                // Compute the new parent item
                var insertIndex;
                var newParentItem = (targetAnchor && targetAnchor.item) || tree.item;
                if (this.dropPosition === "Before" || this.dropPosition === "After") {
                    // Actually this should be checked during onMouseMove too, to make the drag icon red.
                    newParentItem = (targetAnchor.getParent() && targetAnchor.getParent().item) || tree.item;
                    // Compute the insert index for reordering
                    insertIndex = targetAnchor.getIndexInParent();
                    if (this.dropPosition === "After") {
                        insertIndex = targetAnchor.getIndexInParent() + 1;
                    }
                }

                // Get the hash to pass to model.newItem() / pasteItem().  A single call to
                // itemCreator() returns an array of hashes, one for each drag source node.
                var items = this.itemCreator(nodes, targetAnchor.rowNode, source, target);
                if (source === this) {
                    // This is a node from my own tree, and we are moving it, not copying.
                    // Remove item from old parent's children attribute.
                    // and this code should go there.

                    if (model.pasteItems) {
                        var pasteItems = items.map(function (item) {
                            if (item.dndData) {
                                return item.dndData.data;
                            }
                            return item;
                        });
                        model.pasteItems(pasteItems, newParentItem, copy, insertIndex);
                    } else {
                        array.forEach(items, function (item) {
                            if (item.dndData) {
                                var options = item.dndData.options;
                                var oldParentItem = options ? options.oldParentItem : null;
                                var indexInParent = options ? options.indexInParent : 0;

                                if (typeof insertIndex == "number") {
                                    if (newParentItem === oldParentItem && indexInParent < insertIndex) {
                                        insertIndex -= 1;
                                    }
                                }

                                model.pasteItem(item.dndData.data, oldParentItem, newParentItem, copy, insertIndex);
                            }
                        });
                    }
                } else {
                    // Create new items in the tree, based on the drag source.
                    if (model.newItems) {
                        model.newItems(items, newParentItem, insertIndex);
                    } else {
                        array.forEach(items, function (item) {
                            model.newItem(item, newParentItem, insertIndex);
                        });
                    }
                }

                // If both source and target have completed there event chains raise an onDndEnd.
                if (!source.isDragging && !target.isDragging) {
                    this.onDndEnd();
                }
            }

            //If the nodes has been dropped in another target and copy is set to false, raise the onDndItemRemoved on the source if it supports it
            if (this === target && source !== target && !copy && source.onDndItemRemoved) {
                var dndData = array.map(nodes, function (node) {
                    return this._getDndData(source.getItem(node.id), this.accept, false);
                }, this);
                source.onDndItemRemoved(dndData, source, nodes, copy, target);
            }

            this.onDndCancel();
        },

        onMouseOut: function () {
            // summary:
            //      Event processor for when mouse is moved away from a TreeNode
            // tags:
            //      private

            this.inherited(arguments);

            if (this._expandOnDndTimeout) {
                clearTimeout(this._expandOnDndTimeout);
            }
        },

        _onDragMouse: function (e, firstTime) {
            // summary:
            //      Helper method for processing onmousemove/onmouseover events while drag is in progress.
            //      Keeps track of current drop target.
            // e: Event
            //      The mousemove event.
            // firstTime: Boolean?
            //      If this flag is set, this is the first mouse move event of the drag, so call m.canDrop() etc.
            //      even if newTarget == null because the user quickly dragged a node in the Tree to a position
            //      over Tree.containerNode but not over any TreeNode (#7971)

            this.inherited(arguments);

            // Double check for droppable ability in case checkItemAcceptance() returns deferred,
            // because base _onDragMouse() only works correctly with checkItemAcceptance() that returns boolean.
            var m = dndManager.manager();
            if (m.canDropFlag) {
                when(this.checkItemAcceptance(this.current.rowNode, m.source, this.dropPosition.toLowerCase()), function (accepted) {
                    m.canDrop(accepted);
                });
            }

            if (this._expandOnDndTimeout) {
                clearTimeout(this._expandOnDndTimeout);
            }

            // Expand the targetAnchor node (if it's currently collapsed) so the user can see
            // where their node was dropped. In particular since that node is still selected.
            if (this.tree && this.tree.expandOnDnd === true && this.targetAnchor) {
                this._expandOnDndTimeout = setTimeout(function () {
                    // Only try to expand target node when still dragging
                    this.isDragging && this.tree._expandNode(this.targetAnchor);
                }.bind(this), 500);
            }
        },

        onDndEnd: function () {
            // summary:
            //      Event raised when both source and target have completed their drag events.
            // tags:
            //      callback
        },

        onDndItemRemoved: function (dndData, source, nodes, copy, target) {
            // summary:
            //      Called when the nodes has been removed from the source, i.e. dropped in another target
            //
            // dndData:
            //    Dnd data extracted from the dragging items which have the same data type to the current target
            //
            // source:
            //    The dnd source.
            //
            // nodes:
            //    The dragging nodes.
            //
            // copy:
            //    Denote that the drag is copy.
            //
            // tags:
            //    public, event
        },

        itemCreator: function (nodes, targetNode, source, target) {
            // summary:
            //      Returns objects passed to `Tree.model.newItem()` based on DnD nodes
            //      dropped onto the tree.
            // description:
            //      For each node in nodes[], which came from source, create a hash of name/value
            //      pairs to be passed to Tree.model.newItem().  Returns array of those hashes.
            // nodes: DomNode[]
            // targetNode: DomNode
            // source: dojo/dnd/Source
            // target: dojo/dnd/Source
            // returns: __Item[]
            //      Array of name/value hashes for each new item to be added to the Tree
            // tags:
            //      extension
            return array.map(nodes, function (node) {
                return {
                    id: node.id,
                    name: node.textContent || node.innerText || "",
                    dndData: this._getDndData(source.getItem(node.id), this.accept, this === source)
                };
            }, this);
        },

        getItem: function (/*String*/key) {
            // summary:
            //      Returns the dojo.dnd.Item (representing a dragged node) by it's key (id).
            //      Called by dojo.dnd.Source.checkAcceptance().
            // tags:
            //      protected
            var item = this.inherited(arguments);

            // change drag type for the tree
            if (this.tree.getItemType && item && item.data && item.data.item) {
                item.type = this.tree.getItemType(item.data.item);
            }

            // add other options
            item.options = this.getItemOptions(item);

            return item;
        },

        getItemOptions: function (item) {
            // summary:
            //      Add options for each item. Called by getItem.

            var opts = {};
            if (item.data) {
                if (item.data.getParent) {
                    var oldParent = item.data.getParent();
                    opts.oldParentItem = oldParent ? oldParent.item : null;
                }

                if (item.data.getIndexInParent) {
                    opts.indexInParent = item.data.getIndexInParent();
                }
            }
            return opts;
        },

        onMouseDown: function (e) {
            // summary:
            //      Event processor for onmousedown/ontouchstart.
            //      Override this to prevent dnd when user mouses down on scroll bar.
            // e: Event
            //      onmousedown/ontouchend event
            // tags:
            //      protected override

            // Prevent drag/drop from happening when user mouses down on scrollbar.
            var isContainer = domClass.contains(e.target, "dojoDndContainerOver");
            // Prevent drag/drop from happening when user mouses down between nodes.
            var isTreeContainer = domClass.contains(e.target, "dijitTreeContainer");
            if (isContainer || isTreeContainer) {
                return;
            }

            this.inherited(arguments);
        },

        onMouseUp: function (e) {

            // If multiple items are selected and the user clicks on the context menu
            // then it should not de-select the selected items
            if (this.current) {
                var id = this.current.id;

                if (!this.singular && !e.shiftKey && this.selection[id] && domClass.contains(e.target, "epi-iconContextMenu")) {
                    this._doDeselect = false;
                }
            }

            this.inherited(arguments);
        },

        checkAcceptance: function (source, nodes) {
            // summary:
            //		Checks if the target can accept nodes from this source.
            // source: Object
            //		The source which provides items.
            // nodes: Array
            //		The list of transferred items.

            if (this.readOnly) {
                return false;
            }

            var items = array.map(nodes, function (node) {
                return source.getItem(node.id);
            });

            return this._checkAcceptanceForItems(items, this.accept);
        }
    });
});

},
'dijit/tree/dndSource':function(){
define("dijit/tree/dndSource", [
	"dojo/_base/array", // array.forEach array.indexOf array.map
	"dojo/_base/connect", // isCopyKey
	"dojo/_base/declare", // declare
	"dojo/dom-class", // domClass.add
	"dojo/dom-geometry", // domGeometry.position
	"dojo/_base/lang", // lang.mixin lang.hitch
	"dojo/on", // subscribe
	"dojo/touch",
	"dojo/topic",
	"dojo/dnd/Manager", // DNDManager.manager
	"./_dndSelector"
], function(array, connect, declare, domClass, domGeometry, lang, on, touch, topic, DNDManager, _dndSelector){

// module:
//		dijit/tree/dndSource
// summary:
//		Handles drag and drop operations (as a source or a target) for `dijit.Tree`

/*=====
var __Item = {
	// summary:
	//		New item to be added to the Tree, like:
	// id: Anything
	id: "",
	// name: String
	name: ""
};
=====*/

var dndSource = declare("dijit.tree.dndSource", _dndSelector, {
	// summary:
	//		Handles drag and drop operations (as a source or a target) for `dijit.Tree`

	// isSource: Boolean
	//		Can be used as a DnD source.
	isSource: true,

	// accept: String[]
	//		List of accepted types (text strings) for the Tree; defaults to
	//		["text"]
	accept: ["text", "treeNode"],

	// copyOnly: [private] Boolean
	//		Copy items, if true, use a state of Ctrl key otherwise
	copyOnly: false,

	// dragThreshold: Number
	//		The move delay in pixels before detecting a drag; 5 by default
	dragThreshold: 5,

	// betweenThreshold: Integer
	//		Distance from upper/lower edge of node to allow drop to reorder nodes
	betweenThreshold: 0,

	// Flag used by Avatar.js to signal to generate text node when dragging
	generateText: true,

	constructor: function(/*dijit/Tree*/ tree, /*dijit/tree/dndSource*/ params){
		// summary:
		//		a constructor of the Tree DnD Source
		// tags:
		//		private
		if(!params){ params = {}; }
		lang.mixin(this, params);
		var type = params.accept instanceof Array ? params.accept : ["text", "treeNode"];
		this.accept = null;
		if(type.length){
			this.accept = {};
			for(var i = 0; i < type.length; ++i){
				this.accept[type[i]] = 1;
			}
		}

		// class-specific variables
		this.isDragging = false;
		this.mouseDown = false;
		this.targetAnchor = null;	// DOMNode corresponding to the currently moused over TreeNode
		this.targetBox = null;	// coordinates of this.targetAnchor
		this.dropPosition = "";	// whether mouse is over/after/before this.targetAnchor
		this._lastX = 0;
		this._lastY = 0;

		// states
		this.sourceState = "";
		if(this.isSource){
			domClass.add(this.node, "dojoDndSource");
		}
		this.targetState = "";
		if(this.accept){
			domClass.add(this.node, "dojoDndTarget");
		}

		// set up events
		this.topics = [
			topic.subscribe("/dnd/source/over", lang.hitch(this, "onDndSourceOver")),
			topic.subscribe("/dnd/start", lang.hitch(this, "onDndStart")),
			topic.subscribe("/dnd/drop", lang.hitch(this, "onDndDrop")),
			topic.subscribe("/dnd/cancel", lang.hitch(this, "onDndCancel"))
		];
	},

	// methods
	checkAcceptance: function(/*===== source, nodes =====*/){
		// summary:
		//		Checks if the target can accept nodes from this source
		// source: dijit/tree/dndSource
		//		The source which provides items
		// nodes: DOMNode[]
		//		Array of DOM nodes corresponding to nodes being dropped, dijitTreeRow nodes if
		//		source is a dijit/Tree.
		// tags:
		//		extension
		return true;	// Boolean
	},

	copyState: function(keyPressed){
		// summary:
		//		Returns true, if we need to copy items, false to move.
		//		It is separated to be overwritten dynamically, if needed.
		// keyPressed: Boolean
		//		The "copy" control key was pressed
		// tags:
		//		protected
		return this.copyOnly || keyPressed;	// Boolean
	},
	destroy: function(){
		// summary:
		//		Prepares the object to be garbage-collected.
		this.inherited(arguments);
		var h;
		while(h = this.topics.pop()){ h.remove(); }
		this.targetAnchor = null;
	},

	_onDragMouse: function(e, firstTime){
		// summary:
		//		Helper method for processing onmousemove/onmouseover events while drag is in progress.
		//		Keeps track of current drop target.
		// e: Event
		//		The mousemove event.
		// firstTime: Boolean?
		//		If this flag is set, this is the first mouse move event of the drag, so call m.canDrop() etc.
		//		even if newTarget == null because the user quickly dragged a node in the Tree to a position
		//		over Tree.containerNode but not over any TreeNode (#7971)

		var m = DNDManager.manager(),
			oldTarget = this.targetAnchor,			// the TreeNode corresponding to TreeNode mouse was previously over
			newTarget = this.current,				// TreeNode corresponding to TreeNode mouse is currently over
			oldDropPosition = this.dropPosition;	// the previous drop position (over/before/after)

		// calculate if user is indicating to drop the dragged node before, after, or over
		// (i.e., to become a child of) the target node
		var newDropPosition = "Over";
		if(newTarget && this.betweenThreshold > 0){
			// If mouse is over a new TreeNode, then get new TreeNode's position and size
			if(!this.targetBox || oldTarget != newTarget){
				this.targetBox = domGeometry.position(newTarget.rowNode, true);
			}
			if((e.pageY - this.targetBox.y) <= this.betweenThreshold){
				newDropPosition = "Before";
			}else if((e.pageY - this.targetBox.y) >= (this.targetBox.h - this.betweenThreshold)){
				newDropPosition = "After";
			}
		}

		if(firstTime || newTarget != oldTarget || newDropPosition != oldDropPosition){
			if(oldTarget){
				this._removeItemClass(oldTarget.rowNode, oldDropPosition);
			}
			if(newTarget){
				this._addItemClass(newTarget.rowNode, newDropPosition);
			}

			// Check if it's ok to drop the dragged node on/before/after the target node.
			if(!newTarget){
				m.canDrop(false);
			}else if(newTarget == this.tree.rootNode && newDropPosition != "Over"){
				// Can't drop before or after tree's root node; the dropped node would just disappear (at least visually)
				m.canDrop(false);
			}else{
				// Guard against dropping onto yourself (TODO: guard against dropping onto your descendant, #7140)
				var sameId = false;
				if(m.source == this){
					for(var dragId in this.selection){
						var dragNode = this.selection[dragId];
						if(dragNode.item === newTarget.item){
							sameId = true;
							break;
						}
					}
				}
				if(sameId){
					m.canDrop(false);
				}else if(this.checkItemAcceptance(newTarget.rowNode, m.source, newDropPosition.toLowerCase())
						&& !this._isParentChildDrop(m.source, newTarget.rowNode)){
					m.canDrop(true);
				}else{
					m.canDrop(false);
				}
			}

			this.targetAnchor = newTarget;
			this.dropPosition = newDropPosition;
		}
	},

	onMouseMove: function(e){
		// summary:
		//		Called for any onmousemove/ontouchmove events over the Tree
		// e: Event
		//		onmousemouse/ontouchmove event
		// tags:
		//		private
		if(this.isDragging && this.targetState == "Disabled"){ return; }
		this.inherited(arguments);
		var m = DNDManager.manager();
		if(this.isDragging){
			this._onDragMouse(e);
		}else{
			if(this.mouseDown && this.isSource &&
				 (Math.abs(e.pageX-this._lastX)>=this.dragThreshold || Math.abs(e.pageY-this._lastY)>=this.dragThreshold)){
				var nodes = this.getSelectedTreeNodes();
				if(nodes.length){
					if(nodes.length > 1){
						//filter out all selected items which has one of their ancestor selected as well
						var seen = this.selection, i = 0, r = [], n, p;
						nextitem: while((n = nodes[i++])){
							for(p = n.getParent(); p && p !== this.tree; p = p.getParent()){
								if(seen[p.id]){ //parent is already selected, skip this node
									continue nextitem;
								}
							}
							//this node does not have any ancestors selected, add it
							r.push(n);
						}
						nodes = r;
					}
					nodes = array.map(nodes, function(n){return n.domNode});
					m.startDrag(this, nodes, this.copyState(connect.isCopyKey(e)));
					this._onDragMouse(e, true);	// because this may be the only mousemove event we get before the drop
				}
			}
		}
	},

	onMouseDown: function(e){
		// summary:
		//		Event processor for onmousedown/ontouchstart
		// e: Event
		//		onmousedown/ontouchend event
		// tags:
		//		private
		this.mouseDown = true;
		this.mouseButton = e.button;
		this._lastX = e.pageX;
		this._lastY = e.pageY;
		this.inherited(arguments);
	},

	onMouseUp: function(e){
		// summary:
		//		Event processor for onmouseup/ontouchend
		// e: Event
		//		onmouseup/ontouchend event
		// tags:
		//		private
		if(this.mouseDown){
			this.mouseDown = false;
			this.inherited(arguments);
		}
	},

	onMouseOut: function(){
		// summary:
		//		Event processor for when mouse is moved away from a TreeNode
		// tags:
		//		private
		this.inherited(arguments);
		this._unmarkTargetAnchor();
	},

	checkItemAcceptance: function(/*===== target, source, position =====*/){
		// summary:
		//		Stub function to be overridden if one wants to check for the ability to drop at the node/item level
		// description:
		//		In the base case, this is called to check if target can become a child of source.
		//		When betweenThreshold is set, position="before" or "after" means that we
		//		are asking if the source node can be dropped before/after the target node.
		// target: DOMNode
		//		The dijitTreeRoot DOM node inside of the TreeNode that we are dropping on to
		//		Use dijit.getEnclosingWidget(target) to get the TreeNode.
		// source: dijit/tree/dndSource
		//		The (set of) nodes we are dropping
		// position: String
		//		"over", "before", or "after"
		// tags:
		//		extension
		return true;
	},

	// topic event processors
	onDndSourceOver: function(source){
		// summary:
		//		Topic event processor for /dnd/source/over, called when detected a current source.
		// source: Object
		//		The dijit/tree/dndSource / dojo/dnd/Source which has the mouse over it
		// tags:
		//		private
		if(this != source){
			this.mouseDown = false;
			this._unmarkTargetAnchor();
		}else if(this.isDragging){
			var m = DNDManager.manager();
			m.canDrop(false);
		}
	},
	onDndStart: function(source, nodes, copy){
		// summary:
		//		Topic event processor for /dnd/start, called to initiate the DnD operation
		// source: Object
		//		The dijit/tree/dndSource / dojo/dnd/Source which is providing the items
		// nodes: DomNode[]
		//		The list of transferred items, dndTreeNode nodes if dragging from a Tree
		// copy: Boolean
		//		Copy items, if true, move items otherwise
		// tags:
		//		private

		if(this.isSource){
			this._changeState("Source", this == source ? (copy ? "Copied" : "Moved") : "");
		}
		var accepted = this.checkAcceptance(source, nodes);

		this._changeState("Target", accepted ? "" : "Disabled");

		if(this == source){
			DNDManager.manager().overSource(this);
		}

		this.isDragging = true;
	},

	itemCreator: function(nodes /*===== , target, source =====*/){
		// summary:
		//		Returns objects passed to `Tree.model.newItem()` based on DnD nodes
		//		dropped onto the tree.   Developer must override this method to enable
		//		dropping from external sources onto this Tree, unless the Tree.model's items
		//		happen to look like {id: 123, name: "Apple" } with no other attributes.
		// description:
		//		For each node in nodes[], which came from source, create a hash of name/value
		//		pairs to be passed to Tree.model.newItem().  Returns array of those hashes.
		// nodes: DomNode[]
		// target: DomNode
		// source: dojo/dnd/Source
		// returns: __Item[]
		//		Array of name/value hashes for each new item to be added to the Tree
		// tags:
		//		extension

		// TODO: for 2.0 refactor so itemCreator() is called once per drag node, and
		// make signature itemCreator(sourceItem, node, target) (or similar).

		return array.map(nodes, function(node){
			return {
				"id": node.id,
				"name": node.textContent || node.innerText || ""
			};
		}); // Object[]
	},

	onDndDrop: function(source, nodes, copy){
		// summary:
		//		Topic event processor for /dnd/drop, called to finish the DnD operation.
		// description:
		//		Updates data store items according to where node was dragged from and dropped
		//		to.   The tree will then respond to those data store updates and redraw itself.
		// source: Object
		//		The dijit/tree/dndSource / dojo/dnd/Source which is providing the items
		// nodes: DomNode[]
		//		The list of transferred items, dndTreeNode nodes if dragging from a Tree
		// copy: Boolean
		//		Copy items, if true, move items otherwise
		// tags:
		//		protected
		if(this.containerState == "Over"){
			var tree = this.tree,
				model = tree.model,
				target = this.targetAnchor;

			this.isDragging = false;

			// Compute the new parent item
			var newParentItem;
			var insertIndex;
			var before;		// drop source before (aka previous sibling) of target
			newParentItem = (target && target.item) || tree.item;
			if(this.dropPosition == "Before" || this.dropPosition == "After"){
				// TODO: if there is no parent item then disallow the drop.
				// Actually this should be checked during onMouseMove too, to make the drag icon red.
				newParentItem = (target.getParent() && target.getParent().item) || tree.item;
				// Compute the insert index for reordering
				insertIndex = target.getIndexInParent();
				if(this.dropPosition == "After"){
					insertIndex = target.getIndexInParent() + 1;
					before = target.getNextSibling() && target.getNextSibling().item;
				}else{
					before = target.item;
				}
			}else{
				newParentItem = (target && target.item) || tree.item;
			}

			// If necessary, use this variable to hold array of hashes to pass to model.newItem()
			// (one entry in the array for each dragged node).
			var newItemsParams;

			array.forEach(nodes, function(node, idx){
				// dojo/dnd/Item representing the thing being dropped.
				// Don't confuse the use of item here (meaning a DnD item) with the
				// uses below where item means dojo.data item.
				var sourceItem = source.getItem(node.id);

				// Information that's available if the source is another Tree
				// (possibly but not necessarily this tree, possibly but not
				// necessarily the same model as this Tree)
				if(array.indexOf(sourceItem.type, "treeNode") != -1){
					var childTreeNode = sourceItem.data,
						childItem = childTreeNode.item,
						oldParentItem = childTreeNode.getParent().item;
				}

				if(source == this){
					// This is a node from my own tree, and we are moving it, not copying.
					// Remove item from old parent's children attribute.
					// TODO: dijit/tree/dndSelector should implement deleteSelectedNodes()
					// and this code should go there.

					if(typeof insertIndex == "number"){
						if(newParentItem == oldParentItem && childTreeNode.getIndexInParent() < insertIndex){
							insertIndex -= 1;
						}
					}
					model.pasteItem(childItem, oldParentItem, newParentItem, copy, insertIndex, before);
				}else if(model.isItem(childItem)){
					// Item from same model
					// (maybe we should only do this branch if the source is a tree?)
					model.pasteItem(childItem, oldParentItem, newParentItem, copy, insertIndex, before);
				}else{
					// Get the hash to pass to model.newItem().  A single call to
					// itemCreator() returns an array of hashes, one for each drag source node.
					if(!newItemsParams){
						newItemsParams = this.itemCreator(nodes, target.rowNode, source);
					}

					// Create new item in the tree, based on the drag source.
					model.newItem(newItemsParams[idx], newParentItem, insertIndex, before);
				}
			}, this);

			// Expand the target node (if it's currently collapsed) so the user can see
			// where their node was dropped.   In particular since that node is still selected.
			this.tree._expandNode(target);
		}
		this.onDndCancel();
	},

	onDndCancel: function(){
		// summary:
		//		Topic event processor for /dnd/cancel, called to cancel the DnD operation
		// tags:
		//		private
		this._unmarkTargetAnchor();
		this.isDragging = false;
		this.mouseDown = false;
		delete this.mouseButton;
		this._changeState("Source", "");
		this._changeState("Target", "");
	},

	// When focus moves in/out of the entire Tree
	onOverEvent: function(){
		// summary:
		//		This method is called when mouse is moved over our container (like onmouseenter)
		// tags:
		//		private
		this.inherited(arguments);
		DNDManager.manager().overSource(this);
	},
	onOutEvent: function(){
		// summary:
		//		This method is called when mouse is moved out of our container (like onmouseleave)
		// tags:
		//		private
		this._unmarkTargetAnchor();
		var m = DNDManager.manager();
		if(this.isDragging){
			m.canDrop(false);
		}
		m.outSource(this);

		this.inherited(arguments);
	},

	_isParentChildDrop: function(source, targetRow){
		// summary:
		//		Checks whether the dragged items are parent rows in the tree which are being
		//		dragged into their own children.
		//
		// source:
		//		The DragSource object.
		//
		// targetRow:
		//		The tree row onto which the dragged nodes are being dropped.
		//
		// tags:
		//		private

		// If the dragged object is not coming from the tree this widget belongs to,
		// it cannot be invalid.
		if(!source.tree || source.tree != this.tree){
			return false;
		}


		var root = source.tree.domNode;
		var ids = source.selection;

		var node = targetRow.parentNode;

		// Iterate up the DOM hierarchy from the target drop row,
		// checking of any of the dragged nodes have the same ID.
		while(node != root && !ids[node.id]){
			node = node.parentNode;
		}

		return node.id && ids[node.id];
	},

	_unmarkTargetAnchor: function(){
		// summary:
		//		Removes hover class of the current target anchor
		// tags:
		//		private
		if(!this.targetAnchor){ return; }
		this._removeItemClass(this.targetAnchor.rowNode, this.dropPosition);
		this.targetAnchor = null;
		this.targetBox = null;
		this.dropPosition = null;
	},

	_markDndStatus: function(copy){
		// summary:
		//		Changes source's state based on "copy" status
		this._changeState("Source", copy ? "Copied" : "Moved");
	}
});

/*=====
dndSource.__Item = __Item;
=====*/

return dndSource;
});

},
'epi/shell/widget/Tree':function(){
define("epi/shell/widget/Tree", [
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom",

    // Dijit
    "dijit/focus",
    "dijit/Tree"
],

function (
// Dojo
    array,
    declare,
    lang,
    dom,

    // Dijit
    focus,
    Tree
) {

    return declare(Tree, {
        // summary:
        //      Extends dijit/Tree with support for reloading expanded nodes
        //      by listening to the onItemChildrenReload event of the model.
        //      The subscriber needs to call getChildren to get the updated children collection
        // tags:
        //      public

        // dndParams: [internal] Array
        //      Parameters to pull off of the tree and pass on to the dndController as its params.
        dndParams: ["accept", "reject"].concat(Tree.prototype.dndParams),

        postCreate: function () {
            this.inherited(arguments);
            this.connect(this.model, "onItemChildrenReload", "_onChildrenReload");
        },

        _onChildrenReload: function (/*dojo/data/Item*/parent) {
            // summary:
            //      Processes notification of a change to an item's children
            // tags:
            //      private

            var identity = this.model.getIdentity(parent),
                parentNodes = this._itemNodesMap[identity];

            if (parentNodes) {
                if (array.some(parentNodes, function (node) {
                    return node.state === "LOADED";
                })) {
                    this.model.getChildren(parent, lang.hitch(this, function (newChildrenList) {
                        array.forEach(parentNodes, function (parentNode) {
                            parentNode.setChildItems(newChildrenList);
                        });

                        array.forEach(newChildrenList, function (child) {
                            // Update node's item
                            this.model.onChange(child);
                            // Recursive reload
                            this._onChildrenReload(child);
                        }, this);
                    }));
                } else {
                    // Maybe we process more than makeExpandable method
                    array.forEach(parentNodes, function (node) {
                        node.isExpandable = this.model.mayHaveChildren(node.item);
                        node._setExpando(false);
                    }, this);
                }
            }
        },

        _onItemChildrenChange: function () {
            // summary:
            //      Overridden in an effort to keep focus in the tree when the children changes.
            //      Since the tree detaches the nodes from the dom when refreshing children the
            //      focus will be lost

            var currentFocus = null;

            // Do we currently have focus
            if (focus.curNode && dom.isDescendant(focus.curNode, this.domNode)) {
                currentFocus = focus.curNode;
            }

            this.inherited(arguments);

            // Try to restore focus to the tree
            if (currentFocus) {
                if (dom.isDescendant(currentFocus, this.domNode)) {
                    currentFocus.focus();
                } else {
                    // We had focus but the previously focused node is not alive.
                    var node = this._getRootOrFirstNode();
                    if (node) {
                        this.focusNode(node);
                    }
                }
            }
        }
    });

});

},
'epi-cms/dgrid/formatters':function(){
define([
// dojo
    "dojo/_base/lang",
    "dojo/dom-class",

    // epi
    "epi/datetime",
    "epi/username",
    "epi/string",

    "epi/shell/dgrid/Formatter",
    "epi/shell/dgrid/util/misc",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/viewmodel/ContentStatusViewModel",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions",
    "epi/i18n!epi/cms/nls/episerver.shared.header"
],
function (
// dojo
    lang,
    domClass,

    // epi
    epiDate,
    username,
    epiString,

    Formatter,
    misc,
    TypeDescriptorManager,

    ApplicationSettings,
    ContentActionSupport,
    ContentStatusViewModel,

    resources,
    headerResources
) {
    var module = {
        // summary:
        //      Static module that defines miscellaneous formatter methods
        //      for use with the dgrid.
        // tags:
        //      public

        defaultIconClass: "epi-iconObjectUnknown",

        thumbnail: function (thumbnailUrl) {
            // when image does not exists then show default image
            var onerror = "javascript: this.classList.add('epi-no-image'); this.src = '" +
                          ApplicationSettings.noImageSrcPath +
                          "';this.onerror=null;";

            var template = "<image src=\"{0}?{1}\" class=\"epi-floatLeft epi-thumbnail\" onerror=\"" + onerror + "\"/>";
            return thumbnailUrl ? lang.replace(template, [thumbnailUrl, new Date().getTime()]) : "";
        },

        contentIcon: function (typeIdentifier, additionalClass) {
            // summary:
            //      Adds an icon as specified for the type or a default object icon
            // typeIdentifier:
            //      key for the type
            // additionalClass: String?
            //      additional css class
            // tags:
            //      public

            return misc.icon(module.contentIconClass(typeIdentifier, additionalClass));
        },

        contentIconClass: function (typeIdentifier, additionalClass) {
            // summary:
            //      class name of an icon as specified for the type or a default object icon
            // typeIdentifier:
            //      key for the type
            // additionalClass: String?
            //      additional css class
            // tags:
            //      internal

            var iconNodeClass = TypeDescriptorManager.getValue(typeIdentifier, "iconClass");

            var input = iconNodeClass + " epi-objectIcon";
            if (additionalClass) {
                input += " " + additionalClass;
            }

            return input;
        },

        contentTypeDescription: function (typeIdentifier) {
            // summary:
            //      Return content type description
            // typeIdentifier:
            //      key for the type
            // tags:
            //      public
            return TypeDescriptorManager.getResourceValue(typeIdentifier, "name", false);
        },

        languageBranch: function (languageBranch) {
            // summary:
            //      Adds an indicator of the true language for the content object
            // languageBranch:
            //      Language branch object.
            // tags:
            //      public
            return languageBranch ? "<span class=\"epi-missingLanguageIndicator\">" + languageBranch.language + "</span>" : "";
        },

        menu: function (/*Object*/settings) {
            // summary:
            //      Adds a menu icon
            // settings:
            //      Settings information for menu
            // tags:
            //      public

            return lang.replace("<span class=\"dijitInline dijitIcon epi-iconContextMenu epi-floatRight\" title=\"{title}\">&nbsp;</span>", settings);
        },

        path: function (path, options) {
            // summary:
            //      Returns markup for the path to an item created from the names in the path array
            // path: String[]
            //      An array of with the path to render
            // options: Object?
            //      Optional object, supporting the following parameters:
            //      * skipEncode: do not encode the path segments
            //      * skipDefaultClass: do not add the default 'treePath' css class
            // tags:
            //      public

            if (path && path.length) {
                options = options || {};

                var tooltip = path.join(" > ");
                var title = options.skipEncode ? tooltip : misc.attributeEncode(tooltip);
                path = epiString.truncateMiddle(path, 40, "\u2026");

                var text = path.map(function (value) {
                    return options.skipEncode ? value : misc.htmlEncode(value);
                }).join("<span class=\"epi-breadCrumbsSeparator\"></span>");

                return lang.replace("<span class=\"{className} dojoxEllipsis\" title=\"{title}\">{text}</span>", {
                    className: options.skipDefaultClass ? "" : "dgrid-column-treePath", title: title, text: text
                });
            }
            return "";
        },

        userName: function (userName) {
            // summary:
            //      Shim for the epi/username/toUserFriendlyHtml function
            // userName:
            //      The user name.
            // tags:
            //      public
            return username.toUserFriendlyHtml(userName);
        },

        localizedDate: function (date) {
            // summary:
            //      Shim for the epi/date/toUserFriendlyHtml function
            // date:
            //      The date to format.
            // tags:
            //      public
            return epiDate.toUserFriendlyHtml(date);
        },

        friendlyBoolean: function (value) {
            // summary:
            //      Creates a div with a "checked/not checked" css class.
            // tags:
            //      public
            var cssClass = value ? "epi-iconCheckmark" : "epi-iconStop";
            return "<div class=\"" + cssClass + "\" />";
        },

        versionStatus: function (versionId) {
            // summary:
            //      Shim for the epi-cms/contentediting/ContentActionSupport.getVersionStatus function
            // versionId:
            //      The value to format.
            // tags:
            //      public
            return ContentActionSupport.getVersionStatus(versionId);
        },

        commonDraft: function (item, value, node) {
            // summary:
            //      Adds an addition node to the inner HTML of the node if the item is a common draft.
            // tags:
            //      public
            if (item.isCommonDraft) {
                node.innerHTML = "<span class=\"dijitReset dijitInline dijitIcon epi-iconPrimary epi-floatRight\" title=\"" + resources.primarydraft + "\"></span>";
            }
            node.innerHTML += module.versionStatus(value);
            node.title = item.contentLink;
            if (item.projectName) {
                node.innerHTML += " (" + misc.htmlEncode(item.projectName) + ")";
            }
        },

        visibleLink: function (value, valueIsHtml) {
            // summary:
            //      Wraps the value with a span with the 'epi-visibleLink' css class
            // valueIsHtml:
            //      Pass true to skip html encoding of the value. The default is to encode the value.
            // tags:
            //      public

            if (!value) {
                return "";
            }

            var text = !valueIsHtml ? misc.htmlEncode(value) : value;

            return "<span class=\"epi-visibleLink\">" + text + "</span>";
        },

        secondaryText: function (value, valueIsHtml) {
            // summary:
            //      Wraps the value with a span with the 'epi-secondaryText' css class
            // valueIsHtml:
            //      Pass true to skip html encoding of the value. The default is to encode the value.
            // tags:
            //      public

            if (!value) {
                return "";
            }

            var text = !valueIsHtml ? misc.htmlEncode(value) : value;

            return "<span class=\"epi-secondaryText\">" + text + "</span>";
        },

        title: function (name, contentLink, contentTypeName) {
            // summary:
            //      Returns a title string that looks like "{name}, ID: {contentLink} (Type: {contentTypeName})"
            // name: String
            //      The name of the item
            // contentLink: String
            //      The content link
            // contentTypeName: String
            //      The name of the content type
            // tags:
            //      public

            if (!contentLink) {
                return contentTypeName;
            }

            return name + ", " + headerResources.id + ": " + contentLink + " (" + headerResources.type + ": " + contentTypeName + ")";
        },

        contentItemFactory: function (textSelector, titleSelector, iconSelector, menuSettings, thumbnailSelector, languageSelector, isEncoded, showStatus) {
            // summary:
            //      Factory function for configuring the contentItem formatter
            // textSelector:
            //      Selector function or property key of content object
            // titleSelector:
            //      Selector function or property key of content object
            // iconSelector:
            //      Selector function or property key of content object
            // menuSettings:
            //      Settings information for menu
            // isEncoded: Boolean
            //      Flags which is used to enabled/disable encode mode. (default true)
            // showStatus: Boolean?
            //      Flags which is used to enabled/disable status icon display. (default false)
            // tags:
            //      public

            return function (value, object, node, options) {
                var returnValue,
                    typeIdentifier,
                    text,
                    title,
                    missingLanguageBranch,
                    valueIsString,
                    thumbnailUrl,
                    status;

                function get(name) {
                    if (typeof object.get === "function") {
                        return object.get(name);
                    }
                    return object[name];
                }

                function selectorExecutor(selector) {
                    if (selector) {
                        if (typeof selector === "function") {
                            return selector(object);
                        } else {
                            return get(selector);
                        }
                    }
                    return value;
                }

                valueIsString = typeof value === "string";
                typeIdentifier = selectorExecutor(iconSelector || (valueIsString ? false : "typeIdentifier"));
                text = selectorExecutor(textSelector || (valueIsString ? false : "text"));
                title = selectorExecutor(titleSelector || (valueIsString ? false : "title"));
                missingLanguageBranch = (languageSelector && selectorExecutor(languageSelector)) || object.missingLanguageBranch;
                thumbnailUrl = thumbnailSelector && selectorExecutor(thumbnailSelector);
                status = showStatus ? object.status : null;

                returnValue = module.contentItem(typeIdentifier, missingLanguageBranch, text, title, menuSettings, thumbnailUrl, isEncoded, status);

                node.innerHTML = returnValue;

                //If in a list add css-class for the row as well
                if (node.nodeName !== "TD" && missingLanguageBranch) {
                    domClass.add(node, "epi-ct-missingLanguageRow");
                }

                return returnValue;
            };
        },

        contentItem: function (typeIdentifier, missingLanguageBranch, text, title, menuSettings, thumbnailUrl, isEncoded, status) {
            // summary:
            //      Formats a content object with icon missing language indicator and an optional menu
            // typeIdentifier:
            //      content type key for selecting the icon
            // missingLanguageBranch:
            //      Content items language information
            // text:
            //      The name or description of the content
            // title:
            //      The name or description of the content used for the title attribute.
            //      If not specified, the text value will be used
            // menuSettings:
            //      Settings information for menu
            // thumbnailUrl:
            //      The image public url of content
            // isEncoded: Boolean
            //      The flag which is used to enable/disable encode mode. (default true)
            // status: Integer?
            //      content status code
            // tags:
            //      public

            var menu = (menuSettings && menuSettings.hasMenu) ? module.menu(menuSettings.settings) : "",
                languageBranch = module.languageBranch(missingLanguageBranch);

            isEncoded = (isEncoded === null || isEncoded === undefined) ? true : isEncoded;
            title = isEncoded ? misc.attributeEncode(title || text) : (title || text);
            text = isEncoded ? misc.htmlEncode(text) : text;
            var statusIcon = "";

            if (status) {
                statusIcon = module._statusIcon(status);
            }

            var additionalClass = module.additionalClassByFilename(text);

            return (thumbnailUrl ? module.thumbnail(thumbnailUrl) : module.contentIcon(typeIdentifier, additionalClass)) + menu + statusIcon + languageBranch + misc.ellipsis(text, title);
        },

        additionalClassByFilename: function (filename) {
            var additionalClass = null;
            if (!filename) {
                return additionalClass;
            }
            var extension = filename.split(".").pop().toUpperCase();
            if (extension) {
                additionalClass = "epi-iconObject" + extension;
            }
            return additionalClass;
        },

        _statusIcon: function (status) {
            // summary:
            //      Create element for status icon
            // status: Integer?
            //      content status code
            // tags:
            //      private

            if (status === ContentActionSupport.versionStatus.Published) {
                return "";
            }

            var model = new ContentStatusViewModel({ contentStatus: status });
            var statusData = {
                cssClass: model.statusIcon && model.statusIcon.join(" "),
                message: model.statusMessage
            };

            return lang.replace("<span class=\"dijitIcon epi-statusIcon {cssClass}\" title=\"{message}\">&nbsp;</span>", statusData);
        }
    };

    Formatter.addFormatter("contentIcon", module.contentIcon);
    Formatter.addFormatter("userName", module.userName);
    Formatter.addFormatter("versionStatus", module.versionStatus);
    Formatter.addFormatter("localizedDate", module.localizedDate);
    Formatter.addFormatter("contentItem", module.contentItemFactory, true);

    return module;
});

},
'epi/username':function(){
﻿define("epi/username", [
    "dojox/html/entities",
    "epi/dependency",
    "epi/i18n!epi/shell/ui/nls/episerver.shared.text"
],

function (
    entities,
    dependency,
    localizations
) {

    return {
        // tags:
        //      public

        toUserFriendlyString: function (username, currentUsername, capitalizeUsername, keepEmptyUsername, useSubjectPronoun) {
            // summary:
            //      Gets a user friendly username. If the username to be displayed is the same as
            //      the current username, then this will return "you".
            // username: String
            //      The username to be displayed.
            // currentUsername: String?
            //      The username to compare with to see if it's the current user.
            // capitalizeUsername: Boolean?
            //      If the first character should be in upper case.
            // keepEmptyUsername: Booelan?
            //      If the empty username should be kept or replaced by "Installer".
            // useSubjectPronoun: Booelan?
            //      True when the subject pronoun should be used to replace the username when it
            //      matches with the current username; otherwise false to use the object pronoun.
            // tags:
            //      public

            if (!currentUsername) {
                currentUsername = this._getCurrentUsername();
            }

            var emptyUsername = keepEmptyUsername ? "" : localizations.installer,
                youUsername = useSubjectPronoun ? localizations.yousubject : localizations.youobject,
                friendlyUsername = username && currentUsername.toLowerCase() === username.toLowerCase() ? youUsername : username || emptyUsername;

            if (capitalizeUsername) {
                friendlyUsername = friendlyUsername.charAt(0).toUpperCase() + friendlyUsername.slice(1);
            }
            return friendlyUsername;
        },

        toUserFriendlyHtml: function (username, currentUsername, capitalizeUsername, keepEmptyUsername, useSubjectPronoun) {
            // summary:
            //      Creates a user friendly version of the username and wraps it inside standardized
            //      HTML for styling purposes.
            // username: String
            //      The username to be displayed.
            // currentUsername: String?
            //      The username to compare with to see if it's the current user.
            // capitalizeUsername: Boolean?
            //      If the first character should be in upper case.
            // keepEmptyUsername: Booelan?
            //      If the empty username should be kept or replaced by "Installer".
            // useSubjectPronoun: Booelan?
            //      True when the subject pronoun should be used to replace the username when it
            //      matches with the current username; otherwise false to use the object pronoun.
            // tags:
            //      public

            var formattedUserName = this.toUserFriendlyString(username, currentUsername, capitalizeUsername, keepEmptyUsername, useSubjectPronoun);
            if (formattedUserName === "") {
                return formattedUserName;
            }
            return "<span class='epi-username'>" + entities.encode(formattedUserName) + "</span>";
        },

        _getCurrentUsername: function () {
            if (!this.currentUsername) {
                var profile = dependency.resolve("epi.shell.Profile");
                //TODO: Make this Async
                this.currentUsername = profile.get("userName");
            }
            return this.currentUsername;
        }
    };
});

},
'epi/shell/dgrid/Formatter':function(){
﻿define("epi/shell/dgrid/Formatter", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/when",

    // DGrid
    "dgrid/Grid",

    // epi
    "epi/shell/dgrid/TemplateColumn"
], function (
// dojo
    declare,
    array,
    when,
    //
    Grid,
    // epi
    TemplateColumn
) {
    var module = declare(null, {
        // summary:
        //      Add formating capability for dgrid column cell.
        // tags:
        //      public

        _isGrid: false,

        configStructure: function () {
            // summary:
            //      Setup templated column(s)
            // tags:
            //      public

            this.inherited(arguments);

            this._isGrid = this instanceof Grid;

            if (this._isGrid) {
                this._setupTemplateColumns();
            } else {
                this._setupList();
            }
        },

        _setupTemplateColumns: function () {
            // summary:
            //      Loop all dgrid columns, check each is able to template column, convert each.
            // tags:
            //      private

            if (!this.subRows) {
                return;
            }

            var formatters;
            array.forEach(this.subRows, function (columns) {
                array.forEach(columns, function (column) {
                    formatters = [];

                    array.forEach(module.shorthands, function (shorthand) {
                        var formatterActive = column[shorthand],
                            formatter = module.formatters[shorthand];

                        if (formatterActive) {
                            if (formatter) {
                                // If not a bool value, execute formatterFunc with value that should be a factory method
                                formatters.push(formatter.isFactory ?
                                    formatter.handler(formatterActive) :
                                    formatter.handler);
                            } else {
                                throw new Error("Formatter with key " + shorthand + " not found");
                            }

                        }
                    });

                    // Add custom formatters
                    if (column.formatters) {
                        this._findFormatters(column.formatters, formatters);
                    }

                    if (formatters.length > 0) {
                        column = TemplateColumn(column, formatters);
                    }
                }, this);
            }, this);
        },

        _setupList: function () {
            // summary:
            //      Add configured formatters when used with dgrid list.
            // tags:
            //      private

            if (this.formatters) {
                this._resolvedFormatters = this._findFormatters(this.formatters);
            } else if (this.field) {
                this._resolvedFormatters = [function (data, object, row) {
                    return data;
                }];
            }
        },

        renderRow: function (object, options) {
            // summary:
            //      Override of default implementation to add formatter execution.
            // tags:
            //      public

            if (this._isGrid) {
                return this.inherited(arguments);
            }

            var row = this.inherited(arguments, ["", options]),
                data = this.field ? object[this.field] : object,
                formatters = this._resolvedFormatters,
                i = -1;

            function executeFormatter(value) {
                var formatter = formatters[i],
                    result;

                if (formatter) {
                    row.innerHTML = value;
                    data = value;
                }

                i++;

                if (formatters.length > i) {
                    formatter = formatters[i];
                    result = formatter(data, object, row);
                    when(result, executeFormatter);
                }
            }

            if (formatters.length > 0) {
                executeFormatter();
            }

            return row;

        },

        _findFormatters: function (formatterConfig, formatters) {
            // summary:
            //      Loops throgh an array that can consist of either formatter functions
            //      or formatter keys as strings. When a string is found it is replaced
            //      by a matching formatter function from the registered formatters.
            // tags:
            //      private

            formatters = formatters || [];

            array.forEach(formatterConfig, function (formatterKey) {
                var type = typeof formatterKey,
                    item, formatter;

                if (type === "string") {
                    item = module.formatters[formatterKey];

                    if (item) {
                        formatter = item.isFactory ? item.handler() : item.handler;
                        formatter.allParameters = item.allParameters;
                    }
                } else if (type === "function") {
                    formatter = formatterKey;
                }

                if (formatter) {
                    formatters.push(formatter);
                } else {
                    throw new Error("Formatter with key " + formatterKey + "not found");
                }
            });

            return formatters;
        }
    });

    module.formatters = {
        // tags:
        //      internal
    };
    module.shorthands = [];

    module.addFormatter = function (name, formatter, isFactory, addShortHand) {
        // summary:
        //      Adds formatter to the formatter registry.
        // tags:
        //      internal

        module.formatters[name] = { handler: formatter, isFactory: !!isFactory };
        if (addShortHand) {
            module.shorthands.push(name);
        }
    };

    return module;
});

},
'epi/shell/dgrid/TemplateColumn':function(){
﻿define("epi/shell/dgrid/TemplateColumn", [
// dojo
    "dojo/_base/array"
],
function (
// dojo
    array
) {
    return function (/*object*/column, /*array*/formatters) {
        // summary:
        //      Dgrid template column plugin
        // column: [object]
        //      Column definition
        // formatters: [array]
        //      Array of callback function(s)
        // tags:
        //      public

        var originalRenderCell = column.renderCell;

        // accept arguments as parameters to template function, or from column def,
        // but normalize to column def.
        column.formatters = formatters || column.formatters;

        if (column.formatters && column.formatters.length > 0) {
            column.renderCell = function (object, value, cell, options) {
                // Get each formatter and run it.
                array.forEach(column.formatters, function (formatter) {
                    value = formatter(value, object, cell, options);
                });

                if (value) {
                    cell.innerHTML = value;
                }
            };
        }

        // REMARK: This code will most likely fail in the case where renderCell is defined on the column,
        //         since the parameters that get passed through to the method are undefined here.
        return originalRenderCell ? originalRenderCell.call(column /* , object, value, cell, options */) : column;
    };
});

},
'epi/shell/dgrid/util/misc':function(){
require({cache:{
'url:dojox/html/resources/ellipsis.css':".dojoxEllipsis,.dojoxEllipsisShown {white-space: nowrap; width: 100%; overflow: hidden; text-overflow: ellipsis; -o-text-overflow: ellipsis; -webkit-text-overflow: ellipsis;}.dojoxEllipsis window {width:100%; -moz-user-focus:normal; -moz-user-select:text;}.dojoxEllipsis description{-moz-user-focus:normal; -moz-user-select:text;}.dojoxEllipsisIFrame{white-space: normal; border: none; width: 100%; display: block; height: 1px; margin-top: -1px; clear: both;}.dojoxEllipsisContainer{width: 100%;}.dojoxEllipsisShown:after{content: \"\\2026\"}"}});
﻿define("epi/shell/dgrid/util/misc", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    // dojox
    "dojox/html/entities",

    // EPi
    "epi/shell/dgrid/Formatter",

    // resources
    "dojo/text!dojox/html/resources/ellipsis.css"
],
function (
// dojo
    declare,
    lang,
    // dojox
    htmlEntities,
    // EPi
    Formatter,
    // resources
    ellipsisCss
) {

    var module = {
        // summary:
        //      This static module defines miscellaneous utility methods.
        // tags:
        //      public

        _attributeEncodeMap: [["&","amp"], ["\"","quot"]],

        htmlEncode: function (text) {
            // summary:
            //      Make html encode for the given value
            // text:
            //      The text you want to apply html encode
            // tags:
            //      public

            return htmlEntities.encode(text);
        },

        attributeEncode: function (text) {
            return htmlEntities.encode(text, module._attributeEncodeMap);
        },

        ellipsis: function (text, title) {
            // summary:
            //      Make ellipsis for the given text
            // text:
            //      The text you want to apply html ellipsis
            // tags:
            //      public

            if (!title || !lang.isString(title)) {
                title = text;
            }

            return lang.replace("<div class=\"dojoxEllipsis\" title=\"{0}\">{1}</div>", [title, text]);
        },

        ellipsisNoTooltip: function (text) {
            // summary:
            //      Make ellipsis for the given text
            // text:
            //      The text you want to apply html ellipsis
            // tags:
            //      public

            return lang.replace("<div class=\"dojoxEllipsis\">{0}</div>", [text]);
        },

        icon: function (icon, text) {
            // summary:
            //      Add an icon span to the front of the given text
            // text:
            //      The text you want to add an icon in front
            // tags:
            //      public

            text = text || "";

            return lang.replace("<span class=\"dijitInline dijitIcon {0}\"></span>{1}", [icon, text]);
        }
    };

    Formatter.addFormatter("htmlEncode", module.htmlEncode, false, true);
    Formatter.addFormatter("icon", function (icon) {
        return function (value) {
            return module.icon(icon, value);
        };
    }, true, true);
    Formatter.addFormatter("ellipsis", module.ellipsis, false, true);
    Formatter.addFormatter("ellipsisNoTooltip", module.ellipsisNoTooltip, false, true);

    return module;

});

},
'url:dojox/html/resources/ellipsis.css':".dojoxEllipsis,.dojoxEllipsisShown {white-space: nowrap; width: 100%; overflow: hidden; text-overflow: ellipsis; -o-text-overflow: ellipsis; -webkit-text-overflow: ellipsis;}.dojoxEllipsis window {width:100%; -moz-user-focus:normal; -moz-user-select:text;}.dojoxEllipsis description{-moz-user-focus:normal; -moz-user-select:text;}.dojoxEllipsisIFrame{white-space: normal; border: none; width: 100%; display: block; height: 1px; margin-top: -1px; clear: both;}.dojoxEllipsisContainer{width: 100%;}.dojoxEllipsisShown:after{content: \"\\2026\"}",
'epi-cms/contentediting/ContentActionSupport':function(){
﻿define([
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.versionstatus"
],

function (
// resources
    res
) {

    var versionLocalizations = {},
        actionSupport;

    if (res) {
        versionLocalizations = {
            0: res.notcreated,
            1: res.rejected,
            2: res.checkedout,
            3: res.checkedin,
            4: res.published,
            5: res.previouslypublished,
            6: res.delayedpublish,
            7: res.awaitingapproval,
            100: res.expired
        };
    }

    actionSupport = {
        // summary:
        //    This class helps dealing with the content data structure:
        //      * decode the access level mask provided by content data store
        //      * determine if an action is supported for a given version statuse
        // tags:
        //    public static

        // versionStatus: [public readonly] Object
        //      Version status codes used in contentContext.status
        versionStatus: {
            NotCreated: 0,
            Rejected: 1,
            CheckedOut: 2,
            CheckedIn: 3,
            Published: 4,
            PreviouslyPublished: 5,
            DelayedPublish: 6,
            AwaitingApproval: 7,
            Expired: 100
        },

        // versionLocalizations: [internal readonly] Object
        //      Version translations
        versionLocalizations: versionLocalizations,

        getVersionStatus: function (status) {
            return this.versionLocalizations[status];
        },

        // action: [public readonly] Object
        //      Known actions on a contentData object
        action: {
            Create: "Create",
            Edit: "Edit",
            Delete: "Delete",
            CheckIn: "CheckIn",
            Save: "Save",
            Reject: "Reject",
            Publish: "Publish",
            Administer: "Administer"
        },

        // accessLevel: [public readonly] Object
        //      Access level components of the contentContext.accessMask bitmask.
        accessLevel: {
            NoAccess: 0,
            Read: 1,
            Create: 2,
            Edit: 4,
            CheckIn: 4,
            Delete: 8,
            Publish: 16,
            Administer: 32,
            FullAccess: 63
        },

        // saveAction: [public readonly] Object
        //      Options available when saving content
        saveAction: {
            /// Do not save data.
            None: 0x0,
            /// Save a page, leaving it in a checked out state.
            Save: 0x1,
            /// Save and check in page, creating a new version only if necessary.
            CheckIn: 0x2,
            /// Publish page, creating a new version only if necessary.
            Publish: 0x3,
            /// Reject a checked-in page.
            Reject: 0x4,
            /// Sets a content instance to approval state.
            RequestApproval: 0x5,
            /// Sets a content instance in checked out/draft state.
            CheckOut: 0x6,
            /// Schedules a version for publishing.
            Schedule: 0x7,
            /// Flag that is used to force the creation of a new version.
            ForceNewVersion: 0x80,
            /// Save and check in page, always updating the current version
            ForceCurrentVersion: 0x100,
            /// Does not validate the data against <see cref:"EPiServer.Validation.IValidationService"/>
            SkipValidation: 0x200,
            /// Save and check in page, creating a new version only if necessary and sets the content as delayed publish.
            DelayedPublish: 0x400
        },

        // sortOrder: [public readonly] Object
        //      Sort order of contentData, need to verify when change
        sortOrder: {
            None: 0,
            CreatedDescending: 1,
            CreatedAscending: 2,
            Alphabetical: 3,
            Index: 4,
            ChangedDescending: 5,
            Rank: 6,
            PublishedAscending: 7,
            PublishedDescending: 8
        },

        // providerCapabilities: [public readonly] Object
        //      Capabilities bitmask of a content provider
        providerCapabilities: {
            None: 0,
            Create: 1,
            Edit: 2,
            Delete: 4,
            Move: 8,
            Copy: 16,
            MultiLanguage: 32,
            Security: 64,
            Search: 128,
            PageFolder: 256,
            Wastebasket: 512
        },


        isActionAvailable: function (contentData, actionType, providerCapabilityType, skipMissingLanguageCheck, skipLanguageAccess) {
            // summary:
            //    Returns true if the given action type is authorized and represents an allowed state transition for the given contentData context.
            //    This also checks for the capability of content provider whether is configured to allow the action.
            //    If the specified contentData has the missingLanguageBranch property set it will return false.
            // tags:
            //    public

            return actionSupport.hasAccessToAction(contentData, actionType, providerCapabilityType, skipMissingLanguageCheck, skipLanguageAccess) &&
                   actionSupport.canPerformAction(contentData, actionType);

        },

        hasAccessToAction: function (contentData, actionType, providerCapabilityType, skipMissingLanguageCheck, skipLanguageAccess) {
            // summary:
            //    Returns true if the given action type is authorized and the capability of content provider
            //    whether is configured to allow the action.
            //    If the specified contentData has the missingLanguageBranch property set it will return false.
            // tags:
            //    internal

            var access;

            if (!contentData) {
                return false;
            }

            if (!skipMissingLanguageCheck && contentData.capabilities && contentData.capabilities.language && contentData.missingLanguageBranch && contentData.missingLanguageBranch.isTranslationNeeded) {
                return false;
            }

            if (providerCapabilityType && !actionSupport.hasProviderCapability(contentData.providerCapabilityMask, providerCapabilityType)) {
                return false;
            }

            access = skipLanguageAccess ? contentData.accessRights : contentData.accessMask;

            return actionSupport.hasAccess(access, actionSupport.accessLevel[actionType]);
        },

        canPerformAction: function (contentContext, actionType) {
            // summary:
            //    Returns true if the action represents an allowed state transition.
            // tags:
            //    public

            var contentStatus = contentContext.status,
                versionStatus = actionSupport.versionStatus;

            // If the content is scheduled for published, we considered it locked for edit.
            if (contentStatus === versionStatus.DelayedPublish &&
               (actionType === actionSupport.action.Edit || actionType === actionSupport.action.Publish)) {
                return false;
            }

            if (actionType === actionSupport.action.Publish) {
                // we can publish everything that's not already published or expired
                return !(contentStatus === versionStatus.Published ||
                    contentStatus === versionStatus.Expired);
            }
            if (actionType === actionSupport.action.CheckIn) {
                // we can make "not ready" (checkedout) or rejected content "ready to publish" (checkedin)
                return contentStatus === versionStatus.CheckedOut ||
                    contentStatus === versionStatus.Rejected;
            }
            if (actionType === actionSupport.action.Edit) {
                var readonlyVersion =
                    (contentStatus === versionStatus.Published && !contentContext.isCommonDraft) ||
                    (contentStatus === versionStatus.Expired && !contentContext.isCommonDraft) ||
                    contentStatus === versionStatus.PreviouslyPublished ||
                    (contentStatus === versionStatus.CheckedIn && !contentContext.isPartOfAnotherProject) ||
                    contentStatus === versionStatus.DelayedPublish ||
                    contentStatus === versionStatus.AwaitingApproval;

                return !(readonlyVersion || contentContext.isDeleted || contentContext.isWastebasket);
            }
            return true;
        },

        hasAccess: function (accesLevelMask, requiredAccessLevel) {
            // summary:
            //    Returns true if the required access is part of the given access mask.
            //    The access mask can be accessed from a contentData context or lightweight contentData object.
            // tags:
            //    public
            return (accesLevelMask & requiredAccessLevel) === requiredAccessLevel;
        },

        hasLanguageAccess: function (item) {
            // summary:
            //      Verify the current content have access with the given language or not
            // context: Object
            //      A content data or context object
            // tags:
            //      public

            if (!item) {
                return false;
            }

            // Get the language information from either the context or the content data since we don't know what type we have.
            var language = item.languageContext || item.missingLanguageBranch || item;

            return !language || (language.hasTranslationAccess && language.isPreferredLanguageAvailable); // Boolean
        },

        getPermissionMap: function (accesLevelMask) {
            // summary:
            //    Maps the given access mask onto an object, for example:
            //    { Read:true, Edit:true, Delete:false, Publish:false, Administer:false }
            // tags:
            //    public

            var map = {};
            for (var al in actionSupport.accessLevel) {
                map[al] = actionSupport.hasAccess(accesLevelMask, actionSupport.accessLevel[al]);
            }
            return map;
        },

        hasProviderCapability: function (providerCapabilityMask, requiredCapability) {
            // summary:
            //     Returns true if the required capability is part of the given content provider capability mask.
            // tags:
            //    public

            return (providerCapabilityMask & requiredCapability) === requiredCapability;
        }
    };
    return actionSupport;
});

},
'epi-cms/widget/viewmodel/ContentStatusViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/promise/all",
    "dojo/Stateful",

    // epi
    "epi/dependency",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/_ContextMixin",
    "epi-cms/ContentLanguageHelper",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.versionstatus"
],
function (
// dojo
    array,
    declare,
    Deferred,
    lang,
    when,
    all,
    Stateful,

    // epi
    dependency,
    ContentActionSupport,
    _ContextMixin,
    ContentLanguageHelper,

    // resources
    versionStatusResources
) {

    return declare([Stateful, _ContextMixin], {
        // tags:
        //      internal

        _contentStructureStore: null,

        // autoLoadStatus: [Boolean]
        //      Set it to true of the status information should be automatically loaded when the contentLink is set
        // tags:
        //      public
        autoLoadStatus: false,

        // statusIcon: [String]
        //      Store content status icon classes
        // tags:
        //      public
        statusIcon: null,

        // statusMessage: [Object]
        //      Store content status message.
        //      Can be [String] or [Array] data type.
        // tags:
        //      public
        statusMessage: null,

        // contentLink: [String]
        //      The content link.
        // tags:
        //      public
        contentLink: null,

        constructor: function () {
            this._statusIconMap = {
                // Not created icon CSS classes
                0: ["epi-statusIndicatorIcon", "epi-statusIndicator0"],
                // Rejected icon CSS classes
                1: ["epi-statusIndicatorIcon", "epi-statusIndicator1"],
                // Checked-out icon CSS classes
                2: ["epi-statusIndicatorIcon", "epi-statusIndicator2"],
                // Checked-in icon CSS classes
                3: ["epi-statusIndicatorIcon", "epi-statusIndicator3"],
                // Published icon CSS classes
                4: ["epi-statusIndicatorIcon", "epi-statusIndicator4"],
                // Previously published icon CSS classes
                5: ["epi-statusIndicatorIcon", "epi-statusIndicator5"],
                // Delayed publish icon CSS classes
                6: ["epi-statusIndicatorIcon", "epi-statusIndicator6"],
                // Awaiting approval icon CSS classes
                7: ["epi-statusIndicatorIcon", "epi-statusIndicator7"],
                // Expired icon CSS classes
                100: ["epi-statusIndicatorIcon", "epi-statusIndicator100"]
            };

            this._statusMessageMap = {
                // Not created message
                0: versionStatusResources.notcreated,
                // Rejected message
                1: versionStatusResources.rejected,
                // Checked-out message
                2: versionStatusResources.checkedout,
                // Checked-in message
                3: versionStatusResources.checkedin,
                // Published message
                4: versionStatusResources.published,
                // Previously published message
                5: versionStatusResources.previouslypublished,
                // Delayed publish message
                6: versionStatusResources.delayedpublish,
                // Awaiting approval
                7: versionStatusResources.awaitingapproval,
                // Expired message
                100: versionStatusResources.expired
            };
        },

        postscript: function () {
            this.inherited(arguments);

            this._contentStructureStore = this._contentStructureStore || dependency.resolve("epi.storeregistry").get("epi.cms.content.light");
        },

        loadStatus: function () {
            // summary:
            //      Loads the status for the current contentLink
            // tags:
            //      public
            if (!this.contentLink) {
                return;
            }
            when(this.getCurrentContext(), lang.hitch(this, function (ctx) {
                //- Using refresh instead get function to load content link
                //- Do not want use cache in this case
                when(this._contentStructureStore.refresh(this.contentLink), lang.hitch(this, function (contentInfo) {
                    if (contentInfo && contentInfo.status !== undefined) {
                        this.set("content", contentInfo);
                    }
                }));
            }));
        },

        _contentLinkSetter: function (/* String */contentLink) {
            // summary:
            //      Content Link setter
            // contentLink: [String]

            if (!contentLink) {
                return;
            }

            this.contentLink = contentLink;

            if (this.autoLoadStatus) {
                this.loadStatus();
            }
        },

        _isDeletedGetter: function () {
            return this.get("content") && this.get("content").isDeleted;
        },

        _isTranslationNeededGetter: function () {
            return this.get("content") && this.get("content").missingLanguageBranch && this.get("content").missingLanguageBranch.isTranslationNeeded;
        },

        _missingLanguageBranchGetter: function () {
            return this.get("content") && this.get("content").missingLanguageBranch;
        },

        _contentSetter: function (content) {
            this.content = content;

            this.set("contentStatus", content.status);
        },

        _contentStatusSetter: function (status) {
            this.contentStatus = status;

            if (!status) {
                return;
            }

            this.set("statusIcon", this._statusIconMap[status]);

            return when(this._getStatusMessage(), lang.hitch(this, function (message) {
                return this.set("statusMessage", message);
            }));
        },

        _getStatusMessage: function () {
            // summary:
            //      Get content version status message.
            //      Override this function to customize content status message.
            // tags:
            //      protected

            //If the content is deleted return version not found
            if (this.get("isDeleted")) {
                return versionStatusResources.versionnotfound;
            }
            if (this.get("isTranslationNeeded")) {
                return ContentLanguageHelper.getMissingLanguageMessage(this.content);
            }

            if (this.get("isVisibleOnSite")) {
                return null;
            }
            return this._statusMessageMap[this.get("contentStatus")];
        },

        _isVisibleOnSiteGetter: function () {
            // summary:
            //      Allow create additional information area or not.
            //      Based on content version status.
            // status: [Integer]
            //      Content status
            // tags:
            //      public

            var missingLanguageBranch = this.get("missingLanguageBranch");
            if (this.get("isDeleted") || missingLanguageBranch && missingLanguageBranch.reason === 6) {
                return false;
            }

            return this.get("contentStatus") === ContentActionSupport.versionStatus.Published;
        }
    });
});

},
'epi-cms/ContentLanguageHelper':function(){
define("epi-cms/ContentLanguageHelper", [
    "dojo/_base/lang",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/promise/all",

    "epi/dependency",
    "epi/shell/TypeDescriptorManager"
], function (lang, declare, Deferred, all, dependency, TypeDescriptorManager) {

    return {
        // summary:
        //      Helper methods for working with content languages
        //
        // tags:
        //      internal

        getMissingLanguageMessage: function (contentItem) {
            // summary:
            //      Gets a user friendly message explaining why the language is missing
            // contentItem: Object
            //      The content item to read the missing language information from
            // tags:
            //      public

            if (!contentItem || !contentItem.missingLanguageBranch) {
                return "";
            }

            this._languageStore = this._languageStore || dependency.resolve("epi.storeregistry").get("epi.cms.language");

            var def = new Deferred();

            var missingLanguageBranch = contentItem.missingLanguageBranch;

            all([this._languageStore.get(missingLanguageBranch.preferredLanguage),
                this._languageStore.get(missingLanguageBranch.language)
            ]).then(lang.hitch(this, function (languages) {

                var reason = missingLanguageBranch.reason;
                var resourceKey = "languagenotifications.";
                if (reason === 6) {
                    // None
                    resourceKey += "missing";
                } else if (reason === 3 || reason === 5) {
                    //Replacement or ReplacementFallback
                    resourceKey += "replacement";
                } else if (reason === 4) {
                    //Fallback
                    resourceKey += "fallback";
                }

                var resourceValue = TypeDescriptorManager.getResourceValue(contentItem.typeIdentifier, resourceKey);
                resourceValue = lang.replace(resourceValue, [languages[0].name, languages[1].name]);

                def.resolve(resourceValue);

            }), function () {
                def.resolve("");
            });
            return def;
        }
    };
});

},
'epi-cms/widget/_ContentTreeNode':function(){
﻿define([
// dojo
    "dojo/_base/declare",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/string",

    // dijit
    "dijit/Tree",
    "dijit/_TemplatedMixin",
    // dojox
    "dojox/html/ellipsis",
    // epi
    "epi-cms/widget/_ContentTreeNodeMixin",
    // template
    "dojo/text!./templates/_ContentTreeNode.html"
],

function (
// dojo
    declare,
    domClass,
    domConstruct,
    string,

    // dijit
    Tree,
    _TemplatedMixin,
    // dojox
    htmlEllipsis,
    // epi
    _ContentTreeNodeMixin,
    // template
    templateString
) {

    return declare([Tree._TreeNode, _TemplatedMixin, _ContentTreeNodeMixin], {
        // summary:
        //      A customized treenode for page tree
        // description:
        //      Redefine template string. Use <a> tag to be able to drag in IE
        // tags:
        //      internal

        templateString: templateString,

        buildRendering: function () {
            this.inherited(arguments);

            domClass.add(this.labelNode, "dojoxEllipsis");
        },

        _setItemAttr: function (item) {

            this._set("item", item);
            this.set("dndData", item);

            if (item && item.thumbnailUrl) {
                var image = domConstruct.create("img", {
                    src: item.thumbnailUrl + string.substitute("?${0}", [new Date().getTime()]),
                    "class": "epi-thumbnail"
                });
                this.thumbnailNode.appendChild(image);
                domClass.add(this.contentNode, "epi-mediaContent");
            }

            this.inherited(arguments);
        }

    });

});

},
'dojox/html/ellipsis':function(){
define("dojox/html/ellipsis",["dojo/_base/kernel", "dojo/_base/lang", "dojo/_base/array", "dojo/_base/Color", "dojo/colors"], function(d){
	/*=====
	return {
		// summary:
		//		offers cross-browser support for text-overflow: ellipsis
		// description:
		//		Add "dojoxEllipsis" on any node that you want to ellipsis-ize. In order to function properly,
		//		the node with the dojoxEllipsis class set on it should be a child of a node with a defined width.
		//		It should also be a block-level element (i.e. `<div>`) - it will not work on td elements.
		//		NOTE: When using the dojoxEllipsis class within tables, the table needs to have the table-layout: fixed style
	};
	=====*/
	
	if(d.isFF < 7){ //TODO: feature detect text-overflow in computed style?
		// The delay (in ms) to wait so that we don't keep querying when many
		// changes happen at once - set config "dojoxFFEllipsisDelay" if you
		// want a different value
		var delay = 1;
		if("dojoxFFEllipsisDelay" in d.config){
			delay = Number(d.config.dojoxFFEllipsisDelay);
			if(isNaN(delay)){
				delay = 1;
			}
		}
		try{
			var createXULEllipsis = (function(){
				// Create our stub XUL elements for cloning later
				// NOTE: this no longer works as of FF 4.0:
				// https://developer.mozilla.org/En/Firefox_4_for_developers#Remote_XUL_support_removed
				var sNS = 'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul';
				var xml = document.createElementNS(sNS, 'window');
				var label = document.createElementNS(sNS, 'description');
				label.setAttribute('crop', 'end');
				xml.appendChild(label);

				return function(/* Node */ n){
					// Summary:
					//		Given a node, it creates the XUL and sets its
					//		content so that it will have an ellipsis
					var x = xml.cloneNode(true);
					x.firstChild.setAttribute('value', n.textContent);
					n.innerHTML = '';
					n.appendChild(x);
				};
			})();
		}catch(e){}
		
		// Create our iframe elements for cloning later
		var create = d.create;
		var dd = d.doc;
		var dp = d.place;
		var iFrame = create("iframe", {className: "dojoxEllipsisIFrame",
					src: "javascript:'<html><head><script>if(\"loadFirebugConsole\" in window){window.loadFirebugConsole();}</script></head><body></body></html>'", style: {display: "none"}});
		var rollRange = function(/* W3C Range */ r, /* int? */ cnt){
			// summary:
			//		Rolls the given range back one character from the end
			// r: W3C Range
			//		The range to roll back
			// cnt: int?
			//		An optional number of times to roll back (defaults 1)
			if(r.collapsed){
				// Do nothing - we are already collapsed
				return;
			}
			if(cnt > 0){
				do{
					rollRange(r);
					cnt--;
				}while(cnt);
				return;
			}
			if(r.endContainer.nodeType == 3 && r.endOffset > 0){
				r.setEnd(r.endContainer, r.endOffset - 1);
			}else if(r.endContainer.nodeType == 3){
				r.setEndBefore(r.endContainer);
				rollRange(r);
				return;
			}else if(r.endOffset && r.endContainer.childNodes.length >= r.endOffset){
				var nCont = r.endContainer.childNodes[r.endOffset - 1];
				if(nCont.nodeType == 3){
					r.setEnd(nCont, nCont.length - 1);
				}else if(nCont.childNodes.length){
					r.setEnd(nCont, nCont.childNodes.length);
					rollRange(r);
					return;
				}else{
					r.setEndBefore(nCont);
					rollRange(r);
					return;
				}
			}else{
				r.setEndBefore(r.endContainer);
				rollRange(r);
				return;
			}
		};
		var createIFrameEllipsis = function(/* Node */ n){
			// summary:
			//		Given a node, it creates an iframe and and ellipsis div and
			//		sets up the connections so that they will work correctly.
			//		This function is used when createXULEllipsis is not able
			//		to be used (because there is markup within the node) - it's
			//		a bit slower, but does the trick
			var c = create("div", {className: "dojoxEllipsisContainer"});
			var e = create("div", {className: "dojoxEllipsisShown", style: {display: "none"}});
			n.parentNode.replaceChild(c, n);
			c.appendChild(n);
			c.appendChild(e);
			var i = iFrame.cloneNode(true);
			var ns = n.style;
			var es = e.style;
			var ranges;
			var resizeNode = function(){
				ns.display = "";
				es.display = "none";
				if(n.scrollWidth <= n.offsetWidth){ return; }
				var r = dd.createRange();
				r.selectNodeContents(n);
				ns.display = "none";
				es.display = "";
				var done = false;
				do{
					var numRolls = 1;
					dp(r.cloneContents(), e, "only");
					var sw = e.scrollWidth, ow = e.offsetWidth;
					done = (sw <= ow);
					var pct = (1 - ((ow * 1) / sw));
					if(pct > 0){
						numRolls = Math.max(Math.round(e.textContent.length * pct) - 1, 1);
					}
					rollRange(r, numRolls);
				}while(!r.collapsed && !done);
			};
			i.onload = function(){
				i.contentWindow.onresize = resizeNode;
				resizeNode();
			};
			c.appendChild(i);
		};

		// Function for updating the ellipsis
		var hc = d.hasClass;
		var doc = d.doc;
		var s, fn, opt;
		if(doc.querySelectorAll){
			s = doc;
			fn = "querySelectorAll";
			opt = ".dojoxEllipsis";
		}else if(doc.getElementsByClassName){
			s = doc;
			fn = "getElementsByClassName";
			opt = "dojoxEllipsis";
		}else{
			s = d;
			fn = "query";
			opt = ".dojoxEllipsis";
		}
		fx = function(){
			d.forEach(s[fn].apply(s, [opt]), function(n){
				if(!n || n._djx_ellipsis_done){ return; }
				n._djx_ellipsis_done = true;
				if(createXULEllipsis && n.textContent == n.innerHTML && !hc(n, "dojoxEllipsisSelectable")){
					// We can do the faster XUL version, instead of calculating
					createXULEllipsis(n);
				}else{
					createIFrameEllipsis(n);
				}
			});
		};
		
		d.addOnLoad(function(){
			// Apply our initial stuff
			var t = null;
			var c = null;
			var connFx = function(){
				if(c){
					// disconnect us - so we don't fire anymore
					d.disconnect(c);
					c = null;
				}
				if(t){ clearTimeout(t); }
				t = setTimeout(function(){
					t = null;
					fx();
					// Connect to the modified function so that we can catch
					// our next change
					c = d.connect(d.body(), "DOMSubtreeModified", connFx);
				}, delay);
			};
			connFx();
		});
	}
});

},
'dojo/colors':function(){
define("dojo/colors", ["./_base/kernel", "./_base/lang", "./_base/Color", "./_base/array"], function(dojo, lang, Color, ArrayUtil){
	// module:
	//		dojo/colors

	/*=====
	return {
		// summary:
		//		Color utilities, extending Base dojo.Color
	};
	=====*/

	var ColorExt = {};
	lang.setObject("dojo.colors", ColorExt);

//TODO: this module appears to break naming conventions

	// this is a standard conversion prescribed by the CSS3 Color Module
	var hue2rgb = function(m1, m2, h){
		if(h < 0){ ++h; }
		if(h > 1){ --h; }
		var h6 = 6 * h;
		if(h6 < 1){ return m1 + (m2 - m1) * h6; }
		if(2 * h < 1){ return m2; }
		if(3 * h < 2){ return m1 + (m2 - m1) * (2 / 3 - h) * 6; }
		return m1;
	};
	// Override base Color.fromRgb with the impl in this module
	dojo.colorFromRgb = Color.fromRgb = function(/*String*/ color, /*dojo/_base/Color?*/ obj){
		// summary:
		//		get rgb(a) array from css-style color declarations
		// description:
		//		this function can handle all 4 CSS3 Color Module formats: rgb,
		//		rgba, hsl, hsla, including rgb(a) with percentage values.
		var m = color.toLowerCase().match(/^(rgba?|hsla?)\(([\s\.\-,%0-9]+)\)/);
		if(m){
			var c = m[2].split(/\s*,\s*/), l = c.length, t = m[1], a;
			if((t == "rgb" && l == 3) || (t == "rgba" && l == 4)){
				var r = c[0];
				if(r.charAt(r.length - 1) == "%"){
					// 3 rgb percentage values
					a = ArrayUtil.map(c, function(x){
						return parseFloat(x) * 2.56;
					});
					if(l == 4){ a[3] = c[3]; }
					return Color.fromArray(a, obj); // dojo/_base/Color
				}
				return Color.fromArray(c, obj); // dojo/_base/Color
			}
			if((t == "hsl" && l == 3) || (t == "hsla" && l == 4)){
				// normalize hsl values
				var H = ((parseFloat(c[0]) % 360) + 360) % 360 / 360,
					S = parseFloat(c[1]) / 100,
					L = parseFloat(c[2]) / 100,
					// calculate rgb according to the algorithm
					// recommended by the CSS3 Color Module
					m2 = L <= 0.5 ? L * (S + 1) : L + S - L * S,
					m1 = 2 * L - m2;
				a = [
					hue2rgb(m1, m2, H + 1 / 3) * 256,
					hue2rgb(m1, m2, H) * 256,
					hue2rgb(m1, m2, H - 1 / 3) * 256,
					1
				];
				if(l == 4){ a[3] = c[3]; }
				return Color.fromArray(a, obj); // dojo/_base/Color
			}
		}
		return null;	// dojo/_base/Color
	};

	var confine = function(c, low, high){
		// summary:
		//		sanitize a color component by making sure it is a number,
		//		and clamping it to valid values
		c = Number(c);
		return isNaN(c) ? high : c < low ? low : c > high ? high : c;	// Number
	};

	Color.prototype.sanitize = function(){
		// summary:
		//		makes sure that the object has correct attributes
		var t = this;
		t.r = Math.round(confine(t.r, 0, 255));
		t.g = Math.round(confine(t.g, 0, 255));
		t.b = Math.round(confine(t.b, 0, 255));
		t.a = confine(t.a, 0, 1);
		return this;	// dojo/_base/Color
	};

	ColorExt.makeGrey = Color.makeGrey = function(/*Number*/ g, /*Number?*/ a){
		// summary:
		//		creates a greyscale color with an optional alpha
		return Color.fromArray([g, g, g, a]);	// dojo/_base/Color
	};

	// mixin all CSS3 named colors not already in _base, along with SVG 1.0 variant spellings
	lang.mixin(Color.named, {
		"aliceblue":	[240,248,255],
		"antiquewhite": [250,235,215],
		"aquamarine":	[127,255,212],
		"azure":	[240,255,255],
		"beige":	[245,245,220],
		"bisque":	[255,228,196],
		"blanchedalmond":	[255,235,205],
		"blueviolet":	[138,43,226],
		"brown":	[165,42,42],
		"burlywood":	[222,184,135],
		"cadetblue":	[95,158,160],
		"chartreuse":	[127,255,0],
		"chocolate":	[210,105,30],
		"coral":	[255,127,80],
		"cornflowerblue":	[100,149,237],
		"cornsilk": [255,248,220],
		"crimson":	[220,20,60],
		"cyan": [0,255,255],
		"darkblue": [0,0,139],
		"darkcyan": [0,139,139],
		"darkgoldenrod":	[184,134,11],
		"darkgray": [169,169,169],
		"darkgreen":	[0,100,0],
		"darkgrey": [169,169,169],
		"darkkhaki":	[189,183,107],
		"darkmagenta":	[139,0,139],
		"darkolivegreen":	[85,107,47],
		"darkorange":	[255,140,0],
		"darkorchid":	[153,50,204],
		"darkred":	[139,0,0],
		"darksalmon":	[233,150,122],
		"darkseagreen": [143,188,143],
		"darkslateblue":	[72,61,139],
		"darkslategray":	[47,79,79],
		"darkslategrey":	[47,79,79],
		"darkturquoise":	[0,206,209],
		"darkviolet":	[148,0,211],
		"deeppink": [255,20,147],
		"deepskyblue":	[0,191,255],
		"dimgray":	[105,105,105],
		"dimgrey":	[105,105,105],
		"dodgerblue":	[30,144,255],
		"firebrick":	[178,34,34],
		"floralwhite":	[255,250,240],
		"forestgreen":	[34,139,34],
		"gainsboro":	[220,220,220],
		"ghostwhite":	[248,248,255],
		"gold": [255,215,0],
		"goldenrod":	[218,165,32],
		"greenyellow":	[173,255,47],
		"grey": [128,128,128],
		"honeydew": [240,255,240],
		"hotpink":	[255,105,180],
		"indianred":	[205,92,92],
		"indigo":	[75,0,130],
		"ivory":	[255,255,240],
		"khaki":	[240,230,140],
		"lavender": [230,230,250],
		"lavenderblush":	[255,240,245],
		"lawngreen":	[124,252,0],
		"lemonchiffon": [255,250,205],
		"lightblue":	[173,216,230],
		"lightcoral":	[240,128,128],
		"lightcyan":	[224,255,255],
		"lightgoldenrodyellow": [250,250,210],
		"lightgray":	[211,211,211],
		"lightgreen":	[144,238,144],
		"lightgrey":	[211,211,211],
		"lightpink":	[255,182,193],
		"lightsalmon":	[255,160,122],
		"lightseagreen":	[32,178,170],
		"lightskyblue": [135,206,250],
		"lightslategray":	[119,136,153],
		"lightslategrey":	[119,136,153],
		"lightsteelblue":	[176,196,222],
		"lightyellow":	[255,255,224],
		"limegreen":	[50,205,50],
		"linen":	[250,240,230],
		"magenta":	[255,0,255],
		"mediumaquamarine": [102,205,170],
		"mediumblue":	[0,0,205],
		"mediumorchid": [186,85,211],
		"mediumpurple": [147,112,219],
		"mediumseagreen":	[60,179,113],
		"mediumslateblue":	[123,104,238],
		"mediumspringgreen":	[0,250,154],
		"mediumturquoise":	[72,209,204],
		"mediumvioletred":	[199,21,133],
		"midnightblue": [25,25,112],
		"mintcream":	[245,255,250],
		"mistyrose":	[255,228,225],
		"moccasin": [255,228,181],
		"navajowhite":	[255,222,173],
		"oldlace":	[253,245,230],
		"olivedrab":	[107,142,35],
		"orange":	[255,165,0],
		"orangered":	[255,69,0],
		"orchid":	[218,112,214],
		"palegoldenrod":	[238,232,170],
		"palegreen":	[152,251,152],
		"paleturquoise":	[175,238,238],
		"palevioletred":	[219,112,147],
		"papayawhip":	[255,239,213],
		"peachpuff":	[255,218,185],
		"peru": [205,133,63],
		"pink": [255,192,203],
		"plum": [221,160,221],
		"powderblue":	[176,224,230],
		"rosybrown":	[188,143,143],
		"royalblue":	[65,105,225],
		"saddlebrown":	[139,69,19],
		"salmon":	[250,128,114],
		"sandybrown":	[244,164,96],
		"seagreen": [46,139,87],
		"seashell": [255,245,238],
		"sienna":	[160,82,45],
		"skyblue":	[135,206,235],
		"slateblue":	[106,90,205],
		"slategray":	[112,128,144],
		"slategrey":	[112,128,144],
		"snow": [255,250,250],
		"springgreen":	[0,255,127],
		"steelblue":	[70,130,180],
		"tan":	[210,180,140],
		"thistle":	[216,191,216],
		"tomato":	[255,99,71],
		"turquoise":	[64,224,208],
		"violet":	[238,130,238],
		"wheat":	[245,222,179],
		"whitesmoke":	[245,245,245],
		"yellowgreen":	[154,205,50]
	});

	return Color;	// TODO: return ColorExt, not Color
});

},
'epi-cms/widget/_ContentTreeNodeMixin':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",

    "epi-cms/ContentLanguageHelper"
],

function (
    declare,
    lang,
    when,

    domAttr,
    domClass,
    domConstruct,

    ContentLanguageHelper
) {

    return declare(null, {
        // summary:
        //      Stubs to handler common functions for tree
        // tags:
        //      internal mixin

        _missingLanguageCssClass: "epi-ct-missingLanguageRow",

        // =======================================================================
        // Protected overridden functions

        _updateItemClasses: function (/*Item*/item) {
            // summary:
            //      Override dijit/_TreeNode._updateItemClasses function
            //
            //      Set appropriate CSS classes for icon and label dom node
            //      (used to allow for item updates to change respective CSS)
            // tags:
            //      protected, override

            this.inherited(arguments);

            this._updateLayout();
        },

        _updateLayout: function () {
            // summary:
            //      Override dijit/_TreeNode._updateLayout function
            //
            //      Set appropriate CSS classes for this.domNode
            // tags:
            //      protected, override

            this.inherited(arguments);

            this._updateLanguageIndicator();
            this._updateIndividualLayout();
        },

        // =======================================================================
        // Protected functions

        _updateIndividualLayout: function () {
            // summary:
            //      Update tree node layout for individual case
            // tags:
            //      protected, extension
        },

        _addLanguageIndicatorForItem: function (item) {
            // summary:
            //      Setup missing language branch indicator UI for item parameter
            // item: [Object]
            //      Content item
            // tags:
            //      protected

            var missingLanguageBranch = this.item.missingLanguageBranch;

            if (this.iconNodeLanguage) {
                this.iconNodeLanguage.innerHTML = missingLanguageBranch.language || "";
                when(ContentLanguageHelper.getMissingLanguageMessage(item), lang.hitch(this, function (message) {
                    domAttr.set(this.iconNodeLanguage, "title", message || "");
                }));
            }

            domClass.add(this.rowNode, this._missingLanguageCssClass);
        },

        _addLanguageIndicator: function () {
            // summary:
            //      Setup missing language branch indicator UI
            // tags:
            //      protected

            this._addLanguageIndicatorForItem(this.item);
        },

        _removeLanguageIndicator: function () {
            // summary:
            //      Remove all settings for language indicator
            // tags:
            //      protected

            if (this.iconNodeLanguage) {
                domConstruct.empty(this.iconNodeLanguage);
                domAttr.remove(this.iconNodeLanguage, "title");
            }
            domClass.remove(this.rowNode, this._missingLanguageCssClass);
        },

        _updateLanguageIndicator: function () {
            // summary:
            //      Set language indicator for the tree node
            // tags:
            //      protected

            if (this.item.missingLanguageBranch) {
                this._addLanguageIndicator();
            } else {
                this._removeLanguageIndicator();
            }

        },

        _isTypeOfRoot: function () {
            // summary:
            //      Verifies the current tree node item data object is type of root or not
            // returns: [Boolean]
            // tags:
            //      protected

            if (!this.tree.model || typeof this.tree.model.isTypeOfRoot !== "function") {
                return false;
            }

            return this.tree.model.isTypeOfRoot(this.item);
        }

    });

});

},
'url:epi-cms/widget/templates/_ContentTreeNode.html':"﻿<div class=\"dijitTreeNode\" role=\"presentation\">\r\n    <a href=\"#\" tabindex=\"-1\" data-dojo-attach-point=\"rowNode\" class=\"dijitTreeRow\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"thumbnailNode\" class=\"epi-thumbnailIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNodeLanguage\" class=\"epi-extraIcon epi-pt-currentLanguageMissing\" role=\"presentation\"></span>\r\n            </span>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n        </span>\r\n    </a>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>\r\n",
'epi-cms/widget/ContentTreeModelConfirmation':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/string",
    "dojo/when",
    "dojo/_base/json",

    // dojox
    "dojox/html/entities",

    // epi
    "epi/dependency",
    "epi/string",

    "epi/shell/TypeDescriptorManager",
    "epi/shell/DialogService",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/sharedContentDialogHandler",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.pagetree",
    "epi/i18n!epi/cms/nls/episerver.cms.components.project"
],

function (
// dojo
    declare,
    lang,

    aspect,
    Deferred,
    string,
    when,
    json,

    // dojox
    htmlEntities,

    // epi
    dependency,
    epistring,

    TypeDescriptorManager,
    dialogService,

    ContentActionSupport,
    sharedContentDialogHandler,
    res,
    projectResources
) {

    return function (model) {
        // summary:
        //      Attaches confirmation to the pasteItem method of a dijit/tree.model instance.
        //      Looks at the paste parameters to show a confirmation before delting or moving items.
        //
        // tags:
        //      internal xproduct

        // NOTE: This pattern isn't really that nice, since it alters the aspect.around actually alters the underlying store.
        //      It's probably a better idea to use delegation, but that requires us to -implement set() and _set() to get
        //      model property changes updated on the underlying model and not the delegating facade.

        var _isFunction = function (object) {
            return object && typeof object == "function";
        };

        var _showNotification = function (message, callback) {
            // summary:
            //      Uses the alert dialog implementation to notify with the supplied message
            dialogService.alert(epistring.toHTML(message))
                .then(function () {
                    if (_isFunction(callback)) {
                        callback();
                    }
                });
        };

        var _showConfirmation = function (title, confirmationMessage) {
            // summary:
            //      Wrap epi/shell/widget/dialog/Confirmation for short type
            //      and return deferred object
            // confirmQuestion:
            //      String / Deferred : Text to display on dialog
            // tags:
            //		private

            return when(confirmationMessage).then(function (message) {
                return dialogService.confirmation({
                    description: epistring.toHTML(message),
                    title: title
                });
            });
        };

        var onResponse = function (result, callback) {
            // Checks the result of a call to pasteItem and shows error messages if result indicates a failure
            when(result,
                function (serverResponse) {
                    if (serverResponse && (serverResponse.message || serverResponse.statusDescription)) {
                        var message = serverResponse.message || serverResponse.statusDescription;
                        _showNotification(message, callback);
                    } else {
                        if (_isFunction(callback)) {
                            callback();
                        }
                    }
                },
                function (e) {
                    _showNotification(htmlEntities.encode(json.fromJson(e.xhr.responseText)));
                });
            return result;
        };

        var pasteItems = function (sourceItems, newParent, copy, sortIndex, originalMethod, originalArguments) {
            var source = sourceItems[0],
                localizationPrefix = sourceItems.length > 1 ? "move.multiple." : "move.single.";

            // If there are more than one type of content in the source array we fallback back
            // to the icontentdata typeIdentifier
            var typeIdentifier = sourceItems.every(function (element) {
                return element.typeIdentifier === source.typeIdentifier;
            }) ? source.typeIdentifier : "episerver.core.icontentdata";


            var moveTitle = TypeDescriptorManager.getResourceValue(typeIdentifier, localizationPrefix + "title");
            // Defaulting confirmation to an affirmative response in case we don't need a confirmation
            var confirmation = null;

            if (newParent.isWastebasket) {
                confirmation = sharedContentDialogHandler({ contentItems: sourceItems });
            } else if (sortIndex !== undefined && (newParent.properties.pageChildOrderRule !== ContentActionSupport.sortOrder.Index)) {

                // Page is copied/moved and sorted and the new parent sorting rule must be changed
                var message, title;
                if (copy) {
                    localizationPrefix = sourceItems.length > 1 ? "copy.multiple." : "copy.single.";
                    title = TypeDescriptorManager.getResourceValue(typeIdentifier, localizationPrefix + "title");
                    message = string.substitute(res.changepeerorderconfirmationcopy, [model.getLabel(newParent)]);
                } else {
                    // move
                    title = moveTitle;
                    message = string.substitute(res.changepeerorderconfirmation, [model.getLabel(newParent)]);
                }
                confirmation = _showConfirmation(title, message);
            } else if (!copy) {
                if (sourceItems.some(function (item) {
                    return !model.canCut(item);
                })) {
                    _showNotification(TypeDescriptorManager.getResourceValue(typeIdentifier, "moverequiresdeleteaccess"), function () {
                        return false;
                    });
                    return false;
                }

                var formatTemplate = "{0}<br/><br/>{1}",
                    confirmationText = lang.replace(TypeDescriptorManager.getResourceValue(typeIdentifier, localizationPrefix + "confirmation"), [sourceItems.length]),
                    description = lang.replace(formatTemplate, [
                        confirmationText,
                        TypeDescriptorManager.getResourceValue(typeIdentifier, "movedescription")
                    ]);

                var projectService = dependency.resolve("epi.cms.ProjectService");
                if (projectService.isProjectModeEnabled) {
                    description = lang.replace(formatTemplate, [description, projectResources.moveconfirmation]);
                }

                // Plain move
                confirmation = _showConfirmation(moveTitle, description);

            } else if (!model.canCopy(source)) {
                _showNotification(TypeDescriptorManager.getResourceValue(typeIdentifier, "copynotsupported"));
                return false;
            }

            return when(confirmation, function () {
                // Call pasteItem of the model
                return originalMethod.apply(model, originalArguments);
            }, function () {
                return false;
            });
        };

        aspect.around(model, "pasteItem", function (originalMethod) {
            return function (source, oldParent, newParent, copy, sortIndex) {
                return pasteItems([source], newParent, copy, sortIndex, originalMethod, arguments);
            };
        });

        aspect.around(model, "pasteItems", function (originalMethod) {
            return function (sourceItems, newParent, copy, sortIndex) {
                return pasteItems(sourceItems, newParent, copy, sortIndex, originalMethod, arguments);
            };
        });

        aspect.after(model, "pasteItem", function (result) {
            return result && onResponse(result);
        });

        aspect.after(model, "remove", function (result) {
            return result && onResponse(result);
        });

        return model;
    };

});

},
'epi-cms/widget/sharedContentDialogHandler':function(){
﻿define([
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojox/html/entities",
    "epi",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/dialog/Dialog",
    "epi/shell/widget/DelayableStandby",
    "epi-cms/widget/ContentReferences",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentreferences"
], function (
    lang,
    Deferred,
    entities,
    epi,
    TypeDescriptorManager,
    Dialog,
    Standby,
    ContentReferences,
    // Resources
    resources
) {

    var handler = function (settings) {
        // tags:
        //      internal

        var deferred = new Deferred(),
            contentItems = settings.contentItems,
            contentData = contentItems[0],
            standby = new Standby({ target: document.body, zIndex: 999 }).placeAt(document.body);

        // Display a the standby widget in case the content references takes a long time to query the store.
        standby.show(50, 0);

        var mode = settings.mode || handler.mode.confirm,
            isConfirm = mode === handler.mode.confirm,
            content = new ContentReferences({
                contentItems: contentItems,
                mode: mode
            });

        var watch = content.watch("numberOfReferences", function (propertyName, oldValue, newValue) {

            // Remove the watch so we don't leak memory or create additional dialogs on refresh.
            watch.remove();

            var isSingleItem = contentItems.length === 1;
            var description;
            var descriptionResourceKey = isSingleItem ? "movetotrashsingleitemdescription" : "movetotrashdescription";

            if (isConfirm) {
                // The description is determined by whether the content being deleted has children.
                description = TypeDescriptorManager.getResourceValue(contentData.typeIdentifier, descriptionResourceKey);
                description = lang.replace(description, [isSingleItem ? entities.encode(contentData.name) : contentItems.length]);

            } else {
                description = TypeDescriptorManager.getResourceValue(contentData.typeIdentifier, "referencesdescription");
                description = lang.replace(description, [entities.encode(contentData.name)]);
            }

            // If not passed with settings, then the heading is determined by the dialog mode.
            var title = settings.title;
            if (!title) {
                var translationKey = isConfirm ? (isSingleItem ? "movetotrashsingleitem" : "movetotrash") : "references";
                title = TypeDescriptorManager.getResourceValue(contentData.typeIdentifier, translationKey);
            }

            var dialog = new Dialog({
                focusActionsOnLoad: true,
                defaultActionsVisible: isConfirm,
                dialogClass: "epi-dialog-contentReferences",
                title: title,
                description: description,
                cancelActionText: epi.resources.action.cancel,
                confirmActionText: newValue === 0 ? resources.buttons.movetotrash : resources.buttons.movetotrashanyway,
                setFocusOnConfirmButton: newValue === 0
            });

            if (!isConfirm) {
                dialog.definitionConsumer.add({
                    name: "close",
                    label: epi.resources.action.close,
                    action: dialog.onCancel
                });
            }

            dialog.connect(dialog, "onExecute", deferred.resolve);
            dialog.connect(dialog, "onCancel", deferred.cancel);

            dialog.set("content", content);

            // Hide the dialog when a reference is viewed.
            var handle = content.on("viewReference", function () {
                dialog.hide();
                handle.remove();
            });

            standby.hide();

            // Show the dialog when the content is ready
            var refreshHandle = content.grid.on("dgrid-refresh-complete", function () {
                refreshHandle.remove();
                dialog.show();
            }.bind(this));
        });

        content.startup();

        return deferred.promise;
    };

    handler.mode = {
        // tags:
        //      internal
        confirm: "confirm",
        show: "show"
    };

    return handler;
});

},
'epi/shell/widget/DelayableStandby':function(){
define("epi/shell/widget/DelayableStandby", [
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/widget/Standby"
],

function (
// Dojo
    declare,
    lang,
    Standby
) {

    return declare([Standby], {
        // summary:
        //    Represent a Standby widget, which would be display in a delay time.
        //
        // tags:
        //    internal xproduct

        // delayTime: [public] Integer
        //    Delay time before displaying standby, in millisecond.
        delayTime: 300,


        // showTimeOut: Integer
        //      Timeout in milliseconds when to hide standby if it's shown. Set to zero or negative
        //      to show standby until closed
        showTimeOut: 30e3,

        // color:	String
        //		The color to set the overlay.  Should be in #XXXXXX form.
        //		Default color is set to white.
        color: "#FFFFFF",

        // Id of settimeout when show loading indicator
        _timeoutId: -1,

        // _isShowing: Boolean
        //      Indicates if the standby is showing or is about to show
        _isShowing: false,

        destroy: function () {
            this._clearTimeout();

            this.inherited(arguments);
        },

        show: function (delayTime, showTimeOut) {
            // summary:
            //		Show the standby, after a delayTime
            // tags:
            //		public

            var params = arguments;
            this._clearTimeout();

            this._isShowing = true;

            if (delayTime !== undefined && delayTime === 0) {
                this.inherited(params);
            } else {
                this._timeoutId = setTimeout(lang.hitch(this, function () {

                    var alsoHideAfter = showTimeOut || this.showTimeOut;

                    // create another timeout to hide the standby, so we don't get stuck with it forever
                    if (alsoHideAfter >= 0) {
                        this._timeoutId = setTimeout(lang.hitch(this, function () {
                            this.hide();
                        }), alsoHideAfter);
                    }

                    // call inherited show method, this has to be the original arguments, otherwise we loose context
                    this.inherited(params);

                }), delayTime || this.delayTime);
            }
        },

        hide: function () {
            // summary:
            //		Hide the standby
            // tags:
            //		public

            this._isShowing = false;
            this._clearTimeout();
            this.inherited(arguments);
        },

        _clearTimeout: function () {
            // summary:
            //		Clears any existing timeout process.
            // tags:
            //		private

            if (this._timeoutId >= 0) {
                clearTimeout(this._timeoutId);
            }
        },

        _getIsShowingAttr: function () {
            // summary:
            //      Indicated if the standby is showing or is about to show
            return this._isShowing;
        }
    });
});

},
'dojox/widget/Standby':function(){
define("dojox/widget/Standby", ["dojo/_base/kernel",
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/event",
	"dojo/_base/sniff",
	"dojo/dom",
	"dojo/dom-attr",
	"dojo/dom-construct",
	"dojo/dom-geometry",
	"dojo/dom-style",
	"dojo/window",
	"dojo/_base/window",
	"dojo/_base/fx",
	"dojo/fx",
	"dijit/_Widget",
	"dijit/_TemplatedMixin",
	"dijit/registry"],

function(kernel,
		declare,
		array,
		event,
		has,
		dom,
		attr,
		construct,
		geometry,
		domStyle,
		window,
		baseWindow,
		baseFx,
		fx,
		_Widget,
		_TemplatedMixin,
		registry) {

kernel.experimental("dojox.widget.Standby");

return declare("dojox.widget.Standby", [_Widget, _TemplatedMixin],{
	// summary:
	//		A widget designed to act as a Standby/Busy/Disable/Blocking widget to indicate a
	//		particular DOM node is processing and cannot be clicked on at this time.
	//		This widget uses absolute positioning to apply the overlay and image.

	// image: String
	//		A URL to an image to center within the blocking overlay.
	//		The default is a basic spinner.
	image: require.toUrl("dojox/widget/Standby/images/loading.gif").toString(),

	// imageText: String
	//		Text to set on the ALT tag of the image.
	//		The default is 'Please wait...'
	imageText: "Please Wait...", // TODO: i18n

	// text: String
	//		Text/HTML to display in the center of the overlay
	//		This is used if image center is disabled.
	//		Defaults to 'Please Wait...'
	text: "Please wait...",

	// centerIndicator: String
	//		Property to define if the image and its alt text should be used, or
	//		a simple Text/HTML node should be used.  Allowable values are 'image'
	//		and 'text'.
	//		Default is 'image'.
	centerIndicator: "image",
	
	// target: DOMNode||DOMID(String)||WidgetID(String)
	//		The target to overlay when active.  Can be a widget id, a
	//		dom id, or a direct node reference.
	target: "",

	// color:	String
	//		The color to set the overlay.  Should be in #XXXXXX form.
	//		Default color for the translucent overlay is light gray.
	color: "#C0C0C0",

	// duration: Integer
	//		Integer defining how long the show and hide effects should take in milliseconds.
	//		Defaults to 500
	duration: 500,
	
	// zIndex: String
	//		Control that lets you specify if the zIndex for the overlay
	//		should be auto-computed based off parent zIndex, or should be set
	//		to a particular value.  This is useful when you want to overlay
	//		things in digit.Dialogs, you can specify a base zIndex to append from.
	zIndex: "auto",
	
	// opacity: float
	//		The opacity to make the overlay when it is displayed/faded in.
	//		The default is 0.75.  This does not affect the image opacity, only the
	//		overlay.
	opacity: 0.75,	
	
	// templateString: [protected] String
	//		The template string defining out the basics of the widget.  No need for an external
	//		file.
	templateString:
		"<div>" +
			"<div style=\"display: none; opacity: 0; z-index: 9999; " +
				"position: absolute; cursor:wait;\" dojoAttachPoint=\"_underlayNode\"></div>" +
			"<img src=\"${image}\" style=\"opacity: 0; display: none; z-index: -10000; " +
				"position: absolute; top: 0px; left: 0px; cursor:wait;\" "+
				"dojoAttachPoint=\"_imageNode\">" +
			"<div style=\"opacity: 0; display: none; z-index: -10000; position: absolute; " +
				"top: 0px;\" dojoAttachPoint=\"_textNode\"></div>" +
		"</div>",

	// _underlayNode: [private] DOMNode
	//		The node that is the translucent underlay for the
	//		image that blocks access to the target.
	_underlayNode: null,

	// _imageNode: [private] DOMNode
	//		The image node where we attach and define the image to display.
	_imageNode: null,

	// _textNode: [private] DOMNode
	//		The div to attach text/HTML in the overlay center item.
	_textNode: null,

	// _centerNode: [private] DOMNode
	//		Which node to use as the center node, the image or the text node.
	_centerNode: null,

	// _displayed: [private] Boolean
	//		Flag to indicate if the overlay is displayed or not.
	_displayed: false,

	// _resizeCheck: [private] Object
	//		Handle to interval function that checks the target for changes.
	_resizeCheck: null,

	// _started: [private] Boolean
	//		Trap flag to ensure startup only processes once.
	_started: false,

	// _parent: [private] DOMNode
	//		Wrapping div for the widget, also used for IE 7 in dealing with the
	//		zoom issue.
	_parent: null,

	startup: function(args){
		// summary:
		//		Over-ride of the basic widget startup function.
		//		Configures the target node and sets the image to use.
		if(!this._started){
			if(typeof this.target === "string"){
				var w = registry.byId(this.target);
				this.target = w ? w.domNode : dom.byId(this.target);
			}

			if(this.text){
				this._textNode.innerHTML = this.text;
			}
			if(this.centerIndicator === "image"){
				this._centerNode = this._imageNode;
				attr.set(this._imageNode, "src", this.image);
				attr.set(this._imageNode, "alt", this.imageText);
			}else{
				this._centerNode = this._textNode;
			}
			domStyle.set(this._underlayNode, {
				display: "none",
				backgroundColor: this.color
			});
			domStyle.set(this._centerNode, "display", "none");
			this.connect(this._underlayNode, "onclick", "_ignore");

			//Last thing to do is move the widgets parent, if any, to the current document body.
			//Avoids having to deal with parent relative/absolute mess.  Otherwise positioning
			//tends to go goofy.
			if(this.domNode.parentNode && this.domNode.parentNode != baseWindow.body()){
				baseWindow.body().appendChild(this.domNode);
			}

			//IE 7 has a horrible bug with zoom, so we have to create this node
			//to cross-check later.  Sigh.
			if(has("ie") == 7){
				this._ieFixNode = construct.create("div");
				domStyle.set(this._ieFixNode, {
					opacity: "0",
					zIndex: "-1000",
					position: "absolute",
					top: "-1000px"
				});
				baseWindow.body().appendChild(this._ieFixNode);
			}
			this.inherited(arguments);
		}		
	},

	show: function(){
		// summary:
		//		Function to display the blocking overlay and busy/status icon or text.
		if(!this._displayed){
			if(this._anim){
				this._anim.stop();
				delete this._anim;
			}
			this._displayed = true;
			this._size();
			this._disableOverflow();
			this._fadeIn();
		}
	},

	hide: function(){
		// summary:
		//		Function to hide the blocking overlay and status icon or text.
		if(this._displayed){
			if(this._anim){
				this._anim.stop();
				delete this._anim;
			}
			this._size();
			this._fadeOut();
			this._displayed = false;
			if(this._resizeCheck !== null){
				clearInterval(this._resizeCheck);
				this._resizeCheck = null;
			}
		}
	},

	isVisible: function(){
		// summary:
		//		Helper function so you can test if the widget is already visible or not.
		// returns:
		//		boolean indicating if the widget is in 'show' state or not.
		return this._displayed; // boolean
	},

	onShow: function(){
		// summary:
		//		Event that fires when the display of the Standby completes.
	},

	onHide: function(){
		// summary:
		//		Event that fires when the display of the Standby completes.
	},

	uninitialize: function(){
		// summary:
		//		Over-ride to hide the widget, which clears intervals, before cleanup.
		this._displayed = false;
		if(this._resizeCheck){
			clearInterval(this._resizeCheck);
		}
		domStyle.set(this._centerNode, "display", "none");
		domStyle.set(this._underlayNode, "display", "none");
		if(has("ie") == 7 && this._ieFixNode){
			baseWindow.body().removeChild(this._ieFixNode);
			delete this._ieFixNode;
		}
		if(this._anim){
			this._anim.stop();
			delete this._anim;
		}
		this.target = null;
		this._imageNode = null;
		this._textNode = null;
		this._centerNode = null;
		this.inherited(arguments);
	},

	_size: function(){
		// summary:
		//		Internal function that handles resizing the overlay and
		//		centering of the image on window resizing.
		// tags:
		//		private
		if(this._displayed){
			var dir = attr.get(baseWindow.body(), "dir");
			if(dir){dir = dir.toLowerCase();}
			var _ie7zoom;
			var scrollers = this._scrollerWidths();

			var target = this.target;

			//Show the image and make sure the zIndex is set high.
			var curStyle = domStyle.get(this._centerNode, "display");
			domStyle.set(this._centerNode, "display", "block");
			var box = geometry.position(target, true);
			if(target === baseWindow.body() || target === baseWindow.doc){
				// Target is the whole doc, so scale to viewport.
				box = window.getBox();
				box.x = box.l;
				box.y = box.t;
			}

			var cntrIndicator = geometry.getMarginBox(this._centerNode);
			domStyle.set(this._centerNode, "display", curStyle);

			//IE has a horrible zoom bug.  So, we have to try and account for
			//it and fix up the scaling.
			if(this._ieFixNode){
				_ie7zoom = -this._ieFixNode.offsetTop / 1000;
				box.x = Math.floor((box.x + 0.9) / _ie7zoom);
				box.y = Math.floor((box.y + 0.9) / _ie7zoom);
				box.w = Math.floor((box.w + 0.9) / _ie7zoom);
				box.h = Math.floor((box.h + 0.9) / _ie7zoom);
			}

			//Figure out how to zIndex this thing over the target.
			var zi = domStyle.get(target, "zIndex");
			var ziUl = zi;
			var ziIn = zi;

			if(this.zIndex === "auto"){
				if(zi != "auto"){
					ziUl = parseInt(ziUl, 10) + 1;
					ziIn = parseInt(ziIn, 10) + 2;
				}else{
					//We need to search up the chain to see if there
					//are any parent zIndexs to overlay.
					var cNode = target.parentNode;
					var oldZi = -100000;
					while(cNode && cNode !== baseWindow.body() && target !== baseWindow.body()){
						zi = domStyle.get(cNode, "zIndex");
						if(!zi || zi === "auto"){
							cNode = cNode.parentNode;
						}else{
							var newZi = parseInt(zi, 10);
							if(oldZi < newZi){
								oldZi = newZi;
								ziUl = newZi + 1;
								ziIn = newZi + 2;
							}
							// Keep looking until we run out, we want the highest zIndex.
							cNode = cNode.parentNode;
						}
					}
				}
			}else{
				ziUl = parseInt(this.zIndex, 10) + 1;
				ziIn = parseInt(this.zIndex, 10) + 2;
			}

			domStyle.set(this._centerNode, "zIndex", ziIn);
			domStyle.set(this._underlayNode, "zIndex", ziUl);


			var pn = target.parentNode;
			if(pn && pn !== baseWindow.body() &&
				target !== baseWindow.body() &&
				target !== baseWindow.doc){
				
				// If the parent is the body tag itself,
				// we can avoid all this, the body takes
				// care of overflow for me.  Besides, browser
				// weirdness with height and width on body causes
				// problems with this sort of intersect testing
				// anyway.
				var obh = box.h;
				var obw = box.w;
				var pnBox = geometry.position(pn, true);

				//More IE zoom corrections.  Grr.
				if(this._ieFixNode){
					_ie7zoom = -this._ieFixNode.offsetTop / 1000;
					pnBox.x = Math.floor((pnBox.x + 0.9) / _ie7zoom);
					pnBox.y = Math.floor((pnBox.y + 0.9) / _ie7zoom);
					pnBox.w = Math.floor((pnBox.w + 0.9) / _ie7zoom);
					pnBox.h = Math.floor((pnBox.h + 0.9) / _ie7zoom);
				}
				
				//Shift the parent width/height a bit if scollers are present.
				pnBox.w -= pn.scrollHeight > pn.clientHeight &&
					pn.clientHeight > 0 ? scrollers.v: 0;
				pnBox.h -= pn.scrollWidth > pn.clientWidth &&
					pn.clientWidth > 0 ? scrollers.h: 0;

				//RTL requires a bit of massaging in some cases
				//(and differently depending on browser, ugh!)
				//WebKit and others still need work.
				if(dir === "rtl"){
					if(has("opera")){
						box.x += pn.scrollHeight > pn.clientHeight &&
							pn.clientHeight > 0 ? scrollers.v: 0;
						pnBox.x += pn.scrollHeight > pn.clientHeight &&
							pn.clientHeight > 0 ? scrollers.v: 0;
					}else if(has("ie")){
						pnBox.x += pn.scrollHeight > pn.clientHeight &&
							pn.clientHeight > 0 ? scrollers.v: 0;
					}else if(has("webkit")){
						//TODO:  FIX THIS!
					}
				}

				//Figure out if we need to adjust the overlay to fit a viewable
				//area, then resize it, we saved the original height/width above.
				//This is causing issues on IE.  Argh!
				if(pnBox.w < box.w){
					//Scale down the width if necessary.
					box.w = box.w - pnBox.w;
				}
				if(pnBox.h < box.h){
					//Scale down the width if necessary.
					box.h = box.h - pnBox.h;
				}

				//Look at the y positions and see if we intersect with the
				//viewport borders.  Will have to do computations off it.
				var vpTop = pnBox.y;
				var vpBottom = pnBox.y + pnBox.h;
				var bTop = box.y;
				var bBottom = box.y + obh;
				var vpLeft = pnBox.x;
				var vpRight = pnBox.x + pnBox.w;
				var bLeft = box.x;
				var bRight = box.x + obw;
				var delta;
				//Adjust the height now
				if(bBottom > vpTop &&
					bTop < vpTop){
					box.y = pnBox.y;
					//intersecting top, need to do some shifting.
					delta = vpTop - bTop;
					var visHeight = obh - delta;
					//If the visible height < viewport height,
					//We need to shift it.
					if(visHeight < pnBox.h){
						box.h = visHeight;
					}else{
						//Deal with horizontal scrollbars if necessary.
						box.h -= 2*(pn.scrollWidth > pn.clientWidth &&
							pn.clientWidth > 0? scrollers.h: 0);
					}
				}else if(bTop < vpBottom && bBottom > vpBottom){
					//Intersecting bottom, just figure out how much
					//overlay to show.
					box.h = vpBottom - bTop;
				}else if(bBottom <= vpTop || bTop >= vpBottom){
					//Outside view, hide it.
					box.h = 0;
				}

				//adjust width
				if(bRight > vpLeft && bLeft < vpLeft){
					box.x = pnBox.x;
					//intersecting left, need to do some shifting.
					delta = vpLeft - bLeft;
					var visWidth = obw - delta;
					//If the visible width < viewport width,
					//We need to shift it.
					if(visWidth < pnBox.w){
						box.w = visWidth;
					}else{
						//Deal with horizontal scrollbars if necessary.
						box.w -= 2*(pn.scrollHeight > pn.clientHeight &&
							pn.clientHeight > 0? scrollers.w:0);
					}
				}else if(bLeft < vpRight && bRight > vpRight){
					//Intersecting right, just figure out how much
					//overlay to show.
					box.w = vpRight - bLeft;
				}else if(bRight <= vpLeft || bLeft >= vpRight){
					//Outside view, hide it.
					box.w = 0;
				}
			}

			if(box.h > 0 && box.w > 0){
				//Set position and size of the blocking div overlay.
				domStyle.set(this._underlayNode, {
					display: "block",
					width: box.w + "px",
					height: box.h + "px",
					top: box.y + "px",
					left: box.x + "px"
				});

				var styles = ["borderRadius", "borderTopLeftRadius",
					"borderTopRightRadius","borderBottomLeftRadius",
					"borderBottomRightRadius"];
				this._cloneStyles(styles);
				if(!has("ie")){
					//Browser specific styles to try and clone if non-IE.
					styles = ["MozBorderRadius", "MozBorderRadiusTopleft",
						"MozBorderRadiusTopright","MozBorderRadiusBottomleft",
						"MozBorderRadiusBottomright","WebkitBorderRadius",
						"WebkitBorderTopLeftRadius", "WebkitBorderTopRightRadius",
						"WebkitBorderBottomLeftRadius","WebkitBorderBottomRightRadius"
					];
					this._cloneStyles(styles, this);
				}
				var cntrIndicatorTop = (box.h/2) - (cntrIndicator.h/2);
				var cntrIndicatorLeft = (box.w/2) - (cntrIndicator.w/2);
				//Only show the image if there is height and width room.
				if(box.h >= cntrIndicator.h && box.w >= cntrIndicator.w){
					domStyle.set(this._centerNode, {
						top: (cntrIndicatorTop + box.y) + "px",
						left: (cntrIndicatorLeft + box.x) + "px",
						display: "block"
					});
				}else{
					domStyle.set(this._centerNode, "display", "none");
				}
			}else{
				//Target has no size, display nothing on it!
				domStyle.set(this._underlayNode, "display", "none");
				domStyle.set(this._centerNode, "display", "none");
			}
			if(this._resizeCheck === null){
				//Set an interval timer that checks the target size and scales as needed.
				//Checking every 10th of a second seems to generate a fairly smooth update.
				var self = this;
				this._resizeCheck = setInterval(function(){self._size();}, 100);
			}
		}
	},

	_cloneStyles: function(list){
		// summary:
		//		Internal function to clone a set of styles from the target to
		//		the underlay.
		// list: Array
		//		An array of style names to clone.
		//
		// tags:
		//		private
		array.forEach(list, function(s){
			domStyle.set(this._underlayNode, s, domStyle.get(this.target, s));
		}, this);
	},

	_fadeIn: function(){
		// summary:
		//		Internal function that does the opacity style fade in animation.
		// tags:
		//		private
		var self = this;
		var underlayNodeAnim = baseFx.animateProperty({
			duration: self.duration,
			node: self._underlayNode,
			properties: {opacity: {start: 0, end: self.opacity}}
		});
		var imageAnim = baseFx.animateProperty({
			duration: self.duration,
			node: self._centerNode,
			properties: {opacity: {start: 0, end: 1}},
			onEnd: function(){
				self.onShow();
				delete self._anim;
			}
		});
		this._anim = fx.combine([underlayNodeAnim,imageAnim]);
		this._anim.play();
	},

	_fadeOut: function(){
		// summary:
		//		Internal function that does the opacity style fade out animation.
		// tags:
		//		private
		var self = this;
		var underlayNodeAnim = baseFx.animateProperty({
			duration: self.duration,
			node: self._underlayNode,
			properties: {opacity: {start: self.opacity, end: 0}},
			onEnd: function(){
				domStyle.set(this.node,{"display":"none", "zIndex": "-1000"});
			}
		});
		var imageAnim = baseFx.animateProperty({
			duration: self.duration,
			node: self._centerNode,
			properties: {opacity: {start: 1, end: 0}},
			onEnd: function(){
				domStyle.set(this.node,{"display":"none", "zIndex": "-1000"});
				self.onHide();
				self._enableOverflow();
				delete self._anim;
			}
		});
		this._anim = fx.combine([underlayNodeAnim,imageAnim]);
		this._anim.play();
	},

	_ignore: function(e){
		// summary:
		//		Function to ignore events that occur on the overlay.
		// event: Event
		//		The event to halt
		// tags:
		//		private
		if(e){
			event.stop(e);
		}
	},

	_scrollerWidths: function(){
		// summary:
		//		This function will calculate the size of the vertical and
		//		horizontaol scrollbars.
		// returns:
		//		Object of form: {v: Number, h: Number} where v is vertical scrollbar width
		//		and h is horizontal scrollbar width.
		// tags:
		//		private
		var div = construct.create("div");
		domStyle.set(div, {
			position: "absolute",
			opacity: 0,
			overflow: "hidden",
			width: "50px",
			height: "50px",
			zIndex: "-100",
			top: "-200px",
			padding: "0px",
			margin: "0px"
		});
		var iDiv = construct.create("div");
		domStyle.set(iDiv, {
			width: "200px",
			height: "10px"
		});
		div.appendChild(iDiv);
		baseWindow.body().appendChild(div);

		//Figure out content size before and after
		//scrollbars are there, then just subtract to
		//get width.
		var b = geometry.getContentBox(div);
		domStyle.set(div, "overflow", "scroll");
		var a = geometry.getContentBox(div);
		baseWindow.body().removeChild(div);
		return { v: b.w - a.w, h: b.h - a.h };
	},

	/* The following are functions that tie into _Widget.attr() */

	_setTextAttr: function(text){
		// summary:
		//		Function to allow widget.attr to set the text displayed in center
		//		if using text display.
		// text: String
		//		The text to set.
		this._textNode.innerHTML = text;
		this.text = text;
	},

	_setColorAttr: function(c){
		// summary:
		//		Function to allow widget.attr to set the color used for the translucent
		//		div overlay.
		// c: String
		//		The color to set the background underlay to in #XXXXXX format..
		domStyle.set(this._underlayNode, "backgroundColor", c);
		this.color = c;
	},

	_setImageTextAttr: function(text){
		// summary:
		//		Function to allow widget.attr to set the ALT text text displayed for
		//		the image (if using image center display).
		// text: String
		//		The text to set.
		attr.set(this._imageNode, "alt", text);
		this.imageText = text;
	},

	_setImageAttr: function(url){
		// summary:
		//		Function to allow widget.attr to set the url source for the center image
		// text: String
		//		The url to set for the image.
		attr.set(this._imageNode, "src", url);
		this.image = url;
	},

	_setCenterIndicatorAttr: function(indicator){
		// summary:
		//		Function to allow widget.attr to set the node used for the center indicator,
		//		either the image or the text.
		// indicator: String
		//		The indicator to use, either 'image' or 'text'.
		this.centerIndicator = indicator;
		if(indicator === "image"){
			this._centerNode = this._imageNode;
			domStyle.set(this._textNode, "display", "none");
		}else{
			this._centerNode = this._textNode;
			domStyle.set(this._imageNode, "display", "none");
		}
	},

	_disableOverflow: function(){
		 // summary:
		 //		Function to disable scrollbars on the body.  Only used if the overlay
		 //		targets the body or the document.
		 if(this.target === baseWindow.body() || this.target === baseWindow.doc){
			 // Store the overflow state we have to restore later.
			 // IE had issues, so have to check that it's defined.  Ugh.
			 this._overflowDisabled = true;
			 var body = baseWindow.body();
			 if(body.style && body.style.overflow){
				 this._oldOverflow = domStyle.get(body, "overflow");
			 }else{
				 this._oldOverflow = "";
			 }
			 if(has("ie") && !has("quirks")){
				 // IE will put scrollbars in anyway, html (parent of body)
				 // also controls them in standards mode, so we have to
				 // remove them, argh.
				 if(body.parentNode &&
					body.parentNode.style &&
					body.parentNode.style.overflow){
					 this._oldBodyParentOverflow = body.parentNode.style.overflow;
				 }else{
					 try{
						this._oldBodyParentOverflow = domStyle.get(body.parentNode, "overflow");
					 }catch(e){
						 this._oldBodyParentOverflow = "scroll";
					 }
				 }
				 domStyle.set(body.parentNode, "overflow", "hidden");
			 }
			 domStyle.set(body, "overflow", "hidden");
		 }
	},

	_enableOverflow: function(){
		 // summary:
		 //		Function to restore scrollbars on the body.  Only used if the overlay
		 //		targets the body or the document.
		 if(this._overflowDisabled){
			delete this._overflowDisabled;
			var body = baseWindow.body();
			// Restore all the overflow.
			if(has("ie") && !has("quirks")){
				body.parentNode.style.overflow = this._oldBodyParentOverflow;
				delete this._oldBodyParentOverflow;
			}
			domStyle.set(body, "overflow", this._oldOverflow);
			if(has("webkit")){
				//Gotta poke WebKit, or scrollers don't come back. :-(
				var div = construct.create("div", { style: {
						height: "2px"
					}
				});
				body.appendChild(div);
				setTimeout(function(){
					body.removeChild(div);
				}, 0);
			}
			delete this._oldOverflow;
		}
	}
});

});

},
'epi-cms/widget/ContentReferences':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/keys",
    "dojo/when",
    //epi
    "epi-cms/dgrid/formatters",
    "epi/dependency",
    // dgrid
    "dgrid/tree",
    // Base class and mixins
    "./_GridWidgetBase",
    "./viewmodel/ContentReferencesViewModel",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/Evented",
    "epi/shell/widget/_ModelBindingMixin",
    // Resources
    "dojo/text!./templates/ContentReferences.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentreferences",
    // Widgets used in the template
    "dijit/form/Button"
], function (
    declare,
    lang,
    domClass,
    domConstruct,
    domStyle,
    keys,
    when,
    formatters,
    dependency,
    // dgrid
    tree,
    // Base class and mixins
    _GridWidgetBase,
    ContentReferencesViewModel,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    Evented,
    _ModelBindingMixin,
    // Resources
    template,
    resources
) {

    return declare([_GridWidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, Evented, _ModelBindingMixin], {
        // tags:
        //      internal

        // widget resources
        res: resources,

        // templateString: String
        //  Template for the widget
        templateString: template,

        storeKeyName: "epi.cms.referenced-content",

        contextChangeEvent: "dblclick",

        // trackActiveItem: [public] Boolean
        //      A flag indicating whether the item matching the current context should be highlight. The default value is false.
        trackActiveItem: false,

        // ignoreVersionWhenComparingLinks: [public] Boolean
        //      A flag indicating whether the version should be ignored when comparing content references.
        ignoreVersionWhenComparingLinks: false,

        // modelBindingMap: [protected] Object
        //      A map contain bindings from the model to properties on this object.
        modelBindingMap: {
            notification: ["notification"],
            notificationBarStyle: ["notificationBarStyle"],
            numberOfReferences: ["numberOfReferences"],
            showToolbar: ["showToolbar"],
            showGrid: ["showGrid"],
            totalLinks: ["totalLinks"]
        },

        constructor: function (params) {
            this.model = lang.mixin(new ContentReferencesViewModel(), params);
            this.own(this.model);
        },

        _setTotalLinksAttr: { node: "totalLinksNode", type: "innerText" },

        _setNotificationAttr: { node: "contentReferencesNotificationNode", type: "innerText" },

        _setNotificationBarStyleAttr: function (value) {
            // summary:
            //      Sets the color for notification bar. 1 for green, 2 for orange and yellow for everything else
            // tags:
            //      protected
            switch (value) {
                case 1:          // green
                    domClass.add(this.contentReferencesNotificationBar, "epi-statusIndicator epi-statusIndicatorOk");
                    break;
                case 2:      // orange
                    domClass.add(this.contentReferencesNotificationBar, "epi-statusIndicator epi-statusIndicatorWarning");
                    break;
            }
        },

        _setShowToolbarAttr: function (value) {
            domStyle.set(this.captionPanelNode, "display", value ? "" : "none");
        },

        _setShowGridAttr: function (value) {
            domStyle.set(this.grid.domNode, "visibility", value ? "visible" : "hidden");
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            this.store = this.model.getUpdatedStore(this.store);
        },

        buildRendering: function () {
            // summary:
            //      Construct the UI for this widget. this.gridNode is initialized as a dGrid.
            // tags:
            //      protected
            var linkTemplate = this._getLinkTemplate();

            var gridSettings = lang.mixin({
                columns: {
                    name: tree({
                        renderCell: lang.hitch(this, "_renderContentItem"),
                        shouldExpand: function () {
                            return true;
                        }
                    }),
                    language: {
                        className: "epi-width10",
                        renderCell: function (obj, language, node) {
                            // If the language hasn't been specified there is no need to try to compare
                            // it with the current edit language
                            if (!language) {
                                return;
                            }
                            when(dependency.resolve("epi.shell.Profile").getContentLanguage(), function (profileContentLanguage) {
                                if (language !== profileContentLanguage) {
                                    node.textContent = language;
                                }
                            });
                        }
                    },
                    treePath: {
                        className: "epi-width50",
                        formatter: function (value) {
                            return formatters.path(value, {
                                skipEncode: true,
                                skipDefaultClass: true
                            });
                        }
                    },
                    uri: {
                        className: "epi-width10",
                        label: " ",
                        formatter: function (value) {
                            return value ? linkTemplate : "";
                        },
                        sortable: false
                    }
                },
                store: this.store,
                query: {
                    ids: this.model.contentItems.map(function (content) {
                        return content.contentLink;
                    })
                },
                showHeader: false
            }, this.defaultGridMixin);

            this.inherited(arguments);

            this.grid = new this._gridClass(gridSettings, this.gridNode);

            // Hide the notification box if in show mode.
            domClass.toggle(this.contentReferencesNotificationBar, "dijitHidden", this.model.mode === "show");
        },

        startup: function () {
            this.inherited(arguments);

            // Setup event handling for click on the view link.
            this.grid.on(".dgrid-column-uri a:click", lang.hitch(this, "_onChangeContext"));
        },

        fetchData: function () {
            // summary:
            //      Fetches data by setting a query on the grid. A get children query will be performed on the store.
            // tags:
            //      protected

            this.grid.refresh();
        },

        _onChangeContext: function (e) {
            // summary:
            //      Change the context to the content associated with the given row.
            // tags:
            //      private
            var row = this.grid.row(e),
                newContext = { uri: row.data.uri };

            if (newContext.uri) {
                this._requestNewContext(newContext, { sender: this });

                this.emit("viewReference");
            }
        },

        _getLinkTemplate: function () {
            // summary:
            //      Returns an HTML string representing the view link.
            // tags:
            //      private
            var node = domConstruct.create("a", {
                "class": "epi-visibleLink",
                innerHTML: resources.view.label,
                title: resources.view.tooltip
            });

            return node.outerHTML;
        }
    });
});

},
'dgrid/tree':function(){
define([
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/Deferred",
	"dojo/query",
	"dojo/on",
	"dojo/aspect",
	"./util/has-css3",
	"./Grid",
	"dojo/has!touch?./util/touch",
	"put-selector/put"
], function(declare, arrayUtil, Deferred, querySelector, on, aspect, has, Grid, touchUtil, put){

function defaultRenderExpando(level, hasChildren, expanded, object){
	// summary:
	//		Provides default implementation for column.renderExpando.
	
	var dir = this.grid.isRTL ? "right" : "left",
		cls = ".dgrid-expando-icon",
		node;
	if(hasChildren){
		cls += ".ui-icon.ui-icon-triangle-1-" + (expanded ? "se" : "e");
	}
	node = put("div" + cls + "[style=margin-" + dir + ": " +
		(level * (this.indentWidth || 9)) + "px; float: " + dir + "]");
	node.innerHTML = "&nbsp;"; // for opera to space things properly
	return node;
}

function ontransitionend(event){
	var container = this,
		height = this.style.height;
	if(height){
		// After expansion, ensure display is correct;
		// after collapse, set display to none to improve performance
		this.style.display = height == "0px" ? "none" : "block";
	}
	
	// Reset height to be auto, so future height changes (from children
	// expansions, for example), will expand to the right height.
	if(event){
		// For browsers with CSS transition support, setting the height to
		// auto or "" will cause an animation to zero height for some
		// reason, so temporarily set the transition to be zero duration
		put(this, ".dgrid-tree-resetting");
		setTimeout(function(){
			// Turn off the zero duration transition after we have let it render
			put(container, "!dgrid-tree-resetting");
		});
	}
	// Now set the height to auto
	this.style.height = "";
}

function tree(column){
	// summary:
	//		Adds tree navigation capability to a column.
	
	var originalRenderCell = column.renderCell || Grid.defaultRenderCell;
	
	var currentLevel, // tracks last rendered item level (for aspected insertRow)
		clicked; // tracks row that was clicked (for expand dblclick event handling)
		
	if(!column){ column = {}; }
	
	column.shouldExpand = column.shouldExpand || function(row, level, previouslyExpanded){
		// summary:
		//		Function called after each row is inserted to determine whether
		//		expand(rowElement, true) should be automatically called.
		//		The default implementation re-expands any rows that were expanded
		//		the last time they were rendered (if applicable).
		
		return previouslyExpanded;
	};
	
	aspect.after(column, "init", function(){
		var grid = column.grid,
			colSelector = ".dgrid-content .dgrid-column-" + column.id,
			listeners = []; // to be removed when this column is destroyed

		// Turn off automatic cleanup of empty observers, to prevent confusion
		// due to observers operating at multiple hierarchy levels.
		grid.cleanEmptyObservers = false;
		
		if(!grid.store){
			throw new Error("dgrid tree column plugin requires a store to operate.");
		}
		
		if (!column.renderExpando){
			column.renderExpando = defaultRenderExpando;
		}
		
		// Set up the event listener once and use event delegation for better memory use.
		listeners.push(grid.on(
			column.expandOn || ".dgrid-expando-icon:click," + colSelector + ":dblclick," + colSelector + ":keydown",
			function(event){
				var row = grid.row(event);	
				if((!grid.store.mayHaveChildren || grid.store.mayHaveChildren(row.data)) &&
						(event.type != "keydown" || event.keyCode == 32) &&
						!(event.type == "dblclick" && clicked && clicked.count > 1 &&
							row.id == clicked.id && event.target.className.indexOf("dgrid-expando-icon") > -1)){
					grid.expand(row);
				}
				
				// If the expando icon was clicked, update clicked object to prevent
				// potential over-triggering on dblclick (all tested browsers but IE < 9).
				if(event.target.className.indexOf("dgrid-expando-icon") > -1){
					if(clicked && clicked.id == grid.row(event).id){
						clicked.count++;
					}else{
						clicked = {
							id: grid.row(event).id,
							count: 1
						};
					}
				}
			})
		);
		
		if(has("touch")){
			// Also listen on double-taps of the cell.
			listeners.push(grid.on(touchUtil.selector(colSelector, touchUtil.dbltap),
				function(){ grid.expand(this); }));
		}
		
		// Set up hash to store IDs of expanded rows
		if(!grid._expanded){ grid._expanded = {}; }
		
		listeners.push(aspect.after(grid, "insertRow", function(rowElement){
			// Auto-expand (shouldExpand) considerations
			var row = this.row(rowElement),
				expanded = column.shouldExpand(row, currentLevel, this._expanded[row.id]);
			
			if(expanded){ this.expand(rowElement, true, true); }
			return rowElement; // pass return value through
		}));
		
		listeners.push(aspect.before(grid, "removeRow", function(rowElement, justCleanup){
			var connected = rowElement.connected;
			if(connected){
				// if it has a connected expando node, we process the children
				querySelector(">.dgrid-row", connected).forEach(function(element){
					grid.removeRow(element, true);
				});
				// now remove the connected container node
				if(!justCleanup){
					put(connected, "!");
				}
			}
		}));
		
		if(column.collapseOnRefresh){
			// Clear out the _expanded hash on each call to cleanup
			// (which generally coincides with refreshes, as well as destroy).
			listeners.push(aspect.after(grid, "cleanup", function(){
				this._expanded = {};
			}));
		}
		
		grid._calcRowHeight = function(rowElement){
			// we override this method so we can provide row height measurements that
			// include the children of a row
			var connected = rowElement.connected;
			// if connected, need to consider this in the total row height
			return rowElement.offsetHeight + (connected ? connected.offsetHeight : 0); 
		};
		
		grid.expand = function(target, expand, noTransition){
			// summary:
			//		Expands the row corresponding to the given target.
			// target: Object
			//		Row object (or something resolvable to one) to expand/collapse.
			// expand: Boolean?
			//		If specified, designates whether to expand or collapse the row;
			//		if unspecified, toggles the current state.
			
			var row = target.element ? target : grid.row(target),
				hasTransitionend = has("transitionend"),
				dfd = new Deferred(),
				promise = dfd.promise;
			
			// Resolve initial promise immediately;
			// promise will be reassigned later if necessary to only resolve
			// after data is retrieved
			dfd.resolve();
			
			target = row.element;
			target = target.className.indexOf("dgrid-expando-icon") > -1 ? target :
				querySelector(".dgrid-expando-icon", target)[0];
			
			noTransition = noTransition || column.enableTransitions === false;
			
			if(target && target.mayHaveChildren &&
					(noTransition || expand !== !!this._expanded[row.id])){
				// toggle or set expand/collapsed state based on optional 2nd argument
				var expanded = expand === undefined ? !this._expanded[row.id] : expand;
				
				// update the expando display
				put(target, ".ui-icon-triangle-1-" + (expanded ? "se" : "e") +
					"!ui-icon-triangle-1-" + (expanded ? "e" : "se"));
				
				var rowElement = row.element,
					container = rowElement.connected,
					containerStyle,
					scrollHeight,
					options = {
						originalQuery: this.query
					};
				
				if(!container){
					// if the children have not been created, create a container, a preload node and do the 
					// query for the children
					container = options.container = rowElement.connected =
						put(rowElement, '+div.dgrid-tree-container');
					var query = function(options){
						return grid.store.getChildren(row.data, options);
					};
					if(column.allowDuplicates){
						// If allowDuplicates is specified, include parentId in options
						// in order to facilitate unique IDs for each occurrence of the
						// same item under multiple different parents.
						options.parentId = row.id;
					}
					// Include level information on query for renderQuery case
					if("level" in target){
						query.level = target.level;
					}
					// Add the query to the promise chain.
					promise = promise.then(function(){
						if(grid.renderQuery){
							return grid.renderQuery(query, options);
						}
						
						// If not using OnDemandList, we don't need preload nodes,
						// but we still need a beforeNode to pass to renderArray,
						// so create a temporary one
						var firstChild = put(container, "div");
						var rows = grid.renderArray(query(options), firstChild,
							"level" in query ? { queryLevel: query.level } : {});
						Deferred.when(rows, function(){
							put(firstChild, "!");
						});
						return rows;
					});
					
					if(hasTransitionend){
						on(container, hasTransitionend, ontransitionend);
					}else{
						ontransitionend.call(container);
					}
				}
				
				// Show or hide all the children.
				
				container.hidden = !expanded;
				containerStyle = container.style;
				
				// make sure it is visible so we can measure it
				if(!hasTransitionend || noTransition){
					containerStyle.display = expanded ? "block" : "none";
					containerStyle.height = "";
				}else{
					if(expanded){
						containerStyle.display = "block";
						scrollHeight = container.scrollHeight;
						containerStyle.height = "0px";
					}
					else{
						// if it will be hidden we need to be able to give a full height
						// without animating it, so it has the right starting point to animate to zero
						put(container, ".dgrid-tree-resetting");
						containerStyle.height = container.scrollHeight + "px";
					}
					// Perform a transition for the expand or collapse.
					setTimeout(function(){
						put(container, "!dgrid-tree-resetting");
						containerStyle.height =
							expanded ? (scrollHeight ? scrollHeight + "px" : "auto") : "0px";
					});
				}
				
				// Update _expanded map.
				if(expanded){
					this._expanded[row.id] = true;
				}else{
					delete this._expanded[row.id];
				}
			}
			return promise;
		}; // end function grid.expand
		
		// Set up a destroy function on column to tear down the listeners/aspects
		// established above if the grid's columns are redefined later.
		aspect.after(column, "destroy", function(){
			arrayUtil.forEach(listeners, function(l){ l.remove(); });
			// Delete methods we added/overrode on the instance.
			delete grid.expand;
			delete grid._calcRowHeight;
		});
	});
	
	column.renderCell = function(object, value, td, options){
		// summary:
		//		Renders a cell that can be expanded, creating more rows
		
		var grid = column.grid,
			level = Number(options && options.queryLevel) + 1,
			mayHaveChildren = !grid.store.mayHaveChildren || grid.store.mayHaveChildren(object),
			parentId = options.parentId,
			expando, node;
		
		level = currentLevel = isNaN(level) ? 0 : level;
		expando = column.renderExpando(level, mayHaveChildren,
			grid._expanded[(parentId ? parentId + "-" : "") + grid.store.getIdentity(object)], object);
		expando.level = level;
		expando.mayHaveChildren = mayHaveChildren;
		
		node = originalRenderCell.call(column, object, value, td, options);
		if(node && node.nodeType){
			put(td, expando);
			put(td, node);
		}else{
			td.insertBefore(expando, td.firstChild);
		}
	};
	return column;
}

tree.defaultRenderExpando = defaultRenderExpando;
return tree;
});

},
'epi-cms/widget/_GridWidgetBase':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/keys",
    "dojo/topic",
    "dojo/when",

    "dgrid/Keyboard",
    "dgrid/OnDemandGrid",
    "dgrid/Selection",

    "dijit/layout/_LayoutWidget",

    "epi",
    "epi/datetime",
    "epi/UriParser",
    "epi/username",

    "epi/shell/dgrid/Formatter",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/_ContentContextMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/dgrid/DnD",
    "epi-cms/dgrid/formatters",
    "epi-cms/dgrid/WithContextMenu",
    "epi/dependency"
], function (
    declare,
    lang,
    aspect,
    domConstruct,
    keys,
    topic,
    when,

    Keyboard,
    OnDemandGrid,
    Selection,

    _LayoutWidget,

    epi,
    epiDate,
    UriParser,
    username,

    Formatter,
    TypeDescriptorManager,

    _ContentContextMixin,
    ContentReference,
    DnD,
    formatters,
    WithContextMenu,
    dependency
) {

    return declare([_LayoutWidget, _ContentContextMixin], {
        // tags:
        //      internal xproduct

        // _gridClass: [protected] Object
        //		The class to construct the grid with.
        _gridClass: declare([OnDemandGrid, Formatter, Selection, DnD, Keyboard, WithContextMenu]),

        // storeKeyName: [public] string
        //		The key of the store used to retrieve the store from the store registry.
        storeKeyName: null,

        // grid: [public] dgrid
        //		The grid that is used to display information.
        grid: null,

        // store: [public] dojo/store
        //		The store that contains the data.
        store: null,

        // ignoreVersionWhenComparingLinks: [public] boolean
        //		If item comparison should consider versions or not.
        ignoreVersionWhenComparingLinks: true,

        // trackActiveItem: [public] boolean
        //		If comparison should be done to highlight the currently active context item.
        trackActiveItem: true,

        // defaultGridMixin: [protected] object
        //		An object with default settings for dnd to mixin to the grid class.
        defaultGridMixin: null,

        currentItem: null,

        // contextChangeEvent: [public] String
        //      Set the event that will cause a context change (i.e. click or dblclick). Default value is "click".
        contextChangeEvent: "click",

        // forceContextReload: [public] boolean
        //      If context should be forced to reloaded when changing context
        forceContextReload: false,

        // selectionMode: [public] String
        //      The selection mode of the grid. See documentation on dgrid/Selection for valid values.
        selectionMode: "single",

        // selection: [public] Array
        //      An array containing the selected items in the grid.
        selection: null,

        postMixInProperties: function () {
            // summary:
            //		Called after constructor parameters have been mixed-in; sets default values for parameters that have not been initialized.
            // tags:
            //		protected

            this.inherited(arguments);

            this.defaultGridMixin = {
                selectionMode: this.get("selectionMode"),
                dndParams: {
                    creator: lang.hitch(this, this._dndNodeCreator),
                    copyOnly: true,
                    selfAccept: false
                }
            };

            if (!this.store && this.storeKeyName) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get(this.storeKeyName);
            }
        },

        startup: function () {
            // summary:
            //		Connects event handlers to common grid events.
            // tags:
            //		protected

            this.inherited(arguments);

            if (this.contextChangeEvent) {
                var callback = lang.hitch(this, "_onChangeContext");
                this.grid.on(".dgrid-row:" + this.contextChangeEvent, callback);

                // Setup the default keyboard handling for changing context if the Keyboard mixin is supported.
                if (typeof this.grid.addKeyHandler == "function") {
                    this.grid.addKeyHandler(keys.ENTER, callback);
                    this.grid.addKeyHandler(keys.SPACE, callback);
                }
            }

            this.grid.on("dgrid-select, dgrid-deselect", lang.hitch(this, "_onSelectionChanged"));
            this.grid.on("dgrid-error", lang.hitch(this, "_onError"));

            if (this.trackActiveItem) {
                this.own(aspect.after(this.grid, "insertRow", lang.hitch(this, this._selectActiveItem)));
            }

            this.own(this.connect(this, "layout", lang.hitch(this, function () {
                this.grid.resize();
            })));

            this.grid.startup();
        },

        destroy: function () {
            if (this.grid) {
                this.grid.destroy();
            }

            this.inherited(arguments);
        },

        select: function (/*Object*/item) {
            // summary:
            //      Select a grid row from the given item
            // item: [Object]
            // tags:
            //      public

            this.grid.clearSelection();
            if (item) {
                // using .toString() instead of item.id to get the full content link, which contains provider name
                var contentLink = (item instanceof ContentReference ? item : new ContentReference(item.id)).createVersionUnspecificReference().toString();
                this.grid.select(contentLink);
            }
        },

        _forceKeepContext: function (/*String*/uri) {
            // summary:
            //
            // uri: [String]
            //
            // tags:
            //      protected, extension

            return this._isSameAsCurrentContext(uri);
        },

        _onChangeContext: function (e) {
            // summary:
            //      Publish a context request when a version is selected in the list.
            // tags:
            //      protected, extension
            this._onChangeContextInternal(e);
        },

        _onChangeContextInternal: function (e) {
            // summary:
            //      Publish a context request when a version is selected in the list.
            // tags:
            //      internal

            var row = this.grid.row(e),
                uri = row.data.uri,
                newContext = { uri: uri };

            if (this._forceKeepContext(uri)) {
                return;
            }

            this._requestNewContext(newContext, { sender: this, forceReload: this.forceContextReload });
        },

        _onSelectionChanged: function (e) {
            // summary:
            //      Emits "itemsSelected" as an array of the items selected.
            // tags:
            //      private

            var selection = [];
            for (var id in this.grid.selection) {
                if (this.grid.selection[id]) {
                    var row = this.grid.row(id);
                    selection.push(row.data);
                }
            }

            this.set("selection", selection);
            this.emit("selectionChanged", { selection: selection });
            this._onSelect(e);
        },

        _onSelect: function (e) {
            // summary:
            //		Publish a context request when a version is selected in the list.
            // tags:
            //		protected, extension
        },

        _onError: function (e) {
            // summary:
            //		Shows an error message to the user when failing to load data.
            // tags:
            //		protected, extension
            var errorMessage = this.grid.errorMessage;
            var error = e.error;

            if (error.status && error.status === 403) {
                errorMessage = epi.resources.messages.nopermissiontoviewdata;
            }
            this._showErrorMessage(errorMessage);
        },

        _requestNewContext: function (contextParameters, callerData) {
            topic.publish("/epi/shell/context/request", contextParameters, callerData);
        },

        restore: function () {
            // summary: Restore component visuals
            this.resize();
        },

        _isActiveItem: function (/*dgrid row*/row) {
            // summary:
            //      Compare uri current dgrid row with current context
            // tags:
            //      private

            return when(this.getCurrentContext(), lang.hitch(this, function (context) {
                var rowUri = row.data.uri;
                return context && this._compareUris(rowUri, context.uri);
            }));
        },

        _selectActiveItem: function (node) {
            // summary:
            //		Called 'after' the insertRow method in order to select the active version.
            // tags:
            //		private

            var row = this.grid.row(node);

            if (!row) {
                //Note: We don't know why row is null in some cases. Is something wrong?
                return node;
            }

            when(this._isActiveItem(row), lang.hitch(this, function (isActive) {
                if (isActive) {
                    if (this.grid.selectionMode === "single") {
                        this.grid.clearSelection();
                    }
                    this.grid.select(row, null);
                }
            }));

            return node;
        },

        contextChanged: function (context, callerData) {
            this.inherited(arguments);

            if (context.type !== "epi.cms.contentdata") {
                return;
            }

            if (!callerData || callerData.sender !== this) {
                // the context changed, probably because we navigated or published something
                this.onContextChanged(context);
            }
        },

        onContextChanged: function (context) {
            this.fetchData();
        },

        fetchData: function () {
            // summary:
            //      Override this method to implement your logic to bind data to the grid.
            //
            // tags:
            //    protected
        },

        _showErrorMessage: function (errorMessage) {
            this.grid.cleanup();

            // There is no public method for setting messages, so use the same style as dgrid.
            this.grid.contentNode.innerHTML = errorMessage  || "";
        },

        contextChangeFailed: function (oldContext, requestContextParams, callerData) {
            // summary:
            //    Subcriptions to /epi/shell/context/requestfailed topic to sync page tree selection
            //
            // tags:
            //    private

            this.inherited(arguments);

            // select old page link
            if (callerData && callerData.sender === this) {
                this._selectActiveItem();
            }
        },

        _renderContentItem: function (object, value, node, options) {
            node.innerHTML = formatters.contentItem(object.typeIdentifier, object.missingLanguageBranch, value);
        },

        _localizeDate: function (value) {
            return formatters.localizedDate(value);
        },

        _createUserFriendlyUsername: function (name) {
            return formatters.userName(name);
        },

        _dndNodeCreator: function (item, hint) {
            // summary:
            //      Custom DnD avatar creator method

            var dndTypes = TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");

            if (!dndTypes && this.dndTypes) {
                dndTypes = this.dndTypes;
            }

            var node = domConstruct.create("div").appendChild(document.createTextNode(item.name));
            return {
                node: node,
                type: dndTypes,
                data: item
            };
        },

        _aroundInsertRow: function (original) {
            // summary:
            //      Called 'around' the insertRow method to fix the grids less than perfect selection.
            // tags:
            //      protected

            return lang.hitch(this, function (object, parent, beforeNode, i, options) {

                // Call original method
                var row = original.apply(this.grid, arguments);

                var currentItem = this.get("currentItem");
                if (currentItem) {
                    // using .toString() instead of currentItem.id to get the full content link, which contains provider name
                    var contentLink = (currentItem instanceof ContentReference ? currentItem : new ContentReference(currentItem.id)).createVersionUnspecificReference().toString();
                    if (contentLink === object.contentLink) {
                        this.select(currentItem);
                    }
                }

                return row;
            });
        },

        _getCurrentItem: function () {
            // summary:
            //      Get current context row based on current context
            // returns: [Promise]
            //      An instance of dgrid row
            // tags:
            //      protected

            return when(this.getCurrentContext(), function (context) {
                return {
                    id: ContentReference.tryConvert(context.id, context).id
                };
            });
        },

        _setSelectionModeAttr: function (/*String*/selectionMode) {
            // summary:
            //      Set the selection mode for the grid.
            // selectionMode: String
            //      The selection mode.
            // tags:
            //      protected

            if (this.grid) {
                this.grid.set("selectionMode", selectionMode);
            }
            this._set("selectionMode", selectionMode);
        }
    });

});

},
'epi-cms/dgrid/DnD':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/NodeList",
    "epi/shell/dnd/Source",
    "dojo/dom-construct",

    "epi/dependency",
    "epi/shell/TypeDescriptorManager",

    "put-selector/put"

], function (
    declare,
    lang,
    NodeList,
    DnDSource,
    domConstruct,

    dependency,
    TypeDescriptorManager,

    put) {

    var GridSource = declare(DnDSource, {
        _legalMouseDown: function (evt) {
            // Fix _legalMouseDown to only allow starting drag from an item
            // (not from bodyNode outside contentNode).
            var legal = this.inherited(arguments);
            return legal && evt.target !== this.grid.bodyNode;
        },

        getSelectedNodes: function () {
            var grid = this.grid;

            // If dgrid's Selection mixin is in use, synchronize with it, using a
            // map of node references (updated on dgrid-[de]select events).
            var nodes = this.inherited(arguments);
            if (!grid.selection || Object.keys(grid.selection).length === 0) {
                // Only select if there are nodes available.
                if (nodes.length) {
                    grid.select(nodes[0]);
                }
                return nodes;
            }

            var isGridSelection = false;
            var gridSelectionNodes = new NodeList();

            //isGridSelection when exist any selection in nodes
            for (var id in grid.selection) {
                if (grid.row(id).element !== nodes[0]) {
                    gridSelectionNodes.push(grid.row(id).element);
                } else {
                    isGridSelection = true;
                    gridSelectionNodes.push(nodes[0]);
                }
            }
            if (isGridSelection) {
                return gridSelectionNodes;
            }

            grid.clearSelection();
            // Only select if there are nodes available.
            if (nodes.length) {
                grid.select(nodes[0]);
            }
            return nodes;
        },

        destroy: function () {

            this.grid = null;

            this.inherited(arguments);
        }
    });

    return declare([], {
        // tags:
        //      public

        // dndSourceTypes: Array
        //      Specifies the types which will be set for DnD items in the grid.
        dndSourceTypes: null,

        // dndParams: Object
        //      Object containing params to be passed to the DnD Source constructor.
        dndParams: null,

        // dndConstructor: Function
        //      Constructor from which to instantiate the DnD Source.
        dndConstructor: GridSource,

        // dndDisabled: Booleaen
        //      Set to true to disable the dnd support.
        dndDisabled: false,

        // dndFormatSuffix: String
        //      The format suffix to append to the dndTypes for items contained in the list
        //      Set to allow dragging the item to targets that allow for the type with the specified suffix or have a converter
        dndFormatSuffix: null,

        postCreate: function () {
            this.inherited(arguments);

            if (!this.dndDisabled) {
                this._setupDnD();
            }
        },

        destroy: function () {

            this.inherited(arguments);

            this.dndSource && this.dndSource.destroy();
            this.dndParams = this.dndSource = null;

        },

        insertRow: function (object) {
            // override to add dojoDndItem class to make the rows draggable
            var row = this.inherited(arguments);

            if (this.dndDisabled) {
                return row;
            }
            put(row, ".dojoDndItem");

            // setup the source if it hasn't been done yet
            this._setupDnD();

            var opts = {};
            if (this.query) {
                opts.oldParentItem = { contentLink: this.query.referenceId };
            }

            this.dndSource.setItem(row.id, { data: object, type: this._getDndType(object), options: opts });
            return row;
        },

        _getDndType: function (object) {
            // Get a custom dnd type array from the specific object or a general type array from the source.
            var dndTypes = TypeDescriptorManager.getAndConcatenateValues(object.typeIdentifier, "dndTypes");
            if ((!dndTypes || dndTypes.length <= 0) && this.dndSourceTypes) {
                dndTypes = this.dndSourceTypes;
            }
            if (this.dndFormatSuffix) {
                dndTypes = dndTypes.map(lang.hitch(this, function (type) {
                    return type + "." + this.dndFormatSuffix;
                }));
            }
            return dndTypes;
        },

        _setupDnD: function () {

            if (this.dndSource) {
                return;
            }

            if (!this.dndParams.creator) {
                this.dndParams.creator = lang.hitch(this, this._dndNodeCreator);
            }

            this.dndSource = new this.dndConstructor(
                this.bodyNode,
                lang.mixin(this.dndParams, {
                    // add cross-reference to grid for potential use in inter-grid drop logic
                    grid: this,
                    dropParent: this.contentNode
                })
            );
            // Allows selection of only one element
            this.dndSource.singular = true;
        },

        _dndNodeCreator: function (item, hint) {
            // summary:
            //      Custom DnD avatar creator method

            var dndTypes, node;

            dndTypes = this._getDndType(item);

            if (!dndTypes && this.dndTypes) {
                dndTypes = this.dndTypes;
            }

            node = domConstruct.create("div").appendChild(document.createTextNode(item.name));
            return {
                node: node,
                type: dndTypes,
                data: item
            };
        }
    });
});

},
'epi-cms/dgrid/WithContextMenu':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/on",
    "dojo/query",
    "dgrid/extensions/DijitRegistry",
    "epi/shell/DestroyableByKey",
    "epi/shell/widget/ContextMenu",
    "epi-cms/extension/events"
], function (
    declare,
    event,
    domGeometry,
    domStyle,
    on,
    query,
    DijitRegistry,
    DestroyableByKey,
    ContextMenu,
    events
) {

    return declare([DestroyableByKey, DijitRegistry], {
        // summary:
        //      Extension for dgrid that adds a context menu.
        // tags:
        //      public

        // contextMenu: [public] Object
        //      The context menu widget that is bound to the context menu node of each row
        //      in a grid or list.
        contextMenu: null,

        // commandCategory: [public] String
        //      The command category to be used when determining which command should
        //      appear in the context menu.
        commandCategory: "context",

        // stopPropagation: [public] Boolean
        //      Bool to stop propagation when clicking the context menu
        stopPropagation: false,

        // _contextMenuClass: [private] String
        //      The CSS class used to identify the context menu node within a dgrid-row.
        _contextMenuClass: "epi-iconContextMenu",

        postCreate: function () {
            // summary:
            //      Called after the list or grid has finished being created but before
            //      startup is called.
            // tags:
            //      protected

            this.inherited(arguments);

            this.contextMenu = this.contextMenu || new ContextMenu({ category: this.commandCategory, popupParent: this });

            this.own(
                this.contextMenu,
                this.on("." + this._contextMenuClass + ":click", this._contextMouseHandler.bind(this)),
                this.on(on.selector(".dgrid-row", events.keys.shiftf10), this._contextKeyHandler.bind(this))
            );
        },

        startup: function () {
            // summary:
            //      Called automatically after postCreate if the component is already
            //      visible; otherwise, it should be called manually once placed.
            // tags:
            //      protected

            this.inherited(arguments);

            this.contextMenu.startup();
        },

        onContextMenuClick: function (e) {
            // summary:
            //      Opens the context menu at the position the event occurred.
            // tags:
            //      protected callback

            // If the grid supports selection then ensure the row is selected before opening the
            // context menu.
            if (this.selection) {
                this.select(e.target);
            }

            on.emit(e.target, "dgrid-contextmenu", { bubbles: true });

            this.contextMenu.scheduleOpen(this.domNode, null, {
                x: e.pageX,
                y: e.pageY
            });
        },

        _extendedSelectionHandler: function (e, target) {
            // summary:
            //      Extend the selection handler for "extended" mode, so that clicks on
            //      the context menu of a selected row will not clear the selection.
            // tags:
            //      protected

            var hasContextMenuClass = new RegExp("\\b" + this._contextMenuClass + "\\b");

            // If we are clicking on the context menu and the target row is already
            // selected, then do an early exit in order to avoid deselecting the currently
            // selected rows.
            if (hasContextMenuClass.test(e.target.className) && this.isSelected(target)) {
                return;
            }

            this.inherited(arguments);
        },

        _isNodeVisible: function (domNode) {
            // summary:
            //      Checks the computed style on a domNode to see if display is other than "none"
            //      and visibility is other than "hidden".
            // tags:
            //      private

            if (!domNode) {
                return false;
            }
            var style  = domStyle.get(domNode);
            return style.display !== "none" && style.visibility !== "hidden";
        },

        _contextMouseHandler: function (e) {
            // tags:
            //      private

            if (this.stopPropagation) {
                e.stopImmediatePropagation();
                e.stopPropagation();
            }

            this.onContextMenuClick(e);
        },

        _contextKeyHandler: function (e) {
            // tags:
            //      private

            var contextMenuNode = query("." + this._contextMenuClass, e.target)[0],
                position;

            if (!this._isNodeVisible(contextMenuNode)) {
                return;
            }

            e.stopPropagation();
            e.preventDefault();
            position = domGeometry.position(contextMenuNode);

            this.onContextMenuClick({
                target: contextMenuNode,
                pageX: position.x,
                pageY: position.y
            });
        }
    });
});

},
'epi/shell/widget/ContextMenu':function(){
﻿define("epi/shell/widget/ContextMenu", [
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/dom-geometry",
    "dijit/Menu",
    "dijit/popup",

    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/command/builder/MenuBuilder",

    "epi/shell/command/builder/MenuWithSeparatorBuilder"
], function (
    declare,
    aspect,
    domGeometry,
    Menu,
    popup,

    _CommandConsumerMixin,
    MenuAssembler,
    MenuBuilder,
    MenuWithSeparatorBuilder
) {

    var ContextMenu;

    aspect.before(popup, "open", function (args) {
        // Propagate the popupParent property from our ContextMenu to the dijit popup machinery.
        // This keeps the popupParent, the owner of our popup, in the dijit.focus.activeStack.
        // Otherwise we'll lose the dijitFocused class from the parent and the onBlur will
        // be raised on it, etc.

        var popup = args.popup;
        if (popup && popup instanceof ContextMenu && popup.popupParent) {
            args.parent = popup.popupParent;
            return [args];
        }
    });

    return ContextMenu = declare([Menu, _CommandConsumerMixin], {
        // summary:
        //      A context menu that can display context commands for an item.
        //
        // tags:
        //      public

        // category: string
        //		If set the menu will be filtered on the category.
        category: null,

        // leftClickToOpen: [readonly] Boolean
        //		Menu will open on left click instead of right click.
        leftClickToOpen: true,

        postCreate: function () {

            this.inherited(arguments);

            var defaultConfiguration = { builder: new MenuBuilder(), target: this, category: this.category },
                assembler;

            var configuration = [
                defaultConfiguration,
                { builder: new MenuWithSeparatorBuilder(), target: this, category: "menuWithSeparator" },
                { builder: new MenuBuilder(), target: this, category: "popup" }
            ];
            assembler = new MenuAssembler({ configuration: configuration, commandSource: this });

            assembler.build();
        },

        scheduleOpen: function (/*DomNode?*/delegatedTarget, /*DomNode?*/iframe, /*Object?*/coords, /*DomNode?*/target) {
            // summary:
            //      Display the menu
            // remarks:
            //      See more details in the base class(Dijit/Menu)
            // tags:
            //      public

            this._scheduleOpen(delegatedTarget, iframe, coords, target);
        },

        forceOpen: function (e) {
            // summary:
            //      Force to display the menu next to the icon
            // tags:
            //      internal

            if (!e.target || !e.target.parentElement) {
                return;
            }
            var contextMenuIconNode = e.target.parentElement.querySelector(".epi-iconContextMenu");
            if (!contextMenuIconNode) {
                return;
            }

            e.stopPropagation();
            e.preventDefault();
            var position = domGeometry.position(contextMenuIconNode);

            this.scheduleOpen(contextMenuIconNode, null, {x: position.x, y: position.y});
        }
    });
});

},
'epi-cms/extension/events':function(){
﻿define([
    "dojo/keys",                                            // used to detect keyboard event
    "dojo/on"                                               // used to query dom by query string inside this.domNode
], function (
    keys,
    on
) {
    // =======================================================================
    // Helper method
    //
    function isDeleteKey(e) {
        return e.keyCode === keys.DELETE;
    }
    function isShiftKey(e) {
        return e.shiftKey;
    }
    function isF10(e) {
        return e.keyCode === keys.F10;
    }
    function isShiftF10(e) {
        return isShiftKey(e) && isF10(e);
    }

    // =======================================================================
    // Common function to create a customize event
    //
    function eventHandler(type, selectHandler) {
        var handler = function (node, listener) {
            return on(node, type, function (evt) {
                if (selectHandler) {
                    return selectHandler(evt, listener);
                }
                return listener.call(this, evt);
            });
        };

        return handler;
    }

    return {
        // summary:
        //      An static class that add default events (keyboard/mouse) for common uses.
        // tags:
        //      internal

        // Support this for more convenient
        selector: on.selector,

        contextmenu: eventHandler("contextmenu", function (e, listener) {
            // summary:
            //      Shortcut way to listen to the contextmenu event
            // tags:
            //      public event

            listener.call(this, e);
        }),

        // =======================================================================
        // Keyboard events
        //

        // keys: [internal] Object
        //      Key event handlers
        keys: {
            shiftf10: eventHandler("keyup", function (e, listener) {
                // summary:
                //      Shortcut way to listen shift-f10 key event
                // tags:
                //      public event

                if (isShiftF10(e)) {
                    listener.call(this, e);
                }
            }),

            del: eventHandler("keydown", function (e, listener) {
                // summary:
                //      Shortcut way to listen delete keydown event
                // tags:
                //      public event

                if (isDeleteKey(e)) {
                    listener.call(this, e);
                }
            })
        }
    };
});

},
'epi-cms/widget/viewmodel/ContentReferencesViewModel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/store/util/QueryResults",
    "dojo/when",
    "epi/shell/TypeDescriptorManager",
    // Parent class and mixins
    "dojo/Stateful",
    "dijit/Destroyable",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentreferences"
], function (
    declare,
    lang,
    aspect,
    QueryResults,
    when,
    TypeDescriptorManager,
    // Parent class and mixins
    Stateful,
    Destroyable,
    // Resources
    resources
) {
    return declare([Stateful, Destroyable], {
        // tags:
        //      internal

        // contentItems: [public] Content[]
        //      The content items whose references the widget should show.
        contentItems: null,

        // mode: [public] String
        //      What mode the content references widget should be in.
        mode: null,

        // notification: [public] String
        //      The notification text.
        notification: null,

        // notificationBarStyle: [public] Number
        //      The notification text style. 1 for green, 2 for orange and yellow for everything else.
        notificationBarStyle: null,

        // numberOfReferences: [public] Number
        //      How many references the content items have.
        numberOfReferences: null,

        // showToolbar: [public] Boolean
        //      Flag to indicate if the tool bar should show.
        showToolbar: null,

        // showGrid: [public] Boolean
        //      Flag to indicate if the content reference grid should show.
        showGrid: null,

        // totalLinks: [public] String
        //      The text for the number of references.
        totalLinks: null,

        getUpdatedStore: function (store) {
            // summary:
            //      Updates the store with functionality to support the tree structure of the data.
            // store: dojo/store
            //      The store to update.
            // tags:
            //      public

            var updatedStore = lang.delegate(store, {
                getChildren: function (object) {
                    return new QueryResults(object.references);
                },

                mayHaveChildren: function (object) {
                    return !!object.references && object.references.length > 0;
                }
            });

            this.own(aspect.after(updatedStore, "query", function (results) {
                when(results).then(this._afterStoreQuery.bind(this));
                return results;
            }.bind(this)));

            return updatedStore;
        },

        _afterStoreQuery: function (results) {
            // summary:
            //      Sets the values of properties that are dependent on the results from the store.
            // results: ReferenceItem[]
            //      An array of referenced items that will be used when getting the number of references.
            // tags:
            //      private

            var total = this._getReferencesCount(results);
            this._updateReferenceProperties(total);
            this.set("showToolbar", total > 0);
            this.set("showGrid", total > 0);
        },

        _getReferencesCount: function (results) {
            // summary:
            //      Counts the number of references in the results.
            // results: ReferenceItem[]
            //      An array of referenced items that will be used when getting the number of references.
            // tags:
            //      private

            return results.reduce(function (previousValue, referenceItem) {
                return previousValue + referenceItem.references.length;
            }, 0);
        },

        _updateReferenceProperties: function (number) {
            // summary:
            //      sets the number of references, and widget notification, styles based on the number.
            // tags:
            //      private

            var contentItems = this.contentItems,
                contentData = contentItems[0],
                hasReferences = number > 0,
                isSingleItem = contentItems.length === 1,
                // Determine if any item has children
                hasChildren = contentItems.some(function (item) {
                    return item.hasChildren;
                }),
                hasPublicUrls = contentItems.some(function (item) {
                    return !!item.publicUrl;
                });

            var setNotification = function (resourceKey, styleType) {
                resourceKey = "reference." + (isSingleItem ? "single" : "multiple") + "." + resourceKey;

                // Remarks: the typeIdentifier might be wrong if the user has selected more than one item
                // but most of the time it will display the correct resource value
                var text = TypeDescriptorManager.getResourceValue(contentData.typeIdentifier, resourceKey);

                this.set("notification", text);
                this.set("notificationBarStyle", styleType);
            }.bind(this);

            if (hasReferences) {
                setNotification(hasChildren ? "usedwithchildren" : "used", 2);
            } else if (hasPublicUrls) {
                setNotification(hasChildren ? "publicwithchildren" : "public", 2);
            } else {
                setNotification(hasChildren ? "notusedwithchildren" : "notused", hasChildren ? 2 : 1);
            }

            // build number of links text
            if (hasReferences) {
                var resourceText = number === 1 ? resources.totallink : resources.totallinks;
                var numberOfLinks = lang.replace(resourceText, [number]);
                this.set("totalLinks", numberOfLinks);
            }

            this.set("numberOfReferences", number);
        }

    });
});

},
'url:epi-cms/widget/templates/ContentReferences.html':"﻿<div class=\"epi-contentReferences\">\r\n    <div data-dojo-attach-point=\"contentReferencesNotificationBar\" class=\"epi-notificationBar epi-notificationBarWithBorders epi-notificationBarItem\">\r\n        <div data-dojo-attach-point=\"contentReferencesNotificationNode\" class=\"epi-notificationBarText\" ></div>\r\n    </div>\r\n    <div class=\"epi-captionPanel\" data-dojo-attach-point=\"captionPanelNode\">\r\n        <strong data-dojo-attach-point=\"totalLinksNode\"></strong>\r\n        <div class=\"epi-floatRight\">\r\n            <button class=\"epi-chromelessButton\"\r\n                    data-dojo-type=\"dijit/form/Button\"\r\n                    data-dojo-attach-event=\"onClick:fetchData\"\r\n                    data-dojo-props=\"iconClass:'epi-iconReload'\">${res.buttons.refresh}</button>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>\r\n",
'epi-cms/widget/ContentForestStoreModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
    "epi/epi",
    "epi-cms/widget/ContentTreeStoreModel"
], function (
    array,
    declare,
    lang,
    promiseAll,
    when,
    epi,
    ContentTreeStoreModel
) {

    return declare([ContentTreeStoreModel], {
        // summary:
        //      A store model for tree widgets that must support content with multiple roots.
        // description:
        //      The model creates a fabricated root item in order to support a store that has
        //      content with multiple roots. It is expected that the root will never be displayed
        //      in the tree.
        //
        // tags:
        //      internal xproduct

        // root: [readonly] Object
        //      The fabricated root item for the model.
        root: null,

        constructor: function () {
            this.root = {
                id: "0",
                name: "ROOT"
            };
        },

        // =======================================================================
        // Methods for traversing hierarchy

        isRoot: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //		Checks to see if the item is a root node in the content forest
            // contentItem: [dojo/data/Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            var inherited = this.inherited(arguments);
            return inherited || !!(contentItem && this.roots && (array.indexOf(this.roots, this.getIdentity(contentItem)) >= 0));
        },

        getRoot: function (/*Function*/ onItem) {
            // summary:
            //      Calls onItem with the fake root item for the tree.
            onItem(this.root);
        },

        mayHaveChildren: function (item) {
            // summary:
            //      Tells if an item has or may have children.
            // item: Object
            //      Item from the dojo/store
            return item === this.root || this.inherited(arguments); // Boolean
        },

        getChildren: function (parentItem, /*Function*/ onComplete, /*Function*/ onError) {
            // summary:
            //      Calls onComplete() with an array of child items of given parent item.
            // parentItem: Object
            //      Item from the dojo/store
            if (parentItem === this.root) {
                var deferreds = array.map(this.roots, function (item) {
                    return this.store.get(item);
                }, this);

                when(promiseAll(deferreds), onComplete, onError);
            } else {
                this.inherited(arguments);
            }
        },

        getAncestors: function (item, /*Function*/ onComplete) {
            // summary:
            //      Calls onComplete() with an array of ancestors of the given item.
            // item: Object
            //      Item from the dojo/store

            // Return root if item is subroot
            if (this.roots.some(function (subRoot) {
                return this.getIdentity(item) === subRoot;
            }, this)) {
                onComplete([this.root]);
                return;
            }

            var root = this.root,
                callback = lang.hitch(this, function (results) {
                    if (array.some(this.roots, function (subRoot) {
                        return this.getIdentity(results[0]) === subRoot;
                    }, this)) {
                        results.unshift(root);
                    }
                    onComplete(results);
                });

            this.inherited(arguments, [item, callback]);
        },

        // =======================================================================
        // Inspecting items

        getIdentity: function (item) {
            // summary:
            //      Returns identity for an item.
            // item: Object
            //      Item from the dojo/store
            return epi.areEqual(item, this.root) ? this.root.id : this.inherited(arguments); // String
        },

        canCopy: function (item) {
            // summary:
            //      Determine whether the copy action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            return !this.isRoot(item) && this.inherited(arguments);
        },

        canCut: function (item) {
            // summary:
            //      Determine whether the cut action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            return !this.isRoot(item) && this.inherited(arguments);
        },

        canDelete: function (item) {
            // summary:
            //      Determine whether the delete action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            return !this.isTypeOfRoot(item) && this.inherited(arguments);
        },

        canEdit: function (item) {
            // summary:
            //      Determine whether the edit action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            return !this.isRoot(item) && this.inherited(arguments);
        }
    });
});

},
'epi-cms/widget/ContentTreeStoreModel':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when",
    "dojo/topic",
    // epi
    "epi",
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/_ContextMixin",
    "epi/shell/ViewSettings",

    // EPi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/_HierarchicalModelMixin",
    "epi-cms/widget/viewmodel/_UpdateableStoreModelMixin"
],

function (
// dojo
    array,
    connect,
    declare,
    lang,
    Stateful,

    aspect,
    Deferred,
    promiseAll,
    when,
    topic,
    // epi
    epi,
    dependency,
    TypeDescriptorManager,
    _ContextMixin,
    ViewSettings,
    // EPi CMS
    ApplicationSettings,
    ContentActionSupport,
    ContentReference,
    _HierarchicalModelMixin,
    _UpdateableStoreModelMixin
) {

    return declare([Stateful, _HierarchicalModelMixin, _UpdateableStoreModelMixin, _ContextMixin], {
        // summary:
        //      A store model for tree widgets that only support content with a single root.
        //
        // tags:
        //      internal xproduct

        // store: [protected] dojo/store/api/Store
        //		Underlying store that will be queried for page tree items.
        store: null,

        // service: [protected] epi-cms/contentediting/ContentHierarchyService
        //		Service to use when updating data.
        service: null,

        // root: [public] ContentReference|String
        //		Id of the root content
        root: null,

        // notAllowToDelete: [public] List of item that we don't allow to delete. For example: Waste basket, start, root folder,...
        //		Id of the root content
        notAllowToDelete: null,

        // notAllowToCopy: [public] List of item that we don't allow to copy. For example: Waste basket, root folder,...
        //		Id of the root content
        notAllowToCopy: null,

        // typeIdentifiers: [protected] Array | String
        //		The set of type identifiers to be taken into account. Can either be an array or a comma separated string.
        typeIdentifiers: null,

        showAllLanguages: true,

        getChildrenQuery: "getchildren",

        getRootChildrenQuery: null,

        // _observers: [protected] Array
        //		Collection to store all the listeners from observed queries.
        _observers: null,

        // _defaultDataStoreName: [protected] String
        //		Default data store name to get from registry, if store is null.
        _defaultDataStoreName: "epi.cms.content.light",

        // additionalQueryOptions: [protected] Object
        //		Additional query options added when getting children. Set by inherited model.
        additionalQueryOptions: {},

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        // autoSelectPastedItem: Boolean
        //      Set to true if the pasted item automatically should be selected
        autoSelectPastedItem: true,

        constructor: function (args) {
            // summary:
            //		Construct the ContentTreeStoreModel object.

            declare.safeMixin(this, args);

            this._observers = {};
            this.store = this.store || dependency.resolve("epi.storeregistry").get(this._defaultDataStoreName);
            this.service = this.service || dependency.resolve("epi.cms.ContentHierarchyService");

            this._queryOptions = lang.mixin({
                ignore: ["query"],
                comparers: {
                    typeIdentifiers: lang.hitch(this, function (queryValue, instance) {
                        return array.some(queryValue, lang.hitch(this, function (item) {
                            return item === instance.typeIdentifier || TypeDescriptorManager.isBaseTypeIdentifier(instance.typeIdentifier, item);
                        }));
                    }),
                    referenceId: function (queryValue, instance) {
                        return ContentReference.compareIgnoreVersion(queryValue, instance.parentLink);
                    },
                    allLanguages: function (queryValue, instance) {
                        if (queryValue || !instance.currentLanguageBranch) {
                            return true;
                        }

                        return epi.areEqual(ApplicationSettings.currentContentLanguage, instance.currentLanguageBranch.languageId);
                    },
                    references: function (queryValue, instance) {
                        return queryValue.some(function (referenceId) {
                            return ContentReference.compareIgnoreVersion(referenceId, instance.parentLink);
                        });
                    }
                },
                sort: this._getSortSettings(this.typeIdentifiers)
            }, this.additionalQueryOptions);

            var updateHandle = connect.subscribe("/epi/cms/contentdata/updated", this, function (updatedContent) {
                var contentLink = new ContentReference(updatedContent.contentLink).createVersionUnspecificReference().toString();
                this.store.refresh(contentLink).then(lang.hitch(this, function () {
                    if (updatedContent.recursive) {
                        this.onItemChildrenReload(updatedContent);
                    }
                }));
            });

            //publish command has been executed: update children
            var childrenChangeHandle = connect.subscribe("/epi/cms/contentdata/childrenchanged", lang.hitch(this, this._childrenChanged));

            var itemNotifyHandle = this._handleStoreNotification();

            this._handles = [updateHandle, childrenChangeHandle, itemNotifyHandle];
        },

        _handleStoreNotification: function () {
            this._cachedItems = {}; //hashmap of contentItem and { timoutHandle, serializedItem }

            var self = this;
            //when the store is refreshed, update the item
            return aspect.after(this.store, "notify", lang.hitch(this, function (item, id) {
                if (!self._cachedItems[item.contentLink]) {
                    self._cachedItems[item.contentLink] = {};
                }

                var timeoutHandle = self._cachedItems[item.contentLink].timoutHandle;
                if (timeoutHandle) {
                    clearTimeout(timeoutHandle);
                }
                self._cachedItems[item.contentLink].timoutHandle = setTimeout(function () {
                    delete self._cachedItems[item.contentLink].timoutHandle;

                    var serializedItem = JSON.stringify(item);
                    if (serializedItem === self._cachedItems[item.contentLink].serializedItem) {
                        return;
                    }
                    self._cachedItems[item.contentLink].serializedItem = serializedItem;

                    self.onChange(item);
                }, 100);

            }), true);
        },

        destroy: function () {
            // summary:
            //		Destroy the object.

            for (var id in this._observers) {
                if (this._observers[id]) {
                    this._observers[id].remove();
                    this._observers[id] = null;
                }
            }
            if (this._handles) {
                array.forEach(this._handles, function (handle) {
                    handle.remove();
                });

                this._handles = null;
            }
        },

        isSupportedType: function (dataType) {
            // summary:
            //      Check the supported type of data type selected.
            // dataType: [String]
            //      The type of data selected
            // tags:
            //      public

            return array.some(this.typeIdentifiers, function (type) {
                return type === dataType || TypeDescriptorManager.isBaseTypeIdentifier(dataType, type);
            });
        },

        _showAllLanguagesSetter: function (value) {
            this.showAllLanguages = value;
            this.onItemChildrenReload(this.root);
        },

        // =======================================================================
        // Methods for traversing hierarchy

        getRoot: function (onItem, onError) {
            // summary:
            //		Calls onItem with the root item for the tree, possibly a fabricated item.

            if (lang.isArray(this.root)) {
                onItem({});
            } else {
                when(this.store.get(this.root), onItem, onError);
            }
        },

        mayHaveChildren: function (item) {
            // summary:
            //		Tells if an item has or may have children.  Implementing logic here
            //		avoids showing +/- expando icon for nodes that we know don't have children.
            //		(For efficiency reasons we may not want to check if an element actually
            //		has children until user clicks the expando node)

            return item.hasChildren;
        },

        getChildren: function (parentItem, onComplete) {
            // summary:
            //		Calls onComplete() with array of child items of given parent item, all loaded.

            var id = this.getIdentity(parentItem),
                observer = this._observers[id],
                isRoot = id === this.root,
                queryType = isRoot && this.getRootChildrenQuery ? this.getRootChildrenQuery : this.getChildrenQuery,
                query = this._createQuery({ referenceId: id, query: queryType, selectedContentReference: this.selectedContentReference }),
                results = this.store.query(query, this._queryOptions);

            if (observer) {
                observer.remove();
                delete this._observers[id];
            }

            // Hook up an observer to the results to re-query if the collection changes.
            // We cannot reuse the results directly since the query-options are crucial for the data
            // if the items to be correct(i.e. hasChildren depending on contentTypes and language)
            this._observers[id] = results.observe(function (item, removedFrom, insertedInto) {
                when(this.store.query(query, this._queryOptions), this.onChildrenChange.bind(this, parentItem));
            }.bind(this), true);

            when(results, onComplete);
        },

        _getSortSettings: function (/*String || Array*/typeIdentifiers) {
            // summary:
            //      Get sort settings by typeIdentifiers.
            // tags:
            //      protected virtual

            if (!typeIdentifiers) {
                return {};
            }

            if (typeIdentifiers instanceof String) {
                typeIdentifiers = [typeIdentifiers];
            }

            var sortColumn,
                sortSettings = [];

            typeIdentifiers.map(function (type) {
                sortColumn = TypeDescriptorManager.getValue(type, "sortKey");
                if (sortColumn) {
                    sortSettings.push(sortColumn.sortDescending ?
                        { attribute: sortColumn.columnName, descending: true } :
                        { attribute: sortColumn.columnName });
                }
            });

            return sortSettings;
        },

        _createQuery: function (queryBase, excludeType) {
            var typeIdentifiers = this.typeIdentifiers &&
                    (lang.isArray(this.typeIdentifiers) ? this.typeIdentifiers : this.typeIdentifiers.split(","));

            var language = this.showAllLanguages ? { allLanguages: true } : {},
                requestType = excludeType ? {} : { typeIdentifiers: typeIdentifiers };

            var query = lang.mixin(queryBase, requestType, language);

            return query;
        },

        _createChildrenQuery: function (queryBase, excludeType) {
            var childrenQuery = lang.mixin(queryBase, { query: "getchildren" });
            return this._createQuery(childrenQuery, excludeType);
        },

        move: function (sourceItems, target) {
            // summary:
            //      Move the source item to target.

            var contentItems = sourceItems.map(function (item) {
                return item.data;
            });

            return this.pasteItems(contentItems, target, false);
        },

        remove: function (items) {
            // summary
            //      Removes (deletes) the source

            items = items.map(function (item) {
                return item.data;
            });

            var deferreds = items.map(function (item) {
                return this.store.remove(item.contentLink);
            }, this);

            return promiseAll(deferreds).then(lang.hitch(this, function () {
                this.onDeleted(items);
            }));
        },

        copy: function (sourceItems, target) {
            // summary:
            //      Copy the source items to target.

            var contentItems = sourceItems.map(function (item) {
                return item.data;
            });

            return this.pasteItems(contentItems, target, true);
        },

        pasteItems: function (sourceItems, targetItem, copy, sortIndex) {
            // summary:
            //		Move or copy several items from one parent item to another.
            // sourceItems: [Item]
            //      The items that should be copied or moved
            // targetItem: Item
            //      The target item for the operation
            // copy: Boolean
            //      If true the childItem will be copied; otherwise it will be moved.
            // sortIndex: integer
            //      Optional sortIndex in the child collection of the new parent
            // returns: object
            //      An object indicating the result of the operation
            //
            // tags: public

            var method = copy ? "copy" : "move",
                ids,
                ignoredItems = [],
                deletingCurrentContext;

            ids = sourceItems.map(this.getIdentity, this);

            // check if the current context is being deleted before doing the operation
            // afterwards the structure has changed which giver the wrong answer
            return when(this.getCurrentContext()).then(function (ctx) {
                return this._isNodeAContextAncestor(ids, ctx)
                    .then(function (isNodeAContextAncestor) {
                        deletingCurrentContext = isNodeAContextAncestor;
                        return isNodeAContextAncestor;
                    });
            }.bind(this)).then(function () {
                return this.service[method](ids, this.getIdentity(targetItem), this.createAsLocalAsset, sortIndex);
            }.bind(this)).then(function (response) {

                // Get all items that are part of the paste operation
                return promiseAll(sourceItems.map(function (item) {
                    var itemId = response.extraInformation[item.contentLink].extraInformation || item.contentLink;

                    var contentLink = ContentReference.toContentReference(itemId).createVersionUnspecificReference().toString();

                    return this.store.get(contentLink);
                }, this));
            }.bind(this)).then(function (items) {
                if (targetItem.isWastebasket) {
                    this._handleSelect(sourceItems, deletingCurrentContext);
                } else {
                    // Publish a children changed event for the new parent to ensure that the new
                    // parent node is updated if it exists in other tree structures.
                    topic.publish("/epi/cms/contentdata/childrenchanged", targetItem.contentLink);

                    // Publish a children changed event also for the sourceItems parents in order to
                    // refresh it's tree structure
                    var refreshedItems = [];
                    sourceItems.forEach(function (sourceItem) {
                        if (refreshedItems.indexOf(sourceItem.parentLink) === -1) {
                            topic.publish("/epi/cms/contentdata/childrenchanged", sourceItem.parentLink);
                            refreshedItems.push(sourceItem.parentLink);
                        }
                    });
                }

                this._handleDelete(items);

                items.forEach(function (item) {
                    this._onPasteComplete(item, item.isDeleted, null, targetItem);
                }, this);

                // Get all items that were already there in the target folder, if the file is pasted successfully then
                // the parentLink will equal the target folder. Otherwise it will remain the same.
                ignoredItems = items.filter(function (item) {
                    return sourceItems.some(function (sourceItem) {
                        return (sourceItem.contentLink === item.contentLink) && (sourceItem.parentLink === item.parentLink);
                    });
                });

                if (this.createAsLocalAsset === true) {
                    topic.publish("/epi/cms/action/createlocalasset");
                }

            }.bind(this)).then(function () {
                if (ignoredItems.length > 0) {
                    this.onPasteItemsFailed(ignoredItems);
                }
            }.bind(this));
        },

        pasteItem: function (childItem, oldParentItem, newParentItem, copy, sortIndex) {
            // summary:
            //		Move or copy an item from one parent item to another.
            // childItem: Item
            //      A reference to the item that should be moved or copied
            // oldParentItem: Item
            //      The current parent item
            // newParentItem: Item
            //      The target item for the operation
            // copy: Boolean
            //      If true the childItem will be copied; otherwise it will be moved.
            // sortIndex: integer
            //      Optional sortIndex in the child collection of the new parent
            // returns: object
            //      An object indicating the result of the operation
            //
            // tags: public
            //

            // Having copy/paste/delete call pasteItem may seem a bit backwards, but since the drag & drop
            // is calling pasteItem() with all required arguments it becomes a bit messy to drop some arguments
            // here (i.e. old/new parent) and then do the lookup again.
            // Those methods also have to duplicate the notification logic

            return this.pasteItems([childItem], newParentItem, copy, sortIndex)
                .then(function (response) {
                    // Return the response from the first extraInformation
                    return response.extraInformation[childItem.contentLink];
                });
        },

        onPasteComplete: function () {
            // summary:
            //      Stub to do somethings when paste process complete
            // tags:
            //      public, callback
        },

        _onPasteComplete: function (item, isDeleted, oldParentItem, newParentItem) {
            // summary:
            //		Executed after a paste operation has completed
            // item: Item
            //      The target item of the operation
            // isDeleted: boolean
            //      If the operation resulted in the item being deleted, i.e. moved to the trash
            // oldParentItem: Item
            //      The current parent item
            // newParentItem: Item
            //      The target item for the operation
            // tags: protected

            this.onPasteComplete();

            this._selectItemOnPasteComplete(item, isDeleted, oldParentItem, newParentItem);
        },

        _selectItemOnPasteComplete: function (item, isDeleted, oldParentItem, newParentItem) {
            // summary:
            //		Select an item after a paste operation has completed
            // item: Item
            //      The target item of the operation
            // isDeleted: boolean
            //      If the operation resulted in the item being deleted, i.e. moved to the trash
            // oldParentItem: Item
            //      The current parent item
            // newParentItem: Item
            //      The target item for the operation
            // tags: protected

            if (this.autoSelectPastedItem && item && item.contentLink && !isDeleted) {
                this.onSelect(item.contentLink, true);
            }
        },

        newItem: function (item, newParentItem) {
            // summary:
            //		Called when an item that's accepted in the tree is added by an external source, for instance by dragging an item from a listing to the tree.

            this.newItems([item], newParentItem);
        },

        newItems: function (items, newParentItem) {
            var newItems = items.map(function (item) {
                return item.dndData.data;
            });

            this._pasteNewItems(newItems, newParentItem);
        },

        _pasteNewItems: function (newItems, newParentItem) {
            //Right now we only support move actions when moving items from an external source to the tree. Might be changed in the future.
            this.pasteItems(newItems, newParentItem, false);
        },

        _updateItemChanged: function (parentContentLink) {
            // update the parent cause of in some case its properties changed
            when(this.store.refresh(parentContentLink), lang.hitch(this, function (updatedItem) {
                // then update its children
                this._childrenChanged(updatedItem);
            }));
        },

        _childrenChanged: function (parent) {
            var dfd = new Deferred();

            this.getChildren(parent, lang.hitch(this, function (children) {
                this.onChildrenChange(parent, children);
                dfd.resolve(children);
            }));

            return dfd;
        },

        _isNodeAContextAncestor: function (nodeContentLinks, context) {
            var dfd = new Deferred(),
                directMatch = nodeContentLinks.some(function (contentId) {
                    return ContentReference.compareIgnoreVersion(contentId, context.id);
                });

            if (directMatch) {
                dfd.resolve(true);
            } else {
                this.getAncestors(context, function (ancestors) {
                    var result = ancestors.some(function (ancestor) {
                        return nodeContentLinks.indexOf(ancestor.contentLink) > -1;
                    });

                    dfd.resolve(result);
                });
            }

            return dfd.promise;
        },

        _handleSelect: function (deletedItems, deletingCurrentContext) {
            // summary:
            //      Makes sure selection and context is updated based on what has been deleted.
            // tags:
            //      private

            var firstDeletedItem, singleItem;

            if (deletingCurrentContext) {
                firstDeletedItem = deletedItems[0];
                // in headless mode folders or blocks are also displayed in the tree so we need to make sure to try to select the parent or root
                var shouldSelectParentOrRoot = ApplicationSettings.isInHeadlessMode || firstDeletedItem.capabilities.isPage;
                if (shouldSelectParentOrRoot) {
                    singleItem = deletedItems.length === 1 && firstDeletedItem;
                    this.onSelect(singleItem ? singleItem.parentLink : ApplicationSettings.startPage, true);
                    return;
                }

                topic.publish("/epi/shell/context/request", { uri: ViewSettings.settings.defaultContext });
            }

            var folders = deletedItems.filter(function (deletedItem) {
                return this.isSupportedType(deletedItem.typeIdentifier);
            }.bind(this));

            /*
                Deleting from asset pane:
                1) Single folder - look for parent
                2) Many folders - select GlobalAssetsFolder
                3) Item or many items - the selection should not change
            */

            if (folders.length === 1) {
                this.onSelect(folders[0].parentLink, true);
            } else if (folders.length > 1) {
                this.onSelect(ApplicationSettings.globalAssetsFolder, true);
            }
        },

        checkItemAcceptance: function (target, source) {
            // summary:
            //      Called from DnD to check if a specific target can accept the items in source
            //
            // tags: public

            // list source uses getSelectedNodes, tree source uses getSelectedTreeNodes
            var selectedNodes = source.getSelectedNodes ? source.getSelectedNodes() : source.getSelectedTreeNodes();
            var canPastePromises = selectedNodes.map(function (node) {
                var item = source.getItem(node.id);
                var data = item.data;
                if (data.dndData) {
                    data = data.dndData;
                }
                // canPaste can return a promise in classes that inherit from this one.
                return this.canPaste(data, target);
            }, this);

            return promiseAll(canPastePromises).then(function (results) {
                return results.every(function (canPaste) {
                    return canPaste;
                });
            });
        },

        _handleDelete: function (items) {

            var deletedItems = items.filter(function (item) {
                return item.isDeleted;
            });

            if (deletedItems.length > 0) {
                deletedItems.forEach(function (item) {
                    var id = this.getIdentity(item),
                        observer = this._observers[id];
                    if (observer) {
                        observer.remove();
                        delete this._observers[id];
                    }
                    this.onDelete(item, true);
                }, this);

                this.onDeleted(deletedItems);
            }
        },

        // =======================================================================
        // Inspecting items

        getIdentity: function (item) {
            // summary:
            //		Returns identity for an item

            if (lang.isObject(item)) {
                return this.store.getIdentity(item);
            }
            return item;
        },

        getObjectIconClass: function (/*Object*/item, /*String*/fallbackIconClass) {
            // summary:
            //      Get icon class for content based on its content link
            // item: [Object]
            //      Content item data
            // fallbackIconClass: [String]
            //      Default icon class in case nothing returned
            // tags:
            //      public, extension

            var defaultIconClass = TypeDescriptorManager.getValue(item.typeIdentifier, "iconClass");
            if (!defaultIconClass) {
                return fallbackIconClass;
            }

            var suffix = "";
            switch (parseInt(item.contentLink, 10)) {
                case ApplicationSettings.globalAssetsFolder:
                    suffix = "AllSites";
                    break;

                case ApplicationSettings.siteAssetsFolder:
                    suffix = "ThisSite";
                    break;

                default:
                    break;
            }

            return (suffix === "" && defaultIconClass === fallbackIconClass) ? defaultIconClass : (fallbackIconClass + " " + defaultIconClass + suffix);
        },

        getLabel: function (item) {
            // summary:
            //		Get the label for an item

            return item.name;
        },

        canExpandTo: function (item) {
            // summary:
            //		Test if the tree can expand to an item
            // item: Object
            //      The item
            // returns:
            //       A promise which resolves to true if the item can be reached, otherwise false.

            var deferred = new Deferred();

            this.getAncestors(item, lang.hitch(this, function (ancestors) {
                deferred.resolve(this.getIdentity(ancestors[0]) === this.root.id);
            }));

            return deferred.promise;
        },

        canCopy: function (item) {
            // summary:
            //		Determine whether the given item is able to be copied by the current user.
            // remarks:
            //      Override to implement additional check.
            // tags:
            //		public

            if (!item) {
                return false;
            }

            var reference = item.contentLink,
                isSystemPage = reference === this.root || (array.indexOf(this.notAllowToCopy, reference) >= 0);

            return !isSystemPage &&
                ContentActionSupport.hasAccess(item.accessMask, ContentActionSupport.accessLevel.Read) &&
                ContentActionSupport.hasProviderCapability(item.providerCapabilityMask, ContentActionSupport.providerCapabilities.Copy);
        },

        canCut: function (item) {
            // summary:
            //		Determine whether the given item is able to be cut by the current user.
            // tags:
            //		public

            if (!item) {
                return false;
            }

            var reference = item.contentLink,
                isSystemPage = reference === this.root || (array.indexOf(this.notAllowToDelete, reference) >= 0);

            return !isSystemPage &&
                ContentActionSupport.isActionAvailable(item, ContentActionSupport.action.Delete, ContentActionSupport.providerCapabilities.Move, true);
        },

        canDelete: function (item) {
            // summary:
            //		Determine whether the given item is able to be deleted by the current user.
            // tags:
            //		public

            if (!item) {
                return false;
            }

            var reference = item.contentLink,
                isSystemPage = reference === this.root || (array.indexOf(this.notAllowToDelete, reference) >= 0);

            return !isSystemPage &&
                ContentActionSupport.isActionAvailable(item, ContentActionSupport.action.Delete, ContentActionSupport.providerCapabilities.Delete, true);
        },

        canPaste: function (item, target, isCopy) {
            // summary:
            //      Determines whether the given item can be moved or copied from its current parent to a new location
            //      Primarily used when validating drag & drop operations.
            // tags:
            //      public

            if (!item || !target) {
                return false;
            }

            var isCopyToWastebasket = isCopy && target.isWastebasket,
                isCutToTheSameItem = !isCopy && (this.getIdentity(item) === this.getIdentity(target)),
                isCutToTheSameParent = !isCopy && (item.parentLink === this.getIdentity(target)),
                hasAccess = ContentActionSupport.isActionAvailable(target, ContentActionSupport.action.Create, ContentActionSupport.providerCapabilities.Create, true);

            return !target.isDeleted && !isCopyToWastebasket && !isCutToTheSameItem && !isCutToTheSameParent && hasAccess;
        },

        canEdit: function (item) {
            // summary:
            //		Determine whether the given item is able to be edit by the current user.
            // tags:
            //		public

            if (!item) {
                return false;
            }

            var reference = item.contentLink,
                isSystemPage = reference === this.root;

            return !isSystemPage && ContentActionSupport.hasAccess(item.accessMask, ContentActionSupport.accessLevel.Edit);
        },

        // =======================================================================
        // Callbacks

        onItemChildrenReload: function (/*Object*/parent) {
            // summary:
            //  Raised when the children of an item must be reloaded.
            //  The subscriber needs to call getChildren to get the updated children collection
        },

        onChange: function (/*dojo/data/Item*/ /*===== item =====*/) {
            // summary:
            //		Callback whenever an item has changed, so that Tree
            //		can update the label, icon, etc.   Note that changes
            //		to an item's children or parent(s) will trigger an
            //		onChildrenChange() so you can ignore those changes here.
            // tags:
            //		callback
        },

        onChildrenChange: function (/*===== parent, newChildrenList =====*/) {
            // summary:
            //		Callback to do notifications about new, updated, or deleted items.
            // parent: dojo/data/Item
            // newChildrenList: dojo/data/Item[]
            // tags:
            //		callback
        },

        onDelete: function (/*dojo/data/Item*/ /*===== item =====*/) {
            // summary:
            //		Callback when an item has been deleted.
            // description:
            //		Note that there will also be an onChildrenChange() callback for the parent
            //		of this item.
            // tags:
            //		callback
        },

        onDeleted: function (deletedItems) {
            // summary:
            //      Callback when an item has been deleted to set the parent folder as selected
            // deletedItems: dojo/data/Item[]
            //      items deleted
            // tags:
            //      public callback
        },

        onSelect: function (ItemId, setFocus, onComplete) {
            // summary:
            //      Raise event to set an item as selected
            // tags:
            //      callback
        },

        onPasteItemsFailed: function (ignoredItems) {
            // summary:
            //      Raise event to select the items that were not pasted successfully.
            // tags:
            //      public callback
        }
    });
});

},
'epi-cms/widget/_HierarchicalModelMixin':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    // epi
    "epi/shell/_HierarchicalModelMixin"
],

function (
// dojo
    declare,
    lang,
    // epi
    _HierarchicalModelMixin
) {

    return declare([_HierarchicalModelMixin], {
        // summary:
        //      Decorate model for epi/shell/_HierarchicalModelMixin
        // tags:
        //      public

        isTypeOfRoot: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //      Checks to see if the item is type of root node such as: root, sub root
            // contentItem: [dojo/data/Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public, extension

            return !!(contentItem && (this.isRoot(contentItem) || contentItem.isSubRoot));
        },

        isRoot: function (/*dojo/data/Item*/contentItem) {
            // summary:
            //      Checks to see if the item is a root node in the content tree
            // contentItem: [dojo/data/Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            return !!(contentItem && this.root && contentItem === this.root);
        }

    });

});

},
'epi/shell/_HierarchicalModelMixin':function(){
// Disable eqeqeq for this file
/*eslint eqeqeq:0*/

define("epi/shell/_HierarchicalModelMixin", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when"
], function (
    array,
    declare,
    lang,
    Deferred,
    all,
    when
) {

    // summary:
    //		A mixin that adds Hierarchical support for a model
    return declare([], {
        // tags:
        //    public

        // parentProperty: [public] string
        //      The name of the property that indentifies the parent (e.g. parentLink)
        parentProperty: "parentLink",

        // store: [public] dojo/store/JsonRest
        //      The store that is used to get the ancestors
        store: null,

        constructor: function (options) {
            declare.safeMixin(this, options);
        },

        getParentIdentity: function (item) {
            // summary:
            //		Get the identity of the parent
            //
            // item:
            //      The item to get the parent identity for
            //
            // tags:
            //      public

            return lang.getObject(this.parentProperty, false, item);
        },

        isAncestor: function (source, target) {
            // summary:
            //		Checks to see if the source is an ancestor of the target.
            //
            // source:
            //      The item to check if ancestor
            //
            // target:
            //      The item to check the source against
            //
            // tags:
            //      public

            var sourceId = this.store.getIdentity(source),
                targetId = this.store.getIdentity(target),
                targetParentId = this.getParentIdentity(target);

            if (sourceId == targetId || (target.parentLink && source.contentLink == target.parentLink)) {
                return true;
            }

            if (targetParentId) {
                return false;
            }

            return when(this.store.get(targetParentId), lang.hitch(this, function (parent) {
                return this.isAncestor(source, parent);
            }));
        },

        getAncestors: function (item, onComplete) {
            // summary:
            //		Get the ancestors for the item
            //
            // item: Object
            //      The item to get the ancestors for, or the identity of the item
            //
            // onComplete: callback function
            //      Function that will be invoked when the getAncestors has completed
            //
            // tags:
            //      public

            if (!this.store) {
                onComplete([]);
                return;
            }

            var obj = typeof item === "object" ? item : this.store.get(item);
            when(obj, lang.hitch(this, function (storeItem) {
                when(this._getAncestors([storeItem]), onComplete);
            }));
        },

        _getAncestors: function (items) {
            // If the first item is a root then stop the recursion.
            if (this._hasRoot(items)) {
                return items.slice(0, -1);
            }

            var parentId = this.getParentIdentity(items[0]);
            if (!parentId) {
                return items.slice(0, -1);
            }

            return when(this.store.get(parentId), lang.hitch(this, function (parent) {
                if (parent) {
                    items.unshift(parent);
                    return this._getAncestors(items);
                }
                return items.slice(0, -1);
            }));
        },

        _hasRoot: function (items) {
            // summary:
            //      Checks to see if the first item is a root item.
            // tags:
            //      private
            var roots = this.roots || [this.root];

            if (!items.length || !roots.length || typeof this.getIdentity !== "function") {
                return false;
            }

            var identity = this.getIdentity(items[0]);

            return array.some(roots, function (root) {
                return root == identity;
            }, this);
        },

        refreshAncestors: function (item, filter) {
            // summary:
            //      Refreshes the data for each ancester. If a filter function is specified
            //      only ancestors matching the filter will be refreshed.
            //
            //  item: Object
            //      The item or the identity to refresh the ancestors for
            //
            //  filter: function
            //      Filter function used to select which ancestors to refresh. Optional
            //
            // tags:
            //      public

            var store = this.store,
                deferred = new Deferred(),
                refreshDeferreds = [],
                refreshed = [];

            this.getAncestors(item, function (ancestors) {

                array.forEach(ancestors, function (ancestor) {
                    if (!filter || filter(ancestor)) {
                        refreshDeferreds.push(when(store.refresh(store.getIdentity(ancestor)), function (item) {
                            refreshed.push(item);
                        }));
                    }
                });

                all(refreshDeferreds).then(function () {
                    deferred.resolve(refreshed);
                });

            });

            return deferred.promise;
        }
    });
});

},
'epi-cms/widget/viewmodel/_UpdateableStoreModelMixin':function(){
define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/Deferred",
    "dojo/Evented",
    "dojo/json",
    "dojo/topic",
    "dojo/when",
    // epi
    "epi/dependency",

    "epi-cms/ApplicationSettings",
    "epi-cms/_ContentContextMixin",
    "epi-cms/core/ContentReference"
],

function (
// dojo
    array,
    declare,
    lang,

    Deferred,
    Evented,
    json,
    topic,
    when,
    // epi
    dependency,

    ApplicationSettings,
    _ContentContextMixin,
    ContentReference
) {

    return declare(Evented, {
        // tags:
        //      internal mixin

        // updateableStore: [private] dojo/store
        //      Underlying store that will be post data to server for items.
        updateableStore: null,

        // updateableStoreKey: [public] string
        //      Dependency key to resolve the updateableStore
        updateableStoreKey: "epi.cms.contentdata",

        // propertyNames: [public] Object
        //      Maps between client side property names and their server side counterparts
        propertyNames: {
            name: "icontent_name",
            nameInUrl: "iroutable_routesegment"
        },

        // refreshTranslatedAncestors: [public] boolean
        //      If true ancestors of the changed node will be refreshed
        refreshTranslatedAncestors: true,

        // onAddDelegate: [public] function
        //      Will be executed after add
        onAddDelegate: null,

        postscript: function () {
            this.inherited(arguments);
            this._setupStore();
        },

        _setupStore: function () {
            if (!this.updateableStore && this.updateableStoreKey) {
                this.updateableStore = dependency.resolve("epi.storeregistry").get(this.updateableStoreKey);
            }
        },

        rename: function (id, name) {
            // summary:
            //      Renames an item
            // tags:
            //      public

            var self = this,
                deferred = new Deferred();

            when(self.patch(id, { name: name, nameInUrl: null }), function (item) {
                when(self.refreshTranslated(id), function () {
                    deferred.resolve(item);
                }, function (e) {
                    deferred.reject(e);
                });
            }, function (e) {
                deferred.reject(e);
            });

            return deferred;
        },

        add: function (/*Object*/item, /*Function?*/onComplete) {
            // summary:
            //      Add new item
            // item: [Object]
            //      New item data
            // onComplete: [Function?]
            //      Callback function to do something when new content created
            // tags:
            //      Public

            var self = this;

            var def = new Deferred();

            when(self.updateableStore.add(item), function (response) {
                var id = self.getContentId(response),
                    parentId = self.getParentIdentity(item),
                    refreshDeferred = null;

                when(self.updateableStore.get(id), function (/*dojo/data/Item*/addedItem) {
                    if (self.getParentIdentity(addedItem) !== parentId) {
                        refreshDeferred = typeof onComplete == "function" && onComplete();
                    }
                    when(refreshDeferred)
                        .then(self.updateableStore.updateDependentStores.bind(this, addedItem))
                        .then(function () {
                            when(self._childrenChanged(parentId), function () {
                                when(self.refreshTranslated(id), function () {
                                    self.onSelect(id, true, self.onAddDelegate);
                                    def.resolve(addedItem);
                                });
                            });
                        });
                });
            });

            return def.promise;
        },

        patch: function (id, properties) {
            // summary:
            //      Patches the item with the submitted id and updates cache on success
            // id:
            //      Identity of the item to patch
            // properties:
            //      Properties to patch for the item
            // tags:
            //      public

            var self = this,
                deferred = new Deferred(),
                patchData = { id: id, properties: {} };

            //Fix the properties and change the names if needed
            for (var key in properties) {
                if (Object.prototype.hasOwnProperty.call(properties, key)) {
                    patchData.properties[this._convertPropertyName(key)] = json.stringify(properties[key]);
                }
            }

            when(self.updateableStore.patch(patchData, { id: patchData.id }), function (item) {
                if (item && item.successful) {
                    var cacheData = {
                        contentLink: id,
                        properties: patchData.properties,
                        capabilities: { supportsVersions: false } // TODO: This is temporary until we have implemented dependant store capabilities checks
                    };
                    lang.mixin(cacheData, properties);

                    when(self.updateableStore.patchCache(cacheData), deferred.resolve, deferred.reject);
                } else {
                    return deferred.reject(item && item.validationErrors);
                }
            });

            return deferred;
        },

        _convertPropertyName: function (name) {
            return this.propertyNames[name] || name;
        },

        refreshTranslated: function (/*String*/contentId) {
            // summary:
            //      Refresh translated ancestor contents
            // tags:
            //      public

            var self = this,
                deferred = new Deferred(),
                failed;

            // Used to filter which ancestors to refresh
            function filter(item) {
                var id = self.getIdentity(item),
                    parentId = self.getParentIdentity(item);

                if (parentId === self.root || // is subroot
                    id === self.root || // is root
                    !item.missingLanguageBranch) { // already translated
                    return false;
                }

                return true;
            }

            if (!self.refreshTranslatedAncestors) {
                return deferred.resolve();
            }

            // Then refresh the ancestors
            when(self.refreshAncestors(contentId, filter), function (refreshedItems) {
                if (!(refreshedItems instanceof Array) || refreshedItems.length === 0) {
                    deferred.resolve();
                    return;
                }

                // Reverse array in order to get nearest ancestor
                refreshedItems.reverse();

                var hadAnyUntranslatedAncestor = array.some(refreshedItems, function (item) {
                    if (item.missingLanguageBranch) {
                        failed = self.getLabel(item);
                        return true;
                    }

                    return false;
                });

                // Check if any ancestors were not translated, in that case show notification of this
                when(self.store.get(contentId), function (contentItem) {
                    if (hadAnyUntranslatedAncestor && contentItem && !contentItem.missingLanguageBranch) {
                        self.emit("translationFailed", failed);
                    }

                    deferred.resolve();
                });
            });

            return deferred;
        },

        getContentId: function (/*String*/contentLink) {
            // summary:
            //      Get content link without its work version
            // tags:
            //      private

            return ContentReference.toContentReference(contentLink).id.toString();
        }

    });

});

},
'epi-cms/widget/ContextualContentForestStoreModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/topic",
    "dojo/when",
    // epi
    "epi/shell/TypeDescriptorManager",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/ContentForestStoreModel"
],

function (
// dojo
    array,
    declare,
    lang,

    aspect,
    Deferred,
    promiseAll,
    topic,
    when,
    // epi
    TypeDescriptorManager,
    _ContextualContentContextMixin,
    ContentReference,
    ContentForestStoreModel
) {

    return declare([ContentForestStoreModel, _ContextualContentContextMixin], {
        // description:
        //      Adds a contextual root node to the tree.
        // tags:
        //      internal

        // previousSelection: [public] Object
        //      Holds information about previous selection in the tree
        //      Object's properties:
        //          selectedContent: [public] Object
        //              An instance of the "dijit/_TreeNode"
        //              Holds the previous selected content of the given tree
        //          selectedAncestors: [public] Array
        //              Holds the ancestors of the previous selected content of the given tree
        previousSelection: null,

        // forThisFolderEnabled: [public] Boolean
        forThisFolderEnabled: true,

        // =======================================================================
        // Public overrided functions

        postscript: function () {

            this.inherited(arguments);

            this._handles.push(topic.subscribe("/epi/cms/action/createlocalasset", lang.hitch(this, this.refreshRoots)));
            this._handles.push(topic.subscribe("/epi/cms/action/togglecreatemode", lang.hitch(this, this._toggleContextualContent)));

            this._handles.push(aspect.around(this, "pasteItem", lang.hitch(this, this._aroundPasteItem)));
            this._handles.push(aspect.around(this, "pasteItems", lang.hitch(this, this._aroundPasteItems)));
            this._handles.push(aspect.after(this.store, "get", lang.hitch(this, this._afterStoreGet)));
        },

        contextChanged: function (context, callerData) {

            // summary:
            //    Called when the currently loaded context changes
            // tags:
            //    protected

            this.inherited(arguments);

            this.refreshRoots();

        },

        getChildren: function (parentItem, onComplete, onError) {
            // summary:
            //      Calls onComplete() with array of child items of given parent item.
            // parentItem: Object
            //      Item from the dojo/store
            // tags:
            //      public

            if (parentItem === this.root) {
                when(this._getRootItems(), onComplete, onError);
            } else {
                // Overrides onComplete callback function in order to return an empty array of child content for pseudo contextual root
                if (this.isPseudoContextualRoot(parentItem)) {
                    onComplete([]);
                    return;
                }

                this.inherited(arguments);
            }
        },

        // TODO: The getAncestors method should be generalized to support multiple roots and moved to the _HierarchicalModelMixin. (bemc)
        getAncestors: function (item, /*Function*/ onComplete) {
            // summary:
            //      Calls onComplete() with an array of ancestors of the given item.
            // item: Object
            //      Item from the dojo/store

            var inherited = this.getInherited(arguments),
                onCompleteCallback = onComplete;

            // Get the contextual root ID and concatenate it with the roots array.
            when(this.getCurrentContent()).then(lang.hitch(this, function (currentContent) {
                var roots = this.roots.concat(currentContent.assetsFolderLink),
                    callback = lang.hitch(this, function (results) {
                        // Loop through the results from the end to find the first item that is a
                        // root. If a root is found then append the virtual root as the first item and resolve.
                        var ancestor;
                        for (var i = results.length - 1; i >= 0; i--) {
                            ancestor = results[i];

                            // Update as contextual root
                            if (this.isContextualRoot(ancestor)) {
                                results[i] = this.getContextualRoot(ancestor);
                            }

                            if (array.indexOf(roots, this.getIdentity(ancestor)) >= 0) {
                                results = results.slice(i);
                                results.unshift(this.root);
                                onComplete(results);
                                return;
                            }
                        }

                        // Otherwise if no root item is found resolve with only the virtual root.
                        onComplete([this.root]);
                    });

                // If the given item is a root node then resolve with only the virtual root.
                if (array.indexOf(roots, this.getIdentity(item)) >= 0) {
                    onComplete([this.root]);
                }

                //Replace the default callback
                onCompleteCallback = callback;

            })).always(lang.hitch(this, function () {
                inherited.apply(this, [item, onCompleteCallback]);
            }));
        },

        getObjectIconClass: function (/*dojo/data/Item*/contentItem, /*String*/fallbackIconClass) {
            // summary:
            //      Get icon class for content based on its content link
            // contentItem: [dojo/data/Item]
            //      Content item data
            // fallbackIconClass: [String]
            //      Default icon class in case nothing returned
            // tags:
            //      public, extension

            var dataType = this._currentContext && this._currentContext.dataType;

            if (!dataType) {
                return this.inherited(arguments);
            }

            var contentIconClass = TypeDescriptorManager.getValue(dataType, "iconClass");

            return this.isContextualContent(contentItem)
                ? (contentIconClass
                    ? fallbackIconClass + " " + contentIconClass + "Contextual"
                    : fallbackIconClass
                )
                : this.inherited(arguments);
        },

        // =======================================================================
        // Public functions

        onToggleContentDisplay: function (/*String*/target, /*Boolean*/display) {
            // summary:
            //      Callback whenever widget switcher changed
            // target: [String]
            //      Assets folder content item that want to show/hide
            // display: [Boolean]
            // tags:
            //      public, callback
        },

        onRefreshRoots: function (/*dojo/data/Item*/refreshItem) {
            // summary:
            //      Callback whenever context changed
            // refreshItem: [dojo/data/Item]
            //      Assets folder content item that want to refresh
            // tags:
            //      public, callback
        },

        refreshRoots: function (sender) {
            // summary:
            //      Refresh root contents
            // sender: Object
            //      The instance that published the topic
            // tags:
            //      public

            //If the topic was published from this model do not react on it.
            if (sender === this) {
                return true;
            }

            var self = this;
            return when(self._getRootItems(), function (children) {
                self.onChildrenChange(self.root, children);
            });
        },

        canCopy: function (item) {
            // summary:
            //      Determine whether the copy action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            // tags:
            //      public, override

            // Do not allow to copy the current contextual folder
            return this.isContextualContent(item) ? false : this.inherited(arguments);
        },

        canCut: function (/*dojo/data/Item*/item) {
            // summary:
            //      Determine whether the given item is able to be cut by the current user.
            // item: [dojo/data/Item]
            //      The source content item data that is being copied/cut
            // tags:
            //      public, override

            // Do not allow to cut the current contextual folder
            return this.isContextualContent(item) ? false : this.inherited(arguments);
        },

        canPaste: function (item, target, isCopy) {
            // summary:
            //      Determines whether the given item can be moved or copied from its current parent to a new location
            //      Primarily used when validating drag & drop operations.
            // item: [dojo/data/Item]
            //      The source content item data that is being copied/cut
            // target: [dojo/data/Item]
            //      The destination content item data
            // isCopy: Boolean
            //      If true, action is copy, otherwise is cut
            // tags:
            //      public override

            var self = this,
                canPaste = this.inherited(arguments),
                deferred = new Deferred();

            if (isCopy) {
                deferred.resolve(canPaste);
            } else {
                self.getAncestors(target, function (ancestors) {

                    // If we paste into current contextual folder or one of its children
                    var isPastingToContextualContent = self.isContextualContent(target) || self.hasContextual(ancestors);
                    if (isPastingToContextualContent) {
                        when(self.getCurrentContent()).then(function (currentContent) {

                            // and cut content is the current context
                            if (ContentReference.compareIgnoreVersion(item.contentLink, currentContent.contentLink)) {
                                deferred.resolve(false);
                            } else {
                                // or cut content is an ancestor of the current context
                                self.getAncestors(currentContent.contentLink, function (ancestors) {

                                    var itemIsParent = array.some(ancestors, function (ancestor) {
                                        return item.contentLink === ancestor.contentLink;
                                    }, this);

                                    deferred.resolve(itemIsParent ? false : canPaste);
                                });
                            }
                        }).otherwise(function () {
                            deferred.resolve(false);
                        });
                    } else {
                        deferred.resolve(canPaste);
                    }
                });
            }

            return deferred.promise;
        },

        filterAncestors: function (ancestors) {
            // summary:
            //      Filter out the pseudo contextual content from the given ancestor list incase pseudo content is not the deepest ancestor.
            // ancestors: [Array]
            //      Collection of ancestor content
            // tags:
            //      public

            if (!(ancestors instanceof Array)) {
                return ancestors;
            }

            var pseudoIndex = ancestors.indexOf(this._getPseudoContextualContent().toString());
            if (pseudoIndex !== -1 && pseudoIndex < ancestors.length - 1) {
                ancestors.splice(pseudoIndex, 1);
            }

            return ancestors;
        },

        isContextualContent: function (item) {
            // summary:
            //    Overrides _ContextualContentContextMixin.isContextualContent to only report items included in the tree as contextual content.
            // tags:
            //     public, override

            return !!item && this.isSupportedType(item.typeIdentifier) && this.inherited(arguments);
        },

        // =======================================================================
        // Private functions

        _toggleContextualContent: function (/*Boolean*/createMode) {
            // summary:
            //      Show/Hide contextual content (local asset folder)
            // createMode: [Boolean]
            //      Flag indicates that the current mode is create new content or not
            // tags:
            //      private

            when(this.getCurrentContent(), lang.hitch(this, function (currentContent) {
                this.onToggleContentDisplay(currentContent.assetsFolderLink, !createMode);
                this._setSelection(null); // Pass 'null' value in order to set selection to the default target on the tree
            }));
        },

        _setSelection: function (/*Object*/targetItem) {
            // summary:
            //      Set selection tree node by the given content link string
            // targetItem: [Object]
            //      An instance of "dojo/data/Item"
            // tags:
            //      private

            var defaultTarget = this.roots.length > 0 ? this.roots[0].toString() : (!targetItem ? null : targetItem.assetsFolderLink),
                target = targetItem != null ? targetItem.contentLink : defaultTarget,
                previousSelection = this.get("previousSelection"),
                previousContextualSelection = this.get("previousContextualSelection"),
                previousSelectedContextualContent = previousContextualSelection && previousContextualSelection.selectedContent,
                selectDeferred = new Deferred();

            //Return if there is no new target to select or any previous selection
            if (!(target && previousSelection)) {
                selectDeferred.resolve();
                return selectDeferred.promise;
            }

            var focusTarget = false, // Set focus to the target is FALSE to prevent steal focus of the others
                previousSelectedContent = previousSelection.selectedContent,
                previousSelectedAncestors = previousSelection.selectedAncestors,
                previousIsVirtualRoot = previousSelectedContent.item && !previousSelectedContent.item.contentLink;

            var onComplete = function () {
                selectDeferred.resolve();
            };

            if (previousIsVirtualRoot || this.hasContextual(previousSelectedAncestors)) {
                this.onSelect(target, focusTarget, onComplete);
            } else if (previousSelectedContent.item.contentLink === defaultTarget
                    && previousSelectedContextualContent
                    && previousSelectedContextualContent.item
                    && previousSelectedContextualContent.item.contentLink) {
                this.onSelect(previousSelectedContextualContent.item.contentLink, focusTarget, onComplete);
            } else {
                selectDeferred.resolve();
            }

            return selectDeferred.promise;
        },

        getRoots: function (filterContentAssetsFolder) {
            // summary:
            //      Returns the available roots for the current context
            //
            // filterContentAssetsFolder: Boolean?
            //      Set to true if you want to remove the content assets folder from the available roots
            //
            // returns: Promise
            //      A promise that will be resolved with the current roots for the context
            // tags:
            //      internal

            var def = new Deferred();

            var contentAssetRoot = this._getPseudoContextualContent().toString();
            var filterContentAssetsRootFolder = function (rootItem) {
                if (!filterContentAssetsFolder) {
                    return true;
                }
                return rootItem !== contentAssetRoot;
            };

            var mapContentLink = function (rootItem) {
                return rootItem.contentLink;
            };

            when(this._getRootItems(), function (rootItems) {
                def.resolve(rootItems.map(mapContentLink).filter(filterContentAssetsRootFolder));
            }, def.reject);

            return def.promise;
        },

        _getRootItems: function () {
            // summary:
            //      Resolves the root items, including the contextual root.
            // tags:
            //      private

            var self = this,
                currentStore = self.store,
                // Load all ordinary roots
                rootLoads = array.map(self.roots, function (item) {
                    return currentStore.get(item);
                });

            var contextRootLoad =
                // REMARK: This is not a longterm solution. We should push the currentContent to the model instead of getting it from the ContentContextMixin.
                // this model could be use when we do not have a editing context. E.g. an addon that just want's to pick a page/image etc.
                when(promiseAll([self.getCurrentContent(), self.getCurrentContext()]), function (result) {

                    var currentContent = result[0],
                        currentContext = result.length > 1 ? result[1] : null;

                    var currentContentWithoutVersion = new ContentReference(currentContent.contentLink).createVersionUnspecificReference().toString();
                    return when(currentStore.get(currentContentWithoutVersion), function (content) {
                        var inCreateMode = currentContext && currentContext.currentMode === "create";
                        if ((inCreateMode && self.get("view") === "contentselector") || !self.canHaveContextualContent(content) || !self.forThisFolderEnabled) {
                            return null;
                        }

                        // If the current context provided a context root, load it
                        var assetsFolderLink = content.assetsFolderLink;
                        if (assetsFolderLink) {
                            var getContextualContent = function (localFolderLink) {

                                // We need to call refresh local folder here in order to set its selection on the folder tree and refresh its icon and label.
                                return when(currentStore.get(localFolderLink), function (contextualContent) {

                                    // when propertyName is set, then we will not send all typeidentifiers to the server
                                    // They will be resolved based on content model
                                    var typeIdentifiers = self.typeIdentifiers;
                                    if (self.propertyName) {
                                        typeIdentifiers = null;
                                    }


                                    // Take query in order to filters properly children that are allowed.
                                    // So that, we will show the expanded/collapsed icon for the root node correctly.
                                    var query = {
                                        id: contextualContent.contentLink,
                                        typeIdentifiers: typeIdentifiers,
                                        allLanguages: self.showAllLanguages,
                                        propertyName: self.propertyName,
                                        ownerContentLink: currentContentWithoutVersion
                                    };

                                    return when(currentStore.query(query), function (refreshedContent) {
                                        // Only show contextual content in the container that supports its type identifier
                                        if (typeof self.isSupportedType === "function" && !self.isSupportedType(refreshedContent.typeIdentifier)) {
                                            return null;
                                        }

                                        if (!self.isPseudoContextualRoot(refreshedContent)) {
                                            return self.getContextualRoot(refreshedContent);
                                        } else {
                                            return when(self.onRefreshRoots(refreshedContent), function () {
                                                return self._modifyContentAccess(refreshedContent, content);
                                            });
                                        }
                                    });
                                });
                            };

                            if (assetsFolderLink === self._getPseudoContextualContent().toString()) {
                                return when(currentStore.refresh(currentContentWithoutVersion), function (refreshedContent) {
                                    return getContextualContent(refreshedContent.assetsFolderLink);
                                });
                            } else {
                                return getContextualContent(assetsFolderLink);
                            }
                        }

                        return null;
                    });
                },
                //We want a return even the context is not a content item
                function () {
                    return null;
                });

            // Add context root load to the ordinary root loads
            rootLoads.push(contextRootLoad);

            return when(promiseAll(rootLoads), function (rootItems) {
                // When loads are done, filter the ones that resolve null
                return array.filter(rootItems, Boolean);
            });
        },

        _aroundPasteItem: function (originalFunction) {
            // summary:
            //      Stubs to do somethings before pasteItem processing
            // tags:
            //      private

            var self = this;

            return function (/*dojo/data/Item*/childItem, /*dojo/data/Item*/oldParentItem, /*dojo/data/Item*/newParentItem, /*Boolean*/copy, /*Integer?*/sortIndex) {
                var targetItem = newParentItem,
                    createAsLocalAsset = self.get("createAsLocalAsset");

                // If the new parent item is pseudo contextual content, get current content context item insteads
                // In additional, change the value of the "createAsLocalAsset" to TRUE if its value is FALSE, otherwise do nothing
                return when(self.getCurrentContent()).then(function (contextContentItem) {

                    if (!createAsLocalAsset) {
                        createAsLocalAsset = self.isPseudoContextualRoot(targetItem);
                        self.set("createAsLocalAsset", createAsLocalAsset);
                    }

                    createAsLocalAsset && (targetItem = contextContentItem);
                }).always(function () {
                    return when(originalFunction.apply(self, [childItem, oldParentItem, targetItem, copy, sortIndex]), function (response) {
                        if (createAsLocalAsset) {
                            self.set("createAsLocalAsset", false);
                            return when(self.refreshRoots(), function () {

                                // REMARK: This is not a very good place to do this, but when we can't rely on the
                                // store notfications for the contextual content we need to do this
                                // If the item got a new parent, publish the local asset created topic
                                topic.publish("/epi/cms/action/createlocalasset", self);

                                return response;
                            });
                        } else {
                            return response;
                        }
                    });
                });
            };
        },

        _aroundPasteItems: function (originalFunction) {
            // summary:
            //      Aspect around PasteItems to handle pasting content to the local asset folder.
            //      In this case the targetItem has to be replaced with the contentOwner contentLink
            // tags:
            //      private

            var self = this;
            return function (/*Array*/sourceItems, /*dojo/data/Item*/targetItem, /*Boolean*/copy, /*Integer?*/sortIndex) {
                var createAsLocalAsset = self.get("createAsLocalAsset");
                // If the new parent item is pseudo contextual content, get current content context item instead
                // In additional, change the value of the "createAsLocalAsset" to TRUE if its value is FALSE, otherwise do nothing
                return when(self.getCurrentContent()).then(function (contextContentItem) {
                    if (!createAsLocalAsset) {
                        createAsLocalAsset = self.isPseudoContextualRoot(targetItem);
                        self.set("createAsLocalAsset", createAsLocalAsset);
                    }

                    createAsLocalAsset && (targetItem = contextContentItem);
                }).always(function () {
                    return when(originalFunction.apply(self, [sourceItems, targetItem, copy, sortIndex]), function (response) {
                        if (createAsLocalAsset) {
                            self.set("createAsLocalAsset", false);
                        } else {
                            return response;
                        }
                    });
                });
            };
        },

        _afterStoreGet: function (/*Object*/promise) {
            // summary:
            //      Decorates result before send it back
            // promise: [Object]
            //      Store get() result
            // tags:
            //      private

            var self = this;
            return when(promise, function (result) {
                return when(self.getCurrentContent(), function (currentContent) {
                    return self._modifyContentAccess(result, currentContent);
                }, function (error) {
                    //If we fail to load the current content return the value from the store
                    return result;
                });
            });
        },

        _modifyContentAccess: function (/*dojo/data/Item*/targetContent, /*dojo/data/Item*/sourceContent) {
            // summary:
            //      Modify access marks for the given pseudo contextual content
            // targetContent: [dojo/data/Item]
            //      Pseudo contextual content asset folder that needed to overrides access marks
            // sourceContent: [dojo/data/Item]
            //      Source content that used to copy access marks from
            // tags:
            //      private

            // Only modify the content item name if it is a contextual content
            if (this.isContextualContent(targetContent)) {
                var contextualRoot = this.getContextualRoot(targetContent);
                // Only modify the access maske if its the fake folder
                return this.isPseudoContextualRoot(targetContent)
                    ? lang.mixin(contextualRoot, {
                        isPreferredLanguageAvailable: sourceContent.isPreferredLanguageAvailable,
                        hasTranslationAccess: sourceContent.hasTranslationAccess,
                        accessMask: sourceContent.accessRights, // Mix on the access rights that does not include language access rights
                        ownerContentLink: sourceContent.contentLink
                    })
                    : contextualRoot;
            }

            return targetContent;
        }

    });

});

},
'epi-cms/widget/SearchBox':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/connect",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/when",

    "dojo/dom-construct",

    // Dijit
    "dijit/_Widget",

    // EPi Framework
    "epi/shell/SearchManager",

    // EPi CMS
    "epi-cms/widget/ContentSearchBox"
],

function (
// Dojo
    declare,
    connect,
    json,
    lang,
    when,

    domConstruct,

    // Dijit
    _Widget,

    // EPi Framework
    SearchManager,

    // EPi CMS
    ContentSearchBox
) {

    return declare([_Widget], {
        // summary:
        //    A composite widget, which wrap the ContentSearchBox, for setting up the search box.
        //
        // tags:
        //    internal

        // area: [protected] String
        //      Search area to search.
        area: null,

        // searchRoots: [protected] String
        //      Optional comma separated list of roots to search.
        searchRoots: null,

        // filterOnCulture: [protected] Boolean
        //      Flag to set if search results should be filtered on culture. Default value is true.
        filterOnCulture: null,

        // triggerContextChange: [public] Boolean
        //      If [true] will cause a contextChange topic to be published.
        triggerContextChange: true,

        // _searchBox: [private] ContentSearchBox
        //      Content search box widget.
        _searchBox: null,

        // _searchManager: [private] SearchManager
        //      Content search manager.
        _searchManager: null,

        // innerSearchBoxClass: [public] String
        //      CSS class for the inner ContentSearchBox
        innerSearchBoxClass: "",

        parameters: null,

        postCreate: function () {
            // summary:
            //      Add and setup search box
            // tags:
            //      protected
            this.inherited(arguments);

            this._searchManager = new SearchManager();
            when(this._searchManager.getStore(), lang.hitch(this, function (store) {
                this._searchBox = new ContentSearchBox({
                    baseClass: this.innerSearchBoxClass,
                    searchAttr: "searchQuery",
                    store: store
                });

                var parameters = lang.mixin({ filterOnDeleted: true }, this.parameters);
                lang.mixin(this._searchBox.query, { parameters: json.toJson(parameters) });

                // Event onSelect of search box
                this._searchBox.on("select", lang.hitch(this, function (value) {
                    // Set blank value for textbox
                    this._searchBox.set("value", "");
                    this._searchBox.focus();
                    this._searchBox.toggleClearButton();
                    this.onItemAction(value);
                }));
                //search results show contents in all languages
                this.set("filterOnCulture", false);
                // add search box to DOM
                domConstruct.place(this._searchBox.domNode, this.domNode);
            }));
        },

        _setAreaAttr: function (value) {
            this._set("area", value);
            if (this._searchBox) {
                // get query for current search area
                when(this._searchManager.getProviderQuery(value), lang.hitch(this, function (query) {
                    lang.mixin(this._searchBox.query, query);
                }));
            }
        },

        _setSearchRootsAttr: function (value) {
            this._set("searchRoots", value);
            if (this._searchBox) {
                lang.mixin(this._searchBox.query, { searchRoots: value });
            }
        },

        _setFilterOnCultureAttr: function (value) {
            this._set("filterOnCulture", value);
            if (this._searchBox) {
                lang.mixin(this._searchBox.query, { filterOnCulture: value });
            }
        },

        onItemAction: function (item) {
            // summary:
            //      Trigger the context change event when an item has been selected in search box.
            // tags:
            //      callback

            if (this.triggerContextChange) {
                var contextParameters = { uri: "epi.cms.contentdata:///" + item.metadata.id };
                if (item.metadata.isUntranslatedContent === "false") {
                    contextParameters.epslanguage = item.metadata.languageBranch;
                }
                connect.publish("/epi/shell/context/request", [contextParameters, { sender: null }]);
            }
        }
    });
});

},
'epi/shell/SearchManager':function(){
define("epi/shell/SearchManager", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/Deferred",
    "dojo/_base/lang",

    "dojo/when",
    "dojo/promise/all",

    // epi
    "epi/dependency"
],
function (
// dojo
    declare,
    array,
    Deferred,
    lang,

    when,
    all,
    // epi
    dependency
) {
    return declare(null, {
        // summary:
        //      Search component that provides search provider stores and search results store
        //      to make searching by conditions and take searching results.
        // tags:
        //      public

        // _providersStore: [epi.shell.searchproviders] object
        _providersStore: null,
        // _resultsStore: [epi.shell.searchresults] object
        _resultsStore: null,

        constructor: function (params) {
            // summary:
            //      Setup search provider stores and search results store.
            // tags:
            //      public

            this._setupStores(params || {});
        },

        getProviderQuery: function (/*string*/area) {
            // summary:
            //      Return provider query parameter(s) that used as input parameter(s) for search results store.
            // area: string or a coma separated list of strings
            //      The area of the search provider(s).
            //      E.g: "cms/blocks" area, will return all search provider(s) that have area is "cms/blocks".
            //          Will return all search providers if passed blank area.
            // return:
            //      Deferred object that holds provider query parameters JSON object.
            // tags:
            //      public

            var deferred = new Deferred();

            var promises = [];
            var areas = area ? area.split(",") : [];

            areas.forEach(function (a) {
                promises.push(this._getFirstMatchingProvider(a));
            }, this);

            all(promises).then(function (providers) {
                //filter out not resolved providers
                providers = providers.filter(function (p) {
                    return p;
                });

                if (providers.length > 0) {
                    deferred.resolve(this._getQuery(providers, {}));
                } else {
                    deferred.resolve();
                }
            }.bind(this));

            return deferred;
        },

        _getFirstMatchingProvider: function (area) {
            var deferred = new Deferred();

            when(this.getProviders(area)).then(function (providers) {
                if (providers && providers.length > 0) {
                    deferred.resolve(providers[0]);
                } else {
                    deferred.resolve();
                }
            });

            return deferred.promise;
        },

        getProviders: function (/*string*/area) {
            // summary:
            //      Return all search provider in the given area.
            //      If passed blank value will return all providers.
            // area: string
            //      The area that search provider(s) belong to.
            // return:
            //      Deferred object that holds an array of search provider objects.
            // tags:
            //      public

            var deferred = new Deferred();

            when(this._providersStore.query({ searchArea: area })).then(function (providers) {
                if (providers && providers.length > 0) {
                    deferred.resolve(providers);
                } else {
                    deferred.resolve();
                }
            });

            return deferred;
        },

        getStore: function () {
            // summary:
            //      Return search results store object.
            // tags:
            //      public

            return this._resultsStore;
        },

        search: function (/*string*/area, /*object*/queryParams) {
            // summary:
            //      Get all results from search results by passing search provider area and query parameter(s).
            // area: string
            //      The area that search provider(s) belong to.
            // queryParams: JSON object
            //      Query that used to search.
            // return:
            //      Deferred object that contains an array of search result data items.
            // tags:
            //      public

            var deferred = new Deferred();

            // Get all search provider stores from search providers store
            when(this.getProviders(area)).then(lang.hitch(this, function (providers) {
                if (providers && providers.length > 0) {
                    var deferredArray = [];

                    // Query each search provider store to get its results
                    array.forEach(providers, function (provider, index) {
                        deferredArray.push(this._getData(provider, queryParams));
                    }, this);

                    var data = [];

                    // Put all data together
                    all(deferredArray).then(function (items) {
                        items.forEach(function (item) {
                            if (lang.isArray(item)) {
                                data = data.concat(item);
                            }
                        });
                        deferred.resolve(data);
                    });
                }
            }));

            return deferred;
        },

        _setupStores: function (params) {
            // summary:
            //      Get search providers store and search results store from registry.
            // tags:
            //      private

            this._providersStore = params.providersStore || dependency.resolve("epi.storeregistry").get("epi.shell.searchproviders");
            this._resultsStore = params.resultsStore || dependency.resolve("epi.storeregistry").get("epi.shell.searchresults");
        },

        _getQuery: function (/*object|array*/provider, /*object*/queryParams) {
            // summary:
            //      Build search query.
            // provider: object
            //      Search provider store object.
            // queryParams: JSON object
            //      Query that used to search.
            // return:
            //      Query JSON object.
            // tags:
            //      private

            var providerId;
            if (lang.isArray(provider)) {
                providerId = provider.map(function (p) {
                    return p.id;
                }).join(",");
            } else {
                providerId = provider.id;
            }

            var query = { providerId: providerId };

            lang.mixin(query, queryParams || {});

            return query;
        },

        _getData: function (/*object*/provider, /*object*/queryParams) {
            // summary:
            //      Get search results from search results store by the given search provider and query.
            // provider: object
            //      Search provider store object.
            // queryParams: JSON object
            //      Query that used to search.
            // return:
            //      Deferred object that contains an array of search result items.
            // tags:
            //      private

            var deferred = new Deferred();

            // Query by search results store
            when(this._resultsStore.query(this._getQuery(provider, queryParams))).then(function (items) {
                if (items && items.length > 0) {
                    deferred.resolve(items);
                } else {
                    deferred.resolve();
                }
            });

            return deferred.promise;
        }
    });
});

},
'epi-cms/widget/ContentSearchBox':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/event",

    "dojo/aspect",
    "dojo/Evented",
    "dojo/keys",

    "dojo/dom-attr",
    "dojo/dom-style",
    // EPi Framework
    "epi/shell/widget/SuggestionBox",
    "epi-cms/widget/SearchResultList",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentlist"
],

function (
// Dojo
    declare,
    lang,
    event,

    aspect,
    Evented,
    keys,

    domAttr,
    domStyle,
    // EPi Framework
    SuggestionBox,
    SearchResultList,

    // Resources
    resources
) {

    return declare([SuggestionBox, Evented], {
        // summary:
        //    A Search box to search for content.
        //
        // tags:
        //    public

        // res: Object
        //      Resource object, for getting text.
        // tags:
        //      Protected
        res: resources,

        // autoComplete: Boolean
        //      If user types in a partial string, and then tab out of the `<input>` box,
        //      automatically copy the first entry displayed in the drop down list to
        //      the `<input>` field
        autoComplete: false,

        // dropDownClass: [protected extension] Function String
        //      Dropdown widget class, which would be used to create a widget, to show the search result.
        //      Subclasses should specify this.
        dropDownClass: SearchResultList,

        // queryExpr: String
        //      This specifies what query ComboBox/FilteringSelect sends to the data store,
        //      based on what the user has typed.  Changing this expression will modify
        //      whether the drop down shows only exact matches, a "starting with" match,
        //      etc.  Use it in conjunction with highlightMatch.
        //      dojo/data query expression pattern.
        //      `${0}` will be substituted for the user text.
        //      `*` is used for wildcards.
        //      `${0}*` means "starts with", `*${0}*` means "contains", `${0}` means "is"
        queryExpr: "${0}",

        // minimumNumberOfChar: Integer
        //      The minimum number of character that is valid for search.
        // tags:
        //      Protected
        minimumNumberOfChar: 1,

        postCreate: function () {
            // summary: Override to:
            //      - mixin additional query params into query before _startSearch
            //      - connect to onSelect event of dropDown, to forward it to ContentSearchBox after _startSearch
            // tags:
            //      protected
            this.inherited(arguments);

            // Delay in milliseconds between when user types something and we start
            // searching based on that value.
            this.searchDelay = this.defaultDelay;
            this.on("beforeSearch", lang.hitch(this, function () {
                // display dropdown with standby
                if (this.dropDown) {
                    this.dropDown.showStandby(true);
                }
            }));

            this.on("searchComplete", lang.hitch(this, function (results) {
                // hide dropdown's standby
                if (this.dropDown) {
                    this.dropDown.showStandby(false);
                }
            }));

            aspect.before(this, "_startSearch", function (method, args) {
                // doing something before the original call
                this.emit("beforeSearch", {});

                return [method, args];
            });
        },

        _openResultList: function (/*Object*/results, /*Object*/query, /*Object*/options) {
            // summary:
            //		Callback when a search completes.
            // description:
            //		Generates drop-down list and calls _showResultList() to display it

            this.emit("searchComplete", results);

            this._fetchHandle = null;

            this.dropDown.clearResultList();

            var dataAvailable = results.length > 0 || options.start !== 0;
            // display the empty text if data is not available
            this.dropDown.showErrorMessage(!dataAvailable, this.res.contentnotfound);
            this.dropDown.showGrid(dataAvailable);

            if (dataAvailable) {
                this.dropDown.createOptions(results, options, lang.hitch(this, "_getMenuLabelFromItem"));
            }

            // show our list
            this._showResultList();
        },

        _onDropDownMouseDown: function (/*Event*/e) {
            // summary:
            //		Callback when the user mousedown's on the arrow icon.
            // tags:
            //      Private override

            // Do nothing, to prevent start search on click to textbox

            // Enable mouse clickable when pinnable pane in un-pinned state.
            e.stopPropagation();
        },

        _onKey: function (/*Event*/evt) {
            // summary:
            //		Listen for Enter key, to start search request.
            // tags:
            //      private override

            switch (evt.keyCode) {
                case keys.ENTER:
                    if (this.dropDown && this.dropDown.selected) {
                        this.dropDown.handleKey(evt);
                        this.closeDropDown();
                    } else if (!this._fetchHandle) {
                        this._startSearchFromInput();
                        event.stop(evt);
                    }
                    break;
                case keys.PAGE_DOWN:
                case keys.DOWN_ARROW:
                case keys.PAGE_UP:
                case keys.UP_ARROW:
                    // let the dropdown handle these keystrokes for navigating between item
                    if (this.dropDown) {
                        this.dropDown.handleKey(evt);
                    }
                    event.stop(evt);
                    break;
                case keys.LEFT_ARROW:
                case keys.RIGHT_ARROW:
                    // do nothing when navigating, selecting text
                    break;
                default:
                    this.inherited(arguments);
            }
        },

        _startSearchFromInput: function () {
            // summary:
            //      Start the search action
            // tags:
            //      private, override

            var key = this.focusNode.value;

            // start the search action only if input text length is more than minimum number
            if (!key || key.length < this.minimumNumberOfChar) {
                this.closeDropDown();
                return;
            }

            if (!this.dropDown) {
                var popupId = this.id + "_popup",
                    dropDownConstructor = lang.isString(this.dropDownClass) ? lang.getObject(this.dropDownClass, false) : this.dropDownClass;

                this.dropDown = new dropDownConstructor({
                    id: popupId,
                    dir: this.dir,
                    textDir: this.textDir
                });

                domAttr.remove(this.textbox, "aria-activedescendant");
                domAttr.set(this.textbox, "area-owns", popupId); // associate popup with textbox

                this.dropDown.on("select", lang.hitch(this, function (value) {
                    this.closeDropDown();
                    this.emit("select", value);
                }));

                // Set dropdown width belong to input text width
                domStyle.set(this.dropDown.domNode, "width", this.textbox.clientWidth + "px");
            }
            this._showResultList();

            // We do not want to call the inherited method here since it will escape wild card characters (* and ?),
            // which will break any searches with wild card.
            this._startSearch(key);
        },

        _startSearchAll: function () {
            // disable search with empty string
        }
    });
});

},
'epi/shell/widget/SuggestionBox':function(){
﻿define("epi/shell/widget/SuggestionBox", [
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",

    // Dijit
    "dijit/_HasDropDown",
    "dijit/form/_ComboBoxMenu",
    "dijit/form/_AutoCompleterMixin",

    // EPi Framework
    "epi/shell/widget/SearchBox"
],

function (
// Dojo
    declare,
    lang,

    domAttr,

    // Dijit
    _HasDropDown,
    _ComboBoxMenu,
    _AutoCompleterMixin,

    // EPi Framework
    SearchBox
) {

    return declare([SearchBox, _HasDropDown, _AutoCompleterMixin], {
        // summary:
        //    A suggestion box, which will drop a list down when user input a string to a textbox to filter item in a pre-defined list.
        //
        // tags:
        //    public

        // dropDownClass: [protected extension] Function String
        //      Dropdown widget class, which would be used to create a widget, to show the search result.
        //      Subclasses should specify this.
        dropDownClass: _ComboBoxMenu,

        buildRendering: function () {
            this.inherited(arguments);

            domAttr.set(this.textbox, "autocomplete", "off");
            domAttr.set(this.textbox, "aria-haspopup", "true");
        },

        postCreate: function () {
            // summary:
            //      Post widget creation. Initialize event for buttons
            // tags:
            //      Protected

            this.inherited(arguments);

            // clear textbox value when clicking on clear button
            this.connect(this.clearButton, "onclick", lang.hitch(this, function () {
                this.closeDropDown();
            }));
        }
    });
});

},
'epi/shell/widget/SearchBox':function(){
require({cache:{
'url:epi/shell/widget/templates/SearchBox.html':"﻿<div class=\"dijit dijitReset dijitInline dijitLeft dijitTextBox epi-searchInput epi-contentSearchBox\" id=\"widget_${id}\">\r\n    <span data-dojo-attach-point=\"clearButton\" class=\"dijitReset dijitRight epi-clearButton\" role=\"presentation\"></span>\r\n    <div class=\"dijitReset dijitInputField dijitInputContainer\">\r\n        <input data-dojo-attach-point=\"textbox,focusNode\" type=\"text\" class=\"dijitReset dijitInputInner\" role=\"textbox\" />\r\n        <span class=\"dijitPlaceHolder dijitInputField\" data-dojo-attach-point=\"_phspan,placeHolderNode\"></span>\r\n    </div>\r\n</div>"}});
define("epi/shell/widget/SearchBox", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/keys",
    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/focus",
    "dijit/form/TextBox",
    // dojox
    "dojox/html/entities",
    // epi
    "epi/debounce",
    "epi",
    // Templates
    "dojo/text!./templates/SearchBox.html",
    // Resources
    "epi/i18n!epi/shell/ui/nls/EPiServer.Shell.UI.Resources.SearchBox"
],
function (
// dojo
    declare,
    lang,

    domAttr,
    domClass,
    domStyle,

    keys,
    // dijit
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

    focusManager,
    TextBox,
    // dojox
    htmlEntities,
    // epi
    debounce,
    epi,
    // Templates
    template,
    // Resources
    resources
) {
    return declare([TextBox], {
        // tags:
        //      internal

        templateString: template,

        // placeHolder: String
        //      Defines a hint to help users fill out the input field (as defined in HTML 5).
        //      This should only contain plain text (no html markup).
        placeHolder: epi.resources.action.search,

        // commonRes: [private] Object
        //    Common localization resources,
        commonRes: epi.resources,

        // defaultDelay: [Integer]
        //      Delay in milliseconds between when user types something and we start
        //      searching based on that value.
        // tags:
        //      protected
        defaultDelay: 500,

        // encodeSearchText: [public] Boolean
        //      Indicated that need to encode search text or not.
        encodeSearchText: false,

        // triggerChangeOnEnter: Boolean
        //      Indicates if ENTER should trigger the change event
        triggerChangeOnEnter: true,

        postCreate: function () {
            // summary:
            //		Post widget creation. Initialize event for buttons
            // tags:
            //      Protected

            this.inherited(arguments);

            domAttr.set(this.clearButton, "title", resources.clear);

            // clear textbox value when clicking on clear button
            this.connect(this.clearButton, "onclick", lang.hitch(this, this.clearValue));
            this.toggleClearButton();

            this.connect(this, "_onInput",
                debounce(lang.hitch(this, function (event) {
                    // the event callback is debounced, and it's possible that widget
                    // is already destroyed when it's executed
                    if (this._destroyed) {
                        return;
                    }
                    this.toggleClearButton();
                    this._valueChanged(event);
                }), null, this.defaultDelay));

            this.connect(this.domNode, "onclick", "_onClick");
        },

        clearValue: function () {
            // summary:
            //      Clears the value of the search box
            // tags:
            //      public

            this.set("value", "");
            this.focus();
            this.toggleClearButton();
            this._valueChanged();
        },

        toggleClearButton: function () {
            // summary:
            //      Set visibility for clear button
            // tags:
            //      private

            // show clear button only if textbox has value
            domStyle.set(this.clearButton, "visibility", this.textbox.value ? "visible" : "hidden");
        },

        focus: function () {
            // summary:
            //      Set focus for textbox
            // tags:
            //      public

            focusManager.focus(this.textbox);
        },

        _onClick: function () {
            // summary:
            //		Keep focus on textbox
            // tags:
            //		private

            this.focus();
        },

        _valueChanged: function (/* Event */event) {
            // summary:
            //      Trigger when textbox value has been changed
            // tags:
            //      private

            if (event && event.charOrCode) {
                switch (event.charOrCode) {
                    case keys.ESCAPE:
                        this.clearValue();
                        return;
                    case keys.PAGE_DOWN:
                    case keys.DOWN_ARROW:
                    case keys.PAGE_UP:
                    case keys.UP_ARROW:
                    case keys.LEFT_ARROW:
                    case keys.RIGHT_ARROW:
                    case keys.TAB:
                        // do nothing when navigating, selecting text
                        return;
                }

                if (!this.triggerChangeOnEnter && event.charOrCode === keys.ENTER) {
                    return;
                }
            }

            this.onSearchBoxChange(this.encodeSearchText ? htmlEntities.encode(this.textbox.value) : this.textbox.value);
        },
        onSearchBoxChange: function (queryText) {
            // summary:
            //      Callback for the search box change event
            // tags:
            //      public
        }
    });
});

},
'epi/debounce':function(){
define("epi/debounce", [
    "dgrid/util/misc"
], function (misc) {

    /*=====
    return function (cb, context, delay) {
        // summary:
        //      Returns a function which calls the given callback only after a
        //      certain time has passed without successive calls.
        // tags:
        //      public
    };
    =====*/

    return misc.debounce;
});

},
'url:epi/shell/widget/templates/SearchBox.html':"﻿<div class=\"dijit dijitReset dijitInline dijitLeft dijitTextBox epi-searchInput epi-contentSearchBox\" id=\"widget_${id}\">\r\n    <span data-dojo-attach-point=\"clearButton\" class=\"dijitReset dijitRight epi-clearButton\" role=\"presentation\"></span>\r\n    <div class=\"dijitReset dijitInputField dijitInputContainer\">\r\n        <input data-dojo-attach-point=\"textbox,focusNode\" type=\"text\" class=\"dijitReset dijitInputInner\" role=\"textbox\" />\r\n        <span class=\"dijitPlaceHolder dijitInputField\" data-dojo-attach-point=\"_phspan,placeHolderNode\"></span>\r\n    </div>\r\n</div>",
'epi-cms/widget/SearchResultList':function(){
define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",

    // Dojox
    "dojox/widget/Standby",

    // Dijit
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/form/_ListMouseMixin",
    "dijit/form/_ComboBoxMenuMixin",

    // EPi Framework
    "epi/dependency",
    "epi-cms/widget/_ContentListKeyMixin",
    "epi-cms/widget/_ContentListMouseMixin",
    "epi-cms/dgrid/formatters",
    "epi/shell/dgrid/Formatter",

    // DGrid
    "dgrid/OnDemandList",
    "dgrid/Selection",
    "dgrid/Keyboard",

    // Templates
    "dojo/text!./templates/SearchResultList.html"
],

function (
// Dojo
    declare,
    lang,
    Evented,
    domConstruct,
    domClass,
    domStyle,

    // Dojox
    Standby,

    // Dijit
    _WidgetBase,
    _TemplatedMixin,
    _ListMouseMixin,
    _ComboBoxMenuMixin,

    // EPi Framework
    dependency,
    _ContentListKeyMixin,
    _ContentListMouseMixin,
    formatters,
    Formatter,
    // DGrid
    OnDemandList,
    Selection,
    Keyboard,

    // Templates
    template
) {

    return declare([_WidgetBase, _TemplatedMixin, Evented, _ListMouseMixin, _ComboBoxMenuMixin, _ContentListKeyMixin, _ContentListMouseMixin], {
        // summary:
        //    A grid to display content list.
        //
        // tags:
        //    internal

        templateString: template,

        // _standby: Standby
        //      The standby object to indicate the loading process for grid.
        // tags:
        //      Protected
        _standby: null,

        // _messages: Object
        //		Holds "next" and "previous" text for paging buttons on drop down.
        _messages: { nextMessage: "", previousMessage: "" },

        postCreate: function () {
            // summary:
            //		Initialize grid for displaying content list.
            // tags:
            //      Protected
            this.inherited(arguments);

            var self = this,
                profile = dependency.resolve("epi.shell.Profile"),
                gridClass = declare([OnDemandList, Selection, Keyboard, Formatter]),
                // Get item's title
                titleSelector = function (item) {
                    return item.title;
                },
                // Get item's typeIdentifier
                iconSelector = function (item) {
                    return item.metadata.typeIdentifier;
                },
                // Get item's thumbnail url
                thumbnailSelector = function (item) {
                    var container = self.grid.domNode,
                        thumbnailClass = "epi-thumbnailContentList";

                    (item.metadata.thumbnailUrl && !domClass.contains(container, thumbnailClass)) && domClass.add(container, thumbnailClass);

                    return item.metadata.thumbnailUrl;
                },
                languageSelector = function (item) {
                    if (item.metadata && item.metadata.languageBranch !== profile.contentLanguage) {
                        return { language: item.metadata.languageBranch };
                    }
                };

            this.grid = new gridClass({
                formatters: [formatters.contentItemFactory("title", titleSelector, iconSelector, null, thumbnailSelector, languageSelector, false)],
                selectionMode: "single", // for Selection; only select a single row at a time
                cellNavigation: false // for Keyboard; allow only row-level keyboard navigation
            });

            // Hide header of the grid
            this.grid.set("showHeader", false);

            domConstruct.place(this.grid.domNode, this.containerNode);

            // trigger onSelect event when clicking on grid row
            this.grid.on(".dgrid-row:click", lang.hitch(this, function (event) {
                var row = this.grid.row(event);
                if (row) {
                    this._onSelect(row.data);
                }
            }));

            this._standby = new Standby({
                target: this.domNode,
                color: "#fff",
                text: "<div class=\"oui-spinner oui-spinner--small\"></div>",
                centerIndicator: "text"
            }).placeAt(document.body);
            this.own(this._standby);

            // assign the grid container as containerNode, so _ListMouseMixin and _ComboBoxMenuMixin can get the properly container
            this.containerNode = this._getGridContainer();
        },

        startup: function () {
            // summary:
            //		handle processing after any DOM fragments have been actually added to the document.
            // tags:
            //      Protected
            this.inherited(arguments);
            this._standby.startup();
        },

        showStandby: function (show) {
            // summary:
            //		Set standby visibility.
            // tags:
            //      Protected

            if (!this._standby) {
                return;
            }
            if (show) {
                if (!this._standby.isVisible()) {
                    this._standby.show();
                }
            } else {
                this._standby.hide();
            }
        },

        showGrid: function (show) {
            // summary:
            //		Set grid visibility.
            // tags:
            //      Protected
            domStyle.set(this.grid.domNode, "display", show ? "block" : "none");
        },

        _onSelect: function (value) {
            // summary:
            //		Emit onSelect event when an item has been selected.
            // tags:
            //      Private
            this.emit("select", value);
        },

        _getGridContainer: function () {
            // summary:
            //		Returns the grid container, which contains grid rows.
            // tags:
            //      Private
            return this.grid.contentNode;
        },

        createOptions: function (results, options, labelFunc) {
            // summary:
            //		Fills in the items in the list
            // results:
            //		Array of items
            // options:
            //		The options to the query function of the store
            //
            // labelFunc:
            //		Function to produce a label in the drop down list from a dojo/data item

            this.grid.renderArray(results);
            return this.containerNode.childNodes;
        },

        clearResultList: function () {
            // summary:
            //		Clears the entries in the list.

            this.grid.refresh();
        },

        getHighlightedOption: function () {
            // summary:
            //		This will be used to highlight the text in the textbox, to allow screen readers to know what is happening in the menu.
            //      Return null since we don't want this feature.

            return null;
        },

        showErrorMessage: function (show, message) {
            // summary:
            //		Set error message visibility.
            // tags:
            //      Protected

            this.clearResultList();
            this.showStandby(false);
            if (show && message) {
                this.errorMessage.innerHTML = message;
            }
            domStyle.set(this.errorMessage, "display", show ? "block" : "none");
        }
    });
});

},
'epi-cms/widget/_ContentListKeyMixin':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/keys"
],

function (
// Dojo
    declare,
    keys
) {

    return declare(null, {
        // summary:
        //    A Mixin to handle key event for ContentList.
        //
        // tags:
        //    internal mixin

        handleKey: function (evt) {
            // summary:
            //		Handle keystroke event forwarded from ComboBox, returning false if it's
            //		a keystroke I recognize and process, true otherwise.
            // tags:
            //      Protected

            switch (evt.keyCode) {
                case keys.DOWN_ARROW:
                    this.selectNextNode();
                    return false;
                case keys.UP_ARROW:
                    this.selectPreviousNode();
                    return false;
                case keys.ENTER:
                    // select item on pressing Enter
                    if (this.selected && this.grid.row(this.selected)) {
                        this._onSelect(this.grid.row(this.selected).data);
                    }
                    return false;
                default:
                    return true;
            }
        }
    });
});

},
'epi-cms/widget/_ContentListMouseMixin':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/dom-class"
],

function (
// Dojo
    declare,
    domClass) {

    return declare(null, {
        // summary:
        //    A Mixin to handle mouse event for ContentList.
        //
        // tags:
        //    internal mixin

        onHover: function (/*DomNode*/node) {
            // summary:
            //		Add hover CSS
        },

        onUnhover: function (/*DomNode*/node) {
            // summary:
            //		Remove hover CSS
        },

        onSelect: function (/*DomNode*/node) {
            // summary:
            //		Add selected CSS

            domClass.add(node, "dgrid-selected ui-state-active dgrid-focus");
        },

        onDeselect: function (/*DomNode*/node) {
            // summary:
            //		Remove selected CSS
            domClass.remove(node, "dgrid-selected ui-state-active dgrid-focus");
        }
    });
});

},
'url:epi-cms/widget/templates/SearchResultList.html':"﻿<div class=\"epi-searchResultList\">\r\n    <div data-dojo-attach-point=\"containerNode\">\r\n        <div data-dojo-attach-point=\"errorMessage\" class=\"epi-searchResultListEmptyMessage\"></div>\r\n    </div>\r\n    <div class=\"dijitReset epi-searchResultListNavigation\">\r\n        <div data-dojo-attach-point=\"previousButton\" role=\"option\"></div>\r\n        <div data-dojo-attach-point=\"nextButton\" role=\"option\"></div>\r\n    </div>\r\n</div>",
'epi-cms/component/_ContentNavigationTreeNode':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/event",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-class",

    "dojo/Evented",
    "dojo/mouse",
    "dojo/on",

    // template
    "dojo/text!./templates/_ContentNavigationTreeNode.html",

    // epi
    "epi/datetime",
    "epi/dependency",
    "epi/string",

    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/Tooltip",

    "epi-cms/core/ContentReference",
    "epi-cms/widget/_ContentTreeNode",
    "epi-cms/widget/viewmodel/ContentStatusViewModel",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.pagetree"
],

function (
// dojo
    array,
    declare,
    Deferred,
    event,
    lang,

    domAttr,
    domClass,

    Evented,
    mouse,
    on,

    // template
    template,

    // epi
    epiDate,
    dependency,
    epiString,

    _ModelBindingMixin,
    Tooltip,

    ContentReference,
    _ContentTreeNode,
    ContentStatusViewModel,
    // resources
    res
) {

    return declare([_ContentTreeNode, _ModelBindingMixin, Evented], {
        // summary:
        //      A customized treenode for page tree
        // tags:
        //      public
        templateString: template,
        res: res,

        // hasContextMenu: [bool]
        //      Flag used to not create context menu
        hasContextMenu: true,

        _pageLocked: "epi-pt-accessRights",

        _pageBeingEdited: "epi-pt-edited",

        _contextMenuClass: "epi-iconContextMenu",

        // _iconNodeClass: [String]
        //      Custom icon for a node in the tree
        // tags:
        //      protected
        _iconNodeClass: "",

        _selected: false,

        // _contentTypeStore: [Object]
        //      Represents the ContentType REST store to get data.
        _contentTypeStore: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");

            this._contentTypeStore = registry.get("epi.cms.contenttype");
        },

        postCreate: function () {
            this.inherited(arguments);

            this.set("model", new ContentStatusViewModel({ contentStatus: this.item.status }));
        },

        buildRendering: function () {
            this.inherited(arguments);

            domClass.toggle(this.menuContainer, "dijitHidden", !this.hasContextMenu);
        },

        modelBindingMap: {
            statusIcon: ["statusIcon"],
            statusMessage: ["statusMessage"]
        },

        _setStatusMessageAttr: function (/* String */message) {
            // summary:
            //      Set content status message
            // tags:
            //      private

            domAttr.set(this.iconNodeStatus, "title", epiString.toTooltipText(message));
        },

        _setStatusIconAttr: function (/* String */cssClasses) {
            // summary:
            //      Set content status icon CSS classes
            // tags:
            //      private

            if (!(cssClasses instanceof Array)) {
                return;
            }

            //remove everything
            domClass.remove(this.iconNodeStatus);

            domClass.add(this.iconNodeStatus, "dijitTreeIcon epi-extraIcon");
            array.forEach(cssClasses, function (cssClass) {
                domClass.add(this.iconNodeStatus, cssClass);
            }, this);
        },

        showContextMenu: function (/* Boolean */show) {
            // summary:
            //      Toogle context menu icon
            // Remark:
            //      Do not use domClass.toggle because: we show the context menu using _onNodeMouseEnter event in the Tree
            //      but this event will be trigger twice (only in IE & FireFox) once the node is updated or reloaded.
            // tags:
            //      public

            // keep this method to not introduce breaking change
        },

        _onClickIconNodeMenu: function (evt) {
            event.stop(evt);

            // Since we're stopping the event we're preventing the regular focus handling,
            // which means that the context menu won't have anything to restore focus to when closed
            this.labelNode.focus();
            this.emit("onContextMenuClick", { node: this, target: evt.target, x: evt.pageX, y: evt.pageY });
        },

        _onMouseDownIconNodeMenu: function (evt) {
            //Stop mouse down event when clicking on the context menu icon
            event.stop(evt);
        },

        _updateIndividualLayout: function () {
            this._updateAccessRightIcon();

            if (this.model) {
                this.model.set("contentStatus", this.item.status);
            }
        },

        _updateAccessRightIcon: function () {
            // summary:
            //      Set access right and icon for the tree node
            // tags:
            //      private

            // Display lock icon if current user has no permission or only has "Read" permission
            if (this.item.accessMask === 0 || this.item.accessMask === 1) {
                domClass.add(this.iconNodeAccess, this._pageLocked);
                // Add tooltip to icon
                domAttr.set(this.iconNodeAccess, "title", this.res.tooltip.pagelocked);

                // Set default background for this type of nodes
                domClass.add(this.contentNode, "epi-treeReadOnly");
            } else if (this.item.inUseNotifications && this.item.inUseNotifications.length > 0) {
                // Display being edited icon
                // Only display this icon if user has change permission on page
                domClass.add(this.iconNodeAccess, this._pageBeingEdited);

                // create list of user names and dates
                var tooltipRows = [this.res.tooltip.beingedited];

                array.forEach(this.item.inUseNotifications, function (inUseNotification) {
                    var date = epiDate.toUserFriendlyString(new Date(inUseNotification.created));
                    tooltipRows.push(inUseNotification.userName + ", " + date);
                }, this);

                domAttr.set(this.iconNodeAccess, "title", tooltipRows.join("\n"));

            } else {
                domClass.remove(this.iconNodeAccess, this._pageBeingEdited);
                domClass.remove(this.iconNodeAccess, this._pageLocked);
                domAttr.set(this.iconNodeAccess, "title", "");
                domClass.remove(this.contentNode, "epi-treeReadOnly");
            }
        },

        _setIndentAttr: function (indent) {
            // summary:
            //		Tell this node how many levels it should be indented
            // description:
            //		0 for top level nodes, 1 for their children, 2 for their
            //		grandchildren, etc.

            // Math.max() is to prevent negative padding on hidden root node (when indent == -1)

            // Remove the code that sets indent in pixels for each tree node.
            // It has significant impact on memory grow since chrome 95 (version 94 is working fine)

            /*var pixels = (Math.max(indent, 0) * this.tree._nodePixelIndent) + "px";

            domStyle.set(this.domNode, "backgroundPosition", pixels + " 0px");	// TODOC: what is this for???
            domStyle.set(this.indentNode, this.isLeftToRight() ? "paddingLeft" : "paddingRight", pixels);*/

            array.forEach(this.getChildren(), function (child) {
                child.set("indent", indent + 1);
            });

            this._set("indent", indent);
        },

        setChildItems: function (/* Object[] */items) {
            // summary:
            //		Sets the child items of this node, removing/adding nodes
            //		from current children to match specified items[] array.
            //		Also, if this.persist == true, expands any children that were previously
            //		opened.
            // returns:
            //		Deferred object that fires after all previously opened children
            //		have been expanded again (or fires instantly if there are no such children).


            var oldChildren = (this.getChildren() || []).map(function (x) {
                return x.item;
            });

            // children should be refreshed only if they changed
            // see ContentTreeStoreModel.getChildren (results.observe)
            if (oldChildren.length === 0) {
                return this.inherited(arguments);
            }

            if (JSON.stringify(oldChildren) === JSON.stringify(items)) {
                var deferred = new Deferred();
                deferred.resolve();
                return deferred.promise;
            }

            return this.inherited(arguments);
        }
    });
});

},
'url:epi-cms/component/templates/_ContentNavigationTreeNode.html':"<div class=\"dijitTreeNode\" role=\"presentation\">\r\n    <div data-dojo-attach-point=\"rowNode\" class=\"dijitTreeRow dijitInline\" role=\"presentation\">\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"thumbnailNode\" class=\"epi-thumbnailIcon\" role=\"presentation\"></span>\r\n\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNodeStatus\" class=\"epi-extraIcon\" role=\"presentation\"></span>\r\n                <span data-dojo-attach-point=\"iconNodeAccess\" class=\"epi-extraIcon\" role=\"presentation\"></span>\r\n                <span data-dojo-attach-point=\"iconNodeLanguage\" class=\"epi-extraIcon epi-pt-currentLanguageMissing\" role=\"presentation\">&nbsp;</span>\r\n            </span>\r\n            <span data-dojo-attach-point=\"menuContainer\" class=\"menu-container dijitHidden\">\r\n                <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-extraIcon epi-pt-contextMenu epi-iconContextMenu\" role=\"presentation\" data-dojo-attach-event=\"click: _onClickIconNodeMenu\"></span>\r\n            </span>\r\n        </span>\r\n    </div>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer epi-navigation-tree-children\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>\r\n",
'epi/shell/widget/Tooltip':function(){
﻿define("epi/shell/widget/Tooltip", [
    "dojo/_base/declare",
    "dojo/string",

    "dojox/html/entities",
    "dojox/html/ellipsis",

    "dijit/Tooltip"
], function (
    declare,
    string,

    entities,
    ellipsis,

    Tooltip) {
    return declare(Tooltip, {
        // tags:
        //      internal

        showDelay: 600, // tooltip display timeout increased,

        // position: String[]
        //      List of positions to try to position tooltip
        position: ["after", "before", "below", "above"],

        // tooltipRows: [public] Array
        //      If property is set the lable will be overriden
        //      Accepts an array of {label:'', text:'', htmlEncode:false}
        tooltipRows: null,

        // tooltipRowTemplate: [public] String
        //      Detault row template tooltip added to tooltipRows
        tooltipRowTemplate: "<span>${label}</span>: ${text}",
        tooltipRowNoTextTemplate: "<span>${label}</span>",

        getContent: function () {
            //If there are any tooltip rows create a label using the tooltipRowTemplate
            if (this.tooltipRows) {
                var content = "<ul class='dijitInline dijitReset epi-tooltip-ellipsis'>";
                for (var i = 0; i < this.tooltipRows.length; i++) {
                    var row = this.tooltipRows[i];
                    if (!row.text) {
                        row.text = "";
                    }
                    if (row.htmlEncode === undefined || row.htmlEncode === true) {
                        row.label = entities.encode(row.label);
                        row.text = entities.encode(row.text);
                    }
                    if (!row.text) {
                        content += "<li class='dojoxEllipsis'>" + string.substitute(this.tooltipRowNoTextTemplate, row) + "</li>";
                    } else {
                        content += "<li class='dojoxEllipsis'>" + string.substitute(this.tooltipRowTemplate, row) + "</li>";
                    }
                }
                content += "</ul>";

                return content;
            }

            return this.inherited(arguments);
        }
    });
});

},
'epi-cms/widget/ContentTypeList':function(){
﻿define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when",

    // dijit
    "dijit/layout/_LayoutWidget",
    // epi
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/widget/ContentTypeGroup",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contenttypelist"
],

function (
    // dojo
    array,
    declare,
    lang,

    domClass,

    Deferred,
    all,
    when,
    // dijit
    _LayoutWidget,
    // epi
    dependency,
    TypeDescriptorManager,
    ContentTypeGroup,
    i18n
) {

    return declare([_LayoutWidget], {
        // summary:
        //      A list of suggested and available content types for content creation.
        // description:
        //      Displays a list of suggested and available content types for content creation.
        // tags:
        //      internal

        // store: [readonly] dojo/store
        //      Underlying store which will be queried for data to display.
        store: null,

        // parentLink: [public] String
        //      Link to parent content which the new content will be created beneath.
        parentLink: null,

        // groups: [public] Object
        //      Named value object containing the current content type groups.
        groups: null,

        // requestedType: [public] String
        //      Specify the content type to be shown on the list.
        requestedType: null,

        // shouldSkipContentTypeSelection: [public] Boolean
        //      Indicate that we have only 1 available type, so type selection can be skipped.
        shouldSkipContentTypeSelection: null,

        // allowedTypes: [public] Array
        //      The types which are allowed. i.e used for filtering based on AllowedTypesAttribute
        allowedTypes: null,

        // restrictedTypes: [public] Array
        //      The types which are restricted.
        restrictedTypes: null,

        contentTypeService: null,

        postMixInProperties: function () {
            // summary:
            //      Initiates the store if none has been mixed in.
            // tags:
            //      protected

            this.inherited(arguments);

            this.groups = {};

            this.contentTypeService = this.contentTypeService || dependency.resolve("epi.cms.ContentTypeService");

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.contenttype");
            }
        },

        buildRendering: function () {
            // summary:
            //      Construct the base UI with suggested content types.
            // tags:
            //      protected

            this.inherited(arguments);

            var suggested = new ContentTypeGroup();
            this.connect(suggested, "onSelect", function (item) {
                this.onContentTypeSelected(item);
            });
            this.addChild(suggested);
            this._suggestedContentTypes = suggested;
        },

        refresh: function () {
            // summary:
            //      Refresh the content and rendered view of the list.
            // tags:
            //      public

            // Clear any existing data first to stop flickering in the UI.
            this.clear();

            this._setupWidgetTemplate();

            when(all({
                types: this._getSuggestedContentTypes(this.requestedType),
                groups: this._groupContentTypes()
            }), lang.hitch(this, function (result) {
                var types = result.types,
                    groups = result.groups,
                    grouped = groups.grouped,
                    contentTypes = groups.contentTypes;

                // Setup the suggested content types.
                if (types.length <= 0) {
                    // Hide suggested content types only
                    this._suggestedContentTypes.setVisibility(false);
                } else {
                    // Setup the suggested content types.
                    domClass.add(this._suggestedContentTypes.titleNode, "epi-ribbonHeaderSpecial");
                    this._suggestedContentTypes.set("title", this._suggestedTypesTitle);
                    this._suggestedContentTypes.set("contentTypes", types);
                    this._suggestedContentTypes.setVisibility(true);
                }

                // Clear and load the available content types sorted into groups.
                var key, group;

                // Update remaining groups with new content types.
                for (key in grouped) {
                    group = this._getOrCreateGroup(key);
                    group.set("contentTypes", grouped[key]);
                }

                if (contentTypes instanceof Array && contentTypes.length === 1) {
                    // If we have 1 child only, hide all
                    this.setVisibility(false);

                    this.set("shouldSkipContentTypeSelection", true);

                    // Automatically select page type in case only one page type is allowed under the selected container.
                    this.onContentTypeSelected(contentTypes[0]);
                } else {
                    this.set("shouldSkipContentTypeSelection", false);
                }
            }));
        },

        setVisibility: function (display) {
            // summary:
            //      The common method to show / hide this widget
            // display: Boolean
            //      The flag to show or hide.
            // tags:
            //      pubic

            this.getChildren().forEach(function (group) {
                group.setVisibility(display);
            }, this);
        },

        _setupWidgetTemplate: function () {
            this._suggestedTypesTitle = TypeDescriptorManager.getResourceValue(this.requestedType, "suggestedtypes");
            this._otherTypesTitle = TypeDescriptorManager.getResourceValue(this.requestedType, "othertypes");
        },

        clear: function () {
            // summary:
            //      Removes all the content types groups from the current view, except for
            //      suggested content types which will only have it's children removed.
            // tags:
            //      public

            this._suggestedContentTypes.clear();

            for (var key in this.groups) {
                this.groups[key].destroyRecursive();
                delete this.groups[key];
            }
        },

        _getOrCreateGroup: function (name) {
            var group = this.groups[name];
            if (!group) {
                group = new ContentTypeGroup({ title: name });
                this.connect(group, "onSelect", function (item) {
                    this.onContentTypeSelected(item);
                });
                this.addChild(group);
                this.groups[name] = group;
            }

            return group;
        },

        _getAvailableContentTypes: function (type) {
            // summary:
            //      Query for available content types based on the type.
            // tags:
            //      private

            return this.contentTypeService.getAcceptedChildTypes(this.parentLink, this.get("localAsset"), [type], this.allowedTypes, this.restrictedTypes);
        },

        _getSuggestedContentTypes: function (type) {
            // summary:
            //      Query for suggested content types based on the parent page.
            // tags:
            //      private

            var result = this.store.query({
                query: "getsuggestedcontenttypes",
                localAsset: this.get("localAsset"),
                parentReference: this.parentLink,
                requestedTypes: [type]
            });

            return this.contentTypeService.filterQueryResult(result, this.allowedTypes, this.restrictedTypes);
        },

        _groupContentTypes: function () {
            // summary:
            //      Group the available content types.
            // tags:
            //      private

            var grouped = {},
                deferred = new Deferred(),
                otherGroupType = this._otherTypesTitle;

            when(this._getAvailableContentTypes(this.requestedType), lang.hitch(this, function (available) {
                var count = available.length;
                array.forEach(available, function (item) {
                    when(item, function (type) {
                        var groupName = type.groupName || otherGroupType,
                            group = grouped[groupName] || [];

                        group.push(type);
                        grouped[groupName] = group;
                        count--;
                        if (count === 0) {
                            deferred.resolve({ grouped: grouped, contentTypes: available });
                        }
                    });
                });
            }));

            return deferred;
        },

        _setLocalAssetAttr: function (localAsset) {
            this._set("localAsset", localAsset);

            if (this.requestedType && this.parentLink) {
                this.refresh();
            }
        },

        _setParentLinkAttr: function (value) {
            this._set("parentLink", value);

            if (this.requestedType) {
                this.refresh();
            }
        },

        onContentTypeSelected: function (/*===== item =====*/) {
            // summary:
            //      Event raised when a content type widget on the list
            //      is clicked.
            // tags:
            //      callback
        }

    });

});

},
'epi-cms/widget/ContentTypeGroup':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/text!./templates/ContentTypeGroup.html",

    "dijit/_TemplatedMixin",
    "dijit/layout/_LayoutWidget",

    "epi-cms/widget/ContentType",
    "dojo/keys",
    "dijit/_KeyNavContainer"
], function (declare, lang, array, domStyle, template, _TemplatedMixin, _LayoutWidget, ContentType, keys, _KeyNavContainer) {

    return declare([_LayoutWidget, _TemplatedMixin, _KeyNavContainer], {
        // summary:
        //		Displays a group of content types under a common heading.
        //
        // tags:
        //      internal

        // title: [public] String
        //		The title for the content type group.
        title: "",

        // contentTypes: [public] Array
        //		Collection of content types that are displayed in the group.
        contentTypes: null,

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: template,

        buildRendering: function () {
            // summary:
            //		Construct the UI with the initial content types
            // tags:
            //		protected

            this.inherited(arguments);
        },

        postCreate: function () {
            this.inherited(arguments);

            this.render();

            this.connectKeyNavHandlers(
                this.isLeftToRight() ? [keys.LEFT_ARROW, keys.UP_ARROW] : [keys.RIGHT_ARROW, keys.DOWN_ARROW],
                this.isLeftToRight() ? [keys.RIGHT_ARROW, keys.DOWN_ARROW] : [keys.LEFT_ARROW, keys.UP_ARROW]
            );
        },

        render: function () {
            // summary:
            //		Render the group with the current content types. This will
            //		destroy the current view if it exists.
            // tags:
            //		public

            this.clear();
            array.forEach(this.contentTypes, function (type) {
                var child = new ContentType({ contentType: type });
                this.connect(child, "onSelect", this.onSelect);
                this.addChild(child);
            }, this);
        },

        clear: function () {
            // summary:
            //		Destroys the current view.
            // tags:
            //		public

            array.forEach(this.getChildren(), function (child) {
                this.removeChild(child);
                child.destroyRecursive();
            }, this);
        },

        _setTitleAttr: { node: "titleNode", type: "innerText" },

        _setContentTypesAttr: function (value) {
            this._set("contentTypes", value);
            if (this._created) {
                this.render();
            }
        },

        onSelect: function (/*===== item =====*/) {
            // summary:
            //		Callback that is executed when an item in this
            //		group is selected.
            // tags:
            //		callback
        },

        setVisibility: function (display) {
            // summary:
            //    Set the group's visibility
            //
            // display:
            //    Flag states if the group will be shown or not.
            //
            // tags:
            //    public
            var value = (display ? "block" : "none");
            domStyle.set(this.domNode, "display", value);
        }
    });
});

},
'url:epi-cms/widget/templates/ContentTypeGroup.html':"﻿<div class=\"epi-listingContainer\" data-dojo-attach-point=\"focusNode\" tabIndex=\"${tabIndex}\">\r\n    <h2 data-dojo-attach-point=\"titleNode\" class=\"epi-ribbonHeader\"></h2>\r\n    <ul data-dojo-attach-point=\"containerNode\" class=\"epi-advancedListing\"></ul>\r\n</div>",
'epi-cms/widget/ContentType':function(){
﻿define([
    "dojo",
    "dojo/dom-class",
    "dojo/string",

    "dijit/focus",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",

    "epi/i18n!epi/cms/nls/episerver.cms.widget.pagetype",
    "dojo/text!./templates/ContentType.html"
], function (dojo, domClass, string, focus, _Widget, _TemplatedMixin, i18n, template) {

    return dojo.declare([_Widget, _TemplatedMixin], {
        // summary:
        //		Widget for displaying content type information.
        //
        // tags:
        //      internal

        // templateString: [protected] String
        //		The widget template.
        templateString: template,

        // contentType: [public] Object
        //		The content type to be displayed.
        contentType: null,

        // iconTemplate: [public] String
        //		The template used when an icon image is provided.
        iconTemplate: "<img src=\"${0}\" alt=\"${1}\" class=\"epi-preview\" />",

        // emptyIconTemplate: [public] String
        //		The template used when no icon image is provided.
        emptyIconTemplate: string.substitute("<div class=\"epi-noPreviewIcon\"><span class=\"epi-noPreview\">${0}</span></div>", [i18n.nopreview]),

        buildRendering: function () {
            // summary:
            //		Construct the UI with the initial content type.
            // tags:
            //		protected

            this.inherited(arguments);

            this.connect(this.domNode, "onclick", this._onClick);
            this.render();
        },

        render: function () {
            // summary:
            //		Render the content type information.
            // tags:
            //		public

            var type = this.contentType;
            if (type) {
                this.set("name", type.localizedName);
                this.set("description", type.localizedDescription || i18n.nodescription);
                this.set("icon", type.imagePath);
            }
        },

        _setContentTypeAttr: function (value) {
            this._set("contentType", value);
            if (this._created) {
                this.render();
            }
        },

        _setNameAttr: { node: "nameNode", type: "innerText" },

        _setDescriptionAttr: { node: "descriptionNode", type: "innerText" },

        _setIconAttr: function (value) {
            this._set("icon", value);
            this.iconNode.innerHTML = value ? string.substitute(this.iconTemplate, [value, this.name]) : this.emptyIconTemplate;
        },

        focus: function () {
            this.inherited(arguments);

            domClass.add(this.focusNode, "epi-advancedListingItemActive");

            focus.focus(this.focusNode);
        },

        _onBlur: function () {
            this.inherited(arguments);

            domClass.remove(this.focusNode, "epi-advancedListingItemActive");
        },

        _onKeyPress: function (e) {
            //Fire click when pressing the enter/space key
            if (e.keyCode === 13 || e.keyCode === 32) {
                this.onSelect(this.contentType);
            }
        },

        _onClick: function () {
            // summary:
            //    Raised when the widget is clicked.
            //
            // tags:
            //   private

            this.onSelect(this.contentType);
        },

        _onMouseOver: function () {
            domClass.add(this.focusNode, "epi-advancedListingItemActive");
        },
        _onMouseOut: function () {
            domClass.remove(this.focusNode, "epi-advancedListingItemActive");
        },

        onSelect: function (item) {
            // summary:
            //    Raised when the content type is selected.
            //
            // item:
            //    The content type.
            //
            // tags:
            //   public event
        }
    });
});

},
'url:epi-cms/widget/templates/ContentType.html':"﻿<li class=\"clearfix\" data-dojo-attach-event=\"onkeypress:_onKeyPress, onmouseover:_onMouseOver, onmouseout:_onMouseOut\" data-dojo-attach-point=\"focusNode\">\r\n    <div class=\"epi-browserWindow\"><div class=\"epi-browserWindowContent\" data-dojo-attach-point=\"iconNode\">${emptyIconTemplate}</div></div>\r\n    <h3 data-dojo-attach-point=\"nameNode\"></h3>\r\n    <p data-dojo-attach-point=\"descriptionNode\"></p>\r\n</li>",
'epi-cms/contentediting/inline-editing/CreateNewBlockEditFormContainer':function(){
define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/topic",
    "epi/dependency",
    "epi-cms/contentediting/inline-editing/BlockEditFormContainer",
    "epi-cms/contentediting/viewmodel/CreateContentViewModel"
], function (
    declare,
    Deferred,
    topic,
    dependency,
    BlockEditFormContainer,
    CreateContentViewModel) {
    return declare([BlockEditFormContainer], {
        _contextService: null,

        autoStartup: true,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.createContentViewModel = new CreateContentViewModel({
                createAsLocalAsset: true,
                ignoreDefaultNameWarning: true
            });
        },

        buildRendering: function () {
            this.inherited(arguments);

            this._contextService = this._contextService || dependency.resolve("epi.shell.ContextService");
            this._contextService.currentContext = this._contextService.currentContext || {};

            this._setCreateMode();
        },

        onFieldCreated: function (fieldName, widget) {
            // override parent to avoid null exception
        },

        _setAddToDestinationAttr: function (model) {
            this.createContentViewModel.set("addToDestination", model);
        },

        _setAutoPublishAttr: function (autoPublish) {
            this.createContentViewModel.set("autoPublish", autoPublish);
        },

        reloadMetadata: function (parent, contentTypeId) {
            this.createContentViewModel.set({
                parent: parent,
                contentTypeId: contentTypeId
            });

            return this.createContentViewModel._getMetadata(parent.contentLink, contentTypeId).then(function (metadata) {
                this.set("metadata", metadata);
                this.startup();
            }.bind(this));
        },

        saveForm: function (contentType, name) {
            var deferred = new Deferred();

            var saveHandle = this.createContentViewModel.on("saveSuccess", function (result) {
                this._clearCreateMode();
                saveHandle.remove();
                // eslint-disable-next-line no-use-before-define
                errorHandle.remove();
                deferred.resolve(result);

                topic.publish("/epi/cms/action/createlocalasset");
            }.bind(this));
            var errorHandle = this.createContentViewModel.on("saveError", function () {
                saveHandle.remove();
                errorHandle.remove();
                var errorsMessages = [];
                this.validator._store.query().forEach(function (error) {
                    if (error && error.item && error.item.errorMessage) {
                        errorsMessages.push(error.item.errorMessage);
                    }
                });
                deferred.reject(errorsMessages);
            });

            // Only set name when it's given.
            // In the case the block name property is hidden, the block name will be generated automatically.
            if (this.get("value") && (this.get("value").name || this.get("value").icontent_name)) {
                this.createContentViewModel.set("contentName", this.get("value").name || this.get("value").icontent_name);
            } else {
                this.createContentViewModel.set("autoGenerateName", true);
            }
            this.createContentViewModel.set("properties", this.get("value"));
            this.saveModel(contentType, name);
            return deferred.promise;
        },

        saveModel: function () {
            this.createContentViewModel.save();
        },

        _setCreateMode: function () {
            this._contextService.currentContext.currentMode = "create";
        },

        _clearCreateMode: function () {
            this._contextService.currentContext.currentMode = undefined;
        },

        _onFormCreated: function () {
            this.inherited(arguments);
            var value = this.get("value");
            var isDirty = Object.keys(value).length > 0;
            this.set("isDirty", isDirty);
            this.emit("isDirty", isDirty);
        }
    });
});

},
'epi-cms/contentediting/inline-editing/BlockEditFormContainer':function(){
define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/topic",
    "dojo/on",
    "dojo/Evented",
    "epi/dependency",
    "epi",
    "epi/UriParser",
    "epi/shell/tooltipHider",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/ContentViewModel",

    "epi/shell/widget/FormContainer"
], function (
    declare,
    Deferred,
    topic,
    on,
    Evented,
    dependency,
    epi,
    UriParser,
    tooltipHider,
    ContentActionSupport,
    ContentViewModel,
    FormContainer) {

    return declare([FormContainer, Evented], {
        contentLink: null,
        isDirty: false,
        initialValue: null,
        autoStartup: true,
        isInQuickEditMode: true,

        _onIsDirty: function () {
            var isDirty = !epi.areEqual(this.get("initialValue"), this.get("value"));

            this.set("isDirty", isDirty);
            this.emit("isDirty", isDirty);
        },

        postCreate: function () {
            this.inherited(arguments);

            this._enhancedStore = dependency.resolve("epi.storeregistry").get("epi.cms.latestcontentversion");
            this.own(on(this, "FormCreated", function () {
                tooltipHider(this.form.getParent());
                this.onChange = this._onIsDirty.bind(this);

                this.own(on(this, "change", this._onIsDirty.bind(this)));
                this.own(on(this.domNode, "change", this._onIsDirty.bind(this)));
                this.own(on(this.domNode, "keyup", this._onIsDirty.bind(this)));
                this.initialValue = this.get("value");
            }.bind(this)));
        },

        onFieldCreated: function (fieldName, widget) {
            this.inherited(arguments);
            // make sure _model is not null before set _contentLink
            // e.g: CreateNewBlockEditFormContainer
            this._model && widget.set("_contentLink", this._model.contentLink);
        },

        saveForm: function () {
            var model = this._model,
                value = this.get("value"),
                initialValue = this.get("initialValue");

            // the form was not changed
            if (!this.get("value")) {
                return new Deferred().resolve(false);
            }

            this._model.onContentLinkChange = function () { };

            Object.keys(this.get("value")).forEach(function (propertyName) {
                if (value[propertyName] !== initialValue[propertyName]) {
                    model.setProperty(propertyName, value[propertyName]);
                }
            });

            return model.save().then(function (result) {
                if (!result) {
                    return;
                }
                topic.publish("/epi/cms/content/statuschange/", model.contentData.status, {id: model.contentLink});

                if (model.contentData.isPendingPublish) { /*isPendingPublish is true if the content doesn't have a published version*/
                    topic.publish("/epi/cms/block/inline-updated");
                }
            });
        },

        layout: function () {
            this.inherited(arguments);
            if (this.containerLayout) {
                this.containerLayout.containerNode.style.removeProperty("height");
                this.containerLayout.containerNode.style.removeProperty("width");
            }
        },

        _setContentLinkAttr: function (contentLink) {
            this._set("contentLink", contentLink);

            var self = this;
            return this._enhancedStore.query({id: contentLink, keepVersion: true}).then(function (latestContent) {
                var contentData = latestContent;
                return self._getContextStore().query({uri: "epi.cms.contentdata:///" + contentData.contentLink})
                    .then(function (context) {
                        self._context = context;
                        var uri = new UriParser(context.uri);
                        self._model = new ContentViewModel({
                            contentLink: uri.getId(),
                            enableAutoSave: false,
                            isInQuickEditMode: true
                        });
                        return self._model.reload(true);
                    })
                    .then(function () {
                        self.set("metadata", self._model.get("metadata"));
                        return contentData;
                    });
            });
        },

        _onFormCreated: function () {
            this.inherited(arguments);

            if (this._model && !this._model.canChangeContent(ContentActionSupport.action.Edit)) {
                this.set("readOnly", true);
            }
        },

        _hideProperty: function (metadata, propertyName) {
            metadata.properties.some(function (property) {
                if (property.name === propertyName) {
                    property.showForEdit = false;
                    return true;
                }
                return false;
            });
        },

        _disableNonLanguageSpecificProperties: function (metadata) {
            metadata.properties.forEach(function (property) {
                if (!property.settings.isLanguageSpecific) {
                    property.showForEdit = false;
                }
            }.bind(this));
        },

        _setMetadataAttr: function (metadata) {
            var settings = (metadata.customEditorSettings || {}).inlineBlock;

            if (!settings) {
                console.warn("Metadata was not initialized properly");
                settings = {};
            }

            if (!settings.showNameProperty) {
                this._hideProperty(metadata, "icontent_name");
            }
            if (!settings.showCategoryProperty) {
                this._hideProperty(metadata, "icategorizable_category");
            }

            if (this.get("isTranslationNeeded")) {
                this._disableNonLanguageSpecificProperties(metadata);
            }

            metadata.properties.forEach(function (property) {
                property.settings.isInQuickEditMode = this.isInQuickEditMode;
                property.settings.quickEditBlockId = this.contentLink;
            }.bind(this));

            var hiddenGroups = settings.hiddenGroups.map(function (x) {
                return x.toLowerCase();
            });
            var numberOfVisibleGroups = metadata.groups.filter(function (x) {
                return x.name !== "EPiServerCMS_SettingsPanel" && hiddenGroups.indexOf(x.name.toLowerCase()) === -1;
            }).length;

            // Change group properties container to epi-cms/layout/CreateContentGroup
            metadata.layoutType = "epi/shell/layout/SimpleContainer";
            metadata.groups.forEach(function (group) {
                group.uiType = "epi-cms/layout/CreateContentGroupContainerNoHeader";

                if (group.name === "EPiServerCMS_SettingsPanel") {
                    group.options = {};
                    group.title = null;
                } else {
                    if (numberOfVisibleGroups > 1) {
                        group.uiType = "epi-cms/layout/CreateContentGroupContainer";
                    }
                }

                // by default Settings tab is not displayed
                if (hiddenGroups.indexOf(group.name.toLowerCase()) !== -1) {
                    group.displayUI = false;
                }
            });
            this._set("metadata", metadata);

            if (this.autoStartup) {
                this.startup();
            }
        },

        _getContextStore: function () {
            if (!this._contextStore) {
                var registry = dependency.resolve("epi.storeregistry");
                this._contextStore = registry.get("epi.shell.context");
            }
            return this._contextStore;
        }
    });
});

},
'epi/shell/tooltipHider':function(){
define("epi/shell/tooltipHider", [
    "dojo/on",
    "dijit/Tooltip",
    "dijit/registry",
    "epi/debounce"
], function (on, Tooltip, registry, debounce) {
    // summary:
    //      Watcher of any dijit/Tooltip instances created by the provided widget
    //      Once applied to any widget it would track the tooltips created and hide them when the
    //      widget's dom node is scrolled.
    //      ref. https://bugs.dojotoolkit.org/ticket/5777
    // tags:
    //      internal

    var activeTooltips = [];

    var originalOpen = Tooltip._MasterTooltip.prototype.show;
    Tooltip._MasterTooltip.prototype.show = function () {
        originalOpen.apply(this, arguments);
        activeTooltips.push(this.get("id"));
    };
    Tooltip._MasterTooltip.prototype.show.nom = "show";

    var originalClose = Tooltip._MasterTooltip.prototype.hide;
    Tooltip._MasterTooltip.prototype.hide = function () {
        originalClose.apply(this, arguments);
        var tooltipIdIndex = activeTooltips.indexOf(this.get("id"));
        if (tooltipIdIndex !== -1) {
            activeTooltips.splice(tooltipIdIndex, 1);
        }
    };
    Tooltip._MasterTooltip.prototype.hide.nom = "hide";

    function hideAll() {
        // iterating backwards because we are using the 'hide' method which removes tooltip widgets from the activeTooltips array
        for (var i = activeTooltips.length - 1; i >= 0; i--) {
            var tooltipId = activeTooltips[i];
            var widget = registry.byId(tooltipId);
            if (widget) {
                widget.hide(widget.aroundNode);
            }
        }
    }

    return function (widget) {
        if (!widget || !widget.domNode) {
            return;
        }

        widget.own(on(widget.domNode, "scroll", debounce(hideAll, null, 100)));
    };
});


},
'epi-cms/contentediting/ContentViewModel':function(){
define([
    // Dojo
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/json",
    "dojo/Deferred",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/on",
    "dojo/when",
    "dojo/promise/all",
    "dojo/Stateful",
    "dijit/Destroyable",
    "dgrid/List",
    "dgrid/extensions/DijitRegistry",

    // EPi Framework
    "epi",
    "epi/dependency",
    "epi/string",
    "epi/shell/UndoManager",
    "epi/shell/DialogService",
    "epi/shell/conversion/ObjectConverterRegistry",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/Stateful",
    "epi/shell/xhr/errorHandler",

    // EPi CMS
    "../ApplicationSettings",
    "./ContentActionSupport",
    "./ContentEditingValidator",
    "./ContentModelServerSync",
    "./Operation",
    "./ModelPopulation",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting",
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions"
], function (
    // Dojo
    array,
    connect,
    declare,
    json,
    Deferred,
    lang,
    topic,
    on,
    when,
    all,
    Stateful,
    Destroyable,
    List,
    DijitRegistry,

    // EPi Framework
    epi,
    dependency,
    epiString,
    UndoManager,
    dialogService,
    ObjectConverterRegistry,
    Alert,
    EpiStateful,
    errorHandler,

    // EPi CMS
    ApplicationSettings,
    ContentActionSupport,
    ContentEditingValidator,
    ContentModelServerSync,
    Operation,
    ModelPopulation,

    // Resources
    res,
    resVersions
) {

    return declare([Stateful, Destroyable], {
        // tags:
        //      internal xproduct

        // PUBLIC
        contentModel: null,

        metadata: null,

        syncService: null,

        editorFactory: null,

        validator: null,

        contentDataStore: null,

        profileHandler: null,

        languageContext: null,

        enableAutoSave: true,

        isInQuickEditMode: false,

        // PRIVATE
        _converterRegistry: null,

        _contentVersionStore: null,

        _syncRetryTimeout: 60000,

        undoManager: null,

        contextTypeName: "",

        contentLink: null,

        contentData: null,

        viewName: null,

        isCreatingNewVersion: false,

        hasUndoSteps: false,
        hasRedoSteps: false,
        isValid: true,
        hasPendingChanges: false,
        lastSaved: null,
        isSaved: true,
        isSaving: false,
        isOnline: true,
        hasErrors: false,
        validationErrors: null,
        isChangingContentStatus: false,

        // isSuspended: [readonly] Boolean
        //      Determines if the model is suspended or not (re-acting to undo/redo, publishing topics)
        isSuspended: false,

        constructor: function () {
            this.contentModel = new EpiStateful();
        },

        postscript: function () {
            this.inherited(arguments);

            // resolve dependency variables
            this.profileHandler = this.profileHandler || dependency.resolve("epi.shell.Profile");
            this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");
            this.projectService = this.projectService || dependency.resolve("epi.cms.ProjectService");

            this.currentContentLanguage = this.currentContentLanguage || ApplicationSettings.currentContentLanguage;
            this.contentDataStore = this.contentDataStore || dependency.resolve("epi.storeregistry").get("epi.cms.contentdata");

            if (!this._contentVersionStore) {
                this._contentVersionStore = dependency.resolve("epi.storeregistry").get("epi.cms.contentversion");
            }

            this.undoManager = this.undoManager || new UndoManager();
            this.validator = this.validator || new ContentEditingValidator({ contextId: this.get("contentLink"), contextTypeName: this.contextTypeName });
            this._dialogService = this._dialogService || dialogService;

            if (!this.syncService) {
                this._createSyncService();
            }

            // observe and copy these properties to this object
            var updater = lang.hitch(this, function (name, oldVal, newVal) {
                this.set(name, newVal);
            });

            this._operation = new Operation();

            this.own(
                this.syncService.watch("hasPendingChanges", updater),
                this.validator.watch("isValid", updater),
                this.validator.watch("hasErrors", updater),
                this.undoManager.watch("hasUndoSteps", updater),
                this.undoManager.watch("hasRedoSteps", updater),
                on(this._operation, "commit", lang.hitch(this, this._commitChanges))
            );
        },

        setActiveProperty: function (name) {
            // summary:
            //      Set property to active, which would bring up property's editor.
            // name: [String]
            //      Property name. Can also be "dot notation" name if it is sub property of a block property.
            // tags:
            //      public

            this.onSetActiveProperty(name);
        },

        suspend: function () {
            // summary:
            //      Suspends the editing for this view model.

            this.set("isSuspended", true);

            this.onContentChange();
            this.onSuspend();
        },

        onSuspend: function () {
            // summary:
            //  Raise onSuspend current view model
        },

        wakeUp: function () {
            // summary:
            //      Wake the suspended content view model up.
            this.set("isSuspended", false);
        },

        destroy: function () {

            this.clear();

            this.inherited(arguments);
        },


        clear: function () {
            this.undoManager.clear();
        },

        _createSyncService: function () {
            // summary:
            //      Creates and returns a new sync service instance.
            // tags:
            //      private

            var syncService = new ContentModelServerSync({
                contentLink: this.get("contentLink"),
                contentDataStore: this.contentDataStore,
                isInQuickEditMode: this.isInQuickEditMode
            });

            this.syncService = syncService;
        },

        connectLocal: function (targetArray, obj, evt, listener) {
            if (!lang.isArray(targetArray)) {
                throw Error("First argument to connectLocal must be an Array");
            }

            return targetArray.push(connect.connect(obj, evt, this, listener));
        },

        disconnectLocal: function (targetArray) {
            if (lang.isArray(targetArray)) {
                var listener;
                while ((listener = targetArray.pop())) {
                    connect.disconnect(listener);
                }
            }
        },

        resetNotifications: function () {
            this.validator.clearErrorsBySource(this.validator.validationSource.client);

            // only support onpage & formedit views
            if (this.viewName && this.viewName !== "onpageedit" && this.viewName !== "formedit") {
                this.validator.clearErrorsBySource(this.validator.validationSource.client & this.validator.validationSource.server);
                return;
            }

            when(this.contentDataStore.executeMethod("Validate", this.get("contentLink"), {
                validationType: this.validator.validationType.propertyValidation,
                severity: this.validator.severity.warn
            })).then(function (validations) {
                var groupValidations = validations.reduce(function (accumulator, currentValue) {
                    var propertyName = epiString.pascalToCamel(currentValue["propertyName"]);
                    (accumulator[propertyName] = accumulator[propertyName] || []).push(currentValue);
                    return accumulator;
                }, {});
                Object.keys(groupValidations).forEach(function (propertyName) {
                    var propertyValidations = groupValidations[propertyName];
                    this.validator.setPropertyErrors(propertyName, propertyValidations.map(function (issue) {
                        return {
                            severity: issue.severity,
                            errorMessage: issue.errorMessage,
                            externalItemData: {
                                propertyName: propertyName,
                                enabledDeepLink: true,
                                showToPropertyExtraInfoArea: true
                            }
                        };
                    }.bind(this)), this.validator.validationSource.client & this.validator.validationSource.server);
                }.bind(this));
            }.bind(this));
        },

        beginOperation: function () {
            // summary:
            //      Start a multi property operation where all property changes should be handled as one undo step.

            this._operation.begin();
        },

        endOperation: function () {
            // summary:
            //      End a multi property operation, creating an undo step.

            this._operation.end();
        },

        abortOperation: function () {
            // summary:
            //      Abort an ongoing multi property operation.

            this._operation.abort();
        },

        getProperty: function (propertyName) {
            return this.contentModel.get(propertyName);
        },

        setProperty: function (propertyName, value, oldValue) {
            this._setModelProperty(propertyName, value, oldValue);
        },

        scheduleForPublish: function (date) {
            // summary:
            //      Schedule the content for publish at a given time
            // date: Date
            //      The date when the content should be published
            // tags:
            //      internal

            return this.saveProperty("iversionable_startpublish", date, ContentActionSupport.saveAction.ForceCurrentVersion | ContentActionSupport.saveAction.Schedule);
        },

        saveProperty: function (propertyName, value, saveAction) {
            // summary:
            //      Save a property value to the current version with a given save action.
            // propertyName: String
            //      The property name
            // value: Object
            //      The property value
            // saveAction: SaveAction
            //      The save action that should be triggered

            return this.syncService.saveProperty(propertyName, value, saveAction)
                .then(function (result) {
                    this.set("validationErrors", result.validationErrors);
                    this.contentModel.set(propertyName, value);
                    return this.changeContentStatus(saveAction, true);
                }.bind(this));
        },

        saveAndPublishProperty: function (propertyName, value, additionalSaveAction) {
            // summary:
            //      Save a property value to the published version. The change is also saved on the current version.
            // propertyName: String
            //      The property name
            // value:
            //      The property value
            // additionalSaveAction: SaveAction
            //      An additional save action to trigger

            // sync change to syncservice
            return when(this.syncService.saveProperty(propertyName, value, ContentActionSupport.saveAction.Publish | additionalSaveAction), lang.hitch(this, function (result) {

                // Update global errors
                this.validator.setGlobalErrors(result.validationErrors, this.validator.validationSource.server);

                // Update model
                this.contentModel.set(propertyName, value);

                // update data store
                return when(all([
                    this.contentDataStore.refresh(result.contentLink),
                    result.publishedContentLink ? this.contentDataStore.refresh(result.publishedContentLink) : null
                ]), lang.hitch(this, function (promiseResult) {
                    var contentData = promiseResult[0];
                    this.set("contentData", contentData);

                    return result;
                }));
            }));
        },

        _commitChanges: function (/*Array*/ properties) {
            // summary:
            //      Schedules the supplied properties to the server and creates ONE undo step for the changes

            var inverseProperties = [];

            properties.forEach(function (property) {
                inverseProperties.push({
                    propertyName: property.propertyName,
                    value: property.oldValue,
                    oldValue: property.value
                });

            }, this);

            this.undoManager.createStep(this, this._saveProperties, [inverseProperties], "Edit properties");
        },

        _saveProperties: function (properties) {
            // summary:
            //      Updates the model with an array of properties as one "unit" causing one undo step.
            //      Primarily used as undo/redo callback

            this.beginOperation();

            array.forEach(properties, function (p) {
                this._setModelProperty(p.propertyName, p.value, p.oldValue);
            }, this);

            this.endOperation();
        },

        _setModelProperty: function (propertyName, value, oldValue) {
            // summary:
            //      Sets a property value on the content model and adds a save operation to the internal operation object

            oldValue = oldValue === undefined ? this.contentModel.get(propertyName) : oldValue;

            this.set("isSaved", false);

            this.contentModel.set(propertyName, value);

            this._operation.save({
                propertyName: propertyName,
                value: value,
                oldValue: oldValue
            });

            // Add the property to the sync queue
            this.syncService.scheduleForSync(propertyName, value);
            var deferredSave = true;
            if (this.enableAutoSave) {
                deferredSave = this.save();
            }

            this.onPropertyEdited(propertyName, value);

            if (this._shouldRefreshCurrentContext(propertyName)) {
                when(deferredSave).then(function (result) {
                    if (!result) {
                        return;
                    }

                    topic.publish("/epi/shell/context/refreshcurrent");
                }.bind(this));
            }
        },

        _shouldRefreshCurrentContext: function (propertyName) {
            var editedPropertyMapping = this.metadata._propertyMap[propertyName.toLowerCase()];
            if (!editedPropertyMapping || !editedPropertyMapping.additionalValues) {
                return false;
            }

            var shouldReloadOnChange = editedPropertyMapping.additionalValues["reloadOnChange"] === true;

            return this.enableAutoSave && this.viewName === "formedit" && shouldReloadOnChange;
        },

        onPropertyEdited: function (propertyName, value) {
            // summary:
            //      Called when a property has been edited.
            //
            // propertyName: String
            //      Name of the property
            //
            // value: String|Object
            //      The new value
            //
            // tags:
            //      public
        },

        onPropertySaved: function (propertyName, value) {
            // summary:
            //      Raised when a property value has been saved to the server
            //
            // propertyName: String
            //      Name of the saved property
            //
            // value: String|Object
            //      The saved value
            //
            // tags: internal
        },

        onPropertyReverted: function (propertyName, oldValue) {
            // summary:
            //      Raised when a property value has been reverted to last saved value
            //
            // propertyName: String
            //      Name of the reverted property
            //
            // oldValue: String|Object
            //      The old value
            //
            // tags: internal

            this.contentModel.set(propertyName, oldValue);
        },

        _onSynchronizeSuccess: function (contentLink, properties, results) {
            // summary:
            //    Handler when a property has been successfully synchronized
            // contentLink:
            //      The contentLink
            // properties:
            //      Properties synchronized

            array.forEach(properties, lang.hitch(this, function (property) {
                this.validator.clearPropertyErrors(property.name, this.validator.validationSource.server);
                // update data store
                this._patchContentDataStore(contentLink, property.name, null, property.value);
                this.onPropertySaved(property.name, property.value);
            }));

            this.validator.setGlobalErrors(results.validationErrors, this.validator.validationSource.server);
        },


        _onSynchronizeFailure: function (contentLink, properties, message, results) {
            // summary:
            //      Handle a property that couldn't be synchronized due to server rejecting the data,
            //      for instance if the data isn't valid
            // contentLink:
            //      The contentLink
            // properties:
            //      Properties
            // message:
            //      A message why it couldn't update
            // results:
            //      The results of the update including any global validation errors.
            // tags:
            //      private

            var propertiesToRevert = [];

            array.forEach(properties, function (property) {
                if ("successful" in property) {
                    if (property.successful) {
                        this.validator.clearPropertyErrors(property.name, this.validator.validationSource.server);
                    } else {
                        // Could not synchronize property, queue it up to be handled
                        propertiesToRevert.push(property);
                    }
                }
            }, this);

            // We inform the user that properties that couldn't be synchronized will be reverted
            if (propertiesToRevert.length) {
                var errorMessages = array.map(propertiesToRevert, function (property) {
                    return property.validationErrors;
                });
                this._showErrorsDialog(res.autosave.error, errorMessages, lang.hitch(this, function () {
                    array.forEach(propertiesToRevert, function (property) {
                        this.onPropertyReverted(property.name, property.value);
                    }, this);
                }));
            }

            //If we have a result set the global validation errors
            if (results) {
                if (results.validationErrors) {
                    this.validator.setGlobalErrors(results.validationErrors, this.validator.validationSource.server);
                } else {
                    this.validator.clearGlobalErrors(this.validator.validationSource.server);
                }
            }
        },

        _showErrorsDialog: function (description, errors, acknowledgeCallback) {
            // summary:
            //      Shows an alert dialog with a list of errors
            //
            // errors: [Array:string]
            //      Collection of error messages to display
            //
            // acknowledgeCallback: [Function]
            //      Called when user has triggered the dialog's acknowledge action.
            //
            // tags:
            //      private

            var list = new (declare([List, DijitRegistry]))({ className: "epi-grid-max-height--300" });
            list.renderArray(errors);
            list.startup();

            function onActionCallback() {
                if (typeof acknowledgeCallback === "function") {
                    acknowledgeCallback();
                }
                this._currentErrorDialog = null;
            }

            if (this._currentErrorDialog) {
                // don't show alert twice, just update the content
                this._currentErrorDialog.set("content", list);
            } else {
                this._currentErrorDialog = new Alert({
                    description: description,
                    content: list,
                    onAction: onActionCallback.bind(this)
                });
                this._currentErrorDialog.show();
            }
        },

        _contentLinkChanged: function (newContentLink) {

            // store the latest newContentLink, could have changed during sync, ie when first changing a property
            this.set("contentLink", newContentLink);

            this.syncService.set("contentLink", newContentLink);

            // propagate new contentlink
            this.validator.setContextId(newContentLink);

            this.onContentLinkChange();
        },

        ensureWritableVersion: function () {
            // summary:
            //      Ensures that we are editing a writable version
            //
            // tags:
            //      private

            var contentLink = this.get("contentLink");

            if (!this.contentData.isNewVersionRequired) {
                return contentLink;
            }


            if (this._isCreatingNewVersionDeferred && !this._isCreatingNewVersionDeferred.isFulfilled()) {
                return this._isCreatingNewVersionDeferred.promise;
            } else {
                this._isCreatingNewVersionDeferred = new Deferred();
            }

            this.isCreatingNewVersion = true;

            when(this._contentVersionStore.put({ originalContentLink: contentLink }), lang.hitch(this, function (newVersion) {

                //Load the new version
                //NOTE:     we need to refresh contentData before we resolve because isNewVersionRequired
                //          is returned with the contentData, if we don't update contentData before resolving we
                //          can end up in a situation where we keep producing new versions with every sync call
                //          since isNewVersionRequired stays true
                this.contentDataStore.refresh(newVersion.contentLink).then(lang.hitch(this, function (contentData) {
                    this.set("contentData", contentData);
                })).always(lang.hitch(this, function () {
                    this.isCreatingNewVersion = false;
                    this._contentLinkChanged(newVersion.contentLink);
                    this._isCreatingNewVersionDeferred.resolve(newVersion);
                }));

            }), lang.hitch(this, function (error) {
                this.isCreatingNewVersion = false;
                this._isCreatingNewVersionDeferred.reject(error);

                var errorMessage = error.responseText ? json.fromJson(error.responseText) : error.message;
                this.validator.setGlobalErrors(errorMessage, this.validator.validationSource.server);
            }));

            return this._isCreatingNewVersionDeferred.promise;
        },

        validate: function () {
            // summary:
            //      Validate the model
            //
            // tags:
            //      public

            var def;
            if (!this.validator) {
                def = new Deferred();
                def.resolve();
            } else {
                def = this.validator.validate();
            }

            return def;
        },

        revertToPublished: function () {
            // summary:
            //      Revert to published version
            // tags:
            //      public

            var contentLink = this.get("contentLink");

            return when(this._contentVersionStore.remove(contentLink),
                function () {
                    this._loadPublishedVersion(contentLink);
                }.bind(this),
                function (error) {
                    var errorMessage;
                    if (error.status === 403) {
                        // This version already published
                        errorMessage = resVersions.deleteversion.cannotdeletepublished;
                    } else if (error.status === 404) {
                        // This version does not exist
                        errorMessage = res.versionstatus.versionnotfound;
                    }

                    if (errorMessage) {
                        return this._dialogService.alert(errorMessage).then(function () {
                            this._loadPublishedVersion(contentLink);
                        }.bind(this));
                    }
                }.bind(this)
            );
        },

        _loadPublishedVersion: function (contentLink) {
            // summary:
            //      Get published version and reload
            // tags:
            //      private
            when(this._contentVersionStore.query({ contentLink: contentLink, language: this.languageContext ? this.languageContext.language : "", query: "getpublishedversion" }),
                lang.hitch(this, function (result) {
                    if (result !== null) {
                        var contextParameters = { uri: "epi.cms.contentdata:///" + result.contentLink, context: this };
                        topic.publish("/epi/shell/context/request", contextParameters, { sender: this, forceReload: true });
                    }
                }));
        },

        createDraft: function () {

            var contentLink = this.get("contentLink"),
                setCommonDraft;
            /*this.contentData.isCommonDraft &&
            this.contentData.status === ContentActionSupport.versionStatus.DelayedPublish &&
            !this.projectService.isProjectModeEnabled*/

            // There is a bug in this condition, but the bug was there for almost 8 years and now people expect that it will work that way
            // Properly we should check if project mode is enabled, but also check if current project is set
            // For most of the cases where partners do not use projects, project mode is enabled, but the project is not set
            // !(this.projectService.isProjectModeEnabled && currentProject !== null)
            setCommonDraft = false;

            return when(this._contentVersionStore.put({ originalContentLink: contentLink, isCommonDraft: setCommonDraft }), lang.hitch(this, function (newVersion) {
                var contextParameters = { uri: "epi.cms.contentdata:///" + newVersion.contentLink, context: this };
                topic.publish("/epi/shell/context/request", contextParameters, { sender: this });
                topic.publish("/epi/cms/content/statuschange/", "common-draft", { id: newVersion.contentLink });
            }));

        },

        editCommonDraft: function () {
            // summary:
            //      Get common draft version and reload
            // tags:
            //      public
            var contentLink = this.get("contentLink");

            return when(this._contentVersionStore.query({ contentLink: contentLink, query: "getcommondraftversion" }), lang.hitch(this, function (commonDraftVersion) {
                var contextParameters = { uri: "epi.cms.contentdata:///" + commonDraftVersion.contentLink, context: this };
                topic.publish("/epi/shell/context/request", contextParameters, { sender: this });
            }));
        },

        getPropertyMetaData: function (propertyName) {
            // summary:
            //      Return metadata of a property.
            //
            // propertyName: [String]
            //      The property name
            //
            // return: [Object|Deferred]
            //      Returns the metadata object if content metadata has already resolved.
            //      Otherwise returns a deferred which resolves to the property metadata when content metadata is loaded.
            //
            // tags:
            //      public

            return when(this._getMetadata(), function (metadata) {
                return metadata.getPropertyMetadata(propertyName);
            });
        },

        reload: function (force) {
            // summary:
            //      Reloads the metadata and content data for the model
            //
            // force: [Boolean]
            //      Bypass the cache and retrieve the new contentdata from server
            //
            // return: [Promise]
            //      Returns a promise when the data has been reloaded
            //
            // tags:
            //      public

            var serverCall = force ?
                this.contentDataStore.refresh(this.get("contentLink")) :
                this.contentDataStore.get(this.get("contentLink"));
            return when(all([serverCall, this._getMetadata(true)]), lang.hitch(this, function (data) {
                var contentData = data[0],
                    metadata = data[1];

                this.set("contentData", contentData);

                var contentModel = this.get("contentModel");
                var model = ModelPopulation.populateContentModel(contentData.properties, metadata);

                for (var name in model) {
                    // Only update changed values, otherwise watches are called for all properties
                    if (Object.prototype.hasOwnProperty.call(model, name) && !epi.areEqual(contentModel.get(name), model[name])) {
                        contentModel.set(name, model[name]);
                    }
                }
            })
            );
        },

        _getMetadata: function (reload) {
            // summary:
            //      Returns the metadata for the content
            // reload: [Boolean]
            //      Flag inidicating if the metadata should be reloaded or not
            // return: [Object|Promise]
            //      Returns the metadata object if content metadata has already resolved.
            //      Otherwise returns a deferred which resolves to the  content metadata is loaded.
            // tags:
            //      private

            var metadata = this.get("metadata");
            if (!reload && metadata) {
                return metadata;
            }

            var self = this;
            return when(this.metadataManager.getMetadataForType("EPiServer.Core.ContentData", { contentLink: this.get("contentLink") }),
                function (metadata) {
                    self.set("metadata", metadata);

                    return metadata;
                });
        },

        save: function () {
            if (!this.isOnline) {
                var def = new Deferred();

                def.resolve(true);

                return def;
            }
            return this._save();
        },

        _save: function () {
            var def = new Deferred(),
                onSuccess = lang.hitch(this, function (result) {
                    if (result) {
                        if (result.successful) {
                            this._onSynchronizeSuccess(result.contentLink, result.properties, result);
                        } else {
                            this._rescheduleProperties(result.properties);
                            this._onSynchronizeFailure(result.contentLink, result.properties, result.validationErrors, result);
                        }
                        if (result && result.hasContentLinkChanged && this.contentLink !== result.contentLink) {
                            this._contentLinkChanged(result.contentLink);
                        }

                        this.set("validationErrors", result.validationErrors);
                    }
                    this.set("isOnline", true);
                    this.set("lastSaved", new Date());
                    this.set("isSaving", false);
                    this.set("isSaved", true);

                    def.resolve(true);
                }),
                onError = lang.hitch(this, function (result) {

                    this.set("hasErrors", true);
                    this.set("isSaving", false);
                    this.set("isSaved", false);

                    if (result && result.error && (result.error.status === 409 || result.error.status === 404)) {
                        // Version conflict or removed, do not retry.
                        var message = result.error.status === 409 ? res.autosave.conflict : res.autosave.reloadmessage;
                        this._showErrorsDialog(message, []);

                    } else {
                        this.set("isOnline", false);

                        if (result) {
                            this.set("validationErrors", result.validationErrors);
                            this._rescheduleProperties(result.properties);
                        }

                        setTimeout(lang.hitch(this, function () {
                            this.set("isOnline", true);
                            this._save();
                        }), this._syncRetryTimeout);
                    }

                    def.reject(result);
                });

            //Make sure that we have a version that we can make changes to
            if (!this.hasPendingChanges) {
                onSuccess();
            } else {

                when(this.ensureWritableVersion()).then(lang.hitch(this, function () {
                    this.set("isSaving", true);
                    return this.syncService.save();
                })).then(onSuccess).otherwise(onError);

            }
            return def;
        },

        _rescheduleProperties: function (properties) {
            // summary:
            //      Add a range of properties to re-schedule upon next synchronization.
            //      Only properties not already scheduled for synchronization will be added,
            //      meaning that if a new property change has been recorded while syncing
            //      it won't be overwritten.
            // properties: Array
            //      An array of property names and values

            array.forEach(properties, lang.hitch(this, function (property) {
                if (!this.syncService.pendingSync(property.name)) {
                    this.syncService.scheduleForSync(property.name, property.value);
                }
            }));
        },

        undo: function () {
            !this.get("isSuspended") && this.undoManager.undo();
        },

        redo: function () {
            !this.get("isSuspended") && this.undoManager.redo();
        },

        _patchContentDataStore: function (contentLink, propertyName, oldValue, newValue) {
            // summary:
            //      Updates the named named property in the current content data store with value in newValue

            var properties = {};

            lang.setObject(propertyName, newValue, properties);

            return this.contentDataStore.patchCache({
                contentLink: contentLink,
                changedBy: this.profileHandler.userName,
                saved: (new Date()).toISOString(),
                properties: properties
            });
        },

        changeContentStatus: function (status, suppressUpdateStatus) {
            var contentLink = this.get("contentLink");
            var def = new Deferred();

            // This will notify other content that we are in changing state.
            this.set("isChangingContentStatus", true);

            var onSuccess = lang.hitch(this, function (result) {
                var success = result && result.success;
                var validator = this.validator;
                if (success) {
                    // Set lastSaved to null after publishing, ready to publish and Schedule to publish the content
                    if (status === ContentActionSupport.saveAction.Publish
                        || status === ContentActionSupport.saveAction.CheckIn
                        || status === (ContentActionSupport.saveAction.CheckIn | ContentActionSupport.saveAction.DelayedPublish | ContentActionSupport.saveAction.ForceCurrentVersion)) {
                        this.set("lastSaved", null);
                    }
                    if (validator) {
                        validator.clearGlobalErrors(validator.validationSource.server);
                    }
                    var resolveArgs = { id: result.id, oldId: contentLink };
                    topic.publish("/epi/cms/content/statuschange/", status, resolveArgs);
                    def.resolve(resolveArgs);
                } else {
                    if (result && result.validationErrors) {
                        // add to validator
                        if (validator) {
                            validator.setGlobalErrors(result.validationErrors, validator.validationSource.server);
                            validator.validate();
                        }

                        // reject with empty value, we took care of the validations errors
                        def.reject(null);
                    } else {
                        def.reject((result && result.errorMessage) ? result.errorMessage : res.publish.error);
                    }
                }

                this.set("isChangingContentStatus", false);
            });

            var onError = lang.hitch(this, function (result) {
                topic.publish("/epi/cms/action/showerror"); //TODO: Copy from PageDataController to make the system working as before. But, why we need it!!!
                def.reject((result && result.errorMessage) ? result.errorMessage : res.publish.error);

                this.set("isChangingContentStatus", false);
            });

            this.onContentChange();

            if (suppressUpdateStatus) {
                var success;

                if (this.validationErrors && this.validationErrors.length > 0) {
                    //When the severity on the validation errors is not errors but
                    //instead warnings, info and such. Set success to true.
                    success = !this.validationErrors.some(function (error) {
                        return error.severity === 3;
                    });
                } else {
                    success = true;
                }

                onSuccess({ id: this.contentLink, success: success, validationErrors: this.validationErrors });
            } else {
                // Validate, save pending change, then execute changestatus server method.
                when(this.validate())
                    .then(this.save.bind(this))
                    .then(function () {
                        return errorHandler.wrapXhr(this.contentDataStore.executeMethod("ChangeStatus", this.get("contentLink"),
                            { action: status }));
                    }.bind(this))
                    .then(onSuccess)
                    .otherwise(onError);
            }

            return def;
        },

        _lastSavedGetter: function () {
            if (this.lastSaved) {
                return this.lastSaved;
            }
            if (this.contentData) {
                return this.contentData.saved;
            }
            return null;
        },

        onContentChange: function () {
            // summary:
            //      Raised before making changes that will eventually change content
            // tags:
            //      callback
        },

        onContentLinkChange: function () {
            // summary:
            //      Raised after changing the current content link in the view model and in the sync service
            // tags:
            //      callback

            if (this.get("isSuspended")) {
                return;
            }

            // note that our view component, OPE or form must check if we're the sender?
            // or just skip when a content link changed
            var contextParameters = { uri: "epi.cms.contentdata:///" + this.get("contentLink") };
            topic.publish("/epi/shell/context/request", contextParameters, { sender: this, contextIdSyncChange: true, trigger: "internal" });
        },

        hasEditAccess: function () {
            // summary:
            //      Check if current user has access right to edit the content
            return ContentActionSupport.hasAccess(this.contentData.accessMask, ContentActionSupport.accessLevel.Edit);
        },

        hasAccess: function (action) {
            // summary:
            //      Check if current user has access on the active content using the given action.
            // remark:
            //      This method cannot be overriden by plugins. Use when we need to check core conditions only.

            // languageContext is null if the content or content provider does not have multi language support
            // in this case allow editing matter which language is active
            var canEditLanguage = !this.languageContext || !this.languageContext.isTranslationNeeded;
            return canEditLanguage && ContentActionSupport.isActionAvailable(this.contentData, action || ContentActionSupport.action.Edit, ContentActionSupport.providerCapabilities.Edit);
        },

        canTranslateContent: function () {

            if (this.viewLanguage && this.languageContext && this.viewLanguage !== this.currentContentLanguage) {
                return false;
            }

            return true;
        },

        canChangeContent: function (action) {
            // summary:
            //      Check if current user can change on the active content using
            //      the given action.
            // action: String
            //      The action to check.
            // returns: Boolean
            //      A boolean which indicates whether the current user can
            //      change the current content using the given action.
            // tags:
            //      internal

            var isPartOfProject = this.projectService.isProjectModeEnabled && this.contentData.isPartOfAnotherProject;

            return !isPartOfProject && this.canEditCurrentLanguage() && this.hasAccess(action);
        },

        canEditCurrentLanguage: function () {
            // summary:
            //      Check if the current content language can be edited in the current language context.
            // tags:
            //      public
            if (!this.languageContext) {
                return true;
            }

            return this.languageContext.language === this.currentContentLanguage;
        },

        _contentDataSetter: function (contentData) {
            this.contentData = contentData;
            if (contentData.contentLink !== undefined) {
                this.set("contentLink", contentData.contentLink);
            }
        },

        _showOverlayGetter: function () {
            var shortcut = this.getProperty("iversionable_shortcut");
            if (shortcut && shortcut.pageShortcutType) {
                // Return true if the shortcut is not "fetchdata"
                return shortcut.pageShortcutType !== 4;
            }

            return true;
        }
    });
});

},
'epi/shell/xhr/errorHandler':function(){
define("epi/shell/xhr/errorHandler", [
    "dojo/_base/declare",
    "dojo/when",
    "dojo/_base/json",
    "dgrid/List",
    "dgrid/extensions/DijitRegistry",
    "epi/shell/DialogService",
    "../widget/dialog/Alert",
    "../widget/dialog/ErrorDialog"
], function (
    declare,
    when,
    json,
    List,
    DijitRegistry,
    dialogService,
    Alert,
    ErrorDialog
) {
    var ErrorList = declare([List, DijitRegistry]),
        module;

    function parseResponseText(responseData) {
        if (typeof responseData === "string") {
            try {
                return json.fromJson(responseData);
            } catch (e) {
                console.warn("Failed to parse responseText as json", e);
            }
        }

        return {};
    }

    module = {
        // tags:
        //      internal xproduct

        forXhr: function (response) {
            // summary:
            //      Shows an alert dialog with the response message from a failed xhr result.
            //      If it's a 5xx error then the entire body is shown, otherwise the message
            //      is shown in an Alert dialog.
            //
            // tags:
            //      internal

            var data,
                settings,
                list;

            if (response.status >= 500) {
                ErrorDialog.showXmlHttpError(response, response);
            } else {
                data = parseResponseText(response.responseText);
                settings = {
                    description: data.message || response.message
                };

                // If there is additional information for the error then display it as a
                // list within the alert dialog.
                if (data.additionalInformation instanceof Array) {
                    list = new ErrorList({ className: "epi-grid-max-height--300" });
                    list.renderArray(data.additionalInformation);
                    list.startup();

                    settings.content = list;
                }

                return dialogService.alert(settings);
            }
        },
        wrapXhr: function (promise) {
            // summary:
            //      Shows an alert dialog with the response message from a failed xhr result.
            //      If it's a 5xx error then the entire body is shown, otherwise the message
            //      is shown in an Alert dialog.
            // returns:
            //      A promise
            //
            // tags:
            //      internal

            promise = when(promise);
            promise.otherwise(module.forXhr);

            return promise;
        }
    };

    return module;
});

},
'epi/shell/widget/dialog/ErrorDialog':function(){
﻿define("epi/shell/widget/dialog/ErrorDialog", [
    "dojo",
    "dijit/Dialog"
], function (
    dojo,
    Dialog
) {

    var dialog = null;
    var resourceRootPath = "/shell/cms/errordialog/";

    // Fallback resources, since resource fetching may fail as well
    var resources = {
        title: "A background request has failed",
        reloadtext: "Reload",
        heading: "An unhandled error has occured in a background request.",
        description: "The page may not function properly unless it's reloaded. Press the button below to reload the page now."
    };

    // The banner shown above the original error message
    var errorBanner = "\
        <div style=\"padding-bottom:10px; width:600px\"> \
            <h1>${heading}</h1> \
            <div style=\"background-color:#FFF; border:1px solid #000; padding:3px\">${errorMessage}</div> \
            <p>${description}</p> \
            <input type=\"button\" onclick=\"document.location.reload()\" value=\"${reloadtext}\" /> \
        </div> \
    ";

    function getDialog() {
        if (!dialog) {
            dialog = new Dialog();
        }
        return dialog;
    }

    function constructContent(message, responseText) {
        var rootElement = dojo.create("div", {
            innerHTML: dojo.string.substitute(errorBanner, dojo.mixin({ errorMessage: message }, resources))
        });
        // Need to set a lot of iframe properties since IE7 ignores the style attributes
        var iFrame = dojo.create("iframe", {
            style: "width:100%; height:400px; border:inset 1px #CCC",
            frameborder: "0",
            width: "600",
            height: "400",
            src: "about:blank"
        });

        if (iFrame.attachEvent) {
            // Can't use connect when listening to the load event of iframes
            // http://bugs.dojotoolkit.org/ticket/9609
            var contentSetter = function () {
                iFrame.detachEvent("onload", contentSetter);
                iFrame.contentWindow.document.write(responseText);
            };
            iFrame.attachEvent("onload", contentSetter);
        } else {
            var listener = dojo.connect(iFrame, "load", null, function () {
                dojo.disconnect(listener);
                iFrame.contentWindow.document.write(responseText);
            });
        }

        dojo.place(iFrame, rootElement);
        return rootElement;
    }

    var pub = {
        // summary:
        //      A singleton implementation of an error message dialog where require handles
        //      the singleton behavior by only loading this file once.
        // tags:
        //      internal

        getTextResourceKeys: function () {
            // summary:
            //      Returns an array with cms xml file language keys for localization

            var resKeys = [];
            for (var p in resources) {
                resKeys.push(resourceRootPath + p);
            }
            return resKeys;
        },

        setTextResources: function (keys) {
            // summary:
            //      Update localized resources
            // keys:
            //      An array of objects containing the resource key
            //      and localized resource text in the format: {key: "k", text:"t" }

            if (!dojo.isArray(keys)) {
                return;
            }

            dojo.forEach(keys, function (item) {
                if (dojo.isString(item.key) && dojo.isString(item.text)) {
                    resources[item.key.replace(resourceRootPath, "")] = item.text;
                }
            });
        },

        showXmlHttpError: function (response, ioArgs) {
            // summary:
            //      Opens a dijit dialog and populates it with the message and responseText
            //      (containing the server response) from the xml http request
            // message:
            //      The message returned as parameter to an dojo.xhr error callback
            // ioArgs:
            //      The ioArgs parameter for the dojo.xhr error callback

            var dialog = getDialog();

            var responseText = "";
            var message = "";
            if (ioArgs && ioArgs.xhr) {
                responseText = ioArgs.xhr.responseText;
            }

            if (dojo.isObject(response) && dojo.isString(response.message)) {
                // If response is an error object
                message = response.message;
            } else {
                message = response;
            }

            var content = constructContent(message, responseText);

            dialog.set("title", resources.title);
            dialog.set("content", content);
            dialog.show();
        }
    };

    return pub;
});

},
'epi-cms/contentediting/ContentEditingValidator':function(){
﻿define([
    "dojo",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/store/Memory",

    "dojo/Stateful",

    "epi/dependency"
],
function (
    dojo,
    array,
    declare,
    Deferred,
    lang,
    connect,
    Memory,

    Stateful,

    dependency
) {

    return declare([Stateful], {
        // tags:
        //      internal

        // contextTypeName: String
        //      Name of context type used to partitioning messages in message service
        contextTypeName: "",

        // contextId: Object
        //      Id of context used to partitioning messages in message service
        contextId: null,

        messageService: null,
        _isBlocking: false,

        // isValid: Boolean
        //      Indicates if this validator is valid without any validation errors (no error or warn messages)
        isValid: true,

        // hasErrors: Boolean
        //      Indicates if there are any errors (only errors, warn not included)
        hasErrors: false,

        _storeId: 0,
        _store: null,

        // NOTE: this maps to server side enum
        severity: {
            none: 0,
            info: 1,
            warn: 2,
            error: 3
        },

        validationSource: {
            server: 1,
            client: 2
        },

        validationType: {
            unspecified: 0,
            attributeMatched: 1,
            storageValidation: 2,
            propertyValidation: 3
        },

        // hash map for levels
        _errorLevels: {},

        constructor: function (params) {
            declare.safeMixin(this, params);
        },

        postscript: function () {
            this.inherited(arguments);

            // map error types to hash map for levels
            for (var p in this.severity) {
                var enumValue = this.severity[p];
                this._errorLevels[enumValue] = p;
            }

            this.messageService = this.messageService || dependency.resolve("epi.shell.MessageService");

            // create new store
            this._store = new Memory({
                idAttribute: "id",
                data: []
            });
        },

        setContextId: function (contextId) {

            var oldContextId = this.contextId;
            this.contextId = contextId;

            // update new context to items in messageservice
            var items = this.messageService.query({ contextTypeName: this.contextTypeName, contextId: oldContextId });
            items.forEach(lang.hitch(this, function (item) {
                item.contextId = this.contextId;
                this.messageService.put(item);
            }));
        },

        clearPropertyErrors: function (propertyName, source) {

            // must have a property name
            if (!propertyName) {
                return;
            }

            // removes all error for a specific property
            this._clearErrors(propertyName, source);
        },

        setPropertyErrors: function (propertyName, errorMessages, source) {

            // must have a property name
            if (!propertyName) {
                return;
            }

            // sets property errors for a specific property
            this._setErrors(errorMessages, propertyName, source);
        },

        clearGlobalErrors: function (source) {
            // removes all global errors
            this._clearErrors(null, source);
        },

        clearErrorsBySource: function (source) {
            // removes all errors for a source type
            this._clearErrors(undefined, source);
        },

        setGlobalErrors: function (errorMessages, source) {
            // sets property errors for a specific property
            this._setErrors(errorMessages, null, source);
        },

        _clearErrors: function (propertyName, source) {
            var query;

            if (propertyName) {
                query = { propertyName: propertyName };
            } else if (propertyName === null) {
                query = { global: true };
            } else {
                query = {};
            }

            // if source is given then use it
            if (source) {
                query.source = source;
            }

            var items = this._store.query(query);
            items.forEach(lang.hitch(this, function (item) {
                this.messageService.remove({ id: item.messageId });
                this._store.remove(item.id);
            }));

            this._updateFlags();
        },

        _setErrors: function (errorMessages, propertyName, source) {
            this._clearErrors(propertyName, source);
            array.forEach(errorMessages, function (item) {
                this._putStoreItem(item, propertyName, source);
            }, this);

            this._updateFlags();
        },

        _putStoreItem: function (item, propertyName, source) {
            // puts an item in validation store

            var severityName = "";

            // get type name
            if (this._errorLevels[item.severity]) {
                severityName = this._errorLevels[item.severity];
            }

            var messageId = this.messageService.put(severityName, item.errorMessage, this.contextTypeName, this.contextId, item.externalItemId, item.externalItemData);

            var storeItem = {
                id: this._storeId++,
                item: item,
                severity: item.severity,
                messageId: messageId
            };

            // property or global?
            if (propertyName) {
                storeItem.propertyName = propertyName;
            } else {
                storeItem.global = true;
            }

            if (source !== undefined) {
                storeItem.source = source;
            }

            return this._store.put(storeItem);
        },

        _updateFlags: function () {
            // update isValid property
            var errorItems = this._store.query({ severity: this.severity.error });
            var warnItems = this._store.query({ severity: this.severity.warn });
            var isValid = errorItems.length === 0 && warnItems.length === 0;
            var hasErrors = errorItems.length > 0;
            this.set("isValid", isValid);
            this.set("hasErrors", hasErrors);
        },

        validate: function () {
            // summary:
            //      Queries message service by error type and warning type to indicates content is valid or not
            // tags:
            //      public

            var error = this.severity.error,
                deferred = new Deferred();

            Deferred.when(
                this._validate(error),
                function (hasServerSideErrors) {
                    if (hasServerSideErrors) {
                        // defaults behaviour: show notification tooltipdialog when has any error(s)
                        connect.publish("/epi/cms/action/showerror");
                    }
                    deferred.resolve(hasServerSideErrors);
                },
                function () {
                    // defaults behaviour: show notification tooltipdialog when has any error(s)
                    connect.publish("/epi/cms/action/showerror");
                    deferred.reject();
                }
            );

            return deferred;
        },

        _validate: function (severity) {
            // summary:
            //      Queries message service by error type to indicates content is valid or not
            // severity: Enum
            //      Type of error
            // tags:
            //      Private

            var deferred = new Deferred();

            if (!this._isBlocking) {
                Deferred.when(this._store.query({ severity: severity }), lang.hitch(this, function (errorMessages) {

                    var clientSideErrors = array.filter(errorMessages, function (item) {
                        return item.source === this.validationSource.client;
                    }, this);

                    var hasClientSideErrors = clientSideErrors.length > 0;
                    var hasServerSideErrors = errorMessages.length > clientSideErrors.length;

                    if (hasClientSideErrors) {
                        deferred.reject();
                    } else {
                        deferred.resolve(hasServerSideErrors);
                    }
                }));
            }

            return deferred;
        },

        query: function (queryContext) {
            // summary:
            //      Expose method for other internal product can be
            //      queries all messages that we had for the current content.
            // queryContext: Object
            //      Parameters of query
            // tags:
            //      internal
            return this._store.query(queryContext);
        }
    });
});

},
'epi-cms/contentediting/ContentModelServerSync':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/when",
    "dojo/_base/json",
    "dojo/Stateful",

    "epi/epi",
    "epi/assign",
    "epi/datetime",
    "epi/string",
    "epi/shell/postMessage",

    "./ContentActionSupport"
],

function (
    array,
    declare,
    Deferred,
    when,
    json,
    Stateful,

    epi,
    assign,
    epiDateTime,
    epiString,
    postMessage,

    ContentActionSupport) {

    return declare([Stateful], {
        // tags:
        //    internal

        // _queue: [private] Array
        //      The queue of updates to send
        _queue: null,

        // _isSynchronizing: [private] Boolean
        //      Set to true while we're synchronizing
        _isSynchronizing: false,

        // hasPendingChanges: Boolean
        hasPendingChanges: false,

        // contentLink: String
        //      Reference to the content this sync service instance is saving changes to
        contentLink: null,

        // _oldContentLink: [private] String
        //      Old reference to the content this sync service instance is saving changes to
        _oldContentLink: null,

        // contentDataStore: RestStore
        //      Reference to the content data store
        contentDataStore: null,

        // processInterval: Number
        //      How often (in milliseconds) should we check the queue to see if there's any items to be synced
        processInterval: 200,

        // _processIntervalId: [private] Number
        //      Id of the interval to check queue, will only be set when save() has been called
        _processIntervalId: 0,

        _saveDeferred: null,

        _postMessage: null,

        // isInQuickEditMode: [public] Boolean
        //      True when saving content in Quick Edit mode
        isInQuickEditMode: false,

        constructor: function (params) {
            // summary:
            //      init array
            // tags:
            //      private

            declare.safeMixin(this, params);

            // init queue
            this._queue = [];

            this._postMessage = this._postMessage || postMessage;
        },

        _contentLinkSetter: function (newContentLink) {
            // summary:
            //      Sets the content link property and saves the previous value to be used when saving
            // newContentLink:
            //      The value of the new content link
            // tags:
            //      public

            this._oldContentLink = this.contentLink;
            this.contentLink = newContentLink;
        },

        scheduleForSync: function (/*String*/propertyName, /*String|Object*/value) {
            // summary:
            //      Put property update in queue
            // propertyName:
            //      Name of the property
            // value:
            //      The value of the property
            // tags:
            //      public

            if (value === undefined) {
                return;
            }

            this.set("hasPendingChanges", true);
            value = epiDateTime.transformDate(value);

            var index = this._propertyIndexInQueue(propertyName);

            if (index < 0) {
                // add item to queue
                this._queue.push({
                    name: propertyName,
                    value: value
                });
            } else {
                // update item value
                this._queue[index].value = value;
            }
        },

        saveProperty: function (propertyName, value, saveAction) {
            // summary:
            //      Save a property value to the current version with a given saveAction
            // propertyName: String
            //      The property name.
            // value: Object
            //      The updated value.
            // saveAction: SaveAction
            //      The action to trigger.

            this.scheduleForSync(propertyName, value);
            return this._startSynchronizeInterval({ delay: 0,  action: saveAction });
        },

        _propertyIndexInQueue: function (/*String*/propertyName) {

            var index = -1;

            // find item in queue
            array.some(this._queue, function (item, i) {
                if (item.name === propertyName) {
                    index = i;
                    return true;
                }
            });

            return index;
        },

        save: function () {
            // summary:
            //      Save updates to server
            // tags:
            //      public

            return this._startSynchronizeInterval();
        },

        _startSynchronizeInterval: function (settings) {

            var delay;

            if (!this._saveDeferred) {
                this._saveDeferred = new Deferred();
                delay = settings && settings.delay || this.processInterval;
                setTimeout(this._synchronizeItem.bind(this, settings), delay);
            }

            return this._saveDeferred.promise;
        },

        _synchronizeItem: function (settings) {
            // summary:
            //      Save updates to server
            // tags:
            //      private

            var items = this._queue,
                syncContentLink = this.contentLink,
                saveDeferred = this._saveDeferred;

            // Reset the queue and promise
            this._queue = [];
            this._saveDeferred = null;

            // Set hasPendingChanges to false since we have emptied the queue.
            this.set("hasPendingChanges", false);

            // Success callback
            var onSuccess = function (result) {

                var defResult = {},
                    savedLink;

                if (result) {
                    //Convert the property names to camel case
                    array.forEach(result.properties, function (property) {
                        property.name = epiString.pascalToCamel(property.name);
                    }, this);

                    savedLink = result.savedContentLink;

                    //Create def result object
                    defResult = assign({
                        successful: false,
                        contentLink: result.savedContentLink,
                        hasContentLinkChanged: this._hasContentLinkChanged(result)
                    }, result);

                    if (savedLink && savedLink !== this.contentLink) {
                        // If the server saved to another version than we anticipated
                        this.set("contentLink", savedLink);
                    }

                    defResult.oldContentLink = this._oldContentLink;
                    this._oldContentLink = null;

                    this._publishContentSavedMessage(defResult);

                    saveDeferred.resolve(defResult);
                } else {
                    saveDeferred.reject({
                        contentLink: syncContentLink,
                        properties: items,
                        error: "Unexpected result returned from the server."
                    });
                }
            }.bind(this);

            // Failure callback
            var onError = function (error) {

                var defResult = {
                    contentLink: syncContentLink,
                    properties: items,
                    error: error
                };

                saveDeferred.reject(defResult);
            }.bind(this);

            if (items.length === 0) {
                saveDeferred.resolve();
                return;
            }

            when(this._saveProperties(items, settings))
                .then(onSuccess)
                .otherwise(onError);
        },

        _hasContentLinkChanged: function (result) {
            // additional check to see if someone updated contentlink on the sync service before saving pending changes.
            var hasChanged = this._oldContentLink && this._oldContentLink !== this.contentLink;
            return result.savedContentLink && result.savedContentLink !== this.contentLink || hasChanged;
        },

        _publishContentSavedMessage: function (result) {
            var contentSavedData = {
                contentLink: result.contentLink,
                properties: result.properties
            };

            if (result.editUrl) {
                contentSavedData.editUrl = result.editUrl;
            }

            if (result.previewUrl) {
                var url = new URL(result.previewUrl, epi.getOrigin());
                url.searchParams.set("epieditmode", true);
                contentSavedData.previewUrl = url.toString();
            }

            if (!this.isInQuickEditMode) {
                // Publish one global event for this contentLink
                this._postMessage.publish("contentSaved", contentSavedData);
            }
        },

        pendingSync: function (propertyName) {
            // summary:
            //      Check if there is any pending synchronization for the property with propertyName
            //
            // propertyName: String
            //      The name of the property to check for
            //
            // returns:
            //      True if there are pending synchronizations, otherwise False
            // tags:
            //      public
            return this._propertyIndexInQueue(propertyName) !== -1;
        },

        _saveProperties: function (items, settings) {
            // summary:
            //    Validate property value with server.
            //
            // propertyName: String
            //    The updated property name.
            //
            // propertyValue: String
            //    The property value.
            //
            // timestamp: String
            //    The client timestamp.
            //
            // returns:
            //	  A deferred
            //
            // tags:
            //    public

            var contentLink = this.contentLink,
                properties = {};

            array.forEach(items, function (item) {
                properties[item.name] = json.toJson(item.value);
            });

            var patchData = {
                id: contentLink,
                properties: properties,
                action: settings ? settings.action : ContentActionSupport.saveAction.Save | ContentActionSupport.saveAction.SkipValidation
            };

            return this.contentDataStore.patch(patchData, { id: patchData.id });
        }
    });
});

},
'epi-cms/contentediting/Operation':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",
    "dojo/Stateful"
], function (array, declare, lang, Evented, Stateful) {

    return declare([Stateful, Evented], {
        // summary:
        //      This class represents a single operation. The default state commits save directly; otherwise it can run in a
        //      transaction-like state allowing for multiple data saves which will then be committed as a single operation.
        //
        // tags:
        //      internal

        // inProgress: [public] Boolean
        //      Flag indicating if there is an operation in progress.
        inProgress: false,

        // changes: [public] Array
        //      Array of changes associated with the current operation.
        changes: null,

        constructor: function () {
            this.changes = [];
        },

        begin: function () {
            // summary:
            //      Begins a new operation. If there is an operation already is progress this does nothing.
            // tags:
            //      public

            this.set("inProgress", true);
        },

        save: function (/* Object */ data) {
            // summary:
            //      Saves the data to the current active operation otherwise raises a commit event with the data.
            // tags:
            //      public

            if (this.inProgress) {
                // Remove any existing change for the property, but copy the oldValue property to the new data
                this.changes = array.filter(this.changes, function (change) {
                    if (change.propertyName === data.propertyName) {
                        data.oldValue = change.oldValue;
                        return false;
                    }
                    return true;
                });

                this.changes.push(data);

                return;
            }

            // Normalize the data to an array.
            if (!lang.isArray(data)) {
                data = [data];
            }

            this.emit("commit", data);
        },

        end: function () {
            // summary:
            //      Ends the current operation and raises a commit event with the accumulated data.
            // tags:
            //      public
            this.set("inProgress", false);

            if (this.changes.length > 0) {
                this.save(this.changes);
            }

            this.changes = [];
        },

        abort: function () {
            // summary:
            //      Aborts the current operation resetting the accumulated changes.
            // tags:
            //      public

            this.set("inProgress", false);
            this.changes = [];
        }
    });
});

},
'epi-cms/contentediting/ModelPopulation':function(){
define([
    // dojo
    "dojo/_base/declare",
    // epi
    "epi/shell/conversion/ObjectConverterRegistry"
], function (
    // dojo
    declare,
    // epi
    ObjectConverterRegistry
) {

    return {
        // tags:
        //      internal xproduct

        populateContentModel: function (data, metadata) {
            var props = {},
                converterType,
                converter;

            for (var propertyName in data) {
                var propertyMetadata = metadata.getPropertyMetadata(propertyName);
                var propertyValue = data[propertyName];

                // default
                props[propertyName] = propertyValue;
                if (!propertyMetadata) {
                    continue;
                }

                if (propertyMetadata.hasSubProperties()) {
                    props[propertyName] = this.populateContentModel(propertyValue, propertyMetadata);
                } else {


                    // check for converter
                    converterType = propertyMetadata.customEditorSettings.converter;
                    if (converterType) {
                        converter = ObjectConverterRegistry.getConverter(converterType, "runtimeType");
                        if (converter) {
                            // bind converted value instead
                            props[propertyName] = converter.convert(converterType, "runtimeType", propertyValue);
                        }
                    }
                }
            }
            return props;
        }
    };
});

},
'epi-cms/contentediting/viewmodel/CreateContentViewModel':function(){
define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/json",

    "dojo/Stateful",
    "dojo/string",
    "dojo/when",
    "dojo/Evented",

    // epi
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentEditingValidator",

    // resources
    "epi/i18n!epi/shell/ui/nls/episerver.shared.messages",
    "epi/i18n!epi/cms/nls/episerver.cms.components.requiredproperties"
], function (
    // dojo
    array,
    declare,
    lang,
    json,

    Stateful,
    string,
    when,
    Evented,

    // epi
    dependency,
    TypeDescriptorManager,
    ContentReference,
    ContentEditingValidator,

    // resources
    sharedMessages,
    reqPropsResources
) {

    return declare([Stateful, Evented], {
        // summary:
        //      View model of epi-cms/contentediting/CreateContent component.
        // tags:
        //      internal

        // =======================================================================
        // Private stuffs
        // =======================================================================

        // _topLevelContainerType: String
        //      The default top level container type used in properties form.
        _topLevelContainerType: "epi/shell/layout/SimpleContainer",

        // _groupContainerType: String
        //      The default group container type used in properties form.
        _groupContainerType: "epi-cms/layout/CreateContentGroupContainer",

        // =======================================================================
        // Dependencies
        // =======================================================================

        // contentDataStore: epi/shell/RestStore
        //      The content data store instance.
        contentDataStore: null,

        // metadataManager: epi/shell/MetadataManager
        //      The metadata manager instance.
        metadataManager: null,

        // typeIdentifierManager: epi/shell/TypeIdentifierManager
        //      The type identifier manager instance.
        typeIdentifierManager: null,

        // validator: epi-cms/contentediting/ContentEditingValidator
        //      The content editing validator instance.
        validator: null,

        // =======================================================================
        // Data model properties
        // =======================================================================

        // parent: Content
        //      The parent content on which the new content is created.
        parent: null,

        // contentTypeId: Number
        //      The content type id of which the new content is created.
        contentTypeId: null,

        // requestedType: String
        //      The type indentifier of created content. This is used for filtering available content types.
        requestedType: null,

        // createAsLocalAsset: Boolean
        //      Indicates that the content is created as local asset which means it will be attached to the parent content's asset folder.
        createAsLocalAsset: null,

        // autoPublish: Boolean
        //       Indicates if the content should be published automatically when created if the user has publish rights.
        autoPublish: false,

        // autoGenerateName: Boolean
        //      Indicates if the content name should be generated automatically or not
        autoGenerateName: false,

        // addToDestination: Delegate
        //      A delagate object which contains a save method. The method will be executed after the content is successfully created.
        addToDestination: null,

        // =======================================================================
        // View model properties
        // =======================================================================

        // wizardStep: Number
        //      Keeps track the current step of the creation wizard. 0 means selecting content type while 1 means collecting properties value.
        wizardStep: 0,

        // startWizardStep: [protected] Number
        //      Which step to start with
        startWizardStep: 0,

        // contentName: String
        //      Name of the content being created. This is initialized from the resource bundle and bound to the name text box in the widget.
        contentName: null,

        // ignoreDefaultNameWarning: Boolean
        //      Indicates that name checking should be ignored.
        ignoreDefaultNameWarning: null,

        // properties: Collection
        //      The properties collection used to create new content.
        properties: null,

        // headingText: String
        //      Heading text which is displayed on the top of the toolbar. This is set according to the current request type.
        headingText: null,

        // contentNameHelpText: String
        //      Help text for the content name input
        contentNameHelpText: "",

        // createAsLocalAssetHelpText: Boolean
        //      Helper text that displayed in the sub header
        createAsLocalAssetHelpText: null,

        // namePanelIsVisible: Boolean
        //      Indicate that the name panel is visible. If the content is created as local asset, name panel should not be visible
        namePanelIsVisible: null,

        // headingPanelIsVisible: Boolean
        //      Indicates that the heading panel is visible. Similar to the name panel, heading panel is not visible when the content is created as local asset.
        //      In that case, a more detail heading is displayed inside the content type selection list or properties form.
        headingPanelIsVisible: null,

        // subHeadingPanelIsVisible: Boolean
        //      Indicates that the sub heading panel is visible. Similar to the name panel, heading panel is not visible when the content is created as local asset.
        subHeadingPanelIsVisible: null,

        // seamlessTopPanel: Boolean
        //      Indicates that the top panel should show seamlessly.
        seamlessTopPanel: null,

        // saveButtonIsVisible: Boolean
        //      Indicate that the save button should be visible, normally in the last step.
        saveButtonIsVisible: null,

        // saveButtonDisabled: Boolean
        //      Indicate that the save button should be disabled, when saving is on going.
        saveButtonDisabled: null,

        // showAllProperties: Boolean
        //      Indicates that it should show all properties for user to enter initial value, normally when content is created from content area.
        showAllProperties: null,

        // showCurrentNodeOnBreadcrumb: Boolean
        //      Indicates that the breadcrumb should show current content node.
        showCurrentNodeOnBreadcrumb: null,

        // actualParentLink: String
        //      Link of the parent beneath which the content is created. It could be the given parent or the given parent's local asset folder.
        actualParentLink: null,

        // metadata: Object
        //      The metadata object of the content being created.
        metadata: null,

        // =======================================================================
        // Public methods
        // =======================================================================

        postscript: function () {
            // summary:
            //      Initializes internal objects and state after constructed.
            // description:
            //      Obtains content data store and metadata manager instances from dependency manager.
            // tags:
            //      protected

            this.inherited(arguments);

            if (!this.contentDataStore) {
                var registry = dependency.resolve("epi.storeregistry");
                this.contentDataStore = registry.get("epi.cms.contentdata");
            }

            this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");
            this.projectService = this.projectService || dependency.resolve("epi.cms.ProjectService");

            // Could the dependency handle non-singleton objects?
            this.validator = this.validator || new ContentEditingValidator({ contextTypeName: "epi.cms.contentdata" });

            this.set("propertyFilter", lang.hitch(this, this._propertyFilter));
        },

        update: function (settings) {
            // summary:
            //      Update the component with new settings.
            // description:
            //      Taking settings from the ones who request the Create content component.
            //      The supported settings are: allowedTypes, restrictedTypes, createAsLocalAsset, addToDestination, contentTypeId. They will be mixed to the current instance.
            // settings: Object
            //      The settings object.
            // tags:
            //      protected

            // Reset view properties

            this.set("ignoreDefaultNameWarning", false);
            this.set("properties", null);
            this.set("saveButtonIsVisible", false);
            this.set("wizardStep", this.startWizardStep);
            this.set("isContentTypeSelected", false);

            if (settings) {
                if (typeof settings.namePanelIsVisible !== "undefined") {
                    this.set("namePanelIsVisible", settings.namePanelIsVisible);
                } else {
                    this.set("namePanelIsVisible", true);
                }
                if (typeof settings.headingPanelIsVisible !== "undefined") {
                    this.set("headingPanelIsVisible", settings.headingPanelIsVisible);
                } else {
                    this.set("headingPanelIsVisible", true);
                }
                if (typeof settings.subHeadingPanelIsVisible !== "undefined") {
                    this.set("subHeadingPanelIsVisible", settings.subHeadingPanelIsVisible);
                } else {
                    this.set("subHeadingPanelIsVisible", false);
                }
                if (typeof settings.showCurrentNodeOnBreadcrumb !== "undefined") {
                    this.set("showCurrentNodeOnBreadcrumb", settings.showCurrentNodeOnBreadcrumb);
                } else {
                    this.set("showCurrentNodeOnBreadcrumb", true);
                }
            } else {
                this.set("namePanelIsVisible", true);
                this.set("headingPanelIsVisible", true);
                this.set("showCurrentNodeOnBreadcrumb", true);
            }

            this.set("seamlessTopPanel", true);

            // Copy data properties from topic sender
            if (settings) {
                array.forEach(["allowedTypes", "restrictedTypes", "requestedType", "parent", "createAsLocalAsset", "autoPublish", "addToDestination", "contentTypeId"], function (property) {
                    this.set(property, settings[property]);
                }, this);
            }

            // Setup the validator
            if (this.parent) {
                var notificationContextId = this.parent.contentLink + "_new_content"; // A pseudo context id for the content that not yet created.
                this.validator.clearErrorsBySource();
                this.validator.setContextId(notificationContextId);

                this.set("notificationContext", { contextTypeName: "epi.cms.contentdata", contextId: notificationContextId });
            }
        },

        save: function () {
            // summary:
            //      Save the content and finish the wizard.
            // description:
            //      save() will validate the content name if ignoreDefaultNameWarning is not set. By then "invalidContentName" might be emitted.
            //      If data validation is fine, the new content object will be put on the content data store.
            //      On success, "saveSuccess" event is emitted, otherwise "saveError" is emitted.
            // tags:
            //      public

            this.set("saveButtonDisabled", true);

            // Validate content name
            if (!this.ignoreDefaultNameWarning && (!this.contentName || this.contentName === "" || this.contentName === this.defaultName)) {

                var contentName = this.contentName;
                if (this.metadata && this.metadata.additionalValues && this.metadata.additionalValues.modelTypeIdentifier) {
                    contentName = TypeDescriptorManager.getResourceValue(this.metadata.additionalValues.modelTypeIdentifier, "newitemdefaultname");
                }

                this._emitSaveEvent("invalidContentName", contentName);
                return;
            }

            // Ask the validator to do properties validation and/or other global validation
            this.validator.clearErrorsBySource(this.validator.validationSource.server);
            when(this.validator.validate(), lang.hitch(this, function (hasErrors) {
                if (hasErrors) {
                    this._emitSaveEvent("validationError");
                    return;
                }

                // Build the content object
                var content = this.buildContentObject();

                // Determine whether there is a project active
                this.projectService.getCurrentProjectId().then(function (isProjectActive) {
                    // If a project is active then the content should not be auto-published
                    content.autoPublish = content.autoPublish && !isProjectActive;

                    // Put the new content into content data store
                    this.contentDataStore.put(content).then(lang.hitch(this, this._saveSuccessHandler), lang.hitch(this, this._saveErrorHandler));
                }.bind(this));
            }), lang.hitch(this, function () {
                this._emitSaveEvent("validationError");
            }));
        },

        saveLocalBlock: function (localBlock) {
            // summary:
            //      Save the local content and finish the wizard.
            // description:
            //      save() will validate the content name if ignoreDefaultNameWarning is not set. By then "invalidContentName" might be emitted.
            //      If data validation is fine, the new content object will be put on the content data store.
            //      On success, "saveSuccess" event is emitted, otherwise "saveError" is emitted.
            // tags:
            //      public

            this.set("saveButtonDisabled", true);


            // Ask the validator to do properties validation and/or other global validation
            this.validator.clearErrorsBySource(this.validator.validationSource.server);
            when(this.validator.validate(), lang.hitch(this, function (hasErrors) {
                if (hasErrors) {
                    this._emitSaveEvent("validationError");
                    return;
                }

                this.addToDestination.save(localBlock);
                this.set("saveButtonDisabled", false);
            }), lang.hitch(this, function () {
                this._emitSaveEvent("validationError");
            }));
        },

        _emitSaveEvent: function (eventName, params) {
            this.set("saveButtonDisabled", false);
            this.emit(eventName, params);
        },

        cancel: function () {
            // summary:
            //      Cancel operation and finish the wizard
            // tags:
            //      Public

            this.addToDestination && (typeof this.addToDestination.cancel === "function") && this.addToDestination.cancel();
        },

        _propertyFilter: function (ownerMetadata, propertyMetadata) {
            // summary:
            //      Filter out meta properties which are not supposed to have value on creation.
            // tags:
            //      private

            var isNotInSpecialGroup = propertyMetadata.originalGroupName !== "EPiServerCMS_SettingsPanel" && propertyMetadata.originalGroupName !== "Advanced";
            var required = this._isRequiredProperty(ownerMetadata, propertyMetadata);

            if (this.showAllProperties) {
                // show properties which do not belong to a special groups at all OR belong to special groups but required
                return isNotInSpecialGroup || required;
            } else {
                // only show properties from "required" group
                return required;
            }
        },

        _saveSuccessHandler: function (contentLink) {
            // summary:
            //      Save success handler
            // contentLink: String
            //      The newly created content's link
            // tags:
            //      private

            var ref = new ContentReference(contentLink),
                versionAgnosticRef = ref.createVersionUnspecificReference(),
                changeToNewContext = lang.hitch(this, function (/*String*/targetLink) {
                    this._emitSaveEvent("saveSuccess", {
                        newContentLink: targetLink,
                        changeContext: true
                    });
                });

            when(this.contentDataStore.refresh(contentLink), lang.hitch(this, function (newContent) {
                if (this.addToDestination) {
                    this.addToDestination.save({
                        contentLink: versionAgnosticRef.toString(),
                        name: newContent.name,
                        typeIdentifier: newContent.typeIdentifier
                    });

                    // Keep the current context
                    this._emitSaveEvent("saveSuccess", {
                        changeContext: false,
                        contentLink: contentLink
                    });

                } else {
                    // Change to new context
                    changeToNewContext(versionAgnosticRef.toString());
                }
            }));
        },

        _saveErrorHandler: function (err) {
            // summary:
            //      Save error handler
            // err: Object
            //      The error object.
            // tags:
            //      private

            // err is actually the xhr error, as for now the rest store doesn't pre handle errors.
            if (err && err.responseText) {
                // received a list of problems

                // NOTE: Do not copy this code since it's not a good practice to handle error. We are finding a pattern to handle server errors in a nicer manner, perhaps inside the rest store.
                var validationErrors = json.fromJson(err.responseText);

                array.forEach(validationErrors, function (item) {
                    if (item.propertyName) {
                        this.validator.setPropertyErrors(item.propertyName, [{
                            severity: item.severity,
                            errorMessage: item.errorMessage
                        }], this.validator.validationSource.server);
                    } else {
                        this.validator.setGlobalErrors([{
                            severity: item.severity,
                            errorMessage: item.errorMessage
                        }], this.validator.validationSource.server);
                    }
                }, this);

            } else if (err) {
                // general error
                this.validator.setGlobalErrors([{
                    severity: this.validator.severity.error,
                    errorMessage: err.message
                }], this.validator.validationSource.server);
            }

            this._emitSaveEvent("saveError", err);
        },

        buildContentObject: function () {
            // summary:
            //      Build up the content object to create from model properties.
            // tags:
            //      protected

            return {
                name: this.autoGenerateName ? null : string.trim(this.contentName + ""),
                parentLink: this._getParentLink(),
                contentTypeId: this.contentTypeId,
                properties: this._mapProperties(this.properties),
                createAsLocalAsset: this.createAsLocalAsset,
                autoPublish: this.autoPublish
            };
        },

        _mapProperties: function (/*Object*/propertyObject) {
            // summary:
            //      Try to update content guid from metadata additional to the property block.
            // tags:
            //      private

            for (var key in propertyObject) {
                // eslint-disable-next-line no-prototype-builtins
                if (propertyObject.hasOwnProperty(key)) {
                    var propertyMetadata = this.metadata && this.metadata.getPropertyMetadata(key);
                    var additionalValues = propertyMetadata && propertyMetadata.additionalValues;
                    var contentTypeGuidKeyName = additionalValues && additionalValues["contentTypeGuidKeyName"];
                    var contentGuid = additionalValues && contentTypeGuidKeyName && additionalValues[contentTypeGuidKeyName];

                    if (contentGuid) {
                        propertyObject[key][contentTypeGuidKeyName] = contentGuid;
                    }
                }
            }

            return propertyObject;
        },

        addInvalidProperty: function (propertyName, errorMessage) {
            // summary:
            //      State that a property has become invalid after client validation.
            // propertyName: String
            //      The property name.
            // errorMessage: String
            //      The error message.
            // tags:
            //		public

            this.validator.setPropertyErrors(propertyName, [{
                severity: this.validator.severity.error,
                errorMessage: errorMessage
            }], this.validator.validationSource.client);
        },

        removeInvalidProperty: function (propertyName) {
            // summary:
            //      State that a property is no more invalid after client validation.
            // propertyName: String
            //      The property name.
            // tags:
            //		public

            this.validator.clearPropertyErrors(propertyName);
        },

        // =======================================================================
        // Property setters
        // =======================================================================

        _contentTypeIdSetter: function (contentTypeId) {
            // summary:
            //      Set content type id.
            // description:
            //      After the value is set, metadata is also updated. If it is neccessary to enter properties, the wizard is stepped forward, otherwise save is executed.
            // contentTypeId: Number
            //      The value.
            // tags:
            //		private

            this.contentTypeId = contentTypeId;

            if (contentTypeId && this.parent) {
                this.set("isContentTypeSelected", true);
                this.validator.clearErrorsBySource(this.validator.validationSource.server);

                when(this._getMetadata(this.parent.contentLink, contentTypeId), lang.hitch(this, function (metadata) {
                    metadata = this._regroupProperties(metadata);
                    this.set("metadata", metadata);
                    if (this.autoPublish || this._hasRequiredProperties(metadata)) {
                        this.set("wizardStep", 1);
                        this.set("saveButtonIsVisible", true);
                    } else {
                        this.save();
                    }
                }), lang.hitch(this, function () {
                    this.set("isContentTypeSelected", false);

                    this.validator.setGlobalErrors([{
                        severity: this.validator.severity.error,
                        errorMessage: sharedMessages.unexpectederror
                    }], this.validator.validationSource.server);
                }));
            }
        },

        _createAsLocalAssetSetter: function (createAsLocalAsset) {
            // summary:
            //      Set createAsLocalAsset option.
            // createAsLocalAsset: Boolean
            //      The value.
            // tags:
            //      private


            this.createAsLocalAsset = createAsLocalAsset;
            if (this.parent) {
                this.set("actualParentLink", this._getParentLink());
            }
        },

        _autoPublishSetter: function (autoPublish) {
            // summary:
            //      Sets autoPublish option.
            // autoPublish: Boolean
            //      The value.
            // tags:
            //      private

            this.set("showAllProperties", autoPublish);
            this.autoPublish = autoPublish;
        },

        _parentSetter: function (parent) {
            this.parent = parent;

            var typeIdentifier = this.parent.typeIdentifier,
                requestedTypeName = TypeDescriptorManager.getResourceValue(this.requestedType, "name"),
                parentTypeName = TypeDescriptorManager.getResourceValue(typeIdentifier, "name"),
                createAsLocalAssetHelpText = TypeDescriptorManager.getResourceValue(typeIdentifier, "createaslocalassethelptext");

            if (requestedTypeName && parentTypeName) {
                createAsLocalAssetHelpText = lang.replace(createAsLocalAssetHelpText, [requestedTypeName.toLowerCase(), parentTypeName.toLowerCase()]);
            }

            this.set("createAsLocalAssetHelpText", createAsLocalAssetHelpText);
        },

        _requestedTypeSetter: function (requestedType) {
            // summary:
            //      Set requested type.
            // description:
            //      After the value is set, heading text and content name are also updated.
            // requestedType: String
            //      The value.
            // tags:
            //		private

            var headingText = TypeDescriptorManager.getResourceValue(requestedType, "create"),
                defaultName = TypeDescriptorManager.getResourceValue(requestedType, "newitemdefaultname");

            this.defaultName = defaultName;

            this.set("headingText", headingText);
            this.set("contentName", defaultName);

            this.requestedType = requestedType;
        },

        // =======================================================================
        // Private methods
        // =======================================================================

        _getParentLink: function () {
            // summary:
            //      Gets the link to the parent where the content should be created under.
            //      If the parent is a Content Asset folder the link to the owner content will be returned.
            // tags:
            //      private

            if (!this.parent) {
                return undefined;
            }

            var parentLink = this.parent.contentLink;
            if (this.createAsLocalAsset) {
                parentLink = this.parent.ownerContentLink ? this.parent.ownerContentLink : this.parent.contentLink;
            }
            return parentLink ? parentLink.toString() : undefined;
        },


        _hasRequiredProperties: function (metadata) {
            // summary:
            //      Checks if the metadata object contains any required property.
            // metadata: Object
            //      The metadata object.
            // tags:
            //		protected internal

            return array.some(metadata.properties, function (property) {
                return this._isRequiredProperty(metadata, property);
            }, this);
        },

        _isRequired: function (property) {
            // summary:
            //      Checks if the given property is required.
            // property: Object
            //      The metadata property.
            // tags:
            //      protected, extension

            return property.settings && property.settings.required;
        },

        _isRequiredProperty: function (metadata, property) {
            // summary:
            //      Checks if the given property is required.
            // description:
            //      A property is considered to be required if is required or it contains required sub properties.
            //      It should also have no value set, is visible, and is not the icontent_name property which is entered outside the properties form.
            // metadata: Object
            //      The metadata object.
            // property: Object
            //      The metadata property.
            // tags:
            //		private

            var isNotSet = !property.additionalValues.hasValue;

            var isShownForEdit = property.showForEdit && array.every(metadata.groups, function (group) {
                // Every group must be either not the property's original group or have displayui true
                return (group.name !== property.groupName && group.name !== property.originalGroupName) || group.displayUI;
            });

            var hasRequiredChildProperties = array.some(property.properties, function (childProperty) {
                return this._isRequiredProperty(property, childProperty);
            }, this);

            return (this._isRequired(property) || hasRequiredChildProperties) && isNotSet && isShownForEdit && (property.name !== "icontent_name");
        },

        _regroupProperties: function (metadata) {
            // summary:
            //		Regroup properties into required and additional property groups.
            // metadata: Object
            //      The metadata object.
            // tags:
            //		private

            metadata = lang.clone(metadata);

            metadata.layoutType = this._topLevelContainerType;

            array.forEach(metadata.properties, function (prop) {
                var isMandatory = this._isRequiredProperty(metadata, prop);
                prop.originalGroupName = prop.groupName;
                prop.groupName = isMandatory ? "required" : "additional";
            }, this);

            metadata.groups = [
                {
                    name: "required",
                    displayUI: true,
                    title: reqPropsResources.groups.required,
                    uiType: this._groupContainerType
                },
                {
                    name: "additional",
                    displayUI: true,
                    title: reqPropsResources.groups.additional,
                    uiType: this._groupContainerType
                }
            ];

            return metadata;
        },

        _getMetadata: function (parentLink, contentTypeId) {
            // summary:
            //      Get the metadata for the newly created content.
            // parentLink: String
            //      The parent content link.
            // contentTypeId: Number
            //      The content type id.
            // tags:
            //      private

            return this.metadataManager.getMetadataForType("EPiServer.Core.ContentData", {
                parentLink: parentLink,
                contentTypeId: contentTypeId
            });
        }

    });

});

},
'epi-cms/contentediting/inline-editing/InlineEditBlockDialog':function(){
define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi/shell/widget/dialog/ContextAwareDialog",
    "epi-cms/contentediting/move-behind-overlay",
    "epi/i18n!epi/cms/nls/episerver.shared.action"
], function (
    declare,
    topic,
    ContextAwareDialog,
    moveBehindOverlay,
    actionRes
) {
    return declare([ContextAwareDialog], {
        // summary:
        //      Dialog used to display inline edit form

        // saveLabel: [public] String
        //      Label for saving form
        saveLabel: actionRes.save,

        // mainCommand: [public] Object
        //      The command for changing the content's status (Publish, Ready to Publish, Ready for Review)
        mainCommand: null,

        // elementToOverlaySelector: [protected override] String
        //      Display the dialog overlay on top of a specific DOM node
        elementToOverlaySelector: ".epi-main-content",

        dialogClass: "epi-dialog-portrait inline-edit-dialog",

        postMixInProperties: function () {
            this.inherited(arguments);

            var containerNode = document.createElement("div");
            this.content = containerNode;
            this.contentClass = "epi-wrapped epi-mediaSelector";

            this.own(topic.subscribe("/epi/shell/inline-edit-resize", function (overlayPosition, sender) {
                if (this === sender || this._destroyed) {
                    return;
                }

                var dialogEl = this.domNode;
                moveBehindOverlay(dialogEl, overlayPosition);
            }.bind(this)));
        },

        getActions: function () {
            var actions = this.inherited(arguments);

            var saveButton = actions[1];
            saveButton.label = this.saveLabel;

            this._mainButtonName = "mainButton";
            var mainButton = {
                name: this._mainButtonName,
                label: this.mainCommand && this.mainCommand.label,
                title: null,
                settings: {
                    "class": "epi-primary main-button"
                },
                action: function () {
                    this.onMainCommand();
                }.bind(this)
            };
            if (this.mainCommand) {
                actions.push(mainButton);
            }

            return actions;
        },

        _resizeOverlay: function () {
            var result = this.inherited(arguments);
            if (!result) {
                return result;
            }

            topic.publish("/epi/shell/inline-edit-resize", result, this);
        },

        hideSaveButton: function () {
            this.definitionConsumer.setItemProperty(this._okButtonName, "class", "dijitHidden");
        },

        toggleDisabledSaveButton: function (shouldDisable) {
            this.definitionConsumer.setItemProperty(this._okButtonName, "disabled", shouldDisable ? "disabled" : "");
        },

        toggleMainButton: function (visible) {
            if (visible) {
                this.definitionConsumer.setItemProperty(this._mainButtonName, "class", "epi-success main-button Salt");
            } else {
                this.definitionConsumer.setItemProperty(this._mainButtonName, "class", "dijitHidden");
            }
        },

        toggleDisabledMainButton: function (shouldDisable) {
            this.definitionConsumer.setItemProperty(this._mainButtonName, "disabled", shouldDisable ? "disabled" : "");
        },

        _setCloseTextAttr: function (label) {
            this.definitionConsumer.setItemProperty(this._cancelButtonName, "label", label);
        },

        onMainCommand: function () {
        }
    });
});

},
'epi/shell/widget/dialog/ContextAwareDialog':function(){
define("epi/shell/widget/dialog/ContextAwareDialog", [
    // dojo
    "dojo/_base/declare",
    // epi.shell
    "epi/shell/_ContextMixin",
    "epi/shell/widget/dialog/Dialog"
], function (
    // dojo
    declare,
    // epi.shell
    _ContextMixin,
    Dialog
) {
    return declare([Dialog, _ContextMixin], {
        contextChanged: function () {
            this.hide();
            this.destroy();
        }
    });
});

},
'epi-cms/contentediting/move-behind-overlay':function(){
define([], function () {
    // summary:
    //      Moves element behind the overlay
    // tags:
    //      internal

    return function moveBehindOverlay(elToMove, overlayPosition) {
        var elPosition = elToMove.getBoundingClientRect();

        // top, bottom
        if (elPosition.top < overlayPosition.top) {
            elToMove.style.top = overlayPosition.top + "px";
        } else if (elPosition.bottom > overlayPosition.bottom) {
            elToMove.style.top = (overlayPosition.bottom - elPosition.height) + "px";
        }

        // left, right
        if (elPosition.left < overlayPosition.left) {
            elToMove.style.left = overlayPosition.left + "px";
        } else if (elPosition.right > overlayPosition.right) {
            elToMove.style.left = (overlayPosition.right - elPosition.width) + "px";
        }
    };
});

},
'epi-cms/component/command/_GlobalToolbarCommandProvider':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dijit/form/Button",

    "epi/shell/command/_CommandProviderMixin"
], function (
    declare,
    lang,

    Button,

    _CommandProviderMixin) {

    return declare([_CommandProviderMixin], {
        // summary:
        //      Base class for command providers that adds command to the epi-cms/component/GlobalToolbar
        // tags:
        //      internal abstract

        addToLeading: function (command, settings) {
            // summary:
            //      Append the given command to the command list
            // command:
            //      The command to append
            // settings:
            //      The settings to use when creating the menu item for the command
            // tags:
            //      protected
            this.addCommand(command, settings);
        },

        addToCenter: function (command, settings) {
            // summary:
            //      Append the given command to the command list
            // command:
            //      The command to append
            // settings:
            //      The settings to use when creating the menu item for the command
            // tags:
            //      protected
            settings = lang.mixin({
                category: "center"
            }, settings);

            this.addCommand(command, settings);
        },

        addToTrailing: function (command, settings) {
            // summary:
            //      Append the given command to the command list
            // command:
            //      The command to append
            // settings:
            //      The settings to use when creating the menu item for the command
            // tags:
            //      protected
            settings = lang.mixin({
                category: "trailing"
            }, settings);

            this.addCommand(command, settings);
        },

        addCommand: function (/*_Command*/command, /*Object*/settings) {
            // summary:
            //      Append the given command to the command list, un-categorized commands will be added to the "leading" category
            // command:
            //      The command to append
            // settings:
            //      The settings to use when creating the menu item for the command
            // tags:
            //      protected
            settings = lang.mixin({
                iconClass: command.iconClass,
                category: "leading",
                label: command.label,
                tooltip: command.tooltip,
                showLabel: false,
                widget: Button,
                model: command
            }, settings);


            //Create a delegate for the command
            command = lang.delegate(command, { settings: settings });

            //Add to the command list
            this.add("commands", command);
        },

        updateCommandModel: function (model) {
            // summary:
            //		Updates the model for the commands.
            // tags:
            //		public
            this.commands.forEach(function (command) {
                command.settings.model.set("model", model);
            });
        }
    });
});

},
'epi-cms/compare/command/CompareCommandProvider':function(){
define([
    "dojo/_base/declare",
    "epi-cms/component/command/_GlobalToolbarCommandProvider",

    "./CompareSettingsModel",
    "./CompareViewSelection",
    "epi/shell/command/ToggleCommand",
    "epi-cms/command/_NonEditViewCommandMixin",
    "epi/i18n!epi/cms/nls/episerver.cms.compare.command"
], function (
    declare,
    _GlobalToolbarCommandProvider,

    CompareSettingsModel,
    CompareViewSelection,
    ToggleCommand,
    _NonEditViewCommandMixin,
    resources
) {

    var NonEditViewToggleCommand = declare([ToggleCommand, _NonEditViewCommandMixin]);

    return declare([_GlobalToolbarCommandProvider], {
        // summary:
        //      A command provider providing compare commands to the global toolbar
        // tags:
        //      internal
        postscript: function () {
            this.inherited(arguments);

            var model = new CompareSettingsModel();

            // Need to have a settings object as well, since the global menu builder looks a this for category
            var settings = { category: "compare" };

            this.add("commands", new NonEditViewToggleCommand({
                category: "compare",
                settings: settings,
                label: "",
                tooltip: resources.togglecompare.label,
                showLabel: true,
                iconClass: "epi-iconCompare",
                model: model,
                property: "enabled",
                hideSingleOption: true
            }));
            this.add("commands", new CompareViewSelection({
                category: "compare",
                settings: settings,
                model: model,
                label: resources.compareviewselection.label,
                optionsLabel: resources.compareviewselection.label,
                optionsProperty: "modeOptions",
                property: "mode"
            }));
        }
    });
});

},
'epi-cms/compare/command/CompareSettingsModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/Stateful",
    "dojo/when",
    "dijit/Destroyable",
    "epi/dependency",
    "epi/i18n!epi-cms/nls/episerver.cms.compare.mode"
], function (
    declare,
    lang,
    topic,
    Stateful,
    when,
    Destroyable,
    dependency,
    res
) {

    return declare([Stateful, Destroyable], {
        // summary:
        //      Model for settings related to property compare view settings
        // tags: internal

        // enabled: [public] Boolean
        //      A flag telling whether compare mode is enabled
        enabled: false,

        // mode: [public] String
        //      The currently active mode
        mode: "allpropertiescompare",

        _selectedCompareModeProfileKey: "epi.selected-comparemode-id",

        // modeOptions: [readonly] Array[object]
        //      An array of the available compare modes
        modeOptions: [
            { label: res.allpropertiescompare, value: "allpropertiescompare", iconClass: "epi-iconForms" },
            { label: res.sidebysidecompare, value: "sidebysidecompare", iconClass: "epi-iconLayout" }
        ],

        constructor: function () {
            var self = this;

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");

            when(this._loadSelectedModeFromProfile(), lang.hitch(this, function (mode) {
                if (mode) {
                    this.set("mode", mode);
                }
            }));

            this.own(
                topic.subscribe("/epi/shell/action/viewchanged", function (type, args, data) {
                    // Deactivate compare if the view changes something other than compare.
                    var view = data && (data.viewName || (data.sender && data.sender.viewName));
                    var isCompareMode = self.modeOptions.some(function (option) {
                        return option.value === view;
                    });
                    self.set("enabled", isCompareMode, false);
                }),
                topic.subscribe("/epi/cms/action/switcheditmode", function () {
                    self.set("enabled", false, false);
                }),
                topic.subscribe("/epi/cms/action/eyetoggle", function (enabled) {
                    // Deactivate compare if the view settings are toggled on.
                    if (enabled) {
                        self.set("enabled", false, false);
                        topic.publish("/epi/shell/action/changeview/updatestate", { viewName: null });
                    }
                })
            );
        },

        _enabledSetter: function (value, raiseEvent) {
            if (this.enabled !== value) {
                this.enabled = value;
                (raiseEvent !== false) && this._onChange();
            }
        },

        _modeSetter: function (value) {
            // TODO: Try to remove, required to not get change events when clicking the dropdownbutton since the _CommandModelBindinMixing wires up onClick
            if (this.mode !== value) {
                this.mode = value;
                this.get("enabled") && this._onChange();
                // Store the selected mode.
                this.profile.set(this._selectedCompareModeProfileKey, value, { location: "server" });
            }
        },

        _onChange: function () {
            // summary:
            //      Publish view change topics when the state changes
            // tags:
            //      private
            topic.publish("/epi/shell/action/changeview", this.get("enabled") ? this.get("mode") : null, null, { forceReload: true });
        },


        _loadSelectedModeFromProfile: function () {
            // summary:
            //      Load the selected mode from the user profile
            // returns: Promise
            //      The compare mode that was stored in the profile
            // tags:
            //      internal

            //Load the selected mode from the profile
            return when(this.profile.get(this._selectedCompareModeProfileKey), function (mode) {
                if (!mode) {
                    return null;
                }
                return mode;
            });
        }
    });

});

},
'epi-cms/compare/command/CompareViewSelection':function(){
define([
    "dojo/_base/declare",
    // Parent class
    "epi/shell/command/OptionCommand",
    "epi-cms/command/_NonEditViewCommandMixin"
], function (
    declare,
    // Parent class
    OptionCommand,
    _NonEditViewCommandMixin
) {

    return declare([OptionCommand, _NonEditViewCommandMixin], {
        // summary:
        //      A command for selecting the current compare view
        // tags:
        //      internal

        _selectedSetter: function (selected) {
            // summary:
            //      Overridden to set iconClass and tooltip based on the currently selected option
            this.inherited(arguments);
            this.get("options").some(function (option) {
                if (option.value === selected) {
                    this.set("iconClass", option.iconClass);
                    return true;
                }
            }, this);
        },

        _viewChanged: function (type, args, data) {
            var onPageOption = "sidebysidecompare";
            if (data && data.hideView) {
                var filteredOptions = this.get("options").filter(function (option) {
                    return option.value !== onPageOption; //Filter the On-page option if the content has no view
                });

                this.set("options", filteredOptions);

                if (this.selected === onPageOption) {
                    this.set("selected",filteredOptions[0].value);
                }
            } else {
                // set options to null to reset the options to the original option list (modeOptions)
                this.set("options", null);
            }

            // re-set model.enabled value so that the Compare mode selector get updated
            var enabled = this.model.get("enabled");
            if (enabled) {
                this.model.set("enabled", enabled, false);
            }
        }
    });
});

},
'epi/shell/command/OptionCommand':function(){
﻿define("epi/shell/command/OptionCommand", [
    "dojo/_base/declare",
    "epi/shell/command/_Command",
    "dijit/Destroyable"
], function (declare, _Command, Destroyable) {

    return declare([_Command, Destroyable], {
        // summary:
        //      A base class implementation for a command with several options that execute when changed.
        //
        // tags:
        //      public

        // options: [public] Array
        //		An array of options objects that can be selected.
        options: null,

        // optionsLabel: [public] String
        //      An optional label for the options drop down
        optionsLabel: "",

        // optionsProperty: [readonly] String
        //      Name of a property on the model providing the options
        optionsProperty: null,

        // selected: [readonly] String|Number
        //		The value of the selected item from the options array.
        selected: null,

        // property: [public] String
        //		The name of the property on the model that will be set with the selected value on execute.
        property: null,

        _execute: function () {
            // summary:
            //		Toggles the value of the given property on the model.
            // tags:
            //		protected

            this.model.set(this.property, this.selected);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var self = this,
                model = this.model;

            this.set("canExecute", !!model);

            if (model) {
                this.set("selected", this.model.get(this.property));
                this.own(model.watch(this.property, function (name, oldValue, value) {
                    self.set("selected", value);
                }));
            }
        },

        _optionsGetter: function () {
            // summary:
            //      Returns the options array if defined on the command, otherwise if model
            //      and optionsProperty is defined, the options is returned from the model
            // tags:
            //      public

            return this.options || (this.model && this.optionsProperty && this.model.get(this.optionsProperty));
        },

        _selectedSetter: function (selected) {
            // summary:
            //      Setter method for the selected property
            // tags:
            //      private
            var oldValue = this.selected;

            this.selected = selected;

            if (oldValue !== selected) {
                this.execute();
            }
        }
    });
});

},
'epi-cms/command/_NonEditViewCommandMixin':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    // Parent class
    "dijit/Destroyable"
], function (
    declare,
    lang,
    topic,
    // Parent class
    Destroyable
) {

    return declare([Destroyable], {
        // summary:
        //      Mixin for commands that appear in the global toolbar. This mixin sets whether a
        //      command should be available depending on whether the current view supports editing.
        // tags:
        //      internal

        constructor: function () {
            this.own(
                topic.subscribe("/epi/shell/action/viewchanged", lang.hitch(this, "_viewChanged"))
            );
        },

        _viewChanged: function (type, args, data) {
            // summary:
            //      Callback function when the view is changed. Ensures that the command is only
            //      available if the view controller is PageDataController or CompareView.
            // tags:
            //      internal

            this.set("isAvailable",
                type === "epi-cms/contentediting/PageDataController" ||
                type === "epi-cms/compare/views/CompareView");
        }
    });
});

},
'epi-cms/command/ViewSettingsCommandProvider':function(){
define([
    "dojo/_base/declare",

    "epi/dependency",

    "epi-cms/ApplicationSettings",
    "epi-cms/command/TogglePreviewMode",
    "epi-cms/command/ToggleViewSettings",
    "epi-cms/visitorgroups/command/VisitorGroupViewSettingsCommand",

    "epi-cms/project/ProjectPreviewButton",

    "epi-cms/contentediting/command/LanguageSelection",
    "epi-cms/contentediting/viewmodel/LanguageSettingsModel",
    "./DeviceSelection",

    "epi-cms/component/command/_GlobalToolbarCommandProvider",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.togglepreviewmode"
], function (
    declare,

    dependency,

    ApplicationSettings,
    TogglePreviewMode,
    ToggleViewSettings,
    VisitorGroupViewSettingsCommand,

    ProjectPreviewButton,

    LanguageSelection,
    LanguageSettingsModel,
    DeviceSelection,

    _GlobalToolbarCommandProvider,

    resources
) {

    return declare([_GlobalToolbarCommandProvider], {
        // summary:
        //      Provides view settings commands to the global toolbar
        // tags:
        //      internal


        postscript: function () {
            // summary:
            //      Instantiates and add the view commands.
            // tags:
            //      public

            this.inherited(arguments);

            // Needed since the global toolbar looks at the category both on the commands and on a settings object on the commands
            var settings = {category: "view"};

            this.projectService = this.projectService || dependency.resolve("epi.cms.ProjectService");

            var model = new LanguageSettingsModel();

            this.add("commands", new ToggleViewSettings({
                settings: settings,
                category: settings.category,
                showLabel: true
            }));

            this.add("commands", new LanguageSelection({
                category: settings.category,
                showLabel: true,
                settings: settings,
                optionsProperty: "availableLanguages",
                property: "selectedLanguage",
                model: model
            }));

            var sectionsVisibility = Object.assign({}, ApplicationSettings.sectionsVisibility);
            // Only add the view as visitor group if the ui is not limited
            if (!ApplicationSettings.limitUI && (sectionsVisibility.visitorGroups !== false)) {
                this.add("commands", new VisitorGroupViewSettingsCommand({
                    category: settings.category,
                    settings: settings
                }));
            }

            this.add("commands", new DeviceSelection({
                settings: settings,
                category: settings.category
            }));

            // Add the Project Preview button if Project Mode is disabled
            if (!this.projectService.isProjectModeEnabled) {
                if (this.projectService.isProjectGadgetEnabled) {
                    this.add("commands", {
                        settings: settings,
                        category: settings.category,
                        widget: new ProjectPreviewButton({showLabel: false})
                    });
                }
            }

            this.add("commands", new TogglePreviewMode({
                settings: Object.assign({}, settings, {
                    statusMessages: {
                        active: resources.message
                    }
                }),
                category: settings.category,
                showLabel: true
            }));
        }

    });
});

},
'epi-cms/command/TogglePreviewMode':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.togglepreviewmode",
    // Parent class and mixins
    "epi/shell/command/ToggleCommand",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/command/_NonEditViewCommandMixin",
    "epi-cms/_SidePanelsToggleMixin",
    "dijit/Destroyable"
], function (
    declare,
    lang,
    topic,
    // Resources
    localizations,
    // Parent class and mixins
    ToggleCommand,
    TypeDescriptorManager,
    _NonEditViewCommandMixin,
    _SidePanelsToggleMixin,
    Destroyable
) {

    return declare([ToggleCommand, _NonEditViewCommandMixin, _SidePanelsToggleMixin, Destroyable], {
        // summary:
        //      Toggles the preview mode active state.
        // tags:
        //      internal

        // iconClass: [public] String
        //      The CSS class which represents the icon to be used in visual elements.
        iconClass: "epi-iconPreview",

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: localizations.title,

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localizations.label,

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed; true by default.
        canExecute: true,

        constructor: function () {
            this.own(
                // Deactivate the option if we recieve a disable topic.
                topic.subscribe("/epi/cms/action/disablepreview", lang.hitch(this, "_deactivate"))
            );
        },

        _execute: function () {
            this.set("active", !this.active);

            if (this.active) {
                topic.publish("/epi/shell/action/changeview", "view");
                this._hideSidePanels();
            } else {
                this._restoreSidePanels();
                topic.publish("/epi/shell/action/changeview", null);
            }
        },

        _deactivate: function () {
            if (this.active) {
                this.set("active", false);
                this._restoreSidePanels();
            }
        },

        _viewChanged: function (type, args, data) {
            this.inherited(arguments);

            // Close the preview view if another view is opened.
            var view = data && data.viewName;
            if (view !== "view") {
                this._deactivate();
            } else {
                // request change view if content has no view
                if (data.hideView) {
                    this._deactivate();
                    data.viewName = null;
                    topic.publish("/epi/shell/action/changeview", null, args, data);
                }
            }

            // hide the toggle view settings icon if content has no view
            if (data && data.hideView) {
                this.set("isAvailable", false);
            }
        }
    });
});

},
'epi-cms/_SidePanelsToggleMixin':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
    "dojo/topic",

    // epi
    "epi/dependency"
],

function (
// dojo
    declare,
    lang,
    all,
    when,
    topic,

    // epi
    dependency

) {

    return declare([], {
        // summary:
        //      Provides functionality for hiding and restoring side panels
        // tags:
        //      internal abstract

        // The profile obj
        _profile: null,

        // The state of navigation panel
        _isNavigationVisible: null,

        // The state of tools panel
        _isToolsVisible: null,

        constructor: function () {
            // resolve the _profile dependency if not given
            if (!this._profile) {
                this._profile = dependency.resolve("epi.shell.Profile");
            }

            // sets the side panels original values on initialization
            this._storePanelVisibility();
        },

        _restoreSidePanels: function () {
            // summary:
            //      Restores the side panels to their original visibility
            // tags:
            //      protected
            topic.publish("/epi/layout/pinnable/navigation/toggle", this._isNavigationVisible);
            topic.publish("/epi/layout/pinnable/tools/toggle", this._isToolsVisible);
        },

        _hideSidePanels: function () {
            // summary:
            //      hides the navigation and tools side bars
            // tags:
            //      protected

            // Store the previous panels settings before hiding them
            this._storePanelVisibility().then(function () {
                topic.publish("/epi/layout/pinnable/navigation/toggle", false);
                topic.publish("/epi/layout/pinnable/tools/toggle", false);
            });
        },

        _storePanelVisibility: function () {
            // summary:
            //      Gets the panels visibility from the profile and stores it on the instance
            // tags:
            //    private

            return all([
                when(this._profile.get("navigation"), lang.hitch(this, function (navigationSetting) {
                    this._isNavigationVisible = navigationSetting ? navigationSetting.visible : false;
                })),
                when(this._profile.get("tools"), lang.hitch(this, function (toolsSetting) {
                    this._isToolsVisible = toolsSetting ? toolsSetting.visible : false;
                }))
            ]);
        }

    });

});

},
'epi-cms/command/ToggleViewSettings':function(){
define([
    "dojo/_base/declare",
    "dojo/topic",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.viewsetting",
    // Parent class and mixins
    "epi/shell/command/ToggleCommand",
    "epi/dependency",
    "epi-cms/command/_NonEditViewCommandMixin"
], function (
    declare,
    topic,
    // Resources
    localizations,
    // Parent class and mixins
    ToggleCommand,
    dependency,
    _NonEditViewCommandMixin
) {

    return declare([ToggleCommand, _NonEditViewCommandMixin], {
        // summary:
        //      Command for toggling the view settings' active state.
        // tags:
        //      internal

        // iconClass: [public] String
        //      The CSS class which represents the icon to be used in visual elements.
        iconClass: "epi-iconEye",

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed; true by default.
        canExecute: true,

        // property: [readonly] Boolean
        //      The property on the model to reflect in toggle state by. Defaults to "enabled".
        property: "enabled",

        // label: [public] String
        //      The 'view settings' text of the command to be used in visual elements.
        label: localizations.label,

        // tooltip: [public] String
        //      The 'view settings' title text of the command to be used in visual elements.
        tooltip: localizations.viewsettingbutton,

        postscript: function () {
            this.inherited(arguments);
            if (!this.model) {
                this.set("model", dependency.resolve("epi.viewsettingsmanager"));
            }
        },

        _execute: function () {
            // summary:
            //      Overridden to publish "/epi/cms/action/eyetoggle" with the enabled state from the model
            this.inherited(arguments);
            topic.publish("/epi/cms/action/eyetoggle", this.model.get(this.property));
        },

        _viewChanged: function (type, args, data) {
            this.inherited(arguments);

            // Close the view settings button when compare becomes active.
            var view = data && data.viewName;
            if (this.active && view && view.indexOf("compare") !== -1) {
                this.execute();
            }
        }
    });
});

},
'epi-cms/visitorgroups/command/VisitorGroupViewSettingsCommand':function(){
define([
    "dojo/_base/declare",

    "dijit/Destroyable",

    "epi/shell/command/OptionCommand",
    "epi-cms/command/_NonEditViewCommandMixin",
    "./VisitorGroupViewSettingsModel",

    "epi/i18n!epi/cms/nls/episerver.cms.widget.visitorgroupselector"
], function (
    declare,
    Destroyable,
    OptionCommand,
    _NonEditViewCommandMixin,
    VisitorGroupViewSettingsModel,
    res) {

    return declare([OptionCommand, _NonEditViewCommandMixin, Destroyable], {
        // summary:
        //      Command for the visitor groups view settings
        // tags: internal

        iconClass: "epi-iconUsers",
        model: null,
        optionsProperty: "options",
        property: "selectedGroup",
        optionsLabel: res.header,

        postscript: function () {
            this.inherited(arguments);

            this.set("model", this.model || new VisitorGroupViewSettingsModel());
            this.set("label", this.model.tooltip);

            this.set("active", !!this.model.selectedGroup);

            var self = this;
            this.own(this.model.watch("tooltip", function (property, oldValue, newValue) {
                self.set("label", newValue);
            }));

            this.own(this.model.watch("selectedGroup", function (property, oldValue, newValue) {
                self.set("active", !!newValue);
            }));
        },

        _viewChanged: function (type, args, data) {
            this.inherited(arguments);

            // hide the VisitorGroup icon if content has no view
            if (data && data.hideView) {
                this.set("isAvailable", false);
            }
        }
    });
});

},
'epi-cms/visitorgroups/command/VisitorGroupViewSettingsModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/Stateful",
    "dojo/when",
    "dijit/Destroyable",
    "epi/dependency",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.visitorgroupsbutton",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.visitorgroupselector"
], function (
    declare,
    lang,
    topic,
    Stateful,
    when,
    Destroyable,
    dependency,
    buttonRes,
    res
) {

    return declare([Stateful, Destroyable], {
        // summary:
        //      Model for settings related to visitor groups view settings
        // tags: internal

        // selectedGroup: [public] string
        //      The currently selected visitor group
        selectedGroup: null,

        tooltip: buttonRes.defaulttooltip,

        defaultItem: {
            value: null,
            label: res.defaultitem
        },

        // options: [public] Array
        //      The available visitor groups to select from
        options: [],

        postscript: function () {
            this.inherited(arguments);

            if (!this._store) {
                var registry = dependency.resolve("epi.storeregistry");
                this._store = registry.get("epi.cms.visitorgroup");
            }

            if (!this._viewSettingsManager) {
                this._viewSettingsManager = dependency.resolve("epi.viewsettingsmanager");
            }

            //Get the currently selected group from the view settings manager
            var selectedVisitorGroup = this._viewSettingsManager.getSettingProperty("visitorgroup");

            var self = this;
            when(this._store.query()).then(function (visitorGroups) {
                if (!(visitorGroups instanceof Array)) {
                    visitorGroups = [];
                }

                var options = visitorGroups.map(function (item) {
                    return {label: item.name, value: item.id};
                });

                options.unshift(self.defaultItem);
                self.set("options", options);

                self.set("selectedGroup", selectedVisitorGroup, false);
            });

        },
        _selectedGroupSetter: function (selectedGroup, raiseEvent) {

            if (this.selectedGroup === selectedGroup) {
                return;
            }

            // Set the selected group to -1 if no one was provided
            this.selectedGroup = selectedGroup;

            this._setTooltip();

            if (raiseEvent === false) {
                return;
            }

            topic.publish("/epi/cms/action/viewsettingvaluechanged", "visitorgroup", this.selectedGroup);
        },

        _setTooltip: function () {
            // summary:
            //      Combine a new tooltip using the selected group and the tooltip
            // tags:
            //      internal

            var group = this._getGroup(this.selectedGroup);

            if (group) {
                this.set("tooltip", lang.replace(buttonRes.tooltip, { visitorgroup: group.label}));
            } else {
                this.set("tooltip", buttonRes.defaulttooltip);
            }
        },

        _getGroup: function (id) {
            // summary:
            //      Get the group object using the selected group id
            // tags:
            //      internal

            if (id === this.defaultItem.value) {
                return null;
            }

            for (var idx in this.options) {
                if (this.options[idx].value === id) {
                    return this.options[idx];
                }
            }

            return null;
        }
    });
});

},
'epi-cms/project/ProjectPreviewButton':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/Deferred",
    "dojo/topic",
    "epi/dependency",
    // Resources
    "epi/i18n!epi/nls/episerver.cms.components.project.preview",
    // Parent class
    "epi/shell/widget/DeferredDropDownButton",
    // Dropdown widget
    "epi-cms/project/ProjectSelectorList"
], function (
    declare,
    lang,
    domClass,
    Deferred,
    topic,
    dependency,
    // Resources
    localization,
    // Parent class
    DeferredDropDownButton,
    // Dropdown widget
    ProjectSelectorList
) {

    return declare([DeferredDropDownButton], {
        // summary:
        //      The button for the project preview view settings options. Handles creating the project
        //      preview selector and reading and setting the selected project value to the view setting.
        // tags:
        //      internal

        // iconClass: [public] String
        //      The CSS class that adds the button icon.
        iconClass: "epi-iconProject",

        baseClass: "",

        postMixInProperties: function () {
            // summary:
            //      Called after the parameters to the widget have been read-in,
            //      but before the widget template is instantiated.
            // tags:
            //      protected
            this.inherited(arguments);

            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.project");
        },

        buildRendering: function () {
            // summary:
            //      Construct the UI for this widget, setting this.domNode and this.dropdown.
            // tags:
            //      protected
            this.inherited(arguments);
            domClass.add(this.domNode, ["epi-chromeless", "epi-mediumButton"]);

            // Construct the drop down menu if it doesn't exist.
            if (!this.dropDown) {
                this.dropDown = new ProjectSelectorList({
                    baseClass: "dijitMenu",
                    enableDefaultValue: true,
                    defaultValueText: localization.defaultoption,
                    store: this.store,
                    header: localization.header,
                    loadStoreOnStartup: true
                });
            }
        },

        postCreate: function () {
            // summary:
            //      Processing after the DOM fragment is created. Sets up event handlers.
            // tags:
            //      protected
            this.inherited(arguments);

            var self = this,
                // Get the initial state from the view settings manager.
                projectId = dependency.resolve("epi.viewsettingsmanager").getSettingProperty("project"),
                // Resolve the project based on the ID stored in view settings.
                promise = projectId ? this.store.get(parseInt(projectId)) : new Deferred().resolve();

            promise
                .then(function (project) {
                    self.dropDown.set("selectedProject", project);
                    self._updateButtonState(project);
                })
                .always(function () {
                    // Handle changes to the selected project in the selector.
                    self.own(
                        self.dropDown.watch("selectedProject", lang.hitch(self, "_selectedProjectChanged"))
                    );
                });
        },

        loadAndOpenDropDown: function () {
            // summary:
            //      Opens the drop down and refreshes the content.
            // returns: Promise
            //      Promise for the drop down widget that resolves when
            //      the drop down is created and loaded.
            // tags:
            //      protected

            if (this.isLoaded()) {
                // If the drop down has already been loaded then we need to do a refresh after opening.
                return this.inherited(arguments).then(lang.hitch(this, function () {
                    return this.dropDown.refresh();
                }));
            }

            return this.inherited(arguments);
        },

        _selectedProjectChanged: function (name, oldValue, value) {
            // summary:
            //      The callback method for when the selected project changes on the selector.
            // tags:
            //      private
            var projectId = value ? value.id : null;

            topic.publish("/epi/cms/action/viewsettingvaluechanged", "project", projectId);

            this._updateButtonState(value);
        },

        _updateButtonState: function (project) {
            // summary:
            //      Updates the UI state of the button, setting the title attribute and marking
            //      it as checked depending on whether a project is selected.
            // tags:
            //      private
            var tooltip = localization.defaulttooltip;

            // Set a specific tooltip if there is a project selected.
            if (project) {
                tooltip = lang.replace(localization.tooltip, { project: project.name });
            }

            this.set("title", tooltip);

            // Mark the button as checked if there is a project selected.
            domClass.toggle(this.iconNode, "epi-icon--active", !!project);
        }
    });
});

},
'epi/shell/widget/DeferredDropDownButton':function(){
define("epi/shell/widget/DeferredDropDownButton", [
    "dojo/_base/declare",
    // Parent class and mixins
    "dijit/form/DropDownButton",
    "epi/shell/widget/_HasDeferredDropDown"
], function (
    declare,
    // Parent class and mixins
    DropDownButton,
    _HasDeferredDropDown
) {
    return declare([DropDownButton, _HasDeferredDropDown], {
        // tags:
        //      internal
    });
});

},
'epi/shell/widget/_HasDeferredDropDown':function(){
define("epi/shell/widget/_HasDeferredDropDown", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/on",
    // Parent class
    "dijit/_HasDropDown"
], function (
    declare,
    lang,
    Deferred,
    on,
    // Parent class
    _HasDropDown
) {

    return declare([_HasDropDown], {
        // tags:
        //    internal

        // _loaded: [protected] Boolean
        //      Flag indicating whether the drop down content has loaded.
        _loaded: false,

        // loadEvent: [readonly] String
        //      The event that the drop down will raise when it has finished loading.
        loadEvent: "loaded",

        isLoaded: function () {
            // summary:
            //      Indicates whether the drop down content has loaded.
            // tags:
            //      public
            return this._loaded && !!this.dropDown;
        },

        loadDropDown: function () {
            // summary:
            //      Loads the drop down asynchronously and resolves when the load is complete.
            // returns: Promise
            //      Promise for the drop down widget that resolves when
            //      the drop down is loaded.
            // tags:
            //      protected
            var self = this,
                dropDown = this.dropDown,
                deferred = new Deferred();

            on.once(dropDown, this.loadEvent, function () {
                self._loaded = true;
                deferred.resolve();
            });

            dropDown.startup();

            return deferred.promise;
        },

        loadAndOpenDropDown: function () {
            // summary:
            //      Creates the drop down if it doesn't exist and then opens the drop down.
            // returns: Promise
            //      Promise for the drop down widget that resolves when
            //      the drop down is created and loaded.
            // tags:
            //      protected
            var self = this,
                dropDown = this.dropDown;

            if (this.isLoaded()) {
                return new Deferred().resolve(this.openDropDown());
            }

            return this.loadDropDown().then(function () {
                self.openDropDown();
                if (dropDown.focus) {
                    self.defer(lang.hitch(dropDown, "focus"), 1);
                }
            });
        }
    });
});

},
'epi-cms/project/ProjectSelectorList':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/keys",
    "dojo/when",
    "dojo/dom-class",
    "dojox/html/entities",

    "dijit/form/RadioButton",
    "dijit/Menu",

    "epi/epi",
    "epi/shell/command/_WidgetCommandBinderMixin",
    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/command/builder/ExpandoMenuBuilder",
    "epi/shell/command/builder/OptionsBuilderMixin",
    "epi/datetime",
    "epi/username",
    "./viewmodels/ProjectSelectorListViewModel",

    // Resources
    "dojo/text!./templates/ProjectSelectorList.html",
    "epi/i18n!epi/shell/ui/nls/episerver.shared.header",
    "epi/i18n!epi/cms/nls/episerver.cms.components.project",
    // Grid
    "dgrid/OnDemandList",
    "dgrid/extensions/DijitRegistry",
    "dgrid/Keyboard",
    "dgrid/Selection",
    "dgrid/util/mouse",
    "put-selector/put",
    "epi/shell/dgrid/Focusable",
    "epi/shell/dgrid/selection/Exclusive",
    "epi/shell/dgrid/util/misc",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_KeyNavContainer",
    // Widgets in template
    "dijit/Toolbar"
], function (
    declare,
    event,
    lang,
    keys,
    when,
    domClass,
    entities,

    RadioButton,
    Menu,

    epi,
    _WidgetCommandBinderMixin,
    MenuAssembler,
    ExpandoMenuBuilder,
    OptionsBuilderMixin,
    epiDatetime,
    epiUsername,


    ProjectSelectorListViewModel,

    // Resources
    template,
    localizations,
    res,
    // Grid
    OnDemandList,
    DijitRegistry,
    Keyboard,
    Selection,
    mouse,
    put,
    Focusable,
    Exclusive,
    misc,
    // Parent class and mixins
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _KeyNavContainer
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _KeyNavContainer, _WidgetCommandBinderMixin], {
        // summary:
        //      Sortable project selector
        //
        // tags:
        //      internal

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // store: [public] Store
        //      The store that will be queried for projects.
        store: null,

        // query: [public] Object
        //      A query to use when fetching items from the store.
        query: null,

        // markedContentLink: [public] String
        //      The content link of the version which should be marked as in use.
        selectedProject: null,

        // enableDefaultValue: [public] Boolean
        //      Enable/Disable the possiblity to select a default value (null)
        enableDefaultValue: false,

        // defaultValueText: [public] String
        //      The text to display for the default value if enabled
        defaultValueText: res.preview.defaultoption,

        // header: [protected] String
        //      A string that will be displayed in the header of the selector.
        header: res.title,

        // loadStoreOnStartup: [protected] Boolean
        //      Load the store immediately instead of waiting for interaction.
        loadStoreOnStartup: false,

        _setHeaderAttr: { node: "headerNode", type: "innerText" },

        _optionsMenuClass: declare([Menu, OptionsBuilderMixin]),

        postMixInProperties: function () {
            // summary:
            //      Called after the parameters to the widget have been read-in,
            //      but before the widget template is instantiated. The column
            //      definitions are setup at this time.
            // tags:
            //      protected
            this.inherited(arguments);

            if (!this.model) {
                this.own(
                    this.model = new ProjectSelectorListViewModel()
                );
            }
        },

        buildRendering: function () {
            // summary:
            //      Construct the UI for this widget via dijit/_TemplatedMixin with the addition
            //      of a dgrid added via code.
            // tags:
            //      protected
            this.inherited(arguments);

            this._setupProjectSortMenu();

            this.list = new (declare([OnDemandList, DijitRegistry, Selection, Keyboard, Focusable, Exclusive]))({
                sort: [{ attribute: "created", descending: true }],
                className: "epi-grid--no-alternating-rows epi-grid-max-height--300",
                cleanEmptyObservers: false,
                deselectOnRefresh: false,
                selectionMode: "exclusive",
                selectionEvents: "click",
                query: this.get("query"),
                renderRow: this.renderRow
            }, this.listNode);

            // Own the list and the event handlers.
            this.own(
                this.list,
                this.list.on("dgrid-select", lang.hitch(this, "_projectSelected")),
                this.list.on("dgrid-refresh-complete", lang.hitch(this, "_refreshComplete")),
                this.list.addKeyHandler(keys.ENTER, lang.hitch(this, "_listEnterKeypress")),
                this.model.watch("projectSortOrder", lang.hitch(this, "_sortChanged")),

                // Handle key events on the list in order to manage moving focus.
                this.list.addKeyHandler(keys.UP_ARROW, lang.hitch(this, "_listNavigateUp")),
                this.list.addKeyHandler(keys.PAGE_UP, lang.hitch(this, "_listNavigateUp")),
                // Handle mouse over events on the list in order to manage moving focus.
                this.list.on(mouse.enterRow, lang.hitch(this, "_listMouseover")),

                // Handle selection of the default option.
                this.defaultOption.on("click", lang.hitch(this, "_defaultOptionSelected")),
                // Handle key events on the default option in order to manage moving focus.
                this.defaultOption.on("keypress", lang.hitch(this, "_defaultOptionKeypress")),
                // Handle mouse over events on the default option in order to manage moving focus.
                this.defaultOption.on("mouseover", lang.hitch(this, "_defaultOptionMouseover"))
            );

            if (this.enableDefaultValue) {
                // Override the default handler for HOME key event since we don't want to execute the default handler when defaultvalue is enabled.
                this.list.keyMap[keys.HOME] = lang.hitch(this, "_listNavigateHome");
            } else {
                domClass.add(this.defaultOption.domNode, "dijitHidden");
            }

            this.defaultOption.set({
                iconClass: "dijitRadioIcon",
                label: entities.encode(this.defaultValueText)
            });
        },

        startup: function () {
            // summary:
            //      Processing after the widget and its children have been created and
            //      added to the DOM. Setup the initial query and store for the list.
            // tags:
            //      protected
            if (this._started) {
                return;
            }
            this.inherited(arguments);

            this.model.initialize();

            this.list.startup();

            if (this.loadStoreOnStartup) {
                this.list.set("store", this.store);
            }
        },

        focus: function () {
            // summary:
            //      Override the default focus handling and set the focus to either the default options or the list
            // tags:
            //      public
            if (this.enableDefaultValue) {
                this.defaultOption.focus();
            } else {
                this.list.focus();
            }
        },

        resize: function () {
            // summary:
            //      Resize the version selector and its children.
            // tags:
            //      public
            this.inherited(arguments);
            this.list.resize();
        },

        renderRow: function (item, options) {
            // summary:
            //      Render row callback
            // tags:
            //      protected, virtual

            var selector = put("div.epi-selector-list__type-wrapper", put("span.dijit.dijitReset.dijitInline.dijitRadio"));
            var label = put("label.epi-selector-list__title.dojoxEllipsis", put("strong[title=$]", item.name, item.name));
            var state = put("div.epi-selector-list__description.dojoxEllipsis", epiDatetime.toUserFriendlyString(new Date(item.created)) + ", " + epiUsername.toUserFriendlyString(item.createdBy));
            return put("div", [selector, label, state]);
        },

        refresh: function () {
            // summary:
            //      Refreshes the version selector to ensure the data displayed is up to date.
            // tags:
            //      public

            if (!this._started) {
                return;
            }

            if (!this.list.get("store")) {
                this.list.set("store", this.store);
            }

            return this.list.refresh().then(
                lang.hitch(this, function (projects) {
                    var selectedProject = this.get("selectedProject"),
                        projectExists = selectedProject && projects.some(function (item) {
                            if (item.id === selectedProject.id) {
                                selectedProject = item;
                                return true;
                            }
                            return false;
                        }, this);

                    this.set("selectedProject", projectExists ? selectedProject : null);
                })
            );
        },

        _projectSelected: function (e) {
            // summary:
            //      Extracts the version information and emits a change event.
            // tags:
            //      private

            var value = e && e.rows && e.rows[0].data;

            if (!epi.areEqual(value, this.get("selectedProject"))) {
                this.set("selectedProject", value);
                this.emit("change", { value: value });
            }

            this._updateView();
        },

        _refreshComplete: function (evt) {
            // summary:
            //      Selects the current version and marks the marked version when a refresh occurs.
            // tags:
            //      private

            when(evt.results.total, lang.hitch(this, function (total) {
                this.emit("loaded");

                domClass.toggle(this.separatorNode, "dijitHidden", !total || !this.enableDefaultValue);
            }));
        },

        _defaultOptionSelected: function () {
            // summary:
            //      The callback method for when the default option is selected. Set the
            //      selected project to null.
            // tags:
            //      private
            this.set("selectedProject", null);
            this.emit("change", null);
        },

        _defaultOptionKeypress: function (e) {
            // summary;
            //      Event handler for key presses on the default option to take care of moving focus to the list.
            // tags:
            //      private
            var method;

            switch (e.keyCode) {
                case keys.DOWN_ARROW:
                    method = Keyboard.moveFocusHome;
                    break;
                case keys.PAGE_DOWN:
                    method = Keyboard.moveFocusPageDown;
                    break;
                case keys.END:
                    method = Keyboard.moveFocusEnd;
                    break;
                default:
                    return;
            }

            // Apply the correct method to the list giving the event as argument.
            method.apply(this.list, [e]);
        },

        _defaultOptionMouseover: function () {
            // summary:
            //      Event handler for mouse over on the default option
            //      to take care of moving focus to the button.
            // tags:
            //      private
            this.defaultOption.focus();
        },

        _listEnterKeypress: function (e) {
            // summary:
            //      Select the given row when the enter key is pressed.
            // tags:
            //      private

            // Clear the selection first. This ensures we don't end up with multiple items selected.
            this.list.clearSelection();
            this.list.select(e);
        },

        _listNavigateUp: function (e) {
            // summary;
            //      Event handler for page up and arrow up key presses on the list to take care of
            //      moving focus to the default option when the first row is selected in the list.
            // tags:
            //      private
            var list = this.list,
                row = list.row(e),
                previousRow = list.up(row, 1, true);

            // If row and previous row are the same then the first row is selected.
            if (row.id === previousRow.id) {
                this.defaultOption.focus();
            }
        },

        _listNavigateHome: function () {
            // summary:
            //      Event handler for a HOME key press on the list to take care of moving
            //      focus to the default option.
            // tags:
            //      private
            this.defaultOption.focus();
        },

        _listMouseover: function (e) {
            // summary:
            //      Event handler for mouse over on the list to take care
            //      of moving focus to the hovered list item.
            // tags:
            //      private
            var row = this.list.row(e);
            this.list.focus(row);
        },

        _sortChanged: function (evt) {
            //Only set value if its different from the model value
            var value = this.model[evt];
            if (this.list.get("sort") !== value) {
                this.list.set("sort", value);
            }
        },

        _setSelectedProjectAttr: function (selectedProject) {
            // summary:
            //      Sets the selected project and ensures the UI is in the correct state.
            // tags:
            //      protected
            this._set("selectedProject", selectedProject);

            // Clear the value regardless if there is a value or not. This ensures we don't
            // end up with multiple items selected.
            this.list.clearSelection();
            if (selectedProject) {
                this.list.select(selectedProject.id);
            }

            this._updateView();
        },

        _updateView: function () {
            // summary:
            //      Updates the view to ensure it matches the current model state.
            // tags:
            //      private

            // The default option should be checked if there is no selected project.
            this.defaultOption.set("checked", !this.selectedProject);
        },

        _setupProjectSortMenu: function () {
            // summary:
            //      Set up the project sort menu
            // tags:
            //      private

            var configuration = [{
                builder: new ExpandoMenuBuilder({
                    settings: {
                        "class": "epi-flat epi-chromeless",
                        iconClass: "epi-iconSort",
                        showLabel: false,
                        label: res.command.sort.label
                    }
                }),
                category: "context",
                target: this.toolbarGroupNode
            }
            ];

            this.own(
                new MenuAssembler({
                    configuration: configuration,
                    commandSource: this.model
                })
            );
        }
    });
});

},
'epi/shell/command/_WidgetCommandBinderMixin':function(){
﻿define("epi/shell/command/_WidgetCommandBinderMixin", [
    "dojo/_base/declare",
    "epi/shell/command/_CommandConsumerMixin"
], function (declare, _CommandConsumerMixin) {

    return declare(null, {
        // summary:
        //      A mixin for widgets that will automatically push commands from a provider(view model)
        //      to the closest parent widget which is a consumer.
        // tags:
        //      internal

        commandProvider: null,

        _consumerHandle: null,

        startup: function () {
            // summary:
            //		Adds this provider to the closest parent widget which is a consumer.
            // tags:
            //		protected

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            var consumer = this.getConsumer();
            if (!consumer) {
                return;
            }

            this._consumerHandle = consumer.addProvider(this.commandProvider || this);

            this.commandProvider.initializeCommandProviders && this.commandProvider.initializeCommandProviders();
        },

        getConsumer: function () {
            // summary:
            //		Gets the closest command consumer in the hierarchy.
            // tags:
            //		protected

            if (this.isInstanceOf(_CommandConsumerMixin)) {
                return this;
            }

            var parent = this.getParent();
            while (parent) {
                if (parent.isInstanceOf(_CommandConsumerMixin)) {
                    return parent;
                }
                parent = parent.getParent();
            }
        },

        destroy: function () {
            // summary:
            //		Remove the provider from any consumers.
            // tags:
            //		public

            this._consumerHandle && this._consumerHandle.removeProvider();

            this.inherited(arguments);
        }
    });
});

},
'epi/shell/command/builder/ExpandoMenuBuilder':function(){
﻿define("epi/shell/command/builder/ExpandoMenuBuilder", [
    "dojo/_base/declare",
    "dojo/_base/lang",

    "../_CommandModelBindingMixin",
    "./ButtonBuilder",

    "epi/shell/widget/ExpandoMenuButton"
],

function (
    declare,
    lang,

    _CommandModelBindingMixin,
    ButtonBuilder,

    ExpandoMenuButton
) {

    return declare([ButtonBuilder], {
        // summary:
        //      Used to assemble an expando menu where all toggle commands is represented by expando buttons
        //      and the subsequent commands will be added as sub commands to the previous expando button
        // tags:
        //      internal

        _expandoClass: declare([ExpandoMenuButton, _CommandModelBindingMixin]),

        _expandoMenu: null,

        _create: function (/*epi/shell/command/_Command*/command) {
            // tags:
            //      protected override

            var hasOptions, isToggle;

            // If the command specifies a widget, just return it (not that beautiful)
            // used by the project selector in the eye expando-button.
            if (command.widget) {
                return command.widget;
            }

            hasOptions = command.get("options") instanceof Array;
            isToggle = typeof command.active === "boolean";

            if (!hasOptions && isToggle) {
                return this._expandoMenu = new this._expandoClass(this._createOptions(command));
            }

            return this.inherited(arguments);
        },

        _createOptions: function (/*epi/shell/command/_Command*/command) {
            // tags:
            //      protected

            return lang.mixin({
                innerText: command.innerText,
                showLabel: !!command.showLabel,
                hideSingleOption: !!command.hideSingleOption,
                settings: command.settings
            }, this.inherited(arguments));
        },

        _addToContainer: function (/*Object*/widget, /*Object*/container) {
            // summary:
            //      If the widget
            // tags:
            //      protected override

            // Any command other than expando menu buttons will be added as children to previously created expando menu button
            if (!(widget instanceof ExpandoMenuButton) && this._expandoMenu) {
                container = this._expandoMenu;
            }

            this.inherited(arguments, [widget, container]);
        }
    });
});

},
'epi/shell/widget/ExpandoMenuButton':function(){
require({cache:{
'url:epi/shell/widget/templates/ExpandoMenuButton.html':"﻿<span class=\"dijit dijitReset dijitInline epi-mediumButton epi-expandoMenuButton\"><!--\r\n --><button data-dojo-attach-point=\"toggleButton\" data-dojo-type=\"dijit/form/ToggleButton\" class=\"epi-chromelessButton\"\r\n        data-dojo-attach-event=\"onChange: _toggleButtonChange, onClick:_toggleButtonClick\" showlabel=\"false\">${label}</button><!--\r\n    --><ul data-dojo-attach-point=\"expandoNode\" class=\"dijitHidden\"><li data-dojo-attach-point=\"innerTextContainerNode\" class=\"epi-expandoMenuButton--no-children\"><span class=\"epi-expandoMenuButton--no-children-text\" data-dojo-attach-point=\"innerTextNode\"></span></li></ul><!--\r\n--></span>\r\n"}});
define("epi/shell/widget/ExpandoMenuButton", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/on",

    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/dom-construct",

    "dojo/has",

    "dojo/text!./templates/ExpandoMenuButton.html",

    "dijit/registry",
    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_TemplatedMixin",

    "dgrid/util/has-css3",

    // Widgets used in the template
    "dijit/form/ToggleButton"
],

function (
    declare,
    lang,
    array,
    on,

    domClass,
    domGeometry,
    domStyle,
    domConstruct,
    has,

    template,

    registry,
    _WidgetBase,
    _WidgetsInTemplateMixin,
    _TemplatedMixin
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //    A toggle button wrapping child buttons inside a slide-out panel only visible when enabled/checked
        //
        // tags:
        //    internal

        // templateString: [protected] String
        //      Widget's template string.
        templateString: template,

        // value: [public] String
        //      Represents the label/tooltip of this button.
        label: "",

        // tooltip: [public] String
        //      Represents the tooltip of this button.
        tooltip: "",

        // showLabel: [public] Boolean
        //      Flags that represents the show or hide the label.
        showLabel: false,

        // innerText: [public] String
        //      The text displayed if there are no children added to the button
        innerText: "",

        iconClass: "",

        // hideSingleOption: [public] Boolean
        //      Flag to indicate whether the children should be hidden
        //      when the button has only 1 child, and that child has only 1 option
        hideSingleOption: false,

        postCreate: function () {
            // summary:
            //      Post widget creation.
            // tags:
            //      protected
            this.inherited(arguments);

            if (has("css-transitions")) {
                this.own(on(this.expandoNode, has("transitionend"), lang.hitch(this, this._onTransitionEnd)));
            }
        },

        _setLabelAttr: function (label) {
            this.toggleButton.set("label", label);
            this._set("label", label);
        },

        _setTooltipAttr: function (tooltip) {
            this.toggleButton.titleNode.title = tooltip;
            this._set("tooltip", tooltip);
            if (!this.showLabel && !("title" in this.params)) {
                this.toggleButton.titleNode.title = (this.toggleButton.containerNode.innerText || this.toggleButton.containerNode.textContent || "").trim();
            }
        },

        _setShowLabelAttr: function (value) {
            this.toggleButton.set("showLabel", value);
            this._set("showLabel", value);
        },

        _setInnerTextAttr: function (innerText) {
            this._set("innerText", innerText);

            if (innerText) {
                this.innerTextNode.textContent = innerText;
            }

            domClass.toggle(this.innerTextContainerNode, "dijitHidden", !innerText);
        },

        _setIconClassAttr: function (iconClass) {
            this._set("iconClass", iconClass);
            this._updateToggleButtonIcon();
        },

        _setCheckedAttr: function (isChecked) {
            if (isChecked) {
                this.domNode.classList.add("epi-expandoMenuButton--active");
                var activeMessage = this.settings && this.settings.statusMessages && this.settings.statusMessages.active;
                if (activeMessage) {
                    this.toggleButton.set("label", activeMessage);
                }
            } else {
                this.toggleButton.set("label", this.label);
                this.domNode.classList.remove("epi-expandoMenuButton--active");
            }

            this.toggleButton.set("checked", isChecked);
            this._set("checked", isChecked);
            this._updateToggleButtonIcon();
            this._showChildren(isChecked);
        },

        addChild: function (widget) {
            // summary:
            //      Add the widget as a child node.

            // Hide the innerText node if a new child is added
            if (this.innerTextContainerNode) {
                domClass.add(this.innerTextContainerNode, "dijitHidden");
            }

            var li = domConstruct.create("li", {}, this.expandoNode);
            widget.placeAt(li);
        },

        onClick: function () {
            // summary:
            //      Will be raised whenever the view setting button is clicked.
        },

        onChange: function (val) {
            // summary:
            //      Will be raised when the view setting button state changes.
        },

        getChildren: function () {
            return registry.findWidgets(this.expandoNode);
        },

        _toggleButtonClick: function () {
            // tags:
            //      private

            this.onClick();
        },

        _toggleButtonChange: function (val) {
            // summary:
            //      Toggles visibility of child buttons and raises onChange
            // tags:
            //      private

            this.set("checked", val);
            this.onChange(val);
        },

        _updateToggleButtonIcon: function () {
            // summary:
            //      Updates the icon on the toggle button based on our current state.
            // tags:
            //      private

            var iconClasses = [];

            // Add the icon class if there is one.
            if (this.iconClass) {
                iconClasses.push(this.iconClass);
            }
            // Add the active state class if checked is true.
            if (this.checked) {
                iconClasses.push("epi-icon--active");
            }

            this.toggleButton.set("iconClass", iconClasses.join(" "));
        },

        _shouldHideChildren: function () {
            if (!this.hideSingleOption) {
                return false;
            }

            var self = this;
            var childrenCount = function () {
                var children = self.getChildren();
                return children ? children.length : 0;
            };
            var firstChildOptionsCount = function () {
                var firstChild = self.getChildren()[0];
                var options = firstChild.model.get("options");
                return options ? options.length : 0;
            };

            return (childrenCount() === 1) && (firstChildOptionsCount() === 1);
        },

        /*
             *  CSS transition support
             */
        _showChildren: function (show) {
            // summary:
            //      Show/Hide the children using css animation

            var node = this.expandoNode;
            show = show && !this._shouldHideChildren();
            if (show) {
                domClass.toggle(node, "dijitHidden", false);
                domStyle.set(node, "width", this._childrenWidth() + "px");
            } else {
                domStyle.set(node, "width", this._childrenWidth() + "px");
                // Force repaint
                node.offsetWidth; // eslint-disable-line no-unused-expressions
                domStyle.set(node, "width", "0px");
            }
        },

        _onTransitionEnd: function () {
            var visible = this.get("checked") && !this._shouldHideChildren();

            // Must be set to display:none after transition to not take part in keyboard navigation
            domClass.toggle(this.expandoNode, "dijitHidden", !visible);
            if (visible) {
                // Let it auto-size
                domStyle.set(this.expandoNode, "width", "");
            }
        },

        _childrenWidth: function () {
            // summary:
            //      Calculates and returns the total width of the children

            var width = 0;
            array.forEach(this.expandoNode.childNodes, function (child) {
                // Children are wrapped in <li> which will be the domNodes parent node.
                width += domGeometry.getMarginBox(child).w;
            });
            return width;
        }

    });
});

},
'url:epi/shell/widget/templates/ExpandoMenuButton.html':"﻿<span class=\"dijit dijitReset dijitInline epi-mediumButton epi-expandoMenuButton\"><!--\r\n --><button data-dojo-attach-point=\"toggleButton\" data-dojo-type=\"dijit/form/ToggleButton\" class=\"epi-chromelessButton\"\r\n        data-dojo-attach-event=\"onChange: _toggleButtonChange, onClick:_toggleButtonClick\" showlabel=\"false\">${label}</button><!--\r\n    --><ul data-dojo-attach-point=\"expandoNode\" class=\"dijitHidden\"><li data-dojo-attach-point=\"innerTextContainerNode\" class=\"epi-expandoMenuButton--no-children\"><span class=\"epi-expandoMenuButton--no-children-text\" data-dojo-attach-point=\"innerTextNode\"></span></li></ul><!--\r\n--></span>\r\n",
'epi-cms/project/viewmodels/ProjectSelectorListViewModel':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",
    "dojo/Stateful",
    "dojo/when",
    // dijit
    "dijit/Destroyable",

    //epi
    "epi/dependency",
    "epi/shell/command/OptionCommand",
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.sort"
], function (
    // dojo
    declare,
    lang,
    Evented,
    Stateful,
    when,
    // dijit
    Destroyable,

    // epi
    dependency,
    OptionCommand,
    localizations
) {
    return declare([Stateful, Destroyable, Evented], {
        // summary:
        //      The view model for the epi-cms/project/ProjectSelectorList
        // tags:
        //      internal

        // namedCommands: [readonly] Object
        //      Way to access commands using named keys.
        namedCommands: null,

        // profile: [readonly] Profile
        //      The current user profile
        profile: null,

        // projectSortOrder: [public] Object
        //      The order to sort project items by.
        //
        projectSortOrder: null,

        // _commands: [readonly] epi/shell/command/_Command[]
        //      Commands to be consumed by the view.
        // tags:
        //      private
        _commands: null,

        _sortOrderProfileKey: "epi.project-sort-order",

        constructor: function () {
            // Initialize default value
            this.projectSortOrder = [{ attribute: "name", descending: false }];
        },
        postscript: function () {
            this.inherited(arguments);

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");

            this._createCommands();
        },

        initialize: function () {
            // summary:
            //
            // returns: Promise
            //
            // tags:
            //      public

            return when(this.profile.get(this._sortOrderProfileKey), lang.hitch(this, function (sort) {
                var option = this._findSortOption("key", sort) || this.namedCommands.sortProject.options[0]; // default to name ascending
                this._changeAttrValue("projectSortOrder", option.value); // use the internal setter to not trigger a profile save
            }));
        },

        getCommands: function () {
            // summary:
            //      Returns all available commands
            // tags:
            //      public

            return this._commands;
        },

        _projectSortOrderSetter: function (sortOrder) {
            // summary:
            //      Store the sort order in the user profile
            //
            var option,
                key;

            if (sortOrder === null || (sortOrder && sortOrder === this.projectSortOrder)) {
                return;
            }

            this.projectSortOrder = sortOrder;

            option = this._findSortOption("value", sortOrder);
            key = option && option.key || null;

            this.profile.set(this._sortOrderProfileKey, key, {
                location: "server"
            });

        },

        _findSortOption: function (key, term) {

            var options = this.namedCommands.sortProject.options,
                option = null;

            term && options.some(function (item) {
                if (term === item[key]) {
                    option = item;
                    return true;
                }
            });

            return option;
        },

        _createCommands: function () {

            // TODO:
            // CSS classes to be used for toggleable sort options
            // .epi-iconSort
            // .epi-iconSortDescending
            // .epi-iconSortAscending

            var sortProject = new OptionCommand({
                model: this,
                category: "context",
                label: "label",
                property: "projectSortOrder",
                options: [{
                    label: localizations.nameascending,
                    key: "+Name",
                    value: [{
                        attribute: "name",
                        descending: false
                    }]
                }, {
                    label: localizations.namedescending,
                    key: "-Name",
                    value: [{
                        attribute: "name",
                        descending: true
                    }]
                }, {
                    label: localizations.createddescending,
                    key: "-DateCreated",
                    value: [{
                        attribute: "created",
                        descending: true
                    }, {
                        attribute: "name",
                        descending: false
                    }]
                }, {
                    label: localizations.createdascending,
                    key: "+DateCreated",
                    value: [{
                        attribute: "created",
                        descending: false
                    }, {
                        attribute: "name",
                        descending: false
                    }]
                }]
            });

            this.set("_commands", [
                sortProject
            ]);

            this.set("namedCommands", {
                sortProject: sortProject
            });
        }
    });
});

},
'url:epi-cms/project/templates/ProjectSelectorList.html':"﻿<div class=\"epi-selector-list epi-menu--inverted\">\r\n    <div class=\"epi-menuInverted epi-invertedTooltip\">\r\n        <div class=\"epi-tooltipDialogTop\">\r\n            <span data-dojo-attach-point=\"headerNode\"></span>\r\n        </div>\r\n        <div data-dojo-type=\"dijit/Toolbar\" data-dojo-attach-point=\"toolbar\" class=\"epi-flatToolbar\">\r\n            <div data-dojo-attach-point=\"toolbarGroupNode\" class=\"epi-floatRight\"></div>\r\n        </div>\r\n        <button class=\"epi-selector-list-btn epi-chromeless\" data-dojo-attach-point=\"defaultOption\" data-dojo-type=\"dijit/form/ToggleButton\" data-dojo-props=\"iconClass:'dijitRadioIcon'\"></button>\r\n        <div data-dojo-attach-point=\"separatorNode\" class=\"epi-selector-list__separator dijitHidden\"></div>\r\n        <div data-dojo-attach-point=\"listNode\"></div>\r\n    </div>\r\n</div>\r\n",
'dgrid/util/mouse':function(){
define(["dojo/on", "dojo/dom", "dojo/query"], function(on, dom){
	function handler(selector, type){
		// summary:
		//		Creates a handler function usable as a simulated event to dojo/on,
		//		which fires only if the mouse is moving into or out of the node of
		//		interest indicated by the selector.
		//		This is similar, but not identical, to what dojo/mouse does.
		// selector: String
		//		Query selector for event delegation.
		// type: String
		//		Event to delegate on (mouseover or mouseout).
		
		return function(node, listener){
			return on(node, selector + ":" + type, function(evt){
				if(!dom.isDescendant(evt.relatedTarget, this)){
					return listener.call(this, evt);
				}
			});
		};
	}
	
	return {
		// Provide enter/leave events for rows, cells, and header cells.
		// (Header row is trivial since there's only one.)
		enterRow: handler(".dgrid-content .dgrid-row", "mouseover"),
		enterCell: handler(".dgrid-content .dgrid-cell", "mouseover"),
		enterHeaderCell: handler(".dgrid-header .dgrid-cell", "mouseover"),
		leaveRow: handler(".dgrid-content .dgrid-row", "mouseout"),
		leaveCell: handler(".dgrid-content .dgrid-cell", "mouseout"),
		leaveHeaderCell: handler(".dgrid-header .dgrid-cell", "mouseout"),
		
		// Also expose the handler function, so people can do what they want.
		createDelegatingHandler: handler
	};
});
},
'epi/shell/dgrid/Focusable':function(){
define("epi/shell/dgrid/Focusable", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dijit/focus"
], function (declare, lang, aspect, focus) {

    return declare([], {
        // tags:
        //      internal

        postCreate: function () {
            this.inherited(arguments);

            // Reset the focus node after the grid is updated. This is a bug in dgrid: https://github.com/SitePen/dgrid/issues/899
            this._listeners.push(aspect.around(this, "_restoreFocus", function (originalMethod) {
                return function (row) {
                    var focusInfo = this._removedFocus;

                    originalMethod.apply(this, arguments);

                    if (!this._focusedNode) {
                        row = row && this.row(row);
                        var newTarget = row && row.element && row.id === focusInfo.rowId ? row :
                            typeof focusInfo.siblingId !== "undefined" && this.row(focusInfo.siblingId);

                        if (newTarget) {
                            this._focusedNode = newTarget.element;
                        }
                    }
                };
            }));
        },

        hasFocus: function () {
            // summary:
            //      Indicates whether the grid currently has focus.
            // tags:
            //      public

            return this._focusedNode && this._focusedNode === focus.curNode;
        },

        isFocusable: function () {
            // summary:
            //      Indicates whether this grid can currently be focused.
            // tags:
            //      public
            return !!this._focusedNode;
        },

        focus: function (element) {
            // summary:
            //      Set focus to the content of the grid.
            // tags:
            //      public

            // Convert the element to null in the case it is a string. This allows the dgrid to be
            // compatible with the dijit/_KeyNavContainer.
            if (typeof element == "string") {
                element = null;
            }
            this.inherited(arguments, [element]);
        },

        refresh: function (options) {
            // summary:
            //      Refreshes the contents of the grid.
            // options: Object?
            //      Optional object, supporting the following parameters:
            //      * refocus: like the refocusOnRefresh instance property;
            //          specifying it in the options here will override the instance
            //          property's value for this specific refresh call only.
            // tags:
            //      public

            var refocus = options && options.refocus,
                afterRefresh = function (results) {
                    if (this._refocusNode) {
                        this.focus(this.row(this._refocusNode).element);
                        this._refocusNode = null;
                    }
                    return results;
                };

            // Fallback to instance property if option is not defined.
            if (typeof refocus === "undefined") {
                refocus = this.refocusOnRefresh;
            }

            // If the grid has focus and we should refocus on refresh then save the ID of the
            // currently focused node.
            if (refocus && this.hasFocus()) {
                this._refocusNode = this.row(this._focusedNode).id;
            }

            // If the inherited method returns a promise then it is an on demand list and we should
            // bind the after refresh method to the promise.
            var promise = this.inherited(arguments);
            if (promise) {
                return promise.then(afterRefresh.bind(this));
            }
        }
    });
});

},
'epi/shell/dgrid/selection/Exclusive':function(){
define("epi/shell/dgrid/selection/Exclusive", ["dojo/_base/declare"], function (declare) {

    return declare([], {
        // summary:
        //      Adds exclusive item selection to a list or grid. The exclusive selection mode allows
        //      only one item to be selected at a time. The difference from the single selection mode
        //      is that an item can not be deselected via a ctrl/cmd click.
        //
        // tags:
        //      public

        _exclusiveSelectionHandler: function (event, target) {
            // summary:
            //      Selection handler for "exclusive" mode, where only one target may be
            //      selected at a time and can not be deselected.
            // tags:
            //      private
            if (this._lastSelected !== target) {
                this.clearSelection();
                this.select(target);
                this._lastSelected = target;
            }
        }
    });
});

},
'epi-cms/contentediting/command/LanguageSelection':function(){
define([
    "dojo/_base/declare",
    // Parent class
    "epi/shell/command/OptionCommand",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting"
], function (
    declare,
    // Parent class
    OptionCommand,
    // Resources
    resources
) {

    return declare([OptionCommand], {
        // summary:
        //      A command for selecting the current compare view
        // tags:
        //      internal

        optionsLabel: resources.contentdetails.existinglanguages,

        active: false,

        // selected: [readonly] String
        //		The value of the selected item from the options array. Defaults to an empty string
        //		so that it matches the model's default value.
        selected: "",

        _selectedSetter: function (selected) {
            // summary:
            //      Overridden to set label based on the currently selected option
            this.inherited(arguments);

            if (typeof (selected) ==  "string" && selected !== "") {
                this.set("label", selected.toUpperCase());
                if (selected !== this.model.get("documentLanguage")) {
                    this.set("active", true);
                } else {
                    this.set("active", false);
                }
            }

        }

    });
});

},
'epi-cms/contentediting/viewmodel/LanguageSettingsModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/Stateful",
    "dojo/when",
    "dojo/Deferred",
    "epi/dependency",
    "epi-cms/component/SiteTreeModel"
], function (
    declare,
    lang,
    topic,
    Stateful,
    when,
    Deferred,
    dependency,
    SiteTreeModel,
    Destroyable
) {

    return declare([Stateful], {
        // summary:
        //      Model for settings related to property compare view settings
        // tags: internal

        // enabled: [public] Boolean
        //      A flag telling whether view mode is enabled
        enabled: false,

        // selectedLanguage: [public] String
        //      The current document language
        documentLanguage: "",

        // selectedLanguage: [public] String
        //      The currently active language
        selectedLanguage: "",

        // availableLanguages: [readonly] Array[object]
        //      An array of the available languages
        availableLanguages: [],

        // profile: Object
        //      Instance of profile
        profile: null,

        // siteTreeModel: Object
        //      Instance of SiteTreeModel
        siteTreeModel: null,

        postscript: function () {
            this.inherited(arguments);

            if (!this.siteTreeModel) {
                var registry = dependency.resolve("epi.storeregistry"),
                    siteStructureStore = registry.get("epi.cms.sitestructure");
                this.siteTreeModel = new SiteTreeModel({store: siteStructureStore});
            }

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");

            //Get the content language
            this.siteTreeModel.getCurrentSite()
                .then(lang.hitch(this, "_setAvailableLanguages"))
                .then(lang.hitch(this, function () {
                    when(this.profile.getContentLanguage(), lang.hitch(this, function (language) {
                        this.set("documentLanguage", language);
                        this.set("selectedLanguage", language, false);
                    }));
                }));

        },

        _setAvailableLanguages: function (site) {
            if (site) {
                var def = new Deferred();
                this.siteTreeModel.getChildren({ url: site.currentSite }, lang.hitch(this, function (languages) {
                    var obj = languages.filter(function (item) {
                        return (item.languageId && item.name);
                    }).map(function (item) {
                        return { label: item.name, value: item.languageId };
                    });
                    this.set("availableLanguages", obj);
                    def.resolve();
                }));
                return def.promise;
            } else {
                return new Deferred().resolve();
            }
        },

        _enabledSetter: function (enabled) {
            if (this.enabled !== enabled) {
                this.enabled = enabled;
                topic.publish("/epi/cms/action/eyetoggle", enabled);
            }
        },

        _selectedLanguageSetter: function (value, evented) {
            if (evented !== false) {
                topic.publish("/epi/cms/action/viewsettingvaluechanged", "viewlanguage", value);
            }
        }

    });

});

},
'epi-cms/component/SiteTreeModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/Deferred",
    "dojo/when",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/cookie",
    "dijit/Destroyable",
    "epi/dependency"
],
function (array, declare, Stateful, Deferred, when, lang, connect, cookie, Destroyable, dependency) {

    return declare([Stateful, Destroyable], {
        // summary:
        //      Represents the site tree in a specified language.
        // tags:
        //      internal

        query: null,

        // name: [public] Boolean
        //		A flag indicating whether all languages should be shown in the site tree.
        showAllLanguages: true,

        location: document.location,

        profile: null,

        store: null,

        constructor: function () {
            this.query = { allLanguages: this.showAllLanguages };
        },

        postscript: function () {
            this.inherited(arguments);

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");

            this.own(
                connect.subscribe("/epi/cms/contentdata/updated", lang.hitch(this, function () {
                    //when the language settings dialog is closed, get the current site
                    when(this.getCurrentSite(), lang.hitch(this, function (config) {
                        //reload the children for the current site
                        this.onItemChildrenReload({ siteUrl: config.currentSite });
                    }));
                }))
            );
        },

        // Methods for traversing hierarchy
        getRoot: function (onItem, onError) {
            // summary:
            //		Calls onItem with the root item for the tree, possibly a fabricated item.

            // Do dummy call to onItem. We won't actually show the root, we just want to call getchildren with an empty object.
            onItem({});
        },

        getIdentity: function (item) {
            // summary:
            //		Gets the identity for the specified item

            var id = this.store.getIdentity(item);

            // We need to have an id for our dummy root node
            if (!id && !item.isLanguageNode) {
                id = "root";
            }

            return id;
        },

        onItemChildrenReload: function (/*Object*/parent) {
            // summary:
            //  Raised when the children of an item must be reloaded.
            //  The subscriber needs to call getChildren to get the updated children collection
        },

        mayHaveChildren: function (item) {
            // summary:
            //		Tells if an item has or may have children.  Implementing logic here
            //		avoids showing +/- expando icon for nodes that we know don't have children.
            //		(For efficiency reasons we may not want to check if an element actually
            //		has children until user clicks the expando node)

            if (!item.isLanguageNode) {
                return true;
            }

            return false;
        },

        getLabel: function (item) {
            // summary:
            //		Gets the label for the specified item.
            //      This is the text that will be visible in the tree.

            return item.name;
        },

        getChildren: function (parentItem, onComplete) {
            // summary:
            //		Gets the children for the specified item.
            //      The children of a site, identified by the url, is the enabled languages for that site.

            when(this.store.query(lang.mixin({ siteUrl: parentItem.url }, this.query)), onComplete);
        },

        _setQuery: function (q) {
            // summary:
            //  Updates the query of the model and raises the onItemChildrenReload event.

            this.query = q;
            this.onItemChildrenReload({});
        },

        _showAllLanguagesSetter: function (value) {
            this.showAllLanguages = value;
            this._setQuery({ allLanguages: value });
        },

        getCurrentSite: function () {

            var def = new Deferred();

            when(this.profile.getContentLanguage(), lang.hitch(this, function (languageBranch) {
                if (languageBranch) {
                    when(this.store.get(), lang.hitch(this, function (sites) {
                        var returnValue = null;
                        var wildcardSite = null;

                        // Find the site with the wildcard mapping
                        array.some(sites, function (site) {
                            return array.some(site.hosts, function (host) {
                                if (host === "*") {
                                    wildcardSite = site;
                                    return true;
                                }
                            });
                        });

                        var currentHost = this.location.host.toLowerCase();
                        var wasSiteFound = array.some(sites, function (site) {
                            return array.some(site.hosts, function (host) {
                                //Check if the HostUrl is a part of the documentHref
                                if (currentHost === host.toLowerCase()) {
                                    returnValue = {
                                        currentSite: site.url,
                                        currentEditLanguageId: site.url + languageBranch
                                    };
                                    return true;
                                }
                            });
                        });

                        // if the site wasn't found and we have a wildcard site return that one
                        if (!wasSiteFound && wildcardSite) {
                            returnValue = {
                                currentSite: wildcardSite.url,
                                currentEditLanguageId: wildcardSite.url + languageBranch
                            };
                        }

                        if (returnValue) {
                            // Success, found the site
                            def.resolve(returnValue);
                        } else {
                            // No matching found
                            def.cancel();
                        }
                    }),

                    function () {
                        // Error while getting
                        def.reject(null);
                    });

                } else {
                    // No cookie
                    def.reject(null);
                }
            }));

            return def;
        },

        getAllLanguagesForSite: function (siteUrl) {

            var def = new Deferred();

            when(this.store.query({ siteUrl: siteUrl, allLanguages: true }), function (items) {
                def.resolve(items);
            });

            return def;
        },

        getAllLanguagesForCurrentSite: function () {

            var def = new Deferred();

            when(
                this.getCurrentSite(),

                lang.hitch(this, function (config) {

                    this.getAllLanguagesForSite(config.currentSite).then(function (items) {
                        def.resolve(items);
                    });

                }),

                function (result) {
                    def.reject(result);
                }
            );

            return def;
        }
    });
});

},
'epi-cms/command/DeviceSelection':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "epi/shell/DestroyableByKey",
    "epi/shell/command/OptionCommand",
    "epi-cms/command/_NonEditViewCommandMixin",

    "epi-cms/contentediting/viewmodel/DeviceSelectionSettingsModel"
], function (declare,
    lang,
    on,
    DestroyableByKey,
    OptionCommand,
    _NonEditViewCommandMixin,
    DeviceSelectionSettingsModel) {
    return declare([OptionCommand, _NonEditViewCommandMixin, DestroyableByKey], {
        // summary:
        //      Command providing the channel and resolution selection for the top menu
        // tags:
        //      internal

        iconClass: "epi-iconDevice",
        optionsProperty: "options",
        canExecute: true,
        active: false,

        _hasOptions: false,

        postscript: function () {
            this.inherited(arguments);
            if (!this.model) {
                this.set("model", new DeviceSelectionSettingsModel());
            }
            this.own(on(this.model, "optionsChanged", function (options) {
                this._hasOptions = options.length > 0;
                this.set("isAvailable", this._hasOptions);
                this.set("canExecute", this._hasOptions);
            }.bind(this)));
        },

        _updateFromModel: function () {
            // summary:
            //      Update the state of the command from the current model state
            //
            // tags: private

            this.set("label", this.model.get("label"));
            this.set("active", !!(this.model.get("resolution") || this.model.get("channel")));
        },

        _onModelChange: function () {
            // summary:
            //      Watches the model for property changes and updates our state accordingly

            this.inherited(arguments);

            var modelWatchKey = "_ChannelCommandModelWatch";

            this.destroyByKey(modelWatchKey);

            if (this.model) {
                this._updateFromModel();
                this.ownByKey(modelWatchKey, this.model.watch(lang.hitch(this, function (name, oldValue, newValue) {
                    if (["label", "resolution", "channel"].indexOf(name) !== -1) {
                        this._updateFromModel();
                    }
                })));
            }
        },

        _viewChanged: function (type, args, data) {
            this.inherited(arguments);

            if (!this._hasOptions) {
                this.set("isAvailable", false);
            } else if (data && data.hideView) {
                // hide the DeviceSelection icon if content has no view
                this.set("isAvailable", false);
            }
        }
    });
});

},
'epi-cms/contentediting/viewmodel/DeviceSelectionSettingsModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",
    "dojo/Stateful",
    "dojo/topic",
    "epi/dependency",
    "epi-cms/ApplicationSettings",
    "epi/shell/command/OptionGroup",
    "epi/i18n!epi/cms/nls/episerver.cms.widget"
], function (
    declare,
    lang,
    Evented,
    Stateful,
    topic,
    dependency,
    ApplicationSettings,
    OptionGroup,
    resources
) {

    return declare([Stateful, Evented], {
        // summary:
        //      Settings model for channel and resolution view settings
        // tags: internal

        // resolution: [public] Boolean
        //      A string in the format "[width]x[height]" indicating the current view resolution; or null if none is set.
        resolution: null,

        // channel: [public] String
        //      A string indicating the current display channel; or null if none is active.
        channel: null,

        postscript: function () {
            this.inherited(arguments);

            this._updateLabel();

            if (!this.get("viewSettingsManager")) {
                this.set("viewSettingsManager", dependency.resolve("epi.viewsettingsmanager"));
            }

            if (!this.get("channelStore")) {
                var registry = dependency.resolve("epi.storeregistry");
                this.set("channelStore", registry.get("epi.cms.displaychannels"));
            }
        },

        _resolutionSetter: function (resolution) {
            // summary:
            //      Sets a new display resolution.
            //      The /epi/cms/action/viewsettingvaluechanged will be published when the value changes.

            if (resolution !== this.resolution) {
                this.resolution = resolution;
                this._onChange();
            }
        },

        _channelSetter: function (channel) {
            // summary:
            //      Sets a new display channel.
            //      The /epi/cms/action/viewsettingvaluechanged will be published when the value changes.

            if (channel !== this.channel) {
                this.channel = channel;
                this.set("resolution", this._getDefaultResolutionForChannel(channel));
                this._onChange();
            }
        },

        _viewSettingsManagerSetter: function (viewSettingsManager) {
            // summary:
            //      Sets the resolution and channel property when the viewSettingsManager is changed

            this.viewSettingsManager = viewSettingsManager;

            this.set("resolution", viewSettingsManager.getSettingProperty("resolution"));
            this.set("channel", viewSettingsManager.getSettingProperty("epichannel"));
        },

        _channelStoreSetter: function (store) {
            // summary:
            //      Sets the channel store and initializes the options collection

            this.channelStore = store;
            this._initialize();
        },

        _onChange: function () {
            // summary:
            //      Updates the label property and publishes an /epi/cms/action/viewsettingvaluechanged topic
            //      with the current resolution and channel selection
            // tags: private

            this._updateLabel(this.get("resolution"), this.get("channel"));

            var messageData = [
                { key: "resolution", value: this.get("resolution") },
                { key: "epichannel", value: this.get("channel") }
            ];
            topic.publish("/epi/cms/action/viewsettingvaluechanged", messageData);
        },

        _updateLabel: function (resolution, channel) {
            // summary:
            //      Updates the label property with text informing about the currently selected resolution and channel
            // tags: private

            var hasChannels = this._availableChannels && this._availableChannels.length > 0;
            var hasResolutions = this._availableResolutions && this._availableResolutions.length > 0;

            var tooltip;
            if (hasChannels && hasResolutions) {
                tooltip = resources.channelbutton.defaulttooltip;
                if (resolution || channel) {
                    tooltip = lang.replace(resources.channelbutton.tooltip, {
                        channel: this._getOptionLabel(this._availableChannels, channel),
                        resolution: this._getOptionLabel(this._availableResolutions, resolution)
                    });
                }
            } else if (hasChannels) {
                tooltip = resources.channelbutton.channeldefaulttooltip;
                if (channel) {
                    tooltip = lang.replace(resources.channelbutton.channeltooltip, {
                        channel: this._getOptionLabel(this._availableChannels, channel)
                    });
                }
            } else {
                tooltip = resources.channelbutton.resolutiondefaulttooltip;
                if (resolution) {
                    tooltip = lang.replace(resources.channelbutton.resolutiontooltip, {
                        resolution: this._getOptionLabel(this._availableResolutions, resolution)
                    });
                }
            }

            this.set("label", tooltip);
        },

        _getOptionLabel: function (options, value) {
            // summary:
            //      Gets the label from an option having a matching value in the options array
            // tags: private

            var match = this._find(options, function (item) {
                return item.value === value;
            });
            return match && match.label || "";
        },

        _initialize: function () {
            // summary:
            //      Updates the options collection with the available resolutions and channels

            this.channelStore.query({query: "getallregistered"}).then(lang.hitch(this, function (registeredChannels) {
                this._availableResolutions = this._getAvailableResolutions();
                this._availableChannels = [];

                if (registeredChannels.length > 0) {
                    this._availableChannels = [{value: null, label: resources.channelselector.defaultitem}].concat(
                        registeredChannels.map(function (channel) {
                            return {
                                value: channel.channelName,
                                label: channel.name,
                                resolutionId: channel.resolutionId
                            };
                        }));
                }

                var options = [];
                // Only add channels if the ui is not limited
                if (this._availableChannels.length > 0) {
                    if (!ApplicationSettings.limitUI) {
                        options.push(
                            new OptionGroup({
                                property: "channel",
                                model: this,
                                label: resources.channelselector.header,
                                options: this._availableChannels
                            })
                        );
                    }
                }
                if (this._availableResolutions && this._availableResolutions.length > 0) {
                    options.push(
                        new OptionGroup({
                            property: "resolution",
                            model: this,
                            label: resources.resolutionselector.header,
                            options: this._availableResolutions
                        })
                    );
                }
                this.set("options", options);
                this.emit("optionsChanged", options);
                this._updateLabel(this.get("resolution"), this.get("channel"));
            }));
        },

        _getAvailableResolutions: function () {
            // summary:
            //      Returns an option group containing the available resolution options based on the Application settings
            // tags: private

            if (ApplicationSettings.displayResolutions && ApplicationSettings.displayResolutions.length > 0) {
                var resolutions = [{ value: null, label: resources.channelselector.defaultitem }];
                resolutions = resolutions.concat(
                    ApplicationSettings.displayResolutions.map(function (r) {
                        return {
                            value: r.width + "x" + r.height,
                            label: r.name,
                            id: r.id
                        };
                    })
                );
                return resolutions;
            }

            return [];
        },

        _getDefaultResolutionForChannel: function (/*Object*/channel) {
            // summary:
            //    Get the default resolution for a given a channel.
            //
            // tags:
            //    private

            var availableResolutions = this._availableResolutions;
            if (!(channel && lang.isArray(availableResolutions))) {
                return null;
            }

            channel = this._find(this._availableChannels, function (c) {
                return c.value === channel;
            });
            var resolution = this._find(availableResolutions, function (r) {
                return (r.id === channel.resolutionId);
            });

            return resolution ? resolution.value : null;
        },

        _find: function (array, criterion) {
            // summary:
            //      Returns the first matching element in an array based on the supplied criterion callback.

            var match = null;

            if (!lang.isArray(array)) {
                return null;
            }
            array.some(function (element) {
                if (criterion(element)) {
                    match = element;
                    return true;
                }
            });
            return match;
        }

    });
});

},
'epi-cms/content-activity/command/ContentActivityCommandProvider':function(){
define([
    "dojo/_base/declare",
    "dijit/form/ToggleButton",
    "epi-cms/component/command/_GlobalToolbarCommandProvider",
    "epi-cms/content-activity/command/ContentActivityCommand"

], function (
    declare,
    ToggleButton,
    _GlobalToolbarCommandProvider,
    ContentActivityCommand
) {

    return declare([_GlobalToolbarCommandProvider], {
        // summary:
        //    A command provider providing content activity commands to the global toolbar
        // tags:
        //      internal
        model: null,

        postscript: function () {
            this.inherited(arguments);

            var settings = {
                widget: ToggleButton,
                "class": "epi-chromeless epi-mediumButton"
            };

            this.addToTrailing(new ContentActivityCommand({model: this.model, order: -10001}), settings);
        }
    });
});

},
'epi-cms/content-activity/command/ContentActivityCommand':function(){
define([
    "dojo/_base/declare",
    // Parent class and mixins
    "epi-cms/project/command/ToggleProjectActivities",
    "epi-cms/command/_NonEditViewCommandMixin"
], function (
    declare,
    // Parent class and mixins
    ToggleProjectActivities,
    _NonEditViewCommandMixin

) {
    return declare([ToggleProjectActivities, _NonEditViewCommandMixin], {
        // tags:
        //      internal

        iconClass: "epi-iconBubble epi-icon--medium",

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "content-activities"
    });
});

},
'epi-cms/project/command/ToggleProjectActivities':function(){
define([
    "dojo/_base/declare",
    // Parent class and mixins
    "epi/shell/command/ToggleCommand",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.activities.togglecommand.label"
], function (
    declare,
    // Parent class and mixins
    ToggleCommand,
    // Resources
    localizations
) {

    return declare([ToggleCommand], {
        // tags:
        //      internal

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed.
        canExecute: true,

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "projectButton",

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconBubble",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localizations.show,

        // property: [public] String
        //      The name of the property on the model which this command will toggle.
        property: "isActivitiesVisible",

        _activeSetter: function (active) {
            // summary:
            //      Sets the active property and updates the label to match.
            // tags:
            //      protected

            this.active = active;

            this.set("label", active ? localizations.hide : localizations.show);
        }
    });
});

},
'epi-cms/contentediting/ContentHierarchyService':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/Deferred",
    "dojo/promise/all",

    // epi
    "epi/dependency",
    "epi/shell/DialogService",
    "epi-cms/core/ContentReference"
], function (
// dojo
    declare,
    lang,
    when,
    Deferred,
    all,

    // epi
    dependency,
    dialogService,
    ContentReference
) {

    return declare([], {
        // summary:
        //      A service for interacting with the content hierarchy
        // tags:
        //      internal

        // store: [readonly] Store
        //      A REST store for interacting with content items.
        store: null,

        constructor: function (params) {
            declare.safeMixin(this, params);

            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.content.light");
        },

        move: function (sourceIds, targetId, createAsLocalAsset, sortIndex) {
            // summary:
            //		Move one or several content items from one parent to another.
            // sourceIds: ContentReference || ContentReference[]
            //      The items that should be copied or moved
            // targetId: ContentReference
            //      The target item for the operation
            // createAsLocalAsset: Boolean
            //      If set to true the items will be added to the targets asset folder
            // sortIndex: Number
            //      Optional sortIndex in the child collection of the new parent
            // returns: Response object
            //      An object indicating the result of the operation
            //
            // tags: public

            return this._execute("MoveMany", sourceIds, targetId, createAsLocalAsset, sortIndex);
        },

        copy: function (sourceIds, targetId, createAsLocalAsset, sortIndex) {
            // summary:
            //		Copies one or several  content items from one parent to another.
            // sourceIds: ContentReference || ContentReference[]
            //      The items that should be copied or moved
            // targetId: ContentReference
            //      The target item for the operation
            // createAsLocalAsset: Boolean
            //      If set to true the items will be added to the targets asset folder
            // sortIndex: Number
            //      Optional sortIndex in the child collection of the new parent
            // returns: Response object
            //      An object indicating the result of the operation
            //
            // tags: public

            return this._execute("CopyMany", sourceIds, targetId, createAsLocalAsset, sortIndex);
        },

        _execute: function (method, sourceIds, targetId, createAsLocalAsset, sortIndex) {
            // summary:
            //		Calls the store to execute the defined method.
            //
            // tags: private

            var params = {
                ids: sourceIds instanceof Array ? sourceIds : [sourceIds],
                targetId: targetId + "",
                createAsLocalAsset: createAsLocalAsset,
                sortIndex: sortIndex
            };

            return this.store.executeMethod(method, null, params)
                .then(this._checkForErrors.bind(this))
                .then(this._handleUpdates.bind(this));
        },

        _checkForErrors: function (response) {
            // summary:
            //		Extracts failed operations from the response and id any shows
            //      an error dialog.
            //
            // tags: private

            var deferred = new Deferred(),
                errors = this.store.getAllResponsesWithError(response).map(function (error) {
                    return error.message;
                });

            if (errors.length > 0) {
                dialogService.alertWithErrors({}, errors).then(function () {
                    deferred.resolve(response);
                });
            } else {
                deferred.resolve(response);
            }

            return deferred.promise;
        },

        _handleUpdates: function (response) {
            // summary:
            //		Uses the response items to refresh items in the store
            //      and notify listeners of the changes.
            //
            // tags: private

            var store = this.store,
                itemsToNotify = this._getUpdatesFromResponse(response);

            return all(itemsToNotify.map(function (item) {
                var id = ContentReference.toContentReference(item.extraInformation).createVersionUnspecificReference().toString();
                return store.refresh(id, true);
            })).then(function (items) {
                items.forEach(function (item) {
                    store.notify(item, store.getIdentity(item));
                });

                return response;
            });
        },

        _getUpdatesFromResponse: function (response) {
            // summary:
            //		Extracts all successful changes from the response.
            //
            // tags: private

            var items = response.extraInformation,
                itemsToNotify = [];

            Object.keys(items).forEach(function (id) {
                var item = items[id];
                if (item.statusCode === 200) {
                    itemsToNotify.push(item);
                }
            });

            return itemsToNotify;
        }
    });
});

},
'epi-cms/contentediting/EditorFactory':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/_base/lang",
    "epi-cms/ApplicationSettings"],

function (declare, Deferred, lang, ApplicationSettings) {

    return declare(null, {
        // summary:
        //		Factory class, responsible for creating appropriate editor wrapper.
        //
        // tags:
        //      public

        // defaultWrapperType: [public] String
        //      Default wrappert type
        defaultWrapperType: null,

        // _registeredEditorWrappers: [private] Array
        //      Registered editors array
        _registeredEditorWrappers: null,

        onEditorCreated: function (/*dijit/_Widget*/editorWidget) {
            // summary:
            //    Triggered when the editor widget is created
            // editorWidget:
            //    The newly created widget
            // tags:
            //    public callback
        },

        onEditorResolved: function (/*Object*/data, /*Object*/property) {
            // summary:
            //		Set this handler to be notified when editing and editor wrapper has been resolved.
            //      This might be used to change editor or editor wrapper before the actual instantiation.
            // data:
            //      The resolved settings. Can be changed by listener.
            // property:
            //		The settings for the property that is to be edited.
            // tags:
            //		callback
        },

        constructor: function () {
            // summary:
            //		Sets up private arrays etc.
            // tags:
            //		private
            var uiDefaults = ApplicationSettings.uiDefaults;

            this._registeredEditorWrappers = {};
            this.defaultWrapperType = (uiDefaults && uiDefaults.defaultEditorWrapper) || "floating";
        },

        registerEditorWrapper: function (/*String*/wrapperType, /*Function|String*/wrapperClassType, initializer) {
            // summary:
            //		Create the property editor.
            // wrapperType:
            //      The way the editor is shown: inline or dialog
            // wrapper:
            //      Can either be wrapper class or wrapper class name. Wrapper class must implement epi.cms.contentediting._EditorWrapperBase
            // tags:
            //		public

            this._registeredEditorWrappers[wrapperType] = {
                wrapperClassType: wrapperClassType,
                initializer: initializer
            };
        },

        _handleContentEditable: function (editorWidgetType, wrapperType, metadataUiType) {
            // summary:
            //      ContentEditableEditor only works with contenteditable, so if trying to use it in any other wrapper
            //      type fall back to an editor that works in properties mode.
            //      This is because StringEditorDescriptor isn't working as floating or flyout.
            // tags:
            //      private

            var contentEditableEditor = "epi-cms/contentediting/editors/ContentEditableEditor";

            if (editorWidgetType !== contentEditableEditor || wrapperType === "contenteditable") {
                return editorWidgetType;
            }

            // When UIHint is a Textarea or similar we should use the metadata.uiType, otherwise fall back to a standard textbox.
            var isBaseEditorTypeSafe = metadataUiType && metadataUiType !== contentEditableEditor;
            return isBaseEditorTypeSafe ? metadataUiType : "dijit/form/ValidationTextBox";
        },

        _getWrapperAndEditor: function (/*Object*/property) {
            // summary:
            //		Get wrapper and editor parameter based on the property settings
            // property:
            //      Property object
            // tags:
            //		private

            var wrapperType = property.wrapperType;
            var editorParams = property.editorParams || {};
            var editorWidgetType = property.editorWidgetType;

            if (!wrapperType) {
                if (property.metadata.customEditorSettings && property.metadata.customEditorSettings.uiWrapperType) {
                    wrapperType = property.metadata.customEditorSettings.uiWrapperType;
                } else {
                    //Fallback to default wrapper type.
                    wrapperType = this.defaultWrapperType;
                }
            }

            if (!editorWidgetType) {
                if (property.metadata.customEditorSettings && property.metadata.customEditorSettings.uiType) {
                    editorWidgetType = property.metadata.customEditorSettings.uiType;
                } else if (property.metadata.uiType) {
                    editorWidgetType = property.metadata.uiType;
                } else {
                    editorWidgetType = "epi/shell/widget/FormContainer";
                    lang.mixin(editorParams, {
                        metadata: property.metadata,
                        onFieldCreated: function (fieldName, widget) {

                        }
                    });
                }
            }

            // In case of choosing ContentEditableEditor with any wrapper other than contenteditable, change the editor.
            editorWidgetType = this._handleContentEditable(editorWidgetType, wrapperType, property.metadata.uiType);

            if (!editorWidgetType) {
                throw ("Could not resolve editor widget for property: " + property.name);
            }

            var data = {
                editorWidgetType: editorWidgetType,
                editorParams: editorParams
            };

            if (property.metadata.customEditorSettings && property.metadata.customEditorSettings.uiParams) {
                lang.mixin(editorParams, property.metadata.customEditorSettings.uiParams);
            }

            // get the registered item
            var registeredItem = this._registeredEditorWrappers[wrapperType];

            if (!registeredItem) {
                throw ("No suitable editor wrapper found for type: " + wrapperType);
            }

            if (property.metadata.customEditorSettings && property.metadata.customEditorSettings.uiWrapper) {
                data.wrapperInitializer = null;
                data.wrapperType = property.metadata.customEditorSettings.uiWrapper;
            } else {
                data.wrapperInitializer = registeredItem.initializer;
                data.wrapperType = registeredItem.wrapperClassType;
            }

            this.onEditorResolved(data, property);

            if (wrapperType) {
                return data;
            }
            throw ("No suitable editor found");
        },

        createEditor: function (/*Object*/property, /*DomNode*/node, /*String|Object*/value, /*Object*/options) {
            // summary:
            //		Create the property editor.
            // property:
            //      The property
            // node:
            //      The source node to attach to
            // value:
            //      Value to edit in the editor
            // tags:
            //		public
            var def = new Deferred();

            var wrapperAndEditor = this._getWrapperAndEditor(property);

            var wrapperType = wrapperAndEditor.wrapperType;
            var editorWidgetType = wrapperAndEditor.editorWidgetType;
            require([wrapperType, editorWidgetType], lang.hitch(this, function (wrapperClass) {

                var editorParams = options || {};

                if (property.metadata) {
                    lang.mixin(editorParams, property.metadata.settings);
                    lang.mixin(editorParams, wrapperAndEditor.editorParams);
                    editorParams.selections = property.metadata.selections;
                }

                var initParams = {
                    wrapperType: wrapperAndEditor.wrapperType,
                    editorWidgetType: wrapperAndEditor.editorWidgetType,
                    editorParams: editorParams,
                    blockDisplayNode: node,
                    overlayItem: editorParams.overlayItem,
                    property: property,
                    propertyName: property.name,
                    propertyDisplayName: property.metadata.displayName,
                    value: value,
                    contentModel: property.contentModel
                };

                var wrapper = new wrapperClass(initParams);

                // call initializer function for wrapper, adding any additional settings
                var initializer = wrapperAndEditor.wrapperInitializer;
                if (initializer) {
                    lang.mixin(initParams.editorParams, { parent: wrapper });
                    initializer(wrapper, initParams);
                }

                this.onEditorCreated(wrapper.getEditorWidget());

                def.resolve(wrapper);
            }));

            return def;
        }
    });

});

},
'epi-cms/contentediting/InUseNotificationManager':function(){
﻿define([
// Dojo
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/when",
    "dojo/date",
    "dojo/aspect",

    //EPi
    "epi",
    "epi/username",
    "epi/dependency",
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.permanenteditindication"
],

function (
// Dojo
    lang,
    array,
    declare,
    when,
    dojoDate,
    aspect,

    //EPi
    epi,
    username,
    dependency,
    ApplicationSettings,
    ContentReference,

    // Resources
    res
) {

    return declare([], {
        // summary:
        //    Helper class to work with in use notifications.
        // tags:
        //    internal

        contextTypeName: "",

        _postFlag: false,

        _inUseNotificationStore: null,

        _currentUsername: null,

        _messageService: null,

        currentModel: null,

        _eventHandlers: null,

        // ignoreOthersNotifications: Boolean
        //      Set to true will make the getOtherUsersInUseNotifications return nothing.
        ignoreOthersNotifications: null,

        constructor: function (params) {
            // summary:
            //	    Creates a new in use notification manager.
            // tags:
            //      public

            this.inherited(arguments);

            lang.mixin(this, params);

            this._inUseNotificationStore = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.inusenotification");
            this._currentUsername = this.username || ApplicationSettings.userName;
            this._messageService = this.messageService || dependency.resolve("epi.shell.MessageService");

            this._eventHandlers = [];
        },

        updateCommandModel: function (model) {
            // summary:
            //	    Creates a new in use notification manager.
            // tags:
            //      public
            this.inherited(arguments);

            // reset ignore flag if the new content is taking over.
            if (this.currentModel &&
                !ContentReference.compareIgnoreVersion(this.currentModel.contentData.contentLink, model.contentData.contentLink)) {
                this.ignoreOthersNotifications = false;
            }

            this.currentModel = model;

            //Disconnect the event handlers for the previous model object.
            array.forEach(this._eventHandlers, function (eventHandler) {
                eventHandler.remove();
            });

            this.updateMessageService(this.currentModel.contentData);

            this._eventHandlers = [
                aspect.after(model, "suspend", lang.hitch(this, this._onViewModelSuspended)),
                aspect.after(model, "destroyed", lang.hitch(this, this._onViewModelSuspended)),
                aspect.after(model, "onPropertyEdited", lang.hitch(this, this._onPropertyEdited)),
                aspect.around(model, "canChangeContent", lang.hitch(this, this._canChangeContentAdvisor))
            ];
        },

        _canChangeContentAdvisor: function (originalMethod) {
            return lang.hitch(this, function () {
                if (!this.ignoreOthersNotifications) {
                    var othersInUseNotifications = this.getOtherUsersInUseNotifications(this.currentModel.contentData.inUseNotifications);
                    if (othersInUseNotifications && othersInUseNotifications.length) {
                        return false;
                    }
                }

                return originalMethod.apply(this.currentModel, arguments);
            });
        },

        _onViewModelSuspended: function () {
            // summary:
            //	    Removed any automatic in use notifications for the suspended model.
            // tags:
            //      private

            var model = this.currentModel.contentData;
            this.removeAutomaticInUseNotification(model);
        },

        _onPropertyEdited: function () {
            // summary:
            //	    Ensures that we have a in use notification for the current view model or creates one.
            // tags:
            //      private

            var model = this.currentModel.contentData;
            this.ensureAutomaticInUseNotification(model);
        },

        ensureAutomaticInUseNotification: function (model) {
            // summary:
            //		Adds a new automatically created notification if the model does not currently have any notifications for the current user.
            // model:
            //      The model to add the notification for.
            // tags:
            //    public

            var existingNotification;
            array.some(model.inUseNotifications, function (item) {
                if (item.userName.toLowerCase() === this._currentUsername.toLowerCase()) {
                    existingNotification = item;
                    return true;
                }
            }, this);

            if (!existingNotification) {
                return this.put(this._createNotification(model, false), model.inUseNotifications);
            } else if (existingNotification.addedManually) {
                //We don't have to update manual notifications.
                return;
            } else {
                var modifiedDate = new Date(existingNotification.modified);
                if (dojoDate.difference(modifiedDate, new Date(), "minute") > 30) {
                    return this.put(existingNotification, model.inUseNotifications);
                }
            }
        },

        removeAutomaticInUseNotification: function (model) {
            // summary:
            //		Removes any automatically creates notifications for the given model.
            // notification:
            //      The model to add the notification for.
            // tags:
            //    public
            array.forEach(model.inUseNotifications, function (item) {
                if (item.userName.toLowerCase() === this._currentUsername.toLowerCase() && !item.addedManually) {
                    this.remove(item, model.inUseNotifications);
                }
            }, this);
        },

        _createNotification: function (model, addedManually) {
            var currentDate = (new Date()).toISOString();
            return {
                contentLink: model.contentLink,
                languageBranch: model.currentLanguageBranch && model.currentLanguageBranch.languageId,
                addedManually: addedManually,
                created: currentDate,
                modified: currentDate
            };
        },

        put: function (notification, inUseNotifications) {
            // summary:
            //		Adds or updates an in use notification object to the specified page.
            // notification:
            //      The notification to save.
            // tags:
            //    public

            //Update the modified date on the client.
            notification.modified = (new Date()).toISOString();

            // Setup flag to ensure that inusenotification post to server until received response.
            if (!this._postFlag) {
                this._postFlag = true;

                return when(this._inUseNotificationStore.put(notification), lang.hitch(this, function (newNotification) {
                    var indexOfItem;
                    var hasIndex = array.some(inUseNotifications, function (item, index) {
                        if (newNotification.id === item.id) {
                            indexOfItem = index;
                            return true;
                        }
                        return false;
                    });
                    if (hasIndex && indexOfItem >= 0) {
                        inUseNotifications[indexOfItem] = newNotification;
                    } else {
                        inUseNotifications.push(newNotification);
                    }
                    this._updateDependentStores(notification.contentLink, inUseNotifications);
                    this._postFlag = false;
                }));
            }
        },

        remove: function (notification, inUseNotifications) {
            // summary:
            //		Deletes a notification.
            // inUseNotifications:
            //      The list of current notifications.
            // sync: boolean
            //      A boolean to determine if the XHR call should be synchronous or asynchronous. True will cause the browser to stop the chain of execution until the data is returned
            // tags:
            //		public

            return when(this._inUseNotificationStore.remove(notification.id), lang.hitch(this, function () {
                var index = array.indexOf(inUseNotifications, notification);
                inUseNotifications.splice(index, 1);
                this._updateDependentStores(notification.contentLink, inUseNotifications);
            }));
        },

        _updateDependentStores: function (contentLink, inUseNotifications) {
            var patchObject = { contentLink: contentLink, inUseNotifications: inUseNotifications };
            this._inUseNotificationStore.updateDependentStores(patchObject);
        },

        togglePermanentEditIndication: function (model, convertExistingIndication) {
            // summary:
            //      Adds or removes a permanent editing notification.
            // model:
            //      The model object to the notification for.
            // convertExistingIndication:
            //      If the toggle should convert to non permanent indications to/from permanent notifications.
            // tags:
            //		public

            var existingNotification;
            var manualNotificationExists = array.some(model.inUseNotifications, function (item) {
                if (item.userName.toLowerCase() === this._currentUsername.toLowerCase()) {
                    existingNotification = item;
                    if (item.addedManually) {
                        return true;
                    }
                }
            }, this);

            if (manualNotificationExists) {
                if (convertExistingIndication && existingNotification.convertedFromAutomaticNotification) {
                    existingNotification.addedManually = false;
                    return this.put(existingNotification, model.inUseNotifications);
                } else {
                    return this.remove(existingNotification, model.inUseNotifications);
                }
            } else {
                if (existingNotification && convertExistingIndication) {
                    existingNotification.convertedFromAutomaticNotification = true;
                    existingNotification.addedManually = true;
                } else {
                    existingNotification = this._createNotification(model, true);
                }
                return this.put(existingNotification, model.inUseNotifications);
            }
        },

        updateMessageService: function (model) {
            // summary:
            //    Removes any displaying page lock notification, and displays a new notification message when manual lock has been turned on.
            // inUseNotifications: array
            //    The in use notifications for the current object.
            // tags:
            //    private

            var itemKey = model.contentLink + "_permanentEdit";
            this._messageService.remove({ externalItemId: itemKey });
            var notification = this._getManualInUseNotification(model.inUseNotifications);
            if (notification) {
                this._notificationHandlerId = this._messageService.put("note", res.permanenteditison, this.contextTypeName, model.contentLink, itemKey, null);
            }
        },

        _getManualInUseNotification: function (inUseNotifications) {
            var manualIndication;
            array.forEach(inUseNotifications, function (item) {
                if (item.userName.toLowerCase() === this._currentUsername.toLowerCase() && item.addedManually) {
                    manualIndication = item;
                }
            }, this);
            return manualIndication;
        },

        currentUserHasInUseNotification: function (inUseNotifications, onlyCheckManual) {
            return array.some(inUseNotifications, function (item) {
                return item.userName.toLowerCase() === this._currentUsername.toLowerCase()
                    && (!onlyCheckManual || item.addedManually);
            }, this);
        },

        getOtherUsersInUseNotifications: function (inUseNotifications) {
            // summary
            //      Return list of users rather than the current user who have in use notification on the given list.

            var result = [];

            array.forEach(inUseNotifications, function (item) {
                if (item.userName.toLowerCase() !== this._currentUsername.toLowerCase()) {
                    var userName = username.toUserFriendlyString(item.userName, this._currentUsername);
                    result.push(userName);
                }
            }, this);

            return result;
        },

        hasInUseNotificationWarning: function (inUseNotifications) {
            if (this.ignoreOthersNotifications) {
                return false;
            }

            return this.getOtherUsersInUseNotifications(inUseNotifications).length;
        }
    });
});

},
'epi-cms/contentediting/ViewSettingsManager':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",
    "dojo/Stateful",

    // EPi Framework
    "epi/epi",
    "epi/dependency",
    "epi/UriParser",
    "epi/shell/_ContextMixin",
    "epi/shell/StickyViewSelector"
], function (
    // Dojo
    declare,
    array,
    lang,
    topic,
    when,
    Stateful,

    // EPi Framework
    epi,
    dependency,
    UriParser,
    _ContextMixin,
    StickyViewSelector
) {
    return declare([Stateful, _ContextMixin], {
        // summary:
        //      This class to manage view settings by manipulating a list of concrete view settings objects (for example: resolution, visitor group, ...).
        //      The class is responsible for updating URL hash to keep view settings state.
        //      onViewSettingChanged event is raised when one or more view settings are applied.
        //
        // tags:
        //      internal

        // _hashWrapper: epi/shell/HashWrapper
        //    The hash wrapper instance.
        _hashWrapper: null,

        // viewSettings: Array
        //    List of registered view setting items.
        viewSettings: null,

        // _viewSettingsMap: Hashtable
        //    Map of registered view setting items by their key.
        _viewSettingsMap: null,

        // viewSettingsHashValue: Array
        //    All view settings value which are parsed from or persisted to URL hash.
        viewSettingsHashValue: null,

        // _activeKey: String
        //      Key name for active state
        _activeKey: "active",

        // enabled: [Boolean]
        //      State of eye toggle button. True if it is expanded.
        enabled: false,

        previewParams: null,

        // _stickyViewSelector: epi/shell/StickyViewSelector
        //    Responsible for storing view selected by editor
        _stickyViewSelector: null,

        postscript: function () {
            // summary:
            //		Set up the instance after creation.

            this.inherited(arguments);

            this._stickyViewSelector = this._stickyViewSelector || new StickyViewSelector();

            this._hashWrapper = this._hashWrapper || dependency.resolve("epi.shell.HashWrapper");
            this.previewParams = {};
            this.viewSettingsHashValue = [];

            // Create _viewSettingsMap.
            this._viewSettingsMap = {};
            array.forEach(this.viewSettings, lang.hitch(this, function (viewSetting) {
                if (!this._viewSettingsMap[viewSetting.key]) {
                    this._viewSettingsMap[viewSetting.key] = viewSetting;
                } else {
                    throw "Duplicated view settings key.";
                }
            }));

            this.own(
                // Listen changed view setting, to apply view setting.
                topic.subscribe("/epi/cms/action/viewsettingvaluechanged", lang.hitch(this, this._viewSettingChanged)),
                // Listen changed eye toggle button, to enable/disable view setting.
                topic.subscribe("/epi/cms/action/eyetoggle", lang.hitch(this, this._viewSettingEnabledChanged))
            );

            // Parse url hash.
            var obj = this._hashWrapper.getHash();
            if (obj && obj.viewsetting) {
                this.viewSettingsHashValue = this._toObjects(obj.viewsetting);
            }

            this.enabled = this._loadProperty(this._activeKey) === "true";

            // Pass values to every view setting items and get previewParams.
            array.forEach(this.viewSettingsHashValue, lang.hitch(this, function (item) {
                var viewSetting = this._viewSettingsMap[item.type];
                if (viewSetting) {
                    viewSetting.set("enabled", this.get("enabled"));
                    viewSetting.value = item.id;
                    viewSetting.beforePreviewLoad(this.previewParams, this.get("enabled"));
                }
            }));
        },

        onPreviewReady: function (preview) {
            this._preview = preview;

            // Apply all the view setting.
            array.forEach(this.viewSettings, lang.hitch(this, function (viewSetting) {
                viewSetting.afterPreviewLoad(preview, this.get("enabled"));
            }));
        },

        getSettingProperty: function (/*String*/ property) {
            // summary:
            //      Get value of property from view setting object array.
            //
            // property:
            //    The property to get the value.
            //
            // tags:
            //      private
            var setting = array.filter(this.viewSettingsHashValue, function (dataItem) {
                return dataItem.type === property;
            });

            return setting.length > 0 ? setting[0].id : null;
        },

        hasVisitorGroup: function () {
            // summary:
            //      Indicates that in current view setting has visitor group or not
            // tags:
            //      Public

            return this.getSettingProperty("visitorgroup") !== null && this.getSettingProperty("visitorgroup").id !== null;
        },

        _enabledGetter: function () {
            // summary:
            //      Return the current status (Enable or Disable)

            return this.enabled;
        },

        _enabledSetter: function (value) {
            // summary:
            //		Enable or disable all view settings.
            //  value: Boolean
            //      If true, all view setting will be applied. Otherwise, none of them makes any effect.

            this.enabled = value;

            // If there are view settings, all of them are apply or removed accordingly.
            // reset preview params
            var previewParams = {};

            // Apply all the view setting.
            array.forEach(this.viewSettings, lang.hitch(this, function (viewSetting) {
                viewSetting.set("enabled", value);
                viewSetting.beforePreviewLoad(previewParams, value);
            }));

            if (!epi.areEqual(this.previewParams, previewParams)) {
                this.previewParams = previewParams;
            } else {
                array.forEach(this.viewSettings, lang.hitch(this, function (viewSetting) {
                    viewSetting.afterPreviewLoad(this._preview, value);
                }));
            }
        },

        _applyViewSettingValue: function (key, value) {
            // summary:
            //		Apply a view setting.
            // value: Boolean
            //      If true, all view setting will be applied. Otherwise, none of them makes any effect.

            var previewParams,
                viewSetting = this._viewSettingsMap[key];

            if (viewSetting) {
                previewParams = lang.clone(this.previewParams);

                // Assign setting value
                viewSetting.value = value;
                viewSetting.beforePreviewLoad(previewParams, true);

                if (!epi.areEqual(this.previewParams, previewParams)) {
                    this.previewParams = previewParams;
                } else {
                    viewSetting.afterPreviewLoad(this._preview, true);
                }
            }
        },

        _viewSettingChanged: function (key, value) {
            // summary:
            //		Apply view setting when option view setting changed.
            //
            // tags:
            //		private

            var self = this;

            when(this.getCurrentContext()).then(function (context) {
                if (key !== "viewlanguage") {
                    this._stickyViewSelector.save(context.hasTemplate, context.dataType, "onpageedit");
                }

                // commit all changes to the hash in one go.
                this._commitToHash(function () {

                    var settings = key;

                    if (!(key instanceof Array)) {
                        settings = [{ key: key, value: value }];
                    }

                    settings.forEach(function (setting) {
                        self._saveProperty(setting.key, setting.value);
                        self._applyViewSettingValue(setting.key, setting.value);
                    });
                });
            }.bind(this));
        },

        _viewSettingEnabledChanged: function (enabled) {
            // summary:
            //		Apply a preview resolution. If resolution null set size to full screen.
            //
            // enabled: [Boolean]
            //      True if eye button is expanded, a.k.a view setting is enabled.
            // tags:
            //		private

            var self = this;

            if (enabled) {
                when(this.getCurrentContext()).then(function (context) {
                    this._stickyViewSelector.save(context.hasTemplate, context.dataType, "onpageedit");

                    this._commitToHash(function () {
                        self._saveProperty(self._activeKey, "true");

                        self.set("enabled", enabled);
                    });
                }.bind(this));
            } else {
                this._commitToHash(function () {

                    var hasSetting = self._hasSetting();

                    // If haven't any view settings, it should be delete viewsetting URL when collapse eye toggle button.
                    self._saveProperty(self._activeKey, hasSetting ? false : null);

                    self.set("enabled", enabled);
                });
            }
        },

        _addProperty: function (property, value) {
            // summary:
            //      Adds view setting property.
            //
            // property: String.
            //      Name of view setting property.
            // value: String
            //      Value of view setting property.
            // tags:
            //      Private
            this.viewSettingsHashValue.push({
                type: property,
                id: value
            });
        },

        _updateProperty: function (property, value) {
            // summary:
            //      Updates an existing view setting property.
            //
            // property: String.
            //      Name of view setting property.
            // value: String
            //      Value of view setting property.
            // tags:
            //      Private

            // Get index of property
            var position = -1;
            array.forEach(this.viewSettingsHashValue, function (item, index) {
                if (item.type === property) {
                    position = index;
                    return;
                }
            });

            // Update if property exists
            if (position > -1) {
                this.viewSettingsHashValue[position].id = value;
            } else {
                // Otherwise add new property
                this._addProperty(property, value);
            }
        },

        _toObjects: function (url) {
            // summary:
            //      Cast url view settings to URI object.
            //
            // url: String
            //      This is view setting url.
            // tags:
            //      Private

            var uriObjects = [];

            array.forEach(url.split("|"), function (item, index) {
                var uri = new UriParser(item);
                uriObjects.push({
                    type: uri.getType(),
                    id: uri.getId()
                });
            });

            return uriObjects;
        },

        _deleteProperty: function (property) {
            // summary:
            //      Delete view setting property.
            //
            // property: String.
            //      Name of view setting property.
            // tags:
            //      Private
            var position = -1;

            array.forEach(this.viewSettingsHashValue, function (item, index) {
                if (item.type === property) {
                    position = index;
                    return;
                }
            });

            if (position > -1) {
                this.viewSettingsHashValue.splice(position, 1);
            }
        },

        _commitToHash: function (/*function*/unitOfWork) {
            // summary:
            //      Updates hash to reflect view setting changes.
            //
            // tags:
            //      Private

            var obj = this._hashWrapper.getHash();
            var settings = [];

            // Update the local hash value to what is set in the browser
            if (obj && obj.viewsetting) {
                this.set("viewSettingsHashValue", this._toObjects(obj.viewsetting));
            } else {
                this.set("viewSettingsHashValue", []);
            }

            // Make the necessary changes to the hash value
            unitOfWork();

            // Convert object settings to uri
            array.forEach(this.viewSettingsHashValue, function (item, index) {
                settings.push(item.type + ":///" + item.id);
            });

            // Join all settings if have, otherwise delete viewsetting in hash.
            if (settings.length > 0) {
                obj.viewsetting = settings.join("|");
            } else {
                delete obj.viewsetting;
            }

            this._hashWrapper.setHash(obj);
        },

        _saveProperty: function (property, value) {
            // summary:
            //      Save view setting property.
            //
            // property: String
            //      Name of setting property
            // value: String
            //      Value of setting property
            // tags:
            //      private

            if (this.get("viewSettingsHashValue")) {
                if (value != null) {
                    // Update view setting property
                    this._updateProperty(property, value);
                } else {
                    // Delete setting property default or invalid
                    this._deleteProperty(property);
                }
            } else {
                if (value != null) {
                    this._updateProperty(property, value);
                }
            }
        },

        _loadProperty: function (property) {
            // summary:
            //      Get id of view setting property from hash.
            //
            // property: String
            //      Name of setting property
            // tags:
            //      private
            var obj = this._hashWrapper.getHash();
            var value = null;

            if (obj && obj.viewsetting) {
                var viewSettings = this._toObjects(obj.viewsetting);

                var setting = array.filter(viewSettings, function (item) {
                    return item.type === property;
                })[0];

                if (setting) {
                    value = setting.id;
                }
            }
            return value;
        },

        _hasSetting: function () {
            // summary:
            //      Check have any view setting. Not include "active" property.
            //
            // tags:
            //      private
            var obj = this._hashWrapper.getHash();

            if (obj && obj.viewsetting) {
                if (obj.viewsetting.split("|").length > 1) {
                    return true;
                }
            }
            return false;
        },

        getRenderingViewSettings: function () {
            return array.filter(this.viewSettings, lang.hitch(this, function (viewSetting) {
                return viewSetting.usedForRendering;
            }));
        }
    });
});

},
'epi-cms/content-approval/ApprovalService':function(){
﻿define([
    "dojo/topic",
    "dojo/when",
    "dojo/Deferred",

    "epi/shell/xhr/errorHandler",
    "epi/dependency"
], function (
    topic,
    when,
    Deferred,
    errorHandler,
    dependency) {

    function ApprovalService(approvalStore, approvalDefinitionStore) {
        // summary:
        //      A service for interacting with content approvals.
        // tags:
        //      internal

        this.approvalStore = approvalStore || dependency.resolve("epi.storeregistry").get("epi.cms.approval");
        this.approvalDefinitionStore = approvalDefinitionStore || dependency.resolve("epi.storeregistry").get("epi.cms.approval.definition");
    }

    // approvalStore: [readonly] Store
    //      A REST store for saving and loading approval
    ApprovalService.prototype.approvalStore = null;

    // approvalDefinitionStore: [readonly] Store
    //      A REST store for saving and loading approval definitions
    ApprovalService.prototype.approvalDefinitionStore = null;

    ApprovalService.prototype.getApproval = function (contentLink) {
        // summary:
        //      Gets the approval for the given content link.
        // tags:
        //      public

        return when(this.approvalStore.get(contentLink)).otherwise(function () {
            // If the approval doesn't exist then return null.
            return null;
        });
    };

    ApprovalService.prototype.approveChanges = function (approvalId, activeStepIndex, approveReason) {
        // summary:
        //      Approves the changes for the given approval
        // tags:
        //      public

        return errorHandler.wrapXhr(this.approvalStore.executeMethod("ApproveChanges", approvalId, {
            activeStepIndex: activeStepIndex,
            approveReason: approveReason
        }));
    };

    ApprovalService.prototype.forceCompleteApproval = function (approvalId, forceReason) {
        // summary:
        //      Force completes an approval instance as approved.
        // tags:
        //      public

        return errorHandler.wrapXhr(this.approvalStore.executeMethod("ForceComplete", approvalId, {forceReason: forceReason}));
    };

    ApprovalService.prototype.rejectChanges = function (approvalId, activeStepIndex, rejectReason) {
        // summary:
        //      Rejects the changes for the given approval
        // tags:
        //      public

        return errorHandler.wrapXhr(this.approvalStore.executeMethod("RejectChanges", approvalId, {
            activeStepIndex: activeStepIndex,
            rejectReason: rejectReason
        }));
    };

    ApprovalService.prototype.cancelChanges = function (approval) {
        // summary:
        //      Cancels the changes for the given approval
        // tags:
        //      public

        return errorHandler.wrapXhr(this.approvalStore.executeMethod("CancelChanges", approval.id));
    };

    ApprovalService.prototype.commentChanges = function (approvalId, comment) {
        // summary:
        //      Adds a comment to the review request
        // tags:
        //      public
        return errorHandler.wrapXhr(this.approvalStore.executeMethod("CommentChanges", approvalId, {
            comment: comment
        }));
    };

    ApprovalService.prototype.getDefinition = function (contentLink) {
        // summary:
        //      Gets the approval definition for the given content link.
        // tags:
        //      public

        return when(this.approvalDefinitionStore.get(contentLink)).otherwise(function () {
            // If the approval definition doesn't exist then return null.
            return null;
        });
    };

    ApprovalService.prototype.getApprovalRelatedDefinition = function (contentLink) {
        // summary:
        //      Gets the approval definition which belongs to the currently running approval for given content link.
        // tags:
        //      public

        return when(this.approvalDefinitionStore.query({
            id: contentLink,
            getApprovalRelatedDefinition: true
        })).otherwise(function () {
            // If the approval definition doesn't exist then return null.
            return null;
        });
    };

    ApprovalService.prototype.navigateToDefinition = function (contentLink) {
        // summary:
        //      Navigates to the definition for the given content link
        // tags:
        //      public

        topic.publish("/epi/shell/context/request",
            {uri: "epi.cms.approval:///" + contentLink},
            {sender: null});
    };

    ApprovalService.prototype.hasDefinition = function (contentLink) {
        // summary:
        //      Determines whether an approval definition has been created or inherited for the
        //      given content link.
        // tags:
        //      public

        return this.getDefinition(contentLink).then(function (definition) {
            // If a definition exists but has no id then it is the default empty definition.
            return definition !== null && definition.id !== 0;
        });
    };

    ApprovalService.prototype.saveDefinition = function (definition) {
        // summary:
        //      Saves the approval definition.
        // tags:
        //      internal

        if (!definition) {
            return new Deferred().reject();
        }

        return errorHandler.wrapXhr(this.approvalDefinitionStore.put(definition));
    };

    ApprovalService.prototype.deleteDefinition = function (contentLink) {
        // summary:
        //      Deletes the approval definition.
        // tags:
        //      internal

        return errorHandler.wrapXhr(this.approvalDefinitionStore.remove(contentLink));
    };

    ApprovalService.prototype.inheritDefinition = function (contentLink) {
        // summary:
        //      Deletes the approval definition for given contentLink and returns its ancestor's definition.
        // returns: Promise
        //      A promise that resolves to the parent approval definition
        // tags:
        //      internal

        return errorHandler.wrapXhr(this.approvalDefinitionStore.executeMethod("Inherit", contentLink));
    };

    return ApprovalService;
});

},
'epi-cms/project/ProjectService':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/Evented",
    "dojo/aspect",

    //dijit
    "dijit/Destroyable",

    // epi
    "epi/dependency",
    "epi/shell/xhr/errorHandler",
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference"
],

function (
// dojo
    declare,
    lang,
    when,
    Deferred,
    all,
    Evented,
    aspect,

    // dijit
    Destroyable,

    // epi
    dependency,
    errorHandler,
    ApplicationSettings,
    ContentReference
) {

    return declare([Evented, Destroyable], {
        // summary:
        //      A service for interacting with projects
        // tags:
        //      internal xproduct

        // isProjectModeEnabled: [readonly] Boolean
        //      Indicates whether project mode is enabled.
        isProjectModeEnabled: false,

        // isProjectGadgetEnabled: [readonly] Boolean
        //      Indicates whether project gadget is enabled.
        isProjectGadgetEnabled: false,

        // projectItemStore: [readonly] Store
        //      A REST store for interacting with project items.
        projectItemStore: null,

        // projectStore: [readonly] Store
        //      A REST store for interacting with projects.
        projectStore: null,

        _currentProjectProfileKey: "epi.current-project-id",

        constructor: function (params) {
            declare.safeMixin(this, params);

            this.projectItemStore = this.projectItemStore || dependency.resolve("epi.storeregistry").get("epi.cms.project.item");
            this.projectStore = this.projectStore || dependency.resolve("epi.storeregistry").get("epi.cms.project");
            this.profile = this.profile || dependency.resolve("epi.shell.Profile");

            this.isProjectModeEnabled = ApplicationSettings.isProjectModeEnabled;
            this.isProjectGadgetEnabled = ApplicationSettings.isProjectGadgetEnabled;

            this.own(
                this.projectItemStore.on("update", this._onProjectItemUpdated.bind(this)),
                this.projectItemStore.on("delete", this._onProjectItemRemoved.bind(this)),
                this.projectStore.on("update", this._onProjectUpdated.bind(this)),
                this.projectStore.on("delete", this._onProjectRemoved.bind(this))
            );
        },

        hasScheduledProjectItems: function (projectId) {
            // summary:
            //      Checks if the project have any scheduled items
            // projectId: Number
            //      ProjectId
            // returns: Promise
            //      true/false
            // tags:
            //      internal
            return errorHandler.wrapXhr(this.projectStore.refresh(projectId)).then(function (project) {
                return project.itemStatusCount.delayedpublish > 0 || project.itemStatusCount.delayedpublish_nopublishaccess > 0;
            }.bind(this));
        },

        getProjectItemsForContent: function (contentLinks) {
            // summary:
            //      Get the associated projects items for the given content links
            //
            // contentLinks: String|Array
            //      The content links to get the project items for for
            // tags:
            //      internal

            if (!(contentLinks instanceof Array)) {
                contentLinks = [contentLinks];
            }

            return when(this.projectItemStore.query({contentLinks: contentLinks}));
        },

        getProjectItemForContent: function (contentLink) {
            // summary:
            //      Get the associated project item for the given content link
            // contentLink: String
            //      The content link to get the project item for
            // returns: Promise
            //      Returns the associated project item if found otherwise null
            // tags:
            //      internal

            return this.getProjectItemsForContent(contentLink).then(function (projectItems) {
                return this.getCurrentProjectItemFromProjectItems(projectItems, contentLink);
            }.bind(this));
        },

        getCurrentProjectItemFromProjectItems: function (projectItems, contentLink) {
            // summary:
            //      Get the associated project item for the given content link
            // projectItems: Array
            //      Already fetched project items
            // contentLink: String
            //      The content link to get the project item for
            // returns: Object
            //      Returns the associated project item if found otherwise null
            // tags:
            //      internal

            var contentReference = new ContentReference(contentLink);

            if (contentReference.workId === 0) {
                return null;
            }

            for (var i = 0; i < projectItems.length; i++) {
                if (projectItems[i].contentLink === contentLink) {
                    return projectItems[i];
                }
            }
            return null;
        },

        getProjectsForContent: function (contentLinks) {
            // summary:
            //      Get the associated projects for the given content links
            //
            // contentLinks: String|Array
            //      The content links to get the projects for
            // tags:
            //      internal

            var self = this;

            if (!(contentLinks instanceof Array)) {
                contentLinks = [contentLinks];
            }

            return this.getProjectItemsForContent(contentLinks).then(function (projectItems) {
                // If no project items where found return an empty array
                if (projectItems.length === 0) {
                    return new Deferred().resolve([]);
                }

                return self.getProjects(projectItems);
            });
        },

        canAddContent: function (projectId, contentLinks, languageId) {
            // summary:
            //      Verifies that the given content links are unique and can be added to the project
            //
            // projectId: Number
            //      The project id to check
            // contentLinks: Array
            //      The content links to add
            // languageId: string
            //      The language to check
            // returns: Promise
            //      A promise with the result from the server
            // tags:
            //      internal
            var uniqueContentLinks = contentLinks.filter(function (elem, pos) {
                return contentLinks.indexOf(elem) === pos;
            });

            return this.projectStore.executeMethod("CanAddContent", projectId, { contentReferences: uniqueContentLinks, languageId: languageId});
        },

        getProjects: function (projectItems) {
            // summary:
            //      Get the projects for the project items
            //
            // projectItems: int[]
            //      The project items to get the projects for
            // tags:
            //      internal

            var projectStore = this.projectStore;
            var projectPromises = projectItems.map(function (projectItem) {
                return projectStore.get(projectItem.projectId);
            });

            return all(projectPromises);
        },

        exists: function (projectId) {
            // summary:
            //      Checks if the given project still exists
            // projectId: Number
            //      The id of the project
            // returns: Promise
            //      True if it still exists otherwise False

            return errorHandler.wrapXhr(this.projectStore.executeMethod("exists", projectId));
        },

        addProjectItems: function (projectId, contentReferences) {
            // summary:
            //      Adds the given content references as items of the project.
            //
            // projectId: Number
            //      The target project for adding items to.
            // contentReferences: ContentReference[]
            //      An array of references to content items to add to the project.
            // tags:
            //      public

            // Ensure the content reference we received are valid and unique.
            contentReferences = contentReferences.filter(function (reference, pos) {
                if (ContentReference.isContentReference(reference) && contentReferences.indexOf(reference) === pos) {
                    return true;
                }
            });

            var result = this.projectItemStore
                .executeMethod("addItems", projectId, { contentLinks: contentReferences })
                .then(function (result) {
                    result.forEach(function (item) {
                        this.projectItemStore.notify(item, this.projectItemStore.getIdentity(item));
                    }, this);
                    return result;
                }.bind(this));
            return errorHandler.wrapXhr(result);
        },

        removeProjectItems: function (projectItems) {
            // summary:
            //      Removes the project items from a project.
            // projectItems: Array
            //      An array of project items to remove from the project
            // tags:
            //      public

            var itemIds = projectItems.map(function (item) {
                return item.id;
            });

            return errorHandler.wrapXhr(this.projectItemStore.removeRange(itemIds));
        },

        markAsReadyForReview: function (projectItems, options) {
            // summary:
            //      Mark the project items as ready for review.
            // returns: Promise
            //      A promise that resolves when the items have been marked as ready for review.
            // tags:
            //      public

            var args = lang.mixin({ projectItems: projectItems }, options);
            return errorHandler.wrapXhr(this.projectItemStore.executeMethod("ReadyForReview", "", args));
        },

        markAsReadyToPublish: function (projectItems) {
            // summary:
            //      Mark the project items as ready to publish.
            // returns: Promise
            //      A promise that resolves when the items have been marked as ready to publish.
            // tags:
            //      public

            return errorHandler.wrapXhr(this.projectItemStore.executeMethod("ReadyToPublish", "", projectItems));
        },

        isPartOfDelayedPublishedProject: function (contentLink) {
            // summary:
            //      Determines if the content is part of any project that is set to delayed publish
            // contentLink: String
            //      The content link to check
            // returns:
            //      Promise
            // tags:
            //      public

            return this.getProjectsForContent([contentLink])
                .then(function (projects) {
                    return projects.some(function (project) {
                        return project.status === "delayedpublished";
                    });
                });
        },

        publishProject: function (projectId, delayPublishUntil) {
            // summary:
            //      Publishes a project with given id right away or delay publishing until given delayPublish date.
            // projectId: Number
            //      Id of the project to publish
            // delayPublishUntil: Date?
            //      If supplied, then the project will be delay published.
            // returns: Promise
            // tags:
            //      public

            var store = this.projectStore;

            if (isNaN(projectId)) {
                throw new Error("projectId is not a number");
            }

            // we need to patch the store to update cache and notify the observers.
            return errorHandler.wrapXhr(store.executeMethod("Publish", projectId, { delayPublishUntil: delayPublishUntil }))
                .then(store.patchCache.bind(store));
        },

        reactivateProject: function (projectId) {
            // summary:
            //      Reactivates a project that has been scheduled for publishing.
            // projectId: Number
            //      The ID of the project to reactivate
            // returns: Promise
            // tags:
            //      public

            var store = this.projectStore;

            if (isNaN(projectId)) {
                throw new Error("The given project ID is not a number.");
            }

            // we need to patch the store to update cache and notify the observers.
            return errorHandler.wrapXhr(store.executeMethod("Reactivate", projectId))
                .then(store.patchCache.bind(store));
        },

        getCurrentProjectId: function () {
            // summary:
            //      Gets the id of the currently selected project from the user profile
            // returns: Promise
            //      Id of the currently selected project as set in the user.
            // tags:
            //      public

            if (!this.isProjectModeEnabled) {
                return new Deferred().resolve(null);
            }
            return when(this.profile.get(this._currentProjectProfileKey));
        },

        getCurrentProject: function () {
            // summary:
            //      Load the current project
            // returns: Promise
            //      The project that was stored in the profile
            // tags:
            //      public

            var projectStore = this.projectStore;
            var that = this;

            //Load the selected project from the profile
            return this.getCurrentProjectId().then(function (projectId) {
                if (!projectId) {
                    return null;
                }

                // Need to get the project from the store in order to ensure it still exists.
                // Otherwise return null
                return when(projectStore.get(projectId)).otherwise(function (ex) {
                    console.log(ex);

                    // Reset the project if it's not found. Can happen when another user deletes the project.
                    if (ex.status === 404) {
                        that.setCurrentProject(null);
                    }

                    return null;
                });
            });
        },

        setCurrentProject: function (currentProject) {
            // summary:
            //      Set the current project, it will be stored in the profile.
            //
            // returns: Promise
            //
            // tags:
            //      public

            this.emit("currentProjectChanged", currentProject);

            return this.profile.set(this._currentProjectProfileKey, currentProject && currentProject.id, { location: "server" });
        },

        _onProjectItemUpdated: function (event) {
            // summary:
            //      Emits a project item updated event.
            // tags:
            //      private

            this.emit("project-item-updated", event.target);
        },

        _onProjectItemRemoved: function (event) {
            // summary:
            //      Emits a project item removed event.
            // tags:
            //      private

            this.emit("project-item-removed", event.id);
        },

        _onProjectUpdated: function (event) {
            // summary:
            //      Emits a project updated event.
            // tags:
            //      private

            this.emit("project-updated", event.target);
        },

        _onProjectRemoved: function (event) {
            // summary:
            //      Emits a project removed event.
            // tags:
            //      private

            this.emit("project-removed", event.id);
        }
    });
});

},
'epi-cms/activity/ActivityService':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",
    "dijit/Destroyable",
    "epi/dependency"
],
function (declare, lang, Evented, Destroyable, dependency) {

    return declare([Evented, Destroyable], {
        // summary:
        //      A service for interacting with activities and activity comments
        // tags:
        //      internal

        // activityStore: [readonly] Store
        //      A REST store for interacting with activities.
        activityStore: null,

        // activityCommentStore: [readonly] Store
        //      A REST store for interacting with activity comments.
        activityCommentStore: null,

        constructor: function (params) {
            declare.safeMixin(this, params);

            this.activityStore = this.activityStore || dependency.resolve("epi.storeregistry").get("epi.cms.activities");
            this.activityCommentStore = this.activityCommentStore || dependency.resolve("epi.storeregistry").get("epi.cms.activities.comments");

            this.own(
                this.activityCommentStore.on("update", this._onActivityCommentUpdated.bind(this))
            );
        },

        addMessage: function (projectId, contentLink, message) {
            // summary:
            //     Adds a message activity to the project. If a content link is also given then the
            //     activity will also be associated with the content.
            // projectId: Number
            //      The id of the project to associate with the message activity
            // contentLink: String
            //      The content link of the content to associate with the message activity;
            //      otherwise null
            // message: String,
            //      The message to be added to the project
            // tags:
            //      public

            var obj = {
                projectId: projectId,
                contentLink: contentLink,
                message: message
            };
            return this.activityStore.add(obj);
        },

        saveMessage: function (messageActivityId, message) {
            // summary:
            //     Updates a message activity with a new message.
            // messageActivityId: Number
            //      The id of the message activity to update
            // message: String
            //      The updated message for the message activity
            // tags:
            //      public

            var obj = {
                id: messageActivityId,
                message: message
            };
            return this.activityStore.put(obj);
        },

        addComment: function (activityId, comment) {
            // summary:
            //     Adds a "comment" to an activity
            //
            // activityId: Number
            //      The id of the activity to add a comment for
            // comment: String,
            //      The comment
            // tags:
            //      public

            var obj = {
                activityId: activityId,
                message: comment
            };
            return this.activityCommentStore.add(obj);
        },

        saveComment: function (commentId, comment) {
            // summary:
            //     Saves an already existing "comment"
            //
            // commentId: Number
            //      The id of the comment to update
            // activityId: Number
            //      The id of the activity the comment belongs to
            // comment: String,
            //      The comment
            // tags:
            //      public

            var obj = {
                id: commentId,
                message: comment
            };

            return this.activityCommentStore.put(obj);
        },

        _onActivityCommentUpdated: function (event) {
            // summary:
            //      Emits 'activity-comment-updated' when an ActivityComment gets added or updated.
            // tags:
            //      private

            this.emit("activity-comment-updated", event.target);
        }
    });
});

},
'epi-cms/project/request/projectMode':function(){
define([
    "dojo/Deferred",
    "dojo/when",
    "epi/dependency"
], function (Deferred, when, dependency) {

    return {
        // summary:
        //      Request mutator for adding the currently selected project to the an xhr request
        // description:
        //      Sets the X-EPiCurrentProject header with the currently selected project id as returned
        //      from the epi.cms.ProjectService. The header is not added if the isProfileRequest option
        //      is truthy or the project service isn't registered in the dependency resolver.
        // tags:
        //      internal

        _getCurrentProjectId: function () {
            var serviceId = "epi.cms.ProjectService";
            if (dependency.exists(serviceId)) {
                var projectService = dependency.resolve(serviceId);
                return projectService.getCurrentProjectId();
            }
            return when(null);
        },

        beforeSend: function (params) {
            // summary:
            //      Adds X-EPiCurrentProject to the options.headers of the request parameters.
            // params: Object
            //      The request parameters
            // tags: public

            var options = params.options;
            if (options.isProfileRequest) {
                return when(params);
            }

            var result = new Deferred();
            this._getCurrentProjectId().then(function (projectId) {
                if (projectId) {
                    options.headers["X-EPiCurrentProject"] = projectId;
                }
            }).otherwise(function (err) {
                console.error("Failed to get current project id from project service", err);
            }).always(function () {
                // Log the error but don't stop the request
                result.resolve(params);
            });

            return result.promise;
        }
    };

});

},
'epi-cms/request/contentLanguage':function(){
define(["dojo/Deferred", "dojo/when", "epi/dependency"], function (Deferred, when, dependency) {

    return {
        // summary:
        //      Request mutator for adding the currently selected content language to an xhr request
        // tags:
        //      internal

        beforeSend: function (params) {
            // summary:
            //      Adds X-EPiContentLanguage to the headers for the request
            // description:
            //      Sets the X-EPiContentLanguage header with the currently selected content language in the
            //      epi/shell/Profile. The header is not added if the preventLocalizationHeader option is truthy.

            var deferred = new Deferred();

            var options = params.options;

            // Checking preventLocalizationHeader is redundant, but left for backwards compatibility
            if (!(options.preventLocalizationHeader || options.isProfileRequest)) {
                var profile = dependency.resolve("epi.shell.Profile");
                when(profile.getContentLanguage()).then(function (language) {
                    if (language) {
                        options.headers["X-EPiContentLanguage"] = language;
                    }
                    deferred.resolve(params);
                });
                return deferred.promise;
            }

            deferred.resolve(params);
            return deferred.promise;
        }
    };
});

},
'epi-cms/project/ProjectModeRequestInterceptor':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dijit/Destroyable",

    "epi/dependency"
],
function (
    declare,
    lang,
    Deferred,
    Destroyable,
    dependency) {

    return declare([Destroyable], {
        // summary:
        //      Request interceptor that adds the current project id to all render requests if project mode is enabled
        // tags:
        //      internal

        constructor: function (params) {
            declare.safeMixin(this, params);

            this.projectService = this.projectService || dependency.resolve("epi.cms.ProjectService");

            this.contextService = this.contextService || dependency.resolve("epi.shell.ContextService");
            this.own(this.contextService.registerRequestInterceptor(lang.hitch(this, this._onInterceptRequest)));
        },

        _onInterceptRequest: function (contextParams) {
            // summary:
            //      Request interceptor that adds the current project id to all render requests if project mode is enabled
            // tags:
            //      private

            var dfd = new Deferred();

            // If project mode is enabled we want to add the current project id to all render requests
            if (!this.projectService.isProjectModeEnabled) {
                dfd.resolve();
            } else {
                this.projectService.getCurrentProject().then(function (project) {
                    if (project) {
                        contextParams.epiprojects = project.id;
                        contextParams.epieditmode = true;
                    }
                }).always(dfd.resolve);
            }

            return dfd.promise;
        }
    });
});

},
'epi-cms/project/ProjectItemQueryEngine':function(){
define([
    "epi-cms/core/ContentReference",
    "epi/shell/store/queryUtils"
], function (
    ContentReference,
    queryUtils
) {
    return function (query, options) {
        // summary:
        //      A QueryEngine configured to work with project items.
        //
        // query: Object
        //
        // options: dojo/store/api/Store.QueryOptions?
        //      An object that contains optional information such as sort, start, and count
        //
        // tags:
        //      internal xproduct
        //
        // returns: Function
        //		A QueryEngine matching the queries sent to the ProjectItemStore

        options = options || {};

        options.comparers = {
            contentLinks: function (queryValue, instance) {
                return queryValue.some(function (link) {
                    return ContentReference.compareIgnoreVersion(link, instance.contentLink);
                });
            }
        };

        return queryUtils.createEngine(query, options);
    };
});

},
'epi-cms/contentediting/command/Editing':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "epi/shell/command/withConfirmation",
    "epi-cms/command/TranslateContent",
    "epi-cms/contentediting/command/RevertToPublished",
    "epi-cms/contentediting/command/SendForReview",
    "epi-cms/contentediting/command/Publish",
    "epi-cms/contentediting/command/CreateDraft",
    "epi-cms/contentediting/command/Withdraw",
    "epi-cms/contentediting/command/ManageExpiration",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu"
],

function (
    declare,
    lang,
    Stateful,
    withConfirmation,
    TranslateContentCommand,
    RevertToPublishedCommand,
    SendForReviewCommand,
    PublishCommand,
    CreateDraftCommand,
    WithdrawCommand,
    ManageExpiration,
    actionRes
) {
    //Shared instance

    var Editing = declare([Stateful], {
        // summary:
        //      Exposes all available editing commands
        //
        // tags:
        //      internal

        model: null,

        revertToPublished: null,
        translate: null,
        createDraft: null,
        sendForReview: null,
        publish: null,
        withdraw: null,
        manageExpiration: null,

        constructor: function (settings) {
            lang.mixin(this, settings);

            //Wrap the revert to publish command in a confirmation dialog
            this.revertToPublished = withConfirmation(new RevertToPublishedCommand(), null, {
                title: actionRes.reverttopublishconfirmation.dialogtitle,
                heading: actionRes.reverttopublishconfirmation.confirmquestion,
                description: actionRes.reverttopublishconfirmation.description
            });
            this.translate = new TranslateContentCommand();
            this.createDraft = new CreateDraftCommand();
            this.sendForReview = new SendForReviewCommand();
            this.publish = new PublishCommand();
            this.withdraw = new WithdrawCommand();
            this.manageExpiration = new ManageExpiration();
        },

        _modelSetter: function (model) {
            this.model = model;

            //Update the model on the commands
            this.revertToPublished.set("model", model);
            this.translate.set("model", model);
            this.createDraft.set("model", model);
            this.sendForReview.set("model", model);
            this.publish.set("model", model);
            this.withdraw.set("model", model);
            this.manageExpiration.set("model", model);
        }
    });

    return new Editing();
});

},
'epi/shell/command/withConfirmation':function(){
﻿define("epi/shell/command/withConfirmation", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/Deferred",
    "epi/shell/widget/dialog/Confirmation"
],
function (declare, lang, when, Deferred, Confirmation) {

    function defaultConfirmationHandler(settings) {

        var deferred = new Deferred(),
            dialog = new Confirmation(settings);

        dialog.connect(dialog, "onAction", function (confirm) {
            if (confirm) {
                deferred.resolve();
            } else {
                //TODO: reject() is called in DialogService. Need to investigate (CMS-6808)
                deferred.cancel();
            }
        });

        dialog.show();

        return deferred.promise;
    }

    return function (command, /* function */confirmationHandler, /* Object */settings) {
        // summary:
        //      Adds confirmation before executing a command.
        //
        // tags:
        //      internal xproduct

        // keep original method.
        var originalExecute = command._execute;

        // wrap with a confirmation dialog and return a deferred.
        command._execute = function () {

            var commandDeferred = new Deferred();

            function executioner() {
                when(originalExecute.apply(command, arguments),
                    commandDeferred.resolve,
                    commandDeferred.cancel);
            }

            confirmationHandler = confirmationHandler || defaultConfirmationHandler;
            when(confirmationHandler(settings), executioner, commandDeferred.cancel);
            return commandDeferred;
        };

        // return the wrapped command.
        return command;
    };
});

},
'epi-cms/command/TranslateContent':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.translate",
    "epi/shell/command/_Command"
], function (declare, topic, resources, _Command) {

    return declare([_Command], {
        // tags:
        //      internal xproduct

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resources.label,

        // executingLabel: [public] String
        //      The action text of the command when executing to be used in visual elements.
        executingLabel: resources.executinglabel,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: resources.title,

        // category: [const] String
        //      A category which provides a hint about how the command could be displayed.
        category: "context",

        _execute: function () {
            // summary:
            //      Publishes a change view request to change to the create language branch view.
            // tags:
            //      protected
            var model = this._getNormalizedModel();

            if (typeof this.executeDelegate === "function") {
                this.executeDelegate(this.model);
            } else {
                var data = {
                    contentData: model.content,
                    languageBranch: model.language.preferredLanguage
                };

                topic.publish("/epi/shell/action/changeview", "epi-cms/contentediting/CreateLanguageBranch", null, data);
            }
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected
            var model = this._getNormalizedModel(),
                language = model && model.language, // Null if multiple languages are not supported by the content provider on the server.
                isDeleted = model && model.content.isDeleted,
                isAvailable = language && language.isTranslationNeeded && !isDeleted,
                canExecute = isAvailable && language.hasTranslationAccess && language.isPreferredLanguageAvailable;

            if (model && typeof model.content.canTranslateContent === "function") {
                // Check if the model allows the current content to be translated.
                var canTranslate = model.content.canTranslateContent();

                isAvailable = isAvailable && canTranslate;
                canExecute = canExecute && canTranslate;
            }

            // Command is available if there is a translation needed.
            this.set("isAvailable", !!isAvailable);

            // Command is executable if the current user has sufficient privilege to translate and
            // that the preferred language is configured to be available for the current content.
            this.set("canExecute", !!canExecute);
        },

        _getNormalizedModel: function () {
            // summary:
            //      Gets a normalized model in order to handle the different possible inputs.
            // tags:
            //      private
            var model = this.model;
            if (model) {
                return {
                    content: model.contentData || model,
                    language: model.languageContext || model.missingLanguageBranch
                };
            }
        }
    });

});

},
'epi-cms/contentediting/command/RevertToPublished':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi-cms/contentediting/command/_ContentCommandBase",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    lang,
    _ContentCommandBase,
    ContentActionSupport,
    resource
) {

    return declare([_ContentCommandBase], {
        // summary:
        //      Revert back to published version
        //
        // tags:
        //      internal

        name: "reverttopublished",

        tooltip: resource.reverttopublished.title,
        label: resource.reverttopublished.label,
        iconClass: "epi-iconRevert",

        _hasPendingChangeWatch: null,

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the create content view.
            // tags:
            //		protected

            this.model.revertToPublished();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                status = contentData.status,
                versionStatus = ContentActionSupport.versionStatus;

            //Available when content is a draft or awaiting for approval
            var isAvailable = status === versionStatus.CheckedOut || status === versionStatus.Rejected;
            this.set("isAvailable", isAvailable);

            //If the models has pending changes, disable the command
            if (this._hasPendingChangeWatch) {
                this._hasPendingChangeWatch.unwatch();
            }
            this._hasPendingChangeWatch = this.model.watch("hasPendingChanges", lang.hitch(this, function (name, oldValue, newValue) {
                var originalCanExecute = this._getCanExecute(contentData, versionStatus);
                this.set("canExecute", !newValue && originalCanExecute);
            }));

            //Executable when available and not published, have published version and have edit access right
            this.set("canExecute", isAvailable && this._getCanExecute(contentData, versionStatus));
        },

        _getCanExecute: function (contentData, versionStatus) {
            // This condition indicates that the content has published version.
            var hasPublishedVersion = contentData.publishedBy !== null && contentData.publishedBy !== undefined;
            var currentStatusIsNotPublished = contentData.status !== versionStatus.Published;

            // Expired content is basically Published content with a expireDate set to the past
            var currentStatusIsNotExpired = contentData.status !== versionStatus.Expired;

            var contentCanBeChanged = this.model.canChangeContent(ContentActionSupport.action.Edit);
            var hasDeleteRights = ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Delete); // Ensure has delete action to the user
            return hasPublishedVersion && currentStatusIsNotPublished && currentStatusIsNotExpired && contentCanBeChanged && hasDeleteRights;

        }
    });
});

},
'epi-cms/contentediting/command/_ContentCommandBase':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/shell/command/_PropertyWatchCommand"
],

function (
    declare,
    lang,
    _PropertyWatchCommand
) {

    return declare([_PropertyWatchCommand], {
        // summary:
        //      Base class for any content manipulation command, like: Reject, Publish, ...
        //      canExecute is updated to false if the content is changing its status, and restore when done.
        // tags:
        //      internal abstract

        _isChangingContentStatusHandle: null,

        // checkDeleted: [Boolean]
        //      Indicated that need check content is deleted or not before execute command
        // tags:
        //      public
        checkDeleted: true,

        propertiesToWatch: ["isChangingContentStatus"],

        _canExecuteGetter: function () {
            // summary:
            //      Check content is deleted or not
            // tags:
            //      protected

            if (!this.model || !this.model.contentData) {
                return false;
            }

            var contentData = this.model.contentData;
            return this.canExecute && (!this.checkDeleted || (contentData && !contentData.isDeleted));
        },

        _onPropertyChanged: function () {
            // summary:
            //      This is called whenever the specified property in propertiesToWatch
            //      is changed on the model and sets canExecute.
            // tags:
            //      protected

            this.set("canExecute", this.get("canExecute"));
        }
    });
});

},
'epi/shell/command/_PropertyWatchCommand':function(){
define("epi/shell/command/_PropertyWatchCommand", [
    "dojo/_base/declare",
    // Parent class and mixins
    "epi/shell/DestroyableByKey",
    "epi/shell/command/_Command"
], function (
    declare,
    // Parent class and mixins
    DestroyableByKey,
    _Command
) {

    return declare([_Command, DestroyableByKey], {
        // summary:
        //      Base command that will watch the specified properties on the model and set
        //      canExecute accordingly.
        // tags:
        //      internal

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: null,

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            this._watchModelProperty();
        },

        _watchModelProperty: function () {
            // summary:
            //      Calls _onPropertyChanged with the new models property.
            // tags:
            //      protected

            var model = this.model;

            this.destroyByKey("propertyWatchHandle");

            if (model) {
                this._onPropertyChanged();
                this.propertiesToWatch.forEach(function (property) {
                    this.ownByKey("propertyWatchHandle", model.watch(property, this._onPropertyChanged.bind(this)));
                }, this);
            } else {
                this.set("canExecute", false);
            }
        },

        _onPropertyChanged: function () {
            // summary:
            //      This is called whenever the specified property is changed on
            //      the model and sets canExecute to the value.
            // tags:
            //      protected

            var canExecute = this.propertiesToWatch.every(function (property) {
                return !!this.model[property];
            }, this);

            this.set("canExecute", canExecute);
        }
    });
});

},
'epi-cms/contentediting/command/SendForReview':function(){
define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    topic,
    ContentActionSupport,
    _ChangeContentStatus,
    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Set the content as ready to publish
        //
        // tags:
        //      internal

        label: resources.sendforreview.label,

        executingLabel: resources.sendforreview.executinglabel,

        tooltip: resources.sendforreview.title,

        iconClass: "epi-iconCheckmark",

        action: ContentActionSupport.saveAction.CheckIn,

        _execute: function () {
            // summary:
            //    Executes this command. Set the content as ready to publish.
            //
            // tags:
            //		protected

            // Disable Undo & Redo actions.
            topic.publish("/epi/cms/action/disableundoredoactions");

            return this.inherited(arguments);
        }
    });
});

},
'epi-cms/contentediting/command/_ChangeContentStatus':function(){
define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi/shell/DestroyableByKey",
    // Parent class
    "epi-cms/contentediting/command/_ContentCommandBase"
], function (
    declare,
    topic,
    DestroyableByKey,
    // Parent class
    _ContentCommandBase
) {

    return declare([_ContentCommandBase, DestroyableByKey], {
        // summary:
        //      Base class for any Change content status commands, like: Reject, Publish, ...
        // tags:
        //      internal abstract

        // action: [public] String
        //      Action to perform when changing content status. For example: publish, checkin, checkout, ...
        action: null,

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed.
        canExecute: true,

        // forceReload: [public] Boolean
        //      Indicate whether the command should demand a reload together with the context change request.
        forceReload: false,

        // viewName: [public] String
        //      Represents the view that will be display after changing content status. It might be null or empty.
        viewName: null,

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["hasErrors"],

        _execute: function () {
            // summary:
            //      Executes this command which asks the model to change the content status and then
            //      request a context change.
            // tags:
            //      protected

            return this.model.changeContentStatus(this.action).then(this._onContentStatusChange.bind(this));
        },

        _onContentStatusChange: function (result) {
            // summary:
            //      Callback which updates the context after the content status has been changed.
            // tags:
            //      protected

            var contextParameters = { uri: "epi.cms.contentdata:///" +  result.id };
            var callerData = {
                sender: this,
                trigger: "internal",
                forceContextChange: true,
                forceReload: this.forceReload
            };

            if (this.viewName) {
                callerData.viewName = this.viewName;
            }

            topic.publish("/epi/shell/context/request", contextParameters, callerData);

            return result;
        },

        _onPropertyChanged: function () {
            // summary:
            //      This is called whenever the specified property in propertiesToWatch
            //      is changed on the model and sets canExecute.
            // tags:
            //      protected

            this.set("canExecute", !this.model.hasErrors);
        }
    });
});

},
'epi-cms/contentediting/command/Publish':function(){
define([
//Dojo
    "dojo/_base/declare",
    "dojo/topic",
    "dojo/when",
    //EPi
    "epi/shell/TypeDescriptorManager",

    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
//Dojo
    declare,
    topic,
    when,
    //EPi
    TypeDescriptorManager,

    ContentReference,
    ContentActionSupport,
    _ChangeContentStatus,

    //Resources
    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Publish content command.
        //
        // tags:
        //      internal

        label: resources.publish.label,

        executingLabel: resources.publish.executinglabel,

        tooltip: resources.publish.title,

        iconClass: "epi-iconPublished",

        action: ContentActionSupport.saveAction.Publish,

        // forceReload: [public] Boolean
        //      When publishing a content, it may affect the preview parts which fetch data from published version meanwhile the context change request might not force the preview to reload if the preview is already reloaded before the action (switch Allproperties/OPE).
        forceReload: true,

        _execute: function () {
            // summary:
            //    Executes this command; publish the current content
            //
            // tags:
            //		protected

            // Execute base to change content status
            return when(this.inherited(arguments)).then(function (result) {
                // Update tree children nodes
                // if this has sorting by sort order.
                var versionAgnosticId = new ContentReference(result.oldId).createVersionUnspecificReference().toString();
                topic.publish("/epi/cms/contentdata/childrenchanged", versionAgnosticId);
            });
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                res = null;

            switch (contentData.status) {
                case ContentActionSupport.versionStatus.PreviouslyPublished:
                    res = resources.republish;
                    break;
                case ContentActionSupport.versionStatus.CheckedOut:
                    if (contentData.isMasterVersion) {
                        res = resources.publish;
                    } else {
                        res = resources.publishchanges;
                    }
                    break;
                default:
                    res = resources.publishchanges;
            }

            var publishView = TypeDescriptorManager.getValue(contentData.typeIdentifier, "publishView");

            this.set("label", res.label);
            this.set("title", res.title);
            this.set("executingLabel", res.executinglabel);
            this.set("viewName", publishView);
        }
    });
});

},
'epi-cms/contentediting/command/CreateDraft':function(){
define([
    "dojo/_base/declare",
    "epi-cms/contentediting/command/_ContentCommandBase",
    "epi-cms/contentediting/ContentActionSupport",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    _ContentCommandBase,
    ContentActionSupport,
    resources
) {

    return declare([_ContentCommandBase], {
        // summary:
        //      Create a draft version out of the current content
        //
        // tags:
        //      internal

        name: "createdraft",
        label: resources.createdraft.label,
        tooltip: resources.createdraft.title,
        iconClass: "epi-iconVersions",

        // ignoreContentStatus: [public] Boolean
        //      Indicates whether the status of the content should be considered
        //      when determining whether this command can be executed.
        ignoreContentStatus: false,

        _execute: function () {
            // summary:
            //    Executes this command; create a new draft version out of the current content
            //
            // tags:
            //		protected

            this.model.createDraft();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,
                status = contentData.status,
                versionStatus = ContentActionSupport.versionStatus,
                hasAccess,
                draftPossible;

            this.inherited(arguments);

            // The user has to have sufficient access rights
            hasAccess = ContentActionSupport.hasAccessToAction(
                contentData,
                ContentActionSupport.action.Edit,
                ContentActionSupport.providerCapabilities.Edit
            );

            draftPossible =
                // Either we ignore the content status
                this.ignoreContentStatus ||
                // Or the status is delayed publish
                status === versionStatus.DelayedPublish ||
                // Or the status is publish or previously published and it's the common draft
                (status === versionStatus.Published || status === versionStatus.PreviouslyPublished) && !contentData.isCommonDraft;

            this.set({
                canExecute: hasAccess && draftPossible,
                isAvailable: hasAccess && draftPossible
            });
        }
    });

});

},
'epi-cms/contentediting/command/Withdraw':function(){
define([
    "dojo/_base/declare",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",
    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
], function (
    declare,
    ContentActionSupport,
    _ChangeContentStatus,
    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //    Withdraw a ready to publish version to edit command.
        // tags:
        //      internal

        label: resources.withdraw.label,

        tooltip: resources.withdraw.title,

        iconClass: "epi-iconPen",

        action: ContentActionSupport.saveAction.Reject | ContentActionSupport.saveAction.ForceCurrentVersion | ContentActionSupport.saveAction.SkipValidation
    });
});

},
'epi-cms/contentediting/command/ManageExpiration':function(){
﻿define([

    // Dojo
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/when",

    // EPi CMS
    "epi-cms/contentediting/ExpirationDialog",
    "epi-cms/contentediting/viewmodel/ExpirationDialogViewModel",
    "epi-cms/contentediting/ContentActionSupport",

    // EPi Framework
    "epi/shell/command/_Command",
    "epi/shell/DialogService",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.expirationeditor",
    "epi/i18n!epi/nls/episerver.shared"
], function (

    // Dojo
    connect,
    declare,
    when,

    // EPi CMS
    ExpirationDialog,
    ExpirationDialogViewModel,
    ContentActionSupport,

    // EPi Framework
    _Command,
    dialogService,

    // Resources
    resources,
    sharedResources
) {

    return declare([_Command], {
        // summary:
        //      Displays the manage expiration dialog for the current content.
        //
        // tags:
        //      internal xproduct

        label: resources.dialogtitle,

        tooltip: resources.dialogtitle,

        viewModel: null,

        cssClass: "epi-chromelessButton epi-visibleLink",

        // expirationDialogClass: [public] Function
        //      The constructor function for the expiration dialog
        expirationDialogClass: ExpirationDialog,

        // expirationDialogViewModelClass: [public] Function
        //      The constructor function for the expiration dialog view model
        expirationDialogViewModelClass: ExpirationDialogViewModel,

        _execute: function () {
            // summary:
            //		Toggles the value of the given property on the model.
            // tags:
            //		protected

            var dialogViewModel = this.get("viewModel");

            var content = new this.expirationDialogClass({ model: dialogViewModel });

            dialogService.dialog({
                defaultActionsVisible: false,
                confirmActionText: sharedResources.action.save,
                content: content,
                title: resources.dialogtitle,
                dialogClass: "epi-dialog-portrait"
            }).then(function (value) {
                var model = this.get("model");
                model.saveAndPublishProperty("iversionable_expire", value, ContentActionSupport.saveAction.SkipValidation);
            }.bind(this));
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.get("model");
            if (!model || !model.contentData) {
                this.set("canExecute", false);
                return;
            }

            var properties = model.contentData.properties,
                expireBlock = properties.iversionable_expire;

            var canExecute = model.canChangeContent() &&
                             ContentActionSupport.hasAccess(model.contentData.accessMask, ContentActionSupport.accessLevel.Publish); // Ensure the user has Publish access right

            // Command is not available until the metadata resolves
            this.set("canExecute", false);

            when(model.getPropertyMetaData("iversionable_expire"))
                .then(function (metadata) {
                    this.set("viewModel", new this.expirationDialogViewModelClass({
                        metadata: metadata,
                        contentLink: model.contentLink,
                        contentData: model.contentData,
                        contentName: model.contentData.name,
                        value: expireBlock,
                        minimumExpireDate: properties.iversionable_startpublish
                    }));

                    this.set("canExecute", canExecute);
                }.bind(this),
                function (res) {
                    if (res && res.status === 409) {
                        dialogService.alert(sharedResources.messages.unexpectederror);
                    }
                });
        }
    });
});

},
'epi-cms/contentediting/ExpirationDialog':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dijit/_CssStateMixin",
    "epi-cms/widget/Breadcrumb",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/shell/widget/FormContainer",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/_ActionProviderWidget",
    "epi-cms/widget/ContentReferences",
    "dojo/text!./templates/ExpirationDialog.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.expirationeditor",
    "epi/i18n!epi/nls/episerver.shared"
],
function (declare, lang, domStyle, _CssStateMixin, Breadcrumb, _DialogContentMixin, FormContainer, _ModelBindingMixin, _ActionProviderWidget, ContentReferences, template, res, sharedResources) {
    return declare([FormContainer, _ActionProviderWidget, _DialogContentMixin, _CssStateMixin, _ModelBindingMixin], {
        // tags:
        //      internal xproduct

        templateString: template,

        res: res,

        contentLink: null,

        contentName: null,

        baseClass: "epi-statusIndicator",

        modelBindingMap: {
            contentLink: ["contentLink"],
            contentData: ["contentData"],
            contentName: ["contentName"],
            infoText: ["infoText"],
            state: ["state"],
            enableSaveButton: ["enableSaveButton"],
            showRemoveButton: ["showRemoveButton"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            // Things that need to set up the form container
            this.model.reset();
            this.set("metadata", this.model.metadata);
            this.set("value", this.model.value);

            // This form container is used inside a dialog without any size constraints because the dialog allow its content to overflow.
            // Therefore, we should not layout the form's top layout container.
            this.doLayout = false;
        },

        _archiveLinkSelector: null,

        _setContentLinkAttr: function (value) {
            this.breadcrumb.set("contentLink", value);
        },

        _setContentDataAttr: function (value) {
            this._contentReferences = new ContentReferences({
                contentItems: [value],
                mode: "confirm"
            });
            this._contentReferences.placeAt(this.references);
            this.own(this._contentReferences);

            var watch = this._contentReferences.watch("numberOfReferences", function (propertyName, oldValue, newValue) {
                watch.remove();

                if (newValue === 0) {
                    this.references.classList.add("dijitHidden");
                }
            }.bind(this));
        },

        _setContentNameAttr: {
            node: "contentNameNode",
            type: "innerText"
        },

        _setInfoTextAttr: {
            node: "infoTextNode",
            type: "innerText"
        },

        _setEnableSaveButtonAttr: function (value) {
            if (this._actions && this._actions.length) {
                this.setActionProperty("save", "disabled", !value);
            }
        },

        _setShowRemoveButtonAttr: function (value) {
            domStyle.set(this.removeButton.domNode, "display", value ? "" : "none");
        },

        _onRemoveButtonClick: function () {
            var resetValue = {
                stopPublish: null,
                archiveLink: null
            };
            this.set("value", resetValue);
            this.onChange(resetValue);
        },

        onFieldCreated: function (fieldName, widget) {
            // summary:
            //     Raised when a field editor widget is created.
            // description:
            //     Override the FormContainer method to catch and keep reference to archiveLink widget
            // fieldName: String
            //     The field name
            // widget: dijit/_Widget
            //     The widget
            // tags:
            //     callback

            if (fieldName === "stopPublish") {
                widget.set("minimumValue", this.model.get("minimumExpireDate"));
                widget.set("minimumValueMessage", this.model.get("minimumExpireDateMessage"));
            } else if (fieldName === "archiveLink") {

                // TODO: remove link on destroy?

                this._archiveLinkSelector = widget;
                if (this._archiveLinkSelector.readOnly) {
                    //if the widget is already read only is because the property is not language specific and we're not the master language.
                    this._archiveLinkSelector._keepReadOnly = true;
                }

                this._archiveLinkSelector.set("contentLink", this.model.get("contentLink"));
            }
        },

        onChange: function (value) {
            this.inherited(arguments);
            this.model.set("intermediateValue", value);
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget
            //
            // returns:
            //      An array containing a select page action definition, if it is not a shared block

            this._actions = [
                {
                    name: "cancel",
                    label: sharedResources.action.cancel,
                    settings: { type: "button", "class": "epi-plain-button" },
                    action: lang.hitch(this, function () {
                        this.model.reset();
                        this.cancelDialog();
                    })
                },
                {
                    name: "save",
                    label: sharedResources.action.save,
                    settings: { type: "button", disabled: true, "class": "Salt" },
                    action: lang.hitch(this, function () {
                        if (this.validate()) {
                            this.model.save();
                            this.executeDialog(this.model.get("value"));
                        }
                    })
                }
            ];

            return this._actions;
        }
    });
});

},
'epi-cms/widget/Breadcrumb':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/on",
    "dojo/when",

    "dojo/query",
    "dojo/NodeList-manipulate",
    "dojo/topic",

    // dijit
    "dijit/_Widget",
    "dijit/layout/_LayoutWidget",

    // epi
    "epi/dependency",

    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/widget/_HierarchicalModelMixin"
],

function (
// dojo
    array,
    declare,
    lang,

    aspect,
    Deferred,
    domClass,
    domConstruct,
    domGeometry,
    domStyle,
    on,
    when,

    query,
    NodeList,
    topic,

    // dijit
    _Widget,
    _LayoutWidget,

    // epi
    dependency,

    ContentReference,
    _ContextualContentContextMixin,
    _HierarchicalModelMixin
) {

    return declare([_LayoutWidget, _HierarchicalModelMixin, _ContextualContentContextMixin], {
        // summary:
        //    Wiget used to show the content's path on a tree struture.
        //
        // tags:
        //      internal xproduct

        // contentLink: [public] String
        //    The current content link.
        contentLink: null,

        // store: [public] epi.cms.pagedata.light
        //    The widget data store.
        store: null,

        // showOnlyAncestors: [public] Boolean
        //    Flag indicating is the current node will be shown.
        showCurrentNode: true,

        // showLastBracket: [public] Boolean
        //    Flag indicating is the last bracket will be shown.
        showLastBracket: false,

        // displayAsText: [public] Boolean
        //    States if the path will be displayed as links or simple text.
        displayAsText: true,

        // minimumItemCount: [public] Number
        //    If set, when laying out, the widget wouldn't truncate if there is less than this number of item visible.
        minimumItemCount: null,

        baseClass: "epi-breadCrumbs",

        _resizeListener: null,
        _visibleItems: [],

        _currentContent: null,
        _ancestors: null,

        postMixInProperties: function () {
            // summary:
            //    Post mixin properties handler.

            var registry = dependency.resolve("epi.storeregistry");
            this.store = this.store || registry.get("epi.cms.content.light");

            this.minimumItemCount = this.minimumItemCount || 2;
        },

        buildRendering: function () {
            // summary:
            //      Constructs the base DOM node for this widget and sets it to this.domNode.
            // tags:
            //      protected
            this.domNode = this.ownerDocument.createElement("ul");

            this.inherited(arguments);
        },

        startup: function () {
            // summary:
            //      Start the widget up.

            this._addResizeListener();
        },

        destroy: function () {
            // summary:
            //      Destroy the widget.

            if (this._resizeListener) {
                this._resizeListener.remove();
            }

            this.destroyDescendants();

            this.inherited(arguments);
        },

        _addResizeListener: function () {
            // summary:
            //      Add a listener to the closest ancestor which is a layout container to be able to react to resize event.
            // remark:
            //      Since this widget might not be a direct child of a layout widget, it would unlikely know when it got resized.
            //      The dijit layout system relies on layout() and layoutChildren() methods in cases that resizing is caused by a layout container rather than a window resize.
            //      Therefore, we have to actively connect to the closest ancestor's layout method.

            if (this._resizeListener) {
                return;
            }

            var parent = this.getParent(),
                resizeContainer = parent;

            while (resizeContainer && !resizeContainer.isLayoutContainer && resizeContainer.getParent()) {
                resizeContainer = resizeContainer.getParent();
            }

            if (resizeContainer && resizeContainer !== parent) {
                this._resizeListener = aspect.after(resizeContainer, "resize", lang.hitch(this, function () {
                    var changeSize = domGeometry.getMarginBox(this.domNode);
                    this.resize(changeSize);
                }));
            }
        },

        resize: function (changeSize) {
            if (!changeSize && this._resizeListener) {
                return; // The window is resized. If we have a resize container, we will get resize request from resize container later.
            } else {
                // We need to re-layout all the time the sizing container resized
                this.layout();
            }
        },

        layout: function () {
            // summary:
            //      Layout the breadcrums items.

            this._visibleItems = [];

            when(this._buildPath(), lang.hitch(this, function () {
                //if still overflow.
                var actualWidth = domGeometry.getContentBox(this.domNode).w;
                if (actualWidth > this._availableWidth) {
                    var leadingItemWidth = this._leadingItem ? domGeometry.getMarginBox(this._leadingItem.domNode).w : 0;
                    var availableWidthToEllipsis = this._availableWidth - leadingItemWidth;
                    this._ellipsisize(0, availableWidthToEllipsis);
                }
            }));
        },

        _setContentLinkAttr: function (/*Integer*/value) {
            // summary:
            //   The value on the content property
            //
            // value:
            //    The content object.
            //
            // tags:
            //    private

            this._set("contentLink", value);
            this._currentContent = null;
            this._ancestors = null;
            this.layout();
        },

        _buildPath: function () {
            // summary:
            //    Helper function to build the content's path.
            //
            // tags:
            //    private

            var contentLink = this.get("contentLink"),
                def = new Deferred(),
                path = "";

            if (this._currentContent && this._ancestors) {
                this._createAllItems();
                def.resolve(path);
            } else if (contentLink) {
                var contentReference = new ContentReference(contentLink);
                var contentId = contentReference.createVersionUnspecificReference().toString();

                when(this.getCurrentContext(), lang.hitch(this, function (ctx) {

                    when(this.store.get(contentId), lang.hitch(this, function (currentContent) {

                        this.getAncestors(contentId, lang.hitch(this, function (ancestors) {

                            this._currentContent = currentContent;

                            this._ancestors = ancestors;

                            this._createAllItems();

                            def.resolve(path);
                        }));
                    }));
                }));
            } else {
                def.resolve(path);
            }

            return def.promise; // Promise
        },

        _createAllItems: function () {

            // Cleanup first
            this._cleanUp();

            if (!this.isTypeOfRoot(this._currentContent)) {
                var filteredItems = [],
                    ancestor = null;

                // Remove all but first sub root
                for (var i = this._ancestors.length - 1; i >= 0; i--) {
                    // Modify context root name
                    ancestor = this._ancestors[i];

                    // Do not add root node
                    if (!ancestor.parentLink) {
                        continue;
                    }

                    // Push item
                    filteredItems.push(ancestor);

                    // Break after first sub root or context root
                    if (this.isTypeOfRoot(ancestor)) {
                        break;
                    }
                }

                // Reverse the list
                filteredItems.reverse();

                var maxWidth = domGeometry.getContentBox(this.domNode).w;
                this._availableWidth = maxWidth >= 0 ? maxWidth : 0;

                array.forEach(filteredItems, lang.hitch(this, function (content) {
                    this._createItem(content, true);
                }));
            }

            if (this.showCurrentNode) {
                this._createItem(this._currentContent, this.showLastBracket);
            }
        },

        _cleanUp: function () {
            this.destroyDescendants();
            this._leadingItem = null;
            this._visibleItems = [];
        },

        _createItem: function (content, withSeparator) {
            // summary:
            //      Add a link to the content.
            // content: Object
            //      The content object.
            // withSeparator: Boolean
            //      Flag indicating whether a separator should be created after the new breadcrumb item.
            // tags:
            //      private

            var node,
                listNode = domConstruct.create("li"),
                isTextNode = this.displayAsText || !content.hasTemplate;

            if (isTextNode) {
                node = domConstruct.create("span", null, listNode);
            } else {
                node = domConstruct.create("a", { href: "#" }, listNode);

                this.own(on(node, "click", lang.hitch(this, function (e) {
                    this.onNodeClick(e, content);
                })));
            }

            node.textContent = this.isContextualContent(content) ? this.getContextualRootName(content) : content.name;

            if (withSeparator) {
                domConstruct.create("span", { innerHTML: "", "class": "epi-breadCrumbsSeparator" }, listNode);
            }

            this._addAndLayout(listNode);
        },

        onNodeClick: function (e, content) {
            // summary:
            //      Click on a node on breadcrumb, load new context .
            // e: Object
            //      The mouse event object.
            // content: Object
            //      The content object.
            // tags:
            //      protected

            e.preventDefault();
            topic.publish("/epi/shell/context/request", { uri: content.uri }, { sender: this });
        },

        _addAndLayout: function (node) {
            // summary:
            //      Add an item and do layout.
            // remark:
            //      If there was not space, the items on the left would be hidden.

            var toAdd = new _Widget({}, node);

            this._visibleItems.push(toAdd);
            this.addChild(toAdd);

            var newWidth = this._getTotalVisibleItemsSize(); //domGeometry.getContentBox(this.domNode).w;

            if (newWidth > this._availableWidth) {
                this._ensureLeadingItem();

                while (newWidth > this._availableWidth && this._visibleItems.length > this.minimumItemCount) {
                    var firstItem = this._visibleItems.splice(0, 1)[0];

                    domStyle.set(firstItem.domNode, "display", "none");
                    newWidth = this._getTotalVisibleItemsSize();
                }
            }
        },

        _getTotalVisibleItemsSize: function () {
            var width = 0;

            if (this._leadingItem) {
                width += domGeometry.getMarginBox(this._leadingItem.domNode).w;
            }

            array.forEach(this._visibleItems, function (item) {
                width += domGeometry.getMarginBox(item.domNode).w;
            });

            return width;
        },

        _ensureLeadingItem: function () {
            // summary:
            //      Make sure that we have an elipssis item at the beginning if some items is truncated.

            if (this._leadingItem) {
                return;
            }

            var leadingItemNode = domConstruct.create("li"),
                ellipsisNode = domConstruct.create("span", { innerHTML: "..." }),
                separator = domConstruct.create("span", { innerHTML: " &gt; ", "class": "epi-breadCrumbsSeparator" });

            domConstruct.place(ellipsisNode, leadingItemNode, "last");
            domConstruct.place(separator, leadingItemNode, "last");

            this._leadingItem = new _Widget({}, leadingItemNode);
            this.addChild(this._leadingItem, 0); //add to the first index
        },

        _ellipsisize: function (startIndex, availableWidth) {
            // summary:
            //      Ellipsisize a set of items.
            // startIndex: Number
            //      The index of item to start with.
            // availableWidth: Number
            //      Total available width in pixels.

            if (startIndex >= this._visibleItems.length) {
                return;
            }

            var noOfItems = this._visibleItems.length - startIndex,
                maxItemWidth = Math.floor(availableWidth / noOfItems),
                item = this._visibleItems[startIndex],
                actualItemWidth = domGeometry.getMarginBox(item.domNode).w;

            if (actualItemWidth <= maxItemWidth) {
                this._ellipsisize(startIndex + 1, availableWidth - actualItemWidth);
            } else {
                var nodeToEllipsis = query(this.displayAsText ? "span" : "a", item.domNode)[0],
                    separator = query("span.epi-breadCrumbsSeparator", item.domNode)[0],
                    itemWidth = maxItemWidth - domGeometry.getMarginBox(separator).w;

                if (itemWidth < 0) {
                    itemWidth = 0;
                }

                domStyle.set(nodeToEllipsis, "width", itemWidth + "px");
                domClass.add(nodeToEllipsis, "dojoxEllipsis");

                this._ellipsisize(startIndex + 1, availableWidth - maxItemWidth);
            }
        }

    });

});

},
'dojo/NodeList-manipulate':function(){
define("dojo/NodeList-manipulate", ["./query", "./_base/lang", "./_base/array", "./dom-construct", "./NodeList-dom"], function(dquery, lang, array, construct){
	// module:
	//		dojo/NodeList-manipulate

	/*=====
	return function(){
		// summary:
		//		Adds chainable methods to dojo.query() / NodeList instances for manipulating HTML
		//		and DOM nodes and their properties.
	};
	=====*/

	var NodeList = dquery.NodeList;

	//TODO: add a way to parse for widgets in the injected markup?

	function getText(/*DOMNode*/node){
		// summary:
		//		recursion method for text() to use. Gets text value for a node.
		// description:
		//		Juse uses nodedValue so things like <br/> tags do not end up in
		//		the text as any sort of line return.
		var text = "", ch = node.childNodes;
		for(var i = 0, n; n = ch[i]; i++){
			//Skip comments.
			if(n.nodeType != 8){
				if(n.nodeType == 1){
					text += getText(n);
				}else{
					text += n.nodeValue;
				}
			}
		}
		return text;
	}

	function getWrapInsertion(/*DOMNode*/node){
		// summary:
		//		finds the innermost element to use for wrap insertion.

		//Make it easy, assume single nesting, no siblings.
		while(node.childNodes[0] && node.childNodes[0].nodeType == 1){
			node = node.childNodes[0];
		}
		return node; //DOMNode
	}

	function makeWrapNode(/*DOMNode||String*/html, /*DOMNode*/refNode){
		// summary:
		//		convert HTML into nodes if it is not already a node.
		if(typeof html == "string"){
			html = construct.toDom(html, (refNode && refNode.ownerDocument));
			if(html.nodeType == 11){
				//DocumentFragment cannot handle cloneNode, so choose first child.
				html = html.childNodes[0];
			}
		}else if(html.nodeType == 1 && html.parentNode){
			//This element is already in the DOM clone it, but not its children.
			html = html.cloneNode(false);
		}
		return html; /*DOMNode*/
	}

	lang.extend(NodeList, {
		_placeMultiple: function(/*String||Node||NodeList*/query, /*String*/position){
			// summary:
			//		private method for inserting queried nodes into all nodes in this NodeList
			//		at different positions. Differs from NodeList.place because it will clone
			//		the nodes in this NodeList if the query matches more than one element.
			var nl2 = typeof query == "string" || query.nodeType ? dquery(query) : query;
			var toAdd = [];
			for(var i = 0; i < nl2.length; i++){
				//Go backwards in DOM to make dom insertions easier via insertBefore
				var refNode = nl2[i];
				var length = this.length;
				for(var j = length - 1, item; item = this[j]; j--){
					if(i > 0){
						//Need to clone the item. This also means
						//it needs to be added to the current NodeList
						//so it can also be the target of other chaining operations.
						item = this._cloneNode(item);
						toAdd.unshift(item);
					}
					if(j == length - 1){
						construct.place(item, refNode, position);
					}else{
						refNode.parentNode.insertBefore(item, refNode);
					}
					refNode = item;
				}
			}

			if(toAdd.length){
				//Add the toAdd items to the current NodeList. Build up list of args
				//to pass to splice.
				toAdd.unshift(0);
				toAdd.unshift(this.length - 1);
				Array.prototype.splice.apply(this, toAdd);
			}

			return this; // dojo/NodeList
		},

		innerHTML: function(/*String|DOMNode|NodeList?*/ value){
			// summary:
			//		allows setting the innerHTML of each node in the NodeList,
			//		if there is a value passed in, otherwise, reads the innerHTML value of the first node.
			// description:
			//		This method is simpler than the dojo/NodeList.html() method provided by
			//		`dojo/NodeList-html`. This method just does proper innerHTML insertion of HTML fragments,
			//		and it allows for the innerHTML to be read for the first node in the node list.
			//		Since dojo/NodeList-html already took the "html" name, this method is called
			//		"innerHTML". However, if dojo/NodeList-html has not been loaded yet, this
			//		module will define an "html" method that can be used instead. Be careful if you
			//		are working in an environment where it is possible that dojo/NodeList-html could
			//		have been loaded, since its definition of "html" will take precedence.
			//		The nodes represented by the value argument will be cloned if more than one
			//		node is in this NodeList. The nodes in this NodeList are returned in the "set"
			//		usage of this method, not the HTML that was inserted.
			// returns:
			//		if no value is passed, the result is String, the innerHTML of the first node.
			//		If a value is passed, the return is this dojo/NodeList
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"></div>
			//	|	<div id="bar"></div>
			//		This code inserts `<p>Hello World</p>` into both divs:
			//	|	dojo.query("div").innerHTML("<p>Hello World</p>");
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		This code returns `<p>Hello Mars</p>`:
			//	|	var message = dojo.query("div").innerHTML();
			if(arguments.length){
				return this.addContent(value, "only"); // dojo/NodeList
			}else{
				return this[0].innerHTML; //String
			}
		},

		/*=====
		html: function(value){
			// summary:
			//		see the information for "innerHTML". "html" is an alias for "innerHTML", but is
			//		only defined if dojo/NodeList-html has not been loaded.
			// description:
			//		An alias for the "innerHTML" method, but only defined if there is not an existing
			//		"html" method on dojo/NodeList. Be careful if you are working in an environment
			//		where it is possible that dojo/NodeList-html could have been loaded, since its
			//		definition of "html" will take precedence. If you are not sure if dojo/NodeList-html
			//		could be loaded, use the "innerHTML" method.
			// value: String|DOMNode|NodeList?
			//		The HTML fragment to use as innerHTML. If value is not passed, then the innerHTML
			//		of the first element in this NodeList is returned.
			// returns:
			//		if no value is passed, the result is String, the innerHTML of the first node.
			//		If a value is passed, the return is this dojo/NodeList
			return; // dojo/NodeList|String
		},
		=====*/

		text: function(/*String*/value){
			// summary:
			//		allows setting the text value of each node in the NodeList,
			//		if there is a value passed in, otherwise, returns the text value for all the
			//		nodes in the NodeList in one string.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"></div>
			//	|	<div id="bar"></div>
			//		This code inserts "Hello World" into both divs:
			//	|	dojo.query("div").text("Hello World");
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars <span>today</span></p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		This code returns "Hello Mars today":
			//	|	var message = dojo.query("div").text();
			// returns:
			//		if no value is passed, the result is String, the text value of the first node.
			//		If a value is passed, the return is this dojo/NodeList
			if(arguments.length){
				for(var i = 0, node; node = this[i]; i++){
					if(node.nodeType == 1){
						construct.empty(node);
						node.appendChild(node.ownerDocument.createTextNode(value));
					}
				}
				return this; // dojo/NodeList
			}else{
				var result = "";
				for(i = 0; node = this[i]; i++){
					result += getText(node);
				}
				return result; //String
			}
		},

		val: function(/*String||Array*/value){
			// summary:
			//		If a value is passed, allows seting the value property of form elements in this
			//		NodeList, or properly selecting/checking the right value for radio/checkbox/select
			//		elements. If no value is passed, the value of the first node in this NodeList
			//		is returned.
			// returns:
			//		if no value is passed, the result is String or an Array, for the value of the
			//		first node.
			//		If a value is passed, the return is this dojo/NodeList
			// example:
			//		assume a DOM created by this markup:
			//	|	<input type="text" value="foo">
			//	|	<select multiple>
			//	|		<option value="red" selected>Red</option>
			//	|		<option value="blue">Blue</option>
			//	|		<option value="yellow" selected>Yellow</option>
			//	|	</select>
			//		This code gets and sets the values for the form fields above:
			//	|	dojo.query('[type="text"]').val(); //gets value foo
			//	|	dojo.query('[type="text"]').val("bar"); //sets the input's value to "bar"
			// 	|	dojo.query("select").val() //gets array value ["red", "yellow"]
			// 	|	dojo.query("select").val(["blue", "yellow"]) //Sets the blue and yellow options to selected.

			//Special work for input elements.
			if(arguments.length){
				var isArray = lang.isArray(value);
				for(var index = 0, node; node = this[index]; index++){
					var name = node.nodeName.toUpperCase();
					var type = node.type;
					var newValue = isArray ? value[index] : value;

					if(name == "SELECT"){
						var opts = node.options;
						for(var i = 0; i < opts.length; i++){
							var opt = opts[i];
							if(node.multiple){
								opt.selected = (array.indexOf(value, opt.value) != -1);
							}else{
								opt.selected = (opt.value == newValue);
							}
						}
					}else if(type == "checkbox" || type == "radio"){
						node.checked = (node.value == newValue);
					}else{
						node.value = newValue;
					}
				}
				return this; // dojo/NodeList
			}else{
				//node already declared above.
				node = this[0];
				if(!node || node.nodeType != 1){
					return undefined;
				}
				value = node.value || "";
				if(node.nodeName.toUpperCase() == "SELECT" && node.multiple){
					//A multivalued selectbox. Do the pain.
					value = [];
					//opts declared above in if block.
					opts = node.options;
					//i declared above in if block;
					for(i = 0; i < opts.length; i++){
						//opt declared above in if block
						opt = opts[i];
						if(opt.selected){
							value.push(opt.value);
						}
					}
					if(!value.length){
						value = null;
					}
				}
				return value; //String||Array
			}
		},

		append: function(/*String||DOMNode||NodeList*/content){
			// summary:
			//		appends the content to every node in the NodeList.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the appended content.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		Running this code:
			//	|	dojo.query("div").append("<span>append</span>");
			//		Results in this DOM structure:
			//	|	<div id="foo"><p>Hello Mars</p><span>append</span></div>
			//	|	<div id="bar"><p>Hello World</p><span>append</span></div>
			return this.addContent(content, "last"); // dojo/NodeList
		},

		appendTo: function(/*String*/query){
			// summary:
			//		appends nodes in this NodeList to the nodes matched by
			//		the query passed to appendTo.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the matched nodes from the query.
			// example:
			//		assume a DOM created by this markup:
			//	|	<span>append</span>
			//	|	<p>Hello Mars</p>
			//	|	<p>Hello World</p>
			//		Running this code:
			//	|	dojo.query("span").appendTo("p");
			//		Results in this DOM structure:
			//	|	<p>Hello Mars<span>append</span></p>
			//	|	<p>Hello World<span>append</span></p>
			return this._placeMultiple(query, "last"); // dojo/NodeList
		},

		prepend: function(/*String||DOMNode||NodeList*/content){
			// summary:
			//		prepends the content to every node in the NodeList.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the appended content.
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		Running this code:
			//	|	dojo.query("div").prepend("<span>prepend</span>");
			//		Results in this DOM structure:
			//	|	<div id="foo"><span>prepend</span><p>Hello Mars</p></div>
			//	|	<div id="bar"><span>prepend</span><p>Hello World</p></div>
			return this.addContent(content, "first"); // dojo/NodeList
		},

		prependTo: function(/*String*/query){
			// summary:
			//		prepends nodes in this NodeList to the nodes matched by
			//		the query passed to prependTo.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the matched nodes from the query.
			// example:
			//		assume a DOM created by this markup:
			//	|	<span>prepend</span>
			//	|	<p>Hello Mars</p>
			//	|	<p>Hello World</p>
			//		Running this code:
			//	|	dojo.query("span").prependTo("p");
			//		Results in this DOM structure:
			//	|	<p><span>prepend</span>Hello Mars</p>
			//	|	<p><span>prepend</span>Hello World</p>
			return this._placeMultiple(query, "first"); // dojo/NodeList
		},

		after: function(/*String||Element||NodeList*/content){
			// summary:
			//		Places the content after every node in the NodeList.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the appended content.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		Running this code:
			//	|	dojo.query("div").after("<span>after</span>");
			//		Results in this DOM structure:
			//	|	<div id="foo"><p>Hello Mars</p></div><span>after</span>
			//	|	<div id="bar"><p>Hello World</p></div><span>after</span>
			return this.addContent(content, "after"); // dojo/NodeList
		},

		insertAfter: function(/*String*/query){
			// summary:
			//		The nodes in this NodeList will be placed after the nodes
			//		matched by the query passed to insertAfter.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the matched nodes from the query.
			// example:
			//		assume a DOM created by this markup:
			//	|	<span>after</span>
			//	|	<p>Hello Mars</p>
			//	|	<p>Hello World</p>
			//		Running this code:
			//	|	dojo.query("span").insertAfter("p");
			//		Results in this DOM structure:
			//	|	<p>Hello Mars</p><span>after</span>
			//	|	<p>Hello World</p><span>after</span>
			return this._placeMultiple(query, "after"); // dojo/NodeList
		},

		before: function(/*String||DOMNode||NodeList*/content){
			// summary:
			//		Places the content before every node in the NodeList.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the appended content.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		Running this code:
			//	|	dojo.query("div").before("<span>before</span>");
			//		Results in this DOM structure:
			//	|	<span>before</span><div id="foo"><p>Hello Mars</p></div>
			//	|	<span>before</span><div id="bar"><p>Hello World</p></div>
			return this.addContent(content, "before"); // dojo/NodeList
		},

		insertBefore: function(/*String*/query){
			// summary:
			//		The nodes in this NodeList will be placed after the nodes
			//		matched by the query passed to insertAfter.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the matched nodes from the query.
			// example:
			//		assume a DOM created by this markup:
			//	|	<span>before</span>
			//	|	<p>Hello Mars</p>
			//	|	<p>Hello World</p>
			//		Running this code:
			//	|	dojo.query("span").insertBefore("p");
			//		Results in this DOM structure:
			//	|	<span>before</span><p>Hello Mars</p>
			//	|	<span>before</span><p>Hello World</p>
			return this._placeMultiple(query, "before"); // dojo/NodeList
		},

		/*=====
		remove: function(simpleFilter){
			// summary:
			//		alias for dojo/NodeList's orphan method. Removes elements
			//		in this list that match the simple filter from their parents
			//		and returns them as a new NodeList.
			// simpleFilter: String
			//		single-expression CSS rule. For example, ".thinger" or
			//		"#someId[attrName='value']" but not "div > span". In short,
			//		anything which does not invoke a descent to evaluate but
			//		can instead be used to test a single node is acceptable.

			return; // dojo/NodeList
		},
		=====*/
		remove: NodeList.prototype.orphan,

		wrap: function(/*String||DOMNode*/html){
			// summary:
			//		Wrap each node in the NodeList with html passed to wrap.
			// description:
			//		html will be cloned if the NodeList has more than one
			//		element. Only DOM nodes are cloned, not any attached
			//		event handlers.
			// returns:
			//		the nodes in the current NodeList will be returned,
			//		not the nodes from html argument.
			// example:
			//		assume a DOM created by this markup:
			//	|	<b>one</b>
			//	|	<b>two</b>
			//		Running this code:
			//	|	dojo.query("b").wrap("<div><span></span></div>");
			//		Results in this DOM structure:
			//	|	<div><span><b>one</b></span></div>
			//	|	<div><span><b>two</b></span></div>
			if(this[0]){
				html = makeWrapNode(html, this[0]);

				//Now cycle through the elements and do the insertion.
				for(var i = 0, node; node = this[i]; i++){
					//Always clone because if html is used to hold one of
					//the "this" nodes, then on the clone of html it will contain
					//that "this" node, and that would be bad.
					var clone = this._cloneNode(html);
					if(node.parentNode){
						node.parentNode.replaceChild(clone, node);
					}
					//Find deepest element and insert old node in it.
					var insertion = getWrapInsertion(clone);
					insertion.appendChild(node);
				}
			}
			return this; // dojo/NodeList
		},

		wrapAll: function(/*String||DOMNode*/html){
			// summary:
			//		Insert html where the first node in this NodeList lives, then place all
			//		nodes in this NodeList as the child of the html.
			// returns:
			//		the nodes in the current NodeList will be returned,
			//		not the nodes from html argument.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").wrapAll('<div class="allRed"></div>');
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="allRed">
			// 	|			<div class="red">Red One</div>
			// 	|			<div class="red">Red Two</div>
			// 	|		</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			if(this[0]){
				html = makeWrapNode(html, this[0]);

				//Place the wrap HTML in place of the first node.
				this[0].parentNode.replaceChild(html, this[0]);

				//Now cycle through the elements and move them inside
				//the wrap.
				var insertion = getWrapInsertion(html);
				for(var i = 0, node; node = this[i]; i++){
					insertion.appendChild(node);
				}
			}
			return this; // dojo/NodeList
		},

		wrapInner: function(/*String||DOMNode*/html){
			// summary:
			//		For each node in the NodeList, wrap all its children with the passed in html.
			// description:
			//		html will be cloned if the NodeList has more than one
			//		element. Only DOM nodes are cloned, not any attached
			//		event handlers.
			// returns:
			//		the nodes in the current NodeList will be returned,
			//		not the nodes from html argument.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").wrapInner('<span class="special"></span>');
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="red"><span class="special">Red One</span></div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red"><span class="special">Red Two</span></div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			if(this[0]){
				html = makeWrapNode(html, this[0]);
				for(var i = 0; i < this.length; i++){
					//Always clone because if html is used to hold one of
					//the "this" nodes, then on the clone of html it will contain
					//that "this" node, and that would be bad.
					var clone = this._cloneNode(html);

					//Need to convert the childNodes to an array since wrapAll modifies the
					//DOM and can change the live childNodes NodeList.
					this._wrap(lang._toArray(this[i].childNodes), null, this._NodeListCtor).wrapAll(clone);
				}
			}
			return this; // dojo/NodeList
		},

		replaceWith: function(/*String||DOMNode||NodeList*/content){
			// summary:
			//		Replaces each node in ths NodeList with the content passed to replaceWith.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		The nodes currently in this NodeList will be returned, not the replacing content.
			//		Note that the returned nodes have been removed from the DOM.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").replaceWith('<div class="green">Green</div>');
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="green">Green</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="green">Green</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			content = this._normalize(content, this[0]);
			for(var i = 0, node; node = this[i]; i++){
				this._place(content, node, "before", i > 0);
				node.parentNode.removeChild(node);
			}
			return this; // dojo/NodeList
		},

		replaceAll: function(/*String*/query){
			// summary:
			//		replaces nodes matched by the query passed to replaceAll with the nodes
			//		in this NodeList.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		The nodes currently in this NodeList will be returned, not the matched nodes
			//		from the query. The nodes currently in this NodeLIst could have
			//		been cloned, so the returned NodeList will include the cloned nodes.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").replaceAll(".blue");
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="red">Red Two</div>
			//	|	</div>
			var nl = dquery(query);
			var content = this._normalize(this, this[0]);
			for(var i = 0, node; node = nl[i]; i++){
				this._place(content, node, "before", i > 0);
				node.parentNode.removeChild(node);
			}
			return this; // dojo/NodeList
		},

		clone: function(){
			// summary:
			//		Clones all the nodes in this NodeList and returns them as a new NodeList.
			// description:
			//		Only the DOM nodes are cloned, not any attached event handlers.
			// returns:
			//		a cloned set of the original nodes.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").clone().appendTo(".container");
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="red">Red Two</div>
			//	|	</div>

			//TODO: need option to clone events?
			var ary = [];
			for(var i = 0; i < this.length; i++){
				ary.push(this._cloneNode(this[i]));
			}
			return this._wrap(ary, this, this._NodeListCtor); // dojo/NodeList
		}
	});

	//set up html method if one does not exist
	if(!NodeList.prototype.html){
		NodeList.prototype.html = NodeList.prototype.innerHTML;
	}

	return NodeList;
});

},
'epi/shell/widget/dialog/_DialogContentMixin':function(){
﻿define("epi/shell/widget/dialog/_DialogContentMixin", [
    "dojo/_base/declare"
], function (declare) {

    return declare(null, {
        // summary:
        //    Mixin which provides widgets capability to tell the container dialog to execute or cancel.
        // tags:
        //    internal xproduct

        executeDialog: function () {
            // summary:
            //	    Call this method to ask the container dialog to execute.
            // tags:
            //		protected
        },

        cancelDialog: function () {
            // summary:
            //	    Call this method to ask the container dialog to cancel.
            // tags:
            //		protected
        }

    });
});

},
'url:epi-cms/contentediting/templates/ExpirationDialog.html':"<div>\r\n    <div class=\"epi-formContainer\">\r\n        <div data-dojo-type=\"epi-cms/widget/Breadcrumb\" data-dojo-attach-point=\"breadcrumb\" data-dojo-props=\"showCurrentNode: false\"></div>\r\n        <h1 data-dojo-attach-point=\"contentNameNode\" class=\"epi-breadCrumbsCurrentItem dijitInline dojoxEllipsis\"></h1>\r\n        <div data-dojo-attach-point=\"stateNode\" class=\"epi-notificationBar epi-notificationBarItem\">\r\n            <div class=\"epi-notificationBarText\" data-dojo-attach-point=\"infoTextNode\"></div>\r\n            <div class=\"epi-notificationBarButtonContainer\">\r\n                <button data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"removeButton\" data-dojo-attach-event=\"onClick: _onRemoveButtonClick\">${res.removebutton}</button>\r\n            </div>\r\n        </div>\r\n        <div data-dojo-type=\"dijit/form/Form\" data-dojo-attach-point=\"form\"></div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"references\"></div>\r\n</div>\r\n",
'epi-cms/contentediting/viewmodel/ExpirationDialogViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/string",

    //EPi
    "epi/epi",
    "epi/datetime",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.expirationeditor",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.versionstatus"
],

function (
// Dojo
    declare,
    Stateful,
    dojoString,

    // EPi
    epi,
    epiDatetime,

    // Resources
    expirationeditorResources,
    versionstatusResources
) {

    return declare([Stateful], {
        // tags:
        //      internal xproduct

        value: null,

        intermediateValue: null,

        contentLink: null,

        contentData: null,

        contentName: null,

        // View model binding properties
        enableSaveButton: null,

        showRemoveButton: null,

        infoText: null,

        state: null,

        postscript: function () {
            this.inherited(arguments);

            this.set("intermediateValue", this.value);
            this.set("minimumExpireDate", this.minimumExpireDate);
        },

        _intermediateValueSetter: function (value) {
            this.intermediateValue = value;

            this.set("enableSaveButton", !epi.areEqual(this.intermediateValue, this.value));

            if (value && value.stopPublish) {
                var stopPublish = value.stopPublish instanceof Date ? value.stopPublish : new Date(value.stopPublish);

                this.set("showRemoveButton", true);

                this.set("infoText", stopPublish < epiDatetime.serverTime() ?
                    versionstatusResources.expired :
                    dojoString.substitute(expirationeditorResources.expiretimetext, [epiDatetime.timeToGo(stopPublish)]));

                this.set("state", "Expiring");

            } else {
                this.set("showRemoveButton", false);
                this.set("infoText", expirationeditorResources.neverexpiretext);
                this.set("state", "NotExpiring");
            }
        },

        _valueSetter: function (value) {
            this.value = value;

            this.set("enableSaveButton", false);

        },

        _minimumExpireDateSetter: function (value) {
            var date = new Date(value);
            this.minimumExpireDate = epiDatetime.isDateValid(date) ? date : null;
            this.set("minimumExpireDateMessage", expirationeditorResources.minimumdatevalidation);
        },

        save: function () {
            // summary:
            //      Save the pending changes

            this.set("value", this.intermediateValue);
        },

        reset: function () {
            // summary:
            //      Reset the pending changes

            this.set("intermediateValue", this.value);
        }
    });
});

},
'epi-cms/contentediting/commandproviders/ContentDetails':function(){
﻿define([
    "dojo",
    "dojo/_base/declare",

    "epi/shell/command/_CommandProviderMixin",

    "../command/PermanentInUseToggle"
], function (
    dojo,
    declare,

    _CommandProviderMixin,
    PermanentInUseToggle
) {

    return declare([_CommandProviderMixin], {
        // summary:
        //      Command provider, which adds in use notification related commands to content detail area.
        //
        // tags:
        //      internal

        constructor: function () {
            // summary:
            //		Ensure that an array of commands has been initialized.
            // tags:
            //		public
            this.inherited(arguments);

            // permanent inuse notification toggle
            this.add("commands", new PermanentInUseToggle());
        }
    });
});

},
'epi-cms/contentediting/command/PermanentInUseToggle':function(){
﻿define([
    "dojo/_base/declare",
    "epi/dependency",
    "epi/shell/command/ToggleCommand",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.permanenteditindication"
],

function (declare, dependency, ToggleCommand, resources) {

    return declare([ToggleCommand], {
        // summary:
        //      Toggles permanent in use notification on/off.
        //
        // tags:
        //      internal

        name: "PermanentInUseNotification",
        label: resources.title,
        tooltip: resources.tooltip,

        inUseNotificationManager: null,

        postscript: function () {
            this.inherited(arguments);

            if (this.inUseNotificationManager === null) {
                this.inUseNotificationManager = dependency.resolve("epi.cms.contentediting.inUseNotificationManager");
            }

            this.set("canExecute", true);
            this.set("isAvailable", true);
        },

        _execute: function () {
            // summary:
            //		Toggles permanent editing indication on/off.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData;
            this.inUseNotificationManager.togglePermanentEditIndication(contentData, true);

            this._updateCanExecute();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,
                active = this.inUseNotificationManager.currentUserHasInUseNotification(contentData.inUseNotifications, true);

            this.set("active", active);

            this._updateCanExecute();
        },

        _updateCanExecute: function () {
            this.set("canExecute", this.active || this.model.canChangeContent());
        }
    });
});

},
'epi-cms/contentediting/commandproviders/PublishMenu':function(){
﻿define([
    "dojo",
    "dojo/_base/declare",

    "epi/shell/command/_CommandProviderMixin",
    "epi-cms/contentediting/command/ForPublishMenu",
    "epi-cms/contentediting/command/IgnoreInUseNotification"
], function (
    dojo,
    declare,

    _CommandProviderMixin,
    ForPublishMenu,
    IgnoreInUseNotification) {

    return declare([_CommandProviderMixin], {
        // summary:
        //      Command provider, which adds in use notification related commands to publish menu.
        //
        // tags:
        //      internal

        constructor: function () {
            // summary:
            //		Ensure that an array of commands has been initialized.
            // tags:
            //		public
            this.inherited(arguments);

            // ignore inuse notification
            this.add("commands", ForPublishMenu(new IgnoreInUseNotification(), {
                priority: 10000
            }));
        }
    });
});

},
'epi-cms/contentediting/command/ForPublishMenu':function(){
﻿define([
    "dojo/_base/lang"
],
function (lang) {

    return function (command, options) {
        // summary:
        //      Adds some decorations for the command to be used in publish menu.
        // command: epi/shell/command/_Command
        //      The command
        // options: Object
        //      The options. Available options are:
        //          isMain: Indicate if the command can be the main command.
        //          priority: The command priority.
        //          mainButtonClass: CSS class applied to main button if command is main command.
        //          keepMenuOpen: Keep publish menu open after command executed.
        //          successStatus: The text to display when the command successfully executed.
        //
        // tags:
        //      internal

        // TODO: Use lang.delegate and return a new command instance, to avoid messing up the original command.
        // Temporarily set the options to the original command because lang.delegate doesn't work well with Stateful objects.

        options = lang.mixin({
            isMain: false,
            priority: 0,
            resetLabelAfterExecution: true,
            mainButtonClass: null,
            keepMenuOpen: false,
            successStatus: null
        }, options);

        command.options = options;

        return command;
    };
});

},
'epi-cms/contentediting/command/IgnoreInUseNotification':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi/dependency",
    "epi/shell/command/_Command",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (declare, topic, dependency, _Command, resource) {

    return declare([_Command], {
        // summary:
        //      Ignore in use notification and edit.
        //
        // tags:
        //      internal

        name: "IgnoreInUseNotification",
        label: resource.ignoreinusenotification.label,
        tooltip: resource.ignoreinusenotification.title,
        iconClass: "epi-iconPen",

        inUseNotificationManager: null,

        postscript: function () {
            this.inherited(arguments);

            if (this.inUseNotificationManager === null) {
                this.inUseNotificationManager = dependency.resolve("epi.cms.contentediting.inUseNotificationManager");
            }

            this.set("canExecute", true);
            this.set("isAvailable", true);
        },

        _execute: function () {
            // summary:
            //		Toggles permanent editing indication on/off.
            // tags:
            //		protected

            this.inUseNotificationManager.ignoreOthersNotifications = true;

            // reset view name to have the PageDataController load the correct view.
            this.model.viewName = null;

            this._requestContextChange(this.model.contentData.uri, true);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,
                hasInUseNotificationWarning = this.inUseNotificationManager.hasInUseNotificationWarning(contentData.inUseNotifications),
                ignoreFlag,
                originallyEditable;

            // Temporarily ignore inuse notification warning to check original editable status
            ignoreFlag = this.inUseNotificationManager.ignoreOthersNotifications;
            this.inUseNotificationManager.ignoreOthersNotifications = true;
            originallyEditable = this.model.canChangeContent();
            this.inUseNotificationManager.ignoreOthersNotifications = ignoreFlag;

            // Available when the content is originally editable but is locked by notification warning
            this.set("isAvailable", hasInUseNotificationWarning && originallyEditable);
        },

        _requestContextChange: function (uri, forceContextChange) {
            var contextParameters = { uri: uri };
            var callerData = {
                sender: this,
                forceContextChange: forceContextChange
            };

            topic.publish("/epi/shell/context/request", contextParameters, callerData);
        }
    });
});

},
'epi-cms/contentediting/commandproviders/PublishMenuGlobal':function(){
define([
    "dojo/_base/declare",

    "epi/shell/command/withConfirmation",
    "epi/shell/command/_CommandProviderMixin",
    "epi/shell/DestroyableByKey",

    "epi-cms/command/TranslateContent",
    "epi-cms/contentediting/command/ForPublishMenu",
    "epi-cms/contentediting/command/RevertToPublished",
    "epi-cms/contentediting/command/SendForReview",
    "epi-cms/contentediting/command/Publish",
    "epi-cms/contentediting/command/CreateDraft",
    "epi-cms/contentediting/command/EditCommonDraft",
    "epi-cms/contentediting/command/Withdraw",
    "epi-cms/contentediting/command/ScheduleForPublish",
    "epi-cms/contentediting/command/CancelAndEdit",

    "epi-cms/content-approval/command/AbortReview",
    "epi-cms/content-approval/command/ApproveChanges",
    "epi-cms/content-approval/command/CancelReview",
    "epi-cms/content-approval/command/ForceCompleteApproval",
    "epi-cms/content-approval/command/RejectChanges",
    "epi-cms/content-approval/command/ReadyForReview",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command",
    "epi/i18n!epi/nls/episerver.shell.resources.texts"
], function (
    declare,

    withConfirmation,
    _CommandProviderMixin,
    DestroyableByKey,

    TranslateContentCommand,
    ForPublishMenu,
    RevertToPublishedCommand,
    SendForReviewCommand,
    PublishCommand,
    CreateDraftCommand,
    EditCommonDraft,
    WithdrawCommand,
    ScheduleForPublishCommand,
    CancelAndEditCommand,

    AbortReviewCommand,
    ApproveChangesCommand,
    CancelReviewCommand,
    ForceCompleteApprovalCommand,
    RejectChangesCommand,
    ReadyForReviewCommand,

    res,
    commandRes,
    shellResources
) {

    return declare([_CommandProviderMixin, DestroyableByKey], {
        // summary:
        //      Builtin Command provider for publish menu.
        // tags:
        //      internal

        commandMap: null,

        constructor: function () {
            this.commandMap = {
                abortreview: ForPublishMenu(withConfirmation(new AbortReviewCommand(), null, {
                    title: commandRes.abortreview.label,
                    description: commandRes.abortreview.description,
                    confirmActionText: shellResources.ok,
                    cancelActionText: shellResources.cancel
                })),
                approvechanges: ForPublishMenu(new ApproveChangesCommand(), {
                    isMain: true,
                    priority: 10000,
                    mainButtonClass: "epi-success"
                }),
                cancelreview: ForPublishMenu(withConfirmation(new CancelReviewCommand(), null, {
                    title: commandRes.cancelreview.label,
                    description: commandRes.cancelreview.description,
                    confirmActionText: commandRes.cancelreview.ok,
                    cancelActionText: shellResources.cancel
                })),
                forcecompleteapproval: ForPublishMenu(new ForceCompleteApprovalCommand()),
                publish: ForPublishMenu(new PublishCommand(), {
                    resetLabelAfterExecution: true,
                    isMain: true,
                    priority: 9000,
                    mainButtonClass: "epi-success",
                    keepMenuOpen: false,
                    successStatus: res.successfullypublished
                }),
                readyforreview: ForPublishMenu(new ReadyForReviewCommand(), {
                    isMain: true,
                    priority: 10000,
                    mainButtonClass: "epi-success"
                }),
                readytopublish: ForPublishMenu(new SendForReviewCommand(), {
                    isMain: true,
                    priority: 8000,
                    mainButtonClass: "epi-success",
                    keepMenuOpen: true
                }),
                rejectchanges: ForPublishMenu(new RejectChangesCommand()),
                removescheduling: ForPublishMenu(new CancelAndEditCommand()),
                scheduleforpublish: ForPublishMenu(new ScheduleForPublishCommand()),
                withdraw: ForPublishMenu(new WithdrawCommand(), {
                    resetLabelAfterExecution: false,
                    keepMenuOpen: true
                })
            };

            this.commandMap.abortreview.order = 0;
            this.commandMap.approvechanges.order = 100;
            this.commandMap.forcecompleteapproval.order = 200;
            this.commandMap.rejectchanges.order = 300;
            this.commandMap.publish.order = 400;
            this.commandMap.readyforreview.order = 500;
            this.commandMap.readytopublish.order = 600;
            this.commandMap.removescheduling.order = 700;
            this.commandMap.scheduleforpublish.order = 800;
            this.commandMap.cancelreview.order = 900;
            this.commandMap.withdraw.order = 1000;
        },

        updateCommandModel: function (model) {
            // summary:
            //        Creates commands based on the status transitions available for the content as
            //        well as several additional commands that are not status based.
            // tags:
            //        private

            this.destroyByKey("builtinCommands");
            var commands = [];

            model.contentData.transitions.forEach(function (transition) {
                var command = this.commandMap[transition.name];
                if (command) {
                    commands.push(command);
                }
            }, this);

            // Adds builtin commands

            // Translate
            var translateContentCommand = new TranslateContentCommand();
            translateContentCommand.order = 1100;
            commands.push(ForPublishMenu(translateContentCommand, {
                isMain: true,
                priority: 10000,
                mainButtonClass: "epi-primary"
            }));
            this.ownByKey("builtinCommands", translateContentCommand);

            // Edit the common draft
            var editCommonDraft = new EditCommonDraft();
            editCommonDraft.order = 1200;
            commands.push(ForPublishMenu(editCommonDraft));
            this.ownByKey("builtinCommands", editCommonDraft);

            // Create new draft from here
            var draftCommand = new CreateDraftCommand();
            draftCommand.order = 1300;
            commands.push(ForPublishMenu(draftCommand));
            this.ownByKey("builtinCommands", draftCommand);

            // Revert to publish version
            var revertToPublishedCommand = new RevertToPublishedCommand();
            revertToPublishedCommand.order = 1400;
            commands.push(ForPublishMenu(withConfirmation(
                revertToPublishedCommand, null, {
                    title: res.reverttopublishconfirmation.dialogtitle,
                    heading: res.reverttopublishconfirmation.confirmquestion,
                    description: res.reverttopublishconfirmation.description
                }
            )));
            this.ownByKey("builtinCommands", revertToPublishedCommand);

            this.set("commands", commands);

            this.inherited(arguments);
        }
    });
});

},
'epi-cms/contentediting/command/EditCommonDraft':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/command/_ContentCommandBase",
    "epi-cms/contentediting/ContentActionSupport",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    _ContentCommandBase,
    ContentActionSupport,
    resources
) {

    return declare([_ContentCommandBase], {
        // summary:
        //      Edit the common draft version.
        //
        // tags:
        //      internal

        name: "editcommondraft",
        label: resources.editcommondraft.label,
        tooltip: resources.editcommondraft.title,
        iconClass: "epi-iconPen",

        contentActionSupport: null,

        postscript: function () {
            this.inherited(arguments);
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
        },

        _execute: function () {
            // summary:
            //    Executes this command; edit the common draft version.
            //
            // tags:
            //		protected

            this.model.editCommonDraft();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                status = contentData.status,
                versionStatus = ContentActionSupport.versionStatus,
                hasAccessRights = this.contentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Edit),
                canExecute = (status === versionStatus.Published || status === versionStatus.PreviouslyPublished) && !contentData.isCommonDraft &&
                    hasAccessRights &&  this.contentActionSupport.hasProviderCapability(contentData.providerCapabilityMask, ContentActionSupport.providerCapabilities.Edit);

            // The status is publish or previously published, and it is not the common draft and user must have sufficient access rights.
            this.set("canExecute", canExecute && this.model.canEditCurrentLanguage());
            this.set("isAvailable", canExecute);
        }
    });

});

},
'epi-cms/contentediting/command/ScheduleForPublish':function(){
define([
//Dojo
    "dojo/_base/declare",
    //EPi shell
    "epi/shell/DialogService",
    //EPi cms
    "epi-cms/contentediting/command/_ChangeContentStatus",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/ScheduledPublishSelector",
    "epi-cms/contentediting/ScheduledPublishSelectorViewModel",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.scheduledpublishselector"
],

function (
//Dojo
    declare,
    //EPi
    dialogService,
    _ChangeContentStatus,
    ContentActionSupport,
    ScheduledPublishSelector,
    ScheduledPublishSelectorViewModel,

    //Resources
    buttonResources,
    widgetResources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Schedules publish command.
        //
        // tags:
        //      internal

        label: buttonResources.scheduleforpublish.label,

        tooltip: buttonResources.scheduleforpublish.title,

        iconClass: "epi-iconClock",

        action: ContentActionSupport.saveAction.Schedule,

        _execute: function () {
            // summary:
            //		Schedules the content for publish with the time selected by the user
            // tags:
            //		protected

            var viewModel = new ScheduledPublishSelectorViewModel();
            viewModel.set("contentData", this.model.contentData);
            var widget = new ScheduledPublishSelector({ model: viewModel });

            return dialogService.dialog({ content: widget, title: widgetResources.title, defaultActionsVisible: false })
                .then(function () {
                    return this.model.scheduleForPublish(viewModel.get("dateValue"));
                }.bind(this))
                .then(this._onContentStatusChange.bind(this));
        }
    });
});

},
'epi-cms/contentediting/ScheduledPublishSelector':function(){
define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",

    // Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    //EPi
    "epi/shell/widget/_ActionProviderWidget",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "./ScheduledPublishSelectorViewModel",

    // Resources
    "dojo/text!./templates/ScheduledPublishSelector.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.scheduledpublishselector",
    "epi/i18n!epi/nls/episerver.shared",

    // Widgets used in template
    "epi/shell/widget/DateTimeSelectorDropDown",
    "epi-cms/project/ContentReferenceGrid",
    "epi-cms/widget/Breadcrumb"
],

function (
// Dojo
    declare,
    lang,
    domClass,

    // Dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    // EPi
    _ActionProviderWidget,
    _ModelBindingMixin,
    _DialogContentMixin,
    ScheduledPublishSelectorViewModel,
    // Resources
    template,
    resources,
    sharedResources
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin, _ActionProviderWidget, _DialogContentMixin], {
        // summary:
        //    A widget for selecting date when doing a scheduled publish.
        //
        // tags:
        //    internal

        templateString: template,

        modelData: null,

        _setTitleAttr: {
            node: "contentNameNode",
            type: "innerText"
        },

        _setDateLabelAttr: {
            node: "publishChangesCaptionNode",
            type: "innerHTML"
        },

        _setDateValueAttr: function (date) {
            this.dateTimeSelector.set("value", date);
        },

        _setBreadcrumbModelAttr: function (breadcrumbModel) {
            this.breadcrumbNode.set("contentLink", breadcrumbModel);
        },

        _setScheduleButtonEnabledAttr: function (enabled) {
            if (this._actions && this._actions.length) {
                this.setActionProperty("save", "disabled", !enabled);
            }
        },

        _setModelAttr: function (model) {
            // summary:
            //      Set the model for the embedded item grid

            this.inherited(arguments);
            this.referenceGrid.set("model", model);
            if (model) {
                this.own(model.watch("totalItems", lang.hitch(this, "_onGridItemsChange")));
            }
        },

        modelBindingMap: {
            title: ["title"],
            dateLabel: ["dateLabel"],
            dateValue: ["dateValue"],
            breadcrumbModel: ["breadcrumbModel"],
            scheduleButtonEnabled: ["scheduleButtonEnabled"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            this.model = this.model || new ScheduledPublishSelectorViewModel(this.modelData);
        },

        postCreate: function () {
            // summary:
            //
            // tags:
            //      protected
            this.inherited(arguments);

            this.connect(this.dateTimeSelector, "onChange", "dateTimeSelectorChanged");

            this.addActions([
                {
                    name: "cancel",
                    label: sharedResources.action.cancel,
                    settings: { type: "button", "class": "epi-plain-button"  },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                },
                {
                    name: "save",
                    label: resources.confirmtext,
                    settings: { type: "button", "class": "Salt" },
                    action: lang.hitch(this, function () {
                        if (this.dateTimeSelector.validate()) {
                            this.dateTimeSelectorChanged(this.dateTimeSelector.get("value"));
                            this.executeDialog();
                        }
                    })
                }
            ]);
        },

        _onGridItemsChange: function (propName, oldValue, newValue) {
            // summary:
            //      Changes the label of the schedule button and visibility of the embedded when the visible items in the grid changes.
            // tags:
            //      private

            var hasScheduledItems = newValue > 0;
            if (this.referenceGrid) {
                domClass.toggle(this.referenceGrid.domNode, "dijitHidden", !hasScheduledItems);
            }
            this.setActionProperty("save", "label", hasScheduledItems ? resources.scheduleanyway : resources.confirmtext);
            this.setActionProperty("save", "class", hasScheduledItems ? "" : "Salt");
        },

        dateTimeSelectorChanged: function (value) {
            this.model.set("dateValue", value);
        }
    });
});

},
'epi-cms/contentediting/ScheduledPublishSelectorViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Stateful",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.scheduledpublishselector"
],

function (
// Dojo
    declare,
    Stateful,

    // Resources
    resources
) {

    return declare([Stateful], {
        // tags:
        //      internal

        breadcrumbModel: null,

        title: "",

        dateLabel: "",

        dateValue: null,

        scheduleButtonEnabled: false,

        constructor: function () {
            // Create a default date. Set it to noon tomorrow.
            var noonTomorrow = new Date();
            noonTomorrow.setDate(noonTomorrow.getDate() + 1);
            noonTomorrow.setHours(12, 0, 0, 0);

            this.set("dateValue", noonTomorrow);
        },

        _isPublishedSetter: function (isPublished) {
            this.set("dateLabel", isPublished ? resources.publishchangeson : resources.publishon);
        },

        _contentDataSetter: function (contentData) {
            this.set("title", contentData.name);
            this.set("isPublished", !contentData.isPendingPublish);
            this.set("breadcrumbModel", contentData.contentLink);

            // Use any valid publish date in the future
            var publishDate = new Date(contentData.properties.iversionable_startpublish);
            if (!isNaN(publishDate) && publishDate > new Date()) {
                this.set("dateValue", publishDate);
            }
        },

        _dateValueSetter: function (value) {
            this.dateValue = value;

            this.set("scheduleButtonEnabled", !!(value && value > new Date()));
        }
    });
});

},
'url:epi-cms/contentediting/templates/ScheduledPublishSelector.html':"﻿<div>\r\n    <div data-dojo-type=\"epi-cms/widget/Breadcrumb\" data-dojo-attach-point=\"breadcrumbNode\" data-dojo-props=\"showCurrentNode: false\"></div>\r\n    <h1 data-dojo-attach-point=\"contentNameNode\" class=\"epi-breadCrumbsCurrentItem dijitInline dojoxEllipsis\"></h1>\r\n    <div data-dojo-attach-point=\"publishChangesCaptionNode\"></div>\r\n    <div data-dojo-type=\"epi/shell/widget/DateTimeSelectorDropDown\" data-dojo-attach-point=\"dateTimeSelector\" data-dojo-props=\"required:true\"></div>\r\n    <div data-dojo-attach-point=\"referenceGrid\" data-dojo-type=\"epi-cms/project/ContentReferenceGrid\" class=\"dijitHidden push-margin--top\"></div>\r\n</div>",
'epi-cms/project/ContentReferenceGrid':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/keys",
    "dojo/on",
    "dojo/when",

    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    "dgrid/OnDemandGrid",
    "dgrid/Keyboard",
    "dgrid/Selection",

    "epi/shell/dgrid/Formatter",



    "epi/shell/widget/_ModelBindingMixin",

    "dojo/text!./templates/ContentReferenceGrid.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentreferences",

    "dijit/form/Button"

], function (
    declare,
    lang,
    domClass,
    keys,
    on,
    when,
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    OnDemandGrid,
    Keyboard,
    Selection,

    Formatter,
    _ModelBindingMixin,
    template,
    resources
) {

    // Helper function to set a property on the grid
    function setGridProperty(prop) {
        return function (value) {
            if (this._grid) {
                this._grid.set(prop, value);
            }
        };
    }

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      A grid with a notification area, refresh button and a short summary of the shown items.
        // description:
        //      A composite widget consisting of a dgrid with a refresh button and summary node
        //      describing the loaded items. A notification area is also rendered above the grid,
        //      but only visible when the notificationText property is non-empty.
        //      The event 'contentreferencegrid-loading-complete' will be emitted once the grid
        //      has completed loading content
        // tags:
        //      internal

        res: resources,

        templateString: template,

        // model: [public] epi-cms/project/ContentReferenceGridModel
        //      The view model containing column and store configuration.
        model: null,

        // _gridClass: [private]
        _gridClass: declare([OnDemandGrid, Keyboard, Selection, Formatter]),

        // _grid: [private]
        //      The grid instance
        _grid: null,

        // _loadCompleteEmitted: [private] Boolean
        //      A flag indicating if the initial loading complete event has been emitted
        _loadCompleteEmitted: false,

        // modelBindingMap: [protected] Object
        //      The model binding configuration
        modelBindingMap: {
            query: ["query"],
            store: ["store"],
            columns: ["columns"],
            notificationText: ["notificationText"],
            resultSummary: ["resultSummary"]
        },

        _setResultSummaryAttr: { node: "resultSummaryNode", type: "innerText" },
        _setQueryAttr: setGridProperty("query"),
        _setColumnsAttr: setGridProperty("columns"),
        _setStoreAttr: setGridProperty("store"),

        _setNotificationTextAttr: function (text) {
            // summary:
            //      Sets the text in the notification area and toggles its visibility based the text content.
            //      If the notificationText is null opr empty the notification area is hidden.

            var showNotification = text && text.length;
            domClass.toggle(this.notificationBar, "dijitHidden", !showNotification);
            this.notificationNode.textContent = text || "";
        },

        _onRowClicked: function (e) {
            // summary:
            //      Called when the an a tag is clicked in the grid or when enter or space is pressed on a grid row
            // tags:
            //      private

            if (this.model && typeof this.model.onItemClicked === "function") {
                var data = this._grid.row(e).data;
                this.model.onItemClicked(data);
            }
        },

        buildRendering: function () {
            // summary:
            //      Overridden to create and configure the grid from the model

            this.inherited(arguments);

            var columns = this.model && this.model.get("columns");

            this._grid = new this._gridClass({
                "class": "epi-plain-grid epi-plain-grid--no-border epi-plain-grid--no-header epi-plain-grid--margin-bottom",
                columns: columns,
                showHeader: false,
                cellNavigation: false,
                selectionMode: "single"
            }, this.gridNode);

            this._grid.addKeyHandler(keys.ENTER, lang.hitch(this, "_onRowClicked"));
            this._grid.addKeyHandler(keys.SPACE, lang.hitch(this, "_onRowClicked"));
            this._grid.on(".dgrid-cell a:click", lang.hitch(this, "_onRowClicked"));

            this.own(
                this._grid,
                on(this._grid, "dgrid-refresh-complete", lang.hitch(this, "_onGridRefreshComplete"))
            );
        },

        startup: function () {
            this.inherited(arguments);
            this._grid.startup();
            if (!this._grid.store) {
                // When no store is configured the grid won't load anything when started
                this._emitLoadComplete();
            }
        },

        _onGridRefreshComplete: function (data) {
            // summary:
            //      Called to update the totalItems property on the model when the grid has queried the store
            // tags:
            //      private

            var results = data.results;
            when(results.total, lang.hitch(this, function (total) {
                this.model.set("totalItems", total);
                this._emitLoadComplete();
            }));
        },

        _emitLoadComplete: function () {
            // summary:
            //      Emit a contentreferencegrid-loading-complete event if it hasn't been emitted

            if (!this._loadCompleteEmitted) {
                this.emit("contentreferencegrid-loading-complete", {});
                this._loadCompleteEmitted = true;
            }
        },

        _refresh: function () {
            // summary:
            //      Calls refresh on the inner grid
            // tags:
            //      private

            this._grid.refresh();
        }
    });
});

},
'url:epi-cms/project/templates/ContentReferenceGrid.html':"<div class=\"epi-contentReferences\">\r\n    <div data-dojo-attach-point=\"notificationBar\" class=\"dijitHidden epi-notificationBar epi-notificationBarWithBorders epi-notificationBarItem\">\r\n        <div data-dojo-attach-point=\"notificationNode\" class=\"epi-notificationBarText\"></div>\r\n    </div>\r\n    <div class=\"epi-captionPanel\" data-dojo-attach-point=\"captionPanelNode\">\r\n        <strong data-dojo-attach-point=\"resultSummaryNode\"></strong>\r\n        <div class=\"epi-floatRight\">\r\n            <button class=\"epi-chromelessButton\"\r\n                    data-dojo-type=\"dijit/form/Button\"\r\n                    data-dojo-attach-event=\"onClick:_refresh\"\r\n                    data-dojo-props=\"iconClass:'epi-iconReload'\">${res.buttons.refresh}</button>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>\r\n",
'epi-cms/contentediting/command/CancelAndEdit':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.cancelandedit"
], function (
    declare,
    lang,

    ContentActionSupport,
    _ChangeContentStatus,

    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Cancel and edit content command. Available for any delayed published content, and puts the content to rejected when executed.
        //
        // tags:
        //      internal

        label: resources.label,

        tooltip: resources.title,

        iconClass: "epi-iconPen",

        action: ContentActionSupport.saveAction.CheckOut | ContentActionSupport.saveAction.ForceCurrentVersion | ContentActionSupport.saveAction.SkipValidation
    });
});

},
'epi-cms/content-approval/command/AbortReview':function(){
﻿define([
    "dojo/_base/declare",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.abortreview",
    "epi-cms/contentediting/ContentActionSupport",
    // Parent class and mixins
    "epi-cms/contentediting/command/_ChangeContentStatus"
], function (
    declare,
    localization,
    ContentActionSupport,
    // Parent class and mixins
    _ChangeContentStatus
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Back out of the AwaitingApproval state. This is for when something goes wrong and a content is stuck waiting for an approval but no approval definition can be found.
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.label,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconWarning",

        action: ContentActionSupport.saveAction.CheckOut | ContentActionSupport.saveAction.SkipValidation
    });
});

},
'epi-cms/content-approval/command/ApproveChanges':function(){
define([
    "dojo/_base/declare",
    "./_ApprovalTransitionWithReasonTextCommand",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.approvechanges"
], function (
    declare,
    _ApprovalTransitionWithReasonTextCommand,
    localization
) {

    return declare([_ApprovalTransitionWithReasonTextCommand], {
        // summary:
        //      Approve the current approval
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.label,

        // title [readonly] String
        //      The dialog title
        title: localization.title,

        dialogPlaceHolder: localization.placeholder,

        // confirmationActionText [readonly] String
        //      Approve label for the dialog
        confirmActionText: localization.confirmactiontext,

        // executingLabel: [readonly] String
        //      The executing action text of the command to be used in visual elements.
        executingLabel: localization.label,

        // executeMethod: [readonly] String
        //      The method to execute on the approval service
        executeMethod: "approveChanges",

        isCommentRequiredPropertyName: "isApproveCommentRequired"
    });
});

},
'epi-cms/content-approval/command/_ApprovalTransitionWithReasonTextCommand':function(){
define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/dom-construct",
    // Parent class and mixins
    "epi/shell/widget/ValidationTextarea",
    "./_ApprovalTransitionCommand",
    "epi-cms/contentediting/command/_CommandWithDialogMixin"
], function (
    declare,
    Deferred,
    domConstruct,
    // Parent class and mixins
    ValidationTextarea,
    _ApprovalTransitionCommand,
    _CommandWithDialogMixin
) {

    return declare([_ApprovalTransitionCommand, _CommandWithDialogMixin], {
        // summary:
        //      Base class approval transitions that might need a comment
        // tags:
        //      internal

        // dialogContentClass: [readonly] ValidationTextarea
        //      Input field for the approve comment
        dialogContentClass: ValidationTextarea,

        dialogClass: "epi-dialog-confirm",

        // executeMethod: [readonly] String
        //      The method to execute on the approval service
        executeMethod: null,

        // isCommentRequiredPropertyName: [readonly] String
        //      The name of the property to look at to determine if a comment is required
        isCommentRequiredPropertyName: null,

        // dialogPlaceHolder: String
        //      Placeholder text for the text area
        dialogPlaceHolder: null,

        // dialogText: String
        //      Text to be displayed above text area, if any
        dialogText: null,

        postscript: function () {
            this.inherited(arguments);

            this.dialogContentParams = {
                required: true,
                intermediateChanges: true,
                placeHolder: this.dialogPlaceHolder,
                "class": "epi-textarea--max-height--500"
            };
        },

        _execute: function () {
            return this._getApprovalDefinition().then(function (approvalDefinition) {
                if (approvalDefinition[this.isCommentRequiredPropertyName]) {
                    this._executeDeferred = new Deferred();
                    this.showDialog();
                    return this._executeDeferred.promise;
                } else {
                    return this._executeServiceMethod();
                }
            }.bind(this));
        },

        _getApprovalDefinition: function () {
            // summary:
            //      Gets the approval definition when we execute the command
            //      to determine if a comment is required
            // tags:
            //      protected

            return this.approvalService.getApprovalRelatedDefinition(this.model.contentLink);
        },

        showDialog: function () {
            this.inherited(arguments);

            this._disableActionButton(true);

            if (this.dialogText && typeof this.dialogText === "string") { // Add text, if any, above the comment text area
                domConstruct.place("<p>" + this.dialogText + "</p>", this.dialogContent.domNode, "before");
            }

            this._dialog.own(this.dialogContent.on("change", this._onDialogContentChanged.bind(this)));
        },

        _onDialogContentChanged: function (value) {
            // summary:
            //      Called when the dialog content is changed.
            // tags:
            //      private

            this._disableActionButton(!value || !(value.trim()));
        },

        _disableActionButton: function (disable) {
            // summary:
            //      Disables the confirm button if the disable parameter is true.
            // tags:
            //      private

            this._dialog.onActionPropertyChanged({ name: this._dialog._okButtonName }, "disabled", disable);
        },

        onDialogExecute: function () {
            // summary:
            //      Resolves the execute promise after the dialog is executed.
            // tags:
            //      public virtual

            this._executeDeferred.resolve(this._executeServiceMethod.call(this, this.dialogContent.value));
        },

        onDialogCancel: function () {
            // summary:
            //      Rejects the execute promise after the dialog is canceled.
            // tags:
            //      public virtual

            this._executeDeferred.reject();
        },

        _executeServiceMethod: function (reason) {
            return this.approvalService[this.executeMethod](this.approval.id, this.approval.activeStepIndex, reason)
                .then(this._onContentStatusChange.bind(this));
        }
    });
});

},
'epi-cms/content-approval/command/_ApprovalTransitionCommand':function(){
define([
    "dojo/_base/declare",
    "epi/dependency",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.rejectchanges",
    // Parent class and mixins
    "epi-cms/contentediting/command/_ChangeContentStatus"
],
function (
    declare,
    dependency,
    localization,
    // Parent class and mixins
    _ChangeContentStatus
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Base class for any changes to the model and for executing
        // tags:
        //      internal

        // approval: [public] Object
        //      The Approval step
        approval: null,

        // executeMethod: [public] String
        //      The method to execute on the approval service
        executeMethod: null,

        postscript: function () {
            this.inherited(arguments);
            this.approvalService = this.approvalService || dependency.resolve("epi.cms.ApprovalService");
        },

        _onModelChange: function () {
            // summary:
            //      Get the approval so its available when we execute the command
            // tags:
            //      protected

            this.set("canExecute", false);

            if (!this.model) {
                return;
            }

            return this.approvalService.getApproval(this.model.contentLink).then(function (approval) {
                this.set({
                    canExecute: !!approval,
                    approval: approval
                });
            }.bind(this));
        },

        _execute: function () {
            return this._executeServiceMethod();
        },

        _executeServiceMethod: function () {
            // summary:
            //      Executes the this.executeMethod on the approval service.
            // tags:
            //      protected

            return this.approvalService[this.executeMethod](this.approval).then(this._onContentStatusChange.bind(this));
        },

        _onContentStatusChange: function () {
            // Modify the arguments and send the contentLink of the model
            this.inherited(arguments, [{ id: this.model.contentLink }]);
        }
    });
});

},
'epi-cms/contentediting/command/_CommandWithDialogMixin':function(){
﻿define([
// Dojo
    "dojo/_base/array",                                                         // used to loop through array
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",                                                              // used to listen event from Dialog
    "dojo/when",

    // Dijit
    "dijit/Destroyable",                                                        // mixed into me

    // EPi Framework
    "epi/shell/widget/dialog/Dialog",                                           // used to create dialog

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.editlink",                        // used to get default title (common)
    "epi/i18n!epi/nls/episerver.shared"
], function (
// Dojo
    array,
    declare,
    lang,
    aspect,
    when,

    // Dijit
    Destroyable,

    // EPi Framework
    Dialog,

    // Resources
    resouce,
    sharedResources
) {
    return declare([Destroyable], {
        // summary:
        //      The base class for all edit commands wanna use dialog as an editor.
        //      <see cref = "epi-cms/contentediting/command/ItemEdit.js" />
        //
        // description:
        //      That supports:
        //          - Create a dialog
        //          - Interface to update value
        // tags:
        //    internal xproduct

        // res: [public] Object
        //      Json language resource object used to get default title when insert/edit item.
        res: resouce,

        // title: [public] String
        //      The dialog's title.
        title: null,

        // dialogClass: [public] String
        //      The css class for dialog.
        //      Default value is "epi-dialog-portrait".
        dialogClass: "epi-dialog-portrait",

        // dialogContentClass: [public] Class
        //      The widget class that will be created and placed as dialog's content
        dialogContentClass: null,

        // dialogParams: [public] Object
        //      The parameters for create new instance of dialog.
        dialogParams: null,

        // dialogContentParams: [public] Object
        //      The parameters for create new instance of dialogContentClass.
        dialogContentParams: null,

        // dialogContent: [public] Object
        //      The instance of dialogContentClass will be stored by this prop.
        dialogContent: null,

        // defaultActionsVisible: [public] Bool
        //      .Flag which indicates whether the default confirm and cancel
        //		actions should be visible. This can only be set in the constructor.
        defaultActionsVisible: true,

        // confirmActionText: [public] String
        //      Label to be displayed for the confirm (positive) action.
        confirmActionText: sharedResources.action.ok,

        // cancelActionText: [public] String
        //      Label to be displayed for the cancel (negative) action.
        cancelActionText: sharedResources.action.cancel,

        // value: [public] Object
        //      The value of item that being edited.
        value: null,

        // value: [protected] Object
        //      The dialog.
        _dialog: null,

        _getTitle: function () {
            // summary:
            //      Customize base get method for title prop.
            // tags:
            //      protected override

            return this.title || lang.replace(this.value ? this.res.title.template.edit : this.res.title.template.create, this.res.title.action);
        },

        onDialogOpen: function () {
            // summary:
            //      Triggered when dialog is opened.
            // tags:
            //      public virtual
        },

        onDialogExecute: function () {
            // summary:
            //      Process value returned from dialog after it's executed.
            //      It should be implemented from delivery
            // tags:
            //      public virtual
        },

        onDialogCancel: function () {
            // summary:
            //      Process value when dialog after it's hidden.
            //      It should be implemented from delivery
            // tags:
            //      public virtual
        },

        onDialogHideComplete: function () {
            // summary:
            //      Triggered when dialog is closed.
            // tags:
            //      public virtual
        },

        showDialog: function () {
            // summary:
            //      Create and show dialog
            // tags:
            //    protected

            if (this.dialogContent) {
                this.dialogContent.destroy();
                this.dialogContent = null;
            }
            this.dialogContent = new this.dialogContentClass(this.dialogContentParams);

            this._dialog = new Dialog(lang.mixin({
                title: this._getTitle(),
                dialogClass: this.dialogClass,
                content: this.dialogContent,
                defaultActionsVisible: this.defaultActionsVisible,
                confirmActionText: this.confirmActionText,
                cancelActionText: this.cancelActionText
            }, this.dialogParams));

            this._dialog.startup();

            //Set the value when the provider/consumer has been initialized
            this.dialogContent.set("value", this.value);

            this.own(
                this.dialogContent,
                aspect.after(this._dialog, "onExecute", lang.hitch(this, this.onDialogExecute), true),
                aspect.after(this._dialog, "onCancel", lang.hitch(this, this.onDialogCancel), true),
                aspect.after(this._dialog, "onHide", lang.hitch(this, this.onDialogHideComplete), true),
                this._dialog.watch("open", lang.hitch(this, function (name, oldValue, newValue) {
                    if (!newValue) {
                        return;
                    }
                    this.onDialogOpen();
                }))
            );

            this._dialog.show();
        }
    });
});

},
'epi-cms/content-approval/command/CancelReview':function(){
define([
    "dojo/_base/declare",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.cancelreview",
    // Parent class and mixins
    "epi-cms/content-approval/command/_ApprovalTransitionCommand"
], function (
    declare,
    localization,
    // Parent class and mixins
    _ApprovalTransitionCommand
) {

    return declare([_ApprovalTransitionCommand], {
        // summary:
        //      Cancel the approval sequence
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.label,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconClose",

        // executeMethod: [public] String
        //      The method to execute on the approvalservice
        executeMethod: "cancelChanges"
    });
});

},
'epi-cms/content-approval/command/ForceCompleteApproval':function(){
define([
    "dojo/_base/declare",
    // Parent class and mixins
    "./_ApprovalTransitionWithReasonTextCommand",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.forcecompleteapproval"
],
function (
    declare,
    // Parent class and mixins
    _ApprovalTransitionWithReasonTextCommand,
    localization
) {

    return declare([_ApprovalTransitionWithReasonTextCommand], {
        // summary:
        //      Force completes an approval instance as approved.
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.label,

        // title [readonly] String
        //      The dialog title
        title: localization.title,

        // dialogPlaceHolder [readonly] String
        //      Placeholder text for the text area
        dialogPlaceHolder: localization.placeholder,

        // dialogText [readonly] String
        //      Text to display above text area
        dialogText: localization.description,

        // confirmActionText [readonly] String
        //      Approve label for the dialog
        confirmActionText: localization.ok,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconRight",

        isCommentRequiredPropertyName: "isForcedApproveCommentRequired",

        _executeServiceMethod: function (reason) {
            // Override to only send approval id and reject reason.
            return this.approvalService.forceCompleteApproval(this.approval.id, reason)
                .then(this._onContentStatusChange.bind(this));
        }
    });
});

},
'epi-cms/content-approval/command/RejectChanges':function(){
define([
    "dojo/_base/declare",
    "./_ApprovalTransitionWithReasonTextCommand",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.rejectchanges"
],
function (
    declare,
    _ApprovalTransitionWithReasonTextCommand,
    localization
) {

    return declare([_ApprovalTransitionWithReasonTextCommand], {
        // summary:
        //      Reject the changes in the current approval step
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.label,

        // title [readonly] String
        //      The dialog title
        title: localization.title,

        dialogPlaceHolder: localization.placeholder,

        // confirmationActionText [readonly] String
        //      Approve label for the dialog
        confirmActionText: localization.confirmactiontext,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconStop",

        // executeMethod: [public] String
        //      The method to execute on the approval service
        executeMethod: "rejectChanges",

        isCommentRequiredPropertyName: "isDeclineCommentRequired"
    });
});

},
'epi-cms/content-approval/command/ReadyForReview':function(){
define([
    "dojo/_base/declare",
    "epi-cms/contentediting/ContentActionSupport",
    // Parent class
    "epi-cms/content-approval/command/_ApprovalTransitionWithReasonTextCommand",
    // Resources
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.requestapproval"
], function (
    declare,
    ContentActionSupport,
    // Parent class
    _ApprovalTransitionWithReasonTextCommand,
    // Resources
    localization
) {

    return declare([_ApprovalTransitionWithReasonTextCommand], {
        // summary:
        //      Set the content as ready to review.
        // tags:
        //      internal

        label: localization.label,

        executingLabel: localization.label,

        action: ContentActionSupport.saveAction.RequestApproval,

        // title [readonly] String
        //      The dialog title
        title: localization.title,

        dialogPlaceHolder: localization.placeholder,

        // confirmationActionText [readonly] String
        //      Send label for the dialog
        confirmActionText: localization.confirmactiontext,

        isCommentRequiredPropertyName: "isStartCommentRequired",

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            this._watchModelProperty();
        },

        _getApprovalDefinition: function () {
            // summary:
            //      Get approval definition when we execute the command
            //      to determine if a comment is required
            // tags:
            //      protected

            return this.approvalService.getDefinition(this.model.contentLink);
        },

        _executeServiceMethod: function (reason) {
            return this.model.changeContentStatus(this.action)
                .then(function () {
                    if (reason) {
                        return this.approvalService.getApproval(this.model.contentLink)
                            .then(function (approval) {
                                this.set({
                                    canExecute: !!approval,
                                    approval: approval
                                });
                                return this.approvalService.commentChanges(this.approval.id, reason);
                            }.bind(this));
                    }
                }.bind(this))
                .then(this._onContentStatusChange.bind(this));
        }

    });
});

},
'epi-cms/contentediting/viewsettings/ChannelViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi-cms/contentediting/_ViewSetting"
], function (declare, lang, _ViewSetting) {

    return declare([_ViewSetting], {
        // tags:
        //      internal

        key: "epichannel",

        usedForRendering: true,

        isTagItem: false,

        beforePreviewLoad: function (previewParams, enabled) {
            this.inherited(arguments);

            if (enabled && this.value) {
                previewParams.epichannel = this.value;
            } else {
                delete previewParams.epichannel;
            }
        }
    });
});

},
'epi-cms/contentediting/_ViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/_StatefulGetterSetterMixin"
],
function (
    declare,
    _StatefulGetterSetterMixin
) {
    return declare(_StatefulGetterSetterMixin, {
        // summary:
        //      Abstract view setting class.
        //      Concreate view setting classes define a key to get setting value from URL hash, and an apply method.
        //      On applying settings, "/epi/cms/action/viewsettingchanged" will be published.
        // tags:
        //      abstract public

        key: null,

        value: null,

        enabled: null,

        postscript: function () {
            this._disableObsoleteWarnings = true;
            this.inherited(arguments);
        },

        beforePreviewLoad: function (previewParams, enabled) {
            // summary:
            //      Before the preview is loaded. The view setting implementation can modify preview parameters it concerns.
            //      In most of the cases, previewParams contains Url parameter to load the preview iframe.
            // previewParams: Hashtable
            //      The current preview parameters.
            // enabled: Boolean
            //      Indicate that this view setting should be enabled or disabled when apply.
            // tags:
            //      public
        },

        afterPreviewLoad: function (preview, enabled) {
            // summary:
            //      After the preview is loaded. The view setting implementation can modify preview parameters it concerns
            //      Concrete implementation should either make changes to the preview or return set of preview parameters if changes require the preview to reload.
            // preview: Object
            //      The preview widget. For CMS contents, preview widget is usually an IframeWithOverlay.
            // enabled: Boolean
            //      Indicate that this view setting should be enabled or disabled when apply.
            //  return: Hashtable
            //      Preview parameters added when the preview is reloaded.
            // tags:
            //      public
        }
    });
});

},
'epi/shell/_StatefulGetterSetterMixin':function(){
﻿define("epi/shell/_StatefulGetterSetterMixin", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/obsolete"
],

function (
    declare,
    lang,
    obsolete
) {
    return declare(null, {
        // summary:
        //		A mixin for Stateful object with getters and setters like the dijit Widget implementation.
        //		Each property can be accessed or set with a function like:
        //
        //		`myObject.get("propertyName")` will be handled by `myObject._getPropertyNameAttr()` if it exists
        //		and `myObject.set("propertyName", value)` will be handled by
        //		`myObject._setPropertyNameAttr(value)` if it exists
        //
        // tags:
        //    internal xproduct deprecated

        // _disableObsoleteWarnings: [protected] Boolean
        //      Gets or sets if we should we skip the obsolete warnings.
        _disableObsoleteWarnings: false,

        postscript: function () {
            if (!this._disableObsoleteWarnings) {
                obsolete("epi/shell/_StatefulGetterSetterMixin", "Use dojo/Stateful custom setters/getters instead");
            }
        },

        get: function (name) {
            // summary:
            //		Get a property.
            //	name:
            //		The property to get.
            // description:
            //		Get a named property. The property may
            //		potentially be retrieved via a getter method. If no getter is defined, this
            //		just retrieves the object's property.

            var names = this._getAttrNames(name);
            return this[names.g] ? this[names.g]() : this[name];
        },

        set: function (name, value) {
            // summary:
            //		Set a property
            //	name:
            //		The property to set.
            //	value:
            //		The value to set in the property.
            // description:
            //		Sets named properties on this object which may potentially be handled by a
            //		setter.
            //
            //		set() may also be called with a hash of name/value pairs, ex:
            //
            //	|	myWidget.set({
            //	|		foo: "Howdy",
            //	|		bar: 3
            //	|	});

            if (typeof name === "object") {
                for (var x in name) {
                    this.set(x, name[x]);
                }
                return this;
            }

            var names = this._getAttrNames(name);
            var setter = this[names.s];

            if (lang.isFunction(setter)) {
                // use the explicit setter
                setter.apply(this, Array.prototype.slice.call(arguments, 1));
            } else {
                this._set(name, value);
            }

            return this;
        },

        _attrPairNames: {},  // shared between all widgets

        _getAttrNames: function (name) {
            // summary:
            //		Helper function for get() and set().
            //		Caches attribute name values so we don't do the string ops every time.
            // tags:
            //		private

            var apn = this._attrPairNames;
            if (apn[name]) {
                return apn[name];
            }
            var uc = name.replace(/^[a-z]|-[a-zA-Z]/g, function (c) {
                return c.charAt(c.length - 1).toUpperCase();
            });
            return (apn[name] = {
                s: "_set" + uc + "Attr", // converts dashes to camel case, ex: accept-charset --> _setAcceptCharsetAttr
                g: "_get" + uc + "Attr",
                l: uc.toLowerCase()		// lowercase name w/out dashes, ex: acceptcharset
            });
        },

        _set: function (/*String*/name, /*anything*/value) {
            // summary:
            //		Helper function to set new value for specified attribute, and call handlers
            //		registered with watch() if the value has changed.
            // tags:
            //		private

            var oldValue = this[name];
            this[name] = value;
            if (this._watchCallbacks) {
                this._watchCallbacks(name, oldValue, value);
            }
            return this;
        }
    });
});

},
'epi/obsolete':function(){
define("epi/obsolete", [],
    function () {
        return function (/*String*/ behaviour, /*String?*/ extra, /*String?*/ removal) {
            // summary:
            //      Log a debug message to indicate that a behavior has been
            //      obsoleted.
            // behaviour: String
            //      The API or behavior being obsoleted. Usually in the form
            //      of "myApp.someFunction()".
            // extra: String?
            //      Text to append to the message. Often provides advice on a
            //      new function or facility to achieve the same goal during
            //      the obsolete period.
            // removal: String?
            //      Text to indicate when in the future the behavior will be
            //      removed. Usually a version number.
            // example:
            //  | obsolete("myApp.getTemp()", "use myApp.getLocaleTemp() instead", "1.0");
            // tags:
            //      public

            var message = "OBSOLETE: " + behaviour;
            if (extra) {
                message += " " + extra;
            }
            if (removal) {
                message += " -- will be removed in version: " + removal;
            }
            console.warn(message);
        };
    });

},
'epi-cms/contentediting/viewsettings/ResolutionViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/_ViewSetting"
],
function (declare, _ViewSetting) {
    return declare([_ViewSetting], {
        // tags:
        //      internal

        key: "resolution",
        usedForRendering: false,

        afterPreviewLoad: function (preview, enabled) {
            this.inherited(arguments);

            if (preview) {
                var size = enabled ? this._getPreviewResolution() : null;
                preview.set("previewSize", size);
                preview.set("devicePreviewClass", this.value ? "epi-editorViewport--device-preview epi-viewPort-" + this.value : "");
            }

            return null; //Don't need to reload
        },

        _getPreviewResolution: function () {
            // summary:
            //		Gets preview resolution view setting.
            //
            // tags:
            //		private

            var size = null;

            // Get preview resolution.
            var resolution = this.value;

            if (resolution) {
                var screenSize = resolution.split("x");
                if (screenSize.length === 2) {
                    size = { w: screenSize[0], h: screenSize[1] };
                }
            }

            return size;
        }
    });
});

},
'epi-cms/contentediting/viewsettings/ViewLanguageViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dijit/Destroyable",
    "epi-cms/contentediting/_ViewSetting"
],
function (declare, lang, Deferred, Destroyable, _ViewSetting) {
    return declare([Destroyable, _ViewSetting], {
        // tags:
        //      internal

        key: "viewlanguage",
        usedForRendering: true,
        isTagItem: false,

        constructor: function (contextService) {
            this.own(contextService.registerRequestInterceptor(lang.hitch(this, this._onContextChange)));
        },

        _onContextChange: function (contextParams, callerData) {
            var dfd = new Deferred();
            dfd.resolve();
            if (this.get("enabled") && this.value) {
                contextParams.epslanguage = this.value;
            }

            return dfd;
        }
    });
});

},
'epi-cms/contentediting/viewsettings/VisitorGroupViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi-cms/contentediting/_ViewSetting"
], function (declare, lang, _ViewSetting) {

    return declare([_ViewSetting], {
        // tags:
        //      internal

        key: "visitorgroup",

        usedForRendering: true,

        isTagItem: false,

        beforePreviewLoad: function (previewParams, enabled) {
            this.inherited(arguments);

            if (enabled && this.value) {
                previewParams.visitorgroupsByID = this.value;
            } else {
                delete previewParams.visitorgroupsByID;
            }
        }
    });
});

},
'epi-cms/project/ProjectViewSetting':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",

    "dijit/Destroyable",
    // Parent class
    "epi-cms/contentediting/_ViewSetting"
], function (
    declare,
    lang,
    Deferred,
    Destroyable,
    // Parent class
    _ViewSetting
) {

    return declare([Destroyable, _ViewSetting], {
        // summary:
        //      The view setting for previewing projects.
        // tags:
        //      internal

        key: "project",

        usedForRendering: true,

        isTagItem: false,

        constructor: function (contextService) {
            // Register a request interceptor so we can add the correct params on the request when the view setting is enabled
            this.own(contextService.registerRequestInterceptor(lang.hitch(this, this._onContextChange)));
        },

        beforePreviewLoad: function (previewParams, enabled) {
            // summary:
            //      Determines whether to add the projects parameter to the preview
            //      before loading the preview.
            this.inherited(arguments);

            if (enabled && this.value) {
                previewParams.epiprojects = this.value;
            } else {
                delete previewParams.epiprojects;
            }
        },

        _onContextChange: function (contextParams, callerData) {
            var dfd = new Deferred();

            if (this.get("enabled") && this.value) {
                //Add epiprojects and epieditmode to the context params
                //both are need to so for the content api to deliver the correct values
                contextParams.epiprojects = this.value;
                contextParams.epieditmode = true;
            }

            dfd.resolve();

            return dfd.promise;
        }
    });
});

},
'epi-cms/widget/ContentTypeService':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/promise/all",

    // epi
    "epi/dependency",
    "epi/shell/TypeDescriptorManager"
],

function (
// dojo
    declare,
    array,
    lang,
    when,
    all,

    // epi
    dependency,
    TypeDescriptorManager
) {

    return declare(null, {
        // summary:
        //      A service for getting content types through content type store
        // tags:
        //      internal

        // contentTypeStore: [readonly] Store
        //      A REST store for interacting with ContentTypes.
        contentTypeStore: null,

        // _getavailabletypesQuery
        //     query to get all the requested types
        _getavailabletypesQuery: "getavailablecontenttypes",

        constructor: function () {
            this.contentTypeStore = this.contentTypeStore || dependency.resolve("epi.storeregistry").get("epi.cms.contenttype");
        },

        getAcceptedChildTypes: function (parentContentLink, isLocalAsset, requestedTypes, allowedTypes, restrictedTypes) {
            // summary:
            //      Returns the list of accepted child types for given contentLink. The list will be  filtered on based on requestedtypes and allowed/restricted types.
            //
            // parentContentLink: String
            //      The parent contentLink
            // isLocalAsset: Boolean
            //      Represents whether the child types will be local asset or not.
            // requestedTypes: Array
            //      The expected types (i.e epi.core.blockdata for all blocks)
            // allowedTypes: array
            //      The list of allowed types (retrieved from AllowedTypesAttribute.AllowedTypes metadata)
            // restrictedTypes: array
            //      The list of restricted types (retrieved from AllowedTypesAttribute.restrictedTypes metadata)
            // tags:
            //      internal

            var result = this.contentTypeStore.query({
                query: this._getavailabletypesQuery,
                localAsset: isLocalAsset,
                parentReference: parentContentLink,
                requestedTypes: requestedTypes
            });

            return this.filterQueryResult(result, allowedTypes, restrictedTypes);
        },

        filterQueryResult: function (result, allowedTypes, restrictedTypes) {
            // summary:
            //      Returns the filtered list result where filter is based on given allowed/restricted types.
            //
            // query: Object
            //      The returned array of models or promises from ContentTypeStore
            // allowedTypes: array
            //      The list of allowed types (retrieved from AllowedTypesAttribute.AllowedTypes metadata)
            // restrictedTypes: array
            //      The list of restricted types (retrieved from AllowedTypesAttribute.restrictedTypes metadata)
            // tags:
            //      internal

            return when(result).then(function (types) {
                // get the typeIdentifiers
                var availableTypeIdentifiers = array.map(types, function (type) {
                    return type.typeIdentifier;
                });

                // filter typeIdentifiers based on allowed/restricted types
                availableTypeIdentifiers = TypeDescriptorManager.getValidAcceptedTypes(availableTypeIdentifiers, allowedTypes, restrictedTypes);

                types = array.filter(types, function (type) {
                    return array.some(availableTypeIdentifiers, function (typeIdentifier) {
                        return type.typeIdentifier === typeIdentifier;
                    });
                });

                return types;
            });
        }
    });
});

},
'epi-cms/telemetry/telemetryInitializer':function(){
define([
    "dojo/when",
    "epi/dependency",
    "epi/shell/applicationSettings",
    "epi-cms/telemetry/trackComponents"
], function (
    when,
    dependency,
    applicationSettings,
    trackComponents
) {
    return {
        initialize: function () {
            if (typeof aptrinsic !== "function") {
                return;
            }

            var telemetry = applicationSettings.telemetry;
            if (!telemetry) {
                return;
            }

            var registry = dependency.resolve("epi.storeregistry");
            var componentsStore = registry.get("epi.shell.component");
            //Initialize Gainsight
            var userFields = {
                id: telemetry.user,
                signUpDate: telemetry.user_creationDate
            };
            var accountFields = {
                id: telemetry.client
            };

            // current using gadgets component
            componentsStore.query({ viewName: "/episerver/cms/home" }).then(function (components) {
                userFields.cms_current_using_gadget = trackComponents.filterCurrentUsingGadgets(components);
            }).always(function () {
                // eslint-disable-next-line no-undef
                aptrinsic("identify",
                    userFields,
                    accountFields
                );
            });

            trackComponents.initialize();
        }
    };
});

},
'epi-cms/telemetry/trackComponents':function(){
define([
    "dojo/topic",
    "epi/shell/widget/ComponentController",
    "epi-cms/ApplicationSettings"
], function (
    topic,
    ComponentController,
    ApplicationSettings
) {

    //TODO TELEMETRY: this code can now be simplified, all prototype hacks can be removed
    function trackComponent(event, name) {
        // eslint-disable-next-line no-undef
        aptrinsic("track", event, {
            name: name
        });
    }

    function filterGadgets(components) {
        // filter data to exclude default components, we track direct children of ComponentPaneContainers
        // AND Navigation, Assets panes
        var pinnablePaneDefinition = "EPiServer.Shell.ViewComposition.Containers.PinnablePane";
        var componentPaneDefinition = "EPiServer.Shell.ViewComposition.Containers.ComponentPaneContainer";
        var componentGroupDefinition = "EPiServer.Shell.ViewComposition.Containers.ComponentGroup";

        var pinnablePaneIds = components.filter(function (component) {
            return component.definitionName === pinnablePaneDefinition;
        }).map(function (e) {
            return e.id;
        });

        var componentPaneIds = components.filter(function (component) {
            return component.definitionName === componentPaneDefinition && pinnablePaneIds.includes(component.parentId);
        }).map(function (e) {
            return e.id;
        });

        var filteredComponents = components.filter(function (component) {
            return componentPaneIds.includes(component.parentId) && component.definitionName !== componentGroupDefinition;
        }).map(function (component) {
            return component.definitionName;
        });

        // track Navigation and Assets panes usage (visibility) by ComponentGroup"s headingLocalizationKey and isHidden setting
        // "/episerver/cms/homeview/navigation", "/episerver/cms/homeview/assets"
        components.forEach(function (component) {
            var settings = component.settings || {};
            if (settings.headingLocalizationKey === "/episerver/cms/homeview/navigation" && !settings.isHidden) {
                filteredComponents.push("EPiServer.Cms.Shell.UI.Components.MainNavigationComponent");
            }
            if (settings.headingLocalizationKey === "/episerver/cms/homeview/assets" && !settings.isHidden) {
                filteredComponents.push("EPiServer.Cms.Shell.UI.Components.AssetsComponent");
            }
        });

        //distinct result
        return filteredComponents.filter(function (value, index, self) {
            return self.indexOf(value) === index;
        }).join(",");
    }

    function patchComponentController() {
        var originalAddComponent = ComponentController.prototype.addComponent;
        ComponentController.prototype.addComponent = function (container, component, createComponent, callback) {
            var result = originalAddComponent.apply(this, arguments);
            trackComponent("Gadget Added", component.definitionName);
            return result;
        };
        ComponentController.prototype.addComponent.nom = "addComponent";

        var originalRemoveComponent = ComponentController.prototype.removeComponent;
        ComponentController.prototype.removeComponent = function (identity) {
            var result = originalRemoveComponent.apply(this, arguments);
            var component = this.getComponentDefinitionById(identity);
            trackComponent("Gadget Removed", component.definitionName);
            return result;
        };
        ComponentController.prototype.removeComponent.nom = "removeComponent";
    }

    function onToggleComponent(data) {
        //track removing Main Navigation and Assets, adding (hiding) event is tracked in ComponentController.addComponent action
        if (data && data.isHidden) {
            if (data.key === ApplicationSettings.mainNavigationComponentKey ||
                data.key === "/episerver/cms/homeview/navigation") {
                trackComponent("Gadget Removed", "EPiServer.Cms.Shell.UI.Components.MainNavigationComponent");
            }

            if (data.key === ApplicationSettings.assetsComponentKey ||
                data.key === "/episerver/cms/homeview/assets") {
                trackComponent("Gadget Removed", "EPiServer.Cms.Shell.UI.Components.AssetsComponent");
            }
        }
    }

    return {
        initialize: function () {
            patchComponentController();
            topic.subscribe("/epi/cms/action/togglecomponent", onToggleComponent);
        },
        filterCurrentUsingGadgets: filterGadgets
    };
});

},
'epi-cms/Profile':function(){
﻿define("epi-cms/Profile", [
    "dojo/_base/lang",
    "dojo/when",
    "epi/shell/Profile",
    "epi-cms/ApplicationSettings"
], function (lang, when, Profile, ApplicationSettings) {

    lang.extend(Profile, {

        getContentLanguage: function () {
            // summary:
            //      Get the content language for the host
            // tags:
            //      internal xproduct

            return when(this.get("editlanguage"), function (currentLanguage) {

                //If the user hasn't selected any preferred language yet use the current content language configured in the application settings
                return currentLanguage || ApplicationSettings.currentContentLanguage;
            });
        },
        setContentLanguage: function (languageId) {
            // summary:
            //      Set the language for a specific host (stored on the server)
            //
            // languageId: String
            //      The id of the language to set
            // tags:
            //      internal xproduct

            return this.set("editlanguage", languageId, { location: "server" });
        }
    });

    return Profile;
});

},
'epi-cms/compare/views/AllPropertiesCompareView':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/when",

    "../viewmodels/AllPropertiesCompareViewModel",
    "../AllPropertiesTransformer",
    "../FormField",
    "epi/shell/widget/FormContainer",

    // Parent class and mixins
    "epi-cms/contentediting/FormEditing",
    "epi/shell/widget/_ModelBindingMixin"
], function (
    declare,
    lang,
    Deferred,
    when,

    AllPropertiesCompareViewModel,
    AllPropertiesTransformer,
    FormField,
    FormContainer,

    // Parent class and mixins
    FormEditing,
    _ModelBindingMixin
) {

    return declare([FormEditing, _ModelBindingMixin], {
        // summary:
        //      View for comparing all properties.
        // tags:
        //      internal

        modelBindingMap: {
            comparison: ["comparison"],
            rightMetadata: ["rightMetadata"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            this._groupMap = {};

            this.own(
                this.model = new AllPropertiesCompareViewModel({ model: this.model })
            );
        },

        removeForm: function (form) {
            // summary:
            //      Remove the edit form.
            // tags:
            //      protected

            var selectedChild = form.containerLayout.selectedChildWidget;
            if (selectedChild) {
                // Save the selected tabs name so that we can restore it later.
                this._selectedTabName = selectedChild.name.toLowerCase();
            }

            // Reset the group map so that we don't update the old tabs whilst switching views.
            this._groupMap = {};

            // Clear all the editor wrapper mappings. This only other happens when changing
            // the context and it needs to happen when changing the right version as well.
            this._mappingManager.clear();

            return this.inherited(arguments);
        },

        _createForm: function () {
            // summary:
            //      Setup the edit form.
            // tags:
            //      private

            return new FormContainer(lang.mixin({
                readOnly: !this.viewModel.canChangeContent(),
                metadata: this.viewModel.metadata,
                metadataTransformer: new AllPropertiesTransformer({ model: this.model }),
                baseClass: "epi-cmsEditingForm epi-form-container epi-form-container--compare"
            }, this.formSettings));
        },

        _setupForm: function () {
            // summary:
            //      Setup the edit form and set the selected tab if there is one.
            // tags:
            //      private
            this.inherited(arguments);

            // When changing the right version we should keep the tab selection.
            var selectedTab = this._groupMap[this._selectedTabName];
            if (selectedTab) {
                this._form.containerLayout.selectChild(selectedTab);
            }
        },

        _setComparisonAttr: function (comparison) {
            this._set("comparison", comparison);
            for (var groupName in this._groupMap) {
                var group = this._groupMap[groupName];
                var changes = (comparison && comparison[groupName] && comparison[groupName].length) || 0;
                this._setGroupTitleWithChanges(group, changes);
            }
        },

        _setRightMetadataAttr: function (metadata) {
            this._set("rightMetadata", metadata);

            if (!this._started) {
                return;
            }

            this._removeAndDestroyForm();
            this.viewModel && this._setupForm();
        },

        onGroupCreated: function (groupName, widget, parentGroupWidget) {
            // summary:
            //      Triggerred when a group created.
            // tags:
            //      public callback
            this.inherited(arguments);

            // If the group has a parent group we do not want to add that to our group map and change the title of the tab
            if (parentGroupWidget) {
                return;
            }

            var name = groupName.toLowerCase(),
                comparison = this.comparison;
            widget.groupName = groupName;

            this._groupMap[name] = widget;
            this._setGroupTitleWithChanges(widget, comparison && comparison[name] && comparison[name].length);
        },

        _setViewModelAttr: function (viewModel) {
            this.inherited(arguments);

            this.model.set("contentViewModel", this.viewModel);
        },

        _setGroupTitleWithChanges: function (group, numberOfChanges) {
            // summary:
            //      Sets the title along with the number of changes on the group.
            // tags:
            //      internal
            var title = group.params.title;

            if (numberOfChanges) {
                title = lang.replace("{0}<span class=\"epi-compare-tab--has-changes\">{1}</span>", [title, numberOfChanges]);
            }

            group.set("title", title);
        }
    });
});

},
'epi-cms/compare/viewmodels/AllPropertiesCompareViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/when",
    "epi",
    "epi/dependency",
    "epi/string",
    "epi-cms/core/ContentReference",
    // Parent class and mixins
    "dojo/Stateful",
    "dijit/Destroyable"
], function (
    declare,
    lang,
    aspect,
    when,
    epi,
    dependency,
    string,
    ContentReference,
    // Parent class and mixins
    Stateful,
    Destroyable
) {

    return declare([Stateful, Destroyable], {
        // summary:
        //      The view model for the all properties compare view.
        // tags:
        //      internal

        _metadataManager: null,

        // contentViewModel: [public] Object
        //      The view model for the current content.
        contentViewModel: null,

        // leftMetadata: [readonly] Object
        //      The metadata for the left hand version.
        leftMetadata: null,

        leftPropertyMap: null,

        // rightMetadata: [readonly] Object
        //      The metadata for the right hand version.
        rightMetadata: null,

        rightPropertyMap: null,

        postscript: function () {
            // summary:
            //      Setup mixed in properties
            // tags:
            //      protected
            this.inherited(arguments);

            this._metadataManager = this._metadataManager || dependency.resolve("epi.shell.MetadataManager");

            this.initialize();
        },

        initialize: function () {

            var updateMetadata = lang.hitch(this, function (name, oldValue, newValue) {
                var version = this.model.rightVersion;

                // If set to null or no change do an early exit
                if (!version || (oldValue === newValue)) {
                    return;
                }

                when(this._metadataManager.getMetadataForType(
                    "EPiServer.Core.ContentData",
                    { contentLink: version.contentLink }
                ), lang.hitch(this, function (metadata) {
                    this.set("rightMetadata", metadata);
                }));
            });

            updateMetadata("rightVersionContentLink", null,  this.model.rightVersionContentLink);
            this.own(
                this.model.watch("rightVersionContentLink", updateMetadata),
                this.model.watch("contentLink", lang.hitch(this, function (name, oldContentLink, contentLink) {
                    // Reset the left and right metadata to null when changing to a different
                    // content so that we do not generate any erroneous comparisons.
                    if (!ContentReference.compareIgnoreVersion(oldContentLink, contentLink)) {
                        this.set({
                            leftMetadata: null,
                            leftPropertyMap: null,
                            rightMetadata: null,
                            rightPropertyMap: null
                        });
                    }
                }))
            );
        },

        generateComparison: function () {
            // summary:
            //      Generate a new comparison based on the left and right metadata.
            // tags:
            //      internal
            var comparison = {},
                metadata = this.rightMetadata;

            if (!this.leftPropertyMap || !this.rightPropertyMap) {
                this.set("comparison", null);
                return;
            }

            // Create arrays for each group
            metadata.groups.forEach(function (group) {
                comparison[group.name.toLowerCase()] = [];
            });

            // Find all the properties that are different between to two versions.
            metadata.properties.forEach(lang.hitch(this, function (propertyMetadata) {
                this._addPropertyToComparison(comparison, propertyMetadata, propertyMetadata.groupName);
            }));

            this.set("comparison", comparison);
        },

        copy: function (propertyName) {
            // summary:
            //      Copy the old property value
            // propertyName: String
            //      The name of the property to copy from

            if (!propertyName) {
                throw new Error("propertyName is required");
            }

            var contentViewModel = this.contentViewModel,
                oldValue = lang.getObject(propertyName, false, this.rightPropertyMap);

            if (contentViewModel && oldValue !== undefined) {
                contentViewModel.setProperty(propertyName, lang.clone(oldValue));
                contentViewModel.save();
            }
        },

        _addPropertyToComparison: function (comparison, property, groupName, prefix) {
            // summary:
            //      Recursively add properties to the comparison. Sub-properties will have their
            //      name appended to the prefix and have their group overridden by that given.
            // tags:
            //      internal
            var propertyName = string.pascalToCamel((prefix || "") + property.name),
                leftValue = lang.getObject(propertyName, false, this.leftPropertyMap),
                rightValue = lang.getObject(propertyName, false, this.rightPropertyMap);

            if (property.showForEdit && !epi.areEqual(leftValue, rightValue, epi.compareOptions.treatFalsyAsEquals |  epi.compareOptions.skipEmptyProperties)) {
                // If the property is an inline block and has sub properties then we should compare
                // the sub properties instead.
                if (property.properties.length) {
                    property.properties.forEach(lang.hitch(this, function (subproperty) {
                        this._addPropertyToComparison(comparison, subproperty, groupName, propertyName + ".");
                    }));
                } else {
                    // If it is not an inline block then add the property to the comparison.
                    comparison[groupName.toLowerCase()].push(propertyName.toLowerCase());
                }
            }
        },

        _contentViewModelSetter: function (viewModel) {
            this.contentViewModel = viewModel;

            this.set({
                leftMetadata: viewModel.metadata,
                leftPropertyMap: viewModel.contentData.properties
            });

            this.own(
                viewModel.watch("contentData", lang.hitch(this, function (name, oldContentData, contentData) {
                    this.set("leftPropertyMap", contentData.properties);
                })),
                aspect.after(viewModel, "onPropertySaved", lang.hitch(this, "_onPropertySaved"), true)
            );
        },

        _leftPropertyMapSetter: function (properties) {
            this.leftPropertyMap = lang.clone(properties);
            this.generateComparison();
        },

        _rightPropertyMapSetter: function (properties) {
            this.rightPropertyMap = lang.clone(properties);
            this.generateComparison();
        },

        _rightMetadataSetter: function (metadata) {
            this.rightMetadata = metadata;

            if (this.rightMetadata) {
                when(this.model.contentDataStore.get(this.model.rightVersion.contentLink))
                    .then(lang.hitch(this, function (contentData) {
                        this.set("rightPropertyMap", contentData.properties);
                    }));
            }
        },

        _onPropertySaved: function (propertyName, value) {
            var comparison = this.comparison;

            if (this.leftPropertyMap) {
                lang.setObject(propertyName, value, this.leftPropertyMap);
            }

            // Early exit if there is no comparison generated.
            if (!comparison) {
                return;
            }

            var parentMetadata = this.rightMetadata.getPropertyMetadata(propertyName.split(".")[0]),
                propertyMetadata = this.rightMetadata.getPropertyMetadata(propertyName),
                oldValue = this.rightPropertyMap && lang.getObject(propertyName, false, this.rightPropertyMap);

            // Early exit if this property should not displayed in edit mode.
            if (!propertyMetadata.showForEdit) {
                return;
            }

            var group = comparison[parentMetadata.groupName.toLowerCase()],
                name = propertyName.toLowerCase(),
                index = group.indexOf(name),
                areEqual = epi.areEqual(value, oldValue, epi.compareOptions.treatFalsyAsEquals |  epi.compareOptions.skipEmptyProperties);

            if (index >= 0 && areEqual) {
                group.splice(index, 1);
            } else if (index < 0 && !areEqual) {
                group.splice(0, 0, name);
            }

            this.set("comparison", comparison);
        }
    });
});

},
'epi-cms/compare/AllPropertiesTransformer':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/string",
    "epi/shell/MetadataTransformer",

    "epi/i18n!epi/cms/nls/episerver.cms.compare"
],
function (
    declare,
    lang,
    string,
    MetadataTransformer,

    res
) {

    return declare([MetadataTransformer], {
        // summary:
        //     Transforms property metadata to support the compare view
        //
        // tags:
        //     internal

        // model: [readonly] Object
        //      The model used to setup the compare editors.
        model: null,

        // _map: [private]  Object
        //      Map based on the full name of a metadata property
        _map: null,

        _getProperty: function (fullName) {
            // summary:
            //      Tries to get a property metadata matching the full name.
            //
            // fullName: string
            //      The hierarchical name of the property to get.
            // tags:
            //      private

            function populateMap(map, metadataProperties, path) {
                metadataProperties.forEach(function (property) {
                    var name = (!path ? property.name : path + "." + property.name).toLowerCase();

                    map[name] = property;
                    property.properties.length && populateMap(map, property.properties, name);
                });

                return map;
            }

            if (!this.model.rightMetadata) {
                return null;
            }

            if (!this._map) {
                this._map = populateMap({}, this.model.rightMetadata.properties);
            }

            return this._map[fullName.toLowerCase()];
        },

        _getComponentDefinitions: function (propertyDefinitions, groupDefinitions, nameBase, useDefaultValue, readOnly) {
            // summary:
            //      Modify the group definitions before creating the component definitions

            //Modify the groupDefinitions
            if (groupDefinitions instanceof Array) {
                var defaultSingleGroupType = this.defaultSingleGroupType;
                groupDefinitions.forEach(function (group) {
                    if (group.name === "EPiServerCMS_SettingsPanel") {
                        delete group.options.region;
                        group.options.title = res.settingspaneltabname;
                        group.uiType = defaultSingleGroupType;
                    }
                });
            }

            return this.inherited(arguments);
        },

        transformPropertySettings: function (property, nameBase, useDefaultValue, readOnly, modelTypeIdentifier) {
            // summary:
            //      Transforms property and compared property settings into a format that epi/shell/widget/WidgetFactory can process.
            // tags:
            //      public (inherited)

            var editor = this.inherited(arguments),
                compareProperty = this._getProperty(nameBase + property.name),
                compareEditor;

            editor.settings._hint = "compare";
            editor.settings.groupName = property.groupName;

            if (compareProperty) {
                var propertyName = string.pascalToCamel(nameBase + property.name),
                    value = this.model && lang.getObject(propertyName, false, this.model.rightPropertyMap);

                // Don't use the initial value for the compare property. Instead set the value based on what is stored
                // in the content data object which is available in the right property map.
                compareEditor = this.inherited(arguments, [compareProperty, "compare." + nameBase, false, true, modelTypeIdentifier]);
                compareEditor.settings._type = "compare";
                compareEditor.settings.compareViewModel = this.model;
                compareEditor.settings.value = value;

                return [editor, compareEditor];
            }

            return editor;
        },

        _createGroupContainer: function (group, readOnly) {
            var editor = this.inherited(arguments);
            editor.settings._hint = "compare";
            return editor;
        },

        _createParentContainer: function (property) {
            // Set the group name for any sub-properties to be the same as its parent
            // so that comparison information appears on the correct tab.
            property.properties.forEach(function (subproperty) {
                subproperty.groupName = property.groupName;
            });

            return this.inherited(arguments);
        }
    });
});

},
'epi-cms/compare/FormField':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-construct",

    "dojo/dom-style",

    // dijit
    "dijit/form/Button",

    // epi
    "epi/shell/form/Field",
    "epi/shell/form/formFieldRegistry",

    "epi/i18n!epi/cms/nls/episerver.cms.compare",
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash.restore"
],
function (
// dojo
    declare,
    lang,
    domClass,
    domConstruct,

    domStyle,

    // dijit
    Button,

    // epi
    Field,
    registry,
    res,
    restoreRes
) {

    var module = declare([Field], {
        //  tags:
        //      internal

        _copyButton: null,

        buildRendering: function () {

            this.inherited(arguments);

            this.own(this._copyButton = new Button({
                "class": "epi-form-container__section__row__copy-button epi-chromeless",
                iconClass: "epi-iconUndo",
                label: restoreRes.label,
                title: res.copy.tooltip
            }).placeAt(this.domNode, "last"));

            this._copyButton.on("click", lang.hitch(this, function () {
                this.model.copy(this.params.name);
            }));

            this.containerNode = this.domNode;
        },

        addChild: function (child, index) {

            var labelNode,
                wrapperNode = domConstruct.create(
                    "div",
                    { "class": "epi-form-container__section__row__editor--" + child._type },
                    this.domNode
                );

            if (child.checkbox) {
                if (child._type === "compare") {
                    labelNode = domConstruct.create("label", { innerHTML: child.label }, wrapperNode);
                } else {
                    labelNode = domConstruct.place(this.labelNode, wrapperNode);
                    domConstruct.place(this.propertyTooltip, labelNode, "after");
                }

                this._addCheckboxChild(child, labelNode);
            } else {
                child.placeAt(wrapperNode);
            }
        },

        destroy: function () {
            this.inherited(arguments);

            if (this._comparisonWatch) {
                this._comparisonWatch.remove();
                this._comparisonWatch = null;
            }
        },

        _setReadonlyIconDisplayAttr: function (readonlyIconDisplay) {

            this.inherited(arguments);

            if (this._copyButton) {
                domStyle.set(this._copyButton.domNode, "display", readonlyIconDisplay ? "none" : "");
            }
        },

        _setModelAttr: function (model) {
            this._set("model", model);

            if (this._comparisonWatch) {
                this._comparisonWatch.remove();
            }

            this._updateChangedState();
            this._comparisonWatch = model.watch("comparison", lang.hitch(this, "_updateChangedState"));
        },

        _updateChangedState: function () {
            var comparison = this.model.comparison,
                group = comparison && comparison[this.groupName],
                hasChange = group && group.indexOf(this.name.toLowerCase()) >= 0;

            domClass.toggle(this.domNode, "epi-form-container__section__row--has-changes", hasChange);
        }
    });

    function fieldFactory(widget, parent) {

        var wrapper = new module({
            labelTarget: widget.checkbox ? widget.checkbox.id : widget.id,
            label: widget.label,
            tooltip: widget.tooltip,
            name: widget.name,
            groupName: widget.groupName.toLowerCase(),
            readonlyIconDisplay: widget.readOnly,
            required: widget.required,
            hasFullWidthValue: widget.useFullWidth
        });

        wrapper.own(widget.watch("readOnly", function (name, oldValue, newValue) {
            wrapper.set("readonlyIconDisplay", newValue);
        }));

        return wrapper;
    }

    function compareFactory(widget, parent) {
        var wrapper = parent.getChildren().pop();
        wrapper.set("model", widget.compareViewModel);

        return wrapper;
    }

    compareFactory.preventAdd = true;

    registry.add([
        {
            type: registry.type.field,
            hint: "compare",
            factory: fieldFactory
        },
        {
            type: "compare",
            hint: "",
            factory: compareFactory
        }
    ]);

    return module;
});

},
'epi-cms/contentediting/FormEditing':function(){
define([
    "dojo/_base/declare",
    "dojo/dom-class",

    "dijit/layout/ContentPane",

    "epi-cms/contentediting/_FormEditingMixin",
    "epi-cms/contentediting/_ValidationMixin",
    "epi-cms/contentediting/EditingBase"
],

function (
    declare,
    domClass,

    ContentPane,

    _FormEditingMixin,
    _ValidationMixin,
    EditingBase
) {
    return declare([EditingBase, _FormEditingMixin, _ValidationMixin], {
        // summary:
        //		Form editing controller.
        //
        // tags:
        //      internal xproduct

        // createOverlays: [Boolean]
        //      Indicate that the overlays should be created.
        createOverlays: false,

        // selectFormOnCreation: Boolean
        //      Indicate that the form should be set as selected child after being added to edit layout.
        selectFormOnCreation: true,

        placeForm: function (form) {
            // summary:
            //		Setup the edit form.
            // tags:
            //		protected

            form.set("transitionMode", "reveal");
            form.set("fitContainer", true);

            this.editLayoutContainer.addChild(form, 0);
        },

        removeForm: function (form) {
            // summary:
            //		Remove the edit form.
            // tags:
            //		protected

            // if leftover is already assigned, destroy it so we don't leak
            this.editLayoutContainer.leftOver && this._removeLeftOver();

            this.editLayoutContainer.leftOver = form;

            // HACK: Fix for SH7.1 RTM
            // Even though the iframe with overlay would become visible when OPE completely loaded, we need to make it visible a little bit earlier
            // because setting up overlays would fail on FF if the underneath iframe is invisible
            // This workaround is due to a timing problem that overlay is set up at the same time with form, and often finish before.
            // At the moment, it is difficult to have overlay setup to wait for form setup because EditingBase has no idea about form.
            // These things should be refactor after the RTM. (single edit view with mixins instead of OPE and FE).
            // Related work item: #95682
            domClass.replace(this.iframeWithOverlay.domNode, "dijitVisible", "dijitHidden");

            return false;
        },

        _reloadPropertyPreview: function () {
            // We do not want to reload the preview in forms mode
        }
    });
});

},
'epi-cms/contentediting/_FormEditingMixin':function(){
define([
    // Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/when",
    "dijit/focus",

    // EPi
    "epi-cms/contentediting/SideBySideEditorWrapper",
    "epi/shell/widget/FormContainer"
], function (
    // dojo
    array,
    declare,
    lang,
    Deferred,
    when,
    focusUtil,

    // epi
    SideBySideEditorWrapper,
    FormContainer
) {
    return declare(null, {
        // summary:
        //		Form editing controller.
        //
        // tags:
        //      internal

        _form: null,

        _formWidgets: null,

        // canHandleLeftOver: Boolean
        //      Indicate that the view can handle "left over" on the edit layout container.
        canHandleLeftOver: true,

        // selectFormOnCreation: Boolean
        //      Indicate that the form should be set as selected child after being added to edit layout.
        selectFormOnCreation: false,

        // formSettings: Object
        //      Settings used when creating form.
        formSettings: null,

        // connectOverlayItemsToFormWidgets: Boolean
        //      Denote if we want to connect overlay items to form widgets, which means user can click on overlay item to start edit on form.
        //      Should be set to true on side by side editing.
        connectOverlayItemsToFormWidgets: false,

        _formConnects: null,

        destroy: function () {
            // summary:
            //		Destroy the widget.
            // tags:
            //		protected

            // Do not use own because Destroyable destroys owned things before destroy method is called.
            // As a result, we cannot remove the form from edit layout.
            this._removeAndDestroyForm();

            // remove all widgets
            this._formWidgets = null;

            this.inherited(arguments);
        },

        _removeAndDestroyForm: function () {
            // summary:
            //		Check if a form exists so remove from edit layout and destroy it.
            // tags:
            //		private

            // Remove the watches that are added for each form field during form creation.
            if (this._removeViewModelWatches) {
                this._removeViewModelWatches();
            }

            if (this._form) {
                if (this.removeForm(this._form)) {
                    this._form.destroyRecursive();
                    this._form = null;
                }

                var connect;
                while ((connect = this._formConnects.pop())) {
                    this.disconnect(connect);
                    connect = null;
                }
                this._formConnects = null;
                this._form = null;
            }

            for (var p in this._formWidgets) {
                this._formWidgets[p] = null;
            }
        },

        _setupForm: function () {
            // summary:
            //		Setup the edit form.
            // tags:
            //		private

            var formIsCreated = new Deferred();

            this._formWidgets = {};
            // Create Form container
            // Note: We don't need to set a model to the formContainer since a value
            //       will be set by the editor wrapper.
            this._form = this._createForm();

            this._formConnects = [
                this.connect(this._form, "onFieldCreated", this.onFieldCreated),
                this.connect(this._form, "onGroupCreated", this.onGroupCreated),
                this.connect(this._form, "onFormCreated", function () {
                    formIsCreated.resolve();
                })
            ];

            this.placeForm(this._form);

            when(formIsCreated, lang.hitch(this, function () {
                this._finishFormCreation();
            }));
        },

        _createForm: function () {

            return new FormContainer(lang.mixin({
                readOnly: !this.viewModel.canChangeContent(),
                metadata: this.viewModel.metadata,
                baseClass: "epi-cmsEditingForm",
                useDefaultValue: false
            }, this.formSettings));

        },

        _createFormEditorWrappers: function () {
            // summary:
            //		Create editor wrappers for form widgets.
            // formContainer: epi/shell/widget/FormContainer
            //     The form container.
            // tags:
            //		private

            for (var fieldName in this._formWidgets) {

                var property = {
                    name: fieldName,
                    metadata: this.viewModel.getPropertyMetaData(fieldName)
                };

                var value = lang.clone(this.viewModel.getProperty(property.name));

                var wrapper = new SideBySideEditorWrapper({
                    property: property,
                    propertyName: fieldName,
                    value: value,
                    editorWidget: this._formWidgets[fieldName],
                    contentModel: this.viewModel.contentModel,
                    // TODO: Remove the operation dependency when editor wrappers can raise change notifications without being in editable state
                    operation: this.viewModel._operation
                });
                wrapper.editorWidget.set("parent", wrapper);
                wrapper.editorWidget.set("editMode", "formedit");

                // Push these aspects onto the form connects array so that they are correctly destroyed
                // when the form is recreated.
                this._formConnects.push(
                    this.connect(wrapper, "onValueChange", "_onWrapperValueChange"),
                    this.connect(wrapper, "onCancel", "_onWrapperCancel"),
                    this.connect(wrapper, "onStopEdit", "_onWrapperStopEdit")
                );

                // Create mapping between property and form editor wrapper
                this._createMapping(fieldName, wrapper);

                property = null;
                value = null;
                wrapper = null;
            }
        },

        _createMapping: function (fieldName, wrapper) {
            // summary:
            //		Connect editor wraper to property rendering in template.
            // fieldName: String
            //      The property name.
            // wrapper: epi.cms.contentediting._EditorWrapperBase
            //      The editor wrapper
            // tags:
            //		private

            var names = fieldName.split(".");
            var foundAnyBlock = false;

            if (this.connectOverlayItemsToFormWidgets) {
                while (names.length > 0) {
                    var propertyName = names.join(".");

                    var mappings = this._mappingManager.find("propertyName", propertyName);
                    array.forEach(mappings, function (mapping) {
                        foundAnyBlock = true;
                        mapping.propertyName = fieldName;
                        mapping.wrapper = mapping.wrapper || wrapper;
                    });

                    names.pop();
                }
            }

            if (!foundAnyBlock) {
                // create empty mapping
                this._mappingManager.add({
                    propertyName: fieldName,
                    wrapper: wrapper
                });
            }
        },

        onSetActiveProperty: function (property) {
            // summary:
            //      Triggered when active property is set on the current content view model.
            // property: String
            //      The property name.
            // tags:
            //      public, callback

            var mapping =
                this._mappingManager
                    .find("propertyName", property)
                    .filter(function (mapping) {
                        return !!mapping.wrapper;
                    })[0];

            if (mapping) {
                mapping.wrapper.startEdit();
                return;
            }

            // try to find parent widget incase of inline block
            for (var id in this._form._widgetMap) {
                var widget = this._form._widgetMap[id];
                var parentWidget = widget && widget.parent;
                if (parentWidget && parentWidget.name === property) {
                    focusUtil.focus(parentWidget.domNode);
                    widget.parent.domNode.scrollIntoView(true);
                }
            }
        },

        placeForm: function (form) {
            // summary:
            //		Place edit form into container.
            // tags:
            //		protected, abstract

        },

        removeForm: function (form) {
            // summary:
            //		Remove edit form from container.
            // tags:
            //		protected, abstract
            // returns:
            //      false if the form is set as leftover, otherwise if form is removed and ready to destroy: true
        },

        onFieldCreated: function (fieldName, widget) {
            // summary:
            //		Triggerred when a field created.
            // tags:
            //		public, callback

            this._formWidgets[fieldName] = widget;

            if (this._addStateWatch) {
                this._addStateWatch(widget);
            }
        },

        onGroupCreated: function (groupName, widget, parentGroupWidget) {
            // summary:
            //		Triggered when a group created.
            // tags:
            //		public, callback

            if (widget.contentViewModel !== undefined) {
                widget.set("contentViewModel", this.viewModel);
            }
        },

        _finishFormCreation: function () {
            when(this.selectFormOnCreation ? this.editLayoutContainer.selectChild(this._form) : null, lang.hitch(this, this._removeLeftOver));
            this.toolbar.setItemProperty("viewselect", "state", "");

            this._createFormEditorWrappers(this._form);
            this.onSetupEditModeComplete();
        },

        _removeLeftOver: function () {
            var editLayoutContainer = this.editLayoutContainer,
                leftOverIsSelected;

            if (editLayoutContainer.leftOver) {
                leftOverIsSelected = editLayoutContainer.selectedChildWidget === editLayoutContainer.leftOver;

                when(leftOverIsSelected ? editLayoutContainer.selectChild(this.iframeWithOverlay) : null, function () {
                    var leftOver = editLayoutContainer.leftOver;

                    // Have to check again since the container may have been removed while waiting for the select animation
                    if (leftOver) {
                        editLayoutContainer.removeChild(leftOver);
                        leftOver.destroyRecursive();
                        editLayoutContainer = editLayoutContainer.leftOver = null;
                    }
                });
            }
        },

        onReadySetupEditMode: function () {
            // summary:
            //		Finish edit mode setting up.
            // description:
            //      Create editor wrappers for form widgets so it can update the model
            // tags:
            //		public callback

            this.inherited(arguments);

            // Remove the old form if there exists
            this._removeAndDestroyForm();

            // Setup new form
            this._setupForm();
        },

        remapEditMode: function () {
            // summary:
            //      Re configure edit mode after the preview context changed.
            // tags:
            //      public

            this.inherited(arguments);
            this._form && this._form.set("readOnly", !this.viewModel.canChangeContent());
        }
    });
});

},
'epi-cms/contentediting/SideBySideEditorWrapper':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/focus",
    "epi-cms/contentediting/_EditorWrapperBase"
], function (declare, lang, focusUtil, _EditorWrapperBase) {

    return declare([_EditorWrapperBase], {
        // summary:
        //		This editor wrapper connects editor widgets in side-form to the system
        //
        // tags:
        //      internal

        _grabFocusOnStartEdit: true,
        _scrollIntoViewOnStartEdit: true,

        postCreate: function () {
            // summary:
            //		Post create initialization.
            // tags:
            //		protected

            this.inherited(arguments);
            if (this.editorWidget) {
                this.connect(this.editorWidget, "onChange", "_onChange");

                if (this.editorWidget.manualFocusManagement) {
                    this.connect(this.editorWidget, "onStartEdit", lang.hitch(this, function () {
                        this.set("editing", true);
                    }));

                    this.connect(this.editorWidget, "onStopEdit", lang.hitch(this, function () {
                        this.tryToStopEditing(false);
                    }));

                    this.connect(this.editorWidget, "onSetInitialValue", lang.hitch(this, function () {
                        this._lastSavedValue = this._resetValue = lang.clone(this.getEditorValue());
                    }));
                } else {
                    this.connect(this.editorWidget, "onFocus", lang.hitch(this, function () {
                        this._tryToStartEditing(false);
                    }));

                    this.connect(this.editorWidget, "onBlur", lang.hitch(this, function () {
                        // In form widgets onBlur event is raised before the last value change got updated. Therefore, at this point, editor widget's value is not up to date.
                        // This small timeout is for waiting for that change event to finish
                        setTimeout(lang.hitch(this, function () {
                            this.tryToStopEditing(true);
                        }), 0);
                    }));
                }

                this.connect(this.editorWidget, "onDropping", lang.hitch(this, function () {
                    this._scrollIntoViewOnStartEdit = false;
                    this._tryToStartEditing(false);
                }));
            }
        },

        contentModelChanged: function (name, oldValue, value) {
            // Always uptate the editor
            this.set("value", value);
        },


        _tryToStartEditing: function (grabFocus) {
            if (this.editing) {
                return;
            }

            this._grabFocusOnStartEdit = grabFocus;
            this.startEdit();
            this._grabFocusOnStartEdit = true;
        },

        _onChange: function (val) {
            // When using set value attribute, change shouldn't be propagated
            if (this._preventChangeEvent) {
                return;
            }

            var savedState = this.editing;

            // When this change is inside a DnD operation and not in "editing" state.
            if (this.operation && this.operation.inProgress && !this.editing) {
                this.editing = true;
                this._lastSavedValue = this._resetValue = this.value;
            }

            if (this.editorWidget.manualFocusManagement) {
                if (this.editing && this.isValid()) {
                    this.save(val);
                }
            } else {
                this.inherited(arguments);
            }

            this.editing = savedState;
        },

        setEditorValue: function (val) {
            // summary:
            //		Set the [display] value of the edit widget
            // tags:
            //		override

            this.inherited(arguments);
            if (!val) {
                this.editorWidget.initialized = true;
            }
        },

        _setValueAttr: function (value) {
            // Make sure no change events is propagated when setting the value
            this._preventChangeEvent = true;
            this.inherited(arguments);
            this._preventChangeEvent = false;
        },

        startEdit: function () {
            // summary:
            //		Start editing.
            // tags:
            //		public

            var inheritedFunc = this.getInherited(arguments);
            if (this._grabFocusOnStartEdit) {
                var scrollEditorIntoView = function () {
                    focusUtil.focus(this.editorWidget.domNode);
                    this.editorWidget.focus();
                    this._scrollIntoViewOnStartEdit && this.editorWidget.domNode.scrollIntoView(true);
                    this._scrollIntoViewOnStartEdit = true;
                    inheritedFunc.apply(this);
                }.bind(this);

                // add small timeout here to wait tab is selected
                // also change to use native scrollIntoView instead of dojo window
                setTimeout(function () {
                    if (!this.editorWidget || !this.editorWidget.domNode) {
                        return;
                    }

                    scrollEditorIntoView();
                }.bind(this), 200);
                return;
            }

            inheritedFunc.apply(this);
        },

        stopEdit: function (implicitExit) {
            // summary:
            //		Stop editing.
            // tags:
            //		public

            this.set("value", this.getEditorValue());
            this.inherited(arguments);
        }
    });

});

},
'epi-cms/contentediting/_EditorWrapperBase':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/event",
    "dojo/keys",

    "dijit/_Widget",
    "dijit/form/_TextBoxMixin",	// selectInputText

    "epi/epi"
], function (
    declare,
    lang,
    event,
    keys,

    _Widget,
    _TextBoxMixin,
    epi
) {
    return declare([_Widget], {
        // summary:
        //		Base class for all editor wrappers.
        //
        // tags:
        //      public

        // wrapperType: [public] String
        //    Editor wrapper type name
        wrapperType: "",

        // editorWidgetType: [public] String
        //    Editor widget type
        editorWidgetType: null,

        // editorParams: [public] Null|Object
        //    Editor widget's parameters
        editorParams: null,

        // editing: Boolean
        editing: false,

        // disabled: Boolean
        disabled: false,

        // blockDisplayNode: DomNode
        //		The node for the editable block
        blockDisplayNode: null,

        // editorWidget: dijit/_Widget|Object
        //		The editor for the value
        editorWidget: null,

        // isModified: Bool
        //		Indicates if we have triggered any saves while we edited value
        isModified: false,

        // _resetValue: [private] String|Object
        //      The value when as a string we started to edit
        _resetValue: undefined,

        // _lastSavedValue: [private] Object
        //      The last saved value
        _lastSavedValue: undefined,

        // _createdEditor: [private] Bool
        //      Set to true if we created our editor and must destroy it
        _createdEditor: false,

        propertyName: "",
        propertyDisplayName: "",

        // overlayItem: Overlay item
        //      Property overlay layer
        overlayItem: null,

        // isOverlayDisabled: Boolean
        //      Flags that used to disable overlay (or not) when the editor wrapper is running.
        isOverlayDisabled: false,

        // isUndoDisabled: Boolean
        //      Flags that used to disable undo when the editor wrapper is running.
        isUndoDisabled: false,

        // hasInlineEditor: Boolean
        //      A value indicating if the wrapped editor is editing inline, i.e. On-Page-Editing.
        //      False by default.
        hasInlineEditor: false,

        // contentModel: dojo/Stateful
        //     The content model to observe changes
        contentModel: null,

        // closeOnViewportClick: bool
        //      Close editor when clicking on viewport
        closeOnViewportClick: true,

        // _compareOptions: epi.compareOptions
        //      Default flags when do comparison.
        _compareOptions: epi.compareOptions.treatFalsyAsEquals | epi.compareOptions.skipEmptyProperties | epi.compareOptions.ignoreMissingProperties,

        onStartEdit: function (sender, data) {
            // summary:
            //		Set this handler to be notified when editing is started.
            //
            // sender:
            //      The wrapper which triggered this event
            //
            // tags:
            //		callback
        },

        onValueChange: function (sender, value, oldValue) {
            // summary:
            //    Triggered when the an undo step is added.
            //
            // sender:
            //      The wrapper which triggered this event
            //
            // value: String|Object
            //      The value
            // oldValue: String|Object
            //      The old value
            //
            // tags:
            //      public callback
        },

        onCancel: function (sender) {
            // summary:
            //		Set this handler to be notified when editing is cancelled.
            //
            // sender:
            //      The wrapper which triggered this event
            //
            // tags:
            //		callback
        },

        onStopEdit: function (sender, value, oldValue) {
            // summary:
            //		Set this handler to be notified when editing is finished.
            // tags:
            //		callback
        },

        postCreate: function () {
            this.inherited(arguments);

            this._contentModelWatchHandle = this.contentModel.watch(this.propertyName, lang.hitch(this, "contentModelChanged"));
        },

        destroy: function () {
            this._contentModelWatchHandle.remove();

            if (this._createdEditor && this.editorWidget) {
                this.editorWidget.destroyRecursive();
            }

            if (this.editorWidget) {
                this.editorWidget.parent = null;
            }

            this.blockDisplayNode = this.overlayItem = this.editorWidget = null;

            this.inherited(arguments);
        },

        contentModelChanged: function (name, oldValue, value) {
            // Only set the value when we are editing
            if (!this.editing) {
                this.set("value", value);
            }
        },

        startEdit: function (additionParams) {
            !this.editing && this._startEdit(additionParams);
        },

        _startEdit: function (additionParams) {
            lang.mixin(this.editorParams, additionParams);

            // Implemented by sub class
            this.set("editing", true);

            // reset value
            this.set("isModified", false);

            // store old value
            var oldValue = this.getEditorValue();
            // just fallback to init value from params for the 1st time
            // start edit the property.
            if (this._lastSavedValue === undefined && this._resetValue === undefined &&
                (!epi.isEmpty(this.params.value) && epi.isEmpty(oldValue))
            ) {
                oldValue = this.params.value;
            }
            this._lastSavedValue = this._resetValue = lang.clone(oldValue);

            // Cause validation to ensure the widget shows the latest validation messages
            this.isValid();

            this.onStartEdit(this, this.editorParams);
        },

        _stopEdit: function (implicitExit) {
            // Implemented by sub class
            this.set("editing", false);
            this._removeEditingFeatures();

            this.onStopEdit(this, this.getEditorValue(), this._resetValue, implicitExit);
        },

        cancel: function () {
            // force reset of value

            if (this.isModified) {
                // If property is modified then do a final save with the reset value.
                this.save(this._resetValue);
            } else {
                // Else set the value in the wrapper to the reset value.
                this.set("value", this._resetValue);
            }

            this.set("editing", false);
            this._removeEditingFeatures();

            this.onCancel(this);
        },

        save: function (/*String|Object*/val) {
            // keep track that save has been done
            this.set("value", val);
            this.set("isModified", true);
            this.onValueChange(this, val, this._lastSavedValue);
            this._lastSavedValue = lang.clone(val);
        },

        hasBeenEdited: function () {
            return this.editing && !epi.areEqual(this.getEditorValue(), this._resetValue, this._compareOptions);
        },

        hasPendingChanges: function () {
            return this.editing && !epi.areEqual(this.getEditorValue(), this._lastSavedValue, this._compareOptions);
        },

        tryToStopEditing: function (implicitExit) {
            // summary:
            //		Try to stop editing, if the value has changed, editing is stopped
            //      otherwise editing is cancelled
            // tags:
            //		public

            if (this.editing && this.domNode) {
                if (this.isValid()) {
                    if (this.hasBeenEdited()) {
                        if (this.hasPendingChanges()) {
                            this.save(this.getEditorValue());
                        }
                        this._stopEdit(implicitExit);
                    } else {
                        this.cancel(implicitExit);
                    }
                } else {
                    this._onTryToStopWithInvalidValue();
                }
            }
        },

        _removeEditingFeatures: function () {
            // summary:
            //		This is should be implemented by sub class, it's purpose is to
            //      restore state as it was before editing was started.
            // tags:
            //		protected
        },

        _onTryToStopWithInvalidValue: function () {
            // summary:
            //      do nothing, implemented by sub class
            // tags:
            //		protected
            //

            this.set("editing", false);
            this._removeEditingFeatures();
        },

        _onEditorKeyPress: function (e) {
            // summary:
            //		Handler for keypress in editor.
            // description:
            //		For autoSave widgets, if Esc/Enter, call cancel/save.
            // tags:
            //		protected

            if (this.editing) {
                if (e.altKey || e.ctrlKey) {
                    return;
                }
                // If Enter/Esc pressed, treat as save/cancel.
                if (e.keyCode === keys.ESCAPE) {
                    event.stop(e);
                    this.cancel(); // sets editing=false which short-circuits _onBlur processing
                } else if (e.keyCode === keys.ENTER && e.target.tagName === "INPUT") {
                    event.stop(e);

                    // stop editing
                    this.tryToStopEditing(false);
                }

                // _onBlur will handle TAB automatically by allowing
                // the TAB to change focus before we mess with the DOM: #6227
                // Expounding by request:
                //	The current focus is on the edit widget input field.
                //	save() will hide and destroy this widget.
                //	We want the focus to jump from the currently hidden
                //	displayNode, but since it's hidden, it's impossible to
                //	unhide it, focus it, and then have the browser focus
                //	away from it to the next focusable element since each
                //	of these events is asynchronous and the focus-to-next-element
                //	is already queued.
                //	So we allow the browser time to unqueue the move-focus event
                //	before we do all the hide/show stuff.
            }
        },

        _onChange: function (val) {
            if (this.editing && this.isValid() && this.hasPendingChanges()) {
                this.save(val);
            }
        },

        getEditorWidget: function () {
            return this.editorWidget;
        },

        getEditorValue: function () {
            // summary:
            //		Return the [display] value of the edit widget
            var ew = this.editorWidget;

            if (ew) {
                return ew.get("value");
            }
            return null;
        },

        setEditorValue: function (val) {
            // summary:
            //		Set the [display] value of the edit widget
            var ew = this.editorWidget;

            // Don't set the value to the editor if we are currently in an
            // editing state. Since it is possible the value argument is
            // older than the value of the editor. This occurs due to the
            // fact that the onChange event is fired within a timeout.
            if (!this.editing && ew && !epi.areEqual(val, ew.get("value"))) {
                ew.set("value", val);
            }
        },

        _setValueAttr: function (value) {
            this.setEditorValue(value);

            // Get the value back as the editor will return it
            this._set("value", this.getEditorValue() || value);
        },

        _setBlockDisplayNodeAttr: function (node) {
            // Work-around permission denied in IE when the document containing the old reference has been unloaded.
            this.blockDisplayNode = null;
            this._set("blockDisplayNode", node);
        },

        isValid: function () {
            // summary:
            //		User overridable function returning a Boolean to indicate
            //		if the Save button should be enabled or not - usually due to invalid conditions
            // tags:
            //		extension
            return (
                this.editorWidget && this.editorWidget.isValid
                    ? this.editorWidget.isValid()
                    : true
            );
        },

        focus: function () {
            // summary:
            //		Focus the edit widget.
            // tags:
            //		protected

            this.editorWidget.focus();
            setTimeout(lang.hitch(this, function () {
                if (this.editorWidget.focusNode && this.editorWidget.focusNode.tagName === "INPUT") {
                    _TextBoxMixin.selectInputText(this.editorWidget.focusNode);
                }
            }), 0);
        }
    });
});

},
'epi-cms/contentediting/_ValidationMixin':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang"
],

function (
    array,
    declare,
    lang
) {

    return declare(null, {
        // summary:
        //      Handles validation stuffs
        // tags:
        //      public

        _watchHandles: null,

        constructor: function () {
            this._watchHandles = [];
        },

        destroy: function () {
            this._removeViewModelWatches();

            this.inherited(arguments);
        },

        _removeViewModelWatches: function () {
            // summary:
            //      Removes the view model watches
            // tags:
            //      internal, protected

            array.forEach(this._watchHandles, function (handle) {
                handle.remove();
            });
            this._watchHandles = [];
        },

        _addStateWatch: function (/*Object*/widget) {
            var propertyName = widget.get("name"),
                viewModel = this.viewModel;

            var update = function () {
                var state = widget.get("state");
                if (state !== "Error") {
                    viewModel.validator.clearPropertyErrors(propertyName, viewModel.validator.validationSource.client);
                } else if (state === "Error") {
                    var errorMessage = widget.get("message") || widget.getErrorMessage() || "";
                    viewModel.validator.setPropertyErrors(
                        propertyName, [{
                            severity: viewModel.validator.severity.error,
                            errorMessage: errorMessage
                        }],
                        viewModel.validator.validationSource.client
                    );
                }
            };

            this._watchHandles.push(widget.watch("state", update));
            this._watchHandles.push(widget.watch("message", update));
        }
    });
});

},
'epi-cms/contentediting/EditingBase':function(){
define([
    // Dojo
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/query",
    "dojo/topic",
    "dojo/when",

    // EPi Framework
    "epi/dependency",
    "epi/string",
    "epi/shell/DestroyableByKey",

    // EPi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/MutationObserver",
    "epi-cms/contentediting/_View",
    "epi-cms/contentediting/AutoSaveButton",
    "epi-cms/contentediting/MappingManager",
    "epi-cms/contentediting/RenderManager",
    "epi-cms/contentediting/UpdateController",
    "epi-cms/widget/overlay/overlayFactory",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting"
], function (
    // Dojo
    array,
    connect,
    declare,
    Deferred,
    lang,

    aspect,
    query,
    topic,
    when,

    // EPi Framework
    dependency,
    epiString,
    DestroyableByKey,

    // EPi CMS
    ApplicationSettings,
    MutationObserver,
    _View,
    AutoSaveButton,
    MappingManager,
    RenderManager,
    UpdateController,
    overlayFactory,

    // Resources
    res
) {
    return declare([_View, DestroyableByKey], {
        // tags:
        //      internal

        // toolbar: [epi.cms/contentediting/widget/EditToolbar]
        //      Edit toolbar instance.
        toolbar: null,

        // editorFactory: [epi-cms/contentediting/EditorFactory]
        //      Editor factory instance.
        editorFactory: null,

        // activePropertyOnStartup: [String]
        //      Property to be set as active when edit view has done setting up.
        activePropertyOnStartup: null,

        // createOverlays: [Boolean]
        //      Indicate that the overlays should be created.
        createOverlays: true,

        _renderManager: null,

        _mappingManager: null,

        _activeEditorWrapper: null,

        _autoSaveButton: null,

        _deferredReloadHandle: null,

        _eventHandlers: null,

        _isCreatingWrapper: null,

        // _mutationObserver: [private] epi-cms/contentediting/MutationObserver
        //      MutationObserver instance
        _mutationObserver: null,

        constructor: function () {
            this.defaultQueryParameters = {
                epieditmode: true
            };
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            this.editorFactory = this.editorFactory || dependency.resolve("epi.cms.contentediting.EditorFactory");

            this._mappingManager = new MappingManager();

            this._mutationObserver = new MutationObserver();
            this.own(this._mutationObserver.on("dom-updated", function () {
                this.emit("dom-updated");
            }.bind(this)));

            this._eventHandlers = [];
            this._hashWrapper = this._hashWrapper || dependency.resolve("epi.shell.HashWrapper");
        },

        postCreate: function () {
            this.inherited(arguments);

            this.subscribe("/epi/cms/action/disableundoredoactions", this._toggleUndoRedoActions);
        },

        destroy: function () {
            this._stopActiveEditorWrapper();

            if (this._renderManager) {
                this._renderManager.destroy();
            }

            if (this._autoSaveButton) {
                this._autoSaveButton.destroyRecursive();
            }

            this._mappingManager.clear();

            if (this.toolbar) {
                this.toolbar = null;
            }

            // Remove all overlay items that was added
            this.overlay.destroyDescendants();

            // Teardown mutation observers
            this._mutationObserver.teardown();

            this.inherited(arguments);
        },

        _setCommandEnabled: function (toolbarItemName, enabled) {
            if (this.toolbar) {
                this.toolbar.setItemProperty(toolbarItemName, "disabled", !enabled);
            }
        },

        onContentLinkSyncChange: function () {
            this.inherited(arguments);
            this._setButtonState();
        },

        onReloadRequired: function () {
            this.inherited(arguments);

            // clear and suspend render manager after the watch handlers finished
            setTimeout(function () {
                this._renderManager.suspend();
                this._renderManager.clear();
            }.bind(this), 0);
        },

        _setViewModelAttr: function (viewModel) {
            if (viewModel === this.viewModel) {
                return;
            }

            this.inherited(arguments);

            //Disconnect all event handlers
            this.destroyByKey("viewModel");

            //Listen to onSuspend and stop editing the property and reset active editor
            this.ownByKey("viewModel", connect.connect(this.viewModel, "onContentChange", this, this._stopActiveEditorWrapper));

            // Listen on onSetActiveProperty event so it can react when active property is about to set on ContentViewModel
            this.ownByKey("viewModel", connect.connect(this.viewModel, "onSetActiveProperty", this, this.onSetActiveProperty));

            // Listen to onPropertyReverted to handle property value rollback
            this.ownByKey("viewModel", connect.connect(this.viewModel, "onPropertyReverted", this, this._onPropertyReverted));

            this.ownByKey("viewModel", topic.subscribe("/dnd/start", function () {
                // this timeout lets the previous operation end before starting the new one
                setTimeout(this.beginOperation.bind(this), 0);
            }.bind(this.viewModel)));
            this.ownByKey("viewModel", topic.subscribe("/dnd/stop", lang.hitch(this, function () {
                // If we have an active editor do not end the operation
                if (this._activeEditorWrapper) {
                    return;
                }
                this.viewModel.endOperation();
            })));
        },

        _stopActiveEditorWrapper: function () {
            if (this._activeEditorWrapper != null && this._activeEditorWrapper.domNode) {
                when(this._activeEditorWrapper.tryToStopEditing(), lang.hitch(this, function () {
                    this._activeEditorWrapper = null;
                }));
            }
        },

        onSetActiveProperty: function (property) {
            // summary:
            //      Triggered when active property is set on the current content view model.
            // property: String
            //      The property name.
            // tags:
            //      public, callback
        },

        onPreviewReady: function (viewModel, doc, forceSetup, props) {
            // summary:
            //      Triggered when preview is ready.
            // viewModel: [epi.cms.contentediting.ContentViewModel]
            //      The content view model.
            // doc: [Document]
            //      The preview document.
            // forceSetup: [Boolean]
            //      Indicate that the preview ready along with significant model changes, therefore the editing stuff must be setup again.
            // tags:
            //      public, callback.
            if (!doc && !props) {
                return;
            }
            if (forceSetup || viewModel !== this.viewModel) {
                this.set("viewModel", viewModel);
                this.setupEditMode(doc, props);
            } else if (viewModel) {
                this.remapEditMode(doc, props);
            }
        },

        _setButtonState: function () {
            this._setCommandEnabled("reverttopublished", this.viewModel && !this.viewModel.contentData.isPendingPublish);
        },

        setupEditMode: function (doc, props) {
            // summary:
            //      Setup all necessary stuff for edit mode.
            // tags:
            //      protected

            this.viewModel.reload().then(
                lang.hitch(this, function () {
                    // reset
                    this._mappingManager.clear();
                    if (this._renderManager) {
                        this._renderManager.clear();
                    }
                    this._renderManager = new RenderManager();

                    // create toolbar
                    if (this.toolbar && !this._autoSaveButton) {
                        this._autoSaveButton = new AutoSaveButton({
                            button: this.toolbar._getWidget("autosave")
                        });
                        this.own(aspect.after(this._autoSaveButton, "onLayoutChanged", lang.hitch(this, function () {
                            this.mainLayoutContainer.layout();
                        })));
                    }

                    this._autoSaveButton.set("model", this.viewModel);

                    var updateUndoRedo = lang.hitch(this, function () {
                        this._toggleUndoRedoActions(this.viewModel.hasUndoSteps, this.viewModel.hasRedoSteps);
                    });

                    this.viewModel.resetNotifications();

                    // remove existing handles
                    this._destroyOverlay();

                    this.ownByKey("viewModel",
                        this.viewModel.watch("hasUndoSteps", updateUndoRedo),
                        this.viewModel.watch("hasRedoSteps", updateUndoRedo));

                    // Get initial values
                    updateUndoRedo();

                    this.onReadySetupEditMode(doc, props);

                    // Setup mutation observers
                    this._mutationObserver.setup(doc);

                    // Set the doc to null to avoid closure leakage
                    doc = null;

                    //reset Publish button
                    this._setButtonState();

                    this.onPrepareOverlayComplete();
                })
            );
        },

        remapEditMode: function (doc, props) {
            // summary:
            //      Re-configure edit mode after the preview context changed.
            // tags:
            //      protected

            this.viewModel.reload().then(lang.hitch(this, function () {
                this._renderManager.resume();

                // When loading blocks that required reload, wait for blocks rendered then remap update controller
                if (doc) {
                    setTimeout(lang.hitch(this, function () {
                        this._remapUpdateControllers(doc, props);
                        this.onPrepareOverlayComplete();
                        this._toggleUndoRedoActions(this.viewModel.hasUndoSteps, this.viewModel.hasRedoSteps);

                        this._autoSaveButton.set("model", this.viewModel);

                        // Setup mutation observers
                        this._mutationObserver.setup(doc);
                    }), 1);
                }
            }));
        },

        _destroyOverlay: function () {
            // summary:
            //      Destroy the handles owned by the overlay items and view model
            // tags:
            //      protected, internal

            this.destroyByKey("overlay");
        },

        onReadySetupEditMode: function (doc, props) {
            // summary:
            //    Edit mode is ready for setting up.
            //
            // description:
            //    Setup editable blocks. Override to do extra setup, for example: set up form editing.
            //
            // propertyMetadataMap: Object
            //    Property metadata hashmap.
            //
            // tags:
            //    protected

            this._createUpdateControllers(doc, props);
        },

        onSetupEditModeComplete: function () {
            // summary:
            //      Triggered when edit mode is successfully set up.
            // remark:
            //      Should be fired by concrete edit view when it finishes preparations.
            // tags:
            //      public, callback.

            // Try extract activeproperty from hash
            this.activePropertyOnStartup = this._hashWrapper.consume("activeproperty") || this.activePropertyOnStartup;
            // Set active property if exists.
            if (this.activePropertyOnStartup) {
                this.onSetActiveProperty(epiString.pascalToCamel(this.activePropertyOnStartup));
                this.activePropertyOnStartup = null;
            }
        },

        _getPropertyNodes: function (doc) {
            var allNodes = query("[data-epi-edit], [data-epi-property-name]", doc);
            // Write out all the combinations of nested nodes to avoid runtime calculations which would always give the same result.
            var nestedNodes = query("[data-epi-edit] [data-epi-edit], [data-epi-property-name] [data-epi-property-name], [data-epi-property-name] [data-epi-edit], [data-epi-edit] [data-epi-property-name]", doc);

            return array.filter(allNodes, function (node) {
                // return the nodes that are not nested
                return nestedNodes.indexOf(node) === -1;
            });
        },

        _getOverlayParameters: function (nodes, isExternal) {
            var result = [];

            array.forEach(nodes, function (node) {
                var dataset = node.dataset;
                var propertyNodeName = epiString.pascalToCamel(dataset.epiEdit || dataset.epiPropertyName);
                var propertyMetadata = this.viewModel.getPropertyMetaData(propertyNodeName);
                var useNullRenderer = isExternal || !!dataset.epiEdit;

                // Skip this property if we don't have metadata,
                // i.e. the template rendered a node we won't find in the model
                if (!propertyMetadata) {
                    return;
                }

                // readOnly property is not editable
                if (propertyMetadata.settings && propertyMetadata.settings.readOnly) {
                    return;
                }

                // Get the real property name from metadata, since the page property name may be the legacy name (e.g. pageName -> icontent_name)
                var propertyName = epiString.pascalToCamel(propertyMetadata.getName());

                var propertyDisplayName = dataset.epiPropertyDisplayName;
                if (propertyDisplayName) {
                    propertyMetadata = lang.delegate(propertyMetadata, { displayName: propertyDisplayName });
                }

                if (propertyMetadata != null && propertyMetadata.showForEdit) {
                    // Extract block information from the data attributes
                    // add to result array

                    var renderSettings = {
                        cacheResults: true,
                        rerenderOnCancel: false,
                        propertyRenderSettings: dataset.epiPropertyRendersettings || undefined
                    };
                    renderSettings = lang.mixin(renderSettings, propertyMetadata.additionalValues.renderSettings);

                    // Read custom renderer settings from the data attribute resolving any name aliases if needed,
                    // or use the metadata if the attribute is empty.
                    var rendererClass = useNullRenderer ? "none" : dataset.epiPropertyRender || propertyMetadata.customEditorSettings.rendererClass;
                    switch (rendererClass) {
                        case "partial":
                            rendererClass = "epi-cms/contentediting/PropertyRenderer";
                            break;
                        case "client":
                            rendererClass = "epi-cms/contentediting/ClientRenderer";
                            break;
                        case "none":
                        case "full":
                            rendererClass = "epi-cms/contentediting/NullRenderer";
                            break;
                    }

                    var editorParams = JSON.parse(dataset.epiPropertyEditorsettings || null);

                    var overlayParams = JSON.parse(dataset.epiPropertyOverlaysettings || null);

                    overlayParams = lang.mixin(overlayParams, propertyMetadata.overlaySettings);

                    // Disable custom OPE editor and wrapper type since we want to force floating editors.
                    if (dataset.epiEdit) {
                        propertyMetadata.customEditorSettings.uiType = null;
                        propertyMetadata.customEditorSettings.uiWrapper = null;
                    }

                    result.push({
                        node: node,
                        disabled: dataset.epiDisabled === "true",
                        useOverlay: dataset.epiUseoverlay === "true",
                        overlayZIndex: parseInt(dataset.epiOverlayZIndex, 10) || 0,
                        uniqueName: node.uniqueName,
                        elementPosition: node.elementPosition,
                        property: {
                            name: propertyName,
                            contentLink: this.viewModel.contentLink,
                            contentModel: this.viewModel.contentModel,
                            type: dataset.epiPropertyType,
                            wrapperType: isExternal || dataset.epiEdit ? "floating" : dataset.epiPropertyEdittype || null,
                            editorParams: editorParams,
                            overlayParams: overlayParams,
                            editorWidgetType: dataset.epiPropertyEditor,
                            renderSettings: renderSettings,
                            rendererClass: rendererClass,
                            metadata: propertyMetadata,
                            propertyNodeName: propertyNodeName
                        }
                    });
                }
            }, this);

            // sort editable nodes depending on z-index-hint
            result.sort(function (a, b) {
                // use reverse index, higher values later in array
                if (a.overlayZIndex < b.overlayZIndex) {
                    return -1;
                } else if (a.overlayZIndex > b.overlayZIndex) {
                    return 1;
                } else {
                    return 0;
                }
            });

            return result;
        },

        _getEditableNodes: function (doc) {
            // summary:
            //    Create the editable blocks and wire up events.
            //
            // tags:
            //    private

            // Cannot inspect document, assume that we have no editable node.
            if (!doc || !this.viewModel.canChangeContent()) {
                return [];
            }

            var nodes = this._getPropertyNodes(doc);
            // default is inline-editors, optimized for delivery, limitUI, will cause floating editors
            var isExternal = ApplicationSettings.limitUI;

            return this._getOverlayParameters(nodes, isExternal);
        },

        _getEditableNodesFromEpiProps: function (props) {
            // summary:
            //    Create the editable blocks and wire up events.
            //
            // tags:
            //    private

            // No properties exists, assume that we have no editable node.
            if (!props || !this.viewModel.canChangeContent()) {
                return [];
            }

            // default is inline-editors, optimized for delivery, limitUI, will cause floating editors
            var isExternal = ApplicationSettings.limitUI;

            return this._getOverlayParameters(props, isExternal);
        },

        _createUpdateControllers: function (doc, props) {
            // summary:
            //    Create the editable blocks and wire up events.
            //
            // doc: Document
            //    Document where to get editable blocks.
            //
            // tags:
            //    private

            //Create a full page update controller
            var fullpageUpdateController = this._createFullPageUpdateController(doc);
            if (fullpageUpdateController) {
                this._connectFullPageUpdateControllerEvents(fullpageUpdateController);
                this._mappingManager.add({
                    updateController: fullpageUpdateController
                });
            }

            //Create update controllers for nodes
            var editableNodes = null;
            if (doc) {
                editableNodes = this._getEditableNodes(doc);
            } else if (props) {
                editableNodes = this._getEditableNodesFromEpiProps(props);
            }
            array.forEach(editableNodes, function (editableNode) {
                var property = editableNode.property;
                var nodeHTML = editableNode.node.innerHTML;
                var updateController = this._createNodeUpdateController(editableNode);

                when(this._createNodeOverlay(editableNode), lang.hitch(this, function (overlayItem) {
                    if (overlayItem) {
                        overlayItem.uniqueName = editableNode.uniqueName;
                    }

                    this._connectUpdateControllerAndOverlayEvents(updateController, overlayItem);
                    // create mapping
                    this._mappingManager.add({
                        blockPropertyInfo: property,
                        node: editableNode.node,
                        updateController: updateController,
                        overlayItem: overlayItem
                    });
                }));

                //Cache the block's initial rendering.
                this._renderManager.cacheRender(property.name, property.renderSettings, this.viewModel.getProperty(property.name), nodeHTML);
            }, this);
        },

        _createNodeOverlay: function (editableNode) {
            // summary:
            //      Change to use dojo/Deferred because of overlayFactory now use this way
            var deferred = new Deferred();

            // Don't create overlay
            if (!this.createOverlays) {
                deferred.resolve(null);
                return deferred;
            }

            when(overlayFactory.create(editableNode), lang.hitch(this, function (overlayItem) {
                this.overlay.addChild(overlayItem);
                if (ApplicationSettings.limitUI === true) {
                    overlayItem.updatePosition(editableNode.elementPosition);
                }
                deferred.resolve(overlayItem);
            }));

            return deferred;
        },

        _createNodeUpdateController: function (editableNode) {
            var property = editableNode.property;
            var metadata = property.metadata;

            // Create block
            var updateController = new UpdateController({
                displayName: metadata.displayName,
                renderManager: this._renderManager,
                contentModel: property.contentModel,
                contentLink: property.contentLink,
                modelPropertyName: property.name,
                nodePropertyName: property.propertyNodeName,
                renderSettings: property.renderSettings,
                rendererClass: property.rendererClass,
                displayNode: editableNode.node
            });

            return updateController;
        },

        _createFullPageUpdateController: function (doc) {
            var fullreloadProperties = [];

            // Get full page reload properties from template
            if (doc) {
                var metaTags = query("input[data-epi-full-refresh-property-names][type='hidden']", doc);
                array.forEach(metaTags, function (tag) {
                    array.forEach(tag.dataset.epiFullRefreshPropertyNames.split(","), function (propertyName) {
                        if (!array.some(fullreloadProperties, function (p) {
                            return p === propertyName;
                        })) {
                            fullreloadProperties.push(epiString.pascalToCamel(propertyName));
                        }
                    });
                });
            }

            // Get full page reload properties from metadata
            array.forEach(this.viewModel.metadata.properties, function (property) {
                if (property.additionalValues["reloadOnChange"] === true) {
                    fullreloadProperties.push(epiString.pascalToCamel(property.name));
                }
            });

            if (!fullreloadProperties.length) {
                return null;
            }
            //create a full page update controller
            var pageUpdateController = new UpdateController({
                displayName: "",
                renderManager: this._renderManager,
                contentModel: this.viewModel.contentModel,
                modelPropertyName: fullreloadProperties,
                renderSettings: { isFullReload: true }
            });

            return pageUpdateController;
        },

        _remapUpdateControllers: function (doc, props) {
            var editableNodes = this._getEditableNodes(doc);

            // Remap update controller that connected to old nodes. Also remove the old fullpage update controller
            var unmappedNodes = this._mappingManager.remap(editableNodes);

            //Create new update controllers for nodes that was newly added
            array.forEach(unmappedNodes, function (editableNode) {
                var property = editableNode.property;
                var updateController = this._createNodeUpdateController(editableNode);

                when(this._createNodeOverlay(editableNode), lang.hitch(this, function (overlayItem) {
                    this._connectUpdateControllerAndOverlayEvents(updateController, overlayItem);
                    this._mappingManager.add({
                        blockPropertyInfo: property,
                        node: editableNode.node,
                        updateController: updateController,
                        overlayItem: overlayItem
                    });
                }));

                //Cache the block's initial rendering.
                this._renderManager.cacheRender(property.name, property.renderSettings, this.viewModel.getProperty(property.name), editableNode.node.innerHTML);
            }, this);

            // Recreate new fullpage update controller
            var fullpageUpdateController = this._createFullPageUpdateController(doc);
            if (fullpageUpdateController) {
                this._connectFullPageUpdateControllerEvents(fullpageUpdateController);
                this._mappingManager.add({
                    updateController: fullpageUpdateController
                });
            }
        },

        _connectUpdateControllerAndOverlayEvents: function (updateController, overlayItem) {
            if (updateController) {
                this.ownByKey("overlay",
                    aspect.after(updateController, "onReloadRequired", lang.hitch(this, this._onBlockReloadRequired), true),
                    aspect.after(updateController, "onRender", lang.hitch(this, this._onBlockRender), true));
            }
            if (overlayItem) {
                this.ownByKey("overlay",
                    aspect.after(overlayItem, "onClick", lang.hitch(this, this._onOverlayItemClick), true),
                    aspect.after(overlayItem, "onValueChange", lang.hitch(this, function (value) {
                        this._onOverlayValueChange(overlayItem, value);
                    }), true));
            }
        },

        _connectFullPageUpdateControllerEvents: function (fullpageUpdateController) {
            this.destroyByKey("fullpageoverlay");

            this.ownByKey("fullpageoverlay",
                aspect.after(fullpageUpdateController, "onReloadRequired", this._onBlockReloadRequired.bind(this), true),
                aspect.after(fullpageUpdateController, "onRender", this._onBlockRender.bind(this), true));
        },

        _getEditor: function (/*Object*/overlayItem) {
            // summary:
            //      Get wrapper editor
            // overlayItem:
            //      Current overlay item that accepting drop
            // tags:
            //      private

            var mapping = this._mappingManager.findOne("overlayItem", overlayItem);

            return (mapping && mapping.wrapper && mapping.wrapper.editorWidget) ? mapping.wrapper.editorWidget : null;
        },

        onEditorWrapperCreated: function (/*Object*/editorWrapper) {
            // summary:
            //      Triggered when the active editor wrapper created.
            //
            // editorWrapper:
            //      The created editor wrapper
            //
            // tags:
            //    public, callback
        },

        _onOverlayItemClick: function (overlayItem) {
            // Do not continue if a wrapper is already being created
            if (this._isCreatingWrapper) {
                return;
            }
            this._isCreatingWrapper = true;

            var mapping = this._mappingManager.findOne("overlayItem", overlayItem);

            var property = mapping.blockPropertyInfo;
            var val = this.viewModel.getProperty(mapping.propertyName);

            var value = lang.clone(val, true);

            var wrapper;

            var wrapperCreated = lang.hitch(this, function (wrapper) {
                // store wrapper if we want to reuse it
                mapping.wrapper = wrapper;
                this._activeEditorWrapper = wrapper;

                topic.publish("/epi/layout/pinnable/propertyEditor/show", null);

                // TODO: force a save for legacy properties? or close open currentWrapper
                // if saving: use deferred to not open this wrapper until save is done

                array.forEach(this._mappingManager.find(), function (m) {
                    if (m.overlayItem) {
                        m.overlayItem.set("active", false);
                    }
                });

                mapping.overlayItem.set("active", true);

                // start editing
                var editorParams = { value: value, parent: wrapper };
                when(wrapper.startEdit(editorParams)).always(lang.hitch(this, function () {
                    this._isCreatingWrapper = null;
                }));

                this.overlay.set("readOnly", wrapper.isOverlayDisabled);
                this.viewModel.set("disableUndo", wrapper.isUndoDisabled);
            });

            if (mapping.wrapper) {
                wrapper = mapping.wrapper;
                if (wrapper && wrapper.editorWidget && !wrapper.editorWidget.overlayItem) {
                    wrapper.editorWidget.overlayItem = overlayItem;
                }
                wrapper.set("blockDisplayNode", mapping.node);

                wrapperCreated(wrapper);
            } else {
                // create new wrapper
                when(this._createEditorWrapper(property, overlayItem, mapping.node, value), lang.hitch(this, function (wrapper) {
                    wrapperCreated(wrapper);
                    this.onEditorWrapperCreated(wrapper);
                }));
            }
        },

        _createEditorWrapper: function (property, overlayItem, node, value) {
            // summary:
            //		Create editor wrapper for property in template.
            // description:
            //      By default, editor wrappers are created using EditorFactory. Override to implement custom creation, for example: FormEditing creates FormEditorWrapper all the times
            // tags:
            //		protected
            var def = new Deferred(),
                options = { overlayItem: overlayItem };

            when(this.editorFactory.createEditor(property, node, value, options), lang.hitch(this, function (wrapper) {
                this.ownByKey("overlay",
                    aspect.after(wrapper, "onValueChange", lang.hitch(this, this._onWrapperValueChange), true),
                    aspect.after(wrapper, "onCancel", lang.hitch(this, this._onWrapperCancel), true),
                    aspect.after(wrapper, "onStopEdit", lang.hitch(this, this._onWrapperStopEdit), true));

                def.resolve(wrapper);
            }), def.reject);

            return def;
        },

        _onBlockReloadRequired: function (updateController) {

            var reload = function () {
                // If currently editing inline, don't reload
                if (this._activeEditorWrapper && this._activeEditorWrapper.hasInlineEditor) {
                    return;
                }
                if (this._deferredReloadHandle) {
                    this._deferredReloadHandle.remove();
                    this._deferredReloadHandle = null;
                }

                this._toggleUndoRedoActions(false, false);
                this.onReloadRequired();
            }.bind(this);

            if (this.viewModel.isSaved) {
                reload();
            } else {
                if (!this._deferredReloadHandle) {
                    this.own(this._deferredReloadHandle = aspect.after(this.viewModel, "onPropertySaved", reload, true));
                }
            }
        },

        _onBlockRender: function (updateController) {
            var mapping = this._mappingManager.findOne("updateController", updateController);

            if (mapping && mapping.overlayItem) {
                mapping.overlayItem.refresh();
            }
        },

        _saveEditorChanges: function (/*Object*/overlayItem, /*Object*/data) {
            // summary:
            //      Update active editor widget value
            // overlayItem:
            //      Current overlay item that accepting drop
            // data:
            //      Array of objects
            // tags:
            //      private

            var editor = this._getEditor(overlayItem);
            if (editor && !editor.overlayItem) {
                editor.overlayItem = overlayItem;
            }
            if (editor && editor.saveChanges) {
                editor.saveChanges(editor, data);
            }
        },

        _onOverlayValueChange: function (overlayItem, data) {
            // summary:
            //      Handler for single or multiple property changes
            // overlayItem: Object
            //      Current overlay item that accepting drop
            // data: Object || Array
            //      The properties to change n format {propertyName: "myName", value: propertyValue}
            // tags:
            //      Private

            this._saveEditorChanges(overlayItem, data.value);

            this.viewModel.setProperty(data.propertyName, data.value);
        },

        _onWrapperValueChange: function (wrapper, value, oldValue) {
            var mapping = this._mappingManager.findOne("wrapper", wrapper),
                propertyName = mapping.propertyName;
            // If this change from dnd then it will saved when "/dnd/stop"

            if (mapping.overlayItem) {
                mapping.overlayItem.set("updated", true);
            }

            // Begin an operation if not already started
            this.viewModel.beginOperation();

            // Save the property
            this.viewModel.setProperty(propertyName, value, oldValue);
        },

        _onWrapperStopEdit: function (wrapper, value, oldValue, implicitExit) {
            var mapping = this._mappingManager.findOne("wrapper", wrapper);

            // End the ongoing operation, commit the value
            this.viewModel.endOperation();

            if (mapping && mapping.overlayItem) {
                mapping.overlayItem.set("active", false);
            }

            this._activeEditorWrapper = null;
            this.overlay.set("readOnly", false);
            this.viewModel.set("disableUndo", false);
        },

        _onWrapperCancel: function (wrapper, implicitExit) {

            var mapping = this._mappingManager.findOne("wrapper", wrapper),
                updateController = mapping.updateController;

            // Abort the current operation
            this.viewModel.abortOperation();

            // force re-render on block if it has rerenderOnCancel
            if (updateController && updateController.renderSettings && updateController.renderSettings.rerenderOnCancel) {
                updateController.render();
            }

            if (mapping && mapping.overlayItem) {
                mapping.overlayItem.set("active", false);
            }

            this._activeEditorWrapper = null;
            this.overlay.set("readOnly", false);
            this.viewModel.set("disableUndo", false);
        },

        _onPropertyReverted: function (propertyName, oldValue) {
            this._mappingManager.find("propertyName", propertyName).forEach(function (mapping) {
                var wrapper = mapping && mapping.wrapper,
                    editing;

                if (wrapper) {
                    editing = wrapper.get("editing");
                    wrapper.set("editing", false);
                    wrapper.set("value", oldValue);
                    wrapper.set("editing", editing);
                }
            });
        },

        _toggleUndoRedoActions: function (hasUndoSteps, hasRedoSteps) {
            // summary:
            //   Disable Undo & Redo actions when selecting Schedule for Publish or Ready to Publish
            //
            // tags:
            //    private

            this._setCommandEnabled("undo", !!hasUndoSteps);
            this._setCommandEnabled("redo", !!hasRedoSteps);
        }
    });
});

},
'epi-cms/contentediting/MutationObserver':function(){
define([
    "dojo/_base/declare",
    "dojo/Evented"
], function (
    declare,
    Evented
) {
    return declare([Evented], {
        // summary:
        //      Sets up mutation observers on data-epi-edit and data-epi-property-name attribute to react on changes in the DOM
        // tags:
        //      internal

        // _mutationObserverHandle: [private] Object
        //      Mutation observer handle
        _mutationObserverHandle: null,

        setup: function (doc) {
            // summary:
            //      Sets up observers to react on changes in the dom and publishes dom-updated event.
            //      Disconnects all the observers on teardown.
            // tags:
            //      public

            this.teardown();

            // Early exit in case the document is not available.
            if (!doc) {
                return;
            }

            // We listen to the root document DOM for:
            // * New DOM nodes: see if they have the OPE edit property
            // * Existing DOM nodes: observe changes to see if OPE edit property is added or removed
            var observer = new MutationObserver(function (mutations) {
                mutations.forEach(function (mutation) {
                    // Check mutation on existing DOM elements
                    // Only publish event if the mutation is an attribute, with the name "data-epi-edit" or "data-epi-property-name"
                    if (mutation.type === "attributes" && (mutation.attributeName === "data-epi-edit" || mutation.attributeName === "data-epi-property-name")) {
                        this._publishEvent();

                    // Check mutation on new DOM elements
                    } else if (mutation.type === "childList") {
                        Array.prototype.slice.call(mutation.addedNodes).forEach(function (addedNode) {
                            var epiPropertyNodes = this._getEpiPropertyNodes(addedNode);
                            // If none of the added child nodes is related with episerver we don't
                            // need to emit a dom-updated event
                            if (epiPropertyNodes.length === 0) {
                                return;
                            }

                            this._publishEvent();
                        }, this);
                    }
                }.bind(this));
            }.bind(this));

            // Setting subtree to true allows us to monitor the entire tree
            // with just one observer since we're watching all nodes
            observer.observe(doc, {
                attributes: true,
                childList: true,
                subtree: true
            });
            this._mutationObserverHandle = observer;
        },
        teardown: function () {
            if (this._mutationObserverHandle !== null) {
                this._mutationObserverHandle.disconnect();
            }
            this._mutationObserverHandle = null;
        },
        _getEpiPropertyNodes: function (target) {
            // If it is not a node type or document type make an early exit
            // this filters #text and #comments nodes for example and much more
            // https://developer.mozilla.org/en-US/docs/Web/API/Node/nodeType
            if (target.nodeType !== Node.ELEMENT_NODE && target.nodeType !== Node.DOCUMENT_NODE) {
                return [];
            }

            // Return an array of elements with the "data-epi-edit" or "data-epi-property-name" attribute.
            if (target.attributes && (target.attributes["data-epi-edit"] || target.attributes["data-epi-property-name"])) {
                return [target];
            } else {
                var result = target.querySelectorAll("[data-epi-edit], [data-epi-property-name]");
                return Array.prototype.slice.call(result);
            }
        },
        _publishEvent: function () {
            this.emit("dom-updated");
        }
    });
});

},
'epi-cms/contentediting/_View':function(){
﻿define([
    "dojo/_base/declare",
    "dijit/_Widget"
],

function (declare, _Widget) {

    return declare([_Widget], {
        // tags:
        //      internal

        // iframeWithOverlay: [protected] epi/shell/widget/IframeWithOverlay
        //      The IframeWithOverlay widget
        iframeWithOverlay: null,

        overlay: null,

        // iFrame: [protected] epi/shell/widget/Iframe
        //      The iframe widget
        iFrame: null,

        // layoutContainer: [protected] Object
        //      The layout container
        layoutContainer: null,

        // contextTypeName: String
        //      Type name for the context we can handle
        contextTypeName: null,

        // viewModel: [protected] Object
        //      The content view model.
        viewModel: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            if (this.iframeWithOverlay) {
                this.iFrame = this.iframeWithOverlay.iframe;
                this.overlay = this.iframeWithOverlay.overlay;
            }

            this._viewConnections = [];
        },

        _setViewModelAttr: function (viewModel) {
            this._set("viewModel", viewModel);
        },

        _setIframeWithOverlayAttr: function (value) {
            this._set("iframeWithOverlay", value);
            this.iFrame = this.iframeWithOverlay.iframe;
            this.overlay = this.iframeWithOverlay.overlay;
        },

        onPreviewReady: function (viewModel, doc) {
            // summary:
            //  Event raised when a new document is loading in the inner iframe.
            //  Override or connect to to handle the situation when the preview is loaded.
            // remark:
            //  The corresponding context is succesfully loaded and ready to use.
            //  Be very carefull when call inherited on this method.
            //  Because it has nothing to setup, overlay ready event is raised immediately which is not true in other view.
            //
            // url: string
            //  url of the frame source
            // tags: callback public

            this.set("viewModel", viewModel);
            this.onPrepareOverlayComplete();
        },

        onPrepareOverlayComplete: function () {
            // summary:
            //    Overlay preparation is complete
            //
            // tags:
            //    callback
        },

        onContentLinkSyncChange: function (oldContentLink, newContentLink) {
            // summary:
            //  Called when the current content link changed. For example: edit a published common draft.
            //
            // oldContentLink: String
            //  The content link before the update
            //
            // newContentLink: String
            //  The updated content link
            //
            // tags: callback public
        },

        onReloadRequired: function () {
            // summary:
            //  Event raised when the view require to be reloaded.
            //
            // tags: callback public
        }
    });
});

},
'epi-cms/contentediting/AutoSaveButton':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/string",
    "dijit/_WidgetBase",
    "epi/datetime",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.autosave"
], function (
    array,
    connect,
    declare,
    lang,
    domClass,
    domStyle,
    string,
    _WidgetBase,
    epiDate,
    res) {

    var ButtonStates = { Saving: 0, Offline: 1, Saved: 2 };

    return declare([_WidgetBase], {
        // tags:
        //      internal


        _state: null,

        button: undefined,

        lastSaved: undefined,

        model: null,

        _currentlySavingClass: "epi-autosave-saving",
        _errorClass: "epi-autosave-error",
        _savedClass: "epi-autosave-saved",
        _hoverClass: "epi-autosave-hover",

        _modelHandles: null,
        _updateTimeHandle: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._modelHandles = [];
        },

        postCreate: function () {
            this.inherited(arguments);

            if (!this.button) {
                return;
            }

            this.connect(this.button.domNode, "onmouseover", this._addHoverClass);
            this.connect(this.button.domNode, "onmouseout", this._removeHoverClass);
        },

        destroy: function () {
            // disconnect existing observers and events
            array.forEach(this._modelHandles, function (handle) {
                handle.unwatch();
            });

            this._updateTimeHandle && clearTimeout(this._updateTimeHandle);
            this._updateTimeHandle = null;

            this.inherited(arguments);
        },

        _setModelAttr: function (model) {

            // disconnect existing observers and events
            array.forEach(this._modelHandles, function (handle) {
                handle.unwatch();
            });

            this._set("model", model);

            // connect events
            if (model) {
                this._modelHandles = [
                    model.watch("isOnline", lang.hitch(this, "_isOnlineChanged")),
                    model.watch("lastSaved", lang.hitch(this, "_lastSavedChanged")),
                    model.watch("isSaved", lang.hitch(this, "_isSavedChanged")),
                    model.watch("isSaving", lang.hitch(this, "_isSavingChanged")),
                    model.watch("hasErrors", lang.hitch(this, "_hasErrorsChanged")),
                    model.watch("disableUndo", lang.hitch(this, this._disableUndo))
                ];

                this.set("lastSaved", model.lastSaved);

                if (this.lastSaved) {
                    this.updateButton();
                } else {
                    this._setVisibility(false);
                }
            }

        },

        _setLastSavedAttr: function (lastSaved) {
            this._set("lastSaved", lastSaved);
            this.updateLastSaveTime();
        },

        _disableUndo: function (propertyName, oldValue, value) {
            this._isUndoDisabled = value;

            // Update the button status
            this.updateButton();
        },

        _isOnlineChanged: function (name, oldVal, newVal) {

            if (newVal === oldVal) {
                return;
            }

            if (newVal) {
                this.revertToLastAutoSaveTime();
            } else {
                this.showOfflineStatus();
            }
        },

        _lastSavedChanged: function (name, oldVal, newVal) {
            this.set("lastSaved", newVal);
        },

        _isSavedChanged: function (name, wasSaved, isSaved) {
            if (isSaved) {
                this.updateLastSaveTime();
            }
        },

        _isSavingChanged: function (name, wasSaving, isSaving) {

            if (isSaving) {
                this.showSavingStatus();
            } else {
                if (!this.model.isSaved) {
                    this.revertToLastAutoSaveTime();
                }
            }
        },

        _hasErrorsChanged: function (name, valueBefore, valueNow) {
            if (valueBefore === valueNow) {
                return;
            }

            if (!valueNow) {
                this.revertToLastAutoSaveTime();
            } else {
                // publish event to show error on NotificationStatusBar
                connect.publish("/epi/cms/action/showerror");
            }
        },

        _animateSaving: function () {
            domClass.replace(this.button.domNode, this._currentlySavingClass, [this._errorClass, this._savedClass]);
            this._removeHoverClass();
        },

        _animateOffline: function () {
            domClass.replace(this.button.domNode, this._errorClass, [this._currentlySavingClass, this._savedClass]);
            this._removeHoverClass();
        },

        _animateSaved: function () {
            domClass.replace(this.button.domNode, this._savedClass, [this._currentlySavingClass, this._errorClass]);
            this._removeHoverClass();
        },

        _addHoverClass: function () {
            // summary:
            //    Show border and background for the widget
            // tags:
            //    private

            if (this._state == null || this._state === ButtonStates.Saving || this._hasDropDownOpen()) {
                return;
            }
            if (this._state === ButtonStates.Saved) {
                domClass.add(this.button.domNode, this._hoverClass);
            }

        },

        _removeHoverClass: function () {
            // summary:
            //    Hide border and background for widget
            // tags:
            //    private

            if (!this._hasDropDownOpen()) {
                domClass.remove(this.button.domNode, this._hoverClass);
            }
        },

        _updateState: function (text) {
            // summary:
            //      - Change label of button
            //      - Set disabled or not for button
            // tages:
            //      private

            this.button.set("label", text);
            this.button.set("disabled", this._isUndoDisabled || this._state !== ButtonStates.Saved);
        },

        _setVisibility: function (/* Boolean */value) {
            // summary:
            //    Sets the visibility
            // tags:
            //    private

            if (value !== this._visible) {
                this._visible = value;

                if (this.button) {
                    domStyle.set(this.button.domNode, { display: value ? "" : "none" });
                    this.button.set("itemVisibility", value && !this.button.disabled);
                    if (this.button.isInNarrowToolbar) {
                        this.onLayoutChanged();
                    }
                }
            }
        },

        onLayoutChanged: function () {
            // summary:
            //      Notify layout change when the button is toggled on or off.
            // tags:
            //      public, callback
        },

        _hasDropDownOpen: function () {
            // summary:
            //      - Check button items are expanded or not
            // tags:
            //      private

            return this.button._popupStateNode ? domClass.contains(this.button._popupStateNode, "dijitHasDropDownOpen") : false;
        },

        revertToLastAutoSaveTime: function () {
            // summary:
            //      show time of the last successful saving or blank if there wasn't one

            if (this.lastSaved === undefined) {
                this._setVisibility(false);
                return;
            }

            this.updateLastSaveTime();
        },

        updateLastSaveTime: function () {
            // summary:
            //      Update the last auto save time

            if (!this.lastSaved) {
                return;
            }

            if (!this.model.isOnline) {
                return;
            }

            this._updateTimeHandle && clearTimeout(this._updateTimeHandle);

            // Only change the time of last save when saving successful
            this._updateTimeHandle = setTimeout(lang.hitch(this, function () {
                if (this.model.isOnline) {
                    this.updateButton();
                    this._animateSaved();
                }
            }), 1000);

            this._setVisibility(true);
        },

        showSavingStatus: function () {
            // summary:
            //  Show saving status

            this._setVisibility(true);
            this._state = ButtonStates.Saving;
            this._updateState(res.savinglabel);
            this._animateSaving();
        },

        showOfflineStatus: function () {
            // summary:
            //      show offline message when cannot save to server

            this._state = ButtonStates.Offline;
            this._updateState(res.offlinelabel);
            this._animateOffline();
        },

        updateButton: function () {
            // If there is no lastSaved, e.g. user's already published the content but due to annimation
            // this method in invoked after the content has been reloaded, autosave button should be hidden.
            // In case the content has been moved to trash, autosave button should be hidden, too.
            // Also hide the autosave button when the can not be edited, i.e. read-only.
            if (!this.lastSaved || !this.model.canChangeContent() || (this.model.contentData && this.model.contentData.isDeleted)) {
                this._setVisibility(false);
                return;
            }

            if (this.model.isSaving) {
                this._state = ButtonStates.Saving;
                return;
            }

            this._state = ButtonStates.Saved;
            var template = "<span class=\"dijitReset dijitInline clearfix\">${autosavelabel} ${timestamp}</span>&nbsp;<span class=\"epi-inlineButtonLink\">${undolabel}</span>";
            var replaceMap = {
                autosavelabel: res.autosavelabel,
                undolabel: this.model.undoManager.get("hasUndoSteps") && !this._isUndoDisabled ? res.undolabel : "", //if undo is disabled hide the "Undo" text
                timestamp: epiDate.toUserFriendlyHtml(this.lastSaved, null, true)
            };
            this._updateState(string.substitute(template, replaceMap));
        }
    });
});

},
'epi-cms/contentediting/MappingManager':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/_base/connect",
    "dojo/dom-attr",
    "dojox/encoding/digests/SHA1"],

function (declare, lang, array, json, connect, domAttr, SHA1) {

    return declare(null, {
        // summary:
        //		Keeps track of relationship among editable blocks, overlay items, property info, and edit wrappers.
        //
        // tags:
        //      internal

        _mappings: null,

        domUtils: null,

        attrNames: [
            "data-epi-edit",
            "data-epi-property-name",
            "data-epi-property-display-names",
            "data-epi-property-customsettings-customtag",
            "data-epi-disabled",
            "data-epi-useoverlay",
            "data-epi-overlay-z-index",
            "data-epi-property-type",
            "data-epi-property-edittype",
            "data-epi-property-editorsetting",
            "data-epi-property-editor",
            "data-epi-property-render"],

        constructor: function () {
            // summary:
            //      Constructor.
            //
            // tags:
            //		public

            this._mappings = [];
            this.domUtils = domAttr;
        },

        clear: function () {
            // summary:
            //      Destroy all items in mappings.
            //
            // tags:
            //		public

            var mapping;

            try {
                while ((mapping = this._mappings.pop())) {
                    this._clearMapping(mapping);
                }
            } catch (ex) {
                console.error(ex);
            }
        },

        clearMappings: function (mappings) {
            // summary:
            //      Destroy all the given mappings.
            //
            // tags:
            //		public

            mappings.forEach(function (mapping) {
                try {
                    this._clearMapping(mapping);
                    this._mappings.splice(this._mappings.indexOf(mapping), 1);
                } catch (ex) {
                    console.error(ex);
                }
            }, this);
        },

        _calculateNodeHash: function (node) {
            // summary:
            //		Calculate hash value for a dom node based on data-epi attributes.
            //
            // node: DomNode
            //      The dom node
            //
            // return: SHA1 hash string.
            //
            // tags:
            //		private

            if (!node) {
                return "";
            }
            var attrs = array.map(this.attrNames, lang.hitch(this, function (n) {
                return this.domUtils.get(node, n) || "";
            }));

            return SHA1(json.toJson(attrs));
        },

        add: function (item) {
            // summary:
            //      Add a mapping item.
            //
            // item: Object
            //      The mapping item.
            //
            // tags:
            //		public

            if (item.node) {
                item.nodeHash = this._calculateNodeHash(item.node);
            }
            if (item.blockPropertyInfo && !item.propertyName) {
                item.propertyName = item.blockPropertyInfo.name;
            }

            this._mappings.push(item);
        },

        _tryRemapNode: function (item, editableNode) {
            // summary:
            //      Try to remap an editable node to a mapping item.
            //
            // item: Object
            //      The mapping item.
            //
            // editableNode: Object
            //      The editable node info object.
            //
            // bodyNode: DomNode
            //      Reference to the page's body.
            //
            // returns: Object
            //      | success: true or false.
            //      | mappedNode: the node that is successfully mapped.
            //
            // tags:
            //		private

            if (this._calculateNodeHash(editableNode.node) === item.nodeHash) {
                item.node = editableNode.node;
                item.updateController.displayNode = editableNode.node;
                item.updateController.checkEmptyHtml();
                if (item.overlayItem) {
                    // reset the disabled flag, it's set to false when using iframe for preview
                    item.overlayItem.set("disabled", false);
                    item.overlayItem.set("sourceItemNode", editableNode.node);
                    item.overlayItem.refresh();
                }

                return {
                    success: true,
                    mappedNode: editableNode
                };
            }

            return {
                success: false
            };
        },

        remap: function (editableNodes) {
            // summary:
            //      Remap a list of editable nodes to the mapping items.
            //
            // editableNodes: Array
            //      The mapping item list.
            //
            // returns: Array
            //      List of unmapped node.
            //
            // tags:
            //		private

            var unusedMappingItems = [];

            var unmappedNodes = (editableNodes !=  null ? editableNodes.slice(0) : []);

            //Try remap the old editable blocks, and delete the blocks which are not found on the page anymore
            array.forEach(this._mappings, lang.hitch(this, function (item) {
                if (!item.updateController) {
                    return;
                }

                var mappedNode = null;
                var haveMapped = array.some(unmappedNodes, lang.hitch(this, function (editableNode) {
                    var result = this._tryRemapNode(item, editableNode);
                    mappedNode = mappedNode || result.mappedNode;
                    return result.success;
                }));

                if (haveMapped) {
                    if (mappedNode) {
                        unmappedNodes.splice(array.indexOf(unmappedNodes, mappedNode), 1);
                    }
                } else {
                    this._clearMapping(item);
                    delete item.node;
                    unusedMappingItems.push(item);
                }

                if (item.wrapper && item.node) {
                    item.wrapper.set("blockDisplayNode", item.node);
                }
            }));

            var unusedItem;
            while ((unusedItem = unusedMappingItems.pop())) {
                this._mappings.splice(array.indexOf(this._mappings, unusedItem), 1);
            }

            return unmappedNodes;
        },

        findOne: function (fieldName, value) {
            // summary:
            //      Returns first mapping that has a field with the value.
            //
            // fieldName: String
            //      The field name.
            //
            // value: Object|Variant
            //      The search value.
            //
            // returns: the first match item.
            //
            // tags: public

            var mapping;

            array.some(this._mappings, function (m) {
                if (m[fieldName] === value) {
                    mapping = m;
                    return true;
                }
            });

            return mapping;
        },

        find: function () {
            // summary:
            //      Returns all mappings that has a field with the value
            //
            // arguments: Array
            //      Can either be a filter function or field name and search value.
            //      If there is no argument provided, returns all mappings.
            //
            // returns: the match items.
            //
            // tags: public

            var filter;
            if (arguments[0] === undefined) {
                return this._mappings;
            } else if (lang.isFunction(arguments[0])) {
                filter = arguments[0];
            } else {
                var fieldName = arguments[0], value = arguments[1];
                filter = function (m) {
                    return m[fieldName] === value;
                };
            }

            return array.filter(this._mappings, filter);
        },

        _clearMapping: function (mapping) {
            // summary:
            //      Runs destroy on mapping properties
            //
            // tags:
            //		private

            for (var prop in mapping) {
                if (mapping[prop]) {
                    if (prop !== "node") {

                        if (lang.isFunction(mapping[prop].destroyRecursive)) {
                            mapping[prop].destroyRecursive();
                        } else if (lang.isFunction(mapping[prop].destroy)) {
                            mapping[prop].destroy();
                        } else if (lang.isFunction(mapping[prop].remove)) {
                            mapping[prop].remove();
                        }

                    }

                    mapping[prop] = null;
                }
            }
        }
    });
});

},
'dojox/encoding/digests/SHA1':function(){
define("dojox/encoding/digests/SHA1", ["./_base"], function(dxd){

/*
 * A port of Paul Johnstone's SHA1 implementation
 *
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 *
 * Dojo port by Tom Trenka
 */

	var chrsz=8,	//	change to 16 for unicode.
		mask=(1<<chrsz)-1;

	function R(n,c){ return (n<<c)|(n>>>(32-c)); }
	function FT(t,b,c,d){
		if(t<20){ return (b&c)|((~b)&d); }
		if(t<40){ return b^c^d; }
		if(t<60){ return (b&c)|(b&d)|(c&d); }
		return b^c^d;
	}
	function KT(t){ return (t<20)?1518500249:(t<40)?1859775393:(t<60)?-1894007588:-899497514; }

	function core(x,len){
		x[len>>5]|=0x80<<(24-len%32);
		x[((len+64>>9)<<4)+15]=len;

		var w=new Array(80), a=1732584193, b=-271733879, c=-1732584194, d=271733878, e=-1009589776;
		for(var i=0; i<x.length; i+=16){
			var olda=a, oldb=b, oldc=c, oldd=d, olde=e;
			for(var j=0;j<80;j++){
				if(j<16){ w[j]=x[i+j]; }
				else { w[j]=R(w[j-3]^w[j-8]^w[j-14]^w[j-16],1); }
				var t = dxd.addWords(dxd.addWords(R(a,5),FT(j,b,c,d)),dxd.addWords(dxd.addWords(e,w[j]),KT(j)));
				e=d; d=c; c=R(b,30); b=a; a=t;
			}
			a=dxd.addWords(a,olda);
			b=dxd.addWords(b,oldb);
			c=dxd.addWords(c,oldc);
			d=dxd.addWords(d,oldd);
			e=dxd.addWords(e,olde);
		}
		return [a, b, c, d, e];
	}

	function hmac(data, key){
		var wa=toWord(key);
		if(wa.length>16){ wa=core(wa, key.length*chrsz); }

		var ipad=new Array(16), opad=new Array(16);
		for(var i=0;i<16;i++){
			ipad[i]=wa[i]^0x36363636;
			opad[i]=wa[i]^0x5c5c5c5c;
		}

		var hash=core(ipad.concat(toWord(data)),512+data.length*chrsz);
		return core(opad.concat(hash), 512+160);
	}

	function toWord(s){
		var wa=[];
		for(var i=0, l=s.length*chrsz; i<l; i+=chrsz){
			wa[i>>5]|=(s.charCodeAt(i/chrsz)&mask)<<(32-chrsz-i%32);
		}
		return wa;	//	word[]
	}

	function toHex(wa){
		//	slightly different than the common one.
		var h="0123456789abcdef", s=[];
		for(var i=0, l=wa.length*4; i<l; i++){
			s.push(h.charAt((wa[i>>2]>>((3-i%4)*8+4))&0xF), h.charAt((wa[i>>2]>>((3-i%4)*8))&0xF));
		}
		return s.join("");	//	string
	}

	function _toString(wa){
		var s=[];
		for(var i=0, l=wa.length*32; i<l; i+=chrsz){
			s.push(String.fromCharCode((wa[i>>5]>>>(32-chrsz-i%32))&mask));
		}
		return s.join("");	//	string
	}

	function toBase64(/* word[] */wa){
		// summary:
		//		convert an array of words to base64 encoding, should be more efficient
		//		than using dojox.encoding.base64
		var p="=", tab="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", s=[];
		for(var i=0, l=wa.length*4; i<l; i+=3){
			var t=(((wa[i>>2]>>8*(3-i%4))&0xFF)<<16)|(((wa[i+1>>2]>>8*(3-(i+1)%4))&0xFF)<<8)|((wa[i+2>>2]>>8*(3-(i+2)%4))&0xFF);
			for(var j=0; j<4; j++){
				if(i*8+j*6>wa.length*32){
					s.push(p);
				} else {
					s.push(tab.charAt((t>>6*(3-j))&0x3F));
				}
			}
		}
		return s.join("");	//	string
	};

	//	public function
	dxd.SHA1=function(/* String */data, /* dojox.encoding.digests.outputTypes? */outputType){
		// summary:
		//		Computes the SHA1 digest of the data, and returns the result according to output type.
		var out=outputType||dxd.outputTypes.Base64;
		var wa=core(toWord(data), data.length*chrsz);
		switch(out){
			case dxd.outputTypes.Raw:{
				return wa;	//	word[]
			}
			case dxd.outputTypes.Hex:{
				return toHex(wa);	//	string
			}
			case dxd.outputTypes.String:{
				return _toString(wa);	//	string
			}
			default:{
				return toBase64(wa);	//	string
			}
		}
	}

	//	make this private, for later use with a generic HMAC calculator.
	dxd.SHA1._hmac=function(/* string */data, /* string */key, /* dojox.encoding.digests.outputTypes? */outputType){
		// summary:
		//		computes the digest of data, and returns the result according to type outputType
		var out=outputType || dxd.outputTypes.Base64;
		var wa=hmac(data, key);
		switch(out){
			case dxd.outputTypes.Raw:{
				return wa;	//	word[]
			}
			case dxd.outputTypes.Hex:{
				return toHex(wa);	//	string
			}
			case dxd.outputTypes.String:{
				return _toString(wa);	//	string
			}
			default:{
				return toBase64(wa);	//	string
			}
		}
	};

	return dxd.SHA1;
});

},
'dojox/encoding/digests/_base':function(){
define("dojox/encoding/digests/_base", ["dojo/_base/lang"], function(lang){
	var d = lang.getObject("dojox.encoding.digests", true);

	//TODO: see if it makes sense to meld this into one with the
	//	crypto base enums
	d.outputTypes={
		// summary:
		//		Enumeration for input and output encodings.
		Base64:0, Hex:1, String:2, Raw:3
	};

	//	word-based addition
	d.addWords=function(/* word */a, /* word */b){
		// summary:
		//		add a pair of words together with rollover
		var l=(a&0xFFFF)+(b&0xFFFF);
		var m=(a>>16)+(b>>16)+(l>>16);
		return (m<<16)|(l&0xFFFF);	//	word
	};

	//	word-based conversion method, for efficiency sake;
	//	most digests operate on words, and this should be faster
	//	than the encoding version (which works on bytes).
	var chrsz=8;	//	16 for Unicode
	var mask=(1<<chrsz)-1;

	d.stringToWord=function(/* string */s){
		// summary:
		//		convert a string to a word array
		var wa=[];
		for(var i=0, l=s.length*chrsz; i<l; i+=chrsz){
			wa[i>>5]|=(s.charCodeAt(i/chrsz)&mask)<<(i%32);
		}
		return wa;	//	word[]
	};

	d.wordToString=function(/* word[] */wa){
		// summary:
		//		convert an array of words to a string
		var s=[];
		for(var i=0, l=wa.length*32; i<l; i+=chrsz){
			s.push(String.fromCharCode((wa[i>>5]>>>(i%32))&mask));
		}
		return s.join("");	//	string
	};

	d.wordToHex=function(/* word[] */wa){
		// summary:
		//		convert an array of words to a hex tab
		var h="0123456789abcdef", s=[];
		for(var i=0, l=wa.length*4; i<l; i++){
			s.push(h.charAt((wa[i>>2]>>((i%4)*8+4))&0xF)+h.charAt((wa[i>>2]>>((i%4)*8))&0xF));
		}
		return s.join("");	//	string
	};

	d.wordToBase64=function(/* word[] */wa){
		// summary:
		//		convert an array of words to base64 encoding, should be more efficient
		//		than using dojox.encoding.base64
		var p="=", tab="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", s=[];
		for(var i=0, l=wa.length*4; i<l; i+=3){
			var t=(((wa[i>>2]>>8*(i%4))&0xFF)<<16)|(((wa[i+1>>2]>>8*((i+1)%4))&0xFF)<<8)|((wa[i+2>>2]>>8*((i+2)%4))&0xFF);
			for(var j=0; j<4; j++){
				if(i*8+j*6>wa.length*32){
					s.push(p);
				} else {
					s.push(tab.charAt((t>>6*(3-j))&0x3F));
				}
			}
		}
		return s.join("");	//	string
	};

	return d;
});

},
'epi-cms/contentediting/RenderManager':function(){
﻿define([
    "dojo",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/Deferred",
    "dojo/_base/json",
    "dojo/_base/array",
    "epi",
    "epi/dependency",
    "epi/datetime",
    "dojox/encoding/digests/SHA1",
    "dojo/Stateful",
    "epi-cms/contentediting/PropertyRenderer"
],

function (dojo, declare, lang, Deferred, json, array, epi, dependency, epiDateTime, SHA1, Stateful, PropertyRenderer) {

    return declare([Stateful], {
        // summary:
        //    This class manages content blocks server rendering. It provides a cache to avoid redundant server calls.
        // tags:
        //    internal

        // _cache: [private] Object
        //    The internal render cache
        _cache: null,
        _queue: null,

        // defaultRenderer: Object
        //      Instance of the default renderer class
        defaultRenderer: null,

        // _rendererPool: Hashtable
        //      Cache of renderer objects
        _rendererPool: {},

        // rendering: Boolean
        //      Set to true while we're rendering items
        rendering: false,

        // processQueueOnRenderValue: Boolean
        //      Set this to true to start rendering automatically after calling renderValue
        processQueueOnRenderValue: true,

        // numberOfItemsInQueue: Number
        //      Number of items queued to be rendered
        numberOfItemsInQueue: 0,

        // numberOfItemsRendering: Number
        //      Number of items being rendered
        numberOfItemsRendering: 0,

        // concurrentProcessedItems: Number
        //      Maximum number of items that can be rendered at the same time
        concurrentProcessedItems: 2,

        // processInterval: Number
        //      How often (in milliseconds) should we check the queue to see if there's any items to be rendered
        processInterval: 200,

        // _processIntervalId: [private] Number
        //      Id of the interval to check queue, will only be set if any rendering has occurred
        _processIntervalId: 0,

        // _itemsBeingRendered: [private] Hashmap
        //      Hashmap with items being rendered
        _itemsBeingRendered: null,

        // viewSettingsManager: [private] epi.cms.contentediting.ViewSettingsManager
        //      The ViewSettingsManager is used to get a currently selected visitor group.
        viewSettingsManager: null,

        _viewSettingsToCopy: ["visitorgroup"],

        constructor: function (params) {
            this._cache = {};
            this._queue = [];
            this._itemsBeingRendered = {};
            lang.mixin(this, params);

            this.defaultRenderer = this.defaultRenderer || new PropertyRenderer();
        },

        postscript: function () {
            // Listen changed visitor group, to apply visitor group.
            this.viewSettingsManager = this.viewSettingsManager || dependency.resolve("epi.viewsettingsmanager");
        },

        destroy: function () {
            // stop queue
            this._stopRenderingInterval();

            // set flag
            this._isDestroyed = true;

            // clear cache
            for (var i in this._cache) {
                delete this._cache[i];
            }
            // clear itemsbeing rendered
            for (var j in this._itemsBeingRendered) {
                delete this._itemsBeingRendered[j];
            }

            this._cache = null;
            this._itemsBeingRendered = null;
            this._queue = null;

            this.inherited(arguments);
        },

        _getRenderer: function (rendererClassName) {
            var def = new Deferred();
            if (rendererClassName) {
                if (this._rendererPool[rendererClassName]) {
                    return this._rendererPool[rendererClassName];
                } else {
                    require([rendererClassName], function (renderer) {
                        def.resolve(new renderer());
                    });
                }
            } else {
                return this.defaultRenderer;
            }
            return def;
        },

        renderValue: function (contentLink, propertyName, value, renderSettings, rendererClassName) {
            // summary:
            //    Get block render for a content model's node, supplying its value.
            //
            // contentLink: Object|String
            //    The id of the content on which the property is rendered.
            //
            // propertyName: String
            //    Name of the property to render
            //
            // value: String
            //    The node value.
            //
            // rendererClassName: String
            //    Name of renderer class which takes care of render the given value to html.
            //
            // renderSettings: Object
            //    Render setting
            //
            // returns:
            //	  A dojo/Deferred object which results the render
            //
            // tags:
            //    public

            var def;

            if (this._isSuspending) {
                def = new Deferred();
                def.cancel();
                return def;
            }

            value = epiDateTime.transformDate(value);

            renderSettings = this.cloneAndCompleteRenderSettings(renderSettings || {});

            // Firstly, try getting from cache
            var renderedContent = this._get(propertyName, renderSettings, value);

            if (renderedContent) {
                def = new Deferred();
                def.resolve(renderedContent);
            } else {
                if (renderSettings && renderSettings.isFullReload) {
                    def = new Deferred();
                    def.resolve({ doReload: true });
                } else {
                    def = new Deferred();
                    Deferred.when(this._getRenderer(rendererClassName), function (renderer) {
                        if (!renderer) {
                            renderer = this.defaultRenderer;
                        }

                        Deferred.when(this._queueItem(renderer, contentLink, propertyName, renderSettings, value), function (result) {
                            def.resolve(result);
                        });

                        if (this.processQueueOnRenderValue && !this._isSuspending) {
                            this._startRenderingInterval();
                        }
                    }.bind(this));
                }
            }

            return def;
        },

        cloneAndCompleteRenderSettings: function (renderSettings) {
            // summary:
            //    Clones the supplied renderSettings and adds settings from the ViewSettingsManager.
            //
            // returns:
            //    The cloned and updated renderSettings.
            //
            // tags:
            //    public

            renderSettings.propertyRenderSettings = renderSettings.propertyRenderSettings || "";

            var renderSettingsClone = lang.clone(renderSettings);

            if (this.viewSettingsManager.get("enabled")) {
                array.forEach(this.viewSettingsManager.getRenderingViewSettings(), lang.hitch(this, function (viewSetting) {
                    if (viewSetting.get("enabled")) {
                        var settingValue = this.viewSettingsManager.getSettingProperty(viewSetting.key);
                        if (settingValue) {
                            this.updateRenderSettings(renderSettingsClone, settingValue, viewSetting.key, viewSetting.isTagItem);
                        }
                    }
                }));
            }

            return renderSettingsClone;
        },

        updateRenderSettings: function (/*String*/renderSettings, /*String*/newItem, /*String*/key, /*Boolean*/isTagItem) {
            // summary:
            //    Add new items to the renderSettings.
            //
            // renderSettings:
            //    The property render settings.
            //
            // newItem:
            //    The item that will be added to the property.
            //
            // key:
            //    The name of the property that will be updated.
            //
            // isTagItem:
            //    Flag indicating where the new item will be added if it's true
            //    the item will be added to the renderSettings.propertyRenderSettings.tag,
            //    otherwise it will be added directly as a property on the renderSettings object.
            //
            // returns:
            //    The updated setting as a string.
            //
            // tags:
            //    public
            var itemlist = [],
                newitemlist = [],
                itemsString = "",
                propertyName = (isTagItem ? "tag" : key),
                replaceItem = !isTagItem,
                data = null;

            if (isTagItem) {
                renderSettings.propertyRenderSettings = renderSettings.propertyRenderSettings || "";
                data = (renderSettings.propertyRenderSettings ? dojo.fromJson(renderSettings.propertyRenderSettings) : {});
            } else {
                data = (renderSettings ? renderSettings : {});
            }

            if (!data[propertyName] || replaceItem) {
                // in case there isn't any tag defined.
                itemsString = newItem;
            } else {
                // there're tags already configured.
                itemlist = data[propertyName].split(",");

                array.forEach(itemlist, function (item, idx) {
                    item = lang.trim(item);
                    if (item.toLowerCase() !== newItem.toLowerCase()) {
                        newitemlist.push(item);
                    }
                });
                // add the new tag to the array.
                newitemlist.push(newItem);
                itemsString = newitemlist.join(", ");
            }

            // update the settings object.
            data[propertyName] = itemsString;

            if (isTagItem) {
                renderSettings.propertyRenderSettings = dojo.toJson(data);
            }
        },

        processQueue: function () {
            // summary:
            //    Process the queue.
            //

            if (this._isSuspending) {
                return;
            }
            if (this._queue.length === 0) {
                // queue is empty, stop processing queue
                this._stopRenderingInterval();
                return;
            }

            if (this.numberOfItemsRendering >= this.concurrentProcessedItems) {
                // we're already rendering max number of items
                return;
            }

            // add as many items as needed to rendering pool
            var nextItemToProcessIndex = this._nextItemToProcessIndex();

            while (nextItemToProcessIndex >= 0 && this.numberOfItemsRendering < this.concurrentProcessedItems) {

                this._processItemInQueue(nextItemToProcessIndex);

                // Find next item to process
                nextItemToProcessIndex = this._nextItemToProcessIndex();
            }
        },

        suspend: function () {
            // summary:
            //    Suspend the render manager.
            //
            // remarks:
            //    Ongoing rendering items will be canceled. Queueing items will be deleted and adding items will be temporary rejected.
            //    Used when the preview need to be reloaded.

            if (this._isSuspending) {
                return;
            }

            // set flag
            this._isSuspending = true;
            this._stopRenderingInterval();
        },

        clear: function () {
            //cancel ongoing
            this.set("numberOfItemsRendering", 0);
            for (var key in this._itemsBeingRendered) {
                this._itemsBeingRendered[key].deferred.cancel();
                delete this._itemsBeingRendered[key];
            }
            this._itemsBeingRendered = {};

            //empty queue
            this.set("numberOfItemsInQueue", 0);
            for (var i = this._queue.length - 1; i >= 0; i--) {
                delete this._queue[i];
            }
            this._queue = [];
        },

        resume: function () {
            // summary:
            //    Resume render manager.
            //
            // remarks:
            //    Used when the preview has done reloading.
            //    The render queue was reset before so the render manager will start over fresh.

            if (!this._isSuspending) {
                return;
            }

            // set flag
            this._isSuspending = false;
            this._startRenderingInterval();
        },

        _nextItemToProcessIndex: function () {

            // take first item if items in queue exists
            var index = -1;

            var i = 0;

            while (i < this._queue.length && index === -1) {

                // get item
                var item = this._queue[i];

                // get the key
                var key = this._getRenderHash(item.propertyName, item.renderSettings);

                // if the key is not in the items being rendered, we found our next item
                if (!(key in this._itemsBeingRendered)) {
                    index = i;
                }

                i++;
            }

            return index;
        },

        _processItemInQueue: function (index) {
            // take item
            var item = this._queue.splice(index, 1)[0];

            // increase value of items being rendered
            this.set("numberOfItemsRendering", this.numberOfItemsRendering + 1);

            // update number of items
            this.set("numberOfItemsInQueue", this._queue.length);

            // get the key
            var key = this._getRenderHash(item.propertyName, item.renderSettings);

            // put the item in our hashmap
            this._itemsBeingRendered[key] = item;

            // we're rendering
            this.set("rendering", true);

            var onSuccess = lang.hitch(this, function (result) {

                // check if destroy() was called before callback was fired
                if (this._isDestroyed) {
                    item.deferred.cancel();
                    return;
                }

                // cache value if it is successful
                if (result && result.innerHtml) {
                    this._put(item.propertyName, item.renderSettings, item.value, { doReload: result.doReload, innerHtml: result.innerHtml });
                }

                // remove this item from the items being rendered
                delete this._itemsBeingRendered[key];

                // decrease value of items being rendered
                this.set("numberOfItemsRendering", this.numberOfItemsRendering - 1);

                this.set("rendering", false);

                // resolve rendering deferreds
                if (item.deferred.fired !== 1) {
                    item.deferred.resolve(result);
                }
            });

            var onFailure = lang.hitch(this, function (err) {
                // TODO: error handling for server error

                // check if destroy() was called before callback was fired
                if (this._isDestroyed) {
                    item.deferred.cancel();
                    return;
                }

                // remove this item from the items being rendered
                delete this._itemsBeingRendered[key];

                // decrease value of items being rendered
                this.set("numberOfItemsRendering", this.numberOfItemsRendering - 1);

                this.set("rendering", false);

                // reject rendering deferreds
                item.deferred.reject(err);
            });

            Deferred.when(item.renderer.render(item.contentLink, item.propertyName, item.value, item.renderSettings), onSuccess, onFailure);
        },

        cacheRender: function (propertyName, renderSettings, value, content) {
            // summary:
            //    Explicitly update the internal cache with the rendered content for a block.
            //
            // propertyName: String
            //    The content model node. It can be property or sub property.
            //
            // value: String|Object
            //    The value to render.
            //
            // content: String
            //    The rendered content.
            //
            // tags:
            //    public

            var data = {
                innerHtml: content,
                doReload: false
            };

            this._put(propertyName, renderSettings, value, data);
        },

        _queueItem: function (renderer, contentLink, propertyName, renderSettings, value) {
            // summary:
            //      Add or update rendering item

            var key = this._getRenderHash(propertyName, renderSettings);
            var deferred;

            var itemBeingRendered = this._itemsBeingRendered[key];

            if (itemBeingRendered && !itemBeingRendered.deferred.fired && itemBeingRendered.value === value) {
                // The current property is being rendered, return that deferred
                // the deferred should always have fired set to false
                deferred = itemBeingRendered.deferred;
            } else {
                var index = this._queueIndex(renderer, contentLink, propertyName, renderSettings, value);

                if (index < 0) {
                    deferred = new Deferred();

                    // queue item
                    this._queue.push({
                        contentLink: contentLink,
                        renderer: renderer,
                        propertyName: propertyName,
                        renderSettings: renderSettings,
                        renderSettingsString: json.toJson(renderSettings),
                        value: value,
                        deferred: deferred
                    });

                    // update number of items in queue
                    this.set("numberOfItemsInQueue", this._queue.length);
                } else {

                    // it doesn't matter which item we update
                    // update it with new values
                    var item = this._queue[index];

                    // updating with a new renderer could cause errors, ie having two properties on the same
                    // content with same settings, but with different renderers
                    item.contentLink = contentLink;
                    item.renderer = renderer;
                    item.value = value;

                    deferred = item.deferred;
                }
            }

            return deferred;
        },

        _startRenderingInterval: function () {
            if (!this._processIntervalId) {

                // trigger immediate first call
                this.processQueue();

                // create interval
                this._processIntervalId = setInterval(lang.hitch(this, function () {
                    this.processQueue();
                }), this.processInterval);
            }

        },

        _stopRenderingInterval: function () {

            if (this._processIntervalId) {
                clearInterval(this._processIntervalId);
                this._processIntervalId = 0;
            }

            // reset flag
            this.set("rendering", false);
        },


        _getRenderHash: function (propertyName, renderSettings) {
            return SHA1(json.toJson({ p: propertyName, r: renderSettings }));
        },


        _queueIndex: function (renderer, contentLink, propertyName, renderSettings, value) {

            var index = -1;
            var renderSettingsString = json.toJson(renderSettings);

            // find index of item in queue
            array.some(this._queue, function (item, i) {
                if ((item.propertyName === propertyName) && (item.renderSettingsString === renderSettingsString)) {
                    index = i;
                    return true;
                }
            });

            return index;
        },

        _put: function (propertyName, renderSettings, value, data) {
            // summary:
            //    Store the rendered content for a value in the internal cache object
            //
            // propertyName: String
            //    Name of the cached block
            //
            // value: String|Object
            //    The raw value of the object to fetch
            //
            // value: String
            //    The rendered content to put in cache
            //
            // tags:
            //    private

            if (!renderSettings.cacheResults) {
                return;
            }

            var valueHash = this._getCacheHash(propertyName, renderSettings, value);
            if (!this._cache) {
                // Initial internal render cache
                this._cache = {};
            }
            this._cache[valueHash] = { data: data };
        },

        _get: function (propertyName, renderSettings, value) {
            // summary:
            //    Retreive the rendered content for a value from the internal cache
            //
            // propertyName: String
            //    Name of the cached block
            //
            // value: String|Object
            //    The raw value of the object to fetch
            //
            // returns:
            //    The content as a string or undefined if no cached content exists.
            //
            // tags:
            //    private

            var valueHash = this._getCacheHash(propertyName, renderSettings, value);
            var cacheObject = this._cache[valueHash];
            return (cacheObject ? cacheObject.data : undefined);
        },

        _getCacheHash: function (propertyName, renderSettings, value) {
            // summary:
            //    Calculates a hash of the supplied value
            //
            // tags:
            //    private

            // In case the value is an object we serialize before calculating the hash.
            return SHA1(json.toJson({ p: propertyName, r: renderSettings, v: value }));
        }
    });

});

},
'epi-cms/contentediting/PropertyRenderer':function(){
﻿define([
    "dojo/_base/json",
    "dojo/_base/declare",
    "epi",
    "epi/dependency",
    "epi/shell/XhrWrapper",
    "epi-cms/contentediting/_Renderer",
    "epi-cms/core/ContentReference",
    "epi/routes",
    "dojo/string"],

function (json, declare, epi, dependency, XhrWrapper, _Renderer, ContentReference, routes, string) {

    return declare([_Renderer], {
        // summary:
        //    Server side property renderer. Returns the mark-up generated by rendering a property on the server side.
        // tags:
        //    internal

        _routes: routes,

        // xhrHandler: [private] Object
        //  The xhr implementation to use when requesting data. Defaults to epi/shell/XhrWrapper
        _xhrHandler: null,

        // Profile: [private] Object
        //  The current profile.
        _profile: null,

        constructor: function () {
            if (!this._routes) {
                this._routes = epi.routes;
            }
            if (!this._xhrHandler) {
                this._xhrHandler = new XhrWrapper();
            }

            this._profile = this._profile || dependency.resolve("epi.shell.Profile");
        },

        render: function (contentLink, propertyName, propertyValue, renderSettings) {
            // summary:
            //    Get the content rendered by the server for an editable block.
            //
            // contentLink: object
            //    The content containing the update property
            //
            // propertyName: String
            //    The updated property name.
            //
            // propertyValue: String
            //    The updated raw value of the property.
            //
            // returns:
            //    A deferred
            //
            // tags:
            //    public


            var reference = ContentReference.toContentReference(contentLink);

            var url = this._routes.getActionPath({
                moduleArea: "CMS",
                controller: "PropertyRender",
                action: "Render",
                epieditmode: true,
                visitorgroupsByID: renderSettings.visitorgroup,
                epslanguage: this._profile ? this._profile.contentLanguage : "" // in order to render the property (content) in correct language
            });

            var postData = {
                propertyName: propertyName,
                propertyValue: json.toJson(propertyValue),
                id: reference.toString(), // The default model binder in MVC needs the id to be part of the posted data.
                renderSettings: ""
            };

            if (renderSettings && renderSettings.propertyRenderSettings) {
                postData.renderSettings = renderSettings.propertyRenderSettings;
            }


            return this._xhrHandler.xhrPost({
                url: url,
                handleAs: "json",
                content: postData
            }); //Deferred
        }
    });
});

},
'epi-cms/contentediting/_Renderer':function(){
﻿define([
    "epi",
    "dojo"],

function (epi, dojo) {

    return dojo.declare(null, {
        // summary:
        //      Base class for rendering a content block.
        // tags:
        //      public abstract

        constructor: function (params) {
            dojo.mixin(this, params);
        },

        render: function (contentLink, propertyName, propertyValue, renderSettings) {
            // summary:
            //      Render a content block using render manager's implementation or its own implementation
            //
            // value: String
            //      The node value.
            //
            // tags:
            //      public abstract

            throw new Error("Abstract method _render must be overridden in a derived class");
        }
    });

});

},
'epi-cms/contentediting/UpdateController':function(){
define([
    "dojo",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-geometry",
    "dojo/dom-attr",
    "dijit"],

function (
    dojo,
    array,
    declare,
    lang,
    domClass,
    domStyle,
    domGeometry,
    domAttr,
    dijit) {

    return declare(null, {
        // tags:
        //      internal

        _showEmptyNode: true,
        _hasEmptyHtml: false,

        // emptyValue: String
        //		Template to display empty value
        emptyValue: "&nbsp;",

        // minWidth: Number
        //      Use this width for the displayNode when then node has a zero width
        minWidth: 18,

        // minHeight: Number
        //      Use this height for the displayNode when then node has a zero height
        minHeight: 14,

        // displayNode: DomNode
        //		The source node
        displayNode: null,

        // model: dojo/Stateful
        //		A model to update
        contentModel: null,

        // contentLink: String
        //      The content link to update
        contentLink: null,

        // modelPropertyName: String
        //		Name of the property in model to observe
        modelPropertyName: null,

        // nodePropertyName: String
        //		Name of the property in the rendered page
        nodePropertyName: null,

        // renderManager: [public] epi.cms.contentediting._Renderer
        //      The render manager
        renderManager: null,

        // displayName: String
        //		A display name for this block
        displayName: null,

        // renderSettings: Object
        //		A display name for this block
        renderSettings: null,

        // rendererClass: String
        //		A display name for this block
        rendererClass: null,

        constructor: function (settings) {
            dojo.mixin(this, settings);
        },

        postscript: function () {
            // watch model
            if (this.contentModel) {
                this._modelWatchHandle = [];
                dojo.forEach(dojo.isArray(this.modelPropertyName) ? this.modelPropertyName : [this.modelPropertyName], dojo.hitch(this, function (propertyName) {
                    this._modelWatchHandle.push(this.contentModel.watch(propertyName, dojo.hitch(this, this._renderNode)));
                }));
            }

            this.checkEmptyHtml();
        },

        destroy: function () {
            // detach watch handle
            array.forEach(this._modelWatchHandle, function (handle) {
                handle.remove();
            });

            dojo.disconnect(this._renderDisplayNodeConnect);

            // Clear node in other frame to prevent nasty issues with dojo caching unloaded documents
            delete this.srcNodeRef;
            delete this.displayNode;

            this.inherited(arguments);
        },

        onReloadRequired: function (sender) {
            // summary:
            //		Set this handler to be notified when the block requires a full reload of the web page to be rerenderd.
            // tags:
            //		callback

        },

        onRender: function (block) {
            // summary:
            //		Set this handler to be notified when the block renders
            // tags:
            //		callback

        },

        _renderNode: function (propertyName, oldValue, value) {

            var contentLink = this.contentLink;
            var renderSettings = this.renderSettings;
            var rendererClass = this.rendererClass;
            var renderPropertyName = this.nodePropertyName || this.modelPropertyName;

            var def = this.renderManager.renderValue(contentLink, renderPropertyName, value, renderSettings, rendererClass);

            // Did we get a new deferred?
            if (def !== this._lastRenderDeferred) {

                // Store value
                this._lastRenderDeferred = def;

                dojo.when(def, dojo.hitch(this, function (result) {

                    // update node if we have a last deferred, this because cached rendering can
                    // be resolved faster than server rendered values. The last rendered deferred
                    // will be the one to update the node the last time.
                    if (this._lastRenderDeferred) {

                        if (result.doReload !== undefined && result.doReload) {
                            this.onReloadRequired(this);
                        } else if (dojo.isString(result)) {
                            this._updateRendering(result);
                        } else if (result.innerHtml !== undefined) {
                            this._updateRendering(result.innerHtml, result.attributes);
                        } else if (result.error !== undefined) {
                            this._handleValidationError(result.error);
                        }

                        if (def === this._lastRenderDeferred) {
                            this._lastRenderDeferred = null;
                        }
                    }
                }));
            }
        },

        _isEmptyHtml: function (displayNode) {

            // TODO: check for other types of nodes
            // TODO: use property descriptor to know which properties can have content (or not have inner content)
            var html = "";

            if (!displayNode) {
                return false;
            }

            if (displayNode.tagName === "IMG") {
                html = dojo.attr(displayNode, "src") || "";
            } else {
                html = displayNode.innerHTML;
            }

            // strip scripts tag from html. The regex pattern is borrowed from jquery.
            html = html.replace(/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi, "");

            // This won't handle empty <br> in html
            return (typeof html == "string") && (html.replace(/\s*/g, "").length === 0);
        },

        checkEmptyHtml: function () {
            // summary:
            //		Overrides empty DomNode html with this.emptyValue
            // tags:
            //		public

            var isEmpty;

            if (!this._showEmptyNode) {
                return;
            }

            isEmpty = this._isEmptyHtml(this.displayNode);

            if (isEmpty && this._canModifyDisplayNode()) {
                this.displayNode.innerHTML = dojo.string.substitute(this.emptyValue, this);
            }

            this._ensureSize();
        },

        _canModifyDisplayNode: function () {
            // summary:
            //		For 'none' renderer, DomNode html and attributes should not be overwritten.
            //      It should be handled by page rendering framework
            // tags:
            //		private

            return this.rendererClass !== "epi-cms/contentediting/NullRenderer";
        },

        _ensureSize: function () {
            if (!this._canModifyDisplayNode()) {
                return;
            }

            try {
                this._clearComputedStyle();
                this._computeStyle();
            } catch (e) {
                // Probably failed because displayNode is not set yet
                console.warn("Could not get or set domStyle for displayNode", e);
            }
        },

        _clearComputedStyle: function () {

            var originalStyle = this._originalStyle;

            if (originalStyle) {

                // Reset any previous width and height styling, ie get the height for the content of the displaynode
                for (var prop in originalStyle) {

                    if (Object.prototype.hasOwnProperty.call(originalStyle, prop)) {
                        domStyle.set(this.displayNode, prop, this._originalStyle[prop]);
                    }
                }

                this._originalStyle = null;
            }
        },

        _computeStyle: function () {
            var node = this.displayNode,
                computedStyle = node && domStyle.get(node);

            if (!computedStyle) {
                return;
            }

            var originalStyle = {
                    minWidth: domStyle.toPixelValue(node, computedStyle.minWidth),
                    minHeight: domStyle.toPixelValue(node, computedStyle.minHeight),
                    display: computedStyle.display
                },
                styleToApply = { },
                setMinHeight = originalStyle.minHeight === 0,
                setMinWidth = originalStyle.minWidth === 0,
                setDisplay = originalStyle.display === "inline",
                marginBox = domGeometry.getMarginBox(node, computedStyle);

            // Check if the node is smaller than desired, either from page cssClass/style or our min settings
            if (marginBox.h < (setMinHeight ? this.minHeight : originalStyle.minHeight) ||
                marginBox.w < (setMinWidth ? this.minWidth : originalStyle.minWidth)) {

                if (setMinHeight) {
                    styleToApply.minHeight = this.minHeight + "px";
                }
                if (setMinWidth) {
                    styleToApply.minWidth = this.minWidth + "px";
                }
                if (setDisplay) {
                    styleToApply.display = "inline-block";
                }

                if (setDisplay || setMinHeight || setMinWidth) {

                    this._originalStyle = originalStyle;
                    domStyle.set(node, styleToApply);
                }
            }
        },

        _updateRendering: function (innerHtml, attributes) {
            // summary:
            //		Callback when rendering has new html.
            // innerHtml: String
            //		The inner html for the node.
            // attributes: Dictionary
            //      The attributes for the outer node that should be set.
            // tags:
            //		private

            this.displayNode.innerHTML = innerHtml;

            if (attributes) {
                array.forEach(attributes, lang.hitch(this, function (attribute) {
                    this._updateAttribute(attribute);
                }));
            }

            this._hasEmptyHtml = this._isEmptyHtml(this.displayNode);
            if (this._hasEmptyHtml) {
                this.checkEmptyHtml();
                if (!this._showEmptyNode) {
                    domStyle.set(this.displayNode, "display", "none");
                }
            } else {
                // node has value, make sure it's not displayed too small
                // it probably has some html, but it could be with empty
                // innerHTML and then there width or height will be zero

                if (this._showEmptyNode) {
                    this._ensureSize();
                }
            }
            this.onRender(this);
        },

        _updateAttribute: function (attribute) {
            // summary:
            //		Update attribute for the display node.
            // attribute: Object
            //      The attribute for the outer node that should be set.
            // tags:
            //		private

            if (attribute.name.toLowerCase() === "class") {
                // Need to keep existing css style
                domClass.add(this.displayNode, attribute.value);
            } else {
                if (domAttr.get(this.displayNode, attribute.name) !== attribute.value) {
                    domAttr.set(this.displayNode, attribute.name, attribute.value);
                }
            }
        },

        _handleValidationError: function (message) {
            // summary:
            //		Callback when rendering has new html.
            // html: String
            //		Focus on the display mode text
            // tags:
            //		private

            console.log(message + ": \"" + this.contentModel.get(this.modelPropertyName) + "\"");
        },

        render: function () {
            var val = this.contentModel.get(this.modelPropertyName);
            this._renderNode(this.modelPropertyName, val, val);
        },

        focus: function () {
            // TODO: focus overlay?
            dijit.focus(this.displayNode);
        },

        setShowEmptyNode: function (val) {
            this._showEmptyNode = val;

            if (this._hasEmptyHtml) {
                this._updateRendering("");
            }
        }
    });

});

},
'epi-cms/widget/overlay/overlayFactory':function(){
define([
// Dojo
    "dojo/_base/lang",
    "dojo/_base/Deferred",

    "epi-cms/widget/overlay/Property"
], function (
// Dojo
    lang,
    Deferred
) {
    return {
        // tags:
        //      internal

        defaultType: "epi-cms/widget/overlay/Property",

        create: function (editableNode) {
            var createOverlayDeferred = new Deferred();
            var customType = editableNode.property.metadata.overlaySettings && editableNode.property.metadata.overlaySettings.customType;

            var property = editableNode.property,
                overlayType = customType || this.defaultType,
                allowedTypeAttribute = {},
                metadata = property.metadata && property.metadata.settings || {};
            allowedTypeAttribute.allowedTypes = metadata.allowedTypes || [];
            allowedTypeAttribute.restrictedTypes = metadata.restrictedTypes || [];

            require([overlayType], lang.hitch(this, function (overlayClass) {
                var settings = lang.mixin(
                    {
                        name: property.name,
                        description: lang.getObject("settings.tooltip", false, property.metadata),
                        contentModel: property.contentModel,
                        displayName: property.metadata.displayName,
                        disabled: editableNode.disabled,
                        sourceItemNode: editableNode.node,
                        typesFormatSuffix: property.metadata && property.metadata.additionalValues && property.metadata.additionalValues.typesFormatSuffix
                    },
                    property.overlayParams,
                    allowedTypeAttribute);

                var overlay = new overlayClass(settings);
                createOverlayDeferred.resolve(overlay);
            }));

            return createOverlayDeferred;
        }
    };
});

},
'epi-cms/widget/overlay/Property':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    // EPi Framework
    "epi/string",
    "epi/shell/widget/overlay/Item"

],

function (
    // Dojo
    declare,
    lang,

    // EPi Framework
    epiString,
    Item
) {
    return declare([Item], {
        // tags:
        //      public

        onValueChange: function (values/* Array || object*/) {
            // summary:
            //      Event to notify that this and possibly other properties
            //      has changed their values
            // values: Object  ||[Object]
            //      The property values that has changed. {propertyName: "propertyName", value: value}
            // tags:
            //      Public callback
        },

        _getRightProperty: function () {
            // summary:
            //      Gets the proper property name.
            // tags:
            //      internal

            var propertyName = this.name;
            if (this.dndTargetPropertyName) {
                propertyName += ("." + epiString.pascalToCamel(this.dndTargetPropertyName));
            }
            return propertyName;
        },

        onDrop: function (target, value) {

            // If we have a mapping dropdata to child property
            // then set drop data to this
            // REMARK: This's just a simple case, handling one specified property, this doesn't support recursive or duplicate child property
            var propertyName = this._getRightProperty();

            // converts the given input to an array value
            function toArray(input) {
                if (!input) {
                    return [];
                }

                if (!(input instanceof Array)) {
                    return [input];
                }
                return input;
            }

            // a property marked with dndTarget could allow multiple values, in that case add the value instead of replacing
            if (this.dndTargetPropertyAllowMultiple === true) {

                var currentValue = toArray(lang.clone(this.contentModel.get(propertyName)));
                toArray(value).forEach(function (item) {
                    currentValue.push(item);
                });

                value = currentValue;
            }

            this.onValueChange({
                propertyName: propertyName,
                value: value
            });
        }
    });
});

},
'epi-cms/compare/views/CompareView':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    // Parent class
    "epi-cms/contentediting/PageDataController",
    // Toolbar
    "epi-cms/compare/CompareToolbar",
    "epi-cms/compare/viewmodels/CompareViewModel"
], function (
    declare,
    lang,
    topic,
    // Parent class
    PageDataController,
    // Toolbar
    CompareToolbar,
    CompareViewModel
) {

    return declare([PageDataController], {
        // tags:
        //      internal

        // iframeName: [readonly] String
        //      The name to assign to the iframe. Used for topics generated within the iframe.
        iframeName: "compareView",

        buildRendering: function () {
            this.inherited(arguments);

            var model = new CompareViewModel(),
                container = this.mainLayoutContainer,
                toolbar = new CompareToolbar({
                    region: "top",
                    splitter: false,
                    model: model.compareToolbarViewModel
                });

            container.addChild(toolbar);

            this.set("compareModel", model);

            this.own(
                model,
                model.watch("leftVersionUri", lang.hitch(this, function (name, oldUri, uri) {
                    this._changeContext(uri);
                })),
                toolbar,
                toolbar.on("versionInformationUpdated", function () {
                    container.layout();
                }),
                topic.subscribe("/epi/shell/action/changeview", this._onChangeView.bind(this))
            );
        },

        setView: function (viewName, viewParams) {
            viewParams = lang.mixin({ model: this.compareModel }, viewParams);

            return this.inherited(arguments, [viewName, viewParams]);
        },

        _changeContext: function (uri) {
            // tags:
            //      private

            if (uri && this._currentViewModel && uri !== this._currentViewModel.contentData.uri) {
                // Request a context change
                topic.publish("/epi/shell/context/request", { uri: uri }, { sender: this });
            }
        },

        _refreshModel: function (contentData, context) {
            this.inherited(arguments);
            this.compareModel.set({
                contentLink: contentData.contentLink,
                typeIdentifier: contentData.typeIdentifier,
                languages: contentData.existingLanguageBranches
            });
        },

        _switchEditMode: function () {
            // If this is the active component when a switch edit mode event
            // occurs, then switch to form editing.
            if (this.isActive) {
                topic.publish("/epi/shell/action/changeview", "formedit", null, null, true);
            }
        },

        _onChangeView: function (/*String*/type) {
            // tags:
            //      private

            // Subscribe to /epi/shell/action/changeview to reset right version
            // every time when Editor enters compare mode.
            // Can't do it through WidgetSwitcher, because there are to many promises
            if (type === "sidebysidecompare" || type === "allpropertiescompare") {
                this.compareModel.set("rightVersion", null);
            }
        }
    });
});

},
'epi-cms/contentediting/PageDataController':function(){
define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/topic",
    "dojo/when",
    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

    "epi/debounce",

    // epi
    "epi/dependency",
    "epi/Url",

    "epi/shell/StickyViewSelector",
    "epi/shell/postMessage",
    "epi/shell/xhr/errorHandler",

    "epi-cms/_ContentContextMixin",

    "epi-cms/contentediting/EditNotifications",
    "epi-cms/contentediting/ContentViewModel",
    "epi-cms/contentediting/viewmodel/ContentActivityFeedViewModel",

    "epi-cms/contentediting/command/Editing",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting",
    "dojo/text!./templates/PageDataController.html",
    // Used in template
    "dijit/layout/BorderContainer",
    "epi/shell/layout/CardContainer",
    "epi/shell/layout/PreserveRatioBorderContainer",
    "epi/shell/widget/IframeWithOverlay",
    "epi-cms/contentediting/EditToolbar",
    "epi-cms/contentediting/NotificationBar",
    "epi-cms/activity/ActivityFeed"
], function (
    // dojo
    array,
    declare,
    lang,

    domClass,
    domStyle,

    aspect,
    Deferred,
    topic,
    when,
    // dijit
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

    debounce,

    // epi
    dependency,
    Url,

    StickyViewSelector,
    postMessage,
    errorHandler,

    _ContentContextMixin,

    EditNotifications,
    ContentViewModel,
    ContentActivityFeedViewModel,

    EditingCommands,
    // resources
    res,
    template
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ContentContextMixin], {
        // summary:
        //      This component will list all versions of a cms page.
        // tags:
        //      internal

        templateString: template,

        // contextTypeName: String
        //      Type name for the context we can handle
        contextTypeName: "epi.cms.contentdata",

        // iframeName: [readonly] String
        //      The name to assign to the iframe. Used for topics generated within the iframe.
        iframeName: "sitePreview",

        pendingNotificationTimeOutId: null, // holds the timeout handler when pending the notification

        isActive: true,

        // defaultEditCssRules: Array
        //      The CSS rules to inject when we're editing
        defaultEditCssRules: [
            { selector: ".epi-injected-minSize", css: "min-height: 30px;" },
            { selector: ".epi-injected-minSize-inline", css: "min-height: 30px; min-width: 100px; display: inline-block !important;" },
            { selector: "[contenteditable=true]:focus", css: "outline: 3px hsla(227, 100%, 50%, 1) solid;" } // hsla(227, 100%, 50%, 1) - @axiom-brand-primary-color
        ],

        _currentViewComponent: null,
        _viewModels: null,
        _notificationHandlerId: null,
        _messageService: null,

        _postMessage: null,
        _editingCommands: null,
        _currentViewModel: null,
        _pageDataStore: null,

        _availableViews: null,

        _previewQueryParameters: null,
        _viewSettingsManager: null,
        _inUseNotificationManager: null,

        _ensurePreviewReadyPromise: null,

        // _stickyViewSelector: epi/shell/StickyViewSelector
        //    Responsible for storing view selected by editor
        _stickyViewSelector: null,

        // componentTypeName: [public] String
        //      Component type name, used to differentiate between instances (such as edit and compare).
        componentTypeName: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");
            this._pageDataStore = this._pageDataStore || registry.get("epi.cms.contentdata");

            this._stickyViewSelector = this._stickyViewSelector || new StickyViewSelector();

            //resolve _viewSettingsManager
            this._viewSettingsManager = dependency.resolve("epi.viewsettingsmanager");

            // get dependency properties
            this._messageService = this._messageService || dependency.resolve("epi.shell.MessageService");
            this._profile = this._profile || dependency.resolve("epi.shell.Profile");

            this._postMessage = this._postMessage || postMessage;
            this._editingCommands = EditingCommands;

            // create new data for views to persist
            if (!this._viewModels) {
                this._viewModels = [];
            }

            this._inUseNotificationManager = this.inUseNotificationManager || dependency.resolve("epi.cms.contentediting.inUseNotificationManager");

            this._editNotifications = this._editNotifications || new EditNotifications();
            this.own(
                this._editNotifications,
                this._editNotifications.on("changed", function (e) {
                    this._defaultNotificationWatchHandler("", e.oldValue, e.newValue, e.notification);
                }.bind(this)));

            this.activityModel = this.activityModel || new ContentActivityFeedViewModel({ componentTypeName: this.componentTypeName });
            this.own(this.activityModel.watch("isActivitiesVisible", this._toggleActivities.bind(this)));
        },

        postCreate: function () {

            var cs;

            this.inherited(arguments);

            this.subscribe("/epi/cms/action/switcheditmode", this._switchEditMode.bind(this));

            // connect to context service
            cs = dependency.resolve("epi.shell.ContextService");
            this._interceptorHandle = cs.registerRequestInterceptor(this._interceptRequestContext.bind(this));

            this.own(
                this.notificationBar.on("notificationsChanged", function () {
                    this.mainLayoutContainer.layout();
                }.bind(this)),
                topic.subscribe("/epi/cms/action/undo", this._undoAction.bind(this)),
                topic.subscribe("/epi/cms/action/redo", this._redoAction.bind(this)),
                topic.subscribe("/epi/cms/action/save", this._saveAction.bind(this)),
                topic.subscribe("/epi/cms/block/inline-updated", this._onViewRequireReload.bind(this)),
                topic.subscribe("/propertiesCreated", this._onViewRenderPostedProperties.bind(this)),
                aspect.before(topic, "publish", function (event, args, sender) {
                    // notify view is changing
                    // except version transition like: Published to Draft
                    // prevent view change request (hideLoader) when no loader/spinner should be shown
                    if (event &&
                        (
                            event === "/epi/shell/action/changeview" ||
                            event === "/epi/shell/action/changeview/back" ||
                            event === "/epi/shell/context/request"
                        ) && (!sender || !sender.contextIdSyncChange) && (!args || args.hideLoader === false)
                    ) {
                        this._onViewChangeRequest();
                    }
                }.bind(this)),
                topic.subscribe("/epi/shell/action/viewchanged", function (type, args, data) {
                    if (data && data.availableViews) {
                        require([data.availableViews.filter(function (x) {
                            return x.key === data.viewName;
                        })[0].controllerType], function (controllerClass) {
                            if (!this.isInstanceOf(controllerClass) && !controllerClass._meta.bases.some(function (x) {
                                return x === this.constructor;
                            }.bind(this))) {
                                this._onViewChangeCompleted();
                            }
                        }.bind(this));
                        return;
                    }

                    this._onViewChangeCompleted();
                }.bind(this)),
                aspect.after(errorHandler, "forXhr", function () {
                    this._onViewChangeFailured();
                }.bind(this))
            );
        },

        _onViewChangeRequest: function () {
            // summary:
            //      Publish event that notify view is changed.
            // tags:
            //      internal
            topic.publish("/epi/shell/pagedatacontroller/action/viewchange", { sender: this, args: arguments });
        },

        _onViewChangeCompleted: function () {
            // summary:
            //      Publish event that notify view is changed.
            // tags:
            //      internal
            topic.publish("/epi/shell/pagedatacontroller/action/viewchanged", { sender: this, args: arguments });
        },

        _onViewChangeFailured: function () {
            // summary:
            //      Publish event that notify view is changed.
            // tags:
            //      internal
            topic.publish("/epi/shell/pagedatacontroller/action/viewchangefailured", { sender: this, args: arguments });
        },

        startup: function () {

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            this.iFrame = this.iframeWithOverlay.iframe;

            this.connect(this.iFrame, "onLoad", "_iFrameLoaded");
            this.connect(this.iFrame, "onUnload", "_iFrameUnLoaded");

            domClass.add(this.toolbar.domNode, "epi-localToolbar epi-viewHeaderContainer");

            this._injectCssRules();

            when(this.getCurrentContext(), function (context) {
                this.contextChanged(context);
            }.bind(this));

            this._toggleActivities();

            var splitter = this.mainLayoutContainer.getSplitter("right");
            aspect.after(splitter, "_stopDrag", function () {
                var settings = {
                    size: domStyle.get(this.activityFeed.domNode, "width")
                };
                this.activityModel._persistActivityFeedSettings(settings);
            }.bind(this));
        },

        buildRendering: function () {
            this.inherited(arguments);
            this._loadSettings();
        },

        destroy: function () {
            this._interceptorHandle && this._interceptorHandle.remove();
            this._destroyCurrentViewComponent();
            this._viewModels.forEach(function (vm) {
                vm.destroy();
            });
            this._viewModels = null;

            this.inherited(arguments);
        },

        contextChangeFailed: function () {
            // notify view change faiulre whenever context is faile due to some reasons.
            this._onViewChangeFailured();
        },

        _defaultNotificationWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/newValue, /*Object*/notification) {
            // summary:
            //      Add/remove notification to/from notification bar
            // tags:
            //      private

            if (oldValue) {
                this.notificationBar.remove(oldValue);
            }

            if (newValue && newValue.content) {
                var availableNotificationIndex = notification ? this._editNotifications.getAvailableNotificationIndex(notification) : 0;
                this.notificationBar.add(newValue, availableNotificationIndex);
            }
        },

        _switchEditMode: function (switchToPrevious, viewParams, saveView) {
            var newView,
                currentView = this._currentViewModel.viewName,
                reloadIFrame = false,
                previewView = "view",
                onPageEditView = "onpageedit",
                allPropertiesView = "formedit";

            // If this is not the active editing component then don't react on
            // edit mode switch events.
            if (!this.isActive) {
                return;
            }

            if (currentView === previewView) {
                topic.publish("/epi/cms/action/disablepreview");
            }
            if (currentView === allPropertiesView) {
                newView = onPageEditView;

                // whenever display onPageEdit view, let the iframe reload content in order to render overlay
                reloadIFrame = true;
            } else {
                newView = allPropertiesView;
            }

            if (saveView) {
                // saving is deferred but it's not blocking operation
                this._stickyViewSelector.save(this._currentViewModel.contentData.hasTemplate, this._currentViewModel.contentData.typeIdentifier, newView);
            }
            return this._ensurePreviewReady(this.setView(newView, viewParams), reloadIFrame, true, newView);
        },

        _iFrameLoaded: function (url, triggeredExternally) {
            // summary:
            //  Event handler when a new document has been loaded into the inner iframe.
            //
            // url: string
            //  url of the frame source
            //
            // triggeredExternally: Boolean
            //  True when the load was initiated by an external context change, as opposed to a click on a link inside the iframe.

            if (!!url && !triggeredExternally) {

                // Iframe is reloaded when user clicks on a link in preview iframe.
                // set dirty flag

                // request a context change
                this._requestContextChangeByUrl(url, true, true);
            }

            var initialData = this._getInitialData(url);
            var window = this.iFrame.getWindow();
            this._postMessage.publish("epiReady", initialData, window);
        },

        _getInitialData: function (url) {
            url = new Url(url);
            if (!url.query || (url.query.epieditmode !== "True" && url.query.epieditmode !== "true")) {
                // if we're not in edit mode we always return editable false
                return { isEditable: false };
            }

            return {
                isEditable: !!this._currentViewModel && this._currentViewModel.canChangeContent()
            };
        },

        _iFrameUnLoaded: function (url) {
            //Disable the overlay before loading the new view
            this.iframeWithOverlay.overlay.set("enabled", false);
        },

        _destroyCurrentViewComponent: function () {

            if (this._currentViewComponentReloadRequireHandle) {
                this._currentViewComponentReloadRequireHandle.remove();
                this._currentViewComponentReloadRequireHandle = null;
            }

            if (this._currentViewComponent) {
                this._currentViewComponent.destroyRecursive();
                this._currentViewComponent = null;
            }
        },

        _getViewModelIndex: function (id) {

            var index = -1;

            array.some(this._viewModels, function (item, idx) {
                if (item.contentLink === id) {
                    index = idx;
                    return true;
                }
            });

            return index;
        },

        _getViewModel: function (id) {

            var index = this._getViewModelIndex(id);

            if (index >= 0) {
                return this._viewModels[index];
            } else {
                return null;
            }
        },

        _removeViewModel: function (id) {

            var index = this._getViewModelIndex(id);

            if (index >= 0) {

                // remove from list
                var viewModel = this._viewModels.splice(index, 1)[0];

                viewModel.clear();
            }
        },

        _createViewModel: function (contentData, ctx) {

            var viewModel = new ContentViewModel({ contentLink: contentData.contentLink, contextTypeName: this.contextTypeName });
            viewModel.set("contentData", contentData);
            viewModel.set("languageContext", ctx.languageContext);

            this._viewModels.push(viewModel);

            return viewModel;
        },

        contentContextUpdated: function (ctx, callerData) {
            // summary:
            //    Called when the currently loaded content updated.
            // tags:
            //    protected

            var contentLink = ctx.id;
            this._pageDataStore.refresh(contentLink).then(function (contentData) {
                if (this._currentViewModel) {
                    this._updateContentViewModel(contentData, ctx.languageContext);
                    this._refreshModel(contentData, ctx);

                    // In some cases (dynamic properties change) we need to reload the view because the data is changed on server.
                    // Since there is no way to render newly changed server-side data so we reload the view on every contentContextUpdated.
                    this._onViewRequireReload();
                }
            }.bind(this));
        },

        updateView: function (callerData, ctx, additionalParams) {
            this._setActivityCommandModel();
            when(this._ensurePreviewReadyPromise, function () {
                if (callerData && callerData.skipUpdateView && callerData.viewName === this._currentViewModel.viewName) {
                    // notify view is changed
                    this._onViewChangeCompleted();
                    return;
                }

                // Hide our self when content is
                if (additionalParams && additionalParams.widgetResumed) {
                    domStyle.set(this.domNode, "visibility", "hidden");
                }

                if (callerData && callerData.contextIdSyncChange) {
                    //We need to refresh content data when content link change on sync.
                    this._pageDataStore.refresh(ctx.id).then(function (contentData) {
                        var oldContentLink = this._currentViewModel.contentData.contentLink;
                        this._updateContentViewModel(contentData, ctx.languageContext);
                        this._currentViewComponent.onContentLinkSyncChange(oldContentLink, contentData.contentLink);
                        this._refreshModel(contentData, ctx);
                        // notify view is changed
                        this._onViewChangeCompleted();
                    }.bind(this));
                } else {
                    if (this._currentViewModel) {
                        this._currentViewModel.suspend();
                    }

                    var viewName;

                    if (callerData && callerData.viewName) {
                        if (callerData.availableViews) {
                            // receive the available views list from widget switcher
                            // convert to hashtable for easier looking up.
                            this._availableViewsLookup = {};
                            array.forEach(callerData.availableViews, function (availableView) {
                                this._availableViewsLookup[availableView.key] = availableView;
                            }, this);
                        }
                        viewName = callerData.viewName;
                    }

                    // forceReload iframe in Preview mode or OPE mode (CMS-13478) when coming from all properties edit mode
                    var forceReload = callerData.forceReload;
                    if ((viewName === "view" || viewName === "onpageedit") && this._currentViewModel && this._currentViewModel.viewName === "formedit") {
                        forceReload = true;
                    }

                    return this._ensurePreviewReady(this._loadContentDataAndSetView(ctx.id, viewName, ctx, callerData.availableViews), true, forceReload, viewName);
                }
            }.bind(this));
        },

        _getPreviewUrl: function (viewName) {
            // summary:
            //      Gets the URL for the preview based on the requested view.
            // tags:
            //      private

            return when(this.getCurrentContext(), function (context) {
                return (viewName === "view" && context.previewUrl) ? context.previewUrl : context.editablePreviewUrl;
            });
        },

        _ensurePreviewReady: function (action, reload, forceReload, viewName) {
            // summary:
            //      Perform an action and reload preview iframe if needed.
            //      Raise OnPreviewReady event on the current view component when both are finished.
            // action: [Deferred|null]
            //      Action to execute
            //      The result returned by the action is boolean. When true, then overlays are forced to reload
            //
            // reload: [Boolean]
            //      Flag indicating if the preview frame should be reloaded or not
            //
            // forceReload: [Boolean]
            //    if true then reloads the page even if its the same url
            //    by default load will not trigger any request for the same url
            //    forceReload parameter is not forcing to reload overlays
            //
            // tags:
            //      private

            var def = new Deferred();

            if (action) {
                def = action;
            } else {
                def.resolve();
            }

            // notify view is changing
            this._onViewChangeRequest();

            // Only reload the iframe when not in all properties mode. This is to optimize the load
            // times for all properties mode.
            if (reload && viewName !== "formedit") {
                def = def.then(function (actionPromiseResult) {
                    return when(this._getPreviewUrl(viewName), function (url) {
                        return when(this._changeUrl(url, forceReload), function () {
                            // notify view is changed
                            this._onViewChangeCompleted();
                            return actionPromiseResult;
                        }.bind(this));
                    }.bind(this));
                }.bind(this));
            }

            this._ensurePreviewReadyPromise = when(def,
                function (actionPromiseResult) {
                    var doc = this.iframeWithOverlay.iframe.getDocument();
                    var props = this.iframeWithOverlay.iframe.siteProperties;
                    // wait for the setup of the overlay to become ready(update the overlay items needed) which will happen async in onPreviewReady
                    var handle = this.connect(this._currentViewComponent, "onPrepareOverlayComplete", function () {
                        this.disconnect(handle);
                        handle = null;

                        this.iframeWithOverlay.overlay.set("enabled", this._currentViewModel.get("showOverlay"));

                        // TODO: Enable the overlay again when we implement the user story #116539 - Projects - Editing while in Preview
                        // If the Projects preview is enabled disable the editing overlay
                        if (this._viewSettingsManager.get("enabled") && this._viewSettingsManager.getSettingProperty("project")) {
                            this.iframeWithOverlay.overlay.set("enabled", false);
                        }
                        this.iframeWithOverlay.layout(true);

                        // notify view is changed
                        this._onViewChangeCompleted();
                    });

                    // Make sure we're visible
                    domStyle.set(this.domNode, "visibility", "visible");

                    this._viewSettingsManager.onPreviewReady(this.iframeWithOverlay);
                    this._currentViewComponent.onPreviewReady(this._currentViewModel, doc, !!actionPromiseResult, props);

                    this._editNotifications.updateSettings({ viewModel: this._currentViewModel, viewSetting: this._viewSettingsManager });
                }.bind(this)
            );
            return this._ensurePreviewReadyPromise;
        },

        _loadContentDataAndSetView: function (contentLink, viewName, ctx, availableViews) {
            var def = new Deferred();

            // When we're editing data it will get already the fresh data from the server.
            when(this._pageDataStore.refresh(contentLink)).then(function (contentData) {

                // We need to update the toolbar even though we did not receive andy data
                this.toolbar.update({
                    currentContext: ctx,
                    viewConfigurations: {
                        availableViews: availableViews,
                        viewName: viewName
                    },
                    contentData: contentData
                });

                if (!contentData) {
                    return;
                }

                //Clear the notification bar when we are loading new content
                if (this._currentViewModel && this._currentViewModel.contentLink !== contentLink) {
                    this.notificationBar.clear();
                }

                this._currentViewModel = this._getViewModel(contentData.contentLink);

                // create a new viewModel if empty
                if (!this._currentViewModel) {
                    this._currentViewModel = this._createViewModel(contentData, ctx);
                    this._setActivityModel(contentData);
                } else {
                    // Always set the currentPage property since it might have been updated.
                    this._updateContentViewModel(contentData, ctx.languageContext);
                }

                this._currentViewModel.set("viewLanguage", this._viewSettingsManager.get("enabled") ? this._viewSettingsManager.getSettingProperty("viewlanguage") : null);

                this._refreshModel(contentData, ctx);

                when(this.setView(viewName)).then(function () {
                    // load content data should force the edit mode to setup because when the contentModel is re-populated, all the watches will go.
                    def.resolve(true);
                }).otherwise(function () {
                    def.cancel();
                });
            }.bind(this)).otherwise(function () {
                def.reject();
            });

            return def.promise;
        },

        _updateContentViewModel: function (contentData, languageContext) {
            this._currentViewModel.wakeUp();
            this._currentViewModel.set("contentData", contentData);
            this._currentViewModel.set("languageContext", languageContext);
            this._setActivityModel(contentData);
        },

        _refreshModel: function (contentData, context) {
            // summary:
            //      Sets the updated model on all the commands and notifications.

            // NOTE: This method should be the target of some serious PageDataController refactoring.
            var model = this._currentViewModel;
            if (model) {
                // Update the toolbars model
                this.toolbar.set("contentViewModel", model);

                // Set view model to the extensions first
                this._inUseNotificationManager.updateCommandModel(model);

                // Push the new content to the commands
                this._editingCommands.set("model", model);

                // update all custom notifications
                this._editNotifications.update(contentData, context, model);
            }
        },

        itemChanged: function (id, item) {
            // summary:
            //		Notification event when an item has been patched or reloaded.
            // object: id
            //		The id of the updated item.
            // object: item
            //		The updated item.
            // tags:
            //		public


        },

        setView: function (viewName, viewParams) {
            // summary:
            //      Set and load current view handler.
            // viewName: String
            //      Alias name of view handler class. Known views are: view, onpageedit, formedit, readonly.
            // viewParams: Object
            //      Parameters to be mixed in view handler on creation.
            // tags:
            //      public

            var def = new Deferred();

            // Quick fix for the content that do not have template and default view is ope or the ope is not avaiable.
            // The proper fix will come after 7.5 release when we have strong type representation for system pages and content type which have no template.
            if (viewName === "onpageedit" && (!this._currentViewModel.contentData.hasTemplate || !(viewName in this._availableViewsLookup))) {
                viewName = "formedit";
            }

            // Edge case: decoupled mode, when the content type doesnt exists we neither have a document or properties
            // Create an array to allow onPreviewReady to call setupEditMode
            if (viewName === "formedit" && !this.iframeWithOverlay.isOverlayPrerequisitesReady()) {
                this.iframeWithOverlay.resetSiteProperties();
            }

            // exit if it's the current view or view is unknown
            if (viewName && !(viewName in this._availableViewsLookup)) {
                return;
            }

            var onResolved = function () {
                when(this._setView(viewName, viewParams), function () {
                    def.resolve();
                }, function () {
                    def.cancel();
                });
            }.bind(this);

            var onRejected = function () {
                topic.publish("/epi/cms/action/showerror");
                def.cancel();
            };

            when(this._savePendingChanges(), onResolved, onRejected);

            return def;
        },

        _setView: function (viewName, viewParams) {
            var def = new Deferred(),
                component = this._currentViewComponent,
                reuseCurrentViewComponent = component && component.viewModel && component.viewModel.viewName === viewName;

            var resolveDeferred = function (def) {
                // NOTE: The leftover is kept on the editLayoutContainer for the sake of a better feeling when switching between ope and form.
                // Other views rather than ones that implement _FormEditingMixin may have no idea about it. Therefore, the controller should be responsible for a cleanup.
                // For the long run, to avoid the left over things, form editing and ope should be combined into one view.
                if (this.editLayoutContainer.leftOver && !this._currentViewComponent.canHandleLeftOver) {
                    when(this.editLayoutContainer.selectedChildWidget === this.editLayoutContainer.leftOver ? this.editLayoutContainer.selectChild(this.iframeWithOverlay) : null,
                        function () {
                            this.editLayoutContainer.removeChild(this.editLayoutContainer.leftOver);
                            this.editLayoutContainer.leftOver.destroyRecursive();
                            this.editLayoutContainer.leftOver = null;
                        }.bind(this)
                    );
                }

                def.resolve();
            }.bind(this);

            topic.publish("/epi/shell/action/changeview/updatestate", { viewName: viewName });

            if (reuseCurrentViewComponent) {
                this._currentViewModel.viewName = viewName;
                this.toolbar.set("contentViewModel", this._currentViewModel);

                resolveDeferred(def);
            } else {
                // destroy current view
                this._destroyCurrentViewComponent();

                var widgetType = this._availableViewsLookup[viewName].viewType;

                require([widgetType], function (widgetClass) {
                    // create new instance
                    this._currentViewComponent = new widgetClass(lang.mixin({
                        mainLayoutContainer: this.mainLayoutContainer,
                        editLayoutContainer: this.editLayoutContainer,
                        iframeWithOverlay: this.iframeWithOverlay,
                        contextTypeName: this.contextTypeName,
                        toolbar: this.toolbar
                    }, viewParams));

                    this._currentViewComponentReloadRequireHandle = this.connect(this._currentViewComponent, "onReloadRequired", this._onViewRequireReload);

                    this._currentViewComponent.on("dom-updated", debounce(this._onDomUpdated, this, 100));

                    this._currentViewComponent.startup();

                    this._currentViewModel.viewName = viewName;
                    this.toolbar.set("contentViewModel", this._currentViewModel);

                    resolveDeferred(def);
                }.bind(this));
            }

            return def;
        },

        _onViewRequireReload: function () {
            return this._ensurePreviewReady(null, true, true, this._currentViewModel.viewName);
        },

        _onViewRenderPostedProperties: function () {
            var result = new Deferred();
            result.resolve(true); // this deferred result true is responsible for reloading overlays

            this._ensurePreviewReady(result.promise, false, false, this._currentViewModel.viewName);
        },

        resize: function (size) {
            // summary:
            //    Call this to resize a widget, or after its size has changed.
            // tags:
            //    public
            this.inherited(arguments);

            if (this._started) {
                this.mainLayoutContainer.resize(size);
            }
        },

        onShow: function () {
            // summary:
            //    Called by container widgets when showing this widget.
            this.iframeWithOverlay.overlay.set("enabled", true);

            // make sure the overlay isn't read only when we show it.
            this.iframeWithOverlay.overlay.set("readOnly", false);
        },

        onHide: function () {
            // summary:
            //    Called by container widgets when hiding this widget.
            this.iframeWithOverlay.overlay.set("enabled", false);

            // The notification area is shared between multiple views
            // so we need to reset the notifications for this view before loading the new
            if (this._currentViewModel) {
                this._currentViewModel.resetNotifications();
            }
        },

        _requestContextChangeByUrl: function (url, forceContextChange, suppressFailure, params, mixWithExistingParams) {

            var newUrl = new Url(url, params, mixWithExistingParams),
                contextParameters = { url: newUrl.toString() },
                callerData = {
                    sender: this,
                    forceContextChange: forceContextChange,
                    suppressFailure: suppressFailure,
                    viewName: this._currentViewModel && this._currentViewModel.viewName
                };

            topic.publish("/epi/shell/context/request", contextParameters, callerData);
        },

        _changeUrl: function (url, forceReload) {
            var previewParams = lang.mixin(this._previewQueryParameters, this._viewSettingsManager.get("previewParams"));

            // when reloading URL the properties are not relevant anymore, so we need to clear them
            if (this.iframeWithOverlay.hasSiteProperties()) {
                this.iframeWithOverlay.resetSiteProperties();
                this._currentViewComponent.onPreviewReady(this._currentViewModel, null, true, []);
            }

            // we want a reload even if its a same url in order to render all kind of contents (i.e videos)
            return this.iframeWithOverlay.iframe.load(url, { query: previewParams }, true, forceReload);
        },

        _interceptRequestContext: function (newContextParams, callerData) {

            // intercept all context requests so we can resolve any pending changes before context changes

            if (!(callerData && callerData.sender && callerData.sender === this)) {
                // a new context request, resolve pending changes
                return this._savePendingChanges();
            } else {
                var def = new Deferred();
                def.resolve();
                return def;
            }
        },

        _savePendingChanges: function () {
            // summary:
            //      Save all pending changes if they haven't allready been saved
            // tags:
            //      private

            //If we currently are waiting for a save to complete return the old promise
            if (this._saveDeferred && !this._saveDeferred.isFulfilled()) {
                return this._saveDeferred.promise;
            } else {
                this._saveDeferred = new Deferred();
            }
            //If the there are unsaved changes on the viewmodel and no errors, save and wait until all changes has been saved
            if (this._currentViewModel && this._currentViewModel.get("hasPendingChanges") && !this._currentViewModel.get("hasErrors")) {
                var handle = this._currentViewModel.watch("hasPendingChanges", function (name, oldValue, newValue) {
                    if (!newValue) {
                        handle.remove();
                        handle = null;

                        //Resolve the save deferred when all changes has been saved
                        this._saveDeferred.resolve();
                    }
                }.bind(this));

                this._currentViewModel.save();
            } else {
                // resolve immediately
                this._saveDeferred.resolve();
            }
            return this._saveDeferred.promise;
        },

        savePendingChanges: function () {
            // summary:
            //      Save all pending changes if they haven't already been saved
            // tags:
            //      internal

            return this._savePendingChanges();
        },

        _injectCssRules: function () {
            this.iFrame.addCssRules(this.defaultEditCssRules);
        },

        _undoAction: function () {
            // summary:
            //    Undo changes on the current viewmodel
            // tags:
            //    protected

            if (this.get("isActive") && this._currentViewModel) {
                this._currentViewModel.undo();
            }
        },

        _redoAction: function () {
            // summary:
            //    Redo the changes on the current viewmodel
            // tags:
            //    protected

            if (this.get("isActive") && this._currentViewModel) {
                this._currentViewModel.redo();
            }
        },

        _saveAction: function () {
            // summary:
            //    Trigger save on the current viewmodel
            // tags:
            //    protected

            if (this.get("isActive") && this._currentViewModel) {
                this._currentViewModel.save();
            }
        },

        _onDomUpdated: function () {
            // summary:
            //    Remaps the overlays
            // tags:
            //    private

            if (!this._currentViewComponent) {
                return;
            }
            var doc = this.iframeWithOverlay.iframe.getDocument();
            this._currentViewComponent.onPreviewReady(this._currentViewModel, doc, false);
        },

        _setIsActiveAttr: function (value) {
            this._set("isActive", value);

            if (value) {
                this._currentViewModel && this._currentViewModel.wakeUp();
                this._editNotifications.wakeUp();
            } else {
                this._viewModels.forEach(function (viewModel) {
                    viewModel.suspend();
                });
                this._editNotifications.suspend();
            }
        },

        _toggleActivities: function () {
            domClass.toggle(this.activityFeed.domNode, "dijitHidden", !this.activityModel.isActivitiesVisible);
            domClass.toggle(this.activityFeed._splitterWidget.domNode, "dijitHidden", !this.activityModel.isActivitiesVisible);
            this._loadSettings();
            this.mainLayoutContainer.layout();
        },

        _setActivityCommandModel: function () {
            var commandProvider = dependency.resolve("contentActivityCommandProvider");
            commandProvider.updateCommandModel(this.activityModel);
        },

        _setActivityModel: function (contentData) {
            this.activityModel.set({
                contentLink: contentData.contentLink,
                name: contentData.name
            });
        },

        _loadSettings: function () {
            // summary:
            //    Loads comments pane settings
            //    Use the default size when the settings' size is larger than the mainLayoutContainer's size
            // tags:
            //    private
            var settings = this.activityModel.getActivityFeedSettings();
            if (!settings || !settings.size
                || domStyle.get(this.mainLayoutContainer.domNode, "width") < settings.size) {
                return;
            }
            domStyle.set(this.activityFeed.domNode, "width", settings.size + "px");
        }
    });
});

},
'epi-cms/contentediting/EditNotifications':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",

    "epi/shell/DestroyableByKey",
    "epi-cms/plugin-area/edit-notifications"
], function (
    declare,
    lang,
    Evented,

    DestroyableByKey,
    editNotifications
) {

    return declare([DestroyableByKey, Evented], {
        // summary:
        //    Watches and handles plugged editing notifications.
        // tags:
        //    internal

        _notificationChangedKey: "_EditingNotificationHandles",
        _notificationsKey: "_notifications",

        _notifications: null,

        postscript: function () {
            this.inherited(arguments);

            this.own(editNotifications.on("added, removed", this._watchNotifications.bind(this)));

            this._watchNotifications();
        },

        update: function (contentData, context, contentViewModel, isInQuickEditMode) {
            // summary:
            //      Updates all notifications with current content data and context.
            // tags:
            //    public

            this._notifications.forEach(function (notification) {
                notification.set("value", {
                    contentData: contentData,
                    context: context,
                    contentViewModel: contentViewModel,
                    isInQuickEditMode: isInQuickEditMode
                });
            });
        },

        updateSettings: function (settings) {
            this._notifications.forEach(function (notification) {
                notification.set("settings", settings);
            });
        },

        suspend: function () {
            // summary:
            //      Suspends all notifications
            // tags:
            //    public

            this._notifications.forEach(function (notification) {
                notification.set("isSuspended", true);
            });
        },

        wakeUp: function () {
            // summary:
            //      Wakes all notifications up.
            // tags:
            //    public

            this._notifications.forEach(function (notification) {
                notification.set("isSuspended", false);
            });
        },

        _watchNotifications: function () {
            // summary:
            //      Updates notifications when notifications are added or removed
            // tags:
            //      private

            this.destroyByKey(this._notificationsKey);
            this._notifications = editNotifications.get()
                .sort(function (a, b) {
                    return a.order - b.order;
                })
                .map(function (notification) {
                    this.ownByKey(this._notificationsKey, notification);
                    return notification;
                }, this);

            this.destroyByKey(this._notificationChangedKey);
            this._notifications.forEach(function (notification) {
                this.ownByKey(
                    this._notificationChangedKey,
                    notification.watch("notification", function (name, oldValue, newValue) {
                        this.emit("changed", {
                            notification: notification,
                            oldValue: oldValue,
                            newValue: newValue
                        });
                    }.bind(this))
                );
            }, this);
        },

        getAvailableNotificationIndex: function (notification) {
            // summary:
            //      Get index of notification based on notifications sort order
            // tags:
            //      public

            if (typeof notification.order === "undefined") {
                return undefined;
            }

            var availableNotifications = this._notifications.filter(function (n) {
                return n !== notification && n.notification && n.notification.content;
            });

            var insertIndex = 0;
            availableNotifications.forEach(function (n, childIndex) {
                if (notification.order >= n.order) {
                    insertIndex = childIndex + 1;
                }
            }, this);
            return insertIndex;
        }
    });
});

},
'epi-cms/plugin-area/edit-notifications':function(){
define([
    "epi/PluginArea",
    "epi-cms/contentediting/ContentReferencesNotification",
    "epi-cms/contentediting/LanguageNotification",
    "epi-cms/contentediting/ExpirationNotification",
    "epi-cms/contentediting/FuturePublishingDateNotification",
    "epi-cms/project/ProjectNotification",
    "epi-cms/contentediting/ShortcutNotification",
    "epi-cms/contentediting/ViewSettingsNotification"
], function (
    PluginArea,
    ContentReferencesNotification,
    LanguageNotification,
    ExpirationNotification,
    FuturePublishingDateNotification,
    ProjectNotification,
    ShortcutNotification,
    ViewSettingsNotification
) {
    /*=====
    return {
        // summary:
        //      A plugin area for the edit notifications.
        // tags:
        //      public
    };
    =====*/

    var pluginArea = new PluginArea("epi-cms/edit/notifications[]");

    // add default edit notifications here

    pluginArea.add(ProjectNotification);
    pluginArea.add(ShortcutNotification);
    pluginArea.add(ViewSettingsNotification);
    pluginArea.add(ContentReferencesNotification);
    pluginArea.add(LanguageNotification);
    pluginArea.add(ExpirationNotification);
    pluginArea.add(FuturePublishingDateNotification);


    return pluginArea;
});

},
'epi/PluginArea':function(){
define("epi/PluginArea", [
    "dojo/_base/declare",
    "dojo/Evented",
    "epi/locator"
], function (
    declare,
    Evented,
    locator
) {

    return declare([Evented], {
        // summary:
        //      Base class for plugin area modules.
        // tags:
        //      internal

        constructor: function (identifier) {
            // An identifier must be supplied.
            if (typeof identifier !== "string" || identifier === "") {
                throw new Error("The argument 'identifier' must be a non-empty string.");
            }

            this._identifier = identifier;

            //Auto register the key in the locator so that we always get an array back
            locator.add(identifier, []);

            locator.on(identifier, this.emit.bind(this));

        },

        add: function (service) {
            return locator.add(this._identifier, service);
        },

        get: function () {
            return locator.get(this._identifier);
        }
    });
});

},
'epi/locator':function(){
define("epi/locator", ["dojo/Evented", "dojo/has", "dojo/string"], function (Evented, has, string) {

    var arrayRegex = /.+\[\]$/,
        cache = {},
        evented = new Evented();

    return {
        // summary:
        //      This module functions as a service locator, allowing classes or objects to be
        //      added against an identifier. Identifiers can end with array notation to indicate
        //      that the service should be added to a collection.
        // tags:
        //      internal

        add: function (identifier, service) {
            // summary:
            //      Adds the service for the given identifier.
            // identifier: String
            //      The identifier against which the service will be registered.
            // service: Class|Object
            //      The class or object to be registered.
            // tags:
            //      public

            // An identifier must be supplied.
            if (typeof identifier !== "string" || identifier === "") {
                throw new Error("The argument 'identifier' must be a non-empty string.");
            }

            // Do not allow registered services to be overridden.
            var isArray = arrayRegex.test(identifier);
            if (!isArray && cache[identifier]) {
                throw new Error(string.substitute("A service with the identifier '${0}' has already been registered.", [identifier]));
            }

            cache[identifier] = isArray ? (cache[identifier] || []).concat(service) : service;

            // Emit an event indicating that the service for the identifier has changed.
            evented.emit(identifier, "added");

            return {
                remove: this.remove.bind(this, identifier, service)
            };
        },

        get: function (identifier) {
            // summary:
            //      Gets the service associated with the given identifier.
            // identifier: String
            //      The identifier of the service to load.
            // tags:
            //      public

            var cachedService = cache[identifier];
            if (cachedService === undefined) {
                if (has("epi-ignore-undefined-dependencies")) {
                    return;
                }
                throw new Error(string.substitute("No service has been registered for the identifier '${0}'.", [identifier]));
            }

            // Helper method to construct classes if needed.
            var initializeService = function (service) {
                return (typeof service === "function") ? new service() : service;
            };

            if (arrayRegex.test(identifier)) {
                return cachedService.map(initializeService);
            }

            return initializeService(cachedService);
        },

        // Expose evented on method so that it is possible to observe changes on a service.
        on: evented.on.bind(evented),

        remove: function (identifier, service) {
            // summary:
            //      Removes the service associated with the given identifier.
            // identifier: String
            //      The identifier associated with the service to be removed.
            // service: Class|Object
            //      The class or object to be removed.
            // tags:
            //      public

            // Early exit if the service doesn't exist since it may have been removed already.
            var cachedService = cache[identifier];
            if (cachedService === undefined) {
                return;
            }

            if (arrayRegex.test(identifier)) {
                // Remove the service from the array for collection identifiers.
                var index = cachedService.indexOf(service);
                if (index > -1) {
                    cachedService.splice(index, 1);
                }
            } else {
                // Remove the service for individual identifiers.
                delete cache[identifier];
            }

            // Emit an event indicating that the service for the identifier has changed.
            evented.emit(identifier, "removed");
        }
    };
});

},
'epi-cms/contentediting/ContentReferencesNotification':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/dom-construct",
    "dojo/Stateful",
    "dojo/on",
    "dojo/when",
    // epi
    "epi/epi",
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/DestroyableByKey",
    "epi-cms/command/BackCommand",
    "epi-cms/widget/sharedContentDialogHandler",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.notificationbar"
],

function (
// dojo
    array,
    declare,
    event,
    domConstruct,
    Stateful,
    on,
    when,
    // epi
    epi,
    dependency,
    TypeDescriptorManager,
    DestroyableByKey,
    BackCommand,
    sharedContentDialogHandler,
    // resources
    resources
) {

    return declare([Stateful, DestroyableByKey], {
        // tags:
        //      internal

        // order: [public] Number
        //      Sort order of notification
        order: 40,

        // _backCommand: BackCommand
        _backCommand: null,
        _clickHandleKey: "clickHandle",

        constructor: function () {
            this._backCommand = new BackCommand();
        },

        postscript: function () {
            this.inherited(arguments);

            this._store = this._store || dependency.resolve("epi.storeregistry").get("epi.cms.referenced-content");
        },

        _valueSetter: function (/*Object*/value) {
            // summary:
            //      Updates the notification when the property changes.
            // tags:
            //      private

            this.value = value;

            var typeShouldActAsAsset = TypeDescriptorManager.getValue(value.contentData.typeIdentifier, "actAsAnAsset");
            var isHeadlessBlock = value && value.contentData && value.contentData.capabilities && value.contentData.capabilities.isHeadlessBlock;
            if (!typeShouldActAsAsset || isHeadlessBlock) {
                this.set("notification", null);
                return;
            }

            when(this._store.query({ids: [value.contentData.contentLink]}))
                .then(this._updateNotification.bind(this));
        },

        _updateNotification: function (itemsList) {

            if (!itemsList) {
                this.set("notification", null);
                return;
            }

            var references = itemsList[0].references;

            // when inside QuickEdit it does not make sense to show the notification in that case
            // the item is always referenced, 0 could be returned if the parent item has not been published yet
            // it would return 1 if it has been published but still it does not make sense to show it because we are already on that content item
            if (this.value.isInQuickEditMode && references.length <= 1) {
                this.set("notification", null);
                return;
            }

            var notificationText = domConstruct.create("div");
            if (references.length > 0) {
                notificationText.innerHTML += resources.affect;

                var referencesText = references.length + " " + (references.length === 1 ? epi.resources.text.item : epi.resources.text.items),
                    self = this,
                    referenceslink = domConstruct.create("a", { href: "#", innerHTML: referencesText, title: resources.referencestooltip }, notificationText);

                this.destroyByKey(this._clickHandleKey);
                this.ownByKey(this._clickHandleKey, on(referenceslink, "click", function (evt) {
                    event.stop(evt);
                    self._showReferenceDialog();
                }));
            } else {
                notificationText.innerHTML += epi.resources.messages.notinuse;
            }

            //to update canExecute on command :'(
            this._backCommand.set("model", {});

            this._backCommand.set("isAvailable", !this.value.isInQuickEditMode);

            this.set("notification", {
                content: notificationText,
                commands: [this._backCommand]
            });
        },

        _showReferenceDialog: function () {
            sharedContentDialogHandler({
                contentItems: [this.get("value").contentData],
                showToolbar: true,
                mode: sharedContentDialogHandler.mode.show
            });
        }
    });
});

},
'epi-cms/command/BackCommand':function(){
﻿define([
    "dojo/_base/declare",

    "dojo/topic",

    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/i18n!epi/cms/nls/episerver.cms.command"
],
function (
    declare,

    topic,

    dependency,
    _Command,
    resources
) {
    return declare([_Command], {
        // tags:
        //      public

        label: resources.backtoprevious,

        tooltip: resources.backtoprevious,

        category: "leftAligned",

        iconClass: "epi-iconLeft",

        cssClass: "epi-chromelessButton epi-visibleLink",

        _previousContent: null,

        postscript: function () {
            this.inherited(arguments);
            this.contextHistory = this.contextHistory || dependency.resolve("epi.cms.BackContextHistory");
        },

        _execute: function () {
            topic.publish("/epi/shell/context/request", { uri: this._previousContent.uri }, { trigger: "back", sender: this });
        },

        _onModelChange: function () {
            this._previousContent = this.contextHistory.getPrevious();
            this.set("canExecute", this._previousContent != null);
        }
    });
});

},
'epi-cms/contentediting/LanguageNotification':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/url",
    "dojo/Stateful",

    "dojo/dom-construct",

    // epi
    "epi/dependency",
    // epi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/command/Editing",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.languagenotification"
],

function (
// dojo
    declare,
    lang,
    array,
    Url,
    Stateful,

    domConstruct,

    // epi
    dependency,

    // epi CMS
    ApplicationSettings,
    EditingCommands,

    resources
) {

    return declare([Stateful], {
        // summary:
        //      Language notification
        // description:
        //      Show notification for language on a related page
        // tags:
        //      internal

        // order: [public] Number
        //      Sort order of notification
        order: 50,

        _valueSetter: function (data) {
            // summary:
            //      Updates the notification when the property changes.
            // tags:
            //      private

            var context = data.context;

            if (!context.languageContext) {
                this.set("notification", null);
                return;
            }

            var store = dependency.resolve("epi.storeregistry").get("epi.cms.language");

            store.query().then(lang.hitch(this, function (languages) {
                var languageResource = {};
                array.forEach(languages, function (language) {
                    languageResource[language.languageId] = language.name;
                }, this);

                var content = context.languageContext.warning;
                var currentContentLanguage = ApplicationSettings.currentContentLanguage;
                var languageContext = context.languageContext;

                var switchToLanguage;
                if (currentContentLanguage !== languageContext.preferredLanguage && languageContext.isTranslationNeeded) {
                    content = lang.replace(resources.nottranslatedswitchto, [languageResource[languageContext.language], languageResource[languageContext.preferredLanguage]]);
                    switchToLanguage = languageContext.preferredLanguage;
                } else if (currentContentLanguage !== languageContext.language && !languageContext.isTranslationNeeded) {
                    var languageName = languageResource[currentContentLanguage];
                    var contextLanguageName = languageResource[languageContext.language];
                    if (languageName && contextLanguageName) {
                        content = lang.replace(resources.workinginwrongsite,
                            [languageName, contextLanguageName]);
                    } else {
                        content = resources.languagenotenabled;
                    }
                    switchToLanguage = languageContext.language;
                }

                if (!content) {
                    //clear old language notification
                    this.set("notification", null);

                    return;
                }

                var html = domConstruct.create("div", {innerHTML: content});

                var switchToLanguageName = languageResource[switchToLanguage];
                if (switchToLanguageName) {
                    var url = new Url(window.top.location.href);
                    var text = lang.replace(resources.switchto, [switchToLanguageName]);

                    domConstruct.create("a", {
                        href: [url.scheme, "://", url.authority, url.path, "?language=", switchToLanguage, "#context=", context.versionAgnosticUri].join(""),
                        innerHTML: text,
                        title: text}, html);
                }

                this.set("notification", {
                    content: html,
                    //If the the content requires a translation and the current content language is the same as the requested language we can show the command
                    commands: languageContext.isTranslationNeeded && currentContentLanguage === languageContext.preferredLanguage ? [EditingCommands.translate] : []
                });

            }));
        }
    });

});

},
'epi-cms/contentediting/ExpirationNotification':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/Stateful",

    "dojo/string",
    // epi
    "epi/datetime",
    "epi/dependency",

    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/command/ManageExpiration",

    "epi/i18n!epi/cms/nls/episerver.cms.widget.expirationeditor",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.versionstatus"
],

function (
// dojo
    declare,
    Stateful,

    string,
    // epi
    epiDatetime,
    dependency,

    ApplicationSettings,
    ManageExpiration,

    expirationeditorResources,
    versionstatusResources
) {

    return declare([Stateful], {
        // summary:
        //      Provides notifications for content that has an expiration set.
        // tags:
        //      internal

        // order: [public] Number
        //      Sort order of notification
        order: 60,

        postscript: function () {
            this.inherited(arguments);

            this._notificationPeriod = ApplicationSettings.expirationNotificationPeriod;
            this._manageExpirationCommand = new ManageExpiration();

            this._setupCommands();
        },

        _valueSetter: function (/*Object*/context) {
            // summary:
            //      Updates the notification when the property changes.
            // tags:
            //      private

            this.context = context;

            var expireBlock = context.contentData.properties.iversionable_expire;
            if (context.contentViewModel) {
                this._manageExpirationCommand.set("model", context.contentViewModel);
            }

            this._updateNotification(expireBlock);
        },

        _updateNotification: function (expireBlock) {
            var serverTime = epiDatetime.serverTime();

            var stopPublish = expireBlock ? expireBlock.stopPublish : null,
                expiration = new Date(stopPublish);

            var text = null;
            if (stopPublish && epiDatetime.isDateValid(expiration)) {
                if (new Date(serverTime.getTime() + this._notificationPeriod * 1000) > expiration) {
                    text = expiration < serverTime
                        ? versionstatusResources.expired
                        : string.substitute(expirationeditorResources.expiretimetext, [epiDatetime.timeToGo(expiration)]);
                }
            }
            if (!text) {
                this.set("notification", null); //clear notification
            } else {
                this.set("notification", { content: text, commands: [this.context.isInQuickEditMode ? this._manageExpirationCommand : this._editingCommands.manageExpiration] });
            }
        },

        _viewModelValueHandler: null,

        _setupCommands: function () {
            if (!this._editingCommands) {
                this._editingCommands = dependency.resolve("epi.cms.contentEditing.command.Editing");
            }

            if (this._commandsWatchHandler) {
                this._commandsWatchHandler.unwatch();
            }

            var self = this;
            self._commandsWatchHandler = this._editingCommands.manageExpiration.watch("viewModel", function (name, oldViewModel, viewModel) {

                // remove the old observer
                if (self._viewModelValueHandler) {
                    self._viewModelValueHandler.unwatch();
                }

                self._viewModelValueHandler = viewModel.watch("value", function (name, oldValue, value) {
                    self._updateNotification(value);
                });
            });
        }

    });

});

},
'epi-cms/contentediting/FuturePublishingDateNotification':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/string",

    // epi
    "epi/datetime",
    "epi-cms/contentediting/ContentActionSupport",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.futurepublishingdate"
], function (
// dojo
    declare,
    Stateful,
    string,

    // epi
    datetime,
    ContentActionSupport,

    // resources
    resources
) {

    return declare([Stateful], {
        // summary:
        //      Show message if the page is published and the date is set to the "future"
        // tags:
        //      internal

        // order: [public] Number
        //      Sort order of notification
        order: 70,

        // notification: [public] Object
        //      Notification object format: { content: "notification message" }
        notification: null,

        _valueSetter: function (value) {
            // summary:
            //      Updates the notification when the property changes.
            // tags:
            //      private
            var contentData = value && value.contentData;

            if (contentData.status === ContentActionSupport.versionStatus.Published) {

                var publishedDate = new Date(contentData.properties.iversionable_startpublish);

                // compare the publish date with current server time without seconds/milliseconds part
                publishedDate.setSeconds(0, 0);

                if (publishedDate.getTime() > datetime.serverTime()) {

                    var message = string.substitute(resources.message, [datetime.toUserFriendlyHtml(publishedDate)]);

                    this.set("notification", { content: message });
                    return;
                }
            }
            this.set("notification", null);
        }
    });
});

},
'epi-cms/project/ProjectNotification':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/keys",
    "dojo/promise/all",
    "dojo/on",
    "dojo/Stateful",
    "dojo/topic",
    "dojo/when",

    // epi
    "epi/dependency",
    "epi/shell/DestroyableByKey",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/command/CreateDraft",
    "epi-cms/core/ContentReference",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.notifications"
], function (
    // dojo
    declare,
    lang,
    keys,
    all,
    on,
    Stateful,
    topic,
    when,

    // epi
    dependency,
    DestroyableByKey,
    ApplicationSettings,
    CreateDraft,
    ContentReference,

    // resources
    resources
) {
    var projectLinksKey = "projectLinks";

    function createProjectIconEl() {
        var span = document.createElement("span");
        span.classList.add("dijitReset", "dijitInline", "dijitIcon", "epi-objectIcon", "epi-iconProject");
        return span;
    }

    function createMessageContainerEl() {
        var span = document.createElement("span");
        span.classList.add("dijitReset", "dijitInline", "epi-project-notification__content");
        return span;
    }

    return declare([Stateful, DestroyableByKey], {
        // summary:
        //      Show notification if the content is part of a project
        // tags:
        //      internal

        // order: [public] Number
        //      Sort order of notification
        order: 10,

        // _projectService: [private] ProjectService
        //      A service for interacting with projects
        _projectService: null,

        // _createDraftCommand: [private] Command
        //      The create draft command that will be displayed when the current
        //      content is not part of the selected project.
        _createDraftCommand: null,

        // _projectService: [private] Array
        //      Local cache for notifications
        _notifications: null,

        constructor: function (params, projectService) {
            // summary:
            //      Constructs the ProjectNotification
            //
            // params: Object
            //      The keyword arguments
            //
            // projectService: ProjectService?
            //      ProjectService dependency, it is isn't provided it will load it from the epi/dependency

            this._projectService = projectService || dependency.resolve("epi.cms.ProjectService");

            this._createDraftCommand = new CreateDraft({ ignoreContentStatus: true });

            this.own(
                this._projectService.on("project-item-updated", lang.hitch(this, this._onItemUpdated)),
                this._projectService.on("project-item-removed", lang.hitch(this, this._onItemRemoved)),
                this._projectService.on("project-updated", function () {
                    this._onModelChanged(this.value);
                }.bind(this))
            );
        },

        _valueSetter: function (value) {
            // summary:
            //      Updates the notification when the property changes.
            // tags:
            //      private

            var contentModel = value.contentViewModel;
            this.value = contentModel;

            if (!contentModel || !contentModel.contentLink) {
                this.set("model", null);
                this._currentProjectItemId = 0;
                return;
            }

            this._createDraftCommand.set("model", contentModel);

            // Watch the model for changes to the content link since will occur when a new draft is created.
            var ownKey = "contentLinkWatch";
            this.destroyByKey(ownKey);
            this.ownByKey(ownKey, contentModel.watch("contentLink", lang.hitch(this, "_onModelChanged", contentModel)));

            // Invoke the model change callback since we have just set the model.
            this._notifications = {};
            this._onModelChanged(contentModel);
        },

        _onItemUpdated: function (item) {
            this._onItemsAddedOrRemoved(item.id);
        },

        _onItemRemoved: function (id) {
            this._onItemsAddedOrRemoved(id);
        },

        _onItemsAddedOrRemoved: function (projectItemId) {
            if (!this.model) {
                return;
            }

            if (this._currentProjectItemId === projectItemId) {
                this._projectService.getProjectsForContent(this.model.contentLink).then(function (projectItems) {
                    this._updateNotification(this.model.contentLink, projectItems);
                }.bind(this));
            }
        },

        _onModelChanged: function (contentModel) {
            // summary:
            //      Updates the notification when the model changes.
            // tags:
            //      private

            // If the model is suspended do not load or update the notification
            if (contentModel.get("isSuspended")) {
                return;
            }

            if (this._notifications && Object.prototype.hasOwnProperty.call(this._notifications, contentModel.contentLink)) {
                return;
            }

            this._projectService.getProjectItemsForContent(contentModel.contentLink)
                .then(function (projectItems) {
                    var languageContext = contentModel.languageContext,
                        isTranslationNeeded =
                                languageContext && languageContext.isTranslationNeeded &&
                                ApplicationSettings.currentContentLanguage === languageContext.preferredLanguage;

                    this.set("model", contentModel);
                    var projectItem = this._projectService.getCurrentProjectItemFromProjectItems(projectItems, contentModel.contentLink);
                    this._currentProjectItemId =  projectItem && projectItem.id || 0;

                    this._updateNotification(contentModel.contentLink, projectItems, contentModel.contentData.isPartOfAnotherProject, isTranslationNeeded);
                    this._notifications[contentModel.contentLink] = this._currentProjectItemId;
                }.bind(this))
                .otherwise(function () {
                    this._currentProjectItemId = 0;
                }.bind(this));
        },

        _updateNotification: function (contentLink, projectItems, isPartOfAnotherProject, isTranslationNeeded) {
            var self = this;

            this.destroyByKey(projectLinksKey);

            all([this._projectService.getProjects(projectItems), this._projectService.getCurrentProject()]).then(function (result) {
                var projects = result[0],
                    currentProject = result[1];

                if (projects.length === 0) {
                    if (isPartOfAnotherProject) {
                        this.set("notification", null);
                        return;
                    }

                    self._checkAnotherVersionInProject(contentLink);
                    return;
                }

                var contentEl = document.createElement("div");
                contentEl.appendChild(createProjectIconEl());

                //Create the part of project text
                var projectContainerEl = createMessageContainerEl();
                contentEl.appendChild(projectContainerEl);

                if (isPartOfAnotherProject) {
                    var partOfAnotherProjectEl = document.createTextNode(resources.partofanotherproject + ": ");
                    projectContainerEl.appendChild(partOfAnotherProjectEl);
                    self._createClickableProjectsLinks(projectContainerEl, projects);
                } else if (currentProject) {
                    var currentProjectLinkHtml = "<a class=\"dijitReset dijitButtonText\" tabIndex=\"0\">" + resources.current + "</a>";
                    var currentProjectHtml = lang.replace(resources.partofcurrentproject, {
                        currentPlaceholder: currentProjectLinkHtml
                    });

                    projectContainerEl.innerHTML = currentProjectHtml;
                    self._attachProjectNameClickEvent(projectContainerEl.querySelector("a"), currentProject);
                } else {
                    var partOfProjectEl = document.createTextNode(resources.partofproject + ": ");
                    projectContainerEl.appendChild(partOfProjectEl);
                    self._createClickableProjectsLinks(projectContainerEl, projects);
                }

                var commands =
                        isPartOfAnotherProject && self._projectService.isProjectModeEnabled && !isTranslationNeeded ?
                            [self._createDraftCommand] : [];

                self.set("notification", {
                    content: contentEl,
                    commands: commands
                });
            });
        },

        _checkAnotherVersionInProject: function (contentLink) {
            // summary:
            //      Check if another content version is a part of the project
            // tags:
            //      private

            contentLink = (new ContentReference(contentLink)).createVersionUnspecificReference().toString();

            when(this._projectService.getProjectsForContent(contentLink)).then(function (projects) {
                if (projects.length === 0) {
                    this.set("notification", null);
                    return;
                }

                // remove duplicated projects
                var projectIds = projects.map(function (project) {
                    return project.id;
                });
                projects = projects.filter(function (project, index) {
                    return projectIds.indexOf(project.id) === index;
                });

                var contentEl = document.createElement("div");
                contentEl.appendChild(createProjectIconEl());

                var projectContainerEl = createMessageContainerEl();
                contentEl.appendChild(projectContainerEl);

                var contentText = document.createTextNode(resources.anotherversioninproject + " ");
                projectContainerEl.appendChild(contentText);

                this._createClickableProjectsLinks(projectContainerEl, projects);

                this.set("notification", {
                    content: contentEl,
                    commands: []
                });
            }.bind(this));
        },

        _createClickableProjectsLinks: function (contentEl, projects) {
            projects.forEach(function (project, index) {
                var projectEl = document.createElement("a");
                projectEl.setAttribute("tabIndex", 0);
                projectEl.classList.add("dijitReset", "dijitButtonText");
                var projectName = document.createTextNode(project.name);
                projectEl.appendChild(projectName);
                contentEl.appendChild(projectEl);

                if (index < projects.length - 1) {
                    var separatorText = document.createTextNode(", ");
                    contentEl.appendChild(separatorText);
                }
                this._attachProjectNameClickEvent(projectEl, project);
            }, this);
        },

        _attachProjectNameClickEvent: function (projectEl, project) {
            this.ownByKey(projectLinksKey, on(projectEl, "click", this._onProjectNameClick.bind(this, project.id)));
            this.ownByKey(projectLinksKey, on(projectEl, "keypress", function (event) {
                if (event.keyCode === keys.ENTER) {
                    this._onProjectNameClick(project.id);
                }
            }.bind(this)));
        },

        _onProjectNameClick: function (projectId) {
            //Publishes request change for project overview
            var newProjectUri = "epi.cms.project:///" + projectId;
            topic.publish("/epi/shell/context/request", { uri: newProjectUri }, { sender: null });
        }
    });
});

},
'epi-cms/contentediting/ShortcutNotification':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    // epi
    "epi/string",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.shortcutnotification"
],

function (
// dojo
    declare,
    lang,
    Stateful,
    // epi
    epiString,

    // resources
    resources
) {

    // linkTypes should match the EPiServer.Core.LinkTypes enum
    var linkTypes = ["normal",
        "shortcut",
        "external",
        "inactive",
        "fetchdata"];

    return declare([Stateful], {
        // summary:
        //      Helper class to translate pageShortcutTypes
        //      into warning notifications for the notification bar.
        // tags:
        //      internal

        // order: [public] Number
        //      Sort order of notification
        order: 20,

        _valueSetter: function (/*Object*/value) {
            // summary:
            //      Updates the notification when the property changes.
            // tags:
            //      private

            var shortcut = value.contentViewModel.contentModel.get("iversionable_shortcut");
            if (shortcut) {
                this._updateNotification(shortcut.pageShortcutType);
            }

            if (this._contentModelWatch) {
                this._contentModelWatch.unwatch();
            }

            this._contentModelWatch = value.contentViewModel.contentModel.watch("iversionable_shortcut", lang.hitch(this, function (name, oldValue, newValue) {
                this._updateNotification(newValue && newValue.pageShortcutType);
            }));
        },


        _updateNotification: function (shortcutType) {
            // summary:
            //      Maps the shortcutType enum value to a translated message
            // shortcutType: Number
            //      The value to set a message for
            // tags:
            //      private

            var shortcutName,
                message = null;

            if (shortcutType > 0) {
                shortcutName = linkTypes[shortcutType];
                message = epiString.toHTML(resources[shortcutName]);
            }

            this.set("notification", { content: message });
        }
    });
});

},
'epi-cms/contentediting/ViewSettingsNotification':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/Stateful",
    // epi
    "epi-cms/contentediting/ContentActionSupport",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.viewsettingsnotification"
],

function (
// dojo
    declare,
    Stateful,
    // epi
    ContentActionSupport,
    // resources
    resources
) {

    return declare([Stateful], {
        // summary:
        //      Show visitorgroup notification into warning notifications for the notification bar.
        // tags:
        //      internal

        // order: [public] Number
        //      Sort order of notification
        order: 30,

        _settingsSetter: function (/*Object*/value) {
            var isReadOnlyUser = value.viewModel.contentData && value.viewModel.contentData.accessMask <= ContentActionSupport.accessLevel.Read,
                setNotification = isReadOnlyUser && value.viewSetting.get("enabled") && value.viewSetting.hasVisitorGroup();

            this.set("notification", setNotification ? { content: resources.visitorgroups.noaccessright} : null);
        }

    });

});

},
'epi-cms/contentediting/viewmodel/ContentActivityFeedViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "epi/dependency",
    // Parent class and mixins
    "epi-cms/project/viewmodels/_ProjectFeedViewModel"
], function (
    declare,
    lang,
    when,

    dependency,
    // Parent class and mixins
    _ProjectFeedViewModel
) {

    return declare([_ProjectFeedViewModel], {
        // summary:
        //      View model for the content activity feed. Handles setting query and store state as well as
        //      saving new message activities.
        // tags:
        //      internal

        // isSingleItemSelected: [readonly] Boolean
        //      Indicates whether there is only a single item selected.
        isSingleItemSelected: true,

        // _contentLink: [private] String
        //      Content link of the current content.
        _contentLink: null,

        // isActivitiesVisible: [readonly] Boolean
        //      A flag which indicates whether the activities panel
        //      should be visible.
        isActivitiesVisible: false,

        // _activityFeedSettings: [readonly] Object
        //      Persist value for the ActivityFeed pane
        _activityFeedSettings: null,

        postscript: function () {
            this.inherited(arguments);

            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.activities");
            this.profile = this.profile || dependency.resolve("epi.shell.profile");

            this._activityFeedSettings = {};
            when(this.profile.get(this._getActivityFeedProfileKey())).then(function (result) {
                this._activityFeedSettings = result;

                // set to false if isActivitiesVisible hasn't been stored
                this.set("isActivitiesVisible", !!(result && result.isActivitiesVisible));
            }.bind(this));
        },

        _contentLinkSetter: function (contentLink) {
            // summary:
            //      Sets the content link and updates the query.
            // tags:
            //      private

            // Set parameters needed by the add message function.
            this._contentLink = contentLink;
            this._updateQuery();
        },

        _isActivitiesVisibleSetter: function (value) {
            this.isActivitiesVisible = value;
            this._updateQuery();

            this._persistActivityFeedSettings({ isActivitiesVisible: value });
        },

        _updateQuery: function () {
            if (this.isActivitiesVisible && this._contentLink) {
                this.set("query", {
                    contentReferences: [this._contentLink]
                });
            } else {
                this.set("query", null);
            }
        },

        _nameSetter: function (name) {
            // summary:
            //      Sets the name of the content and updates the placeholder.
            // tags:
            //      private
            this.set("placeholderName", name);
        },

        _persistActivityFeedSettings: function (settings) {
            // summary:
            //      Saves activity feed settings
            // tags:
            //      private

            this._activityFeedSettings = lang.mixin(this._activityFeedSettings, settings);
            this.profile.set(this._getActivityFeedProfileKey(), this._activityFeedSettings);
        },

        getActivityFeedSettings: function () {
            // summary:
            //      Gets the activity feed settings

            return this._activityFeedSettings;
        },

        _getActivityFeedProfileKey: function () {
            // summary:
            //    Get prefixed key name
            // tags:
            //    private

            return this.componentTypeName + "activity-feed";
        }
    });
});

},
'epi-cms/project/viewmodels/_ProjectFeedViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/i18n!epi/cms/nls/episerver.cms.activities.activity",
    // Parent class and mixins
    "epi-cms/activity/viewmodels/_ActivityViewModel",
    "dojo/Evented"
], function (
    declare,
    lang,
    localizations,
    // Parent class and mixins
    _ActivityViewModel,
    Evented
) {

    return declare([_ActivityViewModel, Evented], {
        // summary:
        //      Base view model for the project feeds. Handles setting query and store state as well as
        //      saving new message activities.
        // tags:
        //      internal abstract

        // hideOnPost: [public] Boolean
        //      Indicates whether buttons should be hidden when a post is triggered.
        hideOnPost: false,

        // isEditEnabled: [public] Boolean
        //      Indicates whether to allow edit capabilities.
        isEditEnabled: false,

        // isSingleItemSelected: [readonly] Boolean
        //      Indicates whether there is only a single item selected.
        isSingleItemSelected: false,

        // readOnly: [public] Boolean
        //      Indicates whether the widget is read only.
        readOnly: false,

        // selectedProjectId: [public] Integer
        //      The currently selected project Id
        selectedProjectId: null,

        // noDataMessage: [readonly] String
        //      The message displayed when no data is available
        noDataMessage: "",

        _save: function (message) {
            // summary:
            //      Saves the given message as a new message activity.
            // tags:
            //      protected

            var promise =  this.activityService.addMessage(this.selectedProjectId, this._contentLink, message);
            promise.then(this.emit.bind(this, "save"));
            return promise;
        },

        _placeholderNameSetter: function (placeholderName) {
            this.placeholderName = placeholderName;

            // If there is a placeholder name then generate the placeholder text, otherwise default
            // to an empty string.
            var placeholder = placeholderName ?
                lang.replace(localizations.textareaplaceholder, { name: placeholderName }) : "";

            this.set("placeholderText", placeholder);
        }
    });
});

},
'epi-cms/activity/viewmodels/_ActivityViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/regexp",
    "dojo/when",
    "dojox/html/entities",
    "epi/dependency",
    "epi/string",
    // Parent class and mixins
    "dojo/Stateful",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.activities.activity",
    "epi/i18n!epi/cms/nls/episerver.shared.action",
    "epi/i18n!epi/cms/nls/episerver.cms.notification.autocomplete"
],
function (
    declare,
    Deferred,
    all,
    regexp,
    when,
    entities,
    dependency,
    string,
    // Parent class and mixins
    Stateful,
    // Resources
    activitiesResources,
    actionResources,
    notificationResources
) {

    return declare([Stateful], {
        // summary:
        //      Base class view model for the activity components.
        // tags:
        //      internal abstract

        activityService: null,

        editLabel: actionResources.edit,

        // comment: [public] String
        //      The main comment for this activity. Use this.getComment() to access it.
        comment: null,

        // sendLabel: [public] String
        //      Label for sending form
        sendLabel: actionResources.post,

        // resetLabel: [public] String
        //      Label for reset form
        resetLabel: actionResources.cancel,

        // errorMessage: [public] String
        //      Error message when post fails
        errorMessage: "",

        // isEditEnabled: [public] Boolean
        //      A flag indicating whether to allow edit capabilities
        isEditEnabled: true,

        // readOnly: [public] boolean
        //      A flag indicating if the widget should be read only
        readOnly: true,

        // hideOnPost: [public] Boolean
        //      Indicates whether buttons should be hidden when a post is triggered.
        hideOnPost: true,

        // placeholderText: [public] String
        //      Placeholder text for textarea
        placeholderText: "",

        // noNotificationUserMessage: [public] String
        //      The message to show when there are no notification users
        //      returned from the server.
        noNotificationUserMessage: notificationResources.nodatamessage,

        // notificationUserStore: [public] Object
        //      The store to query for notification users.
        notificationUserStore: null,

        postscript: function () {
            this.inherited(arguments);

            this.activityService = this.activityService || dependency.resolve("epi.cms.ActivityService");
            this.profile = this.profile || dependency.resolve("epi.shell.Profile");
            this.notificationUserStore = this.notificationUserStore || dependency.resolve("epi.storeregistry").get("epi.cms.notification.users");
        },

        getComment: function () {
            // summary:
            //      Returns this.comment html encoded.
            // tags:
            //      public

            var comment = this.comment;
            if (!comment) {
                return "";
            }
            return this._formatText(comment);
        },

        save: function (message) {
            // summary:
            //      Saves the message by updating or creating as appropriate.
            // tags:
            //      public
            var promise = this._save(message);

            promise.otherwise(this._handleError.bind(this));

            return promise;
        },

        _save: function (message) {
            // summary:
            //      Called by save method. Should be overridden is subclasses.
            // tags:
            //      protected abstract
        },

        _formatText: function (text) {
            // summary:
            //      Clean up HTML tags and newlines. Encode the entire message.
            // tags:
            //      private

            if (!text) {
                return "";
            }

            var map = entities.html;

            text = entities.encode(text, map);
            text = text.replace(/\r\n|\n|\r/ig, "<br/>");
            return text;
        },

        _handleError: function () {
            // summary:
            //      Sets error message
            // tags:
            //      private
            this.set("errorMessage", activitiesResources.errormessage);
        },

        _isEditEnabledGetter: function () {
            // summary:
            //      Returns whether edit should be enabled
            // description:
            //      Overridden to disallow editing for others than original authors
            // tags:
            //      private

            // If message property is set, we do not want offer other users than the original author to edit
            if (this.message) {
                return (this.author || this.changedBy) === this.profile.userName;
            }
            return this.isEditEnabled;
        },

        _messageSetter: function (message) {
            // summary:
            //      Sets the message and notifies observers that the formatted message has also
            //      changed as a result of this.
            // tags:
            //      private

            this.message = message;
            this._changeAttrValue("formattedMessage", this.get("formattedMessage"));
        },

        _formattedMessageGetter: function () {
            // summary:
            //      Gets an HTML formatted string with the tags converted to the display name of the
            //      user if they exist.
            // tags:
            //      private

            var message = this._formatText(this.message);

            // Early exit if there is no message or the notification user store is not set.
            if (!message || !this.notificationUserStore) {
                return new Deferred().resolve(message);
            }

            // Extract strings beginning with @ to match with users
            var regex = /\B@([^\s":;|=,+*?<>[\]]+)/g,
                matches = message.match(regex) || [],
                matchMap = {},
                promises = matches.map(function (match) {
                    // Get the username by removing the @ symbol
                    var username = match.replace(/^@/, "");

                    // Get the user data for each matched tag.
                    return when(this.notificationUserStore.query({name: username, exactMatch: true}))
                        .then(function (user) {
                            matchMap[username] = user.displayName;
                        })
                        .otherwise(function () {
                            // Non-existing usernames will return a 404 so we swallow the error in
                            // order for the all(promises) not to fail.
                        });
                }.bind(this));

            // Replace all the matched tags with the user's display name.
            return all(promises).then(function () {
                message = message.replace(regex, function (match, key) {
                    return matchMap[key] ? "<strong>" + string.encodeForWebString(matchMap[key]) + "</strong>" : match;
                });

                return message;
            });
        }
    });
});

},
'url:epi-cms/contentediting/templates/PageDataController.html':"<div style=\"width: 100%; height: 100%;\">\r\n    <div data-dojo-attach-point=\"mainLayoutContainer\" data-dojo-type=\"epi/shell/layout/PreserveRatioBorderContainer\" data-dojo-props=\"gutters: false, livesplitters: false\" style=\"width: 100%; height: 100%\">\r\n        <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/EditToolbar\" data-dojo-props=\"region:'top'\"></div>\r\n        <div data-dojo-attach-point=\"notificationBar\" data-dojo-type=\"epi-cms/contentediting/NotificationBar\" data-dojo-props=\"region:'top', layoutPriority: 90\"></div>\r\n        <div data-dojo-attach-point=\"activityFeed\" data-dojo-type=\"epi-cms/activity/ActivityFeed\" data-dojo-props=\"region: 'right', model: this.activityModel, layoutPriority: 95, splitter: true, minSize: 200\" style=\"width: 25%; min-width: 200px\" class=\"dijitHidden\"></div>\r\n        <div data-dojo-attach-point=\"editLayoutContainer\" data-dojo-type=\"epi/shell/layout/CardContainer\" data-dojo-props=\"region: 'center', layoutPriority: 100\">\r\n            <div data-dojo-attach-point=\"iframeWithOverlay\" data-dojo-type=\"epi/shell/widget/IframeWithOverlay\" data-dojo-props=\"fitContainer: true, iframeName:'${iframeName}'\">\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi/shell/layout/CardContainer':function(){
﻿define("epi/shell/layout/CardContainer", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/fx",

    "dojo/aspect",
    "dojo/has",
    "dojo/on",

    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-geometry",

    "dojo/Deferred",
    "dojo/when",

    "dijit/_TemplatedMixin",
    "dijit/layout/StackContainer",

    "dgrid/util/has-css3"
],
function (
    declare,
    lang,
    fx,

    aspect,
    has,
    on,

    domClass,
    domStyle,
    domGeometry,

    Deferred,
    when,

    _TemplatedMixin,
    StackContainer,

    hasCss3) {

    return declare([StackContainer, _TemplatedMixin], {
        // summary:
        //      Layout container that organize pages like set of cards.
        //      Selected page is transitted using animation.
        //
        // tags:
        //      internal xproduct

        // doLayout: Boolean
        //      Override StackContainer.doLayout. Should always be false. In CardContainer, each page decides whether it wants to do layout.
        doLayout: false,

        // transitionClass: String
        //      Css class use to perform page transition.
        transitionClass: "epi-transition",

        // transitionDirection: String
        //      Page transition direction. Available values are "vertical" and "horizontal".
        //      Invalid values are considered to be "vertical".
        transitionDirection: "vertical",

        // baseClass: String
        //      Widget's base css class.
        baseClass: "epi-cardContainer",

        // templateString: String
        //      Widget's template string.
        templateString: "<div><div class='dijitContainer' style='position: relative;' data-dojo-attach-point='containerNode'></div></div>",

        layout: function () {
            // summary:
            //		Layout the contained pages.
            // description:
            //      Stack container set size on all pages depend on the container's doLayout property. Card container let the page design if it want to do layout.
            // tags:
            //		protected extension

            var child = this.selectedChildWidget;

            var children = this.getChildren(), topPage = children[children.length - 1];

            if (child && child.resize) {
                // If the page want to fit in container?
                if (child.fitContainer) {
                    child.resize(this._containerContentBox || this._contentBox);
                } else {
                    child.resize();
                }
            }

            // If current page does not fit the container, set the top page to visible and lay it out.
            if (child !== topPage && !child.fitContainer) {
                domClass.replace(topPage.domNode, "dijitVisible", "dijitHidden");
                if (topPage && topPage !== child && topPage.resize) {
                    if (topPage.fitContainer) {
                        topPage.resize(this._containerContentBox || this._contentBox);
                    } else {
                        topPage.resize();
                    }
                }
            }
        },

        addChild: function (child, insertIndex) {
            // summary:
            //		Makes the given widget a child of this widget.
            // description:
            //		Inserts specified child widget's dom node as a child of this widget's
            //		container node, and possibly does other processing (such as layout).
            //
            //		Functionality is undefined if this widget contains anything besides
            //		a list of child widgets (ie, if it contains arbitrary non-widget HTML).

            if (this._started) {
                var children = this.getChildren(), topPage = children[children.length - 1];
                if (insertIndex >= children.length) {
                    domClass.replace(topPage.domNode, "dijitHidden", "dijitVisible");
                }
            }

            this.inherited(arguments);
        },

        _transition: function (newPage, oldPage /*===== ,  animate =====*/) {
            // summary:
            //		Hide the old widget and display the new widget.
            // newPage: Node|dijit/_WidgetBase
            //		The newly selected widget.
            // oldPage: Node|dijit/_WidgetBase
            //		The previously selected widget.
            // animate: Boolean
            //		Used by AccordionContainer to turn on/off slide effect.
            // tags:
            //		protected extension

            var children = this.getChildren(),
                topPage = children[children.length - 1];

            if (!oldPage || oldPage._destroyed) {
                return;
            }

            // Show the top page if it is invisible, to start transition
            if (oldPage.fitContainer && oldPage !== topPage) {
                domClass.replace(topPage.domNode, "dijitVisible", "dijitHidden");
            }

            return when(newPage === topPage ? this._hideTransition(oldPage, topPage) : null, lang.hitch(this, function (n) {
                var currentOffset = 0;
                if (oldPage && !oldPage._destroyed && oldPage !== topPage) {
                    currentOffset = domGeometry.getMarginBox(oldPage.domNode).h;
                    this._hideChild(oldPage);
                }

                if (!newPage || newPage._destroyed) {
                    return;
                }

                this._showChild(newPage);

                // Size the new widget, in case this is the first time it's being shown,
                // or I have been resized since the last time it was shown.
                // Note that page must be visible for resizing to work.
                if (newPage.resize) {
                    if (newPage.fitContainer) {
                        newPage.resize(this._containerContentBox || this._contentBox);
                    } else {
                        // the child should pick it's own size but we still need to call resize()
                        // (with no arguments) to let the widget lay itself out
                        newPage.resize(null);
                    }

                    // Animate the last page down, making an effect like that we are opening the new page.
                    return when(this._showTransition(newPage, topPage, currentOffset), function () {
                        // Hide the top page if the current page already take all the container's size. This is to prevent tab into the top page and scroll it into view
                        if (newPage.fitContainer && newPage !== topPage) {
                            domClass.replace(topPage.domNode, "dijitHidden", "dijitVisible");
                        }
                    });
                } else {
                    return;
                }
            }));
        },

        _hideTransition: function (oldPage, topPage) {
            // summary:
            //      Override to perform closing transition before hiding a page.
            // oldPage: Node|dijit/_WidgetBase
            //      The old page which is about to hide.
            // topPage: Node|dijit/_WidgetBase
            //      The top page.
            // tags:
            //      protected

            return this._doTransition(oldPage, topPage, false);
        },

        _showTransition: function (newPage, topPage, currentOffset) {
            // summary:
            //      Override to perform opening transition after showing a page.
            // newPage: Node|dijit._WidgetBase
            //      The new page which has just been shown.
            // topPage: Node|dijit._WidgetBase
            //      The top page.
            // currentOffset: Number
            //      Current offset of the topPage, from which animation starts.
            // tags:
            //      protected

            return this._doTransition(newPage, topPage, true, currentOffset);
        },

        _doTransition: function (page, topPage, opening, currentOffset) {
            // summary:
            //      Perform opening or closing transition.
            // page: Node|dijit._WidgetBase
            //      The current page.
            // topPage: Node|dijit._WidgetBase
            //      The top page.
            // opening: Boolean
            //      Indicate that the current page is being opened.
            // currentOffset: Number
            //      Current offset of the topPage, from which animation starts. Use on opening only.
            // tags:
            //      private

            // Animate the last page down/up, making an effect like that we are opening/closing the new page.
            if (page !== topPage) {
                var marginBox = domGeometry.getMarginBox(page.domNode),
                    animationNode = this._getAnimationNode(page, topPage);

                var property = this.transitionDirection === "vertical" ? "top" : "left",
                    size = this.transitionDirection === "vertical" ? marginBox.h : marginBox.w,
                    from = opening ? -(size - currentOffset) + "px" : "0px",
                    to = opening ? "0px" : -size + "px",
                    restore = !opening;

                return this._animate(animationNode, property, from, to, restore);
            }
        },

        _getAnimationNode: function (page, topPage) {
            // summary:
            //      Get the node on which the transition effect is performed.
            // description:
            //      If the page's transitionMode was 'slideIn', the containerNode would be animated. Otherwise would be the last page.
            //      Used for default transition implementation only.
            // page: Node|dijit._WidgetBase
            //      The current page.
            // topPage: Node|dijit._WidgetBase
            //      The top page.
            // tags:
            //      private

            return page.transitionMode === "slideIn" ? this.containerNode : ((page.transitionMode === "reveal") ? topPage.domNode : null);
        },

        _animate: function (node, property, from, to, restore) {
            // summary:
            //      Animate a node using css transition.
            // node: Node
            //      The node to be animated.
            // property: String
            //      Css property used in animation.
            // from: String|Number
            //      Start value.
            // to: String|Number
            //      End value
            // restore: Boolean
            //      Indicate that it should restore the start value after animation.
            // tags:
            //      private

            var dfd = new Deferred();

            if (node && has("css-transitions") && from !== to) {
                domStyle.set(node, property, from);

                // Observed on IE 10 that we must wait for a little while before touching the node, setting transition related properties or events.
                // Otherwise, we don't get transitionend fired.
                setTimeout(lang.hitch(this, function () {
                    domClass.add(node, this.transitionClass);

                    var handle = on(node, has("transitionend"), lang.hitch(this, function () {
                        handle.remove();

                        domClass.remove(node, this.transitionClass);
                        if (restore) {
                            domStyle.set(node, property, from);
                        }

                        dfd.resolve();
                    }));

                    setTimeout(function () {
                        domStyle.set(node, property, to);
                    }, 1);
                }), 1);
            } else {
                dfd.resolve();
            }

            return dfd.promise;
        }
    });
});

},
'epi/shell/layout/PreserveRatioBorderContainer':function(){
define("epi/shell/layout/PreserveRatioBorderContainer", [
    "dojo/_base/declare",
    "dijit/layout/BorderContainer",
    "epi/shell/layout/_PreserveRatioMixin"
], function (
    declare,
    BorderContainer,
    _PreserveRatioMixin
) {
    return declare([BorderContainer, _PreserveRatioMixin], {
        // summary:
        //      A border container which will maintain the size ratio of the panels when the container is resized.
        // tags:
        //      internal
    });
});

},
'epi/shell/layout/_PreserveRatioMixin':function(){
define("epi/shell/layout/_PreserveRatioMixin", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",

    "dijit/Destroyable"
],
function (
    declare,
    lang,
    aspect,

    Destroyable
) {

    return declare([Destroyable], {
        // summary:
        //      Mixin that preserves the size ratio of the splitter panels in a BorderContainer when resizing the window
        // tags:
        //      public

        postCreate: function () {
            // summary:
            //      we adjust the splitter ratio before the resize is executed
            // tags:
            //      protected

            this.inherited(arguments);
            this.own(
                aspect.before(this, "resize", lang.hitch(this, this._adjustSplitter))
            );

        },

        _adjustSplitter: function () {
            // summary:
            //      gets the calculated new style for the frames and applies it
            // tags:
            //      private
            if (typeof this.getChildren === "function") {
                var allFrames = this.getChildren();
                if (allFrames.length === 0) {
                    return;
                }

                var splitFrames = allFrames.filter(function (obj) {
                    return (obj.splitter === true);
                });
                var oddFrames = allFrames.filter(function (obj) {
                    return (obj.splitter !== true);
                });

                var splitterCount = splitFrames.length;
                var max = 0;
                for (var frame in splitFrames) {
                    max = this._calcTrueMax(oddFrames, splitFrames, splitFrames[frame], splitterCount);
                    splitFrames[frame].set("style", this._getStyle(splitFrames[frame], max));
                }
            }

        },

        _getStyle: function (frame, max) {
            // summary:
            //      gets the max allowed size and calculates the new ratio, the returns the styling rule
            // tags:
            //      private

            var style = null;

            switch (frame.region) {
                case "top":
                case "bottom":
                    style = "height: " + this._calcRatio(frame.get("h"), max) + "%;";
                    break;
                case "left":
                case "right":
                    style = "width: " + this._calcRatio(frame.get("w"), max) + "%;";
                    break;
            }

            return style;
        },

        _calcRatio: function (partial, max) {
            // summary:
            //      calculates percentage ratio
            // tags:
            //      private

            return (partial / max) * 100;
        },

        _calcTrueMax: function (oddFrames, splitFrames, currentFrame, splitterCount) {
            // summary:
            //      Summarize max size adjusted with region frames, splitters and center panel
            // tags:
            //      private

            var orientation = "w";

            if (currentFrame.region === "bottom" || currentFrame.region === "top") {
                orientation = "h";
            }

            var max = currentFrame.get(orientation);
            var centerSize = oddFrames.filter(function (child) {
                return child.region === "center";
            })[0].get(orientation);
            var splitterSize = currentFrame._splitterWidget.get(orientation);

            var processFrame = function (frame) {
                if (orientation === "w" && (frame.region === "right" || frame.region === "left")) {
                    max += frame.get("w");
                } else if (orientation === "h" && (frame.region === "bottom" || frame.region === "top")) {
                    max += frame.get("h");
                }
            };

            oddFrames.forEach(processFrame);

            splitFrames.forEach(function (frame) {
                if (frame === currentFrame) {
                    return;
                }

                processFrame(frame);
            });

            return max + centerSize + (splitterSize * splitterCount);
        }

    });
});

},
'epi-cms/contentediting/EditToolbar':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/topic",
    "dojo/when",

    // EPi Framework
    "epi",

    // EPi CMS
    "epi-cms/contentediting/command/Editing",
    "epi-cms/contentediting/viewmodel/EditActionPanelViewModel",

    "epi-cms/contentediting/StandardToolbar",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu",
    // Used by the toolbar
    "epi-cms/widget/NotificationStatusBar",
    "epi-cms/contentediting/EditActionPanel"
], function (
// Dojo
    declare,
    lang,
    array,
    domClass,
    topic,
    when,

    // EPi Framework
    epi,

    // EPi CMS
    EditingCommands,
    EditActionPanelViewModel,

    StandardToolbar,

    // Resources
    res,
    actionRes
) {

    return declare([StandardToolbar], {
        // tags:
        //      internal xproduct

        res: res,

        _isSavingHandle: null,
        _editActionViewModel: null, //FIXME: This will be a part of the upcoming EditToolbarViewModel.
        _commands: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._commands = EditingCommands;

            this.own(this._commands.revertToPublished.watch("canExecute", lang.hitch(this, function () {
                this.setItemProperty(this._commands.revertToPublished.name, "disabled", !this._commands.revertToPublished.canExecute);
            })));

            this._editActionViewModel = new EditActionPanelViewModel();
            this.own(this._editActionViewModel);
        },

        resize: function (changeSize) {
            this.inherited(arguments);
            if (changeSize) {
                domClass.toggle(this.domNode, "epi-editToolbarNarrow", changeSize.w < 620);
                domClass.toggle(this.domNode, "epi-editToolbarMedium", changeSize.w >= 620 && changeSize.w < 1000);
                domClass.toggle(this.domNode, "epi-editToolbarLarge", changeSize.w >= 1300);

                this._editActionViewModel.set("expanded", changeSize.w >= 1000);

                this.setItemProperty("autosave", "isInNarrowToolbar", changeSize.w < 1000);
            }
        },

        setupChildren: function (/* Array */ optionalToolbarGroups, /* Array */ optionalToolbarItems) {
            var toolbarItems = [{
                parent: "center",
                name: "autosave",
                label: this.res.autosave.savinglabel,
                type: "dropdown",
                settings: { "class": "epi-autosave-hidden" }
            }, {
                parent: "autosave",
                name: "undo",
                title: this.res.undo.title,
                label: epi.resources.action.undo,
                type: "menuitem",
                iconClass: "epi-iconUndo",
                settings: { disabled: true, showLabel: false },
                action: function () {
                    topic.publish("/epi/cms/action/undo", []);
                }
            }, {
                parent: "autosave",
                name: "redo",
                title: this.res.redo.title,
                label: epi.resources.action.redo,
                type: "menuitem",
                iconClass: "epi-iconRedo",
                settings: { disabled: true, showLabel: false },
                action: function () {
                    topic.publish("/epi/cms/action/redo", []);
                }
            }, {
                parent: "autosave",
                name: "reverttopublished",
                title: this._commands.revertToPublished.tooltip,
                label: this._commands.revertToPublished.label,
                type: "menuitem",
                iconClass: "epi-iconRevert",
                settings: { separate: true },
                action: lang.hitch(this, function () {
                    this._commands.revertToPublished.execute();
                })
            }, {
                parent: "trailing",
                name: "notifications",
                widgetType: "epi-cms/widget/NotificationStatusBar"
            }, {
                name: "editactionpanel",
                label: epi.resources.action.publish,
                parent: "trailing",
                widgetType: "epi-cms/contentediting/EditActionPanel",
                settings: {
                    model: this._editActionViewModel
                }
            }];

            var toolbarGroups = optionalToolbarGroups ? optionalToolbarGroups : [];
            toolbarItems = optionalToolbarItems ? optionalToolbarItems.concat(toolbarItems) : toolbarItems;

            return this.inherited(arguments, [toolbarGroups, toolbarItems]);
        },

        _setContentViewModelAttr: function (value) {
            this._set("contentViewModel", value);

            when(this.isSetup(), lang.hitch(this, function () {
                this._updateToolbarItemsModel(value);
            }));
        },

        _updateToolbarItemsModel: function (contentViewModel) {
            // View mode changes, hide saving button
            if (!contentViewModel.isSaving) {
                this.setItemProperty("autosave", "label", "");
            }
            //The autosave button has epi-autosave-hidden class in order to be hidden when the toolbar is being rendered
            //here we change class for it to be shown
            this.setItemProperty("autosave", "class", "epi-autoSaveButton epi-disabledDropdownArrow");

            var contentData = contentViewModel.contentData;

            this.setItemProperty("notifications", "notificationContext", { contextTypeName: "epi.cms.contentdata", contextId: contentData.contentLink });

            this._editActionViewModel.set("dataModel", contentViewModel);

            if (this._isSavingHandle) {
                this._isSavingHandle.unwatch();
            }

            this._isSavingHandle = contentViewModel.watch("isSaving", function (name, oldValue, value) {
                this._widgetMap["editactionpanel"].toggleDropDownMenu(!value);
            }.bind(this));

            this.setItemProperty("viewselect", "viewName", contentViewModel.viewName);
        }
    });
});

},
'epi-cms/contentediting/viewmodel/EditActionPanelViewModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/string",

    "dojox/html/entities",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/viewmodel/_ContentViewModelObserver",
    "epi-cms/contentediting/viewmodel/PublishMenuViewModel",

    "epi/datetime",
    "epi/dependency",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel"
],

function (
    array,
    declare,
    lang,
    Stateful,
    dojoString,

    entities,

    ContentActionSupport,
    _ContentViewModelObserver,
    PublishMenuViewModel,

    datetime,
    dependency,

    res
) {

    return declare([_ContentViewModelObserver], {
        // tags:
        //      internal

        // public view model properties
        state: null,
        buttonText: null,
        statusText: null,
        statusIcon: null,
        additionalClass: null,
        nonEditableIndicator: null,
        visible: null,
        publishMenuViewModel: null,

        inUseNotificationManager: null,

        // Skip child model creation. Used in test environment.
        skipChildModels: false,

        // Private stuffs
        _virtualStatusEnum: {
            NotCreated: 0,
            NotPublishedYet: 1,
            NoChangeToPublish: 2,
            ChangesToPublish: 3,
            ReadyToPublish: 4,
            ScheduledPublish: 5,
            Published: 6,
            PreviouslyPublished: 7,
            Expired: 8,
            InUse: 9,
            Deleted: 10,
            AwaitingApproval: 11,
            Rejected: 12
        },
        _isSavingHandle: null,
        _virtualStatusCssState: [],
        _virtualStatusLocalization: [],
        _statusIcon: [],

        _statusMap: {},


        postscript: function () {
            //set up resources
            this.res = this.res || res;

            this.inherited(arguments);

            this.inUseNotificationManager = this.inUseNotificationManager || dependency.resolve("epi.cms.contentediting.inUseNotificationManager");

            // build up virtual status state, localization, and icon
            if (this._virtualStatusCssState.length === 0) {
                for (var status in this._virtualStatusEnum) {
                    this._virtualStatusCssState.push(status);
                    this._virtualStatusLocalization.push(this.res["status"][status.toLowerCase()]);
                }

                this._statusMap[ContentActionSupport.versionStatus.CheckedOut] = this._virtualStatusEnum.NotPublishedYet;
                this._statusMap[ContentActionSupport.versionStatus.CheckedIn] = this._virtualStatusEnum.ReadyToPublish;
                this._statusMap[ContentActionSupport.versionStatus.Rejected] = this._virtualStatusEnum.Rejected;
                this._statusMap[ContentActionSupport.versionStatus.DelayedPublish] = this._virtualStatusEnum.ScheduledPublish;
                this._statusMap[ContentActionSupport.versionStatus.Published] = this._virtualStatusEnum.Published;
                this._statusMap[ContentActionSupport.versionStatus.PreviouslyPublished] = this._virtualStatusEnum.PreviouslyPublished;
                this._statusMap[ContentActionSupport.versionStatus.Expired] = this._virtualStatusEnum.Expired;
                this._statusMap[ContentActionSupport.versionStatus.AwaitingApproval] = this._virtualStatusEnum.AwaitingApproval;

                this._statusIcon[ContentActionSupport.versionStatus.DelayedPublish] = "epi-iconClock";
                this._statusIcon[ContentActionSupport.versionStatus.Rejected] = "epi-icon--inverted epi-iconStop";
                this._statusIcon[ContentActionSupport.versionStatus.AwaitingApproval] = "epi-icon--inverted epi-iconGlasses";
            }

            //create child models
            if (!this.skipChildModels) {
                this.publishMenuViewModel = new PublishMenuViewModel({
                    inUseNotificationManager: this.inUseNotificationManager
                });
            }
        },

        destroy: function () {
            if (this.publishMenuViewModel) {
                this.publishMenuViewModel.destroy();
            }
            if (this._isSavingHandle) {
                this._isSavingHandle.unwatch();
            }
            this.inherited(arguments);
        },

        _dataModelSetter: function (value) {
            this.inherited(arguments);
            if (this.publishMenuViewModel) {
                this.publishMenuViewModel.set("dataModel", value);
            }
        },

        onDataModelChange: function () {
            // summary:
            //      Set properties when the data model is changed
            //
            // tags:
            //      internal

            var contentData = this.dataModel.contentData;

            if (this._isChangingContentStatusHandle) {
                this._isChangingContentStatusHandle.unwatch();
            }

            this._isChangingContentStatusHandle = this.dataModel.watch("isSaving", function (name, oldValue, value) {
                if (value) {
                    this.set("statusText", "");
                } else {
                    this._refresh(value);
                }
            }.bind(this));

            this._refresh((!this.dataModel.hasErrors && this.dataModel.hasPendingChanges) || this.dataModel.isSaving);

            if (contentData.isDeleted) {
                this.set("statusIcon", "");
                this.set("nonEditableIndicator", true);
            } else {
                this.set("statusIcon", this._getStatusIcon(contentData));

                var contentEditable = this.dataModel.canChangeContent(ContentActionSupport.action.Edit);
                var awaitingApproval = contentData.status === ContentActionSupport.versionStatus.AwaitingApproval;

                //Remove the none editable icon when awaiting approval.
                this.set("nonEditableIndicator", !contentEditable && !awaitingApproval);
            }

            this.set("visible", !contentData.isWastebasket);
        },

        _refresh: function (isSaving) {
            if (isSaving) {
                return;
            }

            var contentData = this.dataModel.contentData;
            var virtualStatus = this._getVirtualStatus(contentData);

            this.set("additionalClass", this._getVirtualStatus(contentData) === this._virtualStatusEnum.ChangesToPublish ? "animated8 shake" : "");
            this.set("state", this._virtualStatusCssState[virtualStatus]);
            this.set("statusText", this._getStatusText(virtualStatus, contentData));
            this.set("buttonText", this._getButtonText(virtualStatus, contentData));
        },

        _getStatusText: function (virtualStatus, contentData) {
            if (virtualStatus === this._virtualStatusEnum.Deleted) {
                // If the content is deleted, always set the same status text regardless of
                // the actual contentData.status
                return this._virtualStatusLocalization[virtualStatus];

            }

            if (contentData.status === ContentActionSupport.versionStatus.DelayedPublish) {
                return dojoString.substitute(this._virtualStatusLocalization[virtualStatus],
                    [datetime.toUserFriendlyHtml(contentData.properties.iversionable_startpublish)]);
            }

            if (virtualStatus === this._virtualStatusEnum.InUse) {
                var userList = this.inUseNotificationManager.getOtherUsersInUseNotifications(contentData.inUseNotifications);
                userList = userList.map(function (item) {
                    return entities.encode(item);
                }).join(",");
                return dojoString.substitute(this._virtualStatusLocalization[virtualStatus], [userList]);
            }

            if (contentData.status === ContentActionSupport.versionStatus.AwaitingApproval) {
                if (this._canApproveCurrentStep()) {
                    return this.res.awaitingyourapproval.label;
                }
                return this.res.currentlyinreview.label;
            }

            return this._virtualStatusLocalization[virtualStatus];
        },

        _getStatusIcon: function (contentData) {
            if (this._isRejected()) {
                return "";
            }

            return this._statusIcon[contentData.status] || "";
        },

        _getButtonText: function (virtualStatus, contentData) {
            if ((virtualStatus === this._virtualStatusEnum.NotPublishedYet ||
                virtualStatus === this._virtualStatusEnum.ChangesToPublish ||
                virtualStatus === this._virtualStatusEnum.ReadyToPublish) &&
                this.dataModel.canChangeContent(ContentActionSupport.action.Publish)) {

                return this.res.buttonlabel.publish;
            } else if (this._shouldShowApprovalButton(virtualStatus)) {
                return this.res.awaitingyourapproval.button;
            } else {
                return this.res.buttonlabel.option;
            }
        },

        _shouldShowApprovalButton: function (virtualStatus) {
            return virtualStatus === this._virtualStatusEnum.AwaitingApproval &&
                this._isContentInCurrentLanguage() &&
                this._canApproveCurrentStep();
        },

        _isContentInCurrentLanguage: function () {
            var contentData = this.dataModel.contentData;
            if (contentData && contentData.capabilities && !contentData.capabilities.language) {
                return true;
            }

            if (!this.dataModel.languageContext) {
                return false;
            }

            var currentEditingLanguage = this.dataModel.currentContentLanguage;
            var contentVersionLanguage = this.dataModel.languageContext.language;
            return currentEditingLanguage === contentVersionLanguage;
        },

        _getVirtualStatus: function (contentData) {
            if (contentData.isDeleted) {
                return this._virtualStatusEnum.Deleted;
            }

            var ignoreFlag, originallyEditable, hasInUseNotificationWarning;

            // Temporarily ignore inuse notification warning to check original editable status
            ignoreFlag = this.inUseNotificationManager.ignoreOthersNotifications;
            this.inUseNotificationManager.ignoreOthersNotifications = true;
            originallyEditable = this.dataModel.canChangeContent();
            this.inUseNotificationManager.ignoreOthersNotifications = ignoreFlag;

            hasInUseNotificationWarning = this.inUseNotificationManager.hasInUseNotificationWarning(contentData.inUseNotifications);

            if (hasInUseNotificationWarning && originallyEditable) {
                return this._virtualStatusEnum.InUse;
            }

            if (contentData.isCommonDraft) {
                if (contentData.status === ContentActionSupport.versionStatus.Published) {
                    return this._virtualStatusEnum.NoChangeToPublish;
                }
                if (contentData.status === ContentActionSupport.versionStatus.CheckedOut) {
                    return contentData.isMasterVersion ? this._virtualStatusEnum.NotPublishedYet : this._virtualStatusEnum.ChangesToPublish;
                }
            }

            // when no approvals then Rejected content should be shown as NotPublishedYet
            if (this._isRejected()) {
                return this._virtualStatusEnum.NotPublishedYet;
            }

            return this._statusMap[contentData.status];
        },

        _isRejected: function () {
            // when no approvals then Rejected content should be shown as NotPublishedYet
            return !this._canTransitionTo("readyforreview") && this._canTransitionTo("readytopublish");
        },

        _canApproveCurrentStep: function () {
            return this._canTransitionTo("approvechanges");
        },

        _canTransitionTo: function (transition) {
            return this.dataModel.contentData.transitions.some(function (item) {
                return item.name === transition;
            });
        }
    });
});

},
'epi-cms/contentediting/viewmodel/_ContentViewModelObserver':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/Stateful",

    "epi/shell/DestroyableByKey"
],

function (
    declare,
    Stateful,

    DestroyableByKey
) {

    return declare([Stateful, DestroyableByKey], {
        // tags:
        //      internal

        // dataModel: [public] epi-cms/contentediting/ContentViewModel
        dataModel: null,

        _dataModelHandlesKey: "dataModelHandles",

        _dataModelSetter: function (dataModel) {
            this.destroyByKey(this._dataModelHandlesKey);

            this.dataModel = dataModel;

            this.onDataModelChange();

            this.ownByKey(this._dataModelHandlesKey,
                this.dataModel.watch("status", this.onDataModelChange.bind(this)),
                this.dataModel.watch("contentData", this.onDataModelChange.bind(this)));
        },

        onDataModelChange: function (name, oldValue, value) {
            // when data model changes, update view model properties accordingly.
        }

    });
});

},
'epi-cms/contentediting/viewmodel/PublishMenuViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/Deferred",
    "dijit/Destroyable",
    "dojox/html/entities",
    "epi",
    "epi/datetime",
    "epi/dependency",
    "epi/Url",
    "epi/string",
    "epi/username",
    "epi-cms/content-approval/ApprovalEnums",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/PageShortcutTypeSupport",
    "epi-cms/contentediting/viewmodel/_ContentViewModelObserver",
    "epi-cms/contentediting/viewmodel/lastChangedFormatter",
    "epi-cms/contentediting/viewmodel/getFriendlyUsername",
    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/_GlobalCommandProviderMixin",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu"
],

function (
    declare,
    lang,
    when,
    Deferred,
    Destroyable,
    entities,
    epi,
    epiDate,
    dependency,
    Url,
    epistring,
    username,
    ApprovalEnums,
    ContentActionSupport,
    PageShortcutTypeSupport,
    _ContentViewModelObserver,
    lastChangedFormatter,
    getFriendlyUsername,
    _CommandConsumerMixin,
    _GlobalCommandProviderMixin,
    res
) {

    return declare([_ContentViewModelObserver, _CommandConsumerMixin, _GlobalCommandProviderMixin, Destroyable], {
        // tags:
        //      internal

        commandKey: "epi.cms.publishmenu",

        contentActionSupport: null,
        inUseNotificationManager: null,

        _currentUser: null,

        // Declare view model properties
        // ---------------------------------------------------------------------

        commands: null,
        mainButtonCommand: null,
        lastExecutedCommand: null,

        mainButtonSectionVisible: null,

        lastChangeStatus: null,

        // topInfoSectionVisible: [public] Boolean
        //      Indicates if the top info section should be visible
        topInfoSectionVisible: null,

        // bottomInfoSectionVisible: [public] Boolean
        //      Indicates if the bottom info section should be visible
        bottomInfoSectionVisible: null,

        publishInfoSectionVisible: null,
        lastPublishedText: null,
        lastPublishedViewLinkVisible: null,
        lastPublishedViewLinkHref: null,

        additionalInfoSectionVisible: null,
        additionalInfoText: null,

        isOpen: null,

        typeIdentifier: null,

        // Methods
        // ---------------------------------------------------------------------
        postscript: function () {
            this.inherited(arguments);

            this.res = this.res || res;
            this.projectService = this.projectService || dependency.resolve("epi.cms.ProjectService");
            this.approvalService = this.approvalService || dependency.resolve("epi.cms.ApprovalService");
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
            this.initializeCommandProviders();
        },

        onDataModelChange: function (name, oldValue, value) {
            // when data model changes, update view model properties accordingly.
            var contentData = this.dataModel.contentData,
                contentHasPublishedVersion = this._contentHasPublishedVersion(contentData);

            // Update commands
            this._updateCommands();

            // Update other properties
            // -----------------------------------------------------------------------------

            // Set menu sections and texts to defaults before calling specific setters (e.g. _setApprovalInfo etc).
            this.set("topInfoSectionVisible", this._getTopInfoSectionVisible(contentData));
            this.set("bottomInfoSectionVisible", this._getBottomInfoSectionVisible());
            this.set("publishInfoSectionVisible", this._getPublishInfoSectionVisible(contentData));
            this.set("lastPublishedTitle", this._getLastPublishedTitle(contentData));
            this.set("lastPublishedTitleVisible", contentHasPublishedVersion);
            this.set("lastPublishedText", this._getLastPublishedText(contentData));
            this.set("lastPublishedViewLinkVisible", this._getLastPublishedViewLinkVisible(contentData, contentHasPublishedVersion));
            this.set("lastPublishedViewLinkHref", this._getLastPublishedHref(contentData));

            // Set menu sections and text based on specific scenarios.
            this.set("typeIdentifier", contentData.typeIdentifier);
            this._setAdditionalInfo(contentData);

            if (this._shouldShowApprovalInfo()) {
                this._setApprovalInfo(contentData);
            } else {
                this._setLastChangeStatus(contentData);
            }
        },

        onCommandsChanged: function (name, removed, added) {

            // Remove existing handles
            if (removed) {
                removed.forEach(function (command) {
                    this.destroyByKey(command);
                }, this);
            }

            added.forEach(function (command) {
                if (command.options && command.options.isMain) {
                    this.ownByKey(command, command.watch("canExecute", function () {
                        this._calculateMainButtonCommand();
                    }.bind(this)));
                }
            }, this);
        },

        _dataModelSetter: function (value) {
            this.updateCommandModel(value);
            this.inherited(arguments);
        },

        _shouldShowApprovalInfo: function () {
            // summary:
            //      Indicates if the content is in awaiting approval state
            //      and if the context needs translation
            // returns:
            //      true/false
            // tags:
            //      private

            var awaitingApproval = this.dataModel.contentData.status === ContentActionSupport.versionStatus.AwaitingApproval;
            var translationNeeded = this.dataModel.languageContext && this.dataModel.languageContext.isTranslationNeeded;
            return awaitingApproval && !translationNeeded;
        },

        _isOpenSetter: function (isOpen) {
            this.isOpen = isOpen;
            if (isOpen) {
                var contentData = this.dataModel.contentData;
                if (this._shouldShowApprovalInfo()) {
                    this._setApprovalInfo(contentData);
                } else {
                    this._setLastChangeStatus(contentData);
                }
            }
        },

        _setApprovalInfo: function (contentData) {
            // summary:
            //      Retrieve and renders the approval information if found.
            // contentData:
            //      The content data object
            // tags:
            //      private

            return this.approvalService.getApproval(contentData.contentLink).then(lang.hitch(this, function (approval) {
                // If the content is in an AwaitingApproval state, when there's no approval in review, the content
                // is stuck in limbo. Help the user get back their content to an editable state.
                if (!approval || approval.status !== ApprovalEnums.status.inReview) {
                    if (this.dataModel.contentData.status === ContentActionSupport.versionStatus.AwaitingApproval) {
                        this._setAbortInfo(contentData);
                    }

                    return null;
                }

                var heading = lang.replace(this.res.approvalinfo.timepassed, {
                    timepassed: epiDate.timePassed(new Date(approval.startDate))
                });

                var stepInfo = " <br /> " + lang.replace(this.res.approvalinfo.stepinfo, {
                    activeStepIndex: approval.activeStepIndex + 1,
                    totalsteps: approval.totalSteps
                });

                // render the top heading
                var topInfoSection = heading + (approval.status === ApprovalEnums.status.inReview ? stepInfo : "");
                this.set("topInfoSectionVisible", true);
                this.set("lastChangeStatus", topInfoSection);

                var requestedBy = lang.replace(this.res.approvalinfo.requestedby, {
                    username: this._getFriendlyUsername(approval.startedBy, true),
                    time: epiDate.toUserFriendlyHtml(approval.startDate)
                });

                // render who requested/started the approval
                this.set("publishInfoSectionVisible", true);
                this.set("lastPublishedText", requestedBy);

                // hide everything else.
                this.set("lastPublishedTitleVisible", false);
                this.set("lastPublishedViewLinkVisible", false);
                return approval;
            })).otherwise(function () {
                return null;
            });
        },

        _setAbortInfo: function (contentData) {
            // summary:
            //      Renders abort information for content that's stuck in AwaitingApproval.
            // contentData:
            //      The content data object
            // tags:
            //      private

            // render the top heading
            this.set("topInfoSectionVisible", true);
            this._setLastChangeStatus(contentData);

            // render who requested/started the approval
            this.set("publishInfoSectionVisible", true);

            // render error message
            this.set("lastPublishedText", this.res.approvalinfo.approvalmissing);

            // hide everything else.
            this.set("lastPublishedTitleVisible", false);
            this.set("lastPublishedViewLinkVisible", false);
        },

        _updateCommands: function () {
            this._calculateMainButtonCommand();

            this.set("commands", this.getCommands());
        },

        _calculateMainButtonCommand: function () {
            var commands = this.getCommands(),
                mainCommand = null;

            commands.forEach(function (command) {
                if (command.canExecute &&
                    command.options && command.options.isMain && command.options.priority && (!mainCommand || mainCommand.options.priority < command.options.priority)) {

                    mainCommand = command;
                }
            });

            this.set("mainButtonCommand", mainCommand);
            this.set("mainButtonSectionVisible", mainCommand !== null);
        },

        _getBottomInfoSectionVisible: function () {
            // summary:
            //      Bottom info section should only be visible if there are visible commands in it.
            // tags:
            //      private

            return this.getCommands().some(function (command) {
                // If the visible command is the main command then it's not in the bottom info section.
                return command.isAvailable && command !== this.mainButtonCommand;
            }.bind(this));
        },

        _getTopInfoSectionVisible: function (contentData) {
            // summary:
            //      Top info section should be invisible if there is no main command and content is non-commondraft published version.
            // tags:
            //      private

            return this.mainButtonCommand || !((contentData.status === ContentActionSupport.versionStatus.Published ||
                contentData.status === ContentActionSupport.versionStatus.Expired) && !contentData.isCommonDraft);
        },

        _getPublishInfoSectionVisible: function (contentData) {
            // REMARK: Make it possible to do this in a plugin

            var hasInUseNotificationWarning = this.inUseNotificationManager.hasInUseNotificationWarning(contentData.inUseNotifications),
                originallyEditable = this._isOriginallyEditable();

            return !(hasInUseNotificationWarning && originallyEditable);
        },

        _getLastPublishedViewLinkVisible: function (contentData, contentHasPublishedVersion) {
            return contentHasPublishedVersion && !!contentData.publicUrl;
        },

        _setLastChangeStatus: function (contentData) {

            var defaultText, lastChangeStatus,
                self = this;

            var saveDate = this.dataModel.get("lastSaved");
            lastChangeStatus = defaultText = this._getTemplatedText(this.res.lastchangestatus, contentData.changedBy, saveDate);

            if (this.lastExecutedCommand && this.lastExecutedCommand.options && this.lastExecutedCommand.options.successStatus) {
                var successStatus = this.lastExecutedCommand.options.successStatus;
                this.lastExecutedCommand = this.mainButtonCommand;
                lastChangeStatus = successStatus;
            }

            if (contentData.missingLanguageBranch && contentData.missingLanguageBranch.isTranslationNeeded) {
                lastChangeStatus = lang.replace(this.res.nottranslated, {
                    languageName: epi.resources.language[contentData.missingLanguageBranch.languageId],
                    languageId: contentData.missingLanguageBranch.languageId
                });
            }

            if (contentData.status === ContentActionSupport.versionStatus.Published ||
                contentData.status === ContentActionSupport.versionStatus.Expired) {
                lastChangeStatus = this.res.notmodifiedsincelastpublish;
            }

            if (contentData.status === ContentActionSupport.versionStatus.PreviouslyPublished) {
                lastChangeStatus = this._getTemplatedText(this.res.previouslypublished, contentData.versionCreatedBy, contentData.versionCreatedTime);
            }

            if (contentData.status === ContentActionSupport.versionStatus.Rejected) {
                lastChangeStatus = this._getTemplatedText(this.res.rejectedapproval, contentData.versionCreatedBy, contentData.versionCreatedTime);
            }

            if (contentData.status === ContentActionSupport.versionStatus.DelayedPublish) {
                lastChangeStatus = this.projectService.getProjectsForContent(contentData.contentLink).then(function (projects) {
                    projects = projects.filter(function (project) {
                        return project.status === "delayedpublished";
                    });

                    if (projects.length) {
                        return lang.replace(self.res.projectdelayedpublish, {
                            date: epiDate.toUserFriendlyHtml(contentData.properties.iversionable_startpublish),
                            project: entities.encode(projects[0].name)
                        });
                    }
                    return defaultText;
                });
            }

            when(lastChangeStatus, lang.hitch(this, "set", "lastChangeStatus"));
        },

        _getLastPublishedTitle: function (contentData) {
            return contentData.status === ContentActionSupport.versionStatus.PreviouslyPublished ?
                this.res.currentlypublished : this.res.lastpublishedby;
        },

        _getLastPublishedText: function (contentData) {
            return (this._contentHasPublishedVersion(contentData)) ?
                this._getTemplatedText(this.res.publishedtime, contentData.publishedBy, contentData.lastPublished, true) :
                this.res.notpublishedbefore;
        },

        _getLastPublishedHref: function (contentData) {
            if (!contentData.publicUrl) {
                return null;
            }

            var url = new Url(contentData.publicUrl);
            if (contentData.properties.pageShortcutType === PageShortcutTypeSupport.pageShortcutTypes.Shortcut) {
                url.query.id = new Date().valueOf();
            }

            return url.toString();
        },

        _setAdditionalInfo: function (contentData) {
            // REMARK: Make it possible to do this in a plugin

            var hasInUseNotificationWarning = this.inUseNotificationManager.hasInUseNotificationWarning(contentData.inUseNotifications),
                originallyEditable = this._isOriginallyEditable(),
                visible = hasInUseNotificationWarning && originallyEditable;

            this.set("additionalInfoSectionVisible", visible);

            if (visible) {
                var userList = this.inUseNotificationManager.getOtherUsersInUseNotifications(contentData.inUseNotifications);
                this.set("additionalInfoText", this._getTemplatedText(this.res.inusewarning, userList.join(",")));
            }
        },

        _isOriginallyEditable: function () {
            // Temporarily ignore inuse notification warning to check original editable status
            var ignoreFlag = this.inUseNotificationManager.ignoreOthersNotifications;
            this.inUseNotificationManager.ignoreOthersNotifications = true;

            var originallyEditable = this.dataModel.canChangeContent();

            this.inUseNotificationManager.ignoreOthersNotifications = ignoreFlag;

            return originallyEditable;
        },

        _getFriendlyUsername: function (name, capitalizeUsername) {
            return getFriendlyUsername(name, capitalizeUsername);
        },

        _getTemplatedText: function (template, username, datetime, capitalizeUsername) {
            return lastChangedFormatter(template, username, datetime, capitalizeUsername);
        },

        _canTransitionTo: function (contentData, transition) {
            return contentData.transitions.some(function (item) {
                return item.name === transition;
            });
        },

        _contentHasPublishedVersion: function (contentData) {
            // summary:
            //      Detect whether a content has a published version based on its status
            //      (Published, PreviouslyPublished) or lastPublished is not null
            //      This approach is used to avoid the case when custom providers
            //      do not set the person who published (publishedBy)
            // tags:
            //      private

            if (!contentData) {
                return false;
            }

            var hasDate = contentData.lastPublished && contentData.lastPublished !== "0001-01-01T00:00:00Z";
            if (hasDate) {
                return true;
            }

            return contentData.status === ContentActionSupport.versionStatus.Published ||
                contentData.status === ContentActionSupport.versionStatus.PreviouslyPublished;
        }
    });
});

},
'epi-cms/content-approval/ApprovalEnums':function(){
﻿define({
    // summary:
    //      A collection of enums reflecting the server side enums.
    // tags:
    //      internal

    definitionStatus: {
        // summary:
        //      The status of an ApprovalDefinitionViewModel.
        //      Matches EPiServer.Cms.Shell.UI.Rest.Approvals.Internal.ApprovalDefinitionStatus.
        // tags:
        //      internal
        enabled: 0,
        disabled: 1,
        inherited: 2
    },

    reviewerType: {
        // summary:
        //      Specifies the type of reviewer.
        //      Matches EPiServer.Approvals.ApprovalDefinitionReviewerType.
        // tags:
        //      internal
        user: 0,
        role: 1
    },

    status: {
        // summary:
        //      The approval instance is in review.
        //      Matches EPiServer.Approvals.ApprovalDefinitionReviewerType
        // tags:
        //      internal
        inReview: 0,
        approved: 1,
        rejected: 2
    }
});

},
'epi-cms/contentediting/PageShortcutTypeSupport':function(){
﻿define([], function () {
    return {
        // tags:
        //      internal

        // pageShortcutTypes: [internal readonly] Object
        //      Page shortcut types
        pageShortcutTypes: {
            Normal: 0,
            Shortcut: 1,
            External: 2,
            Inactive: 3,
            FetchData: 4
        }
    };
});

},
'epi-cms/contentediting/viewmodel/lastChangedFormatter':function(){
define([
    "dojo/_base/lang",
    "epi/datetime",
    "epi-cms/contentediting/viewmodel/getFriendlyUsername"
], function (
    lang,
    epiDate,
    getFriendlyUsername
) {
    return function (template, username, datetime, capitalizeUsername) {
        // summary:
        //      Return text represent last update time
        // tags:
        //      private

        var date = new Date(datetime);

        return lang.replace(template, {
            username: getFriendlyUsername(username, capitalizeUsername),
            time: epiDate.toUserFriendlyHtml(date),
            timepassed: epiDate.timePassed(date)
        });
    };
});

},
'epi-cms/contentediting/viewmodel/getFriendlyUsername':function(){
define([
    "epi/username"
], function (
    username
) {
    return function (name, capitalizeUsername) {
        // summary:
        //      Get friendly username: if the username to be displayed is the same
        //      as the current username, this will returns "you"
        // name:
        //      the username to be displayed
        // capitalizeUsername:
        //      If the first character should always be displayed with upper case.
        // tags:
        //      private

        return username.toUserFriendlyHtml(name, null, capitalizeUsername);
    };
});

},
'epi/shell/command/_GlobalCommandProviderMixin':function(){
﻿define("epi/shell/command/_GlobalCommandProviderMixin", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/shell/command/_CommandProviderMixin",
    "epi/dependency"
], function (array, declare, lang, _CommandProviderMixin, dependency) {

    return declare([_CommandProviderMixin], {
        // summary:
        //      A mixin that will add command providers from the global command registry.
        //      It requires a _CommandProviderMixin or _CommandConsumerMixin on the same object when used
        //
        // tags:
        //      internal xproduct

        commandKey: null,

        commandProviders: null,

        _consumer: null,

        _currentCommandModel: null,

        _providerWatch: null,

        _initialized: false,

        initializeCommandProviders: function () {
            // summary:
            //		Gets the providers for the given command key and registers them with a consumer.
            // tags:
            //		protected

            if (this.initialized || !this.commandKey || !this.getConsumer) {
                return;
            }

            this._consumer = this.getConsumer();

            if (!this._consumer) {
                return;
            }

            this.commandRegistry = this.commandRegistry || dependency.resolve("epi.globalcommandregistry");
            this.commandProviders = this.commandRegistry.get(this.commandKey, true);
            array.forEach(this.commandProviders.providers, function (provider) {
                this._consumer.addProvider(provider);
            }, this);

            this._providerWatch = this.commandProviders.watch("providers", lang.hitch(this, this.onProvidersChanged));

            this.initialized = true;
        },

        updateCommandModel: function (model) {
            // summary:
            //		Calls the updateCommandModel method for all provider that implements it.
            // tags:
            //		public

            this._currentCommandModel = model;
            array.forEach(this.commandProviders.providers, function (provider) {
                if (provider.updateCommandModel) {
                    provider.updateCommandModel(model);
                }
            }, this);
        },

        onProvidersChanged: function (name, removed, added) {
            // summary:
            //		Adds or removes the added/removed provider from any consumers.
            // tags:
            //		public
            if (removed) {
                array.forEach(removed, this._consumer.removeProvider, this._consumer);
            }
            if (added) {
                array.forEach(added, function (item) {
                    this._consumer.addProvider(item);
                    if (item.updateCommandModel) {
                        item.updateCommandModel(this._currentCommandModel);
                    }
                }, this);
            }
        },

        destroy: function () {
            // summary:
            //		Remove the provider from any consumers.
            // tags:
            //		public

            if (this._consumer && this.commandProviders) {
                array.forEach(this.commandProviders.providers, this._consumer.removeProvider, this);
            }

            this._providerWatch && this._providerWatch.unwatch();

            this.inherited(arguments);
        }
    });
});

},
'epi-cms/contentediting/StandardToolbar':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
    "dijit/form/DropDownButton",
    "epi/shell/layout/ToolbarContainer",
    "epi/shell/widget/ToolbarLabel",
    "epi/shell/widget/ToolbarSet",
    "epi-cms/plugin-area/edit-view-filters",
    // Used by widget factory
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",
    "epi-cms/widget/ChangeView"
], function (declare, lang, all, when, DropDownButton, ToolbarContainer, ToolbarLabel, ToolbarSet, editViewFilters, Breadcrumb, BreadcrumbCurrentItem) {

    return declare([ToolbarSet], {
        // tags:
        //      public

        // currentContext: [public] Object
        //      An object with the current context information.
        currentContext: null,

        // availableViews: [public] Array
        //      List of available views.
        availableViews: null,

        // viewName: [public] String
        //      The current view name.
        viewName: null,

        // _setupPromise: [private] String
        //      The setup children promise.
        _setupPromise: null,

        constructor: function () {
            this.viewConfigurations = {};
        },

        buildRendering: function () {
            // summary:
            //      Constructs the toolbar container and starts the children setup process.
            // tags:
            //      protected

            this.inherited(arguments);

            // Setup the children items in the toolbar.
            when(this._setupPromise = this.setupChildren(), lang.hitch(this, function () {
                // Update the toolbar items with the current model.
                this.updateChildren();
            }));
        },

        isSetup: function () {
            // summary:
            //      Wait for setup to finish.
            // tags:
            //      protected

            return this._setupPromise;
        },

        setupChildren: function (/* Object[]? */ optionalToolbarGroups, /* Object[]? */ optionalToolbarItems) {
            // summary:
            //      Setup the items in the toolbar. Inheriting classes should extend this to add more items to the toolbar.
            // tags:
            //      protected

            var toolbarGroups = [{
                name: "leading",
                type: "toolbargroup",
                settings: { region: "leading" }
            }, {
                name: "center",
                type: "toolbargroup",
                settings: { region: "center" }
            }, {
                name: "trailing",
                type: "toolbargroup",
                settings: { region: "trailing" }
            }];

            var toolbarItems = [{
                parent: "leading",
                name: "breadcrumbs",
                widgetType: "epi-cms/widget/Breadcrumb",
                settings: {
                    displayAsText: false,
                    showCurrentNode: false
                }
            }, {
                parent: "trailing",
                name: "viewselect",
                widgetType: "epi-cms/widget/ChangeView"
            }, {
                parent: "leading",
                name: "currentcontent",
                widgetType: "epi-cms/widget/BreadcrumbCurrentItem"
            }];

            toolbarGroups = optionalToolbarGroups ? optionalToolbarGroups.concat(toolbarGroups) : toolbarGroups;
            toolbarItems = optionalToolbarItems ? optionalToolbarItems.concat(toolbarItems) : toolbarItems;

            return this.add(toolbarGroups).then(lang.hitch(this, function () {
                return this.add(toolbarItems);
            }));
        },

        updateChildren: function () {
            // summary:
            //      Update the toolbar items. This method is called on startup and whenever the current context is set.
            // tags:
            //      protected

            var context = this.currentContext,
                contentLink = context && context.id;

            this.setItemProperty("breadcrumbs", "contentLink", contentLink);
            this.setItemProperty("viewselect", "currentContext", this.currentContext);
            this.setItemProperty("viewselect", "viewName", this.viewConfigurations.viewName);
            this.setItemProperty("viewselect", "viewConfigurations", this.viewConfigurations);
            if (context) {
                this.setItemProperty("currentcontent", "currentItemInfo", {
                    name: context.name,
                    dataType: context.dataType
                });
            }
        },

        update: function (data) {
            // summary:
            //      Update the toolbar with new data.
            // data:
            //      Toolbar data model. Expected properties are: currentContext and viewConfigurations
            // tags:
            //      public

            if (!data) {
                return;
            }

            var viewConfigurations = data.viewConfigurations;

            // Run the defined view filters to allow partners to decide what should be
            // visible in the View menu
            editViewFilters.get().forEach(function (filter) {
                viewConfigurations = filter(viewConfigurations, data.contentData, data.currentContext);
            }, this);

            this.currentContext = data.currentContext;
            this.viewConfigurations = viewConfigurations;

            when(this.isSetup(), lang.hitch(this, this.updateChildren));
        }
    });
});

},
'epi-cms/plugin-area/edit-view-filters':function(){
define([
    "epi/PluginArea"
], function (
    PluginArea
) {
    /*=====
    return {
        // summary:
        //      A plugin area to plugin custom view filtering for the view button drop down
        // tags:
        //      internal xproduct
    };
    =====*/

    var pluginArea = new PluginArea("epi-cms/edit-view/filters[]");
    return pluginArea;
});

},
'epi-cms/widget/BreadcrumbCurrentItem':function(){
define([
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/Evented",
    "dojo/topic",
    "dojo/dom-construct",

    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",

    "epi/string",

    "epi/shell/TypeDescriptorManager",

    "dojo/text!./templates/BreadcrumbCurrentItem.html"
],

function (
    declare,
    domClass,
    Evented,
    topic,
    domConstruct,

    _TemplatedMixin,
    _WidgetBase,

    epiString,

    TypeDescriptorManager,

    template
) {

    return declare([_WidgetBase, _TemplatedMixin], {
        // tags:
        //      internal xproduct

        templateString: template,

        // _currentIconClass: [String]
        //      The private variable to safe class of current context
        _currentIconClass: null,

        _setCurrentItemInfoAttr: function (/* context */value) {
            // summary:
            //   The context for a content.
            //
            // value:
            //    The current item info object, containing name and dataType.
            //
            // tags:
            //    private

            if (!value) {
                return;
            }

            this.heading.innerHTML = epiString.encodeForWebString(value.name);

            if (value.dataType) {
                var currentIconClass = TypeDescriptorManager.getValue(value.dataType, "iconClass");
                if (currentIconClass !== this._currentIconClass) {

                    // Remove current class and then add new class
                    domClass.remove(this.iconNode, this._currentIconClass);
                    domClass.add(this.iconNode, currentIconClass);
                    this._currentIconClass = currentIconClass;
                }
            }
        }
    });
});

},
'url:epi-cms/widget/templates/BreadcrumbCurrentItem.html':"﻿<div>\r\n    <div class=\"epi-breadCrumbs-title-wrapper\"><span data-dojo-attach-point=\"iconNode\" class=\"dijitInline dijitIcon epi-breadCrumbsCurrentItem-icon\"></span><h1 data-dojo-attach-point=\"heading\" class=\"epi-breadcrumbContentItem dojoxEllipsis\"></h1></div>\r\n</div>",
'epi-cms/widget/ChangeView':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-style",

    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    "epi-cms/widget/ViewSwitchButton",
    "epi-cms/widget/ViewSelectorDropDownButton",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
], function (
    declare,
    array,
    domClass,
    domStyle,

    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    ViewSwitchButton,
    ViewSelectorDropDownButton,
    res
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //      Container widget for ViewSwitchButton and ViewSelectorDropDownButton
        //      Responsible for managing visibility of view selectors
        // tags:
        //      internal

        templateString: "<div class=\"dijitInline epi-trailingContainer\"></div>",

        buildRendering: function () {
            this.inherited(arguments);

            this._createViewSelector();
            this._createSwitchButton();
        },

        _createViewSelector: function () {
            this._viewSelectorDropDownButton = new ViewSelectorDropDownButton({
                showLabel: true,
                label: "",
                "class": "epi-mediumButton"
            });
            this._viewSelectorDropDownButton.placeAt(this.domNode);
        },

        _createSwitchButton: function () {
            this._viewSwitchButton = new ViewSwitchButton({
                firstButtonSettings: {
                    title: res.onpageedit.title,
                    label: res.onpageedit.label,
                    iconClass: "epi-iconLayout",
                    showLabel: false
                },
                secondButtonSettings: {
                    title: res.formedit.title,
                    label: res.formedit.label,
                    iconClass: "epi-iconForms",
                    showLabel: false
                }
            });
            this._viewSwitchButton.placeAt(this.domNode);
        },

        _setStateAttr: function (value) {
            this.inherited(arguments);
            this._viewSwitchButton.set("state", value);
        },

        _setViewNameAttr: function (viewName) {
            var isOnPageEditRelated = viewName === "onpageedit" || viewName === "sidebysidecompare" || viewName === "view" || viewName === "allpropertiescompare";
            this._viewSwitchButton.set("isFirstButtonActive", isOnPageEditRelated);
        },

        _setCurrentContextAttr: function (context) {
            this._currentContext = context;
        },

        _setViewConfigurationsAttr: function (viewConfigurations) {
            this._viewSelectorDropDownButton.set("viewConfigurations", viewConfigurations);

            var hasCustomViews = this._hasCustomViews(viewConfigurations.availableViews);
            var hasBuiltInViews = this._hasBuiltInViews(viewConfigurations.availableViews);

            this._setVisibility(this._viewSwitchButton, !hasCustomViews && hasBuiltInViews && this._currentContext.hasTemplate);
            this._setVisibility(this._viewSelectorDropDownButton, hasCustomViews);
        },

        _hasCustomViews: function (availableViews) {
            // summary:
            //      Determines whether available views contains custom views.
            // tags:
            //      private
            return array.filter(availableViews, function (view) {
                return !view.hideFromViewMenu && view.key !== "onpageedit" && view.key !== "formedit";
            }).length;
        },

        _hasBuiltInViews: function (availableViews) {
            // summary:
            //      Determines whether both on-page edit and all properties edit are available views.
            // tags:
            //      private
            return array.filter(availableViews, function (view) {
                return view.key === "onpageedit" || view.key === "formedit";
            }).length === 2;
        },

        _setVisibility: function (/*widget*/widget, /*Boolean*/visible) {
            // summary:
            //    sets item widget visibility.
            // tags:
            //    private

            domStyle.set(widget.domNode, { display: (visible ? "" : "none") });
            widget.set("itemVisibility", visible);
        }
    });
});

},
'epi-cms/widget/ViewSwitchButton':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/topic",

    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_CssStateMixin",
    "dijit/form/Button"
], function (
    declare,
    domClass,
    topic,

    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _CssStateMixin,
    Button
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin], {
        // summary:
        //      Constructs the two buttons used to switch between two views.
        // tags:
        //      internal

        baseClass: "epi-viewSwitchButton",

        templateString: "<span data-dojo-attach-point=\"stateNode\" class=\"epi-groupedButtonContainer\"></span>",

        _state: "",

        buildRendering: function () {
            this.inherited(arguments);

            this._firstButton = this._createButton();
            this._secondButton = this._createButton();

            this.set("isFirstButtonActive", true);
        },

        _createButton: function (value) {
            var button = new Button({
                showLabel: false,
                onClick: function () {
                    // This action may tear the current view down, including the button it self.
                    // Therefore it should be done when the event chain finished.
                    if (domClass.contains(this.domNode, "loading")) {
                        return;
                    }

                    domClass.toggle(this.domNode, "loading", true);
                    setTimeout(function () {
                        topic.publish("/epi/cms/action/switcheditmode", null, null, true);
                    }, 0);
                }
            });
            button.placeAt(this.domNode);
            return button;
        },

        _setFirstButtonSettingsAttr: function (value) {
            this._firstButton.set(value);
        },

        _setSecondButtonSettingsAttr: function (value) {
            this._secondButton.set(value);
        },

        _setIsFirstButtonActiveAttr: function (value) {
            this._firstButton.set("disabled", value);
            this._secondButton.set("disabled", !value);

            domClass.toggle(this._firstButton.domNode, "epi-button--pressed", value);
            domClass.toggle(this._secondButton.domNode, "epi-button--pressed", !value);

            domClass.toggle(this._firstButton.iconNode, "epi-icon--active", value);
            domClass.toggle(this._secondButton.iconNode, "epi-icon--active", !value);
        },

        _setStateAttr: function (value) {
            this.inherited(arguments);

            if (value === "") {
                domClass.toggle(this._firstButton.domNode, "loading", false);
                domClass.toggle(this._secondButton.domNode, "loading", false);
            }
        },

        _getStateAttr: function () {
            return this._state;
        }
    });
});

},
'epi-cms/widget/ViewSelectorDropDownButton':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/form/DropDownButton",
    "epi-cms/widget/ViewSelector",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.viewselector"
], function (
    array,
    declare,
    lang,
    DropDownButton,
    ViewSelector,
    resources) {

    return declare([DropDownButton], {
        // tags:
        //      internal

        buildRendering: function () {
            // summary:
            //      Constructs the toolbar container and starts the children setup process.
            // tags:
            //      internal

            this.inherited(arguments);
            this.set("title", resources.title);
            this.own(this.dropDown = new ViewSelector());
        },

        _setViewConfigurationsAttr: function (value) {
            // summary:
            //      Set view configurations attribute.
            // tags:
            //      protected

            if (!value) {
                return;
            }

            // Update the button's icon using the current view's icon
            array.some(value.availableViews, lang.hitch(this, function (view) {
                if (view.key === value.viewName) {
                    this.set("iconClass", view.iconClass);
                    return true;
                }
            }));

            this.dropDown.set("viewConfigurations", value);
        }
    });
});

},
'epi-cms/widget/ViewSelector':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",

    // dijit
    "dijit/MenuSeparator",

    // Resouces
    "epi/i18n!epi/cms/nls/episerver.cms.widget.viewselector",

    // Widgets used in template
    "epi-cms/widget/SelectorMenuBase",
    "epi/shell/widget/CheckedMenuItem"
], function (
    array,
    declare,
    lang,
    topic,
    when,

    // dijit
    MenuSeparator,

    // Resouces
    resources,

    SelectorMenuBase,
    CheckedMenuItem
) {

    return declare([SelectorMenuBase], {
        // summary:
        //      Used for selecting display options for a block in a content area
        // tags:
        //      internal

        // viewConfigurations: [protected] Object
        //      The view configurations
        viewConfigurations: null,

        headingText: resources.title,

        _setViewConfigurationsAttr: function (value) {
            // summary:
            //      Set view configurations attribute.
            // tags:
            //      protected

            this._set("viewConfigurations", value);

            this._setup();
        },

        onExecute: function () {
            // summary:
            //	    Triggered when a menu item selected.
            // tags:
            //		public callback
        },

        onCancel: function () {
            // summary:
            //	    Triggered when the menu closed.
            // tags:
            //		public callback
        },

        _setup: function () {
            if (!this.viewConfigurations) {
                return;
            }

            // Remove the old menu items
            this.getChildren().forEach(function (item) {
                this.removeChild(item);
                item.destroyRecursive();
            }, this);

            var currentView = this.viewConfigurations.viewName,
                availableViews = this.viewConfigurations.availableViews;

            var lastCategory = "";
            array.forEach(availableViews, function (view) {
                if (view.hideFromViewMenu) {
                    return;
                }

                var category = view.category || "";
                if (category !== lastCategory) {
                    this.addChild(new MenuSeparator({ baseClass: "epi-menuSeparator" }));
                }
                lastCategory = category;

                var item = new CheckedMenuItem({
                    label: view.name,
                    title: view.description,
                    iconClass: view.iconClass,
                    checked: view.key === currentView
                });

                item.own(item.on("click", function () {
                    this.onExecute();
                    item.set("checked", !item.checked); // we dont want to switch checked state on this item when clicking it.
                    if (currentView === "view") {
                        topic.publish("/epi/cms/action/disablepreview");
                    }
                    topic.publish("/epi/shell/action/changeview", view.key, null, null, true);
                }.bind(this)));

                this.addChild(item);
            }, this);
        }
    });
});

},
'epi-cms/widget/SelectorMenuBase':function(){
define([
    "dojo/_base/declare",
    "dojo/keys",
    "dijit/_MenuBase",
    "dojo/text!./templates/SelectorMenuBase.html"
], function (
    declare,
    keys,
    _MenuBase,
    template) {

    return declare([_MenuBase], {
        // summary:
        //      Base widget for selector menus
        //
        // tags:
        //      internal xproduct

        // templateString: String
        //      The template string.
        templateString: template,

        // headingText: String
        //      The heading text.
        headingText: null,

        postCreate: function () {
            // summary:
            //      Connect key navigation handlers.

            this.inherited(arguments);

            this.connectKeyNavHandlers([keys.UP_ARROW], [keys.DOWN_ARROW]);
        }
    });
});

},
'url:epi-cms/widget/templates/SelectorMenuBase.html':"﻿<div class=\"epi-menu--inverted\">\r\n    <div class=\"epi-dijitTooltipContainer\">\r\n        <div class=\"epi-invertedTooltip\">\r\n            <div class=\"epi-tooltipDialogTop\">\r\n                <span>${headingText}</span>\r\n            </div>\r\n        </div>\r\n        <div class=\"epi-tooltipDialogContent--max-height\">\r\n            <table class=\"dijitReset dijitMenu epi-tooltipDialogMenu epi-menuInverted epi-mediumMenuItem\" style=\"width: 100%\" cellspacing=\"0\">\r\n\t            <tbody data-dojo-attach-point=\"containerNode\" ></tbody>\r\n            </table>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/widget/NotificationStatusBar':function(){
﻿define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/keys",

    // dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/BorderContainer",

    // dojox
    "dojox/html/entities",

    // epi
    "epi/dependency",
    "epi-cms/widget/NotificationStatusZone",
    "epi-cms/widget/TooltipDialog",

    // resources
    "dojo/text!./templates/NotificationStatusBar.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.statusbar.notificationstatus"
], function (
    // dojo
    array,
    declare,
    event,
    lang,
    domClass,
    keys,

    // dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    BorderContainer,

    // dojox
    entities,

    // epi
    dependency,
    NotificationStatusZone,
    TooltipDialog,

    // resources
    template,
    nlsNotificationstatus
) {
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //      Shows notifications from MessageService for typeName's "error", "warn", and "info"
        // tags:
        //      internal

        res: nlsNotificationstatus,

        templateString: template,

        _itemTemplate: "<li>{message}</li>",

        _itemTemplateWithDeepLink: "<li><a href='#context={contextTypeName}:///{contextId}&activeproperty={propertyName}&activeview=formedit'>{message}</a></li>",

        _notificationTooltipDialogCssClass: "epi-notificationToolipDialog epi-notificationToolipDialogCompact",

        _dimmedOutCssClass: "epi-notificationIcon-DimmedOut",

        _notificationErrorClass: "epi-notificationIcon-Error",

        _notificationWarningClass: "epi-notificationIcon-Warning",

        _notificationNoteClass: "epi-notificationIcon-Note",

        _totalNotifications: 0,

        messageContext: null,

        _tooltipDialog: null,

        messageService: null,

        _observeHandle: null,

        zoneContainer: null,

        // notificationContext: [public] Object
        //		The notificationContext for which information will be displayed.
        notificationContext: null,

        baseClass: "epi-notificationIcon",

        postMixInProperties: function () {

            this.inherited(arguments);

            this.messageService = this.messageService || dependency.resolve("epi.shell.MessageService");
        },

        postCreate: function () {
            // summary:
            //    Initializes notification status bar.
            // tags:
            //    public

            this.inherited(arguments);

            this._tooltipDialog = new TooltipDialog({
                connectorMargin: 47,
                hideOnBlur: true,
                content: this.zoneLayoutNode
            });
            this.own(this._tooltipDialog);

            this._buildIconBlock();

            // Css class for notification status bar, overrides connector top styles
            domClass.add(this._tooltipDialog.domNode, this._notificationTooltipDialogCssClass);

            this.connect(this.domNode, "onclick", lang.hitch(this, this._show));
            this.connect(this.domNode, "onkeypress", lang.hitch(this, this._onKeyPress));
            this.connect(this.closeIcon, "onclick", lang.hitch(this, this._hideTooltip));
        },

        update: function (/*Object*/newMessageContext) {
            // summary:
            //    Updates notification context with the new context
            // newMessageContext:
            //    Query to find message belong to.
            // tags:
            //    public

            this._hideTooltip();
            this.messageContext = newMessageContext;
            this._listenMessagePool();
            this._updateUI();
        },

        destroy: function () {
            // summary:
            //    Destroy this widget, removes handler event used, ready for GC
            //
            // tags:
            //    public

            this._unListenMessagePool();
            this.inherited(arguments);
        },

        focus: function () {
            // summary:
            //      Set focus on the widget.
            // tags:
            //      public

            this.domNode.focus(); // No focusNode
        },

        show: function () {
            // summary:
            //    Show tooltip for the widget, force show from other widget (i.e: StatusBar)
            // tags:
            //    public
            this._keepShowing = true;
            this._showTooltip();
        },

        getMessages: function (messageType) {
            // summary:
            //    Gets messages from message service pool
            // tags:
            //    private

            var query = (messageType) ? lang.mixin({ typeName: messageType }, this.messageContext) : this.messageContext;
            return this.messageService.query(query);
        },

        _onKeyPress: function (evt) {
            if (evt.keyCode === keys.ENTER) {
                this._show();
            }
        },

        _listenMessagePool: function () {
            // summary:
            //    Listens change on current page in Message Services
            //    Server in case validate on Edit
            // tags:
            //    private
            this._unListenMessagePool();
            this._observeHandle = this.messageService.observe(this.messageContext, lang.hitch(this, function () {
                this._updateUI();
            }));
        },

        _unListenMessagePool: function () {
            // summary:
            //    Cancels listen change on current page in Message Services
            // tags:
            //    private

            if (this._observeHandle) {
                this._observeHandle.cancel();
                delete this._observeHandle;
            }
        },

        _updateNotificationZone: function (zone, items) {
            if (items && items.length > 0) {
                array.forEach(items, function (item) {
                    if (item.externalItemData && item.externalItemData.enabledDeepLink && item.externalItemData.propertyName) {
                        zone.addRow(lang.replace(this._itemTemplateWithDeepLink, {
                            contextTypeName: item.contextTypeName,
                            contextId: item.contextId,
                            propertyName: item.externalItemData.propertyName,
                            message: entities.encode(item.message)
                        }), "last");
                    } else {
                        zone.addRow(lang.replace(this._itemTemplate, { message: entities.encode(item.message) }), "last");
                    }
                }.bind(this));
                zone.show();
            } else {
                zone.hide();
            }
        },

        _updateUI: function () {
            // summary:
            //    Re-renders the UI of widget.
            // tags:
            //    private

            // empty zone content
            this.errorZone.empty();
            this.warningZone.empty();
            this.infoZone.empty();

            // Get notification types to be updated
            var errors = this.getMessages("error");
            var warnings = this.getMessages("warn");
            var information = this.getMessages("info");

            this._totalNotifications = errors.length + warnings.length + information.length;

            this._buildIconBlock();

            // update "error" zone
            this._updateNotificationZone(this.errorZone, errors);
            // update "warning" zone
            this._updateNotificationZone(this.warningZone, warnings);
            // update "note" zone
            this._updateNotificationZone(this.infoZone, information);

            this._updateIconStatus(errors.length, warnings.length, information.length);
        },

        _buildIconBlock: function () {
            // summary:
            //    Setup status bar notification icon
            // tags:
            //    private

            this.domNode.innerHTML = this._totalNotifications;

            if (this._totalNotifications === 0) {
                domClass.add(this.domNode, this._dimmedOutCssClass);
                domClass.remove(this.domNode, this._notificationNoteClass);
                domClass.remove(this.domNode, this._notificationWarningClass);
                domClass.remove(this.domNode, this._notificationErrorClass);
                this._hideTooltip();
            } else {
                domClass.remove(this.domNode, this._dimmedOutCssClass);
            }
        },

        _updateIconStatus: function (errors, warnings, information) {
            // Set class on notification badge
            if (errors) {
                domClass.add(this.domNode, this._notificationErrorClass);
                domClass.remove(this.domNode, this._notificationNoteClass);
                domClass.remove(this.domNode, this._notificationWarningClass);
            } else if (warnings) {
                domClass.add(this.domNode, this._notificationWarningClass);
                domClass.remove(this.domNode, this._notificationNoteClass);
            } else if (information) {
                domClass.add(this.domNode, this._notificationNoteClass);
            }
        },

        _setNotificationContextAttr: function (value) {
            this._set("notificationContext", value);
            this.update(value);
        },

        _show: function (e) {
            // summary:
            //    Show tooltip for the widget
            // tags:
            //    private

            if (e) {
                event.stop(e);
            }

            this._showTooltip();
        },

        _showTooltip: function () {
            // summary:
            //    Show tooltip for the widget
            // tags:
            //    private

            if (this._totalNotifications === 0) {
                return;
            }

            this._tooltipDialog.showTooltipDialog(this.domNode, ["below-alt"]);
        },

        _hideTooltip: function () {
            // summary:
            //    Hide tooltip for widget
            // tags:
            //    private

            this._tooltipDialog.hideTooltipDialog();
        }
    });
});

},
'epi-cms/widget/NotificationStatusZone':function(){
﻿define([
    "dojo",
    "dojo/_base/declare",
    "dijit/_Widget",
    "dijit/_TemplatedMixin"
],
function (dojo, declare, _Widget, _TemplatedMixin) {

    return declare([_Widget, _TemplatedMixin], {
        // summary:
        //      This widget only use for [epi/cms/widget/NotificationStatusBar]
        //
        // tags:
        //      internal

        templateString: "\
            <div>\
                <div class=\"epi-dijitTooltipNotificationBlock epi-dijitTooltipBlock${TypeName}\" data-dojo-attach-point=\"Zone\">\
                    <span class=\"epi-notificationTypeTitle\"><span class=\"dijitIcon dijitInline epi-dijitTooltip${TypeName}Icon\"></span>${title}</span>\
                    <ul data-dojo-attach-point=\"contentContainer\"></ul>\
                </div>\
            </div>",
        title: "", // String: Title of the zone
        type: "", // String: Type of the zone,
        TypeName: "", // String: Name of Type of the zone with title casing

        _hiddenCssClass: "epi-dijitTooltipBlockHidden",

        postMixInProperties: function () {
            this.TypeName = this.type.charAt(0).toUpperCase() + this.type.slice(1);
        },

        empty: function () {
            // summary:
            //    Clears content of the area.
            // tags:
            //    public
            dojo.empty(this.contentContainer);
        },

        addRow: function (itemHTML, position) {
            // summary:
            //    Adds new row to area content.
            // itemHTML: String
            //    HTML string of row will be added to area
            // position: String
            //    Position of row was added ("begin", "last")
            // tags:
            //    public
            dojo.place(itemHTML, this.contentContainer, position);
        },

        show: function () {
            // summary:
            //    Shows the area content.
            // tags:
            //    public
            dojo.removeClass(this.Zone, this._hiddenCssClass);
        },

        hide: function () {
            // summary:
            //    Hides the area content.
            // tags:
            //    public
            dojo.addClass(this.Zone, this._hiddenCssClass);
        }
    });
});

},
'epi-cms/widget/TooltipDialog':function(){
﻿define([
    "dojo",
    "dojo/number",
    "dijit",
    "dijit/TooltipDialog",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dojo/text!./templates/TooltipDialog.html"
],

function (dojo, number, dijit, TooltipDialog, _Widget, _TemplatedMixin, template) {
    return dojo.declare([TooltipDialog], {
        // tags:
        //      internal

        templateString: template,

        connectorMargin: 25, // Changable margin (left or right) for tooltip dialog connector
        _defaultConnectorMargin: 25, // Default margin (left or right) for tooltip dialog connector

        hideOnBlur: false,

        _isFirstShow: false,

        _beforeCssClass: "epi-dijitTooltipBefore", // Customized css class for before orient
        _afterCssClass: "epi-dijitTooltipAfter", // Customized css class for after orient

        _pos: 0,
        _defaultConnectorRight: 0, // Default margin right for tooltip dialog connector, will be set on the first tooltip show
        _defaultConnectorLeft: 0, // Default margin left for tooltip dialog connector, will be set on the first tooltip show

        _wrapperPosX: 0,
        _availableSpace: 0,
        _right: 0,
        _left: 0,

        onBlur: function () {
            this.inherited(arguments);

            if (this.hideOnBlur) {
                this.hideTooltipDialog();
            }
        },

        postCreate: function () {
            // summary:
            //    Inits tooltip dialog
            // tags:
            //    public

            this.inherited(arguments);

            // Set the default value for connector margin (left or right)
            if (!this.connectorMargin || !number.parse(this.connectorMargin) || this.connectorMargin === "" || this.connectorMargin < this._defaultConnectorMargin) {
                this.connectorMargin = this._defaultConnectorMargin;
            }
        },

        showTooltipDialog: function (target, orient) {
            // summary:
            //    Simply show tooltip dialog like dijit tooltip
            // tags:
            //    public

            dijit.popup.open({
                popup: this,
                around: target,
                orient: orient
            });

            if (this.hideOnBlur) {
                this.focus();
            }
        },

        hideTooltipDialog: function () {
            // summary:
            //    Simply hide tooltip dialog like dijit tooltip
            // tags:
            //    public

            dijit.popup.close(this);
        },

        onOpen: function (pos) {
            // summary:
            //    Overrides from dijit TooltipDialog
            // tags:
            //    extended

            this._pos = pos; // Save position object to use on _onShow()
            this.inherited(arguments);
        },

        _onShow: function () {
            // summary:
            //    Overrides from ContentPane
            // tags:
            //    extended

            this._setDefaultValues();
            this._updatePositions();

            this.inherited(arguments);
        },

        _setDefaultValues: function () {
            // summary:
            //    Sets default values
            // tags:
            //    private

            // Set default connector right and left margins on first show
            if (!this._isFirstShow) {
                this._defaultConnectorRight = this._getConnectorSpace("right") || this._defaultConnectorMargin;
                this._defaultConnectorLeft = this._getConnectorSpace("left") || this._defaultConnectorMargin;
                this._isFirstShow = true;
            }

            this._wrapperPosX = number.parse(this._pos.x); // Get position x of the tooltip dialog wrapper tag
            this._availableSpace = dojo.body().clientWidth; // Get full visible width of browser

            // Set position of tooltip connector to center vertical of around node
            if (this._pos.aroundCorner === "MR" || this._pos.aroundCorner === "ML") {
                var positionTop = number.round((this._pos.h - this.connectorNode.clientHeight) / 2);
                dojo.style(this.connectorNode, "top", this._getNumberInPx(positionTop));
            }
        },

        _updatePositions: function () {
            // summary:
            //    Updates positions of tooltip dialog's connector and tooltip dialog
            // tags:
            //    private

            switch (this._pos.aroundCorner) {
                // Top right or bottom right of around node (by set above or below in orient)
                case "TR":
                case "BR":
                    // Calculates to set connector node point to center horizontal of around node
                    this._calculateConnectorMarginRight();
                    this._calculateAvailableSpaceLeft();
                    this._updateAlignedRightPositions();
                    break;
                // Top left or bottom left of around node (by set above or below in orient)
                case "TL":
                case "BL":
                    // Calculates to set connector node point to center horizontal of around node
                    this._calculateConnectorMarginLeft();
                    this._calculateAvailableSpaceRight();
                    this._updateAlignedLeftPositions();
                    break;
                // Middle right of around node (by set after in orient)
                case "MR":
                    dojo.addClass(this.domNode, this._afterCssClass);
                    break;
                // Middle left of around node (by set before in orient)
                case "ML":
                    dojo.addClass(this.domNode, this._beforeCssClass);
                    break;
                default:
                    break;
            }
        },

        _updateAlignedRightPositions: function () {
            // summary:
            //    Updates positions of tooltip dialog's connector and tooltip dialog when it aligned right around node
            // tags:
            //    private

            if (this._availableSpace >= this.connectorMargin) {
                dojo.style(this.connectorNode, "right", this._getNumberInPx(this.connectorMargin));
                dojo.style(this._popupWrapper, "left", this._getNumberInPx(this._wrapperPosX + (this.connectorMargin - this._right)));
            } else {
                dojo.style(this.connectorNode, "right", this._getNumberInPx(this._defaultConnectorRight));
                dojo.style(this._popupWrapper, "left", this._getNumberInPx(this._wrapperPosX - (this._right - this._defaultConnectorRight)));
            }
        },

        _updateAlignedLeftPositions: function () {
            // summary:
            //    Updates positions of tooltip dialog's connector and tooltip dialog when it aligned left around node
            // tags:
            //    private

            if (this._availableSpace >= this.connectorMargin) {
                dojo.style(this.connectorNode, "left", this._getNumberInPx(this.connectorMargin));
                dojo.style(this._popupWrapper, "left", this._getNumberInPx(this._wrapperPosX + (this.connectorMargin - this._left)));
            } else {
                dojo.style(this.connectorNode, "left", this._getNumberInPx(this._defaultConnectorLeft));
                dojo.style(this._popupWrapper, "left", this._getNumberInPx(this._wrapperPosX - (this._left - this._defaultConnectorLeft)));
            }
        },

        _calculateAvailableSpaceRight: function () {
            // summary:
            //    Calculates available space on right when tooltip dialog aligned left around node
            // tags:
            //    private

            this._wrapperPosX -= this._left + this._getCenterHorizontalAroundNode();
            this._availableSpace -= (this._wrapperPosX + this._pos.w);
        },

        _calculateAvailableSpaceLeft: function () {
            // summary:
            //    Calculates available space on left when tooltip dialog aligned right around node
            // tags:
            //    private

            this._wrapperPosX += this._right + this._getCenterHorizontalAroundNode();
            this._availableSpace -= (this._wrapperPosX + this._pos.w);
        },

        _calculateConnectorMarginRight: function () {
            // summary:
            //    Calculates margin right of the connector
            // tags:
            //    private

            this._right = this._getConnectorSpace("right");
            if (this._right < this.connectorMargin) {
                this._right = this.connectorMargin;
            }
        },

        _calculateConnectorMarginLeft: function () {
            // summary:
            //    Calculates margin left of the connector
            // tags:
            //    private

            this._left = this._getConnectorSpace("left");
            if (this._left < this.connectorMargin) {
                this._left = this.connectorMargin;
            }
        },

        _getConnectorSpace: function (position) {
            // summary:
            //    Gets connector margin (left or right)
            // position:
            //    Css position: left or right
            // tags:
            //    private

            if (!position) {
                return 0;
            }

            if (position === "right" || position === "left") {
                var positionValue = dojo.style(this.connectorNode, position);
                if (!positionValue) {
                    return 0;
                }
                var patterns = /(px|em|%)/ig;
                return number.parse(positionValue) || number.parse(positionValue.replace(patterns, ""));
            }

            return 0;
        },

        _getNumberInPx: function (number) {
            // summary:
            //    Gets number in pixel format
            // number:
            //    Integer number
            // tags:
            //    private

            return number + "px";
        },

        _getCenterHorizontalAroundNode: function () {
            // summary:
            //    Gets number of the center horizontal of tooltip dialog around node
            // tags:
            //    private

            return number.round((number.parse(this.connectorNode.clientWidth) - number.parse(this._pos.aroundNodePos.w)) / 2);
        }
    });
});

},
'url:epi-cms/widget/templates/TooltipDialog.html':"﻿<div class=\"epi-dijitTooltipDialog\" role=\"presentation\" tabindex=\"-1\">\r\n    <div class=\"dijitTooltipContainer epi-dijitTooltipContainer\" role=\"presentation\">\r\n        <div class=\"dijitTooltipContents dijitTooltipFocusNode epi-dijitTooltipContents\" data-dojo-attach-point=\"containerNode\" role=\"dialog\"></div>\r\n    </div>\r\n    <div class=\"dijitTooltipConnector epi-dijitTooltipConnector\" data-dojo-attach-point=\"connectorNode\" role=\"presentation\"></div>\r\n</div>",
'url:epi-cms/widget/templates/NotificationStatusBar.html':"﻿<div>\r\n    <div class=\"epi-dijitTooltipTitleBar\">\r\n        <span class=\"epi-dijitTooltipTitle\">${res.title}</span>\r\n        <span class=\"epi-closeButton dijitDialogCloseIcon\" data-dojo-attach-point=\"closeIcon\" title=\"${res.title}\" role=\"button\"></span>\r\n    </div>\r\n    <div class=\"epi-dijitTooltipContent\" data-dojo-attach-point=\"zoneLayoutNode\">\r\n        <div data-dojo-attach-point=\"zoneContainer\">\r\n            <div data-dojo-type=\"epi-cms/widget/NotificationStatusZone\" data-dojo-attach-point=\"errorZone\" data-dojo-props=\"title: '${res.errortitle}', type: 'error'\"></div>\r\n            <div data-dojo-type=\"epi-cms/widget/NotificationStatusZone\" data-dojo-attach-point=\"warningZone\" data-dojo-props=\"title: '${res.warningtitle}', type: 'warning'\"></div>\r\n            <div data-dojo-type=\"epi-cms/widget/NotificationStatusZone\" data-dojo-attach-point=\"infoZone\"  data-dojo-props=\"title: '${res.notetitle}', type: 'note'\"></div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/EditActionPanel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",

    "dijit/_CssStateMixin",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/DropDownButton",

    "epi",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/PublishMenu",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/string",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel",
    "dojo/text!./templates/EditActionPanel.html"
],

function (
    declare,
    lang,
    domStyle,
    domClass,
    domAttr,

    _CssStateMixin,
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,
    DropDownButton,

    epi,
    ContentActionSupport,
    PublishMenu,
    _ModelBindingMixin,
    string,

    res,
    template
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin, _ModelBindingMixin], {
        // tags:
        //      internal

        templateString: template,

        commonRes: epi.resources,

        // baseClass: [protected] String
        //		Root CSS class of the widget.
        baseClass: "epi-statusIndicator",

        // Declare view model binding
        modelBindingMap: {
            state: ["state"],
            statusText: ["statusText"],
            visible: ["visible"],
            buttonText: ["buttonText"],
            nonEditableIndicator: ["nonEditableIndicator"],
            statusIcon: ["statusIcon"],
            publishMenuViewModel: ["publishMenuViewModel"],
            additionalClass: ["additionalClass"],
            expanded: ["expanded"]
        },

        // statusText: [protected] String
        //      Content status text.
        _setStatusTextAttr: function (statusText) {
            this._set("statusText", statusText);

            this._setStatusNodeText(statusText);
        },

        _setStatusNodeText: function (/*String*/ statusText) {
            // summary:
            //      Updates the content status indication with the supplied text
            // tags: private

            this.statusTextNode.innerHTML = statusText;

            domStyle.set(this.stateNode, "visibility", statusText ? "visible" : "hidden");
            domAttr.set(this.stateNode, "title", string.stripHtmlTags(statusText));
        },

        // buttonText: [protected] String
        //      Publish button label.
        _setButtonTextAttr: function (val) {
            this.dropDownButton.set("label", val);
        },

        // visible: [protected] Boolean
        //      Visibility of the widget.
        _setVisibleAttr: function (val) {
            domStyle.set(this.domNode, "visibility", val ? "visible" : "hidden");
        },

        _setExpandedAttr: function (expanded) {
            this._set("expanded", expanded);

            this._setStatusNodeText(this.statusText);
        },

        // nonEditableIndicator: [protected] Boolean
        //      Visibility of the noneditable indicator.
        _setNonEditableIndicatorAttr: function (val) {
            if (val) {
                domClass.add(this.statusNonEditableIcon, "epi-iconPenDisabled");
            } else {
                domClass.remove(this.statusNonEditableIcon, "epi-iconPenDisabled");
            }
        },

        // statusIcon: [protected] String
        //      Content status icon.
        _setStatusIconAttr: function (val) {
            if (this.get("statusIcon")) {
                domClass.remove(this.statusTextIcon, this.get("statusIcon"));
            }
            this._set("statusIcon", val);
            domClass.add(this.statusTextIcon, val);
        },

        _setAdditionalClassAttr: function (val) {
            // remove
            var currentAdditionalClass = this.get("additionalClass");
            if (currentAdditionalClass) {
                domClass.remove(this.stateNode, currentAdditionalClass);
            }
            // add new
            this._set("additionalClass", val);
            domClass.add(this.stateNode, val);
        },

        focus: function () {
            // summary:
            //      Set focus on the widget
            // description:
            //      The dropdown menu will be the one takes focus when the widget become focused.

            this.dropDownButton.focus();
        },

        toggleDropDownMenu: function (val) {
            // summary:
            //      Close the dropdown menu if necessary and prevent it from being opened
            // description:
            //      The dropdown menu will be the one takes focus when the widget become focused.
            domStyle.set(this.dropDownMenu.domNode, "display", val ? "" : "none");
            this.dropDownButton.set("disabled", !val);
        },

        _setPublishMenuViewModelAttr: function (val) {
            this.dropDownMenu.set("model", val);
        },

        postCreate: function () {
            this.inherited(arguments);

            // align dropdown menu open on the left of the button
            this.dropDownButton.dropDownPosition = ["below-alt"];
        }
    });
});

},
'epi-cms/contentediting/PublishMenu':function(){
define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/html",
    "dojo/on",
    "dojo/sniff",
    "dojo/Stateful",
    "dojo/when",

    // Dijit
    "dijit/DropDownMenu",
    "dijit/_KeyNavContainer",
    "dijit/_WidgetsInTemplateMixin",

    // EPi Framework
    "epi",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/command/builder/MenuBuilder",
    "epi/shell/Downloader",

    // EPi CMS
    "epi-cms/contentediting/ContentActionSupport",

    // Resources
    "dojo/text!./templates/PublishMenu.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu"
],

function (
// Dojo
    array,
    declare,
    event,
    lang,
    domStyle,
    domAttr,
    domClass,
    domGeometry,
    html,
    on,
    sniff,
    Stateful,
    when,

    // Dijit
    DropDownMenu,
    _KeyNavContainer,
    _WidgetsInTemplateMixin,

    // EPi Framework
    epi,
    TypeDescriptorManager,
    _ModelBindingMixin,
    MenuBuilder,
    Downloader,

    // EPi CMS
    ContentActionSupport,

    // Resources
    template,
    res
) {
    return declare([DropDownMenu, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // tags:
        //      internal

        templateString: template,
        res: res,

        // _menuBuilder: [private] Object
        //      Instance of menu builder
        _menuBuilder: null,

        // Binding properties
        commands: null,
        mainButtonCommand: null,

        postMixInProperties: function () {
            this._menuBuilder = new MenuBuilder();
        },

        // Binding map
        modelBindingMap: {
            commands: ["commands"],
            mainButtonCommand: ["mainButtonCommand"],

            mainButtonSectionVisible: ["mainButtonSectionVisible"],

            lastChangeStatus: ["lastChangeStatus"],

            topInfoSectionVisible: ["topInfoSectionVisible"],

            publishInfoSectionVisible: ["publishInfoSectionVisible"],
            lastPublishedTitle: ["lastPublishedTitle"],
            lastPublishedTitleVisible: ["lastPublishedTitleVisible"],
            lastPublishedText: ["lastPublishedText"],
            lastPublishedViewLinkVisible: ["lastPublishedViewLinkVisible"],
            lastPublishedViewLinkHref: ["lastPublishedViewLinkHref"],

            additionalInfoSectionVisible: ["additionalInfoSectionVisible"],
            additionalInfoText: ["additionalInfoText"],

            typeIdentifier: ["typeIdentifier"],
            bottomInfoSectionVisible: ["bottomInfoSectionVisible"]
        },

        _setCommandsAttr: function (commands) {
            // Move focus away from current menu item, which may be removed after command executed.
            this.focusedChild = null;

            //Remove all children first
            this.destroyDescendants();

            this._addCommandsToMenu(commands);

            // Set focus on the main button or the first focusable item.
            this.focusFirstChild();
        },

        _setMainButtonCommandAttr: function (command) {
            this._set("mainButtonCommand", command);
            if (command) {
                this.mainButton.set("label", command.label);
                this.mainButton.set("disabled", !command.get("canExecute"));
                domClass.remove(this.mainButton.domNode, "epi-loading");

                if (this._addedMainButtonClass) {
                    domClass.remove(this.mainButton.domNode, this._addedMainButtonClass);
                }

                if (command.options && command.options.mainButtonClass) {
                    this._addedMainButtonClass = command.options.mainButtonClass;
                    domClass.add(this.mainButton.domNode, this._addedMainButtonClass);
                }
            }
        },

        _setMainButtonSectionVisibleAttr: function (visible) {
            domStyle.set(this.mainButtonSection, "display", visible ? "" : "none");

            // When hiding the main button section, we have to also hide the main button. Otherwise it is still focusable.
            domStyle.set(this.mainButton.domNode, "display", visible ? "" : "none");
        },

        _setLastChangeStatusAttr: {
            node: "lastChangeStatusNode",
            type: "innerHTML"
        },

        _setTopInfoSectionVisibleAttr: function (visible) {
            domStyle.set(this.topInfoSection, "display", visible ? "" : "none");
        },

        _setBottomInfoSectionVisibleAttr: function (visible) {
            domStyle.set(this.bottomInfoSection, "display", visible ? "" : "none");
        },

        _setPublishInfoSectionVisibleAttr: function (visible) {
            domStyle.set(this.publishInfoSection, "display", visible ? "" : "none");
        },

        _setLastPublishedTitleAttr: {
            node: "lastPublishedTitleNode",
            type: "innerHTML"
        },

        _setLastPublishedTitleVisibleAttr: function (visible) {
            domStyle.set(this.lastPublishedTitleNode, "display", visible ? "" : "none");
        },

        _setLastPublishedTextAttr: {
            node: "lastPublishedTextNode",
            type: "innerHTML"
        },

        _setLastPublishedViewLinkVisibleAttr: function (visible) {
            domStyle.set(this.lastPublishedViewLinkNode, "display", visible ? "" : "none");
        },

        _setLastPublishedViewLinkHrefAttr: function (value) {
            domAttr.set(this.lastPublishedViewLinkNode, "href", value);
        },

        _setAdditionalInfoSectionVisibleAttr: function (visible) {
            domStyle.set(this.additionalInfoSection, "display", visible ? "" : "none");
        },

        _setAdditionalInfoTextAttr: {
            node: "additionalInfoNode",
            type: "innerHTML"
        },

        _setTypeIdentifierAttr: function (/*String*/typeIdentifier) {

            var contentData = this.model && this.model.dataModel && this.model.dataModel.contentData,
                isDowloadLinkAvaiable = contentData && contentData.downloadUrl,
                typeShouldActAsAsset = typeIdentifier && TypeDescriptorManager.getValue(typeIdentifier, "actAsAnAsset");

            if (!typeShouldActAsAsset || !isDowloadLinkAvaiable) {
                // Restore default view
                domAttr.set(this.lastPublishedViewLinkNode, "title", res.lastpublishedviewlinktooltip);
                html.set(this.lastPublishedViewLinkNode, res.view);

                // Clear event handler
                if (this._downloadClickHandler) {
                    this._downloadClickHandler.remove();
                    this._downloadClickHandler = null;
                }
                return;
            }

            domAttr.set(this.lastPublishedViewLinkNode, "title", res.download);
            html.set(this.lastPublishedViewLinkNode, res.download);

            // Listen on click event to start download by Downloader
            if (!this._downloadClickHandler) {
                this.own(this._downloadClickHandler = on(this.lastPublishedViewLinkNode, "click", lang.hitch(this, function (e) {
                    event.stop(e);

                    // Should re-calculate to get correct contentData because event listense is added one time
                    // and used for multiple time (for different kinds of content).
                    var contentData = this.model && this.model.dataModel && this.model.dataModel.contentData,
                        url = contentData && contentData.downloadUrl,
                        name = contentData.name;

                    Downloader.download(url, name);
                })));
            }
        },

        postCreate: function () {
            this.inherited(arguments);

            // The main button should behave like a normal menu item.
            // When focused item is the main button and user close the menu, these functions which are not implemented in dijit/form/Button will be called.
            // So we supply dummy ones.
            this.mainButton._setSelected = this.mainButton._onUnhover = function () { };
        },

        onOpen: function () {
            this.model.set("isOpen", true);
            this.inherited(arguments);
        },

        onClose: function () {
            this.model.set("isOpen", false);
            this.inherited(arguments);
        },

        _setModelAttr: function () {
            this.inherited(arguments);

            // No need to do a destroyByKey as _ModelBindingMixin
            this.ownByKey(this.model, this.connect(this.model, "onCommandsChanged", "onCommandsChanged"));
        },

        onCommandsChanged: function (name, removed, added) {
            // summary:
            //		Callback when available commands have been changed.
            // tags:
            //		public

            if (removed) {
                this._removeCommandsFromMenu(lang.isArray(removed) ? removed : [removed]);
            }
            if (added) {
                this._addCommandsToMenu(lang.isArray(added) ? added : [added]);
            }
        },

        _addCommandsToMenu: function (commands) {
            // summary:
            //		Transforms the commands into widgets and adds them to the toolbar.
            // tags:
            //		private

            array.forEach(commands, function (command) {
                if (command !== this.model.mainButtonCommand) {
                    this._menuBuilder.create(command, this);
                }
            }, this);
        },

        _removeCommandsFromMenu: function (commands) {
            // summary:
            //		Removes the commands from the toolbar.
            // tags:
            //		private

            var children = this.getChildren();

            array.forEach(commands, function (command) {
                for (var i = children.length - 1; i >= 0; i--) {
                    var item = children[i];
                    if (item._command === command) {
                        this.removeChild(item);
                        item.destroyRecursive();
                        break;
                    }
                }
            }, this);
        },

        _onMainButtonClick: function () {
            if (this.mainButtonCommand) {
                this.mainButton.set("label", this.mainButtonCommand.executingLabel);
                domClass.add(this.mainButton.domNode, "epi-loading");

                var lastExecutedCommand = this.mainButtonCommand,
                    resetMainButton = lang.hitch(this, function () {
                        if (lastExecutedCommand.options && lastExecutedCommand.options.resetLabelAfterExecution) {
                            this.mainButton.set("label", lastExecutedCommand.label);
                        }
                        domClass.remove(this.mainButton.domNode, "epi-loading");

                        if (lastExecutedCommand.options && !lastExecutedCommand.options.keepMenuOpen) {
                            this.onExecute();
                        }
                    }),
                    setLastExecutedCommand = lang.hitch(this, function () {
                        this.model.set("lastExecutedCommand", lastExecutedCommand);
                    });

                when(this.mainButtonCommand.execute(), function () {
                    return when(resetMainButton(), setLastExecutedCommand);
                }, function () {
                    return resetMainButton();
                });
            }
        },

        focusFirstChild: function () {
            // summary:
            //		Focus the first focusable child in the container.
            // tags:
            //		protected

            if (this.mainButton.isFocusable()) {
                return this.focusChild(this.mainButton);
            } else {
                return this.inherited(arguments);
            }
        },

        focusNext: function () {
            // summary:
            //		Focus the next widget
            // tags:
            //		protected

            var lastFocusableMenuItem = this._getLastFocusableChild();
            if (!this.focusedChild.focused) {
                return this.focusChild(this._getFirstFocusableChild());
            } else if (this.focusedChild === lastFocusableMenuItem) {
                this.focusedChild._setSelected(false);
                return domStyle.get(this.mainButton.domNode, "display") === "none" ?
                    this.lastPublishedViewLinkNode.focus() : this.focusChild(this.mainButton);
            } else if (this.focusedChild === this.mainButton) {
                return this.lastPublishedViewLinkNode.focus();
            } else {
                return this.inherited(arguments);
            }
        },

        focusPrev: function () {
            // summary:
            //		Focus the next widget
            // tags:
            //		protected

            var firstFocusableMenuItem = this._getFirstFocusableChild();
            if (!this.focusedChild.focused) {
                return domStyle.get(this.mainButton.domNode, "display") === "none" ?
                    this.focusChild(this._getLastFocusableChild()) : this.focusChild(this.mainButton);
            } else if (this.focusedChild === firstFocusableMenuItem) {
                this.focusedChild._setSelected(false);
                return this.lastPublishedViewLinkNode.focus();
            } else {
                return this.inherited(arguments);
            }
        },

        resize: function (marginBox) {
            // summary:
            //      Resize action menu fit to large of main button or menu item
            // tags:
            //      Protected

            // Get dom geometry
            var selfMargin = domGeometry.getMarginBox(this.domNode),
                topPadding = domGeometry.getPadExtents(this.topInfoSection),
                mainButtonMargin = domGeometry.getMarginBox(this.mainButton.containerNode),
                menuMargin = domGeometry.getMarginBox(this.containerNode);

            // Get max width of domNode, main button and menu item
            var maxWidth = Math.max(mainButtonMargin.w + topPadding.l + topPadding.r, selfMargin.w);
            maxWidth = Math.max(menuMargin.w, maxWidth);

            marginBox.w = maxWidth;
            domGeometry.setMarginBox(this.domNode, marginBox);
        }
    });
});

},
'epi/shell/Downloader':function(){
﻿define("epi/shell/Downloader", [
// Dojo
    "dojo/_base/lang",
    "dojo/dom-construct"
],
function (
// Dojo
    lang,
    domConstruct
) {
    return {
        // summary:
        //      Downloader static class that used to force download media file from browser by javascript.
        // tags:
        //      internal xproduct

        _classicalDownload: function (/*String*/url, /*String*/name) {
            // summary:
            //      Classical method to download file by direct url.
            // tags:
            //      private

            // Create a temporary anchor link, trigger click event and then destroy it!
            var bodyNode = document.getElementsByTagName("body")[0],
                dowloadLinkAttributes = {
                    href: url,
                    download: name,
                    target: "_blank",
                    style: { display: "none;" }
                },
                downloadLinkNode = domConstruct.create("a", dowloadLinkAttributes, bodyNode, "last");

            downloadLinkNode.click();
            domConstruct.destroy(downloadLinkNode);
        },

        download: function (/*String*/url, /*String*/name) {
            // summary:
            //      Download and save a blob content to local device.
            // tags:
            //      public virtual

            if (url) {
                return this._classicalDownload(url, name);
            }
        }
    };
});

},
'url:epi-cms/contentediting/templates/PublishMenu.html':"﻿<div class=\"epi-invertedTooltip epi-publishActionMenu\" role=\"menu\" tabIndex=\"${tabIndex}\" data-dojo-attach-event=\"onkeypress:_onKeyPress\" >\r\n    <div class=\"epi-tooltipDialogTop\" data-dojo-attach-point=\"topInfoSection\">\r\n        <ul>\r\n            <li data-dojo-attach-point=\"lastChangeStatusNode\" class=\"epi-lastchangeStatus\"></li>\r\n            <li data-dojo-attach-point=\"mainButtonSection\">\r\n                <button data-dojo-type=\"dijit/form/Button\"\r\n                        data-dojo-attach-point=\"mainButton\"\r\n                        data-dojo-attach-event=\"onClick: _onMainButtonClick\"\r\n                        class=\"epi-button--full-width\"></button>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n    <div class=\"epi-tooltipDialogInfo\"data-dojo-attach-point=\"publishInfoSection\">\r\n        <ul>\r\n            <li data-dojo-attach-point=\"lastPublishedTitleNode\"></li>\r\n            <li>\r\n                <span data-dojo-attach-point=\"lastPublishedTextNode\"></span>\r\n            </li>\r\n            <li>\r\n                <a href=\"#\" title=\"${res.lastpublishedviewlinktooltip}\" data-dojo-attach-point=\"lastPublishedViewLinkNode\">${res.view}</a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n    <div class=\"epi-tooltipDialogInfo\" data-dojo-attach-point=\"additionalInfoSection\">\r\n        <ul>\r\n            <li data-dojo-attach-point=\"additionalInfoNode\"></li>\r\n        </ul>\r\n    </div>\r\n    <table class=\"dijitReset epi-tooltipDialogMenu epi-menuInverted\" data-dojo-attach-point=\"bottomInfoSection\" cellspacing=\"0\">\r\n\t    <tbody data-dojo-attach-point=\"containerNode\" ></tbody>\r\n    </table>\r\n</div>\r\n",
'url:epi-cms/contentediting/templates/EditActionPanel.html':"﻿<div style=\"display: inline-block\">\r\n    <div class=\"dijitInline dijitReset\" data-dojo-attach-point=\"stateNode\">\r\n        <span data-dojo-attach-point=\"statusNonEditableIcon\" class=\"dijitInline dijitReset dijitIcon\">&nbsp;</span>\r\n        <span class=\"epi-statusContainer dijitInline dijitReset\">\r\n            <span data-dojo-attach-point=\"statusTextIcon\" class=\"dijitInline dijitReset dijitIcon\"></span>\r\n            <span data-dojo-attach-point=\"statusTextNode\" class=\"epi-statusText\"></span>\r\n        </span><span class=\"epi-statusArrow dijitInline dijitReset\"></span><!-- These need to be on the same line. -->\r\n    </div>\r\n\r\n\r\n\r\n    <div data-dojo-attach-point=\"dropDownButton\" data-dojo-type=\"dijit/form/DropDownButton\"\r\n        data-dojo-props=\"label: '${commonRes.action.publish}', 'class': 'epi-mediumButton epi-button--bold'\">\r\n        <div data-dojo-attach-point=\"dropDownMenu\" data-dojo-type=\"epi-cms/contentediting/PublishMenu\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/NotificationBar':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/_base/array",
    "dojo/on",

    // Dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_Container",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/Evented",
    "dijit/form/Button",

    // Dojox
    "dojox/html/ellipsis",

    //Resources
    "dojo/text!./templates/NotificationBar.html",
    "dojo/text!./templates/NotificationBarItem.html"

], function (
    declare,
    lang,
    domClass,
    domStyle,
    domConstruct,
    array,
    on,

    _TemplatedMixin,
    _Widget,
    _Container,
    _WidgetsInTemplateMixin,
    Evented,
    Button,

    ellipsis,

    template,
    notificationBarItemTemplate) {

    var NotificationBarItem = declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, Evented], {
        templateString: notificationBarItemTemplate,
        item: null,
        viewModel: null,

        postCreate: function () {
            this.inherited(arguments);

            if (this.item.content) {
                this._addContent(this.item);
            }

            this._addCommands(this.item);
        },


        _onClose: function (e) {
            e.preventDefault();

            this.emit("close", this);
        },

        _addContent: function (item) {
            //If it's a string, add it to innerHTML
            if (lang.isString(item.content)) {
                this.textContainer.innerHTML = this.item.content;
            } else { //if its not a string, its assumed to be a dom object.
                domConstruct.place(this.item.content, this.textContainer);
            }
        },

        _addCommands: function (item) {
            if (lang.isArray(this.item.commands)) { //check if it has any commands
                array.forEach(this.item.commands, lang.hitch(this, function (command) {
                    this._addButtonForCommand(command);
                }));
            }
        },

        _addButtonForCommand: function (command) {
            var button = new Button({
                label: command.label,
                title: command.tooltip,
                iconClass: command.iconClass
            });

            if (command.cssClass) {
                domClass.add(button.domNode, command.cssClass);
            }

            button.set("disabled", !command.canExecute);

            button.on("click", function () {
                command.execute();
            });

            this.own(command.watch("canExecute", lang.hitch(this, function () {
                button.set("disabled", !command.canExecute);
            })));

            button.domNode.classList.toggle("dijitHidden", !command.isAvailable);
            this.own(command.watch("isAvailable", function (value) {
                button.domNode.classList.toggle("dijitHidden", !value);
            }.bind(this)));

            if (command.category === "leftAligned") {
                button.placeAt(this.contentContainer, "first");
            } else {
                button.placeAt(this.buttonContainer, "first");
            }

            this.own(button);
        }
    });

    var NotificationBar = declare([_Widget, _Container, _TemplatedMixin, _WidgetsInTemplateMixin, Evented], {
        // tags:
        //      internal xproduct

        templateString: template,

        noBorderClass: "epi-notificationBarWithoutBorder",

        buildRendering: function () {
            this.inherited(arguments);
            this._hideIfEmpty();
        },

        clear: function () {
            this._hideIfEmpty();

            array.forEach(this.getChildren(), function (widget) {
                this.removeChild(widget);
                widget.destroy();
                widget = null;
            }, this);

            this.emit("notificationsChanged");
        },

        destroy: function () {
            this.destroyDescendants();

            this.inherited(arguments);
        },

        add: function (notification, /*int?*/ insertIndex) {
            // summary:
            //    Adds a notification to the notification bar.
            //
            // description:
            //    Notification can be either just text or an object containing content and commands. If it contains an array of commands
            //    the commands will be added as buttons.

            var notificationBarItem = new NotificationBarItem({ item: notification });

            this.own(on(notificationBarItem, "close", lang.hitch(this, "_onCloseNotification")));

            this.addChild(notificationBarItem, insertIndex);

            this._hideIfEmpty();

            this.emit("notificationsChanged");
        },

        remove: function (notification) {
            array.forEach(this.getChildren(), lang.hitch(this, function (childWidget) {
                if (childWidget.item && childWidget.item === notification) {
                    this._onCloseNotification(childWidget);
                }
            }));

            this._hideIfEmpty();
        },

        _onCloseNotification: function (item) {
            this.removeChild(item);

            item.destroy();
            item = null;

            this._hideIfEmpty();

            this.emit("notificationsChanged");
        },

        _hideIfEmpty: function () {

            var show = this.getChildren().length > 0;

            domClass.toggle(this.domNode, this.noBorderClass, !show);

            domStyle.set(this.domNode, "display", show ? "" : "none");
        }
    });

    return NotificationBar;
});

},
'url:epi-cms/contentediting/templates/NotificationBar.html':"﻿<div class=\"epi-notificationBar\">\r\n    <div data-dojo-attach-point=\"containerNode\"></div>\r\n</div>",
'url:epi-cms/contentediting/templates/NotificationBarItem.html':"﻿<div class=\"epi-notificationBarItem\">\r\n    <div class=\"epi-notificationBarText\" data-dojo-attach-point=\"contentContainer\">\r\n        <p data-dojo-attach-point=\"textContainer\"></p>\r\n    </div>\r\n    <div class=\"epi-notificationBarButtonContainer\" data-dojo-attach-point=\"buttonContainer\">\r\n        <button data-dojo-type=\"dijit/form/Button\" class=\"epi-chromelessButton\" data-dojo-props=\"iconClass:'epi-iconClose', showLabel:false\" data-dojo-attach-event=\"onClick:_onClose\"></button>\r\n    </div>\r\n</div>",
'epi-cms/activity/ActivityFeed':function(){
define([
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dijit/focus",
    "dijit/registry",
    "epi/debounce",
    "epi/dependency",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/_CssStateMixin",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/widget/_ModelBindingMixin",
    // List modules
    "dgrid/OnDemandList",
    "dgrid/extensions/DijitRegistry",
    "epi/shell/dgrid/WidgetRow",
    // Activity modules
    "epi-cms/activity/Activity",
    "epi-cms/activity/ActivityCommentForm"
], function (
    declare,
    aspect,
    domClass,
    domGeometry,
    domStyle,
    focusManager,
    registry,
    debounce,
    dependency,
    // Parent class and mixins
    _WidgetBase,
    _CssStateMixin,
    _FocusableMixin,
    _ModelBindingMixin,
    // List modules
    OnDemandList,
    DijitRegistry,
    WidgetRow,
    // Activity modules
    Activity,
    ActivityCommentForm
) {

    // Create a custom list class for the activity feed.
    var ActivityList = declare([OnDemandList, DijitRegistry, WidgetRow]);

    return declare([_WidgetBase, _CssStateMixin, _FocusableMixin, _ModelBindingMixin], {
        // summary:
        //      A widget used to list activities.
        // tags:
        //      internal

        // baseClass: [protected] String
        //      The base CSS class of the widget, used to construct CSS classes
        //      to indicate widget state.
        baseClass: "epi-activity-feed",

        // noDataMessage: [public] String
        //      The message to display when there is no data returned by the server
        //      or when there is no query.
        noDataMessage: "",

        // query: [public] Object
        //      The object used to query the store for activities.
        query: null,

        // queryOptions: [public] Object
        //      The object used to define query options for the activities store.
        queryOptions: null,

        // modelBindingMap: [protected] Object
        //      A map contain bindings from the model to properties on this object.
        modelBindingMap: {
            isSingleItemSelected: ["isSingleItemSelected"],
            query: ["query"],
            noDataMessage: ["noDataMessage"]
        },

        postMixInProperties: function () {
            // summary:
            //      Processing after the parameters to the widget have been read-in,
            //      but before the widget template is instantiated.
            // tags:
            //      protected

            this.inherited(arguments);

            this.queryOptions = this.queryOptions || { sort: [{ attribute: "created", descending: true }] };
        },

        buildRendering: function () {
            // summary:
            //      Build the list component to be shown within this widget.
            // tags:
            //      protected

            this.inherited(arguments);

            this.commentForm = new ActivityCommentForm({ model: this.model });
            // Style the comment form as a card.
            domClass.add(this.commentForm.domNode, "epi-card");

            this.list = new ActivityList({
                className: "dgrid--centered-no-data-message",
                cleanEmptyObservers: false,
                renderRow: this._renderRow.bind(this),
                keepScrollPosition: true
            });

            // Set tabIndex on bodyNode to mimic the behavior usually handled by dgrid/Keyboard.
            this.list.bodyNode.tabIndex = 0;

            this.own(
                this.commentForm,
                this.model.on("save", this.focus.bind(this)),
                aspect.around(this.list, "resize", this._resizeList.bind(this))
            );

            // Append the child widgets to the DOM.
            this.commentForm.placeAt(this.list.bodyNode, "first");
            this.domNode.appendChild(this.list.domNode);

            this.list.resize();
        },

        startup: function () {
            // summary:
            //      Processing after the DOM fragment is added to the document. Also calls
            //      startup on the list.
            // tags:
            //      public

            this.inherited(arguments);
            this.commentForm.startup();
            this.list.startup();
        },

        focus: function () {
            // summary:
            //      Gives focus to the activity feed.
            // tags:
            //      public

            focusManager.focus(this.list.bodyNode);
        },

        refresh: function () {
            // summary:
            //      Refreshes the list causing it to query the server for new data.
            // tags:
            //      public

            this.list.refresh();
        },

        _renderRow: function (value) {
            // summary:
            //      Renders an activity widget for the row and returns its DOM node.
            // tags:
            //      private
            var activity = new Activity({activity: value});

            // Style each row in the list as a card.
            domClass.add(activity.domNode, "epi-card");

            return activity.domNode;
        },

        _resizeList: function (originalMethod) {
            // summary:
            //      Aspect method that is run when the list is resized.
            //      Sets the size of the body node taking into account
            //      the activity comment form size.
            // tags:
            //      private

            return function () {
                originalMethod.apply(this.list, arguments);

                var height =
                    this.model.isSingleItemSelected ?
                        domGeometry.getMarginBox(this.commentForm.domNode).h : 0;

                domStyle.set(this.list.contentNode, "height", "calc(100% - " + height + "px)");
            }.bind(this);
        },

        _setNoDataMessageAttr: function (noDataMessage) {
            // summary:
            //      Sets the no data message property and updates the grid.
            // tags:
            //      protected

            this.noDataMessage = noDataMessage;

            this.list.set("noDataMessage", noDataMessage);
        },

        _setQueryAttr: function (query) {
            // summary:
            //      Sets the query property and updates the grid, debouncing if needed.
            // tags:
            //      protected

            this._set("query", query);

            if (!this._queryFunction) {
                this._queryFunction = debounce(this._setQueryCallback.bind(this), null, 200);
            }

            this._queryFunction(this.model.store, query);
        },

        _setQueryCallback: function (store, query) {
            // summary:
            //      Callback that sets the grid's query and updates the
            //      grid when debouncing has finished.
            // tags:
            //      private

            // Do an early exit if this widget has been destroyed.
            if (this._destroyed) {
                return;
            }

            var isSingleItem = this.model.isSingleItemSelected;

            // Toggle the single item modifier class when this is one so
            // that content names on activities can be hidden with CSS.
            domClass.toggle(this.domNode, "epi-activity-feed--single-item", isSingleItem);

            // Toggle the visibility of the comment form dependent on the
            // number of items selected.
            domClass.toggle(this.commentForm.domNode, "dijitHidden", !isSingleItem);

            if (query) {
                this.list.set("store", store, query, this.queryOptions);
            } else {
                this.list.set("store", null);
            }

            // Resize the list to account for the size of the comment form.
            this.list.resize();
        }
    });
});

},
'epi/shell/dgrid/WidgetRow':function(){
define("epi/shell/dgrid/WidgetRow", [
    "dojo/_base/declare",
    "dijit/registry"
], function (declare, registry) {

    return declare(null, {
        // summary:
        //      A dgrid mixin which implements the insert row and remove row methods to ensure that
        //      the startup and destroy methods are run on the row when the row is a widget.
        //      Widgets using this mixin should override the render row method so that it returns
        //      the DOM node of a widget.
        // tags:
        //      public

        insertRow: function () {
            // summary:
            //      Ensures the widget is started after it has been inserted into the document.

            var row = this.inherited(arguments),
                widget = registry.byNode(row);

            widget.startup();

            return row;
        },

        removeRow: function (rowElement, justCleanup) {
            // summary:
            //      Destroys the widget associated with the row as well as removing the row from
            //      the list.
            // rowElement: Object|DOMNode
            //      Object or element representing the row to be removed.
            // justCleanup: Boolean
            //      If true, the row element will not be removed from the DOM.

            this.inherited(arguments);

            var element = rowElement.element || rowElement,
                widget = registry.byNode(element);

            if (widget) {
                widget.destroyRecursive(justCleanup);
            }
        }
    });
});

},
'epi-cms/activity/Activity':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "./ActivityComment",
    "./viewmodels/ActivityViewModel",
    "./viewmodels/ActivityCommentViewModel",
    "./viewmodels/MessageActivityViewModel",
    // Parent class and mixins
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi/shell/widget/_ModelBindingMixin",
    // Resources
    "dojo/text!./templates/Activity.html",
    "epi/i18n!epi/cms/nls/episerver.cms.activities.activity",
    //Widgets in the template
    "epi-cms/activity/ActivityCommentForm"
], function (
    declare,
    lang,
    domClass,
    ActivityComment,
    ActivityViewModel,
    ActivityCommentViewModel,
    MessageActivityViewModel,
    // Parent class and mixins
    _LayoutWidget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _ModelBindingMixin,
    // Resources
    template,
    localizations
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      A widget used to display an activity.
        // tags:
        //      internal

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // model: [protected] ActivityViewModel
        //      The view model which is a ActivityViewModel object.
        model: null,

        // modelBindingMap: [protected] Object
        //      A map contain bindings from the model to properties on this object.
        modelBindingMap: {
            upsertActivityComment: ["upsertActivityComment"]
        },

        buildRendering: function () {
            this.inherited(arguments);

            var activity = this.activity;

            var model = new ActivityViewModel({
                activity: activity
            });
            this.set("model", model);
            this.own(this.model);

            this.commentForm.set("model", model);

            if (activity.canBeRepliedTo === false) {
                domClass.add(this.commentForm.domNode, "dijitHidden");
            }

            this.titleNode.textContent = model.get("title");

            domClass.add(this.iconNode, model.get("iconClass"));

            // Set the color on the action node and the icon classes.
            domClass.add(this.actionIconNode, model.get("actionIconClass"));
            domClass.add(this.actionNode, model.get("actionClass"));

            this.actionTextNode.textContent = model.get("content");

            // If the activity has a message property create an ActivityComment widget
            // and render the message
            if (activity.message) {
                domClass.add(this.domNode, "epi-activity__message");
                this.own(this._messageForm = new ActivityComment({ model: new MessageActivityViewModel(activity) }, this.messageNode));
            }
            var comment = model.getComment();
            if (comment) {
                // we assign innerHTML instead of textContent to be consistent with other comments
                this.activityCommentNode.innerHTML = comment;
            } else {
                domClass.add(this.activityCommentNode, "dijitHidden");
            }

            // Create an ActivityComment widget for each comment
            if (activity.comments) {
                activity.comments.forEach(function (comment) {
                    this.set("upsertActivityComment", comment);
                }, this);
            }
        },

        startup: function () {
            this.inherited(arguments);

            //Start the message comment form if it has been created
            this._messageForm && this._messageForm.startup();
        },

        _getActivityCommentComponent: function (commentId) {
            // summary:
            //      Returns the ActivityComment component and its position if it has been added to the activity
            //      If comment isn't added yet then the position will be -1.
            // tags:
            //      private

            var index = -1;
            var existingComment = null;

            var allActivityComments = this.getChildren() || [];

            for (var i = 0; i < allActivityComments.length; i++) {
                index = i;
                var current = allActivityComments[i];
                if (current.get("model").id === commentId) {
                    existingComment = current;
                    break;
                }
            }

            return { position: (existingComment !== null ? index : -1), activityComment: existingComment };
        },

        _setUpsertActivityCommentAttr: function (comment) {
            // summary:
            //      Adds new or updates an existing ActivityComment to the the current Activity.
            // tags:
            //      private


            if (!comment) {
                return;
            }

            // find the comment and its position
            var foundActivityComment = this._getActivityCommentComponent(comment.id);
            var oldComment = foundActivityComment.activityComment;
            var position = (foundActivityComment.position === -1 ? this.getChildren().length : foundActivityComment.position);

            // if comment already added then remove it since its easy to remove and add again than to update the entire UI state
            if (oldComment) {

                // if the new comment is the same as existing then don't continue
                var oldCommentUpdatedAt = new Date(oldComment.get("model").lastUpdated).getTime();
                var newCommentUpdatedAt = new Date(comment.lastUpdated).getTime();
                if (oldCommentUpdatedAt === newCommentUpdatedAt) {
                    return;
                }

                // remove from activity and then destroy it
                this.removeChild(oldComment);
                oldComment.destroyRecursive();
            }

            // create new ActivityComment component and add it as a child component
            var activityComment = new ActivityComment({ model: new ActivityCommentViewModel(comment) });
            this.addChild(activityComment, position);
        }
    });
});

},
'epi-cms/activity/ActivityComment':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "epi/datetime",
    "epi/username",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi/shell/widget/_ModelBindingMixin",
    // Resources
    "dojo/text!./templates/ActivityComment.html",
    "epi/i18n!epi/cms/nls/episerver.cms.activities.activity.message",
    // Widgets in template
    "./ActivityCommentForm",
    "dijit/form/Button"
], function (
    declare,
    lang,
    domClass,
    datetime,
    username,
    // Parent class and mixins
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _ModelBindingMixin,
    // Resources
    template,
    localizations
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      A widget used to display an activity comment.
        // tags:
        //      internal

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // Declare view model binding
        modelBindingMap: {
            hasChanged: ["hasChanged"]
        },

        _setHasChangedAttr: function (hasChanged) {
            // summary:
            //      Sets the has changed flag and toggles the visibility
            //      of the edited icon based on whether there are changes.
            // tags:
            //      protected

            this._set("hasChanged", hasChanged);

            var lastUpdated = lang.replace(localizations.editedformat, {
                updated: datetime.toUserFriendlyString(this.model.lastUpdated)
            });

            this.editedTextNode.title = lastUpdated;
            domClass.toggle(this.editedTextNode, "dijitHidden", !hasChanged);
        },

        buildRendering: function () {
            this.inherited(arguments);

            var user = this.model.changedBy || this.model.author;
            this.usernameNode.textContent = username.toUserFriendlyString(user, null, false, false, true);
            this.timestampNode.textContent = datetime.toUserFriendlyString(this.model.created);
            this.editedTextNode.textContent = localizations.edited;
        }
    });
});

},
'url:epi-cms/activity/templates/ActivityComment.html':"<div class=\"epi-activity-comment\">\r\n    <header>\r\n        <span class=\"dijitReset dijitInline epi-username\" data-dojo-attach-point=\"usernameNode\"></span>\r\n        <span class=\"dijitReset dijitInline epi-event__timestamp\" data-dojo-attach-point=\"timestampNode\"></span>\r\n        <span class=\"dijitReset dijitInline epi-event__timestamp\" data-dojo-attach-point=\"editedTextNode\"></span>\r\n    </header>\r\n    <div data-dojo-type=\"epi-cms/activity/ActivityCommentForm\"\r\n         data-dojo-props=\"model: this.model\"\r\n         data-dojo-attach-point=\"commentForm\"></div>\r\n</div>\r\n",
'epi-cms/activity/ActivityCommentForm':function(){
define([
    "dojo/_base/declare",
    "dojo/dom-class",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_FocusMixin",
    "epi/shell/widget/_ModelBindingMixin",
    // Resources
    "dojo/text!./templates/ActivityCommentForm.html",
    // Widgets in template
    "epi/shell/widget/AutoCompleteTextarea",
    "dijit/form/Button"
],
function (
    declare,
    domClass,
    // Parent class and mixins
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _FocusMixin,
    _ModelBindingMixin,
    // Resources
    template
) {
    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _FocusMixin, _ModelBindingMixin], {
        // summary:
        //      A widget for the activity comment form
        // tags:
        //      internal

        // templatePath: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // readOnly: [public] boolean
        //      A flag indicating if the widget is read only
        readOnly: null,

        // hideOnPost: [public] boolean
        //      Hide buttons when post is triggered
        hideOnPost: null,

        // isEditEnabled: [public] boolean
        //      Show/Hide the Edit button depending on the value
        isEditEnabled: true,

        // errorMessage: [public] String
        //      Error message when post fails
        errorMessage: "",

        // Declare view model binding
        modelBindingMap: {
            readOnly: ["readOnly"],
            editLabel: ["editLabel"],
            isEditEnabled: ["isEditEnabled"],
            hideOnPost: ["hideOnPost"],
            errorMessage: ["errorMessage"],
            placeholderText: ["placeholder"],
            sendLabel: ["sendLabel"],
            resetLabel: ["resetLabel"],
            message: ["value"],
            formattedMessage: ["displayValue"],
            noNotificationUserMessage: ["noNotificationUserMessage"],
            notificationUserStore: ["notificationUserStore"]
        },

        postCreate: function () {
            // summary:
            //      Set the widget state after the view is available.
            // tags:
            //      protected

            this.inherited(arguments);

            this._commentChanged(this.get("value"));

            this._commentTextarea.on("save", this._postComment.bind(this));
        },

        _setModelAttr: function (model) {
            this.inherited(arguments);

            //If the model is not readOnly and there is an old value
            //show the forms buttons
            this._toggleFormsButtonVisibility(!model.readOnly && this.get("value") !== "");
        },

        _setErrorMessageAttr: function (errorMessage) {
            this._set("errorMessage", errorMessage);
            this._errorMessage.textContent = errorMessage;
        },

        _setSendLabelAttr: function (sendLabel) {
            this._set("sendLabel", sendLabel);
            if (sendLabel) {
                this._postButton.set("label", sendLabel);
            }
        },

        _setResetLabelAttr: function (resetLabel) {
            this._set("resetLabel", resetLabel);
            if (resetLabel) {
                this._resetButton.set("label", resetLabel);
            }
        },

        _setEditLabelAttr: function (editLabel) {
            this._set("editLabel", editLabel);
            if (editLabel) {
                this._editButton.set("label", editLabel);
            }
        },

        _setIsEditEnabledAttr: function (isEditEnabled) {
            this._set("isEditEnabled", isEditEnabled);

            if (this._editButton) {
                domClass.toggle(this._editButton.domNode, "dijitHidden", !this.isEditEnabled);
            }
        },

        _setNoNotificationUserMessageAttr: function (message) {
            this._commentTextarea.set("noDataMessage", message);
        },

        _setNotificationUserStoreAttr: function (store) {
            this._set("notificationUserStore", store);
            this._commentTextarea.set("store", store);
        },

        _setPlaceholderAttr: function (placeholder) {
            this._commentTextarea.set("placeholder", placeholder);
        },

        _setReadOnlyAttr: function (readOnly) {
            this._set("readOnly", readOnly);

            domClass.toggle(this._commentTextarea.domNode, "dijitHidden", this.readOnly);

            if (this.readOnly) {
                this._toggleFormsButtonVisibility(false);
            }
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            this._commentTextarea.set("value", value);
        },

        _setDisplayValueAttr: function (valuePromise) {
            valuePromise.then(function (value) {
                this.commentNode.innerHTML = value;
            }.bind(this));
        },

        _getValueAttr: function () {
            return this._commentTextarea.get("value");
        },

        _commentChanged: function (comment) {
            // Disable the post button if the comment is empty or hasn't changed
            this._started && this._postButton.set("disabled", !comment || comment === this.model.message);
        },

        _commentFocused: function () {
            //When the user set the focus to the text area we show the post/cancel buttons
            this._toggleFormsButtonVisibility(true);
        },

        _reset: function () {
            // summary:
            //      reset form
            // tags:
            //      private

            //Early exit if the widget is destroyed.
            if (this._destroyed) {
                return;
            }
            this.hideOnPost && this._toggleWriteComment();
            this.model.set("errorMessage", "");
            this._commentTextarea.reset();

            this._toggleFormsButtonVisibility(false);
        },

        _postComment: function () {
            // summary:
            //      Save text area value if a save function is defined
            // tags:
            //      private

            var value = this._commentTextarea.get("value");

            if (value.trim().length === 0) {
                return;
            }

            // Do an early exit if the message is unchanged, or posting is disabled.
            if (value === this.model.message || this._postButton.get("disabled")) {
                this._reset();
                return;
            }

            // Disable posting so the user doesn't accidentally send multiple posts if the server is slow.
            this._postButton.set("disabled", true);

            // Delay so the user doesn't see the spinner directly if the server is fast.
            var delay = 10;

            this.defer(function () {
                domClass.add(this._postButton.domNode, "epi-button--loading");
            }.bind(this), delay);

            this.model.save(value)
                .then(this._reset.bind(this))
                .always(function () {
                    // When we add comments or replies the grid is refreshed and the widget is destroyed.
                    if (!this._destroyed) {
                        this._postButton.set("disabled", false);
                        domClass.remove(this._postButton.domNode, "epi-button--loading");
                    }
                }.bind(this));
        },

        _toggleWriteComment: function () {
            // summary:
            //      Toggles write comment area
            // tags:
            //      private

            domClass.toggle(this._commentTextarea.domNode, "dijitHidden");
            domClass.toggle(this._editButton.domNode, "dijitHidden");
            domClass.toggle(this.commentNode, "dijitHidden");

            // set focus to the comment text area if it is visible
            if (this._commentTextarea.isFocusable()) {
                this._commentTextarea.focus();

                //set caret last in the textarea
                this._commentTextarea.setCaretLast();
            }

            // set focus to the edit button if it is visible
            if (this._editButton.isFocusable()) {
                this._editButton.focus();
            }

        },

        _toggleFormsButtonVisibility: function (visible) {
            domClass.toggle(this._commentFormButtons, "dijitHidden", !visible);
        }

    });
});

},
'url:epi-cms/activity/templates/ActivityCommentForm.html':"<div class=\"epi-activity-comment-form\">\r\n    <div class=\"epi-activity-comment__message\"\r\n         data-dojo-attach-point=\"commentNode\"></div>\r\n    <div data-dojo-attach-point=\"_commentTextarea, focusNode\"\r\n         data-dojo-attach-event=\"onChange:_commentChanged, onFocus: _commentFocused\"\r\n         data-dojo-props=\"intermediateChanges: true, searchProperty: 'name', tagProperty: 'userName', displayProperty: 'displayName'\"\r\n         data-dojo-type=\"epi/shell/widget/AutoCompleteTextarea\" class=\"epi-autocomplete-textarea--chat-icon\"></div>\r\n    <div class=\"epi-activity-comment-form__buttons dijitHidden\"\r\n         data-dojo-attach-point=\"_commentFormButtons\">\r\n        <span class=\"epi-activity-feed__error-message\"\r\n              data-dojo-attach-point=\"_errorMessage\"></span>\r\n        <button data-dojo-type=\"dijit/form/Button\"\r\n                class=\"epi-chromeless epi-chromeless--text-only\"\r\n                data-dojo-attach-point=\"_resetButton\"\r\n                data-dojo-attach-event=\"onClick: _reset\"></button>\r\n        <button data-dojo-type=\"dijit/form/Button\"\r\n                class=\"epi-primary\"\r\n                data-dojo-attach-event=\"onClick:_postComment\"\r\n                data-dojo-props=\"disabled: true\"\r\n                data-dojo-attach-point=\"_postButton\"></button>\r\n    </div>\r\n    <button data-dojo-type=\"dijit/form/Button\"\r\n            class=\"epi-chromeless epi-chromeless--text-only epi-text--small\"\r\n            data-dojo-attach-point=\"_editButton\"\r\n            data-dojo-attach-event=\"onClick: _toggleWriteComment\"></button>\r\n</div>\r\n",
'epi/shell/widget/AutoCompleteTextarea':function(){
﻿define("epi/shell/widget/AutoCompleteTextarea", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/keys",
    "dojo/dom-style",
    "dojo/dom-geometry",
    "dijit/form/_FormValueWidget",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/_TextBoxMixin",
    "dgrid/OnDemandList",
    "dgrid/Selection",
    "epi/debounce",
    "put-selector/put",
    "dijit/popup",
    "epi/shell/dgrid/selection/Extensions",
    // Widgets in template
    "dijit/form/Textarea"
], function (
    declare,
    lang,
    keys,
    domStyle,
    domGeometry,
    _FormValueWidget,
    _WidgetsInTemplateMixin,
    _TextBoxMixin,
    OnDemandList,
    Selection,
    debounce,
    put,
    popup,
    SelectionExtensions
) {

    // Create a custom list class for the suggestion list.
    var SuggestionList = declare([OnDemandList, Selection, SelectionExtensions]);

    return declare([_FormValueWidget, _WidgetsInTemplateMixin], {
        // tags:
        //      internal

        templateString: "<div><div data-dojo-type='dijit/form/Textarea' data-dojo-attach-point='_textArea, focusNode'></div><div data-dojo-attach-point='_listNode'></div></div>",
        baseClass: "epi-autocomplete-textarea",
        value: null,
        store: null,
        placeholder: "",

        // searchProperty: [public] String
        //      The name of the query parameter to use when querying for usernames.
        searchProperty: "query",

        // tagProperty: [public] String
        //      The name of the property to use as the data source for the tag value. This will be
        //      inserted into the text area.
        tagProperty: "",

        // displayProperty: [public] String
        //      The name of the property to use as the data source for the display value. This will
        //      be shown in the list.
        displayProperty: "",

        // noDataMessage: [public] String
        //      The message to show when there are no suggestions that match the tag.
        noDataMessage: "",

        // Override _FormWidgetMixin mapping id to this.focusNode since focus node is also a widget
        // and changing its id will break widget destruction.
        _setIdAttr: "domNode",

        buildRendering: function () {
            this.inherited(arguments);

            var textarea = this._textArea;

            this.own(
                textarea.on("keyup", lang.hitch(this, "_onKeyUp")),
                textarea.on("keydown", lang.hitch(this, "_onKeyDown")),
                textarea.on("change", lang.hitch(this, "_handleOnChange")),
                // Close the popup when the widget loses focus.
                this.on("blur", this._closePopup.bind(this)),

                this._selectList = new SuggestionList({
                    className: "epi-autocomplete-list",
                    selectionMode: "single",
                    renderRow: this._renderRow.bind(this)
                }, this._listNode),

                this._selectList.on(".dgrid-row:click", this._insertSelection.bind(this)),
                this._selectList.on("dgrid-refresh-complete", lang.hitch(this._selectList, "moveSelectionDown"))
            );

            //Move the popup content off screen
            popup.moveOffScreen(this._selectList);
        },

        startup: function () {
            this.inherited(arguments);

            this._selectList.startup();
        },

        focus: function () {
            // summary:
            //		Put focus on this widget
            // remarks:
            //      Check if the widget is focusable before trying to set focus
            // tags:
            //      public overridden
            if (this.isFocusable()) {
                this.inherited(arguments);
            }
        },

        setCaretLast: function () {
            // summary:
            //      Set caret last
            // tags:
            //      public
            if (this._textArea.value) {
                _TextBoxMixin.selectInputText(this._textArea.domNode, this._textArea.value.length);
            }
        },

        reset: function () {
            this._textArea.reset();
        },

        _setIntermediateChangesAttr: function (intermediateChanges) {
            // summary:
            //      Sets whether the textarea should fire onChange events for each value change.
            // tags:
            //      protected

            this._set("intermediateChanges", intermediateChanges);
            this._textArea.set("intermediateChanges", intermediateChanges);
        },

        _setNoDataMessageAttr: function (message) {
            this._selectList.set("noDataMessage", message);
        },

        _setPlaceholderAttr: function (placeholder) {
            // summary:
            //      Sets the hint text to display in the textarea.
            // tags:
            //      protected

            this._set("placeholder", placeholder);
            this._textArea.set("placeholder", placeholder);
        },

        _setValueAttr: function (value) {
            this._set("value", value);

            // Set the new value on the textarea and update the _resetValue
            // in order to be able to handle multiple edits
            this._textArea.set({
                value: value,
                _resetValue: value
            });
        },

        _getValueAttr: function () {
            return this._textArea.get("value");
        },

        _onKeyUp: function (e) {

            // If the store hasn't been defined do not trigger the popup
            if (!this.store) {
                return;
            }

            var key = e.keyCode;

            // Exit early if the user is navigating or if this is a modifier key event.
            switch (key) {
                // The user is navigating within the textarea.
                case keys.LEFT_ARROW:
                case keys.RIGHT_ARROW:
                case keys.HOME:
                case keys.END:
                    // Up and down will be handled by select list. (falls through)
                case keys.UP_ARROW:
                case keys.DOWN_ARROW:
                    // Determine if the key pressed is a modifier key. (falls through)
                case keys.CTRL:
                case keys.ALT:
                case keys.SHIFT:
                    return;
            }

            var textbox = this._textArea.textbox,
                caretPosition = textbox.selectionStart,
                value = textbox.value;

            // open the popup when @ is pressed, but only if it is at the beginning or trailing a space
            if (value[caretPosition - 1] === "@" && (caretPosition === 1 || /\s/.test(value[caretPosition - 2]))) {
                this._tagStart = caretPosition - 1;
                this._openPopup();
            }

            if (this._isPopupOpen) {
                var isEscape = key === keys.ESCAPE,
                    isAtRemoved = typeof this._tagStart == "number" && value[this._tagStart] !== "@";

                // Close the popup if ESC is pressed or if the @ has been removed.
                if (isEscape || isAtRemoved) {
                    this._closePopup();
                    return;
                }

                // Insert the selected list value on enter.
                if (key === keys.ENTER || key === keys.TAB) {
                    this._insertSelection();
                    return;
                }

                // Update the end of the tag to be the current caret position.
                this._tagEnd = caretPosition;

                // Update the query with the current tag value.
                var query = value.substring(this._tagStart + 1, caretPosition);
                this._setQuery(query);
            }
        },

        _setQuery: function (query) {
            // summary:
            //      Sets the query for the suggestion list, debouncing if needed.
            // tags:
            //      private

            // Trim whitespace from the query to ensure we don't send blank queries to the store.
            query = (query || "").trim();

            // Clear suggestion list and do an early exit if the query string is null or empty.
            if (!query) {
                this._selectList.set("store", null);
                return;
            }

            // Configure the debounced query function if it is not configured already.
            if (!this._queryFunction) {
                var queryCallback = function (query) {
                    this._selectList.set("store", this.store, query);
                };
                this._queryFunction = debounce(queryCallback.bind(this), null, 200);
            }

            // Create a query object that uses the search property.
            var queryObject = {};
            queryObject[this.searchProperty] = query;

            // Set the query.
            this._queryFunction(queryObject);
        },

        _onKeyDown: function (e) {
            var selectList = this._selectList,
                key = e.keyCode;

            if (this._isPopupOpen) {
                switch (key) {
                    case keys.UP_ARROW:
                        // Move the selection up in the suggestion list and prevent it from moving
                        // in the text area.
                        e.preventDefault();
                        selectList.moveSelectionUp();
                        break;
                    case keys.DOWN_ARROW:
                        // Move the selection down in the suggestion list and prevent it from moving
                        // in the text area.
                        e.preventDefault();
                        selectList.moveSelectionDown();
                        break;
                    case keys.ESCAPE:
                    case keys.ENTER:
                    case keys.TAB:
                        // Prevent the default browser behaviour for escape (clears textarea in IE),
                        // enter (new line in textarea), and tab (focus next element) when the popup
                        // is open.
                        e.preventDefault();
                        break;
                }

                // Exit early so as not to emit a save event when the suggestion list is open.
                return;
            }

            // Emit a save event when the enter key is pressed. Enter key plus shift modifier should
            // append a new line as usual.
            if (key === keys.ENTER && !e.shiftKey) {
                this.emit("save");
                e.preventDefault();
            }
        },

        _insertSelection: function () {
            var textbox = this._textArea.textbox,
                selectList = this._selectList,
                selectionEnd = this._tagEnd,
                value = textbox.value;

            //Insert the selected value
            var selection = null;
            for (var id in selectList.selection) {
                if (selectList.selection[id]) {
                    selection = selectList.row(id).data;
                    break;
                }
            }

            if (!selection) {
                this._closePopup();
                return;
            }

            var selectedValue = selection[this.tagProperty];

            //Depending on whether trailing char is a space or not we either
            //add a space or modify the caret position after inserting the value
            var spaceAdd = "";
            var caretAdd = 0;
            (value.charAt(selectionEnd) !== " " ? spaceAdd = " " : caretAdd = 1);

            var valueToInsert = value.slice(0, this._tagStart + 1) + selectedValue + spaceAdd;
            var newCaretPos = valueToInsert.length + caretAdd;
            valueToInsert += value.slice(selectionEnd);

            textbox.value = valueToInsert;

            //Set the caret position right after inserted value
            textbox.setSelectionRange(newCaretPos, newCaretPos);
            this._closePopup();
        },

        _renderRow: function (item) {
            // summary:
            //      Creates a row for the grid setting the content to the display property, or
            //      falling back to the tag property if the display property is null or whitespace.
            // tags:
            //      private

            return put("div", "" + item[this.displayProperty]);
        },

        _openPopup: function () {
            // summary:
            //      Opens the suggestion list as a popup and positions it relative to the textarea.
            // tags:
            //      private

            var selectList = this._selectList,
                contentBox = domGeometry.getContentBox(this.domNode),
                closeFunction = this._closePopup.bind(this);

            // Set the width of the popup to be the same as the text area.
            domStyle.set(selectList.domNode, "width", contentBox.w + "px");
            popup.open({
                parent: this,
                popup: selectList,
                around: this.domNode,
                onExecute: closeFunction,
                onCancel: closeFunction
            });
            this._isPopupOpen = true;
        },

        _closePopup: function () {
            // summary:
            //      Closes the suggestion list popup and clears any suggestion data.
            // tags:
            //      private

            this._isPopupOpen = false;
            this._tagStart = null;
            this._tagEnd = null;
            // Set store to null to clear results until next query.
            this._selectList.set("store", null);
            popup.close(this._selectList);
        }
    });
});

},
'epi/shell/dgrid/selection/Extensions':function(){
define("epi/shell/dgrid/selection/Extensions", ["dojo/_base/declare", "dojo/query", "dojo/window"], function (declare, query, win) {
    return declare([], {
        // summary:
        //      Selection mixin that makes it easier to work with selections on a dgrid list
        // tags:
        //      internal

        moveSelectionUp: function () {
            // summary:
            //      Moves the selection up in the list
            // returns:
            //      The selected dgrid row
            // tags:
            //      public

            return this.moveSelection(true);
        },

        moveSelectionDown: function () {
            // summary:
            //      Moves the selection down in the list
            // returns:
            //      The selected dgrid row
            // tags:
            //      public

            return this.moveSelection(false);
        },

        moveSelection: function (up) {
            // summary:
            //      Moves the selection either up or down in the list
            // up: Boolean
            //      true if the selection should be moved upwards in the list otherwise false
            // returns:
            //      The selected dgrid row
            // tags:
            //      public

            var selectedRow = this.getFirstSelectedRow();
            if (!selectedRow) {
                return this._selectFirstRow();
            }

            // Clear the old select
            this.clearSelection();
            selectedRow = up ? this.up(selectedRow, 1, true) : this.down(selectedRow, 1, true);
            // Select the new row
            this.select(selectedRow, 1, true);
            win.scrollIntoView(selectedRow.element);
            return selectedRow;
        },

        hasSelection: function () {
            // summary:
            //      Returns true if there are any selected rows in the list
            // tags:
            //      public

            return Object.keys(this.selection).length > 0;
        },

        getFirstSelectedRow: function () {
            // summary:
            //      Returns the first selected row if any, otherwise null
            // tags:
            //      public

            if (!this.hasSelection()) {
                return null;
            }

            var row = this.row(Object.keys(this.selection)[0]);

            //If dgrid returns a row but no data on the row we consider it as not selected
            if (row && !row.data) {
                return null;
            }

            return row;
        },

        _selectFirstRow: function () {
            var rows = query(".dgrid-row", this.domNode);
            if (rows.length === 0) {
                return null;
            }

            var firstRow = this.row(rows[0]);
            if (!firstRow) {
                return null;
            }
            this.select(firstRow, 1, true);
            return firstRow;
        }
    });
});

},
'epi-cms/activity/viewmodels/ActivityViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/Destroyable",

    "epi/datetime",
    "epi/username",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/ApplicationSettings",

    // Parent class and mixins
    "./_ActivityViewModel",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.activities.activity"
],
function (
    declare,
    lang,
    Destroyable,

    datetime,
    username,
    TypeDescriptorManager,
    ApplicationSettings,
    // Parent class and mixins
    _ActivityViewModel,
    // Resources
    localization
) {

    return declare([_ActivityViewModel, Destroyable], {
        // summary:
        //      The view model for an activity.
        // tags:
        //      internal


        // id: [readonly] number
        //      The id of the activity
        id: null,

        // hasMessage: [readonly] Boolean
        //      Indicates whether this activity has a message. Used to
        //      determine the edit label.
        hasMessage: false,

        // title: [readonly] string
        //      The title for the activity
        title: null,

        // content: [readonly] string
        //      The content for the activity
        content: null,

        // comment: [readonly] string
        //      The comment on the activity, if any
        comment: null,

        // actionIconClass: [readonly] string
        //      The actionIconClass for the activity
        actionIconClass: null,

        // actionClass: [readonly] string
        //      The actionClass for the activity
        actionClass: null,

        // iconClass: [readonly] string
        //      The iconClass for the activity
        iconClass: null,

        _resources: localization,

        postscript: function () {
            this.inherited(arguments);

            this.set({
                id: this.activity.id,
                hasMessage: !!this.activity.message,
                upsertActivityComment: null,
                comment: this.activity.comment,
                title: this.activity.name
            });

            this.own(
                this.activityService.on("activity-comment-updated", lang.hitch(this, this._activityCommentUpdated))
            );

            this.set("actionIconClass", lang.replace("epi-icon{actionIcon} epi-icon--{actionColor}", this.activity));
            this.set("actionClass", lang.replace("epi-event--{actionColor} epi-event--{actionColor}-{activityType}", this.activity));

            // Set the icon class from the type identifier or default to the project icon.
            this.set("iconClass", TypeDescriptorManager.getValue(this.activity.typeIdentifier, "iconClass") || "epi-iconProject");

            var activity = this.activity;
            // Set the message based on the user and date updated.
            var template = activity.delayPublishUntil ? this._resources.delaypublishmessagetemplate : this._resources.messagetemplate;
            var content = lang.replace(template, {
                event: activity.actionText,
                delaypublish: datetime.toUserFriendlyString(activity.delayPublishUntil),
                user: username.toUserFriendlyString(activity.changedBy),
                date: datetime.toUserFriendlyString(activity.created)
            });

            this.set("content", content);
        },

        _editLabelGetter: function () {
            // summary:
            //      Gets the edit label.
            // tags:
            //      private

            return this.hasMessage ? this._resources.message.reply.label : this._resources.message.comment.label;
        },

        _save: function (message) {
            // summary:
            //      Adds a new comment.
            // tags:
            //      protected

            return this.activityService.addComment(this.id, message);
        },

        _activityCommentUpdated: function (comment) {
            // summary:
            //     Sets the given comment as upsertActivityComment only if comment belongs to the current activity
            // tags:
            //      private

            // there could be many instances of activity but it should add/update comment to the relevant activity.
            if (comment && comment.activityId === this.id) {
                this.set("upsertActivityComment", comment);
            }
        },
        _titleSetter: function (title) {
            // summary:
            //      Sets title, and appends the language identifier to the title if the content language is different from
            //      the editing language.
            // tags:
            //      private

            var language = this.activity.language;
            if (language && language !== ApplicationSettings.currentContentLanguage) {
                title = lang.replace("{0} ({1})", [title, language]);
            }

            this.title = title;
        }
    });
});

},
'epi-cms/activity/viewmodels/ActivityCommentViewModel':function(){
define([
    "dojo/_base/declare",
    // Parent class and mixins
    "./_ActivityViewModel",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.shared.action"
], function (
    declare,
    // Parent class and mixins
    _ActivityViewModel,
    // Resources
    localization
) {

    return declare([_ActivityViewModel], {
        // summary:
        //      The view model for an activity comment.
        // tags:
        //      internal

        // sendLabel: [public] String
        //      Label for sending form
        sendLabel: localization.save,

        _save: function (comment) {
            // summary:
            //      Saves the new activity comment.
            // tags:
            //      protected

            var promise = this.activityService.saveComment(this.id, comment);
            // Keep the comment view model up to date with the comment returned from the server
            promise.then(this.set.bind(this));
            return promise;
        }
    });
});

},
'epi-cms/activity/viewmodels/MessageActivityViewModel':function(){
define([
    "dojo/_base/declare",
    // Parent class and mixins
    "./_ActivityViewModel",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.shared.action"
],
function (
    declare,
    // Parent class and mixins
    _ActivityViewModel,
    // Resources
    localization
) {

    return declare([_ActivityViewModel], {
        // summary:
        //      The view model for a message activity.
        // tags:
        //      internal

        // sendLabel: [public] String
        //      Label for sending form
        sendLabel: localization.save,

        _save: function (comment) {
            // summary:
            //      Saves the message activity.
            // tags:
            //      protected

            return this.activityService.saveMessage(this.id, comment);
        }
    });
});

},
'url:epi-cms/activity/templates/Activity.html':"<div class=\"epi-event epi-activity\">\r\n    <div class=\"epi-event__title-wrapper\">\r\n        <span class=\"dijitInline\" data-dojo-attach-point=\"iconNode\"></span>\r\n        <span class=\"epi-event__title\" data-dojo-attach-point=\"titleNode\"></span>\r\n    </div>\r\n    <div class=\"epi-event__status\" data-dojo-attach-point=\"actionNode\">\r\n        <span class=\"dijitInline epi-event__status__icon\">\r\n            <span data-dojo-attach-point=\"actionIconNode\"></span>\r\n        </span><span class=\"epi-event__status__message\" data-dojo-attach-point=\"actionTextNode\"></span>\r\n    </div><div data-dojo-attach-point=\"messageNode\"></div\r\n    ><div class=\"epi-activity__comment\" data-dojo-attach-point=\"activityCommentNode\"></div\r\n    ><div class=\"epi-activity__comments\" data-dojo-attach-point=\"containerNode\"></div>\r\n    <div data-dojo-type=\"epi-cms/activity/ActivityCommentForm\" data-dojo-attach-point=\"commentForm\"></div>\r\n</div>\r\n",
'epi-cms/compare/CompareToolbar':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/Evented",
    "dojo/topic",

    "dijit/Toolbar",
    "epi/shell/widget/DeferredDropDownButton",

    "epi",
    "epi/username",
    "epi-cms/version/VersionSelector",
    "epi/shell/widget/_ModelBindingMixin",

    "dojo/text!./template/CompareToolbar.html",
    "epi/i18n!epi/shell/ui/nls/episerver.shared.header",
    "epi/i18n!epi/shell/ui/nls/episerver.cms.compare"
], function (
    declare,
    lang,
    domClass,
    Evented,
    topic,

    Toolbar,
    DeferredDropDownButton,

    epi,
    username,
    VersionSelector,
    _ModelBindingMixin,

    template,
    localizations,
    compareResources
) {
    return declare([Toolbar, Evented, _ModelBindingMixin], {
        // summary:
        //      Compare toolbar.
        // tags:
        //      internal xproduct

        region: "top",
        baseClass: "epi-compare-toolbar epi-localToolbar epi-flatToolbar",
        templateString: template,

        _leftVersionSelector: null,
        _rightVersionSelector: null,

        _resources: lang.mixin(localizations, compareResources),

        modelBindingMap: {
            currentLanguage: ["currentLanguage"],

            leftVersion: ["leftVersion"],
            rightVersion: ["rightVersion"],

            leftButtonLabel: ["leftButtonLabel"],
            rightButtonLabel: ["rightButtonLabel"],

            leftByText: ["leftByText"],
            rightByText: ["rightByText"],

            leftDateText: ["leftDateText"],
            rightDateText: ["rightDateText"],

            messageText: ["messageText"],
            showsVersionSelectors: ["showsVersionSelectors"]
        },

        buildRendering: function () {
            // summary:
            //      Setup the widgets DOM node based on the template and additionally create the version selectors.
            // tags:
            //      private
            this.inherited(arguments);

            this._leftVersionSelector = this._createVersionSelector("leftVersion", "left");
            this._rightVersionSelector = this._createVersionSelector("rightVersion", "right");

            this._leftButton = new DeferredDropDownButton({
                "class": "epi-chromeless epi-chromeless--with-arrow epi-flat",
                dropDown: this._leftVersionSelector,
                iconClass: "epi-iconVersions"
            }, this.leftVersionSelector);

            this._rightButton = new DeferredDropDownButton({
                "class": "epi-chromeless epi-chromeless--with-arrow epi-flat",
                dropDown: this._rightVersionSelector,
                iconClass: "epi-iconVersions"
            }, this.rightVersionSelector);

            this.own(
                this._leftVersionSelector,
                this._rightVersionSelector,
                this._leftButton,
                this._rightButton
            );
        },

        _refreshSelectors: function () {
            this._leftVersionSelector.refresh();
            this._rightVersionSelector.refresh();
        },

        _setLeftVersionAttr: function (version) {
            // summary:
            //      Sets the versions and updates the selectors.
            // tags:
            //      private
            if (epi.areEqual(this.leftVersion, version)) {
                // Early exit if setting the same value since we shouldn't cause unnecessary refreshes.
                // This also prevents recursive loops.
                return;
            }

            this._set("leftVersion", version);

            if (version) {
                this._leftVersionSelector.set("contentLink", version.contentLink);
                this._rightVersionSelector.set("markedContentLink", version.contentLink);
                this._refreshSelectors();
            }
        },

        _setRightVersionAttr: function (version) {
            this._set("rightVersion", version);

            if (version) {
                this._rightVersionSelector.set("contentLink", version.contentLink);
                this._leftVersionSelector.set("markedContentLink", version.contentLink);
            }
        },

        _setLeftButtonLabelAttr: function (label) {
            this._set("leftButtonLabel", label);
            this._leftButton.set("label", label);
        },

        _setRightButtonLabelAttr: function (label) {
            this._set("rightButtonLabel", label);
            this._rightButton.set("label", label);
        },

        _setLeftByTextAttr: {
            node: "leftBy",
            type: "innerHTML"
        },

        _setRightByTextAttr: {
            node: "rightBy",
            type: "innerHTML"
        },

        _setLeftDateTextAttr: {
            node: "leftDate",
            type: "innerHTML"
        },

        _setRightDateTextAttr: {
            node: "rightDate",
            type: "innerHTML"
        },

        _setMessageTextAttr: {
            node: "messageSection",
            type: "innerHTML"
        },

        _setShowsVersionSelectorsAttr: function (showsVersionSelectors) {
            // Hide the left and right sections if there is no right version.
            domClass.toggle(this.leftVersionSection, "dijitHidden", !showsVersionSelectors);
            domClass.toggle(this.rightVersionSection, "dijitHidden", !showsVersionSelectors);

            // Hide the message section if there is a right version.
            domClass.toggle(this.messageSection, "dijitHidden", showsVersionSelectors);

            this.emit("versionInformationUpdated");
        },

        _createVersionSelector: function (property, region) {
            // summary:
            //      Creates a drop down button with a version selector as its content.
            // tags:
            //      private

            var model = this.model,
                selector = new VersionSelector({
                    store: model.contentVersionStore,
                    region: region,
                    languages: model.languages,
                    currentLanguage: model.currentLanguage,
                    name: property
                }),
                callback = function (name, oldValue, value) {
                    selector.set(name, value);
                };

            this.own(
                selector.on("change", function (e) {
                    model.set(property, e.version);
                }),
                model.watch("languages", callback),
                model.watch("currentLanguage", callback)
            );

            return selector;
        }
    });
});

},
'epi-cms/version/VersionSelector':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/keys",
    "epi-cms/core/ContentReference",
    // Resources
    "dojo/text!./template/VersionSelector.html",
    "epi/i18n!epi/shell/ui/nls/episerver.shared.header",
    // Grid
    "dgrid/OnDemandGrid",
    "dgrid/extensions/DijitRegistry",
    "dgrid/Keyboard",
    "dgrid/Selection",
    "dgrid/extensions/ColumnHider",
    "epi/shell/dgrid/Focusable",
    "epi/shell/dgrid/selection/Exclusive",
    "epi/shell/dgrid/util/misc",
    "epi-cms/dgrid/formatters",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_KeyNavContainer",
    "epi/shell/widget/_FocusableMixin",
    // Widgets in template
    "epi-cms/version/LanguageSelector"
], function (
    declare,
    event,
    lang,
    aspect,
    domClass,
    keys,
    ContentReference,
    // Resources
    template,
    localizations,
    // Grid
    OnDemandGrid,
    DijitRegistry,
    Keyboard,
    Selection,
    ColumnHider,
    Focusable,
    Exclusive,
    misc,
    formatters,
    // Parent class and mixins
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _KeyNavContainer,
    _FocusableMixin
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _KeyNavContainer, _FocusableMixin], {
        // tags:
        //      internal

        // baseClass: [protected] String
        //      Base CSS class of the widget, used to construct CSS classes to indicate widget state.
        baseClass: "epi-version-selector",

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // contentLink: [public] String
        //      The content link of the content for which to display versions.
        contentLink: null,

        // markedContentLink: [public] String
        //      The content link of the version which should be marked as in use.
        markedContentLink: null,

        // languages: [public] Array
        //      The languages to display in the language selector.
        languages: null,

        // store: [public] Store
        //      The store that will be queried for versions.
        store: null,

        // region: [public] String
        //      The region for which this version selector is relevant.
        region: null,

        buildRendering: function () {
            // summary:
            //      Construct the UI for this widget via dijit/_TemplatedMixin with the addition
            //      of a dgrid added via code.
            // tags:
            //      protected

            var self = this;

            this.inherited(arguments);

            this.grid = new (declare([OnDemandGrid, DijitRegistry, Keyboard, Selection, Exclusive, Focusable, ColumnHider]))({
                columns: {
                    selector: {
                        label: "",
                        formatter: function () {
                            return misc.icon("epi-iconCheckmark");
                        },
                        sortable: false
                    },
                    icon: {
                        label: "",
                        formatter: function (data, object) {
                            return misc.icon(self._getIconClassName(object));
                        },
                        sortable: false
                    },
                    language: {
                        label: localizations.language,
                        sortable: false
                    },
                    status: {
                        label: localizations.status,
                        renderCell: formatters.commonDraft
                    },
                    savedDate: {
                        label: localizations.saved,
                        formatter: formatters.localizedDate,
                        className: "epi-grid--30"
                    },
                    savedBy: {
                        label: localizations.by,
                        formatter: formatters.userName,
                        sortable: false
                    }
                },
                cellNavigation: false,
                selectionEvents: "click",
                selectionMode: "exclusive",
                sort: [{ attribute: "savedDate", descending: true }]
            }, this.gridNode);

            // Own the grid and the event handlers.
            this.own(
                this.grid,
                this.grid.on("dgrid-refresh-complete", lang.hitch(this, "_refreshComplete")),
                this.grid.on("dgrid-select", lang.hitch(this, "_versionSelected")),
                aspect.around(this.grid, "renderRow", lang.hitch(this, "_renderRow")),
                this.languageSelector.watch("value", lang.hitch(this, "_updateFilter")),
                this.on("keydown", lang.hitch(this, "_onKeydown"))
            );
        },

        startup: function () {
            // summary:
            //      Processing after the widget and its children have been created and
            //      added to the DOM. Setup the initial query and store for the grid.
            // tags:
            //      protected
            if (this._started) {
                return;
            }
            this.inherited(arguments);

            this.grid.startup();
            this.grid.set("store", this.store, { contentLink: this.contentLink });
        },

        resize: function () {
            // summary:
            //      Resizes the version selector and its children.
            // tags:
            //      public
            this.inherited(arguments);
            this.grid.resize();
        },

        refresh: function () {
            // summary:
            //      Refreshes the version selector to ensure the data displayed is up to date.
            // tags:
            //      public
            if (this._started) {
                this.grid.refresh();
            }
        },

        _setContentLinkAttr: function (contentLink) {
            // summary:
            //      Sets the contentLink and updates the grid.
            // tags:
            //      private
            if (this.contentLink === contentLink) {
                // Early exit if setting the same value since we shouldn't update the query or selection.
                return;
            }

            if (this._started && !ContentReference.compareIgnoreVersion(this.contentLink, contentLink)) {
                // We do not want to cause a query if the new content link is just a different version
                // of the same content.
                this.languageSelector.set("value", this.languageSelector.defaultOption.value);
                this.grid.set("query", { contentLink: contentLink });
            }

            this.contentLink = contentLink;

            this.grid.clearSelection();
            this.grid.select(contentLink);
        },

        _setCurrentLanguageAttr: function (language) {
            // summary:
            //      Sets the current language of the content and updates the language selector.
            // tags:
            //      protected
            this._set("currentLanguage", language);
            this.languageSelector.set("currentLanguage", language);
        },

        _setLanguagesAttr: function (languages) {
            // summary:
            //      Sets the languages the current content is available for and updates the language selector.
            // tags:
            //      protected
            this._set("languages", languages);
            this.languageSelector.set("languages", languages);

            var hasLanguageSupport = languages && languages.length;

            this.languageSelector.set("disabled", !hasLanguageSupport); // Disable the language selector so that it can't get focus.
            domClass.toggle(this.languageSelectorContainer, "dijitHidden", !hasLanguageSupport);
            this.grid.toggleColumnHiddenState("language", !hasLanguageSupport);
        },

        _setMarkedContentLinkAttr: function (contentLink) {
            // summary:
            //      Sets the contentLink and updates the grid.
            // tags:
            //      private
            var row = this._getRowElement(this.markedContentLink);
            if (row) {
                // Remove the CSS class from the current marked row.
                domClass.remove(row, "dgrid-row--marked");
            }

            row = this._getRowElement(contentLink);
            if (row) {
                // Add the CSS class to the new marked row.
                domClass.add(row, "dgrid-row--marked");
            }

            this.markedContentLink = contentLink;
        },

        _setRegionAttr: function (region) {
            // summary:
            //      Sets the contentLink and updates the grid.
            // tags:
            //      private
            var newClass = this.baseClass + "--" + region,
                oldClass = this.baseClass + "--" + this.region;

            this.region = region;

            domClass.replace(this.domNode, newClass, oldClass);
        },

        _refreshComplete: function () {
            // summary:
            //      Selects the current version and marks the marked version when a refresh occurs.
            // tags:
            //      private
            this.grid.select(this.contentLink);

            this.emit("loaded");
        },

        _versionSelected: function (e) {
            // summary:
            //      Extracts the version information and emits a change event.
            // tags:
            //      private
            if (e.parentType) {
                var version = e.rows && e.rows[0].data;
                this.contentLink = version.contentLink;
                this.emit("change", { version: version });
            }
        },

        _renderRow: function (originalMethod) {
            var self = this;

            return function (item) {
                var row = originalMethod.apply(this, arguments);
                if (item.contentLink === self.markedContentLink) {
                    domClass.add(row, "dgrid-row--marked");
                }
                return row;
            };
        },

        _getRowElement: function (contentLink) {
            // summary:
            //      Get the DOM node for the row matching the given content link.
            // tags:
            //      private
            if (contentLink) {
                return this.grid.row(contentLink).element;
            }
        },

        _updateFilter: function (name, oldValue, value) {
            // summary:
            //      update the query filter with the selected language and refresh the grid
            // tags:
            //      private
            if (this._started) {
                if (value !== this.languageSelector.defaultOption.value) {
                    this.grid.set("query", { contentLink: this.contentLink, language: value });
                } else {
                    this.grid.set("query", { contentLink: this.contentLink });
                }
            }
            this.refresh();
        },

        _onKeydown: function (evt) {
            // summary;
            //      Event handler for key presses to take care of tabbing within the version selector.
            // tags:
            //      private
            if (evt.ctrlKey || evt.altKey || evt.keyCode !== keys.TAB) {
                return;
            }

            if (evt.shiftKey) {
                this.focusPrev();
            } else {
                this.focusNext();
            }

            event.stop(evt);
        },

        _getIconClassName: function (object) {
            if (object.contentLink !== this.contentLink && object.contentLink !== this.markedContentLink) {
                return "";
            }

            if (object.contentLink === this.contentLink && object.contentLink === this.markedContentLink) {
                return "epi-icon-compare--both";
            }

            if (object.contentLink === this.contentLink) {
                if (this.region === "right") {
                    return "epi-icon-compare--right";
                }
                if (this.region === "left") {
                    return "epi-icon-compare--left";
                }
            }

            if (object.contentLink === this.markedContentLink) {
                if (this.region === "right") {
                    return "epi-icon-compare--left";
                }
                if (this.region === "left") {
                    return "epi-icon-compare--right";
                }
            }

            return "unknown-compare-mode";
        }
    });
});

},
'url:epi-cms/version/template/VersionSelector.html':"<div>\r\n    <div data-dojo-attach-point=\"languageSelectorContainer\" class=\"epi-flatToolbar\">\r\n        <select data-dojo-attach-point=\"languageSelector\" data-dojo-type=\"epi-cms/version/LanguageSelector\" class=\"epi-flat epi-chromeless epi-chromeless--with-arrow\"></select>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridNode\" class=\"epi-plain-grid epi-grid-max-height--300\"></div>\r\n</div>\r\n",
'dgrid/extensions/ColumnHider':function(){
define(["dojo/_base/declare", "dojo/has", "dojo/on", "../util/misc", "put-selector/put", "dojo/i18n!./nls/columnHider", "xstyle/css!../css/extensions/ColumnHider.css"],
function(declare, has, listen, miscUtil, put, i18n){
/*
 *	Column Hider plugin for dgrid
 *	Originally contributed by TRT 2011-09-28
 *
 *	A dGrid plugin that attaches a menu to a dgrid, along with a way of opening it,
 *	that will allow you to show and hide columns.  A few caveats:
 *
 *	1. Menu placement is entirely based on CSS definitions.
 *	2. If you want columns initially hidden, you must add "hidden: true" to your
 *		column definition.
 *	3. This implementation does NOT support ColumnSet, and has not been tested
 *		with multi-subrow records.
 *	4. Column show/hide is controlled via straight up HTML checkboxes.  If you
 *		are looking for something more fancy, you'll probably need to use this
 *		definition as a template to write your own plugin.
 *
 */
	
	var activeGrid, // references grid for which the menu is currently open
		bodyListener, // references pausable event handler for body mousedown
		// Need to handle old IE specially for checkbox listener and for attribute.
		hasIE = has("ie"),
		hasIEQuirks = hasIE && has("quirks"),
		forAttr = hasIE < 8 || hasIEQuirks ? "htmlFor" : "for";
	
	function getColumnIdFromCheckbox(cb, grid){
		// Given one of the checkboxes from the hider menu,
		// return the id of the corresponding column.
		// (e.g. gridIDhere-hider-menu-check-colIDhere -> colIDhere)
		return cb.id.substr(grid.id.length + 18);
	}
	
	return declare(null, {
		// hiderMenuNode: DOMNode
		//		The node for the menu to show/hide columns.
		hiderMenuNode: null,
		
		// hiderToggleNode: DOMNode
		//		The node for the toggler to open the menu.
		hiderToggleNode: null,
		
		// i18nColumnHider: Object
		//		This object contains all of the internationalized strings for
		//		the ColumnHider extension as key/value pairs.
		i18nColumnHider: i18n,
		
		// _hiderMenuOpened: Boolean
		//		Records the current open/closed state of the menu.
		_hiderMenuOpened: false,
		
		// _columnHiderRules: Object
		//		Hash containing handles returned from addCssRule.
		_columnHiderRules: null,
		
		// _columnHiderCheckboxes: Object
		//		Hash containing checkboxes generated for menu items.
		_columnHiderCheckboxes: null,
		
		_renderHiderMenuEntries: function(){
			// summary:
			//		Iterates over subRows for the sake of adding items to the
			//		column hider menu.
			
			var subRows = this.subRows,
				first = true,
				srLength, cLength, sr, c;
			
			delete this._columnHiderFirstCheckbox;
			
			for(sr = 0, srLength = subRows.length; sr < srLength; sr++){
				for(c = 0, cLength = subRows[sr].length; c < cLength; c++){
					this._renderHiderMenuEntry(subRows[sr][c]);
					if(first){
						first = false;
						this._columnHiderFirstCheckbox =
							this._columnHiderCheckboxes[subRows[sr][c].id];
					}
				}
			}
		},
		
		_renderHiderMenuEntry: function(col){
			var id = col.id,
				replacedId = miscUtil.escapeCssIdentifier(id, "-"),
				div,
				checkId,
				checkbox,
				label;
			
			if(col.hidden){
				// Hide the column (reset first to avoid short-circuiting logic)
				col.hidden = false;
				this._hideColumn(id);
				col.hidden = true;
			}
			
			// Allow cols to opt out of the hider (e.g. for selector column).
			if(col.unhidable){ return; }
			
			// Create the checkbox and label for each column selector.
			div = put("div.dgrid-hider-menu-row");
			checkId = this.domNode.id + "-hider-menu-check-" + replacedId;
			
			// put-selector can't handle invalid selector characters, and the
			// ID could have some, so add it directly
			checkbox = this._columnHiderCheckboxes[id] =
				put(div, "input.dgrid-hider-menu-check.hider-menu-check-" + replacedId + "[type=checkbox]");
			checkbox.id = checkId;
			
			label = put(div, "label.dgrid-hider-menu-label.hider-menu-label-" + replacedId +
				"[" + forAttr + "=" + checkId + "]",
				col.label || col.field || "");
			
			put(this.hiderMenuNode, div);
			
			if(!col.hidden){
				// Hidden state is false; checkbox should be initially checked.
				// (Need to do this after adding to DOM to avoid IE6 clobbering it.)
				checkbox.checked = true;
			}
		},
		
		renderHeader: function(){
			var grid = this,
				hiderMenuNode = this.hiderMenuNode,
				hiderToggleNode = this.hiderToggleNode,
				id;
			
			function stopPropagation(event){
				event.stopPropagation();
			}
			
			this.inherited(arguments);
			
			if(!hiderMenuNode){ // first run
				// Assume that if this plugin is used, then columns are hidable.
				// Create the toggle node.
				hiderToggleNode = this.hiderToggleNode =
					put(this.domNode, "button.ui-icon.dgrid-hider-toggle[type=button][aria-label=" +
						this.i18nColumnHider.popupTriggerLabel + "]");
				
				this._listeners.push(listen(hiderToggleNode, "click", function(e){
					grid._toggleColumnHiderMenu(e);
				}));
	
				// Create the column list, with checkboxes.
				hiderMenuNode = this.hiderMenuNode =
					put("div.dgrid-hider-menu[role=dialog][aria-label=" +
						this.i18nColumnHider.popupLabel + "]");
				hiderMenuNode.id = this.id + "-hider-menu";

				this._listeners.push(listen(hiderMenuNode, "keyup", function (e) {
					var charOrCode = e.charCode || e.keyCode;
					if(charOrCode === /*ESCAPE*/ 27){
						grid._toggleColumnHiderMenu(e);
						hiderToggleNode.focus();
					}
				}));
				
				// Make sure our menu is initially hidden, then attach to the document.
				hiderMenuNode.style.display = "none";
				put(this.domNode, hiderMenuNode);
				
				// Hook up delegated listener for modifications to checkboxes.
				this._listeners.push(listen(hiderMenuNode,
						".dgrid-hider-menu-check:" + (hasIE < 9 || hasIEQuirks ? "click" : "change"),
					function(e){
						grid._updateColumnHiddenState(
							getColumnIdFromCheckbox(e.target, grid), !e.target.checked);
					}
				));
				
				// Stop click events from propagating from menu or trigger nodes,
				// so that we can simply track body clicks for hide without
				// having to drill-up to check.
				this._listeners.push(
					listen(hiderMenuNode, "mousedown", stopPropagation),
					listen(hiderToggleNode, "mousedown", stopPropagation)
				);
				
				// Hook up top-level mousedown listener if it hasn't been yet.
				if(!bodyListener){
					bodyListener = listen.pausable(document, "mousedown", function(e){
						// If an event reaches this listener, the menu is open,
						// but a click occurred outside, so close the dropdown.
						activeGrid && activeGrid._toggleColumnHiderMenu(e);
					});
					bodyListener.pause(); // pause initially; will resume when menu opens
				}
			}else{ // subsequent run
				// Remove active rules, and clear out the menu (to be repopulated).
				for(id in this._columnHiderRules){
					this._columnHiderRules[id].remove();
				}
				hiderMenuNode.innerHTML = "";
			}
			
			this._columnHiderCheckboxes = {};
			this._columnHiderRules = {};

			// Populate menu with checkboxes/labels based on current columns.
			this._renderHiderMenuEntries();
		},
		
		destroy: function(){
			this.inherited(arguments);
			// Remove any remaining rules applied to hidden columns.
			for(var id in this._columnHiderRules){
				this._columnHiderRules[id].remove();
			}
		},
		
		left: function(cell, steps){
			return this.right(cell, -steps);
		},
		
		right: function(cell, steps){
			if(!cell.element){
				cell = this.cell(cell);
			}
			var nextCell = this.inherited(arguments),
				prevCell = cell;
			
			// Skip over hidden cells
			while(nextCell.column.hidden){
				nextCell = this.inherited(arguments, [nextCell, steps > 0 ? 1 : -1]);
				if(prevCell.element === nextCell.element){
					// No further visible cell found - return original
					return cell;
				}
				prevCell = nextCell;
			}
			return nextCell;
		},
		
		isColumnHidden: function(id){
			// summary:
			//		Convenience method to determine current hidden state of a column
			return !!this._columnHiderRules[id];
		},
		
		_toggleColumnHiderMenu: function(){
			var hidden = this._hiderMenuOpened, // reflects hidden state after toggle
				hiderMenuNode = this.hiderMenuNode,
				domNode = this.domNode,
				firstCheckbox;

			// Show or hide the hider menu
			hiderMenuNode.style.display = (hidden ? "none" : "");

			// Adjust height of menu
			if (hidden) {
				// Clear the set size
				hiderMenuNode.style.height = "";
			} else {
				// Adjust height of the menu if necessary
				// Why 12? Based on menu default paddings and border, we need
				// to adjust to be 12 pixels shorter. Given the infrequency of
				// this style changing, we're assuming it will remain this
				// static value of 12 for now, to avoid pulling in any sort of
				// computed styles.
				if (hiderMenuNode.offsetHeight > domNode.offsetHeight - 12) {
					hiderMenuNode.style.height = (domNode.offsetHeight - 12) + "px";
				}
				// focus on the first checkbox
				(firstCheckbox = this._columnHiderFirstCheckbox) && firstCheckbox.focus();
			}

			// Pause or resume the listener for clicks outside the menu
			bodyListener[hidden ? "pause" : "resume"]();

			// Update activeGrid appropriately
			activeGrid = hidden ? null : this;

			// Toggle the instance property
			this._hiderMenuOpened = !hidden;
		},
		
		_hideColumn: function(id){
			// summary:
			//		Hides the column indicated by the given id.
			
			// Use miscUtil function directly, since we clean these up ourselves anyway
			var grid = this,
				selectorPrefix = "#" + miscUtil.escapeCssIdentifier(this.domNode.id) + " .dgrid-column-",
				tableRule; // used in IE8 code path

			if (this._columnHiderRules[id]) {
				return;
			}

			this._columnHiderRules[id] =
				miscUtil.addCssRule(selectorPrefix + miscUtil.escapeCssIdentifier(id, "-"),
					"display: none;");

			if((has("ie") === 8 || has("ie") === 10) && !has("quirks")){
				tableRule = miscUtil.addCssRule(".dgrid-row-table", "display: inline-table;");

				window.setTimeout(function(){
					tableRule.remove();
					grid.resize();
				}, 0);
			}
		},
		
		_showColumn: function(id){
			// summary:
			//		Shows the column indicated by the given id
			//		(by removing the rule responsible for hiding it).
			
			if(this._columnHiderRules[id]){
				this._columnHiderRules[id].remove();
				delete this._columnHiderRules[id];
			}
		},
		
		_updateColumnHiddenState: function(id, hidden){
			// summary:
			//		Performs internal work for toggleColumnHiddenState; see the public
			//		method for more information.
			
			this[hidden ? '_hideColumn' : '_showColumn'](id);
			
			// Update hidden state in actual column definition,
			// in case columns are re-rendered.
			this.columns[id].hidden = hidden;
			
			// Emit event to notify of column state change.
			listen.emit(this.domNode, "dgrid-columnstatechange", {
				grid: this,
				column: this.columns[id],
				hidden: hidden,
				bubbles: true
			});

			// Adjust the size of the header.
			this.resize();
		},
		
		toggleColumnHiddenState: function(id, hidden){
			// summary:
			//		Shows or hides the column with the given id.
			// id: String
			//		ID of column to show/hide.
			// hide: Boolean?
			//		If specified, explicitly sets the hidden state of the specified
			//		column.  If unspecified, toggles the column from the current state.
			
			if(typeof hidden === "undefined"){ hidden = !this._columnHiderRules[id]; }
			this._updateColumnHiddenState(id, hidden);
			
			// Since this can be called directly, re-sync the appropriate checkbox.
			this._columnHiderCheckboxes[id].checked = !hidden;
		}
	});
});

},
'dgrid/extensions/nls/columnHider':function(){
define({
	root: {
		popupTriggerLabel: 'Show or hide columns',
		popupLabel: 'Show or hide columns'
	},
	es: true,
	ro: true
});

},
'epi-cms/version/LanguageSelector':function(){
define([
    "dojo/_base/declare",
    // Resources
    "epi/i18n!epi/nls/episerver.cms.languageselector",
    // Parent class
    "dijit/form/Select"
], function (
    declare,
    // Resources
    localization,
    // Parent class
    Select
) {

    return declare([Select], {
        // tags:
        //      internal

        // defaultOption: [readonly] Object
        //      The default option for all languages.
        defaultOption: null,

        // languages: [public] Array
        //      The languages to display in the selector.
        languages: null,

        // currentLanguage: [public] String
        //      The language code for the language of the current content.
        currentLanguage: null,

        constructor: function () {
            this.defaultOption = {
                label: localization.alllanguages,
                value: "all"
            };
        },

        _setLanguagesAttr: function (languages) {
            // summary:
            //      Sets the languages to be displayed in the selector.
            // tags:
            //      protected
            this._set("languages", languages);

            // Set the options to an empty array and do an early exit if there are no languages.
            if (!languages || !languages.length) {
                this.set("options", []);
                return;
            }

            this.set("options", this._convertLanguagesToOptions(languages));
        },

        _setCurrentLanguageAttr: function (language) {
            // summary:
            //      Sets the current language of the site. The matching option will be marked in the selector.
            // tags:
            //      protected
            this._set("currentLanguage", language);

            var languages = this.languages;
            if (languages && languages.length) {
                this.set("options", this._convertLanguagesToOptions(languages));
            }
        },

        _convertLanguagesToOptions: function (languages) {
            var value = this.value,
                current = this.currentLanguage;

            // Map the supported languages into options with label and value properties.
            var options = languages.map(function (item) {
                var isCurrent = item.languageId === current;
                return {
                    label: item.name + (isCurrent ? " (" + localization.currentlanguage + ")" : ""),
                    value: item.languageId
                };
            });

            // Concatenate the default option together with the language options.
            options = [this.defaultOption, { /*Separator*/ }].concat(options);

            // Set the selected property based on the current value.
            options.forEach(function (item) {
                item.selected = item.value === value;
            });

            return options;
        }
    });
});

},
'dijit/form/Select':function(){
require({cache:{
'url:dijit/form/templates/Select.html':"<table class=\"dijit dijitReset dijitInline dijitLeft\"\n\tdata-dojo-attach-point=\"_buttonNode,tableNode,focusNode,_popupStateNode\" cellspacing='0' cellpadding='0'\n\trole=\"listbox\" aria-haspopup=\"true\"\n\t><tbody role=\"presentation\"><tr role=\"presentation\"\n\t\t><td class=\"dijitReset dijitStretch dijitButtonContents\" role=\"presentation\"\n\t\t\t><div class=\"dijitReset dijitInputField dijitButtonText\"  data-dojo-attach-point=\"containerNode\" role=\"presentation\"></div\n\t\t\t><div class=\"dijitReset dijitValidationContainer\"\n\t\t\t\t><input class=\"dijitReset dijitInputField dijitValidationIcon dijitValidationInner\" value=\"&#935; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t/></div\n\t\t\t><input type=\"hidden\" ${!nameAttrSetting} data-dojo-attach-point=\"valueNode\" value=\"${value}\" aria-hidden=\"true\"\n\t\t/></td\n\t\t><td class=\"dijitReset dijitRight dijitButtonNode dijitArrowButton dijitDownArrowButton dijitArrowButtonContainer\"\n\t\t\tdata-dojo-attach-point=\"titleNode\" role=\"presentation\"\n\t\t\t><input class=\"dijitReset dijitInputField dijitArrowButtonInner\" value=\"&#9660; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t\t${_buttonInputDisabled}\n\t\t/></td\n\t></tr></tbody\n></table>\n"}});
define("dijit/form/Select", [
	"dojo/_base/array", // array.forEach
	"dojo/_base/declare", // declare
	"dojo/dom-attr", // domAttr.set
	"dojo/dom-class", // domClass.add domClass.remove domClass.toggle
	"dojo/dom-geometry", // domGeometry.setMarginBox
	"dojo/_base/event", // event.stop
	"dojo/i18n", // i18n.getLocalization
	"dojo/_base/lang", // lang.hitch
	"dojo/sniff", // has("ie")
	"./_FormSelectWidget",
	"../_HasDropDown",
	"../Menu",
	"../MenuItem",
	"../MenuSeparator",
	"../Tooltip",
	"dojo/text!./templates/Select.html",
	"dojo/i18n!./nls/validate"
], function(array, declare, domAttr, domClass, domGeometry, event, i18n, lang, has,
			_FormSelectWidget, _HasDropDown, Menu, MenuItem, MenuSeparator, Tooltip, template){

// module:
//		dijit/form/Select


var _SelectMenu = declare("dijit.form._SelectMenu", Menu, {
	// summary:
	//		An internally-used menu for dropdown that allows us a vertical scrollbar

	// Override Menu.autoFocus setting so that opening a Select highlights the current value.
	autoFocus: true,

	buildRendering: function(){
		// summary:
		//		Stub in our own changes, so that our domNode is not a table
		//		otherwise, we won't respond correctly to heights/overflows
		this.inherited(arguments);
		var o = (this.menuTableNode = this.domNode);
		var n = (this.domNode = this.ownerDocument.createElement("div"));
		n.style.cssText = "overflow-x: hidden; overflow-y: scroll";
		if(o.parentNode){
			o.parentNode.replaceChild(n, o);
		}
		domClass.remove(o, "dijitMenuTable");
		n.className = o.className + " dijitSelectMenu";
		o.className = "dijitReset dijitMenuTable";
		n.setAttribute("role", "listbox");
		o.setAttribute("role", "presentation");
		n.appendChild(o);
	},

	postCreate: function(){
		// summary:
		//		stop mousemove from selecting text on IE to be consistent with other browsers

		this.inherited(arguments);

		this.connect(this.domNode, "onselectstart", event.stop);
	},


	focus: function(){
		// summary:
		//		Overridden so that the previously selected value will be focused instead of only the first item
		var	found = false,
			val = this.parentWidget.value;
		if(lang.isArray(val)){
			val = val[val.length-1];
		}
		if(val){ // if focus selected
			array.forEach(this.parentWidget._getChildren(), function(child){
				if(child.option && (val === child.option.value)){ // find menu item widget with this value
					found = true;
					this.focusChild(child, false); // focus previous selection
				}
			}, this);
		}
		if(!found){
			this.inherited(arguments); // focus first item by default
		}
	},

	resize: function(/*Object*/ mb){
		// summary:
		//		Overridden so that we are able to handle resizing our
		//		internal widget.  Note that this is not a "full" resize
		//		implementation - it only works correctly if you pass it a
		//		marginBox.
		//
		// mb: Object
		//		The margin box to set this dropdown to.
		if(mb){
			domGeometry.setMarginBox(this.domNode, mb);
			if("w" in mb){
				// We've explicitly set the wrapper <div>'s width, so set <table> width to match.
				// 100% is safer than a pixel value because there may be a scroll bar with
				// browser/OS specific width.
				this.menuTableNode.style.width = "100%";
			}
		}
	}
});

var Select = declare("dijit.form.Select", [_FormSelectWidget, _HasDropDown], {
	// summary:
	//		This is a "styleable" select box - it is basically a DropDownButton which
	//		can take a `<select>` as its input.

	baseClass: "dijitSelect dijitValidationTextBox",

	templateString: template,

	_buttonInputDisabled: has("ie") ? "disabled" : "", // allows IE to disallow focus, but Firefox cannot be disabled for mousedown events

	// required: Boolean
	//		Can be true or false, default is false.
	required: false,

	// state: [readonly] String
	//		"Incomplete" if this select is required but unset (i.e. blank value), "" otherwise
	state: "",

	// message: String
	//		Currently displayed error/prompt message
	message: "",

	// tooltipPosition: String[]
	//		See description of `dijit/Tooltip.defaultPosition` for details on this parameter.
	tooltipPosition: [],

	// emptyLabel: string
	//		What to display in an "empty" dropdown
	emptyLabel: "&#160;",	// &nbsp;

	// _isLoaded: Boolean
	//		Whether or not we have been loaded
	_isLoaded: false,

	// _childrenLoaded: Boolean
	//		Whether or not our children have been loaded
	_childrenLoaded: false,

	_fillContent: function(){
		// summary:
		//		Set the value to be the first, or the selected index
		this.inherited(arguments);
		// set value from selected option
		if(this.options.length && !this.value && this.srcNodeRef){
			var si = this.srcNodeRef.selectedIndex || 0; // || 0 needed for when srcNodeRef is not a SELECT
			this.value = this.options[si >= 0 ? si : 0].value;
		}
		// Create the dropDown widget
		this.dropDown = new _SelectMenu({ id: this.id + "_menu", parentWidget: this });
		domClass.add(this.dropDown.domNode, this.baseClass.replace(/\s+|$/g, "Menu "));
	},

	_getMenuItemForOption: function(/*_FormSelectWidget.__SelectOption*/ option){
		// summary:
		//		For the given option, return the menu item that should be
		//		used to display it.  This can be overridden as needed
		if(!option.value && !option.label){
			// We are a separator (no label set for it)
			return new MenuSeparator({ownerDocument: this.ownerDocument});
		}else{
			// Just a regular menu option
			var click = lang.hitch(this, "_setValueAttr", option);
			var item = new MenuItem({
				option: option,
				label: option.label || this.emptyLabel,
				onClick: click,
				ownerDocument: this.ownerDocument,
				dir: this.dir,
				disabled: option.disabled || false
			});
			item.focusNode.setAttribute("role", "option");
			return item;
		}
	},

	_addOptionItem: function(/*_FormSelectWidget.__SelectOption*/ option){
		// summary:
		//		For the given option, add an option to our dropdown.
		//		If the option doesn't have a value, then a separator is added
		//		in that place.
		if(this.dropDown){
			this.dropDown.addChild(this._getMenuItemForOption(option));
		}
	},

	_getChildren: function(){
		if(!this.dropDown){
			return [];
		}
		return this.dropDown.getChildren();
	},

	_loadChildren: function(/*Boolean*/ loadMenuItems){
		// summary:
		//		Resets the menu and the length attribute of the button - and
		//		ensures that the label is appropriately set.
		// loadMenuItems: Boolean
		//		actually loads the child menu items - we only do this when we are
		//		populating for showing the dropdown.

		if(loadMenuItems === true){
			// this.inherited destroys this.dropDown's child widgets (MenuItems).
			// Avoid this.dropDown (Menu widget) having a pointer to a destroyed widget (which will cause
			// issues later in _setSelected). (see #10296)
			if(this.dropDown){
				delete this.dropDown.focusedChild;
			}
			if(this.options.length){
				this.inherited(arguments);
			}else{
				// Drop down menu is blank but add one blank entry just so something appears on the screen
				// to let users know that they are no choices (mimicing native select behavior)
				array.forEach(this._getChildren(), function(child){ child.destroyRecursive(); });
				var item = new MenuItem({
					ownerDocument: this.ownerDocument,
					label: this.emptyLabel
				});
				this.dropDown.addChild(item);
			}
		}else{
			this._updateSelection();
		}

		this._isLoaded = false;
		this._childrenLoaded = true;

		if(!this._loadingStore){
			// Don't call this if we are loading - since we will handle it later
			this._setValueAttr(this.value, false);
		}
	},

	_refreshState: function(){
		if(this._started){
			this.validate(this.focused);
		}
	},

	startup: function(){
		this.inherited(arguments);
		this._refreshState(); // after all _set* methods have run
	},

	_setValueAttr: function(value){
		this.inherited(arguments);
		domAttr.set(this.valueNode, "value", this.get("value"));
		this._refreshState();	// to update this.state
	},

	_setDisabledAttr: function(/*Boolean*/ value){
		this.inherited(arguments);
		this._refreshState();	// to update this.state
	},

	_setRequiredAttr: function(/*Boolean*/ value){
		this._set("required", value);
		this.focusNode.setAttribute("aria-required", value);
		this._refreshState();	// to update this.state
	},

	_setOptionsAttr: function(/*Array*/ options){
		this._isLoaded = false;
		this._set('options', options);
	},

	_setDisplay: function(/*String*/ newDisplay){
		// summary:
		//		sets the display for the given value (or values)
		var lbl = newDisplay || this.emptyLabel;
		this.containerNode.innerHTML = '<span role="option" class="dijitReset dijitInline ' + this.baseClass.replace(/\s+|$/g, "Label ")+'">' + lbl + '</span>';
	},

	validate: function(/*Boolean*/ isFocused){
		// summary:
		//		Called by oninit, onblur, and onkeypress, and whenever required/disabled state changes
		// description:
		//		Show missing or invalid messages if appropriate, and highlight textbox field.
		//		Used when a select is initially set to no value and the user is required to
		//		set the value.

		var isValid = this.disabled || this.isValid(isFocused);
		this._set("state", isValid ? "" : (this._hasBeenBlurred ? "Error" : "Incomplete"));
		this.focusNode.setAttribute("aria-invalid", isValid ? "false" : "true");
		var message = isValid ? "" : this._missingMsg;
		if(message && this.focused && this._hasBeenBlurred){
			Tooltip.show(message, this.domNode, this.tooltipPosition, !this.isLeftToRight());
		}else{
			Tooltip.hide(this.domNode);
		}
		this._set("message", message);
		return isValid;
	},

	isValid: function(/*Boolean*/ /*===== isFocused =====*/){
		// summary:
		//		Whether or not this is a valid value.  The only way a Select
		//		can be invalid is when it's required but nothing is selected.
		return (!this.required || this.value === 0 || !(/^\s*$/.test(this.value || ""))); // handle value is null or undefined
	},

	reset: function(){
		// summary:
		//		Overridden so that the state will be cleared.
		this.inherited(arguments);
		Tooltip.hide(this.domNode);
		this._refreshState();	// to update this.state
	},

	postMixInProperties: function(){
		// summary:
		//		set the missing message
		this.inherited(arguments);
		this._missingMsg = i18n.getLocalization("dijit.form", "validate", this.lang).missingMessage;
	},

	postCreate: function(){
		// summary:
		//		stop mousemove from selecting text on IE to be consistent with other browsers

		this.inherited(arguments);
 
		this.connect(this.domNode, "onselectstart", event.stop);
		this.domNode.setAttribute("aria-expanded", "false");
	},

	_setStyleAttr: function(/*String||Object*/ value){
		this.inherited(arguments);
		domClass.toggle(this.domNode, this.baseClass.replace(/\s+|$/g, "FixedWidth "), !!this.domNode.style.width);
	},

	isLoaded: function(){
		return this._isLoaded;
	},

	loadDropDown: function(/*Function*/ loadCallback){
		// summary:
		//		populates the menu
		this._loadChildren(true);
		this._isLoaded = true;
		loadCallback();
	},

	closeDropDown: function(){
		// overriding _HasDropDown.closeDropDown()
		this.inherited(arguments);

		if(this.dropDown && this.dropDown.menuTableNode){
			// Erase possible width: 100% setting from _SelectMenu.resize().
			// Leaving it would interfere with the next openDropDown() call, which
			// queries the natural size of the drop down.
			this.dropDown.menuTableNode.style.width = "";
		}
	},

	destroy: function(preserveDom){
		if(this.dropDown && !this.dropDown._destroyed){
			this.dropDown.destroyRecursive(preserveDom);
			delete this.dropDown;
		}
		this.inherited(arguments);
	},

	_onFocus: function(){
		this.validate(true);	// show tooltip if second focus of required tooltip, but no selection
		this.inherited(arguments);
	},

	_onBlur: function(){
		Tooltip.hide(this.domNode);
		this.inherited(arguments);
		this.validate(false);
	}
});

Select._Menu = _SelectMenu;	// for monkey patching

return Select;
});

},
'dijit/form/_FormSelectWidget':function(){
define("dijit/form/_FormSelectWidget", [
	"dojo/_base/array", // array.filter array.forEach array.map array.some
	"dojo/_base/Deferred",
	"dojo/aspect", // aspect.after
	"dojo/data/util/sorter", // util.sorter.createSortFunction
	"dojo/_base/declare", // declare
	"dojo/dom", // dom.setSelectable
	"dojo/dom-class", // domClass.toggle
	"dojo/_base/kernel",	// _scopeName
	"dojo/_base/lang", // lang.delegate lang.isArray lang.isObject lang.hitch
	"dojo/query", // query
	"dojo/when",
	"dojo/store/util/QueryResults",
	"./_FormValueWidget"
], function(array, Deferred, aspect, sorter, declare, dom, domClass, kernel, lang, query, when,
			QueryResults, _FormValueWidget){

// module:
//		dijit/form/_FormSelectWidget

/*=====
var __SelectOption = {
	// value: String
	//		The value of the option.  Setting to empty (or missing) will
	//		place a separator at that location
	// label: String
	//		The label for our option.  It can contain html tags.
	// selected: Boolean
	//		Whether or not we are a selected option
	// disabled: Boolean
	//		Whether or not this specific option is disabled
};
=====*/

var _FormSelectWidget = declare("dijit.form._FormSelectWidget", _FormValueWidget, {
	// summary:
	//		Extends _FormValueWidget in order to provide "select-specific"
	//		values - i.e., those values that are unique to `<select>` elements.
	//		This also provides the mechanism for reading the elements from
	//		a store, if desired.

	// multiple: [const] Boolean
	//		Whether or not we are multi-valued
	multiple: false,

	// options: __SelectOption[]
	//		The set of options for our select item.  Roughly corresponds to
	//		the html `<option>` tag.
	options: null,

	// store: dojo/store/api/Store
	//		A store to use for getting our list of options - rather than reading them
	//		from the `<option>` html tags.   Should support getIdentity().
	//		For back-compat store can also be a dojo/data/api/Identity.
	store: null,

	// query: object
	//		A query to use when fetching items from our store
	query: null,

	// queryOptions: object
	//		Query options to use when fetching from the store
	queryOptions: null,

	// labelAttr: String?
	//		The entries in the drop down list come from this attribute in the dojo.store items.
	//		If ``store`` is set, labelAttr must be set too, unless store is an old-style
	//		dojo.data store rather than a new dojo/store.
	labelAttr: "",

	// onFetch: Function
	//		A callback to do with an onFetch - but before any items are actually
	//		iterated over (i.e. to filter even further what you want to add)
	onFetch: null,

	// sortByLabel: Boolean
	//		Flag to sort the options returned from a store by the label of
	//		the store.
	sortByLabel: true,


	// loadChildrenOnOpen: Boolean
	//		By default loadChildren is called when the items are fetched from the
	//		store.  This property allows delaying loadChildren (and the creation
	//		of the options/menuitems) until the user clicks the button to open the
	//		dropdown.
	loadChildrenOnOpen: false,

	// onLoadDeferred: [readonly] dojo.Deferred
	//		This is the `dojo.Deferred` returned by setStore().
	//		Calling onLoadDeferred.then() registers your
	//		callback to be called only once, when the prior setStore completes.
	onLoadDeferred: null,

	getOptions: function(/*anything*/ valueOrIdx){
		// summary:
		//		Returns a given option (or options).
		// valueOrIdx:
		//		If passed in as a string, that string is used to look up the option
		//		in the array of options - based on the value property.
		//		(See dijit/form/_FormSelectWidget.__SelectOption).
		//
		//		If passed in a number, then the option with the given index (0-based)
		//		within this select will be returned.
		//
		//		If passed in a dijit/form/_FormSelectWidget.__SelectOption, the same option will be
		//		returned if and only if it exists within this select.
		//
		//		If passed an array, then an array will be returned with each element
		//		in the array being looked up.
		//
		//		If not passed a value, then all options will be returned
		//
		// returns:
		//		The option corresponding with the given value or index.
		//		null is returned if any of the following are true:
		//
		//		- A string value is passed in which doesn't exist
		//		- An index is passed in which is outside the bounds of the array of options
		//		- A dijit/form/_FormSelectWidget.__SelectOption is passed in which is not a part of the select

		// NOTE: the compare for passing in a dijit/form/_FormSelectWidget.__SelectOption checks
		//		if the value property matches - NOT if the exact option exists
		// NOTE: if passing in an array, null elements will be placed in the returned
		//		array when a value is not found.
		var opts = this.options || [];

		if(valueOrIdx == null){
			return opts; // __SelectOption[]
		}
		if(lang.isArray(valueOrIdx)){
			return array.map(valueOrIdx, "return this.getOptions(item);", this); // __SelectOption[]
		}
		if(lang.isString(valueOrIdx)){
			valueOrIdx = { value: valueOrIdx };
		}
		if(lang.isObject(valueOrIdx)){
			// We were passed an option - so see if it's in our array (directly),
			// and if it's not, try and find it by value.

			if(!array.some(opts, function(option, idx){
				for(var a in valueOrIdx){
					if(!(a in option) || option[a] != valueOrIdx[a]){ // == and not === so that 100 matches '100'
						return false;
					}
				}
				valueOrIdx = idx;
				return true; // stops iteration through opts
			})){
				valueOrIdx = -1;
			}
		}
		if(valueOrIdx >= 0 && valueOrIdx < opts.length){
			return opts[valueOrIdx]; // __SelectOption
		}
		return null; // null
	},

	addOption: function(/*__SelectOption|__SelectOption[]*/ option){
		// summary:
		//		Adds an option or options to the end of the select.  If value
		//		of the option is empty or missing, a separator is created instead.
		//		Passing in an array of options will yield slightly better performance
		//		since the children are only loaded once.
		array.forEach(lang.isArray(option) ? option : [option], function(i){
			if(i && lang.isObject(i)){
				this.options.push(i);
			}
		}, this);
		this._loadChildren();
	},

	removeOption: function(/*String|__SelectOption|Number|Array*/ valueOrIdx){
		// summary:
		//		Removes the given option or options.  You can remove by string
		//		(in which case the value is removed), number (in which case the
		//		index in the options array is removed), or select option (in
		//		which case, the select option with a matching value is removed).
		//		You can also pass in an array of those values for a slightly
		//		better performance since the children are only loaded once.
		//		For numeric option values, specify {value: number} as the argument.
		var oldOpts = this.getOptions(lang.isArray(valueOrIdx) ? valueOrIdx : [valueOrIdx]);
		array.forEach(oldOpts, function(option){
			// We can get null back in our array - if our option was not found.  In
			// that case, we don't want to blow up...
			if(option){
				this.options = array.filter(this.options, function(node){
					return (node.value !== option.value || node.label !== option.label);
				});
				this._removeOptionItem(option);
			}
		}, this);
		this._loadChildren();
	},

	updateOption: function(/*__SelectOption|__SelectOption[]*/ newOption){
		// summary:
		//		Updates the values of the given option.  The option to update
		//		is matched based on the value of the entered option.  Passing
		//		in an array of new options will yield better performance since
		//		the children will only be loaded once.
		array.forEach(lang.isArray(newOption) ? newOption : [newOption], function(i){
			var oldOpt = this.getOptions({ value: i.value }), k;
			if(oldOpt){
				for(k in i){ oldOpt[k] = i[k]; }
			}
		}, this);
		this._loadChildren();
	},

	setStore: function(store, selectedValue, fetchArgs){
		// summary:
		//		Sets the store you would like to use with this select widget.
		//		The selected value is the value of the new store to set.  This
		//		function returns the original store, in case you want to reuse
		//		it or something.
		// store: dojo/store/api/Store
		//		The dojo.store you would like to use - it MUST implement getIdentity()
		//		and MAY implement observe().
		//		For backwards-compatibility this can also be a data.data store, in which case
		//		it MUST implement dojo/data/api/Identity,
		//		and MAY implement dojo/data/api/Notification.
		// selectedValue: anything?
		//		The value that this widget should set itself to *after* the store
		//		has been loaded
		// fetchArgs: Object?
		//		Hash of parameters to set filter on store, etc.
		//
		//		- query: new value for Select.query,
		//		- queryOptions: new value for Select.queryOptions,
		//		- onFetch: callback function for each item in data (Deprecated)
		var oStore = this.store;
		fetchArgs = fetchArgs || {};

		if(oStore !== store){
			// Our store has changed, so cancel any listeners on old store (remove for 2.0)
			var h;
			while((h = this._notifyConnections.pop())){ h.remove(); }

			// For backwards-compatibility, accept dojo.data store in addition to dojo.store.store.  Remove in 2.0.
			if(!store.get){
				lang.mixin(store, {
					_oldAPI: true,
					get: function(id){
						// summary:
						//		Retrieves an object by it's identity. This will trigger a fetchItemByIdentity.
						//		Like dojo.store.DataStore.get() except returns native item.
						var deferred = new Deferred();
						this.fetchItemByIdentity({
							identity: id,
							onItem: function(object){
								deferred.resolve(object);
							},
							onError: function(error){
								deferred.reject(error);
							}
						});
						return deferred.promise;
					},
					query: function(query, options){
						// summary:
						//		Queries the store for objects.   Like dojo/store/DataStore.query()
						//		except returned Deferred contains array of native items.
						var deferred = new Deferred(function(){ if(fetchHandle.abort){ fetchHandle.abort(); } } );
						deferred.total = new Deferred();
						var fetchHandle = this.fetch(lang.mixin({
							query: query,
							onBegin: function(count){
								deferred.total.resolve(count);
							},
							onComplete: function(results){
								deferred.resolve(results);
							},
							onError: function(error){
								deferred.reject(error);
							}
						}, options));
						return new QueryResults(deferred);
					}
				});

				if(store.getFeatures()["dojo.data.api.Notification"]){
					this._notifyConnections = [
						aspect.after(store, "onNew", lang.hitch(this, "_onNewItem"), true),
						aspect.after(store, "onDelete", lang.hitch(this, "_onDeleteItem"), true),
						aspect.after(store, "onSet", lang.hitch(this, "_onSetItem"), true)
					];
				}
			}
			this._set("store", store);			// Our store has changed, so update our notifications
		}

		// Remove existing options (if there are any)
		if(this.options && this.options.length){
			this.removeOption(this.options);
		}

			// Cancel listener for updates to old (dojo.data) store
		if(this._queryRes && this._queryRes.close){
			this._queryRes.close();
		}
			
			// Cancel listener for updates to new (dojo.store) store
			if(this._observeHandle && this._observeHandle.remove){
				this._observeHandle.remove();
				this._observeHandle = null;
			}

		// If user has specified new query and query options along with this new store, then use them.
		if(fetchArgs.query){
			this._set("query", fetchArgs.query);
			this._set("queryOptions", fetchArgs.queryOptions);
		}

		// Add our new options
		if(store){
			this._loadingStore = true;
			this.onLoadDeferred = new Deferred();

			// Run query
			// Save result in this._queryRes so we can cancel the listeners we register below
			this._queryRes = store.query(this.query, this.queryOptions);
			when(this._queryRes, lang.hitch(this, function(items){

				if(this.sortByLabel && !fetchArgs.sort && items.length){
					if(store.getValue){
						// Old dojo.data API to access items, remove for 2.0
						items.sort(sorter.createSortFunction([{
							attribute: store.getLabelAttributes(items[0])[0]
						}], store));
					}else{
						var labelAttr = this.labelAttr;
						items.sort(function(a, b){
							return a[labelAttr] > b[labelAttr] ? 1 :  b[labelAttr] > a[labelAttr] ? -1 : 0;
						});
					}
				}

				if(fetchArgs.onFetch){
						items = fetchArgs.onFetch.call(this, items, fetchArgs);
				}

				// TODO: Add these guys as a batch, instead of separately
				array.forEach(items, function(i){
					this._addOptionForItem(i);
				}, this);

				// Register listener for store updates
				if(this._queryRes.observe){
						// observe returns yet another handle that needs its own explicit gc
						this._observeHandle = this._queryRes.observe(lang.hitch(this, function(object, deletedFrom, insertedInto){
						if(deletedFrom == insertedInto){
							this._onSetItem(object);
						}else{
							if(deletedFrom != -1){
								this._onDeleteItem(object);
							}
							if(insertedInto != -1){
								this._onNewItem(object);
							}
						}
					}), true);
				}

				// Set our value (which might be undefined), and then tweak
				// it to send a change event with the real value
				this._loadingStore = false;
				this.set("value", "_pendingValue" in this ? this._pendingValue : selectedValue);
				delete this._pendingValue;

				if(!this.loadChildrenOnOpen){
					this._loadChildren();
				}else{
					this._pseudoLoadChildren(items);
				}
				this.onLoadDeferred.resolve(true);
				this.onSetStore();
			}), function(err){
					console.error('dijit.form.Select: ' + err.toString());
					this.onLoadDeferred.reject(err);
			});
		}
		return oStore;	// dojo/data/api/Identity
	},

	// TODO: implement set() and watch() for store and query, although not sure how to handle
	// setting them individually rather than together (as in setStore() above)

	_setValueAttr: function(/*anything*/ newValue, /*Boolean?*/ priorityChange){
		// summary:
		//		set the value of the widget.
		//		If a string is passed, then we set our value from looking it up.
		if(!this._onChangeActive){ priorityChange = null; }
		if(this._loadingStore){
			// Our store is loading - so save our value, and we'll set it when
			// we're done
			this._pendingValue = newValue;
			return;
		}
		if(newValue == null){
			return;
		}
		if(lang.isArray(newValue)){
			newValue = array.map(newValue, function(value){ return lang.isObject(value) ? value : { value: value }; }); // __SelectOption[]
		}else if(lang.isObject(newValue)){
			newValue = [newValue];
		}else{
			newValue = [{ value: newValue }];
		}
		newValue = array.filter(this.getOptions(newValue), function(i){ return i && i.value; });
		var opts = this.getOptions() || [];
		if(!this.multiple && (!newValue[0] || !newValue[0].value) && !!opts.length){
			newValue[0] = opts[0];
		}
		array.forEach(opts, function(opt){
			opt.selected = array.some(newValue, function(v){ return v.value === opt.value; });
		});
		var val = array.map(newValue, function(opt){ return opt.value; });

		if(typeof val == "undefined" || typeof val[0] == "undefined"){ return; } // not fully initialized yet or a failed value lookup
		var disp = array.map(newValue, function(opt){ return opt.label; });
		this._setDisplay(this.multiple ? disp : disp[0]);
		this.inherited(arguments, [ this.multiple ? val : val[0], priorityChange ]);
		this._updateSelection();
	},

	_getDisplayedValueAttr: function(){
		// summary:
		//		returns the displayed value of the widget
		var ret = array.map([].concat(this.get('selectedOptions')), function(v){
			if(v && "label" in v){
				return v.label;
			}else if(v){
				return v.value;
			}
			return null;
		}, this);
		return this.multiple ? ret : ret[0];
	},

	_setDisplayedValueAttr: function(label){
		// summary:
		//		Sets the displayed value of the widget
		this.set('value', this.getOptions(typeof label == "string" ? { label: label } : label));
	},

	_loadChildren: function(){
		// summary:
		//		Loads the children represented by this widget's options.
		//		reset the menu to make it populatable on the next click
		if(this._loadingStore){ return; }
		array.forEach(this._getChildren(), function(child){
			child.destroyRecursive();
		});
		// Add each menu item
		array.forEach(this.options, this._addOptionItem, this);

		// Update states
		this._updateSelection();
	},

	_updateSelection: function(){
		// summary:
		//		Sets the "selected" class on the item for styling purposes
		this._set("value", this._getValueFromOpts());
		var val = [].concat(this.value);
		if(val && val[0]){
			array.forEach(this._getChildren(), function(child){
				var isSelected = array.some(val, function(v){
					return child.option && (v === child.option.value);
				});
				domClass.toggle(child.domNode, this.baseClass.replace(/\s+|$/g, "SelectedOption "), isSelected);
				child.domNode.setAttribute("aria-selected", isSelected ? "true" : "false");
			}, this);
		}
	},

	_getValueFromOpts: function(){
		// summary:
		//		Returns the value of the widget by reading the options for
		//		the selected flag
		var opts = this.getOptions() || [];
		if(!this.multiple && opts.length){
			// Mirror what a select does - choose the first one
			var opt = array.filter(opts, function(i){
				return i.selected;
			})[0];
			if(opt && opt.value){
				return opt.value;
			}else{
				opts[0].selected = true;
				return opts[0].value;
			}
		}else if(this.multiple){
			// Set value to be the sum of all selected
			return array.map(array.filter(opts, function(i){
				return i.selected;
			}), function(i){
				return i.value;
			}) || [];
		}
		return "";
	},

	// Internal functions to call when we have store notifications come in
	_onNewItem: function(/*item*/ item, /*Object?*/ parentInfo){
		if(!parentInfo || !parentInfo.parent){
			// Only add it if we are top-level
			this._addOptionForItem(item);
		}
	},
	_onDeleteItem: function(/*item*/ item){
		var store = this.store;
		this.removeOption({value: store.getIdentity(item) });
	},
	_onSetItem: function(/*item*/ item){
		this.updateOption(this._getOptionObjForItem(item));
	},

	_getOptionObjForItem: function(item){
		// summary:
		//		Returns an option object based off the given item.  The "value"
		//		of the option item will be the identity of the item, the "label"
		//		of the option will be the label of the item.

		// remove getLabel() call for 2.0 (it's to support the old dojo.data API)
		var store = this.store,
			label = (this.labelAttr && this.labelAttr in item) ? item[this.labelAttr] : store.getLabel(item),
			value = (label ? store.getIdentity(item) : null);
		return {value: value, label: label, item: item}; // __SelectOption
	},

	_addOptionForItem: function(/*item*/ item){
		// summary:
		//		Creates (and adds) the option for the given item
		var store = this.store;
		if(store.isItemLoaded && !store.isItemLoaded(item)){
			// We are not loaded - so let's load it and add later.
			// Remove for 2.0 (it's the old dojo.data API)
			store.loadItem({item: item, onItem: function(i){
				this._addOptionForItem(i);
			},
			scope: this});
			return;
		}
		var newOpt = this._getOptionObjForItem(item);
		this.addOption(newOpt);
	},

	constructor: function(params /*===== , srcNodeRef =====*/){
		// summary:
		//		Create the widget.
		// params: Object|null
		//		Hash of initialization parameters for widget, including scalar values (like title, duration etc.)
		//		and functions, typically callbacks like onClick.
		//		The hash can contain any of the widget's properties, excluding read-only properties.
		// srcNodeRef: DOMNode|String?
		//		If a srcNodeRef (DOM node) is specified, replace srcNodeRef with my generated DOM tree

		//		Saves off our value, if we have an initial one set so we
		//		can use it if we have a store as well (see startup())
		this._oValue = (params || {}).value || null;
		this._notifyConnections = [];	// remove for 2.0
	},

	buildRendering: function(){
		this.inherited(arguments);
		dom.setSelectable(this.focusNode, false);
	},

	_fillContent: function(){
		// summary:
		//		Loads our options and sets up our dropdown correctly.  We
		//		don't want any content, so we don't call any inherit chain
		//		function.
		if(!this.options){
			this.options =
				this.srcNodeRef
				? query("> *", this.srcNodeRef).map(
					function(node){
						if(node.getAttribute("type") === "separator"){
							return { value: "", label: "", selected: false, disabled: false };
						}
						return {
							value: (node.getAttribute("data-" + kernel._scopeName + "-value") || node.getAttribute("value")),
							label: String(node.innerHTML),
							// FIXME: disabled and selected are not valid on complex markup children (which is why we're
							// looking for data-dojo-value above.  perhaps we should data-dojo-props="" this whole thing?)
							// decide before 1.6
							selected: node.getAttribute("selected") || false,
							disabled: node.getAttribute("disabled") || false
						};
					},
					this)
				: [];
		}
		if(!this.value){
			this._set("value", this._getValueFromOpts());
		}else if(this.multiple && typeof this.value == "string"){
			this._set("value", this.value.split(","));
		}
	},

	postCreate: function(){
		// summary:
		//		sets up our event handling that we need for functioning
		//		as a select
		this.inherited(arguments);

		// Make our event connections for updating state
		aspect.after(this, "onChange", lang.hitch(this, "_updateSelection"));

		// moved from startup
		//		Connects in our store, if we have one defined
		var store = this.store;
		if(store && (store.getIdentity || store.getFeatures()["dojo.data.api.Identity"])){
			// Temporarily set our store to null so that it will get set
			// and connected appropriately
			this.store = null;
			this.setStore(store, this._oValue);
		}
	},

	startup: function(){
		// summary:
		this._loadChildren();
		this.inherited(arguments);
	},

	destroy: function(){
		// summary:
		//		Clean up our connections

		var h;
		while((h = this._notifyConnections.pop())){ h.remove(); }

		// Cancel listener for store updates
		if(this._queryRes && this._queryRes.close){
			this._queryRes.close();
			}

			// Cancel listener for updates to new (dojo.store) store
			if(this._observeHandle && this._observeHandle.remove){
				this._observeHandle.remove();
				this._observeHandle = null;
		}

		this.inherited(arguments);
	},

	_addOptionItem: function(/*__SelectOption*/ /*===== option =====*/){
		// summary:
		//		User-overridable function which, for the given option, adds an
		//		item to the select.  If the option doesn't have a value, then a
		//		separator is added in that place.  Make sure to store the option
		//		in the created option widget.
	},

	_removeOptionItem: function(/*__SelectOption*/ /*===== option =====*/){
		// summary:
		//		User-overridable function which, for the given option, removes
		//		its item from the select.
	},

	_setDisplay: function(/*String or String[]*/ /*===== newDisplay =====*/){
		// summary:
		//		Overridable function which will set the display for the
		//		widget.  newDisplay is either a string (in the case of
		//		single selects) or array of strings (in the case of multi-selects)
	},

	_getChildren: function(){
		// summary:
		//		Overridable function to return the children that this widget contains.
		return [];
	},

	_getSelectedOptionsAttr: function(){
		// summary:
		//		hooks into this.attr to provide a mechanism for getting the
		//		option items for the current value of the widget.
		return this.getOptions({ selected: true });
	},

	_pseudoLoadChildren: function(/*item[]*/ /*===== items =====*/){
		// summary:
		//		a function that will "fake" loading children, if needed, and
		//		if we have set to not load children until the widget opens.
		// items:
		//		An array of items that will be loaded, when needed
	},

	onSetStore: function(){
		// summary:
		//		a function that can be connected to in order to receive a
		//		notification that the store has finished loading and all options
		//		from that store are available
	}
});

/*=====
_FormSelectWidget.__SelectOption = __SelectOption;
=====*/

return _FormSelectWidget;

});

},
'dojo/data/util/sorter':function(){
define("dojo/data/util/sorter", ["../../_base/lang"], function(lang){
	// module:
	//		dojo/data/util/sorter
	// summary:
	//		TODOC

var sorter = {};
lang.setObject("dojo.data.util.sorter", sorter);

sorter.basicComparator = function(	/*anything*/ a,
													/*anything*/ b){
	// summary:
	//		Basic comparison function that compares if an item is greater or less than another item
	// description:
	//		returns 1 if a > b, -1 if a < b, 0 if equal.
	//		'null' values (null, undefined) are treated as larger values so that they're pushed to the end of the list.
	//		And compared to each other, null is equivalent to undefined.

	//null is a problematic compare, so if null, we set to undefined.
	//Makes the check logic simple, compact, and consistent
	//And (null == undefined) === true, so the check later against null
	//works for undefined and is less bytes.
	var r = -1;
	if(a === null){
		a = undefined;
	}
	if(b === null){
		b = undefined;
	}
	if(a == b){
		r = 0;
	}else if(a > b || a == null){
		r = 1;
	}
	return r; //int {-1,0,1}
};

sorter.createSortFunction = function(	/* attributes[] */sortSpec, /*dojo/data/api/Read*/ store){
	// summary:
	//		Helper function to generate the sorting function based off the list of sort attributes.
	// description:
	//		The sort function creation will look for a property on the store called 'comparatorMap'.  If it exists
	//		it will look in the mapping for comparisons function for the attributes.  If one is found, it will
	//		use it instead of the basic comparator, which is typically used for strings, ints, booleans, and dates.
	//		Returns the sorting function for this particular list of attributes and sorting directions.
	// sortSpec:
	//		A JS object that array that defines out what attribute names to sort on and whether it should be descenting or asending.
	//		The objects should be formatted as follows:
	// |	{
	// |		attribute: "attributeName-string" || attribute,
	// |		descending: true|false;   // Default is false.
	// |	}
	// store:
	//		The datastore object to look up item values from.

	var sortFunctions=[];

	function createSortFunction(attr, dir, comp, s){
		//Passing in comp and s (comparator and store), makes this
		//function much faster.
		return function(itemA, itemB){
			var a = s.getValue(itemA, attr);
			var b = s.getValue(itemB, attr);
			return dir * comp(a,b); //int
		};
	}
	var sortAttribute;
	var map = store.comparatorMap;
	var bc = sorter.basicComparator;
	for(var i = 0; i < sortSpec.length; i++){
		sortAttribute = sortSpec[i];
		var attr = sortAttribute.attribute;
		if(attr){
			var dir = (sortAttribute.descending) ? -1 : 1;
			var comp = bc;
			if(map){
				if(typeof attr !== "string" && ("toString" in attr)){
					 attr = attr.toString();
				}
				comp = map[attr] || bc;
			}
			sortFunctions.push(createSortFunction(attr,
				dir, comp, store));
		}
	}
	return function(rowA, rowB){
		var i=0;
		while(i < sortFunctions.length){
			var ret = sortFunctions[i++](rowA, rowB);
			if(ret !== 0){
				return ret;//int
			}
		}
		return 0; //int
	}; // Function
};

return sorter;
});

},
'url:dijit/form/templates/Select.html':"<table class=\"dijit dijitReset dijitInline dijitLeft\"\n\tdata-dojo-attach-point=\"_buttonNode,tableNode,focusNode,_popupStateNode\" cellspacing='0' cellpadding='0'\n\trole=\"listbox\" aria-haspopup=\"true\"\n\t><tbody role=\"presentation\"><tr role=\"presentation\"\n\t\t><td class=\"dijitReset dijitStretch dijitButtonContents\" role=\"presentation\"\n\t\t\t><div class=\"dijitReset dijitInputField dijitButtonText\"  data-dojo-attach-point=\"containerNode\" role=\"presentation\"></div\n\t\t\t><div class=\"dijitReset dijitValidationContainer\"\n\t\t\t\t><input class=\"dijitReset dijitInputField dijitValidationIcon dijitValidationInner\" value=\"&#935; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t/></div\n\t\t\t><input type=\"hidden\" ${!nameAttrSetting} data-dojo-attach-point=\"valueNode\" value=\"${value}\" aria-hidden=\"true\"\n\t\t/></td\n\t\t><td class=\"dijitReset dijitRight dijitButtonNode dijitArrowButton dijitDownArrowButton dijitArrowButtonContainer\"\n\t\t\tdata-dojo-attach-point=\"titleNode\" role=\"presentation\"\n\t\t\t><input class=\"dijitReset dijitInputField dijitArrowButtonInner\" value=\"&#9660; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t\t${_buttonInputDisabled}\n\t\t/></td\n\t></tr></tbody\n></table>\n",
'url:epi-cms/compare/template/CompareToolbar.html':"<div class=\"dijit\" role=\"toolbar\" tabIndex=\"${tabIndex}\" data-dojo-attach-point=\"containerNode\">\r\n    <span data-dojo-attach-point=\"leftVersionSection\" class=\"epi-compare-toolbar__text-wrapper\">\r\n        <span>${_resources.comparing}</span>\r\n        <span data-dojo-attach-point=\"leftVersionSelector\"></span>\r\n\r\n        <span data-dojo-attach-point=\"leftDate\"></span>\r\n        <span class=\"epi-secondaryText epi-compare-toolbar__info-text\">${_resources.by}</span>\r\n        <span data-dojo-attach-point=\"leftBy\"></span>\r\n    </span>\r\n    <span data-dojo-attach-point=\"rightVersionSection\" class=\"epi-compare-toolbar__text-wrapper\">\r\n        <span>${_resources.with}</span>\r\n        <span data-dojo-attach-point=\"rightVersionSelector\"></span>\r\n        <span data-dojo-attach-point=\"rightDate\"></span>\r\n        <span class=\"epi-secondaryText epi-compare-toolbar__info-text\">${_resources.by}</span>\r\n        <span data-dojo-attach-point=\"rightBy\"></span>\r\n    </span>\r\n    <span data-dojo-attach-point=\"messageSection\" class=\"epi-compare-toolbar__text-wrapper epi-compare-toolbar__text-wrapper--text-only\"></span>\r\n</div>\r\n",
'epi-cms/compare/viewmodels/CompareViewModel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/topic",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/when",
    "epi/shell/DestroyableByKey",
    "epi/dependency",
    "epi-cms/core/ContentReference",
    "epi-cms/compare/viewmodels/CompareToolbarViewModel"
], function (
    declare,
    aspect,
    topic,
    lang,
    Stateful,
    when,
    DestroyableByKey,
    dependency,
    ContentReference,
    CompareToolbarViewmodel
) {
    return declare([Stateful, DestroyableByKey], {
        // summary:
        //      View model for the compare views.
        //
        // tags:
        //      internal

        // contentLink: [public] String
        //      The content link of the content to be compared.
        contentLink: null,

        // languages: [public] Array
        //      An array of languages supported by the current content. An empty array or null indicates
        //      that the current content does not support localization.
        languages: null,

        // typeIdentifier: [public] String
        //      The type identifier for the content to be compared
        typeIdentifier: null,

        // leftVersion: [public] Object
        //      The version data for the version appearing in the left compare panel.
        leftVersion: null,

        // rightVersion: [public] Object
        //      The version data for the version appearing in the right compare panel.
        rightVersion: null,

        // leftVersionUri: String
        //      Uri of the left version. The left version is context bound, so we need to use URI.
        leftVersionUri: null,

        // rightVersionUrl: String
        //      Preview url of the right version. The right version is not context bound, so we handle preview URL directly.
        rightVersionUrl: null,

        // hasAccess: [public] Boolean
        //      A flag which indicates whether the current user has access to view versions.
        hasAccess: true,

        // contentDataStore: [readonly] epi/shell/RestStore
        //      The content data store
        contentDataStore: null,

        // contentVersionStore: [readonly] epi/shell/RestStore
        //      The content version store
        contentVersionStore: null,

        // orientation: [public] String
        //      Orientation of the split panels
        orientation: "vertical",

        compareToolbarViewModel: null,

        _rightVersionDeferred: null,

        postscript: function () {
            // summary:
            //      Setup mixed in properties
            // tags:
            //      protected
            this.inherited(arguments);
            this.contentDataStore = this.contentDataStore || dependency.resolve("epi.storeregistry").get("epi.cms.contentdata");
            this.contentVersionStore = this.contentVersionStore || dependency.resolve("epi.storeregistry").get("epi.cms.contentversion");


            this._setupCompareToolbarViewModel();

            // When a publish occurs we need to refresh the left and rightversion to get the new text to display
            this.own(
                topic.subscribe("/epi/cms/content/statuschange/", lang.hitch(this, "_refresh"))
            );
        },

        _refresh: function () {
            // summary:
            //      Refreshes the left and right versions with the latest data from the server
            // tags:
            //      private

            var store = this.contentVersionStore;

            when(store.refresh(this.leftVersion.contentLink), lang.hitch(this, function (version) {
                this.set("leftVersion", version);
            }));

            if (this.rightVersion) {
                when(store.refresh(this.rightVersion.contentLink), lang.hitch(this, function (version) {
                    this.set("rightVersion", version);
                }));
            }
        },

        _contentLinkSetter: function (contentLink) {
            this.contentLink = contentLink;

            var store = this.contentVersionStore;

            if (this._rightVersionDeferred && !this._rightVersionDeferred.isFulfilled()) {
                this._rightVersionDeferred.cancel();
            }

            when(store.get(contentLink), lang.hitch(this, function (version) {
                this.set("leftVersion", version);

                if (!this.rightVersion || !ContentReference.compareIgnoreVersion(this.leftVersion.contentLink, this.rightVersion.contentLink)) {
                    var queryParams = {
                        contentLink: contentLink,
                        language: this.leftVersion.language,
                        query: "getcompareversion"
                    };

                    this._rightVersionDeferred = store.query(queryParams);

                    when(this._rightVersionDeferred, lang.hitch(this, function (versions) {
                        this.set("hasAccess", true);
                        this.set("rightVersion", versions && versions.length ? versions[0] : null);
                    }), lang.hitch(this, function (error) {
                        this.set("hasAccess", error.status !== 403);
                        this.set("rightVersion", null);
                    }));
                }
            }));
        },

        _leftVersionSetter: function (version) {
            // summary:
            //      Sets the version data for the left compare panel.
            // tags:
            //      protected
            this.leftVersion = version;

            if (this.compareToolbarViewModel) {
                if (this.compareToolbarViewModel.leftVersion !== version) {
                    this.compareToolbarViewModel.set("leftVersion", version);
                }
            }

            this.set("leftVersionUri", version.uri);
        },

        _rightVersionSetter: function (version) {
            // summary:
            //      Sets the version data for the right compare panel.
            // tags:
            //      protected

            var ownKey = "removeAfter";
            this.rightVersion = version;

            this.destroyByKey(ownKey);
            if (version) {
                this.ownByKey(ownKey, aspect.after(this.contentVersionStore, "remove", lang.hitch(this, function (contentLink) {
                    if (version.contentLink === contentLink) {
                        // When the version shown in the right panel is deleted; reset.
                        this.set("rightVersion", null);
                    }
                }), true));
            }

            if (this.compareToolbarViewModel) {
                if (this.compareToolbarViewModel.rightVersion !== version) {
                    this.compareToolbarViewModel.set("rightVersion", version);
                }
            }

            // If the version is null then set the rightVersionUrl to null and do an early exit.
            if (version === null) {
                this.set("rightVersionUrl", "about:blank");
                this.set("rightVersionContentLink", null);
                return;
            }

            // Update the URL for the right panel when the version changes.
            when(this.contentDataStore.get(version.contentLink), lang.hitch(this, function (content) {
                // When the versions are being set and both left and right versions are the same it is
                // because the document content has been updated, in order to force a reload in this case
                // we first clear the right pane, since the original url is identical
                if (this.leftVersion === this.rightVersion) {
                    this.set("rightVersionUrl", "about:blank");
                }
                this.set("rightVersionUrl", content.editablePreviewUrl);
                this.set("rightVersionContentLink", content.contentLink);
            }));
        },

        _typeIdentifierSetter: function (typeIdentifier) {
            // summary:
            //      Sets the curremt content's type identifier.

            this.typeIdentifier = typeIdentifier;

            if (this.compareToolbarViewModel) {
                this.compareToolbarViewModel.set("typeIdentifier", typeIdentifier);
            }
        },

        _languagesSetter: function (languages) {
            // summary:
            //      Sets the languages available for the current content.

            this.languages = languages;

            if (this.compareToolbarViewModel) {
                this.compareToolbarViewModel.set("languages", languages);
            }
        },

        _hasAccessSetter: function (hasAccess) {
            // summary:
            //      Sets the hasAccess flag.

            this.hasAccess = hasAccess;

            if (this.compareToolbarViewModel) {
                this.compareToolbarViewModel.set("hasAccess", hasAccess);
            }
        },

        _setupCompareToolbarViewModel: function () {
            // summary:
            //      Setup the view model for the compare toolbar which is a child view.
            // tags:
            //      private

            this.compareToolbarViewModel = this.compareToolbarViewModel || new CompareToolbarViewmodel({
                contentVersionStore: this.contentVersionStore,
                leftVersion: this.leftVersion,
                rightVersion: this.rightVersion,
                typeIdentifier: this.typeIdentifier,
                hasAccess: this.hasAccess,
                languages: this.languages
            });

            this.own(this.compareToolbarViewModel.watch("leftVersion", lang.hitch(this, function (propertyName, oldValue, newValue) {
                if (this.leftVersion !== newValue) {
                    this.set("leftVersion", newValue);
                }
            })));

            this.own(this.compareToolbarViewModel.watch("rightVersion", lang.hitch(this, function (propertyName, oldValue, newValue) {
                if (this.rightVersion !== newValue) {
                    this.set("rightVersion", newValue);
                }
            })));
        }
    });
});

},
'epi-cms/compare/viewmodels/CompareToolbarViewModel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/when",

    "epi/dependency",
    "epi/datetime",
    "epi/username",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/contentediting/ContentActionSupport",

    "epi/i18n!epi/shell/ui/nls/episerver.cms.compare"
], function (
    declare,
    lang,
    Stateful,
    when,

    dependency,
    datetime,
    username,
    TypeDescriptorManager,

    ContentActionSupport,

    resources
) {
    return declare([Stateful], {
        // summary:
        //      View model for the compare toolbar.
        //
        // tags:
        //      internal

        // contentVersionStore: Store
        //      The content version store.
        contentVersionStore: null,

        // leftVersion: Object
        //      The left version.
        leftVersion: null,

        // rightVersion: Object
        //      The right version.
        rightVersion: null,

        // leftButtonLabel: String
        //      The left version dropdown button's label.
        leftButtonLabel: null,

        // rightButtonLabel: String
        //      The right version dropdown button's label.
        rightButtonLabel: null,

        // leftByText: String
        //      The friendly formatted name of the user who created the left version.
        leftByText: null,

        // rightByText: String
        //      The friendly formatted name of the user who created the right version.
        rightByText: null,

        // leftDateText: String
        //      The friendly formatted creation date of the left version.
        leftDateText: null,

        // leftDateText: String
        //      The friendly formatted creation date of the right version.
        rightDateText: null,

        // messageText: String
        //      The message displayed in the toolbar when comparison cannot be done.
        messageText: null,

        // showsVersionSelectors: Boolean
        //      Indicates that the version selectors should be shown or not.
        showsVersionSelectors: null,

        // hasAccess: Boolean
        //      Indicates that the current user has sufficient access to the current content or not.
        hasAccess: true,

        // typeIdentifier: String
        //      The current content's type identifier.
        typeIdentifier: null,

        // languages: [public] Array
        //      An array of languages supported by the current content. An empty array or null indicates
        //      that the current content does not support localization.
        languages: null,

        // currentLanguage: [public] String
        //      The language code for the language of the current content.
        currentLanguage: null,

        postscript: function () {
            this.inherited(arguments);

            var profile = this._profile || dependency.resolve("epi.shell.Profile");

            when(profile.getContentLanguage(), lang.hitch(this, function (language) {
                this.set("currentLanguage", language);
            }));
        },

        _leftVersionSetter: function (version) {
            // summary:
            //      Sets the left version.

            this.leftVersion = version;

            if (version) {
                this.set("leftButtonLabel", this._createButtonLabel(version));

                this.set("leftByText", username.toUserFriendlyString(version.savedBy, null, false));
                this.set("leftDateText", datetime.toUserFriendlyString(version.savedDate));
            }
        },

        _rightVersionSetter: function (version) {
            // summary:
            //      Sets the right version.

            this.rightVersion = version;

            if (version) {
                this.set("rightButtonLabel", this._createButtonLabel(version));

                this.set("rightByText", username.toUserFriendlyString(version.savedBy, null, false));
                this.set("rightDateText", datetime.toUserFriendlyString(version.savedDate));
            }

            this.set("showsVersionSelectors", version !== null);
        },

        _typeIdentifierSetter: function (typeIdentifier) {
            // summary:
            //      Sets the type identifier.

            this.typeIdentifier = typeIdentifier;
            this._updateMessageText();
        },

        _hasAccessSetter: function (hasAccess) {
            // summary:
            //      Set the hasAccess flag.

            this.hasAccess = hasAccess;
            this._updateMessageText();
        },

        _updateMessageText: function () {
            // summary:
            //      Update the failure message.

            this.set("messageText", this.hasAccess ?
                TypeDescriptorManager.getResourceValue(this.typeIdentifier, "compare.onlyoneversion") :
                resources.insufficientpermission);
        },

        _createButtonLabel: function (version) {
            // summary
            //      Create version dropdown button's label base on the version.
            // version: Object
            //      The version.

            var language = version.language ? " (" + version.language + ")" : "";
            var statusName = ContentActionSupport.getVersionStatus(version.status);
            return statusName + language;
        }
    });
});

},
'epi-cms/compare/views/SideBySideCompareView':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",

    "epi/shell/widget/Iframe",
    "epi/shell/widget/_ModelBindingMixin",

    "epi-cms/contentediting/OnPageEditing"
],

function (
    declare,
    lang,
    topic,

    Iframe,
    _ModelBindingMixin,

    OnPageEditing
) {

    return declare([OnPageEditing, _ModelBindingMixin], {
        // summary:
        //		Side by side compare view.
        //
        // tags:
        //      internal

        // createOverlays: [protected] Boolean
        //      Indicate that the overlays should be created.
        createOverlays: true,

        modelBindingMap: {
            rightVersionUrl: ["rightVersionUrl"]
        },

        _rightIframe: null,

        buildRendering: function () {
            this.inherited(arguments);
            this._setupComparePanes();
        },

        destroy: function () {
            // summary:
            //		Destroy the widget.
            // tags:
            //		protected

            // Do not use own because Destroyable destroys owned things before destroy method is called.
            // As a result, we cannot remove the compare panes from edit layout.
            this._removeAndDestroyComparePanes();

            this.inherited(arguments);
        },

        _setRightVersionUrlAttr: function (url) {
            // tags:
            //      private
            if (url) {
                this._rightIframe.load(url);
            }
        },

        _setupComparePanes: function () {
            // summary:
            //		Setup the edit form.
            // tags:
            //		private
            var orientation = this.model.orientation;
            var width = this.editLayoutContainer.w / 2;

            // Dojo puts an overflow hidden on the region containers which makes Firefox not display the scrollbar,
            // so we add the class epi-iframe--overflow to fix this
            this._rightIframe = new Iframe({
                region: orientation === "vertical" ? "right" : "bottom",
                layoutPriority: 100, // The top region panes' priority are from 0 to 99, the center panes' should be 100 or greater to keep the "headline" design.
                style: orientation === "vertical" ? "width: " + width + "px" : "height: 50%",
                splitter: true,
                "class": "epi-iframe--overflow epi-editorViewport"
            });

            this.own(
                this._rightIframe.on("load", lang.hitch(this, this._onRightIframeLoad))
            );

            this.mainLayoutContainer.addChild(this._rightIframe);
        },

        _onRightIframeLoad: function (url, triggeredExternally) {
            if (!!url && !triggeredExternally && url !== this.model.rightVersionUrl) {
                // Iframe is reloaded when user clicks on a link in preview iframe.

                // request a context change
                topic.publish("/epi/shell/context/request", { url: url }, {
                    sender: this,
                    forceContextChange: true,
                    suppressFailure: true
                });
            }
        },

        _removeAndDestroyComparePanes: function () {
            // summary:
            //		Check if a form exists so remove from edit layout and destroy it.
            // tags:
            //		private

            if (this._rightIframe) {
                this.mainLayoutContainer.removeChild(this._rightIframe);
                this._rightIframe.destroyRecursive();
                this._rightIframe = null;
            }
        }
    });
});

},
'epi-cms/contentediting/OnPageEditing':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/on",
    "dojo/when",
    "dojo/topic",

    "epi/shell/gesture/ScrollPullDown",
    "epi-cms/contentediting/_FormEditingMixin",
    "epi-cms/contentediting/_ValidationMixin",
    "epi-cms/contentediting/EditingBase"
],

function (
    declare,
    lang,
    aspect,
    on,
    when,
    topic,

    ScrollPullDown,
    _FormEditingMixin,
    _ValidationMixin,
    EditingBase
) {

    return declare([EditingBase, _FormEditingMixin, _ValidationMixin], {
        // tags:
        //      internal

        _iframeConnects: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.formSettings = {
                doLayout: false,
                baseClass: "epi-cmsEditingForm epi-cmsEditingFormOpe",
                propertyFilter: function (parent, property) {
                    return property.groupName === "EPiServerCMS_SettingsPanel";
                }
            };
        },

        destroy: function () {
            this._removePullDownGesture();
            this.inherited(arguments);
        },

        onEditorWrapperCreated: function (editorWrapper) {
            // summary:
            //      Triggered when the active editor wrapper created.
            //
            // editorWrapper:
            //      The created editor wrapper
            //
            // tags:
            //    public, override, callback

            if (editorWrapper && editorWrapper.editorWidget) {
                var editorWidget = editorWrapper.editorWidget;

                if (editorWidget.onFieldCreated) {
                    var onFieldCreatedHandle = aspect.after(editorWidget, "onFieldCreated", lang.hitch(this, function (fieldName, widget) {
                        //Remove the aspect handle
                        onFieldCreatedHandle.remove();
                        onFieldCreatedHandle = null;

                        this._addStateWatch(widget);
                    }), true);
                } else {
                    editorWidget.set("name", editorWrapper.get("propertyName"));
                    this._addStateWatch(editorWidget);
                }

                // Make sure content is validated when editorWidget is ready
                editorWidget.validate && editorWidget.validate();
            }
        },

        onSetActiveProperty: function (property) {
            // summary:
            //      Triggered when active property is set on the current content view model.
            //  remark:
            //      Check if property mapping doesn't exist, request switch edit mode to end up in Form Editing, where all the properties are available,
            // property: [String]
            //      The property name.
            // tags:
            //      public, override, callback.

            var mapping = this._mappingManager.findOne("propertyName", property);
            if (!mapping) {
                topic.publish("/epi/cms/action/switcheditmode", null, { activePropertyOnStartup: property});
            } else {
                if (mapping.wrapper) {
                    mapping.wrapper.startEdit();
                } else if (mapping.overlayItem) {
                    this._onOverlayItemClick(mapping.overlayItem);
                }
            }
        },

        _onOverlayItemClick: function (overlayItem, e) {

            var editorWrapper = this._activeEditorWrapper;
            var editorWrappers = this._mappingManager.find().filter(function (item) {
                return (item.overlayItem && item.wrapper);
            }).map(function (item) {
                return item.wrapper;
            });

            if (editorWrappers.length > 0) {
                // try to stop editing any active editors.
                editorWrappers.forEach(function (item) {
                    item.tryToStopEditing();
                });

                // If still in an editing state after trying to stop then return since we don't want to open another editor before this is closed.
                // Or if clicking on overlay item while an editor is still setting up.
                var hasAnyWrappersInEditingState = editorWrappers.some(function (item) {
                    return (item.editing);
                });

                if (hasAnyWrappersInEditingState || (editorWrapper && overlayItem.name === editorWrapper.overlayItem.name)) {
                    return;
                }
            }

            this.inherited(arguments);
        },

        onReadySetupEditMode: function () {
            // summary:
            //      Setup edit mode and then bind mouse event listeners to the form and iframe
            //      in order to close the active editor when the user clicks outside.
            // tags:
            //      protected
            this.inherited(arguments);

            var self = this,
                callback = function () {
                    var editorWrapper = self._activeEditorWrapper;
                    if (editorWrapper && editorWrapper.closeOnViewportClick && editorWrapper.domNode) {
                        editorWrapper.tryToStopEditing(false);
                    }
                };

            // Listen for mousedown events on the form and iframe so that we can close the active editor when they occur.
            this._formConnects.push(on(this._form, "mouseup", callback));
            this.own(on(this.iframeWithOverlay.iframe, "mouseup", callback));
        },

        placeForm: function (form) {
            // summary:
            //		Setup the edit form.
            // tags:
            //		protected

            //Put edit form on the top region of the layout container.
            //It need not to be wrapped in a content pane because of its fixed size and responsiveness.

            form.set("fitContainer", false);
            form.set("transitionMode", "slideIn");

            this.editLayoutContainer.addChild(form, 0);

            this._setupPullDownGesture(form);
        },

        _setupPullDownGesture: function (form) {
            // summary:
            //		Setup pulldown gesture on the form (settings panel).
            // tags:
            //		private

            var opeController = this;

            // Create pull down gesture
            this._pullDownGesture = ScrollPullDown(opeController.iframeWithOverlay.previewContainer, {
                isShown: false,

                show: function () {
                    this.isShown = null; // transiting state
                    when(opeController.editLayoutContainer.selectChild(form), lang.hitch(this, function () {
                        // success
                        this.isShown = true;
                        opeController.iframeWithOverlay.onViewportPullDown();
                    }), lang.hitch(this, function () {
                        // failed
                        this.isShown = false;
                        opeController.iframeWithOverlay.onViewportPullDown();
                    }));
                },

                hide: function () {
                    this.isShown = null; // transiting state
                    when(opeController.editLayoutContainer.selectChild(opeController.iframeWithOverlay), lang.hitch(this, function () {
                        // success
                        this.isShown = false;
                        opeController.iframeWithOverlay.onViewportPullDown();
                    }), lang.hitch(this, function () {
                        // failed
                        this.isShown = true;
                        opeController.iframeWithOverlay.onViewportPullDown();
                    }));
                }
            });

            // Listen to wheel events on the pull-down panel so it's hidden when we scroll down with the pointer over it
            this._pullDownGesture.addMouseWheelListener(form.domNode);

            // Need to listen to mouse wheel events inside the iframed document in IE and Firefox
            if (opeController.iframeWithOverlay.iframe.isInspectable()) {
                this._setupIframeMouseWheelListeners();
            }
        },

        _setupIframeMouseWheelListeners: function () {
            var frameDocumentListener = this._pullDownGesture.addMouseWheelListener(this.iframeWithOverlay.iframe.getDocument());

            this._iframeConnects = [];
            this._iframeConnects.push(this.connect(this.iframeWithOverlay.iframe, "onLoad", function () {
                frameDocumentListener = this._pullDownGesture.addMouseWheelListener(this.iframeWithOverlay.iframe.getDocument());
            }));

            this._iframeConnects.push(this.connect(this.iframeWithOverlay.iframe, "onUnload", function () {
                frameDocumentListener && frameDocumentListener.remove();
            }));
        },

        _teardownIframeMouseWheelListeners: function () {
            if (this._iframeConnects) {
                var c;
                while ((c = this._iframeConnects.pop())) {
                    this.disconnect(c);
                }
                c = null;
                this._iframeConnects = null;
            }
        },

        _removePullDownGesture: function () {
            this._teardownIframeMouseWheelListeners();

            if (this._pullDownGesture) {
                this._pullDownGesture.destroy();
                this._pullDownGesture = null;
            }
        },

        _destroyOverlay: function () {
            // summary:
            //      Destroy the handles owned by the overlay items and view model
            // tags:
            //      protected, internal

            this.inherited(arguments);

            this._removeViewModelWatches();
        },

        removeForm: function (form) {
            // summary:
            //		Remove edit form from container.
            // tags:
            //		protected

            // Destroy pull down gesture.
            this._removePullDownGesture();

            this.editLayoutContainer.leftOver = form;
            return false;
        }
    });
});

},
'epi/shell/gesture/ScrollPullDown':function(){
﻿define("epi/shell/gesture/ScrollPullDown", [
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/mouse",
    "dojo/on",
    "dijit/Destroyable"],
function (
    declare,
    event,
    lang,
    mouse,
    on,
    Destroyable) {

    return declare([Destroyable], {
        // summary:
        //      Class for listening to mouse wheel movements and call show and hide delegate based on
        //      the current scroll position of a monitored target. The class is used for to identify
        //      when to show or hide a pull-down menu based on scroll wheel movement.
        //      If the scrolling is at the top of the scrollTarget (see contructor arguments) when
        //      indicates a positive wheelDelta, the the show delegate is omitted. If the show delegate has been
        //      called when a mouse wheel event indicates a negative wheelDelta then the hide delegate is called.
        //
        // tags:
        //      internal

        _delegate: null,

        _scrollTarget: null,
        _isScrolling: false,
        _pullDownInertia: 100,

        // Timeout references
        _ts: null,
        _tb: null,

        destroy: function () {
            this._delegate = null;
        },

        constructor: function (/*DOMNode*/scrollTarget, /*Object*/delegate) {
            // summary:
            //  Set up a new instance monitoring a specific dom node
            //
            // scrollTarget:
            //  A node with scrolling enabled and whose scrollTop value must be 0 for the show event to be emitted
            // delegate:
            //  An object that contains show, hide methods and isShown property.

            this._delegate = delegate;

            this._scrollTarget = scrollTarget;
            this.addMouseWheelListener(scrollTarget);
        },

        addMouseWheelListener: function (/*DOMNode*/target) {
            // summary:
            //  Add a mouse wheel delegate to the supplied target.
            //
            // returns:
            //  An delegate handle on which you can call remove to detach the delegate.

            if (target) {
                return this.own(on(target, mouse.wheel, lang.hitch(this, this._onMouseWheel)))[0];
            }

        },

        _blockShowEvent: function () {
            // summary:
            //  Used for blocking the show event while scrolling continously. We don't want the event
            //  emitted as a part of scrolling to the top of the page.
            //  Requires _pullDownInertia ms of grace time between wheel events once the top is reached.
            //
            // tags: private

            if (this._scrollTarget.scrollTop > 0) {
                this._isScrolling = true;
            }

            this._ts && clearTimeout(this._ts);
            this._ts = setTimeout(lang.hitch(this, function () {
                this._isScrolling = false;
            }), this._pullDownInertia);

            return this._isScrolling;
        },

        _initiateScrollBlock: function () {
            // summary:
            //  Sets a flag indicating that the mouse whhel event should be blocked while continously emitted

            this._scrollBlock = true;
        },

        _blockScrollEvent: function () {
            // summary:
            //  Returns true if the scroll event should be blocked, and resets the timeout used for
            //  adding resistance between scrolling of the _scrollTarget and showing/hiding the pull-down menu.

            this._tb && clearTimeout(this._tb);
            this._tb = setTimeout(lang.hitch(this, function () {
                this._scrollBlock = false;
            }), this._pullDownInertia);

            // Block scrolling if the pull-down menu is opening or hiding; or the blocking timeout hasn't expired
            return (this._delegate.isShown == null) || this._scrollBlock;
        },



        _raiseShow: function (evt) {
            // summary:
            //  Calls the show delegate. The delegate is only called once for each show/transiting/hide cycle

            // The hide delegate should be called when _isShown === false (obviously not shown)
            if (this._delegate.isShown === false) {
                event.stop(evt);
                this._delegate.show();
                this._initiateScrollBlock();
            }
        },

        _raiseHide: function (evt) {
            // summary:
            //  Calls the hide delegate. The delegate is only called once for each show/transiting/hide cycle

            // The hide delegate should be called when _isShown === true (obviously shown)
            if (this._delegate.isShown === true) {
                event.stop(evt);
                this._delegate.hide();
                this._initiateScrollBlock();
            }
        },

        _onMouseWheel: function (evt) {

            if (!evt.wheelDelta) {
                // Even if the event has no wheel direction we update the scroll block timeout
                this._blockScrollEvent();
                return;
            }

            if (this._blockScrollEvent()) {
                // When hiding (scrolling down while shown) we don't wan't the connected scroll target to scroll.
                event.stop(evt);
                return;
            }

            if (evt.wheelDelta < 0 || (this._delegate.isShown && this._scrollTarget.scrollTop > 0)) {
                // Scrolling down or scrolling when we're in shown state
                this._raiseHide(evt);
            } else if (!this._blockShowEvent()) {
                this._raiseShow(evt);
            }
        }

    });

});

},
'epi-cms/component/ContextHistory':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",

    // EPi Framework
    "epi/dependency",
    "epi/UriParser",

    // EPi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/_GridWidgetBase"
], function (
// Dojo
    array,
    declare,
    lang,
    topic,

    // EPi Framework
    dependency,
    UriParser,

    // EPi CMS
    ApplicationSettings,
    ContentReference,
    _GridWidgetBase
) {

    return declare([_GridWidgetBase], {
        // summary:
        //      This component will list the latest changed pages for the web site.
        //      This is currently bound to handle only "content" but could be generalized to handle any content that has a name and an URI.
        //
        // tags:
        //      public

        // ignoreVersionWhenComparingLinks: [public] Boolean
        //      Use version when compare uris or not. That inherited from _ContentContextMixin.
        ignoreVersionWhenComparingLinks: false,

        // sort: [private] String
        //    Default sort parameter name.
        _sort: "dateAdded",

        postMixInProperties: function () {
            // summary:
            //
            // tags:
            //    protected
            this.inherited(arguments);

            this.store = this.store || dependency.resolve("epi.shell.ContextHistory").store;
        },

        buildRendering: function () {
            // summary:
            //		Construct the UI for this widget with this.domNode initialized as a dgrid.
            // tags:
            //		protected

            this.inherited(arguments);

            var gridSettings = lang.mixin({
                columns: {
                    name: {
                        renderCell: lang.hitch(this, this._renderContentItem)
                    }
                },
                store: this.store,
                selectionMode: "single",
                dndFormatSuffix: this.dndFormatSuffix,
                sort: this._sort
            }, this.defaultGridMixin);

            this.grid = new this._gridClass(gridSettings, this.domNode);

            this.grid.set("showHeader", false);
        },

        postCreate: function () {
            // summary:
            //      The widget ready, listen event or do something
            // tags:
            //      public virtual

            this.inherited(arguments);

            // Listen event when trash is empty
            this.own(
                topic.subscribe("/epi/cms/trash/empty", lang.hitch(this, function (deletedContents) {
                    if (deletedContents) {
                        deletedContents.forEach(function (contentRef) {
                            this.store.remove("epi.cms.contentdata:///" + contentRef);
                        }, this);
                    }
                }))
            );
        },

        startup: function () {
            // summary: Overridden to connect a store to a DataGrid.

            this.inherited(arguments);
            this.fetchData();
        },

        _dndNodeCreator: function (item, hint) {
            // summary:
            //      Custom DnD avatar creator method

            var originalResults = this.inherited(arguments);

            //Since we currently only handle content data we can add an additional contentLink property
            //to the data since it specifies type to be content data.
            originalResults.data.contentLink = new UriParser(originalResults.data.uri).getId();

            return originalResults;
        },

        contextChanged: function () {
            // summary:
            //      Override base in order to call set every time we get a context change.

            this.inherited(arguments);
            this.grid.set("sort", this._sort, true);
        },

        fetchData: function () {
            var wasteBasketId = ApplicationSettings.wastebasketPage;

            // We need to filter the wastebasket. We do so by adding a regex to ignore it. The regex says the following:
            // uri must start with epi.cms.contentdata:///
            // followed by either any single digit except the waste basket id, or two or more digits.
            this.grid.set("query", { uri: new RegExp("epi\\.cms\\.contentdata:///([^" + wasteBasketId + "]|\\d{2,})") });
            this.grid.set("sort", this._sort, true);
        }
    });
});

},
'epi-cms/component/GlobalToolbar':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/store/Memory",

    // Dijit
    "dijit/registry",
    "dijit/Toolbar",

    // EPi CMS
    "epi/shell/command/_CommandModelBindingMixin",
    "epi/shell/command/_WidgetCommandConsumerMixin",
    "epi/shell/command/builder/_Builder",
    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/command/builder/DropDownButtonBuilder",
    "epi/shell/command/builder/ExpandoMenuBuilder",

    //Template
    "dojo/text!./templates/GlobalToolbar.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
// Dojo
    declare,
    lang,

    domStyle,

    Memory,

    // Dijit
    registry,
    Toolbar,

    // EPi CMS
    _CommandModelBindingMixin,
    _WidgetCommandConsumerMixin,
    _Builder,
    MenuAssembler,
    DropDownButtonBuilder,
    ExpandoMenuBuilder,

    template,
    resources
) {

    var _MenuBuilder = declare([_Builder], {
        _create: function (command) {
            //Declare a new widget and add the _CommandModelBindingMixin
            var widgetPrototype = declare([command.settings.widget, _CommandModelBindingMixin]);

            //Create the new widget
            return new widgetPrototype(command.settings);
        }
    });

    var _MenuAssembler = declare([MenuAssembler], {
        _getBuildInfo: function (command) {
            // summary:
            //      Return the builder information for a specific command based on its category property
            // tags: private

            //Get the category from the settings object instead of the command
            if (command.settings.category) {

                var i = this.configuration.length - 1;
                for (; i > 0; i--) {
                    if (this.configuration[i].category === command.settings.category) {
                        return this.configuration[i];
                    }
                }
            }

            return this.configuration[0];
        }
    });

    return declare([Toolbar, _WidgetCommandConsumerMixin], {
        // summary:
        //      A component providing the global toolbar.
        //
        // tags:
        //      internal

        templateString: template,

        commandKey: "epi.cms.globalToolbar",

        postCreate: function () {
            // summary: Overridden to add buttons to the tool bar once the toolbar itself has been created.

            this.inherited(arguments);

            //Assemble the menu for the available commands
            var builder = new _MenuBuilder();

            var dropDownBuilder = new DropDownButtonBuilder({
                settings: {
                    title: resources.createcontent.title,
                    "class": "epi-mediumButton epi-disabledDropdownArrow",
                    iconClass: "epi-iconPlus",
                    showLabel: false
                },
                hideEmptyButton: true
            });

            var assemblerConfig = [
                { category: "leading", builder: builder, target: this.leadingContainerNode },
                { category: "view", builder: new ExpandoMenuBuilder({
                    optionClass: "epi-menu--inverted",
                    optionItemClass: "epi-radioMenuItem"
                }), target: this.viewNode },
                { category: "center", builder: builder, target: this.centerContainerNode },
                { category: "trailing", builder: builder, target: this.trailingContainerNode },
                { category: "create", builder: dropDownBuilder, target: this.leadingContainerNode },
                { category: "compare", builder: new ExpandoMenuBuilder({
                    optionClass: "epi-menu--inverted",
                    optionItemClass: "epi-radioMenuItem"
                }), target: this.compareNode }
            ];

            var assembler = new _MenuAssembler({ configuration: assemblerConfig, commandSource: this });
            assembler.build();
        },

        _getNextFocusableChild: function (child, dir) {
            // summary:
            //      Returns the next or previous focusable child, compared
            //      to "child"
            // child: Widget
            //      The current widget
            // dir: Integer
            //      * 1 = after
            //      * -1 = before

            var children = this.getChildren();
            var index = children.indexOf(child);

            index = (dir > 0) ? index + 1 : index - 1;
            if (index < 0) {
                index = children.length - 1;
            } else if (index >= children.length) {
                index = 0;
            }

            return children[index];
        }
    });
});

},
'epi/shell/command/_WidgetCommandConsumerMixin':function(){
﻿define("epi/shell/command/_WidgetCommandConsumerMixin", [
    "dojo/_base/declare",

    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/_WidgetCommandProviderMixin"
], function (declare, _CommandConsumerMixin, _WidgetCommandProviderMixin) {

    return declare([_CommandConsumerMixin, _WidgetCommandProviderMixin], {
        // summary:
        //		A mixin for objects that will consume and provide commands from widgets and the global command provider
        // tags:
        //		internal

    });
});

},
'epi/shell/command/_WidgetCommandProviderMixin':function(){
﻿define("epi/shell/command/_WidgetCommandProviderMixin", [
    "dojo/_base/declare",
    "epi/shell/command/_WidgetCommandBinderMixin",
    "epi/shell/command/_GlobalCommandProviderMixin"
], function (declare, _WidgetCommandBinderMixin, _GlobalCommandProviderMixin) {

    return declare([_GlobalCommandProviderMixin, _WidgetCommandBinderMixin], {
        // summary:
        //      A mixin for widgets that will automatically provide commands to the closest parent widget which is a consumer.
        //
        // tags:
        //      internal xproduct

        postMixInProperties: function () {
            this.inherited(arguments);

            this.commandProvider = this.commandProvider || this;
        }

    });
});

},
'url:epi-cms/component/templates/GlobalToolbar.html':"﻿<div class=\"dijit epi-globalToolbar\" role=\"toolbar\" tabIndex=\"${tabIndex}\" data-dojo-attach-point=\"containerNode\">\r\n    <div class=\"epi-toolbarGroupContainer\">\r\n        <div class=\"epi-toolbarLeading epi-toolbarGroup\">\r\n            <span data-dojo-attach-point=\"leadingContainerNode\"></span\r\n            ><span data-dojo-attach-point=\"viewNode\"></span\r\n            ><span data-dojo-attach-point=\"compareNode\"></span>\r\n        </div>\r\n        <div data-dojo-attach-point=\"centerContainerNode\" class=\"epi-toolbarCenter epi-toolbarGroup\"></div>\r\n        <div data-dojo-attach-point=\"trailingContainerNode\" class=\"epi-toolbarTrailing epi-toolbarGroup\"></div>\r\n    </div>\r\n</div>",
'epi-cms/component/MainNavigationComponent':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-geometry",
    "dojo/dom-class",
    "dojo/when",
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi-cms/component/_ShowAllLanguagesMixin",
    "epi/dependency",
    "epi-cms/ApplicationSettings",
    "epi/i18n!epi/cms/nls/episerver.cms.components.sitetree",
    "dojo/text!./templates/MainNavigation.html",
    "epi-cms/widget/SearchBox"
], function (
    array,
    declare,
    lang,
    domGeometry,
    domClass,
    when,
    _LayoutWidget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _ShowAllLanguagesMixin,

    dependency,
    ApplicationSettings,
    res,
    template
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ShowAllLanguagesMixin], {
        // summary:
        //      Component for displaying the navigation panel with a search area and a pluggable page selection widget.
        //
        // tags:
        //      internal

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: template,

        res: res,

        contentRepositoryDescriptors: null,

        postCreate: function () {
            this.inherited(arguments);

            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
            var settings = this.contentRepositoryDescriptors.get(this.repositoryKey);

            var roots = this.roots ? this.roots : settings.roots;

            this.search.set("area", settings.searchArea);
            this.search.set("searchRoots", roots);

            var componentType = settings.customNavigationWidget || "epi-cms/component/ContentNavigationTree";

            require([componentType], lang.hitch(this, function (innerComponentClass) {
                var innerComponent = new innerComponentClass(
                    {
                        typeIdentifiers: settings.mainNavigationTypes ? settings.mainNavigationTypes : settings.containedTypes,
                        containedTypes: settings.containedTypes,
                        settings: settings,
                        roots: roots,
                        repositoryKey: this.repositoryKey
                    }
                );
                innerComponent.placeAt(this.navigation);
                this.tree = innerComponent;

                when(this.tree._isSiteMultilingual()).then(function (isSiteMultilingual) {
                    if (!isSiteMultilingual) {
                        return;
                    }

                    ApplicationSettings.mainNavigationComponentId = this.componentId;
                    this.loadShowAllLanguages().then(function (showAllLanguages) {
                        innerComponent.set("showAllLanguages", showAllLanguages);
                        this._setShowAllLanguagesLinkVisibility(showAllLanguages);
                    }.bind(this));
                }.bind(this));

                // Resize the tree once it is added to the UI to ensure the indentation
                // is calculated correctly.
                this.tree.resize();

                this.own(this.tree.watch("showAllLanguages", function (value) {
                    var showAllLanguages = this.tree.get("showAllLanguages");
                    this.search.set("filterOnCulture", !showAllLanguages);
                    if (this.showAllLanguages !== showAllLanguages) {
                        this.saveShowAllLanguages(showAllLanguages);
                    }
                    this.set("showAllLanguages", showAllLanguages);

                    this._setShowAllLanguagesLinkVisibility(showAllLanguages);
                }.bind(this)));
            }));

            this.own(this.on(".epi-main-navigation-language-link:click", function () {
                this.tree.set("showAllLanguages", true);
            }.bind(this)));
        },

        layout: function () {
            // summary:
            //		Resize and layout the search box and page selector widget.
            // tags:
            //		protected

            var cb = this._contentBox, ocb = this._oldContentBox;

            if (!cb) {
                return;
            }

            if (!ocb || cb.w !== ocb.w || cb.h !== ocb.h) {
                this._oldContentBox = cb;
                this._relayout();
            }
        },

        _relayout: function () {
            var sb = domGeometry.getMarginBox(this.search.domNode);

            var showAllLanguagesHeight = domClass.contains(this.bottomLinkContainer, "dijitHidden")  ? 0 : domGeometry.getMarginBox(this.bottomLinkContainer).h;

            domGeometry.setMarginBox(this.navigation, {
                w: this._contentBox.w,
                h: this._contentBox.h - sb.h - showAllLanguagesHeight
            });
        },

        _setShowAllLanguagesLinkVisibility: function (showAllLanguages) {
            domClass.toggle(this.bottomLinkContainer, "dijitHidden", showAllLanguages);
            if (!this._contentBox) {
                return;
            }
            this._relayout();
        }
    });
});

},
'epi-cms/component/_ShowAllLanguagesMixin':function(){
define([
// Dojo
    "dojo/_base/declare",
    "dojo/when",
    // EPi Framework
    "epi/dependency"
], function (declare, when, dependency) {

    return declare([], {
        // summary:
        //      A mixin that provide storage mechanism for the gadget language setting
        // tags:
        //      internal

        // showAllLanguages: [public] Boolean
        //		Flag which indicates whether to show all languages. Value is true if all languages should be shown; otherwise false.
        showAllLanguages: true,

        // showAllLanguagesKey: [private] String
        //      The key to be used while storing the value into the profile.
        _showAllLanguagesKey: "_showAllLanguages",

        // profile: [private] epi.shell.Profile
        //      The profile store.
        _profile: null,

        constructor: function (kwArgs) {
            this._profile = kwArgs._profile || dependency.resolve("epi.shell.Profile");
        },

        loadShowAllLanguages: function () {
            return when(this._profile.get(this.componentId + this._showAllLanguagesKey)).then(function (showAllLanguages) {
                if (showAllLanguages !== null) {
                    this.showAllLanguages = showAllLanguages;
                    return showAllLanguages;
                }

                return this.showAllLanguages;
            }.bind(this));
        },

        saveShowAllLanguages: function (value) {
            // summary:
            //      Saves the setting in the profile.
            // value: Boolean
            // tags:
            //      public

            this._profile.set(this.componentId + this._showAllLanguagesKey, value);
        }
    });
});

},
'url:epi-cms/component/templates/MainNavigation.html':"<div>\r\n    <div data-dojo-type=\"epi-cms/widget/SearchBox\" data-dojo-attach-point=\"search\" class=\"epi-gadgetInnerToolbar\"></div>\r\n    <div data-dojo-attach-point=\"navigation\" class=\"epi-navigation\" style=\"overflow:auto;\">\r\n    </div>\r\n    <div class=\"epi-gadget-bottom-container dijitHidden\" data-dojo-attach-point=\"bottomLinkContainer\">\r\n        <a class=\"epi-visibleLink epi-main-navigation-language-link\">${res.showalllanguages}</a>\r\n    </div>\r\n</div>\r\n",
'epi-cms/component/Media':function(){
﻿define([
// dojo
    "dojo/_base/declare",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",

    "dojo/on",
    "dojo/topic",
    // epi-cms
    "epi-cms/component/MediaViewModel",
    "epi-cms/asset/HierarchicalList",
    "epi-cms/widget/FilesUploadDropZone",
    "epi-cms/widget/UploadUtil",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.hierachicallist",
    "epi/i18n!epi/cms/nls/episerver.cms.components.media"
],

function (
// dojo
    declare,

    domClass,
    domConstruct,
    domStyle,

    on,
    topic,
    // epi
    MediaViewModel,
    HierarchicalList,
    FilesUploadDropZone,
    UploadUtil,
    // Resources
    hierarchicalListResources,
    resources
) {

    return declare([HierarchicalList], {
        // summary:
        //      Media management component
        // tags:
        //      internal

        res: resources,

        // showCreateContentArea: [public] Boolean
        //      Flag to indicate this widget allowed to show create content area by default or not.
        showCreateContentArea: true,

        showThumbnail: true,

        modelClassName: MediaViewModel,

        noDataMessages: resources.nodatamessages,

        // hierarchicalListClass: [readonly] String
        //      The CSS class to be used on the content list.
        hierarchicalListClass: "epi-mediaList",

        // createContentText: [public] String
        //      Upload file text
        createContentText: resources.dropareatitle,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.modelBindingMap.dropZoneSettings = ["dropZoneSettings"];
        },

        buildRendering: function () {
            this.inherited(arguments);

            this._setupDropZone();
        },

        postCreate: function () {

            this.inherited(arguments);

            this.list.set("noDataMessage", this.res.nocontent);
            var uploadDefaultCommand = this.model.getCommand("uploadDefault");
            this.own(
                uploadDefaultCommand.watch("canExecute", function (name, oldValue, newValue) {
                    this._toggleCreateContentArea(newValue);
                }.bind(this)),
                uploadDefaultCommand.watch("isAvailable", function (name, oldValue, newValue) {
                    this._toggleCreateContentArea(newValue);
                }.bind(this))
            );
        },

        _setupDropZone: function () {
            // summary:
            //      Setup drop zone for entire widget.
            // tags:
            //      private

            var uploadCommand = this.model.getCommand("uploadDefault");
            if (!uploadCommand) {
                return;
            }

            // Create drop zone
            this.own(this._dropZone = new FilesUploadDropZone({ outsideDomNode: this.container.domNode }));
            domConstruct.place(this._dropZone.domNode, this.domNode, "first");

            this.connect(this._dropZone, "onDrop", this._onDrop);
        },

        _onDrop: function (evt, fileList) {
            fileList = UploadUtil.filterFileOnly(fileList);
            if (!fileList || fileList.length <= 0) { // ignore folder dropping
                return;
            }

            var uploadCommand = this.model.getCommand("uploadDefault");
            if (!uploadCommand) {
                return;
            }

            uploadCommand.set("fileList", fileList);
            uploadCommand.execute();

            // Hide the search result list by clearing the search box
            this.searchBox.clearValue();
        },

        _setDropZoneSettingsAttr: function (settings) {
            if (this._dropZone) {
                this._dropZone.set("settings", settings);
            }
        },

        _onCreateAreaClick: function () {
            // summary:
            //      A callback function which is executed when the create area is clicked.
            // tags:
            //      protected
            this.inherited(arguments);
            this.model.getCommand("uploadDefault").execute();
        },

        // =======================================================================
        // List setup

        _setupCreateContentArea: function () {
            // summary:
            //      Setup create content area for list widget
            // tags:
            //      protected
            this.inherited(arguments);

            var buttonNode = this.createContentAreaButton.domNode;
            domClass.remove(buttonNode, "epi-flat");
            domClass.add(buttonNode, "epi-button--full-width");
        }
    });

});

},
'epi-cms/component/MediaViewModel':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "dojo/when",
    "dojo/topic",
    // epi
    "epi",
    "epi/shell/widget/dialog/Dialog",

    "epi-cms/core/ContentReference",

    "epi-cms/asset/view-model/HierarchicalListViewModel",
    "epi-cms/widget/viewmodel/MultipleFileUploadViewModel",
    "epi-cms/widget/MultipleFileUpload",

    "epi-cms/command/UploadContent",
    "epi-cms/command/EditImage",
    "epi-cms/command/DownloadMedia",
    "epi-cms/asset/command/UploadContentToSelection",
    // resource
    "epi/i18n!epi/cms/nls/episerver.cms.components.media"
],

function (
// dojo
    array,
    declare,
    lang,

    domClass,

    when,
    topic,
    // epi
    epi,
    Dialog,

    ContentReference,

    HierarchicalListViewModel,
    MultipleFileUploadViewModel,
    MultipleFileUpload,

    UploadContentCommand,
    EditImageCommand,
    DownloadCommand,
    UploadContentToSelectionCommand,
    // resources
    resources
) {

    return declare([HierarchicalListViewModel], {
        // summary:
        //      Handles search and tree to list browsing widgets.
        // tags:
        //      internal

        // dropZoneSettings: Object
        //      Settings for the drop zone containing enabled and validSelection properties.
        dropZoneSettings: null,

        // Dialog widget for uploading new media
        _dialog: null,

        postscript: function () {
            this.inherited(arguments);

            this.own(topic.subscribe("/epi/cms/upload", function (targetId) {
                this.set("selectedTreeItems", this.get("selectedTreeItems"));

                if (this.isPseudoContextualRoot({ contentLink: targetId }) && this.treeStoreModel && typeof this.treeStoreModel.refreshRoots === "function") {
                    this.treeStoreModel.refreshRoots(this);
                }
            }.bind(this)));
        },

        _getTypesToCreate: function () {
            // No create commands for media since upload is used instead.
            return [];
        },

        _setupCommands: function () {
            // summary:
            //      Creates and registers the commands used.
            // tags:
            //      protected

            this.inherited(arguments);

            var settings = {
                selection: this.selection
            };
            var uploadCommand = new UploadContentCommand(lang.mixin({
                iconClass: "epi-iconPlus",
                label: resources.command.label,
                resources: resources,
                viewModel: this
            }, settings));
            var customCommands = {
                uploadDefault: {
                    command: uploadCommand
                },
                upload: {
                    command: new UploadContentToSelectionCommand(lang.mixin({
                        category: "context",
                        iconClass: "epi-iconUpload",
                        label: resources.linktocreateitem,
                        viewModel: this
                    }, settings)),
                    order: 2
                },
                editImage: {
                    command: new EditImageCommand(lang.mixin({
                        category: "context",
                        forceContextChange: true,
                        label: resources.command.openineditor
                    }, settings)),
                    order: 3
                },
                download: {
                    command: new DownloadCommand(lang.mixin({
                        category: "context",
                        label: resources.command.download
                    }, settings)),
                    order: 4
                }
            };

            this.own(uploadCommand.watch("canExecute", this._onUploadCommandUpdated.bind(this)));

            this._commandRegistry = lang.mixin(this._commandRegistry, customCommands);

            this.pseudoContextualCommands.push(this._commandRegistry.uploadDefault.command);
            this.pseudoContextualCommands.push(this._commandRegistry.upload.command);
        },

        _onUploadCommandUpdated: function (name, oldValue, canExecute) {
            // summary:
            //      When the upload command is updated we will update the drop zone settings.
            // tags:
            //      private

            var uploadCommand = this._commandRegistry.uploadDefault.command;
            var commandModel = uploadCommand.get("model");
            var validSelection = commandModel ? commandModel.length === 1 : false;
            var dropFolderName = validSelection ? commandModel[0].name : null;
            var isSearching = this.get("isSearching");
            var dropZoneSettings = {
                dropFolderName: dropFolderName,
                validSelection: validSelection,
                // disable drop zone when searching or when the user does not have permission to upload.
                enabled: !isSearching && (canExecute || !validSelection)
            };
            this.set("dropZoneSettings", dropZoneSettings);
        },

        _selectedTreeItemsSetter: function (items) {
            // summary:
            //      Update model of commands in case selected content is folder
            // tags:
            //      private

            //The default upload command should only update when the list is updated.
            //It needs to be updated before the pseudocommanddecorator is applied.
            this._commandRegistry.uploadDefault.command.set("model", items);

            this.inherited(arguments);
        },

        upload: function (/*Array*/fileList, /*String?*/targetId, /*Boolean?*/createAsLocalAsset) {
            // summary:
            //      Upload multiple files.
            // fileList: [Array]
            //      List files to upload.
            //      When null, only show upload form to select files for uploading.
            //      Otherwise, upload files in list.
            // targetId: [String?]
            //      Parent content id
            // createAsLocalAsset: [Boolean?]
            // tags:
            //      protected

            // only create dialog if it is not available, otherwise, re-use it.
            var uploader = new MultipleFileUpload({
                model: new MultipleFileUploadViewModel({
                    store: this.get("store"),
                    query: this.get("listQuery")
                })
            });

            uploader.on("beforeUploaderChange", lang.hitch(this, function () {
                this._uploading = true;
            }));

            // close multiple files upload dialog when stop uploading
            uploader.on("close", lang.hitch(this, function (uploading) {
                this._dialog && (uploading ? this._dialog.hide() : this._dialog.destroy());
            }));

            // Reload current folder of tree, to reflect changes
            uploader.on("uploadComplete", lang.hitch(this, function (/*Array*/uploadFiles) {
                // Set current tree item again to reload items in list.
                if (uploader.createAsLocalAsset) {
                    when(this.treeStoreModel && typeof this.treeStoreModel.refreshRoots === "function" && this.treeStoreModel.refreshRoots(this), lang.hitch(this, function () {
                        // Turn-off createAsLocalAsset
                        uploader.set("createAsLocalAsset", false);
                        // Update uploading directory after create a new real one local asset folder for the given content
                        uploader.set("uploadDirectory", this.get("selectedTreeItems")[0].contentLink);
                        // Update content list query after create a new real one local asset folder for the given content
                        uploader.model.set("query", this.get("listQuery"));
                        // Publish the local asset created topic so that all the other media component is refreshed
                        topic.publish("/epi/cms/action/createlocalasset", this.treeStoreModel);
                    }));
                } else {
                    this.onListItemUpdated(uploadFiles);
                    topic.publish("/epi/cms/upload", targetId);
                    this.selectListItemsByContentReferences(this._filterUploadedReferences(uploadFiles));
                }

                if (this._dialog && !this._dialog.open) {
                    this._dialog.destroy();
                }

                this._uploading = false;
            }));

            this._dialog = new Dialog({
                title: resources.linktocreateitem,
                dialogClass: "epi-dialog-upload",
                content: uploader,
                autofocus: true,
                defaultActionsVisible: false,
                closeIconVisible: false,
                destroyOnHide: false
            });

            // only show close button for multiple files upload dialog
            this._dialog.definitionConsumer.add({
                name: "close",
                label: epi.resources.action.close,
                action: function () {
                    uploader.close();
                }
            });

            this._dialog.resize({ w: 700 });
            this._dialog.show();

            // we can only upload when a single item is selected so its ok to use index 0;
            var selectedContent = this.get("selectedTreeItems")[0];
            // Update breadcumb on upload dialog.
            this._buildBreadcrumb(selectedContent, uploader);

            // Set destination is current tree item.
            uploader.set("uploadDirectory", targetId || selectedContent.id);
            uploader.set("createAsLocalAsset", createAsLocalAsset);

            uploader.upload(fileList);
        },
        _filterUploadedReferences: function (uploadFiles) {
            // summary:
            //      Get filtered list of version agnostic references
            // tags:
            //      internal
            if (!uploadFiles) {
                return [];
            }
            return uploadFiles.flatMap(function (uploadFile) {
                if (uploadFile.status === "Uploaded" && uploadFile.contentLink) {
                    var contentReference = ContentReference.toContentReference(uploadFile.contentLink);
                    return contentReference.createVersionUnspecificReference().toString();
                }
                return [];
            });
        },

        onListItemUpdated: function (updatedItems) {
            // summary:
            //      Refresh the editing media if it have a new version
            // updatedItems: [Array]
            //      Collection of the updated item. In this case, they are files.
            // tags:
            //      public, extension

            var store = this.store;

            return when(this.getCurrentContext(), function (currentContext) {
                var contentWithoutVersion = (new ContentReference(currentContext.id)).createVersionUnspecificReference().toString();

                return when(store.get(contentWithoutVersion), function (currentContent) {
                    var editingMedia = array.filter(updatedItems, function (updatedItem) {
                        return currentContent.name.toLowerCase() === updatedItem.fileName.toLowerCase();
                    })[0];
                    return editingMedia ? currentContent : null;
                });
            });
        },

        _buildBreadcrumb: function (contentItem, uploader) {
            // summary:
            //      Build breadcrumb for the provided content
            // contentItem: Object
            //      The provided content
            // uploader: Object
            //      The multiple file upload control
            // tags:
            //      private

            if (!uploader) {
                return;
            }

            // Do not add more items when current content is sub root
            if (this.treeStoreModel.isTypeOfRoot(contentItem)) {
                uploader.set("breadcrumb", [contentItem]);
                return;
            }

            this.treeStoreModel.getAncestors(contentItem.contentLink, lang.hitch(this, function (ancestors) {
                var ancestor,
                    paths = [contentItem];

                for (var i = ancestors.length - 1; i >= 0; i--) {
                    ancestor = ancestors[i];
                    paths.unshift(ancestor);

                    // Break after first sub root or context root
                    if (this.treeStoreModel.isTypeOfRoot(ancestor)) {
                        break;
                    }
                }

                uploader.set("breadcrumb", paths);
            }));
        }
    });

});

},
'epi-cms/asset/view-model/HierarchicalListViewModel':function(){
define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/aspect",
    "dojo/Evented",

    "dojo/Stateful",
    "dojo/when",
    "dojo/promise/all",
    "dijit/registry",
    "dijit/Destroyable",
    //epi
    "epi",
    "epi/dependency",

    "epi/shell/ClipboardManager",
    "epi/shell/command/_CommandProviderMixin",
    "epi/shell/selection",
    "epi/shell/TypeDescriptorManager",
    //epi-cms
    "epi-cms/_MultilingualMixin",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/ContentForestStoreModel",
    "epi-cms/widget/ContextualContentForestStoreModel",
    //command
    "epi-cms/widget/CreateCommandsMixin",
    "epi-cms/command/CopyContent",
    "epi-cms/command/CutContent",
    "epi-cms/command/DeleteContent",
    "epi-cms/command/PasteContent",
    "epi-cms/component/command/ViewTrash",
    "epi-cms/asset/command/ChangeContextToSelection",
    "epi-cms/asset/command/NewFolder",
    "epi-cms/asset/command/RenameSelectedFolder",
    "epi-cms/asset/command/TranslateSelectedContent",
    "epi-cms/contentediting/command/BlockInlineEditSelectedContent",
    "epi-cms/plugin-area/assets-pane"
], function (
    // dojo
    array,
    declare,
    lang,
    topic,
    aspect,
    Evented,

    Stateful,
    when,
    all,
    registry,
    Destroyable,
    // epi
    epi,
    dependency,

    ClipboardManager,
    _CommandProviderMixin,
    Selection,
    TypeDescriptorManager,
    //epi-cms
    _MultilingualMixin,
    ApplicationSettings,
    _ContextualContentContextMixin,
    ContentReference,
    ContentForestStoreModel,
    ContextualContentForestStoreModel,
    //command
    CreateCommandsMixin,
    CopyContentCommand,
    CutContentCommand,
    DeleteContentCommand,
    PasteContentCommand,
    ViewTrashCommand,
    ChangeContextToSelectionCommand,
    NewFolderCommand,
    RenameSelectedFolderCommand,
    TranslateSelectedContentCommand,
    BlockInlineEditSelectedContent,
    assetsPanePluginArea
) {

    return declare([Stateful, Evented, _ContextualContentContextMixin, _MultilingualMixin, CreateCommandsMixin, Destroyable], {
        // summary:
        //      Handles search and tree to list browsing widgets.
        //
        // tags:
        //      internal

        // searchArea: [readonly] String
        //      Used with the search component when querying to scope the search.
        searchArea: "",

        // searchRoots: [readonly] String
        //      Used with the search component to set the roots to search in.
        searchRoots: "",

        // clipboardManager: [const] ClipboardManager
        //      Used to handle copy-paste operations with the commands.
        clipboardManager: null,

        // selection: [const] Selection
        //      Used to handle currently selected items for the commands.
        selection: null,

        // commands: [readonly] _Command[]
        //      Used to handle currently selected items for the commands.
        commands: null,

        // createCommands: [readonly] _Command[]
        //      Used to handle currently selected items for the commands.
        createCommands: null,

        // createHierarchyCommands: [readonly] _Command[]
        //      Used to handle currently selected items for the commands.
        createHierarchyCommands: null,

        // pseudoContextualCommands: [readonly] _Command[]
        //      Used to handle currently selected items for the commands.
        pseudoContextualCommands: null,

        // treePaths: [public] Array[]
        //      An array of arrays containing a hierarchy of content items starting with the root
        //      and ending with the actual item being selected.
        treePaths: null,

        // selectedTreeItems: [public] Array
        //      The currently selected tree items.
        selectedTreeItems: null,

        // selectedListItems: [public] Array
        //      An array containing the currently selected list items.
        selectedListItems: null,

        // listQuery: Query
        //      Query object holding parameters to get the children.
        //      of the current tree item
        listQuery: null,

        // listQueryOptions: Object
        //      Extra parameters needed to query the store for the list items.
        listQueryOptions: null,

        // showAllLanguages: Boolean
        //      Indicates if to query for items only in current language context or not.
        showAllLanguages: true,

        // treeStoreModelClass: [const] Function
        //      Class to use as model for the tree.
        treeStoreModelClass: null,

        // treeStoreModel: [const] TreeStoreModel
        //      TreeStoreModel instance.
        treeStoreModel: null,

        // store: [const] Dojo/Store
        //      Store instance used for all server queries.
        store: null,

        // searchStore: [const] Dojo/Store
        //      Store instance used for all server search queries.
        searchStore: null,

        // storeKey: [const] String
        //      Key to resolve store from dependency.
        storeKey: "epi.cms.content.light",

        // mainNavigationTypes: String[]
        //      Which types to filter for tree queries. Also used with trash command.
        mainNavigationTypes: null,

        // containedTypes: [const] String[]
        //       Which types to filter for list queries.
        containedTypes: null,

        // noDataMessages: [public] Object
        //      Object containing the texts for when the list contains no items. It should have two properties named single and multiple.
        noDataMessages: null,

        // noDataMessage: [public] String
        //      String to be displayed in the list when no items are returned from the store.
        noDataMessage: "",

        // isStandaloneComponent: [public] Boolean
        //      Is this component a standalone component or it's part of a ComponentGroup
        isStandaloneComponent: false,

        // profile: [private] shell/Profile
        //       The current users profile that is used to store settings.
        _profile: null,

        // _commandItems: [private] Array
        //      An array containing the currently selected items used in the commands.
        _commandItems: null,

        // _pluginCommands: [private] Array
        //      An array containing the commands loaded from the plugin area.
        _pluginCommands: null,

        constructor: function () {

            // Create the command registry
            this._commandRegistry = {
                sort: function () {
                    var commands = [];
                    for (var key in this) {
                        if (key !== "toArray" && key !== "sort" && Object.prototype.hasOwnProperty.call(this, key)) {
                            var index = this[key].order;
                            if (!index) {
                                index = 100;
                            }
                            commands.push([index, this[key].command]);
                        }
                    }

                    commands.sort(function (a, b) {
                        return a[0] - b[0];
                    });

                    return commands;
                },
                toArray: function () {
                    var sortedCommand = this.sort();
                    var commands = [];
                    array.forEach(sortedCommand, function (key) {
                        commands.push(key[1]);
                    });

                    return commands;
                }
            };

            this.own(assetsPanePluginArea.on("added, removed", this._setCommands.bind(this)));
        },

        postscript: function (args) {
            this.inherited(arguments);
            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
            declare.safeMixin(this, this.contentRepositoryDescriptors.get(args.repositoryKey));

            this._profile = this._profile || dependency.resolve("epi.shell.Profile");
            this.clipboardManager = this.clipboardManager || new ClipboardManager();
            this.selection = this.selection || new Selection();
            this.store = this.store || dependency.resolve("epi.storeregistry").get(this.storeKey);
            this.searchStore = this.searchStore || dependency.resolve("epi.storeregistry").get("epi.cms.content.search");

            this._setupTreeStoreModel();

            this._setupCommands();
            this._setCommands();


            this._setupSearchRoots();

            this.set("listQueryOptions", this.treeStoreModel._queryOptions);
        },

        startup: function () {
            // summary:
            //      Allows the view model to start reacting to external input.
            // tags:
            //      protected

            this.inherited(arguments);

            this._setupSelection();
        },

        getCommand: function (commandName) {
            // summary:
            //      Gets a command by command name
            // tags:
            //      protected

            return this._commandRegistry[commandName] ? this._commandRegistry[commandName].command : null;
        },

        contentContextChanged: function (context, callerData) {
            // summary:
            //      Called when the currently loaded content changes. I.e. a new content data object is loaded into the preview area.
            //      Override _ContextContextMixin.contentContextChanged
            // tags:
            //      protected

            this._setupSearchRoots();

            if (!this._isSupportedContent(context)) {
                return;
            }

            this.selectItemsByContentReference(context.id, false);
        },

        selectItemsByContentReference: function (contentLink, allowAssetsFolderSelection) {
            // summary:
            //      sets both tree folder path and grid selected items based on provided contentLink
            // contentLink: ContentReference?
            //      id of the content that should be selected in the component
            // allowAssetsFolderSelection: Boolean?
            //      if true then allow to select path when image is in Assets Folder
            // tags:
            //      public

            if (!contentLink) {
                return;
            }

            var contentReference = ContentReference.toContentReference(contentLink);

            when(this.store.get(contentReference.createVersionUnspecificReference().toString()), function (content) {

                this.treeStoreModel.getAncestors(content, function (ancestors) {

                    if (!allowAssetsFolderSelection && this._isAncestorAssetFolder(ancestors)) {
                        // If an ancestor is a asset folder we will not update the paths here.
                        // We will handle those cases in updateTreePaths at a later stage.
                        return;
                    }

                    var newListSelection = [];
                    // when content is a ContentFolder then it should be used to select tree path
                    // otherwise it should be used to select item on the list
                    if (content.capabilities.isContentFolder) {
                        ancestors.push(content);
                    } else {
                        newListSelection.push(content);
                    }

                    var newTreeSelection = [ancestors];

                    if (epi.areEqual(this.get("treePaths"), newTreeSelection) && epi.areEqual(this.get("selectedListItems"), newListSelection)) {
                        return;
                    }

                    this.emit("setPathsAndItems", newTreeSelection, newListSelection);
                }.bind(this));
            }.bind(this));
        },

        selectListItemsByContentReferences: function (contentLinks) {
            // summary:
            //      sets selected list items by fetching an array of content data from store
            // contentLinks: Array
            //      references of content items that should be selected
            // tags:
            //      public

            all(contentLinks.map(function (contentLink) {
                return when(this.store.get(contentLink));
            }.bind(this))).then(function (contentItems) {
                this.set("selectedListItems", contentItems);
            }.bind(this));
        },

        _isAncestorAssetFolder: function (ancestors) {
            // summary:
            //      Checks if any ancestor is an asset folder.
            // ancestors:
            //      The ancestors to a content.
            // returns:
            //      true, if any ancestor is an content asset folder; otherwise false.
            // tags:
            //      private

            //if there is only one ancestor we can be sure that this is an item in an asset folder.
            if (ancestors.length === 1) {
                return true;
            }

            return ancestors.some(function (ancestor) {
                return this._isAssetsFolder(ancestor);
            }.bind(this));
        },

        _isAssetsFolder: function (content) {
            // summary:
            //      Checks if a content is an asset folder.
            // content:
            //      The content to check if it's an asset folder.
            // returns:
            //      true, if the specified content is a content asset folder; otherwise false.
            // tags:
            //      private

            return content.typeIdentifier === "episerver.core.contentassetfolder" ||
                ContentReference.compareIgnoreVersion(content.contentLink, ApplicationSettings.contentAssetsFolder);
        },

        updateTreePaths: function (rootChildItems) {
            // summary:
            //      Updates the treePaths value by comparing the existing treePaths with the new child items of the tree root.
            // rootChildItems:
            //      The new child items to the tree's root.
            // tags:
            //      public

            var treePaths = this.get("treePaths");

            if (!treePaths || !treePaths.length) {
                return;
            }

            var assetsFolderIndex = this._getAssetFolderIndex(treePaths);

            if (this._selectionContainsAssetFolder(assetsFolderIndex)) {

                var treePathsCopy = lang.clone(treePaths);

                this._removeOldAssetFolder(treePathsCopy, assetsFolderIndex);

                this._addNewAssetFolder(rootChildItems, treePathsCopy);

                if (!treePathsCopy.length) {
                    treePathsCopy = this._getDefaultTreePaths();
                }

                when(treePathsCopy).then(function (resolvedPaths) {
                    this.set("treePaths", resolvedPaths);
                }.bind(this));
            }
        },

        _getAssetFolderIndex: function (treePaths) {
            // summary:
            //      Gets the index of any treePath that contains an asset folder if any exist.
            // treePaths:
            //      The tree paths where we look for asset folders.
            // returns:
            //      The index of the tree path that contains an asset folder; otherwise -1.
            // tags:
            //      private

            var assetsFolderIndex = -1;

            treePaths.some(function (treePath, index) {
                return treePath.some(function (content) {
                    var isAssetFolder = this._isAssetsFolder(content);
                    if (isAssetFolder) {
                        assetsFolderIndex = index;
                    }
                    return isAssetFolder;
                }.bind(this));
            }.bind(this));

            return assetsFolderIndex;
        },

        _selectionContainsAssetFolder: function (assetsFolderIndex) {
            // summary:
            //      Removes the old asset folder from the specified treePaths.
            // assetsFolderIndex:
            //      The index of the tree path that contains an asset folder.
            // returns:
            //      true if the index is bigger than -1; otherwise false.
            // tags:
            //      private

            return assetsFolderIndex > -1;
        },

        _removeOldAssetFolder: function (treePaths, oldAssetFolderIndex) {
            // summary:
            //      Removes the old asset folder from the specified treePaths.
            // treePaths:
            //      The tree paths that includes the asset folder path that will be removed.
            // oldAssetFolderIndex:
            //      The index of the tree path that will be removed.
            // tags:
            //      private

            treePaths.splice(oldAssetFolderIndex, 1);
        },

        _addNewAssetFolder: function (rootChildItems, treePaths) {
            // summary:
            //      Adds a new tree path to an asset folder if any exists in the specified rootChildItems.
            // rootChildItems:
            //      An array with content items that may contain asset folders.
            // treePaths:
            //      The tree paths that any new path will be added to.
            // tags:
            //      private

            rootChildItems.some(function (content) {
                var isAssetFolder = this._isAssetsFolder(content);
                if (isAssetFolder) {
                    treePaths.push([this.treeStoreModel.root, content]);
                }
                return isAssetFolder;
            }.bind(this));
        },

        setSearchText: function (searchText) {
            // summary:
            //      Updates the search results and commands.
            // searchText:
            //      The text the user is searching for.
            // tags:
            //      protected
            var isSearching = !!searchText;
            this.set("isSearching", isSearching);

            this._updateSearchListQuery(searchText);
            var selectedItems = isSearching ? null : this.get("selectedListItems") || this.get("selectedTreeItems");
            this._updateCommands(selectedItems);
        },

        onListItemUpdated: function (updatedItems) {
            // summary:
            //      Refresh the editing media if it have a new version
            // updatedItems: [Array]
            //      Collection of the updated item
            // tags:
            //      public, extension
        },

        _isSupportedContent: function (/*Object*/content) {
            // summary:
            //      Indicates whether the given content is a type contained by this widget.
            // content:
            //      Object to validate
            // tags:
            //      private
            return !!(content && content.id) && this.containedTypes.some(function (type) {
                return TypeDescriptorManager.isBaseTypeIdentifier(content.dataType, type);
            });
        },

        _showAllLanguagesSetter: function (value) {
            this.showAllLanguages = value;
            this._updateListQuery(this.selectedTreeItems);

            // If we are searching we need to re-run the query otherwise the search result will still contain content in other languages
            if (this.get("isSearching")) {
                var searchListQuery = this.get("searchListQuery");
                this._updateSearchListQuery(searchListQuery.queryText);

            }
            this.treeStoreModel.set("showAllLanguages", value);
        },

        setTreePaths: function (treePaths) {
            // summary:
            //      This is called whenever a user clicks in the components folder tree.
            // treePaths: Array[]
            //      An array of arrays containing a hierarchy of content items starting with the root
            //      and ending with the actual item being selected.
            // tags:
            //      public

            // We call the custom setter directly here instead of using this.set("treePaths") because we
            // don't want want to update any watchers. The tree in the component should already have the correct selection.
            if (!epi.areEqual(treePaths, this.get("treePaths"))) {
                this._treePathsSetter(treePaths);
            }
        },

        _treePathsSetter: function (value) {
            // summary:
            //      Stores the treePaths value and resets the list selection.
            //      Calling set("treePaths", value) should update the corresponding components tree selection.
            // value: Array[]
            //      An array of arrays containing a hierarchy of content items starting with the root
            //      and ending with the actual item being selected.
            // tags:
            //      protected

            this.treePaths = value;

            this._saveTreePaths(value);

            // By using this._changeAttrValue instead of this.set("selectedListItems", null) we will update any
            // watchers (IE update selection in list component) without forcing this model to update the commands
            // several times in a row.
            this._changeAttrValue("selectedListItems", null);

            var treePaths = lang.clone(value);
            // The last item in every treePath array is the item that is selected.
            // We grab the last item and store that as the selectedTreeItems property.
            var selectedItems = treePaths ? treePaths.map(function (path) {
                return path.pop();
            }) : null;

            this.set("selectedTreeItems", selectedItems);
        },

        _selectedTreeItemsSetter: function (value) {
            // summary:
            //      Updates the commands with the specified value and updates the list query.
            // value:
            //      The selected tree items.
            // tags:
            //      protected

            this.selectedTreeItems = value;

            this._updateListQuery(value);

            if (!this.get("isSearching")) {
                this._updateCommands(value);
            }
        },

        setSelectedListItems: function (selectedListItems) {
            // summary:
            //      This is called whenever a user clicks in the components content list.
            // selectedListItems:
            //      The items that is currently selected in the list.
            // tags:
            //      public

            // We call the custom setter directly here instead of using this.set("selectedListItems") because we
            // don't want want to update any watchers. The list in the component should already have the correct selection.
            this._selectedListItemsSetter(selectedListItems);
        },

        _selectedListItemsSetter: function (value) {
            // summary:
            //      Updates the commands with the specified value.
            //      Calling set("selectedTreeItems", value) should update the corresponding components list selection.
            // value:
            //      The selected list items.
            // tags:
            //      protected

            this.selectedListItems = value;

            if (!this.get("isSearching")) {
                this._updateCommands(value);
            }
        },

        setSelectedSearchResults: function (selectedSearchResults) {
            // summary:
            //      This is called whenever a user clicks in the components search results.
            // selectedSearchResults:
            //      The items that is currently selected in the search results.
            // tags:
            //      public

            // We call the custom setter directly here instead of using this.set("selectedSearchResults") because we
            // don't want want to update any watchers. The search results in the component should already have the correct selection.
            this._selectedSearchResultsSetter(selectedSearchResults);
        },

        _selectedSearchResultsSetter: function (value) {
            // summary:
            //      Updates the commands with the specified value.
            // value:
            //      The selected search results.
            // tags:
            //      protected

            this.selectedSearchResults = value;
            this._updateCommands(value);
        },

        updateTreeCommands: function () {
            // summary:
            //      Updates the commands with the currently selected tree items.
            // tags:
            //      public

            this._updateCommands(this.get("selectedTreeItems"));
        },

        updateListCommands: function () {
            // summary:
            //      Updates the commands with the currently selected list items.
            // tags:
            //      public

            this._updateCommands(this.get("selectedListItems"));
        },

        _setupSelection: function () {
            // summary:
            //      Get target tree item and list item for selection
            // tags:
            //      protected

            //if we have no roots, we should not select anything.
            if (!this.roots || !this.roots.length) {
                return null;
            }

            when(this.getCurrentContext(), function (ctx) {
                if (this._isSupportedContent(ctx)) {
                    this.contentContextChanged(ctx, null);
                    return;
                }
                when(this._loadTreePaths()).then(function (paths) {
                    if (!paths) {
                        paths = this._getDefaultTreePaths();
                    }

                    when(paths).then(function (paths) {
                        this.set("treePaths", paths);
                    }.bind(this));

                }.bind(this));
            }.bind(this));
        },

        _getDefaultTreePaths: function () {
            // summary:
            //      Gets a tree paths that contains the treeStoremodel root and the first root item.
            // tags:
            //      private

            if (!this.roots || !this.roots.length) {
                return [];
            }

            // TODO: Fix this hack of always using the first item in roots
            var rootId = ContentReference.toContentReference(this.roots[0]).toString();
            return this.store.get(rootId).then(function (model) {
                return [[this.treeStoreModel.root, model]];
            }.bind(this));
        },

        _setupTreeStoreModel: function () {
            // summary:
            //      Creates an configures the treeStoreModel.
            // tags:
            //      protected

            if (!this.treeStoreModelClass) {
                //Assign the default tree store model class if no custom one has been assigned.
                this.treeStoreModelClass = this.enableContextualContent ? ContextualContentForestStoreModel : ContentForestStoreModel;
            }

            var treeModel = this.treeStoreModel || new this.treeStoreModelClass({
                store: this.store,
                roots: this.roots,
                typeIdentifiers: this.mainNavigationTypes,
                containedTypes: this.containedTypes,
                notAllowToCopy: this.preventCopyingFor,
                notAllowToDelete: this.preventDeletionFor,
                notSupportContextualContents: this.preventContextualContentFor,
                autoSelectPastedItem: false,
                onAddDelegate: lang.hitch(this, function (node) {
                    var targetNode = registry.getEnclosingWidget(node.domNode),
                        target = targetNode && targetNode.item,
                        canExecute = (typeof (this.treeStoreModel.canEdit) === "function") && this.treeStoreModel.canEdit(target);

                    if (canExecute) {
                        node.edit();


                        // Publish the children change AFTER the user has change the name of the new folder or canceled the editor
                        // REMARK: We need to do this after the change otherwise the editing will be canceled because the children change replaced the child items in the tree
                        // TODO: This should be handled by the tree model
                        var publish = function () {
                            topic.publish("/epi/cms/contentdata/childrenchanged", target.parentLink);
                        };

                        var handle = node.on("rename", function () {
                            handle.remove();

                            publish();
                        });

                        var cancelHandle = node.on("cancelEdit", function () {
                            cancelHandle.remove();

                            publish();
                        });

                    }
                }),
                onRefreshRoots: lang.hitch(this, this._setupSearchRoots),
                onPasteItemsFailed: lang.hitch(this, this._pasteItemsFailed),
                additionalQueryOptions: {
                    sort: this._getSortSettings()
                },
                isInQuickEditMode: this.isInQuickEditMode,
                quickEditBlockId: this.quickEditBlockId
            });

            // The ContentTreeModel is a destroyable, so we need to own it and clean up when this model is destroyed
            this.own(treeModel, aspect.after(treeModel, "rename", this._afterRename.bind(this)));

            this.set("treeStoreModel", treeModel);
        },

        _afterRename: function (renamePromise) {
            // summary:
            //      Updates selectedTreeItems property when treeModel rename is executed.
            // tags:
            //      private

            return renamePromise.then(function (renamedItem) {
                // the item returned by rename method came from ContentDataStore
                // and selectedTreeItems expects data from ContentStore

                // we have to use refresh instead of get to make sure that we are using latest version from dependant store
                return this.store.refresh(renamedItem.contentLink)
                    .then(function (item) {
                        var selectedTreeItems = this.selectedTreeItems;
                        if (selectedTreeItems && selectedTreeItems.length === 1) {
                            if (selectedTreeItems[0].contentLink === item.contentLink) {
                                this.set("selectedTreeItems", [item]);
                            }
                        }
                    }.bind(this));
            }.bind(this));
        },

        _getSortSettings: function () {
            // summary:
            //      Returns the list of sort criteria.
            // tags:
            //      protected

            return [{ attribute: "name", descending: false }];
        },

        _setupSearchRoots: function () {
            // summary:
            //      Creates and configures the treeStoreModel.
            // tags:
            //      protected

            var roots = this.roots instanceof Array && this.roots.length > 0 ? lang.clone(this.roots) : [];
            when(this.getCurrentContent()).then(lang.hitch(this, function (content) {

                var assetsFolderLink = content && content.assetsFolderLink;
                if (assetsFolderLink && typeof this._getPseudoContextualContent === "function" && assetsFolderLink !== this._getPseudoContextualContent()) {
                    roots.push(assetsFolderLink);
                }
            })).always(lang.hitch(this, function () {
                this.set("searchRoots", roots.join(","));
            }));
        },

        _setupCommands: function () {
            // summary:
            //      Creates and registers the commands used.
            // tags:
            //      protected

            this._commandSpliter = this._commandSpliter || new Stateful({
                category: "menuWithSeparator"
            });

            var settings = {
                category: "context",
                model: this.treeStoreModel,
                selection: this.selection,
                clipboard: this.clipboardManager
            };

            this.createHierarchyCommands = {};
            var index = 1;

            // Create commands for the navigation types.
            array.forEach(this.mainNavigationTypes, function (type) {
                this.createHierarchyCommands[type] = {
                    command: new NewFolderCommand(lang.mixin({ typeIdentifier: type }, settings)),
                    order: index
                };
                index = index + 1;
            }, this);

            this.createCommands = this.getCreateCommands(index);

            var editableTypes = array.filter(this.containedTypes, function (item) {
                return this.mainNavigationTypes.indexOf(item) < 0;
            }, this);

            var commands = {
                rename: {
                    command: new RenameSelectedFolderCommand(settings),
                    order: 10
                },
                cut: {
                    command: new CutContentCommand(settings),
                    order: 20
                },
                copy: {
                    command: new CopyContentCommand(settings),
                    order: 30
                },
                paste: {
                    command: new PasteContentCommand(lang.mixin({
                        typeIdentifiers: this.mainNavigationTypes
                    }, settings)),
                    order: 40
                },
                edit: {
                    command: new ChangeContextToSelectionCommand(lang.mixin({
                        forceReload: true,
                        forceContextChange: true,
                        typeIdentifiers: editableTypes
                    }, settings)),
                    order: 3
                },
                quickEdit: {
                    command: new BlockInlineEditSelectedContent(settings),
                    order: 4
                },
                translate: {
                    command: new TranslateSelectedContentCommand(settings)
                },
                "delete": {
                    command: new DeleteContentCommand(settings),
                    order: Number.MAX_SAFE_INTEGER
                },
                trash: {
                    command: new ViewTrashCommand({ typeIdentifiers: this.mainNavigationTypes, order: 60 }),
                    order: 60
                }
            };

            this._commandRegistry = lang.mixin(this._commandRegistry, this.createHierarchyCommands, this.createCommands, {
                spliter: {
                    command: this._commandSpliter,
                    order: 10
                }
            }, commands);
            this.pseudoContextualCommands = this._getPseudoContextualCommands();
        },

        _setCommands: function () {
            // summary:
            //      Sets the commands from the hierarchical list plugin area and the command registry
            // tags:
            //      private

            var pluginCommands = [this._commandSpliter];
            assetsPanePluginArea.get().forEach(function (command) {
                command.category = "context";
                pluginCommands.push(command);
            });
            if (pluginCommands && pluginCommands.length > 0) {
                pluginCommands[pluginCommands.length - 1].category = "menuWithSeparator";
            }
            this._pluginCommands = pluginCommands;

            var commands = this._commandRegistry.toArray();
            this._pluginCommands.forEach(function (cmd) {
                commands.splice(commands.length - 2, 0, cmd);
            });
            this.set("commands", commands);
        },

        _pasteItemsFailed: function (ignoredItems) {
            // summary:
            //      Configures the items list based on the result of the paste operation.
            // tags:
            //      private

            this.set("selectedListItems", ignoredItems);
        },

        _updateListQuery: function (items) {
            // summary:
            //      Creates a new query and updates the listQuery property.
            // tags:
            //      protected

            var query = null;

            if (items && items.length > 0) {
                query = this._createListChildrenQuery(items);
                this.set("noDataMessage", items.length > 1 ? this.noDataMessages.multiple : this.noDataMessages.single);
            }

            this.set("listQuery", query);
        },

        _createListChildrenQuery: function (items) {
            // summary:
            //      Creates a new query .
            // tags:
            //      private

            // remove all mainNavigationTypes from containedTypes, to avoid of displaying Folder in Content List
            var contentTypes = array.filter(this.containedTypes, function (item) {
                return this.mainNavigationTypes.indexOf(item) < 0;
            }, this);

            var ids = items.map(function (item) {
                return item.contentLink.toString();
            });

            return { references: ids, query: "getpagedchildren", allLanguages: this.showAllLanguages, typeIdentifiers: contentTypes };
        },

        _updateSearchListQuery: function (searchText) {
            // summary:
            //      Creates a new query and updates the listQuery property.
            // tags:
            //      protected

            var query = null;

            if (searchText) {
                query = this._createListSearchQuery(searchText);
            }

            this.set("searchListQuery", query);
        },

        _createListSearchQuery: function (searchText) {
            return {
                queryText: searchText,
                query: "searchcontent",
                allLanguages: this.showAllLanguages,
                contentSearchAreas: this.get("searchArea"),
                searchRoots: this.get("searchRoots"),
                maxResults: 1000,
                filterDeleted: true
            };
        },

        _updateCommands: function (selectedItems) {
            // summary:
            //      Updates the current model for all commands needing this.
            // tags:
            //      protected

            if (epi.areEqual(this._commandItems, selectedItems)) {
                return;
            }
            this._commandItems = selectedItems;

            this._updateSelection(selectedItems);
            this._updateCommandModels(selectedItems);

            if (selectedItems && selectedItems.length === 1) {
                this.decoratePseudoContextualCommands(this.pseudoContextualCommands);
            }
        },

        _updateSelection: function (selectedItems) {
            // summary:
            //      Updates the selection manager to the selected items. Used when commands execute.
            // tags:
            //      protected

            var selectionData = selectedItems ? selectedItems.map(function (selectedItem) {
                return { type: "epi.cms.contentdata", data: selectedItem };
            }) : [];
            this.selection.set("data", selectionData);
        },

        _updateCommandModels: function (selectedItems) {
            // summary:
            //      Update model of create and plugin commands.
            // tags:
            //      protected

            var commands = this.createCommands;
            for (var key in commands) {
                commands[key].command.set("model", selectedItems);
            }

            this._pluginCommands.forEach(function (command) {
                command.set("model", selectedItems);
            });
        },

        _saveTreePaths: function (treePaths) {
            // summary:
            //      Saves the tree paths on the current profile.
            // treePaths:
            //      The tree paths that should be saved.
            // tags:
            //      private

            this._profile.set(this.componentId + "_treePaths", treePaths);
        },

        _loadTreePaths: function () {
            // summary:
            //      Loads any stored tree paths from the current profile.
            // returns: Promise
            //      The promise will resolve to a stored path if any exists.
            // tags:
            //      private

            return this._profile.get(this.componentId + "_treePaths");
        },

        _getPseudoContextualCommands: function () {
            // summary:
            //      Get commands to decorates
            // returns: [Array]
            //      Array of command object that each is instance of "epi.shell.command._Command" class
            // tags:
            //      private

            var key,
                commands = [];

            for (key in this.createCommands) {
                commands.push(this.createCommands[key].command);
            }

            for (key in this.createHierarchyCommands) {
                commands.push(this.createHierarchyCommands[key].command);
            }

            commands.push(this._commandRegistry.paste.command);

            return commands;
        },

        upload: function (fileList) {
            // summary:
            //      Implementation needs to overwrite this to process upload files action.
            // fileList:
            //      List files to upload.
            //      When null, only show upload form to select files for uploading.
            //      Otherwise, upload files in list.
            // tags:
            //      protected
        }

    });

});

},
'epi/shell/ClipboardManager':function(){
﻿define("epi/shell/ClipboardManager", ["dojo/_base/declare", "dojo/Stateful"], function (declare, Stateful) {

    return declare(Stateful, {
        // summary:
        //    The clipboard object that stores copy and cut data.
        // tags:
        //    internal

        copy: true,

        data: null,

        constructor: function () {
            this.data = [];
        },

        clear: function () {
            // summary:
            //    Clears the clipboard.
            // tags:
            //    public

            this.set("data", null);
        },

        isCopy: function () {
            // summary:
            //    Determines if the last action is copy or not.
            // tags:
            //    public

            return this.get("copy");
        },

        setDataObject: function (object, copy) {
            // summary:
            //    Set data object that is copied or cut to clipboard.
            // copy:
            //    Indicates the mode is copy or cut.
            // tags:
            //    public

            this.set("copy", copy);
            this.set("data", object);
        },

        getDataObject: function () {
            // summary:
            //    Get the data object from the clipboard.
            // tags:
            //    public

            return this.data;
        },

        containsData: function () {
            // summary:
            //    Determines if clipboard contains any data or not.
            // tags:
            //    public

            return !!this.data;
        }
    });

});

},
'epi/shell/selection':function(){
﻿define("epi/shell/selection", [
    "dojo/_base/declare",
    "./StatefulArray"
], function (
    declare,
    StatefulArray
) {
    return declare(StatefulArray, {
        // summary:
        //      A Stateful object for keeping track of currently selected items
        // tags:
        //      internal xproduct

        // data: []
        //      An array of currently selected items.
        data: null,

        constructor: function () {
            // summary:
            //      Initializes the selection with an empty array
            this.data = [];
        }
    });
});

},
'epi-cms/_MultilingualMixin':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/when",
    "dojo/_base/lang",

    // Epi
    "epi/dependency",
    "epi-cms/ApplicationSettings",
    "epi-cms/component/SiteTreeModel"
],

function (
// Dojo
    declare,
    Deferred,
    when,
    lang,

    // Epi
    dependency,
    ApplicationSettings,
    SiteTreeModel
) {

    return declare([], {
        // summary:
        //    A Mixin to check for Multilingual capability
        // tags:
        //    internal

        // isMultilingual: [readonly] Boolean
        //      Flag which indicates whether to support multi-languages
        isMultilingual: false,

        // _application: Object
        //      Instance of CMS application
        _application: null,

        // _siteTreeModel: Object
        //      Instance of SiteTreeModel
        _siteTreeModel: null,

        // _cachedValue: Object
        //      A cached value for the _isSiteMultilingualQuery
        _cachedValue: undefined,

        constructor: function (options) {
            // summary:
            //      Mixin properties of the object for injection later.
            // tags:
            //      protected

            lang.mixin(this, options);
        },

        _isSiteMultilingual: function () {
            // summary:
            //      Check whether current site allows multilingual
            // tags:
            //      protected
            var deferred = new Deferred();

            if (this._cachedValue !== undefined) {
                deferred.resolve(this._cachedValue);
                return deferred;
            }

            if (!this._siteTreeModel) {
                var registry = dependency.resolve("epi.storeregistry"),
                    siteStructureStore = registry.get("epi.cms.sitestructure");
                this._siteTreeModel = new SiteTreeModel({store: siteStructureStore});
            }

            when(this._siteTreeModel.getAllLanguagesForCurrentSite(), lang.hitch(this, function (items) {
                this._cachedValue = items.length >= 2;
                deferred.resolve(this._cachedValue);
            }));

            return deferred;
        },

        _contentExistsInCurrentLanguage: function (/*Object*/contentItem) {
            // summary:
            //      Check if the language branch for the current content differs from the current content language for the application.
            // contentItem:
            //      Content item.
            // tags:
            //      protected

            if (!contentItem) {
                return false;
            }

            //If the content does not support languages then the content exists for the current language
            if (contentItem.capabilities && !contentItem.capabilities.language) {
                return true;
            }

            if (!contentItem.currentLanguageBranch) {
                return false;
            }

            return ApplicationSettings.currentContentLanguage === contentItem.currentLanguageBranch.languageId;
        }
    });
});

},
'epi-cms/widget/CreateCommandsMixin':function(){
﻿define([
    //dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    //epi
    "epi/dependency",
    //epi-cms
    "../command/PopupCommand",
    "../command/NewContent",
    //resources
    "epi/i18n!epi/nls/episerver.shared"
],

function (
    //dojo
    array,
    declare,
    lang,
    //epi
    dependency,
    //epi-cms
    PopupCommand,
    NewContent,
    //resources
    sharedResources
) {
    return declare([], {
        // tags:
        //      internal xproduct

        contentRepositoryDescriptors: null,

        typeDescriptorManager: null,

        createCommandClass: NewContent,

        repositoryKey: null,

        category: null,

        isAvailableFlags: null,

        postscript: function () {
            this.inherited(arguments);
            if (!this.repositoryKey) {
                throw "You need to specify the repositoryKey field";
            }

            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
            declare.safeMixin(this, this.contentRepositoryDescriptors.get(this.repositoryKey));

            this.commandCategory = this.commandCategory || "context";

            //TODO: This should be specified elsewhere, its now duplicated from hierarchicallistviewmodel
            var menuType = { ROOT: 1, TREE: 2, LIST: 4 };

            this.isAvailableFlags = this.isAvailableFlags || menuType.ROOT | menuType.TREE;
        },

        getCreateCommands: function (index) {
            var createCommands = {};
            var commandIndex = index || 1;
            if (!this.creatableTypes) {
                return createCommands;
            }
            // Create commands for the types to create.
            array.forEach(this.creatableTypes, function (type) {
                createCommands[type] = {
                    command: this._createCommand(type),
                    isAvailable: this.isAvailableFlags,
                    order: commandIndex
                };
                commandIndex = commandIndex + 1;
            }, this);

            if (this.creatableTypes.length < 2) {
                return createCommands;
            }

            var popupCommand = new PopupCommand({
                label: sharedResources.action["new"],
                commands: createCommands
            });

            return {
                popupCommand: {
                    command: popupCommand,
                    order: index
                }
            };
        },

        _createCommand: function (type) {
            return new this.createCommandClass({
                contentType: type,
                category: this.commandCategory
            });
        }

    });
});

},
'epi-cms/command/PopupCommand':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "epi/shell/command/_Command",
    "epi/shell/command/_CommandProviderMixin",
    "epi/shell/widget/ContextMenu"
], function (
    array,
    declare,
    Stateful,
    _Command,
    _CommandProviderMixin,
    ContextMenu
) {
    return declare([_Command, _CommandProviderMixin], {
        // tags:
        //      public

        category: "popup",

        canExecute: true,

        popup: null,

        popupClass: ContextMenu,

        popupCategory: "context",

        _commandsSetter: function (value) {
            if (!value) {
                return;
            }

            var commands = [];
            if (value instanceof Array) {
                commands = value;
            } else {
                for (var index in value) {
                    commands.push(value[index].command);
                }
            }

            this.commands = commands;

            this._updateIsAvailable();
        },

        _popupSetter: function (popup) {
            this.popup = popup;

            popup.addProvider(this);
        },

        _updateIsAvailable: function () {
            var isAvailable = array.some(this.get("commands"), function (command) {
                return command.get("isAvailable");
            });
            this.set("isAvailable", isAvailable);
        },

        _onModelChange: function () {
            //set the model on the contained commands
            this.updateCommandModel(this.model);
            this._updateIsAvailable();
        }
    });
});

},
'epi-cms/command/NewContent':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/topic",
    "dojo/when",
    "dojo/promise/all",

    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/contentediting/ContentActionSupport"
],

function (
    array,
    declare,
    lang,
    Deferred,
    topic,
    when,
    all,

    dependency,
    _Command,
    TypeDescriptorManager,
    ContentActionSupport
) {

    return declare([_Command], {
        // summary:
        //      A command that starts the create new content process when executed.
        //
        // tags:
        //      public

        // contentType: [public] String
        //      The type of the content that the create content view should display.
        contentType: null,

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        postscript: function () {
            this.inherited(arguments);

            var identifier = this.contentType;

            this.label = this.label || TypeDescriptorManager.getResourceValue(identifier, "create");
            this.tooltip = this.tooltip || TypeDescriptorManager.getResourceValue(identifier, "createdescription");
            this.iconClass = this.iconClass || TypeDescriptorManager.getValue(identifier, "commandIconClass");

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.contenttype");
            }
        },

        _execute: function () {
            // summary:
            //      Executes this command; publishes a change view request to change to the create content view.
            // tags:
            //      protected

            topic.publish("/epi/shell/action/changeview", "epi-cms/contentediting/CreateContent", null, {
                requestedType: this.contentType,
                parent: this.model,
                createAsLocalAsset: this.createAsLocalAsset,
                view: TypeDescriptorManager.getValue(this.contentType, "createView")
            });
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            // the model can be an array of content, cause we can cut, copy or delete multiple items.
            // but creating new content accepts one content only, so we just get the first data if the input model is an array.
            if (this.model && this.model instanceof Array) {
                if (this.model.length === 1) {
                    this.model = this.model[0];
                } else { // model is an array that has more than one item, or empty.
                    this.model = null;
                }
            }

            this.set("canExecute", this._canExecute());

            var model = this.model;
            if (!model) {
                this.set("isAvailable", false);
                return;
            }

            when(this._getContentType(model), lang.hitch(this, function (contentType) {

                if (!contentType) {
                    this.set("isAvailable", false);
                    return;
                }

                when(this._checkAvailability(contentType.availableContentTypes), lang.hitch(this, function (isAvailable) {
                    this.set("isAvailable", isAvailable);
                }));
            }));
        },

        _canExecute: function () {
            // summary:
            //      Determines if the command can be executed
            // returns: Boolean
            //      True if the command can executed
            //      False if the command can't be executed
            // tags:
            //      protected virtual
            var model = this.model,
                createAction = ContentActionSupport.action.Create,
                createProviderCapability = ContentActionSupport.providerCapabilities.Create,
                canExecute = model && !(model.isWastebasket || model.isDeleted) &&  // Ensure a model is available and it isn't deleted
                    ContentActionSupport.hasLanguageAccess(model) &&  // Ensure the user has access in the current language.
                    ContentActionSupport.isActionAvailable(model, createAction, createProviderCapability, true);  // Ensure the action is available to the user.

            return !!canExecute;
        },

        _getContentType: function (model) {
            // summary:
            //      Query for available content types based on the type.
            // tags:
            //      private

            if (!model) {
                return null;
            }

            return this.store.get(model.contentTypeID);
        },

        _checkAvailability: function (availableContentTypes) {

            if (availableContentTypes.length === 0) {
                return false;
            }

            var deferred = new Deferred();

            var getRequests = array.map(availableContentTypes, lang.hitch(this, function (contentTypeID) {
                return this.store.get(contentTypeID);
            }));

            when(all(getRequests), lang.hitch(this, function (contentTypes) {
                var isAvailable = array.some(contentTypes, lang.hitch(this, function (contentType) {
                    return TypeDescriptorManager.isBaseTypeIdentifier(contentType.typeIdentifier, this.contentType);
                }));
                deferred.resolve(isAvailable);
            }));

            return deferred;
        }

    });

});

},
'epi-cms/command/CopyContent':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "epi",
    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin"
], function (declare, array, epi, _Command, _ClipboardCommandMixin, _SelectionCommandMixin) {

    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {
        // summary:
        //      A command that starts the create new content process when executed.
        //
        // tags:
        //      public

        // label: [readonly] String
        //		The action text of the command to be used in visual elements.
        label: epi.resources.action.copy,

        // iconClass: [readonly] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconCopy",

        _execute: function () {
            // summary:
            //		Copies the currently selected items to the clipboard and sets the clipboard copy flag.
            // tags:
            //		protected

            this.clipboard.set("copy", true);
            this.clipboard.set("data", this.selection.data.concat());
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,
                selection = this.selection.data,
                canExecute = false;

            if (model && selection.length) {
                canExecute = array.every(selection, function (item) {
                    return model.canCopy(item.data);
                });
            }

            this.set("canExecute", canExecute);
        }
    });
});

},
'epi-cms/command/CutContent':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "epi",
    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin"
], function (array, declare, epi, _Command, _ClipboardCommandMixin, _SelectionCommandMixin) {

    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {
        // summary:
        //      Copies the currently selected items to the clipboard.
        //
        // tags:
        //      public

        // label: [readonly] String
        //		The action text of the command to be used in visual elements.
        label: epi.resources.action.cut,

        // iconClass: [readonly] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconCut",

        _execute: function () {
            // summary:
            //		Copies the selection to the clipboard.
            // tags:
            //		protected

            this.clipboard.set("copy", false);
            this.clipboard.set("data", this.selection.data.concat());
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,
                selection = this.selection.data,
                canExecute = false;

            if (model && selection.length) {
                canExecute = array.every(selection, function (item) {
                    return model.canCut(item.data);
                });
            }

            this.set("canExecute", canExecute);
        }
    });
});

},
'epi-cms/command/DeleteContent':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/topic",
    "dojo/when",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/ContentActionSupport",

    // Parent class and mixins
    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin",

    // Localization
    "epi/i18n!epi/cms/nls/episerver.cms.command",
    "epi/i18n!epi/nls/episerver.shared"
], function (
    declare,
    lang,
    promiseAll,
    topic,
    when,
    ApplicationSettings,
    ContentActionSupport,
    _Command,
    _ClipboardCommandMixin,
    _SelectionCommandMixin,
    resources,
    sharedResources
) {

    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {
        // summary:
        //      This command deletes the content in the selection. The actual operation that is executed depends on whether the selected content has a wastebasket. If the
        //      content has a wastebasket then a move operation is performed with the wastebasket as destination, otherwise if the content doesn't have a wastebasket then
        //      it will be removed permanently.
        //
        // tags:
        //      public

        // label: [readonly] String
        //      The action text of the command to be used in visual elements.
        label: resources.movetotrash,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconTrash",

        // hasWastebasket: [readonly] Boolean
        //      Flag indicating whether the provider of current content has a wastebasket. This is set internally on model change.
        hasWastebasket: true,

        _execute: function () {
            // summary:
            //      Executes the move or remove method on the model depending on whether the wastebasket is supported. Also clears the clipboard
            //      if it contains one of the deleted items.
            // tags:
            //      protected

            var model = this.model,
                clipboard = this.clipboard,
                selection = this.selection.data,
                operation = this.hasWastebasket ? model.move(selection, { contentLink: ApplicationSettings.wastebasketPage, isWastebasket: true }) : model.remove(selection);

            return when(operation, lang.hitch(this, function () {
                var promises = [];

                // Check to see if any of the items that were removed are in the clipboard or are ancestors of items in the clipboard.
                if (clipboard && clipboard.data) {
                    selection.forEach(function (selectionItem) {
                        var map = clipboard.data.map(function (clipboardItem) {
                            return model.isAncestor(selectionItem.data, clipboardItem.data);
                        });

                        promises = promises.concat(map);
                    });
                }

                when(promiseAll(promises), function (results) {
                    var containedInClipboard = results.every(function (result) {
                        return result;
                    });

                    if (containedInClipboard) {
                        clipboard.clear();
                    }

                    var deletedContentLinks = selection.map(function (item) {
                        return item.data.contentLink;
                    });
                    topic.publish("/epi/cms/action/delete/result", deletedContentLinks);
                });
            }), lang.hitch(this, function () {
                topic.publish("/epi/cms/action/delete/error");
            }));
        },

        _hasWastebasketSetter: function (hasWastebasket) {
            // summary:
            //      Sets the hasWastebasket property as well as updating the label and iconClass properties to
            //      reflect the available action.
            // tags:
            //      protected
            this.hasWastebasket = hasWastebasket;

            this.set("iconClass", hasWastebasket ? "epi-iconTrash" : "epi-iconClose");
            this.set("label", hasWastebasket ? resources.movetotrash : sharedResources.action.deletelabel);
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected
            var model = this.model,
                selection = this.selection.data,
                canDelete = function (item) {
                    var content = item.data;
                    return content && !content.isDeleted && model.canDelete(content);
                },
                supportsWastebasket = function (item) {
                    var content = item.data;
                    return content && ContentActionSupport.hasProviderCapability(content.providerCapabilityMask, ContentActionSupport.providerCapabilities.Wastebasket);
                };

            // hasWastebasket is true when the selection is not empty and each item has a content provider which supports the wastebasket.
            this.set("hasWastebasket", !!selection.length && selection.every(supportsWastebasket));

            // canExecute is true when a model is set, the selection is not empty, and each item can be deleted, and all the selected items either support wastebasket or don't support wastebasket.
            this.set("canExecute", !!(model && selection.length) && selection.every(canDelete) && (this.hasWastebasket || !selection.some(supportsWastebasket)));
        }
    });
});

},
'epi-cms/command/PasteContent':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
    // epi
    "epi",

    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/shell/TypeDescriptorManager"
],

function (
// dojo
    array,
    declare,
    lang,
    promiseAll,
    when,
    // epi
    epi,

    _Command,
    _ClipboardCommandMixin,
    _SelectionCommandMixin,
    TypeDescriptorManager
) {

    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {
        // summary:
        //      A command that pastes whats in the clip board onto the current selection.
        // tags:
        //      public

        // label: [readonly] String
        //      The action text of the command to be used in visual elements.
        label: epi.resources.action.paste,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPaste",

        // typeIdentifiers: [public] Array
        //      If set, the paste target must inherit from any of the defined type identifiers for the command to be available.
        typeIdentifiers: null,

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        _execute: function () {
            // summary:
            //      Executes this command; publishes a change view request to change to the create content view.
            // tags:
            //      protected

            var source = this.get("clipboardData"),
                target = this._getSingleSelectionData();

            this.model.set("createAsLocalAsset", this.createAsLocalAsset);

            if (this.clipboard.copy) {
                return this.model.copy(source, target);
            } else {
                return when(this.model.move(source, target), lang.hitch(this, function () {
                    // Clear clipboard after successfully moving
                    this.clipboard.clear();
                }));
            }
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            var self = this,
                model = self.model,
                source = self.get("clipboardData"),
                target = self._getSingleSelectionData();

            // Set to false by default in case there are any timing delays in the deferred.
            self.set("canExecute", false);

            var isAvailable = !!target && this._isTargetOfCorrectType(target);

            this.set("isAvailable", isAvailable);

            if (model && source && source.length && target) {
                var deferreds = array.map(source, function (item) {
                    return model.canPaste(item.data, target, self.clipboard.copy);
                });

                when(promiseAll(deferreds), function (results) {
                    var canExecute = array.every(results, function (result) {
                        return result;
                    });

                    if (self.clipboard.copy) {
                        self.set("canExecute", canExecute);
                        return;
                    }

                    // Check to make sure the target is not a descendant of the source.
                    model.getAncestors(target, function (ancestors) {
                        var isDescendant = array.some(source, function (item) {
                            return array.indexOf(ancestors, item.data) >= 0;
                        });
                        self.set("canExecute", canExecute && !isDescendant);
                    });
                });
            }
        },

        _isTargetOfCorrectType: function (target) {
            // summary:
            //      If this.typeIdentifiers is defined we will check if the target is of correct type,
            //      otherwise we will always return true.
            // tags:
            //      private

            if (!this.typeIdentifiers) {
                return true;
            }
            return this.typeIdentifiers.some(function (type) {
                return TypeDescriptorManager.isBaseTypeIdentifier(target ? target.typeIdentifier : "", type);
            }, this);
        }

    });

});

},
'epi-cms/component/command/ViewTrash':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",
    "epi/dependency",
    "epi-cms/ApplicationSettings",
    // Parent class
    "epi/shell/command/_Command",
    // Resource
    "epi/i18n!epi/cms/nls/episerver.cms.command"
], function (
    declare,
    lang,
    topic,
    when,
    dependency,
    ApplicationSettings,
    // Parent class
    _Command,
    // Resource
    resources
) {

    return declare([_Command], {
        // summary:
        //      A command that opens the trash.
        // tags:
        //      internal

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: resources.viewtrash,

        // category: [readonly] String
        //		A category which provides a hint about how the command could be displayed.
        category: "setting",

        // typeIdentifiers: [public] Array
        //      An array of type identifiers that indicates which types should be displayed in the trash.
        typeIdentifiers: null,

        postscript: function () {
            this.inherited(arguments);

            var store = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.content.light"),
                request = store.get(ApplicationSettings.wastebasketPage.toString());

            // Get the wastebasket page in order to determine whether the use has READ access. If the user
            // does not have access then the response will have a 403 status code.
            when(request, lang.hitch(this, function (response) {
                this.set("canExecute", response.statusCode !== 403);
            }));
        },

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the view trash view.
            // tags:
            //		protected
            topic.publish("/epi/shell/context/request",
                { uri: "epi.cms.contentdata:///" + ApplicationSettings.wastebasketPage },
                { sender: this, typeIdentifiers: this.typeIdentifiers, hideLoader: true});
        }
    });
});

},
'epi-cms/asset/command/ChangeContextToSelection':function(){
define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/shell/TypeDescriptorManager",
    "epi/i18n!epi/cms/nls/episerver.shared.action"
], function (
    declare,
    topic,
    ContentActionSupport,
    _Command,
    _SelectionCommandMixin,
    TypeDescriptorManager,
    actionStrings) {

    return declare([_Command, _SelectionCommandMixin], {
        // summary:
        //      A command that issues a request to change the context to the model.
        //
        // tags:
        //      public

        // contentActionSupport: [public] object
        contentActionSupport: null,

        // forceContextChange: [protected] boolean
        //      Force reload context if current contentLink are the same contentLink.
        forceContextChange: false,

        // forceReload: [protected] boolean
        //      Force reload unconditionally
        forceReload: false,

        // viewType: [public] String
        //      Optional parameter if there is a specific view type that should be requested
        viewType: null,

        // viewName: [public] String
        //      Optional parameter if there is a specific view name that should be requested
        viewName: null,

        // typeIdentifiers: [public] Array
        //      Optional parameter if only specific type identifiers should be allowed to change context to.
        typeIdentifiers: null,

        postscript: function () {
            this.inherited(arguments);
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
        },

        _execute: function () {
            // summary:
            //		Executes this command; publishes a context change request to change to the model item.
            // tags:
            //		protected
            var target = this._getSingleSelectionData();
            topic.publish("/epi/shell/context/request", { uri: target.uri }, {
                sender: null,
                forceReload: this.forceReload,
                forceContextChange: this.forceContextChange,
                viewType: this.viewType,
                viewName: this.viewName
            });
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            // In case when input model is an array. Can excute command only when array model have only 1 item
            // Command is not support for multiple items.

            var target = this._getSingleSelectionData();
            if (!target) {
                this.set("canExecute", false);
                this.set("isAvailable", false);
                return;
            }

            var hasReadAccess = this.contentActionSupport.hasAccess(target.accessMask, this.contentActionSupport.accessLevel.Read);
            var isAvailable = this._isTargetOfCorrectType(target);

            this.set("isAvailable", isAvailable);
            this.set("canExecute", isAvailable && hasReadAccess);

            if (this.contentActionSupport.hasAccess(target.accessMask, this.contentActionSupport.accessLevel.Edit)) {
                this.set("label", actionStrings.edit);
                this.set("iconClass", "epi-iconPen");
            } else {
                this.set("label", actionStrings.view);
                this.set("iconClass", "");
            }
        },

        _isTargetOfCorrectType: function (target) {
            // summary:
            //      If this.typeIdentifiers is defined we will check if the model is of correct type,
            //      otherwise we will always return true.
            // tags:
            //      private

            if (!this.typeIdentifiers) {
                return true;
            }
            return this.typeIdentifiers.some(function (type) {
                return TypeDescriptorManager.isBaseTypeIdentifier(target.typeIdentifier, type);
            }, this);
        }
    });
});

},
'epi-cms/asset/command/NewFolder':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/topic",

    "dojo/when",
    // epi
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport"
],

function (
// dojo)
    array,
    declare,
    lang,

    topic,

    when,
    // epi
    _Command,
    _SelectionCommandMixin,
    TypeDescriptorManager,

    ContentReference,

    ContentActionSupport
) {

    return declare([_Command, _SelectionCommandMixin], {
        // summary:
        //      A command that creates a new folder under the current selection.
        // tags:
        //      internal

        iconClass: "epi-iconFolderPlus",

        // typeIdentifier: [public] String
        //      The identifier for the type to be created.
        typeIdentifier: null,

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        // _defaultName: [private] String
        //      Manages settings for different content classes like css class for the item types.
        _defaultName: null,

        postscript: function () {
            this.inherited(arguments);

            var identifier = this.typeIdentifier;

            this._defaultName = TypeDescriptorManager.getResourceValue(identifier, "newitemdefaultname");

            var translatedLabel = TypeDescriptorManager.getResourceValue(identifier, "create");
            this.set("label", translatedLabel);
            this.set("tooltip", translatedLabel);
        },

        _execute: function () {
            // summary:
            //      Executes this command; publishes a context change request to change to the model item.
            // tags:
            //      protected

            var self = this,
                parentItem = self._getSingleSelectionData(),
                parentLink = (new ContentReference(parentItem.contentLink)).createVersionUnspecificReference().toString(),
                createAsLocalAsset = self.createAsLocalAsset;

            var addNewFolder = function (parentItem) {
                self.model.getChildren(parentItem, function (childs) {
                    // Add new folder
                    when(self.model.add({
                        parentLink: parentLink,
                        name: self._getUniqueFolderName(childs, self._defaultName),
                        contentTypeIdentifier: self.typeIdentifier,
                        createAsLocalAsset: createAsLocalAsset
                    }, self.onRefreshSelection), function (newItem) {

                        // REMARK: This is not a very good place to do this, but when we can't rely on the
                        // store notfications for the contextual content we need to do this
                        // If the item got a new parent, publish the local asset created topic
                        if (newItem.parentLink !== parentLink) {
                            topic.publish("/epi/cms/action/createlocalasset");
                        }

                        topic.publish("/epi/cms/action/newfolder", newItem);
                    });
                });
            };

            if (createAsLocalAsset) {
                when(self.model.store.refresh(parentLink), function (parentItem) {
                    when(self.model.store.get(parentItem.assetsFolderLink), addNewFolder);
                });
            } else {
                addNewFolder(parentItem);
            }
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            var target = this._getSingleSelectionData(),
                createAction = ContentActionSupport.action.Create,
                createProviderCapability = ContentActionSupport.providerCapabilities.Create,
                canExecute = !!this.model &&  // Ensure that there is a model available.
                             !!target &&  // Ensure there is something selected.
                             ContentActionSupport.isActionAvailable(target, createAction, createProviderCapability, true),  // Ensure the action is available to the user.
                isRoot = target && !target.parentLink, // ensure it's OK to create folders under root
                isAvailable = canExecute &&
                    (TypeDescriptorManager.isBaseTypeIdentifier(target.typeIdentifier, this.typeIdentifier) || isRoot);
            this.set("isAvailable", isAvailable);
            this.set("canExecute", canExecute);
        },

        _getUniqueFolderName: function (arr, defaultName) {
            // summary:
            //      Return the unique folder name for create
            // arr: [Array]
            //      List of object
            // defaultName: [String]
            //      The default folder name
            // tags:
            //      private

            var constructName = function (times) {
                var name = times > 0 ? lang.replace(defaultName + " {0}", [times]) : defaultName;
                if (times > 1000) {
                    return name;
                }

                // Check exists with the name
                var isExisted = array.some(arr, function (child) {
                    return lang.trim(child.name).toLowerCase() === lang.trim(name).toLowerCase();
                });

                // If there are any the same name, call recursive
                if (isExisted) {
                    times = times + 1;
                    return constructName(times);
                }

                return name;
            };

            // Return unique folder name get
            return constructName(0);
        }

    });

});

},
'epi-cms/asset/command/RenameSelectedFolder':function(){
﻿define([
    "dojo/_base/declare",
    "epi",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/shell/TypeDescriptorManager"
],

function (
    declare,
    epi,
    ContentActionSupport,
    _Command,
    _SelectionCommandMixin,
    TypeDescriptorManager
) {

    return declare([_Command, _SelectionCommandMixin], {
        // summary:
        //      A command that causes the model to switch to an edit mode.
        //
        // tags:
        //      public

        label: epi.resources.action.rename,

        contentActionSupport: null,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconRename",

        renameDelegate: null,

        typeIdentifier: "episerver.core.contentfolder",

        postscript: function () {
            this.inherited(arguments);

            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
        },

        _execute: function () {
            // summary:
            //      Executes this command; publishes a context change request to change to the selected item.
            // tags:
            //      protected

            this.renameDelegate(this._getSingleSelectionData());
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            var target = this._getSingleSelectionData();
            // The model is the folder tree node, which has a label widget for editing the name.
            var isAvailable = !!target && TypeDescriptorManager.isBaseTypeIdentifier(target.typeIdentifier, this.typeIdentifier)
                    && !((this.model.isContextualContent && this.model.isContextualContent(target))
                        || this.model.isRoot(target.contentLink));

            var canExecute = isAvailable &&
                    this.renameDelegate &&
                    this.contentActionSupport.hasAccess(target.accessMask, ContentActionSupport.accessLevel[ContentActionSupport.action.Edit]);

            this.set("isAvailable", isAvailable);
            this.set("canExecute", canExecute);
        }
    });
});

},
'epi-cms/asset/command/TranslateSelectedContent':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.translate",
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin"
], function (declare, topic, resources, _Command, _SelectionCommandMixin) {

    return declare([_Command, _SelectionCommandMixin], {
        // tags:
        //      internal xproduct

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resources.label,

        // executingLabel: [public] String
        //      The action text of the command when executing to be used in visual elements.
        executingLabel: resources.executinglabel,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: resources.title,

        // category: [const] String
        //      A category which provides a hint about how the command could be displayed.
        category: "context",

        _execute: function () {
            // summary:
            //      Publishes a change view request to change to the create language branch view.
            // tags:
            //      protected

            var model = this._getNormalizedModel();
            var data = {
                contentData: model.content,
                languageBranch: model.language.preferredLanguage
            };

            topic.publish("/epi/shell/action/changeview", "epi-cms/contentediting/CreateLanguageBranch", null, data);
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected
            var model = this._getNormalizedModel(),
                language = model && model.language, // Null if multiple languages are not supported by the content provider on the server.
                isDeleted = model && model.content.isDeleted,
                isAvailable = language && language.isTranslationNeeded && !isDeleted,
                canExecute = isAvailable && language.hasTranslationAccess && language.isPreferredLanguageAvailable;

            if (model && typeof model.content.canTranslateContent === "function") {
                // Check if the model allows the current content to be translated.
                var canTranslate = model.content.canTranslateContent();

                isAvailable = isAvailable && canTranslate;
                canExecute = canExecute && canTranslate;
            }

            // Command is available if there is a translation needed.
            this.set("isAvailable", !!isAvailable);

            // Command is executable if the current user has sufficient privilege to translate and
            // that the preferred language is configured to be available for the current content.
            this.set("canExecute", !!canExecute);
        },

        _getNormalizedModel: function () {
            // summary:
            //      Gets a normalized model in order to handle the different possible inputs.
            // tags:
            //      private
            var model = this._getSingleSelectionData();
            if (model) {
                return {
                    content: model.contentData || model,
                    language: model.languageContext || model.missingLanguageBranch
                };
            }
        }
    });

});

},
'epi-cms/contentediting/command/BlockInlineEditSelectedContent':function(){
define([
    "dojo/_base/declare",
    "./BlockInlineEdit",
    "epi/shell/command/_SelectionCommandMixin"
],

function (
    declare,
    BlockInlineEdit,
    _SelectionCommandMixin
) {
    return declare([BlockInlineEdit, _SelectionCommandMixin], {
        _execute: function () {
            this.model = this._getSingleSelectionData();
            this.inherited(arguments);
        },
        _onModelChange: function () {
            this.model = this._getSingleSelectionData();
            this.inherited(arguments);
        }
    });
});

},
'epi-cms/contentediting/command/BlockInlineEdit':function(){
define([
    "dojo/_base/declare",
    "dojo/on",
    "dojo/topic",
    "dojo/when",

    "dojox/html/entities",

    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/DestroyableByKey",

    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/command/_Command",

    "epi-cms/contentediting/DialogPositionAdjust",
    "epi-cms/contentediting/inline-editing/InlineEditBlockDialog",
    "epi-cms/contentediting/inline-editing/BlockEditFormContainer",
    "epi-cms/contentediting/command/BlockInlinePublish",
    "epi-cms/contentediting/command/BlockInlineReadyForReview",
    "epi-cms/contentediting/command/BlockInlineReadyToPublish",
    "epi-cms/contentediting/EditNotifications",
    "epi-cms/contentediting/NotificationBar",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.inlineediting",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.requestapproval"
], function (
    declare,
    on,
    topic,
    when,

    htmlEntities,

    dependency,
    TypeDescriptorManager,
    DestroyableByKey,

    ContentReference,
    ContentActionSupport,
    _Command,

    DialogPositionAdjust,
    InlineEditBlockDialog,
    BlockEditFormContainer,
    InlinePublish,
    InlineReadyForReview,
    InlineReadyToPublish,
    EditNotifications,
    NotificationBar,

    resources,
    toolbarButtonsRes,
    requestapprovalRes
) {

    return declare([_Command, DestroyableByKey], {
        // summary:
        //      Inline-edit command for the Block component
        // tags:
        //      internal xproduct

        label: resources.inlineblockedit,

        iconClass: "epi-iconPenQuick",

        _dialog: null,

        // suppressOverlayAdjustments: [public] Boolean
        //      Flag which indicates that all overlay adjustments should not be performed. It might be useful when showing another overlay or dialog (e.g. TinyMCE full screen)
        suppressOverlayAdjustments: false,

        // summary:
        //      List of statuses, of which content cannot be edit
        ignoredEditStatuses: [
            ContentActionSupport.versionStatus.CheckedIn,
            ContentActionSupport.versionStatus.PreviouslyPublished,
            ContentActionSupport.versionStatus.DelayedPublish,
            ContentActionSupport.versionStatus.AwaitingApproval
        ],

        postscript: function () {
            this.inherited(arguments);

            this._dialogPositionAdjust = new DialogPositionAdjust();
            this.own(this._dialogPositionAdjust);

            this._enhancedStore = dependency.resolve("epi.storeregistry").get("epi.cms.latestcontentversion");
            this.own(topic.subscribe("/epi/cms/content/statuschange/", function (status, contentIdentity) {
                if (!this.model || !this.model.contentLink) {
                    return;
                }
                var updatedContentId = new ContentReference(contentIdentity.id).createVersionUnspecificReference();
                var currentModelId = new ContentReference(this.model.contentLink).createVersionUnspecificReference();
                if (ContentReference.compareIgnoreVersion(updatedContentId, currentModelId)) {
                    this._enhancedStore.query(currentModelId.toString()).then(function (contentData) {
                        this._refreshContentSettings(contentData);
                    }.bind(this));
                }
            }.bind(this)));
        },

        _execute: function () {
            // summary:
            //    Open the inline edit block dialog
            // tags:
            //      protected

            var dialog = this._dialog = new InlineEditBlockDialog({
                title: htmlEntities.encode(this.model.name),
                mainCommand: this.mainCommand,
                suppressOverlayAdjustments: this.suppressOverlayAdjustments
            });

            var _this = this;
            var form;

            function updateMainCommandVisibility() {
                if (!dialog) {
                    return;
                }
                // the mainButton is always visible
                dialog.toggleMainButton(true);
                dialog.toggleDisabledMainButton(!(_this.mainCommand.get("canExecute") || form.get("isDirty")));
                dialog.toggleDisabledSaveButton(!form.get("isDirty"));
            }

            var isAvailableHandle = this.mainCommand.watch("isAvailable", updateMainCommandVisibility.bind(this));
            var canExecuteHandle = this.mainCommand.watch("canExecute", updateMainCommandVisibility.bind(this));

            form = new BlockEditFormContainer({}, dialog.content, "last");
            form.set("contentLink", this.model.contentLink).then(function (formContentData) {
                this.mainCommand.set("model", this.model);

                // manually trigger the _onModelChange in order to fetch contentdata from store and calculate if the mainCommand should be available or not.
                this.mainCommand._onModelChange();

                updateMainCommandVisibility();
                _this.set("isPartOfActiveApproval", formContentData.isPartOfActiveApproval);
            }.bind(this));

            var formCreatedHandle = on(form, "FormCreated", function () {
                if (form.model && !form._model.canChangeContent()) {
                    dialog.hideSaveButton();
                    dialog.set("closeText", "Close");
                }

                dialog.show();
                updateMainCommandVisibility();
                this._createNotificationsBar(dialog, form);
            }.bind(this));

            var _mainCommand = this.mainCommand;
            var onChangeHandle = on(form, "isDirty", updateMainCommandVisibility.bind(form));
            var executeHandle = on(dialog, "execute", form.saveForm.bind(form));
            var mainCommandHandle = on(dialog, "MainCommand", function () {
                if (!this.validate()) {
                    return;
                }
                _mainCommand.tryToSaveAndExecute(form).then(function () {
                    dialog.hide();
                });
            });

            var closeHandle = on(dialog, "hide", function () {
                this._dialogPositionAdjust.cleanup();
                form.destroy();
                this.mainCommand.destroy();
                executeHandle.remove();
                closeHandle.remove();
                formCreatedHandle.remove();
                onChangeHandle.remove();
                mainCommandHandle.remove();
                isAvailableHandle.remove();
                canExecuteHandle.remove();
                this._dialog = null;
            }.bind(this));

            this._dialogPositionAdjust.adjustDialogPosition(dialog);
        },

        _createNotificationsBar: function (dialog, form) {
            var dialogContentEl = document.createElement("div");
            dialog.containerNode.prepend(dialogContentEl);

            var notificationBar = new NotificationBar();
            dialog.own(notificationBar);
            notificationBar.placeAt(dialogContentEl);

            var editNotifications = new EditNotifications();
            dialog.own(editNotifications);
            dialog.own(editNotifications.on("changed", function (e) {
                if (e.oldValue) {
                    notificationBar.remove(e.oldValue);
                }

                if (e.newValue && e.newValue.content) {
                    var availableNotificationIndex = e.notification ? editNotifications.getAvailableNotificationIndex(e.notification) : 0;
                    notificationBar.add(e.newValue, availableNotificationIndex);
                }
            }.bind(this)));
            this._viewSettingsManager = this._viewSettingsManager || dependency.resolve("epi.viewsettingsmanager");
            editNotifications.updateSettings({ viewModel: form._model, viewSetting: this._viewSettingsManager });
            editNotifications.update(form._model.contentData, form._context, form._model, true);
        },

        _getContentData: function () {
            // summary:
            //      Get the latest content version
            //
            // tags:
            //      protected

            return this._enhancedStore.query({ id: this.model.contentLink, keepversion: true });
        },

        updateModel: function (model) {
            // summary:
            //      Updates model and returns result from onModelChange callback
            // tags:
            //      internal

            this.model = model;
            return this._onModelChange();
        },

        _onModelChange: function () {
            // summary:
            //      Updates isAvailable after the model has been updated.
            // tags:
            //      protected

            this.inherited(arguments);

            if (this.model instanceof Array) {
                // this command should be available only if one item selected
                // because it should be disabled when multiple blocks are selected
                // like in Assets pane
                if (this.model.length === 1) {
                    this.model = this.model[0];
                } else {
                    this.model = null;
                }
            }

            if (!this.model) {
                this.set("canExecute", false);
                return;
            }

            if (!this.model || this.model.inlineBlockData ||
                !TypeDescriptorManager.isBaseTypeIdentifier(this.model.typeIdentifier, "episerver.core.blockdata")) {
                this.set("isAvailable", false);
                return;
            }

            if (this.model.isOverlayInitialized === false) {
                return;
            }

            return when(this._getContentData()).then(function (contentData) {
                this._refreshContentSettings(contentData);
            }.bind(this));
        },

        _refreshContentSettings: function (contentData) {
            // summary:
            //      Update the content settings
            // tags:
            //      protected

            // contentData == null when it doesn't have a content version in the current language
            if (contentData == null) {
                this.set("isAvailable", false);
                this.set("canExecute", false);
                return;
            }

            this.set("isAvailable", true);

            var hasAccessRights = ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Edit);
            var hasProviderSupportForEditing = ContentActionSupport.hasProviderCapability(contentData.providerCapabilityMask, ContentActionSupport.providerCapabilities.Edit);
            var isDeleted = contentData.isDeleted;
            var isInUse = contentData.inUseNotifications && contentData.inUseNotifications.length > 0;

            var canExecute = (this.ignoredEditStatuses.indexOf(contentData.status) === -1) && hasAccessRights && hasProviderSupportForEditing && !isDeleted && !isInUse;

            this.set("canExecute", canExecute);

            if (canExecute) {
                this._calculateMainButtonCommand(contentData);
            }
        },
        _calculateMainButtonCommand: function (contentData) {
            // summary:
            //      Calculate to see which command is going to be the main command
            //      in the  InlineEditBlockDialog for the given contentData

            if (contentData.isPartOfActiveApproval) {
                // the content is part of an active approval, therefore the command Ready for Review is the main command
                this.mainCommand = new InlineReadyForReview({
                    commandType: "inline-edit-form",
                    label: requestapprovalRes.label
                });
            } else if (ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Publish)) {
                // user has Publish access right, so the Publish is the main command

                // if the current content has a published version,
                // the button should be "Publish Changes", otherwise "Publish"
                var publishLabel;
                if (contentData.hasPublishedVersion) {
                    publishLabel = toolbarButtonsRes.publishchanges.label;
                } else {
                    publishLabel = toolbarButtonsRes.publish.label;
                }

                this.mainCommand = new InlinePublish({
                    commandType: "inline-edit-form",
                    label: publishLabel
                });
            } else {
                // Ready to Publish command is the main command
                this.mainCommand = new InlineReadyToPublish({
                    commandType: "inline-edit-form",
                    label: toolbarButtonsRes.sendforreview.label
                });
            }
        }
    });
});

},
'epi-cms/contentediting/command/BlockInlinePublish':function(){
define([
    "dojo/_base/declare",
    "epi-cms/contentediting/command/Publish",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_BlockInlineCommandMixin",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.inlineediting.inlinecommands.inlinepublish"
], function (
    declare,
    Publish,
    ContentActionSupport,
    _BlockInlineCommandMixin,
    res
) {

    return declare([Publish, _BlockInlineCommandMixin], {
        // summary:
        //      Inline publish content command.
        // tags:
        //      internal xproduct

        errorMessageHeading: res.error,

        successMessage: res.success,

        requiredAction: ContentActionSupport.action.Publish,

        ignoredStatuses: [
            ContentActionSupport.versionStatus.DelayedPublish,
            ContentActionSupport.versionStatus.Published,
            ContentActionSupport.versionStatus.Expired,
            ContentActionSupport.versionStatus.AwaitingApproval
        ]
    });
});

},
'epi-cms/contentediting/command/_BlockInlineCommandMixin':function(){
define([
    "dojo/_base/declare",
    "dojo/topic",
    "dojo/when",
    "dojox/html/entities",
    "epi/dependency",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentViewModel",
    "epi/shell/DialogService",
    "epi/shell/TypeDescriptorManager"
], function (
    declare,
    topic,
    when,
    htmlEntities,
    dependency,
    ContentActionSupport,
    ContentReference,
    ContentViewModel,
    DialogService,
    TypeDescriptorManager
) {

    return declare(null, {
        // summary:
        //      Inline command mixin.
        // tags:
        //      internal xproduct

        requestContextChange: false,

        _viewModel: null,

        skippedAction: null,

        ignoredStatuses: null,

        ignoredContentTypes: ["episerver.core.contentfolder"],

        errorMessageHeading: "",

        successMessage: "",

        requiredAction: null,

        postscript: function () {
            this.inherited(arguments);

            this.messageService = this.messageService || dependency.resolve("epi.shell.MessageService");
            this._contentDataStore = dependency.resolve("epi.storeregistry").get("epi.cms.contentdata");

            this.own(topic.subscribe("/epi/cms/content/statuschange/", function (status, contentIdentity) {
                if (!this.model || !this.model.contentLink) {
                    return;
                }
                var updatedContentId = new ContentReference(contentIdentity.id).id;
                var currentModelId = new ContentReference(this.model.contentLink).id;
                if (updatedContentId === currentModelId) {
                    this._onModelChange();
                }
            }.bind(this)));
        },

        _getEnhancedStore: function () {
            if (this._enhancedStore) {
                return this._enhancedStore;
            }
            try {
                this._enhancedStore = dependency.resolve("epi.storeregistry").get("epi.cms.latestcontentversion");
                return this._enhancedStore;
            } catch (e) {
                this._enhancedStore = null;
            }
        },

        _execute: function () {
            // tags:
            //      protected

            var self = this;

            function showErrorMessage(error) {
                if (error) {
                    DialogService.alert({
                        heading: self.errorMessageHeading,
                        description: error
                    });
                    return false;
                }

                var query = {
                    contextId: self.model.contentData.contentLink,
                    contextTypeName: "epi.cms.contentdata",
                    typeName: "error"
                };
                var validationErrors = self.messageService.query(query).map(function (validationError) {
                    return validationError.message;
                });
                if (validationErrors.length > 0) {
                    DialogService.alertWithErrors({
                        heading: self.errorMessageHeading
                    }, validationErrors);
                    return false;
                }

                DialogService.alert("<strong>" + htmlEntities.encode(self.model.contentData.name) + ":</strong> " + self.errorMessageHeading);
                return false;
            }

            var messages = this.messageService.query({ contextId: this.model.contentData.contentLink });
            messages.forEach(function (message) {
                this.messageService.remove({ id: message.id });
            }, this);

            return this.inherited(arguments).then(function () {
                this.showMessage("<strong>" + htmlEntities.encode(this.model.contentData.name) + "</strong> " + self.successMessage);
                var contentReference = new ContentReference(this.model.contentData.contentLink);
                // Refresh the data in the store only if it's been published before
                if (contentReference.workId) {
                    this._contentDataStore.refresh(contentReference.toString()).then(function () {
                        topic.publish("/epi/cms/block/inline-updated");
                    });
                } else {
                    topic.publish("/epi/cms/block/inline-updated");
                }
                return true;
            }.bind(this)).otherwise(showErrorMessage)
                .always(function (result) {
                    this.set("isAvailable", false);
                    return result;
                }.bind(this));
        },

        destroy: function () {
            if (this._viewModel) {
                this._viewModel.destroy();
            }
            this.inherited(arguments);
        },


        _onContentStatusChange: function (result) {
            return result;
        },

        _isIgnoredContentType: function (typeIdentifier) {
            //  summary:
            //      Return true if the command doesn't support that content type

            return this.ignoredContentTypes.some(function (type) {
                return TypeDescriptorManager.isBaseTypeIdentifier(typeIdentifier, type);
            }, this);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //      protected

            if (!this.model) {
                return;
            }

            if (this._isIgnoredContentType(this.model.typeIdentifier)) {
                this.set("isAvailable", false);
                return;
            }

            var _arguments = arguments;

            var store = this._getEnhancedStore();
            if (!store) {
                return;
            }

            return store.query({ id: this.model.contentLink, keepversion: true }).then(function (latestContent) {
                var contentData = latestContent;
                // we want to exit early if the page is already published or the user does not have proper access rights
                if (!contentData || this.ignoredStatuses.indexOf(contentData.status) !== -1 ||
                    contentData.isPartOfActiveApproval ||
                    !ContentActionSupport.hasAccessToAction(contentData, this.requiredAction) ||
                    (this.skippedAction && ContentActionSupport.hasAccessToAction(contentData, this.skippedAction))
                ) {
                    this._setCommandVisibility(false);
                    return;
                }

                this._setCommandVisibility(true);

                if (this._viewModel) {
                    this._viewModel.destroy();
                }
                this._viewModel = new ContentViewModel({
                    contentLink: contentData.contentLink,
                    contextTypeName: "epi.cms.contentdata"
                });
                this._viewModel.set("contentData", contentData);
                this.model = this._viewModel;

                this.inherited(_arguments);
            }.bind(this));
        },

        _setCommandVisibility: function (visible) {
            this.set("isAvailable", visible);
        },

        showMessage: function (message) {
            DialogService.alert(message);
        },

        tryToSaveAndExecute: function (form) {
            var deferred = true;
            if (form.get("isDirty")) {
                deferred = form.saveForm();
            }
            return when(deferred).then(function () {
                var preExecuteDeferred = true;
                // check if the command became available after the form was saved
                if (!this.get("canExecute")) {
                    // manually refresh its model to get most recent availability flags
                    preExecuteDeferred = this._onModelChange();
                }
                return when(preExecuteDeferred).then(function () {
                    if (this.get("isAvailable") && this.get("canExecute")) {
                        return this.execute();
                    }
                }.bind(this));
            }.bind(this));
        }
    });
});

},
'epi-cms/contentediting/command/BlockInlineReadyForReview':function(){
define([
    "dojo/_base/declare",
    "epi-cms/content-approval/command/ReadyForReview",
    "epi-cms/contentediting/command/_BlockInlineCommandMixin",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/ContentViewModel",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.inlineediting.inlinecommands.inlinereadyforreview"
], function (
    declare,
    ReadyForReview,
    _BlockInlineCommandMixin,
    ContentActionSupport,
    ContentViewModel,
    res
) {

    return declare([ReadyForReview, _BlockInlineCommandMixin], {
        // summary:
        //      Inline command to set the block as ready to review
        // tags:
        //      internal xproduct

        errorMessageHeading: res.error,

        successMessage: res.success,

        executableStatuses: [
            ContentActionSupport.versionStatus.Rejected,
            ContentActionSupport.versionStatus.CheckedOut
        ],

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            if (!this.model) {
                return;
            }

            if (this._isIgnoredContentType(this.model.typeIdentifier)) {
                this.set("isAvailable", false);
                return;
            }

            var store = this._getEnhancedStore();
            if (!store) {
                return;
            }

            return store.query({ id: this.model.contentLink, keepversion: true }).then(function (latestContent) {
                var contentData = latestContent;

                // Early exit if the current content isn't in the list of the executable statuses
                if (this.executableStatuses.indexOf(contentData.status) === -1) {
                    this._setCommandVisibility(false);
                    return;
                }

                this._setCommandVisibility(true);

                if (this._viewModel) {
                    this._viewModel.destroy();
                }
                this._viewModel = new ContentViewModel({
                    contentLink: contentData.contentLink,
                    contextTypeName: "epi.cms.contentdata"
                });
                this._viewModel.set("contentData", contentData);
                this.model = this._viewModel;
            }.bind(this));
        }
    });
});

},
'epi-cms/contentediting/command/BlockInlineReadyToPublish':function(){
define([
    "dojo/_base/declare",
    "dojo/when",
    "epi-cms/contentediting/command/SendForReview",
    "epi-cms/contentediting/command/_BlockInlineCommandMixin",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.inlineediting.inlinecommands.inlinereadytopublish"
], function (
    declare,
    when,
    SendForReview,
    _BlockInlineCommandMixin,
    ContentActionSupport,
    res
) {

    return declare([SendForReview, _BlockInlineCommandMixin], {
        // summary:
        //      Inline command to set a block to be Ready to Publish
        // tags:
        //      internal xproduct

        errorMessageHeading: res.error,

        successMessage: res.success,

        requiredAction: ContentActionSupport.action.CheckIn,

        skippedAction: ContentActionSupport.action.Publish,

        ignoredStatuses: [
            ContentActionSupport.versionStatus.DelayedPublish,
            ContentActionSupport.versionStatus.CheckedIn,
            ContentActionSupport.versionStatus.Published
        ]
    });
});

},
'epi-cms/plugin-area/assets-pane':function(){
﻿define([
    "epi/PluginArea",
    // Commands
    "epi-cms/content-approval/command/EditApprovalDefinition"
], function (
    PluginArea,
    // Commands
    EditApprovalDefinition
) {

    /*=====
    return {
        // summary:
        //      A plugin area for the assets components and context menu.
        // tags:
        //      public
    };
    =====*/

    var pluginArea = new PluginArea("epi-cms/assets-pane/commands[]");

    pluginArea.add(EditApprovalDefinition);

    return pluginArea;
});

},
'epi-cms/content-approval/command/EditApprovalDefinition':function(){
define([
    "dojo/_base/declare",
    "epi/dependency",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.edit",
    // Parent class and mixins
    "epi/shell/command/_Command"
], function (
    declare,
    dependency,
    ContentActionSupport,
    localization,
    // Parent class and mixins
    _Command
) {

    return declare([_Command], {
        // summary:
        //      Redirects to the content approval view if there is an approval definition.
        // tags:
        //      internal

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed.
        canExecute: false,

        // contentActionSupport: [public] object
        contentActionSupport: null,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconApproval",

        // isAvailable: [public] Boolean
        //      Flag which indicates whether this command is available in the current context.
        isAvailable: false,

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: null,

        postscript: function () {
            this.inherited(arguments);
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;

            this.approvalService = this.approvalService || dependency.resolve("epi.cms.ApprovalService");
        },

        _onModelChange: function () {
            // summary:
            //      Enable the command if the user has access and sets the correct label.
            // tags:
            //      protected

            if (this.model instanceof Array) {
                //this command should only be available if you have exactly one item selected
                if (this.model.length === 1)   {
                    this.model = this.model[0];
                } else {
                    this.model = null;
                }
            }

            if (!this.model) {
                this._setEnabledState(false);
                return;
            }

            this._setEnabledState(true);

            var hasAdminAccess = this.contentActionSupport.hasAccess(this.model.accessMask, this.contentActionSupport.accessLevel.Administer);
            this.set("label", hasAdminAccess ? localization.editlabel : localization.viewlabel);
        },

        _setEnabledState: function (enabled) {
            // summary:
            //      Handles availability and if the command is executable.
            // tags:
            //      private

            this.set("canExecute", !!enabled);

            var available = this.canExecute
                    // cannot check the typeidentifier because for the ones that were not created yet it's
                    // ContentFolder (fake asset folder) while for the ones that exist it's ContentAssetFolder
                    // ownerContentLink property is not null only for 'For this page' nodes
                    && !this.model.ownerContentLink
                    && this.model.capabilities.canconfigureapproval;

            this.set("isAvailable", !!available);
        },

        _execute: function () {
            // summary:
            //      Redirects to the content approval view.
            // tags:
            //      protected

            this.approvalService.navigateToDefinition(this.model.contentLink);
        }
    });
});

},
'epi-cms/widget/viewmodel/MultipleFileUploadViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/Stateful"
],

function (
// dojo
    array,
    declare,
    lang,
    when,
    Stateful
) {

    return declare([Stateful], {
        // summary:
        //      View model for multiple file upload widget.
        // tags:
        //      internal xproduct

        upload: function (/*Array*/uploadingFiles) {
            // summary:
            //      Upload selected file(s) to server.
            //      It will show confirmation dialog that ask for replace/skip existing files.
            //      The filter condition is a file name and a content name.
            // uploadingFiles: [Array]
            //      Selected file(s) to upload
            // returns: [dojo/Deferred]
            //      An instance of Array for filtered file list to upload to server.
            //      This list can be the whole original selected file(s) or just the new file(s) that not existed on the server.
            // tags:
            //      public

            return when(this._filterUploadingFiles(uploadingFiles), function (/*Object*/filteredResult) {
                // filteredResult: [Object]
                //      existingContents: [Array]
                //          Existing content list
                //      newFiles: [Array]
                //          New uploading file list

                if (!filteredResult || !(filteredResult.existingContents instanceof Array) || filteredResult.existingContents.length === 0) {
                    return {
                        showConfirmation: false,
                        uploadingFiles: uploadingFiles
                    };
                }

                // Show confirmation dialog for replace/skip file(s) if it got any existing contents (have the same name) from server
                return {
                    showConfirmation: true,
                    uploadingFiles: uploadingFiles,
                    newFiles: filteredResult.newFiles,
                    existingContents: filteredResult.existingContents
                };
            });
        },

        _filterUploadingFiles: function (/*Array*/uploadingFiles) {
            // summary:
            //      Filters the given uploading files, check to see the list contains existing files on the server or not.
            //      It will return an existing content list and a list of new files.
            //      The filter condition is a file name and a content name.
            // uploadingFiles: [Array]
            //      Selected file(s) to upload
            // returns: [Object]
            //      filteredResult: [Object]
            //          existingContents: [Array]
            //              Existing content list
            //          newFiles: [Array]
            //              New uploading file list
            // tags:
            //      private

            var self = this;
            // If no store given, just return the whole original uploading file list
            if (!self.store) {
                return null;
            }

            // when checking for duplicates we should not only take the same file types
            // into consideration but all content media types
            var query = lang.clone(self.get("query"));
            query.typeIdentifiers = query.typeIdentifiers || [];
            var mediaTypeIdentifier = "episerver.core.icontentmedia";
            if (query.typeIdentifiers.indexOf(mediaTypeIdentifier) < 0) {
                query.typeIdentifiers.push(mediaTypeIdentifier);
            }
            return when(self.store.query(query), function (/*Array*/contentList) {
                // Get existing content list
                var existingContents = array.filter(contentList, function (content) {
                    return content.typeIdentifier !== "episerver.core.icontentfolder"
                        && array.some(uploadingFiles, function (file) {
                            return file.name.toLowerCase() === content.name.toLowerCase();
                        });
                });

                // Get new file list (that not existed on the server)
                var newFiles = array.filter(uploadingFiles, function (file) {
                    return array.every(contentList, function (content) {
                        return file.name.toLowerCase() !== content.name.toLowerCase();
                    });
                });

                return {
                    existingContents: existingContents,
                    newFiles: newFiles
                };
            });
        }

    });

});

},
'epi-cms/widget/MultipleFileUpload':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-geometry",

    "dojo/aspect",
    "dojo/when",
    "dojo/topic",

    "dojo/Evented",
    // dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    // dojox
    "dojox/form/Uploader",

    // epi
    "epi/routes",
    "epi/shell/DialogService",
    "epi/shell/postMessage",

    "epi-cms/widget/MultipleFileUploadConfirmation",
    "epi-cms/widget/UploadUtil",

    "epi-cms/widget/viewmodel/FileListViewModel",
    // templates
    "dojo/text!./templates/MultipleFileUpload.html",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles",

    // Used in the template
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/FileList",

    // Registers itself when loaded
    "epi/shell/form/uploader/HTML5"
],

function (
// dojo
    array,
    declare,
    lang,

    domGeometry,
    aspect,
    when,
    topic,

    Evented,
    // dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    // dojox
    Uploader,
    // epi
    routes,

    dialogService,
    postMessage,

    MultipleFileUploadConfirmation,
    UploadUtil,

    FileListViewModel,
    // templates
    template,
    // resources
    resources
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, Evented], {
        // summary:
        //      Multiple file upload dialog widget. Use HTML5 native Dnd file(s) in Chrome, Firefox and IE.
        // tags:
        //      internal xproduct

        // widget resources
        res: resources,

        // _isCompleted: [private] Boolean
        //      Status of upload files progress
        _isCompleted: true,

        // templateString: String
        //  Template for the widget
        templateString: template,

        // =======================================================================
        // Public overrided functions

        postCreate: function () {

            this.inherited(arguments);

            this._setupUploader();
            this._setupFileList();

            this._confirmationDialog = this._confirmationDialog || new MultipleFileUploadConfirmation();
        },

        // =======================================================================
        // Public functions

        upload: function (/*Array*/uploadingFiles) {
            // summary:
            //      Upload files to a directory.
            // uploadingFiles: [Array]
            //      Collection of file to upload
            // tags:
            //      public

            var self = this,
                uploader = self.uploaderInput,
                uploadSettings = self._getUploadSettings();

            if (!uploadingFiles || uploadingFiles.length === 0) {
                return;
            }

            when(self.model.upload(uploadingFiles), function (/*Object*/result) {

                when(self._confirm(result), function (confirmedFiles) {
                    self._resetUploader();

                    if (!(confirmedFiles instanceof Array) || confirmedFiles.length === 0) {
                        self._onUploadComplete(confirmedFiles);
                        return;
                    }

                    self._fileListModel.set("uploadFiles", confirmedFiles);
                    uploader._files = confirmedFiles;

                    // Call uploader plugin upload(/*Object?*/formData) function
                    uploader.upload(uploadSettings);
                });
            });
        },

        close: function () {
            // summary:
            //      Close upload mutiple files dialog.
            // tags:
            //      public

            var self = this,
                files = self.uploaderInput._files,
                releaseDialog = function (uploading) {
                    // Inactive layer overlay toolbar
                    self.emit("close", uploading);
                    self.set("disableToolbar", false);
                };

            if (self._isCompleted || !files || files.length <= 0) {
                releaseDialog(false);
            } else {
                // Confirm dialog to verify if stopping the upload files.
                dialogService.alert(resources.confirmdialog.description).then(function () {
                    releaseDialog(true);
                });
            }
        },

        // =======================================================================
        // Protected functions

        _setBreadcrumbAttr: function (/*Array*/parts) {
            // summary:
            //      Build breadcrumb
            // tags:
            //      protected

            // Display server path of files directory.
            this.breadcrumbBar._cleanUp();
            this.breadcrumbBar._availableWidth = domGeometry.getContentBox(this.breadcrumbBar.domNode).w;

            var i = 0,
                length = parts ? parts.length : 0;

            if (length > 0) {
                for (i; i < length - 1; i++) {
                    this.breadcrumbBar._createItem(parts[i], true);
                }

                this.breadcrumbBar._createItem(parts[length - 1], false);
            }
        },

        _setDisableToolbarAttr: function (/*Boolean*/disabled) {
            // summary:
            //      Active/Inactive upload button.
            // tags:
            //      protected

            this.uploaderInput.set("disabled", disabled);

            // Have to reset tabIndex since the uploader implementation doesn't do this when it's enabled again
            !disabled && this.uploaderInput.set("tabindex", 0);
        },

        // =======================================================================
        // Private functions

        _setupUploader: function () {
            // summary:
            //      Settings for uploader
            // tags:
            //      private

            var self = this;

            // set the action path for upload form
            this.uploaderInput.uploadUrl = routes.getActionPath({
                moduleArea: "CMS",
                controller: "FileUpload",
                action: "Upload"
            });

            // To pass uploadDirectory to this.onChange delegate, in order to indicate the folder to upload files into.
            this.own(
                aspect.before(this.uploaderInput, "onChange", function (/*Array*/fileArray) {
                    self._isCompleted = false;
                    self.set("disableToolbar", true);

                    return [self._getUploadSettings()];
                }),
                this.uploaderInput.on("error", function () {
                    self._fileListModel.error();
                    self._resetToInitialPreview();
                })
            );
        },

        _getUploadSettings: function () {
            // summary:
            //      Get uploading settings
            // returns: [Object]
            //      Object's properties
            //          uploadDirectory: [String]
            //          createAsLocalAsset: [Boolean]
            // tags:
            //      private

            return {
                uploadDirectory: this.get("uploadDirectory"),
                createAsLocalAsset: this.get("createAsLocalAsset")
            };
        },

        _setupFileList: function () {
            // summary:
            //      Listen on uploader events to controls file list
            // tags:
            //      private

            var self = this,
                uploader = this.uploaderInput;

            self._fileListModel = new FileListViewModel();
            self.fileList.set("model", self._fileListModel);

            // Reset file list
            this.own(
                // Show progress bar
                uploader.on("begin", function (files) {
                    if (files && files.length > 0) {
                        self._fileListModel.set("showProgressBar", true);
                    }
                }),
                // Show uploading progress
                uploader.on("progress", function (customEvent) {
                    self._fileListModel.set("progress", customEvent);
                }),
                uploader.on("complete", lang.hitch(self, self._onUploadComplete)),

                aspect.after(uploader, "reset", lang.hitch(self, self._fileListModel.clear)),

                // Set upload files to file list model
                aspect.around(uploader, "onChange", function (original) {

                    return function (/*Array*/fileArray) {

                        var uploadingFiles = uploader._files;

                        return when(self.model.upload(uploadingFiles), function (/*Object*/result) {

                            return when(self._confirm(result), function (confirmedFiles) {
                                confirmedFiles = UploadUtil.getFileArray(confirmedFiles);

                                if (!(confirmedFiles instanceof Array) || confirmedFiles.length === 0) {
                                    self._resetUploader();
                                    return original.apply(uploader, [fileArray]);
                                }

                                self._fileListModel.set("uploadFiles", confirmedFiles);
                                uploader._files = confirmedFiles;
                                uploader.upload(self._getUploadSettings());

                                return original.apply(uploader, [fileArray]);
                            });
                        });
                    };
                })
            );
        },

        _confirm: function (/*Object*/result) {
            // summary:
            //      Get confirmed file collection to upload to server
            // result: [Object]
            //      Filtered result information
            // returns: [dojo/Deferred]
            //      File collection to upload to server
            // tags:
            //      private

            return result.showConfirmation === true
                ? this._confirmationDialog.showConfirmation(result.existingContents, result.uploadingFiles, result.newFiles)
                : result.uploadingFiles;
        },

        _clearUploadFiles: function () {
            // summary:
            //      Clear uploaded files data.
            // tags:
            //      private

            this.uploaderInput._files = [];
        },

        _resetUploader: function () {
            // summary:
            //      Hide uploading progress bar.
            //      Call dojox uploader reset function.
            // tags:
            //      private

            this._fileListModel.set("showProgressBar", false);
            // make sure the file list is empty, to set new files
            this.uploaderInput.reset();
            this.set("disableToolbar", false);
        },

        _resetToInitialPreview: function () {
            // summary:
            //      Hide uploading progress bar.
            //      Call dojox uploader reset function.
            // tags:
            //      private

            this._fileListModel.set("showProgressBar", false);
            // make sure the file list is empty, to set new files
            this.set("disableToolbar", false);
            this._clearUploadFiles();
            this.emit("uploadComplete", this._fileListModel.uploadFiles, true);
        },

        _onUploadComplete: function (evt) {
            // summary:
            //      Fires when all files have uploaded.
            //      Event is an array of all files.
            // tags:
            //      private

            this._isCompleted = true;
            var fileArray = UploadUtil.getFileArray(evt);
            this._fileListModel.update(fileArray);
            this.set("disableToolbar", false);
            this._clearUploadFiles();
            var uploadFiles = this._fileListModel.uploadFiles || fileArray;
            this.emit("uploadComplete", uploadFiles);

            topic.publish("LastFileUploadedAndReplaced", uploadFiles);
            postMessage.publish("LastFileUploadedAndReplaced");
        }
    });
});

},
'epi-cms/widget/MultipleFileUploadConfirmation':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/when",
    // epi
    "epi/string",

    "epi/shell/widget/dialog/Dialog",

    "epi-cms/widget/ReadOnlyContentList",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles.replaceconfirmdialog"
],

function (
// dojo
    array,
    declare,
    lang,

    domClass,

    aspect,
    Deferred,
    when,
    // epi
    epiString,

    Dialog,

    ReadOnlyContentList,
    // resources
    resources
) {

    return declare(null, {
        // summary:
        //      Confirmation dialog for multiple file upload widget
        // tags:
        //      internal

        showConfirmation: function (/*Array*/existingContents, /*Array*/uploadingFiles, /*Array*/newFiles) {
            // summary:
            //      Show confirmation dialog to replace/skip the existing contents when uploading file(s) by multiple file upload widget.
            // existingContents: [Array]
            //      Filtered existing content(s) on the server
            // uploadingFiles: [Array]
            //      The uploading file(s) given from multiple file upload widget
            // newFiles: [Array]
            //      Filtered new file(s) that are not existing on the server
            // returns: [dojo.Deferred]
            //      An instance of Array for filtered file list to upload to server.
            //      This list can be the whole original selected file(s) or just the new file(s) that not existed on the server.
            // tags:
            //      public

            var deferred = new Deferred(),
                dialog = this._getDialog(existingContents.length),
                content = this._getContentList();

            dialog.set("content", content);
            dialog.set("onAction", function (replace) {
                deferred.resolve(replace ? uploadingFiles : newFiles);
            });

            when(dialog.show(), function () {
                content.grid.renderArray(existingContents);
            });

            return deferred;
        },

        // =======================================================================
        // Private functions

        _getDialog: function (/*Integer*/totalExistingFiles) {
            // summary:
            //      Get confirmation dialog
            // totalExistingFiles: [Integer]
            //      Total filtered existing files on the server
            // returns: [epi/shell/widget/dialog/Dialog]
            //      Confirmation dialog that included existing file list grid
            // tags:
            //      private

            var self = this,
                heading = epiString.toHTML(totalExistingFiles > 1 ? lang.replace(resources.multiple.heading, [totalExistingFiles]) : resources.single.heading),
                description = epiString.toHTML(totalExistingFiles > 1 ? resources.multiple.description : resources.single.description);

            var dialog = new Dialog({
                closeIconVisible: false,
                title: resources.title,
                heading: heading,
                description: description,
                dialogClass: "epi-dialog--auto-height",
                getActions: function () {
                    return self._getActions(this, totalExistingFiles === 1);
                }
            });

            return dialog;
        },

        _getActions: function (/*epi/shell/widget/dialog/Dialog*/dialog, /*Boolean*/single) {
            // summary:
            //      Overridden from Dialog base to assemble the action collection
            // dialog: [epi/shell/widget/dialog/Dialog]
            //      Confirmation dialog
            // single: [Boolean]
            //      Indicates that we must show text for single item or multiple items
            // returns:
            //      A collection of action definitions that can be added to the action pane.
            // tags:
            //      private

            return [
                {
                    name: "skipFiles",
                    label: single ? resources.single.buttons.skip : resources.multiple.buttons.skip,
                    title: null,
                    action: function () {
                        when(dialog.hide(), function () {
                            return dialog.onAction(false);
                        });
                    }
                },
                {
                    name: "replaceFiles",
                    label: single ? resources.single.buttons.replace : resources.multiple.buttons.replace,
                    settings: { "class": "Salt" },
                    title: null,
                    action: function () {
                        when(dialog.hide(), function () {
                            return dialog.onAction(true);
                        });
                    }
                }
            ];
        },

        _getContentList: function () {
            // summary:
            //      Get readonly thumbnail grid for existing contents on the server
            // returns: [epi-cms/widget/ReadOnlyContentList]
            //      Readonly grid with thumbnail enabled
            // tags:
            //      private

            var readOnlyList = new ReadOnlyContentList();
            domClass.add(readOnlyList.grid.domNode, "epi-thumbnailContentList");

            return readOnlyList;
        }

    });

});

},
'epi-cms/widget/ReadOnlyContentList':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    // dgrid
    "dgrid/OnDemandList",
    // epi
    "epi/shell/dgrid/Formatter",

    "epi-cms/core/ContentReference",
    "epi-cms/dgrid/formatters",
    "epi-cms/widget/_ContentListBase"
],

function (
// dojo
    declare,
    // dgrid
    OnDemandList,
    // epi
    Formatter,

    ContentReference,
    formatters,
    _ContentListBase
) {

    return declare([_ContentListBase], {
        // summary:
        //      Widget to show a read only content list
        // tags:
        //      internal

        // _gridClass: [protected]
        //      Declaration for dgrid
        _gridClass: declare([OnDemandList, Formatter]),

        // query: [public] Object
        //      Grid query object
        query: null,

        // queryOptions: [public] Object
        //      Grid query options object
        queryOptions: null,

        // =======================================================================
        // Public functions

        onPostCreateSettings: function () {

        },

        // =======================================================================
        // Public overrided functions

        postCreate: function () {

            this.inherited(arguments);

            this.onPostCreateSettings();
        },

        destroy: function () {

            if (this.grid) {
                this.grid.destroy();
                this.grid = null;
            }

            this.inherited(arguments);
        },

        getContextMenu: function () {
            // summary:
            //
            // tags:
            //      public, extension

            // Do not create a contextMenu if it's not been specified.
        },

        createList: function () {
            // summary:
            //      Hides grid header by default
            // tags:
            //      public, extension

            this.inherited(arguments);

            this.grid.set("showHeader", false);
        },

        getListSettings: function () {
            // summary:
            //      Initialization a list.
            // tags:
            //      public, extension

            return this._getBaseSettings();
        },

        // =======================================================================
        // Protected functions

        _setQueryAttr: function (/*Object*/value) {
            // summary:
            //
            // value: [Object]
            //
            // tags:
            //      protected

            this._set("query", value);
            this._updateQuery(value);
        },

        _getBaseSettings: function (/*Object?*/contextMenu) {
            // summary:
            //
            // contextMenu: [Object?]
            //
            // tags:
            //      protected

            var titleSelector = function (item) {
                var reference = new ContentReference(item.contentLink);

                return formatters.title(item.name, reference.id, item.contentTypeName);
            };

            var thumbnailSelector = function (item) {
                return item.thumbnailUrl;
            };

            // Init content list
            return {
                store: this.store,
                queryOptions: this.queryOptions,
                formatters: [formatters.contentItemFactory("name", titleSelector, null, contextMenu, thumbnailSelector, undefined, undefined, true)],
                deselectOnRefresh: true,
                sort: this.queryOptions && this.queryOptions.sort
            };
        },

        // =======================================================================
        // Private functions

        _updateQuery: function (/*Object*/query) {
            // summary:
            //
            // query: [Object]
            //
            // tags:
            //      private

            if (query) {
                this.grid.set("query", query);
            } else {
                this.grid.cleanup();
            }
        }

    });

});

},
'epi-cms/widget/_ContentListBase':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/when",
    "./_GridWidgetBase"
], function (
    declare,
    lang,
    domConstruct,
    domGeometry,
    when,
    _GridWidgetBase) {
    return declare([_GridWidgetBase], {
        // tags:
        //      internal

        storeKeyName: "epi.cms.content.search",

        trackActiveItem: false,

        gridAttachNode: null,

        // _defaultGridNode: [private] DOMNode
        //      Reference to the node where the grid is attached when no gridAttachNode is configured.
        _defaultGridNode: null,

        // contextChangeEvent: [public] String
        //      Configure double click on a row to cause a context change.
        contextChangeEvent: "dblclick",

        postMixInProperties: function () {
            this.inherited(arguments);
            this.model = this.model || this.createModel();
        },

        postCreate: function () {
            // summary:
            //      Construct the UI for this widget.
            // tags:
            //      protected

            this.inherited(arguments);
            this.createList();
        },

        createModel: function () {
            // summary:
            //      Override to construct the default model for the list and context menu.
            // tags:
            //      protected
        },

        createList: function () {
            // summary:
            //      Creates the list for this widget.
            // tags:
            //      protected

            var settings = this.getListSettings();
            settings = lang.mixin(settings, this.defaultGridMixin);

            // Need a separate element for the grid in case it behaves like a widget and adds itself to dijit/registry.
            // See dgrid/extensions/DijitRegistry.
            if (!this.gridAttachNode) {
                this._defaultGridNode = domConstruct.create("div", null, this.domNode);
            }
            this.grid = new this._gridClass(settings, this.gridAttachNode || this._defaultGridNode);

            var hasModelWithCommands = this.model && this.model.commands && this.model.commands.length > 0;
            if (hasModelWithCommands) {
                this.grid.contextMenu.addProvider(this.model);
            }
            if (this.contextMenu) {
                this.grid.contextMenu = this.contextMenu;
            }

            this.own(this.grid);
            this.setupEvents();
        },

        layout: function () {
            // summary:
            //      Overridden to resize the _defaultGridNode

            // Need to resize the default grid node to the size of our domNode,
            // but if gridAttachNode was supplied then let whoever supplied it
            // be responsible for resizing.
            this.inherited(arguments);
            if (this._defaultGridNode) {
                domGeometry.setMarginBox(this._defaultGridNode, this._contentBox);
            }
        },

        getListSettings: function () {
            // summary:
            //      Override to specify the settings used to create the list.
            // tags:
            //      protected

            return {};
        },

        setupEvents: function () {
            // summary:
            //      Initialization of events on the list.
            // tags:
            //      protected, extension
        },

        onContextChanged: function () {
            //Disable default triggering of fetchData.
        },

        _onSelect: function (e) {

            when(this.getCurrentContext(), lang.hitch(this, function (currentContext) {

                var grid = this.grid;
                var model = {
                    contextId: currentContext.id,
                    data: []
                };

                if (this.model) {
                    for (var id in grid.selection) {
                        if (grid.selection[id]) {
                            var row = grid.row(id);
                            model.data.push(row.data);
                        }
                    }

                    this.model.set("model", model);
                }
            }));
        }
    });
});

},
'epi-cms/widget/UploadUtil':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/lang",

    "dojo/dom-style"
],

function (
// dojo
    array,
    lang,

    domStyle
) {

    return {
        // summary:
        //      Utility for multiple file upload.
        // tags:
        //      internal

        StatusScope: {
            // summary:
            //      Upload file status scope
            //          Single: will be apply for only one row
            //          All: will be apply for all rows
            // tags:
            //      public

            Single: 0,
            All: 1
        },

        validUploadFiles: function (/*Array*/files) {
            // summary:
            //      Validate input upload file array
            // tags:
            //      public

            if (!files || !(files instanceof Array) || files.length === 0) {
                return false;
            }

            return !array.some(files, function (item) {
                return (item.name == null || item.size == null);
            });
        },

        addStatus: function (/*Array*/store, /*Integer*/scope, /*String*/itemName, /*String*/message) {
            // summary:
            //      Append new one status message to the given store
            // store: [Array]
            //
            // scope: [Integer]
            //
            // itemName: [String]
            //
            // message: [String]
            //
            // tags:
            //      public

            var newStore = [];

            if (store instanceof Array) {
                newStore = lang.clone(store);
            }

            var existed = array.some(newStore, function (item) {
                return (item.scope === scope && item.itemName === itemName && item.message === message);
            });

            if (!existed) {
                newStore.push({ scope: scope, itemName: itemName, message: message });
            }

            return newStore;
        },

        filterFileOnly: function (/*Array*/files) {
            // summary:
            //      Returns list of file only, not directory
            // tags:
            //      public

            return array.filter(files, function (file) {
                if (file.type === "" && (file.size === 0 || file.size % 4096 === 0)) {
                    return false;
                }

                return true;
            });
        },

        toggleVisibility: function (/*DOM*/domNode, /*Boolean*/display) {
            // summary:
            //      Toogle visibility of the given dom node
            // domNode: [DOM]
            //
            // display: [Boolean]
            //
            // tags:
            //      public

            domStyle.set(domNode, "display", (display ? "block" : "none"));
        },

        getFileArray: function (/*Object*/inputList) {
            // summary:
            //      Get Array object from the given object list
            // inputList: [Object]
            //      Object list that wants to convert to Array
            // returns: [Array]
            //      Collection of uploading files in Array
            // tags:
            //      public

            if (!inputList) {
                return null;
            }

            if (inputList instanceof Array) {
                return inputList;
            }

            if (typeof inputList.item !== "function") {
                return null;
            }

            var i = 0,
                total = inputList.length,
                fileArray = [];

            for (i; i < total; i++) {
                fileArray.push(inputList.item(i));
            }

            return fileArray;
        }

    };
});

},
'epi-cms/widget/viewmodel/FileListViewModel':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/Stateful",

    // epi
    "epi-cms/widget/UploadUtil",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles"
],

function (
    // dojo
    declare,
    array,
    lang,
    Stateful,

    // epi
    UploadUtil,

    // resources
    resources
) {
    return declare([Stateful], {
        // summary:
        //      The view model for multiple file upload widget
        //
        // tags:
        //      internal

        // progress: [Object]
        //      Progress of uploading files
        progress: null,

        // uploadFiles: [Array]
        //      List of uploading files
        uploadFiles: null,

        // showProgressBar: [Boolean]
        //      Indicates that progress bar should show or hide
        showProgressBar: false,

        _progressSetter: function (value) {
            this.progress = value;

            var files = this.get("uploadFiles");
            var totalFileSize = 0;
            files.forEach(function (fileViewModel) {
                totalFileSize += fileViewModel.size;
                if (fileViewModel.status === resources.uploadform.uploading && value.bytesLoaded >= totalFileSize) {
                    fileViewModel.status = resources.uploadform.uploaded;
                }
            }, this);
            this.set("uploadFiles", files);
        },

        _uploadFilesSetter: function (/* Array */files) {
            // summary:
            //      Uploading files need to send to server
            // tags:
            //      private

            if (!UploadUtil.validUploadFiles(files)) {
                return;
            }

            var fileList = [];
            array.forEach(files, function (file) {
                fileList.push({ fileName: file.name, size: file.size, status: resources.uploadform.uploading });
            }, this);
            this.uploadFiles = fileList;
        },

        update: function (/* Array */newlyUploadedFiles) {
            // summary:
            //      Update the status and contentLink of the uploaded files
            // tags:
            //      public

            if (!newlyUploadedFiles || newlyUploadedFiles.length === 0) {
                return;
            }

            var files = this.get("uploadFiles");

            newlyUploadedFiles.forEach(function (uploadedFile) {
                // Find the view model of that file in the upload list
                var fileViewModel = array.filter(files, function (file) {
                    return uploadedFile.fileName === file.fileName;
                })[0];

                fileViewModel.contentLink = uploadedFile.contentLink;

                // Update status of file upload
                if (uploadedFile.errorMessage) {
                    fileViewModel.status = resources.uploadform.failed;
                    fileViewModel.statusMessage = uploadedFile.errorMessage;
                } else {
                    fileViewModel.status = resources.uploadform.uploaded;
                }
            }, this);

            this.set("uploadFiles", files);
        },

        error: function () {
            // summary:
            //      Mark all files as failed
            // tags:
            //      public

            var files = this.get("uploadFiles");

            array.forEach(files, function (fileViewModel) {
                fileViewModel.status = resources.uploadform.failed;
                fileViewModel.statusMessage = resources.uploadform.errormessage;
            });

            this.set("uploadFiles", files);
        },

        clear: function () {
            // summary:
            //      Clear all temporaries upload file information before
            // tags:
            //      public

            this.set("uploadFiles", null);
        }
    });
});

},
'url:epi-cms/widget/templates/MultipleFileUpload.html':"﻿<div class=\"epi-multiFileUpload\">\r\n    <form method=\"post\" action=\"\" enctype=\"multipart/form-data\">\r\n        <div data-dojo-attach-point=\"breadcrumbBar\" data-dojo-type=\"epi-cms/widget/Breadcrumb\"></div>\r\n        <div data-dojo-attach-point=\"uploadToolbar\" class=\"epi-toolbar-unwrapped\">\r\n            <span title=\"${res.uploadform.addfiles}\" >\r\n                <input type=\"file\" multiple=\"multiple\" data-dojo-type=\"dojox.form.Uploader\" data-dojo-attach-point=\"uploaderInput\" \r\n                    data-dojo-props=\"iconClass:'epi-iconPlus', showLabel: false, multiple: true\" />\r\n            </span>\r\n            <div data-dojo-attach-point=\"toolbarDisableLayer\"></div>\r\n        </div>\r\n        <div data-dojo-attach-point=\"fileList\" data-dojo-type=\"epi-cms/widget/FileList\"></div>\r\n    </form>\r\n</div>",
'epi-cms/widget/FileList':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
    // dojox
    "dojox/form/uploader/Base",
    // dgrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/Keyboard",
    // dijit
    "dijit/ProgressBar",
    // epi
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/dgrid/Formatter",

    "epi-cms/widget/UploadUtil",
    //resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles.uploadform",
    // template
    "dojo/text!./templates/FileList.html"
],
function (
// dojo
    declare,
    lang,

    domAttr,
    domConstruct,
    domClass,
    domStyle,
    // dojox
    formUploaderBase,
    // dgrid
    OnDemandGrid,
    dgridSelection,
    Keyboard,
    // dijit
    ProgressBar,
    // epi
    _ModelBindingMixin,
    Formatter,

    UploadUtil,
    // resources
    resources,
    // template
    template
) {
    return declare([formUploaderBase, _ModelBindingMixin], {
        // summary:
        //      Widget to show uploading file(s).
        // tags:
        //      internal

        templateString: template,

        // Map property name in view model to a list of properties in this widget
        modelBindingMap: {
            showProgressBar: ["showProgressBar"],
            progress: ["progress"],
            uploadFiles: ["uploadFiles"]
        },

        postCreate: function () {
            this.inherited(arguments);

            this._buildGrid();
        },

        _setUploadFilesAttr: function (/* Array */files) {
            // summary:
            //      Give new data (upload files) for grid
            // tags:
            //      private

            this._bindData(files);
        },

        _setShowProgressBarAttr: function (/* Boolean */show) {
            // summary:
            //      Toggle visibility of progress bar
            // tags:
            //      private

            UploadUtil.toggleVisibility(this.progressBar.domNode, show);
        },

        _setProgressAttr: function (/* Object */progressObject) {
            // summary:
            //      Update uploading progress of progress bar
            // tags:
            //      private

            if (!progressObject) {
                return;
            }

            // update upload progress, by updating progress bar.
            this.progressBar.update({ progress: progressObject.percent.replace("%", "") });
        },

        _bindData: function (data) {
            // summary:
            //      Refresh and bind new data to grid
            // tags:
            //      private

            data = data || [];

            this._grid.refresh();
            this._grid.renderArray(data);
        },

        _buildGrid: function () {
            // summary:
            //      Build file(s) upload grid and append it to container
            // tags:
            //      private

            var gridClass = declare([OnDemandGrid, Keyboard, Formatter]);
            this._grid = new gridClass({
                columns: {
                    fileName: {
                        label: resources.uploadfilename,
                        field: "fileName",
                        htmlEncode: true
                    },
                    size: {
                        label: resources.uploadfilesize,
                        field: "size",
                        get: lang.hitch(this, function (file) {
                            var fileSizeValue = this.convertBytes(file.size).value;

                            if (isNaN(fileSizeValue)) {
                                return fileSizeValue;
                            }

                            var byteText = fileSizeValue === 0 ? resources.bytetext : resources.bytestext;
                            return lang.replace("{0} {1}", [fileSizeValue, byteText]);
                        })
                    },
                    status: {
                        label: resources.uploadfilestatus,
                        field: "status",
                        renderCell: lang.hitch(this, function (item, value, node, options) {
                            domAttr.set(node, "title", item.statusMessage ? item.statusMessage : "");
                            domClass.toggle(node, "epi-failedStatus", item.status === resources.failed);
                            node.innerHTML = item.status;
                        })
                    }
                }
            });

            this.own(this._grid);
            domConstruct.place(this._grid.domNode, this.domNode);
        }
    });
});

},
'dijit/ProgressBar':function(){
require({cache:{
'url:dijit/templates/ProgressBar.html':"<div class=\"dijitProgressBar dijitProgressBarEmpty\" role=\"progressbar\"\n\t><div  data-dojo-attach-point=\"internalProgress\" class=\"dijitProgressBarFull\"\n\t\t><div class=\"dijitProgressBarTile\" role=\"presentation\"></div\n\t\t><span style=\"visibility:hidden\">&#160;</span\n\t></div\n\t><div data-dojo-attach-point=\"labelNode\" class=\"dijitProgressBarLabel\" id=\"${id}_label\"></div\n\t><img data-dojo-attach-point=\"indeterminateHighContrastImage\" class=\"dijitProgressBarIndeterminateHighContrastImage\" alt=\"\"\n/></div>\n"}});
define("dijit/ProgressBar", [
	"require",			// require.toUrl
	"dojo/_base/declare", // declare
	"dojo/dom-class", // domClass.toggle
	"dojo/_base/lang", // lang.mixin
	"dojo/number", // number.format
	"./_Widget",
	"./_TemplatedMixin",
	"dojo/text!./templates/ProgressBar.html"
], function(require, declare, domClass, lang, number, _Widget, _TemplatedMixin, template){

// module:
//		dijit/ProgressBar


return declare("dijit.ProgressBar", [_Widget, _TemplatedMixin], {
	// summary:
	//		A progress indication widget, showing the amount completed
	//		(often the percentage completed) of a task.
	//
	// example:
	// |	<div data-dojo-type="ProgressBar"
	// |		 places="0"
	// |		 value="..." maximum="...">
	// |	</div>

	// progress: [const] String (Percentage or Number)
	//		Number or percentage indicating amount of task completed.
	//		Deprecated.   Use "value" instead.
	progress: "0",

	// value: String (Percentage or Number)
	//		Number or percentage indicating amount of task completed.
	//		With "%": percentage value, 0% <= progress <= 100%, or
	//		without "%": absolute value, 0 <= progress <= maximum.
	//		Infinity means that the progress bar is indeterminate.
	value: "",

	// maximum: [const] Float
	//		Max sample number
	maximum: 100,

	// places: [const] Number
	//		Number of places to show in values; 0 by default
	places: 0,

	// indeterminate: [const] Boolean
	//		If false: show progress value (number or percentage).
	//		If true: show that a process is underway but that the amount completed is unknown.
	//		Deprecated.   Use "value" instead.
	indeterminate: false,

	// label: String?
	//		Label on progress bar.   Defaults to percentage for determinate progress bar and
	//		blank for indeterminate progress bar.
	label:"",

	// name: String
	//		this is the field name (for a form) if set. This needs to be set if you want to use
	//		this widget in a dijit/form/Form widget (such as dijit/Dialog)
	name: '',

	templateString: template,

	// _indeterminateHighContrastImagePath: [private] URL
	//		URL to image to use for indeterminate progress bar when display is in high contrast mode
	_indeterminateHighContrastImagePath:
		require.toUrl("./themes/a11y/indeterminate_progress.gif"),

	postMixInProperties: function(){
		this.inherited(arguments);

		// Back-compat for when constructor specifies indeterminate or progress, rather than value.   Remove for 2.0.
		if(!(this.params && "value" in this.params)){
			this.value = this.indeterminate ? Infinity : this.progress;
		}
	},

	buildRendering: function(){
		this.inherited(arguments);
		this.indeterminateHighContrastImage.setAttribute("src",
			this._indeterminateHighContrastImagePath.toString());
		this.update();
	},

	update: function(/*Object?*/attributes){
		// summary:
		//		Internal method to change attributes of ProgressBar, similar to set(hash).  Users should call
		//		set("value", ...) rather than calling this method directly.
		// attributes:
		//		May provide progress and/or maximum properties on this parameter;
		//		see attribute specs for details.
		// example:
		//	|	myProgressBar.update({'indeterminate': true});
		//	|	myProgressBar.update({'progress': 80});
		//	|	myProgressBar.update({'indeterminate': true, label:"Loading ..." })
		// tags:
		//		private

		// TODO: deprecate this method and use set() instead

		lang.mixin(this, attributes || {});
		var tip = this.internalProgress, ap = this.domNode;
		var percent = 1;
		if(this.indeterminate){
			ap.removeAttribute("aria-valuenow");
		}else{
			if(String(this.progress).indexOf("%") != -1){
				percent = Math.min(parseFloat(this.progress)/100, 1);
				this.progress = percent * this.maximum;
			}else{
				this.progress = Math.min(this.progress, this.maximum);
				percent = this.maximum ? this.progress / this.maximum : 0;
			}
			ap.setAttribute("aria-valuenow", this.progress);
		}

		// Even indeterminate ProgressBars should have these attributes
		ap.setAttribute("aria-labelledby", this.labelNode.id);
		ap.setAttribute("aria-valuemin", 0);
		ap.setAttribute("aria-valuemax", this.maximum);
		
		this.labelNode.innerHTML = this.report(percent);

		domClass.toggle(this.domNode, "dijitProgressBarIndeterminate", this.indeterminate);
		tip.style.width = (percent * 100) + "%";
		this.onChange();
	},

	_setValueAttr: function(v){
		this._set("value", v);
		if(v == Infinity){
			this.update({indeterminate:true});
		}else{
			this.update({indeterminate:false, progress:v});
		}
	},

	_setLabelAttr: function(label){
		this._set("label", label);
		this.update();
	},

	_setIndeterminateAttr: function(indeterminate){
		// Deprecated, use set("value", ...) instead
		this.indeterminate = indeterminate;
		this.update();
	},

	report: function(/*float*/percent){
		// summary:
		//		Generates message to show inside progress bar (normally indicating amount of task completed).
		//		May be overridden.
		// tags:
		//		extension

		return this.label ? this.label :
				(this.indeterminate ? "&#160;" : number.format(percent, { type: "percent", places: this.places, locale: this.lang }));
	},

	onChange: function(){
		// summary:
		//		Callback fired when progress updates.
		// tags:
		//		extension
	}
});

});

},
'url:dijit/templates/ProgressBar.html':"<div class=\"dijitProgressBar dijitProgressBarEmpty\" role=\"progressbar\"\n\t><div  data-dojo-attach-point=\"internalProgress\" class=\"dijitProgressBarFull\"\n\t\t><div class=\"dijitProgressBarTile\" role=\"presentation\"></div\n\t\t><span style=\"visibility:hidden\">&#160;</span\n\t></div\n\t><div data-dojo-attach-point=\"labelNode\" class=\"dijitProgressBarLabel\" id=\"${id}_label\"></div\n\t><img data-dojo-attach-point=\"indeterminateHighContrastImage\" class=\"dijitProgressBarIndeterminateHighContrastImage\" alt=\"\"\n/></div>\n",
'url:epi-cms/widget/templates/FileList.html':"﻿<div class=\"epi-multiFileUpload-list\">\r\n    <div data-dojo-type=\"dijit/ProgressBar\" data-dojo-attach-point=\"progressBar\" data-dojo-props=\"maximum:100\"></div>\r\n</div>",
'epi/shell/form/uploader/HTML5':function(){
define("epi/shell/form/uploader/HTML5", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/form/uploader/plugins/HTML5",
    "epi/shell/request/mutators",
    "epi/shell/applicationSettings",
    "epi/shell/XhrWrapper"
], function (
    declare,
    lang,
    HTML5,
    mutators,
    applicationSettings,
    XhrWrapper) {

    var plugin = declare([HTML5], {
        // summary:
        //      Extends the dojox HTML5 uploader plugin with support for adding headers to the upload request
        // tags:
        //      internal

        _headers: null,

        uploadWithFormData: function (/*Object*/ data) {
            // summary:
            //      Overridden to add custom headers appended by the epi/shell/request/mutators chain
            //      to the upload request

            return this._getHeadersThenExecute(this.getInherited(arguments), arguments);
        },

        sendAsBinary: function (/*Object*/ data) {
            // summary:
            //      Overridden to add custom headers appended by the epi/shell/request/mutators chain
            //      to the upload request

            return this._getHeadersThenExecute(this.getInherited(arguments), arguments);
        },

        createXhr: function () {
            // summary:
            //      Overridden to append any headers added by any 'beforeSend' mutators registered with epi/shell/request/mutators

            var xhr     = this.inherited(arguments),
                headers = this._headers;

            if (headers) {
                for (var key in headers) {
                    if (Object.prototype.hasOwnProperty.call(headers, key)) {
                        xhr.setRequestHeader(key, headers[key]);
                    }
                }
            }
            xhr.setRequestHeader(applicationSettings.antiforgeryTokenHeaderName, XhrWrapper.sharedXsrfHeader);
            return xhr;
        },

        _getHeadersThenExecute: function (uploadMethod, args) {

            // The beforeSend handlers expect an options.headers property.
            var params = {
                options: {
                    headers: {}
                }
            };

            // Calls the base implementation once the headers have been added.
            // The base implementation then calls createXhr where the headers
            // are added to the request
            return mutators.execute("beforeSend", params)
                .then(lang.hitch(this, function (params) {
                    this._headers = params.options.headers;
                    var result = uploadMethod.apply(this, args);
                    this._headers = null;
                    return result;
                }));
        }
    });

    dojox.form.addUploaderPlugin(plugin); //eslint-disable-line no-undef
    return plugin;

});

},
'epi-cms/command/UploadContent':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command",
    "epi/shell/DestroyableByKey",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi/shell/TypeDescriptorManager"
], function (
    declare,
    _Command,
    DestroyableByKey,
    ContentActionSupport,
    ContentReference,
    TypeDescriptorManager
) {
    return declare([_Command, DestroyableByKey], {
        // summary:
        //      A command that starts the upload new content process when executed.
        // tags:
        //      internal

        // fileList: [public] Array
        //      A array of files to upload. When null, only show upload form to
        //      select files for uploading; otherwise, upload files in list.
        fileList: null,

        typeIdentifier: "episerver.core.contentfolder",

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        _execute: function () {
            // summary:
            //      Executes this command; call upload method from model.
            // tags:
            //      protected

            var contentLinkWithoutWorkId = ContentReference.toContentReference(this._getParentLink()).createVersionUnspecificReference();

            this.viewModel.upload(this.fileList, contentLinkWithoutWorkId.toString(), this.createAsLocalAsset);

            this.fileList = null; // clear fileList after uploading, to avoid of displaying last uploaded item on upload dialog.
        },

        _getParentLink: function () {
            // summary:
            //      Gets the link to the parent where the content should be created under.
            //      If the parent is a Content Asset folder the link to the owner content will be returned.
            // tags:
            //      private

            var model = this._getModel();

            if (this.createAsLocalAsset) {
                return model.ownerContentLink ? model.ownerContentLink : model.contentLink;
            }

            return model.contentLink;
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            var model = this._getModel(),
                canExecute = !!model && ContentActionSupport.hasProviderCapability(model.providerCapabilityMask, ContentActionSupport.providerCapabilities.Create) &&
                             ContentActionSupport.hasAccess(model.accessMask, ContentActionSupport.accessLevel.Create),
                isAvailable = canExecute && TypeDescriptorManager.isBaseTypeIdentifier(model ? model.typeIdentifier : "", this.typeIdentifier);

            this.destroyByKey("isSearchingWatch");
            this.viewModel && this.ownByKey("isSearchingWatch", this.viewModel.watch("isSearching", this._onModelChange.bind(this)));

            this.set("isAvailable", isAvailable);
            this.set("canExecute", !!(canExecute && this.viewModel && !this.viewModel.get("isSearching")));
        },

        _getModel: function () {
            return this.model instanceof Array ? this.model.length === 1 ? this.model[0] : null : this.model;
        }
    });
});

},
'epi-cms/command/EditImage':function(){
define([
    // dojo
    "require",
    "dojo/_base/declare",
    "dojo/on",
    "dojo/topic",
    "dojo/when",

    // epi
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/dialog/Dialog",

    // EPi CMS
    "epi-cms/ApplicationSettings",
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.command",
    "epi/i18n!epi/cms/nls/edit.imageeditor",
    "epi/i18n!epi/shell/nls/button"
], function (
    moduleRequire,
    // dojo
    declare,
    on,
    topic,
    when,

    // epi
    dependency,
    TypeDescriptorManager,
    Dialog,

    // EPi CMS
    ApplicationSettings,
    _Command,
    _SelectionCommandMixin,

    // Resources
    resources,
    editorResources,
    buttonResources
) {

    function isImageEditorEnabled() {
        return (ApplicationSettings.imageEditor || {}).enabled;
    }

    return declare([_Command, _SelectionCommandMixin], {
        // tags:
        //      public

        // contentDataStore: [Object] rest store
        //      Used to get content data when model is changed.
        contentDataStore: null,

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed.
        canExecute: false,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconNewWindow",

        label: resources.openineditor,

        tooltip: resources.openineditor,

        _execute: function () {
            var target = this._getTarget();
            if (!target) {
                return;
            }

            this._getContentDataStore().get(target.contentLink).then(function (contentData) {
                if (!contentData) {
                    return;
                }

                var onCallback = function (returnValue) {
                    if (returnValue) {
                        // Request context change when save or save as asset image
                        topic.publish("/epi/shell/context/request", { url: returnValue.dataset.mceSrc ? returnValue.dataset.mceSrc : contentData.previewUrl }, { forceReload: true });
                    }
                };

                var img = document.createElement("img");
                img.src = contentData.previewUrl;

                this.showImageEditorDialog(img, onCallback, onCallback);
            }.bind(this));

        },

        postscript: function () {
            this.inherited(arguments);
            this.contextService = this.contextService || dependency.resolve("epi.shell.ContextService");
            this._typeDescriptorManager = this.typeDescriptorManager || TypeDescriptorManager;
        },

        showImageEditorDialog: function (imageNode, onHide, onCallback) {
            var options = ApplicationSettings.imageEditor || {};
            if (!options.windowHeight) {
                options.windowHeight = 0;
            }
            if (!options.windowWidth) {
                options.windowWidth = 0;
            }
            if (!options.sizePresets) {
                options.sizePresets = [
                    { name: "320*240", width: 320, height: 320 },
                    { name: "640*480", width: 640, height: 480 }
                ];
            }

            moduleRequire(["epi-cms-react/components/image-editor-widget", "xstyle/css!epi-cms-react/components/image-editor-widget.css"],
                function (ImageEditorWidget) {
                    var content = new ImageEditorWidget({
                        resources: editorResources,
                        helpLink: ApplicationSettings.userGuideUrl + "#imageeditor",
                        imageSource: imageNode.src,
                        width: imageNode.width,
                        height: imageNode.height,
                        filename: imageNode.src.replace(/^.*[\\\/]/, "").split(",,")[0],
                        presetOptions: options.sizePresets,
                        readOnly: !isImageEditorEnabled(),
                        onChange: function (value) {
                            if (value) {
                                imageNode.src = value;
                                imageNode.dataset.mceSrc = value;
                            }
                        }
                    });

                    var dialog = new Dialog({
                        dialogClass: "epi-dialog--wide",
                        defaultActionsVisible: true,
                        confirmActionText: buttonResources.save,
                        content: content,
                        title: editorResources.title,
                        focusActionsOnLoad: true,
                        validate: function () {
                            content.onDialogSubmit();
                            return false;
                        }
                    });
                    on.once(dialog, "execute", function (value) {
                        onCallback(imageNode, value);
                    });
                    on.once(dialog, "cancel", function () {
                        onHide();
                    });
                    dialog.own(content.on("rendercompleted", function () {
                        dialog.resize();
                    }));

                    if (options.windowWidth) {
                        dialog.containerNode.style.width = options.windowWidth + "px";
                    }

                    if (options.windowHeight) {
                        dialog.containerNode.style.height = options.windowHeight + "px";
                    }

                    dialog.show();
                }.bind(this));
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            if (!isImageEditorEnabled()) {
                if (this.get("isAvailable")) {
                    this.set("isAvailable", false);
                }
                this.set("canExecute", false);
                return;
            }

            var target = this._getTarget(),
                canExecute = target &&  // Ensure there is something selected.
                    this._typeDescriptorManager.isBaseTypeIdentifier(target.typeIdentifier, "episerver.core.icontentimage");  // Check that it is image content.

            if (canExecute) {
                var supportedEditExtensions = (ApplicationSettings.imageEditor || {}).supportedEditExtensions;
                if (!supportedEditExtensions) {
                    canExecute = false;
                } else {
                    canExecute = supportedEditExtensions.some(function (ext) {
                        return target.name.toLowerCase().endsWith(ext);
                    });
                }
            }

            this.set("isAvailable", !!canExecute);
            this.set("canExecute", !!canExecute);

        },

        _getTarget: function () {
            // summary:
            //      Returns the target for the file operation from the current selection.
            // tags:
            //      protected

            return this._getSingleSelectionData();
        },

        _getContentDataStore: function () {
            // summary:
            //      Gets the content data store from store registry if it's not already cached

            if (!this.contentDataStore) {
                var registry = dependency.resolve("epi.storeregistry");
                this.contentDataStore = registry.get("epi.cms.contentdata");
            }
            return this.contentDataStore;
        }
    });
});

},
'epi-cms/command/DownloadMedia':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/has",
    "dojo/sniff",
    "dojo/when",

    // EPi Framework
    "epi/shell/Downloader",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.command"
],
function (
// Dojo
    declare,
    Deferred,
    domConstruct,
    has,
    sniff,
    when,

    // EPi Framework
    Downloader,
    TypeDescriptorManager,
    _Command,
    _SelectionCommandMixin,

    // Resources
    resources
) {
    return declare([_Command, _SelectionCommandMixin], {
        // summary:
        //      Download command that used to force download media file from browser by javascript.
        //
        // tags:
        //      internal

        label: resources.download,

        tooltip: resources.download,

        iconClass: "epi-iconDownload",

        _execute: function () {
            var contentData = this._getContentData();
            if (!contentData) {
                return;
            }

            Downloader.download(contentData.downloadUrl, contentData.name);
        },

        _onModelChange: function () {
            var contentData = this._getContentData(),
                isDowloadLinkAvailable = contentData && contentData.downloadUrl,
                typeIdentifier = contentData && contentData.typeIdentifier,
                typeShouldActAsAsset = typeIdentifier && TypeDescriptorManager.getValue(typeIdentifier, "actAsAnAsset"),
                canExecute = !!(typeShouldActAsAsset && isDowloadLinkAvailable);
            this.set("isAvailable", canExecute);
            this.set("canExecute", canExecute);
        },

        _getContentData: function () {
            // summary:
            //      Get current selected content data by selection
            // tags:
            //      private

            var selectionData = null;
            if (this.selection && this.selection.data && this.selection.data instanceof Array && this.selection.data.length === 1) {
                selectionData = this.selection.data[0].data;
            }

            return selectionData;
        }
    });
});

},
'epi-cms/asset/command/UploadContentToSelection':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/shell/DestroyableByKey",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi/shell/TypeDescriptorManager"
], function (
    declare,
    _Command,
    _SelectionCommandMixin,
    DestroyableByKey,
    ContentActionSupport,
    ContentReference,
    TypeDescriptorManager
) {
    return declare([_Command, DestroyableByKey, _SelectionCommandMixin], {
        // summary:
        //      A command that starts the upload new content process when executed.
        // tags:
        //      internal

        // fileList: [public] Array
        //      A array of files to upload. When null, only show upload form to
        //      select files for uploading; otherwise, upload files in list.
        fileList: null,

        typeIdentifier: "episerver.core.contentfolder",

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        _execute: function () {
            // summary:
            //      Executes this command; call upload method from model.
            // tags:
            //      protected

            var contentLinkWithoutWorkId = ContentReference.toContentReference(this._getParentLink()).createVersionUnspecificReference();

            this.viewModel.upload(this.fileList, contentLinkWithoutWorkId.toString(), this.createAsLocalAsset);

            this.fileList = null; // clear fileList after uploading, to avoid of displaying last uploaded item on upload dialog.
        },

        _getParentLink: function () {
            // summary:
            //      Gets the link to the parent where the content should be created under.
            //      If the parent is a Content Asset folder the link to the owner content will be returned.
            // tags:
            //      private

            var model = this._getSingleSelectionData();

            if (this.createAsLocalAsset) {
                return model.ownerContentLink ? model.ownerContentLink : model.contentLink;
            }

            return model.contentLink;
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            var model = this._getSingleSelectionData(),
                canExecute = !!model && ContentActionSupport.hasProviderCapability(model.providerCapabilityMask, ContentActionSupport.providerCapabilities.Create) &&
                             ContentActionSupport.hasAccess(model.accessMask, ContentActionSupport.accessLevel.Create),
                isAvailable = canExecute && TypeDescriptorManager.isBaseTypeIdentifier(model ? model.typeIdentifier : "", this.typeIdentifier);

            this.set("isAvailable", isAvailable);
            this.set("canExecute", !!(canExecute && this.viewModel && !this.viewModel.get("isSearching")));
        },

        _viewModelSetter: function (value) {
            this.viewModel = value;
            this.destroyByKey("isSearchingWatch");
            this.viewModel && this.ownByKey("isSearchingWatch", this.viewModel.watch("isSearching", this._onModelChange.bind(this)));
        }
    });
});

},
'epi-cms/asset/HierarchicalList':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/keys",
    "dojo/on",
    "dojo/when",

    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",
    "dijit/layout/BorderContainer", // Used in template

    // dojox
    "dojox/html/entities",

    // epi
    "epi/string",
    "epi/shell/command/_WidgetCommandBinderMixin",
    "epi-cms/component/command/NewBlock",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/DestroyableByKey",
    "epi/shell/DialogService",

    "epi/shell/widget/ContextMenu",
    "epi/shell/widget/SearchBox",
    "epi-cms/widget/FolderTree",
    "epi-cms/widget/ContentList",
    "./view-model/HierarchicalListViewModel",
    "epi/shell/dnd/tree/multiDndSource",

    // template
    "dojo/text!./templates/HierarchicalList.html",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.hierachicallist"
],

function (
// dojo
    array,
    declare,
    lang,
    aspect,
    domClass,
    domGeometry,
    domStyle,
    keys,
    on,
    when,

    // dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,
    BorderContainer,

    //dojox
    htmlEntities,

    // epi
    epistring,

    _WidgetCommandBinderMixin,
    NewBlockCommand,
    _ModelBindingMixin,
    DestroyableByKey,
    dialogService,

    ContextMenu,
    SearchBox,
    FolderTree,
    ContentList,
    HierarchicalListViewModel,
    multiDndSource,

    // template
    template,

    // Resources
    res
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin, _WidgetCommandBinderMixin, DestroyableByKey], {
        // summary:
        //      Base widget for displaying the panel with tree on top and list for displaying leaf's items, as well as the search box on very top.
        // tags:
        //      internal xproduct abstract

        // contextMenu: [protected] epi/shell/widget/ContextMenu
        //      The context menu widget
        contextMenu: null,

        templateString: template,

        showRoot: false,

        // showThumbnail: [public] Boolean
        //      Flag to indicate this widget allowed to show a thumbnail in the list.
        showThumbnail: false,

        // showCreateContentArea: [public] Boolean
        //      Flag to indicate this widget allowed to show create content area by default or not.
        showCreateContentArea: false,

        triggerContextChange: false,

        res: res,

        modelClassName: HierarchicalListViewModel,

        // hierarchicalListClass: [readonly] String
        //      The CSS class to be used on the hierarchical list.
        hierarchicalListClass: "",

        // noDataMessages: [public] Object
        //      Object containing the texts for when the list contains no items. It should have two properties named single and multiple.
        noDataMessages: null,

        // noSearchResultMessage: [public] String
        //      No search result message for search result list.
        noSearchResultMessage: res.nosearchresults,

        // createContentIcon: [public] String
        //      The icon class to be used in the create content area of the list.
        createContentIcon: "",

        // createContentText: [public] String
        createContentText: "",

        // dndSource: [public] multiDndSource
        //      The dnd source to use for the tree
        dndSource: multiDndSource,

        // additionalTreeClass: [public] String
        //      Additional CSS class that will be applied to the tree element
        additionalTreeClass: "epi-secondaryGadgetContainer",

        modelBindingMap: {
            searchRoots: ["searchRoots"],
            searchArea: ["searchArea"],
            listQuery: ["listQuery"],
            treePaths: ["treePaths"],
            selectedListItems: ["selectedListItems"],
            searchListQuery: ["searchListQuery"],
            noDataMessage: ["noDataMessage"]
        },

        _setSearchAreaAttr: function (value) {
            this.searchBox.set("area", value);
        },

        _setSelectedListItemsAttr: function (value) {
            this.list.grid.clearSelection();
            (value || []).forEach(function (selectedItem) {
                this.list.grid.select(selectedItem.contentLink);
            }, this);
            this._set("selectedListItems", value);
        },

        _setSearchRootsAttr: function (value) {
            this.searchBox.set("searchRoots", value);
        },

        _setListQueryAttr: function (value) {
            this.list.set("query", value);
        },

        _setNoDataMessageAttr: function (value) {
            this.list.set("noDataMessage", value);
        },

        _setSearchListQueryAttr: function (value) {
            this.searchResultList.set("query", value);
            this._showSearchResults(value);
        },

        _setTreePathsAttr: function (value) {
            // Tree setter for paths attribute returns promise to indicate when the set is complete.
            // We can use this deferred when setting selectedListItems.
            return this.tree.set("paths", value);
        },

        _setShowRootAttr: function (value) {
            this.tree.set("showRoot", value);
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model && !this.commandProvider && this.modelClassName) {
                var modelClass = declare(this.modelClassName);
                this.model = this.commandProvider = new modelClass({
                    componentId: this.componentId,
                    repositoryKey: this.repositoryKey,
                    noDataMessages: this.noDataMessages,
                    isInQuickEditMode: this.isInQuickEditMode,
                    quickEditBlockId: this.quickEditBlockId
                });
            }

            this.setupContextMenu();
        },

        setupContextMenu: function () {
            // summary: set up the context menu
            //
            // tags:
            //      public
            this.own(this.contextMenu = new ContextMenu({ category: "context", popupParent: this }));
            this.contextMenu.addProvider(this.model);
        },

        postCreate: function () {
            this.inherited(arguments);

            domClass.add(this.domNode, this.hierarchicalListClass);

            this._setupTree();
            this._setupCreateContentArea();
            this._setupList();

            this._toggleCreateContentArea(this.showCreateContentArea);

            // Watching instead of binding since we need the old value as well
            this.own(
                this.model.clipboardManager.watch("data", lang.hitch(this, this._updateClipboardIndicators)),
                this.searchBox.on("searchBoxChange", lang.hitch(this, this._onSearchTextChanged))
            );
        },

        startup: function () {
            this.inherited(arguments);

            this.model.startup();


            if (this.contextMenu) {
                this.contextMenu.startup();
            }
        },

        destroy: function () {
            this.model.destroy();

            this.inherited(arguments);
        },

        layout: function () {
            var searchBoxSize = domGeometry.getMarginBox(this.searchBoxNode),
                containerSize = {
                    h: this._contentBox.h - searchBoxSize.h,
                    w: this._contentBox.w,
                    l: this._contentBox.l,
                    t: this._contentBox.t
                };

            this.container.resize(containerSize);
        },

        _toggleCreateContentArea: function (display) {
            // summary:
            //      Toggle display of the create content area
            // display: [Boolean]
            // tags:
            //      protected

            domStyle.set(this.createContentArea.domNode, "display", display ? "" : "none");

            // Since the create area may no longer be visible we need to re-layout the container to ensure
            // the contents are displayed correctly.
            this.listContainer.layout();
        },

        _toggleActive: function (activeWidget) {
            // summary:
            //      Toggle visual indication between tree and list

            var listActiveClass = "epi-list--is-active";
            var treeActiveClass = "epi-tree--is-active";

            if (activeWidget === this.tree) {
                domClass.replace(this.domNode, treeActiveClass, listActiveClass);
            } else {
                domClass.replace(this.domNode, listActiveClass, treeActiveClass);
            }
        },

        _showNotification: function (message) {
            // summary:
            //      Uses the alert dialog implementation to show notification with the supplied message
            //
            // message:
            //      html encoded string to show in notification dialog
            //
            // tags:
            //      public callback

            dialogService.alert(epistring.toHTML(message));
        },

        _onSearchTextChanged: function (searchText) {
            // summary:
            //      Callback method for when the user has search for some content
            // tags:
            //      private callback

            this.model.setSearchText(searchText);
        },

        _showSearchResults: function (searchQuery) {
            domStyle.set(this.contentNode, "display", searchQuery ? "none" : "");
            domStyle.set(this.resultNode, "display", !searchQuery ? "none" : "");
            this.container.layout();
        },

        _setupTree: function () {
            // summary:
            //      Implementation should implement this, to setup the content tree. For example, command binding.
            //
            // tags:
            //      protected

            var registry = this.model._commandRegistry;

            function copyOrCuthandler(copy) {
                copy ? registry.copy.command.execute() : registry.cut.command.execute();
            }

            this.own(
                on(this.tree, "copyOrCut", copyOrCuthandler),
                on(this.tree, "paste", function () {
                    registry.paste.command.execute();
                }),
                on(this.tree, "delete", function () {
                    registry["delete"].command.execute();
                }),
                aspect.after(this.tree, "onFocus", function () {
                    this.model.updateTreeCommands();
                    this._toggleActive(this.tree);
                }.bind(this)),
                aspect.after(this.tree.rootNode, "setChildItems", function (childItems) {
                    this.model.updateTreePaths(childItems);
                }.bind(this), true)
            );

            if (this.contextMenu) {
                this.own(on(this.tree, "showContextMenu", this.contextMenu.forceOpen.bind(this.contextMenu)));
            }

            // start watching "paths" after tree is initialized
            this.tree.onLoadDeferred.then(function () {
                this.own(this.tree.watch("paths", function (property, old, newVal) {
                    this.model.setTreePaths(newVal);
                }.bind(this)));
            }.bind(this));

            registry.rename.command.set("renameDelegate", lang.hitch(this, function (model) {
                this.tree.getNodesByItem(model)[0].edit();
            }));

            // make sure the folder tree only accepts internal dnd operations or dnd from the content list
            this.tree.supportedDndSources = [this.tree.dndController, this.list.grid.dndSource];
        },

        _setupCreateContentArea: function () {
            // summary:
            //      Setup create content area for list widget
            // tags:
            //      protected

            this.createContentAreaButton.set("iconClass", this.createContentIcon);
            this.createContentAreaButton.set("label", this.createContentText);

            this.own(
                // Connect to create new item link when there's no children for the current parent.
                this.createContentAreaButton.on("click", lang.hitch(this, "_onCreateAreaClick"))
            );
        },

        _setupList: function () {
            // summary:
            //      Implementation should implement this, to setup the content list. For example, command binding.
            //
            // tags:
            //      protected
            var registry = this.model._commandRegistry;

            this.own(
                on(this.model, "setPathsAndItems", function (treePaths, selectedListItems) {
                    this.model.set("treePaths", treePaths);
                    // the previous line will trigger set "treePaths" on the view, but this time we want to wait
                    // until it's done and then set "selectedListItems"
                    this.set("treePaths", treePaths).then(function () {
                        // setting "selectedListItems" on model will trigger setting "selectedListItems" on view
                        this.model.set("selectedListItems", selectedListItems);
                    }.bind(this));
                }.bind(this)),
                aspect.after(this.model, "onListItemUpdated", lang.hitch(this.list, function (deferred) {
                    when(deferred, lang.hitch(this, this.editContent));
                })),
                this.searchResultList.grid.addKeyHandler(keys.ESCAPE, lang.hitch(this.searchBox, this.searchBox.clearValue)),
                aspect.after(this.model.treeStoreModel, "onDeleted", lang.hitch(this, function (items) {
                    array.forEach(items, function (item) {
                        var searchResultRow = this.searchResultList.grid.row(item.contentLink);
                        if (searchResultRow && searchResultRow.data) {
                            this.searchResultList.grid.removeRow(searchResultRow);
                        }
                    }, this);
                }), true),
                aspect.after(this.list, "onFocus", function () {
                    this.model.updateListCommands();
                    this._toggleActive(this.list);
                }.bind(this)),
                on(this.searchResultList, "selectionChanged",function (e) {
                    this.model.setSelectedSearchResults(e.selection);
                }.bind(this)),
                on(this.list, "selectionChanged",function (e) {
                    this.model.setSelectedListItems(e.selection);
                }.bind(this)),
                on(this.list.grid.domNode, "dgrid-refresh-complete", function () {
                    var selectedItems = this.get("selectedListItems");
                    this.list.grid.clearSelection();
                    if (selectedItems) {
                        selectedItems.forEach(function (item) {
                            this.list.grid.select(item.contentLink);
                        }, this);
                    }
                }.bind(this))
            );

            this.searchBox.on("keyup", lang.hitch(this, function (e) {
                if (e.keyCode === keys.ENTER) {
                    e.preventDefault();
                    this.searchResultList.editSelectedContent();
                }
            }));

            this.searchBox.on("keydown", lang.hitch(this, function (e) {
                if (e.keyCode === keys.DOWN_ARROW || e.keyCode === keys.UP_ARROW) {
                    e.preventDefault();
                    this.searchResultList.grid.moveSelection(e.keyCode === keys.UP_ARROW);
                }
            }));

            if (this.model.changeContextOnItemSelection) {
                var itemSelectAction =  function () {
                    registry.edit.command.execute();
                };
                this.own(
                    on(this.list, "itemAction", itemSelectAction),
                    on(this.searchResultList, "itemAction", itemSelectAction)
                );
            }
            if (this.showThumbnail) {
                domClass.add(this.list.grid.domNode, "epi-thumbnailContentList");
                domClass.add(this.searchResultList.grid.domNode, "epi-thumbnailContentList");
            }
            this.list.set("selectionMode", "extended");
            this.searchResultList.set("selectionMode", "extended");
            this.searchResultList.set("noDataMessage", this.noSearchResultMessage);

            this._handleListKeyEvents();
        },

        _handleListKeyEvents: function () {
            // summary:
            //      Listen to list key events and run related commands
            // tags:
            //      private

            var registry = this.model._commandRegistry,
                listWidget = this.list;

            this.own(
                on(listWidget, "copyOrCut", function copyOrCuthandler(copy) {
                    copy ? registry.copy.command.execute() : registry.cut.command.execute();
                }),

                on(listWidget, "paste", function () {
                    // paste command is not available for the list, but for the tree
                    // We need to focus tree to enable command
                    this.tree.focus();
                    registry.paste.command.execute();
                }.bind(this)),

                on(listWidget, "delete", function () {
                    registry["delete"].command.execute();
                })
            );
        },

        _onCreateAreaClick: function () {
            // summary:
            //      A callback function which is executed when the create area is clicked.
            // tags:
            //      protected
        },

        // =======================================================================
        // Clipboard handling

        _updateClipboardIndicators: function (name, oldValues, newValues) {

            var isCopy = this.model.clipboardManager.isCopy();

            if (oldValues instanceof Array) {
                array.forEach(oldValues, function (clip) {
                    this.tree.toggleCut(clip.data, false);
                    this.list.toggleCut(clip.data, false);
                    this.searchResultList.toggleCut(clip.data, false);
                }, this);
            }

            if (!isCopy && newValues instanceof Array) {
                array.forEach(newValues, function (clip) {
                    this.tree.toggleCut(clip.data, true);
                    this.list.toggleCut(clip.data, true);
                    this.searchResultList.toggleCut(clip.data, true);
                }, this);
            }
        }

    });

});

},
'epi-cms/component/command/NewBlock':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/when",
    // epi
    "epi/shell/DestroyableByKey",
    "epi/dependency",

    "epi-cms/ApplicationSettings",
    // command
    "epi-cms/command/NewContent",

    // resource
    "epi/i18n!epi/cms/nls/episerver.cms.components.createblock"
],

function (
// dojo
    declare,
    when,
    // epi
    DestroyableByKey,
    dependency,

    ApplicationSettings,
    // command
    NewContentCommand,

    // resource
    resCreateBlock
) {

    return declare([NewContentCommand, DestroyableByKey], {
        // summary:
        //      New block command specially brewed for the SharedBlocksViewModel it will be disabled if the user is searching for content
        // tags:
        //      internal

        contentType: "episerver.core.blockdata",
        iconClass: "epi-iconCreateSharedBlock",
        label: resCreateBlock.command.label,
        resources: resCreateBlock,

        viewModel: null,

        _onModelChange: function () {

            // Listen to changes to the isSearching property on the view model and re-execute the onModelChange method to trigger
            // the canExecute methods to be re-evaluated
            if (this.viewModel && this.viewModel.watch) {
                this.destroyByKey("isSearchingWatch");
                this.ownByKey("isSearchingWatch", this.viewModel.watch("isSearching", this._onModelChange.bind(this)));
            }

            this.inherited(arguments);
        },

        _canExecute: function () {
            // summary:
            //      Determines if the command can be executed and taking isSearching into calculations
            // tags:
            //      protected overridden

            var canExecute = this.inherited(arguments);

            var self = this;
            function isSearching() {
                if (!self.viewModel || !self.viewModel.get) {
                    return false;
                }
                return self.viewModel.get("isSearching");
            }

            // If the user is searching for content can execute should be false
            return canExecute && !isSearching();
        },

        _checkAvailability: function () {
            if (ApplicationSettings.limitUI) {
                if (!this.model.capabilities.isContentFolder) {
                    return false;
                }
            }

            return this.inherited(arguments);
        }
    });
});

},
'epi-cms/widget/FolderTree':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-class",

    "dojo/aspect",
    "dojo/json",
    "dojo/when",
    // dojox
    "dojox/html/entities",
    // dijit
    "dijit/tree/_dndSelector",
    // epi
    "epi/dependency",
    "epi/string",

    "epi/shell/widget/_FocusableMixin",

    "epi-cms/widget/_FolderTreeNode",
    "epi-cms/widget/ContentTree",
    "epi-cms/widget/ContentTreeStoreModel"
],

function (
// dojo
    array,
    declare,
    lang,

    domAttr,
    domClass,

    aspect,
    json,
    when,
    // dojox
    htmlEntities,
    // dijit
    _dndSelector,
    // epi
    dependency,
    epiString,

    _FocusableMixin,

    _FolderTreeNode,
    ContentTree,
    ContentTreeStoreModel
) {

    return declare([ContentTree, _FocusableMixin], {
        // summary:
        //      The EPiServer block folder tree.
        // description:
        //      The block folder tree shows the EPiServer CMS block folder tree using a REST store to fetch the data.
        // tags:
        //      internal

        // handleSelection: [public] Boolean
        //      Flag that indicates this tree need to reset selection each time it had refresh
        handleSelection: true,

        postCreate: function () {

            var self = this;

            self.inherited(arguments);

            self.own(
                self.connect(self.model, "onDeleted", lang.hitch(self, self._onDeleted)),
                aspect.around(self.model, "onRefreshRoots", function (original) {
                    return function (refreshItem) {
                        if (refreshItem && typeof self._onItemDelete === "function") {
                            self._onItemDelete(refreshItem);
                        }

                        return original.apply(self.model, [refreshItem]);
                    };
                })
            );
        },

        toggleCut: function (/*Object*/item, /*Boolean*/isCut) {
            // summary
            //      Mark folder is cutting
            // item:
            //      Object are cutting and save on clipboard
            // tags:
            //      public

            var node = this.tree.getNodesByItem(item)[0];
            if (node) {
                domClass.toggle(node.rowNode, "epi-opacity50", isCut);
            }
        },

        _createTreeModel: function () {
            // summary:
            //      Create content tree model
            // tags:
            //      protected override

            return new ContentTreeStoreModel({
                store: this.store
            });
        },

        _updateItemDeletedHierachy: function (/* Folder tree node */node) {
            // summary:
            //      Manualy mark node's item is deleted descendant (recursive)
            // node: Tree node
            //      The deleted node
            // tags:
            //      Private

            if (!node) {
                return;
            }

            array.forEach(node.getChildren(), function (childNode) {
                childNode.set({ item: lang.mixin(childNode.item, { isDeleted: true }) });
                this._updateItemDeletedHierachy(childNode); // call recursive
            }, this);
        },

        _onDeleted: function (/* Model's item */item) {
            // summary:
            //      Handler onDeleted event that is raised after folder is deleted
            // item: Folder item
            //      The folder was deleted
            // tags:
            //      Private

            var nodes = this.getNodesByItem(item);

            array.forEach(nodes, function (node) {
                this._updateItemDeletedHierachy(node);
            }, this);
        },

        _renameFolder: function (item, name) {
            var newName = lang.trim(name),
                treeNode = this.getNodesByItem(item)[0];

            if (newName) {
                when(this.model.rename(item.contentLink, newName)).otherwise(
                    function (ex) {
                        treeNode.rollbackLabel(item.name, ex);
                        treeNode.edit();
                    });

            } else {
                treeNode.rollbackLabel(item.name);
            }
        },

        buildNodeFromTemplate: function (/*Object*/args) {
            // summary:
            //      Build tree node from the given template.
            // args:
            //      Tree node creation arguments
            // tags:
            //      extension

            var treeNode = new _FolderTreeNode(args);

            treeNode.bindContextMenu(this.contextMenu);

            this.own(
                treeNode.on("rename", lang.hitch(this, function (val) {
                    this._renameFolder(treeNode.item, val);
                }))
            );

            return treeNode;
        },

        _onNodeMouseEnter: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse enter event on a node
            // tags:
            //      private

            this.inherited(arguments);
            node._handleMouseEnter();
        },

        _onNodeMouseLeave: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse leave event on a node
            // tags:
            //      private

            this.inherited(arguments);
            node._handleMouseLeave();
        },

        _onClick: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse leave event on a node
            // tags:
            //      private

            this.inherited(arguments);
            node._onClick();
        },

        checkAcceptance: function (source, nodes) {
            // summary:
            //      Check if the target can accept nodes from this source.
            //      In the case supportedDndSources is provided, only sources from there will be accepted
            // source: Object
            //      the source which provides items
            // nodes: Array
            //      the list of transferred items
            // tags:
            //      public override

            if (this.tree.supportedDndSources) {
                return this.tree.supportedDndSources.indexOf(source) >= 0;
            } else {
                return this.inherited(arguments);
            }
        }
    });

});

},
'epi-cms/widget/_FolderTreeNode':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/Evented",
    "dojo/Deferred",
    "dojo/keys",
    "dojo/on",
    "dojo/when",

    "dojox/html/entities",

    // template
    "dojo/text!./templates/_FolderTreeNode.html",
    // dijit
    "dijit/form/TextBox",
    "dijit/form/ValidationTextBox",

    "dijit/InlineEditBox",
    // epi
    "epi",
    "epi-cms/widget/_ContentTreeNode"
],

function (
// dojo
    declare,
    lang,

    domAttr,
    domClass,
    domGeom,
    domStyle,

    Evented,
    Deferred,
    keys,
    on,
    when,
    htmlEntities,
    // template
    template,
    // dijit
    TextBox,
    ValidationTextBox,

    InlineEditBox,
    // epi
    epi,
    _ContentTreeNode
) {

    declare("_TreeInlineEditor", [InlineEditBox._InlineEditor], {
        // tags:
        //      internal

        postCreate: function () {
            this.inherited(arguments);

            this.own(
                on(this.domNode, "mousedown, mouseup, click, keydown, keypress, selectstart", function (e) {
                    e.stopPropagation();
                })
            );
        }
    });

    return declare([_ContentTreeNode, Evented], {
        // summary:
        //      A customized treenode for block folder tree
        // tags:
        //      public

        templateString: template,

        _blockFolderMenu: "epi-iconContextMenu",

        _blockFolderDnDIcon: "epi-iconDnD",

        _blockFolderExpand: "epi-iconObjectFolderOpen",

        _blockFolderCollapse: "epi-iconObjectFolder",

        _isResetValue: false,

        _menuTooltip: undefined,

        contextMenu: null,

        _editWidget: null,

        // _rowStates: Enum flag
        _rowStates: {
            NORMAL: 1,
            EXPANDED: 2,
            ENTERED: 4,
            SELECTED: 8
        },

        _currentRowState: 1, /* NORMAL row state by default */

        postMixInProperties: function () {
            this.inherited(arguments);
            this._menuTooltip = epi.resources.action.options;
        },

        postCreate: function () {
            this.inherited(arguments);

            domStyle.set(this.iconNodeMenu, "zIndex", domGeom.position(this.rowNode).zIndex + 1);
            this._updateStyle();
        },

        buildRendering: function () {
            this.inherited(arguments);

            this.labelWidget = new InlineEditBox({
                value: this.label,
                editorWrapper: "_TreeInlineEditor",
                editor: "dijit/form/ValidationTextBox",
                width: "auto",
                editorParams: { maxLength: 255 },
                _onMouseOver: function () { /* disable style hover*/ },
                _onClick: function () { /* disable default onclick on editor*/ },
                onChange: lang.hitch(this, this._onChangeLabelValue),
                onCancel: lang.hitch(this, function () {
                    this.emit("cancelEdit", this.item.contentLink);
                    this._resetValue();
                    this._setEditorState();
                })
            }, this.labelNode);

        },

        edit: function () {
            //We need to specificly make sure that the value is updated since the model might have changed and dijit/Tree only updates the value
            //for the dom node, thus making the visual value and the value of the label widget out of sync.
            this.labelWidget.value = this.label;

            this.labelWidget.edit();
            this._editWidget = this.labelWidget.wrapperWidget.editWidget;
            this.own(
                on(this._editWidget.domNode, "keydown", lang.hitch(this, function (e) {
                    if (!this._editWidget.isValid() && e.keyCode !== keys.ENTER) {
                        this._setEditorState();
                    }
                }))
            );
        },

        _resetValue: function (val) {
            // summary:
            //      Reset value of folder name
            // val: [String]
            //      The name of folder
            // tags:
            //      private

            this._isResetValue = true;
            this.labelWidget.set("value", val || this.label);
        },

        _onChangeLabelValue: function (val) {
            // summary:
            // tags:
            //      private

            if (!val) {
                this._resetValue();
                return;
            }

            if (!this._isResetValue) {
                this.emit("rename", val);
            }

            // reset flag to default
            this._isResetValue = false;
        },

        _onClick: function (evt) {
            this.inherited(arguments);

            domClass.remove(this.labelNode, "dijitInlineEditBoxDisplayModeHover");
            this.emit("nodeSelected", this);
        },

        rollbackLabel: function (val, error) {
            // summary:
            //      Set error for editor and reset value
            // val: [String]
            //      The value rollback
            // error: [Object]
            //      The error object
            // tags:
            //      public

            // Reset if value is null
            if (!this.labelWidget.value) {
                this._resetValue(val);
            }

            // Show error message
            if (error && error.length > 0) {
                this._setEditorState(error[0].errorMessage);
            }
        },

        bindContextMenu: function (menu) {
            this.contextMenu = menu;
            this.connect(this.iconNodeMenu, "onclick", "_onIconNodeMenuClick");
        },

        collapse: function () {
            var self = this,
                def = new Deferred();

            when(self.inherited(arguments), function () {
                self._currentRowState = self._currentRowState ^ self._rowStates.EXPANDED;
                self._updateStyle();
                // collapse successful trigger event here
                def.resolve(true);
            });

            return def;
        },

        expand: function () {
            var self = this,
                def = new Deferred();

            when(self.inherited(arguments), function () {
                self._currentRowState = self._currentRowState | self._rowStates.EXPANDED;
                self._updateStyle();
                // expand successful trigger event here
                def.resolve();
            });

            return def;
        },

        setSelected: function (/*Boolean*/selected) {

            // If the current item data object is not existing, do nothing
            if (!this.tree.getNodesByItem(this.item)[0]) {
                return;
            }

            this.inherited(arguments);

            var oldState = this._currentRowState;
            this._currentRowState = selected ?
                (this._currentRowState | this._rowStates.SELECTED) :
                parseInt(this._currentRowState & this._rowStates.SELECTED, 10) > 0 ? (this._currentRowState ^ this._rowStates.SELECTED) : oldState;
            this._updateStyle();

            if (selected) {
                this.emit("nodeSelected", this);
            }
        },

        setFocusable: function (hasFocus) {
            this.inherited(arguments);

            domClass.toggle(this.domNode, "epi-folderTreeNode--focused", hasFocus);
        },

        _updateIndividualLayout: function () {
            // summary:
            //      update folder icon is expanded or not
            // tags:
            //      private
            this._updateStyleBySingleState();

            if (this.item && this.item.contentLink) {
                this.emit("nodeRefreshed", this.item.contentLink);
            }
        },

        _updateBlockFolderTypeIcon: function () {
            // summary:
            //      Set page type icon for the tree node
            // tags:
            //      private

            if (this._isTypeOfRoot()) {
                this._iconNodeClass = this.tree.model.getObjectIconClass(this.item, this._blockFolderCollapse);
            } else {
                this._iconNodeClass = this.isExpanded ? this._blockFolderExpand : this._blockFolderCollapse;
            }

            // Add new class
            domClass.add(this.iconNode, this._iconNodeClass);
        },

        _handleMouseEnter: function () {
            this._currentRowState = this._currentRowState | this._rowStates.ENTERED;
            this._updateStyle();
            domClass.remove(this.labelNode, "dijitInlineEditBoxDisplayModeHover");
            domClass.add(this.domNode, "epi-folderTreeNode--hovered");
        },

        _handleMouseLeave: function () {
            this._currentRowState = this._currentRowState ^ this._rowStates.ENTERED;
            this._updateStyle();
            domClass.remove(this.domNode, "epi-folderTreeNode--hovered");
        },

        _onIconNodeMenuClick: function (evt) {
            this.contextMenu && this.contextMenu.scheduleOpen(evt.target, null, { x: evt.pageX, y: evt.pageY });
            this.emit("nodeSelected", this);
        },

        _updateStyleBySingleState: function (singleRowState) {
            // summary:
            //      Update style for single state
            // singleRowState: Flag
            //      Single (basic) state of the row node
            // tags:
            //      Private

            var states = this._rowStates;
            switch (singleRowState) {
                case states.SELECTED:
                case states.ENTERED:
                    if (this.contextMenu) {
                        domClass.add(this.iconNodeMenu, this._blockFolderMenu);
                    }
                    break;
                default:
                    /* Clear all style */
                    if (this.contextMenu) {
                        domClass.remove(this.iconNodeMenu, this._blockFolderMenu);
                    }
                    domClass.remove(this.iconNode, this._blockFolderExpand);
                    domClass.remove(this.iconNode, this._blockFolderCollapse);

                    /* Re-apply necessary styles */
                    var nodeClass = this.isExpanded && this.hasChildren() ? this._blockFolderExpand : this._blockFolderCollapse;
                    domClass.add(this.iconNode, this._isTypeOfRoot() ? this.tree.model.getObjectIconClass(this.item, this._blockFolderCollapse) : nodeClass);

                    if (this.contextMenu && parseInt(this._currentRowState & this._rowStates.SELECTED, 10) > 0) {
                        domClass.add(this.iconNodeMenu, this._blockFolderMenu);
                    }

                    break;
            }
        },

        _updateStyle: function () {
            // summary:
            //      Update the style by the current state
            // tags:
            //      Private

            //don't worry about looking stylish if you're being destroyed
            if (this._destroyed) {
                return;
            }

            for (var singleRowState in this._rowStates) {
                if (parseInt(this._currentRowState & this._rowStates[singleRowState], 10) > 0) {
                    this._updateStyleBySingleState(this._rowStates[singleRowState]);
                }
            }
        },

        _addLanguageIndicator: function () {
            // summary:
            //      Setup missing language branch indicator UI
            // tags:
            //      protected override

            this.inherited(arguments);

            domAttr.remove(this.iconNodeLanguage, "title");
        },

        _setEditorState: function (/*String*/ errorMessage) {
            // summary:
            //      Set state error for editor widget if there are error message, otherwise reset state
            // errorMessage: [String]
            //      The error message
            // tags:
            //      private

            if (this._editWidget) {
                errorMessage = htmlEntities.encode(errorMessage);
                this._editWidget.invalidMessage = errorMessage || "";
                this._editWidget.set("state", errorMessage ? "Error" : "");
                this._editWidget.isValid = function () {
                    return !errorMessage;
                };
                this._editWidget.validate();
            }
        }

    });

});

},
'url:epi-cms/widget/templates/_FolderTreeNode.html':"﻿<div class=\"dijitTreeNode epi-folderTreeNode\" role=\"presentation\">\r\n    <div tabindex=\"-1\" data-dojo-attach-point=\"rowNode\" class=\"dijitTreeRow\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-extraIcon dijitTreeIcon\" role=\"presentation\" title=\"${_menuTooltip}\">&nbsp;</span>\r\n                <span data-dojo-attach-point=\"iconNodeLanguage\" class=\"epi-extraIcon epi-ft-currentLanguageMissing\" role=\"presentation\">&nbsp;</span>\r\n            </span>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n        </span>\r\n    </div>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>",
'epi-cms/widget/ContentList':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/connect", // To use isCopyKey()
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-construct",

    "dojo/aspect",
    "dojo/Evented",
    "dojo/keys",
    "dojo/on",

    // dgrid
    "dgrid/Keyboard",
    "dgrid/OnDemandList",
    "dgrid/Selection",
    // dojox
    "dojox/html/entities",
    // epi
    "epi/epi",

    "epi/shell/dgrid/Formatter",
    "epi/shell/dgrid/selection/Extensions",
    "epi/shell/TypeDescriptorManager",

    "epi/shell/widget/_FocusableMixin",

    "epi-cms/core/ContentReference",

    "epi-cms/dgrid/formatters",
    "epi-cms/dgrid/DnD",
    "epi-cms/dgrid/WithContextMenu",

    "epi-cms/widget/ReadOnlyContentList"
],

function (
// dojo
    declare,
    connect,
    lang,

    domClass,
    domConstruct,

    aspect,
    Evented,
    keys,
    on,

    // dgrid
    Keyboard,
    OnDemandList,
    Selection,
    // dojox
    htmlEntities,
    // epi
    epi,

    Formatter,
    SelectionExtensions,
    TypeDescriptorManager,

    _FocusableMixin,

    ContentReference,

    formatters,
    DnD,
    WithContextMenu,

    ReadOnlyContentList
) {

    return declare([ReadOnlyContentList, _FocusableMixin, Evented], {
        // summary:
        //      Base class for lists for different content.
        // description:
        //      This is a base class that can be used to quickly create a list.
        // tags:
        //      public

        // _gridClass: [private] Object
        //      Content grid class declaration
        _gridClass: declare([OnDemandList, Formatter, Selection, SelectionExtensions, DnD, Keyboard, WithContextMenu]),

        // resources: [public] Object
        //      Public resources for grid content list
        resources: "",

        // noDataMessage: [public] String
        //      No data message text for grid content list incase it has no data to display
        noDataMessage: null,

        // editingItem: [public] dojo/data/Item
        //      Keeps the selected content information
        editingItem: null,

        postCreate: function () {

            this.inherited(arguments);

            domClass.add(this.domNode, "epi-contentList");
        },

        _setCurrentItemAttr: function (/*dojo/data/Item*/value) {
            // summary:
            //      Store the selected content information on the first load
            // value: [dojo/data/Item]
            // tags:
            //      protected

            if (!this.get("editingItem")) {
                this.set("editingItem", value);
            }

            this._set("currentItem", value);
            this.select(value);
        },

        _setNoDataMessageAttr: function (/*String*/value) {
            // summary:
            //      Set text message for grid content list incase it has no data.
            // value: [String]
            //      No data message text
            // tags:
            //      protected

            this.noDataMessage = value;
            this.grid.set("noDataMessage", value);
        },

        _dndNodeCreator: function (/*dojo/data/Item*/item, hint) {
            // summary:
            //      Custom DnD avatar creator method
            // item: [dojo/data/Item]
            // hint: [String]
            // tags:
            //      private

            var dndTypes = TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");
            if (!dndTypes && this.dndTypes) {
                dndTypes = this.dndTypes;
            }

            return {
                node: domConstruct.create("div").appendChild(document.createTextNode(item.name)),
                type: dndTypes,
                data: item
            };
        },

        getListSettings: function () {
            // summary:
            //      Initialization a list.
            // tags:
            //      protected, extension

            var menu = {
                hasMenu: !!this.contextMenu,
                settings: {
                    title: epi.resources.action.options
                }
            };

            // Init content list
            return lang.delegate(this._getBaseSettings(menu), {
                noDataMessage: this.noDataMessage,
                dndParams: {
                    copyOnly: true,
                    selfAccept: false,
                    accept: [],
                    creator: lang.hitch(this, this._dndNodeCreator)
                }
            });
        },

        setupEvents: function () {
            // summary:
            //      Initialization events on list.
            // tags:
            //      protected

            this.inherited(arguments);

            this.own(
                aspect.around(this.grid, "insertRow", lang.hitch(this, this._aroundInsertRow)),
                this.grid.on("dgrid-contextmenu", lang.hitch(this, "_itemSelected"))
            );
            this._bindKeys();
        },

        _bindKeys: function () {
            // summary:
            //      Setup key shortcuts for the list
            // tags:
            //      private

            var self = this;
            function addControlKeyHandler(key, eventName, eventValue, skipCtrlCheck) {
                return self.grid.addKeyHandler(key, function (e) {
                    if (skipCtrlCheck || connect.isCopyKey(e)) {
                        e.preventDefault();
                        eventValue ? self.emit(eventName, eventValue) : self.emit(eventName);
                    }
                });
            }

            this.own(
                addControlKeyHandler("C".charCodeAt(0), "copyOrCut", true),
                addControlKeyHandler("X".charCodeAt(0), "copyOrCut", false),
                addControlKeyHandler("V".charCodeAt(0), "paste"),
                addControlKeyHandler(keys.DELETE, "delete", undefined, true)
            );
        },

        _onSelect: function (/*Event*/evt) {
            // summary:
            //      Emit selected event
            // evt: [Event]
            //      Select event of the grid
            // tags:
            //      private

            this.inherited(arguments);

            if (this.grid.selectionMode === "single" && evt.rows[0].data) {
                this._itemSelected(evt.rows[0].element);
            }
        },

        _itemSelected: function (element) {
            var row = this.grid.row(element);
            this.emit("itemSelected", row.data);
        },

        editContent: function (/*dojo/data/Item*/item) {
            // summary:
            //      Enable editing mode for the given content
            // item: [dojo/data/Item]
            //      Content that wanted to edit
            // tags:
            //      public

            // Do nothing if we do not found the given content in the grid
            if (!item || !this.grid.row(item).element) {
                return;
            }

            this.emit("itemAction", item);

            // After the selected content loaded, save its information
            this.set("editingItem", this.currentItem);
        },

        editSelectedContent: function () {
            // summary:
            //      Enable editing mode for the currently selected content
            // tags:
            //      internal

            var selectedRow = this.grid.getFirstSelectedRow();
            if (!selectedRow) {
                return;
            }

            this.editContent(selectedRow.data);
        },

        _onChangeContext: function (evt) {
            // summary:
            //      Go to content edit mode when change context event raised
            // evt: [Event]
            //      The click event that caused the change context.
            // tags:
            //      public

            // Refocus the grid after refreshing the content to ensure that the focus
            // does not end up in neverland.
            var grid = this.grid;
            on.once(grid.domNode, "dgrid-refresh-complete", function (evt) {
                grid.focus(grid.getFirstSelectedRow());
            });

            this.editContent(grid.row(evt).data);
        },

        toggleCut: function (/*dojo/data/Item*/item, /*Boolean*/isCut) {
            // summary:
            //      Toggle cutting styles for the given item in the grid content list
            // item: [dojo/data/Item]
            // isCut: [Boolean]
            // tags:
            //      public

            var row;
            if (item) {
                row = this.grid.row(ContentReference.toContentReference(item.contentLink).id);
                if (row && row.element) {
                    domClass.toggle(row.element, "epi-opacity50", isCut);
                }
            }
        }

    });

});

},
'url:epi-cms/asset/templates/HierarchicalList.html':"﻿<div class=\"epi-hierarchicalList\">\r\n    <div class=\"epi-gadgetInnerToolbar\" data-dojo-attach-point=\"searchBoxNode\">\r\n        <div data-dojo-attach-point=\"searchBox\"\r\n             data-dojo-type=\"epi/shell/widget/SearchBox\"\r\n             data-dojo-props=\"triggerContextChange: this.triggerContextChange, triggerChangeOnEnter: true, encodeSearchText: true\">\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"container\"\r\n         data-dojo-type=\"dijit/layout/BorderContainer\"\r\n         data-dojo-props=\"gutters: false\">\r\n\r\n        <div data-dojo-attach-point=\"contentNode\">\r\n            <div class=\"epi-gadgetTopContainer ${additionalTreeClass}\"\r\n                 data-dojo-attach-point=\"tree\"\r\n                 data-dojo-type=\"epi-cms/widget/FolderTree\"\r\n                 data-dojo-props=\"region:'center', splitter:false, model: this.model.treeStoreModel, showRoot: false, contextMenu: this.contextMenu, dndSource: this.dndSource\"></div>\r\n            <div class=\"epi-gadgetBottomContainer\"\r\n                 data-dojo-attach-point=\"listContainer\"\r\n                 data-dojo-type=\"dijit/layout/BorderContainer\"\r\n                 data-dojo-props=\"region:'bottom', splitter:true, gutters: false\">\r\n                <div class=\"epi-createContentContainer\"\r\n                     data-dojo-attach-point=\"createContentArea\"\r\n                     data-dojo-type=\"dijit/layout/_LayoutWidget\"\r\n                     data-dojo-props=\"region:'top', splitter:false\">\r\n                    <button type=\"button\" class=\"epi-flat epi-chromeless\"\r\n                            data-dojo-type=\"dijit/form/Button\"\r\n                            data-dojo-attach-point=\"createContentAreaButton\"></button>\r\n                </div>\r\n                <div data-dojo-attach-point=\"list\"\r\n                     data-dojo-type=\"epi-cms/widget/ContentList\"\r\n                     data-dojo-props=\"region:'center', splitter:false, store: this.model.store, queryOptions: this.model.listQueryOptions, contextMenu: this.contextMenu, resources: this.res\">\r\n                </div>\r\n            </div>\r\n        </div>\r\n        <div data-dojo-attach-point=\"resultNode\" style=\"display:none\">\r\n            <div data-dojo-attach-point=\"searchResultList\"\r\n                 data-dojo-type=\"epi-cms/widget/ContentList\"\r\n                 data-dojo-props=\"region:'center', splitter:false, store: this.model.searchStore, queryOptions: this.model.searchResultQueryOptions, contextMenu: this.contextMenu, resources: this.res\">\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/widget/FilesUploadDropZone':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/on",
    // dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    // epi
    "epi/shell/widget/_ModelBindingMixin",
    "./viewmodel/FilesUploadDropZoneViewModel",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles.dropzone",
    // template
    "dojo/text!./templates/FilesUploadDropZone.html"
],
function (
// dojo
    declare,
    domClass,
    domGeometry,
    on,
    // dijit
    _Widget,
    _TemplatedMixin,
    // epi
    _ModelBindingMixin,
    FilesUploadDropZoneViewModel,
    // resources
    resources,
    // template
    template
) {
    return declare([_Widget, _TemplatedMixin, _ModelBindingMixin], {
        // summary:
        // tags:
        //      internal

        res: resources, // Language resource for drop zone

        // Template for drop zone
        templateString: template,

        dragStartCssClass: "epi-dragStart", // Default drag start css class for drop zone when dragging over outside dom node
        dragOverCssClass: "epi-dragOver", // Default drag over css class for drop zone

        outsideDomNode: null, // Drop zone's outside dom node

        // enabled: [readonly] Boolean
        //      Flag to indicate whether this drop zone should be enabled for dropping or not.
        enabled: true,

        // validSelection: [public] Boolean
        //      Flag to indicate if the current selection is valid.
        validSelection: true,

        // descriptionText: [public] String
        //      The text to display in the drop zone.
        descriptionText: null,

        // settings: [public] Object
        //      The settings object for this drop zone. It should define enabled, validSelection and dropFolderName.
        settings: null,

        // model: [public] FilesUploadDropZoneViewModel
        //      The view model for this drop zone.
        model: null,

        modelBindingMap: {
            descriptionText: ["descriptionText"],
            enabled: ["enabled"],
            validSelection: ["validSelection"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);
            this.model = this.model || new FilesUploadDropZoneViewModel();
        },

        postCreate: function () {
            // summary:
            //      Set initial values.
            // tags:
            //      protected

            this.inherited(arguments);

            if (this.outsideDomNode) {
                this.own(
                    on(this.outsideDomNode, "dragenter", this._onDragEnter.bind(this)),
                    on(this.outsideDomNode, "dragend", this._onDragLeave.bind(this)),
                    on(this.outsideDomNode, "drop", this._onDragLeave.bind(this))
                );
            }

            this.own(
                on(this.dropArea, "dragover", this._onDragOver.bind(this)),
                on(this.dropArea, "dragleave", this._onDragLeave.bind(this)),
                on(this.dropArea, "dragend", this._onDragLeave.bind(this)),
                on(this.dropArea, "drop", this._onDrop.bind(this))
            );
        },

        _onDragEnter: function (evt) {
            // summary:
            //      Handle when dragging file(s) over outside drop zone
            //
            // tags:
            //      private

            if (!this.enabled) {
                return;
            }

            evt.preventDefault();
            domClass.add(this.domNode, this.dragStartCssClass);
        },

        _onDragOver: function (evt) {
            // summary:
            //      Handle when dragging file(s) over drop zone
            //
            // tags:
            //      private

            if (!this.enabled) {
                return;
            }

            evt.preventDefault();
            domClass.remove(this.domNode, this.dragStartCssClass);
            domClass.add(this.domNode, this.dragOverCssClass);
        },

        _onDragLeave: function (evt) {
            // summary:
            //      Handle when drag leaves file management
            //
            // tags:
            //      private

            if (!this.enabled) {
                return;
            }

            evt.preventDefault();
            this._removeAllCssClasses();
        },

        onDrop: function (evt, files) {
            // summary:
            //      Trigger when some files dropped on the target
            // e: Event
            //      event object.
            // files: Array
            //      file list.
            // tags: callback
        },

        _onDrop: function (evt) {
            // summary:
            //      Handle when drop file(s) in drop zone
            //
            // tags:
            //      private

            if (!this.enabled) {
                return;
            }

            evt.preventDefault();
            this._removeAllCssClasses();
            this.onDrop(evt, evt.dataTransfer.files);
        },

        _removeAllCssClasses: function () {
            // summary:
            //      remove all added css classes
            //
            // tags:
            //      private

            domClass.remove(this.domNode, this.dragStartCssClass);
            domClass.remove(this.domNode, this.dragOverCssClass);
        },

        _setSettingsAttr: function (value) {
            // summary:
            //      Sets the settings on the model.
            //
            // tags:
            //      protected

            this._set("settings", value);

            this.model.set("settings", value);
        },

        _setValidSelectionAttr: function (value) {
            // summary:
            //      Toggles the icon node.
            //
            // tags:
            //      protected

            this._set("validSelection", value);

            domClass.toggle(this.iconNode, "epi-no-drop", !value);
        },

        _setDescriptionTextAttr: { node: "descriptionNode", type: "innerText" }
    });
});

},
'epi-cms/widget/viewmodel/FilesUploadDropZoneViewModel':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles.dropzone"
],
function (
// dojo
    declare,
    lang,
    Stateful,
    // resources
    resources
) {
    return declare([Stateful], {
        // tags:
        //      internal

        // settings: [public] Object
        //      The object that sets all other properties on this view model.
        settings: null,

        // descriptionText: [readonly] String
        //      The text to display in the drop zone.
        descriptionText: null,

        // dropFolderName: [readonly] String
        //      The name of the folder that will be the target of files dropped.
        dropFolderName: null,

        // validSelection: [readonly] Boolean
        //      Flag to indicate if the current selection is valid.
        validSelection: null,

        // enabled: [readonly] Boolean
        //      Flag to indicate whether this drop zone should be enabled for dropping or not.
        enabled: null,

        // _descriptionTemplate: [private] String
        //      Template used to create description. By default it's resources.description
        _descriptionTemplate: null,

        _settingsSetter: function (value) {
            // summary:
            //      Sets all other properties using the values on the settings object.
            //
            // value: Object
            //      Object containing the values for enabled, validSelection and dropFolderName.
            //
            // tags:
            //      protected

            this.settings = value;
            if (!value) {
                value = this._getDefaultValue();
            }

            this.set("enabled", value.enabled);
            this.set("validSelection", value.validSelection);
            this.set("dropFolderName", value.dropFolderName);
            this.set("_descriptionTemplate", value.descriptionTemplate);
            this.set("descriptionText", this._getDescription(value));
        },

        _getDefaultValue: function () {
            // summary:
            //      Gets the default value for this view model.
            //
            // tags:
            //      private

            return {
                enabled: false,
                validSelection: false,
                dropFolderName: null
            };
        },

        _getDescription: function (settings) {
            // summary:
            //      Gets the description using the values on the specified settings object.
            //
            //  settings: Object
            //      Object containing the values for enabled, validSelection and dropFolderName.
            //
            // tags:
            //      private

            if (!settings.validSelection) {
                return resources.toomanyfolders;
            }
            var descriptionTemplate = this._descriptionTemplate || resources.description;
            return lang.replace(descriptionTemplate, [settings.dropFolderName || resources.defaultfoldername]);
        }

    });
});

},
'url:epi-cms/widget/templates/FilesUploadDropZone.html':"<div class=\"epi-assetsDropZone\">\r\n    <div class=\"dijitReset dijitInline epi-dropZone\">\r\n        <div data-dojo-attach-point=\"iconNode\" class=\"epi-dropZone-icon\"></div>\r\n        <span data-dojo-attach-point=\"descriptionNode\" class=\"epi-dropZone-text\"></span>\r\n    </div>\r\n    <div data-dojo-attach-point=\"dropArea\" class=\"epi-dropZone-overlay\"></div>\r\n</div>\r\n",
'epi-cms/component/PageNavigationTree':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",

    "epi-cms/ApplicationSettings",
    "../command/NewContent",
    "../command/RemoveNavigationCommand",
    "./command/ViewTrash",
    "./ContentNavigationTree",

    "epi/i18n!epi/cms/nls/episerver.cms.components.createpage"
],

function (
    array,
    declare,
    lang,
    topic,
    when,

    ApplicationSettings,
    NewContentCommand,
    RemoveNavigationCommand,
    ViewTrashCommand,
    ContentNavigationTree,

    resCreatePage
) {

    return declare([ContentNavigationTree], {
        // summary:
        //    Main navigation for pages.
        //
        // description:
        //    Extends epi-cms/component/ContentNavigationTree with some customizations for pages.
        //
        // tags:
        //    internal

        // betweenThreshold: [public] Integer
        //     Gets propagated to dndSource, to be able to drop between nodes to sort.
        betweenThreshold: 5,

        // expandExtraNodeItems: [public] Array|Integer
        //     Expand the startPage.
        expandExtraNodeItems: ApplicationSettings.startPage,

        // allowSorting: [public] Boolean
        //     Allows sorting of items in the tree through DnD. When false it restricts sorting but allows items to be
        //     moved into other items or content areas.
        allowSorting: true,

        postMixInProperties: function () {
            // summary:
            //      Post mixin initializations.
            // tags:
            //      protected

            this.inherited(arguments);

            // make sure these get called with this class as context
            // otherwise context will be the dndController for the tree
            this.checkAcceptance = lang.hitch(this, this.checkAcceptance);
            this.checkItemAcceptance = lang.hitch(this, this.checkItemAcceptance);
        },

        checkAcceptance: function (source, nodes) {
            //Special handling for the page tree. We only accept internal dnd operations and don't have to check types since all content are pages.
            return source === this.tree.dndController;
        },

        checkItemAcceptance: function (target, source, position) {
            //Special handling for the page tree. We can disallow sorting but allow moving through DnD.
            return this.allowSorting || position === "over";
        },

        _startupCommands: function () {
            // summary:
            //    Add command buttons to the Toolbar.
            //
            // tags:
            //    private

            this.inherited(arguments);

            this._createCommand = new NewContentCommand({
                order: 10,
                contentType: this.settings.containedTypes[0],
                iconClass: "epi-iconPlus",
                label: resCreatePage.command.label,
                resources: resCreatePage
            });

            this.commands = array.filter(this.commands, lang.hitch(this, function (command) {
                return !(command instanceof NewContentCommand);
            }));

            this._viewTrashCommand = new ViewTrashCommand({ typeIdentifiers: this.typeIdentifiers, order: 100 });

            this.commands.push(this._createCommand);
            this.commands.push(this._viewTrashCommand);
            this.commands.push(new RemoveNavigationCommand({
                navigation: true
            }));
        },

        _setShowAllLanguagesAttr: function (value) {
            this.inherited(arguments);
            this.allowSorting = !!value;
        },

        getIconClass: function (/*dojo/data/Item*/item, /*Boolean*/opened) {
            // summary:
            //      Overridable function to return CSS class name to display icon,
            // item:
            //      The current contentdata.
            // opened:
            //      Indicate the node is expanded or not.
            // tags:
            //      extension
            var isRoot = array.some(this.model.roots, function (root) {
                return root === this.model.getIdentity(item);
            }, this);

            if (isRoot) {
                return "epi-iconObjectRoot";
            } else if (item.isStartPage) {
                return "epi-iconObjectStart";
            } else {
                return this.inherited(arguments);
            }
        }
    });
});

},
'epi-cms/command/RemoveNavigationCommand':function(){
define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi/dependency",
    "epi/i18n!epi/shell/ui/nls/episerver.shell.ui.resources.gadgetchrome",
    "epi/shell/command/_Command",
    "epi/shell/ViewSettings",
    "epi/shell/DialogService",
    "epi-cms/ApplicationSettings",
    "epi/i18n!epi/shell/ui/nls/episerver.shell.ui.resources.gadgetchrome"
], function (declare, topic, dependency, resources, _Command, viewSettings, dialogService, ApplicationSettings, res) {
    return declare([_Command], {
        // summary:
        //      A command that removes either Main Navigation or Assets components
        //
        // tags:
        //      internal

        constructor: function (params) {
            this.navigation = params ? params.navigation : false;
            var registry = dependency.resolve("epi.storeregistry");
            this._componentsStore = this._componentsStore || registry.get("epi.shell.component");
        },

        label: resources.deletemenuitemlabel,

        category: "setting",

        order: 1000,

        canExecute: true,

        _showRemovalConfirmationDialog: function () {
            return dialogService.confirmation({
                description: res.removecomponentquestionwithoutname,
                title: res.deletemenuitemlabel
            });
        },

        _execute: function () {
            this._showRemovalConfirmationDialog().then(
                function () {
                    this._componentsStore.query({ viewName: viewSettings.viewName }).then(
                        function (components) {
                            var componentKey = this.navigation ? ApplicationSettings.mainNavigationComponentKey : ApplicationSettings.assetsComponentKey;

                            var component = components.find(function (x) {
                                return x.settings.headingLocalizationKey === componentKey;
                            });

                            if (!component) {
                                return;
                            }

                            component.settings.isHidden = true;

                            this._componentsStore.executeMethod("save", "", [component]).then(function () {
                                topic.publish("/epi/cms/action/togglecomponent", {
                                    key: componentKey,
                                    isHidden: true
                                });
                            });
                        }.bind(this)
                    );
                }.bind(this)
            );
        }
    });
});

},
'epi-cms/component/ContentNavigationTree':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "dojo/topic",
    "dojo/when",
    // epi
    "epi/dependency",
    "epi/string",

    "epi/shell/ClipboardManager",
    "epi/shell/command/_WidgetCommandProviderMixin",
    "epi/shell/selection",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/DialogService",

    "epi-cms/_ContentContextMixin",
    "epi-cms/_MultilingualMixin",
    "epi-cms/ApplicationSettings",

    "epi-cms/contentediting/PageShortcutTypeSupport",
    "epi-cms/command/ShowAllLanguages",
    "epi-cms/component/_ContentNavigationTreeNode",
    "epi-cms/component/ContentContextMenuCommandProvider",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",

    "epi-cms/widget/ContentTree",
    "epi/shell/widget/ContextMenu",

    "./command/_GlobalToolbarCommandProvider",
    "../command/CopyContent",
    "../command/CutContent",
    "../command/DeleteContent",
    "../command/PasteContent",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.createpage",
    "epi/i18n!epi/cms/nls/episerver.cms.components.pagetree",
    "epi/i18n!epi/cms/nls/episerver.shared.header"
],

function (
// dojo
    array,
    connect,
    declare,
    lang,

    domClass,

    topic,
    when,
    // epi
    dependency,
    epistring,

    ClipboardManager,
    _WidgetCommandProviderMixin,
    Selection,
    TypeDescriptorManager,
    dialogService,

    _ContentContextMixin,
    _MultilingualMixin,
    ApplicationSettings,

    PageShortcutTypeSupport,
    ShowAllLanguagesCommand,
    _ContentNavigationTreeNode,
    ContextMenuCommandProvider,
    ContentActionSupport,
    ContentReference,

    ContentTree,
    ContextMenu,

    _GlobalToolbarCommandProvider,
    CopyCommand,
    CutCommand,
    DeleteCommand,
    PasteCommand,
    // resources
    resCreatePage,
    res
) {

    return declare([ContentTree, _ContentContextMixin, _WidgetCommandProviderMixin, _MultilingualMixin], {
        // summary:
        //      Light weight Page tree component.
        // description:
        //      Extends epi.cms.widget.PageTree to provide global messaging capability.
        // tags:
        //      internal xproduct

        res: res,

        showAllLanguages: true,

        _separatorBeforeCssClass: "rowSeparatorBefore",
        _separatorAfterCssClass: "rowSeparatorAfter",

        _clipboardManager: null,
        _contextMenu: null,
        _contextMenuCommandProvider: null,

        _focusNode: null,

        // gets propagated to dndSource
        betweenThreshold: 0,

        contextMenuCommandProvider: ContextMenuCommandProvider,

        nodeConstructor: _ContentNavigationTreeNode,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._clipboardManager = new ClipboardManager();

            this.selection = new Selection();


            //Create the context menu command provider
            this._contextMenuCommandProvider = new this.contextMenuCommandProvider({
                treeModel: this.model,
                clipboardManager: this._clipboardManager,
                repositoryKey: this.repositoryKey
            });
            this._startupCommands();

            this.model.roots = this.roots;
            this.model.notAllowToDelete = this.settings.preventDeletionFor;
            this.model.notAllowToCopy = this.settings.preventCopyingFor;
        },

        postCreate: function () {
            // summary:
            //    Post create initialization
            // tags:
            //    protected

            this.inherited(arguments);

            this.own(
                this.on("copyOrCut", lang.hitch(this, function (copy) {
                    copy ? this._copyCommand.execute() : this._cutCommand.execute();
                })),
                this.on("delete", lang.hitch(this, function () {
                    this._deleteCommand.canExecute ? this._deleteCommand.execute() : this._showNotificationMessage(this.res.cannotdelete);
                })),
                this.on("showContextMenu", this._showContextMenuFromKeyboard.bind(this)),
                this.on("select", lang.hitch(this, this._onTreeNodeClicked)),
                this.on("paste", function () {
                    if (this._pasteCommand.get("canExecute")) {
                        this._pasteCommand.execute();
                    }
                }.bind(this))
            );

            this.contextRequests = [];

            this.connect(this, "onClick", "_onTreeNodeClicked");

            //TODO: Remove topic and replace with normal event?
            var resetSelection = lang.hitch(this, "_resetSelectionToLastSelected");
            this.subscribe("/epi/dnd/dropdata", resetSelection);
            this.subscribe("/dnd/cancel", resetSelection);
        },

        _showContextMenuFromKeyboard: function (e) {
            this._ensureContextMenu();
            this._contextMenu.forceOpen(e);
        },

        startup: function () {
            this.inherited(arguments);

            when(this.getCurrentContext(), lang.hitch(this, function (context) {
                this.contextChanged(context);
            }));
        },

        _preparePathNodes: function (paths) {
            // summary:
            //      Prepare steps before node selection in the tree
            // tags:
            //      protected, extension

            var self = this,
                parentNodes;

            array.some(paths, function (pathNode, index) {

                var nodes = self.getNodesByItem(pathNode),
                    noNodes = nodes.length === 1 && !nodes[0]; // No hits returns a single item array with the item set to undefined

                if (index > 0 && noNodes) {
                    array.forEach(parentNodes, function (parentNode) {
                        if (parentNode.state === "LOADED") {
                            // "Unset" to get it to refresh next time it is called
                            parentNode._loadDeferred = null;
                        }
                    });

                    return true;
                }

                parentNodes = nodes;

                return false;
            });
        },

        _resetSelectionToLastSelected: function () {
            if (!this._lastSelectedContentReference || !this.selectedItem) {
                return;
            }

            if (this.selectedItem.contentLink !== this._lastSelectedContentReference) {
                // reset when we our selection is not the last one loaded
                this.selectContent(this._lastSelectedContentReference);
            }
        },

        _startupCommands: function () {
            // summary:
            //    Add command buttons to Global Toolbar
            //
            // appInstance: instance of current application
            //
            // tags:
            //    private

            this._showAllLanguagesCommand = new ShowAllLanguagesCommand({ model: this });

            var commands = this._contextMenuCommandProvider.get("commands");

            array.some(commands, lang.hitch(this, function (command) {
                if (command instanceof CopyCommand) {
                    this._copyCommand = command;
                } else if (command instanceof CutCommand) {
                    this._cutCommand = command;
                } else if (command instanceof PasteCommand) {
                    this._pasteCommand = command;
                } else if (command instanceof DeleteCommand) {
                    this._deleteCommand = command;
                }
                if (this._deleteCommand && this._pasteCommand && this._copyCommand) {
                    return true;
                }
            }));

            this.commands = [
                this._showAllLanguagesCommand
            ].concat(commands);
        },

        _setShowAllLanguagesAttr: function (value) {
            this._set("showAllLanguages", value);
            this.model.set("showAllLanguages", value);
            this._showAllLanguagesCommand.set("active", !value);
        },

        _onTreeNodeClicked: function (page, node, event) {
            // summary:
            //    Override onPageChange event
            //
            // page: Object
            //    The page object.
            //
            // tags:
            //    public

            var selectContent = function () {
                if (this.contextRequests.length > 0) {
                    //TODO: optimization, maybe we should drop all middle items?
                    this.contextRequests.push(page);
                    return;
                }

                this._requestContextChange(page);
                this.contextRequests.push(page);
            }.bind(this);

            if (this.selectContentThrottle) {
                clearTimeout(this.selectContentThrottle);
                this.selectContentThrottle = null;
            }

            // Set timeout to change context in case multiple clicks
            this.selectContentThrottle = setTimeout(selectContent, 200);
        },

        _requestContextChange: function (page) {
            // summary:
            //      Get content type and content name, to pass to requestContentChange request
            // tags:
            //      private

            var requestedContent = {
                typeName: TypeDescriptorManager.getResourceValue(page.typeIdentifier, "name"),
                name: page.name
            };

            topic.publish("/epi/shell/context/request", { uri: page.uri }, {
                sender: lang.mixin(this, { requestedContent: requestedContent }),
                forceContextChange: true
            });
        },

        contentContextChanged: function (newContext, callerData) {
            // summary:
            //      Subscriptions to /epi/shell/context/changed topic to sync page tree selection
            // tags:
            //      private

            this._dequeueContextRequest(newContext.versionAgnosticUri);

            var contentReference = new ContentReference(newContext.id),
                reference = contentReference.createVersionUnspecificReference().toString(),
                wasteBasketId = ApplicationSettings.wastebasketPage.toString();

            this.inherited(arguments);

            // We don't show wastebasket int the trees right now
            if (reference === wasteBasketId) {
                return;
            }

            // Set selection data in order to ensure that its value always updated
            this.selection.set("data", this._getSelectionData(this.selectedItem));

            // keep track of which content was selected last
            this._lastSelectedContentReference = reference;

            //If the new selection is the same as the old, return and do not request a context change.
            if (callerData && callerData.sender === this && this.selectedItem && reference === this.selectedItem.contentLink) {
                this._updateGlobalToolbarButtons();
            }

            // If the new context is a supported type then select that type within the tree and update commands.
            if (this.isSupportedType(newContext.dataType)) {
                this.selectContent(reference, false, true).then(lang.hitch(this, "_updateGlobalToolbarButtons"));
            }
        },

        isSupportedType: function (dataType) {
            // summary:
            //      Check the supported type of data type selected.
            // dataType: [String]
            //      The type of data selected
            // tags:
            //      protected

            return this.tree.model.isSupportedType(dataType);
        },

        _getSelectionData: function (/*dojo/data/Item*/itemData) {
            // summary:
            //      Return selection data
            // tags:
            //      private

            return itemData ? [{ type: "epi.cms.contentdata", data: itemData }] : [];
        },

        _updateGlobalToolbarButtons: function (targetNode) {
            // summary:
            //    Show/hide associated buttons (Copy/Cut/Paste/Move to Recycle Bin) with the current action
            //
            // tags:
            //    private

            var node = targetNode || this.get("selectedNode"),
                selected = node ? this._getSelectionData(node.item) : [],
                commandModel = this.getCommandModel(node);

            if (this._createCommand) {
                this._createCommand.set("model", commandModel);
            }

            //Bind the item
            this._contextMenuCommandProvider.updateCommandModel(commandModel);
            this.selection.set("data", selected);
        },

        getCommandModel: function (selectedTreeNode) {
            // summary:
            //    Gets the command model to update the commands with.
            // selectedTreeNode: Object
            //    The selected tree node that contains the command model.
            //
            // tags:
            //    protected

            return selectedTreeNode && selectedTreeNode.item;
        },

        contextChangeFailed: function (oldContext, requestContextParams, callerData) {
            // summary:
            //    Subscriptions to /epi/shell/context/requestfailed topic to sync page tree selection
            //
            // tags:
            //    protected

            this.inherited(arguments);

            if (oldContext) {
                this._dequeueContextRequest(requestContextParams.uri);
                // select old page link
                if (callerData && callerData.sender === this) {
                    this.selectContent(oldContext.contentLink);
                }
            }
        },

        _dequeueContextRequest: function (uri) {
            // summary:
            //      Removes context request with a given url and tries to process another item from the queue
            // tags:
            //      private

            var firstIndexOf = -1;
            this.contextRequests.some(function (request, i) {
                if (request.uri === uri) {
                    firstIndexOf = i;
                    return true;
                }
            });

            if (firstIndexOf !== -1) {
                this.contextRequests.splice(firstIndexOf, 1);
            }
            if (this.contextRequests.length > 0) {
                this._requestContextChange(this.contextRequests[0], this);
            }
        },

        _removeHighlightClass: function () {
            // summary:
            //      Remove highlight css class for current focus node
            // tags:
            //      private

            if (this._focusNode && this._focusNode !== this.selectedNode && this._focusNode.rowNode) {
                domClass.remove(this._focusNode.rowNode, "dijitTreeRowSelected");
            }
        },

        _onContextMenuClose: function () {
            // summary:
            //      Handles context menu close event
            // tags:
            //      private

            this._removeHighlightClass();
        },

        _onContextMenuOpen: function () {
            // summary:
            //      Handles context menu open event
            // tags:
            //      private

            if (this._focusNode) {
                domClass.add(this._focusNode.rowNode, "dijitTreeRowSelected");
            }
        },

        _set_focusNodeAttr: function (value) {
            // summary:
            //      Set focus node function
            // tags:
            //      private

            this._removeHighlightClass();
            this._focusNode = value;
        },

        _ensureContextMenu: function () {
            //Create the context menu if used for the first time
            if (!this._contextMenu) {
                this.own(
                    this._contextMenu = new ContextMenu({ leftClickToOpen: true, category: "context", popupParent: this}),
                    connect.connect(this._contextMenu, "onClose", this, "_onContextMenuClose"),
                    connect.connect(this._contextMenu, "onOpen", this, "_onContextMenuOpen")
                );
                this._contextMenu.addProvider(this._contextMenuCommandProvider);
                this._contextMenu.startup();
            }
        },

        _showContextMenu: function (evt) {
            this._ensureContextMenu();

            //Open the context menu
            this._contextMenu.scheduleOpen(evt.target, null, { x: evt.x, y: evt.y });
        },

        _createTreeNode: function () {
            // summary:
            //      Overridable function to make tree node draggable and droppable after creation
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            var treeNode = this.inherited(arguments);

            treeNode.on("onContextMenuClick", lang.hitch(this, function (node) {

                this._updateGlobalToolbarButtons(node.node);

                this.set("_focusNode", node.node);
                this._showContextMenu(node);
            }));

            return treeNode;
        },

        getIconClass: function (/*dojo/data/Item*/item, /*Boolean*/opened) {
            // summary:
            //      Overridable function to return CSS class name to display icon,
            // item: [dojo/data/Item]
            //      The current contentdata.
            // opened: [Boolean]
            //      Indicate the node is expanded or not.
            // tags:
            //      public, extension

            var inherited = this.inherited(arguments);

            if (!item || !item.properties || !item.properties.pageShortcutType) {
                return inherited;
            }

            var shortcutTypeIcon = "";

            switch (item.properties.pageShortcutType) {
                case PageShortcutTypeSupport.pageShortcutTypes.Shortcut:
                    shortcutTypeIcon = "epi-iconObjectInternalLink";
                    break;
                case PageShortcutTypeSupport.pageShortcutTypes.External:
                    shortcutTypeIcon = "epi-iconObjectExternalLink";
                    break;
                case PageShortcutTypeSupport.pageShortcutTypes.Inactive:
                    shortcutTypeIcon = "epi-iconObjectNoLink";
                    break;
                case PageShortcutTypeSupport.pageShortcutTypes.FetchData:
                    shortcutTypeIcon = !item.hasTemplate ? "epi-iconObjectContainerFetchContent" : "epi-iconObjectFetchContent";
                    break;
                default:
                    break;
            }

            return shortcutTypeIcon ? inherited + " " + shortcutTypeIcon : inherited;
        },

        enableDrop: function (node, isAllowed) {
            // summary:
            //     Sets whether this target is droppable or not
            // node: Object
            //     Target node to update its _droppable.
            // isAllowed: Boolean
            //     Flag to indicate whether this target is droppable or not.
            // tags: callback

            node._droppable = isAllowed;
        },

        _showNotificationMessage: function (message) {
            // summary:
            //      Show a alert message
            // message:
            //      The message to be displayed in the alert.
            // tags:
            //      private

            dialogService.alert(epistring.toHTML(message));
        }
    });

});

},
'epi-cms/command/ShowAllLanguages':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojox/html/entities",

    "epi/dependency",
    "epi-cms/ApplicationSettings",
    "epi/shell/command/ToggleCommand",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.command"
],

function (
    declare,
    lang,
    when,
    entities,

    dependency,
    ApplicationSettings,
    ToggleCommand,
    resources
) {

    return declare([ToggleCommand], {
        // summary:
        //      A command that toggles whether all languages are shown.
        //
        // tags:
        //      public

        // property: [public] String
        //      The name of the property on the model which this command will toggle.
        property: "showAllLanguages",

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "setting",

        // order: [readonly] Integer
        //      An ordering indication used when generating a ui for this command.
        //      Commands with order indication will be placed before commands with no order indication.
        order: 50,

        _watchHandle: null,

        postscript: function () {
            this.inherited(arguments);

            this.currentContentLanguage = this.currentContentLanguage || ApplicationSettings.currentContentLanguage;

            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.language");

            when(this.store.get(this.currentContentLanguage), lang.hitch(this, function () {
                this.set("label", resources.showonlycontentin);
            }));
        },

        _execute: function () {
            // summary:
            //		Overidde base class, toggles the value of the given property on the model.
            // tags:
            //		protected

            // Toggles the active state
            this.set("active", !this.active);

            // If active state is true, we will show only contents in current language,
            // otherwise show contents in all languages
            this.model.set(this.property, !this.active);
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            if (this.model && this.model._isSiteMultilingual) {
                when(this.model._isSiteMultilingual(), lang.hitch(this, function (value) {
                    this.set("canExecute", value);
                }));
            }
        }
    });
});

},
'epi-cms/component/ContentContextMenuCommandProvider':function(){
﻿define([
    "dojo/_base/declare",
    "dijit/Destroyable",
    // epi
    "epi/shell/command/_CommandProviderMixin",
    "../command/CopyContent",
    "../command/CutContent",
    "../command/PasteContent",
    "../command/TranslateContent",
    "../command/DeleteContent",
    "../plugin-area/navigation-tree",
    "../widget/CreateCommandsMixin",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/shell/selection"
], function (
    declare,
    Destroyable,
    // epi
    _CommandProviderMixin,
    CopyCommand,
    CutCommand,
    PasteCommand,
    TranslateCommand,
    DeleteCommand,
    navigationTreePluginArea,
    CreateCommandsMixin,
    _SelectionCommandMixin,
    Selection
) {

    return declare([_CommandProviderMixin, CreateCommandsMixin, Destroyable], {
        // summary:
        //      Command provider for content context menus
        // tags:
        //      internal xproduct

        // treeModel: [Object]
        //      Model use for the commands
        treeModel: null,

        clipboardManager: null,

        _settings: null,

        constructor: function (params) {
            declare.safeMixin(this, params);

            this.own(navigationTreePluginArea.on("added, removed", this._updateCommands.bind(this)));
        },

        postscript: function () {
            this.inherited(arguments);

            this._updateCommands();
        },

        updateCommandModel: function (contentData) {
            // summary:
            //      Updates the model for the commands.
            // tags:
            //      public

            this.get("commands").forEach(function (command) {
                if (!command.isInstanceOf(_SelectionCommandMixin)) {
                    command.set("model", contentData);
                }
            });

            this._settings.selection.set("data", [{ type: "epi.cms.contentdata", data: contentData }]);
        },

        _updateCommands: function () {

            this.get("commands").forEach(function (command) {
                if (typeof command.destroy === "function") {
                    command.destroy();
                }
            });

            //Create the commands
            this._settings = {
                category: "context",
                model: this.treeModel,
                clipboard: this.clipboardManager,
                selection: new Selection()
            };

            var createCommands = this.getCreateCommands(),
                commands = [];

            for (var key in createCommands) {
                commands.push(createCommands[key].command);
            }
            if (commands.length > 0) {
                commands[commands.length - 1].category = "menuWithSeparator";
            }

            commands.push(
                new TranslateCommand({ category: "context" }),
                new CutCommand(this._settings),
                new CopyCommand(this._settings),
                new PasteCommand(Object.assign({}, this._settings, { category: "menuWithSeparator" }))
            );

            var otherCommands = navigationTreePluginArea.get();
            otherCommands.forEach(function (command) {
                command.category = "context";
                commands.push(command);
            });

            if (otherCommands.length > 0) {
                commands[commands.length - 1].category = "menuWithSeparator";
            }
            commands.push(new DeleteCommand(this._settings));

            this.set("commands", commands);
        }
    });
});

},
'epi-cms/plugin-area/navigation-tree':function(){
define([
    "epi/PluginArea",
    // Commands
    "epi-cms/content-approval/command/EditApprovalDefinition"
], function (
    PluginArea,
    // Commands
    EditApprovalDefinition
) {

    /*=====
    return {
        // summary:
        //      A plugin area for the page tree component and context menu.
        // tags:
        //      public
    };
    =====*/
    var pluginArea = new PluginArea("epi-cms/navigation-tree/commands[]");

    pluginArea.add(EditApprovalDefinition);

    return pluginArea;
});

},
'epi-cms/component/RecentlyChanged':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",

    "epi",
    "epi/dependency",

    "epi/shell/command/_WidgetCommandProviderMixin",
    "epi/shell/command/_Command",
    "epi/shell/command/ToggleCommand",
    "epi/shell/widget/layout/ComponentContainer",
    "epi/shell/DialogService",
    "epi/shell/widget/_FocusableMixin",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/_GridWidgetBase",

    "epi/i18n!epi/cms/nls/episerver.cms.components.recentlychanged"
],
function (
    declare,
    lang,

    epi,
    dependency,

    _WidgetCommandProviderMixin,
    _Command,
    ToggleCommand,
    ComponentContainer,
    dialogService,
    _FocusableMixin,

    ContentActionSupport,
    ContentReference,
    _GridWidgetBase,

    resources
) {
    return declare([_GridWidgetBase, _WidgetCommandProviderMixin, _FocusableMixin], {
        // summary:
        //      This component will list the latest changed content for the web site.
        //
        // tags:
        //      internal

        // _componentsController: [private] epi/shell/widget/Application
        _componentsController: null,

        onlyShowMyChanges: false,

        postMixInProperties: function () {
            // summary:
            //    Overridden to wrap the gridcontainer and add our toolbar after
            //
            // tags:
            //    protected
            this.storeKeyName = "epi.cms.content.search";
            this._componentsController = dependency.resolve("epi.shell.controller.Components");
            this.ignoreVersionWhenComparingLinks = false;
            this.inherited(arguments);
        },

        buildRendering: function () {
            // summary:
            //		Construct the UI for this widget with this.domNode initialized as a dgrid.
            // tags:
            //		protected

            this.inherited(arguments);

            var gridSettings = lang.mixin({
                columns: this._createGridColumns(),
                store: this.store,
                selectionMode: "single"
            }, this.defaultGridMixin);

            this.grid = new this._gridClass(gridSettings, this.domNode);
        },

        startup: function () {
            // summary:
            //      Overridden to connect a store to a DataGrid.

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            var commands = [
                new ToggleCommand({
                    label: resources.showmychanges,
                    category: "setting",
                    model: this,
                    property: "onlyShowMyChanges"
                }),
                new _Command({
                    iconClass: "epi-iconReload",
                    label: epi.resources.action.refresh,
                    canExecute: true,
                    _execute: lang.hitch(this, function () {
                        this.grid.refresh();
                    })
                })];

            this.add("commands", commands);

            this.fetchData();
        },

        _setOnlyShowMyChangesAttr: function (value) {
            this._set("onlyShowMyChanges", value);
            if (this._started) {
                this._saveSettingComponent("onlyShowMyChanges", value);
            }
        },

        fetchData: function () {
            // summary:
            //		Updates the grid with the new data.
            // tags:
            //		private

            var query = this._getQuery();

            this.grid.set("query", query.query, query.options);
        },

        _getQuery: function () {
            return {
                query: { query: "recentlychanged", onlyShowMyChanges: this.onlyShowMyChanges, keepversion: true },
                options: { ignore: ["query"], sort: [{ attribute: "saved", descending: true}] }
            };
        },

        _createGridColumns: function () {
            var columns = {
                name: {
                    label: epi.resources.header.name,
                    className: "epi-width50",
                    renderCell: lang.hitch(this, this._renderContentItem)
                },
                status: {
                    label: epi.resources.header.status,
                    renderCell: function (item, value, node, options) {
                        node.innerHTML = ContentActionSupport.getVersionStatus(value);
                    },
                    className: "epi-width15"
                },
                saved: {
                    label: epi.resources.header.saved,
                    formatter: this._localizeDate,
                    className: "epi-width25"
                }
            };

            if (!this.get("onlyShowMyChanges")) {
                columns.changedBy = {
                    label: epi.resources.header.by,
                    formatter: this._createUserFriendlyUsername,
                    className: "epi-width10"
                };
            }

            return columns;
        },

        _saveSettingComponent: function (type, value) {
            // summary:
            //		Save setting handle by component controller.
            // type: String
            //      The type of a setting.
            // value: value
            //      The value of a setting.
            // tags:
            //		private

            var item = this._componentsController.getComponentDefinition(this.id),
                query;

            if (item) {
                item.settings.onlyShowMyChanges = value;

                // save the settings
                var saved = this._componentsController.saveComponents([item]);
                saved.then(function (done) {

                }, function () {
                    // Show alert dialog on errorCallback
                    dialogService.alert(resources.errormessage);
                });

                // Updated this way on purpose. Both set query and columns will trigger
                // a refresh of data leading to bad rendering behaviour of the grid.
                query = this._getQuery();
                this.grid.query = query.query;
                this.grid.queryOptions = query.options;
                this.grid.set("columns", this._createGridColumns());
            }
        },

        onContextChanged: function (context) {
            // summary:
            //      Selects the current context item if it exists in the grid.

            this.grid.clearSelection();

            var versionAgnosticLink = new ContentReference(context.id).createVersionUnspecificReference().toString();

            var row = this.grid.row(versionAgnosticLink);
            if (row) {
                this.grid.select(row);
            }
        }
    });
});

},
'epi-cms/component/SharedBlocks':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-class",

    "dojo/on",
    // epi
    "epi/shell/widget/layout/_ComponentWrapper",
    "epi-cms/asset/HierarchicalList",
    "epi-cms/component/SharedBlocksViewModel",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.createblock",
    "epi/i18n!epi/cms/nls/contenttypes.blockdata",
    "epi/i18n!epi/cms/nls/episerver.cms.components.sitetree"
],

function (
// dojo
    array,
    declare,
    lang,
    aspect,
    domConstruct,
    domGeometry,
    domClass,
    on,
    // epi
    _ComponentWrapper,
    HierarchicalList,
    SharedBlocksViewModel,
    // resources
    componentResources,
    res,
    sitetreeRes) {

    return declare([HierarchicalList], {
        // summary:
        //      Shared blocks component
        // tags:
        //      internal

        // showCreateContentArea: [public] Boolean
        //      Flag which indicates whether the create content area should be displayed on startup.
        showCreateContentArea: false,

        modelClassName: SharedBlocksViewModel,

        noDataMessages: componentResources.nodatamessages,

        // hierarchicalListClass: [readonly] String
        //      The CSS class to be used on the content list.
        hierarchicalListClass: "epi-blockList",

        // createContentIcon: [public] String
        //      The icon class to be used in the create content area of the list.
        createContentIcon: "epi-iconPlus",

        // createContentText: [public] String
        createContentText: res.create,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.modelBindingMap.showAllLanguages = ["showAllLanguages"];
        },

        buildRendering: function () {
            this.inherited(arguments);

            // Aspect the renderQuery method on the grid to get the number of items rendered after a query has executed
            // We can't depend on the "dgrid-refresh-complete" event from the grid because it might not always return the correct result
            // e.g if two refresh were initiated at almost the same time we will only get the event for the first refresh call
            var self = this;
            this.own(aspect.after(this.list.grid, "renderQuery", function (results) {
                return results.then(function (results) {
                    var showCreateContentArea = results.length > 0 ? false : self.model.getCommand("newBlockDefault").get("canExecute");
                    self._toggleCreateContentArea(showCreateContentArea);
                });
            }));

            var link = domConstruct.create("a", {
                "class": "epi-visibleLink",
                innerHTML: sitetreeRes.showalllanguages
            });
            this.own(on(link, "click", function () {
                this.model.set("showAllLanguages", true);
            }.bind(this)));

            this.bottomLinkContainer = domConstruct.toDom("<div class=\"epi-gadget-bottom-container dijitHidden\"></div>");
            domConstruct.place(link, this.bottomLinkContainer);

            domConstruct.place(this.bottomLinkContainer, this.domNode);
        },

        layout: function () {
            var showAllLanguagesHeight = domClass.contains(this.bottomLinkContainer, "dijitHidden") ? 0 : domGeometry.getMarginBox(this.bottomLinkContainer).h;

            var searchBoxSize = domGeometry.getMarginBox(this.searchBoxNode),
                containerSize = {
                    h: this._contentBox.h - searchBoxSize.h - showAllLanguagesHeight,
                    w: this._contentBox.w,
                    l: this._contentBox.l,
                    t: this._contentBox.t
                };

            this.container.resize(containerSize);
        },

        startup: function () {
            this.inherited(arguments);

            var isStandaloneComponent = this._isStandaloneComponent();
            this.model.set("isStandaloneComponent", isStandaloneComponent);
        },

        _isStandaloneComponent: function () {
            // summary:
            //      Checks if the component is a standalone component or it's part of a ComponentGroup
            // tags:
            //      protected

            var parent = this.getParent();
            while (parent) {
                if (parent.isInstanceOf(_ComponentWrapper)) {
                    return true;
                }
                parent = parent.getParent();
            }

            return false;
        },

        _onCreateAreaClick: function () {
            // summary:
            //      A callback function which is executed when the create area is clicked.
            // tags:
            //      protected
            this.inherited(arguments);
            this.model._commandRegistry.newBlockDefault.command.execute();
        },

        _setShowAllLanguagesAttr: function (showAllLanguages) {
            this._set("showAllLanguages", showAllLanguages);
            domClass.toggle(this.bottomLinkContainer, "dijitHidden", showAllLanguages);
            if (this._contentBox) {
                this.layout();
            }
        }
    });

});

},
'epi-cms/component/SharedBlocksViewModel':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    // epi
    "../asset/view-model/HierarchicalListViewModel",
    "epi-cms/component/_ShowAllLanguagesMixin",

    // command
    "./command/NewBlock",
    "../command/RemoveNavigationCommand",
    "epi-cms/command/ShowAllLanguages"
],

function (
// dojo
    declare,
    lang,
    when,
    // epi
    HierarchicalListViewModel,
    _ShowAllLanguagesMixin,

    // command
    NewBlockCommand,
    RemoveNavigationCommand,
    ShowAllLanguagesCommand
) {

    return declare([HierarchicalListViewModel, _ShowAllLanguagesMixin], {
        // summary:
        //      Handles search and tree to list browsing widgets.
        // tags:
        //      internal

        _selectedTreeItemsSetter: function (selectedItems) {
            // summary:
            //      Update model of commands in case selected content is folder
            // tags:
            //      private

            //The default upload command should only update when the list is updated.
            //It needs to be updated before the pseudocommanddecorator is applied.
            this._commandRegistry.newBlockDefault.command.set("model", selectedItems);

            this.inherited(arguments);
        },

        _setupCommands: function () {
            // summary:
            //      Creates and registers the commands used.
            // tags:
            //      protected

            this.inherited(arguments);

            this.showAllLanguagesCommand = new ShowAllLanguagesCommand({ model: this });

            if (!this.removeAssetsCommand) {
                this.removeAssetsCommand = new RemoveNavigationCommand();
            }
            this._setupShowAllLanguages();

            var customCommands = {
                newBlockDefault: {
                    command: new NewBlockCommand({
                        viewModel: this,
                        iconClass: "epi-iconPlus"
                    })
                },
                allLanguages: {
                    command: this.showAllLanguagesCommand,
                    order: 55
                },
                removeAssetsCommand: {
                    command: this.removeAssetsCommand,
                    order: 66
                }
            };

            this._commandRegistry = lang.mixin(this._commandRegistry, customCommands);

            this.pseudoContextualCommands.push(this._commandRegistry.newBlockDefault.command);
        },

        _setupShowAllLanguages: function () {
            when(this._isSiteMultilingual()).then(function (isSiteMultilingual) {
                if (!isSiteMultilingual) {
                    return;
                }
                this.loadShowAllLanguages().then(function (value) {
                    this.set("showAllLanguages", value);
                    this.showAllLanguagesCommand.set("active", !value);
                }.bind(this));
            }.bind(this));
        },

        _showAllLanguagesSetter: function (value) {
            var oldValue = this.showAllLanguages;
            this.inherited(arguments);
            if (oldValue !== value) {
                this.saveShowAllLanguages(value);
                this.showAllLanguagesCommand.set("active", !value);
            }
        },

        _isStandaloneComponentSetter: function (value) {
            this.removeAssetsCommand.set("isAvailable", !value);
        }
    });
});

},
'epi-cms/component/SiteTree':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/when",
    "dojo/dom-style",
    "dijit/layout/_LayoutWidget",
    "dijit/Tooltip",
    "epi/Url",
    "epi-cms/component/SiteTreeModel",
    "epi-cms/component/SiteTreeNode",
    "epi/dependency",
    "epi/shell/command/_WidgetCommandProviderMixin",
    "epi/shell/command/ToggleCommand",
    "epi/shell/widget/Tree",
    "epi/i18n!epi/cms/nls/episerver.cms.components.sitetree"
], function (
    declare,
    Deferred,
    lang,
    array,
    when,
    domStyle,
    _LayoutWidget,
    Tooltip,
    Url,
    SiteTreeModel,
    SiteTreeNode,
    dependency,
    _WidgetCommandProviderMixin,
    ToggleCommand,
    Tree,
    resources
) {

    return declare([_LayoutWidget, _WidgetCommandProviderMixin], {
        // tags:
        //      internal

        profile: null,

        buildRendering: function () {
            this.inherited(arguments);

            // Set overflow to auto in order for the tree to be scrollable if this container is to small.
            domStyle.set(this.domNode, "overflow", "auto");
        },

        postCreate: function () {
            this.inherited(arguments);

            //Get the store and attach it to the model
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("epi.cms.sitestructure");

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");

            var model = this._treeModel = new SiteTreeModel({store: store});

            //Create show all languages command
            var command = new ToggleCommand({
                category: "setting",
                label: resources.showalllanguages,
                model: model,
                property: "showAllLanguages"
            });

            this.commands.push(command);

            //Create the site and language tree
            this._tree = new Tree({
                model: model,
                showRoot: false,
                "class": "epi-simpleTree",
                persist: false,
                onClick: lang.hitch(this, function (item) {
                    if (!item.host || !item.languageId) {
                        // In case root node (another site in the sites tree) selected (mean that we do not have any information about host and language)
                        window.location.replace(item.editUrl);
                    } else {

                        var self = this;

                        // click on the language branch under a site (root node)
                        when(self.profile.setContentLanguage(item.languageId, item.host), function () {
                            // TECHNOTE: we try to keep the current viewing hostname if the editUrl and current url are sibling in the same (load balancing) site
                            // Example: {
                            //      siteUrl : http://site1,
                            //      hosts: ['site1', 'site1b']
                            //}
                            // if we are viewing site1b, and click on a languageBranch under siteUrl:http://site1, we still navigate to site1b (instead of go to http://site1)

                            var urlToNavigate = item.editUrl;
                            if (array.some(item.hosts, function (host) {
                                return host === window.location.host;
                            })) {
                                var editUrl = new Url(urlToNavigate);
                                editUrl.scheme = window.location.protocol.replace(":", "");
                                editUrl.authority = window.location.host;

                                urlToNavigate = editUrl.toString();
                            }

                            window.location.replace(urlToNavigate);
                        });
                    }
                }),
                _createTreeNode: function (args) {
                    return new SiteTreeNode(args);
                },
                _onNodeMouseEnter: function (node) {
                    if (node.item.isLanguageNode && !node.item.isAvailable) {
                        Tooltip.show(resources.notavailabletooltip, node.labelNode, ["after-centered", "below"]);
                    }
                },
                _onNodeMouseLeave: function (node) {
                    Tooltip.hide(node.labelNode);
                }
            });

            //Add the tree to the container
            this.addChild(this._tree);
        },

        layout: function () {
            this._tree.resize();
        },

        startup: function () {
            this.inherited(arguments);

            this._setTreePath();
        },

        _setTreePath: function () {
            Deferred.when(this._treeModel.getCurrentSite(), lang.hitch(this, function (config) {
                this._tree.set("path", ["root", config.currentSite, config.currentEditLanguageId]);
            }));
        }

    });
});

},
'epi-cms/component/SiteTreeNode':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/dom-class",
    // epi
    "epi-cms/widget/_ContentTreeNode"
],

// Review: Do we need proper documentation and unit tests?.
function (
// dojo
    declare,
    domClass,
    // epi
    _ContentTreeNode
) {

    return declare([_ContentTreeNode], {
        // tags:
        //      internal

        _updateItemClasses: function (item) {
            this.inherited(arguments);

            if (item.isLanguageNode && !item.isAvailable) {
                domClass.add(this.domNode, "epi-st-disabledRow");
            } else {
                domClass.remove(this.domNode, "epi-st-disabledRow");
            }

            if (!item.isLanguageNode) {
                domClass.add(this.iconNode, "epi-iconObjectStart");
            }
        }
    });

});

},
'epi-cms/component/Tasks':function(){
﻿define([
// Dojo
    "dojo",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/topic",

    // Dijit
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "dijit/layout/_LayoutWidget",
    "dijit/_WidgetsInTemplateMixin",

    // EPi Framework
    "epi",

    // EPi CMS
    "./viewmodels/TasksViewModel",
    "epi-cms/component/ContentQueryGrid", // Used in template
    "epi/shell/form/CategorizedSelect",
    "dojo/text!./templates/Tasks.html",
    "epi/i18n!epi/cms/nls/episerver.cms.components.tasks"
], function (
// Dojo
    dojo,
    declare,
    lang,
    domConstruct,
    domGeometry,
    topic,

    // Dijit
    _TemplatedMixin,
    _Container,
    _LayoutWidget,
    _WidgetsInTemplateMixin,

    // EPi Framework
    epi,

    // EPi CMS
    TasksViewModel,
    ContentQueryGrid,
    Select,
    template,
    resources
) {

    return declare([_Container, _LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //      This component will list the latest changed pages for the web site.
        //
        // tags:
        //      internal

        templateString: template,

        resources: resources,

        querySelection: null,

        // model: [ReadOnly] TasksViewModel
        //      The model for the view
        model: null,

        _selectionChangedEventHandler: null,

        buildRendering: function () {

            this.inherited(arguments);

            this.model = new TasksViewModel({categories: this.categories});

            this.querySelection = new Select({
                name: "QuerySelection",
                options: this.model.getOptions()
            });

            domConstruct.place(this.querySelection.domNode, this.reloadButton.domNode, "before");

            this.own(
                this.querySelection.on("change", lang.hitch(this, this._reloadQuery)),
                topic.subscribe("/epi/cms/action/refreshmytasks", lang.hitch(this, this._reloadQuery))
            );
        },

        startup: function () {
            this.inherited(arguments);

            // Set the initial query after the grid has been initialized
            this._reloadQuery();
        },

        resize: function (newSize) {
            // summary:
            //      Customize default resize method
            // newSize: object
            //      The new size of Task component
            // tags:
            //      Public

            this.inherited(arguments);

            this.contentQuery.resize(this._calculateContentQuerySize(newSize));
        },

        _calculateContentQuerySize: function (newSize) {
            // summary:
            //      Calculate the new Size of the Content Query
            // newSize: object
            //      The new size of Task component
            // tags:
            //      Private

            var toolbarSize = domGeometry.getMarginBox(this.toolbar);

            return { w: newSize.w, h: newSize.h - toolbarSize.h };
        },

        _reloadQuery: function () {
            var queryName = this.querySelection.get("value");

            var query = this.model.getQuery(queryName);
            if (query) {
                this.contentQuery.set("ignoreVersionWhenComparingLinks", !query.versionSpecific);
            }

            this.contentQuery.set("queryName", queryName);
        }
    });
});

},
'epi-cms/component/viewmodels/TasksViewModel':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/Stateful"
], function (declare, Stateful) {

    return declare([Stateful], {
        // summary:
        //      View model used by the Task component
        // tags:
        //      internal

        // categories: [readonly] Array
        //      A list of categories and its queries
        categories: null,

        getOptions: function () {
            // summary:
            //      Converts the categories and its queries into select options and returns them

            var options = this._convert(this.categories);

            this._selectFirstItem(options);

            return options;
        },

        getQuery: function (queryName) {
            // summary:
            //      Returns the query with the given name, if not found it returns null
            // queryName: String
            //      The name of the query to find
            // tags:
            //      public

            var foundQuery = null;

            this.categories.some(function (category) {
                return category.queries.some(function (query) {
                    if (query.name === queryName) {
                        foundQuery = query;
                        return true;
                    }
                });
            });

            return foundQuery;
        },

        _selectFirstItem: function (options) {
            // summary:
            //      Selects the first item when the first option is an category
            // tags:
            //      private

            var isCategory = options.length > 0 && options[0].category;
            if (isCategory) {
                var item = options[1];
                if (item) {
                    item.selected = true;
                }
            }
        },

        _convert: function (categories) {
            // summary:
            //      Flattens the category tree into a flat list of select options
            //      where the category is disabled
            // tags:
            //      private

            var options = [];

            categories.forEach(function (category) {
                if (category.displayName) {
                    options.push({
                        category: true,
                        label: category.displayName
                    });
                }

                category.queries.forEach(function (query) {
                    options.push({
                        label: query.displayName,
                        value: query.name
                    });
                });
            });

            return options;
        }
    });
});

},
'epi-cms/component/ContentQueryGrid':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "dojo/aspect",
    // epi-cms
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/_GridWidgetBase"
],

function (
    declare,
    lang,
    when,

    aspect,
    // epi-cms
    ContentActionSupport,
    _GridWidgetBase
) {

    return declare([_GridWidgetBase], {
        // summary: This component will list the latest changed pages for the web site.
        //
        // tags:
        //      public

        // queryName: string
        //    The name of the content query used to fetch data for the grid.
        queryName: null,

        queryParameters: null,

        dndTypes: ["epi.cms.contentreference"],

        postMixInProperties: function () {
            // summary:
            //
            // tags:
            //    protected
            this.storeKeyName = "epi.cms.content.search";

            this.inherited(arguments);
        },

        buildRendering: function () {
            // summary:
            //		Construct the UI for this widget with this.domNode initialized as a dgrid.
            // tags:
            //		protected

            this.inherited(arguments);

            var gridSettings = lang.mixin({
                columns: {
                    name: {
                        renderCell: lang.hitch(this, this._renderContentItem)
                    },
                    status: {
                        className: "epi-width35",
                        renderCell: function (item, value, node, options) {
                            node.innerHTML = ContentActionSupport.getVersionStatus(value);
                        }
                    }
                },
                store: this.store,
                dndSourceType: this.dndTypes
            }, this.defaultGridMixin);

            this.grid = new this._gridClass(gridSettings, this.domNode);

            this.grid.set("showHeader", false);

            this.own(
                aspect.around(this.grid, "insertRow", lang.hitch(this, this._aroundInsertRow))
            );
        },

        fetchData: function () {

            when(this._getCurrentItem(), lang.hitch(this, function (currentItem) {
                this.set("currentItem", currentItem);
            }));

            this.grid.set("queryOptions", { ignore: ["query"], sort: [{ attribute: "name", descending: false }] });
            var queryParameters = this.queryParameters || {};
            queryParameters.query = this.queryName;
            this.grid.set("query", queryParameters);
        },

        _setQueryNameAttr: function (value) {
            this.queryName = value;
            this.fetchData();
        }
    });
});

},
'epi/shell/form/CategorizedSelect':function(){
﻿define("epi/shell/form/CategorizedSelect", [
    "dojo/_base/declare",
    "./CategoryMenuItem",
    "dijit/form/Select"
], function (declare, CategoryMenuItem, Select) {

    return declare([Select], {
        // summary:
        //      Extended Select widget that allows to group menu items.
        //
        // tags:
        //     internal

        baseClass: "epi-categorized-select- dijitSelect dijitValidationTextBox",

        _getMenuItemForOption: function (/*_FormSelectWidget.__SelectOption*/ option) {
            // summary:
            //     For the given option, return the menu item that should be used to display it.
            //     If the option is an items group, the MenuItemGroup is created
            // tags:
            //     protected

            if (option.category) {
                return new CategoryMenuItem({ ownerDocument: this.ownerDocument, label: option.label });
            }

            return this.inherited(arguments);
        }
    });
});

},
'epi/shell/form/CategoryMenuItem':function(){
﻿define("epi/shell/form/CategoryMenuItem", [
    "dojo/_base/declare",
    "dojo/dom",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_Contained"
], function (declare, dom, _WidgetBase, _TemplatedMixin, _Contained) {

    return declare([_WidgetBase, _TemplatedMixin, _Contained], {
        // summary:
        //		A grouping element for menu items
        // tags:
        //      internal

        baseClass: "dijitMenuItemGroup",

        templateString: "<tr class=\"dijitMenuItemGroup\"><td colspan=\"4\" data-dojo-attach-point=\"containerNode\"></td></tr>",

        // label: String
        //     Group display text
        _setLabelAttr: { node: "containerNode", type: "innerHTML" },

        buildRendering: function () {
            this.inherited(arguments);
            dom.setSelectable(this.domNode, false);
        },

        isFocusable: function () {
            return false;
        }
    });
});

},
'url:epi-cms/component/templates/Tasks.html':"﻿<div>\r\n    <div class=\"epi-gadgetInnerToolbar\" data-dojo-attach-point=\"toolbar\">\r\n        <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"reloadButton\" data-dojo-attach-event=\"onClick: _reloadQuery\"\r\n            class=\"epi-chromelessButton epi-iconReload epi-input-margin--left dijitInline dijitReset\">\r\n        </div>\r\n    </div>\r\n    <div data-dojo-type=\"epi-cms/component/ContentQueryGrid\" data-dojo-attach-point=\"contentQuery\">\r\n    </div>\r\n</div>\r\n",
'epi-cms/component/Trash':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/dom-construct",
    // dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    // epi
    "epi/shell/widget/_FocusableMixin",
    "epi-cms/widget/Trash",
    "epi-cms/widget/viewmodel/TrashViewModel"
], function (
// dojo
    declare,
    domConstruct,
    // dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    // epi
    _FocusableMixin,
    Trash,
    TrashViewModel
) {

    // Declare "epi-cms/component/Trash" in order to tell WidgetSwitcher create only one instance of this.
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _FocusableMixin], {
        // summary:
        //      A component to display trash page.
        //
        // tags:
        //      internal

        templateString: "<div class=\"epi-trashComponent\"><div data-dojo-type='epi-cms/widget/Trash' data-dojo-attach-point='trash'></div></div>",

        updateView: function (data) {
            // summary:
            //		This will be invoked by WidgetSwitcher when displaying Trash component.
            //      Implement this to refresh the model, to refresh data.
            // tags:
            //		public
            if (data) {
                this.trash.set("typeIdentifiers", data.typeIdentifiers);
            }

            if (this._trashModel) {
                this._trashModel.destroy();
            }

            this.trash.set("model", this._trashModel = new TrashViewModel());
        },

        destroy: function () {
            this._trashModel.destroy();

            this.inherited(arguments);
        }
    });
});

},
'epi-cms/widget/Trash':function(){
define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/Evented",
    "dojo/_base/Deferred",
    "dojox/html/entities",

    // Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/TabContainer",
    "dijit/layout/ContentPane",
    "dijit/registry",

    // EPi Framework
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/DialogService",
    "epi/shell/command/withConfirmation",

    // EPi
    "epi-cms/widget/TrashItemList",
    "epi-cms/widget/EmptyTrashMenu",
    "epi-cms/widget/TrashViewModelConfirmation",
    "epi-cms/widget/command/EmptyTrash",
    "epi-cms/widget/command/RestoreContent",
    "epi-cms/widget/command/DeleteContent",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash",
    "dojo/text!./templates/Trash.html"
], function (
// Dojo
    array,
    declare,
    lang,
    domClass,
    domConstruct,
    Evented,
    Deferred,
    entities,

    // Dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    TabContainer,
    ContentPane,
    registry,

    // EPi Framework
    _ModelBindingMixin,
    dialogService,
    withConfirmation,

    // EPi
    TrashItemList,
    EmptyTrashMenu,
    TrashViewModelConfirmation,
    EmptyTrashCommand,
    RestoreContentCommand,
    DeleteContentCommand,

    // Resources
    resources,
    template
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin, Evented], {
        // summary:
        //      A widget to display trash page.
        // tags:
        //      internal

        resources: resources,

        templateString: template,

        _restoreContentCommand: null,

        typeIdentifiers: null,

        // Map property name in view model to a list of properties in this widget
        modelBindingMap: {
            contentStore: ["store"],
            queryOptions: ["queryOptions"],
            actionResponse: ["actionResponse"],
            trashes: ["trashes"]
        },

        postCreate: function () {
            this.inherited(arguments);

            // watch for tab change to get data
            this.tabContainer.watch("selectedChildWidget", lang.hitch(this, function (name, oldValue, newValue) {
                this.model.set("currentTrash", newValue.trash);
            }));

            // create a shared instance of Restore Content command, then watch for model updated to update model for that command.
            this._restoreContentCommand = new RestoreContentCommand({ model: this.model /* TrashViewModel */ });
            this.watch("model", lang.hitch(this, function () {
                this.model = TrashViewModelConfirmation(this.model);
                this._restoreContentCommand.set("model", this.model);
            }));

            this.on("restoreItem", this._onRestoreItemClick); // listen for restoreItem event of Trash Item List, to execute Restore Content Command.
            this.on("deleteItem", this._onDeleteItemClick);
        },

        _setTrashesAttr: function (trashes) {
            // summary:
            //      Builds Empty Trash button and Tab strip based on input trashes
            // tags:
            //      private

            // Remove all tab pane before adding new
            this.tabContainer.destroyDescendants();
            var listCommand = [];
            array.forEach(trashes, function (trash) {
                if (trash && trash.active) {
                    this._addTrash(trash); // add a Tab pane

                    var command = new EmptyTrashCommand({
                        hasDeleteAccess: trash.hasDeleteAccess,
                        label: trash.name,
                        tooltip: trash.name,
                        trashId: trash.wasteBasketLink,
                        model: this.model
                    });

                    listCommand.push(withConfirmation(command,
                        null,
                        {
                            title: resources.emptytrash.title,
                            description: this.model.getEmptyTrashConfirmMessage(trash.name),
                            onShow: lang.hitch(this,
                                function () {
                                    var trashItemList = this.tabContainer.selectedChildWidget.getChildren()[0];
                                    trashItemList.clearSelection();
                                })
                        }));
                }
            }, this);

            // Update model for empty menu
            this.emptyTrashMenu.set("commands", listCommand);

            if (trashes && trashes.length === 1) {
                domClass.add(this.tabContainer.domNode, "hide-tablist");
            }

            this.tabContainer.startup();
            this.tabContainer.layout();
        },

        _addTrash: function (trash) {
            // summary:
            //      Adds tab panes to tab container for every trash
            // tags:
            //      private

            var _selectedItem = null;

            if (trash.active) { // add active trash only
                trash.isRequireLoad = true; // make sure trash data will be load on first load
                var item = new ContentPane({
                    title: trash.name, // TODO update the total item number, for example: Pages 1000+
                    trash: trash
                });
                this.tabContainer.addChild(item);
                if (this._isSelected(trash)) {
                    _selectedItem = item;
                }
            }
            if (_selectedItem) {
                this.tabContainer.selectChild(_selectedItem);
            }
        },

        _isSelected: function (trash) {
            var result = false;
            array.some(trash.typeIdentifiers, lang.hitch(this, function (feederType) {
                return array.some(this.typeIdentifiers, function (type) {
                    if (feederType === type) {
                        result = true;
                        return false; // return false to quite the loop, in case we find a match.
                    }
                });
            }));
            return result;
        },

        _setQueryOptionsAttr: function (queryOptions) {
            // summary:
            //      When query is set, use this query options to get content for current tab.
            // tags:
            //      private

            if (queryOptions) {
                var selectedTab = this.tabContainer.selectedChildWidget;
                if (selectedTab) {
                    var contentStore = this.get("store"),
                        trashItemListWidget = null;

                    if (selectedTab.itemListId) { // update itemList's store instead of creating new instance
                        trashItemListWidget = registry.byId(selectedTab.itemListId);
                        trashItemListWidget.set("queryOptions", queryOptions);
                    } else {
                        trashItemListWidget = new TrashItemList({ queryOptions: queryOptions, store: contentStore, model: this.model });

                        trashItemListWidget.on("restoreItem", lang.hitch(this, function (row) {
                            this.emit("restoreItem", row);
                        }));
                        trashItemListWidget.on("deleteItem", lang.hitch(this, function (row) {
                            this.emit("deleteItem", row);
                        }));

                        trashItemListWidget.on("searchBoxChange", lang.hitch(this, this._onSearchBoxChange));

                        selectedTab.set("content", trashItemListWidget);
                        selectedTab.itemListId = trashItemListWidget.id;
                    }
                }
            }
        },

        _setActionResponseAttr: function (message) {
            // summary:
            //      Fired when execute action return response.
            // message: String|Array
            //      One or more messages to show as notification message.
            // tags:
            //      private

            if (!message) {
                return;
            }

            this._showNotificationMessage(message);
        },

        _showNotificationMessage: function (message) {
            // summary:
            //     Show an alert dialog with error message.
            // message: String|Array
            //     The message to be displayed in the alert.

            if (message instanceof Array) {
                dialogService.alertWithErrors({}, message);
            } else {
                dialogService.alert(message ? message : "");
            }
        },

        _onRestoreItemClick: function (row) {
            // summary:
            //     Fired when a row of Trash Item list has been clicked.
            // row:
            //     Selected row.
            // tags:
            //      private

            if (row && row.data && this.model.get("currentTrash")) {
                // set current content to be restored
                this._restoreContentCommand.set("content", row.data);
                this._restoreContentCommand.execute();
            }
        },

        _onDeleteItemClick: function (row) {
            // summary:
            //     Fired when a delete link has been clicked.
            // row:
            //     Selected row.
            // tags:
            //      private

            if (row && row.data && this.model.get("currentTrash")) {
                var command = withConfirmation(
                    new DeleteContentCommand({ model: this.model, contentId: row.data.contentLink}),
                    null,
                    {
                        title: resources.singledelete.dialog.title,
                        description: lang.replace(resources.singledelete.dialog.description, [entities.encode(row.data.name)])
                    }
                );

                command._execute();

            }
        },

        _onSearchBoxChange: function (/* String */queryText) {
            // summary:
            //      Perform search when text changed in search box
            // tags:
            //      private

            var currentTrash = this.model.get("currentTrash");
            currentTrash.queryText = queryText;
            currentTrash.isRequireLoad = true;
            this.model.set("currentTrash", currentTrash);
        }
    });
});

},
'epi-cms/widget/TrashItemList':function(){
define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/window",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/aspect",
    "dojo/keys",
    "dojo/Evented",
    "dojo/query",
    "dojo/html",
    "dojo/Stateful",
    "dojo/string",
    "dojo/when",
    // Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Select",

    // Dojox
    "dojox/widget/Standby",

    // DGrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/Keyboard",
    "dgrid/tree",
    "dgrid/extensions/ColumnResizer",
    "dgrid/util/mouse",
    "put-selector/put",

    // EPi
    "epi",
    "epi/dependency",
    "epi/shell/dgrid/Formatter",
    "epi/shell/dgrid/util/misc",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/SearchBox",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/datetime",
    "epi/username",
    "epi-cms/dgrid/formatters",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash",
    "dojo/text!./templates/TrashItemList.html"
],

function (
// Dojo
    array,
    declare,
    lang,
    window,

    domClass,
    domConstruct,
    domGeometry,
    domStyle,

    aspect,
    keys,
    Evented,
    query,
    html,
    Stateful,
    string,
    when,
    // Dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    Select,

    // Dojox
    Standby,

    // DGrid
    OnDemandGrid,
    DgridSelection,
    Keyboard,
    Tree,
    ColumnResizer,
    MouseUtil,
    put,

    // EPi
    epi,
    dependency,
    Formatter,
    GridMiscUtil,
    TypeDescriptorManager,
    SearchBox,
    _ModelBindingMixin,
    epiDate,
    username,
    formatters,

    // Resources
    resources,
    template
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, Evented, Stateful, _ModelBindingMixin], {
        // summary:
        //      A widget to display content in trash for a specific trash.
        //
        // tags:
        //      internal

        resources: resources,

        epi: epi,

        templateString: template,

        _grid: null,

        _observers: {},

        _setQueryOptionsAttr: function (queryOptions) {
            this._set("queryOptions", queryOptions);
            this._initialize();
        },

        destroy: function () {
            // summary:
            //      Destroy the object.
            for (var id in this._observers) {
                this._observers[id].cancel();
                delete this._observers[id];
            }

            if (this._standby) {
                this._standby.destroyRecursive();
                this._standby = null;
            }

            if (this._grid) {
                this._grid.destroy();
                this._grid = null;
            }

            this.inherited(arguments);
        },

        clearSelection: function () {
            this._grid.clearSelection();
            // NOTE:
            // It is necessary to set the _lastSelected to null due a bug on the dgrid where
            // after deselecting a row it cannot be selected again. If the _lastSelected isn't
            // "clear", it will assume that the same row is selected and it will not apply all
            // styling (highlighted selected classes).
            // The bug report can be found here: https://github.com/SitePen/dgrid/issues/295
            this._grid._lastSelected = null;
        },

        postCreate: function () {
            this.inherited(arguments);

            this.searchBox.encodeSearchText = true;
            this.searchBox.on("searchBoxChange", lang.hitch(this, function (queryText) {
                this.emit("searchBoxChange", queryText);
            }));
        },

        resize: function () {
            // summary:
            //      Resize this widget to the given dimensions.
            // tags:
            //      protected

            // make the grid 100% height
            if (this._grid) {
                var top = domGeometry.position(this._grid.domNode).y;
                var bodyHeight = domGeometry.position(window.body()).h;
                domStyle.set(this._grid.domNode, "height", (bodyHeight - top) + "px");
            }
        },

        _initialize: function () {
            // Enable/Disable search box by content provider search capability
            this.searchBox.set("disabled", !this.queryOptions.query.isSearchable);

            if (!this._grid) {
                this._grid = this._createGrid(this.store, this.queryOptions);
                domConstruct.place(this._grid.domNode, this.gridContainerNode);
            } else { // update _grid's store and query instead of creating new instance
                this._showStandby(true);
                if (this.queryOptions) {
                    this._grid.set("queryOptions", this.queryOptions.options);
                    this._grid.set("query", this.queryOptions.query);
                }
            }
            this.resize(); // grid data changed, so we need to update its height
        },

        _createGrid: function (store, queryOptions) {
            // summary:
            //      Creates and returns grid for displaying content.
            // tags:
            //      private

            var gridClass = declare([OnDemandGrid, DgridSelection, Keyboard, Formatter, ColumnResizer]);
            var grid = new gridClass({
                store: store,
                columns: {
                    name: Tree({
                        field: "name",
                        label: epi.resources.header.name,
                        renderCell: lang.hitch(this, this._renderTreeNode)
                    }),
                    removedOn: {
                        field: "deleted",
                        label: epi.resources.header.removed,
                        formatters: [this._localizeDate, GridMiscUtil.ellipsis]
                    },
                    by: {
                        field: "deletedBy",
                        label: epi.resources.header.by,
                        formatters: [this._createUserFriendlyUsername, GridMiscUtil.ellipsis]
                    },
                    action: { // Restore menu
                        label: " ",
                        formatter: this._renderActionMenu,
                        sortable: false
                    }
                },
                minWidth: 100,
                noDataMessage: this._getNoDataMessage(),
                selectionMode: "single"

            });

            // Set the zIndex to 500 so it appears under the withConfirmation dialog to make it possible for the user to empty the trash even though it still loads
            this._standby = new Standby({
                target: grid.domNode,
                color: "#fff",
                zIndex: 500,
                text: "<div class=\"oui-spinner\"></div>",
                centerIndicator: "text"
            }).placeAt(document.body);
            this._standby.startup();

            this.own(
                aspect.after(grid, "expand", function (target) {
                    var row = target.element ? target : grid.row(target),
                        container = query(row.element).parent()[0];

                    // In firefox, at the first time of expand in grid tree, container's height always smaller than its child.
                    // So that, on the first click to expand a node, nothing happenned.
                    // Clear container's height in order to make container take auto height in this case.
                    if (container) {
                        domStyle.set(container, "height", "");
                    }
                }, true)
            );

            aspect.after(grid, "_processScroll", lang.hitch(this, function () {
                this._showStandby(false);
            }));

            this._showStandby(true);

            // small hack here to remove noDataMessage when store has been notified that new content has been moved to Trash.
            // This should have been implemented in dgrid/List
            // TODO consider a better fix?
            aspect.before(grid, "adjustRowIndices", function (firstRow) {
                if (firstRow) {
                    array.forEach(query("div.dgrid-no-data", this.contentNode), function (div) {
                        html.set(div, "");
                    });
                }
            });

            aspect.around(grid, "insertRow", lang.hitch(this, this._aroundInsertRow));

            // Don't show collap/expand icon when searching
            aspect.before(grid, "renderArray", lang.hitch(this, function (results, beforeNode, options) {
                var querySearch = this.queryOptions.query;
                if (querySearch && querySearch.query === "searchdeletedcontent") {
                    results.map(function (object) {
                        if (object) {
                            object.hasChildren = false;
                        }
                    });
                }
            }));


            if (queryOptions) {
                grid.set("queryOptions", queryOptions.options);
                grid.set("query", queryOptions.query);
            }

            var mouseOverClass = "epi-dgrid-mouseover";
            grid.on(MouseUtil.enterRow, function (evt) {
                domClass.add(this, mouseOverClass); // add mouse over css class when hover a row
            });
            grid.on(MouseUtil.leaveRow, function (evt) {
                domClass.remove(this, mouseOverClass); // remove mouse over css class
            });

            grid.on(".epi-gridRestoreAction:click", lang.hitch(this, function (evt) { // on restore action clicking
                var row = grid.row(evt);
                this.emit("restoreItem", row);
            }));
            grid.on(".epi-gridDeleteAction:click", lang.hitch(this, function (evt) { // on delete action clicking
                var row = grid.row(evt);
                this.emit("deleteItem", row);
            }));

            // Handle ENTER key event for the restore action
            grid.on(".dgrid-column-action:keydown", lang.hitch(this, function (e) {
                if (e.keyCode === keys.ENTER && !e.shiftKey && !e.altKey && !e.ctrlKey) {
                    var row = grid.row(e);
                    this.emit("restoreItem", row);
                }
            }));

            return grid;
        },

        _renderTreeNode: function (object, data, td, options) {
            var title = GridMiscUtil.htmlEncode(formatters.title(data, object.contentLink, object.contentTypeName));

            if (object.thumbnailUrl) {
                domConstruct.create("img", {
                    src: object.thumbnailUrl + string.substitute("?${0}", [new Date().getTime()]),
                    "class": "epi-thumbnail"
                }, td);
                domConstruct.place(GridMiscUtil.ellipsis(GridMiscUtil.htmlEncode(data), title), td);
            } else {
                var iconNodeClass = TypeDescriptorManager.getValue(object.typeIdentifier, "iconClass") || "epi-iconObjectPage";
                domConstruct.place(GridMiscUtil.icon(iconNodeClass + " epi-objectIcon", GridMiscUtil.ellipsis(GridMiscUtil.htmlEncode(data), title)), td);
            }
        },

        _renderActionMenu: function (value) {
            // summary:
            //      Returns HTML string, represents the actions restore and delete
            // tags:
            //      private

            var restoreLink = lang.replace("<a class=\"epi-gridAction epi-gridRestoreAction epi-visibleLink\" title=\"{title}\">{label}</a>",
                { title: resources.restore.tooltip, label: resources.restore.label });

            var deleteLink = lang.replace("<a class=\"epi-gridAction epi-gridDeleteAction epi-visibleLink\" title=\"{title}\">{label}</a>",
                { title: resources.singledelete.tooltip, label: resources.singledelete.label });

            return restoreLink + deleteLink;
        },

        _localizeDate: function (value) {
            // summary:
            //      Returns localized, friendly date as string.
            // tags:
            //      private
            return epiDate.toUserFriendlyString(value);
        },

        _createUserFriendlyUsername: function (name) {
            // summary:
            //      Returns friendly user name as string.
            // tags:
            //      private
            return username.toUserFriendlyString(GridMiscUtil.htmlEncode(name));
        },

        _showStandby: function (visible) {
            // summary:
            //      Set standby visibility.
            // tags:
            //      private

            if (!this._standby) {
                return;
            }
            if (visible) {
                if (!this._standby.isVisible()) {
                    this._standby.show();
                }
            } else {
                this._standby.hide();
            }
        },

        _getNoDataMessage: function () {
            // summary:
            //      Get message in case have no data.
            // tags:
            //      private

            return "<span><span class=\"dijitReset dijitInline\">" + resources.trashitemempty + "</span></span>";
        },

        _aroundInsertRow: function (original) {
            // summary:
            //      Called 'around' the insertRow method to add more class for current row.
            // tags:
            //      protected

            return lang.hitch(this, function (object, parent, beforeNode, i, options) {

                // Call original method
                var row = original.apply(this._grid, arguments);

                if (object && object.thumbnailUrl) {
                    domClass.add(row, "epi-mediaContent");
                }

                return row;
            });
        }

    });

});

},
'dgrid/extensions/ColumnResizer':function(){
define(["dojo/_base/declare", "dojo/on", "dojo/query", "dojo/_base/lang", "dojo/dom", "dojo/dom-geometry", "dojo/has", "../util/misc", "put-selector/put", "dojo/_base/html", "xstyle/css!../css/extensions/ColumnResizer.css"],
function(declare, listen, query, lang, dom, geom, has, miscUtil, put){

function addRowSpan(table, span, startRow, column, id){
	// loop through the rows of the table and add this column's id to
	// the rows' column
	for(var i=1; i<span; i++){
		table[startRow+i][column] = id;
	}
}
function subRowAssoc(subRows){
	// Take a sub-row structure and output an object with key=>value pairs
	// The keys will be the column id's; the values will be the first-row column
	// that column's resizer should be associated with.

	var i = subRows.length,
		l = i,
		numCols = subRows[0].length,
		table = new Array(i);

	// create table-like structure in an array so it can be populated
	// with row-spans and col-spans
	while(i--){
		table[i] = new Array(numCols);
	}

	var associations = {};

	for(i=0; i<l; i++){
		var row = table[i],
			subRow = subRows[i];

		// j: counter for table columns
		// js: counter for subrow structure columns
		for(var j=0, js=0; j<numCols; j++){
			var cell = subRow[js], k;

			// if something already exists in the table (row-span), skip this
			// spot and go to the next
			if(typeof row[j] != "undefined"){
				continue;
			}
			row[j] = cell.id;

			if(cell.rowSpan && cell.rowSpan > 1){
				addRowSpan(table, cell.rowSpan, i, j, cell.id);
			}

			// colSpans are only applicable in the second or greater rows
			// and only if the colSpan is greater than 1
			if(i>0 && cell.colSpan && cell.colSpan > 1){
				for(k=1; k<cell.colSpan; k++){
					// increment j and assign the id since this is a span
					row[++j] = cell.id;
					if(cell.rowSpan && cell.rowSpan > 1){
						addRowSpan(table, cell.rowSpan, i, j, cell.id);
					}
				}
			}
			associations[cell.id] = subRows[0][j].id;
			js++;
		}
	}

	return associations;
}

function resizeColumnWidth(grid, colId, width, parentType, doResize){
	// don't react to widths <= 0, e.g. for hidden columns
	if(width <= 0){ return; }

	var column = grid.columns[colId],
		event,
		rule;
	
	if(!column){
		return;
	}
	
	event = {
		grid: grid,
		columnId: colId,
		width: width,
		bubbles: true,
		cancelable: true
	};
	
	if(parentType){
		event.parentType = parentType;
	}
	
	if(!grid._resizedColumns || listen.emit(grid.headerNode, "dgrid-columnresize", event)){
		// Update width on column object, then convert value for CSS
		if(width === "auto"){
			delete column.width;
		}else{
			column.width = width;
			width += "px";
		}
		
		rule = grid._columnSizes[colId];
		
		if(rule){
			// Modify existing, rather than deleting + adding
			rule.set("width", width);
		}else{
			// Use miscUtil function directly, since we clean these up ourselves anyway
			rule = miscUtil.addCssRule("#" + miscUtil.escapeCssIdentifier(grid.domNode.id) +
				" .dgrid-column-" + miscUtil.escapeCssIdentifier(colId, "-"),
				"width: " + width + ";");
		}

		// keep a reference for future removal
		grid._columnSizes[colId] = rule;
		
		if(doResize !== false){
			grid.resize();
		}
		
		return true;
	}
}

// Functions for shared resizer node

var resizerNode, // DOM node for resize indicator, reused between instances
	resizableCount = 0; // Number of ColumnResizer-enabled grid instances
var resizer = {
	// This object contains functions for manipulating the shared resizerNode
	create: function(){
		resizerNode = put("div.dgrid-column-resizer");
	},
	destroy: function(){
		put(resizerNode, "!");
		resizerNode = null;
	},
	show: function(grid){
		var pos = geom.position(grid.domNode, true);
		resizerNode.style.top = pos.y + "px";
		resizerNode.style.height = pos.h + "px";
		put(document.body, resizerNode);
	},
	move: function(x){
		resizerNode.style.left = x + "px";
	},
	hide: function(){
		resizerNode.parentNode.removeChild(resizerNode);
	}
};

return declare(null, {
	resizeNode: null,
	
	// minWidth: Number
	//		Minimum column width, in px.
	minWidth: 40,
	
	// adjustLastColumn: Boolean
	//		If true, adjusts the last column's width to "auto" at times where the
	//		browser would otherwise stretch all columns to span the grid.
	adjustLastColumn: true,
	
	_resizedColumns: false, // flag indicating if resizer has converted column widths to px
	
	buildRendering: function(){
		this.inherited(arguments);
		
		// Create resizerNode when first grid w/ ColumnResizer is created
		if(!resizableCount++){
			resizer.create();
		}
	},
	
	destroy: function(){
		this.inherited(arguments);
		
		// Remove any applied column size styles since we're tracking them directly
		for(var name in this._columnSizes){
			this._columnSizes[name].remove();
		}
		
		// If this is the last grid on the page with ColumnResizer, destroy the
		// shared resizerNode
		if(!--resizableCount){
			resizer.destroy();
		}
	},
	
	resizeColumnWidth: function(colId, width){
		// Summary:
		//      calls grid's styleColumn function to add a style for the column
		// colId: String
		//      column id
		// width: Integer
		//      new width of the column
		return resizeColumnWidth(this, colId, width);
	},
	
	configStructure: function(){
		var oldSizes = this._oldColumnSizes = lang.mixin({}, this._columnSizes), // shallow clone
			k;
		
		this._resizedColumns = false;
		this._columnSizes = {};
		
		this.inherited(arguments);
		
		// Remove old column styles that are no longer relevant; this is specifically
		// done *after* calling inherited so that _columnSizes will contain keys
		// for all columns in the new structure that were assigned widths.
		for(k in oldSizes){
			if(!(k in this._columnSizes)){
				oldSizes[k].remove();
			}
		}
		delete this._oldColumnSizes;
	},
	
	_configColumn: function(column){
		this.inherited(arguments);
		
		var colId = column.id,
			rule;
		
		if("width" in column){
			// Update or add a style rule for the specified width
			if((rule = this._oldColumnSizes[colId])){
				rule.set("width", column.width + "px");
			}else{
				rule = miscUtil.addCssRule("#" + miscUtil.escapeCssIdentifier(this.domNode.id) +
					" .dgrid-column-" + miscUtil.escapeCssIdentifier(colId, "-"),
					"width: " + column.width + "px;");
			}
			this._columnSizes[colId] = rule;
		}
	},
	
	renderHeader: function(){
		this.inherited(arguments);
		
		var grid = this;
		
		var assoc;
		if(this.columnSets && this.columnSets.length){
			var csi = this.columnSets.length;
			while(csi--){
				assoc = lang.mixin(assoc||{}, subRowAssoc(this.columnSets[csi]));
			}
		}else if(this.subRows && this.subRows.length > 1){
			assoc = subRowAssoc(this.subRows);
		}

		var colNodes = query(".dgrid-cell", grid.headerNode),
			i = colNodes.length;
		while(i--){
			var colNode = colNodes[i],
				id = colNode.columnId,
				col = grid.columns[id],
				childNodes = colNode.childNodes,
				resizeHandle;

			if(!col || col.resizable === false){ continue; }

			var headerTextNode = put("div.dgrid-resize-header-container");
			colNode.contents = headerTextNode;

			// move all the children to the header text node
			while(childNodes.length > 0){
				put(headerTextNode, childNodes[0]);
			}

			resizeHandle = put(colNode, headerTextNode, "div.dgrid-resize-handle.resizeNode-" +
				miscUtil.escapeCssIdentifier(id, "-"));
			resizeHandle.columnId = assoc && assoc[id] || id;
		}

		if(!grid.mouseMoveListen){
			// establish listeners for initiating, dragging, and finishing resize
			listen(grid.headerNode,
				".dgrid-resize-handle:mousedown" +
					(has("touch") ? ",.dgrid-resize-handle:touchstart" : ""),
				function(e){
					grid._resizeMouseDown(e, this);
					grid.mouseMoveListen.resume();
					grid.mouseUpListen.resume();
				}
			);
			grid._listeners.push(grid.mouseMoveListen = listen.pausable(document,
				"mousemove" + (has("touch") ? ",touchmove" : ""),
				miscUtil.throttleDelayed(function(e){ grid._updateResizerPosition(e); })
			));
			grid._listeners.push(grid.mouseUpListen = listen.pausable(document,
				"mouseup" + (has("touch") ? ",touchend" : ""),
				function(e){
					grid._resizeMouseUp(e);
					grid.mouseMoveListen.pause();
					grid.mouseUpListen.pause();
				}
			));
			// initially pause the move/up listeners until a drag happens
			grid.mouseMoveListen.pause();
			grid.mouseUpListen.pause();
		}
	}, // end renderHeader

	_resizeMouseDown: function(e, target){
		// Summary:
		//      called when mouse button is pressed on the header
		// e: Object
		//      mousedown event object
		
		// preventDefault actually seems to be enough to prevent browser selection
		// in all but IE < 9.  setSelectable works for those.
		e.preventDefault();
		dom.setSelectable(this.domNode, false);
		this._startX = this._getResizeMouseLocation(e); //position of the target
		
		this._targetCell = query(".dgrid-column-" + miscUtil.escapeCssIdentifier(target.columnId, "-"),
			this.headerNode)[0];

		// Show resizerNode after initializing its x position
		this._updateResizerPosition(e);
		resizer.show(this);
	},
	_resizeMouseUp: function(e){
		// Summary:
		//      called when mouse button is released
		// e: Object
		//      mouseup event object
		
		var columnSizes = this._columnSizes,
			colNodes, colWidths, gridWidth;
		
		if(this.adjustLastColumn){
			// For some reason, total column width needs to be 1 less than this
			gridWidth = this.headerNode.clientWidth - 1;
		}
		
		//This is used to set all the column widths to a static size
		if(!this._resizedColumns){
			colNodes = query(".dgrid-cell", this.headerNode);
			
			if(this.columnSets && this.columnSets.length){
				colNodes = colNodes.filter(function(node){
					var idx = node.columnId.split("-");
					return idx[0] == "0" && !(node.columnId in columnSizes);
				});
			}else if(this.subRows && this.subRows.length > 1){
				colNodes = colNodes.filter(function(node){
					return node.columnId.charAt(0) == "0" && !(node.columnId in columnSizes);
				});
			}
			
			// Get a set of sizes before we start mutating, to avoid
			// weird disproportionate measures if the grid has set
			// column widths, but no full grid width set
			colWidths = colNodes.map(function(colNode){
				return colNode.offsetWidth;
			});
			
			// Set a baseline size for each column based on
			// its original measure
			colNodes.forEach(function(colNode, i){
				resizeColumnWidth(this, colNode.columnId, colWidths[i], null, false);
			}, this);
			
			this._resizedColumns = true;
		}
		dom.setSelectable(this.domNode, true);
		
		var cell = this._targetCell,
			delta = this._getResizeMouseLocation(e) - this._startX, //final change in position of resizer
			newWidth = cell.offsetWidth + delta, //the new width after resize
			obj = this._getResizedColumnWidths(),//get current total column widths before resize
			totalWidth = obj.totalWidth,
			lastCol = obj.lastColId,
			lastColWidth = query(".dgrid-column-" + miscUtil.escapeCssIdentifier(lastCol, "-"),
				this.headerNode)[0].offsetWidth;
		
		if(newWidth < this.minWidth){
			//enforce minimum widths
			newWidth = this.minWidth;
		}
		
		if(resizeColumnWidth(this, cell.columnId, newWidth, e.type)){
			if(cell.columnId != lastCol && this.adjustLastColumn){
				if(totalWidth + delta < gridWidth) {
					//need to set last column's width to auto
					resizeColumnWidth(this, lastCol, "auto", e.type);
				}else if(lastColWidth-delta <= this.minWidth) {
					//change last col width back to px, unless it is the last column itself being resized...
					resizeColumnWidth(this, lastCol, this.minWidth, e.type);
				}
			}
		}
		resizer.hide();
		
		// Clean up after the resize operation
		delete this._startX;
		delete this._targetCell;
	},
	
	_updateResizerPosition: function(e){
		// Summary:
		//      updates position of resizer bar as mouse moves
		// e: Object
		//      mousemove event object

		if(!this._targetCell){ return; } // Release event was already processed
		
		var mousePos = this._getResizeMouseLocation(e),
			delta = mousePos - this._startX, //change from where user clicked to where they drag
			width = this._targetCell.offsetWidth,
			left = mousePos;
		if(width + delta < this.minWidth){ 
			left = this._startX - (width - this.minWidth); 
		}
		resizer.move(left);
	},

	_getResizeMouseLocation: function(e){
		//Summary:
		//      returns position of mouse relative to the left edge
		// e: event object
		//      mouse move event object
		var posX = 0;
		if(e.pageX){
			posX = e.pageX;
		}else if(e.clientX){
			posX = e.clientX + document.body.scrollLeft +
				document.documentElement.scrollLeft;
		}
		return posX;
	},
	_getResizedColumnWidths: function (){
		//Summary:
		//      returns object containing new column width and column id
		var totalWidth = 0,
			colNodes = query(
				(this.columnSets ? ".dgrid-column-set-cell " : "") + "tr:first-child .dgrid-cell",
				this.headerNode);

		var i = colNodes.length;
		if(!i){ return {}; }

		var lastColId = colNodes[i-1].columnId;

		while(i--){
			totalWidth += colNodes[i].offsetWidth;
		}
		return {totalWidth: totalWidth, lastColId: lastColId};
	}
});
});

},
'url:epi-cms/widget/templates/TrashItemList.html':"﻿<div>\r\n    <div class=\"epi-trashHeader clearfix\">\r\n        <div class=\"epi-gadgetInnerToolbar\" data-dojo-attach-point=\"searchBoxContainer\">\r\n            <div data-dojo-type=\"epi/shell/widget/SearchBox\" data-dojo-attach-point=\"searchBox\"></div>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridContainerNode\"></div>\r\n</div>\r\n",
'epi-cms/widget/EmptyTrashMenu':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",

    // Dijit
    "dijit/layout/_LayoutWidget",

    // EPi Framework
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/command/builder/DropDownButtonBuilder",
    "epi/shell/command/builder/MenuAssembler",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash"
],

function (
// Dojo
    declare,

    // Dijit
    _LayoutWidget,

    // EPi Framework
    ButtonBuilder,
    DropDownButtonBuilder,
    MenuAssembler,

    // Resources
    resources
) {

    return declare([_LayoutWidget], {
        // summary:
        //      A widget to display empty trash button.
        //
        // tags:
        //      internal

        resources: resources,

        _setCommandsAttr: function (commands) {
            // summary:
            //      Set empty trash commands.
            // tags:
            //      private

            this._set("commands", commands);
            this._bindEmptyTrashMenu(commands);
        },

        _bindEmptyTrashMenu: function (commands) {
            // summary:
            //      Bind empty button by empty provider commands with confirmation dialog.
            // tags:
            //      private

            // destroy all old button or menu commands
            this.destroyDescendants();

            if (!commands || commands.length < 1) {
                return;
            }

            var isDropDownButton = commands.length > 1;

            var emptyButton = null;
            //Assemble the menu or button for the available commands
            if (isDropDownButton) {
                emptyButton = new DropDownButtonBuilder({
                    settings: {
                        label: resources.emptytrash.title,
                        dropDownPosition: ["below-alt"] // align dropdown menu open on the left of the button
                    }
                });
            } else {
                emptyButton = new ButtonBuilder({
                    settings: {
                        label: resources.emptytrash.title
                    }
                });

                this.commands[0].label = resources.emptytrash.title;
            }

            new MenuAssembler({ configuration: [{ builder: emptyButton, target: this}], commandSource: this }).build();
        },

        getCommands: function () {
            // summary:
            //      Get commands with confirmation.
            // tags:
            //      public

            return this.get("commands");
        }
    });
});

},
'epi-cms/widget/TrashViewModelConfirmation':function(){
﻿define([
    // Dojo base
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/when",

    // Epi Framework
    "epi/dependency",
    "epi/string",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/dialog/Dialog",
    "epi/shell/DialogService",

    // Epi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/widget/ContentSelectorDialog",
    "epi-cms/contentediting/ContentActionSupport",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash"
], function (
// Dojo base
    array,
    declare,
    Deferred,
    lang,
    aspect,
    when,

    // Epi Framework
    dependency,
    epistring,
    TypeDescriptorManager,
    Dialog,
    dialogService,

    // Epi CMS
    ApplicationSettings,
    ContentSelectorDialog,
    ContentActionSupport,

    // Resources
    resources
) {

    return function (model) {
        // summary:
        //      Attaches confirmation to the restore method of trash view model
        // tags:
        //      internal

        var _showConfirmation = function (title, description, parentLink) {
            // summary:
            //      Wrap epi/shell/widget/dialog/Confirmation for short type
            //      and return deferred object
            // description:
            //      String : Text to display on dialog
            // parentLink:
            //      Old parent link of specific content
            // tags:
            //		private

            return dialogService.confirmation({
                description: epistring.toHTML(description),
                title: epistring.toHTML(title)
            }).then(function () {
                return parentLink;
            });
        };

        var _getcontainedTypes = function (typeIdentifier) {
            // summary:
            //      Returns all the contained types (for the content repository descriptors)
            // typeIdentifier: [String]
            // tags:
            //		private

            var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");


            var containedTypes = [];
            contentRepositoryDescriptors.list().forEach(function (key) {
                contentRepositoryDescriptors.get(key).containedTypes.forEach(function (type) {
                    if (TypeDescriptorManager.isBaseTypeIdentifier(typeIdentifier, type)) {
                        containedTypes = containedTypes.concat(contentRepositoryDescriptors.get(key).containedTypes);
                    }
                });
            });

            return containedTypes;
        };

        var _showContentSelectorDialog = function (content, roots, description) {
            // summary:
            //      Show contentSelector dialog for User select new parent for content
            // content: [Object]
            //      The specific content
            // roots: [Object]
            //      Root of content provider
            // description: [String]
            //      The text show on title of dialog
            // tags:
            //		private

            var df = new Deferred(),
                dialogResources = resources.restore.dialog,
                containerTypes = TypeDescriptorManager.getValue(content.typeIdentifier, "containerTypes"),
                settings = {
                    showButtons: false,
                    roots: roots,
                    multiRootsMode: true,
                    canSelectOwnerContent: false,
                    allowedTypes: containerTypes || _getcontainedTypes(content.typeIdentifier),
                    selectedContentType: content.typeIdentifier,
                    showAllLanguages: true
                };

            var pageSelector = new ContentSelectorDialog(settings);

            var dialog = new Dialog({
                title: epistring.toHTML(dialogResources.title),
                description: description || epistring.toHTML(dialogResources.description),
                confirmActionText: epistring.toHTML(resources.restore.label),
                content: pageSelector
            });

            var _setStateOkButton = function (value) {
                when(model.contentStore.query({ id: value }), function (selectedContent) {
                    dialog.onActionPropertyChanged({ name: "ok" }, "disabled", !selectedContent);
                });
            };

            // listen for onChange event to enable/disable OK button
            pageSelector.on("change", function (value) {
                if (value) {
                    _setStateOkButton(value);
                } else {
                    dialog.onActionPropertyChanged({ name: "ok" }, "disabled", true);
                }
            });

            dialog.on("execute", function () {
                df.resolve(pageSelector.get("value"));
            });
            dialog.on("onHide", function () {
                df.cancel();
            });
            dialog.show();
            // this need to be executed after show, in order to have reference to the button
            // make sure OK button will be disabled on load, since no page has been selected.
            pageSelector.onChange(null);

            return df;
        };

        var _isPermissionValid = function (content, parentContent) {
            // summary:
            //      Check permission of parent content and language permission for content
            // content: [Object]
            //      The content need to restore
            // parentContent: [Object]
            //      The destination parent content
            // tags:
            //      private

            var action = ContentActionSupport.action.Create,
                createProviderCapability = ContentActionSupport.providerCapabilities.Create,
                canExecute = parentContent && !(parentContent.isWastebasket || parentContent.isDeleted) &&  // Ensure a parent content is available and it isn't deleted
                           ContentActionSupport.isActionAvailable(parentContent, action, createProviderCapability, true, true);  // Ensure the create action is available to the user on parent node.

            if (!canExecute) {
                dialogService.alert(epistring.toHTML(resources.restore.userdonothavepermission));
                return false;
            }
            return true;
        };

        var _getRoots = function (content) {
            var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            var roots = [];

            contentRepositoryDescriptors.list().forEach(function (key) {
                var descriptor = contentRepositoryDescriptors.get(key);

                descriptor.containedTypes.forEach(function (type) {
                    if (TypeDescriptorManager.isBaseTypeIdentifier(content.typeIdentifier, type)) {
                        descriptor.roots.forEach(function (root) {

                            if (roots.indexOf(root) === -1) {
                                roots.push(root);
                            }
                        });
                    }
                });
            });
            // Hide assets folder if "Root" node already exists
            var rootId = ApplicationSettings.rootPage.toString();
            var assetsFolderId = ApplicationSettings.globalAssetsFolder.toString();
            if (roots.includes(rootId)) {
                var index =  roots.indexOf(assetsFolderId);
                if (index > -1) {
                    roots.splice(index,1);
                }
            }

            return roots;
        };

        var _executeRestore = function (model, content, parentLink, isConfirmation, callbackMethod, description) {
            // summary:
            //      Execute restore content to parent
            // model: [Object]
            //      The model of module
            // content: [Object]
            //      The content need to restore
            // parentLink: [Object]
            //      The destination parent content
            // isConfirmation: [Boolean]
            //      The flag to indicator dialog will show
            // callbackMethod: [Function]
            //      The method will execute restore
            // description: [String]
            //      The text show on title of dialog
            // tags:
            //      private
            var confirmation;

            if (!callbackMethod || !model || !content) {
                return false;
            }


            if (isConfirmation && parentLink) {
                confirmation = _showConfirmation(resources.restore.label, resources.restore.confirmquestion, parentLink);
            } else {
                confirmation = _showContentSelectorDialog(content, _getRoots(content), description);
            }
            when(confirmation, function (parentLink) {
                when(model.contentStore.get(parentLink), function (parentContent) {
                    if (!_isPermissionValid(content, parentContent)) {
                        return false;
                    }
                    return callbackMethod.apply(model, [content, parentLink]);
                });
            }, function () {
                return false;
            });
        };

        aspect.around(model, "restore", function (originalMethod) {
            return function (deletingContent, targetLink) {

                return when(model.contentStore.query({ id: deletingContent.contentLink }),
                //Success callback
                    lang.hitch(this, function (content) {
                        var description = null;
                        var action = null;

                        if (Object.prototype.hasOwnProperty.call(content, "statusCode") && (content.statusCode === 401 || content.statusCode === 403)) {
                            description = epistring.toHTML(resources.restore.userdonothavepermission);
                        }

                        if (Object.prototype.hasOwnProperty.call(content, "isDeleted") && !content.isDeleted) {
                            description = epistring.toHTML(resources.restore.contentalreadyrestored);
                            action = function () {
                                model.updateTrash(model.get("currentTrash"));
                            };
                        }

                        if (description) {
                            dialogService.alert(description).then(action);
                            return false;
                        }

                        var currentTrash = model.get("currentTrash");
                        if (content.parentLink !== currentTrash.wasteBasketLink) {
                            return when(_showContentSelectorDialog(content, _getRoots(content)), function (parentLink) {
                                when(model.contentStore.get(parentLink), function (parentContent) {
                                    if (!_isPermissionValid(content, parentContent)) {
                                        return false;
                                    }
                                    return originalMethod.apply(model, [content, parentLink]);
                                });
                            }, function () {
                                return false;
                            });
                        } else {
                            return when(model.getOldParent(content.contentLink), function (parentContent) {
                                // Restore to old parent of content, otherwise select new destination to restore
                                var parentLink = parentContent ? parentContent.contentLink : null;
                                _executeRestore(model, content, parentLink, parentLink != null, originalMethod);
                            });
                        }
                    }),
                    //Error callback
                    lang.hitch(this, function (error) {
                        dialogService.alert(epistring.toHTML(resources.restore.contentdeletedpermanently))
                            .then(function () {
                                model.updateTrash(model.get("currentTrash"));
                            });
                        return false;
                    })
                );
            };
        });

        return model;
    };
});

},
'epi-cms/widget/command/EmptyTrash':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command"
], function (
    declare,
    _Command
) {

    return declare([_Command], {
        // summary:
        //      A command that empty items in tab container in trash.
        //
        // tags:
        //      internal

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: null,

        // tooltip: [public] String
        //		The action text of the command to be used in visual elements.
        tooltip: null,

        // hasDeleteAccess: [public] Boolean
        //		If true the user can empty the trash.
        hasDeleteAccess: false,

        // trashId: [public] String
        //      The ID of specific trash to empty.
        trashId: null,

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the view trash view.
            // tags:
            //		protected

            this.model.emptyTrash(this.trashId);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var canExecute = this.model && this.hasDeleteAccess && !!this.trashId;
            this.set("canExecute", canExecute);
        }
    });
});

},
'epi-cms/widget/command/RestoreContent':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command"
], function (
    declare,
    _Command
) {

    return declare([_Command], {
        // summary:
        //      Represents a command to restore content in trash, which allows user to select a parent to restore content to.
        //
        // tags:
        //      internal

        // content: [public] Object
        //      Represents the current content to be restored.
        content: null,

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the view trash view.
            // tags:
            //		protected

            if (this.canExecute && this.content) {
                this.model.restore(this.content);
            }
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var canExecute = !!this.model;
            this.set("canExecute", canExecute);
        }
    });
});

},
'epi-cms/widget/command/DeleteContent':function(){
define([
    "dojo/_base/declare",
    "epi/shell/command/_Command"
], function (
    declare,
    _Command
) {
    return declare([_Command], {
        // summary:
        //      A command that delete a single content in trash.
        //
        // tags:
        //      internal

        // trashId: [public] String
        //      The ID of the item to be removed.
        contentId: null,

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the view trash view.
            // tags:
            //		protected

            this.model.deleteContent(this.contentId);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var canExecute = this.model && !!this.contentId;
            this.set("canExecute", canExecute);
        }
    });
});

},
'url:epi-cms/widget/templates/Trash.html':"﻿<div class=\"epi-trash\">\r\n    <div class=\"epi-listingTopContainer\">\r\n        <h1 class=\"dijitInline\">${resources.heading}</h1>\r\n        <div class=\"epi-mediumButton epi-button--bold epi-emptyCommand\" data-dojo-attach-point=\"emptyTrashMenu\" data-dojo-type=\"epi-cms/widget/EmptyTrashMenu\"\r\n            data-dojo-props=\"title: '${resources.emptytrash.tooltip}'\"></div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"stackContainer\">\r\n        <div data-dojo-type=\"dijit/layout/TabContainer\" data-dojo-attach-point=\"tabContainer\" data-dojo-props=\"doLayout:false, useMenu:true, useSlider:false\"> <!-- doLayout=\"false\" for flexible height -->\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/widget/viewmodel/TrashViewModel':function(){
define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",
    "dojo/Stateful",
    "dojo/_base/json",

    // EPi Framework
    "epi/epi",
    "epi/shell/TypeDescriptorManager",
    "epi/dependency",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash"
],

function (
// Dojo
    array,
    declare,
    lang,
    topic,
    when,
    Stateful,
    json,

    // EPi Framework
    epi,
    TypeDescriptorManager,
    dependency,

    // Resources
    resources
) {
    return declare([Stateful], {
        // summary:
        //      The view model for trash component widget
        //
        // tags:
        //      internal

        resources: resources,

        // trashes: [List]
        //      List of trash, including system and content provider's trash.
        trashes: null,

        // currentTrash: [Object]
        //      Current active trash to get content from.
        currentTrash: null,

        // queryOptions: [Object]
        //      Query options object, which contains query object and options object, to get content for a specific trash.
        queryOptions: null,

        // isEmptyTrash: [Boolean]
        //      State of Empty Trash action.
        isEmptyTrash: false,

        // storeRegistry: [Object]
        //      The store registry.
        storeRegistry: null,

        // contentStore: [Object]
        //      Represents the REST store to get data.
        contentStore: null,

        // contentService: [epi-cms/contentediting/ContentHierarchyService]
        //      A service to perform changes to the content structure
        contentService: null,

        // contentStore: [Object]
        //      Represents the REST store to get trashes.
        trashStore: null,

        // showAllLanguages: [bool]
        //      Flag to indicate whether should we get all language for content in trash.
        showAllLanguages: true,

        // _contentRepositoryDescriptors: [Object]
        //      Contains settings for different content repositories, like root and contained types.
        _contentRepositoryDescriptors: null,

        postscript: function () {
            this.inherited(arguments);

            this.storeRegistry = this.storeRegistry || dependency.resolve("epi.storeregistry");

            this.contentStore = this.contentStore || this._getStore();
            this.contentService = this.contentService || dependency.resolve("epi.cms.ContentHierarchyService");
            this.trashStore = this.trashStore || this.storeRegistry.get("epi.cms.wastebasket");

            this._contentRepositoryDescriptors = this._contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");

            if (!this.trashes) {
                this._createTrashes();
            }
        },

        destroy: function () {
            epi.removeDelegateAspects(this.contentStore);
        },

        _getStore: function () {
            var store = this.storeRegistry.get("epi.cms.content.light"),
                model = this;
            var hierarchicalStore = epi.delegate(store, {
                // the Tree plugin for dGrid needs these 2 functions to be available in store:
                getChildren: function (parent, options) {
                    var currentTrash = model.get("currentTrash"),
                        queryOptions = model._createQueryOptions(currentTrash);

                    lang.mixin(queryOptions.query, { referenceId: parent.contentLink });
                    return this.query(queryOptions.query, queryOptions.options);
                },

                mayHaveChildren: function (parent) {
                    return parent.hasChildren;
                }
            }, ["notify"]);

            return hierarchicalStore;
        },

        _createTrashes: function () {
            when(this.trashStore.query(), function (trashes) {
                this.set("trashes", lang.clone(trashes));
            }.bind(this));
        },

        _currentTrashSetter: function (trash) {
            // summary:
            //      Sets current trash
            // tags:
            //      private
            this.currentTrash = trash;

            if (trash.isRequireLoad) {
                this.updateTrash(trash);
                trash.isRequireLoad = false;
            }
        },

        getEmptyTrashConfirmMessage: function (trashName) {
            // summary:
            //      Get the empty trash confirm message
            // trashName: String
            //      The name of the trash to append to the confirm message if there are more than one provider
            // tags:
            //      public

            var confirmMessage = resources.emptytrash.singleproviderdescription;

            if (this.trashes.length > 1) {
                confirmMessage = resources.emptytrash.description.replace("{0}", trashName);
            }

            return confirmMessage;
        },

        updateTrash: function (trash) {
            // summary:
            //      Process active trash only, otherwise return empty list.
            // tags:
            //      public

            if (trash && trash.active) {
                this.set("queryOptions", this._createQueryOptions(trash)); // ask widget to update UI, by using this query
            } else {
                this.set("queryOptions", null);
            }
        },

        _createQueryOptions: function (trash) {
            // summary:
            //      Creates a query options object from input trash.
            // tags:
            //      private

            var query = { referenceId: trash.wasteBasketLink, query: "getchildren" };
            var options = { ignore: ["query"], comparers: this._createComparers() };

            if (this.showAllLanguages) {
                lang.mixin(query, { allLanguages: this.showAllLanguages });
                options.ignore.push("allLanguages");
            }

            if (trash.isSearchable) {
                lang.mixin(query, { isSearchable: trash.isSearchable });
                options.ignore.push("isSearchable");
            }

            if (trash.queryText) {
                lang.mixin(query, {
                    query: "searchdeletedcontent",
                    matchProvider: true,
                    queryText: trash.queryText
                });
            }

            return { query: query, options: options };
        },

        _createComparers: function () {
            // summary:
            //      Creates a comparer which check type identifier, to be used in CustomQueryEngine to filter content by type identifier.
            // tags:
            //      private

            return {
                referenceId: function (required, object) {
                    return required === object.parentLink;
                }
            };
        },

        emptyTrash: function (trashId) {
            // summary:
            //      Delete all items from a specific trash.
            // tags:
            //      public

            if (!trashId) {
                return;
            }

            when(this.trashStore.executeMethod("Empty", trashId), function (response) {
                // Get all trashes that have specific trash id.
                var trashes = array.filter(this.get("trashes"), function (trash) {
                    return trash && trash.wasteBasketLink === trashId;
                });

                // loop through all affected trashes, turn the isRequireLoad flag to true
                array.forEach(trashes, function (trash) {
                    trash.isRequireLoad = true;
                });

                this.isEmptyTrash = true;
                topic.publish("/epi/cms/trash/empty", response.extraInformation);

                // let's refresh the data of current trash now
                if (this.currentTrash.wasteBasketLink === trashId) {
                    this.set("currentTrash", this.currentTrash);
                }

                // ask UI to show alert message if needed
            }.bind(this), function (response) {
                if (response.status === 403) {
                    this.set("actionResponse", resources.emptytrash.accessdenied);
                }
            }.bind(this));
        },

        deleteContent: function (contentLink) {
            // summary:
            //      Delete a specific content from a specific trash.
            //      Request to update UI in the case of deleting content successfully
            //  contentId: ContentLink
            //      The content link to delete
            // tags:
            //      public

            if (!contentLink) {
                return;
            }
            when(this.trashStore.executeMethod("PermanentDelete", contentLink)
                .then(function (response) {
                    var self = this;
                    var trashes = this.get("trashes");
                    var trashIndex;

                    trashes.some(function (trash, index) {
                        if (response.extraInformation === trash.wasteBasketLink) {
                            trashIndex = index;
                            trash.isRequireLoad = true;
                            self.set("currentTrash", trash);
                            return true;
                        }
                        return false;
                    });

                    // update isRequireLoad to true for the matching wasteBasketLink
                    // because the currentTrash setter which is called in the trashes.some function above resets isRequireLoad to false
                    if (trashIndex) {
                        trashes[trashIndex].isRequireLoad = true;
                    }
                }.bind(this))
                .otherwise(function (response) {
                    if (response.status === 403) {
                        this.set("actionResponse", resources.singledelete.accessdenied);
                    } else if (response.status === 400) {
                        this.set("actionResponse", resources.singledelete.notfromwastebasket);
                    }
                }.bind(this)));
        },

        restore: function (sourceContent, targetLink) {
            // summary:
            //      Restore content from a specific trash to specific content.
            //  source: Content
            //      The content source to restore
            // targetLink: ContentLink
            //      The target link to restore
            // tags:
            //      public

            if (!(sourceContent && sourceContent.contentLink && sourceContent.isDeleted && targetLink)) {
                return;
            }

            return this.contentService.move(sourceContent.contentLink, targetLink);
        },

        getOldParent: function (contentLink) {
            // summary:
            //      Get old parent of specific contentLink.
            // tags:
            //      public

            var query = {
                referenceId: contentLink,
                query: "getrestorepoint",
                allLanguages: true
            };

            return when(this.contentStore.query(query)).then(function (parentContent) {
                var parent = parentContent && lang.isArray(parentContent) && parentContent.length > 0 ? parentContent[0] : null;
                return parent;
            });
        }
    });
});

},
'epi-cms/component/VersionsComponent':function(){
define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-geometry",
    "dojo/dom-class",
    "dojo/when",

    // Dijit
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    // EPi Framework
    "epi/dependency",

    // EPi CMS
    "epi-cms/component/_ShowAllLanguagesMixin",
    "epi-cms/component/Versions",

    // Resources
    "dojo/text!./templates/Versions.html",
    "epi/i18n!epi/cms/nls/episerver.cms.components.sitetree"
], function (
// Dojo
    array,
    declare,
    lang,
    domGeometry,
    domClass,
    when,

    // Dijit
    _LayoutWidget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    // EPi Framework
    dependency,

    // EPi CMS
    _ShowAllLanguagesMixin,
    Versions,

    // Resources
    template,
    res
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ShowAllLanguagesMixin], {
        // summary:
        //      Component for displaying the versions list.
        //
        // tags:
        //      internal

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: template,

        res: res,

        postCreate: function () {
            this.inherited(arguments);

            when(this.versions._isSiteMultilingual()).then(function (isSiteMultilingual) {
                if (!isSiteMultilingual) {
                    return;
                }
                this.loadShowAllLanguages().then(function (showAllLanguages) {
                    this.versions.set("showAllLanguages", showAllLanguages);
                    this._setShowAllLanguagesLinkVisibility(showAllLanguages);
                }.bind(this));
            }.bind(this));

            this.own(this.versions.watch("showAllLanguages", function () {
                var showAllLanguages = this.versions.get("showAllLanguages");
                if (this.showAllLanguages !== showAllLanguages) {
                    this.saveShowAllLanguages(showAllLanguages);
                }
                this.set("showAllLanguages", showAllLanguages);

                this._setShowAllLanguagesLinkVisibility(showAllLanguages);
            }.bind(this)));

            this.own(this.on(".epi-versions-language-link:click", function () {
                this.versions.set("showAllLanguages", true);
            }.bind(this)));
        },

        layout: function () {
            // summary:
            //		Resize and layout.
            // tags:
            //		protected

            var cb = this._contentBox, ocb = this._oldContentBox;

            if (!cb) {
                return;
            }

            if (!ocb || cb.w !== ocb.w || cb.h !== ocb.h) {
                this._oldContentBox = cb;
                this._relayout();
            }
        },

        _relayout: function () {
            var showAllLanguagesHeight = domClass.contains(this.bottomLinkContainer, "dijitHidden") ? 0 : domGeometry.getMarginBox(this.bottomLinkContainer).h;

            domGeometry.setMarginBox(this.versions.domNode, {
                w: this._contentBox.w,
                h: this._contentBox.h - showAllLanguagesHeight
            });
        },

        _setShowAllLanguagesLinkVisibility: function (showAllLanguages) {
            domClass.toggle(this.bottomLinkContainer, "dijitHidden", showAllLanguages);
            if (!this._contentBox) {
                return;
            }
            this._relayout();
        }
    });
});

},
'epi-cms/component/Versions':function(){
﻿define([
    // Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/string",
    "dojo/topic",
    "dojo/when",
    "dojo/_base/json",
    "dojox/html/entities",

    // DGrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "epi-cms/dgrid/formatters",

    // EPi Framework
    "epi",
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/command/_WidgetCommandProviderMixin",
    "epi/shell/command/withConfirmation",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/DialogService",

    // EPi CMS
    "epi-cms/_MultilingualMixin",
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference",
    "epi-cms/component/command/DeleteVersion",
    "epi-cms/component/command/DeleteLanguageBranch",
    "epi-cms/component/command/SetCommonDraft",
    "epi-cms/command/ShowAllLanguages",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/_GridWidgetBase",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions"

], function (
    // Dojo
    array,
    declare,
    lang,
    aspect,
    domClass,
    string,
    topic,
    when,
    json,
    entities,

    // DGrid
    OnDemandGrid,
    Selection,
    formatters,

    // EPi Framework
    epi,
    dependency,
    TypeDescriptorManager,
    _WidgetCommandProviderMixin,
    withConfirmation,
    _FocusableMixin,
    dialogService,

    // EPi CMS
    _MultilingualMixin,
    ApplicationSettings,
    ContentReference,
    DeleteVersion,
    DeleteLanguageBranch,
    SetCommonDraft,
    ShowAllLanguagesCommand,
    ContentActionSupport,
    _GridWidgetBase,

    // Resources
    resources
) {

    return declare([_GridWidgetBase, _WidgetCommandProviderMixin, _FocusableMixin, _MultilingualMixin], {
        // summary:
        //      This component will list all versions of a content item.
        //
        // tags:
        //      internal

        // showAllLanguages: [readonly] Boolean
        //		Flag which indicates whether to show all languages. Value is true if all languages should be shown; otherwise false.
        showAllLanguages: true,

        // isMultilingual:  Boolean
        //		Flag which indicates whether the Show All Languages command should be enabled or disabled, based on Read access right and the number of available languages.
        isMultilingual: false,

        postMixInProperties: function () {
            // summary:
            //		Called after constructor parameters have been mixed-in; sets default values for parameters that have not been initialized.
            // tags:
            //		protected

            this._commonDrafts = {};

            this.storeKeyName = "epi.cms.contentversion";
            this.ignoreVersionWhenComparingLinks = false;
            this.forceContextReload = true;

            this.inherited(arguments);

            this._currentContentLanguage = ApplicationSettings.currentContentLanguage;

            this._showAllLanguagesCommand = new ShowAllLanguagesCommand({ model: this });

            var registry = dependency.resolve("epi.storeregistry");
            this._contentStore = registry.get("epi.cms.contentdata");
        },

        buildRendering: function () {
            // summary:
            //		Construct the UI for this widget with this.domNode initialized as a dgrid.
            // tags:
            //		protected

            this.inherited(arguments);

            var customGridClass = declare([OnDemandGrid, Selection]);
            this.grid = new customGridClass({
                columns: {
                    language: {
                        label: epi.resources.header.language
                    },
                    status: {
                        label: epi.resources.header.status,
                        renderCell: formatters.commonDraft
                    },
                    savedDate: {
                        label: epi.resources.header.saved,
                        formatter: this._localizeDate
                    },
                    savedBy: {
                        label: epi.resources.header.by,
                        formatter: this._createUserFriendlyUsername
                    }
                },
                selectionMode: "single",
                selectionEvents: "click,dgrid-cellfocusin",
                sort: [{ attribute: "savedDate", descending: true }]
            }, this.domNode);
        },

        postCreate: function () {
            this.inherited(arguments);

            this.add("commands", this._showAllLanguagesCommand);
            this._commonDraftCommand = new SetCommonDraft();
            this._deleteVersionCommand = new DeleteVersion();
            this._deleteLanguageBranchCommand = new DeleteLanguageBranch();

            this.own(
                aspect.after(this._commonDraftCommand, "execute", lang.hitch(this, function (deferred) {
                    //We force a new get when a value has changed in the store, otherwise we might have several common drafts
                    deferred.then(lang.hitch(this, this.fetchData), lang.hitch(this, this._onSetCommonDraftFailure));
                })),
                // Refresh after delete successfully
                aspect.after(this._deleteVersionCommand, "execute", lang.hitch(this, function (deferred) {
                    deferred.then(lang.hitch(this, this._onDeleteVersionSuccess), lang.hitch(this, this._onDeleteVersionFailure));
                })),
                aspect.after(this._deleteLanguageBranchCommand, "execute", lang.hitch(this, function (deferred) {
                    deferred.then(lang.hitch(this, this._onDeleteLanguageBranchSuccess), lang.hitch(this, this._onDeleteVersionFailure));
                }))
            );

            this.add("commands", this._commonDraftCommand);
            this.add("commands", withConfirmation(this._deleteVersionCommand, null, {
                title: resources.deletemenuitemtitle,
                heading: resources.deleteversion.note,
                description: resources.deleteversion.confirmquestion
            }));

            this._deleteLanguageBranchSettings = {
                cancelActionText: epi.resources.action.cancel,
                setFocusOnConfirmButton: false
            };
            this.add("commands", withConfirmation(this._deleteLanguageBranchCommand, null, this._deleteLanguageBranchSettings));
            this.own(
                topic.subscribe("/epi/cms/block/inline-updated", this.fetchData.bind(this))
            );
        },

        startup: function () {
            // summary: Overridden to connect a store to a DataGrid.

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            this.own(aspect.around(this.grid, "renderRow", lang.hitch(this, this._aroundRenderRow)));

            this._toggleLanguage();
            this.fetchData();
        },

        _setShowAllLanguagesAttr: function (newValue) {
            this._set("showAllLanguages", newValue);
            this._showAllLanguagesCommand.set("active", !newValue);
            this._toggleFilterByLanguage(newValue);
        },

        contextChanged: function (context, callerData) {
            // summary:
            //		When context change remove all data from list when its not content data.
            // context: Object
            // callerData: Object
            // tags:
            //      protected

            this.inherited(arguments);
            !this._isContentContext(context) && this.grid.set("store", null);
        },

        fetchData: function () {
            // summary:
            //		Updates the grid with the new data.
            // tags:
            //		private

            when(this.getCurrentContent(), lang.hitch(this, function (item) {
                if (!item) {
                    return;
                }

                this._setQuery(item.contentLink, this.showAllLanguages);

                // enable Show All Language command
                this.set("isMultilingual", true);
            }));
        },

        _aroundRenderRow: function (original) {
            // summary:
            //		Called 'around' the renderRow method in order to add a class which indicates published state.
            // tags:
            //		private

            return lang.hitch(this, function (item) {
                // If item is a common draft add it to the hash map.
                if (item.isCommonDraft) {
                    var common = this._commonDrafts[item.language];
                    if (common && common !== item.contentLink) {
                        this._removeCommonDraft(common);
                    }
                    this._commonDrafts[item.language] = item.contentLink;
                }

                this._versionsByLanguage[item.language] = this._versionsByLanguage[item.language] || [];
                if (array.every(this._versionsByLanguage[item.language], function (ver) {
                    return ver !== item.contentLink;
                })) {
                    this._versionsByLanguage[item.language].push(item.contentLink);
                }

                // Call original method
                var row = original.apply(this.grid, arguments);

                // Add state specific classes
                domClass.toggle(row, "dgrid-row-published", item.status === ContentActionSupport.versionStatus.Published);

                return row;
            });
        },

        _onError: function (e) {
            // summary:
            //		Shows an error message to the user when failing to load data.
            // tags:
            //		protected, extension

            if (e.error && e.error.status === 403) {
                when(this.getCurrentContent(), lang.hitch(this, function (item) {
                    this._showErrorMessage(epi.resources.messages.nopermissiontoviewdata);
                    this.set("isMultilingual", false); // disable Show All Language command since user does not have access right to view data
                    this._updateMenu(item);
                }));
            } else {
                this.inherited(arguments);
            }
        },

        _onSelect: function (e) {
            var item = e.rows[0].data;

            this._updateMenu(item);

            this.inherited(arguments);
        },

        _updateMenu: function (item) {
            this._commonDraftCommand.set("model", item);
            this._deleteVersionCommand.set("model", item);

            when(this._contentStore.get(item.contentLink), lang.hitch(this, function (content) {
                if (content && content.currentLanguageBranch) {
                    var heading = lang.replace(resources.deletelanguagebranch.label, [content.currentLanguageBranch.name]),
                        description = TypeDescriptorManager.getResourceValue(content.typeIdentifier, "deletelanguagebranchdescription");

                    lang.mixin(this._deleteLanguageBranchSettings, {
                        confirmActionText: heading,
                        description: lang.replace(description, [entities.encode(content.name), content.currentLanguageBranch.name]),
                        title: heading
                    });
                    this._deleteLanguageBranchCommand.set("label", heading);
                }

                this._deleteLanguageBranchCommand.set("model", content);
            }));
        },

        _showNotificationMessage: function (notification) {
            // summary:
            //     Show a notification message
            // notification:
            //     The notification message
            dialogService.alert({
                title: resources.notificationtitle,
                description: notification
            });
        },

        _selectCommonDraftVersion: function (uri, forceReload) {
            // summary:
            //      Selects the common draft version in the list.
            // tags:
            //      private
            var callerData = {
                sender: this
            };

            if (forceReload) {
                callerData.forceReload = forceReload;
            }

            topic.publish("/epi/shell/context/request", { uri: uri }, callerData);
        },

        _onDeleteLanguageBranchSuccess: function () {
            return when(this._onDeleteVersionSuccess(arguments), lang.hitch(this, function () {
                var language = this._deleteLanguageBranchCommand.model.currentLanguageBranch.languageId;

                array.forEach(this._versionsByLanguage[language], lang.hitch(this, function (ver) {
                    this.store.notify(undefined, new ContentReference(ver));
                }));
            }));
        },

        _onDeleteVersionSuccess: function () {
            // summary:
            //      Update the current context and display notification.
            // tags:
            //      private

            var self = this;
            return when(this.getCurrentContent(), function (currentContent) {
                var contentLink = new ContentReference(currentContent.contentLink);
                var referenceId = contentLink.createVersionUnspecificReference().toString();

                self._selectCommonDraftVersion("epi.cms.contentdata:///" + referenceId, true);
            });
        },

        _onDeleteVersionFailure: function (response) {
            // summary:
            //      Display alert with the delete failure message.
            // tags:
            //      private

            //If the user clicks cancel in the confirmation dialog we will end up here
            if (!response || !response.status) {
                return;
            } else if (response.status === 403) {
                this._showNotificationMessage(resources.deleteversion.cannotdeletepublished);
            } else if (response.status === 409) {
                var errorMessage = response.responseText ? json.fromJson(response.responseText).message : resources.deleteversion.cannotdelete;
                this._showNotificationMessage(errorMessage);
            } else {
                this._showNotificationMessage(resources.deleteversion.cannotdelete);
            }
        },

        _onSetCommonDraftFailure: function () {
            // summary:
            //      Display notification in the UI of failure.
            // tags:
            //      private

            this._showNotificationMessage(resources.setcommondraft.failuremessage);
        },

        _removeCommonDraft: function (reference) {
            // Refresh the previous common draft item, as it might be changed on the server side.
            if (reference) {
                var item = this.grid.row(reference).data;
                if (item) {
                    item.isCommonDraft = false;
                }
            }
        },

        _toggleFilterByLanguage: function (showAll) {
            // summary:
            //      handles filterByLanguage event.
            // tags:
            //      private
            // sender:
            //      the page version widget that triggers the filterByLanguage event

            return when(this.getCurrentContext()).then(function (currentContext) {
                if (!this._isContentContext(currentContext)) {
                    this.grid.set("store", null);
                } else {
                    this._setQuery(currentContext.id, showAll);
                    this._toggleLanguage();
                }
            }.bind(this));
        },

        _setQuery: function (contentLink, showAllLanguages) {
            // summary:
            //      Create a new query from the contentLink and showAllLanguages and set it on the grid
            // tags:
            //      private

            var query = {
                contentLink: new ContentReference(contentLink).createVersionUnspecificReference().toString()
            };
            if (!showAllLanguages) {
                query.language = this._currentContentLanguage;
            }

            this.grid.set("query", query);

            // The server side store requires the contentLink to be set.
            if (!this.grid.store) {
                this.grid.set("store", this.store);
            }

            this._versionsByLanguage = {};
        },

        _toggleLanguage: function () {
            // summary:
            //		Toggles the visibility of the language column.
            // tags:
            //		private

            var value = this.showAllLanguages ? "table-cell" : "none";

            this.grid.styleColumn("language", string.substitute("display:${0};", [value]));
        }
    });
});

},
'epi-cms/component/command/DeleteVersion':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/dependency",
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions",
    "epi/shell/command/_Command"
], function (declare, lang, when, ApplicationSettings, ContentActionSupport, dependency, resources, _Command) {

    return declare([_Command], {
        // summary:
        //      A command which deletes the current version when executed.
        //
        // tags:
        //      internal

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: resources.deletemenuitemtitle,

        // iconClass: [public] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconTrash",

        // category: [readonly] String
        //		A category which provides a hint about how the command could be displayed.
        category: "context",

        postscript: function () {
            // summary:
            //		Constructs the object and sets up the reference to the content data and version stores.
            // tags:
            //		public

            this.inherited(arguments);

            this.storeRegistry = this.storeRegistry || dependency.resolve("epi.storeregistry");

            this._content = this.storeRegistry.get("epi.cms.contentdata");
            this._versions = this.storeRegistry.get("epi.cms.contentversion");
        },

        _execute: function () {
            // summary:
            //		Executes this command assuming canExecute has been checked.
            // tags:
            //		protected

            return this._versions.remove(this.model.contentLink);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            if (ApplicationSettings.disableVersionDeletion) {
                this.set("isAvailable", false);
                return;
            }

            this.set("isAvailable", true);

            if (!this.model.allowToDelete) {
                this.set("canExecute", false);
                return;
            }

            when(this._content.get(this.model.contentLink), lang.hitch(this, function (content) {

                var action = ContentActionSupport.action,
                    hasSufficientAccessRight = content && ContentActionSupport.isActionAvailable(content, action.Delete);

                this.set("canExecute", hasSufficientAccessRight);
            }));
        }
    });
});

},
'epi-cms/component/command/DeleteLanguageBranch':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi-cms/_MultilingualMixin",
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport"
], function (
    declare,
    lang,
    when,
    dependency,
    _Command,
    _MultilingualMixin,
    ApplicationSettings,
    ContentReference,
    ContentActionSupport
) {

    return declare([_Command, _MultilingualMixin], {
        // summary:
        //      A command which deletes all versions belonging to a language branch when executed.
        //
        // tags:
        //      internal xproduct

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: "",

        // iconClass: [public] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "",

        // category: [readonly] String
        //		A category which provides a hint about how the command could be displayed.
        category: "context",

        postscript: function () {
            // summary:
            //		Constructs the object and sets up the reference to the content data and version stores.
            // tags:
            //		public

            this.inherited(arguments);

            this.storeRegistry = this.storeRegistry || dependency.resolve("epi.storeregistry");

            this._versions = this.storeRegistry.get("epi.cms.contentversion");
            this._structure = this.storeRegistry.get("epi.cms.content.light");
        },

        _execute: function () {
            // summary:
            //		Executes this command assuming canExecute has been checked.
            // tags:
            //		protected

            var reference = ContentReference.toContentReference(this.model.contentLink);

            return when(this._versions.remove(reference, { deleteLanguageBranch: true }), lang.hitch(this, function () {
                // TODO: Make sure all stores that can have deleted version gets notitifed.
                return this._structure.refresh(reference.createVersionUnspecificReference().toString());
            }));
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,

                isAvailable = !!(model && model.currentLanguageBranch && model.capabilities.deleteLanguageBranch &&
                    !ApplicationSettings.disableVersionDeletion),

                canExecute = isAvailable && !model.currentLanguageBranch.isMasterLanguage &&
                    ContentActionSupport.isActionAvailable(model, ContentActionSupport.action.Delete);

            this.set("canExecute", canExecute);
            this.set("isAvailable", isAvailable);
        }
    });
});

},
'epi-cms/component/command/SetCommonDraft':function(){
define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/dependency",
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions",
    "epi/shell/command/_Command"
], function (declare, topic, ContentActionSupport, dependency, resources, _Command) {

    return declare([_Command], {
        // summary:
        //      A command which sets the current version as the common draft when executed.
        //
        // tags:
        //      public

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: resources.setcommondraftitemtitle,

        // iconClass: [public] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPrimary",

        // category: [readonly] String
        //		A category which provides a hint about how the command could be displayed.
        category: "context",

        constructor: function () {
            // summary:
            //		Constructs the object and sets up the reference to the content version store.
            // tags:
            //		public

            var registry = dependency.resolve("epi.storeregistry");
            this.store = registry.get("epi.cms.contentversion");
        },

        _execute: function () {
            // summary:
            //		Executes this command assuming canExecute has been checked.
            // tags:
            //		protected

            var store = this.store;

            //Patch the object in the store
            return store.patch({ isCommonDraft: true, contentLink: this.model.contentLink }, { id: this.model.contentLink })
                .then(function (item) {
                    topic.publish("/epi/cms/content/statuschange/", "common-draft", { id: item.contentLink });
                    return store.patchCache(item);
                });
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,
                status = ContentActionSupport.versionStatus,
                canExecute = model && !model.isCommonDraft && (model.status === status.CheckedOut || model.status === status.Rejected);

            this.set("canExecute", !!canExecute);
        }
    });
});

},
'url:epi-cms/component/templates/Versions.html':"<div>\r\n    <div class=\"epi-versions\" data-dojo-type=\"epi-cms/component/Versions\" data-dojo-attach-point=\"versions\"></div>\r\n    <div class=\"epi-gadget-bottom-container dijitHidden\" data-dojo-attach-point=\"bottomLinkContainer\">\r\n        <a class=\"epi-visibleLink epi-versions-language-link\">${res.showalllanguages}</a>\r\n    </div>\r\n</div>\r\n",
'epi-cms/content-approval/ApprovalComponent':function(){
define([
    "dojo/_base/lang",
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/dom-class",
    "epi/shell/DialogService",
    "epi/shell/command/builder/ButtonBuilder",
    "epi-cms/content-approval/ApprovalEnums",
    "epi-cms/content-approval/viewmodels/ContentApprovalViewModel",
    // Parent class and mixins
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi/shell/widget/_ModelBindingMixin",
    // Resources
    "dojo/text!./templates/ApprovalComponent.html",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.component",
    "epi/i18n!epi/nls/episerver.shared.action",
    // Widgets in template
    "dijit/Toolbar",
    "dijit/form/CheckBox",
    "dijit/form/RadioButton",
    "dijit/form/Select",
    "dijit/form/Form",
    "./Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",
    "epi-cms/widget/NotificationStatusBar",
    "epi-cms/content-approval/ApprovalStepList"
], function (
    lang,
    declare,
    Deferred,
    domClass,
    dialogService,
    ButtonBuilder,
    ApprovalEnums,
    ContentApprovalViewModel,
    // Parent class and mixins
    _LayoutWidget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _ModelBindingMixin,
    // Resources
    template,
    localization,
    sharedLocalization
) {

    function toggleVisibility(domNode, visible) {
        domClass.toggle(domNode, "dijitHidden", !visible);
    }

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      The view for the content approval component; responsible for creating the content
        //      approval view model and creating child view components.
        // tags:
        //      internal

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // languageWarningTemplate: [protected] String
        //      HTML template for showing a warning on languageFilter items that has validation issues.
        languageWarningTemplate: " <span class='dijitInline dijitReset dijitIcon epi-iconWarning' title='" + localization.languagefilter.warningmessage + "'></span>",

        // resources: [protected] Object
        //      An object containing resource strings in the current language.
        resources: localization,

        // ApprovalDefinitionStatus: [readonly] epi-cms/content-approval/ApprovalEnums.definitionStatus
        //      Exposes the different approval definition statuses to the template
        ApprovalDefinitionStatus: ApprovalEnums.definitionStatus,

        // _iconThumbnailTemplate: [private] String
        //      HTML template for showing an image thumbnail as the header icon.
        _iconThumbnailTemplate: "<img class=\"epi-heading-icon-thumbnail\" src=\"{url}\" />",

        // _iconContentTemplate: [private] String
        //      HTML template for showing a content icon in the header.
        _iconContentTemplate: "<span class=\"dijitInline dijitReset dijitIcon epi-icon--large {iconClass} \"></span>",

        modelBindingMap: {
            approvalLink: ["approvalLink"],
            content: ["content"],
            isOptionsEnabled: ["isOptionsEnabled"],
            isDeclineCommentRequired: ["isDeclineCommentRequired"],
            isApproveCommentRequired: ["isApproveCommentRequired"],
            isStartCommentRequired: ["isStartCommentRequired"],
            selfApprove: ["selfApprove"],
            isReadOnly: ["isReadOnly"],
            filterOptions: ["filterOptions"],
            status: ["status"],
            approvalInheritedFrom: ["approvalInheritedFrom"]
        },

        postMixInProperties: function () {
            // summary:
            //      Processing after the parameters to the widget have been read-in, but before the
            //      widget template is instantiated.
            // tags:
            //      protected

            this.inherited(arguments);

            // Create the view model if one has not been injected in the constructor.
            this.model = this.model || new ContentApprovalViewModel();
            this.own(this.model);
        },

        buildRendering: function () {
            // summary:
            //      Build the approval component rendering from the template and then create buttons
            //      for the commands.
            // tags:
            //      protected

            this.inherited(arguments);

            // Generate buttons based on commands available in the view model
            var builder = new ButtonBuilder(),
                commands = this.model.get("commands");

            commands.forEach(function (command) {
                builder.create(command, this.commandNode);
            }, this);
        },

        postCreate: function () {
            // summary:
            //        Processing after the DOM fragment is created
            // tags:
            //        protected

            this.inherited(arguments);

            this.stepList.set("model", this.model);

            this.own(
                this.enableButton.on("click", this._updateStatus.bind(this, ApprovalEnums.definitionStatus.enabled)),
                this.disableButton.on("click", this._updateStatus.bind(this, ApprovalEnums.definitionStatus.disabled)),
                this.inheritButton.on("click", this._updateStatus.bind(this, ApprovalEnums.definitionStatus.inherited)),
                this.demandDeclineCommentButton.on("click", this._updateDemandDeclineComment.bind(this)),
                this.demandApproveCommentButton.on("click", this._updateDemandApproveComment.bind(this)),
                this.demandStartCommentButton.on("click", this._updateDemandStartComment.bind(this)),
                this.preventSelfApproveButton.on("click", this._updateSelfApprove.bind(this)),
                this.languageFilter.on("change", this._updateSelectedLanguage.bind(this))
            );
        },

        updateView: function () {
            // summary:
            //		This will be invoked by WidgetSwitcher when displaying Approval component.
            // tags:
            //		public

            this._focus();
        },

        _updateSelectedLanguage: function (language) {
            this.model.set("selectedLanguage", language);
        },

        _setNotificationContext: function (contentLink) {
            // summary:
            //      Set the validation message query to filter what messages on
            //      messageService should display in the NotificationStatusBar.
            // tags:
            //      private

            this.validation.set("notificationContext", {
                contextTypeName: "epi.cms.approval",
                contextId: contentLink
            });
        },

        _setBreadcrumb: function (content) {
            // summary:
            //      Sets up the breadcrumb to show where the content belonging to the edited approval definition is,
            //      and what content type it is.
            // tags:
            //      private

            this.breadcrumb.set("contentLink", content.contentLink);

            this.breadcrumbCurrentItem.set("currentItemInfo", {
                name: content.name,
                dataType: content.typeIdentifier
            });
        },

        _setContentIcon: function (thumbnailUrl) {
            // summary:
            //      Set content icon to make it clearer what approval definition is being edited.
            //      Will use content thumbnail if available.
            // tags:
            //      private

            // Show the icon to start with, in case it was previously hidden.
            toggleVisibility(this.contentIcon, true);

            // If a content thumbnail is available, use it as the icon.
            if (thumbnailUrl) {
                this.contentIcon.innerHTML = lang.replace(this._iconThumbnailTemplate, { url: thumbnailUrl });
                return;
            }

            // Use the content icon if available, otherwise set no icon.
            var contentIcon = this.model.iconClass();
            if (contentIcon) {
                this.contentIcon.innerHTML = lang.replace(this._iconContentTemplate, {iconClass: contentIcon});
                return;
            }

            // Hide the icon since no icon was found.
            toggleVisibility(this.contentIcon, false);
        },

        _setContentName: function (contentName) {
            // summary:
            //      Set content name to make it clearer what content's approval definition is being edited.
            // tags:
            //      private

            this.contentName.textContent = contentName;
        },

        _setApprovalLinkAttr: function (approvalLink) {
            // summary:
            //      Set the content link for the current approval definition being edited.
            // tags:
            //      private

            this._set("approvalLink", approvalLink);

            this._setNotificationContext(approvalLink);
        },

        _setContentAttr: function (content) {
            // summary:
            //      Set the current content for the content approval definition being edited.
            // tags:
            //      private

            this._set("content", content);

            if (!content) {
                return;
            }

            this._setBreadcrumb(content);
            this._setContentName(content.name);
            this._setContentIcon(content.thumbnailUrl);
        },

        _setStatusAttr: function (status) {
            this._set("status", status);
            this.form.set("value", {status: status});

            this._focus();

            toggleVisibility(this.demandCommentFieldsetNode, (this.model.get("isEnabled")));

            // Toggle the visibility of the step list, the filter node and the disabled warning node
            toggleVisibility(this.stepList.domNode, this.model.get("isEnabled"));
            toggleVisibility(this.filterNode, this.model.get("isEnabled") && !!this.model.get("filterOptions"));

            this._updateWarningMessage();
        },

        _focus: function () {
            this.enableButton.get("checked") && this.enableButton.focus();
            this.disableButton.get("checked") && this.disableButton.focus();
            this.inheritButton.get("checked") && this.inheritButton.focus();
        },

        _setApprovalInheritedFromAttr: function (approvalInheritedFrom) {
            this._set("approvalInheritedFrom", approvalInheritedFrom);
            this._updateWarningMessage();
        },

        _updateWarningMessage: function () {
            toggleVisibility(this.warningNode, (!this.model.get("isEnabled") || this.model.get("isInherited")));
            toggleVisibility(this.goToInheritedSequence, this.model.get("isInherited"));
            this.warningMessage.textContent = this.model.getWarningMessage();
        },

        _setIsDeclineCommentRequiredAttr: function (isDeclineCommentRequired) {
            this._set("isDeclineCommentRequired", isDeclineCommentRequired);
            this.demandDeclineCommentButton.set("checked", isDeclineCommentRequired);
        },

        _setIsApproveCommentRequiredAttr: function (isApproveCommentRequired) {
            this._set("isApproveCommentRequired", isApproveCommentRequired);
            this.demandApproveCommentButton.set("checked", isApproveCommentRequired);
        },

        _setIsStartCommentRequiredAttr: function (isStartCommentRequired) {
            this._set("isStartCommentRequired", isStartCommentRequired);
            this.demandStartCommentButton.set("checked", isStartCommentRequired);
        },

        _setSelfApproveAttr: function (selfApprove) {
            this._set("selfApprove", selfApprove);
            this.preventSelfApproveButton.set("checked", !selfApprove);
        },

        _setIsOptionsEnabledAttr: function (isOptionsEnabled) {
            this._set("isOptionsEnabled", isOptionsEnabled);
            this.demandDeclineCommentButton.set("disabled", !isOptionsEnabled);
            this.demandApproveCommentButton.set("disabled", !isOptionsEnabled);
            this.demandStartCommentButton.set("disabled", !isOptionsEnabled);
            this.preventSelfApproveButton.set("disabled", !isOptionsEnabled);
        },

        _setIsReadOnlyAttr: function (isReadOnly) {
            this._set("isReadOnly", isReadOnly);
            this.enableButton.set("disabled", isReadOnly);
            this.disableButton.set("disabled", isReadOnly);
            this.inheritButton.set("disabled", isReadOnly);
        },

        _setFilterOptionsAttr: function (filterOptions) {
            // summary:
            //      Shows or hides the filter widget and also sets its options.
            // tags:
            //      private

            this._set("filterOptions", filterOptions);

            var showFilter = !!filterOptions && this.model.get("isEnabled");
            toggleVisibility(this.filterNode, showFilter);
            if (!filterOptions) {
                return;
            }

            // Clone the object so changes to it won't affect the model.
            filterOptions = lang.clone(filterOptions);
            // Keep track of the selected options. If it's "All Languages" use an empty string.
            var selectedLanguage = this.model.get("selectedLanguage") || "";
            filterOptions.forEach(function (filter) {
                if (!filter.isValid && this.model.get("showValidations")) {
                    filter.label += this.languageWarningTemplate;
                }

                filter.selected = selectedLanguage === filter.value;
            }, this);

            // Reset the filter options, and the selected item to update the displayed value.
            this.languageFilter.set("options", filterOptions);
            this.languageFilter.set("value", selectedLanguage);
        },

        _goToInheritedSequence: function () {
            this.model.goToInheritedSequence();
        },

        _updateStatus: function (nextStatus) {
            var promise;
            switch (nextStatus) {
                case ApprovalEnums.definitionStatus.inherited:
                    promise = this._confirmInherit();
                    break;
                case ApprovalEnums.definitionStatus.enabled:
                    this.model.enable();
                    promise = new Deferred().resolve();
                    break;
                case ApprovalEnums.definitionStatus.disabled:
                    promise = this._confirmDisable();
                    break;
            }

            // Reset the status if the user cancels the dialog.
            promise.otherwise(this.set.bind(this, "status", this.status));
        },

        _updateDemandDeclineComment: function (e) {
            var checked = e.target.checked;
            this.model.set("isDeclineCommentRequired", checked);
            this.demandDeclineCommentButton.set("checked", checked);
        },

        _updateDemandApproveComment: function (e) {
            var checked = e.target.checked;
            this.model.set("isApproveCommentRequired", checked);
            this.demandApproveCommentButton.set("checked", checked);
        },

        _updateDemandStartComment: function (e) {
            var checked = e.target.checked;
            this.model.set("isStartCommentRequired", checked);
            this.demandStartCommentButton.set("checked", checked);
        },

        _updateSelfApprove: function (e) {
            var checked = e.target.checked;
            this.model.set("selfApprove", !checked);
            this.preventSelfApproveButton.set("checked", checked);
        },

        _confirmDisable: function () {
            var settings = {
                title: this.resources.disable.title,
                description: this.resources.disable.description,
                confirmActionText: sharedLocalization.disable,
                cancelActionText: sharedLocalization.cancel
            };

            return dialogService.confirmation(settings)
                .then(this.model.disable.bind(this.model));
        },

        _confirmInherit: function () {
            var settings = {
                title: this.resources.inherit.title,
                description: this.resources.inherit.description,
                confirmActionText: this.resources.inherit.okbutton,
                cancelActionText: sharedLocalization.cancel,
                setFocusOnConfirmButton: false
            };

            return dialogService.confirmation(settings)
                .then(this.model.inheritDefinition.bind(this.model));
        }
    });
});

},
'epi-cms/content-approval/viewmodels/ContentApprovalViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/when",
    "epi/epi",
    "epi/dependency",
    "epi/shell/DialogService",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/content-approval/ApprovalEnums",
    "epi-cms/content-approval/viewmodels/ApprovalStepViewModel",
    "epi/shell/command/withConditionalConfirmation",
    // Parent class
    "dojo/Stateful",
    "epi/shell/DestroyableByKey",
    "epi/shell/_ContextMixin",
    // Commands
    "epi-cms/content-approval/command/SaveApprovalDefinition",
    "epi-cms/content-approval/command/CancelChanges",
    // Store modules
    "epi/shell/store/SortableMemory",
    "dojo/store/Observable",
    //Resources
    "epi/i18n!epi/nls/episerver.cms.contentapproval",
    "epi/i18n!epi/nls/episerver.cms.languageselector",
    "epi/i18n!epi/nls/episerver.shared.action"
], function (
    declare,
    lang,
    on,
    when,
    epi,
    dependency,
    dialogService,
    TypeDescriptorManager,
    ApprovalEnums,
    ApprovalStepViewModel,
    withConditionalConfirmation,
    // Parent class
    Stateful,
    DestroyableByKey,
    _ContextMixin,
    // Commands
    SaveApprovalDefinition,
    CancelChanges,
    // Store modules
    SortableMemory,
    Observable,
    //Resources
    localizationContentApproval,
    localizationLanguageSelector,
    localizationSharedAction
) {

    return declare([Stateful, DestroyableByKey, _ContextMixin], {
        // summary:
        //      The view model for the content approval component.
        // tags:
        //      internal

        // approvalSteps: [readonly] Store
        //      A store containing the approval steps.
        approvalSteps: null,

        // approvalService: [readonly] ApprovalService
        //      A service for interacting with content approvals.
        approvalService: null,

        // userStore: [readonly] Store
        //      A REST store for fetching data for users.
        userStore: null,

        // commands: [public] Array
        //      An array of commands available for the component.
        commands: null,

        // isDirty: [readonly] Boolean
        //      Indicates whether the approval steps are different from the original value and can
        //      be saved.
        isDirty: false,

        // isDeclineCommentRequired: [readonly] Boolean
        //      Indicates whether a comment is required when declining
        isDeclineCommentRequired: false,

        // isApproveCommentRequired: [readonly] Boolean
        //      Indicates whether a comment is required when approving
        isApproveCommentRequired: false,

        // isStartCommentRequired: [readonly] Boolean
        //      Indicates whether a comment is required when requesting a review
        isStartCommentRequired: false,

        // selfApprove: [readonly] Boolean
        //      Indicates whether users can approve their own changes
        selfApprove: true,

        // isEnabled: [readonly] Boolean
        //      Indicates whether the approval is enabled explicitly or it is enabled by inheritance
        isEnabled: false,

        // isInherited: [readonly] Boolean
        //      Indicates whether the approval is inherited from one of its ancestors
        isInherited: false,

        // selectedLanguage: [readonly] String
        //      The selected language.
        selectedLanguage: null,

        // approvalLink: [public] String
        //      The content link of the current approval sequence.
        approvalLink: null,

        // content: [readonly] ContentDataStoreModel
        //      The content belonging to the approval definition.
        content: null,

        // isValid: [readonly] Boolean
        //      Indicates if the approval definition can be saved.
        isValid: true,

        // isReadOnly: [public] Boolean
        //      Set whether the whole approval sequence is in readOnly mode.
        isReadOnly: false,

        // isOptionsEnabled: [readonly] Boolean
        //      Indicates if the approval options are enabled or not
        isOptionsEnabled: true,

        // languages: [public] Array
        //      All the languages that are enabled for the whole approval sequence.
        languages: null,

        // filterOptions: [public] Array
        //      All the languages in dijit/Select options format, for the languageFilter.
        filterOptions: null,

        // approvalInheritedFrom: [public] InheritedApprovalDefinitionViewModel
        //      Gets the inherited approval definition.
        approvalInheritedFrom: null,

        // filterOptions: [public] Array
        //      All the languages in dijit/Select options format, for the reviewers.
        languageOptions: null,

        // showValidations: [public] Boolean
        //      Indicates if we are in a state where we want to show the validation messages.
        showValidations: false,

        // status: [public] ApprovalEnums.definitionStatus
        //      The status of the approval definition.
        status: ApprovalEnums.definitionStatus.inherited,

        // _approvalStepsQuery: [private] QueryResults
        //      The query results for the approval steps query.
        _approvalStepsQuery: null,

        // _originalDefinition: [private] ApprovalDefinition
        //      Original approvalDefinition from the server that is used to compare with before saving.
        _originalDefinition: null,

        // validationMessageIds: [private] Array
        //      An array of error messages given to NotificationStatusBar through MessageService.
        _validationMessageIds: [],

        // _contextService: [private] ContextService
        //      Service for managing context changes.
        _contextService: null,

        // _messageService: [private] MessageService
        //      Service to send validation messages to NotificationStatusBar.
        _messageService: null,

        constructor: function (kwArgs, approvalService, contextService, messageService, userStore, contentStore, typeDescriptorManager) {
            this.approvalService = approvalService || dependency.resolve("epi.cms.ApprovalService");
            this._contextService = contextService || dependency.resolve("epi.shell.ContextService");
            this._messageService = messageService || dependency.resolve("epi.shell.MessageService");
            this.userStore = userStore || dependency.resolve("epi.storeregistry").get("epi.cms.approval.users");
            this._contentStore = contentStore || dependency.resolve("epi.storeregistry").get("epi.cms.content.light");
            this._typeDescriptorManager = typeDescriptorManager || TypeDescriptorManager;
        },

        postscript: function () {
            this.inherited(arguments);

            when(this.getCurrentContext()).then(this.contextChanged.bind(this));
        },

        destroy: function () {
            this.inherited(arguments);

            this._removeEventListeners();
        },

        contextChanged: function (context) {
            // summary:
            //      Update the approval definition and content data when the context has changed.
            // tags:
            //      public

            this.set("approvalLink", context.id);

            this.approvalService.getDefinition(context.id)
                .then(this.loadApprovalDefinition.bind(this))
                .then(function () {
                    // Wait with loading and setting the current content until the approval definition has successfully loaded.
                    this._contentStore.get(context.id)
                        .then(this.set.bind(this, "content"));
                }.bind(this));
        },

        createApprovalStep: function (afterStep) {
            // summary:
            //      Creates a new approval step after the given step.
            // tags:
            //      public

            // Block modification when the approval definition is not enabled or it is read-only.
            if (!this._canEditApprovalSteps()) {
                return;
            }

            var steps = this.approvalSteps,
                nextSibling = steps.getSibling(afterStep),
                viewModel;

            viewModel = new ApprovalStepViewModel({
                languages: this.languages,
                reviewers: [],
                userStore: this.userStore,
                showValidations: this.showValidations
            });

            this._addEventListeners(viewModel);

            steps.add(viewModel, { before: nextSibling });
        },

        getWarningMessage: function () {
            // summary:
            //      Gets the warning message based on current approval definition.
            // tags:
            //      public

            if (this.get("isInherited") && this.approvalInheritedFrom) {
                var text = this.get("isEnabled") ? localizationContentApproval.component.inheritedenabled : localizationContentApproval.component.inheriteddisabled;
                return lang.replace(text, {
                    name: this.approvalInheritedFrom.name
                });
            } else if (!this.get("isEnabled")) {
                return localizationContentApproval.component.disabledwarning;
            }
        },

        goToInheritedSequence: function () {
            // summary:
            //      Navigates to the approval definition that was inherited by the current definition.
            // tags:
            //      public

            this.approvalService.navigateToDefinition(this.get("approvalInheritedFrom").contentLink);
        },

        inheritDefinition: function () {
            // summary:
            //      Clears the current approval definition and loads the ancestor's definition.
            // tags:
            //      public

            var contentLink = this.get("approvalLink"),
                previousStatus = this.status;

            this.set("status", ApprovalEnums.definitionStatus.inherited);

            return this.approvalService.inheritDefinition(contentLink)
                .then(this.loadApprovalDefinition.bind(this))
                .otherwise(this.set.bind(this, "status", previousStatus));
        },

        moveApprovalStep: function (approvalStep, up) {
            // summary:
            //      Moves the approval step up or down in the list.
            // tags:
            //      public

            // Block modification when the approval definition is not enabled or it is read-only.
            if (!this._canEditApprovalSteps()) {
                return;
            }

            var steps = this.approvalSteps,
                beforeSibling = steps.getSibling(approvalStep, up);

            // Do an early exit in the case the step is being moved up but is already first or it is
            // being moved down but is already last. The sibling will be null in both cases.
            if (!beforeSibling) {
                return;
            }

            // If the step is moving down then get the next sibling to insert before.
            if (!up) {
                beforeSibling = steps.getSibling(beforeSibling);
            }

            steps.put(approvalStep, { before: beforeSibling });
        },

        removeApprovalStep: function (approvalStep) {
            // summary:
            //      Removes the approval step if it can be deleted.
            // tags:
            //      public

            // Block modification when the approval definition is not enabled or it is read-only.
            if (!this._canEditApprovalSteps()) {
                return;
            }

            if (approvalStep.canBeDeleted) {
                this.approvalSteps.remove(approvalStep.id);
            }
        },

        loadApprovalDefinition: function (definition) {
            // summary:
            //      Updates the view model with the data from the given approval definition.
            // tags:
            //      public

            //Set the originalDefinition to null to clear the old definition
            this._originalDefinition = null;

            this.set({
                approvalInheritedFrom: definition.approvalInheritedFrom,
                languages: definition.languages,
                status: definition.status,
                isReadOnly: definition.isReadOnly,
                isDeclineCommentRequired: definition.isDeclineCommentRequired,
                isApproveCommentRequired: definition.isApproveCommentRequired,
                isStartCommentRequired: definition.isStartCommentRequired,
                selfApprove: definition.selfApprove,
                showValidations: false
            });

            this._createApprovalSteps(definition.approvalSteps);

            // Save a copy of the definition to be used to determine when the definition has changed.
            this._originalDefinition = this.serialize();
        },

        saveApprovalDefinition: function () {
            // summary:
            //      Saves the approval definition.
            // tags:
            //      public

            var definition = this.serialize();
            return this.approvalService.saveDefinition(definition).then(this.loadApprovalDefinition.bind(this));
        },

        serialize: function () {
            // summary:
            //      Serializes the approval definition.
            // tags:
            //      public

            var approvalSteps = this.approvalSteps.data.map(function (step) {
                return step.serialize();
            });

            return {
                contentLink: this.get("approvalLink"),
                approvalSteps: approvalSteps,
                isDeclineCommentRequired: this.isDeclineCommentRequired,
                isApproveCommentRequired: this.isApproveCommentRequired,
                isStartCommentRequired: this.isStartCommentRequired,
                selfApprove: this.selfApprove,
                status: this.status
            };
        },

        validate: function () {
            // summary:
            //      Validates the viewModel. Triggers validation on the steps.
            // tags:
            //      public

            var validationMessage = null;

            this.approvalSteps.data.forEach(function (step) {
                step.validate();
            });

            if (this._hasErrors()) {
                validationMessage = {
                    level: "error",
                    dialog: {
                        description: localizationContentApproval.validationmessage.notenoughreviewersmessage.description
                    }
                };
            } else if (this._hasWarnings()) {
                validationMessage = {
                    level: "warning",
                    dialog: {
                        title: localizationContentApproval.validationmessage.stephaswarnings.title,
                        description: localizationContentApproval.validationmessage.stephaswarnings.description,
                        confirmActionText: localizationContentApproval.action.saveanyway,
                        cancelActionText: localizationSharedAction.cancel
                    }
                };
            }

            return validationMessage;
        },

        enable: function () {
            // summary:
            //      Enables the definition.
            // tags:
            //      public

            this.set("status", ApprovalEnums.definitionStatus.enabled);
            this._updateIsSequenceEnabled();
        },

        disable: function () {
            // summary:
            //      Disables the definition and immediately saves it.
            // tags:
            //      public

            this.set("showValidations", false);

            // Update the status now instead of waiting for the server to respond.
            this.set("status", ApprovalEnums.definitionStatus.disabled);

            // Update the approval steps now instead of waiting for the server to respond.
            this._updateApprovalSteps();
            this._updateIsSequenceEnabled();
            return this.saveApprovalDefinition()
                .otherwise(function () {
                    this.set("showValidations", true);
                    this.enable();
                }.bind(this));
        },

        iconClass: function () {
            // summary:
            //      The icon representing the content belonging to the approval definition.
            // tags:
            //      public

            return this.content ? this._typeDescriptorManager.getValue(this.content.typeIdentifier, "iconClass") : null;
        },

        _createApprovalSteps: function (steps) {
            // summary:
            //      Transforms a list of approval steps into an observable memory store and observe
            //      the store for changes.
            // tags:
            //      private

            var approvalSteps = (steps || [this._createEmptyStep()]).map(this._createStepViewModel.bind(this)),
                store = Observable(new SortableMemory({ data: approvalSteps }));

            this.set("approvalSteps", store);
            this.set("isDirty", false);

            //Queries the approvalSteps store and observe so that we can
            //we can set canBeDeleted flag on a approval step.
            this._approvalStepsQuery = store.query();

            // Update the approval steps to set the initial values, e.g. canBeDeleted.
            this._updateApprovalSteps();

            // Listen for changes to the approval steps.
            this.destroyByKey("observeHandle");
            this.ownByKey("observeHandle", this._approvalStepsQuery.observe(function () {
                this._updateApprovalSteps();
            }.bind(this)));
        },

        _createEmptyStep: function () {
            // summary:
            //      Creates an empty approval step with no reviewers.
            // tags:
            //      private

            return { reviewers: [] };
        },

        _createStepViewModel: function (step, index) {
            // summary:
            //      Create approval step view models.
            // tags:
            //      private

            //Clone the step so it will not references the object
            //from the original approval steps from the server
            step = lang.clone(step);

            // Set the id for the step so it is possible to find in the store later.
            var viewModel = new ApprovalStepViewModel({
                id: index,
                //Languages need to be set before the reviewers setter because it is used in the validate
                //method that is called from the reviewers setter.
                languages: this.languages,
                selfApprove: this.selfApprove,
                reviewers: step.reviewers,
                name: step.name,
                userStore: this.userStore
            });

            this._addEventListeners(viewModel);

            return viewModel;
        },

        _updateApprovalSteps: function () {
            // summary:
            //      Updates the state of the approval steps.
            // tags:
            //      private

            var approvalStepsQuery = this._approvalStepsQuery;
            if (approvalStepsQuery) {
                // Step can be delete if there are more than one step.
                var canBeDeleted = approvalStepsQuery.length > 1,
                    isReadOnly = !this._canEditApprovalSteps(),
                    selectedLanguage = this.selectedLanguage,
                    selfApprove = this.selfApprove;

                approvalStepsQuery.forEach(function (step) {
                    step.set({
                        canBeDeleted: canBeDeleted,
                        isReadOnly: isReadOnly,
                        selfApprove: selfApprove
                    });
                    step.filterReviewers(selectedLanguage);
                });

                this._onApprovalStepsChanged();
            }
        },

        _resetValidationMessageIds: function () {
            // summary:
            //      Reset errors and re add if there is errors.
            // tags:
            //      private

            // Remove errors
            this._validationMessageIds.forEach(function (messageId) {
                this._messageService.remove({id: messageId});
            }.bind(this));
            this._validationMessageIds = [];

            // Add new errors, if we want to show them.
            if (this.showValidations) {
                // Add new errors
                this._approvalStepsQuery.forEach(function (step) {
                    if (!step.isValid) {
                        step.validationMessages.forEach(function (stepValidationMessage) {
                            var messageType;
                            if (stepValidationMessage.level === "error") {
                                messageType = "error";
                            } else if (stepValidationMessage.level === "warning") {
                                messageType = "warn";
                            }
                            var messageId = this._messageService.put(messageType, stepValidationMessage.value, "epi.cms.approval", this.get("approvalLink"));
                            this._validationMessageIds.push(messageId);
                        }, this);
                    }
                }, this);
            }
        },

        _onApprovalStepsChanged: function () {
            // summary:
            //      Update the isDirty and isValid flags.
            // tags:
            //      private

            this._resetValidationMessageIds();

            // Validate filterOptions based on new validation info in the steps.
            this._validateFilterOptions();

            // Compares originalDefinition from the server with the serialized
            // definition and toggles the save button.
            var serialized = this.serialize();
            var equal = epi.areEqual(serialized, this._originalDefinition);
            //Only set the isDirty flag if the originalDefinition is set
            //because initially it will be empty when some setters are called.
            this._originalDefinition && this.set("isDirty", !equal);
        },

        _addEventListeners: function (step) {
            // summary:
            //      Adds event listeners to the step view model.
            // tags:
            //      private

            this.own(
                step.on("create-step", this.createApprovalStep.bind(this)),
                step.on("remove-step", this.removeApprovalStep.bind(this)),
                step.on("change", this._onApprovalStepsChanged.bind(this)),
                step.watch("isValid", this._onApprovalStepsChanged.bind(this))
            );

        },

        _canEditApprovalSteps: function () {
            // summary:
            //      Determines whether the approval stesp can be modified.
            // tags:
            //      private

            return !this.isReadOnly && this.status === ApprovalEnums.definitionStatus.enabled;
        },

        _commandsGetter: function () {
            // summary:
            //      Lazy loads the commands associated with the component.
            // tags:
            //      protected

            if (this.commands === null) {
                this.commands = [
                    new SaveApprovalDefinition({ model: this, order: 10 }),
                    new CancelChanges({ model: this, order: 20 })
                ];
            }
            return this.commands;
        },

        _createLanguageOptions: function (languages) {
            // summary:
            //      Create languages options if there are any.
            // tags:
            //      private

            if (!languages) {
                this.set("languageOptions", null);
                this.set("filterOptions", null);
                return;
            }

            var languageOptions = languages.map(function (language) {
                return { label: language.text, value: language.value };
            });
            this.set("languageOptions", languageOptions);

            // Deep copy the languageOptions array so languageOptions and
            // filterOptions don't reference to the same objects.
            var filterOptions = lang.clone(languageOptions);
            filterOptions.unshift(this._getDefaultLanguageOption());
            this.set("filterOptions", filterOptions);
        },

        _getDefaultLanguageOption: function () {
            // summary:
            //      Creates a new select item with the "All language" text that is selected.
            // tags:
            //      private

            return {
                label: localizationLanguageSelector.alllanguages,
                value: "",
                selected: true
            };
        },

        _validateFilterOptions: function () {
            // summary:
            //      Create filter options if there are language options.
            // tags:
            //      private

            // When set to "All Languages" there is nothing to validate.
            if (!this.filterOptions) {
                return;
            }

            // Set an isValid flag for views (e.g. ApprovalComponent) to indicate validation status of each option.
            var stepsMissingLanguageReviewer = this._stepsMissingLanguageReviewer();

            this.filterOptions.forEach(function (filter) {
                filter.isValid = stepsMissingLanguageReviewer.every(function (step) {
                    // A filterOption is invalid if it has any language validation issues.
                    return step.get("validationMessages").every(function (validationMessage) {
                        if (!validationMessage.languages) {
                            return true;
                        }
                        return validationMessage.languages.indexOf(filter.value) === -1;
                    });
                });
            });

            // Update the property to trigger watchers.
            this.set("filterOptions", this.filterOptions);
        },

        _hasErrors: function () {
            return this.approvalSteps.data.some(function (step) {
                return !step.isValid && step.hasErrors();
            });
        },

        _hasWarnings: function () {
            return this.approvalSteps.data.some(function (step) {
                return !step.isValid && step.hasWarnings();
            });
        },

        _stepsMissingLanguageReviewer: function () {
            return this.approvalSteps.data.filter(function (step) {
                return !step.isValid &&
                    step.validationMessages.some(function (validationMessage) {
                        return validationMessage.languages;
                    });
            });
        },

        _isDeclineCommentRequiredSetter: function (commentRequired) {
            // summary:
            //      Sets the comment required state of the approval sequence.
            // tags:
            //      protected

            this.isDeclineCommentRequired = commentRequired;

            this._updateApprovalSteps();
        },

        _isApproveCommentRequiredSetter: function (commentRequired) {
            // summary:
            //      Sets the comment required state of the approval sequence.
            // tags:
            //      protected

            this.isApproveCommentRequired = commentRequired;

            this._updateApprovalSteps();
        },

        _isStartCommentRequiredSetter: function (commentRequired) {
            // summary:
            //      Sets the comment required state of the approval sequence.
            // tags:
            //      protected

            this.isStartCommentRequired = commentRequired;

            this._updateApprovalSteps();
        },

        _selfApproveSetter: function (selfApprove) {
            // summary:
            //      Sets the self approve setting of the approval sequence.
            // tags:
            //      protected

            this.selfApprove = selfApprove;

            this._updateApprovalSteps();
        },

        _isDirtySetter: function (isDirty) {
            this.isDirty = isDirty;

            if (!isDirty) {
                this._removeEventListeners();
                return;
            }

            if (this._interceptor) {
                return;
            }

            this._beforeUnloadHandler = on(window, "beforeunload", function (e) {
                var confirmationMessage = localizationContentApproval.command.cancelchanges.description;

                e.returnValue = confirmationMessage;
                return confirmationMessage;
            });

            this._interceptor = this._contextService.registerRequestInterceptor(function () {
                var settings = {
                    title: localizationContentApproval.command.cancelchanges.title,
                    description: localizationContentApproval.command.cancelchanges.description
                };

                return dialogService.confirmation(settings).then(this._removeEventListeners.bind(this));
            }.bind(this));
        },

        _isReadOnlySetter: function (value) {
            // summary:
            //      Set whether the approval definition is in readonly mode.
            // tags:
            //      protected

            this.isReadOnly = value;

            this._updateApprovalSteps();
            this._updateIsSequenceEnabled();
        },

        _languagesSetter: function (value) {
            // summary:
            //      Sets the languages property, and the dependent options lists.
            // tags:
            //      protected

            this.languages = value;

            this._createLanguageOptions(this.languages);
            this._updateApprovalSteps();
        },

        _selectedLanguageSetter: function (selectedLanguage) {
            // summary:
            //      Sets the selected language for the approval definition.
            // tags:
            //      protected

            this.selectedLanguage = !selectedLanguage ? null : selectedLanguage;

            this._updateApprovalSteps();
        },

        _showValidationsSetter: function (showValidations) {
            // summary:
            //      Sets the model into "show validations mode", including all it's children.
            // tags:
            //      protected

            this.showValidations = showValidations;

            if (this.approvalSteps && this.approvalSteps.data) {
                this.approvalSteps.data.forEach(function (step) {
                    step.set("showValidations", showValidations);
                });
            }
        },

        _updateIsSequenceEnabled: function () {
            // summary:
            //      Update the inherit button enable status depending on the value of isEnabled and isReadOnly
            // tags:
            //      private

            this.set("isOptionsEnabled", this._canEditApprovalSteps());
        },

        _statusSetter: function (status) {
            // summary:
            //      Sets the status of the approval definition.
            // tags:
            //      protected

            this.status = status;
            this._updateApprovalSteps();
        },

        _isInheritedGetter: function () {
            return this.get("status") === ApprovalEnums.definitionStatus.inherited;
        },

        _isEnabledGetter: function () {

            if (this.get("status") === ApprovalEnums.definitionStatus.inherited) {
                return this.approvalInheritedFrom && this.approvalInheritedFrom.isEnabled;
            }
            return this.get("status") === ApprovalEnums.definitionStatus.enabled;
        },

        _removeEventListeners: function () {
            this._interceptor && this._interceptor.remove();
            this._interceptor = null;

            this._beforeUnloadHandler && this._beforeUnloadHandler.remove();
            this._beforeUnloadHandler = null;
        }
    });
});

},
'epi-cms/content-approval/viewmodels/ApprovalStepViewModel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    // Epi
    "epi-cms/content-approval/viewmodels/ReviewerViewModel",
    // Parent class
    "dojo/Stateful",
    "dojo/Evented",
    "epi/shell/DestroyableByKey",
    // Commands
    "epi-cms/content-approval/command/AddApprovalStep",
    "epi-cms/content-approval/command/RemoveApprovalStep",
    "epi-cms/content-approval/ApprovalEnums",
    // Store modules
    "dojo/store/Memory",
    "dojo/store/Observable",
    //Resources
    "epi/i18n!epi/nls/episerver.cms.contentapproval"
], function (
    declare,
    lang,

    // Epi
    ReviewerViewModel,
    // Parent class
    Stateful,
    Evented,
    DestroyableByKey,
    // Commands
    AddApprovalStep,
    RemoveApprovalStep,
    ApprovalEnums,
    // Store modules
    Memory,
    Observable,
    //Resources
    localization
) {

    return declare([Stateful, DestroyableByKey, Evented], {
        // summary:
        //      The view model for an approval step.
        // tags:
        //      internal

        // reviewers: [public] Store
        //      Reviewers for the approval step.
        reviewers: null,

        // commands: [public] Array
        //      An array of commands available for the approval step.
        commands: null,

        // userStore: [readonly] Store
        //      A REST store for fetching data for users
        userStore: null,

        // canBeDeleted: [public] Boolean
        //      Indicates if the approval step can be deleted
        canBeDeleted: true,

        // selfApprove: [public] Boolean
        //      Indicates if users can approve their own changes
        selfApprove: true,

        // isReadOnly: [readonly] Boolean
        //      Indicates if the approval step can be modified
        isReadOnly: false,

        // name: [public] String
        //      The name of the approval step that appears in the header.
        name: "",

        // isValid: [public] Boolean
        //      Indicates if the approval step can be saved
        isValid: true,

        // validationMessages: [readonly] Array[object]
        //      Holds the validation message when 'isValid' is false.
        validationMessages: [],

        // languages: [public] Array
        //      All the languages that is enable for the whole approval sequence
        languages: null,

        // showValidations: [public] Boolean
        //      Indicates if we are in a state where we want to show the validation messages.
        showValidations: false,

        addReviewer: function (reviewer) {
            // summary:
            //      Adds an reviewer.
            // reviewer: Object
            //      Reviewer to be added.
            // tags:
            //      public

            reviewer.languages = reviewer.languages || [];

            this.reviewers.add(this._createReviewer(reviewer));
        },

        filterOutExistingUsers: function (users) {
            // summary:
            //      Filters out existing users from the search result that
            //      is already in the reviewer list.
            // tags:
            //      public

            var reviewers = this.get("reviewers")
                .query();

            //Remove already added users/roles before displaying the
            //result so that we can't add them again
            return users = users.filter(function (user) {
                return !reviewers.some(function (reviewer) {
                    return (user.name.toLowerCase() === reviewer.name.toLowerCase() && user.reviewerType === reviewer.reviewerType);
                });
            }, this);
        },

        filterReviewers: function (selectedLanguage) {
            // summary:
            //      Filters out reviewers that cannot approve the given language.
            // tags:
            //      public

            this.reviewers.query().forEach(function (reviewer) {
                // Reviewer can approve when "All languages" is selected,
                // or the reviewer is set for all languages.
                if (selectedLanguage === null || reviewer.languages.length === 0) {
                    reviewer.set("canApprove", true);
                    return;
                }

                // Or an reviewer can only approve languages it's set up for.
                var canApprove = reviewer.languages.some(function (language) {
                    return language === selectedLanguage;
                });
                reviewer.set("canApprove", canApprove);
            });
        },

        createApprovalStep: function () {
            // summary:
            //      Emits event for creating new approval step
            // tags:
            //      public
            this.emit("create-step", this);
        },

        removeApprovalStep: function () {
            // summary:
            //      Emits event for deleting approval step
            // tags:
            //      public
            this.emit("remove-step", this);
        },

        removeReviewer: function (reviewer) {
            // summary:
            //      Removes reviewer by id
            // tags:
            //      public

            if (this.isReadOnly) {
                return;
            }

            this.reviewers.remove(this._getReviewerId(reviewer));
        },

        serialize: function () {
            // summary:
            //      Serialize approval step
            // tags:
            //      public

            var reviewers = this.reviewers.data.map(function (reviewer) {
                return reviewer.serialize();
            });

            return {
                name: this.name,
                reviewers: reviewers
            };
        },

        validate: function () {
            // summary:
            //      Checks if the approval step is valid and sets isValid and validationMessage.
            // tags:
            //      public

            if (!this.reviewers) {
                return;
            }

            var validationMessages = [],
                reviewers = this.reviewers.query(),
                validationMessage = this._validateReviewers(reviewers);

            if (validationMessage) {
                validationMessages.push(validationMessage);
            }

            validationMessage = this._validateLanguages(reviewers);
            if (validationMessage) {
                validationMessages.push(validationMessage);
            }

            validationMessage = this._validateSelfApprove(reviewers);
            if (validationMessage) {
                validationMessages.push(validationMessage);
            }

            validationMessage = this._validateRoles(reviewers);
            if (validationMessage) {
                validationMessages.push(validationMessage);
            }

            // validationMessage should be set before setting isValid as there might be watchers on isValid.
            this.set("validationMessages", validationMessages);
            this.set("isValid", validationMessages.length === 0);
        },

        hasErrors: function () {
            return this.validationMessages.some(function (validationMessage) {
                return validationMessage.level === "error";
            });
        },

        hasWarnings: function () {
            return this.validationMessages.some(function (validationMessage) {
                return validationMessage.level === "warning";
            });
        },

        _createReviewer: function (reviewer) {
            // summary:
            //      Creates ReviewerViewModel and hooking up language event that emits change event. Triggers validation.
            // tags:
            //      private
            var viewModel = new ReviewerViewModel(reviewer);
            viewModel.id = this._getReviewerId(reviewer); // id only used on client to uniquely identify the reviewer

            this.own(
                viewModel.watch("languages", function () {
                    this.validate();
                    this.emit("change");
                }.bind(this))
            );

            this.validate();
            return viewModel;
        },

        _getReviewerId: function (reviewer) {
            // summary:
            //      Returns the id of the reviewer by concatenate name and reviewer type
            // tags:
            //      protected
            return reviewer.name.toLowerCase() + ":" + reviewer.reviewerType;
        },

        _nameSetter: function (value) {
            // summary:
            //      Sets the name property and emit change event
            // tags:
            //      protected

            // If the value is null or undefined then set an empty string instead.
            value = value || "";

            if (value === this.name) {
                return;
            }
            this.name = value;
            this.emit("change");
        },

        _nameGetter: function () {
            // summary:
            //      Gets the name property if any exist; otherwise returns the placeholder.
            // tags:
            //      protected

            return this.name || localization.step.header.placeholder;
        },

        _reviewersSetter: function (reviewers) {
            // summary:
            //      Transforms a list of reviewers into ReviewerViewModels and creates an observable memory store
            //      and observe the store for changes. Triggers validation.
            // tags:
            //      protected

            var viewModels = reviewers.map(function (reviewer) {
                return this._createReviewer(reviewer);
            }, this);

            this.reviewers = Observable(new Memory({
                data: viewModels
            }));

            this.destroyByKey("reviewersObserveHandle");
            this.ownByKey("reviewersObserveHandle", this.reviewers.query().observe(function () {
                // Validate when reviewers change.
                this.validate();
                this.emit("change");
            }.bind(this)));

            // Validate when setting new reviewers.
            this.validate();
        },

        _selfApproveSetter: function (selfApprove) {
            // summary:
            //      Sets selfApprove property and triggers validation.
            // tags:
            //      protected

            this.selfApprove = selfApprove;
            this.validate();
        },

        _commandsGetter: function () {
            // summary:
            //      Lazy loads the commands associated with the approval step.
            // tags:
            //      protected

            if (this.commands === null) {
                this.commands = [
                    new AddApprovalStep({ model: this }),
                    new RemoveApprovalStep({ model: this })
                ];
            }
            return this.commands;
        },

        _validateLanguages: function (reviewers) {
            // summary:
            //      Validates if the approvalStep have reviewers in all languages and
            // returns:
            //      The validationMessage
            // tags:
            //      private

            var validationMessage = null;

            if (!this.languages || reviewers.length === 0) {
                return validationMessage;
            }

            var missingLanguages = [];
            this.languages.forEach(function (definitionLanguage) {
                var hasLanguageReviewers = reviewers.some(function (reviewer) {
                    //When the reviewer is set to approve all languages
                    if (reviewer.languages.length === 0) {
                        return true;
                    }

                    //Otherwise verify that it approves this current language.
                    return reviewer.languages.some(function (reviewerLanguage) {
                        return reviewerLanguage === definitionLanguage.value;
                    });
                });

                if (!hasLanguageReviewers) {
                    // validation message can contain multiple missing languages with the same localized error message
                    if (validationMessage) {
                        validationMessage.languages.push(definitionLanguage.value);
                    } else {
                        validationMessage = {
                            languages: [definitionLanguage.value],
                            level: "warning"
                        };
                    }
                    missingLanguages.push(definitionLanguage.text);
                }
            });

            if (validationMessage) {
                validationMessage.value = lang.replace(localization.validationmessage.notenoughlanguagesmessage.title, { languages: missingLanguages.join(", ") });
            }

            return validationMessage;
        },

        _validateSelfApprove: function (reviewers) {
            // summary:
            //      Validates when selfApprove is false, at least 2 users or 1 group is required
            // returns:
            //      The validationMessage
            // tags:
            //      private

            if (this.selfApprove !== false) {
                return null;
            }

            if (!this.languages) {
                if (reviewers.length === 1 && reviewers[0].reviewerType === ApprovalEnums.reviewerType.user) {
                    return {
                        value: localization.validationmessage.onlyonereviewer.title,
                        languages: null,
                        level: "warning"
                    };
                }
                return null;
            }

            var missingLanguages = this.languages.filter(function (language) {
                var reviewerCount = 0;
                reviewers.forEach(function (reviewer) {
                    if (reviewer.languages.length === 0 || reviewer.languages.indexOf(language.value) !== -1) {
                        if (reviewer.reviewerType === ApprovalEnums.reviewerType.user) {
                            reviewerCount++;
                        } else if (reviewer.reviewerType === ApprovalEnums.reviewerType.role) {
                            //Count a group as 2 users
                            reviewerCount += 2;
                        }
                    }
                });
                return reviewerCount < 2;
            });

            if (missingLanguages.length > 0) {
                return {
                    value: lang.replace(localization.validationmessage.onlyonelanguagereviewer.title, {
                        languages: missingLanguages.map(function (language) {
                            return language.text;
                        }).join(", ")
                    }),
                    languages: missingLanguages.map(function (language) {
                        return language.value;
                    }),
                    level: "warning"
                };
            }

            return null;
        },

        _validateRoles: function (reviewers) {
            // summary:
            //      Validates if there is reviewers of type ApprovalEnums.reviewerType.role
            //      which number of role users that exceeded the limit
            // returns:
            //      The validationMessage
            // tags:
            //      private

            if (reviewers.length === 0) {
                return null;
            }

            var validationResult = [];
            reviewers.forEach(function (reviewer) {
                if (reviewer.reviewerType === ApprovalEnums.reviewerType.role && reviewer.numberOfRoleUsersExceededMax) {
                    validationResult.push(reviewer.displayName);
                }
            });
            if (validationResult.length === 0) {
                return null;
            }

            var text = lang.replace(localization.validationmessage.roleusersexceededmaxmessage.description, { rolenames: validationResult.join(", ") });
            return {
                value: text,
                languages: null,
                level: "warning"
            };
        },

        _validateReviewers: function (reviewers) {
            // summary:
            //      Validates if the approvalStep have any reviewers
            // returns:
            //      The validationMessage
            // tags:
            //      private

            var validationMessage = null;

            if (reviewers.length === 0) {
                validationMessage = {
                    value: localization.validationmessage.notenoughreviewersmessage.title,
                    languages: null,
                    level: "error"
                };
            }

            return validationMessage;
        }
    });
});

},
'epi-cms/content-approval/viewmodels/ReviewerViewModel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojox/html/entities",
    "epi-cms/content-approval/ApprovalEnums"
], function (
    declare,
    Stateful,
    htmlEntities,
    ApprovalEnums
) {
    return declare([Stateful], {
        // summary:
        //      The view model for a reviewer.
        // tags:
        //      internal

        // displayName: [public] String
        //      The displayName for the reviewer.
        displayName: null,

        // name: [public] String
        //      The name for the reviewer.
        name: null,

        // type: [readonly] epi-cms/content-approval/ApprovalDefinitionReviewerType
        //      Specifies the type of reviewer.
        reviewerType: ApprovalEnums.reviewerType.user,

        // numberOfUsers: [public] Number
        //      Total number of group members
        //      Property relevent only for ApprovalEnums.reviewerType.role
        numberOfUsers: 0,

        // numberOfRoleUsersExceededMax: [public] Boolean
        //      True when numberOfUsers exceeded ApprovalMaxRoleUsers
        //      Property relevent only for ApprovalEnums.reviewerType.role
        numberOfRoleUsersExceededMax: false,

        // roleFirstUsersNames: [public] array
        //      List of first 10 users from the group
        //      Property relevent only for ApprovalEnums.reviewerType.role
        roleFirstUsersNames: [],

        postscript: function () {
            this.inherited(arguments);

            if (this.roleInfo != null) {
                this.set("numberOfUsers", this.roleInfo.totalNumberOfUsers);
                this.set("roleFirstUsersNames", this.roleInfo.userNames);
                this.set("numberOfRoleUsersExceededMax", this.roleInfo.numberOfRoleUsersExceededMax);
                this.set("displayNameUsersLimit", this.roleInfo.displayNameUsersLimit);
            }
        },

        _numberOfOtherUsersGetter: function () {
            if (!this.roleFirstUsersNames) {
                return this.numberOfUsers;
            }

            return this.numberOfUsers - this.roleFirstUsersNames.length;
        },

        _displayNameGetter: function () {
            var displayName = this.displayName;
            if (this.reviewerType === ApprovalEnums.reviewerType.role) {
                displayName += " (" + this.displayNameUsersLimit;
                if (this.numberOfRoleUsersExceededMax) {
                    displayName += "+";
                }
                displayName += ")";
            }
            return htmlEntities.encode(displayName);
        },

        _roleFirstUsersNamesGetter: function () {
            if (!this.roleFirstUsersNames || this.roleFirstUsersNames.length === 0) {
                return [];
            }
            return this.roleFirstUsersNames.map(function (roleFirstUsersName) {
                return htmlEntities.encode(roleFirstUsersName);
            });
        },

        // languages: [public] Array
        //      Languages that this reviewer can approve.
        languages: null,

        // canApprove: [public] Boolean
        //      Indicates if the reviewer can approve the selected language.
        canApprove: true,

        serialize: function () {
            // summary:
            //      Serialize reviewer
            // tags:
            //      public

            return {
                name: this.name,
                displayName: this.displayName,
                languages: this.languages,
                reviewerType: this.reviewerType
            };
        },

        _iconGetter: function () {
            // summary:
            //     Returns the icon for current reviewer
            // tags:
            //      private
            return this.reviewerType === ApprovalEnums.reviewerType.role ? "epi-iconUsers" : "epi-iconUser";
        }

    });
});

},
'epi-cms/content-approval/command/AddApprovalStep':function(){
define([
    "dojo/_base/declare",
    "epi/i18n!epi/nls/episerver.shared.action",
    // Parent class and mixins
    "epi/shell/command/_PropertyWatchCommand"
], function (
    declare,
    localization,
    // Parent class and mixins
    _PropertyWatchCommand
) {

    return declare([_PropertyWatchCommand], {
        // summary:
        //      Adds an approval step after the current approval step.
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.add,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "",

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "add",

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["isReadOnly"],

        _execute: function () {
            this.model.createApprovalStep();
        },

        _onPropertyChanged: function () {
            /// summary:
            //      Sets isAvailable and canExecute based on the properties to watch.
            // tags:
            //      protected

            var isAvailable = !this.model.isReadOnly;

            this.set({
                canExecute: isAvailable,
                isAvailable: isAvailable
            });
        }
    });
});

},
'epi-cms/content-approval/command/RemoveApprovalStep':function(){
define([
    "dojo/_base/declare",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.removeapprovalstep",
    // Parent class and mixins
    "epi/shell/command/_PropertyWatchCommand"
], function (
    declare,
    localization,
    // Parent class and mixins
    _PropertyWatchCommand
) {

    return declare([_PropertyWatchCommand], {
        // summary:
        //      Removes the current approval step.
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.label,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconClose",

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "remove",

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["canBeDeleted", "isReadOnly"],

        _execute: function () {
            this.model.removeApprovalStep();
        },

        _onPropertyChanged: function () {
            // summary:
            //      Sets isAvailable and canExecute based on the properties to watch.
            // tags:
            //      protected

            var model = this.model,
                isAvailable = !model.isReadOnly && model.canBeDeleted;

            this.set({
                canExecute: isAvailable,
                isAvailable: isAvailable
            });
        }
    });
});

},
'epi/shell/command/withConditionalConfirmation':function(){
﻿define("epi/shell/command/withConditionalConfirmation", [
    "dojo/Deferred",
    "dojo/when",
    "epi/shell/DialogService"
], function (
    Deferred,
    when,
    dialogService
) {

    return function (command, settings) {
        // summary:
        //      Displays a confirmation before executing a command if the command is in a state that
        //      requires confirmation; otherwise the command is executed as normal.
        // tags:
        //      internal

        var originalExecute = command._execute,
            conditionProperty = settings.property || "requiresConfirmation";

        // Wrap the execution with a confirmation dialog if the condition is true.
        command._execute = function () {

            var promise = command[conditionProperty] ? dialogService.confirmation(settings) : new Deferred().resolve();

            return promise.then(function () {
                return when(originalExecute.apply(command, arguments));
            });
        };

        return command;
    };
});

},
'epi-cms/content-approval/command/SaveApprovalDefinition':function(){
define([
    "dojo/_base/declare",
    "epi/i18n!epi/nls/episerver.shared.action",
    "epi/shell/DialogService",
    // Parent class and mixins
    "epi/shell/command/_PropertyWatchCommand"
], function (
    declare,
    localization,
    dialogService,
    // Parent class and mixins
    _PropertyWatchCommand
) {

    return declare([_PropertyWatchCommand], {
        // summary:
        //      Validates and saves the content approval definition that is being edited.
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.save,

        // isAvailable: [public] Boolean
        //      Flag which indicates whether this command is available in the current context.
        isAvailable: true,

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed.
        canExecute: false,

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["isDirty", "isValid", "isReadOnly"],

        _execute: function () {
            // summary:
            //      Validate the model to see if it's ok to save. Otherwise let the user confirm the save if possible,
            //      or inform that saving is not possible due to validation errors.
            // tags:
            //      private

            this.model.set("showValidations", true);

            var validationIssue = this.model.validate();

            if (!validationIssue) {
                this.model.saveApprovalDefinition();
                return;
            }

            switch (validationIssue.level) {
                case "error":
                    dialogService.alert(validationIssue.dialog);
                    break;
                case "warning":
                    dialogService.confirmation(validationIssue.dialog).then(function () {
                        this.model.saveApprovalDefinition();
                    }.bind(this));
                    break;
            }
        },

        _onPropertyChanged: function () {
            // summary:
            //      Updates isAvailable after the model has been changed.
            // tags:
            //      private

            this.set("isAvailable", !this.model.isReadOnly);
            this.set("canExecute", this.model.isDirty && this.model.isValid);
            this.set("label", this.model.isDirty ? localization.save : localization.saved);
        }
    });
});

},
'epi-cms/content-approval/command/CancelChanges':function(){
define([
    "dojo/_base/declare",
    "epi/dependency",
    "epi/i18n!epi/nls/episerver.shared.action",
    // Parent class and mixins
    "epi/shell/command/_PropertyWatchCommand"
], function (
    declare,
    dependency,
    localization,
    // Parent class and mixins
    _PropertyWatchCommand
) {

    return declare([_PropertyWatchCommand], {
        // summary:
        //      Cancel the changes made to the model by loading the previous context
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.cancel,

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed.
        canExecute: true,

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["isDirty"],

        // contextHistory: [readonly] epi-cms/BackContextHistory
        //      The context history
        contextHistory: null,

        postscript: function () {
            this.inherited(arguments);
            this.contextHistory = this.contextHistory || dependency.resolve("epi.cms.BackContextHistory");
        },

        _execute: function () {
            this.contextHistory.closeAndNavigateBack(this);
        },

        _onPropertyChanged: function () {
            // summary:
            //      This is called whenever the specified property is changed on the model and sets
            //      whether a confirmation is required.
            // tags:
            //      protected

            var isDirty = !!this.model.isDirty;

            this.set("label", isDirty ? localization.cancel : localization.close);
        }
    });
});

},
'epi/shell/store/SortableMemory':function(){
define("epi/shell/store/SortableMemory", [
    "dojo/_base/declare",
    "epi/shell/store/queryUtils",
    // Parent class
    "dojo/store/Memory"
], function (
    declare,
    queryUtils,
    // Parent class
    Memory
) {

    return declare(Memory, {
        // summary:
        //      A memory store that supports natural ordering.
        // tags:
        //      internal

        getSibling: function (object, previous) {
            // summary:
            //      Gets the next sibling of a given object. Will retrieve the previous sibling if
            //      the previous flag is set to true. Returns null if no sibling is found.
            // object: Object
            //      The object to get the sibling of.
            // previous: Boolean
            //      Indicates that the previous sibling should be retrieved.
            // returns:
            //      Object

            var data = this.data,
                index = this.index,
                id = this.getIdentity(object);

            if (!(id in index)) {
                throw new Error("Object specified in options.before does not exist");
            }

            var delta = previous ? -1 : 1,
                pos = index[id] + delta;

            if (pos < 0 || pos >= data.length) {
                return null;
            }

            return data[pos];
        },

        put: function (object, options) {
            // summary:
            //      Stores an object.
            // object: Object
            //      The object to store.
            // options: dojo/store/api/Store.PutDirectives?
            //      Additional metadata for storing the data.
            // returns:
            //      Number

            var data = this.data,
                idProperty = this.idProperty;

            var id = object[idProperty] = (options && "id" in options) ? options.id : idProperty in object ? object[idProperty] : Math.random();
            var existingObject = false;
            if (id in this.index) {
                existingObject = true;
            }

            if (options) {
                if (options.overwrite === false) {
                    if (existingObject) {
                        throw new Error("Object already exists");
                    }
                }

                // If the `before` property exists with a value of null or undefined and an existing object is being
                // updated then it is being moved to the end of the collection.
                if (options.before || (Object.prototype.hasOwnProperty.call(options, "before") && existingObject)) {
                    // Get the previous index and default the destination to the last item.
                    var previousIndex = this.index[id],
                        destination = data.length;

                    // Get the index of the given object.
                    if (options.before) {
                        var beforeRefId = this.getIdentity(options.before);
                        destination = this.index[beforeRefId];
                    }

                    // Account for the removed item
                    if (previousIndex < destination) {
                        --destination;
                    }

                    if (destination !== undefined) {
                        if (existingObject) {
                            // The object is being moved so remove it from its current position.
                            this.remove(id);
                        }
                        // carve out a spot for the new item
                        data.splice(destination, 0, object);
                        // now we have to reindex
                        this.setData(data);

                        return id;
                    } else {
                        throw new Error("Object specified in options.before does not exist");
                    }
                }
            }

            if (existingObject) {
                // replace the entry in data
                data[this.index[id]] = object;
            } else {
                // add the new object
                this.index[id] = data.push(object) - 1;
            }
            return id;
        },

        queryEngine: function (query, options) {
            // summary:
            //        A query engine that supports natural ordering in the memory store. It therefore
            //        does not support the sort query option.

            query = queryUtils.createFilter(query, options);

            function execute() {
                // Return the store data instead of the given results data since the store data is
                // in the correct order. Filter this through the query.
                return this.data.filter(query);
            }

            execute.matches = query;

            return execute.bind(this);
        }
    });
});

},
'url:epi-cms/content-approval/templates/ApprovalComponent.html':"﻿<div class=\"epi-content-approval\">\r\n    <div class=\"epi-localToolbar epi-viewHeaderContainer\" data-dojo-type=\"dijit/Toolbar\">\r\n        <div class=\"epi-toolbarGroupContainer\">\r\n            <div class=\"epi-toolbarGroup epi-toolbarLeading\">\r\n                <div data-dojo-attach-point=\"breadcrumb\" data-dojo-type=\"epi-cms/content-approval/Breadcrumb\" data-dojo-props=\"displayAsText:false, showCurrentNode:false\"></div>\r\n                <div data-dojo-attach-point=\"breadcrumbCurrentItem\" data-dojo-type=\"epi-cms/widget/BreadcrumbCurrentItem\"></div>\r\n            </div>\r\n            <div class=\"epi-toolbarGroup epi-toolbarTrailing\" data-dojo-attach-point=\"commandNode\">\r\n                <div data-dojo-attach-point=\"validation\" data-dojo-type=\"epi-cms/widget/NotificationStatusBar\"></div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"epi-content-approval__container\">\r\n        <div class=\"epi-content-approval__header\">\r\n            <hgroup class=\"epi-heading-group\">\r\n                <h1 class=\"epi-heading\"><span class=\"epi-heading-icon\" data-dojo-attach-point=\"contentIcon\"></span> <span data-dojo-attach-point=\"contentName\"></span></h1>\r\n                <h2 class=\"epi-heading\">${resources.title}</h2>\r\n            </hgroup>\r\n            <p>${resources.instructions.reviewers}</p>\r\n            <p>${resources.instructions.steps}</p>\r\n            <div class=\"epi-content-approval__settings clearfix\" data-dojo-type=\"dijit/form/Form\" data-dojo-attach-point=\"form\">\r\n                <span class=\"dijitInline\">\r\n                    <input id=\"enable-approval\" data-dojo-attach-point=\"enableButton\" data-dojo-type=\"dijit/form/RadioButton\" data-dojo-props=\"name:'status', value:${ApprovalDefinitionStatus.enabled}\">\r\n                    <label class=\"dijitInline\" for=\"enable-approval\">${resources.states.enabled}</label>\r\n                </span>\r\n                <span class=\"dijitInline\">\r\n                    <input id=\"inherit-approval\" data-dojo-attach-point=\"inheritButton\" data-dojo-type=\"dijit/form/RadioButton\" data-dojo-props=\"name:'status', value:${ApprovalDefinitionStatus.inherited}\">\r\n                    <label class=\"dijitInline\" for=\"inherit-approval\">${resources.states.inherited}</label>\r\n                </span>\r\n                <span class=\"dijitInline\">\r\n                    <input id=\"disabled-approval\" data-dojo-attach-point=\"disableButton\" data-dojo-type=\"dijit/form/RadioButton\" data-dojo-props=\"name:'status', value:${ApprovalDefinitionStatus.disabled}\">\r\n                    <label class=\"dijitInline\" for=\"disabled-approval\">${resources.states.disabled}</label>\r\n                </span>\r\n                <fieldset class=\"dijitInline\" data-dojo-attach-point=\"demandCommentFieldsetNode\">\r\n                    <div>\r\n                        <input id=\"demandcomment-start\" data-dojo-attach-point=\"demandStartCommentButton\" data-dojo-type=\"dijit/form/CheckBox\">\r\n                        <label class=\"dijitInline\" for=\"demandcomment-start\">${resources.demandcomment.start}</label>\r\n                    </div>\r\n                    <div>\r\n                        <input id=\"demandcomment-approve-approval\" data-dojo-attach-point=\"demandApproveCommentButton\" data-dojo-type=\"dijit/form/CheckBox\">\r\n                        <label class=\"dijitInline\" for=\"demandcomment-approve-approval\">${resources.demandcomment.label} ${resources.demandcomment.approve}</label>\r\n                    </div>\r\n                    <div>\r\n                        <input id=\"demandcomment-approval\" data-dojo-attach-point=\"demandDeclineCommentButton\" data-dojo-type=\"dijit/form/CheckBox\">\r\n                        <label class=\"dijitInline\" for=\"demandcomment-approval\">${resources.demandcomment.label} ${resources.demandcomment.decline}</label>\r\n                    </div>\r\n                    <div>\r\n                        <input id=\"prevent-self-approve\" data-dojo-attach-point=\"preventSelfApproveButton\" data-dojo-type=\"dijit/form/CheckBox\">\r\n                        <label class=\"dijitInline\" for=\"prevent-self-approve\">${resources.preventselfapprove}</label>\r\n                    </div>\r\n                </fieldset>\r\n            </div>\r\n        </div>\r\n        <div class=\"epi-content-approval__disabled-warning\" data-dojo-attach-point=\"warningNode\">\r\n            <span data-dojo-attach-point=\"warningMessage\"></span><a class=\"epi-visibleLink\" data-dojo-attach-point=\"goToInheritedSequence\" data-dojo-attach-event=\"onclick:_goToInheritedSequence\">${resources.gotoinheritedsequence}</a>\r\n        </div>\r\n        <div class=\"epi-content-approval__filter\" data-dojo-attach-point=\"filterNode\">\r\n            <span class=\"dijitInline\">${resources.languagefilter.description}</span>\r\n            <div data-dojo-attach-point=\"languageFilter\" data-dojo-type=\"dijit/form/Select\" class=\"epi-chromeless epi-chromeless--with-arrow epi-visibleLink\"></div>\r\n        </div>\r\n        <div data-dojo-attach-point=\"stepList\" data-dojo-type=\"epi-cms/content-approval/ApprovalStepList\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/content-approval/Breadcrumb':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/topic",
    // epi
    "epi/dependency",
    "epi-cms/widget/Breadcrumb"
],
function (declare, topic, dependency, Breadcrumb) {
    return declare([Breadcrumb], {
        // summary:
        //      Widget used to show the content's path in the strucuture
        //      and when the user clicks on a node it will load the approval definition for that content item
        //
        // tags:
        //      internal

        postscript: function () {
            this.inherited(arguments);

            this.approvalService = this.approvalService || dependency.resolve("epi.cms.ApprovalService");
        },
        onNodeClick: function (e, content) {
            // summary:
            //      Load the approval context for the clicked content item
            // e: Object
            //      The mouse event object.
            // content: Object
            //      The content object.
            // tags:
            //      protected

            e.preventDefault();

            this.approvalService.navigateToDefinition(content.contentLink);
        }
    });
});

},
'epi-cms/content-approval/ApprovalStepList':function(){
define([
    "dojo/_base/declare",
    "dojo/keys",
    "epi-cms/content-approval/ApprovalStep",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "epi/shell/widget/_ModelBindingMixin",
    // List modules
    "dgrid/List",
    "dgrid/Keyboard",
    "dgrid/extensions/DijitRegistry",
    "dgrid/extensions/DnD",
    "epi/shell/dgrid/SingleQuery",
    "epi/shell/dgrid/WidgetRow",
    // Resources
    "dojo/text!./templates/ApprovalStepList.html",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.steplist"
], function (
    declare,
    keys,
    ApprovalStep,
    // Parent class and mixins
    _WidgetBase,
    _TemplatedMixin,
    _ModelBindingMixin,
    // List modules
    List,
    Keyboard,
    DijitRegistry,
    DnD,
    SingleQuery,
    WidgetRow,
    // Resources
    template,
    localization
) {

    var StepList = declare([List, SingleQuery, DnD, Keyboard, DijitRegistry, WidgetRow]);

    return declare([_WidgetBase, _TemplatedMixin, _ModelBindingMixin], {
        // summary:
        //      The view for the content approval component; responsible for creating the content
        //      approval view model and creating child view components.
        // tags:
        //      internal

        // model: [public] ContentApprovalViewModel
        //      The model containing the approval steps to be listed.
        model: null,

        // modelBindingMap: Object
        //      The binding mappings from model properties to local properties.
        modelBindingMap: {
            approvalSteps: ["approvalSteps"]
        },

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // resources: [protected] Object
        //      An object containing resource strings in the current language.
        resources: localization,

        buildRendering: function () {
            // summary:
            //      Build the approval component rendering from the template and then create buttons
            //      for the commands.
            // tags:
            //      protected

            this.inherited(arguments);

            this.list = new StepList({
                className: "epi-chromeless",
                dndParams: { withHandles: true, creator: this._createAvatar.bind(this), skipForm: true },
                maintainOddEven: false,
                renderRow: this._renderRow.bind(this),
                selectionMode: "single",
                //Added sort because without sort you get console logs
                sort: "default"
            }, this.listNode);

            this.own(
                this.list.addKeyHandler(keys.DELETE, this._removeStep.bind(this)),
                this.list.addKeyHandler(keys.DOWN_ARROW, this._moveStep.bind(this, false)),
                this.list.addKeyHandler(keys.UP_ARROW, this._moveStep.bind(this, true)),
                this.list.on(".dgrid-row:keypress", this._createStep.bind(this))
            );
        },

        startup: function () {
            // summary:
            //      Processing after the DOM fragment is added to the document.
            // tags:
            //      protected

            this.inherited(arguments);

            this.list.startup();
        },

        _createAvatar: function (item) {
            // summary:
            //      Create an avatar for the approval step. Do this by creating a new widget based
            //      on the same model, since the default behavior of Avatar is to clone the existing
            //      widget which causes the inner list ids to be duplicated and this leads to errors
            //      when trying to remove rows.
            // tags:
            //      private

            // Create a new approval step based on the same model as the one being moved.
            var step = new ApprovalStep({ model: item });
            step.startup();

            // Clone the node so that we have a copy that is not bound to a widget and can be
            // removed later.
            var node = step.domNode.cloneNode(true);

            // Destroy the widget to ensure we don't leak memory.
            step.destroyRecursive();

            return {
                node: node,
                type: this.list.dndSourceType,
                data: item
            };
        },

        _createStep: function (event) {
            // summary:
            //      Create a step after the step associated with the event.
            // tags:
            //      private

            if (!event.ctrlKey && String.fromCharCode(event.which) === "+") {
                var row = this.list.row(event);
                this.model.createApprovalStep(row.data);
            }
        },

        _moveStep: function (moveUp, event) {
            // summary:
            //      Move the step associated with the event up or down.
            // tags:
            //      private

            if (event.ctrlKey) {
                var row = this.list.row(event);

                this.list.focus(row);
                this.model.moveApprovalStep(row.data, moveUp);
            }
        },

        _removeStep: function (event) {
            // summary:
            //      Remove the step associated with the event.
            // tags:
            //      private

            var row = this.list.row(event);

            this.model.removeApprovalStep(row.data);
        },

        _renderRow: function (viewModel) {
            // summary:
            //      Renders an approval step widget for the row and returns its DOM node.
            // tags:
            //      private

            var languageOptions = this.model.get("languageOptions");

            var step = new ApprovalStep({
                model: viewModel,
                languageOptions: languageOptions
            });

            return step.domNode;
        },

        _setApprovalStepsAttr: function (approvalSteps) {
            this._set("approvalSteps", approvalSteps);
            this.list.set("store", approvalSteps);
        }
    });
});

},
'epi-cms/content-approval/ApprovalStep':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/keys",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/command/builder/MenuAssembler",
    "epi-cms/content-approval/viewmodels/ReviewerViewModel",
    "./ApprovalEnums",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi/shell/widget/_ModelBindingMixin",
    // List and mixins
    "dgrid/List",
    "epi/shell/dgrid/SingleQuery",
    "epi/shell/dgrid/Formatter",
    "dgrid/Keyboard",
    "dgrid/extensions/DijitRegistry",
    "epi/shell/dgrid/WidgetRow",
    //Search box
    "dijit/form/ComboBox",
    // reviewer widget
    "./Reviewer",
    // Resources
    "dojo/text!./templates/ApprovalStep.html",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.step",
    //Widgets in template
    "dijit/form/TextBox"
], function (
    declare,
    lang,
    aspect,
    domClass,
    keys,
    ButtonBuilder,
    MenuAssembler,
    ReviewerViewModel,
    ApprovalEnums,
    // Parent class and mixins
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _ModelBindingMixin,
    // List and mixins
    List,
    SingleQuery,
    Formatter,
    Keyboard,
    DijitRegistry,
    WidgetRow,
    //Search box
    ComboBox,
    // reviewer widget
    Reviewer,
    //Resources
    widgetTemplate,
    localization,
    //Widgets in template
    Textbox
) {

    var ReviewerList = declare([List, Keyboard, DijitRegistry, Formatter, SingleQuery, WidgetRow]);

    var NavigableComboBox = declare([ComboBox], {

        labelType: "html",

        _onKey: function (evt) {

            if (evt.keyCode === keys.UP_ARROW && !this._opened) {
                this.onMoveUp(evt);
                return;
            }

            if (evt.keyCode === keys.ENTER &&
                    this._hasSuggestions() &&
                    this._hasNoItemSelected()) {
                this.set("item", this.dropDown.items[0]);
            }

            this.inherited(arguments);
        },

        labelFunc: function (item) {
            var iconTemplate = "<span class=\"dijitInline dijitIcon {icon}\"></span>{displayName}";

            var viewModel = new ReviewerViewModel(item);
            return lang.replace(iconTemplate, {
                icon: viewModel.get("icon"),
                displayName: viewModel.get("displayName")
            });
        },

        onMoveUp: function () {},

        _hasSuggestions: function () {
            return this._opened &&
                !!this.get("value") &&
                this.dropDown.items.length > 0;
        },

        _hasNoItemSelected: function () {
            return !this.item;
        }
    });

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      The approval step component, responsible for showing the reviewers.
        // tags:
        //      internal

        // model: [readonly] ApprovalStepViewModel
        //      The model containing the reviewers to be listed.
        model: null,

        // modelBindingMap: [protected] Object
        //      The binding mappings from model properties to local properties.
        modelBindingMap: {
            isReadOnly: ["isReadOnly"],
            isValid: ["isValid"]
        },

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: widgetTemplate,

        // resources: [protected] Object
        //      An object containing resource strings in the current language.
        resources: localization,

        buildRendering: function () {
            // summary:
            //      Build the approvalStep widget
            // tags:
            //      protected

            this.inherited(arguments);

            var store = this.model.get("reviewers");

            this.headerTextbox.set("value", this.model.name);

            this.list = new ReviewerList({
                className: "epi-chromeless",
                maintainOddEven: false,
                store: store,
                //Added sort because without sort you get console logs
                sort: "default",
                renderRow: this._renderReviewer.bind(this)
            }, this.listNode);

            //Stop the propagation of the DOWN and UP arrow key presses
            this.own(
                this.list.addKeyHandler(keys.DOWN_ARROW, function (evt) {
                    evt.stopPropagation();
                    if (evt.target === evt.currentTarget.lastElementChild) {
                        this.searchBox.focus();
                    }
                }.bind(this)),
                this.list.addKeyHandler(keys.UP_ARROW, function (evt) {
                    evt.stopPropagation();
                }),
                this.headerTextbox.on("change", function (value) {
                    this.model.set("name", value);
                }.bind(this))
            );

            var settings = {
                    "class": "epi-approval-step__add-step__button",
                    showLabel: false,
                    tabIndex: -1
                },
                builder = new ButtonBuilder({ settings: settings }),
                configuration = [
                    { category: "add", builder: builder, target: this.arrowNode },
                    { category: "remove", builder: builder, target: this.removeNode }
                ];

            new MenuAssembler({
                configuration: configuration,
                commandSource: this
            });

            var userStore = this.model.get("userStore");

            this.searchBox = new NavigableComboBox({
                labelAttr: "displayName",
                queryExpr: "${0}",
                store: userStore,
                searchAttr: "name",
                autoComplete: false,
                // This mirrors the height set in epi-autocomplete-list styling
                maxHeight: 294
            }, this.searchNode);

            this.own(
                aspect.before(this.searchBox, "onSearch",  this._searchBoxOnSearch.bind(this)),
                this.searchBox.on("change", this._searchBoxOnChange.bind(this)),
                this.searchBox.on("moveUp", function (evt) {
                    Keyboard.moveFocusEnd.call(this.list, evt);
                }.bind(this)),
                //Stops the propagation when pressing for example + button so that
                //we don't get a new approvalStep.
                this.searchBox.on("keypress", function (evt) {
                    evt.stopPropagation();
                })
            );
        },

        _renderReviewer: function (model) {
            // summary:
            //      Renders an reviewer widget for the row and returns its DOM node.
            // tags:
            //      private

            var reviewer = new Reviewer({
                model: model,
                languageOptions: this.languageOptions
            });

            this.own(
                reviewer.on("remove-reviewer", function (reviewer) {
                    this.model.removeReviewer(reviewer);
                }.bind(this))
            );

            return reviewer.domNode;
        },

        _searchBoxOnSearch: function (users, query, options) {
            // summary:
            //      Handles changes when searching in the searchBox
            // tags:
            //      private

            users = this.model.filterOutExistingUsers(users);

            // Return all the arguments to the aspect since they
            // will be used when displaying the result list.
            return [users, query, options];
        },

        _searchBoxOnChange: function (value) {
            // summary:
            //      Handles value changes on the searchBox
            // tags:
            //      private

            //Early exit because when we clear the value
            //below it will call this method again or if someone
            //tries to add something that is not in the user list
            if (!value || !this.searchBox.item) {
                return;
            }

            //Uses the searchBox item because the value only
            //return the displayName not the whole object
            this.model.addReviewer(this.searchBox.item);

            //Reset value because the selected value would
            //otherwise still be there
            this.searchBox.set("value", "");
        },

        startup: function () {
            // summary:
            //      Processing after the DOM fragment is added to the document.
            // tags:
            //      protected

            if (this._started) {
                return;
            }
            this.inherited(arguments);

            this.list.startup();
            this.searchBox.startup();

            // Stop the contentNode from being a tab stop as we don't want to focus an empty list.
            this.list.contentNode.tabIndex = -1;
        },

        getCommands: function () {
            return this.model.get("commands");
        },

        _setIsReadOnlyAttr: function (isReadOnly) {
            this._set("isReadOnly", isReadOnly);

            domClass.toggle(this.domNode, "epi-approval-step--read-only", isReadOnly);

            // Set the textbox as read-only so that the text is selectable but set the tabIndex to -1
            // so that the textbox is no longer a tab stop.
            this.headerTextbox.set({
                readOnly: isReadOnly,
                tabIndex: isReadOnly ? -1 : 0
            });
        },

        _setIsValidAttr: function (isValid) {
            this._set("isValid", isValid);

            var hasValidationMessage = !isValid && this.model.get("showValidations");

            var hasErrors = this.model.hasErrors();
            domClass.toggle(this.domNode, "epi-approval-step--error", hasValidationMessage && hasErrors);
            domClass.toggle(this.domNode, "epi-approval-step--warning", hasValidationMessage && (!hasErrors && this.model.hasWarnings()));
        }
    });
});

},
'epi/shell/dgrid/SingleQuery':function(){
define("epi/shell/dgrid/SingleQuery", [
    "dojo/_base/declare",
    "dgrid/_StoreMixin"
], function (declare, _StoreMixin) {

    return declare(_StoreMixin, {
        // summary:
        //      A dgrid mixin which implements the refresh method to always perform a single query
        //      with no start or count specified, to retrieve all relevant results at once.
        //      Appropriate for grids using memory stores with small result set sizes.
        // tags:
        //      public

        // See: http://dgrid.io/tutorials/0.3/single_query/

        refresh: function () {
            // First defer to List#refresh to clear the grid's previous content.
            this.inherited(arguments);

            if (!this._started || !this.store) {
                return;
            }

            return this._trackError(function () {
                var queryOptions = this.get("queryOptions"),
                    results = this.store.query(this.query, queryOptions);

                return this.renderArray(results, null, queryOptions);
            }.bind(this));
        },

        renderArray: function () {
            var rows = this.inherited(arguments);

            // Clear _lastCollection which is ordinarily only used for store-less grids.
            this._lastCollection = null;

            return rows;
        }
    });
});

},
'epi-cms/content-approval/Reviewer':function(){
define([
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/keys",
    "dojo/store/Memory",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/Tooltip",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi/shell/widget/_ModelBindingMixin",
    "./groupMembersListFormatter",
    "./ApprovalEnums",
    //Resources
    "dojo/text!./templates/Reviewer.html",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.reviewer",
    // Widgets in template
    "epi-cms/contentediting/editors/CheckboxListDropDown"
], function (
    declare,
    domClass,
    domConstruct,
    domStyle,
    keys,
    Memory,
    // Parent class and mixins
    _WidgetBase,
    Tooltip,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _ModelBindingMixin,
    groupMembersListFormatter,
    ApprovalEnums,
    //Resources
    template,
    localization
) {
    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      Responsible for displaying a single reviewer and its settings in the approval step.
        // tags:
        //      internal

        // model: [readonly] ReviewerViewModel
        //      The view model of the reviewer.
        model: null,

        // modelBindingMap: [protected] Object
        //      The binding mappings from model properties to local properties.
        modelBindingMap: {
            canApprove: ["canApprove"]
        },

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // resources: [protected] Object
        //      An object containing resource strings in the current language.
        resources: localization,

        // tooltip: [private] dijit/Tooltip
        tooltip: null,

        postMixInProperties: function () {
            // summary:
            //      Checks whether the model have been set before the template instantiated.
            // tags:
            //      protected

            // a model must be provided before creating this component.
            if (!this.model) {
                throw new Error("An instance of ReviewerViewModel must be provided in order to create an Reviewer component.");
            }
        },

        buildRendering: function () {
            // summary:
            //      Builds the reviewer
            // tags:
            //      protected

            this.inherited(arguments);

            if (this.model.reviewerType === ApprovalEnums.reviewerType.role) {
                this.own(this.tooltip = new Tooltip({
                    connectId: [this.selectedReviewerNode],
                    label: this._formatMembersTooltipLabel(),
                    position: ["below-centered", "above-centered"]
                }));
            }

            this.set("displayName", this.model.get("displayName"));

            var store = new Memory({
                idProperty: "value",
                data: this.languageOptions || []
            });

            this.languageSelector.set("store", store);
            this.languageSelector.set("connectorVisible", false);

            if (this.model.languages) {
                this.languageSelector.set("value", this.model.languages, false);
            }

            // Toggle the language selector visibility depending on whether there are any languages.
            domClass.toggle(this.languageSelector.domNode, "dijitHidden", !this.languageOptions);

            // Set the reviewer icon based on the reviewer type
            domClass.add(this.reviewerIcon, this.model.get("icon"));

            this.own(
                this.on(".epi-reviewer__remove-button:click", this._removeReviewer.bind(this)),
                this.on("keydown", this._removeReviewer.bind(this)),
                this.languageSelector.on("change", function (languages) {
                    this.model.set("languages", languages);
                    this._renderSelectedLanguages();
                }.bind(this))
            );

            this._renderSelectedLanguages();
        },

        _formatMembersTooltipLabel: function () {
            var roleFirstUsersNames = this.model.get("roleFirstUsersNames");
            if (!roleFirstUsersNames || roleFirstUsersNames.length === 0) {
                return localization.nogroupmembers;
            }

            var tooltipLabel = "<div class='epi-approval-group-tooltip'>" + groupMembersListFormatter.renderList(roleFirstUsersNames);
            var numberOfOtherUsers = this.model.get("numberOfOtherUsers");
            if (numberOfOtherUsers > 0) {
                tooltipLabel += "<div>+" + numberOfOtherUsers + "</div>";
            }

            tooltipLabel += "</div>";

            return tooltipLabel;
        },

        _removeReviewer: function (evt) {
            // summary:
            //      Handles when DELETE has been pressed while focusing an reviewer
            //      or the minus icon is clicked.
            // tags:
            //      private

            // only deletes reviewer on click on delete button or DELETE key press.
            if (evt.type === "click" || evt.keyCode === keys.DELETE) {
                evt.stopPropagation();
                this.emit("remove-reviewer", this.model);
            }
        },

        _renderSelectedLanguages: function () {

            // clear all current languages
            domConstruct.empty(this.languageSettingsNode);

            // No language render needed when only one language is available
            if (!this.languageOptions) {
                return;
            }

            var self = this;

            // Creates the language specific dom element for given input
            function toLanguageDom(language) {

                var languageBranch = self.languageSelector.store.get(language),
                    cssClasses = "dijitInline epi-lozenge";

                //Language set on the reviewer that is disabled will change apperance.
                if (!languageBranch && self.model.languages.length > 0) {
                    cssClasses += " epi-lozenge--inactive";
                }

                var properties = {
                    innerHTML: language,
                    "class": cssClasses,
                    title: languageBranch ? languageBranch.label : language
                };

                domConstruct.create("span", properties, self.languageSettingsNode);
            }

            if (this.model.languages) {

                // empty array represents all languages
                if (this.model.languages.length < 1) {
                    toLanguageDom(localization.alllanguages);
                    return;
                }

                this.model.languages.forEach(toLanguageDom);
            }
        },

        _setDisplayNameAttr: { node: "userDisplayNameNode", type: "innerHTML" },

        _setCanApproveAttr: function (canApprove) {
            this._set("canApprove", canApprove);
            domStyle.set(this.domNode, "display", canApprove ? "" : "none");
        }
    });
});

},
'epi-cms/content-approval/groupMembersListFormatter':function(){
define([
    "dojo/_base/lang"

], function (
    lang
) {
    var itemTemplate = "<span class='epi-reviewer__name'>{name}</span></span>";

    var module = {
        // tags:
        //      internal

        renderList: function (users) {
            var res = [];
            users.forEach(function (u) {
                res.push(lang.replace(itemTemplate, { name: u }));
            });

            return res.join(" ");
        }
    };

    return module;
});

},
'url:epi-cms/content-approval/templates/Reviewer.html':"<div class=\"epi-reviewer\">\r\n    <button class=\"epi-button--round epi-reviewer__remove-button\"\r\n            tabindex=\"-1\"\r\n            data-dojo-type=\"dijit/form/Button\"\r\n            type=\"button\">\r\n        <span class=\"dijitInline dijitIcon dijitReset epi-iconMinus epi-icon--inverted\"></span>\r\n    </button>\r\n    <span data-dojo-attach-point=\"selectedReviewerNode\">\r\n        <span data-dojo-attach-point=\"reviewerIcon\" class=\"dijitInline dijitIcon\"></span>\r\n        <span class=\"dijitInline epi-reviewer__name\" data-dojo-attach-point=\"userDisplayNameNode\"></span>\r\n    </span>\r\n    <span class=\"epi-reviewer__language-selector epi-chromeless epi-chromeless--icon-only epi-chromeless--with-arrow\"\r\n          data-dojo-attach-point=\"languageSelector\"\r\n          data-dojo-type=\"epi-cms/contentediting/editors/CheckboxListDropDown\"\r\n          data-dojo-props=\"iconClass: 'epi-iconWebsite', header: '${resources.selectlanguage}', selectAllText: '${resources.anylanguage}'\"></span>\r\n    <span class=\"dijitInline\" data-dojo-attach-point=\"languageSettingsNode\"></span>\r\n</div>\r\n",
'epi-cms/contentediting/editors/CheckboxListDropDown':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",

    "dojox/html/entities",

    "epi/epi",

    // Resources
    "epi/i18n!epi/nls/episerver.shared.action",
    // CheckboxList
    "./CheckboxList",

    // Parent class and mixins
    "dijit/form/_FormValueWidget",
    "epi/shell/widget/DeferredDropDownButton",

    // Widgets in template
    "dijit/form/ToggleButton"
],
function (
    declare,
    lang,
    on,

    entities,

    epi,

    // Resources
    localizations,
    // CheckboxList
    CheckboxList,

    // Parent class and mixins
    _FormValueWidget,
    DeferredDropDownButton
) {
    return declare([DeferredDropDownButton, _FormValueWidget], {
        // summary:
        //      Drop down button for the checkbox list
        // tags:
        //      internal

        value: null,

        // store: [public] Store
        //      A store to query for the list of options.
        store: null,

        // sort: [public] Object
        //      How the items are sorted in the drop down.
        sort: null,

        // query: [public] Object
        //      A query to use when fetching items from the store.
        query: null,

        // enableSelectAll: [public] Boolean
        //      Enable/Disable the possibility to select all values (empty array)
        enableSelectAll: true,

        // selectAllText: [public] String
        //      The text to display for the select all if enabled
        selectAllText: localizations.selectall,

        // header: [protected] String
        //      A string that will be displayed in the header of the selector.
        header: localizations.select,

        buildRendering: function () {
            this.own(
                this.dropDown = new CheckboxList({
                    baseClass: "dijitMenu",
                    header: this.header,
                    enableSelectAll: this.enableSelectAll,
                    selectAllText: this.selectAllText,
                    onExecute: function () {
                        // Override the onExecute method to stop the popup
                        // to close the drop down when an item is selected
                    }
                }),
                on(this.dropDown, "change", lang.hitch(this, function (e) {
                    this.set("value", e.value, true);
                }), true)
            );
            this.inherited(arguments);
        },

        startup: function () {
            if (this._started) {
                return;
            }
            this.inherited(arguments);

            this.dropDown.startup();

            // Set initial value to null if no value has been specified and default values are enabled
            // Set the value after the widget has started to avoid setting the label twice
            // once from the value property setter and one time from the _CssStateMixin
            if (this.enableSelectAll && !this.value) {
                this.set("value", null);
            }
        },

        compare: function (value1, value2) {
            // summary:
            //      Compare two values (as returned by get("value") for this widget).
            // tags:
            //      protected
            return epi.areEqual(value1, value2) ? 0 : -1;
        },

        loadAndOpenDropDown: function () {
            // summary:
            //      Opens the drop down and refreshes the content.
            // returns: Promise
            //      Promise for the drop down widget that resolves when
            //      the drop down is created and loaded.
            // tags:
            //      protected
            var args = arguments;

            //Refresh the drop down before opening it
            var promise = this.dropDown.refresh();

            return promise.then(lang.hitch(this, function () {
                return this.inherited(args);
            }));
        },

        isLoaded: function () {
            // summary:
            //      Make sure the drop down is always considered not loaded
            //      if we have defaultValue enabled, to keep the auto focus
            //      on defaultValue working with the dropDown list
            // tags:
            //      protected
            if (this.enableSelectAll) {
                return false;
            }
            return this.inherited(arguments);
        },

        _getQueryAttr: function () {
            return this.query || {};
        },

        _setQueryAttr: function (value) {
            this._set("query", value);
            if (this.dropDown) {
                this.dropDown.set("query", value);
            }
        },

        _setStoreAttr: function (store) {
            this._set("store", store);
            if (this.dropDown) {
                this.dropDown.set("store", store);
            }
        },

        _setLabelAttr: function (value) {
            // Override the default set label and encode all values before passing them to the drop down
            this.inherited(arguments, [entities.encode(value || "")]);
        },

        _setValueAttr: function (value, internal) {

            !internal && this.dropDown && this.dropDown.set("selectedItems", value);

            this.inherited(arguments);
        },

        _setConnectorVisibleAttr: function (value) {
            this.inherited(arguments);
            if (this.dropDown) {
                this.dropDown.set("connectorVisible", value);
            }
        }
    });
});

},
'epi-cms/contentediting/editors/CheckboxList':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/keys",
    "dojo/when",
    "dojo/dom-class",
    "dojox/html/entities",

    "epi/epi",

    // Resources
    "dojo/text!./templates/CheckboxList.html",
    "epi/i18n!epi/shell/ui/nls/episerver.shared.action",
    // Grid
    "dgrid/OnDemandList",
    "dgrid/extensions/DijitRegistry",
    "dgrid/Keyboard",
    "dgrid/Selection",
    "dgrid/util/mouse",
    "put-selector/put",
    "epi/shell/dgrid/Focusable",
    // Parent class and mixins
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/_KeyNavContainer"
], function (
    declare,
    lang,
    keys,
    when,
    domClass,
    entities,

    epi,

    // Resources
    template,
    localizations,
    // Grid
    OnDemandList,
    DijitRegistry,
    Keyboard,
    Selection,
    mouse,
    put,
    Focusable,
    // Parent class and mixins
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _KeyNavContainer
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _KeyNavContainer], {
        // summary:
        //      Checkbox list
        //
        // tags:
        //      internal

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // store: [public] Store
        //      The store that will be queried for items.
        store: null,

        // query: [public] Object
        //      A query to use when fetching items from the store.
        query: null,

        // enableSelectAll: [public] Boolean
        //      Enable/Disable the possibility to select all values (empty array)
        enableSelectAll: true,

        // selectAllText: [public] String
        //      The text to display for the select all when enabled
        selectAllText: localizations.selectall,

        // header: [protected] String
        //      A string that will be displayed in the header of the selector.
        header: localizations.select,

        _setHeaderAttr: { node: "headerNode", type: "innerText" },

        buildRendering: function () {
            // summary:
            //      Construct the UI for this widget via dijit/_TemplatedMixin with the addition
            //      of a dgrid added via code.
            // tags:
            //      protected
            this.inherited(arguments);

            this.list = new (declare([OnDemandList, DijitRegistry, Selection, Keyboard, Focusable]))({
                className: "epi-grid--no-alternating-rows epi-grid-max-height--300",
                cleanEmptyObservers: false,
                deselectOnRefresh: false,
                selectionEvents: "click",
                selectionMode: "toggle",
                query: this.get("query"),
                renderRow: this.renderRow

            }, this.listNode);

            this.list.on("change", function (e) {
                // stop the change propagation from the checkboxes in the grid
                e.stopPropagation();
            });

            // Own the list and the event handlers.
            this.own(
                this.list,
                this.list.on("dgrid-select,dgrid-deselect", lang.hitch(this, "_itemsSelected")),
                this.list.on("dgrid-refresh-complete", lang.hitch(this, "_refreshComplete")),

                // Handle key events on the list in order to manage moving focus.
                this.list.addKeyHandler(keys.UP_ARROW, lang.hitch(this, "_listNavigateUp")),
                this.list.addKeyHandler(keys.PAGE_UP, lang.hitch(this, "_listNavigateUp")),
                // Handle mouse over events on the list in order to manage moving focus.
                this.list.on(mouse.enterRow, lang.hitch(this, "_listMouseover")),

                // Handle selection of the select all option.
                this.selectAll.on("click", lang.hitch(this, "_selectAllSelected")),
                // Handle key events on the default option in order to manage moving focus.
                this.selectAll.on("keypress", lang.hitch(this, "_selectAllKeypress")),
                // Handle mouse over events on the default option in order to manage moving focus.
                this.selectAll.on("mouseover", lang.hitch(this, "_selectAllMouseover"))
            );

            if (this.enableSelectAll) {
                // Override the default handler for HOME key event since we don't want to execute the default handler when defaultvalue is enabled.
                this.list.keyMap[keys.HOME] = lang.hitch(this, "_listNavigateHome");
            } else {
                domClass.add(this.selectAll.domNode, "dijitHidden");
            }

            this.selectAll.set({
                iconClass: "dijitCheckBoxIcon",
                label: entities.encode(this.selectAllText),
                title: this.selectAllText
            });
        },

        startup: function () {
            // summary:
            //      Processing after the widget and its children have been created and
            //      added to the DOM. Setup the initial query and store for the list.
            // tags:
            //      protected
            if (this._started) {
                return;
            }
            this.inherited(arguments);

            this.list.startup();
            this.list.set("store", this.store);
        },

        focus: function () {
            // summary:
            //      Override the default focus handling and set the focus to either the default options or the list
            // tags:
            //      public
            if (this.enableSelectAll) {
                this.selectAll.focus();
            } else {
                this.list.focus();
            }
        },

        resize: function () {
            // summary:
            //      Resize the version selector and its children.
            // tags:
            //      public
            this.inherited(arguments);
            this.list.resize();
        },

        renderRow: function (item, options) {
            // summary:
            //      Render row callback
            // tags:
            //      protected, virtual

            var selector = put("div.epi-selector-list__type-wrapper", put("span.dijit.dijitReset.dijitInline.dijitCheckBox"));
            var label = put("label.epi-selector-list__title.dojoxEllipsis", "span", {title: item.label, textContent: item.label});
            return put("div", [selector, label]);

        },

        refresh: function () {
            // summary:
            //      Refreshes the version selector to ensure the data displayed is up to date.
            // tags:
            //      public

            if (!this._started) {
                return;
            }

            return this.list.refresh();
        },

        _setConnectorVisibleAttr: function (value) {
            this.inherited(arguments);
            this._set("connectorVisible", value);
            this.connectorNode.classList.toggle("dijitHidden", !value);
        },

        _itemsSelected: function (e) {
            // summary:
            //      Extracts the version information and emits a change event.
            // tags:
            //      private

            var selection = [];
            Object.keys(e.grid.selection).forEach(function (key) {
                selection.push(key);
            });

            if (!epi.areEqual(selection, this.get("selectedItems"))) {
                this.set("selectedItems", selection, true);
                this.emit("change", { value: selection });
            }

            this._updateView();
        },

        _refreshComplete: function (evt) {
            // summary:
            //      Selects the current version and marks the marked version when a refresh occurs.
            // tags:
            //      private

            when(evt.results.total, lang.hitch(this, function (total) {
                this.emit("loaded");

                domClass.toggle(this.separatorNode, "dijitHidden", !total || !this.enableSelectAll);
            }));
        },

        _selectAllSelected: function () {
            // summary:
            //      The callback method for when the default option is selected. Set the
            //      selected items to null.
            // tags:
            //      private
            this.set("selectedItems", null);
        },

        _selectAllKeypress: function (e) {
            // summary;
            //      Event handler for key presses on the select all to take care of moving focus to the list.
            // tags:
            //      private
            var method;

            switch (e.keyCode) {
                case keys.DOWN_ARROW:
                    method = Keyboard.moveFocusHome;
                    break;
                case keys.PAGE_DOWN:
                    method = Keyboard.moveFocusPageDown;
                    break;
                case keys.END:
                    method = Keyboard.moveFocusEnd;
                    break;
                default:
                    return;
            }

            // Apply the correct method to the list giving the event as argument.
            method.apply(this.list, [e]);
        },

        _selectAllMouseover: function () {
            // summary:
            //      Event handler for mouse over on the select all
            //      to take care of moving focus to the button.
            // tags:
            //      private
            this.selectAll.focus();
        },

        _listNavigateUp: function (e) {
            // summary;
            //      Event handler for page up and arrow up key presses on the list to take care of
            //      moving focus to the select all when the first row is selected in the list.
            // tags:
            //      private
            var list = this.list,
                row = list.row(e),
                previousRow = list.up(row, 1, true);

            // If row and previous row are the same then the first row is selected.
            if (row.id === previousRow.id) {
                this.selectAll.focus();
            }
        },

        _listNavigateHome: function () {
            // summary:
            //      Event handler for a HOME key press on the list to take care of moving
            //      focus to the select all.
            // tags:
            //      private
            this.selectAll.focus();
        },

        _listMouseover: function (e) {
            // summary:
            //      Event handler for mouse over on the list to take care
            //      of moving focus to the hovered list item.
            // tags:
            //      private
            var row = this.list.row(e);
            this.list.focus(row);
        },

        _setSelectedItemsAttr: function (selectedItems, internal) {
            // summary:
            //      Sets the selected items and ensures the UI is in the correct state.
            // tags:
            //      protected
            this._set("selectedItems", selectedItems);

            // Clear the value regardless if there is a value or not. This ensures we don't
            // end up with multiple items selected.
            if (!internal) {
                this.list.clearSelection();
                if (selectedItems) {
                    selectedItems.forEach(function (item) {
                        this.list.select(item);
                    }.bind(this));
                }
            }

            this._updateView();
        },

        _updateView: function () {
            // summary:
            //      Updates the view to ensure it matches the current model state.
            // tags:
            //      private

            // The select all should be checked if there is no selected items.
            this.selectAll.set("checked", !this.selectedItems || this.selectedItems.length === 0);
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/CheckboxList.html':"<div class=\"epi-selector-list epi-menu--inverted\">\r\n    <div class=\"epi-menuInverted epi-invertedTooltip\">\r\n        <div class=\"epi-tooltipDialogTop\">\r\n            <span data-dojo-attach-point=\"headerNode\"></span><div data-dojo-attach-point=\"connectorNode\" class=\"dijitTooltipConnector\"></div>\r\n        </div>\r\n        <button class=\"epi-selector-list-btn epi-chromeless\" data-dojo-attach-point=\"selectAll\" data-dojo-type=\"dijit/form/ToggleButton\" data-dojo-props=\"iconClass:'dijitcheckboxicon'\"></button>\r\n        <div data-dojo-attach-point=\"separatorNode\" class=\"epi-selector-list__separator dijitHidden\"></div>\r\n        <div data-dojo-attach-point=\"listNode\"></div>\r\n    </div>\r\n</div>\r\n",
'url:epi-cms/content-approval/templates/ApprovalStep.html':"<div class=\"epi-approval-step\">\r\n    <div class=\"epi-approval-step__header\">\r\n        <div class=\"dijitInline dojoDndHandle\">\r\n            <span class=\"dijitInline epi-iconDnD\"></span>\r\n        </div>\r\n        <div placeholder=\"${resources.header.placeholder}\" title=\"${resources.header.tooltip}\" data-dojo-attach-point=\"headerTextbox\" data-dojo-type=\"dijit/form/TextBox\"></div>\r\n        <div class=\"dijitInline\" data-dojo-attach-point=\"removeNode\"></div>\r\n    </div>\r\n    <div class=\"epi-approval-step__container\">\r\n        <div data-dojo-attach-point=\"listNode\"></div>\r\n        <div class=\"epi-reviewer__add\">\r\n            <span class=\"dijitInline dijitIcon epi-iconUser\"></span>\r\n            <div class=\"dijitInline\" data-dojo-attach-point=\"searchNode\"></div>\r\n        </div>\r\n    </div>\r\n    <div class=\"epi-approval-step__add-step\" data-dojo-attach-point=\"arrowNode\"></div>\r\n</div>\r\n",
'dgrid/extensions/DnD':function(){
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojo/_base/Deferred",
	"dojo/aspect",
	"dojo/on",
	"dojo/topic",
	"dojo/has",
	"dojo/dnd/Source",
	"dojo/dnd/Manager",
	"dojo/_base/NodeList",
	"put-selector/put",
	"../Selection",
	"dojo/has!touch?../util/touch",
	"dojo/has!touch?./_DnD-touch-autoscroll",
	"xstyle/css!dojo/resources/dnd.css"
], function(declare, lang, arrayUtil, Deferred, aspect, on, topic, has, DnDSource, DnDManager, NodeList, put, Selection, touchUtil){
	// Requirements
	// * requires a store (sounds obvious, but not all Lists/Grids have stores...)
	// * must support options.before in put calls
	//   (if undefined, put at end)
	// * should support copy
	//   (copy should also support options.before as above)
	
	// TODOs
	// * consider sending items rather than nodes to onDropExternal/Internal
	// * consider emitting store errors via OnDemandList._trackError
	
	var GridDnDSource = declare(DnDSource, {
		grid: null,
		
		getObject: function(node){
			// summary:
			//		getObject is a method which should be defined on any source intending
			//		on interfacing with dgrid DnD.
			
			var grid = this.grid;
			// Extract item id from row node id (gridID-row-*).
			return grid.store.get(node.id.slice(grid.id.length + 5));
		},
		_legalMouseDown: function(evt){
			// Fix _legalMouseDown to only allow starting drag from an item
			// (not from bodyNode outside contentNode).
			var legal = this.inherited(arguments);
			return legal && evt.target != this.grid.bodyNode;
		},

		// DnD method overrides
		onDrop: function(sourceSource, nodes, copy){
			var targetSource = this,
				targetRow = this._targetAnchor = this.targetAnchor, // save for Internal
				grid = this.grid,
				store = grid.store;
			
			if(!this.before && targetRow){
				// target before next node if dropped within bottom half of this node
				// (unless there's no node to target at all)
				targetRow = targetRow.nextSibling;
			}
			targetRow = targetRow && grid.row(targetRow);
			
			Deferred.when(targetRow && store.get(targetRow.id), function(target){
				// Note: if dropping after the last row, or into an empty grid,
				// target will be undefined.  Thus, it is important for store to place
				// item last in order if options.before is undefined.
				
				// Delegate to onDropInternal or onDropExternal for rest of logic.
				// These are passed the target item as an additional argument.
				if(targetSource != sourceSource){
					targetSource.onDropExternal(sourceSource, nodes, copy, target);
				}else{
					targetSource.onDropInternal(nodes, copy, target);
				}
			});
		},
		onDropInternal: function(nodes, copy, targetItem){
			var grid = this.grid,
				store = grid.store,
				targetSource = this,
				anchor = targetSource._targetAnchor,
				targetRow,
				nodeRow;
			
			if(anchor){ // (falsy if drop occurred in empty space after rows)
				targetRow = this.before ? anchor.previousSibling : anchor.nextSibling;
			}
			
			// Don't bother continuing if the drop is really not moving anything.
			// (Don't need to worry about edge first/last cases since dropping
			// directly on self doesn't fire onDrop, but we do have to worry about
			// dropping last node into empty space beyond rendered rows.)
			nodeRow = grid.row(nodes[0]);
			if(!copy && (targetRow === nodes[0] ||
					(!targetItem && nodeRow && grid.down(nodeRow).element == nodes[0]))){
				return;
			}
			
			nodes.forEach(function(node){
				Deferred.when(targetSource.getObject(node), function(object){
					var id = store.getIdentity(object);
					
					// For copy DnD operations, copy object, if supported by store;
					// otherwise settle for put anyway.
					// (put will relocate an existing item with the same id, i.e. move).
					store[copy && store.copy ? "copy" : "put"](object, {
						before: targetItem
					});
					
					// Self-drops won't cause the dgrid-select handler to re-fire,
					// so update the cached node manually
					if(targetSource._selectedNodes[id]){
						targetSource._selectedNodes[id] = grid.row(id).element;
					}
				});
			});
		},
		onDropExternal: function(sourceSource, nodes, copy, targetItem){
			// Note: this default implementation expects that two grids do not
			// share the same store.  There may be more ideal implementations in the
			// case of two grids using the same store (perhaps differentiated by
			// query), dragging to each other.
			var store = this.grid.store,
				sourceGrid = sourceSource.grid;
			
			// TODO: bail out if sourceSource.getObject isn't defined?
			nodes.forEach(function(node, i){
				Deferred.when(sourceSource.getObject(node), function(object){
					if(!copy){
						if(sourceGrid){
							// Remove original in the case of inter-grid move.
							// (Also ensure dnd source is cleaned up properly)
							Deferred.when(sourceGrid.store.getIdentity(object), function(id){
								!i && sourceSource.selectNone(); // deselect all, one time
								sourceSource.delItem(node.id);
								sourceGrid.store.remove(id);
							});
						}else{
							sourceSource.deleteSelectedNodes();
						}
					}
					// Copy object, if supported by store; otherwise settle for put
					// (put will relocate an existing item with the same id).
					// Note that we use store.copy if available even for non-copy dnd:
					// since this coming from another dnd source, always behave as if
					// it is a new store item if possible, rather than replacing existing.
					store[store.copy ? "copy" : "put"](object, {
						before: targetItem
					});
				});
			});
		},
		
		onDndStart: function(source, nodes, copy){
			// Listen for start events to apply style change to avatar.
			
			this.inherited(arguments); // DnDSource.prototype.onDndStart.apply(this, arguments);
			if(source == this){
				// If TouchScroll is in use, cancel any pending scroll operation.
				if(this.grid.cancelTouchScroll){ this.grid.cancelTouchScroll(); }
				
				// Set avatar width to half the grid's width.
				// Kind of a naive default, but prevents ridiculously wide avatars.
				DnDManager.manager().avatar.node.style.width =
					this.grid.domNode.offsetWidth / 2 + "px";
			}
		},
		
		onMouseDown: function(evt){
			// Cancel the drag operation on presence of more than one contact point.
			// (This check will evaluate to false under non-touch circumstances.)
			if(has("touch") && this.isDragging &&
					touchUtil.countCurrentTouches(evt, this.grid.touchNode) > 1){
				topic.publish("/dnd/cancel");
				DnDManager.manager().stopDrag();
			}else{
				this.inherited(arguments);
			}
		},
		
		onMouseMove: function(evt){
			// If we're handling touchmove, only respond to single-contact events.
			if(!has("touch") || touchUtil.countCurrentTouches(evt, this.grid.touchNode) <= 1){
				this.inherited(arguments);
			}
		},
		
		checkAcceptance: function(source, nodes){
			// Augment checkAcceptance to block drops from sources without getObject.
			return source.getObject &&
				DnDSource.prototype.checkAcceptance.apply(this, arguments);
		},
		getSelectedNodes: function(){
			// If dgrid's Selection mixin is in use, synchronize with it, using a
			// map of node references (updated on dgrid-[de]select events).
			
			if(!this.grid.selection){
				return this.inherited(arguments);
			}
			var t = new NodeList(),
				id;
			for(id in this.grid.selection){
				t.push(this._selectedNodes[id]);
			}
			return t;	// NodeList
		}
		// TODO: could potentially also implement copyState to jive with default
		// onDrop* implementations (checking whether store.copy is available);
		// not doing that just yet until we're sure about default impl.
	});
	
	// Mix in Selection for more resilient dnd handling, particularly when part
	// of the selection is scrolled out of view and unrendered (which we
	// handle below).
	var DnD = declare(Selection, {
		// dndSourceType: String
		//		Specifies the type which will be set for DnD items in the grid,
		//		as well as what will be accepted by it by default.
		dndSourceType: "dgrid-row",
		
		// dndParams: Object
		//		Object containing params to be passed to the DnD Source constructor.
		dndParams: null,
		
		// dndConstructor: Function
		//		Constructor from which to instantiate the DnD Source.
		//		Defaults to the GridSource constructor defined/exposed by this module.
		dndConstructor: GridDnDSource,
		
		postMixInProperties: function(){
			this.inherited(arguments);
			// ensure dndParams is initialized
			this.dndParams = lang.mixin({ accept: [this.dndSourceType] }, this.dndParams);
		},
		
		postCreate: function(){
			this.inherited(arguments);
			
			// Make the grid's content a DnD source/target.
			this.dndSource = new (this.dndConstructor || GridDnDSource)(
				this.bodyNode,
				lang.mixin(this.dndParams, {
					// add cross-reference to grid for potential use in inter-grid drop logic
					grid: this,
					dropParent: this.contentNode
				})
			);
			
			// Set up select/deselect handlers to maintain references, in case selected
			// rows are scrolled out of view and unrendered, but then dragged.
			var selectedNodes = this.dndSource._selectedNodes = {};
			
			function selectRow(row){
				selectedNodes[row.id] = row.element;
			}
			function deselectRow(row){
				delete selectedNodes[row.id];
				// Re-sync dojo/dnd UI classes based on deselection
				// (unfortunately there is no good programmatic hook for this)
				put(row.element, '!dojoDndItemSelected!dojoDndItemAnchor');
			}
			
			this.on("dgrid-select", function(event){
				arrayUtil.forEach(event.rows, selectRow);
			});
			this.on("dgrid-deselect", function(event){
				arrayUtil.forEach(event.rows, deselectRow);
			});
			
			aspect.after(this, "destroy", function(){
				delete this.dndSource._selectedNodes;
				selectedNodes = null;
				this.dndSource.destroy();
			}, true);
		},
		
		insertRow: function(object){
			// override to add dojoDndItem class to make the rows draggable
			var row = this.inherited(arguments),
				type = typeof this.getObjectDndType == "function" ?
					this.getObjectDndType(object) : [this.dndSourceType];
			
			put(row, ".dojoDndItem");
			this.dndSource.setItem(row.id, {
				data: object,
				type: type instanceof Array ? type : [type]
			});
			return row;
		},
		
		removeRow: function (rowElement) {
			this.dndSource.delItem(this.row(rowElement));
			this.inherited(arguments);
		}
	});
	DnD.GridSource = GridDnDSource;
	
	return DnD;
});

},
'url:epi-cms/content-approval/templates/ApprovalStepList.html':"<div class=\"epi-approval-step-list\">\r\n    <div class=\"epi-approval-step-list__status\">\r\n        <span class=\"epi-approval-step-list__status-icon epi-approval-step-list__status-icon--review\"></span><h2 class=\"dijitInline\">${resources.readytoreview}</h2>\r\n    </div>\r\n    <div data-dojo-attach-point=\"listNode\"></div>\r\n\r\n    <div class=\"epi-approval-step-list__status\">\r\n        <span class=\"epi-approval-step-list__status-icon epi-approval-step-list__status-icon--publish\"></span><h2 class=\"dijitInline\">${resources.readytopublish}</h2>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/ContentDetails':function(){
define([
// Dojo
    "dojo",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/url",
    "dojo/_base/window",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/on",
    "dojo/topic",

    // Dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",

    // EPi
    "epi",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/command/builder/MenuBuilder",
    "epi/shell/command/builder/MenuAssembler",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.contentdetails",
    "dojo/text!./templates/ContentDetails.html"

], function (
// Dojo
    dojo,
    array,
    declare,
    lang,
    url,
    win,
    domStyle,
    domConstruct,
    on,
    topic,

    // Dijit
    _TemplatedMixin,
    _WidgetBase,
    _WidgetsInTemplateMixin,

    // EPi
    epi,
    _ModelBindingMixin,
    MenuBuilder,
    MenuAssembler,

    // Resources
    res,
    template
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      Displays extra information about the page. This information includes
        //      page type, ID, created date, changed date and who made the changes.
        //
        // tags:
        //      internal

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: template,

        // Attributes and mappings
        _setContentTypeNameAttr: function (value) {
            this.typeNode.textContent = value;
            this.typeNode.title  = value;
        },

        _setContentIdAttr: { node: "idNode", type: "innerHTML" },

        _setExistingLanguagesAttr: function (languages) {
            this.languagesNode.innerHTML = "";

            // Create text or link elements base on language information.
            array.forEach(languages, function (item, idx) {
                var elm, isLast = idx === languages.length - 1;
                if (item.isCurrentLanguage) {
                    elm = domConstruct.create("span", {
                        innerHTML: item.urlSegment
                    });
                } else {
                    var url = new dojo._Url(window.top.location.href);
                    elm = domConstruct.create("a", {
                        innerHTML: item.urlSegment,
                        href: [url.scheme, "://", url.authority, url.path, "?language=", item.text, "#context=epi.cms.contentdata:///", item.contentLink].join(""),
                        "class": "epi-visibleLink"
                    });
                }
                domConstruct.place(elm, this.languagesNode);

                if (!isLast) {
                    domConstruct.place(win.doc.createTextNode(", "), this.languagesNode);
                }
            }, this);
        },

        _setVisibleToAttr: function (visibleToEveryOne) {
            this.visibleToNode.innerHTML = visibleToEveryOne ? res.visibleto.everyone : res.visibleto.restricted;
        },

        _setManageAccessRightsVisibleAttr: function (value) {
            domStyle.set(this.manageAccessRightsButton.domNode, "display", value ? "" : "none");
        },

        // resources: [readonly] Object
        //		The localization resource for the label headers.
        resources: null,

        modelBindingMap: {
            contentTypeName: ["contentTypeName"],
            contentId: ["contentId"],
            existingLanguages: ["existingLanguages"],
            visibleToEveryOne: ["visibleTo"]
        },

        _menuAssembler: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.resources = dojo.mixin({}, epi.resources.action, res);
        },

        postCreate: function () {
            this.inherited(arguments);

            var builder = new MenuBuilder();
            this._menuAssembler = new MenuAssembler({ configuration: [{ builder: builder, target: this.additionalActionsMenu }], commandSource: this.model });

            this.dropdownButton.set("title", this.resources.toolsbutton.tooltip);
        },

        destroy: function () {
            if (this._menuAssembler) {
                this._menuAssembler.destroy();
            }

            this.inherited(arguments);

            if (this.model) {
                this.model.destroy();
            }
        },

        _setModelAttr: function (value) {

            this.inherited(arguments);

            if (this._menuAssembler) {
                this._menuAssembler.set("commandSource", this.model);
            }

            if (this.model && this.model.accessRightsCommand) {
                this.own(this.model.accessRightsCommand.watch("canExecute", lang.hitch(this, function () {
                    // Manage links visibility
                    this.set("manageAccessRightsVisible", this.model.accessRightsCommand.canExecute);
                })));
            }
        },

        _onManageAccessRightsClick: function () {
            if (this.model && this.model.accessRightsCommand) {
                this.model.accessRightsCommand.execute();
            }
        }
    });
});

},
'url:epi-cms/contentediting/templates/ContentDetails.html':"﻿<ul class=\"epi-form-container__section\">\r\n    <ul data-dojo-type=\"epi/shell/layout/SimpleContainer\" data-dojo-attach-point=\"widgetContainer\"></ul>\r\n    <li class=\"epi-form-container__section__row\">\r\n        <label>${resources.visibleto.title}</label>\r\n        <div class=\"epi-previewableTextBox-wrapper dijitInline\">\r\n            <span data-dojo-attach-point=\"visibleToNode\" class=\"epi-previewableTextBox-text dojoxEllipsis dijitInline\"></span>\r\n            <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"manageAccessRightsButton\" data-dojo-attach-event=\"onClick: _onManageAccessRightsClick\" class=\"epi-chromelessButton epi-chromelessLinkButton epi-functionLink epi-valign--top\">${resources.manage}</div>\r\n        </div>\r\n    </li>\r\n    <li class=\"epi-form-container__section__row\">\r\n        <label>${resources.existinglanguages}</label>\r\n        <span data-dojo-attach-point=\"languagesNode\" class=\"epi-previewableTextBox-text dijitInline\"></span>\r\n    </li>\r\n    <li class=\"epi-form-container__section__row\">\r\n        <label>${resources.idandtypename}</label>\r\n        <div class=\"epi-previewableTextBox-wrapper dijitInline\">\r\n            <span class=\"epi-previewableTextBox-text dojoxEllipsis dijitInline\">\r\n                <span data-dojo-attach-point=\"idNode\"></span>, <span data-dojo-attach-point=\"typeNode\"></span>\r\n            </span>\r\n        </div>\r\n    </li>\r\n    <li class=\"epi-form-container__section__row\">\r\n        <label></label>\r\n        <div data-dojo-attach-point=\"dropdownButton\" data-dojo-type=\"dijit/form/DropDownButton\" class=\"dijit dijitReset dijitInline epi-mediumButton\">\r\n            <span>${resources.toolsbutton.label}</span>\r\n            <div data-dojo-type=\"dijit/DropDownMenu\" data-dojo-attach-point=\"additionalActionsMenu\"></div>\r\n        </div>\r\n    </li>\r\n</ul>",
'epi-cms/contentediting/ContentPreview':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/_View"
], function (declare, _View) {

    return declare([_View], {
        // tags:
        //      internal

        noPreview: true,

        constructor: function () {
            this.defaultQueryParameters = {};
        },

        startup: function () {
            this.inherited(arguments);

            this.overlay.set("enabled", true);

            this.iframeWithOverlay.set("previewClass", "epi-editorViewport-preview--previewing");
        },

        destroy: function () {
            this.iframeWithOverlay.set("previewClass", "");

            this.inherited(arguments);
        }
    });
});

},
'epi-cms/contentediting/CreateContent':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/topic",
    "dojo/when",

    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/form/ValidationTextBox",

    "dijit/layout/_LayoutWidget",
    "dijit/layout/BorderContainer",
    "dijit/layout/ContentPane",
    "dijit/layout/StackContainer",

    // epi
    "epi/dependency",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/DialogService",

    "epi-cms/contentediting/NewContentNameInputDialog",

    "epi-cms/contentediting/viewmodel/CreateContentViewModel",

    "epi-cms/widget/ContentTypeList",
    "epi-cms/widget/PropertiesForm",
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",

    // resources
    "dojo/text!./templates/CreateContent.html",
    "epi/i18n!epi/nls/episerver.shared"
],

function (
// dojo
    declare,
    lang,
    aspect,
    domStyle,
    domClass,
    topic,
    when,

    // dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    ValidationTextBox,

    _LayoutWidget,
    BorderContainer,
    ContentPane,
    StackContainer,

    // epi
    dependency,
    _ModelBindingMixin,
    dialogService,

    NewContentNameInputDialog,

    CreateContentViewModel,

    ContentTypeList,
    PropertiesForm,
    BreadCrumbs,
    BreadcrumbCurrentItem,

    // resources
    template,
    sharedResources
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      A stack container that acts as a content creation wizard.
        // description:
        //      A wizard-like widget that is responsible for showing the widget for
        //      selecting a content type, then determines whether content editing or the
        //      mandatory fields editor is displayed.
        // tags:
        //      internal

        templateString: template,
        sharedResources: sharedResources,

        modelType: CreateContentViewModel,

        // _contextService: [private] epi/shell/ContextService
        _contextService: null,

        // _beingSuspended: [private] boolean
        //      Indicate that the component is being suspended and another view component is being requested.
        _beingSuspended: null,

        modelBindingMap: {
            parent: ["parent"],
            requestedType: ["requestedType"],
            metadata: ["metadata"],
            isContentTypeSelected: ["isContentTypeSelected"],

            headingText: ["headingText"],
            createAsLocalAssetHelpText: ["createAsLocalAssetHelpText"],
            contentName: ["contentName"],
            contentNameHelpText: ["contentNameHelpText"],
            wizardStep: ["wizardStep"],
            showAllProperties: ["showAllProperties"],
            createAsLocalAsset: ["createAsLocalAsset"],

            seamlessTopPanel: ["seamlessTopPanel"],
            namePanelIsVisible: ["namePanelIsVisible"],
            headingPanelIsVisible: ["headingPanelIsVisible"],
            saveButtonIsVisible: ["saveButtonIsVisible"],
            saveButtonDisabled: ["saveButtonDisabled"],
            showCurrentNodeOnBreadcrumb: ["showCurrentNodeOnBreadcrumb"],
            notificationContext: ["notificationContext"],
            actualParentLink: ["actualParentLink"],
            propertyFilter: ["propertyFilter"],
            allowedTypes: ["allowedTypes"],
            restrictedTypes: ["restrictedTypes"]
        },

        // Setters
        _setParentAttr: function (parent) {
            // summary:
            //      set parent attribute
            // tags:
            //      private

            if (parent) {
                this.toolbar.setItemProperty("currentcontent", "currentItemInfo", {
                    name: parent.name,
                    dataType: parent.typeIdentifier
                });
            }
        },

        _setPropertyFilterAttr: function (propertyFilter) {
            // summary:
            //      Set the property filter used when building the property form
            // tags:
            //      private

            this._set("propertyFilter", propertyFilter);
            this.propertiesForm.propertyFilter = propertyFilter;
        },

        _setAllowedTypesAttr: function (value) {
            // summary:
            //      set the allowed types
            // tags:
            //      private

            this.contentTypeList.set("allowedTypes", value);
        },

        _setRestrictedTypesAttr: function (value) {
            // summary:
            //      set the restricted types
            // tags:
            //      private

            this.contentTypeList.set("restrictedTypes", value);
        },

        _setRequestedTypeAttr: function (requestType) {
            // summary:
            //      set requested type attribute
            // tags:
            //      private

            this.contentTypeList.set("requestedType", requestType);
        },

        _setMetadataAttr: function (metadata) {
            // summary:
            //      set metadata attribute
            // tags:
            //      private

            if (metadata) {
                this.propertiesForm.set("metadata", metadata);
            }
        },

        _setHeadingTextAttr: function (headingText) {
            // summary:
            //      set heading text attribute
            // tags:
            //      private

            this.headingTextNode.textContent = this.subHeadingTextNode.textContent = headingText;
        },

        _setContentNameHelpTextAttr: {
            // summary:
            //      Setter for setting the help text next to the name input
            // tags:
            //      private
            node: "contentNameHelpTextNode",
            type: "innerText"
        },

        _setCreateAsLocalAssetAttr: function (/*Boolean*/createAsLocalAsset) {
            // summary:
            //      Reset breadcrumb in case createAsLocalAsset had updated its value
            // createAsLocalAsset: [Boolean]
            //      TRUE if a new content will be create as a local asset
            // tags:
            //      private

            this._set("createAsLocalAsset", createAsLocalAsset);

            var parent = this.model.get("parent");
            if (parent) {
                this.toolbar.setItemProperty("breadcrumbs", "contentLink", createAsLocalAsset ? parent.assetsFolderLink : parent.contentLink);
            }

            this.contentTypeList.set("localAsset", createAsLocalAsset);
        },

        _setCreateAsLocalAssetHelpTextAttr: {
            // summary:
            //      set sub heading's help text
            // tags:
            //      private

            node: "subHeadingDescNode",
            type: "innerHTML"
        },

        _setContentNameAttr: function (contentName) {
            // summary:
            //      set content name attribute
            // tags:
            //      private

            this.nameTextBox.set("value", contentName);
        },

        _setWizardStepAttr: function (wizardStep) {
            // summary:
            //      set wizard step attribute
            // tags:
            //      private

            // NOTE: this check should probably be done in the viewmodel, but we have no
            // value there that tells us how many wizard steps are available. This check
            // ensures we don't try to select outside the bounds

            var children;
            var child;

            if (wizardStep < 0 || wizardStep === this.wizardStep) {
                return;
            }

            children = this.stackContainer.getChildren();

            if (wizardStep < children.length) {

                child = children[wizardStep];

                this.stackContainer.selectChild(child);
                this._set("wizardStep", wizardStep);
            }
        },

        _setShowAllPropertiesAttr: function (showAllProperties) {
            // summary:
            //      set show all properties attribute
            // tags:
            //      private

            this._set("showAllProperties", showAllProperties);
            this.propertiesForm.set("showAllProperties", showAllProperties);
        },

        _setSeamlessTopPanelAttr: function (value) {
            // summary:
            //      set whether the top panel should show seamlessly.
            // tags:
            //      private

            domClass.toggle(this.topPanel.domNode, "epi-listingTopContainer", value);
        },

        _setNamePanelIsVisibleAttr: function (isVisible) {
            // summary:
            //      set name panel visibility
            // tags:
            //      private

            domStyle.set(this.namePanel, "display", isVisible ? "" : "none");
        },

        _setHeadingPanelIsVisibleAttr: function (isVisible) {
            // summary:
            //      set heading panel visibility
            // description:
            //      If the heading panel is visible, the sub heading panel will be invisible and vice versa.
            // tags:
            //      private

            domStyle.set(this.headingPanel, "display", isVisible ? "" : "none");
            domStyle.set(this.subHeadingPanel, "display", isVisible ? "none" : "");
        },

        _setSaveButtonIsVisibleAttr: function (isVisible) {
            // summary:
            //      set save button visibility
            // tags:
            //      private

            this.toolbar.setItemVisibility("saveButton", isVisible);
        },

        _setSaveButtonDisabledAttr: function (disabled) {
            // summary:
            //      set save button visibility
            // tags:
            //      private

            this.toolbar.setItemProperty("saveButton", "disabled", disabled);
        },

        _setShowCurrentNodeOnBreadcrumbAttr: function (show) {
            // summary:
            //      set whether the breadcrumd should display the current content node.
            // description:
            //      If the current content node is displayed, content name label in the heading is not and vice versa
            // tags:
            //      private

            this.toolbar.setItemProperty("breadcrumbs", "showCurrentNode", show);
            this.toolbar.setItemVisibility("currentcontent", !show);
        },

        _setNotificationContextAttr: function (context) {
            // summary:
            //      set context on the notification center
            // context: Object
            //      The notification context
            // tags:
            //      private

            this.toolbar.setItemProperty("notificationCenter", "notificationContext", context);
        },

        _setActualParentLinkAttr: function (parentLink) {
            // summary:
            //      set actual parent link
            // tags:
            //      private

            this.contentTypeList.set("parentLink", parentLink);
        },

        _setContentTypeNameAttr: {
            type: "innerHTML",
            node: "contentTypeNameNode"
        },

        postMixInProperties: function () {
            // summary:
            //      Post properties mixin handler.
            // description:
            //		Set up model and resource for template binding.
            // tags:
            //		protected

            this.inherited(arguments);

            this.model = new this.modelType();

            this.own(this.model.on("saveSuccess", lang.hitch(this, this._onSaveSuccess)));
            this.own(this.model.on("saveError", lang.hitch(this, this._onSaveError)));
            this.own(this.model.on("invalidContentName", lang.hitch(this, this._onInvalidContentName)));
        },

        postCreate: function () {
            // summary:
            //		Post widget creation handler.
            // description:
            //      Set up local toolbar
            // tags:
            //		protected

            this.inherited(arguments);

            this._contextService = this._contextService || dependency.resolve("epi.shell.ContextService");

            this._setupToolbar();
        },

        layout: function () {
            // summary:
            //      Layout the widget
            // description:
            //      Set the widget's size to the top layout container
            // tags:
            //    protected

            if (this._started) {
                this.layoutContainer.resize(this._containerContentBox || this._contentBox);
                domClass.add(this.stackContainer.domNode, "epi-animation-node-reset");
            }
        },

        updateView: function (data) {
            // summary:
            //      Update the current view with new data from the main widget switcher.
            // data: Object
            //      The settings data. The data requires parent and requestedType property in order to update the view
            // tags:
            //    public

            // content can only be created when it has parent and requestedType (when creating via New Page, Block buttons)
            // or content can be created when it has contentData and languageBranch (when creating via Translate notification)
            // if incoming data doesn't have parent and requestedType then no need to update the view & model.

            // WidgetSwitcher calls the updateView when a context change occurs or when a view change happens. If the view change is initiated by the NewContent command then the required information is supplied.
            // but on a context change the required information is not being supplied correctly.
            if (data && ((data.parent && data.requestedType) || (data.contentData && data.languageBranch))) {

                this.view = data.view;
                this._setCreateMode();
                this._beingSuspended = false;

                // TODO: Incorporate content type list with model and use data binding.
                this.set("contentTypeName", "");

                when(this.model.update(data), lang.hitch(this, function () {
                    this.layout();

                    //We want the name text box to have focus and the content selected when the view has loaded
                    if (this.nameTextBox) {
                        this.nameTextBox.focus();
                        this.nameTextBox.textbox.select();
                    }

                }), function (err) {
                    console.log(err);
                });
            }
        },

        _onSaveSuccess: function (result) {
            // summary:
            //    Handle save success event from the model.
            //
            // tags:
            //    private

            this._clearCreateMode();

            this._beingSuspended = true;

            if (result.changeContext) {
                this._changeContext(result.newContentLink);
            } else {
                this._backToCurrentContext();
            }

            if (this.createAsLocalAsset === true) {
                topic.publish("/epi/cms/action/createlocalasset");
            }
        },

        _onSaveError: function () {
            // summary:
            //    Handle save error event from the model.
            //
            // tags:
            //    private

            this._clearCreateMode();

            topic.publish("/epi/cms/action/showerror");
        },

        _onInvalidContentName: function (defaultName) {
            // summary:
            //    Handle invalid content name event from the model.
            //
            // tags:
            //    private

            var contentNameInput = new NewContentNameInputDialog({ defaultContentName: defaultName });

            dialogService.dialog({
                defaultActionsVisible: false,
                autofocus: true,
                content: contentNameInput,
                title: contentNameInput.title
            }).then(function () {
                var name = contentNameInput.get("value");
                if (name === defaultName) {
                    this.model.set("ignoreDefaultNameWarning", true);
                }
                this.model.set("contentName", name);
                this.model.save();
            }.bind(this)).otherwise(function () {
                if (this.contentTypeList.shouldSkipContentTypeSelection) {
                    this._cancel();
                } else {
                    this.model.set("isContentTypeSelected", false);
                }
            }.bind(this));
        },

        _onContentTypeSelected: function (item) {
            // summary:
            //    Handle content type selected event from the content type list widget.
            //
            // tags:
            //    private

            if (!this.isContentTypeSelected) {
                this.model.set("contentTypeId", item.id);

                this.set("contentTypeName", item.localizedName);
            }
        },

        _onPropertyValidStateChange: function (property, error) {
            // summary:
            //      Handle property validity change event from the properties form widget.
            // property: String
            //      The property name
            // error: String
            //      The error message
            // tags:
            //    private

            if (error) {
                this.model.addInvalidProperty(property, error);
            } else {
                this.model.removeInvalidProperty(property);
            }
        },

        _onBlurVerifyContent: function () {
            // summary:
            //    check if the textfield content is empty on blur,
            //    set to default value if it is.
            //
            // tags:
            //    private
            if (this.nameTextBox.get("value") === "") {
                this.nameTextBox.set("value", this.model.defaultName);
            }
        },

        _onContentNameChange: function (name) {
            // summary:
            //    Handle change event from the content name textbox.
            //
            // tags:
            //    private

            this.model.set("contentName", name);
        },

        _onSave: function () {
            // summary:
            //    Handle action of the save button.
            //
            // tags:
            //    private

            if (this._beingSuspended) {
                return;
            }

            // the onChange event is triggered just before _onSave as an aspect and for slower machines
            // there is a chance that save will be executed before new ContentName will be assigned
            this._onContentNameChange(this.nameTextBox.get("value"));

            // Kick off the client validation. Validation result will be handled by the model later on.
            this.propertiesForm.validate();

            this.model.set("properties", this.propertiesForm.get("value"));
            this.model.save();
        },

        _onCancel: function () {
            // summary:
            //    Handle action of the cancel button.
            //
            // tags:
            //    private

            this._cancel();
        },

        _cancel: function () {
            this._clearCreateMode();

            this.model.cancel();
            this._backToCurrentContext();
            this._setCreateAsLocalAssetAttr(false);
        },

        _setupToolbar: function () {
            // summary:
            //    Set up the local toolbar.
            //
            // tags:
            //    private

            var toolbarGroups = [{
                name: "leading",
                type: "toolbargroup",
                settings: { region: "leading" }
            }, {
                name: "trailing",
                type: "toolbargroup",
                settings: { region: "trailing" }
            }];

            var toolbarButtons = [{
                parent: "leading",
                name: "breadcrumbs",
                widgetType: "epi-cms/widget/Breadcrumb",
                settings: { showCurrentNode: false }
            }, {
                parent: "leading",
                name: "currentcontent",
                widgetType: "epi-cms/widget/BreadcrumbCurrentItem"
            }, {
                parent: "trailing",
                name: "notificationCenter",
                widgetType: "epi-cms/widget/NotificationStatusBar"
            }, {
                parent: "trailing",
                name: "saveButton",
                title: sharedResources.action.create,
                label: sharedResources.action.create,
                type: "button",
                action: lang.hitch(this, this._onSave),
                settings: { "class": "epi-button--bold epi-primary" }
            }, {
                parent: "trailing",
                name: "cancelButton",
                title: sharedResources.action.cancel,
                label: sharedResources.action.cancel,
                type: "button",
                action: lang.hitch(this, this._onCancel),
                settings: { "class": "epi-button--bold" }
            }];

            when(this.toolbar.add(toolbarGroups), lang.hitch(this, function () {
                this.toolbar.add(toolbarButtons);
            }));
        },

        _changeContext: function (contentLink) {
            // summary:
            //    Redirect the newly created content to editmode.
            //
            // contentLink:
            //    The content link.
            //
            // tags:
            //    private

            topic.publish("/epi/shell/context/request", {
                uri: "epi.cms.contentdata:///" + contentLink
            }, {
                sender: this,
                viewName: this.view,
                forceContextChange: true,
                forceReload: true
            });
        },

        _backToCurrentContext: function () {
            // summary:
            //    Get back to the default main widget of the current context.
            //
            // tags:
            //    private

            topic.publish("/epi/shell/action/changeview/back");
        },

        _setCreateMode: function () {
            // summary:
            //      Set create new content state for current mode
            // tags:
            //      private

            lang.mixin(this._contextService.currentContext, {
                currentMode: "create"
            });

            topic.publish("/epi/cms/action/togglecreatemode", true);
        },

        _clearCreateMode: function () {
            // summary:
            //      Clear create new content state for current mode
            // tags:
            //      private

            domClass.remove(this.stackContainer.domNode, "epi-animation-node-reset");

            lang.mixin(this._contextService.currentContext, {
                currentMode: undefined
            });

            topic.publish("/epi/cms/action/togglecreatemode", false);
        }

    });

});

},
'epi-cms/contentediting/NewContentNameInputDialog':function(){
define([

    // Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/keys",

    // Dijit
    "dijit/_CssStateMixin",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/TextBox",

    // EPi Framework
    "epi",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/_ActionProviderWidget",

    // Template
    "dojo/text!./templates/NewContentNameInputDialog.html",

    // Resource
    "epi/i18n!epi/cms/nls/episerver.cms.widget.newcontentnamedialog"
],
function (

    // Dojo
    declare,
    lang,
    domStyle,
    keys,

    // Dijit
    _CssStateMixin,
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _TextBox,

    // EPi Framework
    epi,
    _DialogContentMixin,
    _ModelBindingMixin,
    _ActionProviderWidget,

    // Template
    template,

    // Resource
    res
) {
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ActionProviderWidget, _DialogContentMixin, _CssStateMixin], {
        // tags:
        //      internal

        templateString: template,

        res: res,

        defaultContentName: null,

        message: null,

        title: null,

        nameLabel: epi.resources.header.name,

        _setMessageAttr: { node: "messageNode", type: "innerHTML" },

        postMixInProperties: function () {
            this.inherited(arguments);
            this.message = lang.replace(this.res.warningtext, {
                defaultname: this.defaultContentName
            });
            this._set("message", this.message);
            this.title = res.title;
        },

        postCreate: function () {
            this.inherited(arguments);
            this.contentNameTextbox.set("value", this.defaultContentName);

            this.contentNameTextbox.on("keyup", lang.hitch(this, function (evt) {

                var isValid = this.contentNameTextbox.isValid();

                if (evt.keyCode === keys.ENTER && isValid) {
                    this.executeDialog();
                }
            }));

            this.on("focus", lang.hitch(this, function () {
                this.contentNameTextbox.textbox.select();
            }));
        },

        _getValueAttr: function () {
            return this.contentNameTextbox.get("value");
        },

        _onBlurVerifyContent: function () {
            // summary:
            //    check if the textfield content is empty on blur,
            //    set to default value if it is.
            //
            // tags:
            //    private
            if (this.contentNameTextbox.get("value") === "") {
                this.contentNameTextbox.set("value", this.defaultContentName);
            }
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget
            //
            // returns:
            //      An array contining a select page action definition, if it is not a shared block

            this._actions = [
                {
                    name: "cancel",
                    label: epi.resources.action.cancel,
                    settings: { type: "button", "class": "epi-plain-button" },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                },
                {
                    name: "ok",
                    label: epi.resources.action.ok,
                    settings: { type: "button", "class": "Salt" },
                    action: lang.hitch(this, function () {
                        if (this.contentNameTextbox.isValid()) {
                            this.executeDialog();
                        } else {
                            this.contentNameTextbox.focus();
                        }
                    })
                }
            ];

            return this._actions;
        }
    });
});

},
'url:epi-cms/contentediting/templates/NewContentNameInputDialog.html':"<div class=\"epi-formContainer\">\r\n    <div data-dojo-attach-point=\"messageNode\"></div>\r\n    <br />\r\n    <div>\r\n        <label data-dojo-attach-point=\"contentNameLabelNode\">\r\n            ${nameLabel}\r\n            <span class=\"epi-required-indicator dijitInline dijitReset\"></span>\r\n        </label>\r\n        <input type=\"text\" size=\"40\" maxlength=\"255\"  data-dojo-attach-point=\"contentNameTextbox\" data-dojo-type=\"dijit/form/ValidationTextBox\"\r\n                data-dojo-props=\"required: true, trim:true, selectOnClick: true\"\r\n                data-dojo-attach-event=\"onBlur: _onBlurVerifyContent\"\r\n                missingMessage: \"${res.errormessage.missingmessage}\" />\r\n    </div>\r\n</div>\r\n",
'epi-cms/widget/PropertiesForm':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/when",

    "dijit/layout/_LayoutWidget",

    "epi/shell/widget/FormContainer"
], function (
    array,
    declare,
    lang,

    when,

    _LayoutWidget,

    FormContainer) {


    return declare([_LayoutWidget], {
        // summary:
        //      Required properties form used in create content component
        // tags:
        //      internal

        // metadata: Object
        //      Metadata of the selected content type
        metadata: null,

        // showAllProperties: Boolean
        //      Indicate that the form should display all properties
        showAllProperties: false,

        // propertyFiter: Function
        //      Filter used to show/hide properties displayed in the form
        propertyFilter: null,

        _setMetadataAttr: function (value) {
            this._set("metadata", value);

            // Break the long event handlers chain to make IE more responsive.
            setTimeout(lang.hitch(this, function () {
                this._setupForm();
            }), 0);
        },

        _setupForm: function () {
            // summary:
            //		Setup form container after the widget is created.
            // tags:
            //		private

            if (this._form) {
                this._form.destroy();
            }

            this._form = new FormContainer({
                metadata: this.metadata,
                doLayout: false,
                propertyFilter: lang.hitch(this, this.propertyFilter)
            });

            this.connect(this._form, "onFieldCreated", function (fieldName, widget) {
                this.own(widget.watch("state", lang.hitch(this, function (name, oldValue, value) {
                    if (oldValue === "Error" && value !== "Error") {
                        this.onPropertyValidStateChange(fieldName);
                    } else if (oldValue !== "Error" && value === "Error") {
                        this.onPropertyValidStateChange(fieldName, widget.getErrorMessage());
                    }
                })));
            });

            this._form.placeAt(this.domNode);
            // Since the same document is used and saves the scrollposition,
            // we make sure to reset scrollposition so the editor gets to start from the top.
            this.domNode.scrollTop = 0;
            this.own(this._form);
        },

        validate: function () {
            // summary:
            //		Validate the properties.
            // tags:
            //		public

            return this._form.validate();
        },

        onPropertyValidStateChange: function (propertyName, errorMessage) {
            // summary:
            //      Fired when a property become invalid or is valid again.
            // propertyName: String
            //      The property name
            // errorMessage: String
            //      The error message if any.
            // tags:
            //      public, callback
        },

        _getValueAttr: function () {
            // summary:
            //		Get properties form value.
            // tags:
            //		protected

            return this._form.get("value");
        }
    });
});

},
'url:epi-cms/contentediting/templates/CreateContent.html':"<div class=\"epi-createContent\">\r\n    <div data-dojo-attach-point=\"layoutContainer\" data-dojo-type=\"dijit/layout/BorderContainer\" data-dojo-props=\"gutters: false, livesplitters: false\">\r\n        <div class=\"epi-static-node\" data-dojo-attach-point=\"topPanel\" data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-props=\"region:'top'\">\r\n            <div data-dojo-attach-point=\"headingPanel\">\r\n                <h1><span data-dojo-attach-point=\"headingTextNode\"></span>:&nbsp;<span data-dojo-attach-point=\"contentTypeNameNode\"></span></h1>\r\n            </div>\r\n            <div data-dojo-attach-point=\"toolbar\" class=\"epi-localToolbar epi-viewHeaderContainer\" data-dojo-type=\"epi/shell/widget/ToolbarSet\" data-dojo-props=\"region:'top'\"></div>\r\n            <div data-dojo-attach-point=\"namePanel\" class=\"epi-namePanel\">\r\n                <label>\r\n                    ${sharedResources.header.name}\r\n                    <span class=\"epi-required-indicator dijitInline dijitReset\"></span>\r\n                </label>\r\n                <input data-dojo-attach-point=\"nameTextBox\"\r\n                       data-dojo-type=\"dijit/form/ValidationTextBox\"\r\n                       data-dojo-props=\"selectOnClick: true, required: true, trim:true\"\r\n                       data-dojo-attach-event=\"onChange: _onContentNameChange, onBlur: _onBlurVerifyContent\"\r\n                       maxlength=\"255\" />\r\n                <span data-dojo-attach-point=\"contentNameHelpTextNode\" class=\"dijitInline dgrid-no-data\"></span>\r\n            </div>\r\n        </div>\r\n        <div class=\"epi-newContentContainer epi-animation-node\" data-dojo-attach-point=\"stackContainer\" data-dojo-type=\"dijit/layout/StackContainer\" data-dojo-props=\"region: 'center'\">\r\n            <div data-dojo-attach-point=\"contentTypeList\" data-dojo-type=\"epi-cms/widget/ContentTypeList\" data-dojo-attach-event=\"onContentTypeSelected: _onContentTypeSelected\">\r\n                <div data-dojo-attach-point='subHeadingPanel' class=\"push-padding--left\">\r\n                    <h1 data-dojo-attach-point=\"subHeadingTextNode\"></h1>\r\n                    <p data-dojo-attach-point=\"subHeadingDescNode\"></p>\r\n                </div>\r\n            </div>\r\n            <div data-dojo-attach-point=\"propertiesForm\" data-dojo-type=\"epi-cms/widget/PropertiesForm\" data-dojo-attach-event=\"onPropertyValidStateChange: _onPropertyValidStateChange\">\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/CreateLanguageBranch':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    // epi
    "epi-cms/contentediting/CreateContent",
    "epi-cms/contentediting/viewmodel/CreateLanguageBranchViewModel"
],

function (
// dojo
    declare,
    lang,
    // epi
    CreateContent,
    CreateLanguageBranchViewModel
) {

    return declare([CreateContent], {
        // summary:
        //      Widget for language branch creation.
        // tags:
        //      internal xproduct

        modelType: CreateLanguageBranchViewModel,

        _setCreateMode: function () {
            // summary:
            //      Set create new content state for current mode
            // tags:
            //      protected extension

            lang.mixin(this._contextService.currentContext, {
                currentMode: "translate"
            });
        }

    });

});

},
'epi-cms/contentediting/viewmodel/CreateLanguageBranchViewModel':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    // epi
    "epi/dependency",
    "epi-cms/contentediting/viewmodel/CreateContentViewModel",

    "epi/i18n!epi/cms/nls/episerver.cms.components.createpage.translate"
],

function (
// dojo
    declare,
    lang,
    when,

    // epi
    dependency,
    CreateContentViewModel,
    res
) {

    return declare([CreateContentViewModel], {
        // summary:
        //      View model of epi-cms/contentediting/CreateLanguageBranch component.
        // tags:
        //      internal

        // languageBranch: String
        //      Language branch on which the new content is created.
        languageBranch: null,

        // masterLanguageVersionId: String
        //      Content link of the master language version.
        masterLanguageVersionId: null,

        // contentNameHelpText: String
        //      Help text for the content name input
        contentNameHelpText: res.namehelptext,

        postscript: function () {

            // always start with second step
            this.wizardStep = 1;
            this.startWizardStep = 1;

            this.inherited(arguments);

            this._languageStore = this._languageStore || dependency.resolve("epi.storeregistry").get("epi.cms.language");
        },

        update: function (settings) {
            // summary:
            //      Update the component with new settings.
            // description:
            //      Override the base to set other properties (languageBranch, masterLanguageVersionId, contentName) with values provided by the component settings requested.
            // settings: Object
            //      The settings object.
            // tags:
            //      public

            var masterContent = settings.contentData;
            var languageBranch = settings.languageBranch;


            // If the masterContent does not have a public url (will not have url segment) we should not show the help text
            this.set("contentNameHelpText", masterContent.publicUrl ? res.namehelptext : "");

            var self = this;
            return when(this.contentDataStore.get(masterContent.parentLink))
                .then(function (parent) {
                    var baseResult = CreateContentViewModel.prototype.update.apply(self, [{
                        requestedType: masterContent.typeIdentifier,
                        parent: parent,
                        contentTypeId: masterContent.contentTypeID
                    }]);

                    self.set("languageBranch", languageBranch);
                    self.set("masterLanguageVersionId", masterContent.contentLink);
                    self.set("contentName", masterContent.name);

                    return baseResult;
                })
                .then(function (baseResult) {
                    //Change the heading text
                    return when(self._languageStore.get(self.languageBranch)).then(function (language) {
                        self.set("headingText", lang.replace(res.namelabel, [language.name]));

                        return baseResult;
                    });
                });
        },

        _hasRequiredProperties: function () {
            // summary:
            //      We always want to show the default create view, so we always say that we have required properties even though
            return true;
        },

        _isRequired: function (property) {
            // summary:
            //      Checks if the given property is required.
            // property: Object
            //      The metadata property.
            // tags:
            //      protected, extension

            return this.inherited(arguments) && (!this.languageBranch || property.settings.isLanguageSpecific === true);
        },

        buildContentObject: function () {
            // summary:
            //      Build up the content object to create from model properties.
            // description:
            //      Override to set languageBranch and masterLanguageVersionId on the result.
            // tags:
            //      protected

            var content = this.inherited(arguments);

            lang.mixin(content, {
                languageBranch: this.languageBranch,
                masterLanguageVersionId: this.masterLanguageVersionId
            });

            return content;
        }

    });

});

},
'epi-cms/contentediting/DateTimeNowEditor':function(){
﻿define([
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/text!./templates/DateTimeNowEditor.html",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.datetimenow"
], function (connect, declare, lang, domStyle, domConstruct, templateString, _Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ValueRequiredMixin, resources) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ValueRequiredMixin], {
        // summary:
        //      Combining a DateTimeSelectorDropDown and a now button for setting current dateTime
        // tags:
        //      internal

        templateString: templateString,

        value: null,

        resources: resources,

        postCreate: function () {
            this.inherited(arguments);

            this.own(this.dateTimeSelector.watch("value", lang.hitch(this, function (value, oldValue, newValue) {
                this._set("value", newValue);
                this.onChange(newValue);
            })));
        },

        onChange: function (newValue) {
            // summary:
            //      Callback method for updating the editor wrapper.
            // tags:
            //      callback
            this.validate();
        },

        validate: function () {
            // summary:
            //      performs the base required validation of the current value
            //      and if minimumValue is set it validates that value is newer than minimumValue
            // tags:
            //      public

            var isValid = this.inherited(arguments);
            if (isValid) {
                var value = this.get("value");
                isValid = this.disabled || !value || !this.minimumValue || value > this.minimumValue;
                this._set("state", isValid ? "" : "Error");
                if (isValid) {
                    this.hideMessage();
                } else {
                    this.displayMessage(this.minimumValueMessage);
                }
            }
            return isValid;
        },

        _setValueAttr: function (value) {
            this.dateTimeSelector.set("value", value);
            this._set("value", value); //for the value required mixin
        },

        _getValueAttr: function () {
            return this.dateTimeSelector.get("value");
        },

        _onExpireNowClick: function () {
            this.set("value", new Date());
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            this.dateTimeSelector.set("readOnly", value);
            domStyle.set(this.expireNowNode, "display", value ? "none" : "");
        }
    });
});

},
'url:epi-cms/contentediting/templates/DateTimeNowEditor.html':"﻿<div class=\"dijitInline dijitInputContainer\">\r\n    <div data-dojo-type=\"epi/shell/widget/DateTimeSelectorDropDown\" data-dojo-attach-point=\"dateTimeSelector\"></div>\r\n    <a class=\"epi-visibleLink\" style=\"padding-left:10px\" data-dojo-attach-point=\"expireNowNode\"\r\n       data-dojo-attach-event=\"onclick:_onExpireNowClick\">${resources.now}</a>\r\n</div>\r\n",
'epi-cms/contentediting/DialogEditorWrapper':function(){
﻿define([
    "epi",
    "dojo",
    "epi-cms/contentediting/_EditorWrapperBase",
    "epi/shell/widget/dialog/Dialog"],

function (epi, dojo, _EditorWrapperBase, Dialog) {

    return dojo.declare([_EditorWrapperBase], {
        // summary:
        //		Base Dialog Editor wrapper. Create property editor in a dialog. Provides positioning, sizing functions.
        //
        // tags:
        //      internal

        // closeOnChange: [public] Boolean
        //    Denote if the dialog should be closed on change
        closeOnChange: true,

        // closeOnChange: [public] Boolean
        //    Denote if the dialog should show its Ok and Cancel buttons
        showButtons: false,

        _dialog: null,

        buildRendering: function () {
            this.inherited(arguments);

            if (!this.editorWidget) {
                // Create editor widget
                dojo["require"](this.editorWidgetType); // Written this way on purpose to fool the build system.
                var cls = dojo.getObject(this.editorWidgetType);
                var editorParams = this.editorParams || {};

                if ("displayedValue" in cls.prototype || "value" in cls.prototype) {
                    editorParams["displayedValue" in cls.prototype ? "displayedValue" : "value"] = this.value;
                }

                this.editorWidget = new cls(editorParams);
            }

            var ew = this.editorWidget;

            // Create dialog and set content
            var dialog = new Dialog({
                content: ew,
                title: this.propertyDisplayName,
                defaultActionsVisible: this.showButtons,
                contentClass: "epi-dialog-fullWidth",
                destroyOnHide: false
            });

            // ESC and TAB could cancel and save.  Note that edit widgets do a stopEvent() on ESC key (to
            // prevent Dialog from closing when the user just wants to revert the value in the edit widget),
            // so this is the only way we can see the key press event.
            this.connect(ew, "onKeyPress", this._onKeyPress);
            this.connect(ew, "onCancel", this._onCancel);
            this.connect(ew, "onResize", dojo.hitch(this, function () {
                this._dialog.resize();
            }));

            if ("intermediateChanges" in ew) {
                // If an editor widget publishes intermediate changes we want to get notified about them.
                ew.set("intermediateChanges", true);
            }
            this.connect(ew, "onChange", "_onChange");

            this.connect(dialog, "onHide", this._onHide);
            this.connect(dialog, "onCancel", this._onCancel);
            this._dialog = dialog;
        },

        destroy: function () {
            this._dialog.destroyRecursive();
            this.inherited(arguments);
        },

        _onKeyPress: function (e) {
            // summary:
            //		Handler for keypress in the edit box in autoSave mode.
            // description:
            //		For autoSave widgets, if Esc/Enter, call cancel/save.
            // tags:
            //		private

            if (this.editing) {

                if (e.altKey || e.ctrlKey) {
                    return;
                }
                // If Enter/Esc pressed, treat as save/cancel.
                if (e.keyCode === dojo.keys.ESCAPE) {
                    dojo.stopEvent(e);
                    this.cancel(); // sets editing=false which short-circuits _onBlur processing
                } else if (e.keyCode === dojo.keys.ENTER && e.target.tagName === "INPUT") {

                    dojo.stopEvent(e);
                    this._stopEdit();
                }

                // _onBlur will handle TAB automatically by allowing
                // the TAB to change focus before we mess with the DOM: #6227
                // Expounding by request:
                // The current focus is on the edit widget input field.
                // save() will hide and destroy this widget.
                // We want the focus to jump from the currently hidden
                // displayNode, but since it's hidden, it's impossible to
                // unhide it, focus it, and then have the browser focus
                // away from it to the next focusable element since each
                // of these events is asynchronous and the focus-to-next-element
                // is already queued.
                // So we allow the browser time to unqueue the move-focus event
                // before we do all the hide/show stuff.
            }
        },

        _onCancel: function () {
            this.cancel();

            // reset editor value
            this.editorWidget.set("value", this.value);

            if (this._dialog.open) {
                this._dialog.hide();
            }
        },

        _onChange: function () {
            this.inherited(arguments);

            if (this.closeOnChange) {
                this._stopEdit();
            }
        },

        _onHide: function () {
            if (this.editing) {
                this._stopEdit();
            }
        },

        startEdit: function () {
            this.inherited(arguments);
            this._dialog.show();
        },

        _stopEdit: function () {
            this.inherited(arguments);

            if (this._dialog.open) {
                this._dialog.hide();
            }
        },

        _setTitleAttr: function (title) {

            if (this._dialog) {
                this._dialog.set("title", title);
            }

            this._set("title", title);
        }
    });

});

},
'epi-cms/contentediting/editors/CheckBoxListEditor':function(){
﻿define([

    // Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/on",
    "dojox/html/entities",

    // Dijit
    "dijit/focus",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/form/CheckBox",

    // EPi
    "epi/shell/widget/_ValueRequiredMixin"
], function (

    // Dojo
    array,
    declare,
    lang,
    domConstruct,
    on,
    entities,

    // Dijit
    focusUtil,
    _TemplatedMixin,
    _Widget,
    CheckBox,

    // EPi
    _ValueRequiredMixin

) {

    return declare([_Widget, _TemplatedMixin, _ValueRequiredMixin], {
        // tags:
        //      internal xproduct

        templateString: "<div class=\"dijit dijitReset dijitInline\"></div>",

        baseClass: "epi-checkBoxList",

        valueIsCsv: true,

        valueIsInclusive: true,

        value: null,

        constructor: function () {
            this._checkboxes = [];
            this._labelClickHandles = [];
        },

        buildRendering: function () {
            this.inherited(arguments);

            array.forEach(this.selections, this._addCheckBoxForItem, this);
        },

        destroy: function () {
            var checkbox;
            while ((checkbox = this._checkboxes.pop())) {
                checkbox.destroyRecursive();
            }

            var labelClickHandle;
            while ((labelClickHandle = this._labelClickHandles.pop())) {
                labelClickHandle.remove();
            }

            this.inherited(arguments);
        },

        focus: function () {
            // summary:
            //		Focus the widget.

            try {
                if (this._checkboxes.length > 0) {
                    focusUtil.focus(this._checkboxes[0].domNode);
                }
            } catch (e) {
                /*quiet*/
            }
        },

        onChange: function (/*===== newValue =====*/) {
            // summary:
            //		Callback when this widget's value is changed.
            // tags:
            //		callback
        },

        onBlur: function () {
            // summary:
            //		Callback when this widget loses focus.
            // tags:
            //		callback
        },

        onFocus: function () {
            // summary:
            //		Callback when this widget gains focus.
            // tags:
            //		callback
        },

        _calculateValue: function () {
            var values = [];
            var storeChecked = this.valueIsInclusive;
            array.forEach(this._checkboxes, function (checkbox) {
                if (storeChecked === checkbox.checked) {
                    values.push(checkbox.value);
                }
            });

            this._set("value", this.valueIsCsv ? values.join(",") : values);
        },

        _setValueAttr: function (value) {
            this._set("value", value);

            var values = [];
            if (value) {
                values = this.valueIsCsv ? value.split(",") : value;
            }

            var checkValues = this.valueIsInclusive;
            var compareCheckboxValue = this._compareCheckboxValue;

            array.forEach(this._checkboxes, function (checkbox) {
                checkbox.set("checked", checkValues === array.some(values, function (v) {
                    return compareCheckboxValue(checkbox, v);
                }));
            });
        },

        _compareCheckboxValue: function (checkbox, value) {
            // 'value' can be a different type from 'checkbox.value' so we stringify them before comparing.

            var checkboxValue = checkbox.value;

            if (checkboxValue === undefined || checkboxValue === null) {
                return false;
            }

            return checkboxValue.toString() === value.toString();
        },

        _onBlur: function () {
            this.inherited(arguments);
            this.onBlur();
        },

        _addCheckBoxForItem: function (item) {
            // Create a container for the label and checkbox.
            var container = domConstruct.create("div", { "class": "epi-checkboxContainer" }, this.domNode);

            // Add the checkbox to the container.
            var checkbox = new CheckBox({ value: item.value });
            checkbox.placeAt(container);

            this.own(
                on(checkbox, "change", lang.hitch(this, function () {
                    this._calculateValue();
                    this.onChange(this.value);
                }))
            );

            checkbox.set("readOnly", !!this.readOnly);

            this._checkboxes.push(checkbox);

            // Add a label for the checkbox
            var label = domConstruct.create("label", { "for": checkbox.id }, container);
            label.textContent = item.text;
            this._labelClickHandles.push(on(label, "click", lang.hitch(this, function () {
                focusUtil.focus(checkbox.domNode);
            })));
        }
    });
});

},
'epi-cms/contentediting/editors/CollectionEditor':function(){
define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/json",
    "dojo/on",
    "dojo/Stateful",
    "dojo/when",

    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",

    // dgrid
    "dgrid/Keyboard",
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/extensions/ColumnResizer",
    "dgrid/extensions/ColumnReorder",
    "put-selector/put",

    // epi shell
    "epi/shell/dgrid/Formatter",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/FormContainer",
    "epi/string",
    "epi/shell/command/withConfirmation",

    // epi cms
    "epi-cms/contentediting/editors/model/CollectionEditorModel",
    "epi-cms/contentediting/editors/model/CollectionEditorItemModel",
    "epi-cms/contentediting/_EditorWrapperBase",
    "epi-cms/dgrid/DnD",
    "epi-cms/dgrid/formatters",
    "epi-cms/dgrid/WithContextMenu",
    "epi-cms/contentediting/editors/DefaultGridAssembler",
    "./_AddItemDialogMixin",

    // resources
    "dojo/text!./templates/CollectionEditor.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.collectioneditor"
], function (
    // dojo
    array,
    declare,
    lang,

    aspect,
    domConstruct,
    domClass,
    json,
    on,
    Stateful,
    when,

    // dijit
    _TemplatedMixin,
    _Widget,

    // dgrid
    Keyboard,
    OnDemandGrid,
    Selection,
    ColumnResizer,
    ColumnReorder,
    put,

    // epi shell
    Formatter,
    _ModelBindingMixin,
    FormContainer,
    epiString,
    withConfirmation,

    // epi cms
    CollectionEditorModel,
    CollectionEditorItemModel,
    _EditorWrapperBase,
    DnD,
    formatters,
    WithContextMenu,
    DefaultGridAssembler,
    _AddItemDialogMixin,

    // resources
    template,
    resources
) {
    return declare([_Widget, _TemplatedMixin, _ModelBindingMixin, _AddItemDialogMixin], {
        // tags:
        //      public

        // templateString: String
        //      The widget's template.
        templateString: template,

        // multiple: Boolean
        //      Indicates that the widget's value is array-like.
        multiple: true,

        // baseClass: String
        //      The widget's base css class.
        baseClass: "epi-collection-editor",

        // value: Array
        //      The widget's value.
        value: null,

        // model: epi-cms/contentediting/editors/CollectionEditor
        //      The widget's model.
        model: null,

        // modelType: Function
        //      The widget's model class. By default it is epi-cms/contentediting/editors/model/CollectionEditorModel
        modelType: CollectionEditorModel,

        // itemType: String
        //      The collection item type on the server. This is used to retrieve item metadata.
        itemType: null,

        // generateColumn: Boolean
        //      Indicates that grid columns definition should be generated from item type's metadata.
        generateColumns: true,

        // excludedColumns: Array
        //      List of columns those are excluded from generated columns
        excludedColumns: null,

        // includedColumns: Array
        //      List of columns which are configured to assemble the grid.
        includedColumns: null,

        // gridType: Function
        //      The grid class. By default it is OnDemandGrid with Formatter, Selection, Keyboard, and DnD supports.
        gridType: declare([OnDemandGrid, Formatter, Selection, Keyboard, DnD, ColumnResizer, ColumnReorder, WithContextMenu]),

        // gridAssemblerType: Function
        //      The grid assembler class.
        gridAssemblerType: DefaultGridAssembler,

        // gridSettings: Object
        //      The grid settings.
        gridSettings: null,

        // itemModelType: Function
        //      Item Model constructor. Default is epi-cms/contentediting/editors/model/CollectionEditorItemModel.
        itemModelType: null,

        // itemEditorType: Function
        //      The item editor class. By default, it is FormContainer
        itemEditorType: FormContainer,

        // useFullWidth: Boolean
        //      Specifies that this widget should be rendered in full width.
        useFullWidth: true,

        _noDataMessage: "<span><span class=\"dijitReset dijitInline\">" + resources.noitems + "</span></span>",

        _currentProviderHandler: null,

        postMixInProperties: function () {
            // summary:
            //      Post mix in properties initialization.
            // description:
            //      Fullfills properties that needed to start up the widget.
            // tags:
            //      protected

            this.inherited(arguments);

            this.dialogParams = lang.mixin(this.dialogParams, {
                "class": this.baseClass + "--dialog"
            });

            this.itemModelType = this.itemModelType || CollectionEditorItemModel;

            // Create model
            this.model = this.model || new this.modelType({
                itemType: this.itemType,
                itemModelType: this.itemModelType,
                data: this.value,
                availableCommands: this.commands
            });
            this.own(this.model);

            // Connect to model events
            this.own(
                on(this.model, "initializeCompleted", this._renderUI.bind(this)),
                on(this.model, "itemsChanged", lang.hitch(this, this._onItemsChanged))
            );

            // Initialize grid settings
            this.gridSettings = lang.mixin(this.gridSettings || {}, { noDataMessage: this._noDataMessage });

            // Disable gridDnd if the grid is readOnly for instance when another user is editing current page.
            if (this.readOnly) {
                this.allowedDndTypes = [];
                this.gridSettings.dndDisabled = true;
            }

            this.gridSettings.dndParams = {
                copyOnly: true,
                accept: this.allowedDndTypes || [],
                creator: lang.hitch(this, this._dndNodeCreator)
            };
        },

        postCreate: function () {
            // summary:
            //      Post create initialization.
            // description:
            //      Setup related components.
            // tags:
            //      protected

            this.inherited(arguments);

            // When the model is initialized, setup the grid
            when(this.model.initialize(), lang.hitch(this, function () {
                if (this._destroyed) {
                    return;
                }
                this._setupGrid();
            }));
        },

        onChange: function (value) {
            // summary:
            //      Triggered when the widget's value changes.
            // tags:
            //      public, callback
        },

        _setValueAttr: function (value) {
            // summary:
            //      Value setter.
            // description:
            //      Push value to the model to be its data.
            // tags:
            //      private

            this._set("value", value);

            if (this.model) {
                this.model.set("data", value);
            }
        },

        _dndNodeCreator: function (/*Object*/item, /*Object*/hint) {
            // summary:
            //      Custom DnD avatar creator method
            // tags:
            //      private

            // No reason for adding anything but a div.
            // The epi/shell/Avatar will replace its innerHTML with the item name property anyway.
            var node = domConstruct.create("div");

            return {
                node: node,
                type: this.allowedDndTypes,
                data: item
            };
        },

        _setupGrid: function () {
            // summary:
            //      Set up the grid.
            // tags:
            //      private

            // Contains columns definition
            var columns = this._getGridDefinition();

            // Create grid assembler
            var gridAssembler = new this.gridAssemblerType({
                gridType: this.gridType,
                gridSettings: this.gridSettings,
                columnDefinitions: columns,
                listCommands: this.readOnly ? [] : this.model.getListCommands(),
                itemCommandsFactory: lang.hitch(this, function (item, category) {
                    return this.readOnly ? [] : this.model.getItemCommands(item, this.commands, category);
                })
            });

            // Build the grid.
            this.own(this.grid = gridAssembler.build(this.gridNode, this.commandTargetNode));

            //style Grid
            domClass.add(this.gridNode, "epi-plain-grid-modal epi-plain-grid--margin-bottom epi-plain-grid--cell-borders");

            // Setup dnd
            if (!this.gridSettings.dndDisabled) {
                this._setupDnD();
            }

            var items = this.model.get("items");
            this.grid.renderArray(items);

            if (!items || items.length <= 0) {
                this._renderNoDataMessage();
            }

            this.own(this.grid.on(".dgrid-row:click", lang.hitch(this, this.onGridRowClick)));

            this.own(this.grid.on(".dgrid-row:dblclick", lang.hitch(this, this.onGridRowDblClick)));
        },

        _setupDnD: function () {
            // summary:
            //      Set up the dnd on the grid.
            // tags:
            //      private

            this.own(aspect.after(this.grid.dndSource, "onDropData", lang.hitch(this, this.onDndDrop), true));
        },

        onDndDrop: function (dndData, source, nodes, copy) {
            var i;

            // internal move
            if (this.grid.dndSource === source) {
                for (i = 0; i < nodes.length; i++) {
                    this.model.moveItem(
                        this.grid.dndSource.getItem(nodes[i].id).data,
                        this.grid.dndSource.current != null ?
                            this.grid.dndSource.getItem(this.grid.dndSource.current.id).data :
                            null,
                        this.grid.dndSource.before
                    );
                }
                // external drop
            } else {
                // Set focus to mark start editing
                // make sure editor will be marked as start-editing immediately by invoking onDropping
                // to fix an issue in IE9, which was caused by the race condition,
                // which would lead to a problem of auto save.
                this.onDropping && this.onDropping();
                this.onFocus();

                for (i = 0; i < dndData.length; i++) {
                    this._addItem(dndData[i]);

                    // Remove from source?
                    // TODO: Simplify
                    if (source && source.grid && source.grid.consumer && source.grid.consumer !== this) {
                        source.grid.consumer.model.removeItem(this.grid.dndSource.getItem(nodes[i].id).data);
                    }
                }
            }
        },

        _addItem: function (item) {
            when(this._dndGetItemData(item), lang.hitch(this, function (itemData) {
                this.model.addItem(
                    itemData,
                    this.grid.dndSource.current != null ?
                        this.grid.dndSource.getItem(this.grid.dndSource.current.id).data :
                        null,
                    this.grid.dndSource.before
                );
            }));
        },

        _dndGetItemData: function (item) {
            return item.data;
        },

        _getGridDefinition: function () {
            // summary:
            //      Returns grid's columns definition.
            // tags:
            //      private

            var columns = this.generateColumns ?
                this.model.generateColumnsDefinition(this.excludedColumns) : // If auto generate is on, ask model to compute columns definition.
                this.includedColumns || {}; // Otherwise, use configured ones.

            return this.model.generateFormatters(columns);
        },

        _onGridRowSelect: function (e) {
            // summary:
            //      Makes sure the right commands are available in the context menu when selecting a row in the grid.
            // tags:
            //      private

            if (!this.grid.itemCommandProviderMap) {
                return;
            }
            if (this._currentProviderHandler) {
                this._currentProviderHandler.removeProvider();
            }
            var item = this.grid.row(e).data;
            this._currentProviderHandler = this.grid.contextMenu.addProvider(this.grid.itemCommandProviderMap[json.stringify(item)]);
        },

        onGridRowClick: function (e) {
            // summary:
            //      Makes sure the right commands are available in the context menu when selecting a row in the grid.
            // tags:
            //      protected
            this._onGridRowSelect(e);
            this.onFocus();
        },

        onGridRowDblClick: function (e) {
            // summary:
            //      Makes sure the right commands are available in the context menu when selecting a row in the grid.
            // tags:
            //      protected
            if (this.readOnly) {
                return;
            }

            var item = {
                model: this.grid.row(e).data
            };
            this.model.editItemDelegate(item);
        },

        _getDialogConfirmActionText: function () {
            return this.gridSettings.confirmActionText ? this.gridSettings.confirmActionText : this.inherited(arguments);
        },

        onExecuteDialog: function () {
            var item = this._itemEditor.get("value");

            if (this._editingItemIndex !== undefined) {
                this.model.saveItem(item, this._editingItemIndex);
            } else {
                this.model.addItem(item);
            }
        },

        _onCancelDialog: function () {
            // summary:
            //      Blur widget to force stop editing the EditingWrapper
            // tags:
            //      protected

            this.inherited(arguments);
            this._onBlur();
        },

        _renderUI: function (items) {
            // If grid is created, rerender.
            if (this.grid) {
                for (var item in this.grid.itemCommandProviderMap) {
                    delete this.grid.itemCommandProviderMap[item];
                }
                this.grid.refresh();
                this.grid.renderArray(items);

                if (!items || items.length <= 0) {
                    this._renderNoDataMessage();
                }
            }
            // When initializing is completed, set the value without triggering the change event
            // This is needed to make sure the _ValueRequiredMixin.isValid work properly
            this._set("value", this.model.get("data"));
        },

        _onItemsChanged: function (items) {
            // summary:
            //      The model's itemsChanged event handler.
            // items: Array
            //      The items list (Note that it is an item model instance, not the raw data item).
            // tags:
            //      private

            this._renderUI(items);

            // Set value and trigger change event
            var value = this.model.get("data"); // Get raw data which is unwrapped from item models.
            this._set("value", value);

            if (!this.readOnly) { // disable auto save if read only is true
                this.onChange(value);
            }
        },

        _renderNoDataMessage: function () {
            if (this.grid.noDataNode) {
                return;
            }

            this.grid.noDataNode = put(this.grid.contentNode, "div.dgrid-no-data");
            this.grid.noDataNode.innerHTML = this.grid.noDataMessage;
        }
    });
});

},
'dgrid/extensions/ColumnReorder':function(){
define([
	"dojo/_base/lang",
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/on",
	"dojo/query",
	"dojo/dnd/Source",
	"put-selector/put",
	"xstyle/css!../css/extensions/ColumnReorder.css"
], function(lang, declare, arrayUtil, on, query, DndSource, put){
	var dndTypeRx = /(\d+)(?:-(\d+))?$/; // used to determine subrow from dndType
	
	// The following 2 functions are used by onDropInternal logic for
	// retrieving/modifying a given subRow.  The `match` variable in each is
	// expected to be the result of executing dndTypeRx on a subRow ID.
	
	function getMatchingSubRow(grid, match) {
		var hasColumnSets = match[2],
			rowOrSet = grid[hasColumnSets ? "columnSets" : "subRows"][match[1]];
		
		return hasColumnSets ? rowOrSet[match[2]] : rowOrSet;
	}
	
	function setMatchingSubRow(grid, match, subRow) {
		if(match[2]){
			grid.columnSets[match[1]][match[2]] = subRow;
		}else{
			grid.subRows[match[1]] = subRow;
		}
	}

	// Builds a prefix for a dndtype value based on a grid id.
	function makeDndTypePrefix(gridId) {
		return "dgrid-" + gridId + '-';
	}

	// Removes the grid id prefix from a dndtype value.  This allows the grid id to contain
	// a dash-number suffix.  This works only if a column is dropped on the grid from which it
	// originated.  Otherwise, a dash-number suffix will cause the regex to match on the wrong values.
	function stripIdPrefix(gridId, dndtype) {
		return dndtype.slice(makeDndTypePrefix(gridId).length);
	}
	
	var ColumnDndSource = declare(DndSource, {
		// summary:
		//		Custom dojo/dnd source extension configured specifically for
		//		dgrid column reordering.
		
		copyState: function(){ return false; }, // never copy
		
		checkAcceptance: function(source, nodes){
			return source == this; // self-accept only
		},
		
		_legalMouseDown: function(evt){
			// Overridden to prevent blocking ColumnResizer resize handles.
			return evt.target.className.indexOf("dgrid-resize-handle") > -1 ? false :
				this.inherited(arguments);
		},
		
		onDropInternal: function(nodes){
			var grid = this.grid,
				match = dndTypeRx.exec(stripIdPrefix(grid.id, nodes[0].getAttribute("dndType"))),
				structureProperty = match[2] ? "columnSets" : "subRows",
				oldSubRow = getMatchingSubRow(grid, match),
				columns = grid.columns;
			
			// First, allow original DnD logic to place node in new location.
			this.inherited(arguments);
			
			if(!match){ return; }
			
			// Then, iterate through the header cells in their new order,
			// to populate a new row array to assign as a new sub-row to the grid.
			// (Wait until the next turn to avoid errors in Opera.)
			setTimeout(function(){
				var newSubRow = arrayUtil.map(nodes[0].parentNode.childNodes, function(col) {
						return columns[col.columnId];
					}),
					eventObject;
				
				setMatchingSubRow(grid, match, newSubRow);
				
				eventObject = {
					grid: grid,
					subRow: newSubRow,
					column: columns[nodes[0].columnId],
					bubbles: true,
					cancelable: true,
					// Set parentType to indicate this is the result of user interaction.
					parentType: "dnd"
				};
				// Set columnSets or subRows depending on which the grid is using.
				eventObject[structureProperty] = grid[structureProperty];
				
				// Emit a custom event which passes the new structure.
				// Allow calling preventDefault() to cancel the reorder operation.
				if(on.emit(grid.domNode, "dgrid-columnreorder", eventObject)){
					// Event was not canceled - force processing of modified structure.
					grid.set(structureProperty, grid[structureProperty]);
				}else{
					// Event was canceled - revert the structure and re-render the header
					// (since the inherited logic invoked above will have shifted cells).
					setMatchingSubRow(grid, match, oldSubRow);
					grid.renderHeader();
					// After re-rendering the header, re-apply the sort arrow if needed.
					if (this._sort && this._sort.length){
						this.updateSortArrow(this._sort);
					}
				}
			}, 0);
		}
	});
	
	var ColumnReorder = declare(null, {
		// summary:
		//		Extension allowing reordering of columns in a grid via drag'n'drop.
		//		Reordering of columns within the same subrow or columnset is also
		//		supported; between different ones is not.
		
		// columnDndConstructor: Function
		//		Constructor to call for instantiating DnD sources within the grid's
		//		header.
		columnDndConstructor: ColumnDndSource,
		
		_initSubRowDnd: function(subRow, dndType){
			// summary:
			//		Initializes a dojo/dnd source for one subrow of a grid;
			//		this could be its only subrow, one of several, or a subrow within a
			//		columnset.
			
			var dndParent, c, len, col, th;
			
			for(c = 0, len = subRow.length; c < len; c++){
				col = subRow[c];
				if(col.reorderable === false){ continue; }
				
				th = col.headerNode;
				if(th.tagName != "TH"){ th = th.parentNode; } // from IE < 8 padding
				// Add dojoDndItem class, and a dndType unique to this subrow.
				put(th, ".dojoDndItem[dndType=" + dndType + "]");
				
				if(!dndParent){ dndParent = th.parentNode; }
			}
			
			if(dndParent){ // (if dndParent wasn't set, no columns are draggable!)
				this._columnDndSources.push(new this.columnDndConstructor(dndParent, {
					horizontal: true,
					grid: this
				}));
			}
		},
		
		renderHeader: function(){
			var dndTypePrefix = makeDndTypePrefix(this.id),
				csLength, cs;
			
			this.inherited(arguments);
			
			// After header is rendered, set up a dnd source on each of its subrows.
			
			this._columnDndSources = [];
			
			if(this.columnSets){
				// Iterate columnsets->subrows->columns.
				for(cs = 0, csLength = this.columnSets.length; cs < csLength; cs++){
					arrayUtil.forEach(this.columnSets[cs], function(subRow, sr){
						this._initSubRowDnd(subRow, dndTypePrefix + cs + "-" + sr);
					}, this);
				}
			}else{
				// Iterate subrows->columns.
				arrayUtil.forEach(this.subRows, function(subRow, sr){
					this._initSubRowDnd(subRow, dndTypePrefix + sr);
				}, this);
			}
		},
		
		_destroyColumns: function(){
			if(this._columnDndSources){
				// Destroy old dnd sources.
				arrayUtil.forEach(this._columnDndSources, function(source){
					source.destroy();
				});
			}
			
			this.inherited(arguments);
		}
	});
	
	ColumnReorder.ColumnDndSource = ColumnDndSource;
	return ColumnReorder;
});

},
'epi-cms/contentediting/editors/model/CollectionEditorModel':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/Evented",
    "dojo/Stateful",
    "dojo/when",
    "dojo/promise/all",

    "dijit/Destroyable",

    "dojox/mvc/StatefulArray",

    "epi/dependency",
    "epi/string",
    "epi/shell/command/DelegateCommand",

    "epi-cms/contentediting/editors/model/CollectionEditorItemModel",
    "epi-cms/dgrid/formatters",

    "epi/i18n!epi/nls/episerver.shared"
], function (
    array,
    declare,
    lang,

    aspect,
    Deferred,
    Evented,
    Stateful,
    when,
    all,

    Destroyable,

    StatefulArray,

    dependency,
    epiString,
    DelegateCommand,

    CollectionEditorItemModel,
    formatters,

    sharedResources
) {

    var commandMask = {
        // summary:
        //      Command mask enum.
        // tags:
        //      internal
        none: 0, add: 1, edit: 2, remove: 4, moveUp: 8, moveDown: 16
    };

    var CollectionEditorModel = declare([Stateful, Evented, Destroyable], {
        // summary:
        //      Model class for collection editor.
        //
        // tags:
        //      internal

        // data: Object[]
        //      The raw data collection.
        data: null,

        // itemType: String
        //      Server item type, which is used to retrieve item's metadata
        itemType: null,

        // itemModelType: Fuction
        //      Item Model constructor. Default is epi-cms/contentediting/editors/model/CollectionEditorItemModel.
        itemModelType: null,

        // itemMetadata: Object
        //      The item's metadata.
        itemMetadata: null,

        // metadataManager: Object
        //      The metadata manager reference.
        metadataManager: null,

        //  availableCommands: Object
        //      The available commands.
        availableCommands: null,

        // _itemModels: dojox/mvc/StatefulArray
        //      The item models array
        _itemModels: null,

        // _itemsUnchanged: Boolean
        //      Indicate that the items are unchanged (only order is changed)
        _itemsUnchanged: false,

        postscript: function () {
            // summary:
            //      Post script initialization.
            // description:
            //      Set default values.

            this.inherited(arguments);

            this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");

            this.itemModelType = this.itemModelType || CollectionEditorItemModel;
        },

        initialize: function () {
            // summary:
            //      Initialize the model.
            // return:
            //      A promise which resolves when initialization is done.
            // tags:
            //      public

            // Retrieve metadata and init data when finished.
            return when(this.metadataManager.getMetadataForType(this.itemType, null, true), lang.hitch(this, function (metadata) {
                // TODO: Don't retrieve metadata if we don't use it to generate columns
                this.set("itemMetadata", metadata);

                return this._initData();
            }));
        },

        _initData: function () {
            // summary:
            //      Initialize data.
            // return:
            //     A promise which resolves when all the data items are set up.
            // tags:
            //      private

            // Create a stateful array to hold item models.
            this._itemModels = new StatefulArray([]);
            this._itemsUnchanged = true;

            this.own(aspect.before(this._itemModels, "sort", lang.hitch(this, function () {
                // Turn on flag
                this._itemsUnchanged = true;
            }, true)));

            // Watch the item models for change.
            this.own(this._itemModels.watchElements(lang.hitch(this, function () {
                if (!this._itemsUnchanged) {
                    this.emit("itemsChanged", this.get("items"));
                }
                // Reset flag Sortorder
                this._itemsUnchanged = false;
            })));

            // Create initializer for each item.
            var itemInitializers = array.map(this.data, function (item) {
                var itemModel = new this.itemModelType();
                return when(itemModel.fromItemData(item, this.itemType), function () {
                    return itemModel;
                });
            }, this);

            // Perform item initialization.
            return when(all(itemInitializers), lang.hitch(this, function (itemModels) {
                // Add the created ones to the item models list.
                this._itemModels.splice.apply(this._itemModels, [0, this._itemModels.length].concat(itemModels));
                this.emit("initializeCompleted", this.get("items"));
            }));
        },

        getListCommands: function (availableCommands) {
            // summary:
            //      Return list level commands.
            // availableCommands:
            //      The available commands bitmask. This value is Not needed to be passed since it's set up when the model is created.
            // tags:
            //      public

            return [
                new DelegateCommand({
                    name: "add",
                    tooltip: sharedResources.action.add,
                    iconClass: "epi-iconPlus",
                    canExecute: true,
                    isAvailable: this._commandIsAvailable(commandMask.add, availableCommands),
                    delegate: lang.hitch(this, this.addItemDelegate)
                })
            ];
        },

        getItemCommands: function (item, availableCommands, category) {
            // summary:
            //      Return item level commands.
            // item:
            //      The item
            // availableCommands:
            //      The available commands bitmask. This value is Not needed to be passed since it's set up when the model is created.
            // category:
            //      The category
            // tags:
            //      public

            return [
                new DelegateCommand({
                    name: "edit",
                    category: "menuWithSeparator",
                    label: sharedResources.action.edit,
                    iconClass: "epi-iconPen",
                    model: item,
                    canExecute: true,
                    isAvailable: this._commandIsAvailable(commandMask.edit, availableCommands),
                    delegate: lang.hitch(this, this.editItemDelegate)
                }),


                new DelegateCommand({
                    name: "moveUp",
                    category: category,
                    label: sharedResources.action.moveup,
                    iconClass: "epi-iconUp",
                    model: item,
                    canExecute: this._itemModels.indexOf(item) > 0,
                    isAvailable: this._commandIsAvailable(commandMask.moveUp, availableCommands),
                    delegate: lang.hitch(this, this.moveItemUpDelegate)
                }),

                new DelegateCommand({
                    name: "moveDown",
                    category: "menuWithSeparator",
                    label: sharedResources.action.movedown,
                    iconClass: "epi-iconDown",
                    model: item,
                    canExecute: this._itemModels.indexOf(item) < this._itemModels.length - 1,
                    isAvailable: this._commandIsAvailable(commandMask.moveDown, availableCommands),
                    delegate: lang.hitch(this, this.moveItemDownDelegate)
                }),

                new DelegateCommand({
                    name: "remove",
                    category: category,
                    label: sharedResources.action.remove,
                    iconClass: "epi-iconTrash",
                    model: item,
                    canExecute: true,
                    isAvailable: this._commandIsAvailable(commandMask.remove, availableCommands),
                    delegate: lang.hitch(this, this.removeItemDelegate)
                })
            ];
        },

        _commandIsAvailable: function (command, availableCommands) {
            // summary:
            //      Test if the command is available according to the bitmask.
            // command:
            //      The command.
            // availableCommands:
            //      The available commands bitmask. Not needed to be passed since it's set up when the model is created.
            // tags:
            //      private

            availableCommands = availableCommands || this.availableCommands;

            return !!(command & availableCommands);
        },

        generateColumnsDefinition: function (excludedColumns) {
            // summary:
            //      Generate columns definition from item type's metadata.
            // excludedColumns:
            //      The columns which are excluded.
            // tags:
            //      public

            var columnDefinitions = {};

            array.forEach(array.filter(this.itemMetadata.properties, function (property) {
                // filter exlcuded properties
                return array.every(excludedColumns, function (col) {
                    return col !== property.name;
                });
            }), function (property) {
                var columnName = epiString.pascalToCamel(property.name);

                columnDefinitions[columnName] = {
                    // TODO: More options?
                    label: property.displayName || property.name
                };
            });

            return columnDefinitions;
        },

        generateFormatters: function (columnDefinitions) {
            // summary:
            //      Generate formatters for the specified column definitions.
            // columnDefinitions:
            //      The definition for the columns that should get the generated formatters.
            // tags:
            //      public

            for (var columnName in columnDefinitions) {
                array.some(this.itemMetadata.properties, function (property) {
                    if (columnName === epiString.pascalToCamel(property.name)) {
                        this._setTypeFormatter(property, columnDefinitions[columnName]);
                        this._setSelectionFactoryFormatter(property, columnDefinitions[columnName]);
                        this._setWrappingFormatter(columnDefinitions[columnName]);
                        return true;
                    }
                }, this);
            }
            return columnDefinitions;
        },

        _typeFormatterMap: {
            "System.DateTime": formatters.localizedDate,
            "System.Boolean": formatters.friendlyBoolean
        },

        _wrappingFormatterMap: {
            SecondaryText: function (formatter) {
                if (formatter) {
                    return function (value) {
                        return formatters.secondaryText(formatter(value), true);
                    };
                }

                return function (value) {
                    return formatters.secondaryText(value);
                };
            },
            VisibleLink: function (formatter) {
                if (formatter) {
                    return function (value) {
                        return formatters.visibleLink(formatter(value), true);
                    };
                }

                return function (value) {
                    return formatters.visibleLink(value);
                };
            }
        },

        _setTypeFormatter: function (property, columnDefinition) {

            for (var typeName in this._typeFormatterMap) {
                //nullable types in model type forces this "strange" check for type
                if (property.modelType.indexOf(typeName) > -1) {
                    columnDefinition.formatter = this._typeFormatterMap[typeName];
                    break;
                }
            }
        },

        _setSelectionFactoryFormatter: function (property, columnDefinition) {
            function formatValue(value) {
                var valueText = value;

                property.selections.forEach(function (selection) {
                    if (selection.value == value) {
                        valueText = selection.text;
                    }
                });

                return valueText;
            }

            if (property.selections && property.selections.length > 0) {
                if (columnDefinition) {
                    var isMultiSelect = property.uiType === "epi-cms/contentediting/editors/CheckBoxListEditor";

                    if (isMultiSelect) {
                        columnDefinition.formatter = function (value) {
                            if (!value) {
                                return value;
                            }
                            return value.split(",").map(formatValue).join(", ");
                        };
                    } else {
                        columnDefinition.formatter = formatValue;
                    }
                }
            }
        },

        _setWrappingFormatter: function (columnDefinition) {

            // summary:
            //      Sets the formatter on the column definition by using a wrapping formatter, if a wrapping formatter exists for the column definition.
            // columnDefinitions:
            //      The definition for the columns that should get the generated formatters.
            // tags:
            //      private
            if (columnDefinition.wrappingFormatter && this._wrappingFormatterMap[columnDefinition.wrappingFormatter]) {
                columnDefinition.formatter = this._wrappingFormatterMap[columnDefinition.wrappingFormatter](columnDefinition.formatter);
            }
        },

        //----------------------------------------------------------------------------------
        // Command delagate methods
        //----------------------------------------------------------------------------------
        addItemDelegate: function () {
            // summary:
            //      execute delegate for add command.
            // tags:
            //      protected

            this.emit("toggleItemEditor", null);
        },

        editItemDelegate: function (cmd) {
            // summary:
            //      execute delegate for edit command.
            // tags:
            //      protected
            if (this._commandIsAvailable(commandMask.edit, this.availableCommands)) {

                var item = cmd.model;
                var index = this._itemModels.indexOf(item);

                this.emit("toggleItemEditor", item, index);
            }
        },

        removeItemDelegate: function (cmd) {
            // summary:
            //      execute delegate for remove command.
            // tags:
            //      protected

            this.removeItem(cmd.model);
        },

        moveItemUpDelegate: function (cmd) {
            // summary:
            //      execute delegate for move up command.
            // tags:
            //      protected

            var item = cmd.model;
            var index = this._itemModels.indexOf(item);
            var refIndex = index - 1;

            if (refIndex >= 0) {
                this.moveItem(item, this._itemModels[refIndex], true);
            }
        },

        moveItemDownDelegate: function (cmd) {
            // summary:
            //      execute delegate for move down command.
            // tags:
            //      protected

            var item = cmd.model;
            var index = this._itemModels.indexOf(item);
            var refIndex = index + 1;

            if (refIndex < this._itemModels.length) {
                this.moveItem(item, this._itemModels[refIndex], false);
            }
        },

        //----------------------------------------------------------------------------------
        // Model manipulation API methods
        //----------------------------------------------------------------------------------
        saveItem: function (item, index) {
            // summary:
            //      Save an item.
            // item: Object
            //      The item raw data
            // index: Number
            //      The item index
            // tags:
            //      public

            var itemModel = new this.itemModelType();

            return when(itemModel.fromItemData(item, this.itemType), lang.hitch(this, function () {
                this._itemModels.splice(index, 1, itemModel);
            }));
        },

        addItem: function (item, refItem, before) {
            // summary:
            //      Add new item.
            // item: Object
            //      The item raw data
            // refItem: Object
            //      The reference item (item model instance)
            // before: Boolean
            //      Indicates that the new item should be added before the reference item.
            // tags:
            //      public

            var itemModel = new this.itemModelType();

            return when(itemModel.fromItemData(item, this.itemType), lang.hitch(this, function () {
                var refIndex;
                if (!refItem) {
                    // If we have no reference item, put new item to the end (Add from item editor case)
                    refIndex = this._itemModels.length;
                } else {
                    // Drop from external source
                    refIndex = this._itemModels.indexOf(refItem);

                    if (!before) {
                        refIndex++;
                    }
                }

                this._itemModels.splice(refIndex, 0, itemModel);
            }));
        },

        moveItem: function (item, refItem, before) {
            // summary:
            //      Move an item.
            // item: Object
            //      The item model instance
            // refItem: Object
            //      The reference item (item model instance)
            // before: Boolean
            //      Indicates that the new item should be moved before the reference item.
            // tags:
            //      public

            // Indicate that is still moving
            this._itemsUnchanged = true;

            var itemIndex = this._itemModels.indexOf(item);

            // Remove item
            this._itemModels.splice(itemIndex, 1);

            // Get ref index
            var refIndex = this._itemModels.indexOf(refItem);
            var targetIndex = before ? refIndex : refIndex + 1;
            //are we moving the same item? use itemIndex since refIndex will be -1;
            targetIndex = refIndex === -1 ? itemIndex : targetIndex;

            this._itemModels.splice(targetIndex, 0, item);
        },

        removeItem: function (item) {
            // summary:
            //      Remove an item.
            // item: Object
            //      The item model instance
            // tags:
            //      public

            var index = this._itemModels.indexOf(item);
            this._itemModels.splice(index, 1);
        },

        //----------------------------------------------------------------------------------
        // Property accessors
        //----------------------------------------------------------------------------------

        _dataSetter: function (value) {
            // summary:
            //      Set data property.
            // tags:
            //      private

            this.data = value;
            this._initData();
        },

        _dataGetter: function () {
            // summary:
            //      Get data property.
            // tags:
            //      private

            return array.map(this._itemModels, function (itemModel) {
                return itemModel.toItemData();
            }, this);
        },

        _itemsGetter: function () {
            // summary:
            //      Get items property.
            // tags:
            //      private

            return this._itemModels;
        }
    });

    CollectionEditorModel.commandMask = commandMask;

    return CollectionEditorModel;
});

},
'dojox/mvc/StatefulArray':function(){
define("dojox/mvc/StatefulArray", [
	"dojo/_base/lang",
	"dojo/Stateful"
], function(lang, Stateful){
	function update(/*dojox/mvc/StatefulArray*/ a){
		// summary:
		//		Set all array elements as stateful so that watch function runs.
		// a: dojox/mvc/StatefulArray
		//		The array.

		// Notify change of elements.
		if(a._watchElementCallbacks){
			a._watchElementCallbacks();
		}

		return a; // dojox/mvc/StatefulArray
	}

	var StatefulArray = function(/*Anything[]*/ a){
		// summary:
		//		An inheritance of native JavaScript array, that adds dojo/Stateful capability.
		// description:
		//		Supported methods are:
		//
		//		- pop() - Stateful update is done for the removed element, as well as the length.
		//		- push() - Stateful update is done for the added element, as well as the length.
		//		- reverse() - Stateful update is done for the elements.
		//		- shift() - Stateful update is done for the removed element, as well as the length.
		//		- sort() - Stateful update is done for the elements.
		//		- splice() - Stateful update is done for the removed/added elements, as well as the length. Returns an instance of StatefulArray instead of the native array.
		//		- unshift() - Stateful update is done for the added element, as well as the length.
		//		- concat() - Returns an instance of StatefulArray instead of the native Array.
		//		- join() - The length as well as the elements are obtained via stateful getters, instead of direct access.
		//		- slice() - The length as well as the elements are obtained via stateful getters, instead of direct access.
		//		- Setting an element to this array via set() - Stateful update is done for the new element as well as the new length.
		//		- Setting a length to this array via set() - Stateful update is done for the removed/added elements as well as the new length.

		var array = lang._toArray(a || []);
		var ctor = StatefulArray;
		ctor._meta = {bases: [Stateful]}; // For isInstanceOf()
		array.constructor = ctor;
		return lang.mixin(array, {
			pop: function(){
				return this.splice(this.get("length") - 1, 1)[0];
			},
			push: function(){
				this.splice.apply(this, [this.get("length"), 0].concat(lang._toArray(arguments)));
				return this.get("length");
			},
			reverse: function(){
				return update([].reverse.apply(this, lang._toArray(arguments)));
			},
			shift: function(){
				return this.splice(0, 1)[0];
			},
			sort: function(){
				return update([].sort.apply(this, lang._toArray(arguments)));
			},
			splice: function(/*Number*/ idx, /*Number*/ n){
				// summary:
				//		Removes and then adds some elements to an array.
				//		Updates the removed/added elements, as well as the length, as stateful.
				// idx: Number
				//		The index where removal/addition should be done.
				// n: Number
				//		How many elements to be removed at idx.
				// varargs: Anything[]
				//		The elements to be added to idx.
				// returns: dojox/mvc/StatefulArray
				//		The removed elements.

				var l = this.get("length");

				idx += idx < 0 ? l : 0;

				var p = Math.min(idx, l),
				 removals = this.slice(idx, idx + n),
				 adds = lang._toArray(arguments).slice(2);

				// Do the modification in a native manner except for setting additions
				[].splice.apply(this, [idx, n].concat(new Array(adds.length)));

				// Set additions in a stateful manner
				for(var i = 0; i < adds.length; i++){
					this.set(p + i, adds[i]);
				}

				// Notify change of elements.
				if(this._watchElementCallbacks){
					this._watchElementCallbacks(idx, removals, adds);
				}

				// Notify change of length.
				// Not calling the setter for "length" though, given removal/addition of array automatically changes the length.
				if(this._watchCallbacks){
					this._watchCallbacks("length", l, l - removals.length + adds.length);
				}

				return removals; // dojox/mvc/StatefulArray
			},
			unshift: function(){
				this.splice.apply(this, [0, 0].concat(lang._toArray(arguments)));
				return this.get("length");
			},
			concat: function(/*Array*/ a){
				return new StatefulArray([].concat.apply(this, arguments));
			},
			join: function(/*String*/ sep){
				// summary:
				//		Returns a string joining string elements in a, with a separator.
				// sep: String
				//		The separator.

				var list = [];
				for(var l = this.get("length"), i = 0; i < l; i++){
					list.push(this.get(i));
				}
				return list.join(sep); // String
			},
			slice: function(/*Number*/ start, /*Number*/ end){
				// summary:
				//		Returns partial elements of an array.
				// start: Number
				//		The index to begin with.
				// end: Number
				//		The index to end at. (a[end] won't be picked up)

				var l = this.get("length");

				start += start < 0 ? l : 0;
				end = (end === void 0 ? l : end) + (end < 0 ? l : 0);

				var slice = [];
				for(var i = start || 0; i < Math.min(end, this.get("length")); i++){
					slice.push(this.get(i));
				}
				return new StatefulArray(slice); // dojox/mvc/StatefuArray
			},
			watchElements: function(/*Function*/ callback){
				// summary:
				//		Watch for change in array elements.
				// callback: Function
				//		The callback function, which should take: The array index, the removed elements, and the added elements.

				var callbacks = this._watchElementCallbacks, _self = this;
				if(!callbacks){
					callbacks = this._watchElementCallbacks = function(idx, removals, adds){
						for(var list = [].concat(callbacks.list), i = 0; i < list.length; i++){
							list[i].call(_self, idx, removals, adds);
						}
					};
					callbacks.list = [];
				}

				callbacks.list.push(callback);

				var h = {};
				h.unwatch = h.remove = function(){
					for(var list = callbacks.list, i = 0; i < list.length; i++){
						if(list[i] == callback){
							list.splice(i, 1);
							break;
						}
					}
				}; 
				return h; // dojo/handle
			}
		}, Stateful.prototype, {
			set: function(/*Number|String*/ name, /*Anything*/ value){
				// summary:
				//		Sets a new value to an array.
				// name: Number|String
				//		The property name.
				// value: Anything
				//		The new value.

				if(name == "length"){
					var old = this.get("length");
					if(old < value){
						this.splice.apply(this, [old, 0].concat(new Array(value - old)));
					}else if(value > old){
						this.splice.apply(this, [value, old - value]);
					}
					return this;
				}else{
					var oldLength = this.length;
					Stateful.prototype.set.call(this, name, value);
					if(oldLength != this.length){
						Stateful.prototype.set.call(this, "length", this.length);
					}
					return this;
				}
			}
		});
	};

	return lang.setObject("dojox.mvc.StatefulArray", StatefulArray);
});

},
'epi/shell/command/DelegateCommand':function(){
﻿define("epi/shell/command/DelegateCommand", [
    "dojo/_base/declare",
    "epi/shell/command/_Command"
], function (declare, _Command) {

    return declare([_Command], {
        // summary:
        //      A command implementation which can delegate execution to an external model.
        //
        // tags:
        //      internal

        // delegate: Function
        //      The delegate method.
        delegate: null,

        _execute: function () {
            // summary:
            //      Execute the command
            // tags:
            //      protected

            // Execute the delagate. Alter the arguments to send this instance as the first parameter.
            return this.delegate ? this.delegate.apply(this, [this].concat(arguments)) : null;
        }
    });
});

},
'epi-cms/contentediting/editors/model/CollectionEditorItemModel':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful"
], function (
// Dojo
    array,
    declare,
    lang,
    Stateful
) {

    return declare([Stateful], {
        // summary:
        //      Item model class for collection editor.
        //
        // tags:
        //      internal

        // _itemDataProperties: Array
        //      An array populated with the property names of the source item
        _itemDataPropertyNames: null,

        _nameGetter: function () {
            // summary:
            //      Used by dnd avatar creation to get the avatar text.
            return this.name || this.text || "*";
        },

        fromItemData: function (itemData, typeIdentifier) {
            // summary:
            //      Create item model object from raw item data.
            // itemData: Object
            //      The raw item data.
            // typeIdentifier: String
            //      The meta data identifier of the backing data type
            // tags:
            //      public

            lang.mixin(this, itemData);

            this._itemDataPropertyNames = [];
            for (var propertyName in itemData) {
                if (Object.prototype.hasOwnProperty.call(itemData, propertyName)) {
                    this._itemDataPropertyNames.push(propertyName);
                }
            }

            this.typeIdentifier = typeIdentifier && typeIdentifier.toLowerCase();
        },

        toItemData: function () {
            // summary:
            //      Unwrap item model and return raw item data.
            // tags:
            //      public

            var result = {};

            array.forEach(this._itemDataPropertyNames, function (propertyName) {
                result[propertyName] = this.get(propertyName);
            }, this);

            return result;
        }
    });
});

},
'epi-cms/contentediting/editors/DefaultGridAssembler':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/json",
    "dojo/Stateful",

    // epi shell
    "epi",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/command/withConfirmation",

    // epi cms
    "epi-cms/dgrid/formatters"

],
function (
    // dojo
    array,
    declare,
    lang,

    json,
    Stateful,

    // epi shell
    epi,
    ButtonBuilder,
    withConfirmation,
    formatters
) {


    // Base grid assembler
    var _GridAssembler = declare([], {
        // gridType: Function
        //      The grid constructor.
        gridType: null,

        // gridSettings: Object
        //      The grid settings.
        gridSettings: null,

        // columnDefinitions: Array|Object
        //      The grid's column definition.
        columnDefinitions: null,

        // listCommands: Array<Command>
        //      The list level commands.
        listCommands: null,

        // itemCommandFactory: Array<Command>
        //      The item level commands.
        itemCommandsFactory: null,

        // summary:
        //      Construct _GridAssembler object.
        // params: Object
        //      The parameters.
        constructor: function (params) {
            lang.mixin(this, params);
        },

        // summary:
        //      Build the grid from given parameters.
        // gridNode: DomNode
        //      The dom node where the grid is created on.
        // listCommandNode: DomNode
        //      The dom node where the list command is created on.
        // tags:
        //      public abstract
        build: function (gridNode, listCommandNode) {
        },

        // summary:
        //      Instantiate a dgid object.
        // gridType: Function
        //      The grid constructor.
        // gridSettings: Object
        //      The grid settings.
        // columnDefinitions: Array|Object
        //      The grid's columns definition.
        // node: DomNode
        //      The dom node where the grid is created on.
        // tags:
        //      protected
        instantiateGrid: function (gridType, gridSettings, columnDefinitions, node) {
            return new gridType(lang.mixin(gridSettings, {
                columns: columnDefinitions,
                className: "epi-plain-grid epi-grid-height--auto"
            }), node);
        }
    });

    return declare([_GridAssembler], {
        // summary:
        //      Editor widget for collection like value.
        //
        // tags:
        //      public

        itemCommandProviderMap: null,

        constructor: function () {
            this.itemCommandProviderMap = {};
        },

        build: function (gridNode, listCommandNode) {
            // summary:
            //      Build the grid from given parameters.
            // gridNode: DomNode
            //      The dom node where the grid is created on.
            // listCommandNode: DomNode
            //      The dom node where the list command is created on.
            // tags:
            //      public, abstract

            // add an action column
            this.columnDefinitions["_epiGrid_Action"] = {
                renderHeaderCell: function () { }, // no header
                renderCell: lang.hitch(this, function (item, value, node, options) {
                    var commands = this._getItemCommands(item);
                    this.itemCommandProviderMap[json.stringify(item)] = new Stateful({
                        commands: commands
                    });
                    this.renderActionMenu(item, node, commands);
                }),
                className: "epi-columnNarrow",
                sortable: false
            };

            var grid = this.instantiateGrid(this.gridType, this.gridSettings, this.columnDefinitions, gridNode);
            grid.itemCommandProviderMap = this.itemCommandProviderMap;

            this._setupCommands(this.listCommands, listCommandNode);

            return grid;
        },

        renderActionMenu: function (item, node, commands) {

            node.innerHTML = commands && commands.length > 0 ?
                formatters.menu({
                    title: epi.resources.action.options
                }) : ""; //if there are no commands, dont render any context menu
        },

        _getItemCommands: function (item) {
            var commands = this.itemCommandsFactory(item, "context");
            array.some(commands, function (command) {
                if (command.name === "remove" && this.gridSettings.useDeleteWithConfirmation) {
                    command = withConfirmation(command, null, {
                        title: this.gridSettings.deleteConfirmationTitle,
                        description: this.gridSettings.deleteConfirmationMessage
                    });
                    return true;
                }
            }, this);
            return commands;
        },

        _setupCommands: function (commands, target) {
            // summary:
            //      Setup UI for commands on the target.
            // tags:
            //      private

            var builder = this.getListCommandBuilder();
            array.forEach(commands, function (command) {
                builder.create(command, target);
            }, this);
        },

        getListCommandBuilder: function () {
            return new ButtonBuilder({
                settings: {
                    showLabel: true
                },
                optionClass: "epi-menu--inverted",
                optionItemClass: "epi-radioMenuItem"
            });
        }
    });
});

},
'epi-cms/contentediting/editors/_AddItemDialogMixin':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    // epi
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/shell/widget/dialog/Dialog",
    // epi-cms
    "../../widget/_HasChildDialogMixin",
    "epi-cms/contentediting/DialogPositionAdjust",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.collectioneditor",
    "epi/i18n!epi/nls/episerver.shared"
], function (
    // dojo
    declare,
    lang,
    on,
    // epi
    _ValueRequiredMixin,
    Dialog,
    // epi-cms
    _HasChildDialogMixin,
    DialogPositionAdjust,
    // resources
    resources,
    sharedResources
) {
    return declare([_ValueRequiredMixin, _HasChildDialogMixin], {
        // tags:
        //      internal xproduct

        // itemEditorType: Function
        //      The item editor class.
        itemEditorType: null,

        _itemEditor: null,

        _dialog: null,

        // Set autofocus to false to prevent the validate the require fields when opening dialog.
        dialogParams: null,

        _editingItemIndex: null,

        postCreate: function () {
            this.inherited(arguments);

            this._dialogPositionAdjust = new DialogPositionAdjust();
            // Connect to model events
            this.own(
                on(this.model, "toggleItemEditor", lang.hitch(this, this._onToggleItemEditor)),
                this._dialogPositionAdjust
            );
        },

        _onToggleItemEditor: function (item, index) {
            // summary:
            //      The model's toggleItemEditor event handler.
            // item: Object
            //      The item to edit (Note that it is an item model instance, not the raw data item). If null, open item editor to create new item.
            // tags:
            //      private

            // In IE11 we have to set focus explicitly to ensure that onFocus from SideBySideEditorWrapper gets triggered
            this.onFocus();

            this._setupItemEditor();

            // Set data to item editor. (NOTE: Consider item model or raw data???)
            this._itemEditor.set("value", item);
            this._editingItemIndex = index;

            // Show the dialog.
            this._dialogPositionAdjust.adjustDialogPosition(this._dialog, function () {
                this._dialog.resize();
            }.bind(this));

            this.isShowingChildDialog = true;
            this._dialog.show();

            this._setDialogConfirmActionText(item);
            this._setDialogTitle(item);

            // Set confirm action status when showing dialog
            this._setDialogConfirmActionStatus(item);
        },

        _setupItemEditor: function () {
            // summary:
            //      Returns grid's columns definition.
            // tags:
            //      private

            // Create item editor
            this._itemEditor = this._createItemEditor();
            this.own(
                // Create dialog
                this._dialog = new Dialog(lang.mixin({
                    title: this._getDialogTitleText(),
                    content: this._itemEditor
                }, this.dialogParams))
            );
            // the dialog will own all events so they get destroyed when the dialog is destroyed
            this._dialog.own(
                this._itemEditor,
                this.connect(this._itemEditor, "onChange", "_setDialogConfirmActionStatus"),

                // Connect to dialog events
                on(this._dialog, "execute", lang.hitch(this, this._onDialogExecute)),
                on(this._dialog, "hide", lang.hitch(this, this._onCancelDialog))
            );
        },

        _createItemEditor: function () {
            return new this.itemEditorType({ metadata: this.model.get("itemMetadata"), doLayout: false });
        },

        _setDialogTitle: function (existingItem) {
            this._dialog.set("title", this._getDialogTitleText(existingItem));
        },

        _getDialogTitleText: function (existingItem) {
            return resources.title;
        },

        _onCancelDialog: function () {
            // summary:
            //      Sets isShowingChildDialog to false before calling the public callback onCancelDialog.
            // tags:
            //      protected

            this.isShowingChildDialog = false;
            this.onCancelDialog();
            this._dialogPositionAdjust.cleanup();
        },

        _onDialogExecute: function () {
            // summary:
            //      Validates the dialog before calling the public callback onExecuteDialog.
            // tags:
            //      protected

            if (this.validate()) {
                this._dialogPositionAdjust.cleanup();
                this.onExecuteDialog();
            }
        },

        onExecuteDialog: function () {
            // summary:
            //      Callback for when the dialog is executed.
            // tags:
            //      public
        },

        onCancelDialog: function () {
            // summary:
            //      Callback for when the dialog is cancelled.
            // tags:
            //      public
        },

        _setDialogConfirmActionText: function (existingItem) {
            this._dialog.onActionPropertyChanged({ name: this._dialog._okButtonName }, "label", this._getDialogConfirmActionText(existingItem));
        },

        _getDialogConfirmActionText: function (existingItem) {
            return existingItem ? sharedResources.action.ok : sharedResources.action.add;
        },

        _setDialogConfirmActionStatus: function (item) {
            this._dialog.onActionPropertyChanged({ name: this._dialog._okButtonName }, "disabled", !item || item === "");
        }
    });

});

},
'epi-cms/widget/_HasChildDialogMixin':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom",
    "dijit/_FocusMixin",
    "dijit/popup"
], function (
    declare,
    lang,
    aspect,
    dom,
    _FocusMixin,
    popup
) {

    return declare([_FocusMixin], {
        // summary:
        //    Base class for all EPiServer CMS property editor controls.
        // tags:
        //    public

        // isShowingChildDialog: [public] Boolean
        //    Indicates whether a child dialog window is currently being displayed.
        isShowingChildDialog: false,

        // _openedChildDialog: [private] Widget
        //      A reference to the currently open child dialog
        _openedChildDialog: null,

        // _waitingForFocus: [private] Boolean
        //      A flag indicating that the child dialog has been closed and we're waiting for a focus on this widget
        _waitingForFocus: false,

        startup: function () {
            // summary:
            //		startup widgets
            // tags:
            //		public

            if (!this._started) {
                this.own(
                    aspect.before(popup, "open", lang.hitch(this, "_onPopupOpen"), true),
                    aspect.after(popup, "close", lang.hitch(this, "_onPopupClosed"), true)
                );
            }

            this.inherited(arguments);
        },

        _onPopupOpen: function (openArgs) {
            // summary:
            //      Called before a popup is opened. Checks if the popup is opened for a descendant,
            //      and if so it's assumed to be a child dialog.
            // tags:
            //		private

            var popup = openArgs.popup;

            // If the popup is a context menu with a parent node then set the dijit focus handling.
            // This will keep the widget in the stack and not blur the owner widget.
            // The WithContextMenu mixin sets popupParent for grid context menus.
            if (popup && popup.popupParent) {
                return;
            }

            // currentTarget is the node clicked to open a pop-up menu
            var target = popup && popup.currentTarget;

            // if the popup is a opened for a descendant node, then it's opened for this widget
            // and we're entering "prevent blur" mode.
            if (target && dom.isDescendant(target, this.domNode)) {
                this._openedChildDialog = popup;
                this.isShowingChildDialog = true;
            }
        },

        _onPopupClosed: function (popup) {
            // summary:
            //      Called when a popup dialog has been closed
            // popup: Object
            //		The provided closed popup instance
            // tags:
            //		private

            if (this._openedChildDialog === popup) {
                this._openedChildDialog = null;
                this.isShowingChildDialog = false;

                // If the popup is closed by a click on this widget we get a focus call,
                // but when focus is lost to a widget which isn't a child of ours we need to explicitly
                // call _onBlur since we've prevented the original blur call when the pop-up was opened.
                // If we're still waiting for a focus call when _waitForFocus executes we've lost focus
                // to an element which is not a descendant.
                this._waitingForFocus = true;
                setTimeout(lang.hitch(this, "_waitForFocus"), 0);
            }
        },

        _waitForFocus: function () {
            // summary:
            //      Pop-up was closed and we should have received focus by now if we are the new focus target.
            // tags:
            //		private

            // _waitForFocus is called inside setTimeout. In some scenarios
            // the widget can be already destroyed
            if (this._destroyed) {
                return;
            }

            if (this._waitingForFocus) {
                this._waitingForFocus = false;
                this._onBlur();
            }
        },

        _onBlur: function () {
            // summary:
            //		This is where widgets do processing for when they stop being active,
            //		such as changing CSS classes.  See onBlur() for more details.
            // tags:
            //		protected

            if (this.isShowingChildDialog) {
                return;
            }

            this.inherited(arguments);
        },

        _onFocus: function () {
            // summary:
            //		This is where widgets do processing for when they are active,
            //		such as changing CSS classes.  See onFocus() for more details.
            // tags:
            //		protected

            this._waitingForFocus = false;

            if (this.isShowingChildDialog) {
                return;
            }

            this.inherited(arguments);
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/CollectionEditor.html':"﻿<div class=\"dijitInline\">\r\n    <div class=\"command-area\"><div data-dojo-attach-point=\"commandTargetNode\"></div></div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>",
'epi-cms/contentediting/editors/ContentAreaEditor':function(){
define([
    // Dojo
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/on",
    "dojo/topic",
    "dojo/when",
    "dojo/Stateful",

    //Dijit
    "dijit/registry",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_CssStateMixin",
    "dijit/_WidgetsInTemplateMixin",

    // EPi Framework
    "epi/dependency",
    "epi/shell/dnd/Target",
    "epi/shell/command/_CommandProviderMixin",
    "epi/shell/command/_Command",
    "epi/shell/applicationSettings",

    //EPi CMS
    "./_ContentAreaTree",
    "./_ContentAreaTreeModel",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel",
    "epi-cms/_ContentContextMixin",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/viewmodel/ContentAreaViewModel",
    "epi-cms/core/ContentReference",
    "epi/shell/widget/ContextMenu",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi-cms/widget/overlay/Block",
    "epi-cms/widget/command/CreateContentFromContentArea",
    "epi-cms/widget/command/CreateContentFromSelector",

    "epi-cms/widget/_HasChildDialogMixin",

    "epi-cms/contentediting/command/BlockRemove",
    "epi-cms/contentediting/command/BlockConvert",
    "epi-cms/contentediting/command/BlockEdit",
    "epi-cms/contentediting/command/ContentAreaItemBlockEdit",
    "epi-cms/contentediting/command/BlockInlineEdit",
    "epi-cms/contentediting/command/MoveToPrevious",
    "epi-cms/contentediting/command/MoveToNext",
    "epi-cms/contentediting/command/MoveOutsideGroup",
    "epi-cms/contentediting/command/Personalize",
    "epi-cms/contentediting/command/SelectDisplayOption",
    "epi-cms/contentediting/AllowedTypesList",
    "./_TextWithActionsMixin",

    // Resources
    "dojo/text!./templates/ContentAreaEditor.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.overlay.blockarea"
], function (

    // Dojo
    declare,
    aspect,
    domClass,
    domStyle,
    on,
    topic,
    when,
    Stateful,

    // Dijit
    registry,
    _WidgetBase,
    _TemplatedMixin,
    _CssStateMixin,
    _WidgetsInTemplateMixin,

    // EPi Framework
    dependency,
    Target,
    _CommandProviderMixin,
    _Command,
    shellApplicationSettings,

    // CMS
    _ContentAreaTree,
    _ContentAreaTreeModel,
    PersonalizedGroupViewModel,

    _ContentContextMixin,
    ApplicationSettings,
    ContentAreaViewModel,

    ContentReference,
    ContextMenu,
    _ValueRequiredMixin,
    BlockOverlay,
    CreateContentFromContentArea,
    CreateContentFromSelector,

    _HasChildDialogMixin,

    RemoveCommand,
    BlockConvertCommand,
    EditCommand,
    ContentAreaItemBlockEdit,
    BlockInlineEdit,
    MoveToPrevious,
    MoveToNext,
    MoveOutsideGroup,
    Personalize,
    SelectDisplayOption,
    AllowedTypesList, // used in template
    _TextWithActionsMixin,

    // Resources
    template,
    resources,
    blockAreaRes
) {

    return declare([
        _WidgetBase,
        _TemplatedMixin,
        _WidgetsInTemplateMixin,
        _CssStateMixin,
        _ValueRequiredMixin,
        _ContentContextMixin,
        _CommandProviderMixin,
        _HasChildDialogMixin,
        _TextWithActionsMixin
    ], {
        // summary:
        //      Editor for ContentArea to be able to edit my content area property in forms mode
        //      This should be a simple, non WYSIWYG listing of the inner content blocks with possibilities to add, remove and rearrange the content.
        //
        // tags:
        //      internal

        // baseClass: [public] String
        //    The widget's base CSS class.
        baseClass: "epi-content-area-wrapper",

        emptyClass: "epi-content-area-wrapper--empty",

        // res: Json object
        //      Language resource
        res: resources,

        // templateString: String
        //      UI template for content area editor
        templateString: template,

        // value: String
        //      Value of the content area
        value: null,

        // multiple: Boolean
        //  Value must be true, otherwise dijit/Form will trea the value as an object instead of an array
        multiple: true,

        // parent: Object
        //      Editor wrapper object containe the editor
        parent: null,

        // overlayItem: Object
        //      Source overlay of the content area in on page edit mode
        overlayItem: null,

        // model: Object
        //      Content area editor view model
        model: null,

        // intermediateChanges: Boolean
        //      Inherited from editor interface
        intermediateChanges: true,

        // editMode: String
        //      Flags to detect page edit mode (On page edit or Form edit mode or Create content mode)
        editMode: "onpageedit",

        // _preventOnBlur: [private] Boolean
        //      When set, the onBlur event is prevented.
        _preventOnBlur: false,

        _dndTarget: null,

        // allowedTypes: [public] Array
        //      The types which are allowed. i.e used for filtering based on AllowedTypesAttribute
        allowedTypes: null,

        // restrictedTypes: [public] Array
        //      The types which are restricted.
        restrictedTypes: null,

        // actionsResource: [Object]
        //      The resource of actions link
        actionsResource: blockAreaRes,

        // actionsResource: [Object]
        //      Name of constructor function of ContentAreaTree class
        treeClass: _ContentAreaTree,

        // allowMultipleItems: [Boolean]
        //      Allow dnd multiple items at once
        allowMultipleItems: true,

        constructor: function () {
            this.allowedDndTypes = [];
        },

        onChange: function (value) {
            // summary:
            //    Called when the value in the widget changes.
            // tags:
            //    public callback
        },

        onForceChange: function (value) {
            this.onChange(value);
        },

        _handleModelChange: function (value) {
            // summary:
            //    Called when the value in the model changes.
            // tags:
            //    public callback

            this.validate();
            this.onForceChange(value);

            this._toggleEmptyClass();
            if (this.model.selectedItem) {
                this.updateCommandModel(this.model.selectedItem);
            }

            this._toggleActionsContainer();
        },

        _toggleClass: function (node, className, condition) {
            (node || this.domNode).classList[condition ? "add" : "remove"](className);
        },

        _toggleEmptyClass: function () {
            this._toggleClass(this.domNode, this.emptyClass, !this.value || this.value.length <= 0);
        },

        _onBlur: function () {
            // summary:
            //      Override base to prevent the onBlur from being called when the _preventOnBlur flag is set.
            // tags:
            //      protected override

            if (this._preventOnBlur) {
                return;
            }
            this.inherited(arguments);
        },

        focus: function () {
            // summary:
            //    Focus the tree if there is a value, else focus the create block text.
            // tags:
            //    public
            if (this.tree && this.model.get("value").length > 0) {
                this._focusManager.focus(this.tree.domNode);
            } else {
                if (this.textWithLinks) {
                    this.textWithLinks.focus();
                }
            }
        },

        postMixInProperties: function () {

            this.inherited(arguments);

            this._commandSpliter = this._commandSpliter || new Stateful({
                category: "menuWithSeparator"
            });

            // NOTE: Check for this._commands to allow for mocking the commands without breaking _CommandProviderMixin.
            this.contentAreaItemBlockEdit = new ContentAreaItemBlockEdit({ category: null, isContentAreaReadonly: this.get("readOnly") });
            this.blockInlineEdit = new BlockInlineEdit();
            this.movePrevious = new MoveToPrevious();
            this.moveNext = new MoveToNext();

            this.commands = this._commands || [
                new EditCommand({ category: null }),
                this.contentAreaItemBlockEdit,
                this.blockInlineEdit,
                this._commandSpliter,
                new SelectDisplayOption(),
                this.movePrevious,
                this.moveNext,
                new RemoveCommand(),
                new BlockConvertCommand()
            ];

            this.own(on(this.contentAreaItemBlockEdit, "save", function (inlineBlockData, name) {
                this._preventOnBlur = false;

                var value = [];
                (this.model.getChildren() || []).forEach(function (child) {
                    if (child instanceof PersonalizedGroupViewModel) {
                        (child.getChildren() || []).forEach(function (child) {
                            if (child.id === this.model.selectedItem.id) {
                                child.inlineBlockData = inlineBlockData;
                                child.name = name;
                            }
                            value.push(child);
                        }.bind(this));
                    } else {
                        if (child.id === this.model.selectedItem.id) {
                            child.inlineBlockData = inlineBlockData;
                            child.name = name;
                        }
                        value.push(child);
                    }
                }.bind(this));
                value = value.map(function (v) {
                    return v.serialize();
                });

                this.set("value", value);

                // In order to be able to add a block when creating it from a floating editor
                // we need to set the editing parameter on the editors parent wrapper to true
                // since it has been set to false while being suspended when switching to
                // the secondaryView.
                this.parent = this.parent || this.getParent();
                this.parent.set("editing", true);
                this.onForceChange(value);

                // Now call onBlur since it's been prevented using the _preventOnBlur flag.
                this.onBlur();
            }.bind(this)));

            // Only add personalize command if the ui is not limited
            if (this._isPersonalizationEnabled()) {
                this.commands.splice(4, 0,
                    new Personalize({ category: null }),
                    new MoveOutsideGroup()
                );
            }
            this.commands.forEach(function (command) {
                this.own(command);
            }, this);

            this.own(
                //Create the view model
                this.model = this.model || new ContentAreaViewModel({
                    maxLength: this.maxLength,
                    minLength: this.minLength
                }),
                this.treeModel = this.treeModel || new _ContentAreaTreeModel({ model: this.model }),
                this.model.watch("selectedItem", function (name, oldValue, newValue) {
                    //Update the commands with the selected block
                    this.updateCommandModel(newValue);
                }.bind(this)),
                on(this.model, "changed", function () {
                    if (!this._started || this._supressValueChanged) {
                        return;
                    }

                    this._set("value", this.model.get("value"));

                    //Call to the handle model change with the new value
                    this._handleModelChange(this.value);
                }.bind(this))
            );
            // personalizationarea isn't an actual type so it needs to be hardcoded like in _ContentAreaTree
            this.allowedDndTypes.push("personalizationarea");
            this.allowedDndTypes.push(this._getInlineBlockDndKey());

            if (!this.contentDataStore) {
                var registry = dependency.resolve("epi.storeregistry");
                this.contentDataStore = registry.get("epi.cms.contentdata");
            }
        },

        buildRendering: function () {
            this.inherited(arguments);

            this.contextMenu = new ContextMenu();
            this.contextMenu.addProvider(this);

            this.own(this.contextMenu);

            this._setupActions(this.actionsContainer);

            this.own(this._dndTarget = new Target(this.actionsContainer, {
                accept: this.allowedDndTypes,
                reject: this.restrictedDndTypes,
                isSource: false,
                alwaysCopy: false,
                allowMultipleItems: this.allowMultipleItems,
                insertNodes: function () { }
            }));

            this.own(aspect.after(this._dndTarget, "onDropData", function (dndData, source, nodes, copy) {
                dndData.forEach(function (dndData) {
                    this.model.modify(function () {
                        this.model.addChild(dndData.data);
                    }.bind(this));
                }, this);

                if (!this.tree) {
                    this._createTree();
                }

            }.bind(this), true));

            // Handle focus after dropping on the tree or the drop area. We set focus to ourselves so that
            // it is not left where the drag originated.
            this.own(aspect.after(this._dndTarget, "onDrop", this.focus.bind(this)));
        },

        postCreate: function () {
            this.inherited(arguments);

            this.set("emptyMessage", resources.emptymessage);
            this._toggleEmptyClass();

            if (this.parent && this.overlayItem) {
                this.own(aspect.after(this.parent, "onStartEdit", function () {
                    this._selectFromOverlay(this.overlayItem.model);
                }.bind(this)));
            }

            this.own(topic.subscribe("/dnd/start", this._startDrag.bind(this)));
        },

        startup: function () {

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            this.tree && this.tree.startup();
            this.contextMenu.startup();
            this._updateStyle();

            this.own(
                this.allowedTypesHeader.watch("hasRestriction", this._updateStyle.bind(this))
            );
        },

        destroy: function () {
            this.tree && this.tree.destroyRecursive();

            this.inherited(arguments);
        },

        isCreateLinkVisible: function () {
            // summary:
            //      Overridden mixin class, depend on currentMode will show/not create link
            // tags:
            //      protected

            return this.model.canCreateBlock(this.allowedTypes, this.restrictedTypes);
        },

        onDialogExecute: function (selectedContent) {
            if (selectedContent) {
                this._saveValueAndFireOnChange({
                    contentLink: new ContentReference(selectedContent.contentLink).createVersionUnspecificReference().toString(),
                    name: selectedContent.name,
                    typeIdentifier: selectedContent.typeIdentifier
                });
            }
        },

        _saveValueAndFireOnChange: function (block) {
            this._preventOnBlur = false;
            var value = Object.assign([], this.model.get("value"), true);
            value.push(block);
            this.set("value", value);

            // In order to be able to add a block when creating it from a floating editor
            // we need to set the editing parameter on the editors parent wrapper to true
            // since it has been set to false while being suspended when switching to
            // the secondaryView.
            this.parent = this.parent || this.getParent();
            this.parent.set("editing", true);
            this.validate();
            this.onForceChange(value);

            // Now call onBlur since it's been prevented using the _preventOnBlur flag.
            this.onBlur();
        },

        executeAction: function (actionName) {
            // summary:
            //      Overridden mixin class executing click actions from textWithLinks widget
            // actionName: [String]
            //      Action name of link on content area
            // tags:
            //      public

            if (actionName === "createnewblock") {
                // HACK: Preventing the onBlur from being executed so the editor wrapper keeps this editor in editing state
                this._preventOnBlur = true;

                // since we're going to create a block, we need to hide all validation tooltips because onBlur is prevented here
                this.validate(false);

                var command = shellApplicationSettings.inlineBlocksInContentAreaEnabled ? new CreateContentFromContentArea({
                    allowedTypes: this.allowedTypes,
                    restrictedTypes: this.restrictedTypes
                }) : new CreateContentFromSelector({
                    creatingTypeIdentifier: "episerver.core.blockdata",
                    createAsLocalAsset: true,
                    isInQuickEditMode: this.isInQuickEditMode,
                    quickEditBlockId: this.quickEditBlockId,
                    autoPublish: true,
                    allowedTypes: this.allowedTypes,
                    restrictedTypes: this.restrictedTypes
                });

                command.set("model", {
                    save: this._saveValueAndFireOnChange.bind(this),
                    cancel: function () {
                        this._preventOnBlur = false;
                        this.onBlur();
                    }.bind(this)
                });
                command.execute();
            }
        },

        isValid: function (isFocused) {
            // summary:
            //    Check if widget's value is valid.
            // isFocused:
            //    Indicate that the widget is being focused.
            // tags:
            //    protected

            // When create block screen is visible, we need to hide all validation messages since onBlur is prevented.
            return (this._preventOnBlur || !this.required || this.model.get("value").length > 0);
        },

        _setReadOnlyAttr: function (readOnly) {
            this._set("readOnly", readOnly);
            this._toggleActionsContainer();

            if (this._source) {
                this._source.isSource = !this.readOnly;
            }

            if (this.model) {
                this.model.set("readOnly", readOnly);
            }

            this.tree && this.tree.set("readOnly", readOnly);
        },

        _toggleActionsContainer: function () {
            // summary:
            //    Hide actions when readonly or editor has reached the items limit
            // tags:
            //    private

            var visible = !this.model.hasReachedItemsLimit() && !this.get("readOnly");
            domStyle.set(this.actionsContainer, "display", visible ? "" : "none");
        },

        _checkAcceptance: function (source, nodes) {
            // summary:
            //      Customize checkAcceptance func
            // source: Object
            //      The source which provides items
            // nodes: Array
            //      The list of transferred items

            return this.readOnly ? false : this._source.defaultCheckAcceptance(source, nodes) && !this.model.hasReachedItemsLimit();
        },

        _createTree: function () {
            // summary:
            //    Creates the tree widget
            // tags:
            //    private

            //Create the tree
            this.tree = new this.treeClass({
                accept: this.allowedDndTypes,
                reject: this.restrictedDndTypes,
                contextMenu: this.contextMenu,
                model: this.treeModel,
                readOnly: this.readOnly,
                inlineBlockDndKey: this._getInlineBlockDndKey(),
                inlineBlockNameProperties: this.inlineBlockNameProperties
            }).placeAt(this.treeNode);

            this.tree.own(on(this.tree, "dblclick", function (itemModel) {
                if (itemModel.inlineBlockData) {
                    when(this.contentAreaItemBlockEdit.updateModel(itemModel)).then(function () {
                        this.contentAreaItemBlockEdit.execute();
                    }.bind(this));
                } else {
                    when(this.blockInlineEdit.updateModel(itemModel)).then(function () {
                        this.blockInlineEdit.execute();
                    }.bind(this));
                }
            }.bind(this)));

            this.tree.own(
                aspect.after(this.tree.dndController, "onDndEnd", this.focus.bind(this))
            );
        },

        _selectFromOverlay: function (overlayModel) {
            var child = overlayModel && overlayModel.selectedItem && overlayModel.selectedItem.serialize(),
                model = this.model,
                path = ["root"];

            // exit if there is no overlay model to select item
            if (!child) {
                return;
            }

            if (child.contentGroup) {
                model = model.getChild({ name: child.contentGroup });
                path.push(model.id);
            }
            model = model.getChild(child);
            if (!model) {
                return;
            }

            path.push(model.id);

            model.set("selected", true);
            model.set("ensurePersonalization", overlayModel.selectedItem.ensurePersonalization);

            // TODO: move this selection into tree instead
            this.tree && this.tree.set("path", path);

        },

        _startDrag: function (source, nodes, copy) {
            var accepted = this._dndTarget.accept && this._dndTarget.checkAcceptance(source, nodes);
            domClass.toggle(this.domNode, "dojoDndTargetDisabled", !accepted);

            // close the editor when user start draging Block from BlockArea
            //TODO: This widget should not call a method on the parent
            var widget = registry.getEnclosingWidget(nodes[0]);
            if (widget && widget.isInstanceOf(BlockOverlay) && this.parent && this.parent.cancel) {
                // We set isModified to false (default value) because always synchronize value
                // between OPE and Editor
                this.parent.set("isModified", false);
                this.parent.cancel();
            }
        },

        _ensureNonBrokenContentAreaItems: function (value) {
            var itemsList = value || [];
            itemsList.forEach(function (item) {
                if (!item || (!item.contentLink && !item.inlineBlockData)) {
                    item.isBrokenLink = true;
                    item.name = resources.brokenlink;
                }
            });
            return itemsList;
        },

        _setValueAttr: function (value) {
            value = this._ensureNonBrokenContentAreaItems(value);
            // Destroy the tree since that is the fastest way to remove all items
            this.tree && this.tree.destroyRecursive();

            this._set("value", value);

            this._supressValueChanged = true;
            this.model.set("value", value);
            this._supressValueChanged = false;

            // Create the tree again after the value has been set so
            // all tree nodes are created in one go
            this._createTree();

            this._toggleEmptyClass();
            this._toggleActionsContainer();
        },

        _updateStyle: function () {
            // summary:
            //      Handle the widget style depending on the allowedTypesList visibility

            if (!this.domNode) {
                return;
            }

            if (this.allowedTypesHeader.get("hasRestriction")) {
                domClass.remove(this.domNode, "allowed-types-list-hidden");
            } else {
                domClass.add(this.domNode, "allowed-types-list-hidden");
            }
        },

        _isPersonalizationEnabled: function () {
            var sectionsVisibility = Object.assign({}, ApplicationSettings.sectionsVisibility);
            if (sectionsVisibility.visitorGroups === false) {
                return false;
            }
            return !ApplicationSettings.limitUI;
        },

        _getInlineBlockDndKey: function () {
            return this.name + "_contentarea-inline-block";
        }
    });
});

},
'epi-cms/contentediting/editors/_ContentAreaTree':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/_base/event",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/on",
    "dijit/registry",
    "dojox/html/entities",

    "epi/dependency",
    "epi/shell/conversion/ObjectConverterRegistry",
    "epi/shell/dnd/tree/dndSource",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/Tree",

    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel",

    "./_BlockTreeNode",
    "./_GroupTreeNode"
], function (
    declare,
    aspect,
    event,
    array,
    lang,
    domClass,
    on,
    registry,
    entities,

    dependency,
    ObjectConverterRegistry,
    dndSource,
    TypeDescriptorManager,
    Tree,

    ContentBlockViewModel,
    PersonalizedGroupViewModel,
    _BlockTreeNode,
    _GroupTreeNode
) {

    return declare([Tree], {
        // tags:
        //      internal

        persist: false,
        showRoot: false,
        dndController: dndSource,
        betweenThreshold: 8,
        inlineBlockDndKey: "",
        inlineBlockNameProperties: {},

        // _typeDescriptorManager: [private] TypeDescriptorManager
        _typeDescriptorManager: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._typeDescriptorManager =  this._typeDescriptorManager || TypeDescriptorManager;
        },

        postCreate: function () {
            this.inherited(arguments);

            domClass.add(this.domNode, "epi-tree-mngr");

            this.own(aspect.after(this.dndController, "onDndItemRemoved", lang.hitch(this, function (dndData) {
                if (dndData[0] && dndData[0].data) {
                    this.model.deleteItem(dndData[0].data);
                }
            }), true));

            this.own(aspect.after(this, "_onItemChildrenChange", lang.hitch(this, function (parent, children) {
                array.forEach(children, function (child) {
                    var childNode = this._itemNodesMap[this.model.getIdentity(child)];

                    //Auto-expand the node
                    if (child.expandOnAdd) {
                        this._expandNode(childNode[0]);
                    }

                    //If the child does not have any roles auto show the personalization selector
                    //TODO: What happens if there are more children that does not have any roles??
                    if (child.contentGroup && child.ensurePersonalization && child.hasAnyRoles && !child.hasAnyRoles()) {
                        childNode[0].showPersonalizationSelector();
                    }
                }, this);
            }), true));
        },

        getTooltip: function (item) {
            // summary:
            //      Gets the label as the tooltip text if it exists.

            return item.tooltip || "";
        },

        getLabel: function (item) {
            // summary:
            //      Gets the label.

            var typeName = this._typeDescriptorManager.getTypeNameFromTypeId(item.contentTypeId);
            if (item.inlineBlockData && this.inlineBlockNameProperties && typeName) {
                var inlineBlockNamePropertyName = this.inlineBlockNameProperties[typeName.toLowerCase()];
                if (inlineBlockNamePropertyName) {
                    var propertyValue = item.inlineBlockData[inlineBlockNamePropertyName];
                    if (propertyValue) {
                        return entities.encode(propertyValue);
                    }
                }
            }

            return this.inherited(arguments);
        },

        _setReadOnlyAttr: function (readOnly) {
            this._set("readOnly", readOnly);

            if (this.dndController) {
                this.dndController.isSource = !readOnly;
            }
        },

        getItemType: function (item) {
            // summary:
            //      Resolve the type for each item. Called by the dnd source.

            if (item.inlineBlockData) {
                return [this.inlineBlockDndKey];
            }

            if (item.typeIdentifier) {
                var values = this._typeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");
                return values;
            } else if (item.contentGroup !== undefined) {
                //Since personalization items does not have a typeIdentifier we return a hardcoded type.
                return ["personalizationarea"];
            }
            return this.accept;
        },

        checkItemAcceptance: function (targetNode, source, position, copy) {
            if (this.tree.readOnly) {
                return false;
            }

            var targetTreeNode = registry.getEnclosingWidget(targetNode);
            var target = targetTreeNode.item;

            var accepts = true;
            source.forInSelectedItems(function (item) {
                accepts = this.tree.model.checkItemAcceptance(target, item.data.item, position);
            }, this);

            return accepts;
        },

        _onNodeMouseEnter: function (node) {
            node.set("mouseHover", true);
        },

        _onNodeMouseLeave: function (node) {
            node.set("mouseHover", false);
        },

        _createTreeNode: function (model) {
            var node;
            if (model.item instanceof PersonalizedGroupViewModel) {
                node = new _GroupTreeNode(model);
            } else if (model.item instanceof ContentBlockViewModel) {
                node = new _BlockTreeNode(model);
                this.own(on(node.domNode, "dblclick", function () {
                    this.emit("dblclick", model);
                }.bind(this)));
            } else {
                node = this.inherited(arguments);
            }

            //Set the context menu and the dndData for the node
            node.set("contextMenu", this.contextMenu);
            node.set("dndData", model.item);
            return node;
        },
        onClick: function (item, node, e) {

            //Auto expand/collapse the group tree node
            if (node instanceof _GroupTreeNode) {
                if (node.isExpanded) {
                    this._collapseNode(node);
                } else {

                    this._expandNode(node);
                }
            }
        }
    });
});

},
'epi-cms/contentediting/viewmodel/ContentBlockViewModel':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/promise/all",
    "dojox/html/entities",
    "epi",
    "epi/dependency",
    // Parent class and mixin
    "./_ViewModelMixin",
    "epi-cms/widget/viewmodel/ContentStatusViewModel",
    "epi-cms/dgrid/formatters",
    "epi/shell/TypeDescriptorManager",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize"
], function (
    declare,
    lang,
    when,
    all,
    entities,
    epi,
    dependency,
    // Parent class and mixin
    _ViewModelMixin,
    ContentStatusViewModel,
    formatters,
    TypeDescriptorManager,
    // Resources
    resources
) {

    return declare([ContentStatusViewModel, _ViewModelMixin], {
        // summary:
        //      The view model for a content block.
        //
        // tags:
        //      internal xproduct

        // label: [public] String
        //      The label used when displaying the block
        label: null,

        // store: [public] Visitor gruroup store
        //      The Visitor Groups store
        store: null,

        // hasSiblings: [public] Boolean
        //      Is true if the block has any siblings
        hasSiblings: true,

        // isVisible: [public] Boolean
        //      If the block could be seen it is true
        isVisible: true,

        // settings: [public] Object
        //      Settings object for the model
        settings: {
            // displayOptionsAttributeName: [public] String
            //      The name of the display options attribute put in the DOM
            displayOptionsAttributeName: "data-epi-content-display-option",

            // contentGroupAttributeName: [public] String
            //      The name of the content group attribute
            contentGroupAttributeName: "data-contentgroup"
        },

        // roles: [public] Array
        //      An array of the selected role objects.
        roles: null,

        // contentGroup: [public] String
        //      The name of the content group.
        contentGroup: null,

        // name: [public] String
        //      The block name.
        name: null,

        // contentTypeName: [public] String
        //      The name of the content type for the block
        contentTypeName: null,

        // roleIdentities: [public] Array
        //      An array of the role identities.
        roleIdentities: null,

        // typeIdentifier: [public] String
        //      The type identifier.
        typeIdentifier: null,

        // attributes: [public] Object
        //      HTML attributes on the widget.
        attributes: null,

        // attributes: [public] Object
        //      Dictionary of local blocks properties
        inlineBlockData: null,

        constructor: function () {
            this.roleIdentities = this.roleIdentities || [];
            this.attributes = {};
        },

        postscript: function () {
            this.inherited(arguments);

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.visitorgroup");
            }

            this.contentTypeName = this.contentTypeName || (this.typeIdentifier && TypeDescriptorManager.getResourceValue(this.typeIdentifier, "name"));

            this.set("label", this.name);
            this.updateTooltip();
            this._reloadRoles();
        },

        serialize: function () {
            return {
                contentGroup: this.contentGroup,
                contentLink: this.contentLink,
                name: this.name,
                roleIdentities: this.roleIdentities,
                typeIdentifier: this.typeIdentifier,
                attributes: this.attributes,
                inlineBlockData: this.inlineBlockData,
                contentTypeId: this.contentTypeId
            };
        },

        equals: function (item) {
            // summary:
            //      Returns true if this content block is the same as the given item at a property level.
            // tags:
            //      public
            for (var prop in item) {
                if (!epi.areEqual(this[prop], item[prop])) {
                    return false;
                }
            }
            return true;
        },

        isRoleSelected: function (roleId) {
            // summary:
            //      Returns true if the roles is selected
            // roleId: Guid
            //      The id of the role to check
            // tags:
            //      public

            if (!this.roleIdentities) {
                return false;
            }

            return this.roleIdentities.indexOf(roleId) > -1;
        },

        hasAnyRoles: function () {
            // summary:
            //      Returns true if there are any selected roles
            // tags:
            //      public
            if (!this.roleIdentities) {
                return false;
            }

            return this.roleIdentities.length > 0;
        },

        moveNext: function () {
            // summary:
            //      Move this instance to the next index in the parents child list
            // tags:
            //      internal
            var index = this.parent.indexOf(this);
            this.parent.modify(function () {
                this.parent.move(this, index + 1);
            }, this);
        },

        movePrevious: function () {
            // summary:
            //      Move this instance to the previous index in the parents child list
            // tags:
            //      internal
            var index = this.parent.indexOf(this);
            this.parent.modify(function () {
                this.parent.move(this, index - 1);
            }, this);
        },

        moveOutsideGroup: function () {
            // summary:
            //      If the block is inside a gruop move it outside
            // tags:
            //      internal

            if (!this.contentGroup) {
                return;
            }

            this.parent.modify(function () {
                this.parent.moveOutsideGroup(this);
            }, this);
        },

        remove: function () {
            // summary:
            //      Removes the block from the parent
            // tags:
            //      internal
            this.parent.modify(function () {
                this.parent.removeChild(this);
            }, this);
        },

        personalize: function () {
            // summary:
            //      Personalizes the block
            // tags:
            //      internal

            this.parent.modify(function () {
                this.parent.personalize(this);
            }, this);
        },

        selectRole: function (roleId, select) {
            // summary:
            //      Selects or unselects the role depending on the select param
            //  roleId: Guid
            //      The role id to select/unselect
            //  select: Boolean
            //      True of false depending on if the role should be selected or unselected
            var identities = (this.roles || []).map(function (role) {
                return role.id;
            });

            var index = identities.indexOf(roleId);

            if (index >= 0) {
                if (!select) {
                    identities.splice(index, 1);
                }
            } else if (select) {
                identities.push(roleId);
            }

            //Set the roleIdenties again to emit a change event
            this.set("roleIdentities", identities);
        },

        resetRoleIdentities: function () {
            // summary:
            //      Resets the role identities for the block
            // tags:
            //      public

            this.set("visible", true);
            this.set("roleIdentities", null);
        },

        updateTooltip: function () {
            this.set("tooltip", formatters.title(this.name, this.contentLink, this.contentTypeName));
        },

        _displayOptionSetter: function (option) {
            // summary:
            //      Sets the display options attribute on the attribute list
            // tags:
            //      public
            this.attributes[this.settings.displayOptionsAttributeName] = option;
        },

        _displayOptionGetter: function () {
            // summary:
            //      Gets the display options attribute from the attribute list
            // tags:
            //      public
            return this.attributes[this.settings.displayOptionsAttributeName];
        },

        _roleIdentitiesSetter: function (roleIdentities) {
            this.roleIdentities = roleIdentities || [];

            this._reloadRoles();
        },

        _parentSetter: function (parent) {
            this.parent = parent;

            this.set("contentGroup", this.parent.name);
        },

        _contentGroupSetter: function (contentGroup) {
            this.contentGroup = contentGroup || "";
            this.attributes[this.settings.contentGroupAttributeName] = this.contentGroup;
            this._reloadRoles();
        },

        _reloadRoles: function () {
            var store = this.store;

            if (!store) {
                return;
            }

            // Get the role object from the store for each identity.
            var promise = all(this.roleIdentities.map(function (id) {
                return when(store.get(id)).otherwise(function () {
                    // Must return a deferred that doesn't fail otherwise roles will never be set.
                    // So just log a warning that we couldn't load the given vistor group.
                    console.warn("Could not load visitor group with id: " + id);
                });
            }));

            // Run this callback as a seperate chain so that this method
            // returns a promise that resolves in an array of roles.
            promise.then(lang.hitch(this, "set", "roles"));

            return promise;
        },

        _hasSiblingsSetter: function (hasSiblings) {
            this.hasSiblings = hasSiblings;

            this._updateRolesString();
        },

        _selectedSetter: function (selected) {
            this.selected = selected;

            if (selected) {
                this.emit("selected", this);
            }
        },

        _updateRolesString: function () {
            if (!this.contentGroup || this.roles === null) {
                this.set("rolesString", "");
                return;
            }

            if (!this.hasAnyRoles()) {
                if (this.hasSiblings) {
                    this.set("rolesString", resources.everyoneelsesee);
                } else {
                    this.set("rolesString", resources.everyonesees);
                }

                return;
            }

            // If roles has no length then all the selected roles have been removed from the system.
            // Display a specific message that explains this scenario.
            if (!this.roles.length) {
                this.set("rolesString", resources.groupcannotsees);
                return;
            }

            var namesCommaList = this.roles.map(function (r) {
                return "<em>" + entities.encode(r.name) + "</em>";
            }).sort().join(", ");
            var names = namesCommaList.replace(/, (?=[^,]+$)/, " " + resources.groupsand); // an extra space cause resource trims leading whitespace

            var rolesString = "";
            if (this.roles.length > 1) {
                rolesString = lang.replace(resources.groupssee, { groupNames: names });
            } else {
                rolesString = lang.replace(resources.groupsees, { groupName: names });
            }

            this.set("rolesString", rolesString);
        },

        _rolesSetter: function (roles) {
            // Filter out any roles that are undefined. This can happen if someone
            // deletes a visitor group that is in use.
            this.roles = roles.filter(function (role) {
                return !!role;
            });

            this._updateRolesString();
        }
    });
});

},
'epi-cms/contentediting/viewmodel/_ViewModelMixin':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/Evented",
    "dijit/Destroyable"
], function (array, declare, Stateful, Evented, Destroyable) {
    //TODO: Rename to _ViewModel

    return declare([Stateful, Evented, Destroyable], {
        // tags:
        //      public

        modify: function (callback, scope, emitChanged) {
            // summary:
            //      Method used to wrap several changes in one "operation"
            //      When the callback has been executed the "changed" event will be emitted
            //
            // callback: function
            //      Function to execute
            //
            // scope: Object?
            //      The scope that the callback should be executed in
            //
            // emitChanged: Boolean?
            //      Whether the "changed" event should be emitted after the changes have been applied.
            //      Default is true.

            this._isBeingModified = true;
            if (scope) {
                callback.apply(scope);
            } else {
                callback();
            }
            this._isBeingModified = false;

            if (emitChanged || emitChanged === undefined) {
                this.emit("changed");
            }
        },

        emit: function (type, event) {

            if (type === "changed" && this._isBeingModified) {
                return;
            }

            this.inherited(arguments);
        }
    });
});

},
'epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel':function(){
define([
    // General application modules
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    // Parent class
    "epi-cms/contentediting/viewmodel/_ContainerViewModel",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize"
], function (array, declare, lang, _ContainerViewModel, resources) {

    return declare([_ContainerViewModel], {
        // summary:
        //      The view model for a personalized group.
        //
        // tags:
        //      internal

        // name: [public] String
        //      The name of the personalized group.
        name: null,

        // name: [public] String
        //      The label used when displaying the group
        label: resources.grouplabel,

        addChild: function (child, index) {
            // summary:
            //      Adds a child to the view model at the given index or at the end of the collection.
            // child: Object
            //      The child to be added.
            // index: Number?
            //      The index where to the child will be inserted.
            // tags:
            //      public

            // Add new child first instead of last when no index is given
            this.inherited(arguments, [child, index || 0]);

            // Propagate all selection and changed events from children.
            this.ownByKey(child.id,
                child.on("selected", lang.hitch(this, "emit", "selected", child)),
                child.on("changed", lang.hitch(this, "emit", "changed"))
            );
        },

        serialize: function () {
            // summary:
            //      Serialize the view model's children to an array.
            // tags:
            //      public
            return array.map(this.getChildren(), function (child) {
                return child.serialize();
            });
        },

        equals: function (item) {
            // summary:
            //      Returns true if this groups name is the same as the name on the given item.
            // tags:
            //      public
            return this.name === item.name;
        },

        moveNext: function () {
            // summary:
            //      Move this instance to the next index in the parents child list
            // tags:
            //      internal

            var index = this.parent.indexOf(this);
            this.parent.modify(function () {
                this.parent.move(this, index + 1);
            }, this);
        },

        moveOutsideGroup: function (child) {
            this.parent.moveOutsideGroup(child);
        },

        movePrevious: function () {
            // summary:
            //      Move this instance to the previous index in the parents child list
            // tags:
            //      internal

            var index = this.parent.indexOf(this);
            this.parent.modify(function () {
                this.parent.move(this, index - 1);
            }, this);
        },

        remove: function () {
            // summary:
            //      Removes the group from the parent
            // tags:
            //      internal

            this.parent.modify(lang.hitch(this, function () {
                this.parent.removeChild(this);
            }));
        },

        _hash: function (child) {
            // summary:
            //      Creates a hash for the given child.
            // tags:
            //      protected
            return child.contentLink + "_" + Date.now();
        },

        _selectedSetter: function (selected) {
            this.selected = selected;
            if (selected) {
                this.emit("selected", this);
            }
        },

        _visibleGetter: function () {
            return array.some(this._data, function (item) {
                return item.get("visible");
            });
        }
    });
});

},
'epi-cms/contentediting/viewmodel/_ContainerViewModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "epi/shell/DestroyableByKey",
    "./_ViewModelMixin"
], function (array, declare, DestroyableByKey, _ViewModelMixin) {

    return declare([_ViewModelMixin, DestroyableByKey], {
        // summary:
        //      Base class for container view models.
        // remarks:
        //      Classes inheriting this class should own all child related handles using the child.id, as they will
        //      be destroyed by this class.
        // tags:
        //      internal

        constructor: function () {
            this._data = [];
        },

        destroy: function () {
            this.inherited(arguments);

            // Recursively destroy child view models.
            this._data.forEach(function (item) {
                if (item.destroy) {
                    item.destroy();
                }
            });
        },

        addChild: function (child, index) {
            // summary:
            //      Adds a child to the view model at the given index or at the end of the collection.
            // remarks:
            //      The child will get an 'id' property if it does not already have one. This id should be used ownByKey
            //      when owning any handles from the child.
            // child: Object
            //      The child to be added.
            // index: Number?
            //      The index where to the child will be inserted.
            // tags:
            //      public

            child.set("parent", this);
            child.set("readOnly", this.readOnly);

            // Set the id property to the contentLink or group name so that we have unique children.
            child.id = this._hash(child);

            if (typeof index == "number") {
                this._data.splice(index, 0, child);
            } else {
                this._data.push(child);
            }

            this._emitChildrenChanged();
        },

        getChild: function (item) {
            // summary:
            //      Get the first child whose properties match the properties on the given item.
            // tags:
            //      public
            var children = this._data;

            for (var i = children.length - 1; i >= 0; i--) {
                if (children[i].equals(item)) {
                    return children[i];
                }
            }

            return null;
        },

        getChildById: function (id) {
            //TODO: Consider removing this
            var children = this._data;

            for (var i = children.length - 1; i >= 0; i--) {
                if (children[i].id === id) {
                    return children[i];
                }
            }

            return null;
        },

        getChildByIndex: function (index) {
            // summary:
            //      Return the indexed child.
            // tags:
            //      public
            return this._data[index];
        },

        getChildren: function () {
            // summary:
            //      Get the children of the view model.
            // tags:
            //      public
            return this._data;
        },

        removeChild: function (child, recursive) {
            // summary:
            //      Remove a child from the view model.
            // tags:
            //      public
            var index = this.indexOf(child);

            if (index < 0) {
                if (recursive) {
                    this.getChildren().slice().forEach(function (item) {
                        if (typeof item.removeChild === "function") {
                            item.removeChild(child, recursive);
                        }
                    });
                }
                return;
            }

            // Ensure child is a model instance.
            child = this.getChildByIndex(index);

            // Destroy all handles related to this child before destroying the child
            this.destroyByKey(child.id);
            child.destroy();
            this._data.splice(index, 1);

            this._emitChildrenChanged();
        },

        move: function (child, index) {
            // summary:
            //      Moves the child to a specific index
            // child: Object
            //      The child to be moved.
            // index: Number
            //      The index where to the child will be moved to.
            // tags:
            //      public
            var sourceIndex = this.indexOf(child);

            // Remove the child
            this._data.splice(sourceIndex, 1);

            // Insert it again at the new index
            this._data.splice(index, 0, child);

            this._emitChildrenChanged();
        },

        indexOf: function (child) {
            // summary:
            //      Returns the index of the child in the list of children
            // child: Object
            //      The child to find the index for
            var result = this._data.indexOf(child);

            if (result >= 0 || !child || typeof child.id === "undefined") {
                return result;
            }

            // fallback to finding child by id
            for (var i = 0; i < this._data.length; i++) {
                if (this._data[i].id === child.id) {
                    return i;
                }
            }
            return -1;
        },

        _hash: function (child) {
            // summary:
            //      Creates a hash for the given child.
            // tags:
            //      abstract
        },

        _readOnlySetter: function (readOnly) {
            this.readOnly = readOnly;

            array.forEach(this.getChildren(), function (child) {
                child.set("readOnly", readOnly);
            }, this);
        },

        _emitChildrenChanged: function (sender) {
            // summary:
            //      Emits children changed event
            // sender: Object?
            //      The sender
            // tags:
            //      protected, internal

            var length = this._data.length;
            array.forEach(this._data, function (child, index) {
                child.set("canMoveNext", index < (length - 1));
                child.set("canMovePrevious", index > 0 && index <= (length - 1));
                child.set("hasSiblings", length > 1);
            });

            this.set("count", length || 0);

            this.emit("childrenChanged", sender ? sender : this);
        }
    });
});

},
'epi-cms/contentediting/editors/_BlockTreeNode':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/keys",
    "dojo/dom-class",
    "dojo/on",
    "dojo/when",
    "dijit/Tree",
    "dijit/focus",
    "dijit/_HasDropDown",

    "epi/shell/applicationSettings",

    // epi-cms
    "epi-cms/widget/PersonalizationSelector",
    "epi-cms/dgrid/formatters",
    "./_ContentAreaTreeNodeMixin",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.blockcontextmenu",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea",
    "dojo/text!./templates/_BlockTreeNode.html"
], function (
    // dojo
    declare,
    lang,
    keys,
    domClass,
    on,
    when,
    Tree,
    focusUtil,
    _HasDropDown,

    applicationSettings,

    // epi-cms
    PersonalizationSelector,
    formatters,
    _ContentAreaTreeNodeMixin,

    // resources
    tooltip,
    resources,
    template
) {

    return declare([Tree._TreeNode, _ContentAreaTreeNodeMixin, _HasDropDown], {
        // tags:
        //      internal

        templateString: template,

        _contextMenuClass: "epi-iconContextMenu",
        isExpandable: false,
        dropDownPosition: ["before"],
        resources: lang.mixin(tooltip, resources.personalize, { shared: resources.shared }),

        buildRendering: function () {
            this.inherited(arguments);

            this.dropDown = new PersonalizationSelector({ model: this.item });
            this.own(this.dropDown);
            this.aroundNode = this.domNode;
            this.set("readOnly", this.item.readOnly);

            domClass.add(this.domNode, "epi-tree-mngr--block");

            var node = this.rolesNode;

            // Get the icon from the type descriptor
            var iconClass = formatters.contentIconClass(this.item.typeIdentifier);
            domClass.add(this.iconNode, iconClass);

            node.innerHTML = this.item.get("rolesString");
            this.own(this.item.watch("rolesString", lang.hitch(this, function (property, oldValue, newValue) {
                node.innerHTML = newValue;
            })));

            this.own(this.item.watch("readOnly", lang.hitch(this, function () {
                this.set("readOnly", this.item.readOnly);
            })));

            this.own(on(this.item, "changed", function () {
                this.item.updateTooltip();
                this.set("item", this.item);
                this.set("label", this.item.label);
                this.set("tooltip", this.item.tooltip);
            }.bind(this)));

            if (this.item.isBrokenLink) {
                domClass.add(this.iconNode, "epi-iconWarning");
            }
        },

        setSelected: function (selected, internalSelect) {
            this.inherited(arguments);

            this.item.set("selected", selected);

            domClass.toggle(this.iconNodeMenu, this._contextMenuClass, selected);
        },

        showPersonalizationSelector: function () {
            if (this.readOnly) {
                return;
            }

            this.item.set("ensurePersonalization", false);

            focusUtil.focus(this.labelNode);

            this.loadAndOpenDropDown();
        },

        focus: function () {
            // summary:
            //      We need this method because _HasDropDown calls focus when toggling the dropdown
            this.labelNode.focus();
        },

        _onKey: function (/*Event*/ e) {
            // summary:
            //      We need to override the default behaviour otherwise the dropdown will popup
            //      when we click the downarrow on the tree node
            if (this.dropDown && this._opened && e.keyCode === keys.ESCAPE) {
                this.closeDropDown();
            }
        },

        _onKeyUp: function () {

        },

        _setItemAttr: function (item) {
            this._set("item", item);
            this.sharedIndicatorNode.classList.toggle("dijitHidden", !applicationSettings.inlineBlocksInContentAreaEnabled || (item && item.inlineBlockData));
        }
    });
});

},
'epi-cms/widget/PersonalizationSelector':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/when",
    "dojox/html/entities",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/CheckedMenuItem",
    "epi/dependency",
    // Resouces
    "dojo/text!./templates/PersonalizationSelector.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize",
    // Widgets used in template
    "dijit/Menu",
    "epi/shell/widget/RadioMenuItem"
], function (
    array,
    declare,
    lang,
    Stateful,
    when,
    entities,
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    CheckedMenuItem,
    dependency,
    // Resouces
    template,
    resources
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // tags:
        //      internal

        templateString: template,

        model: null,

        resources: resources,

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.visitorgroup");
            }
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(
                this.rdEveryone.on("change", lang.hitch(this, "restoreDefault")),
                this.model.watch("roleIdentities", lang.hitch(this, function () {
                    if (!this.rdEveryone.checked && this.model.roleIdentities && this.model.roleIdentities.length === 0) {
                        this.restoreDefault();
                    }
                }))
            );

            //Query the store for all groups
            when(this.store.query(), lang.hitch(this, function (groups) {
                if (!this._destroyed) {
                    this.set("visitorGroups", groups);
                }
            }));
        },

        restoreDefault: function () {
            array.forEach(this.visitorGroupsMenu.getChildren(), function (item) {
                item.set("checked", false);
            });

            this.rdEveryone.set("checked", true);
            this.model.modify(function () {
                this.model.resetRoleIdentities();
            }, this);
        },

        _setVisitorGroupsAttr: function (groups) {
            this._set("visitorGroups", groups);

            if (!this.model.hasAnyRoles()) {
                this.rdEveryone.set("checked", true);
            }

            array.forEach(groups, function (group) {

                var item = new CheckedMenuItem({
                    label: entities.encode(group.name),
                    visitorgroupId: group.id,
                    checked: this.model.isRoleSelected(group.id)
                });

                this.own(item.watch("checked", lang.hitch(this, function (property, oldValue, newValue) {
                    this.model.modify(function () {
                        this.model.selectRole(group.id, newValue);
                    }, this);

                    this.rdEveryone.set("checked", !this.model.hasAnyRoles());
                })));

                this.visitorGroupsMenu.addChild(item);
            }, this);
        }
    });
});

},
'url:epi-cms/widget/templates/PersonalizationSelector.html':"﻿<div class=\"epi-menu--inverted\">\r\n    <div class=\"epi-dijitTooltipContainer\">\r\n        <div class=\"epi-invertedTooltip\">\r\n            <div class=\"epi-tooltipDialogTop\">\r\n                <span data-dojo-attach-point=\"header\">${resources.whocansee}</span>\r\n            </div>\r\n        </div>\r\n        <div class=\"epi-tooltipDialogContent--max-height\">\r\n            <div data-dojo-type=\"dijit/Menu\" data-dojo-attach-point=\"visitorGroupsMenu\" style=\"width:100%\"></div>\r\n            <div class=\"epi-menuSeparator\" tabindex=\"-1\"></div>\r\n            <div data-dojo-type=\"dijit/Menu\" data-dojo-attach-point=\"filterOptionsMenu\" style=\"width:100%\">\r\n                <div data-dojo-attach-point=\"rdEveryone\" data-dojo-type=\"epi/shell/widget/RadioMenuItem\" data-dojo-props=\"label:'${resources.everyone}', value: ''\"></div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi/shell/widget/RadioMenuItem':function(){
require({cache:{
'url:epi/shell/widget/templates/RadioMenuItem.htm':"﻿<tr class=\"dijitReset dijitMenuItem\" data-dojo-attach-point=\"focusNode\" role=\"menuitemradio\" tabIndex=\"-1\">\r\n\t<td class=\"dijitReset dijitMenuItemIconCell\" role=\"presentation\">\r\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon dijitCheckedMenuItemIcon\" data-dojo-attach-point=\"iconNode\"/>\r\n\t\t<span class=\"dijitCheckedMenuItemIconChar\">&#10003;</span>\r\n\t</td>\r\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\"><span class=\"dijitInline dijitReset dijitIcon\" data-dojo-attach-point=\"labelIconNode\"></span> <span data-dojo-attach-point=\"containerNode, labelNode\"></span></td>\r\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" data-dojo-attach-point=\"accelKeyNode\"></td>\r\n\t<td class=\"dijitReset dijitMenuArrowCell\" role=\"presentation\">&#160;</td>\r\n</tr>"}});
﻿define("epi/shell/widget/RadioMenuItem", [
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-class",
    "dijit/CheckedMenuItem",
    "dojo/text!./templates/RadioMenuItem.htm"],
function (declare, array, domClass, CheckedMenuItem, template) {
    return declare([CheckedMenuItem], {
        // summary:
        //      Override CheckedMenuItem type to RadioButton type.
        // tags:
        //      public

        // baseClass: [protected] String
        //      The root className to be placed on this widget's domNode.
        baseClass: "dijitMenuItem epi-radioMenuItem",
        iconClass: null,

        templateString: template,

        _onClick: function (/*Event*/e) {
            // summary:
            //      Do nothing if the current item is checked
            //      otherwise clear all state, click this item and toggle its state
            // tags:
            //      private

            if (!this.checked) {
                this._resetState();
                this.inherited(arguments);
            }
        },

        _resetState: function () {
            // summary:
            //      Set state of all menu items to false
            // tags:
            //      private

            array.forEach(this._getChildren(), function (child, index) {
                child.set("checked", false);
            });
        },

        _getChildren: function () {
            // summary:
            //      Get all menu items.
            // tags:
            //      private

            return this.getParent().getChildren();
        },

        _setIconClassAttr: function (iconClass) {
            this._set("iconClass", iconClass);
            domClass.add(this.labelIconNode, iconClass);
        }
    });
});

},
'url:epi/shell/widget/templates/RadioMenuItem.htm':"﻿<tr class=\"dijitReset dijitMenuItem\" data-dojo-attach-point=\"focusNode\" role=\"menuitemradio\" tabIndex=\"-1\">\r\n\t<td class=\"dijitReset dijitMenuItemIconCell\" role=\"presentation\">\r\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon dijitCheckedMenuItemIcon\" data-dojo-attach-point=\"iconNode\"/>\r\n\t\t<span class=\"dijitCheckedMenuItemIconChar\">&#10003;</span>\r\n\t</td>\r\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\"><span class=\"dijitInline dijitReset dijitIcon\" data-dojo-attach-point=\"labelIconNode\"></span> <span data-dojo-attach-point=\"containerNode, labelNode\"></span></td>\r\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" data-dojo-attach-point=\"accelKeyNode\"></td>\r\n\t<td class=\"dijitReset dijitMenuArrowCell\" role=\"presentation\">&#160;</td>\r\n</tr>",
'epi-cms/contentediting/editors/_ContentAreaTreeNodeMixin':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dijit/focus",
    "dojo/_base/event",
    "dojo/dom-class"
], function (declare, lang, on, focusUtil, event, domClass) {

    return declare([], {
        // summary:
        //      Common functionality used by the _BlockTreeNode and _GroupTreeNode
        // tags:
        //      internal

        destroy: function () {
            this._unBindContextMenu();

            this.inherited(arguments);
        },

        postCreate: function () {
            this.inherited(arguments);

            // Need the focus set on the label before opening the context menu,
            // otherwise focus is lost if the menu is closed using escape
            this.own(on(this.iconNodeMenu, "click", lang.hitch(this.labelNode, this.labelNode.focus)));
        },

        _unBindContextMenu: function () {
            if (this.contextMenu) {
                this.contextMenu.unBindDomNode(this.iconNodeMenu);
            }
        },

        _setContextMenuAttr: function (contextMenu) {
            this._unBindContextMenu();

            this._set("contextMenu", contextMenu);
            this.contextMenu.bindDomNode(this.iconNodeMenu);
        },

        _setMouseHoverAttr: function (hover) {
            this._set("hover", hover);

            if (this.item.get("selected")) {
                return;
            }
            domClass.toggle(this.iconNodeMenu, this._contextMenuClass, this.hover);
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/_BlockTreeNode.html':"﻿<div class=\"dijitTreeNode\" role=\"presentation\">\r\n    <div class=\"epi-tree-mngr--node-wrapper\" data-dojo-attach-point=\"rowNode\">\r\n        <span data-dojo-attach-point=\"rolesNode, _buttonNode\" class=\"epi-tree-mngr--view-settings\"></span>\r\n        <div class=\"dijitTreeRow dijitInline\" role=\"presentation\">\r\n            <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n                <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n                <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                    <span data-dojo-attach-point=\"sharedIndicatorNode\" class=\"dijitTreeLabel dijitHidden epi-sharedIndicator\" tabindex=\"-1\" aria-selected=\"false\">${resources.shared}</span>\r\n                    <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-extraIcon epi-pt-contextMenu\" title=\"${resources.settingstooltip}\" role=\"presentation\">&nbsp;</span>\r\n                </span>\r\n            </span>\r\n        </div>\r\n        <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/editors/_GroupTreeNode':function(){
﻿define([
    "dojo/aspect",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-style",

    "dijit/Tree",

    "./_ContentAreaTreeNodeMixin",

    "dojo/text!./templates/_GroupTreeNode.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea"

], function (aspect, array, declare, lang, domClass, domStyle, Tree, _ContentAreaTreeNodeMixin, template, resources) {

    return declare([Tree._TreeNode, _ContentAreaTreeNodeMixin], {
        // tags:
        //      internal

        templateString: template,

        _contextMenuClass: "epi-iconContextMenu",

        resources: resources,

        buildRendering: function () {
            this.inherited(arguments);

            domClass.remove(this.iconNode, "dijitFolderClosed");

            this.own(aspect.after(this, "expand", lang.hitch(this, function (deferred) {
                deferred.then(lang.hitch(this, function () {
                    // Seems the deferred is sometimes resolved after the tree has been destroyed
                    if (this._destroyed) {
                        return;
                    }

                    domClass.add(this.domNode, "epi-treeNodeOpen");

                    array.forEach(this.getChildren(), function (childNode) {
                        var child = childNode.item;

                        //If the child does not have any roles auto show the personalization selector
                        //TODO: What happens if there are more children that does not have any roles??
                        if (child.contentGroup && child.ensurePersonalization && child.hasAnyRoles && !child.hasAnyRoles()) {
                            child.set("ensurePersonalization", false);
                            childNode.showPersonalizationSelector();
                        }
                    }, this);
                }));

                return deferred;
            })));

            this.own(aspect.after(this, "collapse", lang.hitch(this, function (deferred) {
                deferred.then(lang.hitch(this, function () {
                    domClass.remove(this.domNode, "epi-treeNodeOpen");
                }));

                return deferred;
            })));

            this.own(this.item.watch("readOnly", lang.hitch(this, function () {
                this._toggleDropMoreMessageNode();
            })));
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(this.item.watch("count", lang.hitch(this, function (property, oldValue, newValue) {
                this.set("count", newValue);
            })));

            // copy initial value from model
            if (this.item) {
                this.set("count", this.item.count);
            }
        },

        setSelected: function (selected) {
            this.inherited(arguments);

            this.item.set("selected", selected);

            domClass.remove(this.rowNode, "dijitTreeRowSelected");
            domClass.toggle(this.domNode, "dijitTreeRowSelected", selected);
        },

        _setCountAttr: function (count) {
            this._set("count", count);

            this._toggleDropMoreMessageNode();
        },

        _toggleDropMoreMessageNode: function () {
            domStyle.set(this.dropMoreMessageNode, "display", !this.item.readOnly && this.count === 1 ? "" : "none");
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/_GroupTreeNode.html':"<div class=\"dijitTreeNode epi-tree-mngr--group\" role=\"presentation\" data-dojo-attach-point=\"rowNode\">\r\n    <div class=\"dijitTreeRow dijitInline epi-tree-mngr--group-header\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n        <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-extraIcon epi-pt-contextMenu\" role=\"presentation\">&nbsp;</span>\r\n            </span>\r\n            <img src=\"${_blankGif}\" alt=\"\" data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon epi-iconUsers\" role=\"presentation\"/>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n        </span>\r\n    </div>\r\n    <hr />\r\n    <span data-dojo-attach-point=\"dropMoreMessageNode\" class=\"epi-tip epi-tip--block\">${resources.groupdropmoremessage}</span>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>\r\n",
'epi-cms/contentediting/editors/_ContentAreaTreeModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/tree/model",

    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel"
], function (
    array,
    declare,
    lang,
    TreeModel,

    ContentBlockViewModel,
    PersonalizedGroupViewModel) {

    return declare([TreeModel], {
        // tags:
        //      internal

        model: null,
        root: {
            id: "root",
            name: "root"
        },

        constructor: function (params) {
            declare.safeMixin(this, params);
        },

        pasteItem: function (childItem, oldParentItem, newParentItem, bCopy, insertIndex, before) {
            // summary:
            //      Move or copy an item from one parent item to another.
            //      Used in drag & drop.
            //      If oldParentItem is specified and bCopy is false, childItem is removed from oldParentItem.
            //      If newParentItem is specified, childItem is attached to newParentItem.
            // childItem: Item
            // oldParentItem: Item
            // newParentItem: Item
            // bCopy: Boolean
            // insertIndex: int?
            //      Allows to insert the new item as the n'th child of `parent`.
            // before: Item?
            //      Insert the new item as the previous sibling of this item.  `before` must be a child of `parent`.
            // tags:
            //      extension
            var oldParent = oldParentItem.id === "root" ? this.model : this.model.getChildById(oldParentItem.id);

            var child = oldParent.getChildById(childItem.id);

            var newParent = newParentItem.id === "root" ? this.model : this.model.getChildById(newParentItem.id);

            if (child instanceof ContentBlockViewModel && !child.hasAnyRoles()) {
                child.set("ensurePersonalization", true);
            }

            if (oldParent === newParent) {
                this.model.modify(function () {
                    newParent.move(child, insertIndex);
                });

                return;
            }

            this.model.modify(function () {
                oldParent.removeChild(child);
                newParent.addChild(child, insertIndex);
            });
        },

        deleteItem: function (item) {
            this.model.modify(lang.hitch(this, function () {
                this.model.removeChild(item, true);
            }));
        },

        newItem: function (args, parent, insertIndex, before) {
            if (args.dndData && args.dndData.data) {
                var parentModel = parent.id === "root" ? this.model : this.model.getChildById(parent.id);

                var item = args.dndData.data;
                if (!(item instanceof ContentBlockViewModel) && !(item instanceof PersonalizedGroupViewModel)) {
                    item = new ContentBlockViewModel(item);
                }

                item.set("ensurePersonalization", true);

                this.model.modify(function () {
                    parentModel.addChild(item, insertIndex);
                });
            }
        },

        checkItemAcceptance: function (target, item, position) {
            if (position === "over") {
                if (!(target instanceof PersonalizedGroupViewModel)) {
                    return false;
                }

                if (!(item instanceof ContentBlockViewModel)) {
                    return false;
                }
            }

            if (target instanceof ContentBlockViewModel && item instanceof PersonalizedGroupViewModel && target.contentGroup) {
                return false;
            }

            return true;
        },

        getRoot: function (onItem) {
            onItem(this.root);
        },

        getLabel: function (item) {
            return item.label;
        },

        mayHaveChildren: function (item) {
            if (typeof item.getChildren == "function" || item.id === "root") {
                return true;
            }

            return false;
        },

        getIdentity: function (item) {
            return item.id;
        },

        getChildren: function (parentItem, onComplete) {
            var children;

            if (parentItem.id === "root") {
                children = this.model.getChildren();
                onComplete(children);

                this.model.on("childrenChanged", lang.hitch(this, function (index, removals, adds) {
                    this.onChildrenChange(this.root, this.model.getChildren());
                }));
            } else {
                var model = this.model.getChildById(parentItem.id);
                if (model && typeof model.getChildren == "function") {
                    children = model.getChildren();
                    onComplete(children);

                    model.on("childrenChanged", lang.hitch(this, function (index, removals, adds) {
                        this.onChildrenChange(parentItem, model.getChildren());
                    }));

                } else {
                    onComplete([]);
                }

            }
        }
    });
});

},
'dijit/tree/model':function(){
define("dijit/tree/model", ["dojo/_base/declare"], function(declare){

return declare(
	"dijit.tree.model",
	null,
{
	// summary:
	//		Contract for any data provider object for the tree.
	// description:
	//		Tree passes in values to the constructor to specify the callbacks.
	//		"item" is typically a dojo/data/Item but it's just a black box so
	//		it could be anything.
	//
	//		This (like `dojo/data/api/Read`) is just documentation, and not meant to be used.

	destroy: function(){
		// summary:
		//		Destroys this object, releasing connections to the store
		// tags:
		//		extension
	},

	// =======================================================================
	// Methods for traversing hierarchy

	getRoot: function(onItem){
		// summary:
		//		Calls onItem with the root item for the tree, possibly a fabricated item.
		//		Throws exception on error.
		// tags:
		//		extension
	},

	mayHaveChildren: function(item){
		// summary:
		//		Tells if an item has or may have children.  Implementing logic here
		//		avoids showing +/- expando icon for nodes that we know don't have children.
		//		(For efficiency reasons we may not want to check if an element actually
		//		has children until user clicks the expando node)
		// item: dojo/data/Item
		// tags:
		//		extension
	},

	getChildren: function(parentItem, onComplete){
		// summary:
		//		Calls onComplete() with array of child items of given parent item, all loaded.
		//		Throws exception on error.
		// parentItem: dojo/data/Item
		// onComplete: function(items)
		// tags:
		//		extension
	},

	// =======================================================================
	// Inspecting items

	isItem: function(something){
		// summary:
		//		Returns true if *something* is an item and came from this model instance.
		//		Returns false if *something* is a literal, an item from another model instance,
		//		or is any object other than an item.
		// tags:
		//		extension
	},

	fetchItemByIdentity: function(keywordArgs){
		// summary:
		//		Given the identity of an item, this method returns the item that has
		//		that identity through the onItem callback.  Conforming implementations
		//		should return null if there is no item with the given identity.
		//		Implementations of fetchItemByIdentity() may sometimes return an item
		//		from a local cache and may sometimes fetch an item from a remote server.
		// tags:
		//		extension
	},

	getIdentity: function(item){
		// summary:
		//		Returns identity for an item
		// tags:
		//		extension
	},

	getLabel: function(item){
		// summary:
		//		Get the label for an item
		// tags:
		//		extension
	},

	// =======================================================================
	// Write interface

	newItem: function(args, parent, insertIndex, before){
		// summary:
		//		Creates a new item.   See `dojo/data/api/Write` for details on args.
		// args: dijit/tree/dndSource.__Item
		// parent: Item
		// insertIndex: int?
		//		Allows to insert the new item as the n'th child of `parent`.
		// before: Item?
		//		Insert the new item as the previous sibling of this item.  `before` must be a child of `parent`.
		// tags:
		//		extension
	},

	pasteItem: function(childItem, oldParentItem, newParentItem, bCopy, insertIndex, before){
		// summary:
		//		Move or copy an item from one parent item to another.
		//		Used in drag & drop.
		//		If oldParentItem is specified and bCopy is false, childItem is removed from oldParentItem.
		//		If newParentItem is specified, childItem is attached to newParentItem.
		// childItem: Item
		// oldParentItem: Item
		// newParentItem: Item
		// bCopy: Boolean
		// insertIndex: int?
		//		Allows to insert the new item as the n'th child of `parent`.
		// before: Item?
		//		Insert the new item as the previous sibling of this item.  `before` must be a child of `parent`.
		// tags:
		//		extension
	},

	// =======================================================================
	// Callbacks

	onChange: function(item){
		// summary:
		//		Callback whenever an item has changed, so that Tree
		//		can update the label, icon, etc.   Note that changes
		//		to an item's children or parent(s) will trigger an
		//		onChildrenChange() so you can ignore those changes here.
		// item: dojo/data/Item
		// tags:
		//		callback
	},

	onChildrenChange: function(parent, newChildrenList){
		// summary:
		//		Callback to do notifications about new, updated, or deleted items.
		// parent: dojo/data/Item
		// newChildrenList: dojo/data/Item[]
		// tags:
		//		callback
	}
});

});
},
'epi-cms/contentediting/viewmodel/ContentAreaViewModel':function(){
define([
    // General application modules
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
    "dojox/uuid/generateRandomUuid",
    "epi/dependency",
    "epi/shell/applicationSettings",
    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel",
    "epi-cms/contentediting/ContentActionSupport",
    // Parent class and mixins
    "epi-cms/contentediting/viewmodel/_ContainerViewModel",
    "epi-cms/_ContentContextMixin"
], function (
    array,
    declare,
    lang,
    all,
    when,
    generateRandomUuid,
    dependency,
    applicationSettings,
    ContentBlockViewModel,
    PersonalizedGroupViewModel,
    ContentActionSupport,
    // Parent class and mixins
    _ContainerViewModel,
    _ContentContextMixin
) {

    return declare([_ContainerViewModel, _ContentContextMixin], {
        // summary:
        //      The view model for the content area when editing in on-page mode and forms mode.
        // tags:
        //      internal

        /*=====

        // value: [public] Array
        //      The value of the content area property.
        value: null,

        =====*/

        // selectedItem: [public] Object
        //      The model for the selected content.
        selectedItem: null,

        postscript: function () {
            this.inherited(arguments);

            this.contentTypeService = this.contentTypeService || dependency.resolve("epi.cms.ContentTypeService");

            if (!this._contentTypeStore) {
                var registry = dependency.resolve("epi.storeregistry");
                this._contentTypeStore = registry.get("epi.cms.contenttype");
            }
        },

        addChild: function (child /*=====, index =====*/) {
            // summary:
            //      Adds a child to the view model at the given index or at the end of the collection.
            // child: Object
            //      The child to be added.
            // index: Number?
            //      The index where to the child will be inserted.
            // tags:
            //      public

            //TODO: make this code more generic
            // and merge with _transformValueToModels

            if (this.hasReachedItemsLimit()) {
                return;
            }

            // We cannot own the child handles by id until the child has been added and received an id, so store them
            // in this array and own them all by id at the end.
            var childHandles = [];

            if (!(child instanceof ContentBlockViewModel) && !(child instanceof PersonalizedGroupViewModel)) {
                var model = new ContentBlockViewModel(child);

                // If the model has a content group add it to the groups view model.
                if (model.contentGroup) {
                    child = this._groups[model.contentGroup];

                    if (!child) {
                        // Create the group if it doesn't exist and add it to the data.
                        child = this._createGroup(model.contentGroup);
                    }

                    child.addChild(model);
                } else {
                    // Else add the model directly to the data for this view model.
                    child = model;
                }
            } else {
                child.set("contentGroup", null);

                if (child instanceof PersonalizedGroupViewModel) {
                    childHandles.push(child.on("childrenChanged", lang.hitch(this, function () {

                        //Propagate changes of the group
                        this._emitChildrenChanged(child);

                        //If there are no more children, remove the group
                        if (child.getChildren().length === 0) {
                            this.removeChild(child);
                            this._emitChanged();
                        }
                    })));
                } else if (child instanceof ContentBlockViewModel) {
                    child.resetRoleIdentities();
                }
            }

            // Propagate changed event from the child to the content area.
            childHandles.push(child.on("changed", this._emitChanged.bind(this)));
            childHandles.push(child.watch("inlineBlockData", this._emitChanged.bind(this)));

            this.inherited(arguments);

            childHandles.push(child.on("selected", lang.hitch(this, "set", "selectedItem")));

            childHandles.forEach(function (handle) {
                this.ownByKey(child.id, handle);
            }, this);
        },

        canCreateBlock: function (allowedTypes, restrictedTypes) {
            // summary:
            //      Determines whether the user can create blocks on this content area.
            // tags:
            //      internal

            var contentTypeservice = this.contentTypeService;
            return all([this.getCurrentContext(), this.getCurrentContent()])
                .then(function (results) {
                    var context = results[0],
                        contentData = results[1];

                    // If there is no context or content data then it shouldn't be possible
                    // to create a block for this content area. So return false.
                    if (!context || !contentData) {
                        return false;
                    }

                    if (applicationSettings.inlineBlocksInContentAreaEnabled) {
                        // inline blocks are only allowed as part of pages and other blocks for now
                        if (!context.capabilities.isPage && !context.capabilities.isBlock) {
                            return false;
                        }
                    } else {
                        var hasCreatePermission = ContentActionSupport.isActionAvailable(
                            contentData,
                            ContentActionSupport.action.Create,
                            ContentActionSupport.providerCapabilities.Create,
                            true);

                        // Check whether the current user has create permission. Also check if the current content is
                        // resourecable and finally check whether we are in a mode where create should not be available.
                        if (!hasCreatePermission ||
                            !context.capabilities.resourceable ||
                            context.currentMode === "create" || context.currentMode === "translate") {
                            return false;
                        }
                    }

                    return when(contentTypeservice.getAcceptedChildTypes(contentData.contentLink, true, ["episerver.core.blockdata"], allowedTypes, restrictedTypes)).then(function (availableTypes) {
                        return !!availableTypes.length;
                    });

                });
        },

        hasReachedItemsLimit: function () {
            // summary:
            //      Has limit of the items reached or not. Will return false if limit was not set at all
            // tags:
            //      public

            return this.maxLength && this.getChildren().length >= this.maxLength;
        },

        moveVisible: function (child, moveToNext) {
            // summary:
            //      Moves the child to a specific index based on visibility of children.
            // tags:
            //      public
            var children = array.filter(this.getChildren(), function (item) {
                    return item.get("visible");
                }),
                delta = moveToNext ? 1 : -1, // Delta indicating if this is a move next or move previous.
                target = array.indexOf(children, child) + delta, // The target visible index to move to.
                index = this.indexOf(children[target]); // The actual index of the target in the model.

            this.modify(lang.hitch(this, function () {
                this.move(child, index);
            }));
        },

        moveOutsideGroup: function (child) {
            // summary:
            //      Move the child out from the group
            // child: Object
            //      The child to move
            //
            if (!child.contentGroup) {
                console.debug("The child does not belong to any group", child);

                return;
            }

            var group = this.getChild({
                    name: child.contentGroup
                }),
                index = this.indexOf(group);

            this.modify(lang.hitch(this, function () {
                //Remove the child from the group but do not emit the change event
                group.removeChild(child);

                //Add the child to this model
                this.addChild(child, index);
            }));
        },

        personalize: function (child) {
            // summary:
            //      Personalizes the child
            // child: ContentBlockViewModel
            //      The block to personalize
            // tags:
            //      internal

            // Remove the item from the model.
            var index = this.indexOf(child);
            this.removeChild(child);

            // Create a new personalized group and add the item to it.
            var group = new PersonalizedGroupViewModel({
                name: "group_" + Date.now(),
                expandOnAdd: true
            });
            child.set("ensurePersonalization", true);
            group.addChild(child);

            // Add the group to the model.
            this.addChild(group, index);
        },

        _valueGetter: function () {
            var value = [];
            array.forEach(this.getChildren(), function (child) {
                if (!child.isBrokenLink) {
                    value = value.concat(child.serialize());
                }
            });
            return value;
        },

        _valueSetter: function (value) {
            this._transformValueToModels(value || []);
        },

        _selectedItemSetter: function (value) {
            if (this.selectedItem) {
                this.selectedItem.set("selected", false);
            }
            this.selectedItem = value;
        },

        _transformValueToModels: function (value) {
            // summary:
            //      Transforms the current value into a tree representation using observable stores.
            // tags:
            //      private

            // Remove the existing children since we are recreating all the data.
            this.modify(function () {
                var children = this.getChildren();
                for (var i = children.length - 1; i >= 0; i--) {
                    this.removeChild(children[i]);
                }

                // Clear the groups since we are recreating all the data.
                this._groups = {};

                value.forEach(function (child, index) {
                    var model = new ContentBlockViewModel(child);
                    model.inlineBlockDataIndex = index;
                    // If the model has a content group add it to the groups view model.
                    if (model.contentGroup) {
                        var group = this._groups[model.contentGroup];

                        if (!group) {
                            // Create the group if it doesn't exist and add it to the data.
                            group = this._createGroup(model.contentGroup);
                            this.addChild(group);
                        }

                        // Add the child at the end
                        group.addChild(model, group.getChildren().length);
                    } else {
                        // Else add the model directly to the data for this view model.
                        this.addChild(model);
                    }
                }.bind(this));
            }, this, false);
        },

        _emitChanged: function () {
            // tags:
            //      private
            this.emit("changed");
        },

        _createGroup: function (name) {
            // summary:
            //      Creates the group with the given name and adds it to the groups map.
            // tags:
            //      private
            var group = new PersonalizedGroupViewModel({
                name: name
            });

            this._groups[name] = group;

            return group;
        },

        _hash: function (child) {
            // summary:
            //      Creates a hash for the given child.
            // tags:
            //      protected
            return (child.contentLink || child.name) + "_" + generateRandomUuid();
        }
    });
});

},
'dojox/uuid/generateRandomUuid':function(){
define("dojox/uuid/generateRandomUuid", ['./_base'], function(){

dojox.uuid.generateRandomUuid = function(){
	// summary:
	//		This function generates random UUIDs, meaning "version 4" UUIDs.
	// description:
	//		A typical generated value would be something like this:
	//		"3b12f1df-5232-4804-897e-917bf397618a"
	//
	//		For more information about random UUIDs, see sections 4.4 and
	//		4.5 of RFC 4122: http://tools.ietf.org/html/rfc4122#section-4.4
	//
	//		This generator function is designed to be small and fast,
	//		but not necessarily good.
	//
	//		Small: This generator has a small footprint. Once comments are
	//		stripped, it's only about 25 lines of code, and it doesn't
	//		dojo.require() any other modules.
	//
	//		Fast: This generator can generate lots of new UUIDs fairly quickly
	//		(at least, more quickly than the other dojo UUID generators).
	//
	//		Not necessarily good: We use Math.random() as our source
	//		of randomness, which may or may not provide much randomness.
	// examples:
	//		var string = dojox.uuid.generateRandomUuid();
	var HEX_RADIX = 16;

	function _generateRandomEightCharacterHexString(){
		// Make random32bitNumber be a randomly generated floating point number
		// between 0 and (4,294,967,296 - 1), inclusive.
		var random32bitNumber = Math.floor( (Math.random() % 1) * Math.pow(2, 32) );
		var eightCharacterHexString = random32bitNumber.toString(HEX_RADIX);
		while(eightCharacterHexString.length < 8){
			eightCharacterHexString = "0" + eightCharacterHexString;
		}
		return eightCharacterHexString; // for example: "3B12F1DF"
	}

	var hyphen = "-";
	var versionCodeForRandomlyGeneratedUuids = "4"; // 8 == binary2hex("0100")
	var variantCodeForDCEUuids = "8"; // 8 == binary2hex("1000")
	var a = _generateRandomEightCharacterHexString();
	var b = _generateRandomEightCharacterHexString();
	b = b.substring(0, 4) + hyphen + versionCodeForRandomlyGeneratedUuids + b.substring(5, 8);
	var c = _generateRandomEightCharacterHexString();
	c = variantCodeForDCEUuids + c.substring(1, 4) + hyphen + c.substring(4, 8);
	var d = _generateRandomEightCharacterHexString();
	var returnValue = a + hyphen + b + hyphen + c + d;
	returnValue = returnValue.toLowerCase();
	return returnValue; // String
};

return dojox.uuid.generateRandomUuid;

});

},
'dojox/uuid/_base':function(){
define("dojox/uuid/_base", ['dojo/_base/kernel', 'dojo/_base/lang'], function(dojo){

dojo.getObject("uuid", true, dojox);

// Public constants:
dojox.uuid.NIL_UUID = "00000000-0000-0000-0000-000000000000";
dojox.uuid.version = {
	//	Enumeration for the different UUID versions.
	UNKNOWN: 0,
	TIME_BASED: 1,
	DCE_SECURITY: 2,
	NAME_BASED_MD5: 3,
	RANDOM: 4,
	NAME_BASED_SHA1: 5 };
dojox.uuid.variant = {
	//	Enumeration for the different UUID variants.
	NCS: "0",
	DCE: "10",
	MICROSOFT: "110",
	UNKNOWN: "111" };

dojox.uuid.assert = function(/*Boolean*/ booleanValue, /*String?*/ message){
	// summary:
	//		Throws an exception if the assertion fails.
	// description:
	//		If the asserted condition is true, this method does nothing. If the
	//		condition is false, we throw an error with a error message.
	// booleanValue: Must be true for the assertion to succeed.
	// message: A string describing the assertion.
	// throws: Throws an Error if 'booleanValue' is false.
	if(!booleanValue){
		if(!message){
			message = "An assert statement failed.\n" +
			"The method dojox.uuid.assert() was called with a 'false' value.\n";
		}
		throw new Error(message);
	}
};

dojox.uuid.generateNilUuid = function(){
	// summary:
	//		This function returns the Nil UUID: "00000000-0000-0000-0000-000000000000".
	// description:
	//		The Nil UUID is described in section 4.1.7 of
	//		RFC 4122: http://tools.ietf.org/html/rfc4122#section-4.1.7
	// examples:
	//		var string = dojox.uuid.generateNilUuid();
	return dojox.uuid.NIL_UUID; // String
};

dojox.uuid.isValid = function(/*String*/ uuidString){
	// summary:
	//		Returns true if the UUID was initialized with a valid value.
	uuidString = uuidString.toString();
	var valid = (dojo.isString(uuidString) &&
		(uuidString.length == 36) &&
		(uuidString == uuidString.toLowerCase()));
	if(valid){
		var arrayOfParts = uuidString.split("-");
		valid = ((arrayOfParts.length == 5) &&
			(arrayOfParts[0].length == 8) &&
			(arrayOfParts[1].length == 4) &&
			(arrayOfParts[2].length == 4) &&
			(arrayOfParts[3].length == 4) &&
			(arrayOfParts[4].length == 12));
		var HEX_RADIX = 16;
		for (var i in arrayOfParts) {
			var part = arrayOfParts[i];
			var integer = parseInt(part, HEX_RADIX);
			valid = valid && isFinite(integer);
		}
	}
	return valid; // boolean
};

dojox.uuid.getVariant = function(/*String*/ uuidString){
	// summary:
	//		Returns a variant code that indicates what type of UUID this is.
	//		Returns one of the enumerated dojox.uuid.variant values.
	// example:
	//		var variant = dojox.uuid.getVariant("3b12f1df-5232-4804-897e-917bf397618a");
	//		dojox.uuid.assert(variant == dojox.uuid.variant.DCE);
	// example:
	//	|	"3b12f1df-5232-4804-897e-917bf397618a"
	//	|                   ^
	//	|                   |
	//	|       (variant "10__" == DCE)
	if(!dojox.uuid._ourVariantLookupTable){
		var variant = dojox.uuid.variant;
		var lookupTable = [];

		lookupTable[0x0] = variant.NCS;       // 0000
		lookupTable[0x1] = variant.NCS;       // 0001
		lookupTable[0x2] = variant.NCS;       // 0010
		lookupTable[0x3] = variant.NCS;       // 0011

		lookupTable[0x4] = variant.NCS;       // 0100
		lookupTable[0x5] = variant.NCS;       // 0101
		lookupTable[0x6] = variant.NCS;       // 0110
		lookupTable[0x7] = variant.NCS;       // 0111

		lookupTable[0x8] = variant.DCE;       // 1000
		lookupTable[0x9] = variant.DCE;       // 1001
		lookupTable[0xA] = variant.DCE;       // 1010
		lookupTable[0xB] = variant.DCE;       // 1011

		lookupTable[0xC] = variant.MICROSOFT; // 1100
		lookupTable[0xD] = variant.MICROSOFT; // 1101
		lookupTable[0xE] = variant.UNKNOWN;   // 1110
		lookupTable[0xF] = variant.UNKNOWN;   // 1111
		
		dojox.uuid._ourVariantLookupTable = lookupTable;
	}

	uuidString = uuidString.toString();
	var variantCharacter = uuidString.charAt(19);
	var HEX_RADIX = 16;
	var variantNumber = parseInt(variantCharacter, HEX_RADIX);
	dojox.uuid.assert((variantNumber >= 0) && (variantNumber <= 16));
	return dojox.uuid._ourVariantLookupTable[variantNumber]; // dojox.uuid.variant
};

dojox.uuid.getVersion = function(/*String*/ uuidString){
	// summary:
	//		Returns a version number that indicates what type of UUID this is.
	//		Returns one of the enumerated dojox.uuid.version values.
	// example:
	//		var version = dojox.uuid.getVersion("b4308fb0-86cd-11da-a72b-0800200c9a66");
	//		dojox.uuid.assert(version == dojox.uuid.version.TIME_BASED);
	// exceptions:
	//		Throws an Error if this is not a DCE Variant UUID.
	var errorMessage = "dojox.uuid.getVersion() was not passed a DCE Variant UUID.";
	dojox.uuid.assert(dojox.uuid.getVariant(uuidString) == dojox.uuid.variant.DCE, errorMessage);
	uuidString = uuidString.toString();
	
		// "b4308fb0-86cd-11da-a72b-0800200c9a66"
		//			      ^
		//			      |
		//		 (version 1 == TIME_BASED)
	var versionCharacter = uuidString.charAt(14);
	var HEX_RADIX = 16;
	var versionNumber = parseInt(versionCharacter, HEX_RADIX);
	return versionNumber; // dojox.uuid.version
};

dojox.uuid.getNode = function(/*String*/ uuidString){
	// summary:
	//		If this is a version 1 UUID (a time-based UUID), getNode() returns a
	//		12-character string with the "node" or "pseudonode" portion of the UUID,
	//		which is the rightmost 12 characters.
	// exceptions:
	//		Throws an Error if this is not a version 1 UUID.
	var errorMessage = "dojox.uuid.getNode() was not passed a TIME_BASED UUID.";
	dojox.uuid.assert(dojox.uuid.getVersion(uuidString) == dojox.uuid.version.TIME_BASED, errorMessage);

	uuidString = uuidString.toString();
	var arrayOfStrings = uuidString.split('-');
	var nodeString = arrayOfStrings[4];
	return nodeString; // String (a 12-character string, which will look something like "917bf397618a")
};

dojox.uuid.getTimestamp = function(/*String*/ uuidString, /*String?*/ returnType){
	// summary:
	//		If this is a version 1 UUID (a time-based UUID), this method returns
	//		the timestamp value encoded in the UUID.  The caller can ask for the
	//		timestamp to be returned either as a JavaScript Date object or as a
	//		15-character string of hex digits.
	// returnType:
	//		Any of these five values: "string", String, "hex", "date", Date
	// returns:
	//		Returns the timestamp value as a JavaScript Date object or a 15-character string of hex digits.
	// examples:
	//		var uuidString = "b4308fb0-86cd-11da-a72b-0800200c9a66";
	//		var date, string, hexString;
	//		date   = dojox.uuid.getTimestamp(uuidString);         // returns a JavaScript Date
	//		date   = dojox.uuid.getTimestamp(uuidString, Date);     //
	//		string = dojox.uuid.getTimestamp(uuidString, String);   // "Mon, 16 Jan 2006 20:21:41 GMT"
	//		hexString = dojox.uuid.getTimestamp(uuidString, "hex"); // "1da86cdb4308fb0"
	// exceptions:
	//		Throws an Error if this is not a version 1 UUID.
	var errorMessage = "dojox.uuid.getTimestamp() was not passed a TIME_BASED UUID.";
	dojox.uuid.assert(dojox.uuid.getVersion(uuidString) == dojox.uuid.version.TIME_BASED, errorMessage);
	
	uuidString = uuidString.toString();
	if(!returnType){returnType = null};
	switch(returnType){
		case "string":
		case String:
			return dojox.uuid.getTimestamp(uuidString, Date).toUTCString(); // String (e.g. "Mon, 16 Jan 2006 20:21:41 GMT")
			break;
		case "hex":
			// Return a 15-character string of hex digits containing the
			// timestamp for this UUID, with the high-order bits first.
			var arrayOfStrings = uuidString.split('-');
			var hexTimeLow = arrayOfStrings[0];
			var hexTimeMid = arrayOfStrings[1];
			var hexTimeHigh = arrayOfStrings[2];
		
			// Chop off the leading "1" character, which is the UUID
			// version number for time-based UUIDs.
			hexTimeHigh = hexTimeHigh.slice(1);
		
			var timestampAsHexString = hexTimeHigh + hexTimeMid + hexTimeLow;
			dojox.uuid.assert(timestampAsHexString.length == 15);
			return timestampAsHexString; // String (e.g. "1da86cdb4308fb0")
			break;
		case null: // no returnType was specified, so default to Date
		case "date":
		case Date:
			// Return a JavaScript Date object.
			var GREGORIAN_CHANGE_OFFSET_IN_HOURS = 3394248;
			var HEX_RADIX = 16;
		
			var arrayOfParts = uuidString.split('-');
			var timeLow = parseInt(arrayOfParts[0], HEX_RADIX);
			var timeMid = parseInt(arrayOfParts[1], HEX_RADIX);
			var timeHigh = parseInt(arrayOfParts[2], HEX_RADIX);
			var hundredNanosecondIntervalsSince1582 = timeHigh & 0x0FFF;
			hundredNanosecondIntervalsSince1582 <<= 16;
			hundredNanosecondIntervalsSince1582 += timeMid;
			// What we really want to do next is shift left 32 bits, but the
			// result will be too big to fit in an int, so we'll multiply by 2^32,
			// and the result will be a floating point approximation.
			hundredNanosecondIntervalsSince1582 *= 0x100000000;
			hundredNanosecondIntervalsSince1582 += timeLow;
			var millisecondsSince1582 = hundredNanosecondIntervalsSince1582 / 10000;
		
			// Again, this will be a floating point approximation.
			// We can make things exact later if we need to.
			var secondsPerHour = 60 * 60;
			var hoursBetween1582and1970 = GREGORIAN_CHANGE_OFFSET_IN_HOURS;
			var secondsBetween1582and1970 = hoursBetween1582and1970 * secondsPerHour;
			var millisecondsBetween1582and1970 = secondsBetween1582and1970 * 1000;
			var millisecondsSince1970 = millisecondsSince1582 - millisecondsBetween1582and1970;
		
			var timestampAsDate = new Date(millisecondsSince1970);
			return timestampAsDate; // Date
			break;
		default:
			// we got passed something other than a valid returnType
			dojox.uuid.assert(false, "dojox.uuid.getTimestamp was not passed a valid returnType: " + returnType);
			break;
	}
};

return dojox.uuid;

});

},
'epi-cms/widget/overlay/Block':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/on",
    "dojo/when",

    // Parent classes
    "epi/shell/widget/overlay/_Base",
    "epi/shell/applicationSettings",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi-cms/widget/overlay/_OverlayItemInfoMixin",
    "epi-cms/contentediting/command/ContentAreaCommands",
    "epi-cms/ContentLanguageHelper",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.blockcontextmenu",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea",
    "dojo/text!../templates/Block.html",
    // Widgets used in template
    "dijit/form/DropDownButton",
    "epi/shell/widget/ContextMenu"
], function (
    // General application modules
    declare,
    event,
    lang,
    domClass,
    domStyle,
    on,
    when,

    // Parent classes
    _Base,
    applicationSettings,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _OverlayItemInfoMixin,
    ContentAreaCommands,
    ContentLanguageHelper,

    // Resources
    resources,
    contentAreaResources,
    template
) {

    return declare([_Base, _TemplatedMixin, _WidgetsInTemplateMixin, _OverlayItemInfoMixin], {
        // summary:
        //    The block widget is used together with the BlockArea widget to show the
        //    position of the different blocks for a ContentAreaProperty.
        // tags:
        //      internal xproduct

        // templateString: [public] String
        templateString: template,

        res: lang.mixin(resources, { shared: contentAreaResources.shared }),

        _setMissingRendererAttr: function (value) {
            domClass.toggle(this.domNode, "epi-overlay-item-missing-renderer", value);
        },

        buildRendering: function () {
            this.inherited(arguments);

            domStyle.set(this.personalizedIcon, "display", this.viewModel.contentGroup ? "" : "none");
            domStyle.set(this.sharedLabelNode, "display", applicationSettings.inlineBlocksInContentAreaEnabled && !this.isLocalBlock ? "" : "none");
        },

        postCreate: function () {
            // summary:
            //      Initialize widgets
            // tags:
            //      protected
            this.inherited(arguments);

            this._injectDynamicStyles();

            this.own(
                // Make command provider is injected
                this.commandProvider = this.commandProvider || new ContentAreaCommands({ model: this.viewModel }),

                this.viewModel.watch("statusMessage", lang.hitch(this, function (propertyName, oldValue, newValue) {
                    when(ContentLanguageHelper.getMissingLanguageMessage(this.viewModel.content), lang.hitch(this, function (message) {
                        domStyle.set(this.warningIcon, "display", message ? "" : "none");
                    }));
                    //Show/Hide the icons container
                    domStyle.set(this.iconsContainer, "display", this.viewModel.contentGroup || newValue || !this.isLocalBlock ? "" : "none");
                }))
            );

            this.own(on(this.commandProvider.contentAreaItemBlockEdit, "save", function (inlineBlockData) {
                this.viewModel.set("inlineBlockData", inlineBlockData);
            }.bind(this)));

            this.viewModel.loadStatus();

            this.contextMenu.addProvider(this.commandProvider);

            if (this.blockInfo && this.blockInfo.missingrenderer) {
                this.set("missingRenderer", this.blockInfo.missingrenderer);
            }

            this.own(
                on(this.domNode, "click", lang.hitch(this.viewModel, "set", "selected", true)),
                on(this.settingsButton, "click", lang.hitch(this, "_onContextMenuClick")),
                on(this.domNode, "mouseout", lang.hitch(this, function (e) {
                    if (this.contextMenu && this.contextMenu.isShowingNow) {
                        event.stop(e);
                    }
                }))
            );

            // Connect dblclick event to show the dialog for inline-editing block
            var node = this.get("containerDomNode");

            this.own(
                on(node, "dblclick", function () {
                    this.commandProvider.handleDoubleClick(this.viewModel);
                }.bind(this))
            );
        },

        _injectDynamicStyles: function () {
            // summary:
            //      Inject dynamic styles for original dom node
            // tags:
            //      private
            var node = this.sourceItemNode,
                display = node.style.display,
                suffix = /inline|inline-block/.test(display) ? "-inline" : "";

            domClass.add(node, "epi-injected-minSize" + suffix);
        },

        _onContextMenuClick: function () {
            // Set the viewmodel to the command provider again
            this.commandProvider.set("model", this.viewModel);

            this.viewModel.set("selected", true);
            // Return false to cause prevent default in dijit/form/_ButtonMixin
            return false;
        }
    });
});

},
'epi-cms/widget/overlay/_OverlayItemInfoMixin':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/on",
    "dojo/when",
    "dojo/mouse",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/overlay/OverlayItemInfo",
    "epi-cms/widget/viewmodel/ContentStatusViewModel"
], function (declare, lang, domConstruct, on, when, mouse, TypeDescriptorManager, OverlayItemInfo, ContentStatusViewModel) {

    return declare(null, {
        // summary:
        //      A mixin for overlays that adds an information layer containing an icon and message.
        //
        // tags:
        //      internal

        // disableTooltip: [Boolean]
        //      Flag to indicate disable overlay information tooltip when starting drag.
        disableTooltip: false,

        // useIconOnBlock: [Boolean]
        //      Flag to indicate always show/not overlay and icon of block.
        useIconOnBlock: false,
        postCreate: function () {
            this.own(this.viewModel.watch("contentStatus", lang.hitch(this, "_setupIcon")));

            this.own(this.viewModel.watch("statusMessage", lang.hitch(this, function (propertyName, oldValue, newValue) {
                this.set("statusMessage", newValue);
            })));

            // Subcrible global dnd events to toggle state of disableTooltip.
            this.subscribe("/dnd/start", lang.hitch(this, function () {
                if (!this.disableTooltip) {
                    this._set("disableTooltip", true);

                    // Make sure close current tooltip if it showed.
                    this._showStatusMessage(false);
                }
            }));
            this.subscribe("/dnd/cancel", lang.hitch(this, function () {
                this._set("disableTooltip", false);
            }));
            this.subscribe("/dnd/drop", lang.hitch(this, function () {
                this._set("disableTooltip", false);
            }));

            // Connect onmouseenter/onmouseleave events in order to show/hide additional information
            var node = this.get("containerDomNode");
            if (node) {
                this.own(on(node, mouse.enter, lang.hitch(this, function () {
                    this._showStatusMessage(!this.get("disableTooltip"));
                })));

                this.own(on(node, mouse.leave, lang.hitch(this, function () {
                    this._showStatusMessage(false);
                })));
            }

            this.inherited(arguments);
        },

        destroy: function () {
            if (this._overlayItemInfo) {
                this._overlayItemInfo.destroyRecursive();
                this._overlayItemInfo = null;
            }

            this.inherited(arguments);
        },

        _setStatusIconAttr: function (/* String */ iconCSSClasses) {
            // summary:
            //      Apply CSS class for content status icon.
            // iconCSSClasses: [String]
            //      List of CSS class for content status icon
            // tags:
            //      private
            var overlayItemInfo = this.get("overlayItemInfo");

            if (!overlayItemInfo) {
                return;
            }

            overlayItemInfo.set("statusIcon", iconCSSClasses);
        },

        _setStatusMessageAttr: function (/* Object */ message) {
            // summary:
            //      Set content status message
            // message: [Object]
            //      Content status message object. Can be String data type or Array data type.
            // tags:
            //      private
            var overlayItemInfo = this.get("overlayItemInfo");

            if (!overlayItemInfo) {
                return;
            }

            overlayItemInfo.set("statusMessage", message);
        },

        _getContainerDomNodeAttr: function () {
            // summary:
            //      Get container DOM node.
            // tags:
            //      private
            return this.containerDomNode || this.domNode;
        },

        _getOverlayItemInfoAttr: function () {
            // summary:
            //      Get overlay item information widget
            // tags:
            //      private
            if (!this._overlayItemInfo) {
                // Setup overlay item information widget
                this._overlayItemInfo = new OverlayItemInfo();

                domConstruct.place(this._overlayItemInfo.domNode, this.get("containerDomNode"));
            }

            return this._overlayItemInfo;
        },

        _setupIcon: function () {

            var overlayItemInfo,
                useIconOnBlock,
                iconClass,
                description;

            overlayItemInfo = this.get("overlayItemInfo");
            overlayItemInfo.set("class", !this.viewModel.get("isVisibleOnSite") ? "epi-overlay-content-invisible" : "");

            // Get typeIdentifier of content first and if null then get of viewmodel.
            var typeIdentifier = (this.viewModel.content && this.viewModel.content.typeIdentifier) || this.viewModel.typeIdentifier;

            if (this.viewModel.get("isVisibleOnSite") && typeIdentifier) {
                useIconOnBlock = TypeDescriptorManager.getValue(typeIdentifier, "useIconOnBlock");
                iconClass = TypeDescriptorManager.getValue(typeIdentifier, "iconClass");
                description = TypeDescriptorManager.getValue(typeIdentifier, "description");

                if (useIconOnBlock) {
                    overlayItemInfo.set("class", "epi-overlay-content-info");
                    this.set("useIconOnBlock", true);
                    this.set("statusIcon", iconClass);
                    this.set("statusMessage", description);
                }
            }
        },

        _showStatusMessage: function (/* Boolean */ visible) {
            // summary:
            //      Set availibility to display additional information.
            // visible: [Boolean]
            //      Indicated that show additional information if true
            // tags:
            //      private
            if (this._overlayItemInfo) {
                this._overlayItemInfo.showStatusMessage(visible);
            }
        }
    });
});

},
'epi/shell/widget/overlay/OverlayItemInfo':function(){
require({cache:{
'url:epi/shell/widget/overlay/templates/OverlayItemInfo.html':"﻿<span class=\"epi-overlay-content\">\r\n    <span data-dojo-attach-point=\"highlightArea\" class=\"epi-overlay-content-highlight-area\"></span>\r\n</span>"}});
﻿define("epi/shell/widget/overlay/OverlayItemInfo", [
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    // dijit
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    // dojox
    "dojox/html/entities",
    // epi
    "epi/string",
    "epi/shell/widget/Tooltip",
    // template
    "dojo/text!./templates/OverlayItemInfo.html"
],
function (
// dojo
    array,
    declare,
    lang,

    domClass,
    domConstruct,
    domStyle,
    // dijit
    _WidgetBase,
    _TemplatedMixin,
    // dojox
    htmlEntities,
    // epi
    epiString,
    Tooltip,
    // template
    template
) {
    return declare([_WidgetBase, _TemplatedMixin], {
        // summary:
        //      Widget that used to display information for an overlay item
        // tags:
        //      internal

        templateString: template,

        postCreate: function () {
            this.inherited(arguments);

            // Setup default settings
            this.showStatusMessage(false);
        },

        destroy: function () {
            this.inherited(arguments);
            this._destroyTooltip();
        },

        showStatusMessage: function (/* Boolean */visible) {
            // summary:
            //      Toggle display of opacity layer
            // visible: [Boolean]
            //      Indicates additional information tooltip will be shown or not
            // tags:
            //      public

            if (this._tooltip) {
                visible ? this._tooltip.open(this.domNode) : this._tooltip.close();
            }
        },

        _setStatusIconAttr: function (/*Object*/ iconCssClass) {
            // summary:
            //      Set icon class of overlay item info
            // iconCssClass: [Object]
            //      The icon css class name
            // tags:
            //      private

            var isArray = lang.isArray(iconCssClass);
            if (isArray) {
                // Loop through array and add css class
                array.forEach(iconCssClass, function (cssClass) {
                    domClass.add(this.highlightArea, cssClass);
                }, this);
            } else {
                domClass.add(this.highlightArea, iconCssClass);
            }
        },

        _setStatusMessageAttr: function (/* Object */message) {
            // summary:
            //      Additional information about the content could be accessible in a tooltip
            // message: [Object]
            //      Tooltip content in multiple lines format
            //      Line format: { label: "label string", text: "text string", htmlEncode: true/false }
            // tags:
            //      private

            if (!message) {
                return;
            }

            var isArray = lang.isArray(message);

            if (this._tooltip) {
                if (isArray) {
                    this._tooltip.tooltipRows = message;
                } else {
                    this._tooltip.label = htmlEntities.encode(message);
                }
            } else {
                var messageContainer = domConstruct.create("div",
                        {
                            "class": "epi-overlay-content-tooltip",
                            innerHTML: epiString.toHTML(htmlEntities.encode(message))
                        }),
                    properties = isArray ? { tooltipRows: message} : { label: messageContainer.outerHTML };

                this._tooltip = new Tooltip(properties);
            }
        },

        _destroyTooltip: function () {
            // summary:
            //      Destroy tooltip
            // tags:
            //      private

            if (this._tooltip) {
                this._tooltip.destroyRecursive();
                this._tooltip = null;
            }
        }
    });
});

},
'url:epi/shell/widget/overlay/templates/OverlayItemInfo.html':"﻿<span class=\"epi-overlay-content\">\r\n    <span data-dojo-attach-point=\"highlightArea\" class=\"epi-overlay-content-highlight-area\"></span>\r\n</span>",
'epi-cms/contentediting/command/ContentAreaCommands':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/when",
    "dijit/Destroyable",
    "epi-cms/ApplicationSettings",
    "./BlockRemove",
    "./BlockEdit",
    "./ContentAreaItemBlockEdit",
    "./BlockInlineEdit",
    "./MoveVisibleToPrevious",
    "./MoveVisibleToNext",
    "./Personalize",
    "./SelectDisplayOption",
    "./MoveOutsideGroup"
], function (array, declare, Stateful, when, Destroyable, ApplicationSettings, Remove, Edit, ContentAreaItemBlockEdit, InlineEdit, MoveVisibleToPrevious, MoveVisibleToNext, Personalize, SelectDisplayOption, MoveOutsideGroup) {

    return declare([Stateful, Destroyable], {
        // tags:
        //      internal

        commands: null,

        constructor: function () {
            this._commandSpliter = this._commandSpliter || new Stateful({
                category: "menuWithSeparator"
            });
            this.contentAreaItemBlockEdit = new ContentAreaItemBlockEdit({ category: null });
            this.blockInlineEdit = new InlineEdit();
            this.moveVisibleToPrevious = new MoveVisibleToPrevious();
            this.moveVisibleToNext = new MoveVisibleToNext();
            this.commands = [
                new Edit({ category: null }),
                this.contentAreaItemBlockEdit,
                this.blockInlineEdit,
                this._commandSpliter,
                new SelectDisplayOption(),
                this.moveVisibleToPrevious,
                this.moveVisibleToNext,
                new Remove()
            ];
            var sectionsVisibility = Object.assign({}, ApplicationSettings.sectionsVisibility);
            // Only add personalize command if the ui is not limited
            if (!ApplicationSettings.limitUI && (sectionsVisibility.visitorGroups !== false)) {
                this.moveOutsideGroup = new MoveOutsideGroup();
                this.personalize = new Personalize({ category: null });
                this.commands.splice(4, 0, this.personalize, this.moveOutsideGroup);
            }

            this.commands.forEach(function (command) {
                this.own(command);
            }, this);
        },

        handleDoubleClick: function (itemModel) {
            if (itemModel.inlineBlockData) {
                when(this.contentAreaItemBlockEdit.updateModel(itemModel)).then(function () {
                    this.contentAreaItemBlockEdit.execute();
                }.bind(this));
            } else {
                when(this.blockInlineEdit.updateModel(itemModel)).then(function () {
                    this.blockInlineEdit.execute();
                }.bind(this));
            }
        },

        _modelSetter: function (model) {
            this.model = model;

            array.forEach(this.commands, function (command) {
                command.set("model", model);
            });
        }
    });
});

},
'epi-cms/contentediting/command/BlockRemove':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "epi",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand"
], function (declare, epi, _ContentAreaCommand) {

    return declare([_ContentAreaCommand], {
        // tags:
        //      internal xproduct

        name: "remove",

        label: epi.resources.action.remove,

        tooltip: epi.resources.action.remove,

        _execute: function () {
            // summary:
            //      Removes the content item.
            // tags:
            //      protected
            this.model.remove();
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            this.set("canExecute", !!this.model && !this.model.get("readOnly"));
        }
    });
});

},
'epi-cms/contentediting/command/_ContentAreaCommand':function(){
define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/lang",
    // Parent class
    "epi/shell/command/_Command"
], function (declare, lang, _Command) {

    return declare([_Command], {
        // summary:
        //      Base class for content area commands that execute on selected content item on the model.
        //
        // tags:
        //      internal

        _onModelChange: function () {
            // summary:
            //      Watches the model for changes to the current content after the model has been updated.
            // tags:
            //      protected
            var model = this.model;

            this._destroyModelHandles();

            if (!model) {
                this.set("canExecute", false);
                return;
            }

            this._watch("readOnly", function () {
                this._onModelValueChange();
            }, this);

            this._onModelValueChange();
        },

        destroy: function () {
            this._destroyModelHandles();

            this.inherited(arguments);
        },

        _destroyModelHandles: function () {
            if (this._handles) {
                // Remove any exisiting handles.
                for (var i = 0; i < this._handles.length; i++) {
                    this._handles[i].remove();
                }
            }

            this._handles = [];
        },

        _watch: function (property, callback, scope) {
            // summary:
            //      Attach a watch handler to the model
            // property: [String]
            //      The name of the property to watch
            // callback: [function]
            //      The function to execute when the property changed
            // scope: [Object]
            //      The scope in which the callback should be executed

            if (scope) {
                this._handles.push(this.model.watch(property, lang.hitch(scope, callback)));
            } else {
                this._handles.push(this.model.watch(property, callback));
            }
        },

        _getItem: function () {
            // summary:
            //      Get the selected content model, based on its group
            // tags:
            //      protected

            return this.model.contentGroup ? this.model.parent : this.model;
        },

        _getContainer: function () {
            // summary:
            //      Get the selected content parent model
            // tags:
            //      protected

            var getContainer = function (item) {
                if (item.parent) {
                    return getContainer(item.parent);
                }
                return item;
            };

            return getContainer(this.model);
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the current model value has changed. Subclasses should override this method.
            // tags:
            //      protected
        }
    });
});

},
'epi-cms/contentediting/command/BlockEdit':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",
    "epi",
    "epi/dependency",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/i18n!epi/cms/nls/episerver.shared.action"
], function (declare, lang, topic, when, epi, dependency, _ContentAreaCommand, ContentActionSupport, actionStrings) {

    return declare([_ContentAreaCommand], {
        // summary:
        //      Edit/View command for the Block component
        // tags:
        //      internal xproduct

        name: "edit",

        label: epi.resources.action.edit,

        tooltip: epi.resources.action.edit,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPen",

        // category: [readonly] String
        //      A category which hints that this item should be displayed with a separator.
        category: "menuWithSeparator",

        constructor: function () {
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
            var registry = dependency.resolve("epi.storeregistry");
            this._store = registry.get("epi.cms.content.light");
        },

        _execute: function () {
            // summary:
            //      Change the context to edit the block.
            // tags:
            //      protected
            var contentLink = this.model.contentLink;
            topic.publish("/epi/shell/context/request", {
                uri: "epi.cms.contentdata:///" + contentLink
            }, {});
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            var item = this.model;

            if (!item || item.inlineBlockData) {
                this.set("isAvailable", false);
                return;
            }

            this.set("isAvailable", true);

            if (!item || !item.contentLink) {
                this.set("canExecute", false);
                return;
            }

            var result = item && this._store.get(item.contentLink);

            // if the accessMask is available then display the label accordingly. (i.e either "View" or "Edit")
            when(result, lang.hitch(this, function (content) {
                this.set("canExecute", content && !content.isDeleted);
                if (content && content.accessMask) {
                    if (this.contentActionSupport.hasAccess(content.accessMask, this.contentActionSupport.accessLevel[this.contentActionSupport.action.Edit])) {
                        this.set("label", actionStrings.edit);
                        this.set("iconClass", "epi-iconPen");
                    } else {
                        this.set("label", actionStrings.view);
                        this.set("iconClass", "epi-iconSearch");
                    }
                }
            }));
        }
    });
});

},
'epi-cms/contentediting/command/ContentAreaItemBlockEdit':function(){
define([
    "dojo/_base/declare",
    "dojo/on",
    "dojo/topic",
    "dojo/when",
    "dojo/Evented",

    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",

    "dojox/html/entities",

    "epi/dependency",
    "epi/shell/DestroyableByKey",
    "epi/shell/TypeDescriptorManager",

    "epi/shell/command/_Command",

    "epi-cms/contentediting/DialogPositionAdjust",
    "epi-cms/contentediting/inline-editing/InlineEditBlockDialog",
    "epi-cms/contentediting/inline-editing/LocalBlockEditFormContainer",
    "epi-cms/_ContentContextMixin",
    "epi-cms/ApplicationSettings",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.inlineediting",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons",
    "epi/i18n!epi/nls/episerver.cms.contentapproval.command.requestapproval",

    "dojo/text!./../../widget/templates/CreateInlineBlock.html",
    "epi/i18n!epi/cms/nls/episerver.shared.action",
    "epi/i18n!epi/cms/nls/episerver.cms.components.createblock"
], function (
    declare,
    on,
    topic,
    when,
    Evented,

    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,

    htmlEntities,

    dependency,
    DestroyableByKey,
    TypeDescriptorManager,

    _Command,

    DialogPositionAdjust,
    InlineEditBlockDialog,
    LocalBlockEditFormContainer,
    _ContentContextMixin,
    applicationSettings,
    resources,
    toolbarButtonsRes,
    requestapprovalRes,

    template,
    actionStrings,
    createBlockRes
) {

    var EditInlineBlock = declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, Evented], {
        templateString: template,

        createBlockRes: createBlockRes,

        postCreate: function () {
            this.inherited(arguments);

            this.own(this.nameTextBox.on("keyup", function () {
                this.emit("change", this.getName());
            }.bind(this)));
        },

        getName: function () {
            return this.nameTextBox.get("value");
        },

        setName: function (name) {
            this.nameTextBox.set("value", name);

            if (!this.readOnly) {
                this.nameTextBox.focus();
                this.nameTextBox.textbox.select();
            }
        },

        setReadOnly: function (readOnly) {
            this.readOnly = readOnly;
            this.nameTextBox.set("readOnly", readOnly);
        }
    });

    return declare([_Command, Evented, DestroyableByKey, _ContentContextMixin], {
        // summary:
        //      Inline-edit command for local ContentArea blocks stored in ContentArea
        // tags:
        //      internal xproduct

        label: resources.inlineblockedit,

        iconClass: "epi-iconPenQuick",

        isContentAreaReadonly: false,

        // suppressOverlayAdjustments: [public] Boolean
        //      Flag which indicates that all overlay adjustments should not be performed. It might be useful when showing another overlay or dialog (e.g. TinyMCE full screen)
        suppressOverlayAdjustments: false,

        postscript: function () {
            this.inherited(arguments);

            this._dialogPositionAdjust = new DialogPositionAdjust();
            this.own(this._dialogPositionAdjust);
        },

        _execute: function () {
            // summary:
            //    Open the inline edit block dialog
            // tags:
            //      protected

            var blockName = htmlEntities.encode(this.model.name);
            var dialog = new InlineEditBlockDialog({
                title: blockName,
                mainCommand: this.mainCommand,
                suppressOverlayAdjustments: this.suppressOverlayAdjustments
            });

            var editInlineBlock;
            var form;
            var newName = blockName;

            function updateMainCommandVisibility() {
                if (!dialog) {
                    return;
                }
                dialog.toggleDisabledSaveButton(!form.get("isDirty") && (!newName || newName === blockName));
            }

            editInlineBlock = new EditInlineBlock({}, dialog.content, "last");

            var typeName = TypeDescriptorManager.getTypeNameFromTypeId(this.model.contentTypeId);
            if (typeName && !Object.prototype.hasOwnProperty.call(applicationSettings.inlineBlockNameProperties, typeName.toLowerCase())) {
                editInlineBlock.setReadOnly(this.isContentAreaReadonly);
                editInlineBlock.setName(blockName);
                editInlineBlock.namePanel.classList.remove("dijitHidden");
            }

            this.own(editInlineBlock.on("change", function (name) {
                newName = name;
                updateMainCommandVisibility();
            }.bind(this)));

            form = new LocalBlockEditFormContainer({});
            dialog.own(form);

            this._getMetadata(this.model.contentTypeId).then(function (metadata) {
                form.set("contentLink", this.parentContentLink);
                when(form.set("metadata", metadata)).then(function () {
                    form.set("value", this.model.inlineBlockData);
                    form.placeAt(editInlineBlock.propertiesForm);
                }.bind(this));
            }.bind(this));

            if (this.model.get("readOnly")) {
                form.set("readOnly", true);
            }

            dialog.own(on(form, "FormCreated", function () {
                if (form.model && !form._model.canChangeContent()) {
                    dialog.hideSaveButton();
                    dialog.set("closeText", "Close");
                }

                dialog.show();
                this._positionDialogOnTopOfMainContent(dialog);
                updateMainCommandVisibility();
            }.bind(this)));

            dialog.own(on(form, "isDirty", updateMainCommandVisibility.bind(form)));
            dialog.own(on(dialog, "execute", function () {
                this.emit("save", form.get("value"), newName || this.model.contentTypeName);
            }.bind(this)));

            dialog.own(on(dialog, "hide", function () {
                this._dialogPositionAdjust.cleanup();
            }.bind(this)));

            this.own(dialog);
            this._dialogPositionAdjust.adjustDialogPosition(dialog);
        },

        _positionDialogOnTopOfMainContent: function (dialog) {
            // summary:
            //      Content Types List will cover the main editing area with some small padding
            //
            // dialog:
            //      Dialog which will cover the editing area
            //
            // tags:
            //      private

            var mainContent = document.querySelector(".epi-main-content");
            if (mainContent) {
                var dimensions = mainContent.getBoundingClientRect();
                var padding = 40;
                dialog.domNode.style.left = dimensions.left + padding + "px";
                dialog.domNode.style.top = dimensions.top + padding + "px";
                dialog.domNode.style.width = dimensions.width - 2 * padding + "px";
                dialog.domNode.style.maxWidth = 880 + "px";
            }
        },

        _getMetadata: function (contentTypeId) {
            return when(this.getCurrentContent()).then(function (content) {
                this.parentContentLink = content.contentLink;
                this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");
                return this.metadataManager.getMetadataForType("EPiServer.Core.ContentData", {
                    parentLink: content.contentLink,
                    contentTypeId: contentTypeId
                });
            }.bind(this));
        },

        updateModel: function (model) {
            // summary:
            //      Updates model and returns result from onModelChange callback
            // tags:
            //      internal

            this.model = model;
            return this._onModelChange();
        },

        _onModelChange: function () {
            // summary:
            //      Updates isAvailable after the model has been updated.
            // tags:
            //      protected

            this.inherited(arguments);

            var item = this.model;

            if (!item || !item.inlineBlockData) {
                this.set("isAvailable", false);
                return;
            }

            this.set("canExecute", true);
            this.set("isAvailable", true);

            if (this.model instanceof Array) {
                // this command should be available only if one item selected
                // because it should be disabled when multiple blocks are selected
                // like in Assets pane
                if (this.model.length === 1) {
                    this.model = this.model[0];
                } else {
                    this.model = null;
                }
            }

            if (!this.model) {
                this.set("canExecute", false);
                return;
            }

            if (this.model.isOverlayInitialized === false) {
                return;
            }

            if (!this.isContentAreaReadonly) {
                this.set("label", actionStrings.edit);
                this.set("iconClass", "epi-iconPen");
            } else {
                this.set("label", actionStrings.view);
                this.set("iconClass", "epi-iconSearch");
            }
        }
    });
});

},
'epi-cms/contentediting/inline-editing/LocalBlockEditFormContainer':function(){
define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/on",
    "dojo/Evented",
    "epi",
    "epi/shell/tooltipHider",
    "epi-cms/contentediting/ContentActionSupport",

    "epi/shell/widget/FormContainer"
], function (
    declare,
    Deferred,
    on,
    Evented,
    epi,
    tooltipHider,
    ContentActionSupport,
    FormContainer) {

    return declare([FormContainer, Evented], {
        contentLink: null,
        isDirty: false,
        initialValue: null,

        _onIsDirty: function () {
            var isDirty = !epi.areEqual(this.get("initialValue"), this.get("value"));

            this.set("isDirty", isDirty);
            this.emit("isDirty", isDirty);
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(on(this, "FormCreated", function () {
                tooltipHider(this.form.getParent());
                this.onChange = this._onIsDirty.bind(this);

                this.own(on(this, "change", this._onIsDirty.bind(this)));
                this.own(on(this.domNode, "change", this._onIsDirty.bind(this)));
                this.own(on(this.domNode, "keyup", this._onIsDirty.bind(this)));
                this.initialValue = this.get("value");
            }.bind(this)));
        },

        layout: function () {
            this.inherited(arguments);
            if (this.containerLayout) {
                this.containerLayout.containerNode.style.removeProperty("height");
                this.containerLayout.containerNode.style.removeProperty("width");
            }
        },

        _onFormCreated: function () {
            this.inherited(arguments);

            if (this._model && !this._model.canChangeContent(ContentActionSupport.action.Edit)) {
                this.set("readOnly", true);
            }
        },

        _hideProperty: function (metadata, propertyName) {
            metadata.properties.some(function (property) {
                if (property.name === propertyName) {
                    property.showForEdit = false;
                    return true;
                }
                return false;
            });
        },

        _disableNonLanguageSpecificProperties: function (metadata) {
            metadata.properties.forEach(function (property) {
                if (!property.settings.isLanguageSpecific) {
                    property.showForEdit = false;
                }
            }.bind(this));
        },

        _setMetadataAttr: function (metadata) {
            var settings = (metadata.customEditorSettings || {}).inlineBlock;

            if (!settings) {
                console.warn("Metadata was not initialized properly");
                settings = {};
            }

            if (!settings.showNameProperty) {
                this._hideProperty(metadata, "icontent_name");
            }
            if (!settings.showCategoryProperty) {
                this._hideProperty(metadata, "icategorizable_category");
            }

            if (this.get("isTranslationNeeded")) {
                this._disableNonLanguageSpecificProperties(metadata);
            }

            metadata.properties.forEach(function (property) {
                property.settings.isInQuickEditMode = true;
                property.settings.quickEditBlockId = this.contentLink;
            }.bind(this));

            var hiddenGroups = settings.hiddenGroups.map(function (x) {
                return x.toLowerCase();
            });
            var numberOfVisibleGroups = metadata.groups.filter(function (x) {
                return x.name !== "EPiServerCMS_SettingsPanel" && hiddenGroups.indexOf(x.name.toLowerCase()) === -1;
            }).length;

            // Change group properties container to epi-cms/layout/CreateContentGroup
            metadata.layoutType = "epi/shell/layout/SimpleContainer";
            metadata.groups.forEach(function (group) {
                group.uiType = "epi-cms/layout/CreateContentGroupContainerNoHeader";

                if (group.name === "EPiServerCMS_SettingsPanel") {
                    group.options = {};
                    group.title = null;
                } else {
                    if (numberOfVisibleGroups > 1) {
                        group.uiType = "epi-cms/layout/CreateContentGroupContainer";
                    }
                }

                // by default Settings tab is not displayed
                if (hiddenGroups.indexOf(group.name.toLowerCase()) !== -1) {
                    group.displayUI = false;
                }
            });
            this._set("metadata", metadata);

            this.startup();
        }
    });
});

},
'url:epi-cms/widget/templates/CreateInlineBlock.html':"<div class=\"epi-createInlineBlock\">\r\n    <div class=\"epi-namePanel dijitHidden\" data-dojo-attach-point=\"namePanel\">\r\n        <label>\r\n            ${createBlockRes.name}\r\n        </label>\r\n        <input data-dojo-attach-point=\"nameTextBox\"\r\n               data-dojo-type=\"dijit/form/ValidationTextBox\"\r\n               data-dojo-props=\"selectOnClick: true, trim:true\"\r\n               maxlength=\"255\" />\r\n    </div>\r\n    <div>\r\n        <div data-dojo-attach-point=\"contentTypeList\"></div>\r\n        <div data-dojo-attach-point=\"propertiesForm\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/command/MoveVisibleToPrevious':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    // Parent class
    "epi-cms/contentediting/command/MoveToPrevious"
], function (array, declare, MoveToPrevious) {

    return declare([MoveToPrevious], {
        // summary:
        //      Moves the selected content block after the previous visible sibling. If the selected content block
        //      is within a group the group is moved instead.
        //
        // tags:
        //      internal

        _execute: function () {
            // summary:
            //      Moves the block after the next sibling; this could be abother block or a visitor group.
            // tags:
            //      protected

            this._getContainer().moveVisible(this._getItem(), false);
        },

        _onModelChange: function () {
            this.inherited(arguments);

            this._watch("visible", function () {
                this._onModelValueChange();
            }, this);
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            var children = array.filter(this._getContainer().getChildren(), function (child) {
                    return child.get("visible");
                }),
                index = array.indexOf(children, this._getItem());

            // Can execute if the index of the item is greater than the first index.
            this.set("canExecute", index > 0);
        }
    });
});

},
'epi-cms/contentediting/command/MoveToPrevious':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "epi",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand"
], function (declare, epi, _ContentAreaCommand) {

    return declare([_ContentAreaCommand], {
        // summary:
        //      Moves the selected content block after the previous sibling.
        //
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: epi.resources.action.moveup,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: epi.resources.action.moveup,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconUp",

        _execute: function () {
            // summary:
            //      Moves the block before the previous sibling; this could be abother block or a visitor group.
            // tags:
            //      protected
            this.model.movePrevious();
        },

        _onModelChange: function () {
            this.inherited(arguments);

            this._watch("canMovePrevious", function () {
                this._onModelValueChange();
            }, this);
        },

        _onModelValueChange: function () {
            this.set("canExecute", this.model.get("canMovePrevious") && !this.model.get("readOnly"));
        }
    });
});

},
'epi-cms/contentediting/command/MoveVisibleToNext':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    // Parent class
    "epi-cms/contentediting/command/MoveToNext"
], function (array, declare, MoveToNext) {

    return declare([MoveToNext], {
        // summary:
        //      Moves the selected content block after the next visible sibling. If the selected content block
        //      is within a group the group is moved instead.
        //
        // tags:
        //      internal

        _execute: function () {
            // summary:
            //      Moves the block after the next sibling; this could be abother block or a visitor group.
            // tags:
            //      protected

            this._getContainer().moveVisible(this._getItem(), true);
        },

        _onModelChange: function () {
            this.inherited(arguments);

            this._watch("visible", function () {
                this._onModelValueChange();
            }, this);
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            var children = array.filter(this._getContainer().getChildren(), function (child) {
                    return child.get("visible");
                }),
                index = array.indexOf(children, this._getItem());

            // Can execute if the index of the item is less than the last index.
            this.set("canExecute", index !== -1 && index < children.length - 1);
        }
    });
});

},
'epi-cms/contentediting/command/MoveToNext':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "epi",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand"
], function (declare, epi, _ContentAreaCommand) {

    return declare([_ContentAreaCommand], {
        // summary:
        //      Moves the selected content block after the next sibling.
        //
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: epi.resources.action.movedown,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: epi.resources.action.movedown,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconDown",

        // category: [readonly] String
        //      Indicates that this command should created with a separator.
        category: "menuWithSeparator",

        _execute: function () {
            // summary:
            //      Moves the block after the next sibling; this could be abother block or a visitor group.
            // tags:
            //      protected

            this.model.moveNext();
        },

        _onModelChange: function () {
            this.inherited(arguments);

            // Watch the new model for changes
            this._watch("canMoveNext", function () {
                this._onModelValueChange();
            }, this);
        },

        _onModelValueChange: function () {
            this.set("canExecute", this.model.get("canMoveNext") && !this.model.get("readOnly"));
        }
    });
});

},
'epi-cms/contentediting/command/Personalize':function(){
define([
    // General application modules
    "dojo/_base/declare",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize"
], function (declare, PersonalizedGroupViewModel, _ContentAreaCommand, resources) {

    return declare([_ContentAreaCommand], {
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resources.label,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconUsers",


        _execute: function () {
            // summary:
            //      Opens the personalization dialog and adds the selected item to a visitor group if necessary.
            // tags:
            //      protected
            if (!this.model.contentGroup) {
                this.model.personalize();
            }
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            this.set("canExecute", !!this.model && (this.model.contentLink || this.model.inlineBlockData) && !this.model.contentGroup && !this.model.get("readOnly"));
        }
    });
});

},
'epi-cms/contentediting/command/SelectDisplayOption':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "epi/dependency",

    "epi-cms/contentediting/command/_ContentAreaCommand",
    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",

    "epi-cms/widget/DisplayOptionSelector",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.displayoptions"
], function (declare, lang, when, dependency, _ContentAreaCommand, ContentBlockViewModel, DisplayOptionSelector, resources) {

    return declare([_ContentAreaCommand], {
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resources.label,

        // category: [readonly] String
        //      A category which hints that this item should be displayed as an popup menu.
        category: "popup",

        _labelAutomatic: lang.replace(resources.label, [resources.automatic]),

        constructor: function () {
            this.popup = new DisplayOptionSelector();
        },

        postscript: function () {
            this.inherited(arguments);

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.displayoptions");
            }

            when(this.store.get(), lang.hitch(this, function (options) {
                // Reset command's available property in order to reset dom's display property of the given node
                this._setCommandAvailable(options);

                this.popup.set("displayOptions", options);
            }));
        },

        destroy: function () {
            this.inherited(arguments);

            this.popup && this.popup.destroyRecursive();
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected

            if (!this.model) {
                this.set("isAvailable", false);
                return;
            }

            this.inherited(arguments);

            var options = this.popup.displayOptions,
                selectedOption = this.model.get("displayOption"),
                isAvailable = options && options.length > 0;

            isAvailable = isAvailable && (this.model instanceof ContentBlockViewModel);

            this._setCommandAvailable(options);

            if (!isAvailable) {
                this.set("label", this._labelAutomatic);
                return;
            }

            this.popup.set("model", this.model);

            if (!selectedOption) {
                this.set("label", this._labelAutomatic);
            } else {
                this._setLabel(selectedOption);
            }

            this._watch("displayOption", function (property, oldValue, newValue) {
                if (!newValue) {
                    this.set("label", this._labelAutomatic);
                } else {
                    this._setLabel(newValue);
                }
            }, this);
        },

        _setCommandAvailable: function (/*Array*/displayOptions) {
            // summary:
            //      Set command available
            // displayOptions: [Array]
            //      Collection of a content display mode
            // tags:
            //      private

            this.set("isAvailable", displayOptions && displayOptions.length > 0 && this.model instanceof ContentBlockViewModel);
        },

        _setLabel: function (displayOption) {
            when(this.store.get(displayOption), lang.hitch(this, function (option) {
                this.set("label", lang.replace(resources.label, [option.name]));

            }), lang.hitch(this, function (error) {

                console.log("Could not get the option for: ", displayOption, error);

                this.set("label", this._labelAutomatic);
            }));
        },

        _onModelValueChange: function () {
            this.set("canExecute", !!this.model && (this.model.contentLink || this.model.inlineBlockData) && !this.model.get("readOnly"));
        }
    });
});

},
'epi-cms/widget/DisplayOptionSelector':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "dijit/MenuSeparator",

    "epi/shell/DestroyableByKey",
    "epi-cms/widget/SelectorMenuBase",

    // Resouces
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.displayoptions",

    // Widgets used in template
    "epi/shell/widget/RadioMenuItem"
], function (
    array,
    declare,
    lang,
    when,

    MenuSeparator,

    DestroyableByKey,
    SelectorMenuBase,

    // Resouces
    resources,

    RadioMenuItem
) {

    return declare([SelectorMenuBase, DestroyableByKey], {
        // summary:
        //      Used for selecting display options for a block in a content area
        //
        // tags:
        //      internal

        // model: [public] epi-cms/contentediting/viewmodel/ContentBlockViewModel
        //      View model for the selector
        model: null,

        // _resources: [private] Object
        //      Resource object used in the template
        headingText: resources.title,

        _rdAutomatic: null,

        postCreate: function () {
            // summary:
            //      Create the selector template and query for display options

            this.inherited(arguments);

            this.own(this._rdAutomatic = new RadioMenuItem({ label: resources.automatic, value: "" }));
            this.addChild(this._rdAutomatic);
            this.own(this._rdAutomatic.on("change", lang.hitch(this, this._restoreDefault)));
        },

        destroy: function () {
            this._removeMenuItems();

            this.inherited(arguments);
        },

        _restoreDefault: function () {
            this.model.modify(function () {
                this.model.set("displayOption", null);
            }, this);
        },

        _setModelAttr: function (model) {
            this._set("model", model);

            this._setup();
        },

        _setDisplayOptionsAttr: function (displayOptions) {
            this._set("displayOptions", displayOptions);

            this._setup();
        },

        _setup: function () {

            if (!this.model || !this.displayOptions) {
                return;
            }

            //Destroy the old menu items
            this._removeMenuItems();

            var selectedDisplayOption = this.model.get("displayOption");

            array.forEach(this.displayOptions, function (displayOption) {

                var item = new RadioMenuItem({
                    label: displayOption.name,
                    iconClass: displayOption.iconClass,
                    displayOptionId: displayOption.id,
                    checked: selectedDisplayOption === displayOption.id,
                    title: displayOption.description
                });

                this.ownByKey("items", item.watch("checked", lang.hitch(this, function (property, oldValue, newValue) {
                    if (!newValue) {
                        return;
                    }
                    //Modify the model
                    this.model.modify(function () {
                        this.model.set("displayOption", displayOption.id);
                    }, this);
                })));

                this.addChild(item);
            }, this);

            this._rdAutomatic.set("checked", !selectedDisplayOption);
        },

        _removeMenuItems: function () {
            var items = this.getChildren();
            this.destroyByKey("items");
            items.forEach(function (item) {
                if (item === this._rdAutomatic) {
                    return;
                }
                this.removeChild(item);
                item.destroy();
            }, this);
        }
    });
});

},
'epi-cms/contentediting/command/MoveOutsideGroup':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize"
], function (declare, _ContentAreaCommand, resource) {

    return declare([_ContentAreaCommand], {
        // summary:
        //      Moves the selected content block outside the group if it belongs to a group
        //
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resource.moveoutsidegroup,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: resource.moveoutsidegroup,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "",

        // category: [readonly] String
        //      Indicates that this command should created with a separator.
        category: "menuWithSeparator",

        _execute: function () {
            // summary:
            //      Moves the block after the next sibling; this could be abother block or a visitor group.
            // tags:
            //      protected

            this.model.moveOutsideGroup();
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected

            this.set("canExecute", this.model.contentGroup && !this.model.get("readOnly"));
        }
    });
});

},
'url:epi-cms/widget/templates/Block.html':"﻿<div class=\"dojoDndItem epi-overlay-block\">\r\n    <div data-dojo-attach-point=\"containerDomNode\"></div>\r\n    <span class=\"epi-personalized\" data-dojo-attach-point=\"iconsContainer\">\r\n        <span class=\"epi-overlayLabels\">\r\n            <span class=\"dijitReset dijitInline epi-sharedIndicator\" data-dojo-attach-point=\"sharedLabelNode\">${res.shared}</span>\r\n        </span>\r\n        <span class=\"epi-overlayControls epi-mediumButton\">\r\n            <span class=\"dijitReset dijitInline dijitIcon epi-iconWarning\" data-dojo-attach-point=\"warningIcon\" style=\"display: none;\"></span>\r\n            <span class=\"dijitReset dijitInline dijitIcon epi-iconUsers\" data-dojo-attach-point=\"personalizedIcon\"></span>\r\n        </span>\r\n    </span>\r\n    <button class=\"epi-chromelessButton epi-overlayControls epi-settingsButton epi-mediumButton\" data-dojo-attach-point=\"settingsButton\" data-dojo-type=\"dijit/form/DropDownButton\" data-dojo-props=\"showLabel:false, title:'${res.settingstooltip}', iconClass:'epi-iconContextMenu'\">\r\n        <div data-dojo-attach-point=\"contextMenu\" data-dojo-type=\"epi/shell/widget/ContextMenu\"></div>\r\n    </button>\r\n</div>\r\n",
'epi-cms/widget/command/CreateContentFromContentArea':function(){
define([
    "dojo/_base/declare",
    "dojo/on",
    "dojo/when",

    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",

    // Shell
    "epi",
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/widget/dialog/Dialog",

    // CMS
    "epi-cms/contentediting/DialogPositionAdjust",
    "epi-cms/_ContentContextMixin",
    "epi-cms/widget/ContentTypeList",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/inline-editing/CreateNewInlineBlockEditFormContainer",
    "epi-cms/contentediting/inline-editing/InlineEditBlockDialog",

    "dojo/text!./../templates/CreateInlineBlock.html",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea",
    "epi/i18n!epi/cms/nls/episerver.shared.action",
    "epi/i18n!epi/cms/nls/episerver.cms.components.createblock",
    "epi/i18n!epi/cms/nls/contenttypes.blockdata"
],

function (
    declare,
    on,
    when,

    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,

    // Shell
    epi,
    dependency,
    _Command,
    Dialog,

    // CMS
    DialogPositionAdjust,
    _ContentContextMixin,
    ContentTypeList,
    applicationSettings,
    CreateNewInlineBlockEditFormContainer,
    InlineEditBlockDialog,

    template,

    contentAreaRes,
    sharedResources,
    createBlockRes,
    blockDataRes
) {
    var formIdentifier = "episerver.forms.implementation.elements.formcontainerblock";

    var SimpleContentTypeList = declare([ContentTypeList], {
        _getSuggestedContentTypes: function () {
            return [];
        },
        //TODO: Fix support in EPiServer Forms package, for now we disable the command for forms
        _getAvailableContentTypes: function () {
            var result = this.inherited(arguments);
            return when(result).then(function (types) {
                return types.filter(function (type) {
                    return type.typeIdentifier !== formIdentifier;
                });
            });
        }
    });

    var CreateInlineBlock = declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        templateString: template,

        createBlockRes: createBlockRes,

        getName: function () {
            return this.nameTextBox.get("value");
        },

        setName: function (defaultName) {
            this.nameTextBox.set("value", defaultName);
            this.nameTextBox.focus();
            this.nameTextBox.textbox.select();
        }
    });

    return declare([_Command, _ContentContextMixin], {
        // tags:
        //      internal

        // canExecute: [Boolean]
        //      Default value indicate that command can execute
        canExecute: true,

        // value: [String]
        //      Default select content
        value: null,

        // allowedTypes: [public] Array
        //      The types which are allowed for the given property. i.e used for filtering based on AllowedTypesAttribute
        allowedTypes: null,

        // restrictedTypes: [public] Array
        //      The types which are restricted.
        restrictedTypes: null,

        // suppressOverlayAdjustments: [public] Boolean
        //      Flag which indicates that all overlay adjustments should not be performed. It might be useful when showing another overlay or dialog (e.g. TinyMCE full screen)
        suppressOverlayAdjustments: false,

        postscript: function () {
            this.inherited(arguments);
            this._dialogPositionAdjust = new DialogPositionAdjust();
            this.own(this._dialogPositionAdjust);

            this.contextService = this.contextService || dependency.resolve("epi.shell.ContextService");
        },

        contextChanged: function (ctx, callerData) {
            // summary:
            //      On context change
            // tags:
            //      protected

            this.set("isAvailable", this._isContentContext(ctx));
            this.inherited(arguments);
        },

        _execute: function () {
            // summary:
            //		Executes this command; ...
            // tags:
            //		protected

            when(this.getCurrentContent(), function (currentContent) {
                if (!currentContent) {
                    return;
                }

                // when creating nest block in quick edit
                var contentLink = currentContent.contentLink || currentContent.id;

                // Get the context store for more information about the model
                // We need to append the ?uri= because the request chain can not handle URI's in URI's
                when(this.contextService.query({uri: "epi.cms.contentdata:///" + contentLink}), function (context) {
                    if (!context) {
                        return;
                    }
                    this._createLocalBlock(currentContent, contentLink);
                }.bind(this));
            }.bind(this));
        },

        _createInlineForm: function (content, selectedType) {
            // summary:
            //      Create an inline form for a specific block type
            //
            // content:
            //      The content which will be the parent of the new block
            // selectedType:
            //      Selected block type
            //
            // tags:
            //      private

            var form = new CreateNewInlineBlockEditFormContainer({
                autoPublish: true,
                addToDestination: this.model
            });

            return form.reloadMetadata(content, selectedType.id).then(function () {
                return form;
            });
        },

        _positionDialogOnTopOfMainContent: function (dialog) {
            // summary:
            //      Content Types List will cover the main editing area with some small padding
            //
            // dialog:
            //      Dialog which will cover the editing area
            //
            // tags:
            //      private

            var mainContent = document.querySelector(".epi-main-content");
            if (mainContent) {
                var dimensions = mainContent.getBoundingClientRect();
                var padding = 40;
                dialog.domNode.style.left = dimensions.left + padding + "px";
                dialog.domNode.style.top = dimensions.top + padding + "px";
                dialog.domNode.style.width = dimensions.width - 2 * padding + "px";
                dialog.domNode.style.height = dimensions.height - 2 * padding + "px";
                dialog.domNode.style.maxWidth = 880 + "px";
                dialog.containerNode.style.maxHeight = "calc(100% - 100px)";
            }
        },

        _createLocalBlock: function (content, contentLink) {
            var _this = this;
            var dialog;

            var restrictedTypes = this.restrictedTypes;
            var createInlineBlock;
            var contentTypeList = new SimpleContentTypeList({
                allowedTypes: this.allowedTypes,
                restrictedTypes: restrictedTypes,
                localAsset: true,
                parentLink: contentLink,
                onContentTypeSelected: function (selectedType) {
                    when(_this._createInlineForm(content, selectedType)).then(function (form) {
                        form.placeAt(createInlineBlock.propertiesForm);
                        contentTypeList.destroy();

                        function updateMainCommandVisibility() {
                            if (!dialog) {
                                return;
                            }

                            var formValue = form.get("value");
                            var allValuesAreFalsy = !formValue || Object.values(formValue).every(function (x) {
                                return epi.isEmpty(x);
                            });

                            dialog.toggleDisabledSaveButton(!form.get("isDirty") || allValuesAreFalsy);
                        }
                        _this.own(on(dialog, "execute", function () {
                            form.saveForm(selectedType, createInlineBlock.getName());
                            dialog.hide();
                        }));
                        _this.own(on(dialog, "hide", function () {
                            _this._dialogPositionAdjust.cleanup();
                        }));
                        dialog.own(form);

                        _this._dialogPositionAdjust.adjustDialogPosition(dialog);

                        dialog.toggleDisabledSaveButton(false);
                        updateMainCommandVisibility();

                        dialog.own(on(form, "isDirty", updateMainCommandVisibility.bind(form)));

                        if (!Object.prototype.hasOwnProperty.call(applicationSettings.inlineBlockNameProperties, selectedType.name.toLowerCase())) {
                            var title = sharedResources["new"] + " " + selectedType.localizedName;
                            createInlineBlock.namePanel.classList.remove("dijitHidden");
                            createInlineBlock.setName(title);
                        }
                    });
                }
            });

            _this.own(contentTypeList.watch("shouldSkipContentTypeSelection", function () {
                dialog = new InlineEditBlockDialog({
                    // eslint-disable-next-line no-undef
                    acknowledgeActionText: epi.resources.action.cancel,
                    confirmActionText: epi.resources.action.create,
                    dialogClass: "epi-dialog-portrait inline-edit-dialog inline-create-dialog",
                    title: sharedResources["new"] + " " + contentAreaRes.inline + " " + blockDataRes.name,
                    suppressOverlayAdjustments: _this.suppressOverlayAdjustments,
                    saveLabel: sharedResources.create
                });

                var contextService = _this.contextService;
                dialog.on("cancel", function () {
                    if (!contextService.currentContext) {
                        contextService.currentContext = {};
                    }
                    contextService.currentContext.currentMode = undefined;
                });

                createInlineBlock = new CreateInlineBlock({}, dialog.content, "last");
                contentTypeList.placeAt(createInlineBlock.contentTypeList);

                dialog.show();
                dialog.toggleDisabledSaveButton(true);
                _this._positionDialogOnTopOfMainContent(dialog);
                _this.own(dialog);
                contentTypeList._suggestedContentTypes.setVisibility(false);
                createInlineBlock.own(contentTypeList);
            }));
            contentTypeList.set("requestedType", "episerver.core.blockdata");
            contentTypeList.refresh();
        }
    });
});

},
'epi-cms/contentediting/inline-editing/CreateNewInlineBlockEditFormContainer':function(){
define([
    "dojo/_base/declare",
    "epi-cms/contentediting/inline-editing/CreateNewBlockEditFormContainer"
], function (
    declare,
    CreateNewBlockEditFormContainer) {
    return declare([CreateNewBlockEditFormContainer], {
        autoStartup: false,

        saveModel: function (contentType, name) {
            this.createContentViewModel.saveLocalBlock({
                name: name || contentType.localizedName,
                contentTypeId: contentType.id,
                inlineBlockData: this.get("value"),
                typeIdentifier: contentType.typeIdentifier
            });
        }
    });
});

},
'epi-cms/contentediting/command/BlockConvert':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/when",
    "epi",
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/applicationSettings",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand",
    "epi/shell/DialogService",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea"
], function (
    declare,
    when,
    epi,
    dependency,
    TypeDescriptorManager,
    applicationSettings,
    _ContentAreaCommand,
    dialogService,
    res) {

    return declare([_ContentAreaCommand], {
        // tags:
        //      internal xproduct

        name: "convert",

        label: res.converttoinlineblock,

        _execute: function () {
            this.contentDataStore = this.contentDataStore || dependency.resolve("epi.storeregistry").get("epi.cms.contentdata");
            when(this.contentDataStore.executeMethod("ConvertSharedBlock", this.model.contentLink)).then(function (result) {
                if (!Object.values(result.data).some(function (x) {
                    return !!x;
                })) {
                    dialogService.alert(res.converttoinlineblockerror);
                    return;
                }

                this.model.parent.modify(function () {
                    this.model.modify(function () {
                        this.model.inlineBlockData = result.data;
                        this.model.contentTypeId = result.contentTypeId;
                        this.model.label = result.name;
                        this.model.name = result.name;
                        // inline blocks have no content link, we need to set it to null
                        this.model.contentLink = null;
                    }.bind(this));
                }.bind(this));
            }.bind(this));
        },

        _getMetadata: function () {
            this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");
            return when(this.metadataManager.getMetadataForType("EPiServer.Core.ContentData", { contentLink: this.model.contentLink }),
                function (metadata) {
                    return metadata;
                });
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected

            if (this.model.get("readOnly") || !applicationSettings.inlineBlocksInContentAreaEnabled) {
                this.set("isAvailable", false);
                this.set("canExecute", false);
                return;
            }

            //TODO: Fix support in EPiServer Forms package, for now we disable the command for forms
            var formIdentifier = "episerver.forms.implementation.elements.formcontainerblock";
            if (this.model.typeIdentifier === formIdentifier) {
                this.set("isAvailable", false);
                this.set("canExecute", false);
                return;
            }

            this._typeDescriptorManager = this._typeDescriptorManager || TypeDescriptorManager;
            var isBlockType = this._typeDescriptorManager.isBaseTypeIdentifier(this.model.typeIdentifier, "episerver.core.blockdata");
            var isInlineBlock = this.model && this.model.inlineBlockData;
            this.set("isAvailable", isBlockType && !isInlineBlock);
            this.set("canExecute", isBlockType && !isInlineBlock);
        }
    });
});

},
'epi-cms/contentediting/AllowedTypesList':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/dom-class",

    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",

    // epi
    "epi/shell/TypeDescriptorManager",

    // resources
    "dojo/text!./templates/AllowedTypesList.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentreferencelisteditor"
], function (
    // dojo
    declare,
    domClass,

    // dijit
    _TemplatedMixin,
    _WidgetBase,

    // epi
    TypeDescriptorManager,

    // resources
    templateString,
    resources) {

    return declare([_WidgetBase, _TemplatedMixin], {
        // tags:
        //      internal

        templateString: templateString,

        // defaultAllowedTypedList: [public] String[]
        //    The default allowed types list
        defaultAllowedTypes: ["episerver.core.icontentdata", "episerver.core.icontent"],

        // _hasAllowedTypes: [private] Boolean
        //      Indicate whether there is any allowed types restriction
        _hasAllowedTypes: false,
        // _hasRestrictedTypes: [private] Boolean
        //      Indicate whether there is any restricted types restriction
        _hasRestrictedTypes: false,

        postMixInProperties: function () {
            this.inherited(arguments);
            this.resources = resources;
        },

        _setAllowedTypesAttr: function (allowedTypes) {
            this.allowedTypes = allowedTypes;
            if (this._hasAllowedTypesRestriction()) {
                this._hasAllowedTypes = true;
                domClass.remove(this.allowedTypesWrapper, "dijitHidden");
                this.allowedTypesList.innerHTML = this._convertToUserFriendlyNames(allowedTypes).join(", ");
            } else {
                this._hasAllowedTypes = false;
                domClass.add(this.allowedTypesWrapper, "dijitHidden");
            }
        },

        _setRestrictedTypesAttr: function (restrictedTypes) {
            if (!restrictedTypes || restrictedTypes.length === 0) {
                this._hasRestrictedTypes = false;
                domClass.add(this.restrictedTypesWrapper, "dijitHidden");
            } else {
                this._hasRestrictedTypes = true;
                domClass.remove(this.restrictedTypesWrapper, "dijitHidden");
                this.restrictedTypesList.innerHTML = this._convertToUserFriendlyNames(restrictedTypes).join(", ");
            }
        },

        _convertToUserFriendlyNames: function (types) {
            function onlyUnique(value, index, array) {
                return array.indexOf(value) === index;
            }

            return types.map(function (typeIdentifier) {
                return TypeDescriptorManager.getTypeName(typeIdentifier);
            }).filter(onlyUnique);
        },

        _getHasRestrictionAttr: function () {
            //  summary:
            //      Return true if there is any restriction which is not default

            return this._hasAllowedTypes || this._hasRestrictedTypes;
        },

        _hasAllowedTypesRestriction: function () {
            // summary:
            //      Return true if there is any restriction in allowedTypes which is not default

            if (!this.allowedTypes || this.allowedTypes.length === 0) {
                // allowedTypes doesn't exist
                return false;
            }

            // unlikely happens, but added to detect unwanted null exception
            if (!this.defaultAllowedTypes || this.defaultAllowedTypes.length === 0) {
                return true;
            }

            var defaultList = this.defaultAllowedTypes;
            if (this.allowedTypes.every(function (e) {
                return defaultList.includes(e);
            })) {
                // every item in allowedTypes is default restriction
                return false;
            }

            // restriction in allowedTypes exists which is not default.
            return true;
        }
    });
});

},
'url:epi-cms/contentediting/templates/AllowedTypesList.html':"﻿<div>\r\n    <div data-dojo-attach-point=\"allowedTypesWrapper\" class=\"dijitHidden\">\r\n        <strong>${resources.allowedtypes}</strong>\r\n        <p data-dojo-attach-point=\"allowedTypesList\"></p>\r\n    </div>\r\n    <div data-dojo-attach-point=\"restrictedTypesWrapper\" class=\"dijitHidden\">\r\n        <strong>${resources.restrictedtypes}</strong>\r\n        <p data-dojo-attach-point=\"restrictedTypesList\"></p>\r\n    </div>\r\n</div>",
'epi-cms/contentediting/editors/_TextWithActionsMixin':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/when",

    // epi
    "epi/dependency",
    "epi/string",
    "epi/shell/command/_Command",

    // epi-cms
    "epi-cms/widget/ContentSelectorPlugAndPlay",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.overlay.blockarea"
], function (
    // dojo
    declare,
    aspect,
    when,

    // epi
    dependency,
    epiString,
    _Command,

    // epi-cms
    ContentSelectorPlugAndPlay,

    // Resources
    resource
) {

    return declare(null, {
        // summary:
        //      Handles action links
        // tags:
        //      public

        // actionsResource: [Object]
        //      The resource of actions link
        actionsResource: resource,

        // actionButtonLabel: [String]
        //      The label of action button.
        actionButtonLabel: null,

        isCreateLinkVisible: function () {
            // summary:
            //      Determines whether the "create" action in the action area is visible.
            //      Defaults to true, meaning that the action is shown.
            // returns:
            //      Promise|Boolean
            // tags:
            //      protected

            return true;
        },

        _setupCommands: function (actions, showCreateLink) {
            this._actionCommands = [];
            if (!showCreateLink) {
                return this._actionCommands;
            }

            for (var action in actions) {
                this._actionCommands.push(new _Command({
                    label: actions[action],
                    isAvailable: true,
                    canExecute: true,
                    _execute: function () {
                        this.executeAction(action);
                    }.bind(this)
                }));
            }
        },

        _setupContentSelector: function (container, commands) {
            // construct instance with options commands & content selector dialog settings.
            this._contentSelectorPlugNPlay = this._contentSelectorPlugNPlay || new ContentSelectorPlugAndPlay({
                roots: this.roots,
                actionsNodeOptions: {
                    settings: {
                        label: this.actionButtonLabel
                    }
                },
                commands: commands || [],
                contentSelectorDialogSettings: {
                    allowedTypes: this.allowedTypes,
                    restrictedTypes: this.restrictedTypes
                }
            });
            // place widget to container
            this._contentSelectorPlugNPlay.placeAt(container);
            // listen event when the widget's dialog is executed and save value.
            this.own(aspect.after(this._contentSelectorPlugNPlay, "onDialogExecute", function (selectedContentLink) {
                this.onFocus();
                if (!this.contentDataStore) {
                    var registry = dependency.resolve("epi.storeregistry");
                    this.contentDataStore = registry.get("epi.cms.contentdata");
                }
                when(this.contentDataStore.get(selectedContentLink)).then(function (selectedContent) {
                    this.onDialogExecute(selectedContent);
                }.bind(this));
            }.bind(this), true));
        },

        _setupActions: function (/*Object*/container) {
            // summary:
            //      Initial ContentSelectorPlugAndPlay
            //      depend on context are create will show template without create, otherwise
            // container: [Object]
            //      The container will put content selector plug and play instance to.
            // tags:
            //      internal

            when(this.isCreateLinkVisible()).then(function (showCreateLink) {
                this._setupCommands(this.actionsResource.emptyactions.actions, showCreateLink);
                this._setupContentSelector(container, this._actionCommands);
            }.bind(this));
        },

        executeAction: function (/*String*/actionName) {
            // summary:
            //      Called when action clicked
            // tags:
            //      public
        },

        onDialogExecute: function (/*object*/value) {
            // summary:
            //      Called when dialog is executed
            // tags:
            //      public
        }
    });
});

},
'epi-cms/widget/ContentSelectorPlugAndPlay':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",

    // dijit
    "dijit/registry",
    "dijit/_CssStateMixin",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/focus",

    // epi.shell
    "epi/shell/command/_Command",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/command/builder/DropDownButtonBuilder",
    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/TypeDescriptorManager",

    // epi.cms
    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/widget/command/DefaultContentSelectorPlugAndPlayCommand",
    "epi-cms/plugin-area/content-selector-plugandplay",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentselectorplugandplay",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentselector",
    "dojo/text!./templates/ContentSelectorPlugAndPlay.html"
], function (
    // dojo
    declare,
    lang,
    aspect,

    // dijit
    registry,
    _CssStateMixin,
    _TemplatedMixin,
    _Widget,
    focusManager,

    // epi.shell
    _Command,
    ButtonBuilder,
    DropDownButtonBuilder,
    MenuAssembler,
    TypeDescriptorManager,

    // epi.cms
    _HasChildDialogMixin,
    DefaultContentSelectorPlugAndPlayCommand,
    plugInArea,

    // resources
    localization,
    contentselectorLocalization,
    template
) {
    return declare([_Widget, _TemplatedMixin, _CssStateMixin, _HasChildDialogMixin], {
        // summary:
        //    Represents the widget to select ContentReference with extra actions everywhere.
        // tags:
        //      internal xproduct

        baseClass: "epi-content-selector-plugnplay",
        templateString: template,
        resources: localization,

        iconClass: "iconUpload",
        text: null,
        commands: null,
        dialogSettings: null,
        contentSelectorDialogSettings: null,
        readonly: false,
        selectCommandText: null,
        buttonLabel: null,

        dialog: null,
        contentSelectorDialog: null,
        actionsNodeOptions: null,
        _selectContentCommand: null,
        _menuWithSeparator: null,

        onContentSelectorChange: function (/*object*/value) {
            // summary:
            //    Handle content selector inside dialog is changed value.
            // tags:
            //    public callback
        },

        onSearchResultSelected: function (/*object*/value) {
            // summary:
            //    Handle a search result is selected.
            // tags:
            //    public callback
        },

        onDialogExecute: function (/*object*/value) {
            // summary:
            //    Handle dialog execute
            // tags:
            //    public callback
        },

        onDialogShow: function () {
            // summary:
            //    Handle dialog show
            // tags:
            //    public callback
        },

        onDialogHide: function () {
            // summary:
            //    Handle dialog hide
            // tags:
            //    public callback
        },

        _getActionButton: function () {
            var node = this.actionsNode.children[0];
            return node && registry.byNode(node);
        },

        _setTitleAttr: function (value) {
            this._set("title", value);

            // update dialog title
            this.dialogSettings.title = value;
            this.dialog && this.dialog.set("title", value);
        },

        _setSelectCommandTextAttr: function (value) {
            this._set("selectCommandText", value);

            // update button label in case we have only one command.
            var button = this._getActionButton();
            button && this._set("buttonLabel", value);
            button && button.set("label", value);
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);
            [].concat(this.commands).forEach(function (cmd) {
                cmd && cmd.set("canExecute", !value);
            });
        },

        _setDisabledAttr: function (value) {
            this._set("disabled", value);
            [].concat(this.commands).forEach(function (cmd) {
                cmd && cmd.set("canExecute", !value);
            });
        },

        _setupCommands: function () {
            this.commands = this.commands || [];
            this._selectContentCommand = this._selectContentCommand || new DefaultContentSelectorPlugAndPlayCommand({
                contentSelectorDialogSettings: this.contentSelectorDialogSettings,
                dialogSettings: this.dialogSettings,
                label: this.selectCommandText || this.resources.selectcontentcommand.label,
                canExecute: !this.readonly
            });
            ["onContentSelectorChange", "onSearchResultSelected", "onDialogExecute", "onDialogHide", "onDialogShow"].forEach(function (callbackName) {
                this.own(aspect.after(this._selectContentCommand, callbackName, function () {
                    this[callbackName].apply(this, arguments);
                }.bind(this), true));
            }.bind(this));

            this._menuWithSeparator = this._menuWithSeparator || new _Command({ isAvailable: false, canExecute: false, category: "menuWithSeparator" });
            if (this.commands.length > 0) {
                this.commands.push(this._menuWithSeparator);
            }
            this.commands.push(this._selectContentCommand);
            [].concat(plugInArea.get()).forEach(function (cmd) {
                var otherCmd = lang.mixin({}, cmd);
                otherCmd.set("model", lang.mixin({
                    allowedTypes: this.contentSelectorDialogSettings.allowedTypes,
                    restrictedTypes: this.contentSelectorDialogSettings.restrictedTypes,
                    modelType: this.contentSelectorDialogSettings.modelType
                }, otherCmd.model || otherCmd.get("model") || {}));
                this.commands.push(otherCmd);
            }.bind(this));

            this.own(this.commands);
        },

        _onPopupOpen: function (openArgs) {
            this.inherited(arguments);
            if (this.actionsNode.contains(openArgs.around)) {
                this._openedChildDialog = openArgs.popup;
                this.isShowingChildDialog = true;
            }
        },

        _correctLabelByTypes: function () {
            // summary:
            //      Support
            //      1. Single base type: folder, block, page, image, video, media
            //      2. Multiple of 'media' like: image + video will be treated as 'media'
            //      3. Otherwise is Default = 'Select Content'
            // tags:
            //      private

            var types = TypeDescriptorManager.removeIntersectingTypes(
                this.contentSelectorDialogSettings.allowedTypes,
                this.contentSelectorDialogSettings.restrictedTypes);

            if (!types || types.length <= 0) {
                return;
            }

            var localization = contentselectorLocalization;
            var mediaTypeBase = { typeIdentifier: "episerver.core.icontentmedia", label: localization.button.selectmedia };
            var contentTypeBases = [
                { typeIdentifier: "episerver.core.contentfolder", label: localization.button.selectfolder },
                { typeIdentifier: "episerver.core.blockdata", label: localization.button.selectblock },
                { typeIdentifier: "episerver.core.pagedata", label: localization.button.selectpage },
                { typeIdentifier: "episerver.core.icontentimage", label: localization.button.selectimage },
                { typeIdentifier: "episerver.core.icontentvideo", label: localization.button.selectvideo },
                mediaTypeBase
            ];

            var found = types.map(function (t) {
                return contentTypeBases.find(function (b) {
                    return t === b.typeIdentifier || TypeDescriptorManager.isBaseTypeIdentifier(t, b.typeIdentifier);
                });
            }).filter(function (t) {
                return t;
            });

            if (!found || found.length !== 1) {
                // all is media?
                if (types.some(function (x) {
                    return x !== mediaTypeBase.typeIdentifier && !TypeDescriptorManager.isBaseTypeIdentifier(x, mediaTypeBase.typeIdentifier);
                })) {
                    return;
                }

                found = [mediaTypeBase];
            }

            var first = found[0];
            this.title = this.title || first.label;
            this.selectCommandText = this.selectCommandText || first.label;
            this.buttonLabel = this.buttonLabel || first.label;
        },

        getCommands: function () {
            // summary:
            //      Return commands for menu assembler.
            return this.commands;
        },

        postMixInProperties: function () {
            // summary:
            //      Initialize properties
            // tags:
            //      protected

            this.inherited(arguments);

            this.contentSelectorDialogSettings = Object.assign({
                roots: this.roots,
                allowedTypes: ["episerver.core.icontent", "episerver.core.icontentdata"],
                canSelectOwnerContent: false,
                getCurrentValue: function () {
                    return undefined;
                },
                isInQuickEditMode: this.isInQuickEditMode,
                quickEditBlockId: this.quickEditBlockId
            }, this.contentSelectorDialogSettings || {});
            this._correctLabelByTypes();

            this.dialogSettings = Object.assign({
                title: this.title || this.resources.dialogtitle,
                dialogClass: "epi-dialog-portrait epi-content-selector-plugnplay-dialog",
                destroyOnHide: true
            }, this.dialogSettings || {});

            this.text = this.text || this.resources.text;

            this._setupCommands();

            this.actionsNodeOptions = Object.assign({
                itemSettings: {
                    showLabel: true
                },
                settings: {
                    label: this.buttonLabel || this.resources.buttonlabel,
                    showLabel: true
                },
                actionsBuilder: this.commands.filter(function (cmd) {
                    return cmd.isAvailable;
                }).length > 1 ? DropDownButtonBuilder : ButtonBuilder,
                commandSource: this
            }, this.actionsNodeOptions || {});
            // avoid null or empty label
            this.actionsNodeOptions.settings.label = this.actionsNodeOptions.settings.label || this.resources.buttonlabel;
        },

        postCreate: function () {
            // summary:
            //      Construct commands list and build icon, text, actions button.
            // tags:
            //      protected

            this.inherited(arguments);

            this.buildIconNode(this.iconNode, this.iconClass);
            this.buildTextNode(this.textNode, this.text);
            this.buildActionsNode(this.actionsNode, this.actionsNodeOptions);

            var actionButton = this._getActionButton();
            actionButton && this.own(
                actionButton.on("click", function (evt) {
                    evt.preventDefault();
                    evt.stopPropagation();
                    return false;
                }.bind(this))
            );

            // default endpoint for command raise saved value to editor.
            [].concat(this.commands).forEach(function (cmd) {
                this.own(aspect.after(cmd, "onExecuted", function (contentLink) {
                    this.onDialogExecute(contentLink);
                }.bind(this), true));
            }.bind(this));

            // correct status
            var canExecute = !this.get("readOnly") && !this.get("disabled");
            [].concat(this.commands).forEach(function (cmd) {
                cmd && cmd.set("canExecute", canExecute);
            }.bind(this));
        },

        focus: function () {
            // summary:
            //       Put focus on this widget
            // tags:
            //      public

            var focusNode = this.focusNode || this.inputContainer;
            try {
                focusManager.focus(focusNode);
            } catch (e) {
                /*squelch errors from hidden nodes*/
            }
        },

        selectContent: function () {
            // summary:
            //      Helper method to manually show content selector dialog.
            // tags:
            //      protected

            if (!this.commands || this.commands.length > 1) {
                return;
            }

            var actionButton = this._getActionButton();
            actionButton && actionButton.onClick(new Event("click"));
        },

        buildIconNode: function (iconTargetNode, iconClass) {
            iconTargetNode.classList.add(iconClass);
        },

        buildTextNode: function (textTargetNode, text) {
            textTargetNode.innerText = text;
        },

        buildActionsNode: function (actionsTargetNode, options) {

            var builderSettings = {
                itemSettings: options.itemSettings,
                settings: options.settings
            };
            var actionsBuilder = new options.actionsBuilder(builderSettings),
                menuAssemblerConfiguration = [
                    { builder: actionsBuilder, target: actionsTargetNode },
                    { category: "menuWithSeparator", builder: actionsBuilder, target: actionsTargetNode }
                ],
                menuAssembler = new MenuAssembler({
                    configuration: menuAssemblerConfiguration,
                    commandSource: options.commandSource
                });

            menuAssembler.build();
        }
    });
});

},
'epi-cms/widget/command/DefaultContentSelectorPlugAndPlayCommand':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/on",
    "dojo/aspect",

    // diji
    "dijit/Destroyable",

    // epi.shell
    "epi/shell/command/_Command",
    "epi/shell/widget/dialog/ContextAwareDialog",

    // epi-cms
    "epi-cms/widget/ContentSelectorDialog",
    "epi-cms/component/_ShowAllLanguagesMixin",
    "epi-cms/ApplicationSettings"
], function (
    // dojo
    declare,
    on,
    aspect,

    // dijit
    Destroyable,

    // epi.shell
    _Command,
    ContextAwareDialog,

    // epi-cms
    ContentSelectorDialog,
    _ShowAllLanguagesMixin,
    ApplicationSettings
) {
    return declare([_Command, _ShowAllLanguagesMixin, Destroyable], {
        // summary:
        //    Default command class used in ContentSelectorPlugAndPlay widget.
        // tags:
        //      private xproduct

        contentSelectorDialogSettings: null,
        dialogSettings: null,

        dialog: null,
        contentSelectorDialog: null,

        onContentSelectorChange: function (/*object*/value) {
            // summary:
            //    Handle content selector inside dialog is changed value.
            // tags:
            //    public callback
        },

        onSearchResultSelected: function (/*object*/value) {
            // summary:
            //    Handle a search result is selected.
            // tags:
            //    public callback
        },

        onDialogExecute: function (/*object*/value) {
            // summary:
            //    Handle dialog execute
            // tags:
            //    public callback
        },

        onDialogShow: function () {
            // summary:
            //    Handle dialog show
            // tags:
            //    public callback
        },

        onDialogHide: function () {
            // summary:
            //    Handle dialog hide
            // tags:
            //    public callback
        },

        _execute: function () {
            this.componentId = ApplicationSettings.mainNavigationComponentId;
            this.loadShowAllLanguages().then(function (showAllLanguages) {
                this._buildDialog(showAllLanguages);
                var currentValue = this.contentSelectorDialogSettings.getCurrentValue();
                currentValue && this.contentSelectorDialog.set("value", currentValue);
                !currentValue && !this.contentSelectorDialog.setInitialValue && this.contentSelectorDialog.set("value", undefined);
                this.dialog.definitionConsumer.setItemProperty(this.dialog._okButtonName, "disabled", !currentValue);
                this.dialog.show();
                !currentValue && this.contentSelectorDialog.setInitialValue && this.contentSelectorDialog.setInitialValue();
            }.bind(this));
        },

        _buildDialog: function (showAllLanguages) {
            // summary:
            //    Create content tree dialog
            // tags:
            //    protected

            // Verifies that the dialog instance and its dom node existing or not
            if (this.dialog && this.dialog.domNode) {
                return;
            }

            var DialogClass = this.dialogSettings.dialogContentClass || ContentSelectorDialog;
            this.contentSelectorDialog = new DialogClass(Object.assign({}, this.contentSelectorDialogSettings, { showAllLanguages: showAllLanguages }));

            this.dialog = new ContextAwareDialog(Object.assign({ content: this.contentSelectorDialog }, this.dialogSettings));

            this.dialog.own(this.contentSelectorDialog);
            var callbackWithValue = function (callbackName, closeDialog) {
                var value = this.contentSelectorDialog.get("value");
                callbackName && this[callbackName].call(this, value);
                this.dialog && this.dialog.definitionConsumer && this.dialog.definitionConsumer.setItemProperty(this.dialog._okButtonName, "disabled", !value);
                closeDialog && this.dialog && this.dialog.hide();
            }.bind(this);
            this.own(
                this.dialog,
                on(this.contentSelectorDialog, "data-changed", function (value) {
                    this.dialog.definitionConsumer.setItemProperty(this.dialog._okButtonName, "disabled", !value);
                }.bind(this)),
                aspect.after(this.contentSelectorDialog, "onChange", callbackWithValue.bind(this, "onContentSelectorChange", false), true),
                aspect.after(this.contentSelectorDialog, "onSearchResultSelected", callbackWithValue.bind(this, "onSearchResultSelected", true), true),
                aspect.after(this.dialog, "onExecute", callbackWithValue.bind(this, "onDialogExecute"), true),
                aspect.after(this.dialog, "onHide", this.onDialogHide.bind(this), true),
                aspect.after(this.dialog, "onShow", this.onDialogShow.bind(this), true)
            );

            this.dialog.startup();
        }
    });
});

},
'epi-cms/plugin-area/content-selector-plugandplay':function(){
define([
    "epi/PluginArea"
], function (
    PluginArea
) {

    /*=====
    return {
        // summary:
        //      A plugin area for the content selector plug and play.
        // tags:
        //      public
    };
    =====*/
    var pluginArea = new PluginArea("epi-cms/widget/content-selector-plug-and-play/commands[]");
    return pluginArea;
});

},
'url:epi-cms/widget/templates/ContentSelectorPlugAndPlay.html':"<div class=\"dijitReset dijitInline\" tabindex=\"-1\" aria-selected=\"false\">\r\n    <div data-dojo-attach-point=\"iconNode\" class=\"dijitIcon epi-content-selector-plugnplay-iconContainer\" role=\"presentation\"></div>\r\n    <div data-dojo-attach-point=\"textNode\" class=\"dijitInline dojoxEllipsis epi-content-selector-plugnplay-textContainer dijitPlaceHolder\"></div>\r\n    <div data-dojo-attach-point=\"actionsNode, focusNode\" class=\"epi-content-selector-plugnplay-actionsContainer\"></div>\r\n</div>\r\n",
'url:epi-cms/contentediting/editors/templates/ContentAreaEditor.html':"﻿<div class=\"dijitInline\" tabindex=\"-1\" role=\"presentation\">\r\n    <div class=\"epi-content-area-header-block\">\r\n        <div data-dojo-type=\"epi-cms/contentediting/AllowedTypesList\"\r\n            data-dojo-props=\"allowedTypes: this.allowedTypes, restrictedTypes: this.restrictedTypes\"\r\n            data-dojo-attach-point=\"allowedTypesHeader\"></div>\r\n    </div>\r\n    <div class=\"epi-content-area-editor--wide epi-content-area-editor\">\r\n        <div data-dojo-attach-point=\"treeNode\"></div>\r\n        <div data-dojo-attach-point=\"actionsContainer\" class=\"epi-content-area-actionscontainer\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/editors/ContentReferenceEditor':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/on",
    "dojo/when",

    // epi.cms
    "epi-cms/widget/SelectorWrapperBase",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/_ContentSelectorActionsMixin",
    "epi-cms/widget/ContentSelector",
    "epi-cms/widget/MediaSelector",
    "epi-cms/widget/ThumbnailSelector",
    "epi-cms/contentediting/AllowedTypesList",
    "epi-cms/contentediting/command/BlockInlineEdit",

    // resources
    "dojo/text!./templates/ContentReferenceEditor.html"
], function (
    // dojo
    declare,
    on,
    when,

    // epi.cms
    SelectorWrapperBase,
    ContentReference,
    _ContentSelectorActionsMixin,
    ContentSelector,
    MediaSelector,
    ThumbnailSelector,
    AllowedTypesList,
    BlockInlineEdit,

    // resources
    template
) {

    return declare([SelectorWrapperBase], {
        // summary:
        //    Represents the widget to select ContentReference.
        // tags:
        //      internal xproduct

        templateString: template,

        baseClass: "epi-content-reference-wrapper",

        hideAllowedTypesList: false,

        postMixInProperties: function () {
            // summary:
            //    Initialize properties
            // tags:
            //    protected

            this.selectorClass = this._getContentSelectorType();
            this.inherited(arguments);
        },

        buildRendering: function () {
            // summary:
            //    Creates and append the input hidden field to the dom to preserve the contentLink id
            // tags:
            //    protected

            this.inherited(arguments);

            this.allowedTypesList = new AllowedTypesList({
                defaultAllowedTypes: this.defaultAllowedTypes,
                allowedTypes: this.allowedTypes,
                restrictedTypes: this.restrictedTypes
            });

            this.allowedTypesList.placeAt(this.allowedTypesHeader);

            this.own(
                on(this.domNode, "dblclick", function () {
                    if (this.contentSelector.model && this.contentSelector.model.capabilities && this.contentSelector.model.capabilities.isBlock) {
                        var inlineEditCommand = new BlockInlineEdit();
                        when(inlineEditCommand.updateModel(this.contentSelector.model)).then(function () {
                            inlineEditCommand.execute();
                        });
                    }
                }.bind(this))
            );

            this.allowedTypesList.startup();
            this.own(this.allowedTypesList);
        },

        postCreate: function () {
            this.inherited(arguments);

            this._updateStyle();
            this.own(this.allowedTypesList.watch("hasRestriction", this._updateStyle.bind(this)));
        },

        _onSelectorValueChange: function (contentLink) {
            if (!ContentReference.compareIgnoreVersion(this.value, contentLink)) {
                this.onFocus();
                this.value = contentLink;
                this._triggerSave();
            }
        },

        _getContentSelectorType: function () {
            if (this._isSelectorFor("episerver.core.icontentimage")) {
                return ThumbnailSelector;
            }

            if (this._isSelectorFor("episerver.core.icontentmedia")
                || this._isSelectorFor("episerver.core.icontentvideo")) {
                return declare([MediaSelector, _ContentSelectorActionsMixin], {});
            }

            return declare([ContentSelector, _ContentSelectorActionsMixin], {});
        },

        _isSelectorFor: function (typeIdentifier) {
            // summary:
            //      Determine which editor descriptor is used
            return this.defaultAllowedTypes && this.defaultAllowedTypes.indexOf(typeIdentifier) > -1;
        },

        _updateStyle: function () {
            // summary:
            //      Handle the widget style depending on the allowedTypesList visibility

            if (!this.domNode) {
                return;
            }

            this.domNode.classList.remove("allowed-types-list-hidden");
            this.allowedTypesHeader.classList.remove("dijitHidden");

            if (this.allowedTypesList.get("hasRestriction") === false) {
                this.domNode.classList.add("allowed-types-list-hidden");
            }

            if (this.hideAllowedTypesList) {
                this.allowedTypesHeaderContainer.classList.add("dijitHidden");
            }
        }
    });
});

},
'epi-cms/widget/SelectorWrapperBase':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/aspect",

    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",

    // epi.shell
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/shell/widget/_FocusableMixin",

    // epi.cms
    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/widget/_Droppable"
], function (
    // dojo
    declare,
    aspect,

    // dijit
    _TemplatedMixin,
    _WidgetBase,
    _WidgetsInTemplateMixin,

    // epi.shell
    _ValueRequiredMixin,
    _FocusableMixin,

    // epi.cms
    _HasChildDialogMixin,
    _Droppable
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ValueRequiredMixin, _FocusableMixin, _HasChildDialogMixin, _Droppable], {
        // summary:
        //    Represents the selector wrapper.
        // tags:
        //      internal xproduct

        templateString: "<div><div data-dojo-attach-point='container,dropAreaNode'></div></div>",

        selectorClass: null,

        value: null,

        postMixInProperties: function () {
            // summary:
            //    Initialize properties
            // tags:
            //    protected

            this.inherited(arguments);
            // Ignore value here then set later via set("value") method.
            this.selector = new this.selectorClass(Object.assign({}, this.params, { value: null }, this._getSelectorParams()));
            this.own(this.selector);
        },

        buildRendering: function () {
            // summary:
            //    Creates and append the selector to the container.
            // tags:
            //    protected

            this.inherited(arguments);
            this.selector.placeAt(this.container);
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(aspect.after(this.selector, "onChange", function (value) {
                this._onSelectorValueChange(value);
                this.onChange(this.get("value"));
            }.bind(this), true));
        },

        onChange: function (value) {
            // summary:
            //      An extension point invoked when the value has changed.
            // tags:
            //      public
        },

        _onSelectorValueChange: function (val) {
            // summary:
            //      Callback whenever selector's value is changed.
            //
            // tags:
            //      protected abstract

            // should implement by usage or inheritance class.
        },

        _getSelectorParams: function () {
            // summary:
            //      Retrieves the selector's params.
            //
            // tags:
            //      protected abstract

            // should implement by usage or inheritance class.
            return {};
        },

        focus: function () {
            this.selector && this.selector.focus();
        },

        _set: function (name, value) {
            this.inherited(arguments);
            if (name === "value") {
                this._setValue(value);
                return;
            }
            this.selector && this.selector.set(name, value);
        },

        _setValueAttr: function (value) {
            return this._setValue(value);
        },

        _setValue: function (value) {
            this.value = value;
            this.selector && this.selector.set("value", value);
        },

        _get: function (name, value) {
            if (name === "value") {
                return this._getValue(value);
            }
            return this.selector && this.selector.get(name, value);
        },

        _getValueAttr: function () {
            return this._getValue();
        },

        _getValue: function () {
            return this.value;
        },

        _getPermanentLinkAttr: function () {
            return this.selector && this.selector.get("permanentLink");
        },

        onDrop: function () {
            this._triggerSave();
        },

        _triggerSave: function () {
            this.onChange && this.onChange(this.value);
            this._hasBeenBlurred = true;
            this.validate(true);
            this.onBlur();
        }
    });
});

},
'epi-cms/widget/_Droppable':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi/shell/dnd/Target"
], function (declare, lang, when, Target) {
    return declare(null, {
        // summary:
        //    Mixin for widgets that are droppable.
        // tags:
        //    public

        // dropAreaNode: [protected] DomNode
        //      The dom node where user can drop
        dropAreaNode: null,

        // allowedDndTypes: [protected] Array
        //      List of data types that this widget can handle
        allowedDndTypes: null,

        postCreate: function () {
            // summary:
            //		Initialize child widgets
            // tags:
            //    protected

            this.inherited(arguments);

            //create drop target
            var dropTarget = this.own(new Target(this.dropAreaNode, {
                accept: this.allowedDndTypes,
                reject: this.restrictedDndTypes,
                createItemOnDrop: false,
                readOnly: this.readOnly,
                skipForm: true
            }))[0];

            this.connect(dropTarget, "onDropData", "_onDropData");
        },

        onDropping: function () {
            // summary:
            //    Triggered when something is dropping onto the widget.
            //
            // tags:
            //    public callback
        },

        onDrop: function () {
            // summary:
            //    Triggered when something has been dropped onto the widget.
            //
            // tags:
            //    public callback
        },

        _onDropData: function (dndData, source, nodes, copy) {
            //summary:
            //    Handle drop data event.
            //
            // dndData:
            //    Dnd data extracted from the dragging items which have the same data type to the current target
            //
            // source:
            //    The dnd source.
            //
            // nodes:
            //    The dragging nodes.
            //
            // copy:
            //    Denote that the drag is copy.
            //
            // tags:
            //    private

            var dropItem = dndData ? (dndData.length ? dndData[0] : dndData) : null;

            if (dropItem) {
                this.onDropping();

                when(dropItem.data, lang.hitch(this, function (resolvedValue) {
                    var value;
                    if (this.dndSourcePropertyName) {
                        value = resolvedValue[this.dndSourcePropertyName];
                    } else {
                        value = resolvedValue;
                    }
                    this.set("value", value);
                    this.onDrop();
                }));
            }
        }
    });
});

},
'epi-cms/widget/_ContentSelectorActionsMixin':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/on",
    "dojo/Deferred",
    "dojo/Stateful",
    "dojo/string",
    "dijit/Destroyable",

    // epi.shell
    "epi/epi",
    "epi/shell/widget/ContextMenu",
    "epi/shell/command/_CommandProviderMixin",
    "epi/shell/command/withConfirmation",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/DialogService",
    "epi/shell/widget/dialog/Confirmation",

    // epi.cms
    "epi-cms/dgrid/formatters",
    "epi-cms/ApplicationSettings",

    // commands
    "epi-cms/contentediting/command/BlockEdit",
    "epi-cms/contentediting/command/BlockInlineEdit",
    "epi-cms/contentediting/command/BlockRemove",
    "epi-cms/widget/command/DefaultContentSelectorPlugAndPlayCommand",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentselector",

    // template
    "dojo/text!./templates/_ContentSelectorActionsMixin.html"
], function (
    // dojo
    declare,
    aspect,
    on,
    Deferred,
    Stateful,
    dojoString,
    Destroyable,

    // epi.shell
    epi,
    ContextMenu,
    _CommandProviderMixin,
    withConfirmation,
    TypeDescriptorManager,
    DialogService,
    Confirmation,

    // epi.cms
    formatters,
    ApplicationSettings,

    // commands
    EditCommand,
    BlockInlineEdit,
    RemoveCommand,
    DefaultContentSelectorPlugAndPlayCommand,

    // resources
    localization,

    // template
    template
) {

    return declare([_CommandProviderMixin], {
        // summary:
        //    Represents the widget to select ContentReference with actions.
        // tags:
        //      internal product

        baseClass: "epi-content-selector-with-actions",

        templateString: template,

        resources: localization,

        modelClass: declare([Stateful, Destroyable]),
        model: null,

        iconClass: null,

        postMixInProperties: function () {
            // summary:
            //		Initialize properties
            // tags:
            //    protected

            this.inherited(arguments);

            // setup model and context menu
            var that = this;
            this.own(this.model = this.model || new this.modelClass({
                readOnly: that.readOnly,
                remove: function () {
                    that.clearValue({ preventDefault: function () { } });
                }
            }));
        },

        buildRendering: function () {
            // summary:
            //		Update text and setup context menu.
            // tags:
            //    protected

            this.inherited(arguments);
            this.own(
                on(this.displayNode, "click", function (evt) {
                    evt.preventDefault();
                    evt.stopPropagation();

                    this.focus();
                }.bind(this))
            );

            this._setupContextMenu();
        },

        _getChangeSelectionCommand: function () {
            var dialogSettings = Object.assign({
                title: this.title,
                dialogClass: "epi-dialog-portrait epi-content-selector-plugnplay-dialog",
                destroyOnHide: true
            }, this.dialogSettings || {});

            var contentSelectorDialogSettings = Object.assign({
                roots: [ApplicationSettings.rootPage],
                allowedTypes: ["episerver.core.icontent", "episerver.core.icontentdata"],
                canSelectOwnerContent: false,
                getCurrentValue: function () {
                    return undefined;
                },
                isInQuickEditMode: this.isInQuickEditMode,
                quickEditBlockId: this.quickEditBlockId
            }, this.contentSelectorDialogSettings || {});

            var changeSelection = new DefaultContentSelectorPlugAndPlayCommand({
                label: epi.resources.action.replace,
                canExecute: !this.readOnly,
                dialogSettings: dialogSettings,
                contentSelectorDialogSettings: contentSelectorDialogSettings
            });

            this.own(
                aspect.after(changeSelection, "onContentSelectorChange", this._onContentSelectorChange.bind(this), true),
                aspect.after(changeSelection, "onSearchResultSelected", this._onSearchResultSelected.bind(this), true),
                aspect.after(changeSelection, "onDialogExecute", this._onDialogExecute.bind(this), true),
                aspect.after(changeSelection, "onDialogHide", this._onDialogHide.bind(this), true),
                aspect.after(changeSelection, "onDialogShow", this._onDialogShow.bind(this), true)
            );

            return changeSelection;
        },

        _setupContextMenu: function () {
            // summary: set up the context menu
            //
            // tags:
            //      public

            var that = this;
            var editCommand = new EditCommand({ category: null });

            this.commands = [
                withConfirmation(editCommand, function (settings) {
                    var dialogStack = DialogService.getEnclosingDialog(that), dialog = dialogStack && dialogStack.dialog;
                    if (!dialog) {
                        return;
                    }

                    if (!DialogService.hasPendingChanges(dialogStack, epi.compareOptions.skipEmptyProperties)) {
                        dialog.onCancel();
                        return;
                    }

                    var deferred = new Deferred();

                    var confirmationDialog = new Confirmation({
                        title: that.resources.command.blockedit.title,
                        description: dojoString.substitute(that.resources.command.blockedit.description, [dialog.titleNode.textContent.trim()]),
                        confirmActionText: that.resources.command.blockedit.action.yes,
                        cancelActionText: that.resources.command.blockedit.action.no
                    });

                    that.own(
                        confirmationDialog,
                        // TODO: Temporary solution until we apply new dialog layout (CMS-20406).
                        aspect.around(confirmationDialog, "getActions", function (originalMethod) {
                            return function () {
                                var actions = originalMethod.apply(this, arguments);
                                actions[0].settings = { "class": "epi-plain-button" }; // yes
                                actions[1].settings = { "class": "Salt" }; // no
                                return actions;
                            }.bind(confirmationDialog);
                        }.bind(confirmationDialog)),

                        aspect.after(confirmationDialog, "onAction", function (confirm) {
                            if (confirm) {
                                // force dialog stacks close
                                DialogService.hideStack();
                                deferred.resolve();
                            } else {
                                dialog.resize(); // restore parent dialog underlay: BlockInlineEdit has custom underlay position.
                                deferred.cancel();
                            }
                        }.bind(confirmationDialog), true)
                    );

                    confirmationDialog.startup();
                    confirmationDialog.show();
                    confirmationDialog.resize(); // force underlay cover all owner document.

                    return deferred.promise;
                }.bind(editCommand)),
                new BlockInlineEdit(),
                this._getChangeSelectionCommand(),
                new RemoveCommand()
            ];

            this.commands.forEach(function (command) {
                this.own(command);
            }, this);

            this.own(
                this.commands,
                this.contextMenu = new ContextMenu({
                    onClose: function () {
                        that.displayNode.classList.remove("dijitFocused", "epi-content-selector-with-actionsActive");
                    }
                }),
                on(this.iconNodeMenu, "click", function (evt) {
                    evt.preventDefault();
                    evt.stopPropagation();

                    this.displayNode.classList.add("dijitFocused", "epi-content-selector-with-actionsActive");
                    this.contextMenu && this.contextMenu.scheduleOpen(evt.target, null, { x: evt.pageX, y: evt.pageY });
                }.bind(this))
            );

            this.contextMenu.addProvider(this);
        },

        _updateDisplayNode: function (content) {
            // summary:
            //      Overridden to initialize ui when value is set.

            this.inherited(arguments);

            // Reset text + icon to empty state.
            this.iconNode.className = this.iconNode.className.replace(this.iconClass, "");
            this.resourceName.title = this.resources.helptext;

            if (content) {
                this.iconClass = formatters.contentIconClass(content.typeIdentifier);
                this.iconNode.className += (" " + this.iconClass);

                this.resourceName.title = formatters.title(this.resourceName.textContent.trim(), content.contentLink, TypeDescriptorManager.getResourceValue(content.typeIdentifier, "name"));

                for (var propertyName in content) {
                    this.model.set(propertyName, content[propertyName]);
                }
            }

            this.updateCommandModel(content ? this.model : null);
        }
    });
});

},
'url:epi-cms/widget/templates/_ContentSelectorActionsMixin.html':"<div data-dojo-attach-point=\"inputContainer\" class=\"dijitReset dijitInputField dijitInline epi-resourceInputContainer\" id=\"widget_${id}\">\r\n    <div data-dojo-attach-point=\"displayNode, dropAreaNode, stateNode\" class=\"dijit dijitReset dijitInline dijitInlineTable dijitLeft dijitTextBox displayNode\">\r\n        <div class=\"dijitReset dijitLeft dijitInputField dijitInputContainer dijitTree dijitTreeContainer epi-tree-mngr\">\r\n            <div class=\"dijitTreeNode\" role=\"presentation\">\r\n                <div class=\"epi-tree-mngr--node-wrapper\" data-dojo-attach-point=\"rowNode\">\r\n                    <span data-dojo-attach-point=\"rolesNode, _buttonNode\" class=\"epi-tree-mngr--view-settings\"></span>\r\n                    <div class=\"dijitTreeRow dijitInline\" role=\"presentation\">\r\n                        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n                            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n                            <span data-dojo-attach-point=\"selectedContentNameNode, resourceName, focusNode\"\r\n                                class=\"dijitTreeLabel dijitInline dojoxEllipsis\" role=\"treeitem\" tabindex=\"-1\"\r\n                                aria-selected=\"false\">&nbsp;</span>\r\n                            <span data-dojo-attach-point=\"selectedContentLinkNode\"></span>\r\n                            <div data-dojo-attach-point=\"contentSelectorContainer\" class=\"contentSelectorContainer\"></div>\r\n                            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                                <span data-dojo-attach-point=\"iconNodeMenu\" title=\"${resources.menutooltip}\"\r\n                                    class=\"epi-extraIcon epi-pt-contextMenu epi-iconContextMenu\"\r\n                                    role=\"presentation\">&nbsp;</span>\r\n                            </span>\r\n                            <div data-dojo-attach-point=\"clearButton\"></div>\r\n                        </span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/widget/ContentSelector':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/dom-construct",
    "dojo/string",
    "dojo/when",

    // epi.shell
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",

    // epi.cms
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/_SelectorBase",

    // resources

    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentselector"
], function (
    // dojo
    declare,
    domConstruct,
    stringUtil,
    when,

    // epi.shell
    dependency,
    TypeDescriptorManager,

    // epi.cms
    ContentReference,
    ContentActionSupport,
    _SelectorBase,

    // resources
    localization
) {

    return declare([_SelectorBase], {
        // summary:
        //    Represents the widget to select content reference.
        // tags:
        //      internal xproduct

        roots: null,

        value: null,

        // destroyOnHide: [protected] Boolean
        //      Flag which indicates whether the content selector dialog will be destroyed after being hidden.
        destroyOnHide: true,

        // required: Boolean
        //		User is required to enter data into this field.
        required: false,

        // missingMessage: [public] String
        //    Message which is displayed when required is true and value is empty.
        missingMessage: localization.requiredmessage,

        // tooltipPosition: String[]
        //		See description of `dijit/Tooltip.defaultPosition` for details on this parameter.
        tooltipPosition: [],

        // contentLink: [public] String
        //      Content reference of the content being edited.
        contentLink: null,

        // canSelectOwnerContent: [public] Boolean
        //      Indicates whether the owner content that is being edited can be selected
        canSelectOwnerContent: false,

        // accessLevel: [public] Enum
        //      The access right level for the content node can be selected
        accessLevel: ContentActionSupport.accessLevel.Read,

        // showAllLanguages: Boolean
        //      Flags to indicate that the content tree should show all content in multiple languages or not.
        showAllLanguages: true,

        // showSearchBox: Boolean
        //      If true - a search field is displayed that allows user to find content
        showSearchBox: true,

        // searchArea: String
        //      Search area for the search box.
        searchArea: null,

        // contentClass: [public] String
        //      The content class to be set on the epi-cms/widget/ContentSelectorDialog.
        contentClass: null,

        // dialogClass: [public] String
        //      The dialog class to be set on the epi-cms/widget/ContentSelectorDialog.
        dialogClass: "epi-dialog-portrait",

        // manualFocusManagement: [protected] Boolean
        //      Skip focus management by the editor wrapper and control editing manually - through dialog actions or d&d
        manualFocusManagement: true,

        buildRendering: function () {
            // summary:
            //		Creates and append the input hidden field to the dom to preserve the contentLink id
            // tags:
            //    protected

            var inputName = this.name ? (this.name.replace(/"/g, "&quot;")) : "";
            this.input = domConstruct.create("input", { type: "hidden", name: inputName });

            this.inherited(arguments);
            this.domNode.appendChild(this.input);
        },

        postMixInProperties: function () {
            // summary:
            //		Initialize properties
            // tags:
            //    protected

            var registry = dependency.resolve("epi.storeregistry");
            this._store = registry.get("epi.cms.content.light");

            var contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
            var settings = contentRepositoryDescriptors.get(this.repositoryKey);

            if (settings && !this.roots) {
                this.roots = settings.roots;
            }

            if (settings && !this.searchArea) {
                this.searchArea = settings.searchArea;
            }

            this.inherited(arguments);
        },

        _setupContentSelectorDialogSettings: function () {
            this.inherited(arguments);

            this.title = localization.title;
            if (this.allowedTypes && this.allowedTypes.length === 1) {
                var name = TypeDescriptorManager.getResourceValue(this.allowedTypes[0], "name");
                if (name) {
                    this.title = stringUtil.substitute(localization.format, [name]);
                }
            }

            this.contentSelectorDialogSettings.title = this.title;
        },

        postCreate: function () {
            // summary:
            //      Overridden to initialize ui elements when no value is set.

            this.inherited(arguments);

            if (!this.value) {
                this._updateDisplayNode(null);
            }
        },

        _setValueAttr: function (value) {
            //summary:
            //    Value's setter.
            //
            // value: String
            //    Value to be set.
            //
            // tags:
            //    protected

            this._setValueAndFireOnChange(value);
        },

        _onDialogExecute: function (value) {
            //summary:
            //    Handle dialog close
            // tags:
            //    private

            this._setValueAndFireOnChange(value);
        },

        _onSearchResultSelected: function (value) {
            this._setValueAndFireOnChange(value);
        },

        _convertValueToContentReference: function (value) {
            //summary:
            //
            // tags:
            //    protected
            return value ? new ContentReference(value) : null;
        },

        _setValueAndFireOnChange: function (value) {
            //summary:
            //    Gets the content data by selected value, updates the view and calls onChange if value was changed
            // tags:
            //    private

            var contentLink = value === "-" ? this.contentLink : value;

            this.set("permanentLink", null);

            this._valueChangedPromise = when(this._getContentData(contentLink)).then(function (content) {

                if (this._destroyed) {
                    return;
                }

                // Clear the pointer to the promise since it is resolved.
                this._valueChangedPromise = null;

                var hasChange = this.value !== contentLink;

                this._set("value", contentLink);
                this.input.value = this.value;
                this._started && this.validate();
                this._updateDisplayNode(content);

                if (hasChange) {
                    if (this.initialized) {
                        this.onStartEdit();
                    }
                    this.onChange(contentLink);
                    if (this.initialized) {
                        this.onStopEdit();
                    }
                }

                if (content) {
                    this.set("permanentLink", content.permanentLink);
                }

                this.initialized = true;
            }.bind(this));
        },

        _getContentData: function (contentLink) {
            //summary:
            //    Loads the content data from the store
            // tags:
            //    private

            if (!contentLink) {
                return null;
            }
            return this._store.get(contentLink);
        },

        _onFocus: function () {
            // summary:
            //		This is where widgets do processing for when they start being active,
            //		such as changing CSS classes.  See onFocus() for more details.
            // tags:
            //		protected

            if (this.get("disabled")) {
                return;
            }
            this.inherited(arguments);
            this.validate();
        },

        _onBlur: function () {
            // summary:
            //		This is where widgets do processing for when they stop being active,
            //		such as changing CSS classes.  See onBlur() for more details.
            // tags:
            //		protected

            if (this.get("disabled")) {
                return;
            }
            this.inherited(arguments);
            this.validate();
        },

        _updateDisplayNode: function (content) {
            //summary:
            //    Update widget's display text
            // tags:
            //    protected

            this.inherited(arguments);

            // content selector also sets Link id
            if (content) {
                this.set("selectedContentLink", new ContentReference(content.contentLink).id);
            } else {
                this.set("selectedContentName", localization.helptext);
                this.set("selectedContentLink", "");
            }
        },

        reset: function () {
            this.set("value", null);
        },

        clearValue: function (e) {
            // summary:
            //    Do clear value from _HasClearButton
            // tags:
            //    protected override

            this.onStartEdit();
            this.inherited(arguments);
            this.onStopEdit();
        },

        onStartEdit: function () {
            // summary:
            //      Set this handler to be notified when editing is started.
            // tags:
            //      callback
        },

        onStopEdit: function () {
            // summary:
            //      callback method called when editor is no longer active
            //  tags:
            //      public
        }
    });
});

},
'epi-cms/widget/_SelectorBase':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/aspect",

    // dijit,
    "dijit/_CssStateMixin",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/focus",

    // epi.shell
    "epi/dependency",
    "epi/shell/widget/_ValueRequiredMixin",

    // epi.cms
    "epi-cms/widget/_Droppable",
    "epi-cms/widget/_HasClearButton",
    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/widget/ContentSelectorPlugAndPlay",

    // resources
    "dojo/text!./templates/_SelectorBase.html"
], function (
    // dojo
    declare,
    aspect,

    // dijit
    _CssStateMixin,
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,
    focusManager,

    // epi.shell
    dependency,
    _ValueRequiredMixin,

    // epi.cms
    _Droppable,
    _HasClearButton,
    _HasChildDialogMixin,
    ContentSelectorPlugAndPlay,

    // resources
    template
) {
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin, _HasChildDialogMixin, _HasClearButton, _Droppable, _ValueRequiredMixin], {
        // summary:
        //    Represents base class for item selector widget (a textbox and a browse button).
        // tags:
        //    public

        templateString: template,

        roots: null,

        value: null,

        // required: Boolean
        //		User is required to enter data into this field.
        required: false,

        // missingMessage: [public] String
        //    Message which is displayed when required is true and value is empty.
        missingMessage: "",

        // tooltipPosition: String[]
        //		See description of `dijit/Tooltip.defaultPosition` for details on this parameter.
        tooltipPosition: [],

        // canSelectOwnerContent: [public] Boolean
        //      Indicates whether the owner content that is being edited can be selected
        canSelectOwnerContent: false,

        contentRepositoryDescriptors: null,

        allowedDndTypes: [],

        // _hasBeenBlurred: [protected] Boolean
        //      Force show tooltip when clear a required value.
        _hasBeenBlurred: true,

        // _valueChangedPromise: [protected] Promise
        //      Promise which is set while the value in being changed within an asynchronous call.
        _valueChangedPromise: null,

        // contentSelectorPnP: [protected] Object
        //      Instance of ContentSelectorPlugAndPlay.
        contentSelectorPnP: null,

        _setSelectedContentNameAttr: function (value) {
            // summary:
            //		Sets the display name for selected content
            // tags:
            //    protected

            // set the text
            this.selectedContentNameNode.textContent = value;

            // set the title
            this._updateDisplayNodeTitle();
        },

        _setSelectedContentLinkAttr: function (value) {
            this.selectedContentLinkNode.innerHtml = value;
            this._updateDisplayNodeTitle();
        },

        _updateDisplayNodeTitle: function () {
            // summary:
            //		updates the tooltip with the current text of displayNode
            // tags:
            //    protected

            this.resourceName.title = this.resourceName.textContent.trim();
        },

        postCreate: function () {
            // summary:
            //      Post create initialization.
            // description:
            //      Setup related components.
            // tags:
            //      protected

            this.inherited(arguments);

            // After dnd into widget
            this.own(aspect.after(this, "onDrop", this.focus.bind(this)));

            this._setupContentSelector();
        },

        postMixInProperties: function () {
            // summary:
            //		Initialize properties
            // tags:
            //    protected

            this.inherited(arguments);

            if (!this.contentRepositoryDescriptors) {
                this.contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            }

            if (!this.roots && this.repositoryKey) {
                var settings = this.contentRepositoryDescriptors.get(this.repositoryKey);
                this.roots = settings.roots;
            }

            this._setupDialogSettings();
            this._setupContentSelectorDialogSettings();
        },

        _selectContent: function (event) {
            if (this.readOnly) {
                event.preventDefault();
                event.stopPropagation();
                return;
            }

            this._onDialogShow();
            this.contentSelectorPnP && this.contentSelectorPnP.selectContent();
        },

        _setupDialogSettings: function () {
            // summary:
            //      Setup settings for dialog.
            // tags:
            //      protected virtual

            this.dialogSettings = {};
        },

        _setupContentSelectorDialogSettings: function () {
            this.contentSelectorDialogSettings = this.contentSelectorDialogSettings || {
                canSelectOwnerContent: this.canSelectOwnerContent,
                showButtons: false,
                roots: this.roots,
                allowedTypes: this.allowedTypes,
                restrictedTypes: this.restrictedTypes,
                showAllLanguages: this.showAllLanguages,
                showSearchBox: this.showSearchBox,
                searchArea: this.searchArea,
                propertyName: this.name,
                getCurrentValue: function () {
                    return this.value;
                }.bind(this)
            };
        },

        destroy: function (/*Boolean*/ preserveDom) {
            // summary:
            //      Destroy this class, cancelling any promises that are in progress.
            // tags:
            //      public
            this.inherited(arguments);

            // If there is a value change promise in progress then cancel it.
            if (this._valueChangedPromise) {
                this._valueChangedPromise.cancel();
                this._valueChangedPromise = null;
            }
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            this.contentSelectorPnP && this.contentSelectorPnP.set("readOnly", value);
            this.clearButton.style.display = value ? "none" : "";
            this.domNode.classList.toggle("dijitReadOnly", value);
        },

        _setIsListItemAttr: function (value) {
            if (value) {
                if (this.clearButton) {
                    this.clearButton.style.display = "none";
                }
            }
        },

        _setDisabledAttr: function (value) {
            this._set("disabled", value);
            this.contentSelectorPnP && this.contentSelectorPnP.set("disabled", value);
        },

        _setupContentSelector: function () {
            //summary:
            //    Try create instance of ContentSelectorPlugAndPlay and setup events.
            // tags:
            //    protected

            if (this.contentSelectorPnP && this.contentSelectorPnP.domNode) {
                // already setup
                return;
            }

            this.contentSelectorPnP = new ContentSelectorPlugAndPlay({
                actionsNodeOptions: this.actionsNodeOptions || {},
                dialogSettings: this.dialogSettings,
                contentSelectorDialogSettings: this.contentSelectorDialogSettings,
                readOnly: this.readOnly,
                isVisible: !this.get("value"), // only show for initial state.
                isInQuickEditMode: this.isInQuickEditMode,
                quickEditBlockId: this.quickEditBlockId
            });
            this.contentSelectorPnP.placeAt(this.contentSelectorContainer || this.domNode);
            this.contentSelectorPnP.startup();

            this.own(
                this.contentSelectorPnP,
                aspect.after(this.contentSelectorPnP, "onContentSelectorChange", this._onContentSelectorChange.bind(this), true),
                aspect.after(this.contentSelectorPnP, "onSearchResultSelected", this._onSearchResultSelected.bind(this), true),
                aspect.after(this.contentSelectorPnP, "onDialogExecute", this._onDialogExecute.bind(this), true),
                aspect.after(this.contentSelectorPnP, "onDialogHide", this._onDialogHide.bind(this), true),
                aspect.after(this.contentSelectorPnP, "onDialogShow", this._onDialogShow.bind(this), true)
            );
        },

        _onDialogShow: function () {
            //summary:
            //    Handle onShow dialog event.
            // tags:
            //    protected

            this.isShowingChildDialog = true;
        },

        _onDialogExecute: function (/*object*/value) {
            //summary:
            //    Handle dialog close. Need override
            // value: string (content id) or object (link object)
            // tags:
            //    protected
        },

        _onContentSelectorChange: function (/*object*/value) {
            //summary:
            //    Handle dialog content selector is changed.
            // tags:
            //    protected
        },

        _onSearchResultSelected: function (/*object*/value) {
            //summary:
            //    Handle dialog content selector's search result is selected.
            // tags:
            //    protected
        },

        _onDialogHide: function () {
            //summary:
            //    Handle dialog hide. Need override
            // tags:
            //    protected

            this.isShowingChildDialog = false;

            // Return focus to the editor when the dialog closes.
            this.focus();
        },

        focus: function () {
            // summary:
            //       Put focus on this widget
            // tags:
            //      public

            if (this.contentSelectorPnP && this.contentSelectorPnP.isShowingChildDialog) {
                return;
            }

            var focusNode = this.focusNode || this.domNode;
            try {
                focusManager.focus(focusNode);
            } catch (e) {
                /*squelch errors from hidden nodes*/
            }
        },

        _onBlur: function () {
            // summary:
            //		This is where widgets do processing for when they stop being active,
            //		such as changing CSS classes.  See onBlur() for more details.
            // tags:
            //		protected

            this.inherited(arguments);

            this.validate();
        },

        onChange: function (value) {
            // summary:
            //    Fired when value is changed.
            //
            // value:
            //    The value
            // tags:
            //    public, callback
        },

        _updateDisplayNode: function (content) {
            //summary:
            //    Update widget's display text and title.
            // tags:
            //    protected

            this.domNode.classList.add("epi-noValue");
            this.resourceName.classList.add("dijitPlaceHolder");
            if (content) {
                this.domNode.classList.remove("epi-noValue");
                this.resourceName.classList.remove("dijitPlaceHolder");
            }
            this.set("selectedContentName", content ? content.name : "");
            this.contentSelectorPnP && this.contentSelectorPnP.set("isVisible", !content);
        }
    });
});

},
'epi-cms/widget/_HasClearButton':function(){
﻿define([
    "epi",
    "dojo",
    "dijit"
], function (epi, dojo, dijit) {
    return dojo.declare(null, {
        // summary:
        //    Mixin for widgets that need child dialog ability.
        // tags:
        //    internal

        postCreate: function () {
            // summary:
            //		Initialize child widgets
            // tags:
            //    protected

            this.inherited(arguments);

            var eventName = this.clearButton.onClick ? "onClick" : "onclick";

            dojo.connect(this.clearButton, eventName, dojo.hitch(this, this.clearValue));
        },

        clearValue: function (e) {
            // summary:
            //    Do clear value
            // tags:
            //    protected

            e.preventDefault();

            if (this.readOnly) {
                return;
            }
            this.focus();
            var value = this.getEmptyValue();
            this.set("value", value);

            // force show tooltip when clear value
            if (typeof this.validate === "function") {
                this.validate(true);
            }
        },

        getEmptyValue: function () {
            // summary:
            //		Gets widget's empty value.
            // description:
            //      Returns null by default. Override this method to change widget's empty value.
            // tags:
            //    protected

            return null;
        }
    });
});

},
'url:epi-cms/widget/templates/_SelectorBase.html':"﻿<div data-dojo-attach-point=\"inputContainer\" class=\"dijitReset dijitInputField dijitInline epi-resourceInputContainer\" id=\"widget_${id}\">\r\n    <div data-dojo-attach-point=\"displayNode, dropAreaNode, stateNode\" class=\"dijit dijitReset dijitInline dijitInlineTable dijitLeft dijitTextBox displayNode\">\r\n        <div class=\"dijitReset dijitLeft dijitInputField dijitInputContainer\">\r\n            <div data-dojo-attach-point=\"clearButton\" class=\"epi-clearButton\">&nbsp;</div>\r\n            <div data-dojo-attach-point=\"contentSelectorContainer\" class=\"contentSelectorContainer\"></div>\r\n            <div data-dojo-attach-point=\"resourceName\" class=\"dijitInline epi-resourceName dojoxEllipsis\" >\r\n                <span data-dojo-attach-point=\"selectedContentNameNode\"></span> <span data-dojo-attach-point=\"selectedContentLinkNode\"></span>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/widget/MediaSelector':function(){
define([
    "dojo/_base/declare",
    "epi-cms/widget/ContentSelector",
    "epi-cms/widget/SelectableMediaComponent"
], function (
    declare,
    ContentSelector,
    SelectableMediaComponent
) {

    return declare([ContentSelector], {
        // summary:
        //      Represents a widget to select Media files.
        // tags:
        //      internal

        // contentClass: [public] String
        //      The content class to be set on the epi-cms/widget/ContentSelectorDialog.
        contentClass: "epi-wrapped epi-mediaSelector",

        // dialogClass: [public] String
        //      The dialog class to be set on the epi-cms/widget/ContentSelectorDialog.
        dialogClass: null,

        // destroyOnHide: [protected] Boolean
        //      Flag which indicates whether the content selector dialog will be destroyed after being hidden.
        //      We can keep the MediaSelector instance alive since it is heavy, it supports paging and only loads
        //      a subset of child content items compared to ContentSelector which loads all children.
        //      The instance will still eventually be destroyed together with the form (for example after changing context
        destroyOnHide: false,

        _setupDialogSettings: function () {
            this.inherited(arguments);
            this.dialogSettings = Object.assign(this.dialogSettings, {
                dialogContentClass: SelectableMediaComponent,
                dialogClass: this.dialogSettings,
                destroyOnHide: this.destroyOnHide
            });
        },

        _setupContentSelectorDialogSettings: function () {
            this.inherited(arguments);
            this.contentSelectorDialogSettings = Object.assign(this.contentSelectorDialogSettings, {
                contentClass: this.contentClass,
                repositoryKey: this.repositoryKey
            });
        }
    });
});

},
'epi-cms/widget/SelectableMediaComponent':function(){
define([
    "dojo/_base/declare",
    "dojo/dom-style",
    "dojo/Evented",
    "dojo/topic",
    "dojo/when",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/_ContentContextMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/ApplicationSettings",
    "epi-cms/component/Media"
], function (
    declare,
    domStyle,
    Evented,
    topic,
    when,
    TypeDescriptorManager,
    _ContentContextMixin,
    ContentReference,
    ApplicationSettings,
    Media
) {
    return declare([Media, _ContentContextMixin, Evented], {
        // summary:
        //      Represents a wrapper of the Media component that allows to set/get selected value.
        // tags:
        //      internal xproduct

        // componentId: [readonly] String
        //      The id of this component.
        componentId: "SelectableMediaComponent",

        // root: [readonly] ContentReference|String
        //      Id of the root content, used by epi-cms/widget/ContentTreeStoreModel.
        root: ApplicationSettings.rootPage,

        // additionalTreeClass: [public] String
        //      Additional CSS class that will be applied to the tree element.
        additionalTreeClass: "",

        postMixInProperties: function () {
            this.inherited(arguments);
            this.model.containedTypes = this.allowedTypes;
            this.model.changeContextOnItemSelection = false;
            this.model.treeStoreModel.forThisFolderEnabled = this._currentContext.currentMode !== "create";
            this.own(topic.subscribe("/epi/cms/upload", this._focusGrid.bind(this)));
        },

        postCreate: function () {
            this.inherited(arguments);

            this.list.set("selectionMode", "single");
            this.searchResultList.set("selectionMode", "single");

            this.resize({ h: 370, w: 680, l: 0, t: 0 });
            this.tree.set({ region: "left", splitter: true });
            domStyle.set(this.tree.domNode, "width", "250px");
            this.listContainer.set({ region: "center", splitter: false });

            this.own(this.model.selection.watch("data", this._dataChanged.bind(this)));
        },

        setInitialValue: function () {
            when(this.getCurrentContent()).then(function (content) {
                var assetsFolderLink;
                if (this._currentContext.currentMode === "create") {
                    assetsFolderLink = ApplicationSettings.globalAssetsFolder;
                } else {
                    assetsFolderLink = new ContentReference(content.assetsFolderLink).createVersionUnspecificReference().toString();
                }
                this.set("value", assetsFolderLink);
            }.bind(this));
        },

        _getValueAttr: function () {
            var currentData = this.model.selection.data[0];
            if (currentData) {
                return currentData.data.contentLink;
            }

            return null;
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            if (value) {
                this.model.selectItemsByContentReference(value, true);
                this._focusGrid();
            } else {
                this.model.set("treePaths", null);
            }
        },

        _focusGrid: function () {
            // summary:
            //      Set focus on grid element
            // tags:
            //      private

            this._focusManager.focus(this.list.grid.domNode);
        },

        _dataChanged: function (name, oldValue, newValue) {
            // summary:
            //      Propagate the new value to the dialog to make sure it is not possible to select a folder
            // tags:
            //      private

            if (!newValue || newValue.length !== 1 || !newValue[0].data || !this.allowedTypes.some(function (allowedType) {
                return TypeDescriptorManager.isBaseTypeIdentifier(newValue[0].data.typeIdentifier, allowedType);
            })) {
                this.emit("data-changed", null);
                return;
            }

            var contentLink = newValue[0].data.contentLink;
            this.emit("data-changed", contentLink);
        },

        contextChanged: function () {
            // summary:
            //    Hide the dialog on every context change
            // tags:
            //    protected

            this.emit("close-diaog");
        }
    });
});

},
'epi-cms/widget/ThumbnailSelector':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/when",
    "dojo/on",
    "dojo/topic",
    "dojo/dom-class",
    "dojo/dom-construct",
    // dijit
    "dijit/focus",
    "dijit/ProgressBar",
    // epi
    "epi/Url",
    "epi/routes",
    "epi/shell/dnd/Target",
    "epi/shell/DialogService",
    "epi/shell/postMessage",
    // epi-cms
    "epi-cms/core/ContentReference",
    "epi-cms/widget/MediaSelector",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/command/UploadContent",
    "epi-cms/widget/UploadUtil",
    "epi-cms/widget/viewmodel/MultipleFileUploadViewModel",
    "epi-cms/widget/LocalFolderUploader",
    "dojo/text!./templates/ThumbnailSelector.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.thumbnailselector",
    "epi-cms/widget/FilesUploadDropZone",
    "require"
], function (
    // dojo
    declare,
    when,
    on,
    topic,
    domClass,
    domConstruct,
    // dijit
    focusManager,
    ProgressBar, // used in template
    // epi
    Url,
    routes,
    Target,
    dialogService,
    postMessage,
    ContentReference,
    MediaSelector,
    _ContextualContentContextMixin,
    UploadContent,
    UploadUtil,
    MultipleFileUploadViewModel,
    LocalFolderUploader,
    template,
    resources,
    FilesUploadDropZone, // used in template
    moduleRequire
) {

    var defaultImageUrl = require.toUrl("epi-cms/themes/sleek/images/default-image.png");
    var _dropFileMixin = declare(_ContextualContentContextMixin, {
        // summary:
        //      This mixin is responsible for the local file upload
        // tags:
        //      internal

        // _dialogService: [private] epi/shell/DialogService
        //      The dialog service. Defaults to epi/shell/DialogService.
        _dialogService: null,

        // allowedExtensions: [public] Array
        //      List of file extensions that may be dropped onto the editor
        allowedExtensions: [],

        brokenThumbnailTooltipWidget: null,
        isBrokenThumbnailImage: false,

        postCreate: function () {
            this.inherited(arguments);

            this._dialogService = this._dialogService || dialogService;

            if (this._currentContext.currentMode === "create") {
                return;
            }

            this.uploadCommand = new UploadContent({
                viewModel: this
            });

            when(this.getCurrentContent()).then(function (contentItem) {
                if (this._destroyed) {
                    return;
                }
                this._dropZone.set("settings", {
                    enabled: true,
                    validSelection: true,
                    dropFolderName: this.getContextualRootName(contentItem),
                    descriptionTemplate: resources.dropfile
                });
            }.bind(this));
        },

        _onButtonClick: function () {
            if (this.progressBar.progress && this.progressBar.progress !== this.progressBar.maximum) {
                return;
            }

            this.inherited(arguments);
        },

        upload: function (fileList) {
            var uploader = new LocalFolderUploader({
                model: new MultipleFileUploadViewModel({
                    store: this._store,
                    query: this.query
                }),
                // we decide to not show the thumbnail & progressbar if the first chunk is bigger than 40% of the whole image
                uploadProgressThreshold: 40,
                // show thumbnails on for images smaller than 50 megabytes to avoid hanging the browser by the File API
                thumbnailMaxFileSize: 50 * 1024 * 1024
            });

            uploader.own(on(uploader, "uploadProgress", function (progress) {
                if (this._destroyed) {
                    return;
                }

                this.progressBar.update({ progress: progress });
            }.bind(this)));

            uploader.own(on(uploader, "uploadFilePreview", function (fileBytes, fileName) {
                if (this._destroyed) {
                    return;
                }

                domClass.add(this.domNode, "uploading");
                this.set("selectedContentName", resources.uploading + fileName);
                this.thumbnail.src = fileBytes;
            }.bind(this)));

            uploader.own(uploader.on("uploadComplete", function (uploadFiles, isError) {
                if (this._destroyed) {
                    return;
                }

                this.progressBar.update({ progress: 0 });
                focusManager.focus(this.button.domNode); // we need to focus the control so we can trigger the 'onChange' immediately
                domClass.remove(this.domNode, "uploading");

                // handle upload errors, first a general error that causes null to come back from server
                if (!uploadFiles) {
                    this.set("value", this.value);
                    this._dialogService.alert(resources.failed);
                    return;
                }

                // server call was successful however all files were skipped by the user
                if (uploadFiles.length === 0) {
                    return;
                }

                // handle a custom upload error, for example file size exceeded and similar
                if (uploadFiles[0].statusMessage) {
                    if (isError) {
                        this.value = this.lastContentLinkPreviwed;
                    }
                    this.set("value", this.value);
                    this._dialogService.alert(uploadFiles[0].statusMessage);
                    return;
                }

                this.set("value", uploadFiles[0].contentLink);
                this.onChange(this.value);
                // publish this topic so that the uploaded image is shown in the Assets Pane immediately
                topic.publish("/epi/cms/upload", this.assetsFolderLink);
            }.bind(this)));

            uploader.upload(fileList);
        },

        _refreshTargetUploadContent: function () {
            // We need to handle scenarios when user drops images on a page that does not have assets folder yet.
            // We could try to reuse the logic from ContextualContentForestStoreModel.js & _ContextualContentContextMixin.js
            // The same issue happens in TinyMCE after d&d an image file to a new page that does not have a folder yet.
            var self = this;

            if (this.assetsFolderLink && !this.isPseudoContextualRoot({ contentLink: this.assetsFolderLink })) {
                return this.assetsFolderLink;
            }

            function getAssetsFolderLink(contentItem) {
                if (!self.isPseudoContextualRoot({ contentLink: contentItem.assetsFolderLink })) {
                    return contentItem.assetsFolderLink;
                }

                var contentLink = new ContentReference(contentItem.contentLink).createVersionUnspecificReference().toString();
                return self._store.refresh(contentLink).then(function (refreshedContent) {
                    return refreshedContent.assetsFolderLink;
                });
            }

            return when(this.getCurrentContent()).then(function (contentItem) {
                return when(getAssetsFolderLink(contentItem)).then(function (contentAssetsLink) {
                    self.assetsFolderLink = new ContentReference(contentAssetsLink).createVersionUnspecificReference().toString();
                    self.query.references = [self.assetsFolderLink];
                    return when(self._store.get(contentAssetsLink)).then(function (contentAssetFolderContent) {
                        self.uploadCommand.set("model", contentAssetFolderContent);
                    });
                });
            });
        },

        _onDrop: function (evt, fileList) {
            // Accept only HTML5 img tag compliant file types, editors can still use the old Assets Pane
            // if they need any other file type like *.svg or *.tiff
            fileList = UploadUtil.filterFileOnly(fileList);
            if (!fileList || fileList.length !== 1) {
                this._dialogService.alert(resources.singleimage);
                return;
            }
            var fileName = fileList[0].name.split(".").pop().toLowerCase();
            if (this.allowedExtensions.indexOf(fileName) === -1) {
                this._dialogService.alert(resources.wrongfileformat);
                return;
            }

            when(this._refreshTargetUploadContent()).then(function () {
                this.uploadCommand.set("fileList", fileList);
                this.uploadCommand.execute();
            }.bind(this));
        }
    });

    return declare([MediaSelector, _dropFileMixin], {
        // summary:
        //      Represents the widget to select ContentReference.
        // tags:
        //      internal

        resources: resources,
        templateString: template,

        _getThumbnailUrl: function (content) {
            if (!content.capabilities.generateThumbnail) {
                return content.thumbnailUrl || defaultImageUrl;
            }
            var url = new Url(routes.getActionPath({
                moduleArea: "CMS",
                controller: "Thumbnail",
                action: "Generate"
            }));
            url.query = {
                contentLink: content.contentLink,
                "epi.preventCache": new Date().valueOf()
            };
            // storing the previous previewed content link
            this.lastContentLinkPreviwed = content.contentLink;
            return url.toString();
        },

        _setTooltipBrokenThumbnail: function () {
            moduleRequire([
                "epi-cms-react/components/property-extra-info-widget",
                "xstyle/css!epi-cms-react/components/property-extra-info-widget.css"
            ], function (PropertyExtraInfo) {
                this.brokenThumbnailTooltipWidget = new PropertyExtraInfo({
                    messages: [{
                        text: resources.brokenimagewarningmessage,
                        type: "warn"
                    }]
                });
                this.brokenThumbnailTooltipWidget.placeAt(this.inputContainer.parentNode, "last");
                this.own(this.brokenThumbnailTooltipWidget);
            }.bind(this));
        },

        _updateDisplayNode: function (content) {
            this.inherited(arguments);
            if (content) {
                this.isBrokenThumbnailImage = false;
                this.thumbnail.src = this._getThumbnailUrl(content);
                this.contentLink = content.contentLink;

                this.thumbnail.onerror = function () {
                    domClass.toggle(this.brokenThumbnail, "dijitHidden", false);
                    domClass.toggle(this.brokenThumbnail, "brokenThumbnail", true);
                    domClass.toggle(this.thumbnail, "dijitHidden", true);
                    this._setTooltipBrokenThumbnail();
                }.bind(this);
            } else {
                this.contentLink = null;
            }
            domClass.toggle(this.displayNode, "dijitHidden", !content);
            domClass.toggle(this.actionsContainer, "dijitHidden", content);
            this.stateNode.title = content ? content.name : "";
            domClass.toggle(this.thumbnail, "dijitHidden", this.isBrokenThumbnailImage);
            if (this.brokenThumbnailTooltipWidget) {
                domClass.toggle(this.brokenThumbnail, "dijitHidden", true);
                domConstruct.destroy(this.brokenThumbnailTooltipWidget.id);
                this.brokenThumbnailTooltipWidget = null;
            }
        },

        _setupContentSelectorDialogSettings: function () {
            this.inherited(arguments);
            this.contentSelectorDialogSettings = Object.assign(this.contentSelectorDialogSettings, {
                getCurrentValue: function () {
                    if (this.value && this._convertValueToContentReference(this.value)) {
                        return this._convertValueToContentReference(this.value).createVersionUnspecificReference().toString();
                    }
                    return this.value;
                }.bind(this)
            });
        },

        postCreate: function () {
            this.inherited(arguments);
            this.query = { query: "getchildren", allLanguages: true };
            this.own(topic.subscribe("LastFileUploadedAndReplaced", function (changedContentLinks) {
                var foundFile = changedContentLinks.find(function (contentItem) {
                    return ContentReference.compareIgnoreVersion(contentItem.contentLink, this.contentLink);
                }.bind(this));
                if (foundFile) {
                    var contentLink = new ContentReference(foundFile.contentLink).id;
                    when(this._getContentData(contentLink)).then(function (foundContent) {
                        this.thumbnail.src = this._getThumbnailUrl(foundContent);

                    }.bind(this));
                }
            }.bind(this)));
        },

        _onClick: function (event) {
            if (this.readOnly) {
                event.preventDefault();
                event.stopPropagation();
                return;
            }

            this._selectContent();
        }
    });
});

},
'epi-cms/widget/LocalFolderUploader':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/when",
    "dojo/on",
    // epi-cms
    "epi-cms/_ContentContextMixin",
    "epi-cms/widget/MultipleFileUpload"
], function (
    // dojo
    declare,
    when,
    on,
    // epi
    _ContentContextMixin,
    MultipleFileUpload
) {

    var emptyImage = "data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==";

    return declare([MultipleFileUpload, _ContentContextMixin], {
        // summary:
        //      Single file uploader to Local Asset Folders. It comes with preview & progress capabilities.
        // tags:
        //      internal

        constructor: function (params) {
            declare.safeMixin(this, params);
        },

        postCreate: function () {
            this.inherited(arguments);
            when(this.getCurrentContent()).then(function (contentItem) {
                this.set("uploadDirectory", contentItem.contentLink);
                // all images d&d to the editor should be saved to 'For this page'
                this.set("createAsLocalAsset", true);
            }.bind(this));

            var fileBytes, fileName;

            var uploadedFilesHandle = this._fileListModel.watch("uploadFiles", function (name, oldValue, newValue) {
                var file = newValue[0];
                fileName = file.name;
                // only generate thumbnails for image files with size lower than 'thumbnailMaxFileSize'
                if (file.size > this.thumbnailMaxFileSize) {
                    fileBytes = emptyImage;
                } else {
                    var reader = new FileReader();
                    reader.onload = function (file) {
                        fileBytes = file.target.result;
                    }.bind(this);
                    reader.readAsDataURL(file);
                }
                uploadedFilesHandle.remove();
            }.bind(this));

            this.own(this._fileListModel.watch("progress", function (name, oldValue, newValue) {
                var progress = parseInt(newValue.percent.replace("%", ""));
                if (progress <= this.uploadProgressThreshold && fileBytes) {
                    // only show the preview if the progress is not too fast
                    this.emit("uploadFilePreview", fileBytes, fileName);
                }
                this.emit("uploadProgress", progress);
            }.bind(this)));
        }
    });
});

},
'url:epi-cms/widget/templates/ThumbnailSelector.html':"<div data-dojo-attach-point=\"inputContainer, stateNode, dropAreaNode\" id=\"widget_${id}\"\r\n    class=\"dijitReset dijitInline dijitInputContainer epi-resourceInputContainer thumbnail-editor\">\r\n    <div class=\"dijitTextBox\" data-dojo-attach-point=\"_dropZone\" data-dojo-type=\"epi-cms/widget/FilesUploadDropZone\"\r\n        data-dojo-attach-event=\"onDrop: _onDrop\" data-dojo-props=\"outsideDomNode: this.domNode\"></div>\r\n    <a class=\"thumbnail-button dijitTextBox\" href=\"#\" data-dojo-type=\"dijit/layout/_LayoutWidget\" data-dojo-attach-point=\"button\" data-dojo-attach-event=\"onClick: _onClick\">\r\n        <figure data-dojo-attach-point=\"displayNode\" class=\"dijitHidden\">\r\n            <div class=\"dijitHidden\" data-dojo-attach-point=\"brokenThumbnail\"></div>\r\n            <img data-dojo-attach-point=\"thumbnail\" />\r\n            <figcaption class=\"dijitInline dojoxEllipsis\">\r\n                <span data-dojo-attach-point=\"selectedContentNameNode\"></span>\r\n                <span data-dojo-attach-point=\"selectedContentLinkNode, resourceName\"></span>\r\n            </figcaption>\r\n        </figure>\r\n        <div data-dojo-type=\"dijit/ProgressBar\" data-dojo-attach-point=\"progressBar\" data-dojo-props=\"maximum:100\">\r\n        </div>\r\n        <div data-dojo-attach-point=\"actionsContainer, contentSelectorContainer\" class=\"contentSelectorContainer\"></div>\r\n    </a>\r\n\r\n    <a data-dojo-attach-point=\"clearButton\" href=\"#\" class=\"epi-clearButton\">&nbsp;</a>\r\n</div>\r\n",
'url:epi-cms/contentediting/editors/templates/ContentReferenceEditor.html':"<div class=\"dijitInline\" tabindex=\"-1\" role=\"presentation\">\r\n    <div class=\"epi-content-reference-header-block\" data-dojo-attach-point=\"allowedTypesHeaderContainer\">\r\n        <div data-dojo-attach-point=\"allowedTypesHeader\"></div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"container,dropAreaNode\" />\r\n</div>\r\n",
'epi-cms/contentediting/editors/ItemCollectionEditor':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/_base/event",                                                         // used to stop event
    "dojo/aspect",                                                              // used to listen event from model
    "dojo/mouse",                                                               // used to detect mouse event
    "dojo/on",                                                                  // used to listen event
    "dojo/when",                                                                // used to work with potential assynchronous calls

    // Dijit
    "dijit/_TemplatedMixin",                                                    // mixin into me
    "dijit/_WidgetsInTemplateMixin",                                            // mixin into me
    "dijit/layout/_LayoutWidget",                                               // inherited directly

    // EPi Framework
    "epi/shell/dgrid/Formatter",                                                // mixin into grid class
    "epi/shell/dnd/Target",                                                     // used to create an drop zone in actionContainer area
    "epi/shell/widget/_ValueRequiredMixin",                                     // mixin into me
    "epi/shell/TypeDescriptorManager",

    // EPi CMS
    "dgrid/Keyboard",                                                           // mixin into grid class
    "dgrid/OnDemandList",                                                       // mixin into grid class
    "dgrid/Selection",                                                          // mixin into grid class
    "epi-cms/dgrid/formatters",                                                 // used to format grid's item display name
    "epi-cms/dgrid/DnD",                                                        // mixin into grid class
    "epi-cms/dgrid/WithContextMenu",                                            // mixin into grid class
    "epi-cms/extension/events",                                                 // used to get default events
    "epi-cms/contentediting/command/NewItem",                                   // used to create new item
    "epi-cms/contentediting/viewmodel/ItemCollectionViewModel",                 // editor view model
    "epi-cms/contentediting/command/ItemCollectionCommands",                    // context menu
    "epi-cms/widget/_HasChildDialogMixin",                                      // mixin into me
    "./_TextWithActionsMixin",

    // Resources
    "dojo/text!./templates/ItemCollectionEditor.html",                          // editor template
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.itemcollection"  // language resources

], function (
    // Dojo
    declare,
    event,
    aspect,
    mouse,
    on,
    when,

    // Dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,

    // EPi Framework
    Formatter,
    Target,
    _ValueRequiredMixin,
    TypeDescriptorManager,

    // EPi CMS
    Keyboard,
    OnDemandList,
    Selection,
    formatters,
    DnD,
    WithContextMenu,
    events,
    NewItemCommand,
    ItemCollectionViewModel,
    ItemCollectionCommands,
    _HasChildDialogMixin,
    _TextWithActionsMixin,

    // Resources
    template,
    resources

) {

    return declare([
        _LayoutWidget,                                                          // for base functionalities
        _TemplatedMixin, _WidgetsInTemplateMixin,                               // for base functionalities
        _ValueRequiredMixin,                                                    // for styling
        _HasChildDialogMixin,                                                   // for open dialog to create/edit an item
        _TextWithActionsMixin
    ], {
        // summary:
        //      The new editor for property link collection.
        // description:
        //      That supports:
        //          - Collection item name automatically ellipsed
        //          - Sorting list of link items through drag n drop
        //          - Sorting list of link items through context menu
        //          - Create new link
        //          - Edit a link
        //          - Remove a link
        //          - Drag n drop of pages and media
        // tags:
        //    internal

        // baseClass: [public] String
        //    The widget's base CSS class.
        baseClass: "epi-item-collection-editor",

        // multiple: [proteced] Boolean
        //      used by formmixin to determine whether to inject value as an array or single item
        //      return true
        multiple: true,

        // res: [protected] Json object
        //      Language resource
        res: resources,

        // actionsResource: [Object]
        //      The language resource for actions link
        actionsResource: resources,

        // templateString: [protected] String
        //      UI template for the editor
        templateString: template,

        // value: [protected] String
        //      Value of the property (link collection)
        value: null,

        // model: [public] ItemCollectionViewModel
        //      The view model of this edtior.
        model: null,

        // gird: [public] dgrid instance.
        //      The dgrid instance
        grid: null,

        // commandProviderClass: [public] String
        //      The command's namespace can be injected from inheritance or caller.
        commandProviderClass: ItemCollectionCommands,

        // newItemCommand: [public] Command
        //      The command is used to create new item.
        _newItemCommand: null,

        // _gridClass: [private] Grid class
        //      The grid class to create new grid instance.
        _gridClass: declare([OnDemandList, Formatter, Selection, DnD, Keyboard, WithContextMenu]),

        // _mouseOverClass: [private] CSS class
        //      Used to show context menu when mouse hover a row
        _mouseOverClass: "epi-dgrid-mouseover",

        // actionsVisible: Boolean
        //      The flag to show/not actions container area
        actionsVisible: true,

        // customTypeIdentifier: [public] String
        //      If set, will be propagated as the dnd type for all items in the collection
        customTypeIdentifier: null,

        // actionButtonLabel: [String]
        //      The label of action button.
        actionButtonLabel: resources.emptyactions.buttonlabel,

        onChange: function (value) {
            // summary:
            //      Event raised when model value change or item's sort order changed
            // value:
            //      The link collection value
            // tags:
            //      public callback
        },

        postMixInProperties: function () {

            this.inherited(arguments);

            this.setupAllowedTypes();
        },

        postCreate: function () {
            this.inherited(arguments);

            this.set("model", new ItemCollectionViewModel(this.value, {
                itemModelType: this.itemModelType,
                readOnly: this.readOnly,
                maxLength: this.maxLength,
                minLength: this.minLength
            }));

            this.setupCommands();
            this.setupList();
            this.setupActionContainer();
            this.setupEvents();
        },

        setupActionContainer: function () {
            // summary:
            //      Initialization a actions container.
            // tags:
            //      protected

            this.own(
                // Setup dndTarget and store it.
                this._dndTarget = new Target(this.actionsContainer, {
                    accept: this.get("allowedDndTypes"),
                    isSource: false,
                    alwaysCopy: false,
                    insertNodes: function () { }
                })
            );

            this._setupActions(this.actionsContainer);

            this._displayActionsContainer();
        },

        setupCommands: function () {
            // summary
            //      Initialization commands
            // tags:
            //      protected

            // Make command provider is injected
            this.commandProvider = this.commandProvider || new this.commandProviderClass({ model: this.model, commandOptions: this.commandOptions });

            this.own(
                this.commandProvider,

                // Create new item command, store to reuse.
                this._newItemCommand = new NewItemCommand({
                    model: this.model,
                    dialogContentParams: this.commandOptions ? this.commandOptions.dialogContentParams : {}
                }));
        },

        setupList: function () {
            // summary:
            //      Initialization a list.
            // tags:
            //      protected

            var menu = { hasMenu: true, settings: { title: this.res ? this.res.menutooltip : "" } },

                linkAssembler = function (data, object, row) {
                    return "<div class='epi-rowIcon'><span class='dijitInline dijitIcon epi-iconLink epi-objectIcon'></span></div>" + data;
                },
                // Init grid
                settings = {
                    selectionMode: "single",
                    selectionEvents: "click,dgrid-cellfocusin",
                    formatters: [formatters.contentItemFactory("text", "title", "typeIdentifier", menu), linkAssembler],
                    dndParams: {
                        copyOnly: true,
                        accept: this.get("allowedDndTypes"),
                        creator: this._dndNodeCreator.bind(this),
                        isSource: !this.readOnly
                    },
                    dndSourceTypes: this.customTypeIdentifier ? [this.customTypeIdentifier] : [],
                    consumer: this,
                    commandCategory: null
                },

                getDndType = function (object) {
                    var types = TypeDescriptorManager.getAndConcatenateValues(this.dndSourceTypes, "dndTypes");

                    if (types.length === 0) {
                        types = this.dndSourceTypes;
                    }
                    return types;
                };

            if (this.customTypeIdentifier) {
                settings._getDndType = getDndType;
            }

            this.own(this.grid = new this._gridClass(settings, this.itemsContainer));
            this.grid.stopPropagation = true;
            this.grid.contextMenu.addProvider(this.commandProvider);
            this.grid.set("showHeader", false);
            this.grid.renderArray(this.model.get("data"));
            this.grid.startup();
        },

        setupEvents: function () {
            // summary:
            //      Initialization events on list.
            // tags:
            //      protected

            var selector = on.selector;

            this.own(
                // Automatic re-focus when selectedItem is changed.
                this.model.on("selectedItem", this.focus.bind(this)),
                // Sometime model initialization slower than, so we should listen on "initCompleted" then re-render grid ui
                this.model.on("initCompleted", this._renderUI.bind(this)),
                // When mouse is over a row, show the context menu node
                this.grid.on(selector(".dgrid-row", mouse.enter), function (e) {
                    this.domNode.classList.add(this._mouseOverClass);
                }.bind(this)),
                // When mouse is out of an unselected row, hide the context menu node
                this.grid.on(selector(".dgrid-row", mouse.leave), function (e) {
                    this.domNode.classList.remove(this._mouseOverClass);
                }.bind(this)),
                // Handle row click/selection event
                this.grid.on("dgrid-select", function (e) {
                    this.model.set("selectedItem", e.rows[0].data);
                    this.commandProvider.set("model", this.model);
                }.bind(this)),

                // Listen keyboard event to delete grid's row item
                this.grid.on(selector(".dgrid-row", events.keys.del), function (e) {
                    this.model.remove();
                }.bind(this)),

                this.grid.on(selector(".dgrid-row", events.contextmenu), function (e) {
                    var item = this.grid.row(e).data;
                    this.model.set("selectedItem", item);
                    this.select(item);
                    this._showContextMenu(e);
                }.bind(this)),

                // Self handler checkAcceptance on grid
                aspect.around(this.grid.dndSource, "checkAcceptance", function (defaultCheckAcceptance) {
                    return function (source, nodes) {
                        return !this.readOnly && defaultCheckAcceptance.apply(this.grid.dndSource, arguments) && !this.model.hasReachedItemsLimit();
                    }.bind(this);
                }.bind(this)),

                aspect.after(this.grid.dndSource, "onDropData", function (dndData, source, nodes, copy) {

                    var i;

                    // internal move
                    if (this.grid.dndSource === source) {
                        for (i = 0; i < nodes.length; i++) {
                            this.model.moveTo(
                                this.grid.dndSource.getItem(nodes[i].id).data,
                                this.grid.dndSource.current != null ? this.grid.dndSource.getItem(this.grid.dndSource.current.id).data : null,
                                this.grid.dndSource.before);
                        }
                        // external drop
                    } else {
                        for (i = 0; i < dndData.length; i++) {

                            //Need to resolve the data since it might be a deferred.
                            when(dndData[i].data, function (resolvedItem) {
                                this.model.addTo(
                                    resolvedItem,
                                    this.grid.dndSource.current != null ?
                                        this.grid.dndSource.getItem(this.grid.dndSource.current.id).data :
                                        null,
                                    this.grid.dndSource.before);

                                if (source && source.grid && source.grid.consumer && source.grid.consumer !== this) {
                                    source.grid.consumer.model.set("selectedItem", resolvedItem);
                                    source.grid.consumer.model.remove();
                                }
                            }.bind(this));
                        }
                    }

                    // Set the focus back to the editor after a drop so that
                    // the focus is not left where the drag originated.
                    this.focus();

                }.bind(this), true),

                // Overide base method from grid to set selected item
                aspect.around(this.grid, "insertRow", this._aroundInsertRow.bind(this)),

                // Handle model value changed
                this.model.on("changed", function () {
                    this.onChange(this.value = this.model.get("value") || []);
                    this._renderUI();
                    this.focus();
                }.bind(this)),

                // Listen to the grid at onDndStart method to override state
                aspect.after(this.grid.dndSource, "onDndStart", function (source, nodes, copy) {
                    var dndSource = this.grid.dndSource,
                        accepted = dndSource.accept && dndSource.checkAcceptance(source, nodes);

                    this.container.classList[accepted ? "remove" : "add"]("dojoDndTargetDisabled");
                }.bind(this), true),

                // Listen dnd event on drop zone
                aspect.after(this._dndTarget, "onDropData", function (dndData, source, nodes, copy) {
                    for (var i = 0; i < dndData.length; i++) {
                        //Need to resolve the data since it might be a deferred.
                        when(dndData[i].data, function (resolvedItem) {
                            this.model.addTo(resolvedItem, null, false);

                            if (source && source.grid && source.grid.consumer && source.grid.consumer !== this) {
                                source.grid.consumer.model.set("selectedItem", resolvedItem);
                                source.grid.consumer.model.remove();
                            }
                        }.bind(this));
                    }

                    // Set the focus back to the editor after a drop so that
                    // the focus is not left where the drag originated.
                    this.focus();

                }.bind(this), true)
            );

            // Listen on command to change state
            var commands = this.commandProvider.commands.concat(this._newItemCommand);
            commands.forEach(function (command) {
                this.own(
                    aspect.after(command, "onDialogOpen", function () {
                        this.set("isShowingChildDialog", true);
                        this.validate();
                    }.bind(this)),
                    aspect.after(command, "onDialogHideComplete", function () {
                        this.set("isShowingChildDialog", false);
                        this.focus();
                    }.bind(this))
                );
            }.bind(this));
        },

        executeAction: function (actionName) {
            // summary:
            //      Overidden mixin class, listen acion clicked on new link command.
            // actionName: [String]
            //      Action name of link on content area
            // tags:
            //      public

            if (actionName === "createnewitem") {
                // Execute create new link command here
                if (this._newItemCommand) {
                    this._newItemCommand.execute();
                }
            }
        },

        onDialogExecute: function (selectedContent) {
            this.model && this.model.addTo({
                url: selectedContent.publicUrl,
                previewUrl: selectedContent.previewUrl,
                permanentUrl: selectedContent.permanentLink,
                text: selectedContent.name,
                typeIdentifier: selectedContent.typeIdentifier
            }, null, null);
        },

        setupAllowedTypes: function () {
            // summary:
            //      Setup the allowed types for drag and drop
            // tags:
            //      Public

            var converterKey = this.itemConverterKey;

            this.allowedDndTypes = this.allowedDndTypes || [];

            if (converterKey) {
                this.allowedDndTypes = this.allowedDndTypes.map(function (type) {
                    return type + "." + converterKey;
                });
            }

            if (this.customTypeIdentifier) {
                this.allowedDndTypes.unshift(this.customTypeIdentifier);
            }
        },

        focus: function () {
            // summary:
            //      Focus the container if there is a value and
            //      focus the grid if we already have a model and set selected item,
            //      else focus the action container.
            // tags:
            //    public

            if (this.grid && this.value && this.value.length > 0) {
                this.grid.focus();

                if (this.model) {
                    var selectedItem = this.model.get("selectedItem"),
                        selectedItemIndex = this.model.getItemIndex(selectedItem);
                    if (selectedItem) {
                        this.grid.focus(this.grid.row(selectedItemIndex).element);
                    }
                }
            } else {
                this.onFocus();
            }
        },

        select: function (item) {
            // summary:
            //      Set selected item on dgrid
            // item: Object
            //      The selected object
            // tags:
            //      protected

            this.grid.clearSelection();
            if (item) {
                this.grid.select(this.model.getItemIndex(item));
            }
        },

        isValid: function () {
            // summary:
            //    Check if widget's value is valid.
            // isFocused:
            //    Indicate that the widget is being focused.
            // tags:
            //    protected

            return (!this.required || (this.model && this.model.get("value").length > 0));
        },

        _onBlur: function () {
            // summary:
            //      Override base (_HasChildDialogMixin) to check that the context menu is showing or not.
            // tags:
            //      protected override

            if (this.grid.contextMenu && this.grid.contextMenu.isShowingNow) {
                return;
            }
            this.inherited(arguments);
        },

        _getValueAttr: function () {
            // summary:
            //      The get value method
            // tags:
            //      public override

            return this.model.get("value");
        },

        _setValueAttr: function (/*Object*/val) {
            // summary:
            //      The set value method
            // tags:
            //      public override

            this._set("value", val);
            // Reset value to an empty array
            if (!val || !(val instanceof Array)) {
                this._set("value", []);
            }

            if (this._started) {
                this.model ? this.model.set("data", this.value) : (this.model = new ItemCollectionViewModel(this.value, { readOnly: this.readOnly }));
                this._renderUI();
            }
        },

        _setReadOnlyAttr: function (/*Boolean*/readOnly) {
            // summary:
            //      Overwrite readonly property
            // tags:
            //      Protected

            this._set("readOnly", readOnly);

            // Hide actions container area if is readOnly
            this._displayActionsContainer();

            if (this.model) {
                this.model.set("readOnly", readOnly);
            }
        },

        _dndNodeCreator: function (/*Object*/item, /*Object*/hint) {
            // summary:
            //      Custom DnD avatar creator method
            // tags:
            //      Protected

            var dndTypes = this.allowedDndTypes,
                node = document.createElement("div").appendChild(document.createTextNode(item.text));

            if (item.typeIdentifier) {
                dndTypes = TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");
            }

            return {
                node: node,
                type: dndTypes,
                data: item
            };
        },

        _aroundInsertRow: function (/*Object*/original) {
            // summary:
            //      Called 'around' the insertRow method to fix the grids less than perfect selection.
            // tags:
            //      private

            return function (object, parent, beforeNode, i, options) {

                // Call original method
                var row = original.apply(this.grid, arguments);

                var currentItem = this.model.get("selectedItem");
                if (currentItem && currentItem.id === object.id) {
                    this.select(currentItem);
                }

                return row;
            }.bind(this);
        },

        _renderUI: function () {
            // summary:
            //      The common method to update grid ui and set selected item.
            // tags:
            //      private

            this.grid.refresh();
            this.grid.renderArray(this.model.get("data"));
            this.actionsVisible = !this.model.hasReachedItemsLimit();
            this._displayActionsContainer();
        },

        _showContextMenu: function (e) {
            // summary:
            //      Show context menu when keydown (shift+F10 or contextMenu key on windows)
            // e: Object
            //      Keyboard event
            // tags:
            //      private

            // Don't show the context menu if the editor is disabled.
            if (this.readOnly) {
                return;
            }

            var selectedItem = this.model.get("selectedItem"),
                selectedItemIndex = this.model.getItemIndex(selectedItem);
            if (selectedItem) {
                event.stop(e);
                this.grid.contextMenu.scheduleOpen(this, null, this.grid.row(selectedItemIndex).element.querySelector(".epi-iconContextMenu").getBoundingClientRect(), true);
            }
        },

        _displayActionsContainer: function () {
            // summary:
            //      Show/not actions container area
            // tags:
            //      private

            // Hide actions when readonly or set not visible
            this.actionsContainer.style = "display: " + (this.readOnly || !this.actionsVisible ? "none" : "");
        }
    });
});

},
'epi-cms/contentediting/command/NewItem':function(){
﻿define([
// Dojo
    "dojo/_base/declare",

    // EPi Framework
    "epi/shell/command/_Command",                                                   // mixed into me

    // EPi CMS
    "epi-cms/contentediting/command/_CommandWithDialogMixin",                       // mixed into me
    "epi-cms/widget/LinkEditor"
], function (
// Dojo
    declare,

    // EPi Framework
    _Command,

    // EPi CMS
    _CommandWithDialogMixin,
    LinkEditor
) {

    return declare([_Command, _CommandWithDialogMixin], {
        // tags:
        //      internal

        // dialogContentClass: [public] Class
        //      The widget class that will be created and placed as dialog's content
        dialogContentClass: LinkEditor,

        // dialogContentParams: [public] Object
        //      The parameters for create new instance of dialogContentClass.
        dialogContentParams: null,

        // defaultActionsVisible: [public] Bool
        //      .Flag which indicates whether the default confirm and cancel
        //		actions should be visible. This can only be set in the constructor.
        defaultActionsVisible: false,

        _execute: function () {
            // summary:
            //      Overwrite base clase, change the context to edit the block.
            // tags:
            //      protected
            this.set("value", null); // Create new item dialog without value

            this.showDialog();
        },

        _onModelChange: function () {
            // summary:
            //      Overwrite base class, updates canExecute after the model has changed.
            // tags:
            //      protected

            if (!this.model) {
                this.set("canExecute", false);
                return;
            }

            this.set("canExecute", true);
        },

        onDialogExecute: function () {
            // summary:
            //      Process value returned from dialog after it's executed.

            this.inherited(arguments);

            if (this.dialogContent) {
                this.value = this.dialogContent.get("value");
            }

            if (this.model) {
                this.model.addTo(this.value, null, null);
            }
        }
    });
});

},
'epi-cms/widget/LinkEditor':function(){
define([
//dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    //dijit
    "dijit/_CssStateMixin",
    //epi
    "epi",
    "epi/dependency",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/shell/widget/FormContainer",
    "epi/shell/widget/_ActionProviderWidget",
    "epi/shell/widget/_ModelBindingMixin",
    // EPi CMS
    "epi-cms/widget/viewmodel/LinkEditorViewModel",
    "epi-cms/widget/HyperLinkSelector"
],
function (
//dojo
    array,
    declare,
    lang,
    domStyle,
    domClass,
    //dijit
    _CssStateMixin,
    //epi
    epi,
    dependency,
    _DialogContentMixin,
    FormContainer,
    _ActionProviderWidget,
    _ModelBindingMixin,
    // EPi CMS
    LinkEditorViewModel,
    HyperLinkSelector
) {
    return declare([FormContainer, _ActionProviderWidget, _DialogContentMixin, _CssStateMixin, _ModelBindingMixin], {
        // summary:
        //    The dialog to insert or edit a link item.
        // tags:
        //    public

        _metadataManager: null,

        // modelClassName: [public] Class
        //      Represents the model class name that will be used for this widget.
        modelClassName: LinkEditorViewModel,

        // hiddenFields: Array
        //      The list of fields will be hidden from editing.
        hiddenFields: [],

        postMixInProperties: function () {
            // summary:
            //		Initialize properties
            // tags:
            //    protected
            this.inherited(arguments);

            this.doLayout = false;

            this._metadataManager = this._metadataManager || dependency.resolve("epi.shell.MetadataManager");

            if (!this.model && this.modelClassName) {
                var modelClass = declare(this.modelClassName);
                this.model = new modelClass();
            }

            this._actions = [
                {
                    name: "delete",
                    label: epi.resources.action.deletelabel,
                    settings: { type: "button", disabled: true, "class": "epi-outlined-button" }, // Default disable Delete button until the value is valid
                    action: lang.hitch(this, function () {
                        // if we return the null object, FormContainer will ignore of setting its value.
                        // So we need to return the object with empty properties, in order to clear data.
                        array.forEach(this.form._getDescendantFormWidgets(), function (widget) {
                            widget.set("value", "");
                        }, this);
                        this.executeDialog({ action: "delete" });
                    })
                },
                {
                    name: "cancel",
                    label: epi.resources.action.cancel,
                    settings: { type: "button", "class": "epi-plain-button" },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                },
                {
                    name: "ok",
                    label: epi.resources.action.ok,
                    settings: { type: "button", "class": "Salt" },
                    action: lang.hitch(this, function () {
                        if (this.validate()) {
                            this.executeDialog({ action: "ok" });
                        }
                    })
                }
            ];
        },

        postCreate: function () {
            if (this.modelType) {
                this.metadata = this._metadataManager.getMetadataForType(this.modelType);
            }

            this.inherited(arguments);
        },

        resize: function (changeSize, resultSize) {
            // summary:
            //      Customize default resize method
            // newSize: object
            //      The new size of Task component
            // tags:
            //      internal

            this.inherited(arguments);
            this.domNode.style.width = "";
            this.domNode.style.height = "";
        },

        _setValueAttr: function (value) {
            // summary:
            //    Set selected href.
            // tags:
            //    private
            this.inherited(arguments);
            this._handleActions(value);
        },

        onFormCreated: function (widget) {
            array.forEach(this.form._getDescendantFormWidgets(), function (widget) {

                if (this.hiddenFields && this.hiddenFields.indexOf(widget.name) > -1) {
                    var parent = this._getAncestorNode(widget.domNode, "epi-form-container__section__row");
                    domStyle.set(parent, { display: "none" });
                    widget.set("required", false); // disable required validation for hidden field
                }
            }, this);

            // Set state of delete button when form created
            this._handleActions(this.value);
        },

        _handleActions: function (value) {
            if (this.hasAction("delete")) {
                this.setActionProperty("delete", "disabled", this.model._isEmptyObject(value));
            }
        },

        getFormWidget: function (widgetName) {
            // Summary
            //      Gets form widget by name.
            // widgetName: String
            //      Name of the form widget to get.
            // tag
            //      Public

            var widgets = array.filter(this.form._getDescendantFormWidgets(), function (widget) {
                return widget && widget.name === widgetName;
            }, this);

            return widgets ? widgets[0] : null;
        },

        _getAncestorNode: function (node, classAttr) {
            // Summary
            //      Get ancestor node which has class classAttr
            // node: DomNode
            //      The domNode which need to get ancestor.
            // classAttr: String
            //      The class attribute.
            // tag
            //      Private

            var parentNode = node ? node.parentNode : null;
            if (!parentNode) {
                return null;
            }

            if (!domClass.contains(parentNode, classAttr)) {
                return this._getAncestorNode(parentNode, classAttr);
            }

            return parentNode;
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget
            //
            // returns:
            //      An array containing a select page action definition, if it is not a shared block
            return this._actions;
        },


        isValidValue: function () {
            // Summary
            //      Indicator that value of widgets which set required are valid
            // tag
            //      Public
            return array.every(this.form._getDescendantFormWidgets(), function (widget) {
                return widget.get("required") ? !!widget.get("value") : true;
            });
        }
    });
});

},
'epi-cms/widget/viewmodel/LinkEditorViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/io-query",
    "dojo/topic",
    "dojo/Stateful",
    "dojo/when",

    // EPi Framework
    "epi/dependency"
],

function (
// Dojo
    array,
    declare,
    Deferred,
    lang,
    ioQuery,
    topic,
    Stateful,
    when,

    // EPi Framework
    dependency
) {
    return declare([Stateful], {
        // summary:
        //    Represents the view model for LinkEditor
        // tags:
        //    internal

        _isEmptyObject: function (obj) {
            // Summary
            //      Check empty object
            // obj: object
            //      The object which need to check for empty.
            // tag
            //      Private

            for (var i in obj) {
                if (obj[i] && obj[i] !== "") {
                    return false;
                }
            }
            return true;
        }
    });
});


},
'epi-cms/widget/HyperLinkSelector':function(){
﻿define([
    //dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/Deferred",

    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/when",
    "dojo/promise/all",
    "dojo/string",
    //dijit
    "dijit/_Widget",
    "dijit/_Container",
    "dijit/form/ValidationTextBox",
    //epi
    "epi/dependency",
    "epi/Url",
    "epi/shell/widget/_ModelBindingMixin",
    "epi-cms/widget/_HyperLinkFieldItem",
    "epi-cms/contentediting/editors/SelectionEditor",
    "epi-cms/widget/viewmodel/HyperLinkSelectorViewModel",
    "epi-cms/form/EmailValidationTextBox",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.editlink",
    // Template
    "dojo/text!./templates/_HyperLinkLanguageField.html"
], function (
    //dojo
    array,
    declare,
    lang,
    Deferred,

    domStyle,
    domClass,
    domConstruct,
    when,
    all,
    dojoString,
    //dijit
    _Widget,
    _Container,
    ValidationTextBox,
    //epi
    dependency,
    Url,
    _ModelBindingMixin,
    _HyperLinkFieldItem,
    SelectionEditor,
    HyperLinkSelectorViewModel,
    EmailValidationTextBox,

    resources,
    template
) {
    return declare([_Widget, _Container, _ModelBindingMixin], {
        // summary:
        //    Represents the selector for all hyper link, for example: page, media, 3rd party providers.
        // tags:
        //    internal

        value: null,

        // showLanguageSelector: [internal] Boolean
        //      Show or hide the language selector
        showLanguageSelector: true,

        // Set by form _FormMixin and used by validation to determine whether the error state should be shown
        _hasBeenBlurred: false,

        modelClassName: HyperLinkSelectorViewModel,

        modelBindingMap: {
            wrapperSettings: ["wrapperSettings"],
            selectedWrapper: ["selectedWrapper"]
        },

        _languageSelector: null,
        _languageSelectorWrapperNode: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model && this.modelClassName) {
                var modelClass = declare(this.modelClassName);
                this.model = new modelClass({ providers: this.providers });
            }

            this._languageStore = this._languageStore || dependency.resolve("epi.storeregistry").get("epi.cms.language");
        },

        buildRendering: function () {
            this.inherited(arguments);

            this._createLanguageSelector();
            this._createRemainingUrlInput();

        },

        startup: function () {
            this.inherited(arguments);

            this._languageSelector.startup();
            this._remainingUrl.startup();

            //Add the available languages to the language selector
            var self = this,
                languageSelector = this._languageSelector;
            when(this._languageStore.get(), function (languages) {

                //Show the selector if there are more than one language enabled on the site
                if (self.get("showLanguageSelector")) {
                    if (languages.length <= 1) {
                        self._toggleLanguageSelector(false);
                    } else {
                        self._toggleLanguageSelector(true);
                    }
                }

                var selections = languages.map(function (language) {
                    return {
                        text: language.name,
                        value: language.languageId
                    };
                });

                // Add the automatic option first
                selections.splice(0, 0, { text: resources.automaticlanguage, value: "" });
                languageSelector.set("selections", selections);

                //Select the default (Automatic value)
                languageSelector.set("value", "");

                // createInputWrappers run require for child widgets so the first time we load this widget it runs the startup before the child widgets has created.
                // that's why we're creating child widgets in startup other than buildRendering.

                // Run the create input wrappers after the language selector has been initialized,
                // otherwise the onSelectorsCreated might run before the languages has been initialized
                return self._createInputWrappers();
            }).then(function () {
                // Place the remaining url after all other inputs
                domConstruct.place(this._remainingUrlWrapperNode, this.domNode, "last");
            }.bind(this));
        },

        onSelectorsCreated: function (widget) {
            // summary:
            //    Raise when finish constructing hyperlinkSelector.
            // tags:
            //    public
        },

        _setShowLanguageSelectorAttr: function (value) {
            this._set("showLanguageSelector", value);
            this._toggleLanguageSelector(value);
        },

        _setSelectedWrapperAttr: function (target) {
            // summary:
            //    Disabled all wrappers, enabled selected.
            // tags:
            //    private

            if (!target) {
                return;
            }

            array.forEach(this.wrappers, function (wrapper) {
                wrapper.set("selected", false);
            });

            target.set("selected", true); // mark this widget as selected/enabled

            // Enable/Disable the language selector depending on if the wrapper is used to select ContentReferences
            this._languageSelector.set("disabled", !target.settings.isContentLink);

            // The remaining url input should only be visible if the current wrapper is for internal links
            domClass.toggle(this._remainingUrlWrapperNode, "dijitHidden", !target.settings.isContentLink);

        },

        _createLanguageSelector: function () {
            // summary:
            //      Create the language selector
            // tags:
            //      private

            this.own(this._languageSelector = new SelectionEditor());

            //Create the row for the selector and hide it by default
            this._languageSelectorWrapperNode = domConstruct.toDom(
                dojoString.substitute(template, {
                    id: this._languageSelector.id,
                    label: resources.language,
                    title: ""
                }));
            domConstruct.place(this._languageSelectorWrapperNode, this.domNode, "first");

            //Inject the selector
            this._languageSelector.placeAt(this._languageSelectorWrapperNode, "last");
        },

        _createRemainingUrlInput: function () {
            this.own(this._remainingUrl = new ValidationTextBox({}));
            this._remainingUrlWrapperNode = domConstruct.toDom(
                dojoString.substitute(template, {
                    id: this._remainingUrl.id,
                    label: resources.remainingurl,
                    title: resources.remainingurltitle
                }));
            this._remainingUrl.placeAt(this._remainingUrlWrapperNode, "last");
        },

        _toggleLanguageSelector: function (visible) {
            // summary:
            //      Toggle the visibility of the language selector
            // visible: Boolean
            //      True if it should be visible otherwise false
            // tags:
            //      protected

            domClass.toggle(this._languageSelectorWrapperNode, "dijitHidden", !visible);
        },

        _createInputWrappers: function () {
            // summary:
            //      Create the input wrappers for the providers

            var settings = this.model.wrapperSettings,
                createPromises = [],
                self = this;

            settings.forEach(function (setting) {
                var def = new Deferred();

                createPromises.push(def.promise);

                require([setting.widgetType], function (ctor) {

                    var wrapper = new _HyperLinkFieldItem(lang.mixin(setting, {
                        groupName: setting.groupName + this.id,
                        inputWidgetCtor: ctor,
                        required: self.required
                    }));

                    self.own(wrapper.on("radioButtonChange", lang.hitch(this, function () {
                        self.set("selectedWrapper", wrapper);
                        wrapper.focus();
                    })));

                    //Hide the widget if it set to invisible
                    if (setting.invisible) {
                        domStyle.set(wrapper.domNode, { display: "none" });
                    }

                    def.resolve(wrapper);
                });

            }, this);

            return when(all(createPromises), function (wrappers) {
                if (wrappers.length === 0) {
                    return;
                }

                //Add the wrappers to the child collection
                wrappers.forEach(function (wrapper) {
                    self.addChild(wrapper);
                });

                self.set("wrappers", wrappers);

                var value = self.get("value");
                if (value) {
                    self._setValueForWidgets(value);
                } else {
                    //Select the first wrapper
                    self.set("selectedWrapper", wrappers[0]);
                }

                self.onSelectorsCreated(self);
            });
        },

        _getSelectedWrapper: function () {
            // summary:
            //    Get selected widget.
            // tags:
            //    private
            return array.filter(this.wrappers, function (wrapper) {
                return wrapper.get("selected");
            })[0];
        },

        _getValueAttr: function () {
            // summary:
            //    Get selected href.
            // tags:
            //    private
            var selectedWrapper = this._getSelectedWrapper();
            if (selectedWrapper) {
                if (selectedWrapper.inputWidget && selectedWrapper.settings.isContentLink) {

                    return this.model.getUrlValue(
                        selectedWrapper.inputWidget.get("permanentLink"),
                        this._languageSelector.get("value"),
                        this._remainingUrl.get("value"),
                        this.value
                    );

                } else {
                    return selectedWrapper.get("value");
                }
            }

            return this.value;
        },

        _setValueAttr: function (value) {
            // summary:
            //    Set selected href.
            // tags:
            //    private


            var setValue = function (value) {
                this._set("value", value);

                this._remainingUrl.set("value", this.model.getRemainingUrl(value));
                this._setValueForWidgets(value);
            };

            if (value) {
                // No need to try to resolve a permenent link if there isn't a value
                this.model.getPermanentLink(value).then(setValue.bind(this));
            } else {
                setValue.call(this, value);
            }
        },

        _setValueForWidgets: function (value) {
            // Reset wrappers value to default

            var wrappers = this.get("wrappers");
            if (!wrappers) {
                return;
            }

            array.forEach(wrappers, function (wrapper) {
                wrapper.set("value", null);
            });

            if (!value) {
                return;
            }

            var url = new Url(this.value);
            this._languageSelector.set("value", url.getQueryParameterValue("epslanguage"));

            when(this.model.getContentData(value), lang.hitch(this, function (content) {
                if (content) { // dynamic link (pages, media, products)
                    array.every(wrappers, function (wrapper) {
                        if (wrapper && wrapper.settings.isContentLink) {
                            if (array.some(wrapper.settings.allowedTypes, lang.hitch(this, function (baseType) {
                                return this.model.isBaseTypeIdentifier(content.typeIdentifier, baseType);
                            }))) {
                                wrapper.set("value", content.contentLink);

                                this.set("selectedWrapper", wrapper);
                                return false; // break the loop
                            }
                        }
                        return true; // continue the loop
                    }, this);
                } else { // static link (email, external links)
                    array.every(wrappers, function (wrapper) {
                        if (wrapper && !wrapper.settings.isContentLink) {
                            var widget = wrapper.inputWidget;
                            if (widget && this._isValidEditorWidget(value, widget) && widget.validator(value, widget.constraints)) {
                                wrapper.set("value", value);
                                this.set("selectedWrapper", wrapper);
                                return false; // break the loop
                            }
                        }
                        return true; // continue the loop
                    }, this);
                }
            }));
        },

        _isValidEditorWidget: function (value, widget) {
            // summary:
            //    Checks if it is an valid editor widget. We only want it to validate against email if the url scheme is mailto.
            //
            // tags:
            //    private
            if (widget instanceof EmailValidationTextBox) {
                return Url(value).scheme === "mailto";
            }
            return true;
        },

        validate: function () {
            // summary:
            //    Validation value of Href.
            // tags:
            //    public
            var selectedWrapper = this._getSelectedWrapper();
            if (selectedWrapper) {
                // Set by form _FormMixin and used by validation to determine whether the error state should be shown
                selectedWrapper._hasBeenBlurred = this._hasBeenBlurred;
                return selectedWrapper.validate();
            }
            return false;
        },

        focus: function () {
            // summary:
            //    Set focus to the selected wrapper
            // tags:
            //    public
            var selectedWrapper = this._getSelectedWrapper();

            if (selectedWrapper) {
                selectedWrapper.focus();
            }
        },

        reset: function () {
            // Do as in _FormValueMixin.reset()
            this._hasBeenBlurred = false;
            this.set("value", null);
        }
    });
});

},
'epi-cms/widget/_HyperLinkFieldItem':function(){
﻿define([
//dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    //dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_Contained",
    //epi
    "epi/string",
    //resources
    "dojo/text!./templates/_HyperLinkFieldItem.html"
],
function (
//dojo
    declare,
    lang,
    //dijit
    _Widget,
    _TemplatedMixin,
    _Contained,
    //epi
    epiString,
    //resources
    template
) {
    return declare([_Widget, _Contained, _TemplatedMixin], {
        // tags:
        //      internal

        templateString: template,

        // Represents widget to input link value
        inputWidget: null,

        inputWidgetCtor: null,

        // Settings for child widget
        settings: null,

        // Set by form _FormMixin and used by validation to determine whether the error state should be shown
        _hasBeenBlurred: false,

        buildRendering: function () {
            this.inherited(arguments);

            var settings = lang.mixin({value: this.get("value") || null}, this.settings);

            this.own(this.inputWidget = new this.inputWidgetCtor(settings).placeAt(this.domNode));
        },

        _onRadioButtonChange: function (evt) {
            this.onRadioButtonChange(this, evt);
        },

        onRadioButtonChange: function (target, evt) {
            // trigger radio button change value event
        },

        validate: function () {
            if (this.inputWidget) {
                // Set by form _FormMixin and used by validation to determine whether the error state should be shown
                this.inputWidget._hasBeenBlurred = this._hasBeenBlurred;
                return this.inputWidget.validate();
            }
            return true;
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            if (this.inputWidget) {
                this.inputWidget.set("value", value);
            }
        },

        _getValueAttr: function () {
            if (this._started && this.inputWidget) {
                return this.inputWidget.get("value");
            }

            return this.value;
        },

        _setRequiredAttr: function (val) {
            this._set("required", val);
            if (this.inputWidget) {
                this.inputWidget.set("required", val);
            }
        },

        _setSelectedAttr: function (value) {
            this._set("selected", value);
            if (this.inputWidget) {
                this.inputWidget.set("disabled", !value);

                if (!value) {
                    this.inputWidget.set("state", "");
                }
            }

            this.radioNode.checked =  value;
        },

        _getSelectedAttr: function () {
            return this.radioNode.checked;
        },

        _setShowAllLanguagesAttr: function (val) {
            this._set("showAllLanguages", val);
            if (this.inputWidget) {
                this.inputWidget.set("showAllLanguages", val);
            }
        },

        focus: function () {
            if (this.inputWidget) {
                this.inputWidget.focus();
            }
        }
    });
});

},
'url:epi-cms/widget/templates/_HyperLinkFieldItem.html':"﻿<div class=\"epi-form-container__section__row epi-form-container__section__row--field epi-hyperLink\">\r\n    <label for=\"${id}_${name}\">\r\n        <input type=\"radio\" name=\"${groupname}\" id=\"${id}_${name}\" value=\"${name}\" data-dojo-type=\"dijit/form/RadioButton\" data-dojo-attach-event=\"onchange:_onRadioButtonChange\" data-dojo-attach-point=\"radioNode\" />\r\n        ${displayName}\r\n    </label>\r\n</div>",
'epi-cms/contentediting/editors/SelectionEditor':function(){
﻿define([

    // Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/on",

    "dojox/html/entities",

    // Dijit
    "dijit/form/Select",
    "dijit/MenuItem",
    "dijit/MenuSeparator",

    // EPi
    "epi/shell/layout/_LayoutWidget",
    "epi/shell/widget/_ValueRequiredMixin"
],
function (

    // Dojo
    array,
    declare,
    lang,
    domClass,
    on,

    entities,
    // Dijit
    Select,
    MenuItem,
    MenuSeparator,

    // EPi
    _LayoutWidget,
    _ValueRequiredMixin
) {

    return declare([_LayoutWidget, Select, _ValueRequiredMixin], {
        // tags:
        //      public

        actualValue: null,

        value: null,

        // To limit height to available space in viewport
        maxHeight: -1,

        postMixInProperties: function () {
            // summary:
            //		Set options based on the selections passed through.

            this.inherited(arguments);

            this.set("selections", this.selections);

            this.actualValue = this.value;
        },

        _setSelectionsAttr: function (newSelections) {
            this.set("options", array.map(newSelections, function (item) {
                return {
                    label: entities.encode(item.text),
                    value: item.value,
                    selected: (item.value === this.value) || (!item.value && !this.value)
                };
            }, this));
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(on(this, "change", lang.hitch(this, function () {
                if (!this.disabled) {
                    this.validate();
                }
                this.onLayoutChanged();
            })));
        },

        _getMenuItemForOption: function (option) {
            // summary:
            //		For the given option, return the menu item that should be used to display it.

            var item = null;
            if (option.type === "separator") {
                item = new MenuSeparator();
            } else {
                var click = lang.hitch(this, "_setValueAttr", option);
                item = new MenuItem({
                    option: option,
                    label: option.label || this.emptyLabel,
                    onClick: click,
                    disabled: option.disabled || false
                });
                item.focusNode.setAttribute("role", "listitem");
            }

            this.own(item);
            return item;
        },

        _getValueFromOpts: function () {
            // summary:
            //		Returns the value of the widget by reading the options for the selected flag.

            var options = this.getOptions() || [];

            if (!this.multiple && options.length) {
                // Mirror what a select does - choose the first one
                var option = array.filter(options, function (i) {
                    return i.selected;
                })[0];
                if (option && option.value !== undefined) {
                    return option.value;
                } else {
                    return null;
                }
            } else if (this.multiple) {
                // Set value to be the sum of all selected
                return array.map(array.filter(options, function (i) {
                    return i.selected;
                }), function (i) {
                    return i.value;
                }) || [];
            }
            return "";
        },

        _setValueAttr: function (value, priorityChange) {
            // summary:
            //		Set the value of the widget.
            //		If a non-object is passed, then we set our value from looking it up.

            var options = this.getOptions() || [];

            if (value === null || typeof value != "object") {
                value = array.filter(options, function (i) {
                    return (i.value === value) || (!i.value && !value);
                });
            }

            // Convert item to an array if needed.
            if (!lang.isArray(value)) {
                value = [value];
            }

            if (this._onChangeActive) {
                var actual = value[0] ? value[0].value : null;

                this._pendingOnChange = this.actualValue !== actual;
                this.actualValue = actual;
            }

            array.forEach(options, function (i) {
                i.selected = array.some(value, function (v) {
                    return v.value === i.value;
                });
            });

            var val = array.map(value, function (i) {
                    return i.value;
                }),
                disp = array.map(value, function (i) {
                    return i.label;
                });

            this._set("value", this.multiple ? val : val[0]);
            this._setDisplay(this.multiple ? disp : disp[0]);
            this._updateSelection();
            this._handleOnChange(this.value, priorityChange);
        },

        _updateSelection: function () {
            // summary:
            //		Sets the "selected" class on the item for styling purposes.

            this._set("value", this._getValueFromOpts());
            var value = this.value;

            if (value !== undefined) {
                if (!lang.isArray(value)) {
                    value = [value];
                }
                array.forEach(this._getChildren(), function (child) {
                    var isSelected = array.some(value, function (v) {
                        return child.option && (v === child.option.value);
                    });
                    child.domNode.setAttribute("aria-selected", isSelected);
                }, this);
            }
        },

        validator: function (/*Object*/value, /*Object?*/ flags) {
            // summary:
            //      Validate the value is match with this selection value type.
            // tags:
            //      public abtract
        }
    });
});

},
'epi-cms/widget/viewmodel/HyperLinkSelectorViewModel':function(){
define([
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/io-query",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/when",
    //epi
    "epi/string",
    "epi/Url",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/core/PermanentLinkHelper"

], function (
    // dojo
    array,
    declare,
    lang,
    Stateful,
    ioQuery,
    domStyle,
    domConstruct,
    when,
    //epi
    epiString,
    Url,
    TypeDescriptorManager,
    PermanentLinkHelper

) {

    return declare([Stateful], {
        // summary:
        //		Represents the view model for HyperLinkSelector widget.
        //
        // tags:
        //      internal

        _providersSetter: function (providers) {
            var wrapperSettings = [];

            array.forEach(providers, lang.hitch(this, function (provider) {
                wrapperSettings.push({
                    name: provider.name,
                    displayName: provider.displayName ? provider.displayName : provider.name,
                    title: provider.title ? provider.title : "",
                    groupname: "hyperLink_",
                    widgetType: provider.widgetType,
                    invisible: provider.invisible,
                    settings: lang.mixin({
                        roots: provider.roots,
                        allowedTypes: provider.linkableTypes,
                        isContentLink: (provider.linkableTypes && provider.linkableTypes.length > 0),
                        allowedDndTypes: [],
                        disabled: true, // Disable all link input as default
                        value: null,
                        searchArea: provider.searchArea
                    }, provider.widgetSettings)
                });
            }));

            this.set("wrapperSettings", wrapperSettings);
        },

        getContentData: function (value) {
            if (value) {
                return PermanentLinkHelper.getContent(value, { allLanguages: true });
            }

            return null;
        },

        isBaseTypeIdentifier: function (type, base) {
            return TypeDescriptorManager.isBaseTypeIdentifier(type, base);
        },

        getPermanentLink: function (href) {
            // summary:
            //     Get the permanent link for the given href, if it can be converted. Otherwise it returns the given href
            // tags:
            //      internal

            return PermanentLinkHelper.getPermanentLink(href);
        },

        getUrlValue: function (newValue, selectedLanguage, remainingUrl, oldValue) {
            // summary:
            //      Creates a new url based on the new value the selected language and the query params on the old value.
            //      If the newValue and the oldValue points to the same url (except the query params)
            //      the query params from the oldValue will be appended to the new value.
            // tags:
            //      internal

            if (!newValue) {
                return "";
            }

            var url = new Url(newValue);

            //If the old url is the same as the new one append the old query params to
            //Get the old query string
            if (oldValue) {
                var oldUrl = new Url(oldValue);
                if (this._areEqual(oldUrl, url)) {
                    //Append the old query params
                    url.query = lang.mixin(oldUrl.query, url.query);
                }
            }

            //If the user has selected a language add that to the query
            if (selectedLanguage === "") {
                delete url.query.epslanguage;
            } else {
                url.query.epslanguage = selectedLanguage;
            }

            // Add the remaining url to the url
            if (remainingUrl) {
                var rUrl = new Url(remainingUrl);

                // If there is a path segment add it to the epsremainingpath query parameter
                if (rUrl.path) {
                    url.query["epsremainingpath"] = rUrl.path;
                }

                // Add the fragment
                if (rUrl.fragment) {
                    url.fragment = rUrl.fragment;
                }

                //Add all query string parameters
                Object.keys(rUrl.query).forEach(function (key) {
                    url.query[key] = rUrl.query[key];
                });
            }


            return url.toString();
        },

        getRemainingUrl: function (value) {
            // summary:
            //      Returns the query string and fragments of the url as a new url
            //      If the epsremainingpath query parameter set it set as the path on the new url
            // tags:
            //      public

            if (!value) {
                return "";
            }

            // replace some encoded characters get from CMS
            value = value.replace(/\+/g, "%20");

            var url = new Url(value);

            // reset the authority and scheme as we do not want these in the url
            url.authority = "";
            url.scheme = "";


            // Delete known query strings
            delete url.query["epslanguage"];
            delete url.query["epieditmode"];

            // set the epsremainingpath as the path on the url
            if (url.query.epsremainingpath) {
                url.path = url.query.epsremainingpath;
            } else {
                url.path = "";
            }

            // delete it from the query string
            delete url.query["epsremainingpath"];

            return url.toString();
        },

        _areEqual: function (url1, url2) {
            // summary:
            //      Determines if the two urls are the same but ignoring the query string params
            // tags:
            //      private

            return url1.scheme === url2.scheme &&
                url1.authority === url2.authority &&
                url1.path === url2.path &&
                url1.fragment === url2.fragment;
        }
    });
});

},
'epi-cms/core/PermanentLinkHelper':function(){
﻿define([
// dojo
    "dojo/_base/lang",
    "dojo/when",

    // epi
    "epi/dependency",
    "epi/shell/XhrWrapper",
    "epi/routes"
],

function (
// dojo
    lang,
    when,

    // epi
    dependency,
    XhrWrapper,
    routes
) {

    var xhr = new XhrWrapper();

    return {
        // summary:
        //      Get the content from a permanent link
        // tags:
        //      public

        getContent: function (/*String*/link, /*Object*/options) {
            // summary:
            //      Get linked content data with the permanent link
            // tags:
            //      public

            if (!link) {
                return null;
            }

            var registry = dependency.resolve("epi.storeregistry"),
                store = registry.get("epi.cms.content.light"),
                query = lang.mixin({
                    query: "getcontentbypermanentlink",
                    permanentLink: link
                }, options || {});

            return when(store.query(query)).then(function (contentItems) {
                return contentItems && contentItems instanceof Array ? contentItems[0] : contentItems;
            });
        },

        getPermanentLink: function (href) {
            // summary:
            //     Get the permanent link for the given href, if it can be converted. Otherwise it returns the given href
            // tags:
            //      internal

            var route = routes.getActionPath({ moduleArea: "CMS", controller: "Links", action: "GetPermanentLink" });

            return xhr.xhrGet({
                url: route,
                content: {
                    href: href
                }
            });
        }
    };
});

},
'epi-cms/form/EmailValidationTextBox':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/form/ValidationTextBox",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.form.emailvalidation"
],
function (
    declare,
    lang,
    ValidationTextBox,

    // Resources
    res
) {

    var module = declare([ValidationTextBox], {
        // summary:
        //    Represents the email input textbox.
        // tags:
        //    internal

        invalidMessage: res.invalidmessage,

        // addMailTo: Boolean
        //      If true the value will always be prepended
        //      with the mailto protocol
        addMailTo: false,

        validator: function (value, constraints) {
            // summary:
            //		Validate the text input with email address validation.
            // tags:
            //		override

            value = value || "";

            if (!this.required && this._isEmpty(value)) {
                return true;
            }

            // replace escaped sequences to enable/simplify regexp validation (\@ or "everythingInHereIsEsc@ped"
            value = value.replace(/\\.{1}/g, "replaced").replace(/".*?"/g, "replaced");

            return module.validationRegex.test(value);
        },

        _getValueAttr: function () {

            var value = this.inherited(arguments);

            if (this.addMailTo) {
                // make sure the hyper link has mailto: prefix
                value = value ? lang.trim(value) : "";
                if (value && value.indexOf("mailto:") !== 0) {
                    value = "mailto:" + value;
                }
            }

            return value;
        },

        _setValueAttr: function (value) {
            value = value ? value.replace("mailto:", "") : "";

            this.inherited(arguments, [value]);
        }
    });

    // Simple and incomplete test for email-likeness: somechars@somechars.somechars
    // only trying to stop the most common mistakes
    module.validationRegex = /.+@.+\..+/i;

    return module;

});

},
'url:epi-cms/widget/templates/_HyperLinkLanguageField.html':"<div class=\"epi-form-container__section__row epi-form-container__section__row--field epi-hyperLink\">\r\n    <label for=\"${id}\" title=\"${title}\">${label}</label>\r\n</div>",
'epi-cms/contentediting/viewmodel/ItemCollectionViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when",

    // EPi CMS
    "epi-cms/contentediting/viewmodel/_ViewModelMixin",                                 // mixed into me
    "epi-cms/contentediting/viewmodel/LinkItemModel"                                    // Required for

], function (
// Dojo
    declare,
    lang,
    Deferred,
    all,
    when,

    // EPi CMS
    _ViewModelMixin,
    LinkItemModel
) {
    return declare([_ViewModelMixin], {
        // summary:
        //      The link collection editor view model.
        // description:
        //      That supports Move next/previous/remove logic
        // tags:
        //    internal

        // _instanceId: [private] String
        //      The identity for each instance.
        _instanceId: null,

        // _autoId: [private] Number
        //      The item's index
        _autoId: 0,

        // _selectedItem: [private] Object
        //      The current selected item.
        _selectedItem: null,

        // _data: [private] Array
        //      Array of <itemModelClass> that represent for the editor value
        _data: null,

        // itemModelClass: [public] Class
        //      The item's class got from itemModelType.
        itemModelClass: null,

        // itemModelType: [public] String
        //      The item model's class name can be injected from inheritance or caller.
        itemModelType: null,

        constructor: function (/*Object[]*/data, /*Object*/options) {
            // summary:
            //      Create new instance of ItemCollectionViewModel
            //      Parse original data to <itemModelClass>
            // data: Array
            //      The value of link collection property
            // options: Object
            //      Parameters to inject some argument from caller.
            //      For instance: itemModelClass

            declare.safeMixin(this, options);
        },

        postscript: function (data) {

            require([this.itemModelType], lang.hitch(this, function (modelClass) {
                this.itemModelClass = modelClass;
                this._instanceId = new Date().getTime();
                this._init(data);
            }));
        },

        moveNext: function () {
            // summary:
            //      The method used in "MoveToNext" command
            // tags:
            //      public

            this._move(1) && this.emit("changed");
        },

        movePrevious: function () {
            // summary:
            //      The method used in "MoveToPrevious" command
            // tags:
            //      public

            this._move(-1) && this.emit("changed");
        },

        remove: function () {
            // summary:
            //      The method used in "BlockRemove" command
            // tags:
            //      public

            if (!this.get("canEdit")) {
                return;
            }

            var index = this.getItemIndex(this._selectedItem);
            this._data.splice(index, 1);

            var len = this._data.length;
            this.set("selectedItem", this._data[index >= len ? len - 1 : index] || null);

            this.emit("changed");
        },

        hasReachedItemsLimit: function () {
            // summary:
            //      Has limit of the items reached or not. Will return false if limit was not set at all
            // tags:
            //      public

            return this.maxLength && this._data.length >= this.maxLength;
        },

        addTo: function (/*Object*/newItem, /*Object*/item, /*Boolean*/before) {
            // summary:
            //      The method used when drag and drop item into LinkCollectionEdtior
            // tags:
            //      public

            if (!newItem) {
                return false;
            }

            if (this.hasReachedItemsLimit()) {
                return;
            }

            if (this.getItemIndex(newItem) >= 0) {
                this.moveTo(newItem, null, false);
                this.emit("changed");
            } else {
                var self = this;
                when(self._createItemModel(newItem), function (model) {
                    if (!item) {
                        self._data.push(model);
                    } else {
                        // insert newItem to selected index rely on item's index
                        var targetIndex = self.getItemIndex(item) + (before ? 0 : 1);
                        self._data.splice(targetIndex, 0, model);
                    }

                    self.emit("changed", { uiChanged: false });
                });
            }
        },

        moveTo: function (/*Object*/selectedItem, /*Object*/item, /*Boolean*/before) {
            // summary:
            //      The method used when drag and drop selected item to reorder
            // tags:
            //      public

            if (!selectedItem && !this._selectedItem) {
                return false;
            }

            // set new selected item if drag another
            this.set("selectedItem", selectedItem || this._selectedItem);

            var sourceIndex = this.getItemIndex(this._selectedItem);
            // remove selected item first
            this._data.splice(sourceIndex, 1);

            // insert selectedItem to new index, if new index not exist then set to last index
            var targetIndex = (item ? this.getItemIndex(item) : (this._data.length - 1)) + (before ? 0 : 1);
            this._data.splice(targetIndex, 0, this._selectedItem);

            this.emit("changed");
        },

        updateItemData: function (/*Object*/ item) {
            // summary:
            //      Provides a consistant way to update the model.
            // value: Object
            //      The new data of selected item
            // tags:
            //      private

            var index = this.getItemIndex(this._selectedItem);
            if (index < 0) {
                return;
            }

            var self = this;
            when(self._createItemModel(item), function (model) {
                self._selectedItem = self._data[index] = model;
                self.emit("changed");
            });
        },

        swap: function (/*Object*/sourceIndex, /*Object*/targetIndex) {
            // summary:
            //      Swap 2 items by index
            // sourceIndex: Number
            //      Position (index) of 1st item
            // targetIndex: Number
            //      Position (index) of 2nd item
            // tags:
            //      private

            if (!this._data[sourceIndex] || !this._data[targetIndex]) {
                return false;
            }

            var temp = this._data[sourceIndex];
            this._data[sourceIndex] = this._data[targetIndex];
            this._data[targetIndex] = temp;

            return true;
        },

        getItemIndex: function (/*Object*/item) {
            // summary:
            //      Get item index in the data array
            // item: Object
            //      The item data

            var index = -1;
            if (!item || !(item instanceof this.itemModelClass)) {
                return index;
            }

            this._data.some(function (i, o) {
                if (i.id === item.id) {
                    index = o;
                    return true;
                }

                return false;
            }, this);

            return index;
        },

        _init: function (data) {
            // summary:
            //      Initialize the mode
            // data: Array
            //      The native array data

            var self = this,
                itemDfds;

            this.set("selectedItem", null);

            if (!(data instanceof Array)) {
                this._data = [];
            } else {
                itemDfds = data.map(function (item) {
                    return this._createItemModel(item);
                }, this);

                all(itemDfds).then(function (results) {
                    self._data = results;
                    self.emit("initCompleted");
                });
            }
        },

        _generateItemId: function () {
            // summary:
            //      Create new item identity.
            // tags:
            //      private

            return this._instanceId + "_" + this._autoId++;
        },

        _createItemModel: function (/*Object*/ item) {
            // summary:
            //      Create new link item model
            // item: Object
            //      The object's data to work with.
            // tags:
            //      private

            var modelClass = this.itemModelClass,
                id = { id: this._generateItemId() },
                model,
                dfd = new Deferred();

            // Return item directly if it is mine.
            if (this.getItemIndex(item) >= 0) {
                return item;
            }

            if (item instanceof modelClass) {
                model = lang.mixin(lang.clone(item), id);
            } else {
                model = new modelClass(lang.mixin(lang.clone(item), id));
            }

            when(model.parse(true)).always(function () {
                dfd.resolve(model);
            });

            return dfd;
        },

        _move: function (/*Number*/direction) {
            // summary:
            //      The generic method used for "moveNext" or "movePrevious" methods.
            // direction: Number
            //      Can be "1" or "-1" represent for "next" or "previous" action
            // tags:
            //      private

            var index = this.getItemIndex(this._selectedItem);
            if (index < 0) {
                return false;
            }

            return this.swap(index, index + direction);
        },

        _canMoveNextGetter: function () {
            // summary:
            //      Override the get('canMoveNext') method that used in command

            var index = this.getItemIndex(this._selectedItem);
            return !!(this._selectedItem && index >= 0 && index < (this._data.length - 1));
        },

        _canMovePreviousGetter: function () {
            // summary:
            //      Override the get('canMovePrevious') method that used in command

            var index = this.getItemIndex(this._selectedItem);
            return !!(this._selectedItem && index > 0 && index <= (this._data.length - 1));
        },

        _canEditGetter: function () {
            // summary:
            //      The method used in "canEdit" link item command
            // tags:
            //      public

            return !this.readOnly && !!this._selectedItem;
        },

        _valueGetter: function () {
            // summary:
            //      Override base "get('value')" method to return array of serialized data.
            // tags:
            //      public override

            if (!this._data) {
                return [];
            }

            return this._data.map(function (item) {
                return item.serialize();
            }, this);
        },

        _dataGetter: function () {
            // summary:
            //      Override base "get('data')" method to return array of serialized data.
            // tags:
            //      public override

            return this._data || [];
        },

        _dataSetter: function (data) {
            // summary:
            //      Override base "set('data')" method to init data of this model.
            // tags:
            //      public override

            this._init(data);
        },

        _selectedItemGetter: function () {
            // summary:
            //      Override base "get('selectedItem')" method to return selected item.
            // tags:
            //      public override

            return this._selectedItem;
        },

        _selectedItemSetter: function (value) {
            // summary:
            //      Override base "set('selectedItem')" method to set selected item.
            // tags:
            //      public override

            this._selectedItem = value;
        }
    });
});

},
'epi-cms/contentediting/viewmodel/LinkItemModel':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",                                                                        // used to make a method become asynchronous
    "dojo/when",                                                                            // used to wait an asynchronous request

    // EPi Framework
    "epi/Url",                                                                              // used to build a public url

    // EPi CMS
    "epi-cms/contentediting/viewmodel/CollectionItemModel",                                 // mixed into me
    "epi-cms/core/PermanentLinkHelper"                                                      // used to get content by permanent link

], function (

    // Dojo
    declare,
    lang,
    Deferred,
    when,

    // EPi Framework
    Url,

    // EPi CMS
    CollectionItemModel,
    PermanentLinkHelper

) {

    return declare([CollectionItemModel], {
        // summary:
        //      The link item view model.
        // description:
        //      That supports Customize link item's data
        // tags:
        //      internal

        titleKey: "publicUrl",

        // publicUrl: [public] String
        //      The public url of this item
        publicUrl: null,

        // permanentUrl: [pubilc] String
        //      The permanent url of this item. That prop equal to href prop
        //      If the item parsed from an converted item, should update href prop by this.
        permanentUrl: null,

        // _defaultDataStoreName: [protected virtual] String
        //      Default data store name to get from registry, if store is null.
        _defaultDataStoreName: "epi.cms.content.light",

        serialize: function () {
            // summary:
            //      Serialize data to be accepted by server
            // tags:
            //      public override

            return {
                text: this.text,
                href: this.href || this.url,
                target: this.target || null,
                title: this.title || "",
                publicUrl: this.publicUrl,
                typeIdentifier: this.typeIdentifier || "",
                contentLink: this.contentLink
            };
        },

        _buildPublicUrl: function (/*String*/url) {
            // summary:
            //      The common method used to build full url.
            // tags:
            //      private

            var returnUrl = new Url(url);
            if (!returnUrl.scheme) {
                returnUrl = new Url("", {
                    scheme: window.location.protocol,
                    authority: window.location.hostname,
                    path: url
                });

            }
            return returnUrl.toString();
        },

        _publicUrlGetter: function () {
            // summary:
            //      Customize get method to return correct a public url.
            // tags:
            //      protected override

            return this._buildPublicUrl(this.publicUrl || this.url || this.href);
        },

        _permanentUrlSetter: function (/*String*/value) {
            // summary:
            //      Customize default set method for permanentUrl prop.
            // tags:
            //      protected override

            this.href = this.permanentUrl = value;
        },

        _onTryUpdateItemModel: function () {
            // summary:
            //      Callback method that called when we need updated item's model
            // data: [Object]
            //      The data returned from store
            // tags:
            //      protected override

            // Try get content from href (assumption that href is permanent link)
            if (!this.typeIdentifier || !this.contentLink) {
                return when(PermanentLinkHelper.getContent(this.href), lang.hitch(this, function (content) {
                    if (content) {
                        this._parseFromContent(content);
                    }
                }));
            }
        },

        _parseFromContent: function (content) {
            // summary:
            //      Parse a link item model from contentdata
            // content: [Object]
            //      An structure store content data model
            // tags:
            //      private

            if (content) {
                this.typeIdentifier = content.typeIdentifier;
                this.publicUrl = this._buildPublicUrl(content.publicUrl);
                this.text = this.text || content.name;
                this.contentLink = content.contentLink;
            }
        }
    });
});

},
'epi-cms/contentediting/viewmodel/CollectionItemModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",

    // EPi CMS
    "epi-cms/contentediting/viewmodel/_ViewModelMixin"                                      // mixed into me

], function (
// Dojo
    declare,

    // EPi CMS
    _ViewModelMixin
) {

    return declare([_ViewModelMixin], {
        // summary:
        //      The item view model.
        // description:
        //      That is a base class for all collection item models.
        //      <see cref = "epi-cms/contentediting/viewmodel/LinkItemModel" />
        // tags:
        //    internal

        // id: [public] Number
        //      The identifier of this.
        id: null,

        // nameKey: [public] String
        //      Property name for the text value.
        textKey: "text",

        // titleKey: [public] String
        //      Property name for the title value.
        titleKey: null,

        // iconTypeKey: [public] String
        //      Property name for the IconType value.
        iconTypeKey: "typeIdentifier",

        // typeIdentifier: [public] String
        //      The item's content type.
        typeIdentifier: null,

        serialize: function () {
            // summary:
            //      Serialize data to be accepted by server that should be implemented by deliver class
            // tags:
            //      public abstract
        },

        parse: function (/*Boolean*/ tryUpdateItem) {
            // summary:
            //      User can be dnd some kind of data, so we need an generic method to process allover.
            //      That should be implemented by deliver class
            // tryUpdateItem: [Boolean]
            //      The flag to indicate that should try update item or not.
            // tags:
            //      pubic virtual

            if (tryUpdateItem) {
                return this._onTryUpdateItemModel();
            }

            return null;
        },

        _onTryUpdateItemModel: function () {
            // summary:
            //      Callback method that called when we need updated item's model
            // tags:
            //      protected abstract
        },

        _getPropertyValue: function (/*String*/keyName, /*String*/propName) {
            // summary:
            //      The common method to get property value by key name.
            // tags:
            //      private

            // Avoid recursive loop.
            if (keyName === propName) {
                return this[keyName];
            }
            return this.get(keyName);
        },

        _nameGetter: function () {
            return this._getPropertyValue(this.textKey, "name");
        },

        _textGetter: function () {
            return this._getPropertyValue(this.textKey, "text");
        },

        _titleGetter: function () {
            return this._getPropertyValue(this.titleKey, "title") || this._getPropertyValue(this.textKey, "title");
        },

        _iconTypeIdentifierGetter: function () {
            return this._getPropertyValue(this.iconTypeKey, "iconTypeIdentifier");
        }
    });
});

},
'epi-cms/contentediting/command/ItemCollectionCommands':function(){
﻿define([
    "dojo/_base/declare",
    "./BlockRemove",
    "./ItemEdit",
    "./MoveToPrevious",
    "./MoveToNext",
    "./ContentAreaCommands"
], function (declare, Remove, Edit, MoveToPrevious, MoveToNext, ContentAreaCommands) {

    return declare([ContentAreaCommands], {
        // summary:
        //      The commands for context menu of editor,
        //      and use as class for commandProviderClass
        // description:
        //      That include:
        //          - Edit command
        //          - Move previous command
        //          - Move next command
        //          - Remove command
        // tags:
        //      internal

        constructor: function (/*Object*/options) {
            // summary:
            //      Overwrite base class
            // tags:
            //      protected

            var commandOptions = options ? options.commandOptions : {};
            this.commands = [
                new Edit(Object.assign({}, commandOptions, { category: "menuWithSeparator" })),
                new MoveToPrevious(commandOptions),
                new MoveToNext(Object.assign({}, commandOptions, { category: "menuWithSeparator" })),
                new Remove(commandOptions)
            ];
        }
    });
});

},
'epi-cms/contentediting/command/ItemEdit':function(){
﻿define([
// Dojo
    "dojo/_base/declare",

    // EPi CMS
    "epi-cms/contentediting/command/BlockEdit",                                     // mixed into me
    "epi-cms/contentediting/command/_CommandWithDialogMixin",                       // mixed into me
    "epi-cms/widget/LinkEditor"
], function (
// Dojo
    declare,

    // EPi CMS
    BlockEdit,
    _CommandWithDialogMixin,
    LinkEditor
) {

    return declare([BlockEdit, _CommandWithDialogMixin], {
        // tags:
        //      internal

        // dialogContentClass: [public] Class
        //      The widget class that will be created and placed as dialog's content
        dialogContentClass: LinkEditor,

        // dialogContentParams: [public] Object
        //      The parameters for create new instance of dialogContentClass.
        dialogContentParams: null,

        // defaultActionsVisible: [public] Bool
        //      .Flag which indicates whether the default confirm and cancel
        //		actions should be visible. This can only be set in the constructor.
        defaultActionsVisible: false,

        _execute: function () {
            // summary:
            //      Overwrite base clase, change the context to edit the block.
            // tags:
            //      protected

            this.showDialog();
        },

        _onModelValueChange: function () {
            // summary:
            //      Overwrite base class, updates canExecute after the model value has changed.
            // tags:
            //      protected

            if (!this.model) {
                this.set("canExecute", false);
                return;
            }

            this.set("value", this.model.get("selectedItem"));
            this.set("canExecute", this.model.get("canEdit"));
        },

        onDialogExecute: function (/*Object*/actionParams) {
            // summary:
            //      Process value returned from dialog after it's executed.
            // action: [String]
            //      Which action corespondent with? ("ok" or "delete")
            //      See "epi-cms/widget/LinkEditor" module for more detail.
            // tags:
            //      protected override

            this.inherited(arguments);

            if (this.dialogContent) {
                this.value = this.dialogContent.get("value");
            }

            if (this.model) {
                if (actionParams && actionParams.action === "delete") {
                    this.model.remove();
                } else {
                    this.model.updateItemData(this.value);
                }
            }
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/ItemCollectionEditor.html':"﻿<div class=\"dijitInline\" tabindex=\"-1\" role=\"presentation\">\r\n    <!-- To reuse styling of content area we wrap into a div that include content area class -->\r\n    <div class=\"epi-content-area-editor\" data-dojo-attach-point=\"container\">\r\n        <div data-dojo-attach-point=\"itemsContainer\"></div>\r\n        <div data-dojo-attach-point=\"actionsContainer\" class=\"epi-content-area-actionscontainer\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/editors/PreviewableDateTimeEditor':function(){
﻿define([
    "dojo/_base/declare",

    "epi/datetime",
    "epi/shell/widget/DateTimeSelectorDropDown",
    "epi-cms/contentediting/editors/_PreviewableEditor"

], function (
    declare,

    epiDate,
    DateTimeSelectorDropDown,
    _PreviewableEditor
) {
    return declare([_PreviewableEditor], {
        // tags:
        //      internal

        required: false,

        // controlParams: Array
        //      Properties to copy from this widget into the wrapped control
        controlParams: ["required"],

        buildRendering: function () {
            this.control = new DateTimeSelectorDropDown({ datePackage: null });
            this.inherited(arguments);
        },

        _setLabelValueAttr: function (value) {
            // summary:
            //      Overridden to format the displayed date in a user friendly way

            this.inherited(arguments, [epiDate.toUserFriendlyHtml(value)]);
        },

        _setValueAttr: function (value) {
            if (value && value instanceof Date) {
                value = new Date(value.getFullYear(), value.getMonth(), value.getDate(), value.getHours(), value.getMinutes());
            }
            this.inherited(arguments, [value]);
        }
    });
});

},
'epi-cms/contentediting/editors/_PreviewableEditor':function(){
define([
    "dojo/_base/array",
    "dojo/_base/event",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",

    "dijit",
    "dijit/_CssStateMixin",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/ValidationTextBox",

    "epi",

    "dojo/text!./templates/_PreviewableEditor.html",
    "dojox/html/entities"

], function (
    array,
    event,
    declare,
    lang,
    domClass,
    domStyle,

    dijit,
    _CssStateMixin,
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    ValidationTextBox,

    epi,

    template,
    entities
) {

    return declare([_Widget, _CssStateMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // tags:
        //      public

        value: null,

        changeLabel: epi.resources.action.change,

        templateString: template,

        control: null,

        // controlParams: Array
        //      Properties to copy from this widget into the wrapped control
        controlParams: [],

        // state: [readonly] String
        //		Shows current state (ie, validation result) of input (""=Normal, Incomplete, or Error).
        state: "",

        _setLabelValueAttr: function (value) {
            // summary:
            //      Sets the value to the innerHTML of the label node

            this._set("labelValue", value);
            if (this._isHtml(value)) {
                this.labelNode.innerHTML = value;
            } else {
                this.labelNode.title = value;
                this.labelNode.textContent = value;
            }
        },

        _setIsEmptyAttr: function (isEmpty) {
            this._set("isEmpty", isEmpty);
            if (isEmpty) {
                domClass.add(this.domNode, "epi-state-empty");
            } else {
                domClass.remove(this.domNode, "epi-state-empty");
            }
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            this.control.set("value", value);
            this.set("labelValue", typeof (value) == "string" ? entities.encode(value) : value);
            this.set("isEmpty", !value);
        },

        onChange: function (val) {

        },

        buildRendering: function () {
            this.inherited(arguments);

            // Create default TextBox for input Node
            if (!this.control) {
                this.control = new ValidationTextBox();
                this.own(this.control);
            }

            this.control.placeAt(this.domNode, "first");
        },

        postCreate: function () {
            this.inherited(arguments);

            this._setDisplay(false);

            // connect events
            this.connect(this.labelNode, "onclick", this._onChangeNodeClick);
            this.connect(this.changeNode, "onclick", this._onChangeNodeClick);
            this.connect(this.control, "onChange", this._onControlChange);
            this.connect(this.control, "onBlur", this._onControlBlur);

            // always copy state value from control
            this.own(this.control.watch("state", lang.hitch(this, function (name, old, value) {
                this.set("state", value);
            })));

            // validate first time
            this.control.validate();

            this.set("state", this.control.state);

            // propagate value from this to the textbox
            array.forEach(this.controlParams, function (property) {
                this.control.set(property, this.get(property));
            }, this);
        },

        onBlur: function () {
            this._setDisplay(false);
        },

        _setDisplay: function (showControl) {
            // Validation input data before hidden textbox
            if (!showControl && !this.validate()) {
                return;
            }

            this.showControl = showControl;
            domStyle.set(this.labelNode, "display", showControl ? "none" : "");
            domStyle.set(this.control.domNode, "display", showControl ? "" : "none");

            if (!this.readOnly) {
                domStyle.set(this.changeNode, "display", showControl ? "none" : "");
            }
        },

        focus: function () {
            if (this.showControl) {
                this.control.focus();
            } else {
                this.changeNode.focus();
            }
        },

        _onControlChange: function (value) {
            this._set("value", value);
            this.set("labelValue", typeof (value) == "string" ? entities.encode(value) : value);
            this.set("isEmpty", !value);
            this.onChange(value);
        },

        _onControlBlur: function () {
            this._setDisplay(false);
        },

        _onChangeNodeClick: function (e) {
            event.stop(e);
            this._setDisplay(true && !this.readOnly);
            dijit.selectInputText(this.control.focusNode);
        },

        _setReadOnlyAttr: function (readOnly) {
            this._set("readOnly", readOnly);

            domStyle.set(this.changeNode, "display", this.readOnly ? "none" : "");
            this.readOnly && this._setDisplay(false);
        },

        validate: function () {
            return this.control.validate();
        },

        isValid: function () {
            return this.control.isValid();
        },

        getErrorMessage: function () {
            // summary:
            //      Get error message from the control
            // tags:
            //      public

            return this.control.getErrorMessage();
        },

        _isHtml: function (text) {
            // summary:
            //      Checks whether string is an HTML string
            // tags:
            //      private

            return text !== entities.encode(text);
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/_PreviewableEditor.html':"﻿<div class=\"dijitReset dijitInline epi-previewableTextBox-wrapper\">\r\n    <span data-dojo-attach-point=\"labelNode\" class=\"epi-previewableTextBox-text dojoxEllipsis dijitInline\"></span>\r\n    <a href=\"#\" data-dojo-attach-point=\"changeNode, focusNode\" class=\"epi-previewableTextBox-link epi-functionLink\">${changeLabel}</a>\r\n</div>\r\n",
'epi-cms/contentediting/editors/PreviewableTextEditor':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dom-construct",

    "dijit/form/ValidationTextBox",
    "epi-cms/contentediting/editors/_PreviewableEditor"
], function (
    array,
    declare,
    domConstruct,

    ValidationTextBox,
    _PreviewableEditor
) {
    return declare([_PreviewableEditor], {
        // tags:
        //      internal

        required: false,

        intermediateChanges: false,

        // controlParams: Array
        //      Properties to copy from this widget into the wrapped control
        controlParams: ["intermediateChanges", "regExp", "required", "invalidMessage"],

        _getRegExpAttr: function () {
            return this.regExp || "";
        }
    });
});

},
'epi-cms/contentediting/editors/RangeNumberEditor':function(){
define([
    "dojo/_base/declare",
    "dijit/form/NumberSpinner"
], function (declare, NumberSpinner) {

    return declare([NumberSpinner], {
        // tags:
        //      internal

        adjust: function (/*Object*/ val, /*Number*/ delta) {
            var tc = this.constraints,
                v = isNaN(val),
                gotMax = !isNaN(tc.max),
                gotMin = !isNaN(tc.min);

            if (v && gotMax && gotMin && tc.max >= 0 && tc.min <= 0) {
                return 0;
            } else {
                return this.inherited(arguments);
            }
        }
    });
});

},
'epi-cms/contentediting/editors/ShortcutEditor':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",

    // dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Button",

    //epi cms
    "epi", //Used for the manage button label
    "epi/shell/DialogService",
    "epi-cms/contentediting/ShortcutDialog",
    "../viewmodel/ShortcutDialogViewModel",
    "../../widget/_HasChildDialogMixin",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.shortcutblockeditor",
    "epi/i18n!epi/nls/episerver.shared"

], function (
    // dojo
    declare,
    lang,
    domClass,
    domStyle,

    //dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    Button,

    //epi cms
    epi,
    dialogService,
    ShortcutDialog,
    ShortcutDialogViewModel,
    _HasChildDialogMixin,
    resources,
    sharedResources) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _HasChildDialogMixin], {
        // tags:
        //      internal

        templateString: "<div class=\"dijitInline\"> \
                           <span data-dojo-attach-point=\"shortcutTypeNameNode\" class=\"epi-previewableTextBox-text dijitInline\"></span> <div class=\"epi-chromelessButton epi-chromelessLinkButton epi-functionLink\" data-dojo-attach-point=\"button\" data-dojo-type=\"dijit/form/Button\" data-dojo-attach-event=\"onClick:_showDialog\" >${resources.action.manage}</div> \
                         </div>",

        resources: epi.resources,
        value: null,
        contentLink: null,
        metadata: null,

        destroy: function () {
            if (this.button) {
                this.button.destroyRecursive();
            }

            this.inherited(arguments);
        },

        onChange: function (value) {
            // summary:
            //		Callback method for updating the editor wrapper.
            // tags:
            //		callback
        },

        _showDialog: function () {
            var content = new ShortcutDialog({
                metadata: this.metadata,
                contentLink: this.contentLink,
                value: this.value,
                model: new ShortcutDialogViewModel({
                    contentLink: this.contentLink,
                    contentName: this.contentName,
                    value: this.value
                })
            });

            dialogService.dialog({
                defaultActionsVisible: false,
                confirmActionText: sharedResources.action.save,
                content: content,
                title: resources.dialogtitle,
                dialogClass: "epi-dialog-portrait epi-dialog--wide"
            }).then(function () {
                var value = content.get("value");
                this.set("value", value);
                this.onChange(value);
            }.bind(this)).always(function () {
                this.isShowingChildDialog = false;
            }.bind(this));

            this.isShowingChildDialog = true;
        },

        _setShortcutTypeNameAttr: {
            node: "shortcutTypeNameNode",
            type: "innerHTML"
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            domStyle.set(this.button.domNode, "display", value ? "none" : "");
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            this.set("ShortcutTypeName", value && value.pageShortcutTypeName ? value.pageShortcutTypeName : "");
        }
    });
});

},
'epi-cms/contentediting/ShortcutDialog':function(){
define([

    // Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/html",

    // Dijit
    "dijit/_CssStateMixin",

    //Dojox
    "dojox/validate/regexp",

    // EPi CMS
    "epi-cms/widget/Breadcrumb",
    "epi-cms/contentediting/PageShortcutTypeSupport",

    // EPi Framework
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/shell/widget/FormContainer",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/_ActionProviderWidget",

    // Template
    "dojo/text!./templates/ShortcutDialog.html",

    // Resources
    "epi/i18n!epi/nls/episerver.shared"
],
function (

    // Dojo
    declare,
    lang,
    domStyle,
    domClass,
    html,

    // Dijit
    _CssStateMixin,

    //Dojox
    regexp,

    // EPi CMS
    Breadcrumb,
    PageShortcutTypeSupport,

    // EPi Framework
    _DialogContentMixin,
    FormContainer,
    _ModelBindingMixin,
    _ActionProviderWidget,

    // Template
    template,

    // Resources
    sharedResources) {

    return declare([FormContainer, _ActionProviderWidget, _DialogContentMixin, _CssStateMixin, _ModelBindingMixin], {
        // summary:
        //      Dialog used to modify edit content shortcuts
        // tags:
        //      internal

        // templateString: String
        //      The template of widget
        templateString: template,

        // contentLink: String
        //      The content link id
        contentLink: null,

        // contentName: String
        //      The content name
        contentName: null,

        baseClass: "epi-statusIndicator",

        // _externalLinkWidget: Object
        //      The external link widget
        _externalLinkWidget: null,

        // _shortcutLinkWidget: Object
        //      The shortcut link widget
        _shortcutLinkWidget: null,

        // _shortcutTypeWidget: Object
        //      The shortcut type widget
        _shortcutTypeWidget: null,

        // _targetFrameWidget: Object
        //      The target frame widget
        _targetFrameWidget: null,

        //  _switchLinkTypeFirstRunDone: Boolean
        //     Indicate whether we ever have chosen the external link
        _switchLinkTypeFirstRunDone: false,

        modelBindingMap: {
            contentLink: ["contentLink"],
            contentName: ["contentName"],
            enableSaveButton: ["enableSaveButton"],
            enableShortcutLink: ["enableShortcutLink"],
            enableExternalLink: ["enableExternalLink"],
            clearExternalLink: ["clearExternalLink"],
            enableOpenIn: ["enableOpenIn"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            // This form container is used inside a dialog without any size constraints because the dialog allow its content to overflow.
            // Therefore, we should not layout the form's top layout container.
            this.doLayout = false;
        },

        _setContentLinkAttr: function (value) {
            this.breadcrumb.set("contentLink", value);
        },

        _setContentNameAttr: {
            node: "contentNameNode",
            type: "innerText"
        },

        _setEnableSaveButtonAttr: function (value) {
            // summary
            //      Disable/Enable save button
            // tag
            //      Private

            if (this._actions && this._actions.length) {
                this.setActionProperty("save", "disabled", !value);
            }
        },

        _setEnableShortcutLinkAttr: function (value) {
            // Summary
            //      Disable/Enable validation of shortcut link
            //      Reset state of widget
            //      Show/hide shortcut link widget
            // value: Boolean
            //      If this is true, shortcut link  will be show, enable validation, otherwise it hidden
            // tag
            //      Private

            if (this._shortcutLinkWidget) {
                this._shortcutLinkWidget.set("required", value);
                // Set state of textbox to normal
                this._shortcutLinkWidget.set("state", "");
                var formRowNode = this._getAncestorNode(this._shortcutLinkWidget.domNode, "epi-form-container__section__row");
                if (formRowNode) {
                    domStyle.set(formRowNode, "display", value ? "" : "none");
                }
            }
        },

        _setEnableExternalLinkAttr: function (value) {
            // Summary
            //      Disable/Enable validation of textbox
            //      Reset state of textbox
            //      Show/hide external link widget
            // value: Boolean
            //      If this is true, external link will be show, enable validation, otherwise it hidden
            // tag
            //      Private

            if (this._externalLinkWidget) {
                this._externalLinkWidget.set("required", value);
                this._externalLinkWidget.set("disabled", !value);
                // Set state of textbox to normal
                this._externalLinkWidget._set("state", "");

                var formRowNode = this._getAncestorNode(this._externalLinkWidget.domNode, "epi-form-container__section__row");
                if (formRowNode) {
                    domStyle.set(formRowNode, "display", value ? "" : "none");
                }
            }
        },

        _setEnableOpenInAttr: function (value) {
            if (this._targetFrameWidget) {

                var formRowNode = this._getAncestorNode(this._targetFrameWidget.domNode, "epi-form-container__section__row");
                if (formRowNode) {
                    domStyle.set(formRowNode, "display", value ? "" : "none");
                }
            }
        },

        _getAncestorNode: function (node, classAttr) {
            // Summary
            //      Get ancestor node which has class classAttr
            // node: DomNode
            //      The domNode which need to get ancestor.
            // classAttr: String
            //      The class attribute.
            // tag
            //      Private

            var parentNode = node ? node.parentNode : null;
            if (!parentNode) {
                return null;
            }

            if (!domClass.contains(parentNode, classAttr)) {
                return this._getAncestorNode(parentNode, classAttr);
            }

            return parentNode;
        },

        _setClearExternalLinkAttr: function (value) {
            // summary
            //      Clear text and reset state of external link textbox
            //  tag
            //      Private

            if (this._externalLinkWidget && value && !this._switchLinkTypeFirstRunDone) {
                // We need to clear the input textbox for external link the first time we chose external link.
                // If the page is saved with external link chosen however, we do not wish to clear the input textbox.
                this._externalLinkWidget.reset();
                this._switchLinkTypeFirstRunDone = true;
            }
        },

        onFieldCreated: function (fieldName, widget) {
            // summary:
            //     Raised when a field editor widget is created.
            // description:
            //     Override the FormContainer method to catch and keep reference to externalLink, shortcutLink and shortcutType widget
            // fieldName: String
            //     The field name
            // widget: dijit/_Widget
            //     The widget
            // tags:
            //     callback

            switch (fieldName) {
                case "pageLinkURL":
                    this._externalLinkWidget = widget;
                    this.connect(this._externalLinkWidget.domNode, "onkeyup", lang.hitch(this, function (evt) {
                        // Enable save button when user start typing
                        this.model.set("enableSaveButton", true);
                    }));
                    break;

                case "contentShortcutLink":
                    this._shortcutLinkWidget = widget;
                    this._shortcutLinkWidget.set("contentLink", this.model.get("contentLink"));
                    break;

                case "pageShortcutType":
                    this._shortcutTypeWidget = widget;
                    break;

                case "pageTargetFrame":
                    this._targetFrameWidget = widget;
                    break;

                default:
                    break;
            }
        },

        onChange: function (value) {
            this.inherited(arguments);
            this.model.set("intermediateValue", lang.mixin(value, { pageShortcutTypeName: this._shortcutTypeWidget ? this._shortcutTypeWidget.get("displayedValue") : "" }));

            var shortCutType = this._shortcutTypeWidget && this._shortcutTypeWidget.get("value");

            // The same content link should not be able to set as short cut link
            if (shortCutType === PageShortcutTypeSupport.pageShortcutTypes.Shortcut) {
                this._shortcutLinkWidget && this._shortcutLinkWidget.set("canSelectOwnerContent", false);
            }
        },

        _getValueAttr: function () {
            //We need to override getValue because the FormContainer returns the values in the form
            //But this dialog values that is not visible in the form

            return this.model.get("intermediateValue");
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget
            //
            // returns:
            //      An array contining a select page action definition, if it is not a shared block

            this._actions = [
                {
                    name: "cancel",
                    label: sharedResources.action.cancel,
                    settings: { type: "button", "class": "epi-plain-button" },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                },
                {
                    name: "save",
                    label: sharedResources.action.save,
                    settings: { type: "button", disabled: true, "class": "Salt" },
                    action: lang.hitch(this, function () {
                        if (this.validate()) {
                            this.executeDialog();
                        } else {
                            this.model.set("enableSaveButton", false);
                        }
                    })
                }
            ];

            return this._actions;
        }
    });
});

},
'dojox/validate/regexp':function(){
define("dojox/validate/regexp", ["dojo/_base/lang", "dojo/regexp", "dojox/main"], 
  function(lang, regexp, dojox){

var dxregexp = lang.getObject("validate.regexp", true, dojox);
dxregexp = dojox.validate.regexp = {
	
	ipAddress: function(flags){
		// summary:
		//		Builds a RE that matches an IP Address
		// description:
		//		Supports 5 formats for IPv4: dotted decimal, dotted hex, dotted octal, decimal and hexadecimal.
		//		Supports 2 formats for Ipv6.
		// flags: Object?
		//		All flags are boolean with default = true.
		//
		//		- flags.allowDottedDecimal  Example, 207.142.131.235.  No zero padding.
		//		- flags.allowDottedHex  Example, 0x18.0x11.0x9b.0x28.  Case insensitive.  Zero padding allowed.
		//		- flags.allowDottedOctal  Example, 0030.0021.0233.0050.  Zero padding allowed.
		//		- flags.allowDecimal  Example, 3482223595.  A decimal number between 0-4294967295.
		//		- flags.allowHex  Example, 0xCF8E83EB.  Hexadecimal number between 0x0-0xFFFFFFFF.
		//		  Case insensitive.  Zero padding allowed.
		//		- flags.allowIPv6   IPv6 address written as eight groups of four hexadecimal digits.
		
		//	FIXME: ipv6 can be written multiple ways IIRC
		//		- flags.allowHybrid   IPv6 address written as six groups of four hexadecimal digits
		//		-   followed by the usual 4 dotted decimal digit notation of IPv4. x:x:x:x:x:x:d.d.d.d

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if(typeof flags.allowDottedDecimal != "boolean"){ flags.allowDottedDecimal = true; }
		if(typeof flags.allowDottedHex != "boolean"){ flags.allowDottedHex = true; }
		if(typeof flags.allowDottedOctal != "boolean"){ flags.allowDottedOctal = true; }
		if(typeof flags.allowDecimal != "boolean"){ flags.allowDecimal = true; }
		if(typeof flags.allowHex != "boolean"){ flags.allowHex = true; }
		if(typeof flags.allowIPv6 != "boolean"){ flags.allowIPv6 = true; }
		if(typeof flags.allowHybrid != "boolean"){ flags.allowHybrid = true; }

		// decimal-dotted IP address RE.
		var dottedDecimalRE =
			// Each number is between 0-255.  Zero padding is not allowed.
			"((\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])\\.){3}(\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])";

		// dotted hex IP address RE.  Each number is between 0x0-0xff.  Zero padding is allowed, e.g. 0x00.
		var dottedHexRE = "(0[xX]0*[\\da-fA-F]?[\\da-fA-F]\\.){3}0[xX]0*[\\da-fA-F]?[\\da-fA-F]";

		// dotted octal IP address RE.  Each number is between 0000-0377.
		// Zero padding is allowed, but each number must have at least 4 characters.
		var dottedOctalRE = "(0+[0-3][0-7][0-7]\\.){3}0+[0-3][0-7][0-7]";

		// decimal IP address RE.  A decimal number between 0-4294967295.
		var decimalRE =  "(0|[1-9]\\d{0,8}|[1-3]\\d{9}|4[01]\\d{8}|42[0-8]\\d{7}|429[0-3]\\d{6}|" +
			"4294[0-8]\\d{5}|42949[0-5]\\d{4}|429496[0-6]\\d{3}|4294967[01]\\d{2}|42949672[0-8]\\d|429496729[0-5])";

		// hexadecimal IP address RE.
		// A hexadecimal number between 0x0-0xFFFFFFFF. Case insensitive.  Zero padding is allowed.
		var hexRE = "0[xX]0*[\\da-fA-F]{1,8}";

		// IPv6 address RE.
		// The format is written as eight groups of four hexadecimal digits, x:x:x:x:x:x:x:x,
		// where x is between 0000-ffff. Zero padding is optional. Case insensitive.
		var ipv6RE = "([\\da-fA-F]{1,4}\\:){7}[\\da-fA-F]{1,4}";

		// IPv6/IPv4 Hybrid address RE.
		// The format is written as six groups of four hexadecimal digits,
		// followed by the 4 dotted decimal IPv4 format. x:x:x:x:x:x:d.d.d.d
		var hybridRE = "([\\da-fA-F]{1,4}\\:){6}" +
			"((\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])\\.){3}(\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])";

		// Build IP Address RE
		var a = [];
		if(flags.allowDottedDecimal){ a.push(dottedDecimalRE); }
		if(flags.allowDottedHex){ a.push(dottedHexRE); }
		if(flags.allowDottedOctal){ a.push(dottedOctalRE); }
		if(flags.allowDecimal){ a.push(decimalRE); }
		if(flags.allowHex){ a.push(hexRE); }
		if(flags.allowIPv6){ a.push(ipv6RE); }
		if(flags.allowHybrid){ a.push(hybridRE); }

		var ipAddressRE = "";
		if(a.length > 0){
			ipAddressRE = "(" + a.join("|") + ")";
		}
		return ipAddressRE; // String
	},

	host: function(flags){
		// summary:
		//		Builds a RE that matches a host
		// description:
		//		A host is a named host (A-z0-9_- but not starting with -), a domain name or an IP address, possibly followed by a port number.
		// flags: Object?
		//		- flags.allowNamed Allow a named host for local networks. Default is false.
		//		- flags.allowIP  Allow an IP address for hostname.  Default is true.
		//		- flags.allowLocal  Allow the host to be "localhost".  Default is false.
		//		- flags.allowPort  Allow a port number to be present.  Default is true.
		//		- flags in regexp.ipAddress can be applied.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};

		if(typeof flags.allowIP != "boolean"){ flags.allowIP = true; }
		if(typeof flags.allowLocal != "boolean"){ flags.allowLocal = false; }
		if(typeof flags.allowPort != "boolean"){ flags.allowPort = true; }
		if(typeof flags.allowNamed != "boolean"){ flags.allowNamed = false; }

		//TODO: support unicode hostnames?
		// Domain name labels can not end with a dash.
		var domainLabelRE = "(?:[\\da-zA-Z](?:[-\\da-zA-Z]{0,61}[\\da-zA-Z])?)";
		var domainNameRE = "(?:[a-zA-Z](?:[-\\da-zA-Z]{0,6}[\\da-zA-Z])?)"; // restricted version to allow backwards compatibility with allowLocal, allowIP

		// port number RE
		var portRE = flags.allowPort ? "(\\:\\d+)?" : "";

		// build host RE
		var hostNameRE = "((?:" + domainLabelRE + "\\.)+" + domainNameRE + "\\.?)";
		if(flags.allowIP){ hostNameRE += "|" +  dxregexp.ipAddress(flags); }
		if(flags.allowLocal){ hostNameRE += "|localhost"; }
		if(flags.allowNamed){ hostNameRE += "|^[^-][a-zA-Z0-9_-]*"; }
		return "(" + hostNameRE + ")" + portRE; // String

	},

	url: function(flags){
		// summary:
		//		Builds a regular expression that matches a URL
		// flags: Object?
		//		- flags.scheme  Can be true, false, or [true, false].
		//		-   This means: required, not allowed, or match either one.
		//		- flags in regexp.host can be applied.
		//		- flags in regexp.ipAddress can be applied.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if(!("scheme" in flags)){ flags.scheme = [true, false]; }

		// Scheme RE
		var protocolRE = regexp.buildGroupRE(flags.scheme,
			function(q){ if(q){ return "(https?|ftps?)\\://"; } return ""; }
		);

		// Path and query and anchor RE
		var pathRE = "(/(?:[^?#\\s/]+/)*(?:[^?#\\s/]+(?:\\?[^?#\\s/]*)?(?:#[A-Za-z][\\w.:-]*)?)?)?";

		return protocolRE + dxregexp.host(flags) + pathRE;
	},

	emailAddress: function(flags){
		// summary:
		//		Builds a regular expression that matches an email address
		// flags: Object?
		//		- flags.allowCruft  Allow address like `<mailto:foo@yahoo.com>`.  Default is false.
		//		- flags in regexp.host can be applied.
		//		- flags in regexp.ipAddress can be applied.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if (typeof flags.allowCruft != "boolean") { flags.allowCruft = false; }
		flags.allowPort = false; // invalid in email addresses

		// user name RE per rfc5322
		var usernameRE = "([!#-'*+\\-\\/-9=?A-Z^-~]+[.])*[!#-'*+\\-\\/-9=?A-Z^-~]+";

		// build emailAddress RE
		var emailAddressRE = usernameRE + "@" + dxregexp.host(flags);

		// Allow email addresses with cruft
		if ( flags.allowCruft ) {
			emailAddressRE = "<?(mailto\\:)?" + emailAddressRE + ">?";
		}

		return emailAddressRE; // String
	},

	emailAddressList: function(flags){
		// summary:
		//		Builds a regular expression that matches a list of email addresses.
		// flags: Object?
		//		- flags.listSeparator  The character used to separate email addresses.  Default is ";", ",", "\n" or " ".
		//		- flags in regexp.emailAddress can be applied.
		//		- flags in regexp.host can be applied.
		//		- flags in regexp.ipAddress can be applied.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if(typeof flags.listSeparator != "string"){ flags.listSeparator = "\\s;,"; }

		// build a RE for an Email Address List
		var emailAddressRE = dxregexp.emailAddress(flags);
		var emailAddressListRE = "(" + emailAddressRE + "\\s*[" + flags.listSeparator + "]\\s*)*" +
			emailAddressRE + "\\s*[" + flags.listSeparator + "]?\\s*";

		return emailAddressListRE; // String
	},
	
	numberFormat: function(flags){
		// summary:
		//		Builds a regular expression to match any sort of number based format
		// description:
		//		Use this method for phone numbers, social security numbers, zip-codes, etc.
		//		The RE can match one format or one of multiple formats.
		//
		//		Format:
		//
		//		- #        Stands for a digit, 0-9.
		//		- ?        Stands for an optional digit, 0-9 or nothing.
		//		- All other characters must appear literally in the expression.
		//
		// example:
		//		- "(###) ###-####"		-    ->   (510) 542-9742
		//		- "(###) ###-#### x#???" ->   (510) 542-9742 x153
		//		- "###-##-####"		- 		-   ->   506-82-1089		-    i.e. social security number
		//		- "#####-####"		- 		-    ->   98225-1649		- 		- i.e. zip code
		//
		// flags:  Object?
		//		- flags.format  A string or an Array of strings for multiple formats.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if(typeof flags.format == "undefined"){ flags.format = "###-###-####"; }

		// Converts a number format to RE.
		var digitRE = function(format){
			// escape all special characters, except '?'
			return regexp.escapeString(format, "?")
				// Now replace '?' with Regular Expression
				.replace(/\?/g, "\\d?")
				// replace # with Regular Expression
				.replace(/#/g, "\\d")
			;
		};

		// build RE for multiple number formats
		return regexp.buildGroupRE(flags.format, digitRE); //String
	},
	
	ca: {

		postalCode: function(){
			// summary:
			//		String regular Express to match Canadain Postal Codes
			return "([A-Z][0-9][A-Z] [0-9][A-Z][0-9])";
		},

		province: function(){
			// summary:
			//		a regular expression to match Canadian Province Abbreviations
			return "(AB|BC|MB|NB|NL|NS|NT|NU|ON|PE|QC|SK|YT)";
		}

	},
	
	us:{
		state: function(flags){
			// summary:
			//		A regular expression to match US state and territory abbreviations
			// flags: Object?
			//		- flags.allowTerritories  Allow Guam, Puerto Rico, etc.  Default is true.
			//		- flags.allowMilitary  Allow military 'states', e.g. Armed Forces Europe (AE).  Default is true.

			// assign default values to missing parameters
			flags = (typeof flags == "object") ? flags : {};
			if(typeof flags.allowTerritories != "boolean"){ flags.allowTerritories = true; }
			if(typeof flags.allowMilitary != "boolean"){ flags.allowMilitary = true; }

			// state RE
			var statesRE =
				"AL|AK|AZ|AR|CA|CO|CT|DE|DC|FL|GA|HI|ID|IL|IN|IA|KS|KY|LA|ME|MD|MA|MI|MN|MS|MO|MT|" +
				"NE|NV|NH|NJ|NM|NY|NC|ND|OH|OK|OR|PA|RI|SC|SD|TN|TX|UT|VT|VA|WA|WV|WI|WY";

			// territories RE
			var territoriesRE = "AS|FM|GU|MH|MP|PW|PR|VI";

			// military states RE
			var militaryRE = "AA|AE|AP";

			// Build states and territories RE
			if(flags.allowTerritories){ statesRE += "|" + territoriesRE; }
			if(flags.allowMilitary){ statesRE += "|" + militaryRE; }

			return "(" + statesRE + ")"; // String
		}

	}
	
};

return dxregexp;

});

},
'dojox/main':function(){
define("dojox/main", ["dojo/_base/kernel"], function(dojo) {
	// module:
	//		dojox/main

	/*=====
	return {
		// summary:
		//		The dojox package main module; dojox package is somewhat unusual in that the main module currently just provides an empty object.
		//		Apps should require modules from the dojox packages directly, rather than loading this module.
	};
	=====*/

	return dojo.dojox;
});
},
'url:epi-cms/contentediting/templates/ShortcutDialog.html':"﻿<div class=\"epi-form-container\">\r\n    <div data-dojo-type=\"epi-cms/widget/Breadcrumb\" data-dojo-attach-point=\"breadcrumb\" data-dojo-props=\"showCurrentNode: false\"></div>\r\n    <h1 data-dojo-attach-point=\"contentNameNode\" class=\"epi-breadCrumbsCurrentItem dijitInline dojoxEllipsis\"></h1>\r\n    <div data-dojo-type=\"dijit/form/Form\" data-dojo-attach-point=\"form\"></div>\r\n</div>",
'epi-cms/contentediting/viewmodel/ShortcutDialogViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/string",

    //EPi
    "epi-cms/contentediting/PageShortcutTypeSupport",
    "epi/epi"
],

function (
// Dojo
    declare,
    Stateful,
    dojoString,

    // EPi
    PageShortcutTypeSupport,
    epi
) {

    return declare([Stateful], {
        // summary:
        //      View model used by epi-cms/contentediting/ShortcutDialog
        // tags:
        //      internal

        // value: [public] Object
        //      The value
        value: null,

        // intermediateValue: [public] Object
        //      Changes to the model are stored on this property
        intermediateValue: null,

        // savedValue: [public] Object
        //      Initial value
        savedValue: null,

        // contentLink: [public] String
        //      The content link id
        contentLink: null,

        // contentName: [public] String
        //      The name for the content
        contentName: null,

        // enableSaveButton: [public] Boolean
        //      Determines if the save button should be enabled
        enableSaveButton: null,

        // enableShortcutLink: [public] Boolean
        //      Determines if should be possible to set the shortcut link
        enableShortcutLink: null,

        // enableExternalLink: [public] Boolean
        //      Determines if should be possible to set an external link
        enableExternalLink: null,

        // enableOpenIn: [public] Boolean
        //      Determines if should be possible to select the target frame for a link
        enableOpenIn: true,

        postscript: function () {
            this.inherited(arguments);

            this.set("savedValue", this.value);
        },

        _intermediateValueSetter: function (value) {
            // summary:
            //  Set the intermediate value for the model
            // tags:
            //      public

            this.intermediateValue = value;
            this.set("enableSaveButton", !epi.areEqual(this.intermediateValue, this.savedValue));
            this.set("enableShortcutLink", value && (value.pageShortcutType === PageShortcutTypeSupport.pageShortcutTypes.Shortcut || value.pageShortcutType === PageShortcutTypeSupport.pageShortcutTypes.FetchData) ? true : false);
            this.set("enableExternalLink", value && value.pageShortcutType === PageShortcutTypeSupport.pageShortcutTypes.External ? true : false);
            this.set("clearExternalLink", value && value.pageShortcutType === PageShortcutTypeSupport.pageShortcutTypes.External && this.savedValue.pageShortcutType !== PageShortcutTypeSupport.pageShortcutTypes.External ? true : false);
            this.set("enableOpenIn", value && value.pageShortcutType !== PageShortcutTypeSupport.pageShortcutTypes.Inactive);
        },

        _savedValueSetter: function (value) {
            // summary:
            //      Sets the saved value
            // tags:
            //      public

            this.savedValue = value;
            this.set("enableSaveButton", false);
        },

        save: function () {
            // summary:
            //      Stores the value in the 'savedValue' property
            // tags:
            //      public
            this.set("savedValue", this.intermediateValue);
        }
    });
});

},
'epi-cms/contentediting/FloatingEditorWrapper':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/Deferred",
    "dojo/topic",
    "dijit/focus",
    // epi
    "epi/dependency",

    "epi/shell/widget/dialog/LightWeight",

    "epi-cms/contentediting/OverlayBasedEditorWrapper",
    "./move-behind-overlay"
],

function (
// dojo
    array,
    declare,
    aspect,
    Deferred,
    topic,
    FocusManager,
    // epi
    dependency,

    LightWeightDialog,

    OverlayBasedEditorWrapper,
    moveBehindOverlay
) {

    return declare([OverlayBasedEditorWrapper], {
        // summary:
        //      A lightweight dialog used for displaying property editors. This dialog doesn't contain any
        //      buttons, instead it will close when a user clicks on the overlay outside the dialog.
        // tags:
        //      internal

        // formContainerWidgetType: String
        //      Special editor widget type
        formContainerWidgetType: "epi/shell/widget/FormContainer",

        // isOverlayDisabled: Boolean
        //      Override base value to disable overlay when editing.
        isOverlayDisabled: true,

        // isUndoDisabled: Boolean
        //      Override base value to disable undo when editing.
        isUndoDisabled: true,

        // _overlayContainer: [protected] epi/shell/widget/overlay/Container widget
        _overlayContainer: null,

        postCreate: function () {
            this.inherited(arguments);

            var self = this;
            this.own(
                topic.subscribe("/epi/shell/context/request", function (context, callerData) {
                    // Don't stop editing if we are creating a draft.
                    if (!callerData.contextIdSyncChange) {
                        self.tryToStopEditing(false);
                        // Ensure editing is set to false since the dialog is about to be destroyed.
                        self.set("editing", false);
                        // Remove the dialog regardless of whether editing stopped correctly
                        // since the context change will occur anyway.
                        self._destroyDialog();
                    }
                }),
                topic.subscribe("/epi/shell/action/changeview", function () {
                    self.set("editing", false);
                    self._removeEditingFeatures();
                }),
                topic.subscribe("/epi/shell/inline-edit-resize", function (overlayPosition) {
                    if (!this._dialog) {
                        return;
                    }

                    var dialogEl = this._dialog.domNode;
                    moveBehindOverlay(dialogEl, overlayPosition);
                }.bind(this))
            );
        },

        destroy: function () {
            // Make sure editing has been stopped so this wrapper is no
            // longer the activeEditorWrapper after being destroyed
            this.tryToStopEditing(false);
            this._destroyDialog();
            this.inherited(arguments);
        },

        startEdit: function (params) {
            // summary:
            //    Start editing and show the dialog.
            // tags:
            //    public

            this.editorParams = Object.assign(this.editorParams || {}, params);

            var self = this;

            self._destroyDialog();

            return self._setupDialog().then(function () {
                self.own(
                    aspect.after(self._dialog, "onAfterShow", function () {
                        self._startEdit(params);
                        self._onTryToStopWithInvalidValue();
                    })
                );

                return self._dialog.show();
            });
        },

        _createDialog: function (/*Object*/editor) {
            // summary:
            //      Create dialog
            // editor:
            //      Editor object
            // tags:
            //      protected

            return new LightWeightDialog({
                title: this.propertyDisplayName,
                content: editor,
                duration: 350,
                snapToNode: this.get("overlayItem").domNode,
                positioner: dependency.resolve("epi.shell.layout.PositioningUtility"),
                showButtonContainer: false
            });
        },

        _setBlockDisplayNodeAttr: function (node) {
            this.inherited(arguments);

            var dialog = this._dialog;
            if (dialog) {
                // Work-around permission denied in IE when the document containing the old reference has been unloaded.
                dialog.set("snapToNode", node);
            }
        },

        _setupDialog: function () {
            var _formWidgets = {};

            //Define form's field created event handler.
            var onFieldCreatedHandler = function (fieldName, widget) {
                _formWidgets[fieldName] = widget;
            };

            //Define form's form created event handler.
            var onFormCreatedHandler = function (formContainer) {
                // set parent for each child widget
                for (var fieldName in _formWidgets) {
                    var widget = _formWidgets[fieldName];
                    widget.set("parent", this);
                }

                _formWidgets = null;
            }.bind(this);

            var editorParams = Object.assign({ intermediateChanges: true }, this.editorParams);

            // Add event only when editor type is FormContainer
            if (this.editorWidgetType === this.formContainerWidgetType) {
                editorParams = Object.assign(editorParams, {
                    onFieldCreated: onFieldCreatedHandler,
                    onFormCreated: onFormCreatedHandler,
                    doLayout: false
                });
            }

            var deferred = new Deferred();

            // Create editor widget
            require([this.editorWidgetType], function (editorClass) {
                var editor = new editorClass(editorParams);
                this.editorWidget = editor;

                // Create dialog and set content
                var dialog = this._createDialog(editor);

                this._handlers = [
                    this.connect(dialog, "onButtonClose", this._onButtonClose),
                    this.connect(dialog, "onCancel", this._onDialogCancel),
                    this.connect(dialog.doneButtonNode, "onClick", this._onButtonClose),
                    this.connect(editor, "onChange", this._onChange),
                    this.connect(editor, "onKeyPress", "_onEditorKeyPress"),
                    this.connect(editor, "onStartEdit", function () {
                        this.set("editing", true);
                    }.bind(this)),
                    this.connect(editor, "onStopEdit", function () {
                        this.tryToStopEditing(false);
                    }.bind(this))
                ];
                this._dialog = dialog;

                // start editor if we created it
                if (this._createdEditor && this.editorWidget.startup) {
                    this.editorWidget.startup();
                }

                deferred.resolve();
            }.bind(this));

            return deferred.promise;
        },

        _onDialogCancel: function () {
            this.cancel();
        },

        _destroyDialog: function () {
            array.forEach(this._handlers, function (handle) {
                handle.remove();
            });
            this._handlers = null;

            if (this.editorWidget) {
                this.editorWidget.destroy();
                this.editorWidget = null;
            }

            if (this._dialog) {
                this._dialog.destroy();
                this._dialog = null;
            }
        },

        _removeEditingFeatures: function () {
            var dialog = this._dialog;

            if (dialog && dialog.open) {
                dialog.hide();
            }
        },

        _onTryToStopWithInvalidValue: function () {
            // force the editor to show any validation message
            // trigger a blur for the widget and then refocus it
            // this is a workaround to get any validation feedback
            // from widgets that only displays validation message when
            // input fields are blurred
            FocusManager.focus(this._dialog.titleNode);

            if (this.editorWidget.focus) {
                this.editorWidget.focus();
            }
        },

        _onButtonClose: function () {
            // summary:
            //    Stop editing when the dialog is hidden.
            // tags:
            //    private

            this.tryToStopEditing(false);
        }

    });

});

},
'epi/shell/widget/dialog/LightWeight':function(){
require({cache:{
'url:epi/shell/widget/dialog/templates/LightWeight.html':"﻿<div class=\"epi-lfw-dialog epi-lfw-dialog--dark dijitDialog\" role=\"dialog\" aria-labelledby=\"${id}_title\">\r\n    <div data-dojo-attach-point=\"titleBar\" class=\"dijitDialogTitleBar\">\r\n        <span data-dojo-attach-point=\"titleNode\" class=\"dijitDialogTitle\" id=\"${id}_title\"></span>\r\n         <span data-dojo-attach-point=\"closeButtonNode\" class=\"dijitDialogCloseIcon\" data-dojo-attach-event=\"ondijitclick: onButtonClose\" title=\"${buttonCloseText}\" role=\"button\" tabIndex=\"0\">\r\n            <span data-dojo-attach-point=\"closeText\" class=\"closeText\" title=\"${buttonCloseText}\">x</span>\r\n        </span>\r\n    </div>\r\n    <div class=\"dijitDialogPaneContent\">\r\n        <div data-dojo-attach-point=\"containerNode\" class=\"dijitDialogPaneContentArea\" data-dojo-attach-event=\"onclick:_onContainerNodeClick\"></div>\r\n        <div data-dojo-attach-point=\"buttonContainerNode\" class=\"dijitDialogPaneActionBar clearfix\">\r\n            <button data-dojo-attach-point=\"doneButtonNode\" data-dojo-type=\"dijit/form/Button\" type=\"button\">${buttonDoneText}</button>\r\n        </div>\r\n    </div>\r\n</div>\r\n"}});
﻿define("epi/shell/widget/dialog/LightWeight", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/has",
    "dijit/focus",
    "dijit/DialogUnderlay",
    // Parent class and mixins
    "dijit/Dialog",
    "epi/shell/widget/dialog/_DialogMixin",
    "dijit/_WidgetsInTemplateMixin",
    // Resources
    "epi/i18n!epi/nls/episerver.shared",
    "dojo/text!./templates/LightWeight.html"
],
function (
    declare,
    lang,
    aspect,
    domGeom,
    domStyle,
    has,
    focus,
    DialogUnderlay,
    // Parent class and mixins
    Dialog,
    _DialogMixin,
    _WidgetsInTemplateMixin,
    // Resources
    localizations,
    template
) {

    return declare([Dialog, _DialogMixin, _WidgetsInTemplateMixin], {
        // summary:
        //		A lightweight dialog Widget
        //
        // description:
        //		Pops up a modeless lightweight dialog window
        //
        // tags:
        //      public

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: template,

        // buttonCloseText: [protected] String
        //      Text to be displayed on the 'close' button
        buttonCloseText: localizations.action.close,

        // buttonDoneText: [protected] String
        //      Text to be displayed on the 'done' button
        buttonDoneText: localizations.action.done,

        // buttonLearnMoreText: [protected] String
        //      Text to be displayed on the 'learnmore' button
        buttonLearnMoreText: localizations.action.learnmore,

        // useGlassUnderlay: [public] Boolean
        //    Denotes that a glass underlay should be used. This underlay is not the global dijit/_underlay which is designed for modal dialogs only.
        useGlassUnderlay: false,

        // _glassUnderlay: [public] dijit/DialogUnderlay
        //    Underlay object. dijit/Dialog use a single global underlay which is not fully transparent for all dialog layers.
        //    This lightweight dialog maintains a different underlay to avoid messing up dijit's dialog stack.
        _glassUnderlay: null,

        "class": "epi-lfw-dialog",

        // snapToNode: [public] domNode
        //    The DomNode to snap to when doing positioning.
        snapToNode: null,

        // positioner: [public] epi/shell/layout/PositioningUtility
        //    Utility used to determine the correct position to display this dialog.
        positioner: null,

        // showButtonContainer: [public] Boolean
        //      A flag indicating whether the button container should be visible.
        showButtonContainer: true,

        destroy: function () {
            // summary:
            //		Destroy dialog

            this._interval && clearInterval(this._interval);

            this.inherited(arguments);
        },

        show: function () {
            // summary:
            //		Display the dialog
            // returns: dojo/Deferred
            //		Deferred object that resolves when the display animation is complete

            return this.inherited(arguments).then(lang.hitch(this, this._onAfterShow));
        },

        _size: function () {

            var transformId = this._relativePosition && this._relativePosition.id;

            // Set the overflow to visible before we calculate the container size. The size of the
            // dialog may be smaller than the content, causing it to scroll. However the default
            // dialog implementation doesn't account for this and so will calculate incorrectly.
            domStyle.set(this.containerNode, "overflow", "visible");

            this.inherited(arguments);

            // Reset the overflow to auto so that it scrolls if needed.
            domStyle.set(this.containerNode, "overflow", "auto");

            // Optional property. Check null before using
            if (this.positioner) {
                var obj = { snapTo: this.snapToNode, transformIndex: transformId};
                this._relativePosition = this.positioner.findPosition(this.domNode, obj);
            }
        },

        resize: function () {
            this._size();
            this._position();
        },

        _onAfterShow: function () {
            // summary:
            //		Additional work after dialog is shown.

            function checkSize() {

                var curPos = domGeom.position(this.domNode),
                    oldPos = this._relativePosition;

                if (oldPos && (Math.abs(oldPos.w - curPos.w) > 8 || Math.abs(oldPos.h - curPos.h) > 8)) {
                    this.resize();
                }
            }

            if (this.content && this.content.focus) {
                this.content.focus();
            }

            if (this.useGlassUnderlay) {
                this._createUnderlay();
            } else {
                //No glass underlay created when showing up, we use a temporary underlay to avoid lag when moving/resizing.
                //Handle moving
                if (this._moveable && !this._attachedMoveEvents) {
                    this.connect(this._moveable, "onMoveStart", lang.hitch(this, this._createUnderlay));
                    this.connect(this._moveable, "onMoveStop", lang.hitch(this, this._removeUnderlay));
                    this._attachedMoveEvents = true;
                }

                //Handle content resizing
                if (this.content && this.content.onResizeStart && this.content.onResizeStop && !this._attachedContentResizeEvents) {
                    this.own(
                        aspect.after(this.content, "onResizeStart", lang.hitch(this, this._createUnderlay)),
                        aspect.after(this.content, "onResizeStop", lang.hitch(this, this._removeUnderlay))
                    );
                    this._attachedContentResizeEvents = true;
                }
            }

            this._interval = setInterval(lang.hitch(this, checkSize), 250);

            this.onAfterShow();
        },

        _createUnderlay: function () {
            // summary:
            //		Handle move start event.
            // description:
            //      Show a transparent underlay to prevent lagging when drag over the underneath iframe.

            var container = this.containerNode,
                contentWidth = domStyle.get(container, "width");

            // Special handling for IE since it ignores the box sizing model and the scrollbar width
            // when retrieving the width of the DOM node.
            if (has("trident")) {
                var scrollbarWidth = container.offsetWidth - container.clientWidth;

                contentWidth += domGeom.getPadBorderExtents(container).w + scrollbarWidth;
            }

            // Calculate the width of the dialog container node and set it specifically as a style. This
            // fixes an issue where editors that have width of 100% cause the dialog to grow or shrink when dragged.
            domStyle.set(container, {
                width: contentWidth + "px"
            });

            if (this._glassUnderlay) {
                this._glassUnderlay.show();
            } else {
                this.own(
                    this._glassUnderlay = new DialogUnderlay()
                );
                this._glassUnderlay.show();

                // Set z-index a bit under the dialog
                var zIndex = domStyle.get(this.domNode, "zIndex");
                domStyle.set(this._glassUnderlay.domNode, "zIndex", zIndex - 1);

                //Make it transparent
                domStyle.set(this._glassUnderlay.domNode, "opacity", "0");
            }
        },

        _endDrag: function () {
            // summary:
            //      Called after dragging the dialog; sets the transform ID for the current position to be user set.
            // tags:
            //      protected
            this.inherited(arguments);

            this._relativePosition.id = this.positioner.userSetTransformId;
        },

        _removeUnderlay: function () {
            // summary:
            //		Handle move stop event.
            // description:
            //      Hide the transparent underlay.

            this._glassUnderlay.hide();
        },

        _onContainerNodeClick: function (e) {
            //If we inside the dialog, set the focus to the first focusable item
            if (e.target === this.containerNode) {
                this._getFocusItems();
                this._firstFocusItem && focus.focus(this._firstFocusItem);
            }
        },

        _setSnapToNodeAttr: function (node) {
            // Work-around permission denied in IE when the document containing the old reference has been unloaded.
            this.snapToNode = null;
            this._set("snapToNode", node);
        },


        onButtonClose: function () {

        },

        onAfterShow: function () {
            // summary:
            //    Fired on after show.
            //
            // tags:
            //    public, callback
        },

        onAfterHide: function () {
            // summary:
            //    Fired on hide.
            //
            // tags:
            //    public, callback
        },

        hide: function () {
            // summary:
            //		Hide the dialog
            // returns: dojo/Deferred
            //		Deferred object that resolves when the hide animation is complete

            this._interval && clearInterval(this._interval);
            this._interval = null;

            return this.inherited(arguments).then(lang.hitch(this, this._onAfterHide));
        },

        _onAfterHide: function () {
            if (this.useGlassUnderlay) {
                this._removeUnderlay();
            }

            this.onAfterHide();
        },

        layout: function () {
            // summary:
            //		Position the Dialog and the underlay
            // tags:
            //		private

            if (this._glassUnderlay && domStyle.get(this._glassUnderlay.domNode, "display") !== "none") {
                // Calling layout of the underlay sets display, and since show() calls layout we can ignore it if it's not shown
                this._glassUnderlay.layout();
            }

            var underlay = DialogUnderlay._singleton;

            //Adjust other dijit underlay display state, since Dialog.layout always set the modal Dialog's underlay to visible.
            var dijitUnderlayDisplay = underlay ? domStyle.get(underlay.domNode, "display") : null;

            this.inherited(arguments);

            if (underlay) {
                domStyle.set(underlay.domNode, "display", dijitUnderlayDisplay);
            }
        },

        _setShowButtonContainerAttr: function (showButtonContainer) {
            this._set("showButtonContainer", showButtonContainer);
            domStyle.set(this.buttonContainerNode, "display", showButtonContainer ? "" : "none");
        },

        _checkIfSingleChild: function () {
            // Force the lightweight dialog to run as if it doesn't have a single child.
            // This forces the dialog to set any width and height styles to itself instead
            // of the child, meaning that scrolling will occur on the container node rather
            // than the child node. This is necessary since our dialog styles only allow
            // for scrolling on the container node and not the child node.
            this._singleChild = null;
        }
    });
});

},
'url:epi/shell/widget/dialog/templates/LightWeight.html':"﻿<div class=\"epi-lfw-dialog epi-lfw-dialog--dark dijitDialog\" role=\"dialog\" aria-labelledby=\"${id}_title\">\r\n    <div data-dojo-attach-point=\"titleBar\" class=\"dijitDialogTitleBar\">\r\n        <span data-dojo-attach-point=\"titleNode\" class=\"dijitDialogTitle\" id=\"${id}_title\"></span>\r\n         <span data-dojo-attach-point=\"closeButtonNode\" class=\"dijitDialogCloseIcon\" data-dojo-attach-event=\"ondijitclick: onButtonClose\" title=\"${buttonCloseText}\" role=\"button\" tabIndex=\"0\">\r\n            <span data-dojo-attach-point=\"closeText\" class=\"closeText\" title=\"${buttonCloseText}\">x</span>\r\n        </span>\r\n    </div>\r\n    <div class=\"dijitDialogPaneContent\">\r\n        <div data-dojo-attach-point=\"containerNode\" class=\"dijitDialogPaneContentArea\" data-dojo-attach-event=\"onclick:_onContainerNodeClick\"></div>\r\n        <div data-dojo-attach-point=\"buttonContainerNode\" class=\"dijitDialogPaneActionBar clearfix\">\r\n            <button data-dojo-attach-point=\"doneButtonNode\" data-dojo-type=\"dijit/form/Button\" type=\"button\">${buttonDoneText}</button>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/OverlayBasedEditorWrapper':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/on",
    // epi
    "epi/shell/widget/IframeWithOverlay",
    "epi-cms/contentediting/_EditorWrapperBase"
],

function (
// dojo
    declare,
    lang,

    on,
    // epi
    IframeWithOverlay,
    _EditorWrapperBase
) {

    return declare([_EditorWrapperBase], {
        // summary:
        //      Based editor wrapper for the overlay relying editor widget type
        // tags:
        //      internal

        destroy: function () {

            this._iframeWithOverlay = null;

            this.inherited(arguments);
        },

        _onEditorResize: function (/*Object*/resizeInfo) {
            // summary:
            //      Stub to do somethings on editor resizing process
            // resizeInfo: [Object]
            //      Resize information
            // tags:
            //      protected
        },

        _onEditorResizeFinished: function (/*Function*/callbackFunction) {
            // summary:
            //      Stub to do somethings after editor finished its resize function
            // callbackFunction: [Function]
            //      Function will be call after finish resizing process
            // tags:
            //      protected
        },

        _getOverlayItemAttr: function () {
            // summary:
            //      Get editing overlay item object
            // tags:
            //      protected

            return this.overlayItem || this.editorParams.overlayItem;
        },

        _getIframeWithOverlayAttr: function () {
            // summary:
            //      Get the viewport ("epi/shell/widget/IframeWithOverlay") object
            // tags:
            //      protected

            if (this._iframeWithOverlay) {
                return this._iframeWithOverlay;
            }

            var iframeWithOverlay = null,
                widget = this.overlayItem;

            while (widget) {
                if (widget instanceof IframeWithOverlay) {
                    iframeWithOverlay = widget;
                    break;
                }

                widget = widget.getParent();
            }

            return this._iframeWithOverlay = iframeWithOverlay;
        }

    });

});

},
'epi-cms/contentediting/FlyoutEditorWrapper':function(){
﻿define([
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/number",

    "epi/shell/widget/IframeWithOverlay",
    "epi/shell/widget/dialog/LightWeight",
    "epi-cms/contentediting/FloatingEditorWrapper"
],

function (
    connect,
    declare,
    lang,

    domClass,
    domGeom,
    domStyle,

    number,

    IframeWithOverlay,
    Dialog,
    FloatingEditorWrapper
) {

    return declare([FloatingEditorWrapper], {
        // tags:
        //      internal

        // summary:
        //    A lightweight right-floating dialog used for displaying property editors.

        _eventHandlers: null,

        constructor: function () {
            this._eventHandlers = [];
        },

        _createDialog: function (/*Object*/editor) {
            // summary:
            //      Overrided to create floating dialog and return it
            // editor:
            //      Editor object
            // tags:
            //      protected

            var dialogResize = function (changeSize) {
                if (!this.open || !changeSize) {
                    return;
                }

                this._containerNodeCS = this._containerNodeCS || domStyle.getComputedStyle(this.containerNode);

                //Calculate the height of the chrome
                if (!this._dialogChromeSize) {
                    this._chromeHeight = domGeom.getMarginBox(this.domNode).h - domGeom.getMarginBox(this.containerNode).h;
                }

                domGeom.setMarginBox(this.containerNode, { h: changeSize.h - this._chromeHeight }, this._containerNodeCS);
                domStyle.set(this.domNode, { top: changeSize.t + "px", left: changeSize.l + "px" });
            };

            var dialog = new Dialog({
                title: this.propertyDisplayName,
                content: editor,
                duration: 350,
                draggable: false,
                closeIconVisible: false,
                region: "trailing",
                resize: dialogResize,
                overlayItem: this.overlayItem,
                _position: function () { },
                _size: function () { }
            });
            domClass.add(dialog.domNode, "epi-floatingEditorWrapperDialog");
            domClass.remove(dialog.domNode, "epi-lfw-dialog--dark");

            // Place dialog inside IframeWithOverlay widget as last child.
            dialog.placeAt(this.get("iframeWithOverlay"));
            domStyle.set(dialog.domNode, { top: "-10000px" });

            return dialog;
        },

        _disconnectLocal: function (targetArray) {
            if (lang.isArray(targetArray)) {
                var listener;
                while ((listener = targetArray.pop())) {
                    connect.disconnect(listener);
                }
            }
        },

        _removeEditingFeatures: function () {
            this.inherited(arguments);

            this._disconnectLocal(this._eventHandlers);
        }

    });

});

},
'epi-cms/contentediting/InlineEditorWrapper':function(){
define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",

    "dojo/dom-style",

    "dojo/Deferred",
    "dojo/on",
    "dojo/when",
    // epi
    "epi-cms/contentediting/OverlayBasedEditorWrapper"
],

function (
// dojo
    array,
    declare,
    event,
    lang,

    domStyle,

    Deferred,
    on,
    when,
    // epi
    OverlayBasedEditorWrapper
) {

    return declare([OverlayBasedEditorWrapper], {
        // summary:
        //      Widget that wraps a editor for inline property editing.
        // tags:
        //      internal xproduct

        // width: [public] String
        //      The witdh to use for the editor
        width: "100%",

        // hasInlineEditor: Boolean
        //      A value indicating if the wrapped editor is editing inline, i.e. On-Page-Editing.
        //      True by default.
        hasInlineEditor: true,

        matchStyle: false,

        destroy: function () {

            this._removeLocalHandlers();

            this._blockDisplayNodeOpacity = null;

            this.inherited(arguments);
        },

        tryToStopEditing: function () {
            // summary:
            //      Try to stop editing, ensure the inline editor has closed correctly
            //      first to ensure it has called to save.
            // tags:
            //      private

            var editorWidget = this.getEditorWidget();
            if (editorWidget && editorWidget.isEditing()) {
                editorWidget.onEditorBlur();
            }

            this.inherited(arguments, [true]);
        },

        _getOrCreateEditor: function () {
            if (this._createdEditor) {
                return this.editorWidget;
            }

            var deferred = new Deferred();

            var params = lang.mixin(this.editorParams, {
                value: this.value
            });

            if (this.matchStyle) {
                params.style = this._computeStyling();
            }

            require([this.editorWidgetType], lang.hitch(this, function (Editor) {
                var editorWidget = this.editorWidget = new Editor(params);

                editorWidget.placeAt(this.get("overlayItem").domNode);

                this.own(
                    on(editorWidget.domNode, "editorstatechanged", lang.hitch(this, this._onEditorStateChanged))
                );

                this._handlers = [
                    this.connect(editorWidget, "onClick", this._onClick),
                    this.connect(editorWidget, "onEditorResizing", this._onEditorResizing),
                    this.connect(editorWidget, "onEditorResized", this._onEditorResized)
                ];

                this._handlers.push(this.connect(editorWidget, "onChange", "_onEditorChange"));

                // ESC and TAB should cancel and save.  Note that edit widgets do a stopEvent() on ESC key (to
                // prevent Dialog from closing when the user just wants to revert the value in the edit widget),
                // so this is the only way we can see the key press event.
                this._handlers.push(this.connect(editorWidget, "onKeyPress", "_onEditorKeyPress"));

                this._createdEditor = true;

                deferred.resolve(editorWidget);
            }));

            return deferred;
        },

        _computeStyling: function () {

            var srcStyle = domStyle.getComputedStyle(this.blockDisplayNode),
                editStyle = "line-height:" + srcStyle.lineHeight + ";",
                destStyle = domStyle.getComputedStyle(this.domNode);

            ["Weight", "Family", "Size", "Style"].forEach(function (prop) {
                var textStyle = srcStyle["font" + prop],
                    wrapperStyle = destStyle["font" + prop];
                if (wrapperStyle !== textStyle) {
                    editStyle += "font-" + prop + ":" + srcStyle["font" + prop] + ";";
                }
            }, this);

            var width = this.width;
            if (width === "100%") {
                // block mode
                editStyle += "width:100%;";
            } else {
                // inline-block mode
                editStyle += "width:" + (width + (Number(width) === width ? "px" : "")) + ";";
            }

            editStyle += "position: absolute; left: 0px; top: 0px;";

            return editStyle;
        },

        _onEditorChange: function (value) {
            this._onChange(value);
        },

        _onEditorResizing: function (/*Object*/resizeInfo) {
            // summary:
            //      Stub to do something when the current editor on resizing progress
            // resizeInfo: [Object]
            //      Object that provides resize information to editor wrapper
            // tags:
            //      protected, extension
        },

        _onEditorResized: function (/*Function*/callbackFunction) {
            // summary:
            //      Stub to do something when the current editor finished its resizing process
            // tags:
            //      protected, extension
        },

        _onEditorStateChanged: function (/*String*/inputValue) {
            // summary:
            //      Delegate validation state to the current editing overlay item
            // inputValue: [String]
            //      Validation state string value
            // tags:
            //      private

            var overlayItem = this.get("overlayItem");
            overlayItem && overlayItem.set("error", inputValue === "Error");
        },

        startEdit: function () {
            var inherited = this.getInherited(arguments);

            when(this._getOrCreateEditor(), lang.hitch(this, function (editorWidget) {
                this._blockDisplayNodeOpacity = domStyle.get(this.blockDisplayNode, "opacity");

                domStyle.set(editorWidget.domNode, { display: "" });
                domStyle.set(this.blockDisplayNode, { opacity: 0.5 });

                inherited.apply(this);

                this.focus();
            }));
        },

        _removeLocalHandlers: function () {
            // summary:
            //      Remove all local handlers
            // tags:
            //      private

            (this._handlers instanceof Array && this._handlers.length > 0) && this._handlers.forEach(function (handle) {
                handle.remove();
            });
        },

        _onTryToStopWithInvalidValue: function () {
            // summary:
            //      Overridden to prevent user from leaving an inline editor with an invalid value.
            //      Leaving the editor gives a bad UX, since the last saved value is shown rather than the invalid value.
        },

        _removeEditingFeatures: function () {
            // summary:
            //      Its purpose is to restore state as it was before editing was started.
            // tags:
            //      protected, extension

            (this.blockDisplayNode && this._blockDisplayNodeOpacity) && domStyle.set(this.blockDisplayNode, { opacity: this._blockDisplayNodeOpacity });
            (this.editorWidget && this.editorWidget.domNode) && domStyle.set(this.editorWidget.domNode, "display", "none");
        },

        _toggleSupportCustomDnd: function (/*Boolean*/customDnd) {
            // summary:
            //      We should passively connect to onDropData event since overlayItem can be setup dndTarget.
            //      If not, we never get dnd data from overlayItem.
            // customDnd: [Boolean]
            // tags:
            //      protected

            var overlayItem = this.get("overlayItem");
            if (!overlayItem) {
                return;
            }

            var editorWidget = this.getEditorWidget();
            if (!editorWidget || !editorWidget.supportCustomDnd) {
                return;
            }

            if (customDnd === true) {
                overlayItem.transferDndControlTo(editorWidget);
            } else {
                overlayItem.transferDndControlTo(overlayItem);
            }
        },

        _toggleOverlayItemZIndex: function (/*Boolean*/increase) {
            // summary:
            //      Toggle increase/decrease z-index of the current editing overlay item in order to make it have higher indexed
            // increase: [Boolean]
            //      TRUE to increase, otherwise decrease
            // tags:
            //      protected

            var overlayItem = this.get("overlayItem");
            if (!overlayItem || !overlayItem.item) {
                return;
            }

            var currentZIndex = parseInt(domStyle.get(overlayItem.item, "zIndex"), 10);

            domStyle.set(overlayItem.item, {
                zIndex: increase === true ? ++currentZIndex : --currentZIndex
            });
        },

        _onClick: function (e) {
            // tags:
            //      internal xproduct

            event.stop(e);
        }

    });

});

},
'epi-cms/contentediting/SettingsPanel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/Deferred",
    "dojo/when",
    "dojo/dom-geometry",
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",
    "dijit/layout/BorderContainer",
    "epi/shell/layout/SimpleContainer",
    "dojo/text!./templates/SettingsPanel.html"
],
function (
    declare,
    lang,
    array,
    Deferred,
    when,
    domGeometry,
    _Container,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,
    BorderContainer,
    SimpleContainer,
    template) {

    return declare([_LayoutWidget, _Container, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //    Base class for rendering a content block.
        // tags:
        //    internal abstract

        templateString: template,

        contentViewModel: null,

        detailsWidgetIdentifier: "epi-cms/contentediting/ContentDetails",

        detailsModelIdentifier: "epi-cms/contentediting/viewmodel/ContentDetailsViewModel",

        detailsWidgetProperties: null,

        _contentDetailsDef: null,

        _contentDetailsModelDef: null,

        buildRendering: function () {
            this.inherited(arguments);

            // Load details widget class and its model class async
            var widgetIdentifier = this.detailsWidgetIdentifier;
            var modelIdentifier = this.detailsModelIdentifier;
            var widgetDef = new Deferred();
            var modelDef = new Deferred();

            require([widgetIdentifier, modelIdentifier], lang.hitch(this, function (widgetClass, modelClass) {

                var widget = new widgetClass({}, this.contentDetails);
                this.own(widget);

                var model = new modelClass();
                this.own(model);

                widget.set("model", model);

                // If the widget constructor takes time to load, we might have missed the startup, so better call it manually.
                widget.startup();

                this.contentDetails = widget;
                widgetDef.resolve(widget);
                modelDef.resolve(model);
            }));

            this._contentDetailsDef = widgetDef;
            this._contentDetailsModelDef = modelDef;
        },

        _setContentViewModelAttr: function (contentViewModel) {
            this._set("contentViewModel", contentViewModel);

            // When the model is created, change its datamodel
            when(this._contentDetailsModelDef, function (model) {
                model.set("dataModel", contentViewModel);
            });
        },

        addChild: function (w) {
            // Check settings if this property should be blaced in the contentDetails widget
            if (this.detailsWidgetProperties) {
                var matches = array.filter(this.detailsWidgetProperties, function (item) {
                    return item.propertyName === w.name;
                });
                if (matches.length > 0) {
                    when(this._contentDetailsDef, lang.hitch(this, function (contentDetails) {
                        contentDetails.addChild(w, matches[0].options);
                    }));

                    return;
                }
            }

            // Default: Place in property widget container
            this.widgetContainer.addChild(w);
        }
    });
});

},
'url:epi-cms/contentediting/templates/SettingsPanel.html':"﻿<div class=\"epi-documentHeader\">\r\n    <div data-dojo-type=\"epi/shell/layout/SimpleContainer\" data-dojo-attach-point=\"widgetContainer\"></div>\r\n    <div data-dojo-attach-point=\"contentDetails\"></div>\r\n</div>",
'epi-cms/contentediting/ValidationTextboxWithWarning':function(){
﻿define([
    "dojo/_base/declare",
    "dojox/validate/regexp",

    "dijit/form/ValidationTextBox"

], function (declare, regexp, ValidationTextBox) {

    return declare([ValidationTextBox], {
        // tags:
        //      public

        // regExpForWarning: [extension protected] String
        //		regular expression string used to validate the input when typing
        regExpForWarning: null,

        // acceptUrl: boolean
        //      If this is true, user can input an url to the textbox e.g. http://, https://, ftp://
        acceptUrl: false,

        // acceptMailAddress: boolean
        //      If this is true, user can input an email address like mailto:username@mail.com
        acceptMailAddress: false,

        _refreshState: function () {
            // summary:
            //      Overrides ValidationTextbox._refreshState()
            // tags:
            //      private
            if (!this._created) {
                return;
            }
            this.focused ? this._validateWhenTyping() : this.validate(false);
        },

        _isValidWhenTyping: function () {
            // summary:
            //      Validate the value when typing
            // tags:
            //      private

            var value = this.textbox.value;
            return (this.acceptUrl && (new RegExp(regexp.url({ scheme: true }))).test(value))
                        || (this.acceptMailAddress && (new RegExp("mailto\\:" + regexp.emailAddress())).test(value))
                        || (this.regExpForWarning && (new RegExp("^(?:" + this.regExpForWarning + ")" + (this.required ? "" : "?") + "$")).test(value));
        },

        _validateWhenTyping: function () {
            // summary:
            //		Validate the value when typing and show hint(promptMessage) for user if neccessary
            // tags:
            //		private

            var message = "";
            var isValid = this.disabled || this.isValid(true);
            if (isValid) {
                this._maskValidSubsetError = true;
            }
            var isEmpty = this._isEmpty(this.textbox.value);
            var isValidSubset = !isValid && this._isValidSubset();
            this._set("state", isValid ? (this._isValidWhenTyping() ? "" : "Incomplete") :
                (((isEmpty || isValidSubset) && this._maskValidSubsetError) ? "Incomplete" : "Error"));
            this.focusNode.setAttribute("aria-invalid", isValid ? "false" : "true");

            if (this.state === "Error") {
                this._maskValidSubsetError = isValidSubset; // we want the error to show up after a blur and refocus
                message = this.getErrorMessage(true);
            } else if (this.state === "Incomplete") {
                message = this.getPromptMessage(true); // show the prompt whenever the value is not yet complete
                this._maskValidSubsetError = !this._hasBeenBlurred; // no Incomplete warnings while focused
            } else if (isEmpty) {
                message = this.getPromptMessage(true); // show the prompt whenever there's no error and no text
            }
            this.set("message", message);

            return isValid;
        }
    });
});

},
'epi-cms/contentediting/viewmodel/ContentDetailsViewModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    // EPi Framework
    "epi",
    "epi/datetime",
    "epi/dependency",
    "epi/username",
    "epi-cms/contentediting/command/AccessRights",
    "epi-cms/contentediting/command/LanguageSettings",
    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/_GlobalCommandProviderMixin",

    // EPi CMS
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/viewmodel/_ContentViewModelObserver"
],

function (
    array,
    declare,
    lang,
    when,

    // EPi Framework
    epi,
    datetime,
    dependency,
    username,
    AccessRightsCmd,
    LanguageSettingsCmd,
    _CommandConsumerMixin,
    _GlobalCommandProviderMixin,

    // EPi CMS
    ContentActionSupport,
    ContentReference,
    _ContentViewModelObserver) {

    return declare([_ContentViewModelObserver, _CommandConsumerMixin, _GlobalCommandProviderMixin], {
        // tags:
        //      internal

        commandKey: "epi.cms.contentdetailsmenu",

        res: null,

        contentTypeName: null,
        contentId: null,
        visibleToEveryOne: null,
        existingLanguages: null,

        accessRightsCommand: null,
        languageSettingsCommand: null,
        expirationCommand: null,

        constructor: function (params) {
            declare.safeMixin(this, params);
        },

        postscript: function () {
            this.initializeCommandProviders();
            this.accessRightsCommand = this.accessRightsCommand || new AccessRightsCmd();
            this.languageSettingsCommand = this.languageSettingsCommand || new LanguageSettingsCmd();
            if (!this.expirationCommand) {
                //we use the global expiration command as the same command is used in expiration notification.
                var editingCommands = dependency.resolve("epi.cms.contentEditing.command.Editing");
                this.expirationCommand = editingCommands.manageExpiration;
            }

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.contenttype");
            }

            this.inherited(arguments);
        },

        destroy: function () {
            this.accessRightsCommand.destroy();
            this.languageSettingsCommand.destroy();
            this.inherited(arguments);
        },

        _dataModelSetter: function (value) {
            this.updateCommandModel(value);

            this.accessRightsCommand.set("model", value);
            this.languageSettingsCommand.set("model", value);

            this.inherited(arguments);
        },

        onDataModelChange: function (name, oldValue, value) {
            var contentData = this.dataModel.contentData,
                contentRef = new ContentReference(contentData.contentLink);

            this.set("contentId", contentRef.id);

            this.set("existingLanguages", array.map(contentData.existingLanguageBranches, function (item) {
                return {
                    text: item.languageId,
                    urlSegment: item.urlSegment,
                    isCurrentLanguage: contentData.currentLanguageBranch && item.languageId === contentData.currentLanguageBranch.languageId,
                    contentLink: new ContentReference(item.commonDraftLink).createVersionUnspecificReference().toString()
                };
            }));

            this.set("visibleToEveryOne", contentData.visibleToEveryOne);

            when(this.store.get(contentData.contentTypeID), lang.hitch(this, function (type) {
                this.set("contentTypeName", type.localizedName);
            }));

            this.set("commands", this.getCommands());
        },

        getCommands: function () {
            var commands = this.inherited(arguments);

            return [this.languageSettingsCommand, this.expirationCommand].concat(commands);
        }
    });
});

},
'epi-cms/contentediting/command/AccessRights':function(){
define([
    "require",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/json",
    "dojo/Deferred",
    "dojo/on",
    "dojo/topic",
    "epi/dependency",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/command/_Command",
    "epi/shell/widget/dialog/Dialog",
    "epi-cms/ApplicationSettings",
    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.contentdetails.command.accessrights",
    "epi/i18n!epi/shell/nls/admin.security",
    "epi/i18n!epi/shell/nls/admin.searchusers",
    "epi/i18n!epi/shell/nls/edit.editsecurity",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.hierachicallist",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentreferences",
    "epi/i18n!epi/shell/nls/button",
    "epi/i18n!epi/nls/episerver.shared"
],

function (
    moduleRequire,
    declare,
    lang,
    json,
    Deferred,
    on,
    topic,
    dependency,
    ContentActionSupport,
    _Command,
    Dialog,
    ApplicationSettings,
    resources,
    securityResources,
    searchusersResources,
    editsecurityResources,
    hierachicalListResources,
    contentReferencesResources,
    buttonResources,
    sharedResources) {

    function AccessRightsViewModel(store) {

        return {
            onMessage: function (message) {
                // callback
            },
            onReadOnly: function (readOnly) {
                // callback
            },
            searchVirtualRoles: function (searchPhrase, startIndex, maxRows) {
                return store.query({ type: "VirtualRoles", partOfName: searchPhrase }, { start: startIndex, count: maxRows });
            },
            searchRoles: function (searchPhrase, startIndex, maxRows) {
                return store.query({ type: "Roles", partOfName: searchPhrase }, { start: startIndex, count: maxRows });
            },
            searchVisitorGroups: function (searchPhrase, startIndex, maxRows) {
                return store.query({ type: "VisitorGroups", partOfName: searchPhrase }, { start: startIndex, count: maxRows });
            },
            searchApplications: function (searchPhrase, startIndex, maxRows) {
                return store.query({ type: "Applications", partOfName: searchPhrase }, { start: startIndex, count: maxRows });
            },
            searchUsers: function (searchPhrase, startIndex, maxRows) {
                return store.query({ type: "Users", partOfName: searchPhrase }, { start: startIndex, count: maxRows });
            }
        };
    }

    return declare([_Command], {
        // summary:
        //      Toggles permanent in use notification on/off.
        //
        // tags:
        //      internal

        name: "AccessRights",
        label: resources.label,
        tooltip: resources.tooltip,
        store: null,
        accessrightUsersStore: null,

        constructor: function (params) {
            declare.safeMixin(this, params);
            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.accessrights");
            this.accessrightUsersStore = this.accessrightUsersStore || dependency.resolve("epi.storeregistry").get("epi.cms.accessright.users");
        },

        _execute: function () {
            moduleRequire(["epi-cms-react/components/content-access-rights-widget", "xstyle/css!epi-cms-react/components/content-access-rights-widget.css"], function (ContentAccessRightsWidget) {
                var resources = Object.assign({}, securityResources, searchusersResources, editsecurityResources, buttonResources, hierachicalListResources, contentReferencesResources, {
                    heading: lang.replace(editsecurityResources.heading, [this.model.contentData.name]),
                    user: lang.replace(editsecurityResources.user, [ApplicationSettings.userName])
                });
                var model = AccessRightsViewModel(this.accessrightUsersStore);

                this.store.get(this.model.contentData.contentLink).then(function (settings) {
                    var dialog;
                    var content = new ContentAccessRightsWidget({
                        model: model,
                        resources: resources,
                        helpLink: ApplicationSettings.userGuideUrl + "#editsecurity",
                        entries: settings.entries,
                        isInherited: settings.isInherited,
                        isInheritedEnabled: settings.isInheritedEnabled,
                        isReadOnly: settings.isReadOnly,
                        userGroups: settings.userGroups,
                        onDirty: function (isDirty) {
                            if (!dialog) {
                                return;
                            }

                            dialog.definitionConsumer.setItemProperty(dialog._okButtonName, "disabled", !isDirty);
                        }
                    });
                    dialog = new Dialog({
                        dialogClass: "epi-dialog-portrait epi-dialog-portrait__autosize epi-dialog--wide",
                        defaultActionsVisible: true,
                        confirmActionText: sharedResources.action.save,
                        content: content,
                        title: editsecurityResources.title
                    });

                    dialog.addValidator(function () {
                        var deferred = new Deferred();
                        this.store.executeMethod("Save", this.model.contentData.contentLink, {
                            entries: model.entries,
                            id: this.model.contentData.contentLink,
                            isInherited: model.isInherited
                        }).then(function (response) {
                            model.onMessage(response.messageModel ? response.messageModel : { text: editsecurityResources.savemessage, type: "good-news" });
                            model.onReadOnly(response.isReadOnly);
                            if (!response.messageModel) {
                                dialog.hide();
                            }
                            dialog.definitionConsumer.setItemProperty(dialog._okButtonName, "disabled", response.isReadOnly);
                            topic.publish("/epi/cms/contentdata/updated", {
                                contentLink: this.model.contentData.contentLink,
                                recursive: true
                            });
                            return deferred.resolve([]);
                        }.bind(this)).otherwise(function (response) {
                            model.onMessage(response.responseText ? json.fromJson(response.responseText) : null);
                        });
                        return deferred.promise;
                    }.bind(this));

                    dialog.show();
                    dialog.definitionConsumer.setItemProperty(dialog._okButtonName, "disabled", true);
                    model.onMessage(settings.messageModel);
                    model.onReadOnly(settings.isReadOnly);
                }.bind(this));
            }.bind(this));
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,
                hasAdminAccess = ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Administer);

            this.set("canExecute", contentData.capabilities.securable && hasAdminAccess);
        }
    });
});

},
'epi-cms/contentediting/command/LanguageSettings':function(){
define([
    "require",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",
    "dojo/Deferred",
    "epi/dependency",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/command/_Command",
    "epi/shell/widget/dialog/Dialog",
    "epi-cms/ApplicationSettings",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.contentdetails.command.languagesettings",
    "epi/i18n!epi/shell/nls/edit.languagesettings",
    "epi/i18n!epi/shell/nls/button",
    "epi/i18n!epi/nls/episerver.shared"
], function (
    moduleRequire,
    declare,
    lang,
    topic,
    when,
    Deferred,
    dependency,
    ContentActionSupport,
    _Command,
    Dialog,
    ApplicationSettings,
    commandResources,
    uiResources,
    buttonResources,
    sharedResources) {

    function LanguageSettingsViewModel(store, contentLink) {

        return {
            getLanguageSettings: function () {
                return store.get(contentLink);
            },
            saveLanguageSettings: function (settings) {
                return store.executeMethod("UpdateLanguageSettings", contentLink, {
                    availableLanguages: settings.availableLanguages,
                    id: contentLink,
                    inheritSettings: settings.inheritSettings,
                    replacementLanguages: settings.replacementLanguages,
                    fallbackLanguages: settings.fallbackLanguages
                });
            },
            onMessage: function (message) {
                // callback
            },
            onReadOnly: function (isReadOnly) {
                // callback
            }
        };
    }

    return declare([_Command], {
        // summary:
        //      Toggles permanent in use notification on/off.
        //
        // tags:
        //      internal
        name: "LanguageSettings",
        label: commandResources.label,
        tooltip: commandResources.tooltip,
        store: null,

        constructor: function () {
            this.store = dependency.resolve("epi.storeregistry").get("epi.cms.languagesettings");
            this.contentStore = dependency.resolve("epi.storeregistry").get("epi.cms.content.light");
        },

        _execute: function () {
            // summary:
            //		Toggles the value of the given property on the model.
            // tags:
            //		protected

            moduleRequire(["epi-cms-react/components/language-settings-widget", "xstyle/css!epi-cms-react/components/language-settings-widget.css"], function (LanguageSettingsWidget) {
                when(this.contentStore.get(this.model.contentData.parentLink)).then(function (parentContent) {
                    var resources = Object.assign({}, uiResources,
                        {
                            heading: lang.replace(uiResources.heading, [this.model.contentData.name]),
                            inheritsettings: parentContent ? lang.replace(uiResources.inheritsettings, [parentContent.name]) : uiResources.inheritsettings,
                            change: buttonResources.change,
                            save: buttonResources.save,
                            ok: buttonResources.ok,
                            cancel: buttonResources.cancel
                        });
                    var contentLink = this.model.contentData.contentLink;
                    var model = LanguageSettingsViewModel(this.store, contentLink);

                    var dialog;
                    model.getLanguageSettings().then(function (settings) {
                        var sectionsVisibility = Object.assign({}, ApplicationSettings.sectionsVisibility);

                        var content = new LanguageSettingsWidget({
                            model: model,
                            resources: resources,
                            defaultSettings: settings,
                            helpLink: ApplicationSettings.userGuideUrl + "#languagesettings",
                            enableLanguageFallbacks: sectionsVisibility.languageFallbacks,
                            enableLanguageReplacements: sectionsVisibility.languageReplacements,
                            onDirty: function (isDirty) {
                                if (!dialog) {
                                    return;
                                }

                                dialog.definitionConsumer.setItemProperty(dialog._okButtonName, "disabled", !isDirty);
                            }
                        });

                        dialog = new Dialog({
                            dialogClass: "epi-dialog-portrait epi-dialog-portrait__autosize epi-dialog--wide",
                            defaultActionsVisible: true,
                            confirmActionText: sharedResources.action.save,
                            content: content,
                            title: commandResources.label
                        });

                        dialog.addValidator(function () {
                            var deferred = new Deferred();
                            model.saveLanguageSettings(model.settings)
                                .then(function (response) {
                                    model.onReadOnly(response.isReadOnly);
                                    dialog.definitionConsumer.setItemProperty(dialog._okButtonName, "disabled", response.isReadOnly);

                                    if (response.messageModel && response.messageModel.text) {
                                        model.onMessage(response.messageModel);
                                    } else {
                                        topic.publish("/epi/cms/contentdata/updated", {
                                            contentLink: contentLink,
                                            recursive: true
                                        });

                                        dialog.hide();
                                    }

                                    return deferred.resolve([]);
                                }.bind(this));
                            return deferred.promise;
                        }.bind(this));

                        dialog.show();
                        dialog.definitionConsumer.setItemProperty(dialog._okButtonName, "disabled", true);
                        model.onReadOnly(settings.isReadOnly);
                        model.onMessage(settings.messageModel);

                    }.bind(this));
                }.bind(this));
            }.bind(this));
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData;
            var hasAdminAccess =
                ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Administer);

            this.set("canExecute", contentData.capabilities.languageSettings && hasAdminAccess);
        }
    });
});

},
'epi-cms/conversion/PropertyContentAreaConverter':function(){
﻿define([
    "dojo/_base/declare"
],
function (declare) {

    return declare(null, {
        // summary:
        //    Converts propertyContentArea. Checks if the data is located in the _unparsedString
        //
        // tags:
        //    internal

        sourceDataType: "epi.cms.propertycontentarea",
        targetDataType: "runtimeType",

        registerDefaultConverters: function (/*Object*/registry) {
            // summary:
            //    Registers the type conversions that this class supports to the given registry.
            //
            // registry: Object
            //    The converter registry to add mappings to.
            registry.registerConverter(this.sourceDataType, this.targetDataType, this);
        },

        convert: function (/*String*/sourceDataType, /*String*/targetDataType, /*Object*/data) {
            // summary:
            //    Converts data between two types.
            //
            // sourceDataType: String
            //    The source data type.
            //
            // targetDataType: String
            //    The target data type.
            //
            // converter: Object
            //    The class that performs the actual conversion.
            // tags:
            //    public

            if (sourceDataType === this.sourceDataType && targetDataType === this.targetDataType) {
                return data ? data._unparsedString : data;
            }

            return null;
        }
    });
}
);

},
'epi-cms/layout/CreateContentGroupContainer':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/dom-construct",
    "epi/shell/layout/SimpleContainer"
], function (
    declare,
    domConstruct,
    SimpleContainer) {

    return declare([SimpleContainer], {
        // summary:
        //     Group container that have a title.
        //
        // tags:
        //      internal

        templateString: "<div class='epi-containerLayout clearfix'>\
                            <div class='epi-formsHeaderContainer'>\
                                <h2>${title}</h2>\
                            </div>\
                            <ul data-dojo-attach-point='containerNode'></ul>\
                        </div>"
    });
});

},
'epi-cms/layout/EditLayoutContainer':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dom-construct",
    "dojo/when",
    "dijit/layout/TabContainer",
    "dijit/registry",
    "epi/dependency",
    "epi-cms/core/ContentReference",
    "epi-cms/_ContentContextMixin",
    "epi/shell/tooltipHider",
    "dojo/text!./templates/EditLayoutContainer.html"
], function (
    array,
    declare,
    domConstruct,
    when,
    TabContainer,
    registry,
    dependency,
    ContentReference,
    _ContentContextMixin,
    tooltipHider,
    template
) {

    return declare([TabContainer, _ContentContextMixin], {
        // summary:
        //     Widget that contains a group form items widgets, aimed to apply the html formatting specific to a group
        //
        // tags:
        //      internal

        templateString: template,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");
            // This container does not allow doing layout children and only support top tabs because we use relative position when laying out.
            // The reason behind is that absolute position make the container zero height when it is laid out without size constraints.
            this.doLayout = false;
            this.tabPosition = "top";
        },

        startup: function () {
            this.inherited(arguments);
            when(this.getCurrentContext(), this._trySelectStoredTab.bind(this));
            tooltipHider(this);

            // The top pane container does not automatically start its' widgets, so we do it manually
            var topPaneContents = registry.findWidgets(this.topPaneContainerNode);
            array.forEach(topPaneContents, function (widget) {
                !widget.started && widget.startup();
            });
        },

        addChild: function (widget, index) {
            // summary:
            //     Add a child o the container.
            // widget: dijit/_Widget
            //     The widget to add
            // index: Number
            //     The position
            // tags:
            //     public

            if (this._destroyed) {
                return;
            }

            if (widget.region === "top") {
                this.own(widget.placeAt(this.topPaneContainerNode));
            } else {
                this.inherited(arguments);
            }
        },

        removeChild: function (widget) {
            // Overrides _Container.removeChild() to do layout

            if (widget.region === "top") {
                // Return if we are being destroyed
                if (this._descendantsBeingDestroyed) {
                    return;
                }

                // Otherwise, do layout again
                if (this._started) {
                    this.layout();
                }
            } else {
                this.inherited(arguments);
            }
        },

        layout: function () {
            // Overrides TabContainer.layout().
            // Configure the content pane to take up all the space except for where the tabs and the top panel are.

            if (!this._contentBox || typeof (this._contentBox.l) == "undefined") {
                return;
            }

            // layout the top panel first
            var topPaneContents = registry.findWidgets(this.topPaneContainerNode);
            array.forEach(topPaneContents, function (widget) {
                widget.resize();
            });

            return this.inherited(arguments);
        },

        selectChild: function (widget) {
            // summary:
            //     Select child widget or group.
            // widget: dijit/_Widget
            //     The child widget or group
            // tags:
            //     public

            if (!widget) {
                return;
            }

            if (widget._type === "group") {
                this._saveSelectedTab(widget);
            }

            if (widget.region === "top") {
                return;
            } else {
                // After inherited finishes we call layout to reflow the content
                // in case a scrollbar has appeared on tab change, and then we pass on the result
                return when(this.inherited(arguments)).then(function (result) {
                    this.layout();
                    return result;
                }.bind(this));
            }
        },

        _saveSelectedTab: function (widget) {
            when(this.getCurrentContext(), function (context) {
                this.profile.set(this._getSelectedTabProfileKey(context.id), this.getChildren().indexOf(widget));
            }.bind(this));
        },

        _getSelectedTabProfileKey: function (contentLink) {
            var contentId = new ContentReference(contentLink).createVersionUnspecificReference().toString();
            return "EditFormContainer_selectedTab_" + contentId;
        },

        _trySelectStoredTab: function (context) {
            when(this.profile.get(this._getSelectedTabProfileKey(context.id))).then(function (selectedTabIndex) {
                if (!selectedTabIndex) {
                    return;
                }

                var children = this.getChildren();

                if (selectedTabIndex < children.length) {
                    this.selectChild(children[selectedTabIndex]);
                }
            }.bind(this));
        }
    });
});

},
'url:epi-cms/layout/templates/EditLayoutContainer.html':"﻿<div class=\"dijitTabContainer\">\r\n    <div data-dojo-attach-point=\"topPaneContainerNode\"></div>\r\n\t<div class=\"dijitTabListWrapper\" data-dojo-attach-point=\"tablistNode\"></div>\r\n\t<div data-dojo-attach-point=\"tablistSpacer\" class=\"dijitTabSpacer ${baseClass}-spacer\"></div>\r\n\t<div class=\"dijitTabPaneWrapper ${baseClass}-container\" data-dojo-attach-point=\"containerNode\"></div>\r\n</div>\r\n",
'epi-cms/project/Overview':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-geometry",
    "dojo/on",
    "dojo/when",

    "epi/shell/_ContextMixin",
    "./_ProjectView",
    "./viewmodels/OverviewViewModel",

    // Template
    "dojo/text!./templates/Overview.html",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project",

    // Template widgets
    "dijit/Toolbar",
    "dijit/form/Button",
    "dijit/form/DropDownButton",
    "dijit/layout/TabContainer",
    "epi-cms/activity/ActivityFeed",
    "epi-cms/project/ProjectItemList",
    "epi-cms/project/PublishMenu"
], function (
//dojo
    declare,
    lang,
    domGeometry,
    on,
    when,

    //epi
    _ContextMixin,
    _ProjectView,
    OverviewViewModel,

    // Template
    template,

    // Resources
    res
) {

    return declare([_ProjectView], {
        // tags:
        //      internal

        modelBindingMap: {
            projectItemQuery: ["projectItemQuery"],
            projectItemSortOrder: ["projectItemSortOrder"],
            selectedProject: ["selectedProject"],
            created: ["created"],
            createdBy: ["createdBy"],
            dndEnabled: ["dndEnabled"],
            isActivitiesVisible: ["isActivitiesVisible"],
            notificationMessage: ["notificationMessage"],
            projectStatus: ["projectStatus"],
            contentLanguage: ["contentLanguage"],
            projectItemCountMessage: ["projectItemCountMessage"],
            projectName: ["projectName"]
        },

        res: res,

        templateString: template,

        postCreate: function () {
            // summary:
            //      Processing after the DOM fragment is created. Binds to events that can occur on
            //      child widgets.
            // tags:
            //      protected

            this.inherited(arguments);

            this.own(
                on(this.model, "refresh-activities", this.activityFeed.refresh.bind(this.activityFeed))
            );
        },

        _createViewModel: function () {
            // summary:
            //      Setting up the view model
            // tags:
            //      protected
            return new OverviewViewModel();
        },

        layout: function () {

            // Do not call resize unless we have been started
            if (!this._started) {
                return;
            }

            var toolbarSize = domGeometry.getMarginBox(this.toolbar),
                size = lang.mixin({}, this._contentBox, { h: this._contentBox.h - toolbarSize.h });
            this.tabs.resize(size);
        },

        _onShow: function () {
            // summary:
            //      Sets isProjectOverviewActive false when widgets is visible
            // tags:
            //      private
            this.model.set("isProjectOverviewActive", true);
        },

        onHide: function () {
            // summary:
            //      Sets isProjectOverviewActive true when widgets is hidden
            // tags:
            //      public
            this.model.set("isProjectOverviewActive", false);
        },

        _close: function () {
            // summary:
            //      Closes the overview
            // tags:
            //      private
            this.model.requestPreviousContext();
        },

        _setIsActivitiesVisibleAttr: function (isVisible) {
            // summary:
            //      Toggles whether the activities panel is visible in
            //      the overview.
            // tags:
            //      private
            this.itemList.toggleActivities(isVisible);
        },

        _setProjectNameAttr: { node: "projectNameNode", type: "innerText" },

        _setProjectItemCountMessageAttr: { node: "toolbarTextNode", type: "innerText" }

    });
});

},
'epi-cms/project/_ProjectView':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/on",
    "dojo/when",

    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",

    // epi
    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/widget/_ModelBindingMixin",
    "./CreateNewDraftConfirmationDialog",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project"
],

function (
// dojo
    declare,
    lang,
    aspect,
    domClass,
    domGeometry,
    on,
    when,

    // dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,

    // epi
    MenuAssembler,
    ButtonBuilder,
    _ModelBindingMixin,
    CreateNewDraftConfirmationDialog,

    // Resources
    res
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //
        // tags:
        //      internal

        model: null,

        commandProvider: null,

        res: res,

        // _menuAssembler: [private] Object
        //      Instance of menu assembler
        _menuAssembler: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model) {
                this.own(
                    this.model = this.commandProvider = this._createViewModel()
                );
            }
        },

        _createViewModel: function () {
            // summary:
            //    Setting up the view model
            // tags:
            //    protected abstract
        },

        buildRendering: function () {
            this.inherited(arguments);
            this._setupList();
            this._setupProjectMenu();
        },

        startup: function () {
            if (this._started) {
                return;
            }
            this.inherited(arguments);
            this.model.initialize();
        },

        _setupList: function () {
            // summary:
            //    Setting up the list
            // tags:
            //    private
            var model = this.model,
                itemList = this.itemList;

            //Callback method to execute when the canAddContent promise gets resolved
            function addContent(result) {
                if (result.existingProjectItems.length !== 0) {
                    new CreateNewDraftConfirmationDialog({
                        projectItems: result.existingProjectItems,
                        contentReferences: result.contentReferences,
                        onAction: function (dialogOk) {
                            if (dialogOk) {
                                model.addProjectItems(result.contentReferencesToAdd)
                                    .then(itemList.setSelection.bind(itemList));
                            }
                        }
                    }).show();

                } else if (result.contentReferencesToAdd.length > 0) {
                    model.addProjectItems(result.contentReferencesToAdd);
                }
            }

            this.own(
                // listen to view model for request to refresh the list
                on(this.model, "refresh", itemList.refresh.bind(itemList)),
                on(this.model, "selected-project-items-updated", function (updatedItems) {
                    // a remote user can update an item which was selected for this user
                    // in that case we need to select them again since Realtime store has already run refresh/notify & remove the selection.
                    itemList.selectItems(updatedItems);
                }),
                on(this.domNode, "selection-changed", function (e) {
                    // selection-changed is only emited when user interaction with grid items
                    // so we need to update the activity feed based on items being selected/deslected
                    model.updateActivityFeed(e.items);
                }),
                on(this.domNode, "active-items-changed", function (e) {
                    // activit-items-changed happens when an items gets added,updated or deleted via any means (i.e another user deletes an items and Realtime invokes notify)
                    // we don't need to touch activityFeed but only left panel selected items
                    model.set("selectedProjectItems", e.items);
                }),
                on(this.domNode, "itemaction", function (e) {
                    model.namedCommands.editProjectItem.execute();
                }),
                on(this.domNode, "itemremove", function () {
                    model.namedCommands.removeProjectItem.execute();
                }),
                on(this.domNode, "itemsdropped", function (e) {
                    model.canAddContent(e.items).then(addContent);
                }),
                on(this.model, "clear-selection", function () {
                    itemList.clearSelection();
                }),
                on(this.model, "item-removed", function () {
                    // Clear Selection after removing selected project items
                    itemList.clearSelection();
                    // Remove the project item and then set focus back to the grid since it
                    // would have been moved to the confirmation dialog.
                    itemList.focus();
                })
            );
        },

        _setupProjectMenu: function () {
            // summary:
            //    Setting up the project menu
            // tags:
            //    private
            this.own(
                this._menuAssembler = new MenuAssembler({
                    configuration: [{
                        builder: new ButtonBuilder({
                            settings: {
                                "class": "epi-disabledDropdownArrow",
                                showLabel: false
                            }
                        }),
                        category: "projectButton",
                        target: this.toolbarGroupNode
                    },
                    {
                        builder: new ButtonBuilder({
                            settings: {
                                "class": "epi-floatRight",
                                showLabel: false
                            }
                        }),
                        category: "project-comments",
                        target: this.projectCommentsToolbar
                    },
                    {
                        builder: new ButtonBuilder(),
                        category: "project-activities",
                        target: this.toolbarGroupNode
                    }],
                    commandSource: this.model
                })
            );
        },

        _publishMenuClickHandler: function () {
            // summary:
            //    Click handler for publish menu
            // tags:
            //    private
            this.model.refreshProject(false);
        },

        _setCreatedAttr: { node: "createdNode", type: "innerText" },

        _setCreatedByAttr: { node: "createdByNode", type: "innerText" },

        _setDndEnabledAttr: function (/*Boolean*/value) {
            // summary:
            //    Enable the dnd
            // tags:
            //    private
            this.itemList.set("dndEnabled", value);
        },

        _setProjectItemQueryAttr: function (value) {
            // summary:
            //      Updates the query on the list
            // value: Object
            //      Query
            // tags:
            //      private

            // Set store to null if query is null to stop list updates
            var store = value ? this.model.projectItemStore : null;
            this.itemList.updateQuery(store, value);
        },

        _setProjectItemSortOrderAttr: function (value) {
            // summary:
            //    Changes the sort order'
            // value: Object
            //      Sort order
            // tags:
            //    private
            this.itemList.set("sortOrder", value);
        },

        _setNotificationMessageAttr: function (value) {
            // summary:
            //      Sets the notification message
            // value: String
            //      Message
            // tags:
            //      private
            this.itemList.set("notificationMessage", value);
        },

        _setProjectStatusAttr: function (value) {
            // summary:
            //      Sets project status message
            // value: String
            //      Message
            // tags:
            //      private
            this.projectStatusMessageNode.textContent = value;
            domClass.toggle(this.projectStatusMessageNode, "dijitHidden", !value);
        },

        _setContentLanguageAttr: function (value) {
            // summary:
            //      Sets the contentLanguage
            // value: String
            //      Language
            // tags:
            //      private
            this.itemList.set("contentLanguage", value);
        }
    });
});

},
'epi-cms/project/CreateNewDraftConfirmationDialog':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/string",

    //dgrid
    "dgrid/Grid",

    // epi
    "epi/shell/widget/dialog/Confirmation",
    "epi/string",

    // epi-cms
    "epi-cms/dgrid/listItemFormatters",
    "epi-cms/dgrid/formatters",

    // Resources
    "epi/i18n!epi/nls/episerver.shared",
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.newdraftconfirmation"
], function (
// dojo
    declare,
    string,

    //dgrid
    Grid,

    // epi
    Confirmation,
    epiString,

    // epi-cms
    listItemFormatters,
    formatters,

    // Resources
    sharedResources,
    confirmationResources
) {
    return declare([Confirmation], {
        // summary:
        //      Confirmation dialog asking the user if a new draft should be created
        // tags:
        //      internal xproduct

        // projectItems: [readonly] Array
        //      The conflicting project items
        projectItems: null,

        // contentReferences: [readonly] Array
        //      All content references that is going to be added
        contentReferences: null,

        title: confirmationResources.allreadypartofproject,

        cancelActionText: sharedResources.action.cancel,

        dialogClass: "epi-dialog-contentReferences epi-contentReferences",

        setFocusOnConfirmButton: false,

        buildRendering: function () {
            this.inherited(arguments);

            var gridSettings = {
                showHeader: true,
                "class": "epi-plain-grid epi-plain-grid--no-border",
                columns: {
                    name: {
                        sortable: false,
                        label: sharedResources.header.name,
                        className: "epi-grid--30 epi-cursor--default",
                        renderCell: function (object, value, node, options) {
                            //Create a tooltip in the format: "Alloy Meet, ID: 20_2"
                            // The title gets encoded in the formatters.contentItem function
                            var title = object.name + ", ID: " + object.contentLink;
                            node.innerHTML = listItemFormatters.statusFormatter(formatters.contentItem(object.typeIdentifier, "", value, title), object, node, options);
                        }
                    },
                    path: {
                        sortable: false,
                        label: confirmationResources.path,
                        className: "epi-grid--40 epi-cursor--default",
                        formatter: formatters.path
                    },
                    projectName: {
                        sortable: false,
                        className: "epi-grid--30 epi-cursor--default",
                        label: confirmationResources.project,
                        renderCell: function (object, value, node, options) {
                            node.textContent  = object.projectName;
                        }
                    }
                }
            };

            this.own(this.content = new declare([Grid])(gridSettings));
            this.content.renderArray(this.projectItems);

            this.set("description", string.substitute(confirmationResources.confirmationtext, [this.projectItems.length, this.contentReferences.length]));
            this.set("confirmActionText", this.projectItems.length === 1 ? confirmationResources.addnewdraft : confirmationResources.addnewdrafts);
        },

        _size: function () {
            this.inherited(arguments);
            this.content.resize();
        }
    });
});

},
'epi-cms/dgrid/listItemFormatters':function(){
define([
// dojo
    "dojo/dom-class",
    "dojo/string",

    //dojox
    "dojox/html/entities",

    // epi
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/dgrid/formatters",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.versionstatus",
    "epi/i18n!epi/nls/episerver.shared",

    // template
    "dojo/text!./templates/ListItem.html"

], function (
// dojo
    domClass,
    string,

    // dojox
    entities,

    // epi
    ContentActionSupport,
    formatters,

    // Resources
    res,
    versionStatusRes,
    sharedResources,

    // Template
    template
) {

    var module;

    function titleSelector(item) {
        return item.path ? item.path.join(" > ") :
            item.name;
    }

    function languageSelector(item) {
        //if the item is not ILocalizable it will not have a specific content language
        if (!item.contentLanguage) {
            return null;
        }
        // If the current content language differs from the contentLanguage for the list item
        // return the content language for the list item
        return item.contentLanguage !== module.contentLanguage ?  { language: item.contentLanguage } : null;
    }

    function statusFormatter(value, object, node/*, options*/) {
        // summary:
        //      Usable for the view to get an icon indicating the status of an item.
        // tags:
        //      public

        var accessLevel = ContentActionSupport.accessLevel,
            cssClass = "epi-statusIndicatorIcon epi-statusIndicator" + object.status,
            title = ContentActionSupport.versionLocalizations[object.status] || "";

        if (object.isDeleted) {
            cssClass = "epi-iconWarning epi-icon--warning";
            title = versionStatusRes.versionnotfound;
            domClass.add(node, "epi-content--deleted");
        } else if (!ContentActionSupport.hasAccess(object.accessMask, accessLevel.Read)) {
            cssClass = "epi-iconLock";
            title = res.status.message.noreadaccess;
            domClass.add(node, "epi-content--no-access");
        } else if (!ContentActionSupport.hasAccess(object.accessMask, accessLevel.Publish)) {
            cssClass = "epi-iconWarning epi-icon--warning";
            title = res.status.message.nopublishaccess;
        }

        return "<span class=\"dijitReset dijitInline dijitIcon epi-objectIcon " + cssClass + "\" title=\"" + title + "\"></span>" + value;
    }

    function cardFormatter(baseCss) {
        // summary:
        //      Renders html for a card view of a list item.
        // tags:
        //      public

        return function formatter(value, object, node, options) {

            var language = languageSelector(object),
                name = value.name || "",
                cardTitle = string.substitute(res.list.card.modifiedbyuser, {
                    modified: formatters.localizedDate(object.modified),
                    userName: formatters.userName(object.userName)
                }),
                status = (ContentActionSupport.versionLocalizations[object.status] || "") + (object.delayPublishUntil ? " " + formatters.localizedDate(object.delayPublishUntil) : ""),
                map,
                typeIdentifier = object.typeIdentifier;

            // If the user lacks read permissions remove the card title and set the name to (Not available)
            if (!ContentActionSupport.hasAccess(object.accessMask, ContentActionSupport.accessLevel.Read)) {
                name = res.status.message.notavailable;
                status = res.status.message.insufficient;
                cardTitle = "";
                typeIdentifier = "";
            }

            if (object.isDeleted) {
                status = versionStatusRes.versionnotfound;
            }

            map = {
                iconResizer: object.thumbnailUrl ? "epi-card__icon epi-card__icon--thumbnailresizer" : "epi-card__icon",
                icon: object.thumbnailUrl ? formatters.thumbnail(object.thumbnailUrl) : typeIdentifier && formatters.contentIcon(typeIdentifier, " epi-icon--large") || "",
                name: entities.encode(name, entities.html),
                nameTooltip: entities.encode(titleSelector(object) || "", entities.html),
                statusIcon: statusFormatter("", object, node, options),
                status: status,
                menu: formatters.menu({title: sharedResources.action.options}),
                cardTitle: cardTitle,
                cardTitleTooltip: res.list.card.lastmodified,
                contentTypeDescription: formatters.contentTypeDescription(typeIdentifier) || "",
                languageBranch: language && language.language || "",
                languageBranchClass: language && language.language ? "epi-card__language-branch" : "epi-card__language-branch--hidden",
                commentsClass: object.hasComments ? "" : "dijitHidden",
                commentsTooltip: res.list.card.hascomments
            };

            //Add classname for each row in dgrid list
            domClass.add(node, baseCss);

            return string.substitute(template, map);
        };
    }

    module = {
        // summary:
        //      A collection of formatters and utilities aiding
        //      rendering item lists.
        // tags:
        //      internal

        contentLanguage: null,

        languageSelector: languageSelector,

        titleSelector: titleSelector,

        statusFormatter: statusFormatter,

        card: [
            cardFormatter("epi-card")
        ],

        "card-compact": [
            cardFormatter("epi-card epi-card--compact")
        ]
    };

    return module;
});

},
'url:epi-cms/dgrid/templates/ListItem.html':"<div class=\"epi-mo\">\r\n    <div class=\"epi-mo--img\">\r\n        <div class=\"dijitIcon ${iconResizer}\">${icon}</div>\r\n    </div>\r\n    <div class=\"epi-mo--body\">\r\n        <div class=\"epi-card__menu\">\r\n            ${menu}\r\n        </div>\r\n        <span class=\"epi-secondaryText dijitInline epi-lozenge ${languageBranchClass}\">${languageBranch}</span>\r\n        <div class=\"epi-card__info\">\r\n            <div class=\"dijitInline\">\r\n                <span class=\"epi-card__title\" title=\"${cardTitleTooltip}\">${cardTitle}</span>\r\n                <span class=\"epi-secondaryText\">\r\n                    ${contentTypeDescription}\r\n                    <span class=\"dijitInline epi-lozenge ${languageBranchClass}\">${languageBranch}</span>\r\n                </span>\r\n            </div>\r\n        </div>\r\n        <div class=\"dijitInline epi-card__title--ellipsis-wrapper\">\r\n            <div>\r\n                <span class=\"dijitInline epi-card__title dojoxEllipsis\" title=\"${nameTooltip}\">${name}</span>\r\n            </div>\r\n            ${statusIcon}<span class=\"epi-secondaryText\">${status}</span>\r\n            <span class=\"dijitInline dijitIcon epi-iconBubble epi-icon--warning ${commentsClass}\" title=\"${commentsTooltip}\"></span>\r\n        </div>\r\n    </div>\r\n</div>",
'epi-cms/project/viewmodels/OverviewViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",
    "epi/dependency",
    "epi-cms/project/command/RefreshProjectItems",
    "epi-cms/project/command/ToggleProjectActivities",
    "./_ProjectViewModel",
    "./ActivityFeedViewModel",
    "./ProjectCommentViewModel",
    "epi/i18n!epi/nls/episerver.cms.components.project.overview.eventfeed"
], function (
    declare,
    lang,
    topic,
    when,
    dependency,
    RefreshProjectItems,
    ToggleProjectActivities,
    _ProjectViewModel,
    ActivityFeedViewModel,
    ProjectCommentViewModel,
    localizations
) {
    return declare([_ProjectViewModel], {
        // summary:
        //
        // tags:
        //      internal

        // contextHistory: [readonly] epi-cms/BackContextHistory
        //      The context history stack
        contextHistory: null,

        // isProjectOverviewActive: [public] Boolean
        //      Indicates if the overview is open
        isProjectOverviewActive: false,

        // _sortOrderProfileKey: [protected] String
        //      The profile key used to store the sort order
        _sortOrderProfileKey: "epi.project-overview-sort-order",

        // _isActivitiesVisibleProfileKey: [protected] String
        //      The profile key used to store whether the activities panel is visible or not
        _isActivitiesVisibleProfileKey: "epi.project-overview-is-activities-visible",

        postscript: function () {
            this.inherited(arguments);
            this.contextHistory = this.contextHistory || dependency.resolve("epi.cms.BackContextHistory");
            this.own(this.projectService.on("currentProjectChanged", lang.hitch(this, this.projectOverviewChanged)));

            this.activityFeedModel = new ActivityFeedViewModel({
                noQueryMessage: localizations.noquerymessage,
                noAccessMessage: localizations.noaccessmessage,
                activitiesStore: this.activitiesStore
            });

            this.projectCommentFeedModel = new ProjectCommentViewModel({
                noQueryMessage: localizations.noquerymessage,
                activitiesStore: this.activitiesStore
            });

        },

        contextChanged: function (/*Object*/context, /*Object*/callerData) {
            // summary:
            //      When context changes
            // tags:
            //      protected
            this.inherited(arguments);

            if (context && context.type === "epi.cms.project") {
                var projectId = parseInt(context.id, 10);
                when(this.projectStore.refresh(projectId)).then(this.set.bind(this, "selectedProject"));
            } else {
                this.set("selectedProject", null);
            }
        },

        projectOverviewChanged: function (project) {
            // summary:
            //      When the project overview changes
            // project: Object
            //      Project
            // tags:
            //      public

            var active = this.get("isProjectOverviewActive"),
                newProjectUri;

            // id is empty when selecting None.
            if (active) {
                if (project && project.id) {
                    newProjectUri = "epi.cms.project:///" + project.id;
                    topic.publish("/epi/shell/context/request", { uri: newProjectUri }, { sender: this });
                } else {
                    this.requestPreviousContext();
                }
            }
        },

        requestPreviousContext: function () {
            // summary:
            //      Navigates back to previous context
            // tags:
            //      public

            this.contextHistory.closeAndNavigateBack(this);
        },

        _createProjectCommands: function () {
            var commands = this.inherited(arguments);

            commands.refreshProject = new RefreshProjectItems({ model: this, category: "project-comments", order: 120 });

            return commands;
        },

        _createProjectItemCommands: function () {

            var commands = this.inherited(arguments);

            commands.toggleProjectActivities = new ToggleProjectActivities({ model: this, order: 100 });

            return commands;
        },

        updateActivityFeed: function (selectedItems) {

            // Update the activity feed view model with the user selection.
            this.activityFeedModel.set({
                selectedProjectId: this.selectedProject && this.selectedProject.id,
                selectedProjectItems: selectedItems
            });
        },

        _selectedProjectSetter: function (selectedProject) {
            this.inherited(arguments);
            this._updateProjectFeedViewModel(selectedProject);
        },

        _updateSelectedProjectDependencies: function (selectedProject) {
            this.inherited(arguments);
            this._updateProjectFeedViewModel(selectedProject);
        },

        _updateProjectFeedViewModel: function (selectedProject) {
            // Update the Project comments feed view model with the new project name and id.
            this.projectCommentFeedModel.set({
                placeholderName: selectedProject && selectedProject.name,
                selectedProjectId: selectedProject && selectedProject.id
            });
        }
    });
});

},
'epi-cms/project/command/RefreshProjectItems':function(){
define([
    "dojo/_base/declare",
    // Parent class
    "./_ProjectCommand",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.shared.action"
], function (
    declare,
    // Parent class
    _ProjectCommand,
    // Resources
    res
) {

    return declare([_ProjectCommand], {
        // summary:
        //      Refreshes the current project.
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.refresh,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconReload",

        category: "projectButton",

        canExecute: true,

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            this.model.refreshProject();
            this.model.refreshActivities();
        }
    });
});

},
'epi-cms/project/command/_ProjectCommand':function(){
define([
    "dojo/_base/declare",
    // Parent class and mixins
    "epi/shell/command/_PropertyWatchCommand"
], function (
    declare,
    // Parent class and mixins
    _PropertyWatchCommand
) {

    return declare([_PropertyWatchCommand], {
        // summary:
        //      A base class for project commands which watches the selectedProject property and causes
        //      _onPropertyChanged to be called when it changes.
        // tags:
        //      internal xproduct

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["selectedProject"],

        _onPropertyChanged: function () {
            // summary:
            //      The default for project commands is to not update canExecute
            //      so we override here and do nothing.
            // tags:
            //      protected override
        }
    });
});

},
'epi-cms/project/viewmodels/_ProjectViewModel':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/Deferred",
    "dojo/Evented",
    "dojo/Stateful",
    "dojo/topic",
    "dojo/dom-class",
    "dojo/promise/all",
    "dojo/when",
    "dojo/string",

    // dijit
    "dijit/Destroyable",

    //epi
    "epi/epi",
    "epi/datetime",
    "epi/dependency",
    "epi/username",
    "epi/shell/_ContextMixin",
    "epi/shell/xhr/errorHandler",
    "epi-cms/plugin-area/project-overview",
    "../../contentediting/ContentActionSupport",

    // Commands
    "epi/shell/command/withConfirmation",
    "../command/AddProject",
    "../command/PublishProject",
    "../command/EditProjectItem",
    "../command/ReadyForReviewProjectItem",
    "../command/ReadyToPublishProjectItem",
    "../command/RefreshProjectItems",
    "../command/RemoveProject",
    "../command/RemoveProjectItem",
    "../command/RemoveProjectScheduling",
    "../command/RenameProject",
    "../command/SortProjectItems",
    "../command/ScheduleProject",

    // Resources
    "epi/i18n!epi/nls/episerver.cms.components.project",
    "epi/i18n!epi/nls/episerver.shared.action"
], function (
// dojo
    declare,
    lang,
    aspect,
    Deferred,
    Evented,
    Stateful,
    topic,
    domClass,
    all,
    when,
    string,

    // dijit
    Destroyable,

    // epi
    epi,
    epiDate,
    dependency,
    username,
    _ContextMixin,
    errorHandler,
    projectOverviewPluginArea,
    ContentActionSupport,

    // Commands
    withConfirmation,
    AddProject,
    PublishProject,
    EditProjectItem,
    ReadyForReviewProjectItem,
    ReadyToPublishProjectItem,
    RefreshProjectItems,
    RemoveProject,
    RemoveProjectItem,
    RemoveProjectScheduling,
    RenameProject,
    SortProjectItems,
    ScheduleProject,

    // Resources
    res,
    resShared
) {
    return declare([Stateful, Destroyable, Evented, _ContextMixin], {
        // summary:
        //      The view model for the epi-cms/project/ProjectComponent
        // tags:
        //      internal xproduct

        // commands: [readonly] epi/shell/command/_Command[]
        //      Commands to be consumed by the view.
        commands: null,

        // namedCommands: [readonly] Object
        //      Way to access commands using named keys.
        namedCommands: null,

        // created: [readonly] string
        //      A view prepared version of the date the selected project was created.
        created: "",

        // createdBy: [readonly] string
        //      A view prepared version of the user that created the selected project.
        createdBy: "",

        // profile: [readonly] Profile
        //      The current user profile
        profile: null,

        // contentLanguage: [readonly] string
        //      The current UI language
        contentLanguage: "",

        dndEnabled: false,

        // isActivitiesVisible: [readonly] Boolean
        //      A flag which indicates whether the activities panel
        //      should be visible.
        isActivitiesVisible: false,

        // projectStore: [readonly] Store
        //      A REST store for interacting with projects.
        projectStore: null,

        // projectSortOrder: [public] Object
        //      The order projects are sorted by.
        projectSortOrder: null,

        // projectItemStore: [readonly] Store
        //      A REST store for interacting with project items.
        projectItemStore: null,

        // projectItemQuery: Query
        //      Query object holding parameters to get a projects items.
        projectItemQuery: null,

        // activitiesStore: [readonly] Store
        //      A REST store for interacting with activities.
        activitiesStore: null,

        // projectItemSortOrder: [public] Object
        //      The order to sort project items by.
        projectItemSortOrder: null,

        // projectStatus: [public] string
        //      State that indicates if a project and it's contents are available.
        projectStatus: "",

        // projectName: [public] string
        //      The name of the selected project.
        projectName: "",

        // notificationMessage: [public] string
        //      The message to show in the notification bar.
        notificationMessage: "",

        // selectedProject: [public] Object
        //      The project that is currently selected.
        selectedProject: null,

        // selectedProjectItems: [public] Array
        //      An array of the project items that are selected through user interaction
        selectedProjectItems: null,

        // projectItemCountMessage: [public] String
        //      Message that is displayed when selecting items in the list
        projectItemCountMessage: "",

        // placeholderState: [public] string
        //      State that indicates if a project and it's contents are available.
        placeholderState: "noProjects",

        // _sortOrderProfileKey: [protected] String
        //      The profile key used to store the sort order
        _sortOrderProfileKey: "epi.project-sort-order",

        // _isActivitiesVisibleProfileKey: [protected] String
        //      The profile key used to store whether the activities panel is visible or not
        _isActivitiesVisibleProfileKey: "epi.project-is-activities-visible",

        _messages: null,

        constructor: function () {
            // Initialize default values for object typed properties.
            this.projectItemSortOrder = [];
            this.projectSortOrder = [{ attribute: "created", descending: true }];
            this.selectedProjectItems = [];

            this.own(projectOverviewPluginArea.on("added, removed", this._updateCommands.bind(this)));
        },

        postscript: function () {
            this.inherited(arguments);

            // Resolve the stores from the registry if they haven't been injected. This allows
            // us to mock the stores when testing.
            this.projectService = this.projectService || dependency.resolve("epi.cms.ProjectService");
            this.projectStore = this.projectStore || dependency.resolve("epi.storeregistry").get("epi.cms.project");
            this.projectItemStore = this.projectItemStore || dependency.resolve("epi.storeregistry").get("epi.cms.project.item");
            this.activitiesStore = this.activitiesStore || dependency.resolve("epi.storeregistry").get("epi.cms.activities");

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");

            this._messages = this.isProjectModeEnabled() ? res.status.message : lang.mixin({}, res.status.message, res.status["messagelegacy"]);

            this._createCommands();

            this.own(
                this.projectService.on("project-item-updated", lang.hitch(this, this._updateSelectedItems)),
                this.projectService.on("project-updated", lang.hitch(this, this._projectUpdated))
            );

        },

        initialize: function () {
            // summary:
            //
            // returns: Promise
            //
            // tags:
            //      public

            return all(
                // Set the sort order based on what is stored in the profile, fall back to default value if nothing stored.
                when(this.profile.get(this._sortOrderProfileKey), lang.hitch(this, function (sort)  {
                    var option = this._findSortOption("key", sort) || this.namedCommands.sortProjectItems.options[0]; // default to name ascending
                    this._changeAttrValue("projectItemSortOrder", option.value); // use the internal setter to not trigger a profile save
                })),
                // Load the selected/current project
                when(this._loadSelectedProject(), lang.hitch(this, function (project) {
                    this._updateSelectedProjectDependencies(project);
                    this._changeAttrValue("selectedProject", project);  // use the internal setter to not trigger a profile save
                })),
                // Get the current content language from the profile
                when(this.profile.getContentLanguage(), lang.hitch(this, function (contentLanguage) {
                    this.set("contentLanguage", contentLanguage);
                })),
                when(this.profile.get(this._isActivitiesVisibleProfileKey), lang.hitch(this, function (isVisible) {
                    //Don´t set value if it is not a boolean
                    if (typeof isVisible === "boolean") {
                        this.set("isActivitiesVisible", isVisible);
                    }
                }))
            );
        },

        isProjectModeEnabled: function () {
            // summary:
            //      Indicates whether project mode is enabled or not
            // tags:
            //      public

            return this.projectService.isProjectModeEnabled;
        },

        getCommands: function () {
            // summary:
            //      Returns all available commands
            // tags:
            //      public

            return this.commands;
        },

        addProject: function (project) {
            // summary:
            //      Adds a project and sets it as the selectedProject
            // tags:
            //      public

            this.projectStore.add(project)
                .then(lang.hitch(this, function (value) {
                    this.set("selectedProject", value);
                }))
                .otherwise(errorHandler.forXhr);
        },

        getProject: function () {
            // summary:
            //      Get the current project.
            // tags:
            //      public

            return this.get("selectedProject");
        },

        updateProject: function (project) {
            // summary:
            //      Adds a project and sets it as the selectedProject
            // tags:
            //      public

            this.projectStore.put(project)
                .then(lang.hitch(this, "set", "selectedProject"))
                .otherwise(errorHandler.forXhr);
        },

        publishProject: function (projectId, delayPublishUntil) {
            // summary:
            //      Publishes a project with given id right away or delay publishing until given delayPublish date.
            // projectId: Number
            //      Id of the project to publish
            // delayPublishUntil: Date?
            //      If supplied, then the project will be delay published.
            // returns: Promise
            // tags:
            //      public

            var self = this;

            return this.projectService.publishProject(projectId, delayPublishUntil)
                .then(function (updatedProject) {
                    return self._updateSelectedProjectAndRefreshContextRequest(updatedProject)
                        .then(function () {
                            return updatedProject;
                        });
                });
        },

        reactivateProject: function (projectId) {
            // summary:
            //      Reactivates a project that has been scheduled to publish.
            // projectId: Number
            //      The ID of the project to reactivate
            // returns: Promise
            // tags:
            //      public

            var self = this;

            if (isNaN(projectId)) {
                throw new Error("The given project ID is not a number.");
            }

            return this.projectService.reactivateProject(projectId)
                .then(function (updatedProject) {
                    return self._updateSelectedProjectAndRefreshContextRequest(updatedProject)
                        .then(function () {
                            return updatedProject;
                        });
                });
        },

        refreshActivities: function () {
            // summary:
            //      Refreshes the activity feed.
            // tags:
            //      public

            this.emit("refresh-activities");
        },

        refreshProject: function (refreshItems) {
            // summary:
            //      Refreshes the selected project, particularly information if the project can be published or not.
            // refreshItems: Boolean
            //      A flag indicating whether to emit a refresh event to also refresh project items. Default true.
            // tags:
            //      public

            var self = this;

            if (refreshItems === undefined) {
                refreshItems = true;
            }

            if (this.selectedProject) {
                return this.projectStore.refresh(this.selectedProject.id).then(
                    function (value) {
                        self.set("selectedProject", value);
                        if (refreshItems) {
                            self.emit("refresh");
                        }
                        return value;
                    },
                    function (ex) {
                        self.set("selectedProject", null);
                    }
                );
            }

            if (refreshItems) {
                this.emit("refresh");
            }
        },

        removeProject: function () {
            // summary:
            //      Removes the selected project and sets the selected project property to null.
            // tags:
            //      public
            var self = this,
                store = this.projectStore;

            if (!this.selectedProject) {
                return new Deferred().resolve();
            }

            return store.remove(this.selectedProject.id).then(function () {
                self.set("selectedProject", null);
            });
        },

        canAddContent: function (contentReferences) {
            // summary:
            //      Verifies that the given content references can be added to the currently selected project
            // contentReferences: Array
            //      The content references to add to the currently selected project
            // returns: Promise
            //      A promise
            // tags:
            //      public

            var selectedProjectId = this.get("selectedProject").id;

            return this.projectService.canAddContent(selectedProjectId, contentReferences);
        },

        canPublishProject: function (project) {
            // summary:
            //      Checks if a project can be published. Uses either a project
            //      as an argument or the currently selected proejct.
            // tags:
            //      public

            var itemStatusCount;

            function noPublishAccess() {
                return Object.keys(itemStatusCount).some(function (key) {
                    if (key.indexOf("nopublishaccess") > -1) {
                        if (itemStatusCount[key] > 0) {
                            return true;
                        }
                    }
                });
            }

            function checkState(state) {
                return itemStatusCount[state] > 0;
            }

            project = project || this.selectedProject;
            itemStatusCount = project && project.itemStatusCount;

            if (this.isProjectModeEnabled()) {
                return !!project && project.itemStatusCount.checkedin > 0;
            } else {
                return !!project && (project.status === "active" || project.status === "publishfailed") &&
                       !noPublishAccess() && !checkState("notcreated") && !checkState("rejected") && !checkState("checkedout") &&
                       (checkState("checkedin") || checkState("published") || checkState("previouslypublished") || checkState("delayedpublish"));
            }
        },

        addProjectItems: function (contentReferences, projectId) {
            // summary:
            //      Adds the given content references as items of the project.
            // tags:
            //      public

            var selectedProject = this.get("selectedProject");

            projectId = projectId || (selectedProject && selectedProject.id);

            if (!projectId) {
                throw new Error("If no projectId is provided a selectedProject must be set in the context");
            }

            return this.projectService.addProjectItems(projectId, contentReferences);
        },

        removeSelectedProjectItems: function () {
            // summary:
            //      Removes the selected project items from the project.
            // tags:
            //      public
            var promise = this.projectService.removeProjectItems(this.selectedProjectItems);
            promise.then(function () {
                this.emit("item-removed");
            }.bind(this));

            return promise;
        },

        markProjectItemsAsReadyForReview: function (comment) {
            // summary:
            //      Mark the selected project items as ready to publish.
            // returns: Promise
            //      A promise that resolves when the refresh project has completed.
            // tags:
            //      public

            return this._setStatusOnProjectItems("markAsReadyForReview", { comment: comment });
        },

        markProjectItemsAsReadyToPublish: function () {
            // summary:
            //      Mark the selected project items as ready to publish.
            // returns: Promise
            //      A promise that resolves when the refresh project has completed.
            // tags:
            //      public

            this._setStatusOnProjectItems("markAsReadyToPublish");
        },

        _setStatusOnProjectItems: function (methodName, options) {
            // summary:
            //      Set the status of the project items using the given method.
            // tags:
            //      private

            // Do an early exit when there are no project items selected.
            if (!this.selectedProjectItems.length) {
                return new Deferred().resolve();
            }

            var self = this;
            var itemIds = this.selectedProjectItems.map(function (item) {
                return item.id;
            });

            return this.projectService[methodName](itemIds, options)
                .then(function () {
                    return when(self.getCurrentContext());
                })
                .then(function (ctx) {
                    var matchingItem;
                    self.selectedProjectItems.some(function (item) {
                        if (item.contentLink === ctx.id) {
                            matchingItem = item;
                            return true;
                        }
                    });
                    if (matchingItem) {
                        self.requestContextChange(matchingItem.contentLink);
                    }
                });
        },

        requestContextChange: function (contextOrContentReference) {
            // summary:
            //      Requests that the UI changes the context to the specified contentReference.
            // tags:
            //      public

            var context = contextOrContentReference.uri ? contextOrContentReference :
                { uri: "epi.cms.contentdata:///" +  contextOrContentReference};

            topic.publish("/epi/shell/context/request", context, { sender: this });
        },

        updateActivityFeed: function (selectedItems) {
            // summary:
            //      Used to update activity feed in project overview
            // tags:
            //      protected
        },

        _projectUpdated: function (project) {
            // summary:
            //      Handle project-updated event
            //      Check if provided project is the same as the currently selected one
            //      then set notificationMessage if projectstatus is publishfailed if true
            // tags:
            //      private
            if (this.selectedProject && this.selectedProject.id === project.id) {
                this.set("selectedProject", project);
            }
        },

        _updateSelectedItems: function (item) {
            // summary:
            //      Update selectedProjectItems with new one if provided item has changed
            // tags:
            //      private

            var selectedLength = this.selectedProjectItems.length;

            for (var i = 0; i < selectedLength; i++) {
                if (this.selectedProjectItems[i].id === item.id) {
                    this.selectedProjectItems[i] = item;
                    this.set("selectedProjectItems", this.selectedProjectItems);

                    // since store has already run refresh on these items, we need to highligt them again in the list
                    this.emit("selected-project-items-updated", this.selectedProjectItems);
                    break;
                }
            }
        },

        onCommandsChanged: function (name, removed, added) {
            // summary:
            //		Callback when available commands have been changed.
            // name: String
            //      Name of the affected command collection
            // removed: Array
            //      An array of removed commands
            // added: Array
            //      An array of added commands
            // tags:
            //		public callback
        },

        _updateCommands: function () {
            var oldCommands = this.commands;
            this._createCommands();
            this.onCommandsChanged("commands", oldCommands, this.commands);
        },

        _createCommands: function () {
            var namedCommands = this._getOrCreateNamedCommands();

            var commands = Object.keys(namedCommands).map(function (key) {
                return namedCommands[key];
            });

            projectOverviewPluginArea.get().forEach(function (command) {
                this.own(command);
                commands.push(command);
            }.bind(this));

            commands = commands.sort(function (a, b) {
                return a.order - b.order;
            });

            this.set("commands", commands);
        },

        _getOrCreateNamedCommands: function () {
            if (this.namedCommands) {
                return this.namedCommands;
            }
            var namedCommands = Object.assign(this._createProjectCommands(), this._createProjectItemCommands());
            this.own.apply(this, namedCommands);
            this.set("namedCommands", namedCommands);
            return namedCommands;
        },

        _createProjectCommands: function () {

            return {
                addProject: new AddProject({ model: this, order: 10 }),
                renameProject: new RenameProject({ model: this, order: 20 }),
                removeProject: new RemoveProject({ model: this, order: 30, store: this.projectStore }),
                publishProject: new PublishProject({ model: this, order: 40 }),
                scheduleProject: new ScheduleProject({ model: this, order: 50 }),
                removeProjectScheduling: withConfirmation(new RemoveProjectScheduling({ model: this, order: 60 }), null, {
                    title: res.command.removeschedulingprojectitem.title,
                    description: res.command.removeschedulingprojectitem.confirmation,
                    confirmActionText: resShared.remove,
                    cancelActionText: resShared.cancel
                })
            };
        },

        _createProjectItemCommands: function () {

            return {
                readyForReviewProjectItem: new ReadyForReviewProjectItem({ model: this, order: 90 }),
                readyToPublishProjectItem: new ReadyToPublishProjectItem({ model: this, order: 100 }),
                editProjectItem: new EditProjectItem({ model: this, order: 110 }),
                removeProjectItem: withConfirmation(new RemoveProjectItem({ model: this, order: 120 }), null, {
                    title: res.command.removeprojectitem.label,
                    description: res.command.removeprojectitem.confirmation,
                    confirmActionText: resShared.remove,
                    cancelActionText: resShared.cancel
                }),
                sortProjectItems: new SortProjectItems({ model: this, order: 130 }),
                refreshProjectItems: new RefreshProjectItems({ model: this, order: 140 })
            };
        },

        _loadSelectedProject: function () {
            // summary:
            //      Loads the selected project
            // returns: Promise
            // tags:
            //      protected

            return this.projectService.getCurrentProject();
        },

        _persistSelectedProject: function (selectedProject) {
            // summary:
            //      Store the selected project in the user profile
            // tags: protected

            this.profile.set(this._selectedProjectProfileKey, selectedProject && selectedProject.id, { location: "server" });
        },

        _persistSortOrder: function (sortOrder) {
            // summary:
            //      Store the project item sort order in the user profile
            // tags: protected

            var option = this._findSortOption("value", sortOrder),
                key = option && option.key || null;

            this.profile.set(this._sortOrderProfileKey, key, { location: "server" });
        },

        _persistIsActivitiesPanelVisible: function (isVisible) {
            // summary:
            //      Store whether the activities panel is visible or not
            // tags: protected

            this.profile.set(this._isActivitiesVisibleProfileKey, isVisible, { location: "server" });
        },

        _findSortOption: function (key, term) {

            var options = this.namedCommands.sortProjectItems.options,
                option = null;

            term && options.some(function (item) {
                if (term === item[key]) {
                    option = item;
                    return true;
                }
            });

            return option;
        },

        _updateSelectedProjectDependencies: function (selectedProject) {

            var created = "",
                createdBy = "",
                delayPublish = "",
                dndEnabled = false,
                notificationMessage = "",
                projectItemQuery = null,
                projectStatus = "",
                projectName = "",
                isProjectModeEnabled = this.isProjectModeEnabled();

            if (selectedProject) {
                created = epiDate.toUserFriendlyString(new Date(selectedProject.created));
                createdBy = username.toUserFriendlyString(selectedProject.createdBy, null, true);
                dndEnabled = (isProjectModeEnabled && selectedProject.status !== "publishing") || selectedProject.status === "active" || selectedProject.status === "publishfailed";
                projectItemQuery = { projectId: selectedProject.id };
                projectName = selectedProject.name;

                if (!this.canPublishProject(selectedProject) || isProjectModeEnabled) {
                    projectStatus = this._messages[selectedProject.status] || "";

                    if (selectedProject.status === "delayedpublished" && !isProjectModeEnabled) {
                        delayPublish = epiDate.toUserFriendlyString(selectedProject.delayPublishUntil);
                        projectStatus = lang.replace(projectStatus, { date: delayPublish });
                        notificationMessage = lang.replace(res.status.state.delayedpublished, { delayPublishUntil: delayPublish });
                    }
                }

                if (selectedProject.status === "publishfailed") {
                    notificationMessage = this._getProjectFailedMessage(selectedProject);
                }
            }

            this.set({
                created: created,
                createdBy: createdBy,
                dndEnabled: dndEnabled,
                notificationMessage: notificationMessage,
                projectItemQuery: projectItemQuery, // Refresh the list query when the selected project changes.
                projectStatus: projectStatus,
                projectName: projectName
            });
        },

        _getProjectFailedMessage: function (selectedProject) {
            // summary:
            //      Helper function to get the project failed notification message
            // returns: String
            // tags: private
            var failedItemsCount = 0,
                notificationMessage = "",
                publishfailed = res.notifications.publishfailed;

            failedItemsCount = this._getUnpublishedItems(selectedProject.itemStatusCount);

            if (failedItemsCount > 0) {
                notificationMessage = lang.replace(failedItemsCount > 1
                    ? publishfailed.notificationtextmultipleitems
                    : publishfailed.notificationtextsingleitem, { failedItemsCount: failedItemsCount });
            }
            return notificationMessage;
        },

        _getUnpublishedItems: function (statuses) {
            // summary:
            //      Helper function to count the amount of unpublished items in the project
            // returns: Integer
            // tags: private
            var count = 0;

            Object.keys(statuses).forEach(function (key) {
                if (key.indexOf("checkedin") === 0) {
                    count += statuses[key];
                }
            });
            return count;
        },

        _isActivitiesVisibleSetter: function (isVisible) {

            if (isVisible === this.isActivitiesVisible) {
                return;
            }
            this.isActivitiesVisible = isVisible;
            this._persistIsActivitiesPanelVisible(isVisible);
        },

        _selectedProjectSetter: function (selectedProject) {

            //Store return the same instance sometimes.
            selectedProject = lang.clone(selectedProject);

            // Early exit if the project has not changed
            if (epi.areEqual(this.selectedProject, selectedProject)) {
                return;
            }

            // Only clear the selection if a new project is selected and
            // not when the current project has been updated.
            if (this.selectedProject && (!selectedProject || this.selectedProject.id !== selectedProject.id)) {
                this.emit("clear-selection");
            }

            this.selectedProject = selectedProject;
            this._updateSelectedProjectDependencies(selectedProject);
        },

        _projectItemSortOrderSetter: function (sortOrder) {
            // summary:
            //      Store the selected project in the user profile

            if (sortOrder && sortOrder === this.projectItemSortOrder) {
                return;
            }

            this.projectItemSortOrder = sortOrder;

            this._persistSortOrder(sortOrder);

        },

        _updateSelectedProjectAndRefreshContextRequest: function (updatedProject) {
            // summary:
            //      Updates the selectedProject with given project and runs the context request change with currently available context
            // returns: Promise
            //      The context which is reloaded/refreshed.
            // tags:
            //      internal

            var self = this;

            // update the selected project and also change context request to current context.
            self.set("selectedProject", updatedProject);

            return when(this.getCurrentContext()).then(function (context) {
                self.requestContextChange(context);
                return context;
            });
        },

        _selectedProjectItemsSetter: function (selectedItems) {
            this.selectedProjectItems = selectedItems;
            this._updateProjectCountMessage(selectedItems);
        },

        _updateProjectCountMessage: function (selectedItems) {

            var items = selectedItems && selectedItems.length > 0 ? selectedItems.length : null,
                message = "";

            function createMessage(count, resourceKey) {
                message = string.substitute(res.notifications.selecteditems[resourceKey], {
                    count: count
                });
            }

            if (items) {
                if (items === 1) {
                    createMessage(items, "singular");
                } else if (items > 1) {
                    createMessage(items, "plural");
                }
            }

            this.set("projectItemCountMessage", message);
        }

    });
});

},
'epi-cms/plugin-area/project-overview':function(){
define([
    "epi/PluginArea"
], function (
    PluginArea
) {

    /*=====
    return {
        // summary:
        //      A plugin area for project items context menu and project publish menu
        // tags:
        //      internal xproduct
    };
    =====*/
    var pluginArea = new PluginArea("epi-cms/project-overview/commands[]");

    return pluginArea;
});

},
'epi-cms/project/command/AddProject':function(){
define([
    "dojo/_base/declare",
    // epi
    "./_ProjectCommand",
    "epi-cms/project/ProjectDialogContent",
    "epi-cms/contentediting/command/_CommandWithDialogMixin",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.newproject"

], function (
    declare,

    // epi
    _ProjectCommand,
    ProjectDialogContent,
    _CommandWithDialogMixin,

    res
) {
    return declare([_ProjectCommand, _CommandWithDialogMixin], {
        // summary:
        //      A command for creating a new project
        // tags:
        //      internal

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.label,

        // title: [public] String
        //      The title text of the command to be used in visual elements.
        title: res.label, // Title for the dialog

        // canExecute: [public] bool
        //      Indicating if the command can execute or not.
        canExecute: true,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPlus",

        // defaultActionsVisible: [public] bool
        //      Setting for the dialog buttons.
        defaultActionsVisible: true,

        // dialogClass: [public] String
        //      Setting for the dialog size.
        dialogClass: "epi-dialog-landscape",

        // confirmActionText: [public] String
        //      Label to be displayed for the confirm (positive) action.
        confirmActionText: res.create,

        // dialogContentClass: [public] bool
        //      Setting for what dialog content to create.
        dialogContentClass: ProjectDialogContent,

        onDialogExecute: function () {
            this.model.addProject(this.dialogContent.get("value"));
        },

        _execute: function () {
            this.showDialog();
        },

        showDialog: function () {
            this.inherited(arguments);

            this._disableActionButton(true);

            this._dialog.own(this.dialogContent.on("change", this._onDialogContentChanged.bind(this)));
        },

        _onDialogContentChanged: function (value) {
            // summary:
            //      Called when the dialog content is changed.
            // tags:
            //      private

            this._disableActionButton(!value || !(value.name.trim()));
        },

        _disableActionButton: function (disable) {
            // summary:
            //      Disables the confirm button if the disable parameter is true.
            // tags:
            //      private

            this._dialog.onActionPropertyChanged({ name: this._dialog._okButtonName }, "disabled", disable);
        }
    });
});

},
'epi-cms/project/ProjectDialogContent':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/keys",
    "epi/dependency",
    // Parent class and mixins
    "epi/shell/widget/FormContainer",
    "epi/shell/widget/dialog/_DialogContentMixin"
], function (
    declare,
    lang,
    keys,
    dependency,
    // Parent class and mixins
    FormContainer,
    _DialogContentMixin
) {

    return declare([FormContainer, _DialogContentMixin], {
        // summary:
        //      This is an internal class to help with displaying the project dialog correctly.
        // tags:
        //      internal xproduct

        // _metadataManager: [readonly] Object
        //      The metadata manager used to request metadata about the type that will be displayed.
        _metadataManager: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.metadata) {
                // Resolve the metadata that will be used when constructing the view for this form.
                var metadataManager = this._metadataManager || dependency.resolve("epi.shell.MetadataManager");
                this.metadata = metadataManager.getMetadataForType("EPiServer.Cms.Shell.UI.Rest.Projects.Internal.Models.ProjectViewModel");
            }
        },

        postCreate: function () {
            this.inherited(arguments);

            this.on("keypress", lang.hitch(this, function (e) {
                if (e.keyCode === keys.ENTER && this.isValid()) {
                    this.executeDialog();
                }
            }));
        }
    });
});

},
'epi-cms/project/command/PublishProject':function(){
define([
    "dojo/_base/declare",
    "dojo/string",
    // Parent class
    "epi-cms/project/command/_ProjectCommand",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.publishproject"
], function (
    declare,
    string,
    // Parent class
    _ProjectCommand,
    // Resources
    res
) {

    return declare([_ProjectCommand], {
        // summary:
        //      Publish project
        //
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "publishmenu-primary",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.label,

        // isExecuting: [public] Boolean
        //      Indicates whether the command is currently executing.
        isExecuting: false,

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected

            var model = this.model,
                self = this;

            self.set("isExecuting", true);

            model.publishProject(this.model.selectedProject.id).then(
                function () {
                    self.set("isExecuting", false);
                },
                function () {
                    self.set("isExecuting", false);
                });
        },

        _onPropertyChanged: function () {
            // summary:
            //      Sets canExecute based on the state of the model.
            // tags:
            //      protected
            //
            var selectedProject = this.model.selectedProject,
                status = selectedProject && selectedProject.status,
                canExecute = this.model.canPublishProject(selectedProject),
                projectMode = this.model.isProjectModeEnabled();

            // The command shouldn't be executable if a project is not selected or cannot be published.
            this.set({
                canExecute: canExecute,
                isAvailable: projectMode || (status !== "published" && status !== "delayedpublished"),
                isExecuting: status === "publishing"
            });
        },

        _updateLabel: function () {
            // summary:
            //      Updates the label with the itemcount
            // tags:
            //      private

            var project = this.model && this.model.selectedProject,
                itemCount = (project && project.itemStatusCount.checkedin) || 0,
                data = { count: itemCount > 0 ? itemCount + " " : "" },
                label;

            if (this.isExecuting) {
                label = itemCount === 1 ? res.labelexecuting.singular : res.labelexecuting.plural;
            } else if (!this.isAvailable) {
                label = res.labelexecuted;
            } else {
                label = itemCount === 1 ? res.label.singular : res.label.plural;
            }

            this.set("label", string.substitute(label, data));
        },

        _isExecutingSetter: function (value) {
            // summary:
            //      Sets the state whether the command is currently executing.
            // value: Boolean
            // tags:
            //      private

            this.isExecuting = value;
            this._updateLabel();
        }
    });
});

},
'epi-cms/project/command/EditProjectItem':function(){
define([
    "dojo/_base/declare",

    "epi-cms/contentediting/ContentActionSupport",

    // Parent class
    "./_ProjectCommand",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.shared.action"
],
function (
    declare,
    ContentActionSupport,
    // Parent class
    _ProjectCommand,
    // Resources
    actionStrings
) {
    return declare([_ProjectCommand], {
        // summary:
        //      A command for switching to the edit view for a project item.
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "menuWithSeparator",

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPen",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: actionStrings.edit,

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["selectedProjectItems"],

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected

            // Get the one and only project item from the array.
            var selectedItem = this.model.selectedProjectItems[0];

            this.model.requestContextChange(selectedItem.contentLink);
        },

        _onPropertyChanged: function () {
            // summary:
            //      This command is able to execute if there is a single selected project item.
            // tags:
            //      protected
            var canExecute = false,
                permissionMap;

            var items = this.model && this.model.selectedProjectItems;

            this.set("label", actionStrings.edit);
            this.set("iconClass", "epi-iconPen");

            if (items && items.length === 1) {
                permissionMap = ContentActionSupport.getPermissionMap(items[0].accessMask);

                if (permissionMap.Read && !permissionMap.Edit) {
                    canExecute = permissionMap.Read;
                    this.set("label", actionStrings.view);
                    this.set("iconClass", "epi-iconSearch");
                } else {
                    canExecute = permissionMap.Edit;
                }
            }

            this.set("canExecute", !!canExecute);
        }

    });
});

},
'epi-cms/project/command/ReadyForReviewProjectItem':function(){
define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "epi-cms/contentediting/ContentActionSupport",
    // Resources
    "epi/i18n!epi/nls/episerver.cms.components.project.command.readyforreviewprojectitem",
    // Parent class
    "epi-cms/content-approval/command/ReadyForReview"
], function (
    declare,
    Deferred,
    ContentActionSupport,
    // Resources
    localizations,
    // Parent class
    ReadyForReview
) {

    return declare([ReadyForReview], {
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "itemContext",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localizations.label,

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["selectedProjectItems"],

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            var requiresComment = this.model.selectedProjectItems.some(function (item) {
                return item.isStartCommentRequired;
            });
            if (requiresComment) {
                this._executeDeferred = new Deferred();
                this.showDialog();
                return this._executeDeferred.promise;
            } else {
                return this._executeServiceMethod();
            }
        },

        _executeServiceMethod: function (reason) {
            return this.model.markProjectItemsAsReadyForReview(reason);
        },

        _onPropertyChanged: function () {
            // summary:
            //      Sets canExecute based on the state of the model.
            // tags:
            //      protected
            var items = this.model && this.model.selectedProjectItems,
                status = ContentActionSupport.versionStatus,
                canExecute = items && items.length > 0 && items.every(function (item) {
                    return !item.isDeleted
                        && item.hasApprovalDefinition
                        && (item.status === status.CheckedOut || item.status === status.Rejected)
                        && ContentActionSupport.hasAccess(item.accessMask, ContentActionSupport.accessLevel.Edit);
                });

            this.set("canExecute", !!canExecute);
        }
    });
});

},
'epi-cms/project/command/ReadyToPublishProjectItem':function(){
define([
    "dojo/_base/declare",
    "epi-cms/contentediting/ContentActionSupport",
    // Resources
    "epi/i18n!epi/nls/episerver.cms.components.project.command.readytopublishprojectitem",
    // Parent class
    "epi-cms/project/command/_ProjectCommand"
], function (
    declare,
    ContentActionSupport,
    // Resources
    localizations,
    // Parent class
    _ProjectCommand
) {

    return declare([_ProjectCommand], {
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "menuWithSeparator",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localizations.label,

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["selectedProjectItems"],

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            return this.model.markProjectItemsAsReadyToPublish();
        },

        _onPropertyChanged: function () {
            // summary:
            //      Sets canExecute based on the state of the model.
            // tags:
            //      protected
            var items = this.model && this.model.selectedProjectItems,
                status = ContentActionSupport.versionStatus,
                canExecute = items && items.length > 0 && items.every(function (item) {
                    return !item.isDeleted
                        && !item.hasApprovalDefinition
                        && (item.status === status.CheckedOut || item.status === status.Rejected)
                        && ContentActionSupport.hasAccess(item.accessMask, ContentActionSupport.accessLevel.Edit);
                });

            this.set("canExecute", !!canExecute);
        }
    });
});

},
'epi-cms/project/command/RemoveProject':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/when",
    "./RemoveProjectConfirmation",
    // Resources
    "epi/i18n!epi/nls/episerver.cms.components.project.command.removeproject",
    // Parent class
    "./_ProjectCommand"
], function (
    declare,
    lang,
    on,
    when,
    RemoveProjectConfirmation,
    // Resources
    res,
    // Parent class
    _ProjectCommand
) {

    return declare([_ProjectCommand], {
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "context",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.label,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconTrash",

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            var project = this.model.getProject();
            this.model.projectService.hasScheduledProjectItems(project.id)
                .then(this._createRemoveProjectConfirmationDialog.bind(this));
        },

        _createRemoveProjectConfirmationDialog: function (hasScheduledItems) {
            // summary:
            //      Creates different remove confirmation dialog whether there is scheduled items or not.
            // hasScheduledItems: Boolean
            //      If the project have scheduled items
            // tags:
            //      protected
            var isScheduled = this.model.getProject().status === "delayedpublished",
                dialog = new RemoveProjectConfirmation({ isScheduledProject: hasScheduledItems && isScheduled });

            on.once(dialog, "execute", lang.hitch(this, "_removeProject"));

            dialog.show();
        },

        _removeProject: function (keepScheduling) {
            // summary:
            //      Removes the project on the server and reactivates the project items if keepScheduling is set to false.
            // tags:
            //      private

            var model = this.model,
                project = model.getProject(),
                promise = !keepScheduling && model.reactivateProject(project.id);

            when(promise)
                .then(function () {
                    return model.removeProject();
                })
                .otherwise(function (error) {
                    console.error("An error occured while removing the project.", error);
                });
        },

        _onPropertyChanged: function () {
            var project = this.model.getProject();
            // The command shouldn't be executable if a project is not selected and the project is deleted
            this.set("canExecute", !!project && !project.isDeleted);
        }
    });
});

},
'epi-cms/project/command/RemoveProjectConfirmation':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    // Resources
    "epi/i18n!epi/nls/episerver.cms.components.project.command.removeproject",
    "epi/i18n!epi/nls/episerver.shared.action",
    // Parent class
    "epi/shell/widget/dialog/Confirmation"
], function (
    declare,
    lang,
    // Resources
    localization,
    sharedLocalization,
    // Parent class
    Confirmation
) {

    return declare([Confirmation], {
        // tags:
        //      internal

        // isScheduledProject: [public] Boolean
        //      Flag which indicates whether the dialog should be formatted for a scheduled project.
        isScheduledProject: false,

        // dialogClass: [protected] String
        //      Class to apply to the root DOMNode of the dialog.
        dialogClass: "epi-dialog-confirm epi-dialog--wide",

        postMixInProperties: function () {
            // summary:
            //      Mixin language resources to the dialog.
            // tags:
            //      protected
            this.inherited(arguments);

            this.title = this.isScheduledProject ? localization.scheduledlabel : localization.label;
            this.description = this.isScheduledProject ? localization.scheduledconfirmation : localization.confirmation;
        },

        getActions: function () {
            // summary:
            //      Overridden from Dialog base to assemble the action collection
            // returns:
            //      A collection of action definitions that can be added to the action pane.
            // tags:
            //      protected

            var keepScheduling = {
                    name: "keepScheduling",
                    label: this.isScheduledProject ? localization.deleteandkeepscheduling : sharedLocalization.deletelabel,
                    action: lang.hitch(this, "onExecute", true), // true indicated that scheduling should be kept
                    settings: { "class": "epi-plain-button" }
                },
                removeScheduling = {
                    name: "removeScheduling",
                    label: localization.deleteandremovescheduling,
                    action: lang.hitch(this, "onExecute", false), // false indicated that scheduling should be removed
                    settings: { "class": "epi-outlined-button" }
                },
                cancel = {
                    name: "cancel",
                    label: sharedLocalization.cancel,
                    action: lang.hitch(this, this.onCancel),
                    settings: { "class": "Salt", firstFocusable: true }
                };

            return this.isScheduledProject ? [keepScheduling, removeScheduling, cancel] : [keepScheduling, cancel];
        }
    });
});

},
'epi-cms/project/command/RemoveProjectItem':function(){
define([
    "dojo/_base/declare",

    // Parent class
    "./_ProjectCommand",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.removeprojectitem"
],
function (
    declare,
    // Parent class
    _ProjectCommand,
    // Resources
    res
) {
    return declare([_ProjectCommand], {
        // summary:
        //      A command for removing items from a project.
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "itemContext",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.label,

        // propertiesToWatch: [public] Array
        //      A list of properties to watch for changes.
        propertiesToWatch: ["selectedProjectItems"],

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            return this.model.removeSelectedProjectItems();
        },

        _onPropertyChanged: function () {
            // summary:
            //      This command is able to execute if there is a selected project and item and the project
            //      is in an active or publish failed state.
            // tags:
            //      protected

            var self = this,
                model = this.model,
                hasItems = model && model.selectedProjectItems && model.selectedProjectItems.length,
                project = model.selectedProject;

            this.set("canExecute", false);

            this.model.projectService.getCurrentProject()
                .then(function (currentProject) {
                    var isActive = project && (project.status === "active" || project.status === "publishfailed" || currentProject);
                    self.set("canExecute", !!(hasItems && isActive));
                });
        }
    });
});

},
'epi-cms/project/command/RemoveProjectScheduling':function(){
define([
    "dojo/_base/declare",

    // Parent class
    "epi-cms/project/command/_ProjectCommand",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command"

], function (
    declare,

    // Parent class
    _ProjectCommand,

    // Resources
    res
) {

    return declare([_ProjectCommand], {
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "publishmenu",

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconClose",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.removeschedulingprojectitem.label,

        postscript: function () {
            // tags:
            //      public

            this.inherited(arguments);

            if (!this.model.isProjectModeEnabled()) {
                this.set("label", res.removeschedulingproject.label);
            }
        },

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            var model = this.model;

            return model.reactivateProject(model.selectedProject.id);
        },

        _onPropertyChanged: function () {
            // summary:
            //      Sets canExecute based on the state of the model.
            // tags:
            //      protected

            var selectedProject = this.model.selectedProject,
                isScheduled;

            isScheduled = !!selectedProject &&
                            (this.model.isProjectModeEnabled() ?
                                selectedProject.itemStatusCount.delayedpublish > 0 :
                                selectedProject.status === "delayedpublished");

            this.set("canExecute", isScheduled);
            this.set("isAvailable", isScheduled);
        }
    });
});

},
'epi-cms/project/command/RenameProject':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi-cms/project/ProjectDialogContent",
    // Parent class and mixins
    "epi-cms/project/command/_ProjectCommand",
    "epi-cms/contentediting/command/_CommandWithDialogMixin",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.renameproject"
], function (
    declare,
    lang,
    ProjectDialogContent,
    // Parent class and mixins
    _ProjectCommand,
    _CommandWithDialogMixin,
    // Resources
    localization
) {

    return declare([_ProjectCommand, _CommandWithDialogMixin], {
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "context",

        // dialogClass: [public] String
        //      The CSS class to be applied to the .
        dialogClass: "epi-dialog-landscape",

        // dialogContentClass: [public] Function
        //      Setting for what dialog content to create.
        dialogContentClass: ProjectDialogContent,

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localization.label,

        // title: [public] String
        //      The text to be displayed as the title in the dialog.
        title: localization.label,

        // confirmActionText: [public] String
        //      Label to be displayed for the confirm (positive) action.
        //      Override from _CommandWithDialogMixin.
        confirmActionText: localization.confirmationtext,

        iconClass: "epi-iconRename",

        onDialogExecute: function () {
            // summary:
            //      Process the value returned from the dialog after it's executed.
            // tags:
            //      protected callback
            var value = lang.mixin(this.value, this.dialogContent.get("value"));

            this.model.updateProject(value);
        },

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            this.showDialog();
        },

        _onPropertyChanged: function () {
            var project = this.model.getProject();

            // The command shouldn't be executable if a project is not selected and the project is deleted
            this.set("canExecute", !!project && !project.isDeleted);

            // Set the value that will be used as the default values in the dialog.
            this.set("value", lang.clone(project));
        },

        showDialog: function () {
            this.inherited(arguments);
            this._dialog.own(this.dialogContent.on("change", this._onDialogContentChanged.bind(this)));
        },

        _onDialogContentChanged: function (value) {
            // summary:
            //      Called when the dialog content is changed.
            // tags:
            //      private

            this._disableActionButton(!value || !(value.name.trim()));
        },

        _disableActionButton: function (disable) {
            // summary:
            //      Disables the confirm button if the disable parameter is true.
            // tags:
            //      private

            this._dialog.onActionPropertyChanged({ name: this._dialog._okButtonName }, "disabled", disable);
        }
    });
});

},
'epi-cms/project/command/SortProjectItems':function(){
define([
    "dojo/_base/declare",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.sort",
    // Parent class
    "epi/shell/command/OptionCommand"
], function (
    declare,
    // Resources
    localizations,
    // Parent class
    OptionCommand
) {

    return declare([OptionCommand], {
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "projectButton",

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconSort",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localizations.label,

        // options: [readonly] Array
        //      An array of options objects that can be selected.
        options: null,

        // property: [readonly] String
        //      The name of the property on the model that will be set with the selected value on execute.
        property: "projectItemSortOrder",

        constructor: function () {
            this.options = [
                { label: localizations.nameascending,      key: "+Name",                  value: [{ attribute: "name", descending: false }]},
                { label: localizations.namedescending,     key: "-Name",                  value: [{ attribute: "name", descending: true }]},
                { label: localizations.status,             key: "+Status",                value: [{ attribute: "status", descending: false }, { attribute: "name", descending: false }]},
                { label: localizations.type,               key: "+PrimaryTypeIdentifier", value: [{ attribute: "primaryTypeIdentifier", descending: false }, { attribute: "name", descending: false }]},
                { label: localizations.modifieddescending, key: "-Modified",              value: [{ attribute: "modified", descending: true }, { attribute: "name", descending: false }]},
                { label: localizations.modifiedascending,  key: "+Modified",              value: [{ attribute: "modified", descending: false }, { attribute: "name", descending: false }]}
            ];
        }
    });
});

},
'epi-cms/project/command/ScheduleProject':function(){
define([
    "dojo/_base/declare",

    "./_ProjectCommand",
    "../ProjectSchedulingDialog",
    "../ProjectSchedulingDialogViewModel",

    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command"
],
function (
    declare,

    _ProjectCommand,
    ProjectSchedulingDialog,
    ProjectSchedulingDialogViewModel,

    res
) {

    return declare([_ProjectCommand], {
        // summary:
        //      Command for setting scheduled publishing on a project.
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "publishmenu",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.scheduleprojectitem.label,

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconClock",

        postscript: function () {
            // tags:
            //      public

            this.inherited(arguments);

            if (!this.model.isProjectModeEnabled()) {
                this.set("label", res.scheduleproject.label);
            }
        },

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected

            var model = this.model,
                project = model.selectedProject,
                viewModel = new ProjectSchedulingDialogViewModel({
                    title: project.name,
                    query: { projectId: project.id, scheduled: true }
                }),
                dialog = new ProjectSchedulingDialog({model: viewModel});

            dialog.on("execute", function () {
                model.publishProject(project.id, viewModel.dateValue);
            });

            dialog.show();
        },

        _onPropertyChanged: function () {
            // summary:
            //      Sets canExecute based on the state of the model.
            // tags:
            //      protected

            this.set("canExecute", this.model.canPublishProject());
            this._updateIsAvailable();
        },

        _updateIsAvailable: function () {
            // summary:
            //      Update isAvailable state on the project
            // tags:
            //      private

            var isAvailable,
                project = this.model.selectedProject,
                status = project && project.status;

            if (this.model.isProjectModeEnabled()) {
                isAvailable = true;
            } else {
                // Check delay published as well
                isAvailable = status !== "published" && status !== "delayedpublished";
            }

            this.set("isAvailable", isAvailable);
        }
    });
});

},
'epi-cms/project/ProjectSchedulingDialog':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/on",
    "epi-cms/contentediting/ScheduledPublishSelector",
    "epi/shell/widget/DelayableStandby",
    "epi/shell/widget/dialog/Dialog",
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.scheduleproject"
], function (
    declare,
    lang,
    Deferred,
    on,
    ScheduledPublishSelector,
    DelayableStandby,
    Dialog,
    res
) {

    return declare([Dialog], {
        // summary:
        //      Custom dialog for scheduling a project. The dialog will show a standby spinner if loading takes time
        // tags:
        //      internal

        dialogClass: "epi-dialog-contentReferences",

        title: res.label,

        // defaultActionsVisible:
        //      Set to false to hide the default actions
        defaultActionsVisible: false,

        // _contentLoaded: [private] Deferred
        //      A deferred resolved when the already scheduled items in the dialog has been loaded
        _contentLoaded: null,

        constructor: function () {
            this._contentLoaded = new Deferred();
        },

        buildRendering: function () {
            // summary:
            //      Overridden to create the publish selector and the standby spinner shown when loading takes time
            this.inherited(arguments);

            this.own(
                this.content = new ScheduledPublishSelector({ model: this.model }),
                this._standby = new DelayableStandby({target: document.body, zIndex: 999}).placeAt(document.body),
                on.once(this.content, "contentreferencegrid-loading-complete", this._contentLoaded.resolve)
            );
        },

        show: function () {
            // summary:
            //      Show the dialog and

            var showArgs = arguments;

            // Start loading data
            if (!this._started) {
                this.startup();
            }

            this._standby.show();

            return this._contentLoaded.then(lang.hitch(this, function () {
                // Once the grid has finished loading the dialog can be shown.
                this._standby.hide();
                return this.inherited(showArgs);
            }));
        }
    });
});

},
'epi-cms/project/ProjectSchedulingDialogViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/dependency",
    "dojo/topic",
    "epi-cms/dgrid/formatters",
    "./ContentReferenceGridModel",
    "epi-cms/contentediting/ScheduledPublishSelectorViewModel",
    //Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.scheduleproject",
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.contentreferencelist",
    "epi/i18n!epi/cms/nls/episerver.shared.action",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.scheduledpublishselector"
], function (
    declare,
    lang,
    dependency,
    topic,
    formatters,
    ContentReferenceGridModel,
    ScheduledPublishSelectorViewModel,
    cmdRes,
    resources,
    action,
    res
) {

    return declare([ContentReferenceGridModel, ScheduledPublishSelectorViewModel], {
        // summary:
        //      Grid model for contents of a project returned from a project item store
        // tags:
        //      internal

        dateLabel: res.publishchangeson,

        notificationText: res.alreadyscheduleditems,

        _totalItemsSetter: function (value) {
            // summary:
            //      Updates the resultSummary property when totalItems changes

            this.totalItems = value;
            if (value) {
                var message = (value === 1 ? resources.itemintotal : resources.itemsintotal);
                this.set("resultSummary", lang.replace(message, [value]));
            }
        },

        onItemClicked: function (item) {
            // summary:
            //      Raised when navigation to an item is triggered from the view
            topic.publish("/epi/shell/context/request", { uri: item.contentUri });
        },

        postscript: function () {
            this.inherited(arguments);

            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.project.item");

            this.columns = {
                primaryTypeIdentifier: {
                    label: "",
                    className: "epi-grid-column--snug epi-cursor--default",
                    formatter: formatters.contentIcon
                },
                name: {
                    label: "",
                    className: "epi-grid--30 epi-cursor--default"
                },
                path: {
                    label: "",
                    formatter: formatters.path,
                    className: "epi-grid--35 epi-cursor--default"
                },
                delayPublishUntil: {
                    label: "",
                    formatter: formatters.localizedDate,
                    className: "epi-grid--25 epi-grid-column--centered epi-cursor--default dgrid-column-treePath"
                },
                contentUri: {
                    formatter: function () {
                        return "<a class=\"epi-visibleLink\">" + action.view + "</a>";
                    },
                    className: "dgrid-column-view"
                }
            };
        }
    });
});

},
'epi-cms/project/ContentReferenceGridModel':function(){
define([
    "dojo/_base/declare",
    "dojo/Stateful"
],
function (declare,
    Stateful) {

    return declare([Stateful], {
        // summary:
        //      A model for the ContentReferenceGrid. A store and column configuration is required for showing contents in the grid
        // tags:
        //      internal

        onItemClicked: function (item) { },

        // resultSummary: String
        //      A summary for the result shown above the grid to the right of the refresh button
        resultSummary: "",

        // notificationText: String
        //      A notification text describing summary for the result shown above the grid to the right of the refresh button
        notificationText: "",

        // store: dojo/store/api/Store
        //      A data store to query for the items in the grid
        store: null,

        // query: Object
        //      An object with parameters used whn querying the store
        query: null,

        // columns: object
        //      dgrid column configuration
        columns: null,

        // totalItems: Number
        //      The total items shown in the grid. Updated as the grid refreshes.
        totalItems: null
    });
});

},
'epi-cms/project/viewmodels/ActivityFeedViewModel':function(){
define([
    "dojo/_base/declare",
    // Parent class and mixins
    "./_ProjectFeedViewModel"
], function (
    declare,
    // Parent class and mixins
    _ProjectFeedViewModel
) {

    return declare([_ProjectFeedViewModel], {
        // summary:
        //      View model for the activity feed. Handles setting query and store state as well as
        //      saving new message activities.
        // tags:
        //      internal

        // _contentLink: [private] String
        //      Content link of the selected project item.
        _contentLink: null,

        postscript: function () {
            this.inherited(arguments);

            // Set the default no data message to be no query.
            this.set("noDataMessage", this.noQueryMessage);
        },

        _selectedProjectItemsSetter: function (selectedItems) {

            selectedItems = selectedItems || [];

            // Map the selected items to a list of content references filtering out items that
            // don't have a content link, e.g. when user doesn't have access to the item.
            var references = selectedItems.filter(function (item) {
                return !!item.contentLink;
            });

            // Single selection is determined by whether there is one item selected and
            // whether the user has access to that item.
            var isSingleItem = selectedItems.length === 1 && references.length === 1;

            this.set("isSingleItemSelected", isSingleItem);

            // Set the placeholder text using the single items name.
            var placeholderName = isSingleItem ? references[0].name : "";
            this.set("placeholderName", placeholderName);

            // Set parameters needed by the add message function.
            this._contentLink = isSingleItem ? references[0].contentLink : null;

            // If there is no query then set the no data message to reflect that; otherwise
            // default to the no access message since an empty result set indicates that the
            // user has no access.
            this.set("noDataMessage", selectedItems.length ? this.noAccessMessage : this.noQueryMessage);

            // If there is no query then set the store to null so that the
            // dgrid doesn't query for everything.
            this.set("store", references.length ? this.activitiesStore : null);

            // Set the activity query if there are selected items otherwise set null.
            var query = {
                contentReferences: references.map(function (item) {
                    return item.contentLink;
                }),
                projectId: this.selectedProjectId
            };
            this.set("query", references.length ? query : null);
        }
    });
});

},
'epi-cms/project/viewmodels/ProjectCommentViewModel':function(){
define([
    "dojo/_base/declare",
    "epi/i18n!epi/cms/nls/episerver.cms.activities.commentfeed",
    // Parent class and mixins
    "./_ProjectFeedViewModel"
], function (
    declare,
    localizations,
    // Parent class and mixins
    _ProjectFeedViewModel
) {

    return declare([_ProjectFeedViewModel], {
        // summary:
        //      View model for the project comments feed. Handles setting query and store state as well as
        //      saving new message activities.
        // tags:
        //      internal

        // isSingleItemSelected: [readonly] Boolean
        //      Indicates whether there is only a single item selected.
        isSingleItemSelected: true, //force show comment form

        // noDataMessage: [readonly] String
        //      The message displayed when no data is available.
        noDataMessage: localizations.nodatamessage,

        _selectedProjectIdSetter: function (projectId) {
            this.selectedProjectId = projectId;

            // If no project id is given then set the store to null to disable querying.
            this.set("store", projectId ? this.activitiesStore : null);
            this.set("query", { projectId: projectId, activityType: "ProjectMessageActivity" });
        }
    });
});

},
'url:epi-cms/project/templates/Overview.html':"<div class=\"epi-project-overview\">\r\n    <div data-dojo-attach-point=\"toolbar\" class=\"epi-project-overview__toolbar epi-viewHeaderContainer epi-editToolbarMedium\">\r\n        <h2 class=\"dijitInline\">\r\n            <div class=\"dijitInline epi-iconObjectProject epi-icon--large\"></div>\r\n            <span data-dojo-attach-point=\"projectNameNode\"></span>\r\n        </h2>\r\n        <div class=\"epi-project-overview__toolbar__trailing\">\r\n            <div data-dojo-type=\"dijit/form/DropDownButton\"\r\n                 data-dojo-attach-point=\"publishContainer\"\r\n                 data-dojo-props=\"showLabel: true, label: this.res.overview.publishdropdown.label\"\r\n                 data-dojo-attach-event=\"onClick:_publishMenuClickHandler\"\r\n                 class=\"epi-mediumButton epi-button--bold\">\r\n                <span></span>\r\n                <div data-dojo-type=\"epi-cms/project/PublishMenu\"\r\n                     data-dojo-attach-point=\"publishMenu\"\r\n                     data-dojo-props=\"commandSource: this.model\">\r\n                    <section data-epi-section=\"primarySection\">\r\n                        <span data-dojo-attach-point=\"projectStatusMessageNode\"></span>\r\n                    </section>\r\n                    <section data-epi-section=\"statusSection\">\r\n                        <ul>\r\n                            <li>\r\n                                ${res.view.createdby} <span data-dojo-attach-point=\"createdByNode\" class=\"epi-username\"></span>,\r\n                                <span data-dojo-attach-point=\"createdNode\" class=\"epi-timestamp\"></span>\r\n                            </li>\r\n                        </ul>\r\n                    </section>\r\n                </div>\r\n            </div>\r\n            <button data-dojo-type=\"dijit/form/Button\"\r\n                    data-dojo-attach-point=\"closeButton\"\r\n                    data-dojo-attach-event=\"onClick:_close\"\r\n                    data-dojo-props=\"showLabel: true, label: this.res.overview.closebutton.label\"\r\n                    class=\"epi-mediumButton epi-button--bold\"></button>\r\n        </div>\r\n    </div>\r\n\r\n    <div data-dojo-attach-point=\"tabs\" data-dojo-type=\"dijit/layout/TabContainer\">\r\n        <div data-dojo-type=\"epi-cms/project/ProjectItemList\"\r\n             data-dojo-attach-point=\"itemList\"\r\n             data-dojo-props=\"title: this.res.overview.title, commandSource: this.model, res: this.res.overview\">\r\n\r\n                <section data-epi-section=\"toolbarSection\">\r\n                    <div data-dojo-attach-point=\"toolbarTextNode\" class=\"epi-project-item-list__item-count-message-node\"></div>\r\n                    <div data-dojo-attach-point=\"toolbarGroupNode\" class=\"epi-floatRight\"></div>\r\n                </section>\r\n                <section data-epi-section=\"activitySection\">\r\n                    <div data-dojo-type=\"epi-cms/activity/ActivityFeed\"\r\n                         data-dojo-attach-point=\"activityFeed\"\r\n                         data-dojo-props=\"model: this.model.activityFeedModel\"></div>\r\n                </section>\r\n        </div>\r\n\r\n        <div data-dojo-type=\"epi-cms/activity/ActivityFeed\"\r\n             data-dojo-attach-point=\"projectComments\"\r\n             data-dojo-props=\"title: this.res.comments.title, model: this.model.projectCommentFeedModel\"\r\n             class=\"epi-project-comment-feed\">\r\n            <div data-dojo-type=\"dijit/Toolbar\"\r\n                 data-dojo-attach-point=\"projectCommentsToolbar\"\r\n                 class=\"epi-project-item-list__toolbar epi-flatToolbar\">\r\n            </div>\r\n         </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/project/ProjectItemList':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-geometry",
    "dojo/dom-class",
    "dojo/keys",
    "dojo/on",

    // dijit
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",
    "dijit/_CssStateMixin",

    // dgrid
    "dgrid/Keyboard",
    "dgrid/OnDemandList",
    "dgrid/Selection",
    "dgrid/extensions/DijitRegistry",

    // epi
    "epi",
    "epi/shell/dnd/Target",
    "epi/shell/dgrid/Focusable",
    "epi/shell/dgrid/Formatter",
    "epi/shell/dgrid/Responsive",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/widget/_SectionedTemplatedMixin",
    "epi-cms/extension/events",
    "epi-cms/dgrid/listItemFormatters",
    "epi-cms/dgrid/WithContextMenu",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project",

    // template
    "dojo/text!./templates/ProjectItemList.html"
],
function (
// dojo
    declare,
    lang,
    aspect,
    domGeometry,
    domClass,
    keys,
    on,

    // dijit
    _WidgetsInTemplateMixin,
    _LayoutWidget,
    _CssStateMixin,

    // dgrid
    Keyboard,
    OnDemandList,
    Selection,
    DijitRegistry,

    // epi
    epi,
    Target,
    Focusable,
    Formatter,
    Responsive,
    _FocusableMixin,
    _SectionedTemplatedMixin,
    events,
    listItemFormatters,
    WithContextMenu,

    // Resources
    res,

    // template
    template
) {

    return declare([_LayoutWidget, _SectionedTemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin, _FocusableMixin], {
        // summary:
        //
        // tags:
        //      internal

        contentLanguage: null,

        commandProvider: null,

        dndEnabled: false,

        sections: ["toolbarSection", "listContainer", "activitySection"],

        templateString: template,

        // listItemType: [public] String
        //      What type of formatting to use from listItemFormatters
        listItemType: "card",

        res: res,

        _listClass: declare([OnDemandList, Formatter, Selection, Keyboard, WithContextMenu, DijitRegistry, Focusable, Responsive]),

        _list: null,

        _noDataMessageWrapper: "<span class=\"dgrid-no-data__content\">{0}</span>",

        buildRendering: function () {
            this.inherited(arguments);
            this._setupList();
        },

        focus: function () {
            // summary:
            //      Set focus to the project item list.
            // tags:
            //      public
            if (this._list) {
                this._list.focus();
            }
        },

        layout: function () {

            var toolbarHeight, size;

            if (!this._contentBox) {
                return;
            }

            toolbarHeight = domGeometry.getMarginBox(this.toolbar.domNode).h + domGeometry.getMarginBox(this.notificationBarNode).h;
            size = lang.mixin({}, this._contentBox, { h: this._contentBox.h - toolbarHeight });

            domGeometry.setMarginBox(this.listContainer, size);
            this._list.resize();
        },

        clearSelection: function () {
            // summary:
            //      Clears the selection in the list.
            // tags:
            //      public
            this._list.clearSelection();
            this.emit("selection-changed", { items: [] });
        },

        refresh: function () {
            // summary:
            //      Refreshes the item list
            // tags:
            //      public

            this._list.refresh({ keepScrollPosition: true });
        },

        setSelection: function (projectItems) {
            // summary:
            //      Sets the selection in the list and emit selection-chaged with the given project items
            // tags:
            //      public

            this.selectItems(projectItems);
            this.emit("selection-changed", { items: projectItems });
        },

        selectItems: function (projectItems) {
            // summary:
            //      Sets the selection in the list to the given project items.
            // tags:
            //      public

            this._list.clearSelection();
            projectItems.forEach(function (item) {
                this._list.select(item);
            }, this);
        },

        toggleActivities: function (visible) {
            domClass.toggle(this.domNode, "epi-project-item-list--activities-visible", visible);
        },

        updateQuery: function (store, query) {
            // summary:
            //      Updates query and store for the item list.
            // tags:
            //      public
            var messageText = !query && this.res.noquery ? this.res.noquery : this.res.nodata,
                message = lang.replace(this._noDataMessageWrapper, [messageText]);

            this._list.set("noDataMessage", message);

            // Don't refresh the data if neither the store nor the query has changed
            if (this._list.store !== store || !epi.areEqual(this._list.query, query)) {
                this._list.set("store", store, query);
            }
        },

        _setupList: function () {
            // summary:
            //    Setting up the list
            // tags:
            //    private

            var list, target;

            listItemFormatters.contentLanguage = this.contentLanguage;

            list = new this._listClass({
                formatters: listItemFormatters[this.listItemType],
                cleanEmptyObservers: false,
                commandCategory: "itemContext",
                deselectOnRefresh: false,
                farOffRemoval: Infinity,
                refocusOnRefresh: true,
                responsiveMap: {
                    "epi-card-list--narrow": 570
                },
                pagingMethod: "throttleDelayed",
                pagingDelay: 500,
                minRowsPerPage: 25,
                maxRowsPerPage: 25
            }, this.itemListNode);

            list.contextMenu.addProvider(this.commandSource);

            this.own(
                this._list = list,
                list.on("dgrid-cellfocusin, .dgrid-content:click", lang.hitch(this, function (evt) {
                    if (evt.target === list.contentNode) {
                        this.clearSelection();
                    }

                    var items = this._getSelectedItems(list);
                    this.emit("selection-changed", { items: items });
                })),
                list.on("dgrid-select, dgrid-deselect", lang.hitch(this, function (evt) {
                    var items = this._getSelectedItems(list);
                    this.emit("active-items-changed", { items: items });
                })),
                list.on(".dgrid-row:dblclick", lang.hitch(this, function (evt) {
                    var item = this._list.row(evt).data;
                    this.emit("itemaction", { item: item });
                })),
                list.addKeyHandler(keys.ENTER, lang.hitch(this, function (evt) {
                    var item = this._list.row(evt).data;
                    this.emit("itemaction", { item: item });
                })),
                list.on(on.selector(".dgrid-row", events.keys.del), lang.hitch(this, function (evt) {
                    var item = this._list.row(evt).data;
                    this.emit("itemremove", { item: item });
                })),
                target = new Target(this.overlayNode, {
                    createItemOnDrop: false,
                    allowMultipleItems: true,
                    accept: ["episerver.core.icontentdata.reference"]
                }),
                aspect.after(target, "onDropData", lang.hitch(this, this._onDropData), true)
            );
        },

        _getSelectedItems: function (list) {
            var items = [];
            Object.keys(list.selection).forEach(function (key) {
                if (list.selection[key]) {
                    var item = list.row(key).data;
                    items.push(item);
                }
            });
            return items;
        },

        _onDropData: function (dndItems) {
            var items = dndItems.map(function (item) {
                return item.data;
            });
            this.emit("itemsdropped", { items: items });
        },

        _setDndEnabledAttr: function (value) {
            this._set("dndEnabled", value);
            domClass.toggle(this.overlayNode, "dijitHidden", !value);
        },

        _setNotificationMessageAttr: function (value) {
            this.notificationTextNode.textContent = value;
            domClass.toggle(this.notificationBarNode, "dijitHidden", !value);
            this.layout();
        },

        _setSortOrderAttr: function (value) {
            //Set the sort if it has changed
            if (this._list.get("sort") !== value) {
                this._list.set("sort", value);
            }
        },

        _setContentLanguageAttr: function (value) {
            this._set("contentLanguage", value);
            listItemFormatters.contentLanguage = value;
        }
    });
});

},
'epi/shell/dgrid/Responsive':function(){
define("epi/shell/dgrid/Responsive", [
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/dom-geometry"
], function (declare, domClass, domGeometry) {

    return declare([], {
        // summary:
        //      Adds a class to the grid based on its width.
        // tags:
        //      internal

        // currentResponsiveClass: [readonly] String
        //      The CSS class that is current assigned to the grid from the responsive map.
        currentResponsiveClass: "",

        // responsiveMap: [public] Object
        //      A map of CSS class names to width thresholds.
        responsiveMap: null,

        resize: function () {
            // summary:
            //      Resizes the grid and adds responsive CSS classes based on the grids new size.
            // tags:
            //      public

            this.inherited(arguments);

            var currentRuleWidth = Infinity,
                gridWidth = domGeometry.getContentBox(this.domNode).w,
                responsiveClass = "",
                responsiveMap = this.responsiveMap;

            if (responsiveMap) {
                // Get the rule with the smallest break point which is also greater than or equal to
                // the grid's width.
                Object.keys(responsiveMap).forEach(function (key) {
                    var ruleWidth = responsiveMap[key];
                    if (gridWidth <= ruleWidth && ruleWidth < currentRuleWidth) {
                        currentRuleWidth = ruleWidth;
                        responsiveClass = key;
                    }
                });

                domClass.replace(this.domNode, responsiveClass, this.currentResponsiveClass);

                this.currentResponsiveClass = responsiveClass;
            }
        }
    });
});

},
'epi/shell/widget/_SectionedTemplatedMixin':function(){
define("epi/shell/widget/_SectionedTemplatedMixin", [
// dojo
    "dojo/_base/declare",
    "dojo/query",
    "dojo/string",

    // dijit
    "dijit/_TemplatedMixin"
],

function (
// dojo
    declare,
    query,
    string,

    // dijit
    _TemplatedMixin
) {

    return declare([_TemplatedMixin], {
        // summary:
        //	    Mixin for widgets that are based on a template containing multiple sections
        //      that can be populated when instantiated.
        //
        // description:
        //      To compose content in a widget with multiple sections define attach-points
        //      where content should be inserted and reference these in the sections property.
        //      When using the widget, define which content  should go where by specifying
        //      a data-epi-section property tying the source and destination together.
        //
        // |    <div>
        // |        <div data-dojo-type="dijit/Toolbar" data-dojo-attach-point="toolbar">
        // |            <span data-dojo-attach-point="toolbarSection"></span>
        // |        </div>
        // |        <span data-dojo-attach-point="statusSection"></span>
        // |    </div>
        //
        //      Source markup example:
        //
        // |    <div data-dojo-type="epi/shell/widget/_SectionedTemplatedMixin">
        // |        <span data-epi-section="toolbarSection">Hello World!</span>
        // |        <span data-epi-section="statusSection">
        // |            <ul>
        // |                <li>Good evening!</li>
        // |            </ul>
        // |        </span>
        // |    </div>
        //
        // tags:
        //      internal

        // sections: String[]
        //      An array of attach-point names to inject content into.
        sections: [],

        _fillContent: function (/*DomNode*/ source) {
            // summary:
            //      Overridden from _TemplatedMixin to populate the templated sections defined by the sections array
            // tags:
            //		protected

            this.sections.forEach(function (sectionId) {
                var targetNode = this[sectionId],
                    sections = query(string.substitute("[data-epi-section=${0}]", [sectionId]), source);

                sections.forEach(function (section) {
                    while (section.childNodes.length > 0) {
                        targetNode.appendChild(section.childNodes[0]);
                    }
                });
            }, this);
        }

    });
});

},
'url:epi-cms/project/templates/ProjectItemList.html':"<div class=\"epi-project-item-list\">\r\n    <div data-dojo-type=\"dijit/Toolbar\"\r\n         data-dojo-attach-point=\"toolbar\"\r\n         class=\"epi-project-item-list__toolbar epi-flatToolbar\">\r\n        <span data-dojo-attach-point=\"toolbarSection\"></span>\r\n    </div>\r\n    <div data-dojo-attach-point=\"listContainer\" class=\"epi-project-item-list__container\">\r\n        <div data-dojo-attach-point=\"notificationBarNode\" class=\"epi-notificationBar dijitHidden\">\r\n            <div class=\"epi-notificationBarItem\">\r\n                <div class=\"epi-notificationBarText\">\r\n                    <p data-dojo-attach-point=\"notificationTextNode\"></p>\r\n                </div>\r\n            </div>\r\n        </div>\r\n        <div data-dojo-attach-point=\"overlayNode\"\r\n             class=\"epi-project-item-list__dnd-area epi-visible-dnd-area epi-project-list-area__dnd-area--empty-list dijitHidden\">\r\n            <span class=\"epi-project-item-list__dnd-area-content\">${res.droptoadditems}</span>\r\n        </div>\r\n        <div data-dojo-attach-point=\"itemListNode\"\r\n             class=\"epi-card-list dgrid--centered-no-data-message\"></div\r\n        ><div data-dojo-attach-point=\"activitySection\"\r\n              class=\"epi-activity-section\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/project/PublishMenu':function(){
define([
    "dojo/_base/declare",
    "dojo/on",

    "dijit/DropDownMenu",
    "dijit/registry",

    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/command/builder/MenuBuilder",
    "epi/shell/widget/_SectionedTemplatedMixin",

    "./command/PublishMenuButtonBuilder",

    "dojo/text!./templates/PublishMenu.html"
], function (
    declare,
    on,

    DropDownMenu,
    registry,

    MenuAssembler,
    MenuBuilder,
    _SectionedTemplatedMixin,
    PublishMenuButtonBuilder,

    template
) {

    return declare([DropDownMenu, _SectionedTemplatedMixin], {
        // summary:
        //      Composite menu for displaying a publish button and general commands for a content item.
        //      It also sports two custom regions for information text, links or widgets.
        //
        // description:
        //      Composite popup menu containing two regions for exposing commands and two custom regions
        //      for showing general markup, text or widgets.
        //
        //      A command can be placed in the top, publish region, by setting the command category to
        //      "publishmenu-primary". The primary commands will be represented by buttons and won't close
        //      the menu when executed.
        //      By setting the command category to "publishmenu", the command will be added to the lower
        //      region as regular menu options.
        //
        //      The two custom regions, "primarySection" and "statusSection", is populated from the named
        //      sections in source content.
        //
        //      Markup example:
        //
        // |    <div id="publishMenu" data-dojo-type="epi-cms/project/PublishMenu">
        // |        <span data-epi-section="primarySection">Hello World!</span>
        // |        <span data-epi-section="statusSection">
        // |            <ul>
        // |                <li>Good evening!</li>
        // |            </ul>
        // |        </span>
        // |    </div>
        //
        // tags:
        //      internal

        sections: ["primarySection", "statusSection"],

        templateString: template,

        buildRendering: function () {
            this.inherited(arguments);

            var configuration = [{
                builder: new PublishMenuButtonBuilder({
                    settings: {
                        "class": "epi-button--bold epi-button--full-width epi-success",
                        isExecutingClass: "epi-loading"
                    },
                    optionClass: "epi-menu--inverted",
                    optionItemClass: "epi-radioMenuItem"
                }),
                category: "publishmenu-primary",
                target: this.publishMenuNode
            }, {
                builder: new MenuBuilder(),
                category: "publishmenu",
                target: this.projectActionMenu
            }];

            this.own(this._menuAssembler = new MenuAssembler({
                configuration: configuration
            }));

            // The PublishMenuButtonBuilder makes sure that any button being "undisplayed" while focused
            // emits an event before focus is lost.
            this.own(on(this.domNode, "beforeFocusedButtonRemoved", this.domNode.focus));
        },

        childSelector: function (/*DOMNode*/ node) {
            // summary:
            //		Selector (passed to on.selector()) used to identify MenuItem child widgets, but exclude inert children
            //		like MenuSeparator.
            // tags:
            //		protected

            // Called by _MenuBase. to determine which items are menu options. Exclude the publish button,
            // since buttons handle their own click execution
            var widget = registry.byNode(node);
            return widget && widget.focus && (node.parentNode === this.projectActionMenu);
        },

        getChildren: function () {
            // summary:
            //      Returns publish button and menu options. Used by _KeyNavContainer to navigate between nodes.

            return [].concat(
                registry.findWidgets(this.publishMenuNode),
                registry.findWidgets(this.projectActionMenu));
        },

        _setCommandSourceAttr: function (commandSource) {
            // summary:
            //      Set the command source which provides commands to the menu

            this._menuAssembler.set("commandSource", commandSource);
        },

        _getCommandSourceAttr: function () {
            // summary:
            //      Gets the command source from the internal menu assembler

            return this._menuAssembler.get("commandSource");
        }
    });
});

},
'epi-cms/project/command/PublishMenuButtonBuilder':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",

    "dijit/form/Button",

    "epi/shell/command/_CommandModelBindingMixin",
    "epi/shell/command/builder/ButtonBuilder"
], function (
    declare,
    lang,
    on,

    Button,

    _CommandModelBindingMixin,
    ButtonBuilder
) {

    return declare([ButtonBuilder], {
        // summary:
        //      Creates buttons for commands with an ability to emit a beforeFocusedButtonRemoved event on
        //      its domNode when made unavailable in a focused state.
        // tags:
        //      internal

        _buttonClass: declare([Button, _CommandModelBindingMixin], {
            _setSelected: function () {
                // summary:
                //      Needed for buttons to work inside a menu
            },

            _setIsAvailableAttr: function (available) {
                // summary:
                //      Overridden to emit a beforeFocusedButtonRemoved event when the command
                //      is made unavailable while the button has focus.

                if (!available && this.get("focused")) {
                    on.emit(this.domNode, "beforeFocusedButtonRemoved", { bubbles: true });
                }
                this.inherited(arguments);
            }
        })
    });
});

},
'url:epi-cms/project/templates/PublishMenu.html':"<div tabIndex=\"${tabIndex}\" role=\"menu\" class=\"epi-invertedTooltip epi-publishActionMenu\" data-dojo-attach-point=\"containerNode\" data-dojo-attach-event=\"onkeypress:_onKeyPress\">\r\n    <div class=\"epi-tooltipDialogTop\">\r\n        <ul>\r\n            <li data-dojo-attach-point=\"primarySection\" class=\"epi-projectStatusMessage\"></li>\r\n            <li data-dojo-attach-point=\"publishMenuNode\"></li>\r\n        </ul>\r\n    </div>\r\n    <div data-dojo-attach-point=\"statusSection\" class=\"epi-tooltipDialogInfo\"></div>\r\n    <table class=\"epi-tooltipDialogMenu epi-menuInverted\" cellspacing=\"0\">\r\n        <tbody data-dojo-attach-point=\"projectActionMenu\"></tbody>\r\n    </table>\r\n</div>\r\n",
'epi-cms/project/ProjectChangesComponent':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/on",
    "dojo/when",

    // epi
    "epi/shell/command/_WidgetCommandBinderMixin",

    // epi-cms
    "./_ProjectView",
    "./viewmodels/ProjectChangesComponentViewModel",

    // template
    "dojo/text!./templates/ProjectChangesComponent.html",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.changes",

    // Widgets in template
    "dijit/DropDownMenu",
    "dijit/form/Button",
    "dijit/form/DropDownButton",
    "dijit/Toolbar",
    "./ProjectItemList"
],

function (
// dojo
    declare,
    lang,
    aspect,
    domClass,
    domGeometry,
    on,
    when,

    // epi
    _WidgetCommandBinderMixin,

    // epi-cms
    _ProjectView,
    ProjectChangesComponentViewModel,

    // template
    template,

    // Resources
    res
) {


    return declare([_ProjectView, _WidgetCommandBinderMixin], {
        // summary:
        //
        // tags:
        //      internal

        modelBindingMap: {
            projectItemQuery: ["projectItemQuery"],
            projectItemSortOrder: ["projectItemSortOrder"],
            dndEnabled: ["dndEnabled"],
            contentLanguage: ["contentLanguage"]
        },

        res: res,

        templateString: template,

        "class": "epi-project-changes-component",

        layout: function () {
            this.inherited(arguments);

            this.itemList.resize(this._contentBox, this._contentBox);
        },

        _createViewModel: function () {
            // summary:
            //    Setting up the view model
            // tags:
            //    protected

            return new ProjectChangesComponentViewModel();
        }
    });
});

},
'epi-cms/project/viewmodels/ProjectChangesComponentViewModel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",

    "./_ProjectViewModel"
], function (
//dojo
    declare,
    lang,

    _ProjectViewModel
) {
    return declare([_ProjectViewModel], {
        // summary:
        //
        // tags:
        //      internal

        // _sortOrderProfileKey: [protected] String
        //      The profile key used to store the sort order
        _sortOrderProfileKey: "epi.project-changes-sort-order",

        postscript: function () {
            this.inherited(arguments);

            this.own(this.projectService.on("currentProjectChanged", lang.hitch(this, this._projectChanged)));
        },

        refreshProject: function () {
            // summary:
            //      Refreshes the selected project, particularly information if the project can be published or not.
            // tags:
            //      public

            if (!this.selectedProject) {
                this._updateHasProject();
            }

            this.inherited(arguments);
        },

        _createProjectCommands: function () {
            // summary:
            //    No project commands should be available from this view.
            // tags:
            //    protected

            return {};
        },

        _createProjectItemCommands: function () {

            var commands = this.inherited(arguments),
                commandsToAdd = {};

            Object.keys(commands).forEach(function (key) {

                var command = commands[key];

                switch (key) {
                    case "refreshProjectItems":
                    case "editProjectItem":
                        break;
                    case "sortProjectItems" :
                        command.set({
                            category: "projectButton",
                            iconClass: "epi-iconSort"
                        });

                        break;

                    case "readyToPublishProjectItem" :
                        commandsToAdd.primaryReadyToPublishProjectItem = lang.delegate(command, {
                            iconClass: "epi-iconCheckmark",
                            category: null
                        });

                        break;

                    default :
                        commandsToAdd[key + "_context"] = lang.delegate(command, { category: "context" });
                }
            });

            return lang.mixin(commands, commandsToAdd);
        },

        _projectChanged: function (project) {
            // summary:
            //      When the project overview changes
            // project: Object
            //      Project
            // tags:
            //      private

            this.set("selectedProject", project);
        },

        _updateSelectedProjectDependencies: function (selectedProject) {

            var dndEnabled = false,
                projectItemQuery = null,
                isProjectModeEnabled = this.isProjectModeEnabled();

            if (selectedProject) {
                dndEnabled = (isProjectModeEnabled && selectedProject.status !== "publishing") || selectedProject.status === "active" || selectedProject.status === "publishfailed";
                projectItemQuery = { projectId: selectedProject.id };
            }

            this.set({
                dndEnabled: dndEnabled,
                projectItemQuery: projectItemQuery
            });
        }
    });
});

},
'url:epi-cms/project/templates/ProjectChangesComponent.html':"﻿<div>\r\n    <div data-dojo-type=\"epi-cms/project/ProjectItemList\"\r\n         data-dojo-attach-point=\"itemList\"\r\n         data-dojo-props=\"commandSource: this.model, listItemType: 'card-compact', res: this.res\">\r\n        <section data-epi-section=\"toolbarSection\">\r\n            <div data-dojo-attach-point=\"toolbarGroupNode\" class=\"epi-floatRight\"></div>\r\n        </section>\r\n        <section data-epi-section=\"listContainer\">\r\n            <div data-dojo-attach-point=\"placeholderNode\" class=\"epi-project-gadget__placeholder dijitHidden\"></div>\r\n        </section>\r\n    </div>\r\n</div>\r\n",
'epi-cms/project/ProjectComponent':function(){
define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/on",
    "dojo/when",

    // epi
    "epi/shell/command/_WidgetCommandBinderMixin",

    // epi-cms
    "./_ProjectView",
    "./viewmodels/ProjectComponentViewModel",

    // template
    "dojo/text!./templates/ProjectComponent.html",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project",

    // Widgets in template
    "dijit/DropDownMenu",
    "dijit/form/Button",
    "dijit/form/DropDownButton",
    "dijit/Toolbar",
    "./ProjectItemList",
    "./ProjectSelector",
    "./PublishMenu"
],

function (
// dojo
    declare,
    lang,
    aspect,
    domClass,
    domGeometry,
    on,
    when,

    // epi
    _WidgetCommandBinderMixin,

    // epi-cms
    _ProjectView,
    ProjectComponentViewModel,

    // template
    template,

    // Resources
    res
) {
    function show(list) {
        list.forEach(function (node) {
            domClass.remove(node, "dijitHidden");
        });
    }

    function hide(list) {
        list.forEach(function (node) {
            domClass.add(node, "dijitHidden");
        });
    }

    lang.delegate(_ProjectView.prototype.modelBindingMap, { placeHolder: ["placeHolder"] });

    return declare([_ProjectView, _WidgetCommandBinderMixin], {
        // summary:
        //
        // tags:
        //      internal

        "class": "epi-project-component",

        modelBindingMap: {
            projectItemQuery: ["projectItemQuery"],
            projectItemSortOrder: ["projectItemSortOrder"],
            selectedProject: ["selectedProject"],
            created: ["created"],
            createdBy: ["createdBy"],
            createProjectInfo: ["createProjectInfo"],
            dndEnabled: ["dndEnabled"],
            placeholderState: ["placeholderState"],
            notificationMessage: ["notificationMessage"],
            projectStatus: ["projectStatus"],
            contentLanguage: ["contentLanguage"]
        },

        res: res,

        templateString: template,

        layout: function () {
            this.inherited(arguments);

            this.itemList.resize(this._contentBox, this._contentBox);
        },

        _createViewModel: function () {
            // summary:
            //    Setting up the view model
            // tags:
            //    private

            return new ProjectComponentViewModel();
        },

        _projectSelectorSortChanged: function (sortOrder) {
            this.model.set("projectSortOrder", sortOrder);
        },

        _projectSelectorChange: function (project) {
            this.model.set("selectedProject", project);
        },

        _newProjectButtonClickHandler: function () {
            this.model.namedCommands.addProject.execute();
        },

        _setCreateProjectInfoAttr: { node: "createProjectInfoNode", type: "innerText" },

        _setSelectedProjectAttr: function (value) {
            this.projectSelector.set("value", value);
        },

        _setPlaceholderStateAttr: function (value) {
            // summary:
            //    Sets the placeholderState
            // tags:
            //    private

            if (this.get("_placeholderState") === value) {
                return;
            }

            this._set("_placeholderState", value);

            switch (value) {

                case "noProjects":
                    show([this.placeholderNode]);
                    hide([this.projectSelector.domNode, this.publishContainer.domNode]);

                    break;

                case "noSelectedProject":
                    show([this.projectSelector.domNode, this.placeholderNode]);
                    hide([this.publishContainer.domNode]);

                    break;

                default:
                    show([this.projectSelector.domNode, this.publishContainer.domNode]);
                    hide([this.placeholderNode]);

            }
        }
    });
});

},
'epi-cms/project/viewmodels/ProjectComponentViewModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/when",

    "./_ProjectViewModel",

    // Resources
    "epi/i18n!epi/nls/episerver.cms.components.project"

], function (
//dojo
    declare,
    lang,
    Deferred,
    when,

    _ProjectViewModel,

    res
) {
    return declare([_ProjectViewModel], {
        // summary:
        //
        // tags:
        //      internal

        // createdProjectInfo: [readonly] string
        //      A view prepared version of the placeholder info.
        createProjectInfo: "",

        // hasProject: [readonly] bool
        //      Indicates if there are any projects available.
        hasProject: false,

        _selectedProjectProfileKey: "epi.selected-project-id",

        initialize: function () {
            this._updateHasProject();
            return this.inherited(arguments);
        },

        removeProject: function () {
            // summary:
            //      Removes the selected project and sets the selected project property to null.
            // tags:
            //      public

            var self = this,
                store = this.projectStore;

            if (!this.selectedProject) {
                return new Deferred().resolve();
            }

            return store.remove(this.selectedProject.id).then(function () {
                self._selectNextProject();
            });
        },

        _loadSelectedProject: function () {
            // summary:
            //      Loads the selected project
            // returns: Promise
            //      The project that was stored in the profile
            // tags:
            //      internal

            var projectStore = this.projectStore;

            //Load the selected project from the profile
            return when(this.profile.get(this._selectedProjectProfileKey), function (projectId) {

                if (!projectId) {
                    return null;
                }

                // Need to get the project from the store in order to ensure it still exists.
                // Otherwise return null
                return when(projectStore.get(projectId)).then(function (project) {

                    // if a project has been resolved we know that there is at least one available
                    // so that we can pass it along to the hasProject check
                    var hasProject = !!project || undefined;

                    return this._updateHasProject(hasProject).then(function () {
                        return project;
                    });

                }.bind(this)).otherwise(function (ex) {
                    return null;
                });
            }.bind(this));
        },

        _updatePlaceholderState: function () {

            var hasProjects = this.get("hasProject"),
                hasSelectedProject = !!this.get("selectedProject"),
                state = "";

            if (!hasProjects) {
                // should set placeholderState to 'noProjects' when there are no projects
                state = "noProjects";
                this.set("createProjectInfo", res.placeholder.noprojectscreated);
            } else if (hasProjects && !hasSelectedProject) {
                // should set placeholderState to 'noSelectedProject' when there are projects available and no project is selected
                state = "noSelectedProject";
                this.set("createProjectInfo", res.placeholder.noprojectselected);
            }

            this.set("placeholderState", state);
        },

        _getProjects: function (start, count, sort) {
            // summary:
            //      Gets projects based on attributes
            // tags:
            //      private

            return this.projectStore.query(null, { start: start, count: count, sort: sort });
        },

        _updateHasProject: function (hasProject) {
            // summary:
            //      updates hasProject boolean depending on getHasProject result
            // tags:
            //      private

            return when(hasProject === true ? [hasProject] : this._getProjects(0, 1)).then(function (results) {
                var result = results.length > 0;
                this.set("hasProject", result);

                return result;
            }.bind(this));
        },

        _selectNextProject: function () {
            // summary:
            //      Selects next project
            // tags:
            //      protected

            when(this._getProjects(0, 1, this.get("projectSortOrder")), lang.hitch(this, function (results) {
                var value = results.length > 0 ? results[0] : null;
                this.set("selectedProject", value);
                this.set("hasProject", results.length > 0);
            }));
        },

        _hasProjectSetter: function (value) {
            this.hasProject = value;
            this._updatePlaceholderState();
        },

        _selectedProjectSetter: function (selectedProject) {

            this.inherited(arguments);

            if (!this.hasProject && selectedProject) {
                this.set("hasProject", true);
            } else {
                this._updatePlaceholderState();
            }

            // Store the selected project.
            this.profile.set(this._selectedProjectProfileKey, selectedProject && selectedProject.id, { location: "server" });
        }
    });
});

},
'url:epi-cms/project/templates/ProjectComponent.html':"﻿<div>\r\n    <div data-dojo-type=\"epi-cms/project/ProjectItemList\"\r\n         data-dojo-attach-point=\"itemList\"\r\n         data-dojo-props=\"commandSource: this.model, listItemType: 'card-compact'\">\r\n        <section data-epi-section=\"toolbarSection\">\r\n            <span data-dojo-type=\"epi-cms/project/ProjectSelector\"\r\n                  data-dojo-attach-point=\"projectSelector\"\r\n                  data-dojo-props=\"store:this.model.projectStore\"\r\n                  data-dojo-attach-event=\"onSortChanged:_projectSelectorSortChanged, onChange:_projectSelectorChange\"></span>\r\n            <div data-dojo-type=\"dijit/form/DropDownButton\"\r\n                 data-dojo-attach-point=\"publishContainer\"\r\n                 data-dojo-props=\"iconClass: 'epi-iconPublishProject', showLabel: false, label: this.res.publishdropdown.label\"\r\n                 data-dojo-attach-event=\"openDropDown:_publishMenuClickHandler\"\r\n                 class=\"epi-flat epi-chromeless epi-chromeless--with-arrow\">\r\n                <span></span>\r\n                <div data-dojo-type=\"epi-cms/project/PublishMenu\"\r\n                     data-dojo-attach-point=\"publishMenu\"\r\n                     data-dojo-props=\"commandSource: this.model\">\r\n                    <section data-epi-section=\"primarySection\">\r\n                        <span data-dojo-attach-point=\"projectStatusMessageNode\"></span>\r\n                    </section>\r\n                    <section data-epi-section=\"statusSection\">\r\n                        <ul>\r\n                            <li>\r\n                                ${res.view.createdby} <span data-dojo-attach-point=\"createdByNode\" class=\"epi-username\"></span>,\r\n                                <span data-dojo-attach-point=\"createdNode\" class=\"epi-timestamp\"></span>\r\n                            </li>\r\n                        </ul>\r\n                    </section>\r\n                </div>\r\n            </div>\r\n            <div data-dojo-attach-point=\"toolbarGroupNode\" class=\"epi-floatRight\"></div>\r\n        </section>\r\n\r\n        <section data-epi-section=\"listContainer\">\r\n            <div data-dojo-attach-point=\"placeholderNode\" class=\"epi-project-gadget__placeholder dijitHidden\">\r\n                <div class=\"epi-project-gadget__placeholder-content\">\r\n                    <button data-dojo-type=\"dijit/form/Button\" type=\"button\"\r\n                            data-dojo-props=\"iconClass: 'epi-iconPlus'\"\r\n                            data-dojo-attach-event=\"onClick:_newProjectButtonClickHandler\"\r\n                            class=\"epi-flat epi-chromeless\">${res.command.newproject.label}</button>\r\n                    <div data-dojo-attach-point=\"createProjectInfoNode\" class=\"epi-project-gadget__placeholder-info\"></div>\r\n                </div>\r\n            </div>\r\n        </section>\r\n    </div>\r\n</div>\r\n",
'epi-cms/project/ProjectSelector':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/on",
    "dojo/Deferred",

    "dojox/html/entities",

    "epi",

    // Resources
    "dojo/text!dijit/form/templates/Select.html",
    "epi/i18n!epi/shell/ui/nls/episerver.shared.header",
    "epi/i18n!epi/cms/nls/episerver.cms.components.project",
    // Grid
    "./ProjectSelectorList",

    // Parent class and mixins
    "dijit/form/_FormValueWidget",
    "epi/shell/widget/DeferredDropDownButton",

    // Widgets in template
    "dijit/form/ToggleButton"
],
function (
    declare,
    lang,
    aspect,
    domConstruct,
    on,
    Deferred,

    entities,

    epi,

    // Resources
    template,
    localizations,
    projectResources,
    // Grid
    ProjectSelectorList,

    // Parent class and mixins
    _FormValueWidget,
    DeferredDropDownButton
) {
    return declare([DeferredDropDownButton, _FormValueWidget], {
        // summary:
        //      Drop down button for selecting projects
        // tags:
        //      internal xproduct

        // class: [protected] String
        //      class of the button
        "class": "epi-project-selector epi-chromeless epi-chromeless--with-arrow epi-flat",

        iconClass: "epi-iconProject",

        value: null,

        // store: [public] Store
        //      A store to query for the list of options.
        store: null,

        // sort: [public] Object
        //      How the projects are sorted in the drop down.
        sort: null,

        // query: [public] Object
        //      A query to use when fetching items from the store.
        query: null,

        // enableDefaultValue: [public] Boolean
        //      Enable/Disable the possiblity to select a default value (null)
        enableDefaultValue: false,

        // defaultValueText: [public] String
        //      The text to display for the default value if enabled
        defaultValueText: projectResources.preview.defaultoption,

        // header: [protected] String
        //      A string that will be displayed in the header of the selector.
        header: projectResources.selector.title,

        buildRendering: function () {
            this.inherited(arguments);

            this.own(
                this.dropDown = new ProjectSelectorList({
                    baseClass: "dijitMenu",
                    header: this.header,
                    enableDefaultValue: this.enableDefaultValue,
                    defaultValueText: this.defaultValueText
                }),
                on(this.dropDown, "change", lang.hitch(this, function (e) {
                    this.set("value", e.value, true);
                    this.closeDropDown(true);
                }), true)
            );
        },
        startup: function () {
            if (this._started) {
                return;
            }
            this.inherited(arguments);

            this.dropDown.startup();

            // Set initial value to null if no value has been specified and default values are enabled
            // Set the value after the widget has started to avoid setting the label twice
            // once from the value property setter and one time from the _CssStateMixin
            if (this.enableDefaultValue && !this.value) {
                this.set("value", null);
            }
        },

        compare: function (value1, value2) {
            // summary:
            //      Compare two values (as returned by get("value") for this widget).
            // tags:
            //      protected
            return epi.areEqual(value1, value2) ? 0 : -1;
        },

        loadAndOpenDropDown: function () {
            // summary:
            //      Opens the drop down and refreshes the content.
            // returns: Promise
            //      Promise for the drop down widget that resolves when
            //      the drop down is created and loaded.
            // tags:
            //      protected
            var args = arguments;

            //Refresh the drop down before opening it
            var promise = this.dropDown.refresh();

            return promise.then(lang.hitch(this, function () {
                return this.inherited(args);
            }));
        },

        isLoaded: function () {
            // summary:
            //      Make sure the dropdown is always considered not loaded
            //      if we have defaultValue enabled, to keep the autofocus
            //      on defaultValue working with the dropDown list
            // tags:
            //      protected
            if (this.enableDefaultValue) {
                return false;
            }
            return this.inherited(arguments);
        },

        _getQueryAttr: function () {
            return this.query || {};
        },

        _setQueryAttr: function (value) {
            this._set("query", value);
            if (this.dropDown) {
                this.dropDown.set("query", value);
            }
        },

        _setStoreAttr: function (store) {
            this._set("store", store);
            if (this.dropDown) {
                this.dropDown.set("store", store);
            }
        },

        _setLabelAttr: function (value) {
            // Override the default set label and encode all values before passing them to the drop down
            this.inherited(arguments, [entities.encode(value || "")]);
        },

        _setValueAttr: function (value, internal) {
            this.set("label", value && value.name);

            if (this.enableDefaultValue && !value) {
                this.set("label", this.defaultValueText);
            }
            !internal && this.dropDown && this.dropDown.set("selectedProject", value);

            this.inherited(arguments);
        }
    });
});

},
'epi-cms/project/ProjectModeToolbar':function(){
﻿define([
// dojo
    "require",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/has",
    "dojo/on",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/string",

    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",
    "dijit/form/Button",

    // epi
    "epi/shell/DialogService",
    "epi/shell/widget/_ModelBindingMixin",
    "./viewmodels/ProjectModeToolbarViewModel",
    "epi/dependency",
    "epi/shell/command/builder/DropDownButtonBuilder",
    "epi/shell/command/builder/MenuAssembler",

    // template
    "dojo/text!./templates/ProjectModeToolbar.html",
    "dojo/text!./templates/CurrentProjectDoesNotExistsWarning.html",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.toolbar"
], function (
// dojo
    moduleRequire,
    declare,
    lang,

    has,
    on,
    domStyle,
    domClass,
    string,

    // dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,
    Button,

    // epi
    dialogService,
    _ModelBindingMixin,
    ProjectModeToolbarViewModel,
    dependency,
    DropDownButtonBuilder,
    MenuAssembler,

    // template
    template,
    projectDoesNotExistsWarningTemplate,

    // Resources
    localizations
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        // summary:
        //      Project mode toolbar for selecting the project to work with
        // tags:
        //      internal

        templateString: template,

        localizations: localizations,

        _projectDoesNotExistWarning: "",

        postscript: function () {
            this.inherited(arguments);

            this.projectService = this.projectService || dependency.resolve("epi.cms.ProjectService");
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model) {
                this.own(
                    this.model = new ProjectModeToolbarViewModel()
                );
            }

            this._projectDoesNotExistWarning = string.substitute(projectDoesNotExistsWarningTemplate, {
                warning: localizations.projectdoesnotexists.alert.warning,
                description: localizations.projectdoesnotexists.alert.description
            });
        },

        buildRendering: function () {

            this.inherited(arguments);

            this._setupContextMenu();

            var dialogContent = this._projectDoesNotExistWarning;

            this.own(
                this.projectOverviewButton = new Button({
                    showLabel: true,
                    "class": "dijitHidden epi-chromeless",
                    label: localizations.overview.label
                }, this.projectOverviewButtonNode),

                this.projectOverviewButton.on("click", lang.hitch(this, "_openProjectOverview")),

                this.model.on("currentProjectDoesNotExists", function () {
                    dialogService.alert(dialogContent);
                }));
        },

        _toggleOverviewButton: function (isVisible) {
            // summary:
            //      Toggles the overview button
            // isVisible: Boolean
            // tags:
            //      private
            var projectOverviewButtonNode = this.projectOverviewButton.domNode;
            domClass.toggle(projectOverviewButtonNode, "dijitHidden", !isVisible);
        },

        startup: function () {
            this.inherited(arguments);

            this.own(this.model.watch("overviewButtonVisible", lang.hitch(this, function (property, oldValue, newValue) {
                this._toggleOverviewButton(newValue);
            })));

            var model = this.model;
            this.model.initialize().then(function () {
                moduleRequire(["epi-cms-react/components/project-selector-widget", "xstyle/css!epi-cms-react/components/project-selector-widget.css"], function (ProjectSelector) {
                    this.projectSelector = new ProjectSelector({
                        store: this.model.projectStore
                    }, this.projectSelectorNode);

                    var domNode = this.domNode;

                    this.own(this.projectSelector.watch("value", lang.hitch(this, function (property, oldValue, newValue) {
                        domClass.toggle(domNode, "epi-project-mode-toolbar--project-selected", !!newValue);
                        domClass.remove(domNode, "epi-project-mode-toolbar--project-deleted");
                        model.set("currentProject", newValue);
                    })));

                    this.projectSelector.set("value", model.get("currentProject"));
                }.bind(this));
            }.bind(this));

            this.own(this.projectService.on("currentProjectChanged", lang.hitch(this, function (currentProject) {
                this.projectSelector.set("value", currentProject);
            })));

            this.own(this.model.on("animateToolbar", lang.hitch(this, function () {
                domClass.add(this.domNode, "epi-project-mode-toolbar--flash");

                var animationend = on(this.domNode, "animationend", lang.hitch(this, function () {
                    domClass.remove(this.domNode, "epi-project-mode-toolbar--flash");
                    animationend.remove();
                }));
            })));

            this.own(this.model.watch("currentProject", lang.hitch(this, function (property, oldValue, newValue) {
                if (newValue && newValue.isDeleted) {
                    domClass.add(this.domNode, "epi-project-mode-toolbar--project-deleted");
                }
            })));

        },

        _openProjectOverview: function () {
            // summary:
            //      Click handler for opening project overview
            // tags:
            //      private

            var project = this.projectSelector.get("value");
            if (project) {
                this.model.showProjectOverview(project.id);
            }
        },


        _setupContextMenu: function () {
            // summary:
            //      Set up the project sort menu
            // tags:
            //      private

            this.own(
                new MenuAssembler({
                    configuration: [{
                        builder: new DropDownButtonBuilder({
                            settings: {
                                "class": "epi-chromeless",
                                iconClass: "epi-iconContextMenu",
                                showLabel: false,
                                label: localizations.contextmenu.label
                            },
                            optionClass: ""
                        }),
                        category: "context",
                        target: this.contextMenu
                    }],
                    commandSource: this.model
                })
            );
        }
    });
});

},
'epi-cms/project/viewmodels/ProjectModeToolbarViewModel':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/Deferred",
    "dojo/Evented",
    "dojo/Stateful",
    "dojo/topic",
    "dojo/when",
    // dijit
    "dijit/Destroyable",

    //epi
    "epi/shell/command/_CommandProviderMixin",
    "epi/epi",
    "epi/dependency",
    "epi-cms/_ContentContextMixin",
    "../command/AddProject",
    "../command/RenameProject",
    "../command/RemoveProject",
    "epi/shell/xhr/errorHandler"
],

function (
    // dojo
    declare,
    lang,
    aspect,
    Deferred,
    Evented,
    Stateful,
    topic,
    when,
    // dijit
    Destroyable,

    // epi
    _CommandProviderMixin,
    epi,
    dependency,
    _ContentContextMixin,
    AddProject,
    RenameProject,
    RemoveProject,
    errorHandler
) {
    return declare([Stateful, Destroyable, Evented, _ContentContextMixin, _CommandProviderMixin], {
        // summary:
        //      The view model for the epi-cms/project/ProjectModeToolbar
        // tags:
        //      internal

        // projectStore: [readonly] Store
        //      A REST store for interacting with projects.
        projectStore: null,

        // currentProject: [public] Object
        //      The project that is currently selected.
        currentProject: null,

        // overviewButtonVisible: [public] Boolean
        //       Visiblity of overview button
        overviewButtonVisible: false,

        postscript: function () {
            this.inherited(arguments);

            // Resolve the project service and store from the dependency if they
            // haven't been injected. This allows us to mock them when testing.
            this.projectService = this.projectService || dependency.resolve("epi.cms.ProjectService");
            this.projectStore = this.projectStore || dependency.resolve("epi.storeregistry").get("epi.cms.project");

            this._createCommands();

            var projectRemoved = function (id) {
                if (this.currentProject && this.currentProject.id === id) {
                    this._markCurentProjectAsDeleted();
                }
            }.bind(this);

            var projectUpdated = function (project) {
                if (this.currentProject && this.currentProject.id === project.id) {
                    this.set("currentProject", project);
                }
            }.bind(this);

            this.own(
                this.projectService.on("project-removed", projectRemoved),
                this.projectService.on("project-updated", projectUpdated)
            );

            when(this.getCurrentContext()).then(this.contextChanged.bind(this));
        },

        initialize: function () {
            // summary:
            //
            // returns: Promise
            //
            // tags:
            //      public


            // Set the current project based on what is stored in the profile
            return when(this.projectService.getCurrentProject()).then(lang.hitch(this, function (project) {
                this._changeAttrValue("currentProject", project, false); // use the internal setter to not trigger a profile save
                this.set("overviewButtonVisible", !!project);
            }));
        },

        contentContextChanged: function (context, callerData) {
            // summary:
            //      Callback method for when the current content context has changed
            // context: Object
            // callerData: Object
            // tags:
            //      protected
            this.inherited(arguments);

            if (this.get("currentProject")) {
                var self = this;
                this.projectService.exists(this.currentProject.id).then(function (exists) {
                    if (!exists) {
                        self.emit("currentProjectDoesNotExists");
                    }
                });
            }
        },

        _markCurentProjectAsDeleted: function () {
            // summary:
            //      Set the currentProject with property indicating that the project is deleted.
            // tags:
            //      private

            var currentProject = lang.clone(this.currentProject);
            currentProject.isDeleted = true;
            this.set("currentProject", currentProject, false);
            this.set("overviewButtonVisible", false);
        },

        contextChanged: function (/*Object*/context, /*Object*/callerData) {
            // summary:
            //      On context changed
            // tags:
            //      protected
            this.inherited(arguments);

            if (context && context.type === "epi.cms.project") {
                var projectId = parseInt(context.id, 10);
                when(this.projectStore.get(projectId)).then(lang.hitch(this, function (project) {
                    //only animate icon and text in toolbar when url changes
                    if (callerData && callerData.sender && callerData.sender._requestContext) {
                        //Animates toolbar when URL changes.
                        this.emit("animateToolbar");
                    }
                    this.set("currentProject", project);
                }));
            }

        },

        _currentProjectSetter: function (currentProject, persist) {
            // summary:
            //      Sets the current project
            // currentProject: Object
            //      The current project
            // persist: Boolean
            // tags:
            //      private

            // Early exit if the project has not changed
            if (this.currentProject && currentProject && this.currentProject.id === currentProject.id &&
                this.currentProject.name === currentProject.name && this.currentProject.status === currentProject.status) {
                return;
            }

            this.set("overviewButtonVisible", !!currentProject);

            this.currentProject = currentProject;

            var promise = new Deferred().resolve();

            // Store the selected project.
            if (persist || persist === undefined) {
                promise = this.projectService.setCurrentProject(currentProject);
            }

            // Refresh the current context when switching projects to ensure
            // that the preview is correct.
            promise
                .then(lang.hitch(this, "getCurrentContext"))
                .then(function (context) {
                    // In order to avoid a page refresh, for instance when creating or translating a page with required fields,
                    // we make sure to not request any new context while we're still in these modes (create, translate)
                    // in order not to lose any data entered into the required fields.
                    if (context.type !== "epi.cms.project" && context.currentMode === undefined) {
                        topic.publish("/epi/shell/context/request", { uri: context.versionAgnosticUri }, { sender: this });
                    }

                });

        },

        showProjectOverview: function (projectId) {
            // summary:
            //      Publishes request change for project overview
            // projectId: Int
            //      The id of the project
            // tags:
            //      public
            var newProjectUri = "epi.cms.project:///" + projectId;
            topic.publish("/epi/shell/context/request", { uri: newProjectUri }, { sender: this });
        },

        getCommands: function () {
            // summary:
            //      Returns all available commands
            // tags:
            //      public

            return this.commands;
        },

        addProject: function (project) {
            // summary:
            //      Adds a project and sets it as the currentProject
            // tags:
            //      public
            this.projectStore.add(project)
                .then(lang.hitch(this, function (value) {
                    this.set("currentProject", value);
                }))
                .otherwise(errorHandler.forXhr);
        },

        getProject: function () {
            // summary:
            //      Get the current project.
            // tags:
            //      public

            return this.get("currentProject");
        },

        updateProject: function (project) {
            // summary:
            //      Adds a project and sets it as the currentProject
            // tags:
            //      public

            this.projectStore.put(project)
                .then(lang.hitch(this, "set", "currentProject"))
                .otherwise(errorHandler.forXhr);
        },

        reactivateProject: function () {
            // summary:
            //      Reactivates a project that has been scheduled to publish.
            // returns:
            //      Promise
            // tags:
            //      public

            if (!this.currentProject) {
                return new Deferred().resolve();
            }

            return this.projectService.reactivateProject(this.currentProject.id);
        },

        removeProject: function () {
            // summary:
            //      Removes the selected project and sets the currentProject property to null.
            // tags:
            //      public
            if (!this.currentProject) {
                return new Deferred().resolve();
            }

            return this.projectStore.remove(this.currentProject.id).then(lang.hitch(this, function () {
                this.set("currentProject", null);
            }));
        },

        _createCommands: function () {

            var commandArgs = {
                    model: this,
                    category: "context",
                    propertiesToWatch: ["currentProject"]
                },
                commands = this.own(
                    new AddProject(commandArgs),
                    new RenameProject(commandArgs),
                    new RemoveProject(commandArgs)
                );

            this.set("commands", commands);
        }
    });
});

},
'url:epi-cms/project/templates/ProjectModeToolbar.html':"﻿<div class=\"epi-project-mode-toolbar\">\r\n\t<span data-dojo-attach-point=\"projectIconNode\" class=\"dijitReset dijitInline epi-project-mode-toolbar__icon-node\">\r\n\t\t<span class=\"dijitReset dijitInline dijitIcon epi-iconProject\"></span>\r\n    </span>\r\n    <span data-dojo-attach-point=\"projectLabelNode\" class=\"dijitInline\">${localizations.label}</span>\r\n    <span data-dojo-attach-point=\"projectSelectorNode\"></span>\r\n    <span class=\"dijitInline epi-project-mode-toolbar__warning-label\">${localizations.projectdoesnotexists.currentprojectdoesnotexists}</span>\r\n    <span data-dojo-attach-point=\"contextMenu\" class=\"epi-project-mode-toolbar__contextmenu\"></span>\r\n    <span data-dojo-attach-point=\"projectOverviewButtonNode\"></span>\r\n</div>\r\n",
'url:epi-cms/project/templates/CurrentProjectDoesNotExistsWarning.html':"<div class=\"epi-project-mode-project-deleted-warning\">${warning}</div>\r\n<p>${description}</p>",
'epi-cms/widget/CategorySelector':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/query",

    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Button",
    "dijit/Tooltip",

    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/widget/CategorySelectorDialog",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/epi",
    "epi/shell/widget/dialog/Dialog",

    "./viewmodel/CategorySelectorViewModel",

    "dojo/text!./templates/CategorySelector.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.CategorySelector"
],

function (
    array,
    declare,
    lang,
    domAttr,
    domClass,
    domConstruct,
    query,

    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,
    Button,
    Tooltip,

    _HasChildDialogMixin,
    CategorySelectorDialog,
    _ValueRequiredMixin,
    epi,
    Dialog,

    CategorySelectorViewModel,

    template,
    res) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _HasChildDialogMixin, _ValueRequiredMixin], {
        // tags:
        //      internal

        templateString: template,

        localization: res,
        //this widget wants a value that is an array
        multiple: true,

        value: null,

        onChange: function (value) {
            // summary:
            //    Fired when value is changed.
            //
            // value:
            //    The value
            // tags:
            //    public, callback
        },

        postMixInProperties: function () {
            // summary:
            //      Initialize properties
            // tags:
            //      protected

            this.inherited(arguments);

            this.model = new CategorySelectorViewModel();
            this.own(this.model);
        },

        startup: function () {
            this.inherited(arguments);

            this.own(this.connect(this.button, "click", this._onButtonClick));
        },

        destroyDescendants: function () {
            if (this._tooltip) {
                this._tooltip.destroy();
                delete this._tooltip;
            }
            this.inherited(arguments);
        },

        postCreate: function () {
            // summary:
            //      Overridden to initialize ui elements when no value is set.

            this.inherited(arguments);

            if (!this.value) {
                this._updateDisplayNode();
            }
        },

        _setValueAttr: function (value) {
            //summary:
            //    Value's setter.
            //
            // value: array of categories.
            //    Value to be set.
            //
            // tags:
            //    protected

            if (!lang.isArray(value)) {
                value = [value];
            }
            var filteredValue = array.filter(value, function (v) {
                return !!v;
            });
            this._setValueAndFireOnChange(filteredValue);

            if (filteredValue.length > 0) {
                this._set("value", filteredValue);
            } else {
                this._set("value", null);
            }

            this._started && this.validate();
        },

        _setValueAndFireOnChange: function (value) {
            // Compare arrays
            if (epi.areEqual(this.model.get("categories"), value)) {
                return;
            }

            this.model.set("categories", value);
            this.onChange(this.model.get("categories"));
            this._updateDisplayNode();
        },

        _getValueAttr: function () {
            //summary:
            //    Value's getter
            // tags:
            //    protected

            return this.model.get("categories");
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            this.button.style.display = value ? "none" : "";
            domClass.toggle(this.domNode, "dijitReadOnly", value);
        },

        focus: function () {
            this.button.focus();
        },

        isValid: function () {
            // summary:
            //      Returns true if the editor is not required or if it contains one or more categories.
            // tags:
            //      protected

            if (!this.required) {
                return true;
            }
            var value = this.get("value");
            return value && value.length > 0;
        },

        _createCategoryButton: function (category) {
            //summary:
            //    create category button.
            //
            // categoryId: category id.

            // categoryName: category name.
            //
            // tags:
            //    private


            //
            // TODO: create a widget for item with a template instead of creating dom nodes
            //

            //don't add a button if it's already added.
            if (query("div[data-epi-category-id='" + category.id + "']", this.categoriesGroupContainer).length !== 0) {
                return;
            }

            var containerDiv = domConstruct.create("div", { "class": "dijitReset dijitLeft dijitInputField dijitInputContainer epi-categoryButton" });
            var buttonWrapperDiv = domConstruct.create("div", { "class": "dijitInline epi-resourceName" });
            var categoryNameDiv = domConstruct.create("div", { "class": "dojoxEllipsis", innerHTML: category.description });
            domConstruct.place(categoryNameDiv, buttonWrapperDiv);

            domConstruct.place(buttonWrapperDiv, containerDiv);
            // create tooltip for the div
            this._tooltip = new Tooltip({
                connectId: categoryNameDiv,
                label: this._getCategoryPath(category)
            });


            var removeButtonDiv = domConstruct.create("div", { "class": "epi-removeButton", innerHTML: "&nbsp;" });
            domAttr.set(removeButtonDiv, "data-epi-category-id", category.id);
            var eventName = removeButtonDiv.onClick ? "onClick" : "onclick";

            if (!this.readOnly) {
                this.connect(removeButtonDiv, eventName, lang.hitch(this, this._onRemoveClick));
                domConstruct.place(removeButtonDiv, buttonWrapperDiv);
            } else {
                domConstruct.place(domConstruct.create("span", { innerHTML: "&nbsp;" }), buttonWrapperDiv);
            }

            domConstruct.place(containerDiv, this.categoriesGroupContainer);
        },

        _getCategoryPath: function (category) {
            // summary:
            //    Return the path to a category excluding root.
            // category:
            //    the category
            // tags:
            //    private

            if (!category.parentsNameCollection || category.parentsNameCollection.length === 1) {
                return "";
            }

            // The parentsNameCollection contains categories on the path to a category including the root category
            // and that category node itself (e.g.: [Root,BlogRoot,Javascript]). On the UI, the Root is not shown,
            // so the path to a category starts from 2nd level of the tree (e.g.: BlogRoot/Javascript).
            var path = category.parentsNameCollection[1];
            for (var i = 2; i < category.parentsNameCollection.length; i++) {
                path = path + "/" + category.parentsNameCollection[i];
            }

            return path;
        },

        _createNoCategoriesChosenSpan: function () {
            //summary:
            //    create no categories chosen span.
            //tag:
            //      private

            //domConstruct.empty(this.categoriesGroupContainer);
            domConstruct.create("div", {
                innerHTML: this.localization.nocategorieschosen,
                "class": "epi-categoriesGroup__message"
            }, this.categoriesGroupContainer, "only");
        },

        _updateDisplayNode: function () {
            //summary:
            //    update category group.
            //
            // tags:
            //    private

            this.categoriesGroupContainer.innerHTML = "";

            this.model.refreshCategories().then(function (categories) {
                if (!this.model.hasCategories()) {
                    // Create no categories chosen span if haven't any category in list.
                    this._createNoCategoriesChosenSpan();
                    return;
                }

                categories.forEach(function (category) {
                    this._createCategoryButton(category);
                }, this);
            }.bind(this));
        },

        _onRemoveClick: function (arg) {
            //summary:
            //    handles remove click event.
            //
            // arg: event argument .
            //
            // tags:
            //    private

            if (!this.model.get("categories")) {
                return;
            }

            var categoryId = parseInt(domAttr.get(arg.target, "data-epi-category-id"), 10);
            var categoryIndex = this.model.get("categories").indexOf(categoryId);
            if (categoryIndex === -1) {
                return;
            }

            var remainingCategories = lang.clone(this.model.get("categories"));
            remainingCategories.splice(categoryIndex, 1);
            this.set("value", remainingCategories);
        },

        _getCategoriesParentsNameClone: function () {
            //summary:
            //    get a clone of categoriesPath.
            // tags:
            //    private

            var categoriesParentsNameClone = {};
            array.forEach(this.model.get("categories"), lang.hitch(this, function (categoryId) {
                categoriesParentsNameClone[categoryId] = this.model.get("categoriesParentsName")[categoryId];
            }));

            return categoriesParentsNameClone;
        },

        _onShow: function () {
            //summary:
            //    Handle onShow dialog event.
            // tags:
            //    private

            // the original categories need to keep to support cancel case, so a clone of categories need to pass to category selector dialog.
            this.categorySelectorDialog.set("value", lang.clone(this.model.get("categories")));
            this.categorySelectorDialog.set("selectedCategoriesData", this._getCategoriesParentsNameClone());

            this.isShowingChildDialog = true;
            this.categorySelectorDialog.onShow();
        },

        _onExecute: function () {
            //summary:
            //    Handle dialog close
            // tags:
            //    private

            var categoriesSelected = this.categorySelectorDialog.get("value");

            this.set("value", categoriesSelected);
        },

        _isEmptyArray: function (array) {
            // summary:
            //      Validate empty of array
            // tags:
            //      private
            return !array || array.length === 0;
        },

        _onDialogHide: function () {
            //summary:
            //    Handle dialog close
            // tags:
            //    private
            this.focus();
            this.isShowingChildDialog = false;
        },

        _createDialog: function () {
            // summary:
            //		Create page tree dialog
            // tags:
            //    protected

            this.categorySelectorDialog = new CategorySelectorDialog({
                rootCategory: this.root
            });

            this.dialog = new Dialog({
                title: this.localization.popuptitle,
                content: this.categorySelectorDialog,
                destroyOnHide: false,
                dialogClass: "epi-dialog-portrait"
            });
            this.own(this.dialog);
            this.connect(this.dialog, "onExecute", "_onExecute");
            this.connect(this.dialog, "onShow", "_onShow");
            this.connect(this.dialog, "onHide", "_onDialogHide");

            this.dialog.startup();
        },

        _onButtonClick: function () {
            //summary:
            //    Handle add category button click
            // tags:
            //    private

            if (!this.dialog) {
                this._createDialog();
            }

            this.dialog.show(true);
        }
    });
});

},
'epi-cms/widget/CategorySelectorDialog':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/form/Button",

    "epi",
    "epi/dependency",
    "epi-cms/widget/CategoryTree"
],

function (
    array,
    declare,
    lang,

    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

    Button,

    epi,
    dependency,
    CategoryTree
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //      Category selector widget.
        //      Used for editing PropertyCategory properties in flyout editor.
        // tags:
        //      internal

        // templateString: [protected] String
        //      Widget's template string.
        templateString: "<div class=\"epi-categorySelectorDialog\"> \
                            <div data-dojo-attach-point=\"categoryTree\" data-dojo-type=\"epi-cms/widget/CategoryTree\" data-dojo-props=\"rootCategory: ${rootCategory}\"></div> \
                        </div>",

        // selectedCategoriesData: [Object] public
        //      Object that contains necessary selected categories information
        selectedCategoriesData: null,

        // _selectedCategoryIds: [Array] private
        //      Array of selected category identities
        _selectedCategoryIds: null,

        rootCategory: null,

        onShow: function () {
            // summary:
            //      handles onShow dialog event.
            // tags:
            //      public

            if (!this._selectedCategoryIds && !this.categoryTree) {
                return;
            }

            this.categoryTree.set("selectedNodeIds", this._selectedCategoryIds);
            this.categoryTree.set("selectedNodeData", this.selectedCategoriesData);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Value's setter.
            // value: String
            //      Value to be set.
            // tags:
            //      private

            this._selectedCategoryIds = value;

            if (!this._selectedCategoryIds) {
                this._selectedCategoryIds = [];
            }
        },

        _getValueAttr: function () {
            // summary:
            //      Value's getter
            // tags:
            //      private

            return this.categoryTree.get("selectedNodeIds");
        }
    });

});

},
'epi-cms/widget/CategoryTree':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dijit/Tree",

    "epi",
    "epi-cms/widget/_CategoryTreeNode",
    "epi-cms/widget/CategoryTreeStoreModel"
],

function (
    array,
    declare,
    lang,

    Tree,

    epi,
    _CategoryTreeNode,
    CategoryTreeStoreModel
) {

    return declare([Tree], {
        // summary:
        //      The EPiServer Category tree.
        //      The page tree shows the EPiServer Category  page tree using a REST store to fetch the data.
        // tags:
        //      internal

        // Hide the root node.
        showRoot: false,

        // selectedNodeIds: [Array] public
        //      Array of selected node identies
        selectedNodeIds: null,

        // selectedNodeData: [Object] public
        //      Object that hold all necessary information about selected nodes
        selectedNodeData: null,

        constructor: function () {
            this.selectedNodeIds = [];
            this.selectedNodeData = {};
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model) {
                this.model = new CategoryTreeStoreModel({rootCategory: this.rootCategory});
                this.persist = false;
            }
        },

        postCreate: function () {
            this.inherited(arguments);

            this.connect(this, "onOpen", lang.hitch(this, this._onNodeOpen));
            this.connect(this, "onClose", lang.hitch(this, this._onNodeClose));

            this.watch("selectedNodeData", lang.hitch(this, this._loadSelectedNodes));
        },

        startup: function () {

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            // Disabling multiselect in tree
            this.dndController.singular = true;
        },

        buildNodeFromTemplate: function (args) {
            // summary:
            //      Build tree node from the given template.
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            return new _CategoryTreeNode(args);
        },

        getTooltip: function (item) {
            // summary:
            //		Overridden to select data for the tooltip
            // tags:
            //		public, extension

            var getter = this.model.getTooltip || this.model.getLabel;

            return getter ? getter(item) : this.inherited(arguments);

        },

        getNodeById: function (categoryId) {
            // summary:
            //      get the tree node by category id.
            // categoryId:
            //      the category id.
            // tags:
            //      public

            var nodes = this.getNodesByItem(categoryId.toString());
            if (!nodes) {
                return null;
            }

            return nodes[0];
        },

        _getTotalSelectedNodes: function (/*Object*/parentNode, /*Array*/selectedNodeIds, /*Object*/selectedData) {
            // summary:
            //      Get total selected child nodes under the given collapsed parent node
            // parentNode:
            //      Parent tree node that we want to display total selected child items (contains selected child nodes or not)
            // selectedNodeIds:
            //      Selected child node identities
            // selectedData:
            //      Selected child node data (object that contains selected child node identities and its parent names
            // tags:
            //      private

            if (!parentNode || !parentNode.item || !parentNode.item.hasChildren ||
                !lang.isArray(selectedNodeIds) || selectedNodeIds.length === 0 ||
                !selectedData) {
                return 0;
            }

            var totalItems = 0,
                targetArray = [], compareArray = [],
                parentsNameCollection = lang.clone(parentNode.item.parentsNameCollection);

            var removeSelectedItem = function (targetArray) {
                if (lang.isArray(targetArray) && targetArray.length > 0) {
                    targetArray.pop();
                }
            };

            parentsNameCollection[parentsNameCollection.length - 1] = parentNode.item.description;

            array.forEach(selectedNodeIds, function (selectedNodeId) {

                targetArray = lang.clone(selectedData[selectedNodeId]);
                // Remove selected node from selected path
                removeSelectedItem(targetArray);

                // Ensure we count correct in case the selected nodes that have the same name, but in other levels
                compareArray = lang.clone(targetArray);
                lang.mixin(compareArray, parentsNameCollection);

                if (lang.isArray(targetArray) && epi.areEqual(targetArray, compareArray)) {
                    totalItems++;
                }
            }, this);

            return totalItems;
        },

        _setTotalSelectedNodes: function (/*Tree._TreeNode*/parentNode) {
            // summary:
            //      Set total selected nodes recurisvely
            // tags:
            //      private

            if (parentNode) {
                parentNode.set("totalSelectedNodes", this._getTotalSelectedNodes(parentNode, this.selectedNodeIds, this.selectedNodeData));

                array.forEach(parentNode.getChildren(), function (childNode) {
                    if (childNode && childNode.item && childNode.item.hasChildren) {
                        if (childNode.isExpanded) {
                            this._setTotalSelectedNodes(childNode);
                        } else {
                            childNode.set("totalSelectedNodes", this._getTotalSelectedNodes(childNode, this.selectedNodeIds, this.selectedNodeData));
                        }
                    }
                }, this);
            }
        },

        _loadSelectedNodes: function () {
            // summary:
            //      Set selected nodes when the first time this tree show
            // tags:
            //      private

            this.expandChildrenDeferred.then(lang.hitch(this, function () {
                this.set("toggleSelectNodes", this.rootNode, this.selectedNodeIds);
                this._setTotalSelectedNodes(this.rootNode);
            }));
        },

        _onNodeCreated: function (node) {
            // summary:
            //      onNodeCreated event.
            // node:
            //      the tree node.
            // tags:
            //      private

            node.set("totalSelectedNodes", this._getTotalSelectedNodes(node, this.selectedNodeIds, this.selectedNodeData));
        },

        _onNodeSelectChanged: function (checked, item) {
            // summary:
            //      onNodeSelectChanged event.
            // checked:
            //      true if the check box is checked,otherwise false.
            // item:
            //      the tree node item.
            // tags:
            //      private

            if (!this.getNodeById(item.id)) {
                return;
            }

            var index = this.selectedNodeIds.indexOf(item.id),
                exist = index !== -1;

            if (checked && !exist) {
                this.selectedNodeIds.push(item.id);
                this.selectedNodeData[item.id] = item.parentsNameCollection;
            }

            if (!checked && exist) {
                this.selectedNodeIds.splice(index, 1);
                this.selectedNodeData[item.id] = {};
            }
        },

        _onNodeOpen: function (item, node) {
            // summary:
            //      handles node expanded event.
            // treeNode:
            //      the tree node.
            // item:
            //      the tree node item.
            // tags:
            //      private

            this.set("toggleSelectNodes", node, this.selectedNodeIds);
            this._setTotalSelectedNodes(node);
        },

        _onNodeClose: function (item, node) {
            // summary:
            //      handles node closed event.
            // treeNode:
            //      the tree node.
            // item:
            //      the tree node item.
            // tags:
            //      private

            this._setTotalSelectedNodes(node);
        },

        _setToggleSelectNodesAttr: function (/*Object*/parentNode, /*Array*/toggleNodeIds) {
            // summary:
            //      Set selected for the given nodes in tree
            // tags:
            //      private

            if (!parentNode || !lang.isArray(toggleNodeIds)) {
                return;
            }

            var checked = false;
            array.forEach(parentNode.getChildren(), function (childNode) {
                if (childNode) {
                    checked = toggleNodeIds.indexOf(childNode.item.id) !== -1;
                    childNode.set("checked", checked);

                    if (childNode.hasChildren()) {
                        this.set("toggleSelectNodes", childNode, toggleNodeIds);
                    }
                }
            }, this);
        },

        _createTreeNode: function (/*Object*/args) {
            // summary:
            //      Overridable function to create tree node.
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            var node = this.buildNodeFromTemplate(args);
            node.connect(node, "onNodeSelectChanged", lang.hitch(this, function (checked, item) {
                this._onNodeSelectChanged(checked, item);
            }));

            this._onNodeCreated(node);

            return node;
        }
    });

});

},
'epi-cms/widget/_CategoryTreeNode':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/keys",

    "dojo/text!./templates/_CategoryTreeNode.html",
    // dijit
    "dijit/_TemplatedMixin",
    "dijit/form/CheckBox",
    // epi
    "epi",
    "epi-cms/widget/_ContentTreeNode"
],

function (
// dojo
    declare,
    lang,

    domClass,
    domConstruct,
    keys,

    template,
    // dijit
    _TemplatedMixin,
    CheckBox,
    // epi
    epi,
    _ContentTreeNode
) {

    return declare([_ContentTreeNode, _TemplatedMixin], {
        // summary:
        //      A customized treenode for page tree
        //      Redefine template string. Use <a> tag to be able to drag in IE
        // tags:
        //      internal

        templateString: template,

        _checkbox: null,

        // checked: [Boolean] public
        //      Indicate that the current node is checked or not
        checked: false,

        postCreate: function () {
            // summary:
            //      Place checkbox into the tree node after node created.
            // tags:
            //      protected

            this.inherited(arguments);

            domClass.add(this.iconNode, "dijitHidden");

            this._checkbox = this._createCheckbox();
        },

        _createCheckbox: function () {
            // summary:
            //      Create checkbox for the tree node.
            // tags:
            //      private

            if (!this.item.selectable) {
                return;
            }

            var container = domConstruct.create("span", {
                "class": "epi-checkboxNode dijitTreeExpando"
            });

            var checkbox = new CheckBox({
                name: "checkboxCategory",
                value: this.item.id,
                tabIndex: -1,
                checked: false,
                onChange: lang.hitch(this, function (checked) {
                    this.onNodeSelectChanged(checked, this.item);
                })
            });

            checkbox.placeAt(container);
            domConstruct.place(container, this.expandoNode, "after");

            return checkbox;
        },

        onNodeSelectChanged: function (checked, item) {
            // summary:
            //      on checkbox clicked event.
            // tags:
            //      public callback
        },

        _onLabelClick: function () {
            // summary:
            //      clicking the label toggles the checkbox
            // tags:
            //      private

            if (!this._checkbox) {
                return;
            }

            this.set("checked", !this._checkbox.checked);
        },

        _onLabelKeyUp: function (evt) {
            // summary:
            //      pressing a key on the label toggles the checkbox
            // tags:
            //      private

            if (evt.keyCode === keys.SPACE || evt.keyCode === keys.ENTER) {
                this._onLabelClick();
            }
        },

        _setCheckedAttr: function (checked) {
            // summary:
            //      Check/UnCheck the node.
            // tags:
            //      public

            if (!this._checkbox) {
                return;
            }

            this._set("checked", checked);
            this._checkbox.set("checked", checked);
        },

        _setTotalSelectedNodesAttr: function (/*Int*/totalItems) {
            // summary:
            //      update label of the tree node.
            // totalItems:
            //      Total selected child nodes
            // tags:
            //      public

            var originalLabel = this.tree.model.getLabel(this.item),
                addTotal = !this.isExpanded && totalItems > 0;

            this.labelNode.innerHTML = addTotal ? originalLabel + " (" + totalItems + ")" : originalLabel;
        }
    });

});

},
'url:epi-cms/widget/templates/_CategoryTreeNode.html':"﻿<div class=\"dijitTreeNode epi-categoryTreeNode\" role=\"presentation\">\r\n    <a href=\"#\" tabIndex=\"-1\" data-dojo-attach-point=\"rowNode\" class=\"dijitTreeRow\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel epi-categoryTreeLabel\" role=\"treeitem\"\r\n                  tabindex=\"-1\" aria-selected=\"false\" data-dojo-attach-event=\"onclick:_onLabelClick, keyup:_onLabelKeyUp\">\r\n            </span>\r\n        </span>\r\n    </a>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>",
'epi-cms/widget/CategoryTreeStoreModel':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojox/html/entities",
    "epi/dependency",
    "epi/routes"
], function (declare, lang, when, entities, dependency, routes) {

    return declare(null, {
        // summary:
        //      store model for category tree.
        //
        // tags:
        //      internal

        // store: [protected] dojo/store/api/Store
        //      Underlying store that will be queried for category tree items.
        store: null,

        // rootCategory: [protected]
        //      Store root category id.
        rootCategory: undefined,

        constructor: function (args) {

            lang.mixin(this, args);

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.category");
            }
        },

        // =======================================================================
        // Methods for traversing hierarchy

        getRoot: function (onItem) {
            // summary:
            //      Calls onItem with the root item for the tree, possibly a fabricated item.

            when(this.store.get(this.rootCategory), onItem);
        },

        mayHaveChildren: function (item) {
            // summary:
            //      Tells if an item has or may have children.  Implementing logic here
            //      avoids showing +/- expando icon for nodes that we know don't have children.
            //      (For efficiency reasons we may not want to check if an element actually
            //      has children until user clicks the expando node)

            return item.hasChildren;
        },

        getChildren: function (parentItem, onComplete) {
            // summary:
            //      Calls onComplete() with array of child items of given parent item, all loaded.

            var id = this.getIdentity(parentItem),
                results = this.store.query({ id: id, query: "getchildren" });

            results.then(function (children) {
                parentItem.children = children;
                onComplete(children);
            });
        },

        // =======================================================================
        // Inspecting items

        getIdentity: function (item) {
            // summary:
            //      Returns identity for an item

            return this.store.getIdentity(item);
        },

        getTooltip: function (item) {
            // summary:
            //      Get the tooltip for an item

            return item.description;
        },

        getLabel: function (item) {
            // summary:
            //      Get the label for an item

            return entities.encode(item.description);
        }
    });
});

},
'epi-cms/widget/viewmodel/CategorySelectorViewModel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "dijit/Destroyable",
    "dojo/Stateful",
    "dojo/when",
    "dojo/promise/all",

    "epi/dependency"
],

function (
    declare,
    Deferred,
    Destroyable,
    Stateful,
    when,
    all,

    dependency
) {

    return declare([Stateful, Destroyable], {
        // tags:
        //      internal

        // _categories: [private] Array
        //      List of selected category id's
        _categories: null,

        // _categoriesParentsName: [private] Object
        //      Named indexes array of Parents for categories
        _categoriesParentsName: null,

        // _updateDisplayPromise: [private] Object
        //      Result of refreshing categories
        _updateDisplayPromise: null,

        // store: [private] Store
        //      Category store
        store: null,

        constructor: function (kwArgs) {
            if (kwArgs && kwArgs.store) {
                this.store = kwArgs.store;
            } else {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.category");
            }

            this._categoriesParentsName = {};
        },

        destroy: function () {
            this.inherited(arguments);

            if (this._updateDisplayPromise) {
                this._updateDisplayPromise.cancel();
                this._updateDisplayPromise = null;
            }
        },

        refreshCategories: function () {
            //summary:
            //    refresh categories list
            //
            // tags:
            //    public

            var result = new Deferred();

            this._categoriesParentsName = {};

            if (!this.hasCategories()) {
                result.resolve([]);
                return result.promise;
            }

            var dfdList = [];
            var categoriesToRemove = [];
            this._categories.forEach(function (categoryId) {
                var def = when(this.store.refresh(categoryId))
                    .then(function (category) {
                        if (!category || !category.visible) {
                            categoriesToRemove.push(categoryId);
                            return null;
                        }

                        this._categoriesParentsName[category.id] = category.parentsNameCollection;
                        return category;
                    }.bind(this), function () {
                        categoriesToRemove.push(categoryId);
                        return null;
                    }.bind(this));

                dfdList.push(def);
            }, this);

            this._updateDisplayPromise = all(dfdList)
                .then(function (categories) {

                    // Clear the pointer to the promise since it is resolved.
                    this._updateDisplayPromise = null;

                    categoriesToRemove.forEach(function (c) {
                        var categoryIndex = this._categories.indexOf(c);
                        if (categoryIndex !== -1) {
                            this._categories.splice(categoryIndex, 1);
                        }
                    }.bind(this), this);

                    result.resolve(categories.filter(function (c) {
                        return c !== null;
                    }));
                }.bind(this));

            return result.promise;
        },

        hasCategories: function () {
            //summary:
            //    Returns true when categories has at least one element
            //
            // tags:
            //    public

            var categories = this.get("categories");
            return !!categories && categories.length > 0;
        },

        hasCategory: function (categoryId) {
            //summary:
            //    Returns true when category for specific id is on the list
            //
            // tags:
            //    public

            return this.get("categories") && this.get("categories").indexOf(categoryId) !== -1;
        },

        _categoriesParentsNameGetter: function () {
            //summary:
            //    Getter for categoriesParentsName
            //
            // tags:
            //    private

            return this._categoriesParentsName;
        },

        _categoriesGetter: function () {
            //summary:
            //    Getter for categories
            //
            // tags:
            //    private

            return this._categories;
        },

        _categoriesSetter: function (value) {
            //summary:
            //    Setter for categoriesParentsName
            //
            // tags:
            //    private

            this._categories = value;
        }
    });
});

},
'url:epi-cms/widget/templates/CategorySelector.html':"﻿<div class=\"dijitReset dijitInputField dijitInputContainer dijitInline epi-resourceInputContainer epi-categorySelector\" id=\"widget_${id}\">\r\n    <div data-dojo-attach-point=\"categoriesGroupContainer\" class=\"dijit dijitReset dijitInline dijitInlineTable dijitLeft dijitTextBox displayNode epi-categoriesGroup\">\r\n    </div>\r\n\r\n    <span data-dojo-attach-point=\"button\" class=\"dijitInline dijitIcon epi-iconContextMenu\"></span>\r\n</div>\r\n",
'epi-cms/widget/overlay/ContentArea':function(){
define([
    // Dojo
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/on",
    "dojo/query",

    // Dijit
    "dijit/_Container",
    "dijit/registry",

    // EPi Framework
    "epi",
    "epi/shell/widget/overlay/Item",
    "epi/shell/dnd/Source",
    "epi/shell/dnd/_MarkerSource",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/applicationSettings",

    // EPi CMS
    "epi-cms/core/ContentReference",
    "epi-cms/widget/overlay/Block",
    "epi-cms/contentediting/editors/ContentBlockEditor",
    "epi-cms/widget/command/CreateContentFromContentArea",
    "epi-cms/widget/command/CreateContentFromSelector",
    "epi-cms/contentediting/viewmodel/ContentAreaViewModel",
    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/editors/_TextWithActionsMixin",
    "epi-cms/ApplicationSettings",

    // Resources
    "dojo/text!../templates/ContentArea.html"
], function (
    // Dojo
    declare,
    aspect,
    on,
    query,

    // Dijit
    _Container,
    registry,

    // EPi Framework
    epi,
    Item,
    Source,
    _MarkerSource,
    TypeDescriptorManager,
    shellApplicationSettings,

    // EPi CMS
    ContentReference,
    Block,
    ContentBlockEditor,
    CreateContentFromContentArea,
    CreateContentFromSelector,
    ContentAreaViewModel,
    ContentBlockViewModel,
    _TextWithActionsMixin,
    ApplicationSettings,

    // Resources
    template
) {

    return declare([Item, _Container, _TextWithActionsMixin], {
        // tags:
        //      internal xproduct

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // _hasTextActionsIcon: [internal] boolean
        hasTextActionsIcon: true,

        // layout: [public] String
        //      Used to indicate in which direction drag and drop should function; vertical or horizontal.
        layout: "",

        // defaultWatchKey: [public] String
        //      Used to kind of default handler when children change for all area.
        defaultWatchKey: "",

        allowedDndTypes: null,

        // blockClass: [public] Class
        //      Used to inject block overlay class.
        blockClass: Block,

        // modelClass: [public] Class
        //      Used to inject model for this.
        modelClass: ContentAreaViewModel,

        dndSourceClass: declare([Source, _MarkerSource]),

        // dndSourceSettings: [public] Json object
        //      Used to inject settings for dnd source.
        dndSourceSettings: null,

        // allowedTypes: [public] Array
        //      The types which are allowed. i.e used for filtering based on AllowedTypesAttribute
        allowedTypes: null,

        // restrictedTypes: [public] Array
        //      The types which are restricted.
        restrictedTypes: null,

        _supressValueChanged: false,

        // typesFormatSuffix: [public] String
        //      Suffix string for allow type.
        typesFormatSuffix: null,

        constructor: function () {
            this._watches = {};
        },

        postMixInProperties: function () {
            // summary:
            //      Create the view model if it doesn't exist and update the view model with the current value of this property.
            // tags:
            //      protected
            this.inherited(arguments);

            if (!this.model) {
                this.model = new this.modelClass();
            }

            this.own(this.model);

            // Must copy the values, otherwise updates are done to the values inside the content model,
            // circumventing the undo function.
            // Shouldn't be done here, but since we only have the content model there's really no other solution.
            this.model.set("value", Object.assign([], this.getFormattedValue(this.contentModel.get(this.name))));

            // Since we're copying the values we must also listen to changes, since we no longer have
            // references to the backing data.
            this.own(this.contentModel.watch(this.name, function (name, oldValue, value) {
                if (epi.areEqual(this.getFormattedValue(value), this.model.get("value"))) {
                    return;
                }
                this.refresh();
            }.bind(this)));

            this._pendingPersonalizations = [];

            this._ownerContentLink = this.contentModel.get("icontent_contentlink");
        },

        getFormattedValue: function (value) {
            return value;
        },

        buildRendering: function () {
            this.inherited(arguments);

            this._setupActions(this.actionsNodeControls);
        },

        postCreate: function () {
            // summary:
            //      Configure the drag and drop direction and synchronize the visible content blocks with the view model.
            // tags:
            //      protected

            var timeout;
            // prevent showing the floating editor after double clicking
            this.own(on(this.domNode, "click", function (e) {
                e.stopImmediatePropagation();
                if (e.detail === 1) {
                    timeout = setTimeout(function () {
                        this.onClick(this, e);
                    }.bind(this), 500);
                }

                if (e.detail === 2) {
                    clearTimeout(timeout);
                }
            }.bind(this))
            );

            this.inherited(arguments);

            this.own(on(this.model, "changed", function () {

                if (!this._started || this._supressValueChanged) {
                    return;
                }

                this._onChildrenChanged();

                if (this._pendingPersonalizations.length > 0) {
                    this._pendingPersonalizations = [];

                    // TODO: refactor this, trigger an activate/select event or watch to force a start edit
                    this.onClick(this);
                }
            }.bind(this)));

            this._setupDirectionality();

            this._setupBlocks();
        },

        destroy: function () {

            this.inherited(arguments);

            // Destroy all the current blocks and reset the map.
            for (var i in this._watches) {
                this._watches[i].remove();
            }
            this._watches = {};

            this._source.destroy();

            if (this.textWithLinks) {
                this.textWithLinks.destroy();
                this.textWithLinks = null;
            }
        },


        isCreateLinkVisible: function () {
            // summary:
            //      Overridden to hide the "create block" link when user doesn't have permission to create new blocks in the local assets folder.

            return this.model.canCreateBlock(this.allowedTypes, this.restrictedTypes);
        },

        onDialogExecute: function (selectedContent) {
            selectedContent && this.model && this.model.addChild({
                contentLink: new ContentReference(selectedContent.contentLink).createVersionUnspecificReference().toString(),
                name: selectedContent.name,
                typeIdentifier: selectedContent.typeIdentifier
            });

            this._onChildrenChanged();
        },

        _setHasChildrenAttr: function (value) {
            this._set("hasChildren", value);
        },

        _getMinHeightAttr: function () {
            return this.sourceItemNode.style.minHeight;
        },

        onValueChange: function (values) {
            // summary:
            //      Event to notify that this and possibly other properties
            //      has changed their values
            // values: Object || [Object]
            //      The property values that has changed. {propertyName: "propertyName", value: value}
            // tags:
            //      public callback
        },

        onForceValueChange: function (values) {
            this.onValueChange(values);
        },

        updatePosition: function (position) {
            // summary:
            //      Override of the base implementation to include positioning
            //      of the blocks
            //
            // position: Object
            //      the coordinates to set the position to

            if (!this.canUpdatePosition() && !ApplicationSettings.limitUI) {
                return false;
            }

            // NOTE: this assumes there's a width, but maybe not a height
            var actionClientRect = this.actionsNodeControls.getBoundingClientRect();
            var currentActionNodeHeight = Math.floor(actionClientRect.bottom - actionClientRect.top);
            var actionNodeHeight = currentActionNodeHeight > 0 ? currentActionNodeHeight : this.get("actionNodeHeight") || 0;
            var result, originalMinHeight;

            // first size this to match source node
            if (ApplicationSettings.limitUI) {
                var extendedPosition = {
                    h: position.h + Math.max(actionNodeHeight || 32),
                    w: position.w,
                    l: position.l,
                    t: position.t,
                    x: position.x,
                    y: position.y
                };
                if (position.h > 0 || position.w > 0) {
                    result = this.inherited(arguments, [extendedPosition, true]);
                } else {
                    result = false;
                }
            } else {
                result = this.inherited(arguments);
            }

            if (this.hasChildren) {
                // update position of blocks
                this._setupDirectionality();
                this._positionBlocks();
            }

            // get min height before we reset it
            originalMinHeight = this.get("minHeight");

            // reset min height on source node
            this.sourceItemNode.style.minHeight = "";

            var sourceClientRect = this.sourceItemNode.getBoundingClientRect && this.sourceItemNode.getBoundingClientRect();
            var sourceNodeHeight = Math.floor(ApplicationSettings.limitUI ? position.h : (sourceClientRect.bottom - sourceClientRect.top));

            if (sourceNodeHeight === 0) {
                sourceNodeHeight = position.h;
            }

            if (ApplicationSettings.limitUI === true) {
                actionNodeHeight && (this.set("actionNodeHeight", actionNodeHeight));
                this.actionsNodeControls.style.marginTop = (sourceNodeHeight) + "px";
                // if we got here, return false, this is considered to be no resize of dom node
                if (originalMinHeight === sourceNodeHeight + actionNodeHeight) {
                    return result;
                }
            } else {
                // actionNode has not taken it's height yet, no need to resize anything, abort.
                if (actionNodeHeight === 0) {

                    // if sourceNodeHeight is 0 then ContentArea is hidden and _clearPosition
                    // will be executed in every iteration.
                    // This will affect whole iframe to be reloaded endless
                    if (sourceNodeHeight !== 0) {
                        this._clearPosition();
                        return result;
                    }
                }

                actionNodeHeight && (this.set("actionNodeHeight", actionNodeHeight));

                // set a min height
                this.sourceItemNode.style.minHeight = (sourceNodeHeight + actionNodeHeight) + "px";
                this.actionsNodeControls.style.marginTop = (sourceNodeHeight) + "px";

                // if we got here, return false, this is considered to be no resize of dom node
                if (originalMinHeight === sourceNodeHeight + actionNodeHeight) {
                    return result;
                }
            }
            // if we get here we consider it as a resizse
            return true;
        },

        refresh: function () {
            // summary:
            //      Recreate block overlay item for the current content area.
            // tags:
            //      public
            this._actionNodeHeight = null;

            // Destroy all the child blocks and clear the drag and drop items from the source.
            this.destroyDescendants();
            this._source.clearItems();
            if (this._source.anchor) {
                this._source.anchor.remove();
            }

            // Destroy all the current blocks and reset the map.
            for (var i in this._watches) {
                this._watches[i].remove();
            }
            this._watches = {};

            this._supressValueChanged = true;

            // Update model to the latest value and recreate the blocks from the DOM.
            this.model.set("value", Object.assign([], this.getFormattedValue(this.contentModel.get(this.name))));
            this._setupBlocks();

            this.inherited(arguments);

            this._supressValueChanged = false;
        },

        _setDisabledAttr: function () {
            this.inherited(arguments);
            if (this.position && !ApplicationSettings.limitUI) {
                // when Disabled value is false, the display attribute will change to ""
                // but somethimes the overlay should be forced to be hidden by updatePosition function
                // Calling updatePosition again will check this and eventually set display to "none"
                // When running with limitUI we have floating editors built from element metadata and not the
                // sourcenodes themselves. This code will hide the overlay items for content areas so lets not run it.
                this.updatePosition(this.position);
            }
        },

        _setupDnd: function () {
            // summary:
            //      Overrides the default implementation creating a suitable source for the BlockArea
            // tags:
            //      private

            var settings = Object.assign({
                _skipStartup: true,
                creator: this._creator.bind(this),
                copyOnly: false,
                alwaysCopy: false,
                dropParent: this.containerNode,
                type: this.allowedDndTypes,
                accept: this.allowedDndTypes,
                reject: this.restrictedDndTypes,
                singular: true,
                propertyName: this.name,
                allowMultipleItems: false
            }, this.dndSourceSettings || {});

            settings.accept.push(this._getInlineBlockDndKey());

            this._source = new this.dndSourceClass(this.domNode, settings);

            this._source.defaultCheckAcceptance = this._source.checkAcceptance;
            this._source.checkAcceptance = this._checkAcceptance.bind(this);

            this.own(aspect.after(this._source, "onDropData", this._onDrop.bind(this), true));
            this.own(aspect.before(this._source, "delItem", this._onDndItemRemoved.bind(this), true));
        },

        _creator: function (item) {
            // summary:
            //      Customizes dnd item creation
            // tags:
            //      protected
            var node = document.createElement("div"),
                itemData;

            if (typeof item.getNormalizedData == "function") {
                itemData = item.getNormalizedData();
            }

            itemData = itemData ? itemData.data : item;

            return {
                node: node,
                type: this.allowedDndTypes,
                data: itemData
            };
        },

        _getDndItemType: function (childItem) {
            if (childItem.inlineBlockData) {
                return [this._getInlineBlockDndKey()];
            }

            if (this.typesFormatSuffix && childItem.typeIdentifier) {
                return TypeDescriptorManager.getInheritanceChain(childItem.typeIdentifier).map(function (type) {
                    return type + "." + this.typesFormatSuffix;
                }.bind(this));
            }

            return this.allowedDndTypes;
        },

        _setupBlocks: function () {
            // summary:
            //      Creates and positions the blocks.
            var blocks = this._getBlockNodes();

            blocks.forEach(this._createBlock.bind(this));

            this.set("hasChildren", blocks.length > 0);
        },

        _createBlock: function (node) {
            // summary:
            //      Creates a single block.

            var id = node.dataset.epiBlockId,
                contentGuid = node.dataset.epiContentId,
                itemIndex = node.dataset.epiContentareaItemIndex,
                info = JSON.parse(node.dataset.epiBlockPersonalization || null) || {},
                contentGroup = info ? info.contentGroup : this.defaultWatchKey,
                model = this.model,
                childIdentifier = {};

            var epiBlockInfo = JSON.parse(node.dataset.epiBlockInfo || null) || {};

            // Get the view model for the item's group.
            if (contentGroup) {
                model = model.getChild({ name: contentGroup });
            }

            var isLocalBlock = epiBlockInfo && epiBlockInfo.inlineBlockContentTypeId && typeof itemIndex !== "undefined";
            if (isLocalBlock) {
                childIdentifier = {inlineBlockDataIndex: parseInt(itemIndex)};
            } else {
                if (id) {
                    childIdentifier = {contentLink: new ContentReference(id).createVersionUnspecificReference().toString()};
                } else if (contentGuid) {
                    childIdentifier = {contentGuid: contentGuid};
                }
            }

            // Get the view model for the item.
            var indexChild = model && model.getChild(Object.assign(childIdentifier, info));

            if (!indexChild) {
                // Happens when we're notified about model updates, but the markup hasn't
                // been refreshed yet so the block info grabbed from dom doesn't match the model.
                // Should sort itself out once new markup arrives.
                return;
            }

            indexChild.set("isOverlayInitialized", false);
            // TODO: Pass context menu through instead of provider.
            var block = new this.blockClass({
                disabled: this.disabled,
                viewModel: indexChild,
                sourceItemNode: node,
                isLocalBlock: isLocalBlock
            });

            indexChild.set("isOverlayInitialized", true);

            this.addChild(block);

            this._watches["block_" + id + "_ensurePersonalization"] = indexChild.watch("ensurePersonalization", function (propertyName, oldValue, newValue) {

                var index = this._pendingPersonalizations.indexOf(indexChild);

                if (newValue) {

                    // add if it doesn't exist
                    if (index < 0) {
                        this._pendingPersonalizations.push(indexChild);
                    }
                } else {
                    // remove if exists
                    if (index > 0) {
                        this._pendingPersonalizations.splice(index, 1);
                    }
                }

            }.bind(this));

            // Mark the block's model as visible.
            indexChild.set("visible", true);

            // Add the block's node to the drag and drop souce.

            this._source.setItem(block.domNode.id, {
                name: indexChild.name,
                data: indexChild,
                type: this._getDndItemType(indexChild)
            });
        },

        _onChildrenChanged: function () {

            this.onForceValueChange({
                propertyName: this.name,
                value: this.model.get("value")
            });
        },

        _positionBlocks: function () {
            // summary:
            //      Centralized position logic for all blocks within the
            //      area. It is done here since we need to nudge them a
            //      bit to cover the entire area even if the position method disagrees.
            var widgets = this.getChildren(),
                positions = [],
                position = this.get("position");

            widgets.forEach(function (widget, i) {

                var widgetPos;

                if (!positions[i]) {
                    var clientRect = widget.sourceItemNode.getBoundingClientRect();
                    positions[i] = { w: clientRect.right - clientRect.left, h: clientRect.bottom - clientRect.top, x: clientRect.left, y: clientRect.top };
                }

                widgetPos = positions[i];
                widgetPos.x -= position.x;
                widgetPos.y -= position.y;

                widget.resize(widgetPos);

            }.bind(this));

        },

        _checkAcceptance: function (source, nodes) {
            // summary:
            //      Customize checkAcceptance func
            // source: Object
            //      The source which provides items
            // nodes: Array
            //      The list of transferred items
            if (this.readOnly || nodes === undefined) {
                return false;
            }
            var widget = registry.getEnclosingWidget(nodes[0]);
            if (widget.isInstanceOf(ContentBlockEditor)) {
                return false;
            }

            return this._source.defaultCheckAcceptance(source, nodes);
        },

        _getBlockNodes: function () {

            if (!this.canUpdatePosition()) {
                return [];
            }

            var allBlockNodes = query("[data-epi-block-id]", this.sourceItemNode);
            var nestedBlockNodes = query("[data-epi-block-id] [data-epi-block-id]", this.sourceItemNode);

            // support contentGuid
            if (allBlockNodes.length === 0) {
                allBlockNodes = query("[data-epi-content-id]", this.sourceItemNode);
                nestedBlockNodes = query("[data-epi-content-id] [data-epi-content-id]", this.sourceItemNode);
            }

            return allBlockNodes.filter(function (node) {
                // return the blocks that are not nested
                return nestedBlockNodes.indexOf(node) === -1;
            });
        },

        _setupDirectionality: function () {
            // summary:
            //      Iterates over the sourceItemNodes children checking if any is floating.
            // tags:
            //      private
            var horizontal;

            if (/vertical|horizontal/.test(this.layout)) {
                horizontal = this.layout === "horizontal";
            } else {
                horizontal = this._getBlockNodes().some(function (node) {
                    var style = window.getComputedStyle(node),
                        floating = /left|right/.test(style.cssFloat),
                        inline = /inline|inline-block/.test(style.display);

                    return floating || inline;
                });
            }

            this._source.setHorizontal(horizontal);
        },

        executeAction: function (actionName) {
            // summary:
            //      Overidden mixin class, listen acion clicked on textWithLinks widget
            // actionName: [String]
            //      Action name of link on content area
            // tags:
            //      public

            if (actionName === "createnewblock") {

                // TODO: destroy and dereference command when done
                var command = shellApplicationSettings.inlineBlocksInContentAreaEnabled ? new CreateContentFromContentArea({
                    allowedTypes: this.allowedTypes,
                    restrictedTypes: this.restrictedTypes
                }) : new CreateContentFromSelector({
                    creatingTypeIdentifier: "episerver.core.blockdata",
                    createAsLocalAsset: true,
                    treatAsSecondaryView: true,
                    isInQuickEditMode: this.isInQuickEditMode,
                    quickEditBlockId: this.quickEditBlockId,
                    autoPublish: true,
                    allowedTypes: this.allowedTypes,
                    restrictedTypes: this.restrictedTypes
                });

                command.set("model", {
                    save: function (block) {
                        var value = Object.assign([], this.model.get("value") || []);
                        block.inlineBlockDataIndex = block.inlineBlockDataIndex || value.length;
                        value.push(block);

                        this.onForceValueChange({
                            propertyName: this._source.propertyName,
                            value: value
                        });
                    }.bind(this)
                });

                command.execute();

            } else {
                this.inherited(arguments);
            }
        },

        _onDrop: function (data, source, nodes, isCopy) {
            // summary:
            //      onDrop handler for the source
            // data:
            //      Data extracted from the dragged items.
            // source:
            //      The source that the drag event originated from.
            // nodes:
            //      The nodes being dragged.
            // isCopy:
            //      Flag indicating whether the drag is a copy. False indicates a move.
            // tags:
            //      protected
            var model = this.model,
                target = this._source;

            // If the drag source item and drag target item are the same node then return since
            // we don't want to move if the node is dropped on itself.
            if (target.anchor === target.targetAnchor) {
                return;
            }

            // Calculate the visual index of the target.
            var index = target.getAllNodes().indexOf(target.targetAnchor) + (target.before ? -1 : 1),
                children = model.getChildren().filter(function (child) {
                    return child.get("visible");
                });

            // Calculate the actual index in the model to move to.
            index = model.indexOf(children[index - 1]) + 1;

            // Normalize the data to an array.
            if (!Array.isArray(data)) {
                data = [data];
            }

            // If the drag and drop event originated from ourself and is a move, then
            // we need to remove the item before we add them again at the new index.
            if (target === source && !isCopy) {
                model.modify(function () {
                    data.forEach(function (item, i) {
                        var data = item.data;

                        // If the item is in a group then move the group instead.
                        if (data.contentGroup) {
                            data = model.getChild({ name: data.contentGroup });
                        }

                        model.move(data, index + i);
                    });
                });
            } else {
                model.modify(function () {
                    data.forEach(function (item, i) {
                        var block = new ContentBlockViewModel(item.data);
                        model.addChild(block, index + i);
                    });
                });
            }
        },

        _onDndItemRemoved: function (key) {
            // summary:
            //      Called when item are dragged out of the source and dropped in another target.
            // tags:
            //      protected

            // Normalize the data to an array.
            var data = this._source.getItem(key);

            if (!Array.isArray(data)) {
                data = [data];
            }

            // Remove each item from the model.
            this.model.modify(function () {
                data.forEach(function (item) {
                    this.model.removeChild(item.data);
                }.bind(this));
            }.bind(this));
        },

        _getInlineBlockDndKey: function () {
            return this.name + "_contentarea-inline-block";
        }
    });
});

},
'epi/shell/dnd/_MarkerSource':function(){
﻿define("epi/shell/dnd/_MarkerSource", [
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/has",
    "dojo/dnd/Manager",
    "dojo/dnd/Source",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style"
],
function (
    array,
    declare,
    has,
    Manager,
    Source,
    domClass,
    domConstruct,
    domGeom,
    domStyle
) {

    return declare(null, {
        // summary:
        //      Use as a mixin with a dnd Source to enable an absolutely positioned marker
        //      and extra css classes for the sibling nodes when hovering over a target item
        //      during drag and drop operations.
        //
        // tags:
        //      internal

        _markerNode: null,

        // markerTemplateString: String
        //      The html template for the marker
        markerTemplateString: "<div class=\"dojoDndItem-marker\"><div class=\"epi-dndDropMarker\"></div></div>",

        // markerDelay: Number
        //      The amount of time in milliseconds to delay the switch between marker positions
        markerDelay: 150,

        // markOnlyAllowedDropLocations: Boolean
        //      If set to true only positions where a drop will occur is be highlighted
        markOnlyAllowedDropLocations: false,

        _calculatedCurrent: false,

        destroy: function () {
            // summary:
            //		prepares the object to be garbage-collected
            this.inherited(arguments);

            this.targetAnchorSibling = null;
            if (this._markerNode) {
                domConstruct.destroy(this._markerNode);
                this._markerNode = null;
            }
        },

        setHorizontal: function (horizontal) {
            // summary:
            //		Changes the direction for drop markers
            // horizontal: Boolean
            //		true for horizontal direction, false for vertical

            domClass.toggle(this.node, "dojoDndHorizontal", horizontal);
            this.horizontal = horizontal;
        },

        onMouseOver: function (e) {
            // summary:
            //		event processor for onmouseover
            // e: Event
            //		mouse event

            this.inherited(arguments);
            this._calculatedCurrent = false;
        },

        onMouseMove: function (e) {
            // summary:
            //		event processor for onmousemove
            // e: Event
            //		mouse event

            if (this.isDragging && this.targetState === "Disabled") {
                return;
            }
            Source.superclass.onMouseMove.call(this, e);
            var m = Manager.manager();
            var copyKey = has("mac") ? "metaKey" : "ctrlKey";

            if (!this.isDragging) {
                if (this.mouseDown && this.isSource &&
     (Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay)) {
                    var nodes = this.getSelectedNodes();
                    if (nodes.length) {
                        m.startDrag(this, nodes, this.copyState(e[copyKey], true));
                    }
                }
            }

            if (this.isDragging) {
                // calculate before/after
                var before = false;

                if (this.current && !this._calculatedCurrent) {
                    if (!this.targetBox || this.targetAnchor !== this.current) {
                        this.targetBox = domGeom.position(this.current, true);
                    }
                    if (this.horizontal) {
                        before = (e.pageX - this.targetBox.x) < (this.targetBox.w / 2);
                    } else {
                        before = (e.pageY - this.targetBox.y) < (this.targetBox.h / 2);
                    }
                } else {
                    before = this._calculateCurrent({ x: e.pageX, y: e.pageY });
                }

                if (this.current !== this.targetAnchor || before !== this.before) {
                    this._markTargetAnchor(before);
                    m.canDrop(!this.current || m.source !== this || !this.markOnlyAllowedDropLocations || !(this.current.id in this.selection));
                }
            }
        },

        _calculateCurrent: function (point) {
            // summary:
            //      Finds the closest dnd item in the collection and sets it to this.current.
            //      Use to locate where to drop when not having a current item i.e not hovering over any.
            //
            //  point: Object {x: 0, y:0}
            //      The anchor point for the calculation. Most likely the current mouse position

            var points = [],
                current,
                minDistance;

            function calcDistance(startPoint, endPoint) {

                function square(value) {
                    return value * value;
                }

                return Math.sqrt(square(startPoint.x - endPoint.x) + square(startPoint.y - endPoint.y));
            }

            this.getAllNodes().forEach(function (node) {

                var pos = domGeom.position(node);
                pos.x2 = pos.x + pos.w;
                pos.xCentered = pos.x + pos.w / 2;
                pos.y2 = pos.y + pos.h;
                pos.yCentered = pos.y + pos.h / 2;

                if (this.horizontal) {
                    // put measuring points in middle of left and right side
                    points.push({ node: node, before: true, x: pos.x, y: pos.yCentered },
                        { node: node, before: false, x: pos.x2, y: pos.yCentered });
                } else {
                    // put measuring points in centered top and bottom
                    points.push({ node: node, before: true, x: pos.xCentered, y: pos.y },
                        { node: node, before: false, x: pos.xCentered, y: pos.y2 });
                }
            }, this);

            // Brute force distance check. Betting on few points to compare, and a simple
            // point to point calculation instead of checking the full segments for the closest point
            array.forEach(points, function (value) {
                value.distance = calcDistance(point, value);

                if (!current || value.distance < minDistance) {
                    current = value;
                    minDistance = value.distance;
                }
            }, this);

            if (current) {
                this.current = current.node;
                this._calculatedCurrent = true;

                return current.before;
            }

            return false;
        },

        _markTargetAnchor: function (before) {
            // summary:
            //		assigns a class to the current target anchor based on state
            //
            // state: Boolean
            //		insert before, if true, after otherwise

            var targetNotInSelection = true,
                siblingNotInSelection = true;

            if (this.current === this.targetAnchor && this.before === before) {
                return;
            }

            // Remove the previous set classes
            if (this.targetAnchor) {
                this._removeItemClass(this.targetAnchor, this.before ? "Before" : "After");
            }
            if (this.targetAnchorSibling) {
                this._removeItemClass(this.targetAnchorSibling, !this.before ? "Before" : "After");
            }

            this.targetAnchor = this.current;
            this.targetBox = null;
            this.before = before;

            // Add the new classes
            if (this.targetAnchor) {

                this.targetAnchorSibling = before ? this.targetAnchor.previousSibling
                    : this.targetAnchor.nextSibling;

                // Verify that the sibling is a node that we are interested in
                if (!(this.targetAnchorSibling &&
                          this.targetAnchorSibling.nodeType === 1 &&
                          domClass.contains(this.targetAnchorSibling, "dojoDndItem"))) {

                    this.targetAnchorSibling = null;
                }

                if (this.markOnlyAllowedDropLocations) {
                    targetNotInSelection = !(this.targetAnchor.id in this.selection);
                    siblingNotInSelection = !this.targetAnchorSibling || !(this.targetAnchorSibling.id in this.selection);
                }
                if (targetNotInSelection && siblingNotInSelection) {
                    this._addItemClass(this.targetAnchor, this.before ? "Before" : "After");
                }

                if (this.targetAnchorSibling && targetNotInSelection && siblingNotInSelection) {
                    this._addItemClass(this.targetAnchorSibling, !this.before ? "Before" : "After");
                }

                this._positionMarker(targetNotInSelection && siblingNotInSelection);


            } else {
                this._positionMarker(false);
            }
        },

        _unmarkTargetAnchor: function () {
            // summary:
            //		removes a class of the current target anchor based on state

            if (this.targetAnchor) {
                this._removeItemClass(this.targetAnchor, this.before ? "Before" : "After");
            }
            if (this.targetAnchorSibling) {
                this._removeItemClass(this.targetAnchorSibling, !this.before ? "Before" : "After");
            }

            this._positionMarker(false);

            this.targetAnchor = this.targetAnchorSibling = this.targetBox = null;
            this.before = true;
        },

        _positionMarker: function (enable) {

            var markerNode = this._markerNode,
                anchorPos,
                siblingAnchorPos,
                boxPos,
                style,
                top,
                left,
                height,
                width,
                gap = -1;

            if (enable) {

                anchorPos = domGeom.position(this.targetAnchor, false);
                siblingAnchorPos = this.targetAnchorSibling ? domGeom.position(this.targetAnchorSibling, false) : { h: 0, w: 0 };
                boxPos = domGeom.position(this.node, false);

                if (this.horizontal) {

                    if (this.before) {

                        left = anchorPos.x - boxPos.x;

                        // Check if we have a gap between siblings and in that case adjust for it
                        if (this.targetAnchorSibling) {
                            gap = (anchorPos.x - siblingAnchorPos.x - siblingAnchorPos.w) / 2;
                        }
                        if (gap >= 0) {
                            left -= gap;
                        }
                    } else {

                        left = anchorPos.x + anchorPos.w - boxPos.x;

                        // Check if we have a gap between siblings and in that case adjust for it
                        if (this.targetAnchorSibling) {
                            gap = (siblingAnchorPos.x - anchorPos.x - anchorPos.w) / 2;
                        }
                        if (gap >= 0) {
                            left += gap;
                        }
                    }

                    // if we have a sibling in adjacent location take the biggest width
                    // to avoid the markers size changing when moving between them
                    height = gap >= 0 ? Math.max(anchorPos.h, siblingAnchorPos.h) : anchorPos.h;

                    style = {
                        display: "block",
                        top: anchorPos.y - boxPos.y + "px",
                        left: left + "px",
                        height: height + "px"
                    };

                } else {
                    if (this.before) {

                        top = anchorPos.y - boxPos.y;

                        // Check if we have a gap between siblings and in that case adjust for it
                        if (this.targetAnchorSibling) {
                            gap = (anchorPos.y - siblingAnchorPos.y - siblingAnchorPos.h) / 2;
                        }
                        if (gap >= 0) {
                            top -= gap;
                        }
                    } else {

                        top = anchorPos.y + anchorPos.h - boxPos.y;

                        // Check if we have a gap between siblings and in that case adjust for it
                        if (this.targetAnchorSibling) {
                            gap = (siblingAnchorPos.x - anchorPos.x - anchorPos.w) / 2;
                        }
                        if (gap >= 0) {
                            top -= gap;
                        }
                    }

                    // if we have a sibling in adjacent location take the biggest width
                    // to avoid the markers size changing when moving between them
                    width = gap >= 0 ? Math.max(anchorPos.w, siblingAnchorPos.w) : anchorPos.w;

                    style = {
                        display: "block",
                        top: top + "px",
                        width: width + "px"
                    };
                }

            } else {
                style = {
                    display: "none"
                };
            }

            if (!markerNode) {
                markerNode = this._markerNode = domConstruct.place(this.markerTemplateString, this.node);
                domStyle.set(markerNode, style);
            } else {
                setTimeout(function () {
                    domStyle.set(markerNode, style);
                }, this.markerDelay);
            }
        }
    });
});

},
'epi-cms/contentediting/editors/ContentBlockEditor':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/event",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/html",
    "dojo/NodeList-dom",
    "dojo/query",

    //Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/popup",

    // Dojox
    "dojox/html/ellipsis",

    // EPi Framework
    "epi/shell/widget/_ModelBindingMixin",

    // EPi CMS
    "epi-cms/contentediting/editors/ContentBlockEditorViewModel",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.blockcontextmenu",

    "dojo/text!./templates/ContentBlockEditor.html",

    "dojo/NodeList-manipulate"

], function (

    // Dojo
    declare,
    Deferred,
    event,
    domAttr,
    domClass,
    domStyle,
    html,
    NodeList,
    query,

    // Dijit
    _Widget,
    _TemplatedMixin,
    pm,

    // Dojox
    ellipsis,

    // EPi Framework
    _ModelBindingMixin,

    //EPi
    ContentBlockEditorViewModel,

    //Resources
    res,

    template
) {

    return declare([_Widget, _TemplatedMixin, _ModelBindingMixin], {
        // summary:
        //      The editor for an content.
        //
        // tags:
        //      internal xproduct

        // templateString: String
        //      UI template for content editor
        templateString: template,

        // model: Object
        //      Content block editor view model
        model: null,

        contextMenu: null,

        isDraggable: true,

        modelBindingMap: {
            contentLink: ["contentLink"],
            name: ["name"],
            contentGroup: ["contentGroup"],
            roleIdentities: ["roleIdentities"],
            selected: ["selected"]
        },

        _setSelectedAttr: function (isSelected) {
            this.inherited(arguments);

            domClass.toggle(this.itemNode, "epi-content-block-editor-node-selected", isSelected);
            domStyle.set(this.iconNodeMenu, "visibility", isSelected ? "visible" : "hidden");
        },

        _setNameAttr: function (value) {
            this.inherited(arguments);

            query(this.labelNode).text(value);
            domAttr.set(this.iconNodeMenu, "title", res.settingstooltip);
        },

        postMixInProperties: function () {
            this.inherited(arguments);
            this.model = this.model || new ContentBlockEditorViewModel(this.modelData);
        },

        _setIsDraggableAttr: function (isDraggable) {
            this._set("isDraggable", isDraggable);

            if (this.isDraggable) {
                domClass.add(this.domNode, "dojoDndItem");
            } else {
                domClass.remove(this.domNode, "dojoDndItem");
            }
        },

        _onClick: function (evt) {
            event.stop(evt);
            this.contextMenu && pm.close(this.contextMenu);

            this.model.set("selected", !this.model.selected);
        },

        _onContextMenu: function (evt) {
            // summary:
            //      Handler onclick event on iconNodeMenu to show context menu manually.
            // tags:
            //      Private

            event.stop(evt);
            this.contextMenu && this.contextMenu.scheduleOpen(evt.target, null, { x: evt.pageX, y: evt.pageY });
        }
    });
});

},
'epi-cms/contentediting/editors/ContentBlockEditorViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",

    // EPi
    "epi-cms/widget/viewmodel/ContentStatusViewModel"
], function (

    // Dojo
    declare,
    lang,
    Stateful,

    // EPi
    ContentStatusViewModel

) {
    return declare([Stateful, ContentStatusViewModel], {
        // tags:
        //      internal

        contentLink: "",
        contentGroup: "",
        roleIdentities: null,

        selected: false,
        name: "",
        index: 0,

        getValue: function () {
            return {
                contentLink: this.contentLink,
                name: this.name,
                contentGroup: this.contentGroup,
                roleIdentities: this.roleIdentities
            };
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/ContentBlockEditor.html':"﻿<div class=\"epi-content-block-editor\">\r\n    <a href=\"#\" data-dojo-attach-point=\"itemNode\" style=\"display: block;\" data-dojo-attach-event=\"onclick:_onClick\">\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"epi-content-block-node\">\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dojoxEllipsis\"></span>\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-floatRight\">\r\n                <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-iconContextMenu\" style=\"visibility: hidden;\" data-dojo-attach-event=\"onclick:_onContextMenu\"></span>\r\n            </span>\r\n        </span>\r\n    </a>\r\n</div>",
'url:epi-cms/widget/templates/ContentArea.html':"﻿<div class=\"epi-overlay-blockarea\">\r\n\t<div class=\"epi-overlay-item-container\">\r\n        <span data-dojo-attach-point=\"informationNode\" class=\"epi-overlay-item-info\"></span>\r\n        <div class=\"epi-overlay-bracket\"></div>\r\n\t</div>\r\n\t<div data-dojo-attach-point=\"containerNode\" class=\"epi-overlay-blockarea-container\"></div>\r\n\t<div data-dojo-attach-point=\"actionsNode\" class=\"epi-overlay-blockarea-actionscontainer\">\r\n\t\t<div data-dojo-attach-point=\"actionsNodeControls\" class=\"epi-overlay-blockarea-actions\"></div>\r\n\t</div>\r\n</div>\r\n",
'epi-cms/widget/overlay/ItemCollection':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    // EPi CMS
    "epi-cms/contentediting/viewmodel/ItemCollectionViewModel",                         // the injected model class
    "epi-cms/widget/overlay/Property"                                                   // mixin into me
], function (
// Dojo
    declare,
    lang,

    // EPi CMS
    ItemCollectionViewModel,
    Property
) {
    return declare([Property], {
        // summary:
        //      The new overlay item for property link collection.
        // description:
        //      Drag and drop page/media to create new link (at the bottom)
        // tags:
        //      internal xproduct

        // modelType: [public] String
        //      Used to inject model for this.
        modelType: "epi-cms/contentediting/viewmodel/ItemCollectionViewModel",

        // model: [public] Object
        //      Instance of modelClass
        model: null,

        postMixInProperties: function () {
            // summary:
            //      Create the view model if it doesn't exist.
            // tags:
            //      protected

            this.inherited(arguments);

            this._setupAllowedTypes();
            this._setupModel(this.contentModel.get(this.name));

            this.own(this.contentModel.watch(this.name, lang.hitch(this, function (name, oldValue, newValue) {
                this.model.set("data", newValue);
            })));
        },

        onDrop: function (target, value) {
            // summary:
            //      Handles onDrop and add new value to model then raise onValueChange event to save this.
            // target: [Object]
            //      The dnd target.
            // value: [Object || Array]
            //      The dnd data.
            // tags:
            //      private

            // Add new value to model at the bottom
            this.model.addTo(value, null, false);
        },

        _setupModel: function (/*Object*/data) {
            // summary:
            //      setup the viewmodel with latest value
            // tags:
            //      public

            require([this.modelType], lang.hitch(this, function (modelClass) {

                this.model = new modelClass(data, this.modelParams);

                this.own(
                    // Handle model value changed
                    this.model.on("changed", lang.hitch(this, function (result) {
                        // Raise event to save this
                        this.onValueChange({
                            propertyName: this.name,
                            value: this.model.get("value")
                        });
                    }))
                );
            }));
        },

        _setupAllowedTypes: function () {
            // summary:
            //      Setup the allowed types for drag and drop
            // tags:
            //      Protected

            var converterKey = this.modelParams.itemConverterKey,
                customTypeIdentifier = this.modelParams.customTypeIdentifier;

            this.allowedDndTypes = this.allowedDndTypes || [];

            if (converterKey) {
                this.allowedDndTypes = this.allowedDndTypes.map(function (type) {
                    return type + "." + converterKey;
                });
            }

            if (customTypeIdentifier) {
                this.allowedDndTypes.unshift(customTypeIdentifier);
            }
        }

    });
});

},
'epi-cms/widget/ReadOnlyDateTimeEditor':function(){
﻿define([
    "dojo/_base/declare",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "epi/datetime",
    "dojo/text!./templates/ReadOnlyDateTimeEditor.html"
], function (
    declare,
    _Widget,
    _TemplatedMixin,
    epiDate,
    template
) {
    return declare([_Widget, _TemplatedMixin], {
        // tags:
        //      internal

        templateString: template,
        value: null,

        _setValueAttr: function (value) {
            this._set("value", value);
            if (value) {
                this.valueNode.innerHTML = epiDate.toUserFriendlyHtml(value);
            }
        }
    });
});

},
'url:epi-cms/widget/templates/ReadOnlyDateTimeEditor.html':"﻿<div class=\"dijitReset dijitInline epi-previewableTextBox-wrapper\">\r\n    <span data-dojo-attach-point=\"valueNode\" class=\"epi-previewableTextBox-text dijitInline\"></span>\r\n</div>",
'epi-cms/widget/UrlContentSelector':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/widget/ContentSelector",
    "epi-cms/widget/_UrlSelectorMixin"
], function (
    declare,
    ContentSelector,
    _UrlSelectorMixin) {

    return declare([ContentSelector, _UrlSelectorMixin], {
        // tags:
        //      internal
    });
});

},
'epi-cms/widget/_UrlSelectorMixin':function(){
define([
// Dojo
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/_base/lang",
    "dojo/when",
    // EPi Framework
    "epi",
    "epi/Url",
    // EPi CMS
    "epi-cms/core/ContentReference",
    "epi-cms/core/PermanentLinkHelper"
], function (
    // Dojo
    declare,
    Deferred,
    lang,
    when,
    // EPi Framework
    epi,
    Url,
    // EPi CMS
    ContentReference,
    PermanentLinkHelper) {

    return declare(null, {
        // tags:
        //      internal

        // _contentData: Object
        //      Content data which is related to the url value.
        _contentData: null,

        _setValueAndFireOnChange: function (value) {
            //summary:
            //    Sets the value and calls onChange if value was changed
            // tags:
            //    protected

            var isModified;
            if (this._valueChangedPromise) {
                this._valueChangedPromise.cancel("");
                this._valueChangedPromise = null;
            }

            this.set("permanentLink", null);

            if (!value) {

                this._updateDisplayNode(null);
                isModified = this.value !== value;
                this.value = value;
                this._contentData = null;

                if (isModified) {
                    if (this.initialized) {
                        this.onStartEdit();
                    }
                    this.onChange(value);
                    if (this.initialized) {
                        this.onStopEdit();
                    }
                }

                this._started && this.validate();
                this.initialized = true;
                return;
            }

            when(this._getContentByPermanentLink(value), lang.hitch(this, function (content) {
                this._updateDisplayNode(content);

                // We need to recreate the internal format before saving the data.
                var urlFormatValue = content.permanentLink;
                this._started && this.validate();

                isModified = !epi.areEqual(this.value, urlFormatValue);
                this.value = urlFormatValue;

                if (isModified) {
                    if (this.initialized) {
                        this.onStartEdit();
                    }
                    this.onChange(urlFormatValue);
                    if (this.initialized) {
                        this.onStopEdit();
                    }
                }

                if (content) {
                    this.set("permanentLink", content.permanentLink);
                }
                this._started && this.validate();
                this.initialized = true;
            }));
        },

        _convertValueToContentReference: function (value) {
            // summary:
            //      Creates a ContentReference from the internal value.
            // tags:
            //      protected

            if (this._contentData) {
                return new ContentReference(this._contentData.contentLink);
            }

            return null;
        },

        _getContentByPermanentLink: function (/*String*/value) {
            // summary:
            //      Get content which is related to the permanent link value.
            // tags:
            //      protected

            if (epi.areEqual(this.value, value) && this._contentData) {
                return this._contentData;
            }

            this._valueChangedPromise = new Deferred();
            when(PermanentLinkHelper.getContent(value, { allLanguages: true }), lang.hitch(this, function (content) {
                this._contentData = content;
                if (this._valueChangedPromise) {
                    this._valueChangedPromise.resolve(content);
                }
            }));

            return this._valueChangedPromise.promise;
        }
    });
});

},
'epi-cms/widget/UrlSelector':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/when",
    "dojo/Deferred",

    // epi.cms
    "epi-cms/core/PermanentLinkHelper",
    "epi-cms/contentediting/editors/LinkItemEditor",
    "./SelectorWrapperBase",

    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.editlink"
], function (
    // dojo
    declare,
    when,
    Deferred,

    // epi.cms
    PermanentLinkHelper,
    LinkItemEditor,
    SelectorWrapperBase,

    // resources
    res
) {

    return declare([SelectorWrapperBase], {
        // summary:
        //    Represents the widget wrapper.
        // tags:
        //      internal xproduct

        resource: res,

        selectorClass: LinkItemEditor,

        hiddenFields: ["text", "title", "target", "language"],

        // LinkHelper to retrieve the link info
        linkHelper: PermanentLinkHelper,

        _getSelectorParams: function () {
            // summary:
            //      Retrieves the selector's params.
            //
            // tags:
            //      protected abstract

            // should implement by usage or inheritance class.
            return {
                hiddenFields: this.hiddenFields,
                getCurrentValue: function () {
                    return { href: this.value };
                }.bind(this)
            };
        },

        _onSelectorValueChange: function (val) {
            // summary:
            //      Callback whenever selector's value is changed.
            //
            // tags:
            //      protected abstract

            if ((!val && this.value) || (val && this.value !== val.href)) {
                this.onFocus();
                this.set("value", val && val.href);
                this._triggerSave();
            }
        },

        _setValue: function (value) {
            this.value = value;
            when(this._getLinkData(value)).then(function (linkData) {
                this.selector && this.selector.set("value", linkData);
            }.bind(this));
        },

        _getLinkDataJob: function (value) {
            // summary:
            //      Real job to retrieves the content of given link value.
            //
            // value: [String]
            //    A string as link value
            //
            // tags:
            //      private

            if (!value) {
                return null;
            }

            var def = new Deferred();

            when(this.linkHelper.getContent(value, { allLanguages: true }), function (content) {
                var result = content ? {
                    text: content.name,
                    href: content.permanentLink
                } : {
                    text: value,
                    href: value
                };
                def.resolve(result);
            }.bind(this));

            return def.promise;
        },

        _getLinkData: function (/* String */ value) {
            // summary:
            //      Retrieves the content of given link value.
            //
            // value: [String]
            //    A string as link value
            //
            // tags:
            //      private

            var getLinkDataQueueDeferred = new Deferred();

            if (!this._getLinkDataQueue) {
                this._getLinkDataQueue = [];
            }

            this._getLinkDataQueue.push(value);

            if (!this._getLinkDataTimer) {
                this._getLinkDataTimer = setTimeout(function () {
                    when(this._getLinkDataJob(this._getLinkDataQueue.reverse()[0])).then(function (result) {
                        getLinkDataQueueDeferred.resolve(result);
                        this._getLinkDataQueue = [];
                        this._getLinkDataTimer = undefined;
                    }.bind(this));
                }.bind(this));
            }

            return getLinkDataQueueDeferred.promise;
        }
    });
});

},
'epi-cms/contentediting/editors/LinkItemEditor':function(){
define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    // epi-cms
    "epi-cms/widget/_SelectorBase",
    "epi-cms/contentediting/viewmodel/LinkItemModel",
    "epi-cms/contentediting/viewmodel/ItemCollectionViewModel",
    "epi-cms/widget/SingleLinkEditor",
    "epi-cms/dgrid/formatters",
    "epi-cms/widget/_ContentSelectorActionsMixin",

    // resources
    "dojo/text!./templates/LinkItemEditor.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.editlink"
], function (
    // dojo
    declare,
    lang,

    // epi-cms
    _SelectorBase,
    LinkItemModel,
    ItemCollectionViewModel,
    SingleLinkEditor,
    formatters,
    _ContentSelectorActionsMixin,

    // resources
    template,
    resource
) {

    return declare([_SelectorBase, _ContentSelectorActionsMixin], {

        resource: resource,

        baseClass: "epi-linkItemEditor",

        templateString: template,

        itemModelType: LinkItemModel,

        dialogContentClass: SingleLinkEditor,

        postMixInProperties: function () {

            this.actionsNodeOptions = {
                settings: {
                    label: resource.buttonlabel
                }
            };

            if (this.customTypeIdentifier) {
                this.allowedDndTypes.unshift(this.customTypeIdentifier);
            }

            this.own(
                this.model = this.model || new ItemCollectionViewModel(this.value ? [this.value] : [], {
                    itemModelType: this.itemModelType,
                    readOnly: this.readOnly
                }),
                this.model.on("changed", function () {
                    var value = this.get("value");
                    value = value === undefined ? null : value;
                    this._updateDisplayNode(value ? Object.assign({}, value, { name: value.text }) : null);
                    this.onChange(value);
                }.bind(this))
            );

            this.inherited(arguments);
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(this.model.on("initCompleted", this._initialize.bind(this)));
            this._initialize();
        },

        _updateDisplayNode: function (content) {
            // summary:
            //      Override to set icon class

            this.inherited(arguments);

            // Reset icon class
            this.iconNode.className = "";
            if (content) {
                var additionalClass = formatters.additionalClassByFilename(content.text);
                this.iconClass = formatters.contentIconClass(content.typeIdentifier, additionalClass);
                this.iconNode.className = this.iconClass;

                //change the title from "{name}, ID: {contentLink} (Type: {contentTypeName})" to show resource name only if 'content' is not content.
                if (!content.contentLink) {
                    this.resourceName.title = this.resourceName.textContent.trim();
                }
            }
        },

        _initialize: function () {
            var value = this.get("value");
            this.model.set("selectedItem", value);
            this._updateDisplayNode(value ? Object.assign({}, value, { name: value.text }) : null);
            this._editItemCommand && this._editItemCommand.set("model", this.model);
            if (this._waitToFireOnChange) {
                this._waitToFireOnChange = false;
                this.onChange(value);
            }
        },

        _setupDialogSettings: function () {
            // summary:
            //      Setup settings for dialog.
            // tags:
            //      protected virtual

            this.inherited(arguments);

            this.dialogSettings = Object.assign(this.dialogSettings, {
                title: this._getTitle(),
                dialogContentClass: this.dialogContentClass
            });
        },

        _setupContentSelectorDialogSettings: function () {
            this.inherited(arguments);

            this.contentSelectorDialogSettings = Object.assign(this.contentSelectorDialogSettings, {
                modelType: this.metadata.additionalValues["modelType"],
                hiddenFields: this.hiddenFields,
                getCurrentValue: this.getCurrentValue.bind(this)
            });
        },

        getCurrentValue: function () {
            return this.get("value");
        },

        _onDialogExecute: function (linkObj) {
            //summary:
            //    Handle dialog close through executing OK, Cancel, Delete commands
            // tags:
            //    protected

            this.set("value", linkObj);
            this._waitToFireOnChange = true;
        },

        _setValueAttr: function (value) {
            if (!value || (value instanceof Array) && value.length === 0) {
                value = null;
            }

            this.model && this.model.set("data", value ? [value] : []);
        },

        _getValueAttr: function () {
            if (!this.model) {
                return null;
            }

            var value = this.model.get("value");
            if (value instanceof Array && value.length === 0) {
                return null;
            }

            return value && value[0];
        },

        isValid: function () {
            return (!this.required || this.get("value"));
        },

        getEmptyValue: function () {
            // summary:
            //    Returns empty property value
            //    Overriden from _HasClearButton
            //
            // tags:
            //    public callback

            return null;
        },

        onDrop: function (value) {
            // summary:
            //    Triggered when something has been dropped onto the widget.
            //    Overriden from _Droppable
            //
            // tags:
            //    public callback

            this._waitToFireOnChange = true;
        },

        _getTitle: function () {
            // summary:
            //      Customize base get method for title prop.
            // tags:
            //      protected

            return lang.replace(this.value ? this.resource.title.template.edit : this.resource.title.template.create, this.resource.title.action);
        }

    });
});

},
'epi-cms/widget/SingleLinkEditor':function(){
define([
// Dojo
    "dojo/_base/declare",
    "epi-cms/widget/LinkEditor"
], function (
// Dojo
    declare,
    LinkEditor
) {
    return declare([LinkEditor], {
        // summary:
        //    The dialog to add or edit a single link item.
        // tags:
        //      internal

        baseClass: "epi-link-item",

        postMixInProperties: function () {
            this.inherited(arguments);

            // Hide "delete" button
            this._actions = this._actions.filter(function (action) {
                return action.name !== "delete";
            });
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/LinkItemEditor.html':"﻿<div data-dojo-attach-point=\"inputContainer\" class=\"dijitReset dijitInputField dijitInline epi-resourceInputContainer\" id=\"widget_${id}\">\r\n    <div data-dojo-attach-point=\"displayNode, dropAreaNode, stateNode\" class=\"dijit dijitReset dijitInline dijitInlineTable dijitLeft dijitTextBox displayNode\">\r\n        <div class=\"dijitReset dijitLeft dijitInputField dijitInputContainer\">\r\n            <div data-dojo-attach-point=\"contentSelectorContainer\" class=\"contentSelectorContainer\"></div>\r\n            <div class=\"epi-linkItemContainer\">\r\n                <span class=\"epi-iconLink\"></span>\r\n                <span data-dojo-attach-point=\"iconNode\"></span>\r\n                <div data-dojo-attach-point=\"resourceName\" class=\"dijitInline epi-resourceName dojoxEllipsis\" >\r\n                    <span data-dojo-attach-point=\"selectedContentNameNode\"></span>\r\n                    <span data-dojo-attach-point=\"selectedContentLinkNode\"></span>\r\n                </div>\r\n                <div data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\">\r\n                    <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-iconContextMenu\" />\r\n                </div>\r\n                <div data-dojo-attach-point=\"clearButton\"></div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/widget/UrlThumbnailSelector':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/widget/ThumbnailSelector",
    "epi-cms/widget/_UrlSelectorMixin"
], function (
    declare,
    ThumbnailSelector,
    _UrlSelectorMixin) {

    return declare([ThumbnailSelector, _UrlSelectorMixin], {
        // tags:
        //      internal
    });
});

}}});
/* Dummy file to trick the AMD loader when running debug mode */
